/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var V=["require","exports","vs/base/common/platform","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/range","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/event","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/base/common/uri","vs/base/common/diff/diffChange","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/editor/common/core/characterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Q=function(I){for(var t=[],p=0,U=I.length;p<U;p++)t[p]=V[I[p]];return t},Le=this,Se=typeof global=="object"?global:{},ee;(function(I){I.global=Le;var t=function(){function p(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1}return Object.defineProperty(p.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(p.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(p.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(p.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),p.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=p._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof I.global.importScripts=="function")},p._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},p}();I.Environment=t})(ee||(ee={}));var ee;(function(I){var t=function(){function P(s,b,l){this.type=s,this.detail=b,this.timestamp=l}return P}();I.LoaderEvent=t;var p=function(){function P(s){this._events=[new t(1,"",s)]}return P.prototype.record=function(s,b){this._events.push(new t(s,b,I.Utilities.getHighPerformanceTimestamp()))},P.prototype.getEvents=function(){return this._events},P}();I.LoaderEventRecorder=p;var U=function(){function P(){}return P.prototype.record=function(s,b){},P.prototype.getEvents=function(){return[]},P.INSTANCE=new P,P}();I.NullLoaderEventRecorder=U})(ee||(ee={}));var ee;(function(I){var t=function(){function p(){}return p.fileUriToFilePath=function(U,P){if(P=decodeURI(P).replace(/%23/g,"#"),U){if(/^file:\/\/\//.test(P))return P.substr(8);if(/^file:\/\//.test(P))return P.substr(5)}else if(/^file:\/\//.test(P))return P.substr(7);return P},p.startsWith=function(U,P){return U.length>=P.length&&U.substr(0,P.length)===P},p.endsWith=function(U,P){return U.length>=P.length&&U.substr(U.length-P.length)===P},p.containsQueryString=function(U){return/^[^\#]*\?/gi.test(U)},p.isAbsolutePath=function(U){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(U)},p.forEachProperty=function(U,P){if(U){var s=void 0;for(s in U)U.hasOwnProperty(s)&&P(s,U[s])}},p.isEmpty=function(U){var P=!0;return p.forEachProperty(U,function(){P=!1}),P},p.recursiveClone=function(U){if(!U||typeof U!="object"||U instanceof RegExp||!Array.isArray(U)&&Object.getPrototypeOf(U)!==Object.prototype)return U;var P=Array.isArray(U)?[]:{};return p.forEachProperty(U,function(s,b){b&&typeof b=="object"?P[s]=p.recursiveClone(b):P[s]=b}),P},p.generateAnonymousModule=function(){return"===anonymous"+p.NEXT_ANONYMOUS_ID+++"==="},p.isAnonymousModule=function(U){return p.startsWith(U,"===anonymous")},p.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=I.global.performance&&typeof I.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?I.global.performance.now():Date.now()},p.NEXT_ANONYMOUS_ID=1,p.PERFORMANCE_NOW_PROBED=!1,p.HAS_PERFORMANCE_NOW=!1,p}();I.Utilities=t})(ee||(ee={}));var ee;(function(I){function t(P){if(P instanceof Error)return P;var s=new Error(P.message||String(P)||"Unknown Error");return P.stack&&(s.stack=P.stack),s}I.ensureError=t;var p=function(){function P(){}return P.validateConfigurationOptions=function(s){function b(u){if(u.phase==="loading"){console.error('Loading "'+u.moduleId+'" failed'),console.error(u),console.error("Here are the modules that depend on it:"),console.error(u.neededBy);return}if(u.phase==="factory"){console.error('The factory method of "'+u.moduleId+'" has thrown an exception'),console.error(u);return}}if(s=s||{},typeof s.baseUrl!="string"&&(s.baseUrl=""),typeof s.isBuild!="boolean"&&(s.isBuild=!1),typeof s.paths!="object"&&(s.paths={}),typeof s.config!="object"&&(s.config={}),typeof s.catchError=="undefined"&&(s.catchError=!1),typeof s.recordStats=="undefined"&&(s.recordStats=!1),typeof s.urlArgs!="string"&&(s.urlArgs=""),typeof s.onError!="function"&&(s.onError=b),Array.isArray(s.ignoreDuplicateModules)||(s.ignoreDuplicateModules=[]),s.baseUrl.length>0&&(I.Utilities.endsWith(s.baseUrl,"/")||(s.baseUrl+="/")),typeof s.cspNonce!="string"&&(s.cspNonce=""),typeof s.preferScriptTags=="undefined"&&(s.preferScriptTags=!1),Array.isArray(s.nodeModules)||(s.nodeModules=[]),s.nodeCachedData&&typeof s.nodeCachedData=="object"&&(typeof s.nodeCachedData.seed!="string"&&(s.nodeCachedData.seed="seed"),(typeof s.nodeCachedData.writeDelay!="number"||s.nodeCachedData.writeDelay<0)&&(s.nodeCachedData.writeDelay=1e3*7),!s.nodeCachedData.path||typeof s.nodeCachedData.path!="string")){var l=t(new Error("INVALID cached data configuration, 'path' MUST be set"));l.phase="configuration",s.onError(l),s.nodeCachedData=void 0}return s},P.mergeConfigurationOptions=function(s,b){s===void 0&&(s=null),b===void 0&&(b=null);var l=I.Utilities.recursiveClone(b||{});return I.Utilities.forEachProperty(s,function(u,c){u==="ignoreDuplicateModules"&&typeof l.ignoreDuplicateModules!="undefined"?l.ignoreDuplicateModules=l.ignoreDuplicateModules.concat(c):u==="paths"&&typeof l.paths!="undefined"?I.Utilities.forEachProperty(c,function(L,w){return l.paths[L]=w}):u==="config"&&typeof l.config!="undefined"?I.Utilities.forEachProperty(c,function(L,w){return l.config[L]=w}):l[u]=I.Utilities.recursiveClone(c)}),P.validateConfigurationOptions(l)},P}();I.ConfigurationOptionsUtil=p;var U=function(){function P(s,b){if(this._env=s,this.options=p.mergeConfigurationOptions(b),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var l=this.options.nodeRequire.main.filename,u=Math.max(l.lastIndexOf("/"),l.lastIndexOf("\\"));this.options.baseUrl=l.substring(0,u+1)}if(this.options.nodeMain&&this._env.isNode){var l=this.options.nodeMain,u=Math.max(l.lastIndexOf("/"),l.lastIndexOf("\\"));this.options.baseUrl=l.substring(0,u+1)}}}return P.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var s=0;s<this.options.ignoreDuplicateModules.length;s++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[s]]=!0},P.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var s=0,b=this.options.nodeModules;s<b.length;s++){var l=b[s];this.nodeModulesMap[l]=!0}},P.prototype._createSortedPathsRules=function(){var s=this;this.sortedPathsRules=[],I.Utilities.forEachProperty(this.options.paths,function(b,l){Array.isArray(l)?s.sortedPathsRules.push({from:b,to:l}):s.sortedPathsRules.push({from:b,to:[l]})}),this.sortedPathsRules.sort(function(b,l){return l.from.length-b.from.length})},P.prototype.cloneAndMerge=function(s){return new P(this._env,p.mergeConfigurationOptions(s,this.options))},P.prototype.getOptionsLiteral=function(){return this.options},P.prototype._applyPaths=function(s){for(var b,l=0,u=this.sortedPathsRules.length;l<u;l++)if(b=this.sortedPathsRules[l],I.Utilities.startsWith(s,b.from)){for(var c=[],L=0,w=b.to.length;L<w;L++)c.push(b.to[L]+s.substr(b.from.length));return c}return[s]},P.prototype._addUrlArgsToUrl=function(s){return I.Utilities.containsQueryString(s)?s+"&"+this.options.urlArgs:s+"?"+this.options.urlArgs},P.prototype._addUrlArgsIfNecessaryToUrl=function(s){return this.options.urlArgs?this._addUrlArgsToUrl(s):s},P.prototype._addUrlArgsIfNecessaryToUrls=function(s){if(this.options.urlArgs)for(var b=0,l=s.length;b<l;b++)s[b]=this._addUrlArgsToUrl(s[b]);return s},P.prototype.moduleIdToPaths=function(s){var b=this.nodeModulesMap[s]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(s);if(b)return this.isBuild()?["empty:"]:["node|"+s];var l=s,u;if(!I.Utilities.endsWith(l,".js")&&!I.Utilities.isAbsolutePath(l)){u=this._applyPaths(l);for(var c=0,L=u.length;c<L;c++)this.isBuild()&&u[c]==="empty:"||(I.Utilities.isAbsolutePath(u[c])||(u[c]=this.options.baseUrl+u[c]),!I.Utilities.endsWith(u[c],".js")&&!I.Utilities.containsQueryString(u[c])&&(u[c]=u[c]+".js"))}else!I.Utilities.endsWith(l,".js")&&!I.Utilities.containsQueryString(l)&&(l=l+".js"),u=[l];return this._addUrlArgsIfNecessaryToUrls(u)},P.prototype.requireToUrl=function(s){var b=s;return I.Utilities.isAbsolutePath(b)||(b=this._applyPaths(b)[0],I.Utilities.isAbsolutePath(b)||(b=this.options.baseUrl+b)),this._addUrlArgsIfNecessaryToUrl(b)},P.prototype.isBuild=function(){return this.options.isBuild},P.prototype.isDuplicateMessageIgnoredFor=function(s){return this.ignoreDuplicateModulesMap.hasOwnProperty(s)},P.prototype.getConfigForModule=function(s){if(this.options.config)return this.options.config[s]},P.prototype.shouldCatchError=function(){return this.options.catchError},P.prototype.shouldRecordStats=function(){return this.options.recordStats},P.prototype.onError=function(s){this.options.onError(s)},P}();I.Configuration=U})(ee||(ee={}));var ee;(function(I){var t=function(){function l(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}return l.prototype.load=function(u,c,L,w){var m=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new U;else if(this._env.isElectronRenderer){var f=u.getConfig().getOptionsLiteral().preferScriptTags;f?this._scriptLoader=new p:this._scriptLoader=new P(this._env)}else this._env.isNode?this._scriptLoader=new P(this._env):this._scriptLoader=new p;var g={callback:L,errorback:w};if(this._callbackMap.hasOwnProperty(c)){this._callbackMap[c].push(g);return}this._callbackMap[c]=[g],this._scriptLoader.load(u,c,function(){return m.triggerCallback(c)},function(A){return m.triggerErrorback(c,A)})},l.prototype.triggerCallback=function(u){var c=this._callbackMap[u];delete this._callbackMap[u];for(var L=0;L<c.length;L++)c[L].callback()},l.prototype.triggerErrorback=function(u,c){var L=this._callbackMap[u];delete this._callbackMap[u];for(var w=0;w<L.length;w++)L[w].errorback(c)},l}(),p=function(){function l(){}return l.prototype.attachListeners=function(u,c,L){var w=function(){u.removeEventListener("load",m),u.removeEventListener("error",f)},m=function(g){w(),c()},f=function(g){w(),L(g)};u.addEventListener("load",m),u.addEventListener("error",f)},l.prototype.load=function(u,c,L,w){if(/^node\|/.test(c)){var m=u.getConfig().getOptionsLiteral(),f=s(u.getRecorder(),m.nodeRequire||I.global.nodeRequire),g=c.split("|"),A=null;try{A=f(g[1])}catch(i){w(i);return}u.enqueueDefineAnonymousModule([],function(){return A}),L()}else{var E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript"),this.attachListeners(E,L,w);var S=u.getConfig().getOptionsLiteral().trustedTypesPolicy;S&&(c=S.createScriptURL(c)),E.setAttribute("src",c);var n=u.getConfig().getOptionsLiteral().cspNonce;n&&E.setAttribute("nonce",n),document.getElementsByTagName("head")[0].appendChild(E)}},l}(),U=function(){function l(){}return l.prototype.load=function(u,c,L,w){var m=u.getConfig().getOptionsLiteral().trustedTypesPolicy,f=/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,self.origin.length)!==self.origin;if(!f){fetch(c).then(function(g){if(g.status!==200)throw new Error(g.statusText);return g.text()}).then(function(g){g=g+`
//# sourceURL=`+c;var A=m?self.eval(m.createScript("",g)):new Function(g);A.call(self),L()}).then(void 0,w);return}try{m&&(c=m.createScriptURL(c)),importScripts(c),L()}catch(g){w(g)}},l}(),P=function(){function l(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}return l.prototype._init=function(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))},l.prototype._initNodeRequire=function(u,c){var L=c.getConfig().getOptionsLiteral().nodeCachedData;if(!L||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var w=this,m=u("module");function f(g){var A=g.constructor,E=function(n){try{return g.require(n)}finally{}};return E.resolve=function(n,i){return A._resolveFilename(n,g,!1,i)},E.resolve.paths=function(n){return A._resolveLookupPaths(n,g)},E.main=process.mainModule,E.extensions=A._extensions,E.cache=A._cache,E}m.prototype._compile=function(g,A){var E=m.wrap(g.replace(/^#!.*/,"")),S=c.getRecorder(),n=w._getCachedDataPath(L,A),i={filename:A},r;try{var o=w._fs.readFileSync(n);r=o.slice(0,16),i.cachedData=o.slice(16),S.record(60,n)}catch(C){S.record(61,n)}var h=new w._vm.Script(E,i),_=h.runInThisContext(i),a=w._path.dirname(A),d=f(this),N=[this.exports,d,this,A,a,process,Se,Buffer],M=_.apply(this.exports,N);return w._handleCachedData(h,E,n,!i.cachedData,c),w._verifyCachedData(h,E,n,r,c),M}},l.prototype.load=function(u,c,L,w){var m=this,f=u.getConfig().getOptionsLiteral(),g=s(u.getRecorder(),f.nodeRequire||I.global.nodeRequire),A=f.nodeInstrumenter||function(_){return _};this._init(g),this._initNodeRequire(g,u);var E=u.getRecorder();if(/^node\|/.test(c)){var S=c.split("|"),n=null;try{n=g(S[1])}catch(_){w(_);return}u.enqueueDefineAnonymousModule([],function(){return n}),L()}else{c=I.Utilities.fileUriToFilePath(this._env.isWindows,c);var i=this._path.normalize(c),r=this._getElectronRendererScriptPathOrUri(i),o=Boolean(f.nodeCachedData),h=o?this._getCachedDataPath(f.nodeCachedData,c):void 0;this._readSourceAndCachedData(i,h,E,function(_,a,d,N){if(_){w(_);return}var M;a.charCodeAt(0)===l._BOM?M=l._PREFIX+a.substring(1)+l._SUFFIX:M=l._PREFIX+a+l._SUFFIX,M=A(M,i);var C={filename:r,cachedData:d},R=m._createAndEvalScript(u,M,C,L,w);m._handleCachedData(R,M,h,o&&!d,u),m._verifyCachedData(R,M,h,N,u)})}},l.prototype._createAndEvalScript=function(u,c,L,w,m){var f=u.getRecorder();f.record(31,L.filename);var g=new this._vm.Script(c,L),A=g.runInThisContext(L),E=u.getGlobalAMDDefineFunc(),S=!1,n=function(){return S=!0,E.apply(null,arguments)};return n.amd=E.amd,A.call(I.global,u.getGlobalAMDRequireFunc(),n,L.filename,this._path.dirname(L.filename)),f.record(32,L.filename),S?w():m(new Error("Didn't receive define call in "+L.filename+"!")),g},l.prototype._getElectronRendererScriptPathOrUri=function(u){if(!this._env.isElectronRenderer)return u;var c=u.match(/^([a-z])\:(.*)/i);return c?"file:///"+(c[1].toUpperCase()+":"+c[2]).replace(/\\/g,"/"):"file://"+u},l.prototype._getCachedDataPath=function(u,c){var L=this._crypto.createHash("md5").update(c,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),w=this._path.basename(c).replace(/\.js$/,"");return this._path.join(u.path,w+"-"+L+".code")},l.prototype._handleCachedData=function(u,c,L,w,m){var f=this;u.cachedDataRejected?this._fs.unlink(L,function(g){m.getRecorder().record(62,L),f._createAndWriteCachedData(u,c,L,m),g&&m.getConfig().onError(g)}):w&&this._createAndWriteCachedData(u,c,L,m)},l.prototype._createAndWriteCachedData=function(u,c,L,w){var m=this,f=Math.ceil(w.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),g=-1,A=0,E=void 0,S=function(){setTimeout(function(){E||(E=m._crypto.createHash("md5").update(c,"utf8").digest());var n=u.createCachedData();if(!(n.length===0||n.length===g||A>=5)){if(n.length<g){S();return}g=n.length,m._fs.writeFile(L,Buffer.concat([E,n]),function(i){i&&w.getConfig().onError(i),w.getRecorder().record(63,L),S()})}},f*Math.pow(4,A++))};S()},l.prototype._readSourceAndCachedData=function(u,c,L,w){if(!c)this._fs.readFile(u,{encoding:"utf8"},w);else{var m=void 0,f=void 0,g=void 0,A=2,E=function(S){S?w(S):--A==0&&w(void 0,m,f,g)};this._fs.readFile(u,{encoding:"utf8"},function(S,n){m=n,E(S)}),this._fs.readFile(c,function(S,n){!S&&n&&n.length>0?(g=n.slice(0,16),f=n.slice(16),L.record(60,c)):L.record(61,c),E()})}},l.prototype._verifyCachedData=function(u,c,L,w,m){var f=this;!w||u.cachedDataRejected||setTimeout(function(){var g=f._crypto.createHash("md5").update(c,"utf8").digest();w.equals(g)||(m.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+L+"' now, but a RESTART IS REQUIRED")),f._fs.unlink(L,function(A){A&&m.getConfig().onError(A)}))},Math.ceil(5e3*(1+Math.random())))},l._BOM=65279,l._PREFIX="(function (require, define, __filename, __dirname) { ",l._SUFFIX=`
});`,l}();function s(l,u){if(u.__$__isRecorded)return u;var c=function(w){l.record(33,w);try{return u(w)}finally{l.record(34,w)}};return c.__$__isRecorded=!0,c}I.ensureRecordedNodeRequire=s;function b(l){return new t(l)}I.createScriptLoader=b})(ee||(ee={}));var ee;(function(I){var t=function(){function l(u){var c=u.lastIndexOf("/");c!==-1?this.fromModulePath=u.substr(0,c+1):this.fromModulePath=""}return l._normalizeModuleId=function(u){var c=u,L;for(L=/\/\.\//;L.test(c);)c=c.replace(L,"/");for(c=c.replace(/^\.\//g,""),L=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;L.test(c);)c=c.replace(L,"/");return c=c.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),c},l.prototype.resolveModule=function(u){var c=u;return I.Utilities.isAbsolutePath(c)||(I.Utilities.startsWith(c,"./")||I.Utilities.startsWith(c,"../"))&&(c=l._normalizeModuleId(this.fromModulePath+c)),c},l.ROOT=new l(""),l}();I.ModuleIdResolver=t;var p=function(){function l(u,c,L,w,m,f){this.id=u,this.strId=c,this.dependencies=L,this._callback=w,this._errorback=m,this.moduleIdResolver=f,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return l._safeInvokeFunction=function(u,c){try{return{returnedValue:u.apply(I.global,c),producedError:null}}catch(L){return{returnedValue:null,producedError:L}}},l._invokeFactory=function(u,c,L,w){return u.isBuild()&&!I.Utilities.isAnonymousModule(c)?{returnedValue:null,producedError:null}:u.shouldCatchError()?this._safeInvokeFunction(L,w):{returnedValue:L.apply(I.global,w),producedError:null}},l.prototype.complete=function(u,c,L){this._isComplete=!0;var w=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);var m=l._invokeFactory(c,this.strId,this._callback,L);w=m.producedError,u.record(22,this.strId),!w&&typeof m.returnedValue!="undefined"&&(!this.exportsPassedIn||I.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(w){var f=I.ensureError(w);f.phase="factory",f.moduleId=this.strId,this.error=f,c.onError(f)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},l.prototype.onDependencyError=function(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1},l.prototype.isComplete=function(){return this._isComplete},l}();I.Module=p;var U=function(){function l(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return l.prototype.getMaxModuleId=function(){return this._nextId},l.prototype.getModuleId=function(u){var c=this._strModuleIdToIntModuleId.get(u);return typeof c=="undefined"&&(c=this._nextId++,this._strModuleIdToIntModuleId.set(u,c),this._intModuleIdToStrModuleId[c]=u),c},l.prototype.getStrModuleId=function(u){return this._intModuleIdToStrModuleId[u]},l}(),P=function(){function l(u){this.id=u}return l.EXPORTS=new l(0),l.MODULE=new l(1),l.REQUIRE=new l(2),l}();I.RegularDependency=P;var s=function(){function l(u,c,L){this.id=u,this.pluginId=c,this.pluginParam=L}return l}();I.PluginDependency=s;var b=function(){function l(u,c,L,w,m){m===void 0&&(m=0),this._env=u,this._scriptLoader=c,this._loaderAvailableTimestamp=m,this._defineFunc=L,this._requireFunc=w,this._moduleIdProvider=new U,this._config=new I.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return l.prototype.reset=function(){return new l(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},l.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},l.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},l._findRelevantLocationInStack=function(u,c){for(var L=function(r){return r.replace(/\\/g,"/")},w=L(u),m=c.split(/\n/),f=0;f<m.length;f++){var g=m[f].match(/(.*):(\d+):(\d+)\)?$/);if(g){var A=g[1],E=g[2],S=g[3],n=Math.max(A.lastIndexOf(" ")+1,A.lastIndexOf("(")+1);if(A=A.substr(n),A=L(A),A===w){var i={line:parseInt(E,10),col:parseInt(S,10)};return i.line===1&&(i.col-="(function (require, define, __filename, __dirname) { ".length),i}}}throw new Error("Could not correlate define call site for needle "+u)},l.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var u=[],c=0,L=0,w=this._modules2.length;L<w;L++){var m=this._modules2[L];if(!!m){var f=this._buildInfoPath[m.id]||null,g=this._buildInfoDefineStack[m.id]||null,A=this._buildInfoDependencies[m.id];u[c++]={id:m.strId,path:f,defineLocation:f&&g?l._findRelevantLocationInStack(f,g):null,dependencies:A,shim:null,exports:m.exports}}}return u},l.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new I.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=I.NullLoaderEventRecorder.INSTANCE),this._recorder},l.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},l.prototype.enqueueDefineAnonymousModule=function(u,c){if(this._currentAnnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var L=null;this._config.isBuild()&&(L=new Error("StackLocation").stack||null),this._currentAnnonymousDefineCall={stack:L,dependencies:u,callback:c}},l.prototype.defineModule=function(u,c,L,w,m,f){var g=this;f===void 0&&(f=new t(u));var A=this._moduleIdProvider.getModuleId(u);if(this._modules2[A]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}var E=new p(A,u,this._normalizeDependencies(c,f),L,w,f);this._modules2[A]=E,this._config.isBuild()&&(this._buildInfoDefineStack[A]=m,this._buildInfoDependencies[A]=(E.dependencies||[]).map(function(S){return g._moduleIdProvider.getStrModuleId(S.id)})),this._resolve(E)},l.prototype._normalizeDependency=function(u,c){if(u==="exports")return P.EXPORTS;if(u==="module")return P.MODULE;if(u==="require")return P.REQUIRE;var L=u.indexOf("!");if(L>=0){var w=c.resolveModule(u.substr(0,L)),m=c.resolveModule(u.substr(L+1)),f=this._moduleIdProvider.getModuleId(w+"!"+m),g=this._moduleIdProvider.getModuleId(w);return new s(f,g,m)}return new P(this._moduleIdProvider.getModuleId(c.resolveModule(u)))},l.prototype._normalizeDependencies=function(u,c){for(var L=[],w=0,m=0,f=u.length;m<f;m++)L[w++]=this._normalizeDependency(u[m],c);return L},l.prototype._relativeRequire=function(u,c,L,w){if(typeof c=="string")return this.synchronousRequire(c,u);this.defineModule(I.Utilities.generateAnonymousModule(),c,L,w,null,u)},l.prototype.synchronousRequire=function(u,c){c===void 0&&(c=new t(u));var L=this._normalizeDependency(u,c),w=this._modules2[L.id];if(!w)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!w.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(w.error)throw w.error;return w.exports},l.prototype.configure=function(u,c){var L=this._config.shouldRecordStats();c?this._config=new I.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!L&&(this._recorder=null)},l.prototype.getConfig=function(){return this._config},l.prototype._onLoad=function(u){if(this._currentAnnonymousDefineCall!==null){var c=this._currentAnnonymousDefineCall;this._currentAnnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),c.dependencies,c.callback,null,c.stack)}},l.prototype._createLoadError=function(u,c){var L=this,w=this._moduleIdProvider.getStrModuleId(u),m=(this._inverseDependencies2[u]||[]).map(function(g){return L._moduleIdProvider.getStrModuleId(g)}),f=I.ensureError(c);return f.phase="loading",f.moduleId=w,f.neededBy=m,f},l.prototype._onLoadError=function(u,c){var L=this._createLoadError(u,c);this._modules2[u]||(this._modules2[u]=new p(u,this._moduleIdProvider.getStrModuleId(u),[],function(){},function(){},null));for(var w=[],m=0,f=this._moduleIdProvider.getMaxModuleId();m<f;m++)w[m]=!1;var g=!1,A=[];for(A.push(u),w[u]=!0;A.length>0;){var E=A.shift(),S=this._modules2[E];S&&(g=S.onDependencyError(L)||g);var n=this._inverseDependencies2[E];if(n)for(var m=0,f=n.length;m<f;m++){var i=n[m];w[i]||(A.push(i),w[i]=!0)}}g||this._config.onError(L)},l.prototype._hasDependencyPath=function(u,c){var L=this._modules2[u];if(!L)return!1;for(var w=[],m=0,f=this._moduleIdProvider.getMaxModuleId();m<f;m++)w[m]=!1;var g=[];for(g.push(L),w[u]=!0;g.length>0;){var A=g.shift(),E=A.dependencies;if(E)for(var m=0,f=E.length;m<f;m++){var S=E[m];if(S.id===c)return!0;var n=this._modules2[S.id];n&&!w[S.id]&&(w[S.id]=!0,g.push(n))}}return!1},l.prototype._findCyclePath=function(u,c,L){if(u===c||L===50)return[u];var w=this._modules2[u];if(!w)return null;var m=w.dependencies;if(m)for(var f=0,g=m.length;f<g;f++){var A=this._findCyclePath(m[f].id,c,L+1);if(A!==null)return A.push(u),A}return null},l.prototype._createRequire=function(u){var c=this,L=function(w,m,f){return c._relativeRequire(u,w,m,f)};return L.toUrl=function(w){return c._config.requireToUrl(u.resolveModule(w))},L.getStats=function(){return c.getLoaderEvents()},L.hasDependencyCycle=function(){return c._hasDependencyCycle},L.config=function(w,m){m===void 0&&(m=!1),c.configure(w,m)},L.__$__nodeRequire=I.global.nodeRequire,L},l.prototype._loadModule=function(u){var c=this;if(!(this._modules2[u]||this._knownModules2[u])){this._knownModules2[u]=!0;var L=this._moduleIdProvider.getStrModuleId(u),w=this._config.moduleIdToPaths(L),m=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(L.indexOf("/")===-1||m.test(L))&&w.push("node|"+L);var f=-1,g=function(A){if(f++,f>=w.length)c._onLoadError(u,A);else{var E=w[f],S=c.getRecorder();if(c._config.isBuild()&&E==="empty:"){c._buildInfoPath[u]=E,c.defineModule(c._moduleIdProvider.getStrModuleId(u),[],null,null,null),c._onLoad(u);return}S.record(10,E),c._scriptLoader.load(c,E,function(){c._config.isBuild()&&(c._buildInfoPath[u]=E),S.record(11,E),c._onLoad(u)},function(n){S.record(12,E),g(n)})}};g(null)}},l.prototype._loadPluginDependency=function(u,c){var L=this;if(!(this._modules2[c.id]||this._knownModules2[c.id])){this._knownModules2[c.id]=!0;var w=function(m){L.defineModule(L._moduleIdProvider.getStrModuleId(c.id),[],m,null,null)};w.error=function(m){L._config.onError(L._createLoadError(c.id,m))},u.load(c.pluginParam,this._createRequire(t.ROOT),w,this._config.getOptionsLiteral())}},l.prototype._resolve=function(u){var c=this,L=u.dependencies;if(L)for(var w=0,m=L.length;w<m;w++){var f=L[w];if(f===P.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(f===P.MODULE){u.unresolvedDependenciesCount--;continue}if(f===P.REQUIRE){u.unresolvedDependenciesCount--;continue}var g=this._modules2[f.id];if(g&&g.isComplete()){if(g.error){u.onDependencyError(g.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(f.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(f.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");var A=this._findCyclePath(f.id,u.id,0)||[];A.reverse(),A.push(f.id),console.warn(A.map(function(n){return c._moduleIdProvider.getStrModuleId(n)}).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[f.id]=this._inverseDependencies2[f.id]||[],this._inverseDependencies2[f.id].push(u.id),f instanceof s){var E=this._modules2[f.pluginId];if(E&&E.isComplete()){this._loadPluginDependency(E.exports,f);continue}var S=this._inversePluginDependencies2.get(f.pluginId);S||(S=[],this._inversePluginDependencies2.set(f.pluginId,S)),S.push(f),this._loadModule(f.pluginId);continue}this._loadModule(f.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)},l.prototype._onModuleComplete=function(u){var c=this,L=this.getRecorder();if(!u.isComplete()){var w=u.dependencies,m=[];if(w)for(var f=0,g=w.length;f<g;f++){var A=w[f];if(A===P.EXPORTS){m[f]=u.exports;continue}if(A===P.MODULE){m[f]={id:u.strId,config:function(){return c._config.getConfigForModule(u.strId)}};continue}if(A===P.REQUIRE){m[f]=this._createRequire(u.moduleIdResolver);continue}var E=this._modules2[A.id];if(E){m[f]=E.exports;continue}m[f]=null}u.complete(L,this._config,m);var S=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,S)for(var f=0,g=S.length;f<g;f++){var n=S[f],i=this._modules2[n];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var r=this._inversePluginDependencies2.get(u.id);if(r){this._inversePluginDependencies2.delete(u.id);for(var f=0,g=r.length;f<g;f++)this._loadPluginDependency(u.exports,r[f])}}},l}();I.ModuleManager=b})(ee||(ee={}));var z,ee;(function(I){var t=new I.Environment,p=null,U=function(l,u,c){typeof l!="string"&&(c=u,u=l,l=null),(typeof u!="object"||!Array.isArray(u))&&(c=u,u=null),u||(u=["require","exports","module"]),l?p.defineModule(l,u,c,null,null):p.enqueueDefineAnonymousModule(u,c)};U.amd={jQuery:!0};var P=function(l,u){u===void 0&&(u=!1),p.configure(l,u)},s=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){P(arguments[0]);return}if(typeof arguments[0]=="string")return p.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){p.defineModule(I.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};s.config=P,s.getConfig=function(){return p.getConfig().getOptionsLiteral()},s.reset=function(){p=p.reset()},s.getBuildInfo=function(){return p.getBuildInfo()},s.getStats=function(){return p.getLoaderEvents()},s.define=function(){return U.apply(null,arguments)};function b(){if(typeof I.global.require!="undefined"||typeof require!="undefined"){var l=I.global.require||require;if(typeof l=="function"&&typeof l.resolve=="function"){var u=I.ensureRecordedNodeRequire(p.getRecorder(),l);I.global.nodeRequire=u,s.nodeRequire=u,s.__$__nodeRequire=u}}t.isNode&&!t.isElectronRenderer?(module.exports=s,require=s):(t.isElectronRenderer||(I.global.define=U),I.global.require=s)}I.init=b,(typeof I.global.define!="function"||!I.global.define.amd)&&(p=new I.ModuleManager(t,I.createScriptLoader(t),U,s,I.Utilities.getHighPerformanceTimestamp()),typeof I.global.require!="undefined"&&typeof I.global.require!="function"&&s.config(I.global.require),z=function(){return U.apply(null,arguments)},z.amd=U.amd,typeof doNotInitLoader=="undefined"&&b())})(ee||(ee={}));var be=this,de;(function(I){var t=be||{},p=t.Plugin&&t.Plugin.Resources?t.Plugin.Resources:void 0,U=t&&t.document&&t.document.location&&t.document.location.hash.indexOf("pseudo=true")>=0;function P(c,L){var w;return L.length===0?w=c:w=c.replace(/\{(\d+)\}/g,function(m,f){var g=f[0];return typeof L[g]!="undefined"?L[g]:m}),U&&(w="\uFF3B"+w.replace(/[aouei]/g,"$&$&")+"\uFF3D"),w}function s(c,L){var w=c[L];return w||(w=c["*"],w)?w:null}function b(c,L){for(var w=[],m=0;m<arguments.length-2;m++)w[m]=arguments[m+2];return P(L,w)}function l(c){return function(L,w){var m=Array.prototype.slice.call(arguments,2);return P(c[L],m)}}var u=function(){function c(){this.localize=b}return c.prototype.setPseudoTranslation=function(L){U=L},c.prototype.create=function(L,w){return{localize:l(w[L])}},c.prototype.load=function(L,w,m,f){if(f=f||{},!L||L.length===0)m({localize:b});else{var g=void 0;if(p&&p.getString)g=".nls.keys",w([L+g],function(S){m({localize:function(n,i){if(!S[n])return"NLS error: unknown key "+n;var r=S[n].keys;if(i>=r.length)return"NLS error unknow index "+i;var o=r[i],h=[];h[0]=n+"_"+o;for(var _=0;_<arguments.length-2;_++)h[_+1]=arguments[_+2];return p.getString.apply(p,h)}})});else if(f.isBuild)w([L+".nls",L+".nls.keys"],function(S,n){c.BUILD_MAP[L]=S,c.BUILD_MAP_KEYS[L]=n,m(S)});else{var A=f["vs/nls"]||{},E=A.availableLanguages?s(A.availableLanguages,L):null;g=".nls",E!==null&&E!==c.DEFAULT_TAG&&(g=g+"."+E),w([L+g],function(S){Array.isArray(S)?S.localize=l(S):S.localize=l(S[L]),m(S)})}}},c.prototype._getEntryPointsMap=function(){return t.nlsPluginEntryPoints=t.nlsPluginEntryPoints||{},t.nlsPluginEntryPoints},c.prototype.write=function(L,w,m){var f=m.getEntryPoint(),g=this._getEntryPointsMap();g[f]=g[f]||[],g[f].push(w),w!==f&&m.asModule(L+"!"+w,"define(['vs/nls', 'vs/nls!"+f+`'], function(nls, data) { return nls.create("`+w+'", data); });')},c.prototype.writeFile=function(L,w,m,f,g){var A=this._getEntryPointsMap();if(A.hasOwnProperty(w)){for(var E=m.toUrl(w+".nls.js"),S=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],n=A[w],i={},r=0;r<n.length;r++)i[n[r]]=c.BUILD_MAP[n[r]];S.push('define("'+w+'.nls", '+JSON.stringify(i,null,"	")+");"),f(E,S.join(`\r
`))}},c.prototype.finishBuild=function(L){L("nls.metadata.json",JSON.stringify({keys:c.BUILD_MAP_KEYS,messages:c.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},c.DEFAULT_TAG="i-default",c.BUILD_MAP={},c.BUILD_MAP_KEYS={},c}();I.NLSPlugin=u,function(){z("vs/nls",new u)}()})(de||(de={})),z(V[15],Q([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class p{constructor(P,s,b,l){this.originalStart=P,this.originalLength=s,this.modifiedStart=b,this.modifiedLength=l}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=p}),z(V[4],Q([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(h){setTimeout(()=>{throw h.stack?new Error(h.message+`

`+h.stack):h},0)}}addListener(h){return this.listeners.push(h),()=>{this._removeListener(h)}}emit(h){this.listeners.forEach(_=>{_(h)})}_removeListener(h){this.listeners.splice(this.listeners.indexOf(h),1)}setUnexpectedErrorHandler(h){this.unexpectedErrorHandler=h}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(h){this.unexpectedErrorHandler(h),this.emit(h)}onUnexpectedExternalError(h){this.unexpectedErrorHandler(h)}}t.ErrorHandler=p,t.errorHandler=new p;function U(o){t.errorHandler.setUnexpectedErrorHandler(o)}t.setUnexpectedErrorHandler=U;function P(o){u(o)||t.errorHandler.onUnexpectedError(o)}t.onUnexpectedError=P;function s(o){u(o)||t.errorHandler.onUnexpectedExternalError(o)}t.onUnexpectedExternalError=s;function b(o){if(o instanceof Error){let{name:h,message:_}=o;const a=o.stacktrace||o.stack;return{$isError:!0,name:h,message:_,stack:a}}return o}t.transformErrorForSerialization=b;const l="Canceled";function u(o){return o instanceof Error&&o.name===l&&o.message===l}t.isPromiseCanceledError=u;class c extends Error{constructor(){super(l);this.name=this.message}}t.CancellationError=c;function L(){const o=new Error(l);return o.name=o.message,o}t.canceled=L;function w(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}t.illegalArgument=w;function m(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}t.illegalState=m;function f(o){return o?new Error(`readonly property '${o} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=f;function g(o){const h=new Error(`${o} has been disposed`);return h.name="DISPOSED",h}t.disposed=g;function A(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}t.getErrorMessage=A;class E extends Error{constructor(h){super("NotImplemented");h&&(this.message=h)}}t.NotImplementedError=E;class S extends Error{constructor(h){super("NotSupported");h&&(this.message=h)}}t.NotSupportedError=S;class n extends Error{constructor(){super(...arguments);this.isExpected=!0}}t.ExpectedError=n;function i(o){const h=o;return h instanceof Error&&Array.isArray(h.actions)}t.isErrorWithActions=i;function r(o,h=Object.create(null)){const _=new Error(o);return h.actions&&(_.actions=h.actions),_}t.createErrorWithActions=r}),z(V[7],Q([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function p(U){const P=this;let s=!1,b;return function(){return s||(s=!0,b=U.apply(P,arguments)),b}}t.once=p}),z(V[16],Q([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var p;(function(U){function P(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}U.is=P;const s=Object.freeze([]);function b(){return s}U.empty=b;function*l(o){yield o}U.single=l;function u(o){return o||s}U.from=u;function c(o){return!o||o[Symbol.iterator]().next().done===!0}U.isEmpty=c;function L(o){return o[Symbol.iterator]().next().value}U.first=L;function w(o,h){for(const _ of o)if(h(_))return!0;return!1}U.some=w;function m(o,h){for(const _ of o)if(h(_))return _}U.find=m;function*f(o,h){for(const _ of o)h(_)&&(yield _)}U.filter=f;function*g(o,h){let _=0;for(const a of o)yield h(a,_++)}U.map=g;function*A(...o){for(const h of o)for(const _ of h)yield _}U.concat=A;function*E(o){for(const h of o)for(const _ of h)yield _}U.concatNested=E;function S(o,h,_){let a=_;for(const d of o)a=h(a,d);return a}U.reduce=S;function*n(o,h,_=o.length){for(h<0&&(h+=o.length),_<0?_+=o.length:_>o.length&&(_=o.length);h<_;h++)yield o[h]}U.slice=n;function i(o,h=Number.POSITIVE_INFINITY){const _=[];if(h===0)return[_,o];const a=o[Symbol.iterator]();for(let d=0;d<h;d++){const N=a.next();if(N.done)return[_,U.empty()];_.push(N.value)}return[_,{[Symbol.iterator](){return a}}]}U.consume=i;function r(o,h,_=(a,d)=>a===d){const a=o[Symbol.iterator](),d=h[Symbol.iterator]();for(;;){const N=a.next(),M=d.next();if(N.done!==M.done)return!1;if(N.done)return!0;if(!_(N.value,M.value))return!1}}U.equals=r})(p=t.Iterable||(t.Iterable={}))}),z(V[17],Q([0,1,4]),function(I,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.KeyCode=void 0;var U;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.KEY_0=21]="KEY_0",n[n.KEY_1=22]="KEY_1",n[n.KEY_2=23]="KEY_2",n[n.KEY_3=24]="KEY_3",n[n.KEY_4=25]="KEY_4",n[n.KEY_5=26]="KEY_5",n[n.KEY_6=27]="KEY_6",n[n.KEY_7=28]="KEY_7",n[n.KEY_8=29]="KEY_8",n[n.KEY_9=30]="KEY_9",n[n.KEY_A=31]="KEY_A",n[n.KEY_B=32]="KEY_B",n[n.KEY_C=33]="KEY_C",n[n.KEY_D=34]="KEY_D",n[n.KEY_E=35]="KEY_E",n[n.KEY_F=36]="KEY_F",n[n.KEY_G=37]="KEY_G",n[n.KEY_H=38]="KEY_H",n[n.KEY_I=39]="KEY_I",n[n.KEY_J=40]="KEY_J",n[n.KEY_K=41]="KEY_K",n[n.KEY_L=42]="KEY_L",n[n.KEY_M=43]="KEY_M",n[n.KEY_N=44]="KEY_N",n[n.KEY_O=45]="KEY_O",n[n.KEY_P=46]="KEY_P",n[n.KEY_Q=47]="KEY_Q",n[n.KEY_R=48]="KEY_R",n[n.KEY_S=49]="KEY_S",n[n.KEY_T=50]="KEY_T",n[n.KEY_U=51]="KEY_U",n[n.KEY_V=52]="KEY_V",n[n.KEY_W=53]="KEY_W",n[n.KEY_X=54]="KEY_X",n[n.KEY_Y=55]="KEY_Y",n[n.KEY_Z=56]="KEY_Z",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.US_SEMICOLON=80]="US_SEMICOLON",n[n.US_EQUAL=81]="US_EQUAL",n[n.US_COMMA=82]="US_COMMA",n[n.US_MINUS=83]="US_MINUS",n[n.US_DOT=84]="US_DOT",n[n.US_SLASH=85]="US_SLASH",n[n.US_BACKTICK=86]="US_BACKTICK",n[n.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",n[n.US_BACKSLASH=88]="US_BACKSLASH",n[n.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",n[n.US_QUOTE=90]="US_QUOTE",n[n.OEM_8=91]="OEM_8",n[n.OEM_102=92]="OEM_102",n[n.NUMPAD_0=93]="NUMPAD_0",n[n.NUMPAD_1=94]="NUMPAD_1",n[n.NUMPAD_2=95]="NUMPAD_2",n[n.NUMPAD_3=96]="NUMPAD_3",n[n.NUMPAD_4=97]="NUMPAD_4",n[n.NUMPAD_5=98]="NUMPAD_5",n[n.NUMPAD_6=99]="NUMPAD_6",n[n.NUMPAD_7=100]="NUMPAD_7",n[n.NUMPAD_8=101]="NUMPAD_8",n[n.NUMPAD_9=102]="NUMPAD_9",n[n.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",n[n.NUMPAD_ADD=104]="NUMPAD_ADD",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",n[n.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",n[n.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.MAX_VALUE=112]="MAX_VALUE"})(U=t.KeyCode||(t.KeyCode={}));class P{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(i,r){this._keyCodeToStr[i]=r,this._strToKeyCode[r.toLowerCase()]=i}keyCodeToStr(i){return this._keyCodeToStr[i]}strToKeyCode(i){return this._strToKeyCode[i.toLowerCase()]||0}}const s=new P,b=new P,l=new P;(function(){function n(i,r,o=r,h=o){s.define(i,r),b.define(i,o),l.define(i,h)}n(0,"unknown"),n(1,"Backspace"),n(2,"Tab"),n(3,"Enter"),n(4,"Shift"),n(5,"Ctrl"),n(6,"Alt"),n(7,"PauseBreak"),n(8,"CapsLock"),n(9,"Escape"),n(10,"Space"),n(11,"PageUp"),n(12,"PageDown"),n(13,"End"),n(14,"Home"),n(15,"LeftArrow","Left"),n(16,"UpArrow","Up"),n(17,"RightArrow","Right"),n(18,"DownArrow","Down"),n(19,"Insert"),n(20,"Delete"),n(21,"0"),n(22,"1"),n(23,"2"),n(24,"3"),n(25,"4"),n(26,"5"),n(27,"6"),n(28,"7"),n(29,"8"),n(30,"9"),n(31,"A"),n(32,"B"),n(33,"C"),n(34,"D"),n(35,"E"),n(36,"F"),n(37,"G"),n(38,"H"),n(39,"I"),n(40,"J"),n(41,"K"),n(42,"L"),n(43,"M"),n(44,"N"),n(45,"O"),n(46,"P"),n(47,"Q"),n(48,"R"),n(49,"S"),n(50,"T"),n(51,"U"),n(52,"V"),n(53,"W"),n(54,"X"),n(55,"Y"),n(56,"Z"),n(57,"Meta"),n(58,"ContextMenu"),n(59,"F1"),n(60,"F2"),n(61,"F3"),n(62,"F4"),n(63,"F5"),n(64,"F6"),n(65,"F7"),n(66,"F8"),n(67,"F9"),n(68,"F10"),n(69,"F11"),n(70,"F12"),n(71,"F13"),n(72,"F14"),n(73,"F15"),n(74,"F16"),n(75,"F17"),n(76,"F18"),n(77,"F19"),n(78,"NumLock"),n(79,"ScrollLock"),n(80,";",";","OEM_1"),n(81,"=","=","OEM_PLUS"),n(82,",",",","OEM_COMMA"),n(83,"-","-","OEM_MINUS"),n(84,".",".","OEM_PERIOD"),n(85,"/","/","OEM_2"),n(86,"`","`","OEM_3"),n(110,"ABNT_C1"),n(111,"ABNT_C2"),n(87,"[","[","OEM_4"),n(88,"\\","\\","OEM_5"),n(89,"]","]","OEM_6"),n(90,"'","'","OEM_7"),n(91,"OEM_8"),n(92,"OEM_102"),n(93,"NumPad0"),n(94,"NumPad1"),n(95,"NumPad2"),n(96,"NumPad3"),n(97,"NumPad4"),n(98,"NumPad5"),n(99,"NumPad6"),n(100,"NumPad7"),n(101,"NumPad8"),n(102,"NumPad9"),n(103,"NumPad_Multiply"),n(104,"NumPad_Add"),n(105,"NumPad_Separator"),n(106,"NumPad_Subtract"),n(107,"NumPad_Decimal"),n(108,"NumPad_Divide")})();var u;(function(n){function i(a){return s.keyCodeToStr(a)}n.toString=i;function r(a){return s.strToKeyCode(a)}n.fromString=r;function o(a){return b.keyCodeToStr(a)}n.toUserSettingsUS=o;function h(a){return l.keyCodeToStr(a)}n.toUserSettingsGeneral=h;function _(a){return b.strToKeyCode(a)||l.strToKeyCode(a)}n.fromUserSettings=_})(u=t.KeyCodeUtils||(t.KeyCodeUtils={}));var c;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl",n[n.KeyCode=255]="KeyCode"})(c||(c={}));var L;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl"})(L=t.KeyMod||(t.KeyMod={}));function w(n,i){const r=(i&65535)<<16>>>0;return(n|r)>>>0}t.KeyChord=w;function m(n,i){if(n===0)return null;const r=(n&65535)>>>0,o=(n&4294901760)>>>16;return o!==0?new A([f(r,i),f(o,i)]):new A([f(r,i)])}t.createKeybinding=m;function f(n,i){const r=!!(n&2048),o=!!(n&256),h=i===2?o:r,_=!!(n&1024),a=!!(n&512),d=i===2?r:o,N=n&255;return new g(h,_,a,d,N)}t.createSimpleKeybinding=f;class g{constructor(i,r,o,h,_){this.ctrlKey=i,this.shiftKey=r,this.altKey=o,this.metaKey=h,this.keyCode=_}equals(i){return this.ctrlKey===i.ctrlKey&&this.shiftKey===i.shiftKey&&this.altKey===i.altKey&&this.metaKey===i.metaKey&&this.keyCode===i.keyCode}getHashCode(){const i=this.ctrlKey?"1":"0",r=this.shiftKey?"1":"0",o=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`${i}${r}${o}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new A([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=g;class A{constructor(i){if(i.length===0)throw(0,p.illegalArgument)("parts");this.parts=i}getHashCode(){let i="";for(let r=0,o=this.parts.length;r<o;r++)r!==0&&(i+=";"),i+=this.parts[r].getHashCode();return i}equals(i){if(i===null||this.parts.length!==i.parts.length)return!1;for(let r=0;r<this.parts.length;r++)if(!this.parts[r].equals(i.parts[r]))return!1;return!0}}t.ChordKeybinding=A;class E{constructor(i,r,o,h,_,a){this.ctrlKey=i,this.shiftKey=r,this.altKey=o,this.metaKey=h,this.keyLabel=_,this.keyAriaLabel=a}}t.ResolvedKeybindingPart=E;class S{}t.ResolvedKeybinding=S}),z(V[8],Q([0,1,7,16]),function(I,t,p,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.markAsSingleton=t.setDisposableTracker=void 0;const P=!1;let s=null;function b(a){s=a}if(t.setDisposableTracker=b,P){const a="__is_disposable_tracked__";b(new class{trackDisposable(d){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[a]||console.log(N)},3e3)}setParent(d,N){if(d&&d!==n.None)try{d[a]=!0}catch{}}markAsDisposed(d){if(d&&d!==n.None)try{d[a]=!0}catch{}}markAsSingleton(d){}})}function l(a){return s?.trackDisposable(a),a}function u(a){s?.markAsDisposed(a)}function c(a,d){s?.setParent(a,d)}function L(a,d){if(!!s)for(const N of a)s.setParent(N,d)}function w(a){return s?.markAsSingleton(a),a}t.markAsSingleton=w;class m extends Error{constructor(d){super(`Encountered errors while disposing of store. Errors: [${d.join(", ")}]`);this.errors=d}}t.MultiDisposeError=m;function f(a){return typeof a.dispose=="function"&&a.dispose.length===0}t.isDisposable=f;function g(a){if(U.Iterable.is(a)){let d=[];for(const N of a)if(N)try{N.dispose()}catch(M){d.push(M)}if(d.length===1)throw d[0];if(d.length>1)throw new m(d);return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}t.dispose=g;function A(...a){const d=E(()=>g(a));return L(a,d),d}t.combinedDisposable=A;function E(a){const d=l({dispose:(0,p.once)(()=>{u(d),a()})});return d}t.toDisposable=E;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,l(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return c(d,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(d),d}}t.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class n{constructor(){this._store=new S,l(this),c(this._store,this)}dispose(){u(this),this._store.dispose()}_register(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(d)}}t.Disposable=n,n.None=Object.freeze({dispose(){}});class i{constructor(){this._isDisposed=!1,l(this)}get value(){return this._isDisposed?void 0:this._value}set value(d){this._isDisposed||d===this._value||(this._value?.dispose(),d&&c(d,this),this._value=d)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,u(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const d=this._value;return this._value=void 0,d&&c(d,null),d}}t.MutableDisposable=i;class r{constructor(d){this._disposable=d,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}t.RefCountedDisposable=r;class o{constructor(){this.references=new Map}acquire(d,...N){let M=this.references.get(d);M||(M={counter:0,object:this.createReferencedObject(d,...N)},this.references.set(d,M));const{object:C}=M,R=(0,p.once)(()=>{--M.counter==0&&(this.destroyReferencedObject(d,M.object),this.references.delete(d))});return M.counter++,{object:C,dispose:R}}}t.ReferenceCollection=o;class h{constructor(d){this.referenceCollection=d}async acquire(d,...N){const M=this.referenceCollection.acquire(d,...N);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(C){throw M.dispose(),C}}}t.AsyncReferenceCollection=h;class _{constructor(d){this.object=d}dispose(){}}t.ImmortalReference=_}),z(V[18],Q([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class p{constructor(s){this.element=s,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class U{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let s=this._first;for(;s!==p.Undefined;){const b=s.next;s.prev=p.Undefined,s.next=p.Undefined,s=b}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(s){return this._insert(s,!1)}push(s){return this._insert(s,!0)}_insert(s,b){const l=new p(s);if(this._first===p.Undefined)this._first=l,this._last=l;else if(b){const c=this._last;this._last=l,l.prev=c,c.next=l}else{const c=this._first;this._first=l,l.next=c,c.prev=l}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(l))}}shift(){if(this._first!==p.Undefined){const s=this._first.element;return this._remove(this._first),s}}pop(){if(this._last!==p.Undefined){const s=this._last.element;return this._remove(this._last),s}}_remove(s){if(s.prev!==p.Undefined&&s.next!==p.Undefined){const b=s.prev;b.next=s.next,s.next.prev=b}else s.prev===p.Undefined&&s.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):s.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):s.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let s=this._first;for(;s!==p.Undefined;)yield s.element,s=s.next}}t.LinkedList=U}),z(V[2],Q([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setImmediate=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.isElectronSandboxed=t.globals=void 0;const p="en";let U=!1,P=!1,s=!1,b=!1,l=!1,u=!1,c=!1,L,w=p,m,f;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?g=t.globals.vscode.process:typeof process!="undefined"&&(g=process);const A=typeof g?.versions?.electron=="string"&&g.type==="renderer";if(t.isElectronSandboxed=A&&g?.sandboxed,typeof navigator=="object"&&!A)f=navigator.userAgent,U=f.indexOf("Windows")>=0,P=f.indexOf("Macintosh")>=0,c=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,s=f.indexOf("Linux")>=0,u=!0,L=navigator.language,w=L;else if(typeof g=="object"){U=g.platform==="win32",P=g.platform==="darwin",s=g.platform==="linux",b=s&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,L=p,w=p;const a=g.env.VSCODE_NLS_CONFIG;if(a)try{const d=JSON.parse(a),N=d.availableLanguages["*"];L=d.locale,w=N||p,m=d._translationsConfigFile}catch(d){}l=!0}else console.error("Unable to resolve platform.");var E;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(E=t.Platform||(t.Platform={}));function S(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=S;let n=0;P?n=1:U?n=3:s&&(n=2),t.isWindows=U,t.isMacintosh=P,t.isLinux=s,t.isLinuxSnap=b,t.isNative=l,t.isWeb=u,t.isIOS=c,t.platform=n,t.userAgent=f,t.language=w;var i;(function(a){function d(){return t.language}a.value=d;function N(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}a.isDefaultVariant=N;function M(){return t.language==="en"}a.isDefault=M})(i=t.Language||(t.Language={})),t.locale=L,t.translationsConfigFile=m,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if(typeof t.globals.postMessage=="function"&&!t.globals.importScripts){let N=[];t.globals.addEventListener("message",C=>{if(C.data&&C.data.vscodeSetImmediateId)for(let R=0,F=N.length;R<F;R++){const W=N[R];if(W.id===C.data.vscodeSetImmediateId){N.splice(R,1),W.callback();return}}});let M=0;return C=>{const R=++M;N.push({id:R,callback:C}),t.globals.postMessage({vscodeSetImmediateId:R},"*")}}if(typeof g?.nextTick=="function")return g.nextTick.bind(g);const d=Promise.resolve();return N=>d.then(N)}();var r;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(r=t.OperatingSystem||(t.OperatingSystem={})),t.OS=P||c?2:U?1:3;let o=!0,h=!1;function _(){if(!h){h=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,o=new Uint16Array(a.buffer)[0]===(2<<8)+1}return o}t.isLittleEndian=_}),z(V[19],Q([0,1,2]),function(I,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.nextTick=t.platform=t.env=t.cwd=void 0;let U;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const P=p.globals.vscode.process;U={get platform(){return P.platform},get env(){return P.env},cwd(){return P.cwd()},nextTick(s){return(0,p.setImmediate)(s)}}}else typeof process!="undefined"?U={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(P){return process.nextTick(P)}}:U={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(P){return(0,p.setImmediate)(P)},get env(){return{}},cwd(){return"/"}};t.cwd=U.cwd,t.env=U.env,t.platform=U.platform,t.nextTick=U.nextTick}),z(V[20],Q([0,1,19]),function(I,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const U=65,P=97,s=90,b=122,l=46,u=47,c=92,L=58,w=63;class m extends Error{constructor(r,o,h){let _;typeof o=="string"&&o.indexOf("not ")===0?(_="must not be",o=o.replace(/^not /,"")):_="must be";const a=r.indexOf(".")!==-1?"property":"argument";let d=`The "${r}" ${a} ${_} of type ${o}`;d+=`. Received type ${typeof h}`,super(d),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,r){if(typeof i!="string")throw new m(r,"string",i)}function g(i){return i===u||i===c}function A(i){return i===u}function E(i){return i>=U&&i<=s||i>=P&&i<=b}function S(i,r,o,h){let _="",a=0,d=-1,N=0,M=0;for(let C=0;C<=i.length;++C){if(C<i.length)M=i.charCodeAt(C);else{if(h(M))break;M=u}if(h(M)){if(!(d===C-1||N===1))if(N===2){if(_.length<2||a!==2||_.charCodeAt(_.length-1)!==l||_.charCodeAt(_.length-2)!==l){if(_.length>2){const R=_.lastIndexOf(o);R===-1?(_="",a=0):(_=_.slice(0,R),a=_.length-1-_.lastIndexOf(o)),d=C,N=0;continue}else if(_.length!==0){_="",a=0,d=C,N=0;continue}}r&&(_+=_.length>0?`${o}..`:"..",a=2)}else _.length>0?_+=`${o}${i.slice(d+1,C)}`:_=i.slice(d+1,C),a=C-d-1;d=C,N=0}else M===l&&N!==-1?++N:N=-1}return _}function n(i,r){if(r===null||typeof r!="object")throw new m("pathObject","Object",r);const o=r.dir||r.root,h=r.base||`${r.name||""}${r.ext||""}`;return o?o===r.root?`${o}${h}`:`${o}${i}${h}`:h}t.win32={resolve(...i){let r="",o="",h=!1;for(let _=i.length-1;_>=-1;_--){let a;if(_>=0){if(a=i[_],f(a,"path"),a.length===0)continue}else r.length===0?a=p.cwd():(a=p.env[`=${r}`]||p.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==r.toLowerCase()&&a.charCodeAt(2)===c)&&(a=`${r}\\`));const d=a.length;let N=0,M="",C=!1;const R=a.charCodeAt(0);if(d===1)g(R)&&(N=1,C=!0);else if(g(R))if(C=!0,g(a.charCodeAt(1))){let F=2,W=F;for(;F<d&&!g(a.charCodeAt(F));)F++;if(F<d&&F!==W){const O=a.slice(W,F);for(W=F;F<d&&g(a.charCodeAt(F));)F++;if(F<d&&F!==W){for(W=F;F<d&&!g(a.charCodeAt(F));)F++;(F===d||F!==W)&&(M=`\\\\${O}\\${a.slice(W,F)}`,N=F)}}}else N=1;else E(R)&&a.charCodeAt(1)===L&&(M=a.slice(0,2),N=2,d>2&&g(a.charCodeAt(2))&&(C=!0,N=3));if(M.length>0)if(r.length>0){if(M.toLowerCase()!==r.toLowerCase())continue}else r=M;if(h){if(r.length>0)break}else if(o=`${a.slice(N)}\\${o}`,h=C,C&&r.length>0)break}return o=S(o,!h,"\\",g),h?`${r}\\${o}`:`${r}${o}`||"."},normalize(i){f(i,"path");const r=i.length;if(r===0)return".";let o=0,h,_=!1;const a=i.charCodeAt(0);if(r===1)return A(a)?"\\":i;if(g(a))if(_=!0,g(i.charCodeAt(1))){let N=2,M=N;for(;N<r&&!g(i.charCodeAt(N));)N++;if(N<r&&N!==M){const C=i.slice(M,N);for(M=N;N<r&&g(i.charCodeAt(N));)N++;if(N<r&&N!==M){for(M=N;N<r&&!g(i.charCodeAt(N));)N++;if(N===r)return`\\\\${C}\\${i.slice(M)}\\`;N!==M&&(h=`\\\\${C}\\${i.slice(M,N)}`,o=N)}}}else o=1;else E(a)&&i.charCodeAt(1)===L&&(h=i.slice(0,2),o=2,r>2&&g(i.charCodeAt(2))&&(_=!0,o=3));let d=o<r?S(i.slice(o),!_,"\\",g):"";return d.length===0&&!_&&(d="."),d.length>0&&g(i.charCodeAt(r-1))&&(d+="\\"),h===void 0?_?`\\${d}`:d:_?`${h}\\${d}`:`${h}${d}`},isAbsolute(i){f(i,"path");const r=i.length;if(r===0)return!1;const o=i.charCodeAt(0);return g(o)||r>2&&E(o)&&i.charCodeAt(1)===L&&g(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,o;for(let a=0;a<i.length;++a){const d=i[a];f(d,"path"),d.length>0&&(r===void 0?r=o=d:r+=`\\${d}`)}if(r===void 0)return".";let h=!0,_=0;if(typeof o=="string"&&g(o.charCodeAt(0))){++_;const a=o.length;a>1&&g(o.charCodeAt(1))&&(++_,a>2&&(g(o.charCodeAt(2))?++_:h=!1))}if(h){for(;_<r.length&&g(r.charCodeAt(_));)_++;_>=2&&(r=`\\${r.slice(_)}`)}return t.win32.normalize(r)},relative(i,r){if(f(i,"from"),f(r,"to"),i===r)return"";const o=t.win32.resolve(i),h=t.win32.resolve(r);if(o===h||(i=o.toLowerCase(),r=h.toLowerCase(),i===r))return"";let _=0;for(;_<i.length&&i.charCodeAt(_)===c;)_++;let a=i.length;for(;a-1>_&&i.charCodeAt(a-1)===c;)a--;const d=a-_;let N=0;for(;N<r.length&&r.charCodeAt(N)===c;)N++;let M=r.length;for(;M-1>N&&r.charCodeAt(M-1)===c;)M--;const C=M-N,R=d<C?d:C;let F=-1,W=0;for(;W<R;W++){const j=i.charCodeAt(_+W);if(j!==r.charCodeAt(N+W))break;j===c&&(F=W)}if(W!==R){if(F===-1)return h}else{if(C>R){if(r.charCodeAt(N+W)===c)return h.slice(N+W+1);if(W===2)return h.slice(N+W)}d>R&&(i.charCodeAt(_+W)===c?F=W:W===2&&(F=3)),F===-1&&(F=0)}let O="";for(W=_+F+1;W<=a;++W)(W===a||i.charCodeAt(W)===c)&&(O+=O.length===0?"..":"\\..");return N+=F,O.length>0?`${O}${h.slice(N,M)}`:(h.charCodeAt(N)===c&&++N,h.slice(N,M))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const r=t.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===c){if(r.charCodeAt(1)===c){const o=r.charCodeAt(2);if(o!==w&&o!==l)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(E(r.charCodeAt(0))&&r.charCodeAt(1)===L&&r.charCodeAt(2)===c)return`\\\\?\\${r}`;return i},dirname(i){f(i,"path");const r=i.length;if(r===0)return".";let o=-1,h=0;const _=i.charCodeAt(0);if(r===1)return g(_)?i:".";if(g(_)){if(o=h=1,g(i.charCodeAt(1))){let N=2,M=N;for(;N<r&&!g(i.charCodeAt(N));)N++;if(N<r&&N!==M){for(M=N;N<r&&g(i.charCodeAt(N));)N++;if(N<r&&N!==M){for(M=N;N<r&&!g(i.charCodeAt(N));)N++;if(N===r)return i;N!==M&&(o=h=N+1)}}}}else E(_)&&i.charCodeAt(1)===L&&(o=r>2&&g(i.charCodeAt(2))?3:2,h=o);let a=-1,d=!0;for(let N=r-1;N>=h;--N)if(g(i.charCodeAt(N))){if(!d){a=N;break}}else d=!1;if(a===-1){if(o===-1)return".";a=o}return i.slice(0,a)},basename(i,r){r!==void 0&&f(r,"ext"),f(i,"path");let o=0,h=-1,_=!0,a;if(i.length>=2&&E(i.charCodeAt(0))&&i.charCodeAt(1)===L&&(o=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let d=r.length-1,N=-1;for(a=i.length-1;a>=o;--a){const M=i.charCodeAt(a);if(g(M)){if(!_){o=a+1;break}}else N===-1&&(_=!1,N=a+1),d>=0&&(M===r.charCodeAt(d)?--d==-1&&(h=a):(d=-1,h=N))}return o===h?h=N:h===-1&&(h=i.length),i.slice(o,h)}for(a=i.length-1;a>=o;--a)if(g(i.charCodeAt(a))){if(!_){o=a+1;break}}else h===-1&&(_=!1,h=a+1);return h===-1?"":i.slice(o,h)},extname(i){f(i,"path");let r=0,o=-1,h=0,_=-1,a=!0,d=0;i.length>=2&&i.charCodeAt(1)===L&&E(i.charCodeAt(0))&&(r=h=2);for(let N=i.length-1;N>=r;--N){const M=i.charCodeAt(N);if(g(M)){if(!a){h=N+1;break}continue}_===-1&&(a=!1,_=N+1),M===l?o===-1?o=N:d!==1&&(d=1):o!==-1&&(d=-1)}return o===-1||_===-1||d===0||d===1&&o===_-1&&o===h+1?"":i.slice(o,_)},format:n.bind(null,"\\"),parse(i){f(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const o=i.length;let h=0,_=i.charCodeAt(0);if(o===1)return g(_)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(g(_)){if(h=1,g(i.charCodeAt(1))){let F=2,W=F;for(;F<o&&!g(i.charCodeAt(F));)F++;if(F<o&&F!==W){for(W=F;F<o&&g(i.charCodeAt(F));)F++;if(F<o&&F!==W){for(W=F;F<o&&!g(i.charCodeAt(F));)F++;F===o?h=F:F!==W&&(h=F+1)}}}}else if(E(_)&&i.charCodeAt(1)===L){if(o<=2)return r.root=r.dir=i,r;if(h=2,g(i.charCodeAt(2))){if(o===3)return r.root=r.dir=i,r;h=3}}h>0&&(r.root=i.slice(0,h));let a=-1,d=h,N=-1,M=!0,C=i.length-1,R=0;for(;C>=h;--C){if(_=i.charCodeAt(C),g(_)){if(!M){d=C+1;break}continue}N===-1&&(M=!1,N=C+1),_===l?a===-1?a=C:R!==1&&(R=1):a!==-1&&(R=-1)}return N!==-1&&(a===-1||R===0||R===1&&a===N-1&&a===d+1?r.base=r.name=i.slice(d,N):(r.name=i.slice(d,a),r.base=i.slice(d,N),r.ext=i.slice(a,N))),d>0&&d!==h?r.dir=i.slice(0,d-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...i){let r="",o=!1;for(let h=i.length-1;h>=-1&&!o;h--){const _=h>=0?i[h]:p.cwd();f(_,"path"),_.length!==0&&(r=`${_}/${r}`,o=_.charCodeAt(0)===u)}return r=S(r,!o,"/",A),o?`/${r}`:r.length>0?r:"."},normalize(i){if(f(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===u,o=i.charCodeAt(i.length-1)===u;return i=S(i,!r,"/",A),i.length===0?r?"/":o?"./":".":(o&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return f(i,"path"),i.length>0&&i.charCodeAt(0)===u},join(...i){if(i.length===0)return".";let r;for(let o=0;o<i.length;++o){const h=i[o];f(h,"path"),h.length>0&&(r===void 0?r=h:r+=`/${h}`)}return r===void 0?".":t.posix.normalize(r)},relative(i,r){if(f(i,"from"),f(r,"to"),i===r||(i=t.posix.resolve(i),r=t.posix.resolve(r),i===r))return"";const o=1,h=i.length,_=h-o,a=1,d=r.length-a,N=_<d?_:d;let M=-1,C=0;for(;C<N;C++){const F=i.charCodeAt(o+C);if(F!==r.charCodeAt(a+C))break;F===u&&(M=C)}if(C===N)if(d>N){if(r.charCodeAt(a+C)===u)return r.slice(a+C+1);if(C===0)return r.slice(a+C)}else _>N&&(i.charCodeAt(o+C)===u?M=C:C===0&&(M=0));let R="";for(C=o+M+1;C<=h;++C)(C===h||i.charCodeAt(C)===u)&&(R+=R.length===0?"..":"/..");return`${R}${r.slice(a+M)}`},toNamespacedPath(i){return i},dirname(i){if(f(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===u;let o=-1,h=!0;for(let _=i.length-1;_>=1;--_)if(i.charCodeAt(_)===u){if(!h){o=_;break}}else h=!1;return o===-1?r?"/":".":r&&o===1?"//":i.slice(0,o)},basename(i,r){r!==void 0&&f(r,"ext"),f(i,"path");let o=0,h=-1,_=!0,a;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let d=r.length-1,N=-1;for(a=i.length-1;a>=0;--a){const M=i.charCodeAt(a);if(M===u){if(!_){o=a+1;break}}else N===-1&&(_=!1,N=a+1),d>=0&&(M===r.charCodeAt(d)?--d==-1&&(h=a):(d=-1,h=N))}return o===h?h=N:h===-1&&(h=i.length),i.slice(o,h)}for(a=i.length-1;a>=0;--a)if(i.charCodeAt(a)===u){if(!_){o=a+1;break}}else h===-1&&(_=!1,h=a+1);return h===-1?"":i.slice(o,h)},extname(i){f(i,"path");let r=-1,o=0,h=-1,_=!0,a=0;for(let d=i.length-1;d>=0;--d){const N=i.charCodeAt(d);if(N===u){if(!_){o=d+1;break}continue}h===-1&&(_=!1,h=d+1),N===l?r===-1?r=d:a!==1&&(a=1):r!==-1&&(a=-1)}return r===-1||h===-1||a===0||a===1&&r===h-1&&r===o+1?"":i.slice(r,h)},format:n.bind(null,"/"),parse(i){f(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const o=i.charCodeAt(0)===u;let h;o?(r.root="/",h=1):h=0;let _=-1,a=0,d=-1,N=!0,M=i.length-1,C=0;for(;M>=h;--M){const R=i.charCodeAt(M);if(R===u){if(!N){a=M+1;break}continue}d===-1&&(N=!1,d=M+1),R===l?_===-1?_=M:C!==1&&(C=1):_!==-1&&(C=-1)}if(d!==-1){const R=a===0&&o?1:a;_===-1||C===0||C===1&&_===d-1&&_===a+1?r.base=r.name=i.slice(R,d):(r.name=i.slice(R,_),r.base=i.slice(R,d),r.ext=i.slice(_,d))}return a>0?r.dir=i.slice(0,a-1):o&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=p.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=p.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=p.platform==="win32"?t.win32.join:t.posix.join,t.resolve=p.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=p.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=p.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=p.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=p.platform==="win32"?t.win32.extname:t.posix.extname,t.format=p.platform==="win32"?t.win32.format:t.posix.format,t.parse=p.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=p.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=p.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=p.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),z(V[9],Q([0,1,2]),function(I,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const U=p.globals.performance&&typeof p.globals.performance.now=="function";class P{constructor(b){this._highResolution=U&&b,this._startTime=this._now(),this._stopTime=-1}static create(b=!0){return new P(b)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}t.StopWatch=P}),z(V[10],Q([0,1,4,7,8,18,9]),function(I,t,p,U,P,s,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;var l;(function(i){i.None=()=>P.Disposable.None;function r(e){return(q,y=null,H)=>{let X=!1,Z;return Z=e(K=>{if(!X)return Z?Z.dispose():X=!0,q.call(y,K)},null,H),X&&Z.dispose(),Z}}i.once=r;function o(e,q){return M((y,H=null,X)=>e(Z=>y.call(H,q(Z)),null,X))}i.map=o;function h(e,q){return M((y,H=null,X)=>e(Z=>{q(Z),y.call(H,Z)},null,X))}i.forEach=h;function _(e,q){return M((y,H=null,X)=>e(Z=>q(Z)&&y.call(H,Z),null,X))}i.filter=_;function a(e){return e}i.signal=a;function d(...e){return(q,y=null,H)=>(0,P.combinedDisposable)(...e.map(X=>X(Z=>q.call(y,Z),null,H)))}i.any=d;function N(e,q,y){let H=y;return o(e,X=>(H=q(H,X),H))}i.reduce=N;function M(e){let q;const y=new m({onFirstListenerAdd(){q=e(y.fire,y)},onLastListenerRemove(){q.dispose()}});return y.event}function C(e,q,y=100,H=!1,X){let Z,K,ne,ue=0;const oe=new m({leakWarningThreshold:X,onFirstListenerAdd(){Z=e(fe=>{ue++,K=q(K,fe),H&&!ne&&(oe.fire(K),K=void 0),clearTimeout(ne),ne=setTimeout(()=>{const he=K;K=void 0,ne=void 0,(!H||ue>1)&&oe.fire(he),ue=0},y)})},onLastListenerRemove(){Z.dispose()}});return oe.event}i.debounce=C;function R(e,q=(y,H)=>y===H){let y=!0,H;return _(e,X=>{const Z=y||!q(X,H);return y=!1,H=X,Z})}i.latch=R;function F(e,q){return[i.filter(e,q),i.filter(e,y=>!q(y))]}i.split=F;function W(e,q=!1,y=[]){let H=y.slice(),X=e(ne=>{H?H.push(ne):K.fire(ne)});const Z=()=>{H&&H.forEach(ne=>K.fire(ne)),H=null},K=new m({onFirstListenerAdd(){X||(X=e(ne=>K.fire(ne)))},onFirstListenerDidAdd(){H&&(q?setTimeout(Z):Z())},onLastListenerRemove(){X&&X.dispose(),X=null}});return K.event}i.buffer=W;class O{constructor(q){this.event=q}map(q){return new O(o(this.event,q))}forEach(q){return new O(h(this.event,q))}filter(q){return new O(_(this.event,q))}reduce(q,y){return new O(N(this.event,q,y))}latch(){return new O(R(this.event))}debounce(q,y=100,H=!1,X){return new O(C(this.event,q,y,H,X))}on(q,y,H){return this.event(q,y,H)}once(q,y,H){return r(this.event)(q,y,H)}}function j(e){return new O(e)}i.chain=j;function J(e,q,y=H=>H){const H=(...ne)=>K.fire(y(...ne)),X=()=>e.on(q,H),Z=()=>e.removeListener(q,H),K=new m({onFirstListenerAdd:X,onLastListenerRemove:Z});return K.event}i.fromNodeEventEmitter=J;function G(e,q,y=H=>H){const H=(...ne)=>K.fire(y(...ne)),X=()=>e.addEventListener(q,H),Z=()=>e.removeEventListener(q,H),K=new m({onFirstListenerAdd:X,onLastListenerRemove:Z});return K.event}i.fromDOMEventEmitter=G;function x(e){return new Promise(q=>r(e)(q))}i.toPromise=x})(l=t.Event||(t.Event={}));class u{constructor(r){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${r}_${u._idPool++}`}start(r){this._stopWatch=new b.StopWatch(!0),this._listenerCount=r}stop(){if(this._stopWatch){const r=this._stopWatch.elapsed();this._elapsedOverall+=r,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${r.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}u._idPool=0;let c=-1;function L(i){const r=c;return c=i,{dispose(){c=r}}}t.setGlobalLeakWarningThreshold=L;class w{constructor(r,o=Math.random().toString(18).slice(2,5)){this.customThreshold=r,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(r){let o=c;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||r<o)return;this._stacks||(this._stacks=new Map);const h=new Error().stack.split(`
`).slice(3).join(`
`),_=this._stacks.get(h)||0;if(this._stacks.set(h,_+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let a,d=0;for(const[N,M]of this._stacks)(!a||d<M)&&(a=N,d=M);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${d}):`),console.warn(a)}return()=>{const a=this._stacks.get(h)||0;this._stacks.set(h,a-1)}}}class m{constructor(r){this._disposed=!1,this._options=r,this._leakageMon=c>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new u(this._options._profName):void 0}get event(){return this._event||(this._event=(r,o,h)=>{this._listeners||(this._listeners=new s.LinkedList);const _=this._listeners.isEmpty();_&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const a=this._listeners.push(o?[r,o]:r);_&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,r,o);const d=this._leakageMon?.check(this._listeners.size),N=(0,P.toDisposable)(()=>{d&&d(),this._disposed||(a(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof P.DisposableStore?h.add(N):Array.isArray(h)&&h.push(N),N}),this._event}fire(r){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,r]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,h]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,h):o[0].call(o[1],h)}catch(_){(0,p.onUnexpectedError)(_)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}t.Emitter=m;class f extends m{async fireAsync(r,o,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new s.LinkedList);for(const _ of this._listeners)this._asyncDeliveryQueue.push([_,r]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[_,a]=this._asyncDeliveryQueue.shift(),d=[],N={...a,waitUntil:M=>{if(Object.isFrozen(d))throw new Error("waitUntil can NOT be called asynchronous");h&&(M=h(M,typeof _=="function"?_:_[0])),d.push(M)}};try{typeof _=="function"?_.call(void 0,N):_[0].call(_[1],N)}catch(M){(0,p.onUnexpectedError)(M);continue}Object.freeze(d),await Promise.allSettled(d).then(M=>{for(const C of M)C.status==="rejected"&&(0,p.onUnexpectedError)(C.reason)})}}}}t.AsyncEmitter=f;class g extends m{constructor(r){super(r);this._isPaused=0,this._eventQueue=new s.LinkedList,this._mergeFn=r?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const r=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(r))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(r){this._listeners&&(this._isPaused!==0?this._eventQueue.push(r):super.fire(r))}}t.PauseableEmitter=g;class A extends g{constructor(r){super(r);this._delay=r.delay??100}fire(r){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(r)}}t.DebounceEmitter=A;class E{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(r){const o={event:r,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const h=()=>{this.hasListeners&&this.unhook(o);const _=this.events.indexOf(o);this.events.splice(_,1)};return(0,P.toDisposable)((0,U.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(r=>this.hook(r))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(r=>this.unhook(r))}hook(r){r.listener=r.event(o=>this.emitter.fire(o))}unhook(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=E;class S{constructor(){this.buffers=[]}wrapEvent(r){return(o,h,_)=>r(a=>{const d=this.buffers[this.buffers.length-1];d?d.push(()=>o.call(h,a)):o.call(h,a)},void 0,_)}bufferEvents(r){const o=[];this.buffers.push(o);const h=r();return this.buffers.pop(),o.forEach(_=>_()),h}}t.EventBufferer=S;class n{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=P.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(r){this.inputEvent=r,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=r(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=n}),z(V[21],Q([0,1,10]),function(I,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const U=Object.freeze(function(l,u){const c=setTimeout(l.bind(u),0);return{dispose(){clearTimeout(c)}}});var P;(function(l){function u(c){return c===l.None||c===l.Cancelled||c instanceof s?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}l.isCancellationToken=u,l.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),l.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:U})})(P=t.CancellationToken||(t.CancellationToken={}));class s{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?U:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class b{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new s),this._token}cancel(){this._token?this._token instanceof s&&this._token.cancel():this._token=P.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof s&&this._token.dispose():this._token=P.None}}t.CancellationTokenSource=b}),z(V[5],Q([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLeftDeleteOffset=t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.decodeUTF8=t.encodeUTF8=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function p(v){return!v||typeof v!="string"?!0:v.trim().length===0}t.isFalsyOrWhitespace=p;const U=/{(\d+)}/g;function P(v,...D){return D.length===0?v:v.replace(U,function(T,k){const B=parseInt(k,10);return isNaN(B)||B<0||B>=D.length?T:D[B]})}t.format=P;const s=/{([^}]+)}/g;function b(v,D){return v.replace(s,(T,k)=>D[k]??T)}t.format2=b;function l(v){return v.replace(/[<>&]/g,function(D){switch(D){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return D}})}t.escape=l;function u(v){return v.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=u;function c(v,D){let T=0;const k=D.charCodeAt(0);for(let B=v.length-1;B>=0;B--)v.charCodeAt(B)===k&&T++;return T}t.count=c;function L(v,D,T="\u2026"){return v.length<=D?v:`${v.substr(0,D)}${T}`}t.truncate=L;function w(v,D=" "){const T=m(v,D);return f(T,D)}t.trim=w;function m(v,D){if(!v||!D)return v;const T=D.length;if(T===0||v.length===0)return v;let k=0;for(;v.indexOf(D,k)===k;)k=k+T;return v.substring(k)}t.ltrim=m;function f(v,D){if(!v||!D)return v;const T=D.length,k=v.length;if(T===0||k===0)return v;let B=k,Y=-1;for(;Y=v.lastIndexOf(D,B-1),!(Y===-1||Y+T!==B);){if(Y===0)return"";B=Y}return v.substring(0,B)}t.rtrim=f;function g(v){return v.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=g;function A(v){return v.replace(/\*/g,"")}t.stripWildcards=A;function E(v,D,T={}){if(!v)throw new Error("Cannot create regex from empty string");D||(v=u(v)),T.wholeWord&&(/\B/.test(v.charAt(0))||(v="\\b"+v),/\B/.test(v.charAt(v.length-1))||(v=v+"\\b"));let k="";return T.global&&(k+="g"),T.matchCase||(k+="i"),T.multiline&&(k+="m"),T.unicode&&(k+="u"),new RegExp(v,k)}t.createRegExp=E;function S(v){return v.source==="^"||v.source==="^$"||v.source==="$"||v.source==="^\\s*$"?!1:!!(v.exec("")&&v.lastIndex===0)}t.regExpLeadsToEndlessLoop=S;function n(v){return!!v.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=n;function i(v){return(v.global?"g":"")+(v.ignoreCase?"i":"")+(v.multiline?"m":"")+(v.unicode?"u":"")}t.regExpFlags=i;function r(v){return v.split(/\r\n|\r|\n/)}t.splitLines=r;function o(v){for(let D=0,T=v.length;D<T;D++){const k=v.charCodeAt(D);if(k!==32&&k!==9)return D}return-1}t.firstNonWhitespaceIndex=o;function h(v,D=0,T=v.length){for(let k=D;k<T;k++){const B=v.charCodeAt(k);if(B!==32&&B!==9)return v.substring(D,k)}return v.substring(D,T)}t.getLeadingWhitespace=h;function _(v,D=v.length-1){for(let T=D;T>=0;T--){const k=v.charCodeAt(T);if(k!==32&&k!==9)return T}return-1}t.lastNonWhitespaceIndex=_;function a(v,D){return v<D?-1:v>D?1:0}t.compare=a;function d(v,D,T=0,k=v.length,B=0,Y=D.length){for(;T<k&&B<Y;T++,B++){let ie=v.charCodeAt(T),re=D.charCodeAt(B);if(ie<re)return-1;if(ie>re)return 1}const $=k-T,te=Y-B;return $<te?-1:$>te?1:0}t.compareSubstring=d;function N(v,D){return M(v,D,0,v.length,0,D.length)}t.compareIgnoreCase=N;function M(v,D,T=0,k=v.length,B=0,Y=D.length){for(;T<k&&B<Y;T++,B++){let ie=v.charCodeAt(T),re=D.charCodeAt(B);if(ie===re)continue;const le=ie-re;if(!(le===32&&R(re))&&!(le===-32&&R(ie)))return C(ie)&&C(re)?le:d(v.toLowerCase(),D.toLowerCase(),T,k,B,Y)}const $=k-T,te=Y-B;return $<te?-1:$>te?1:0}t.compareSubstringIgnoreCase=M;function C(v){return v>=97&&v<=122}t.isLowerAsciiLetter=C;function R(v){return v>=65&&v<=90}t.isUpperAsciiLetter=R;function F(v){return C(v)||R(v)}function W(v,D){return v.length===D.length&&O(v,D)}t.equalsIgnoreCase=W;function O(v,D,T=v.length){for(let k=0;k<T;k++){const B=v.charCodeAt(k),Y=D.charCodeAt(k);if(B!==Y){if(F(B)&&F(Y)){const $=Math.abs(B-Y);if($!==0&&$!==32)return!1}else if(String.fromCharCode(B).toLowerCase()!==String.fromCharCode(Y).toLowerCase())return!1}}return!0}function j(v,D){const T=D.length;return D.length>v.length?!1:O(v,D,T)}t.startsWithIgnoreCase=j;function J(v,D){let T,k=Math.min(v.length,D.length);for(T=0;T<k;T++)if(v.charCodeAt(T)!==D.charCodeAt(T))return T;return k}t.commonPrefixLength=J;function G(v,D){let T,k=Math.min(v.length,D.length);const B=v.length-1,Y=D.length-1;for(T=0;T<k;T++)if(v.charCodeAt(B-T)!==D.charCodeAt(Y-T))return T;return k}t.commonSuffixLength=G;function x(v){return 55296<=v&&v<=56319}t.isHighSurrogate=x;function e(v){return 56320<=v&&v<=57343}t.isLowSurrogate=e;function q(v,D){return(v-55296<<10)+(D-56320)+65536}t.computeCodePoint=q;function y(v,D,T){const k=v.charCodeAt(T);if(x(k)&&T+1<D){const B=v.charCodeAt(T+1);if(e(B))return q(k,B)}return k}t.getNextCodePoint=y;function H(v,D){const T=v.charCodeAt(D-1);if(e(T)&&D>1){const k=v.charCodeAt(D-2);if(x(k))return q(k,T)}return T}function X(v,D){const T=se.getInstance(),k=D,B=v.length,Y=y(v,B,D);D+=Y>=65536?2:1;let $=T.getGraphemeBreakType(Y);for(;D<B;){const te=y(v,B,D),ie=T.getGraphemeBreakType(te);if(ae($,ie))break;D+=te>=65536?2:1,$=ie}return D-k}t.nextCharLength=X;function Z(v,D){const T=se.getInstance(),k=D,B=H(v,D);D-=B>=65536?2:1;let Y=T.getGraphemeBreakType(B);for(;D>0;){const $=H(v,D),te=T.getGraphemeBreakType($);if(ae(te,Y))break;D-=$>=65536?2:1,Y=te}return k-D}t.prevCharLength=Z;function K(v,D){const T=se.getInstance(),k=v.length,B=D,Y=y(v,k,D),$=T.getGraphemeBreakType(Y);D+=Y>=65536?2:1;let te=$;for(;D<k;){const re=y(v,k,D),le=T.getGraphemeBreakType(re);if(ae(te,le))break;D+=re>=65536?2:1,te=le}const ie=D;for(D=B,te=$;D>0;){const re=H(v,D),le=T.getGraphemeBreakType(re);if(ae(le,te))break;D-=re>=65536?2:1,te=le}return[D,ie]}function ne(v,D){return D>0&&e(v.charCodeAt(D))?K(v,D-1):K(v,D)}t.getCharContainingOffset=ne;function ue(v){const D=v.length;let T=0,k=0;for(;k<D;){const $=y(v,D,k);k+=$>=65536?2:1,$<128?T+=1:$<2048?T+=2:$<65536?T+=3:T+=4}const B=new Uint8Array(T);k=0;let Y=0;for(;k<D;){const $=y(v,D,k);k+=$>=65536?2:1,$<128?B[Y++]=$:$<2048?(B[Y++]=192|($&1984)>>>6,B[Y++]=128|($&63)>>>0):$<65536?(B[Y++]=224|($&61440)>>>12,B[Y++]=128|($&4032)>>>6,B[Y++]=128|($&63)>>>0):(B[Y++]=240|($&1835008)>>>18,B[Y++]=128|($&258048)>>>12,B[Y++]=128|($&4032)>>>6,B[Y++]=128|($&63)>>>0)}return B}t.encodeUTF8=ue;function oe(v){const D=v.byteLength,T=[];let k=0;for(;k<D;){const B=v[k];let Y;if(B>=240&&k+3<D?Y=(v[k++]&7)<<18>>>0|(v[k++]&63)<<12>>>0|(v[k++]&63)<<6>>>0|(v[k++]&63)<<0>>>0:B>=224&&k+2<D?Y=(v[k++]&15)<<12>>>0|(v[k++]&63)<<6>>>0|(v[k++]&63)<<0>>>0:B>=192&&k+1<D?Y=(v[k++]&31)<<6>>>0|(v[k++]&63)<<0>>>0:Y=v[k++],Y>=0&&Y<=55295||Y>=57344&&Y<=65535)T.push(String.fromCharCode(Y));else if(Y>=65536&&Y<=1114111){const $=Y-65536,te=55296+(($&1047552)>>>10),ie=56320+(($&1023)>>>0);T.push(String.fromCharCode(te)),T.push(String.fromCharCode(ie))}else T.push(String.fromCharCode(65533))}return T.join("")}t.decodeUTF8=oe;const fe=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function he(v){return fe.test(v)}t.containsRTL=he;const Ee=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ae(v){return Ee.test(v)}t.containsEmoji=Ae;const Ne=/^[\t\n\r\x20-\x7E]*$/;function we(v){return Ne.test(v)}t.isBasicASCII=we,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ce(v){return t.UNUSUAL_LINE_TERMINATORS.test(v)}t.containsUnusualLineTerminators=Ce;function Pe(v){for(let D=0,T=v.length;D<T;D++)if(ge(v.charCodeAt(D)))return!0;return!1}t.containsFullWidthCharacter=Pe;function ge(v){return v=+v,v>=11904&&v<=55215||v>=63744&&v<=64255||v>=65281&&v<=65374}t.isFullWidthCharacter=ge;function me(v){return v>=127462&&v<=127487||v===8986||v===8987||v===9200||v===9203||v>=9728&&v<=10175||v===11088||v===11093||v>=127744&&v<=128591||v>=128640&&v<=128764||v>=128992&&v<=129003||v>=129280&&v<=129535||v>=129648&&v<=129750}t.isEmojiImprecise=me;function Me(v,D){if(v.length<D)return v;const T=/\b/g;let k=0;for(;T.test(v)&&!(v.length-T.lastIndex<D);)k=T.lastIndex,T.lastIndex+=1;return v.substring(k).replace(/^\s/,"")}t.lcut=Me;const pe=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Ue=/\x1b\[0?m/g;function Re(v){return v&&(v=v.replace(pe,""),v=v.replace(De,""),v=v.replace(Ue,"")),v}t.removeAnsiEscapeCodes=Re,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function _e(v){return!!(v&&v.length>0&&v.charCodeAt(0)===65279)}t.startsWithUTF8BOM=_e;function Fe(v){return _e(v)?v.substr(1):v}t.stripUTF8BOM=Fe;function Ie(v,D){if(!v||!D||v.length<D.length)return!1;const T=D.length,k=v.toLowerCase();let B=0,Y=-1;for(;B<T;){const $=k.indexOf(D[B],Y+1);if($<0)return!1;Y=$,B++}return!0}t.fuzzyContains=Ie;function Te(v,D=!1){return v?(D&&(v=v.replace(/\\./g,"")),v.toLowerCase()!==v):!1}t.containsUppercaseCharacter=Te;function ke(v){return v.charAt(0).toUpperCase()+v.slice(1)}t.uppercaseFirstLetter=ke;function ye(v,D=1){if(D===0)return"";let T=-1;do T=v.indexOf(`
`,T+1),D--;while(D>0&&T>=0);return T===-1?v:(v[T-1]==="\r"&&T--,v.substr(0,T))}t.getNLines=ye;function We(v){const D=90-65+1;return v=v%(2*D),v<D?String.fromCharCode(97+v):String.fromCharCode(65+v-D)}t.singleLetterHash=We;function Oe(v){return se.getInstance().getGraphemeBreakType(v)}t.getGraphemeBreakType=Oe;function ae(v,D){return v===0?D!==5&&D!==7:v===2&&D===3?!1:v===4||v===2||v===3||D===4||D===2||D===3?!0:!(v===8&&(D===8||D===9||D===11||D===12)||(v===11||v===9)&&(D===9||D===10)||(v===12||v===10)&&D===10||D===5||D===13||D===7||v===1||v===13&&D===14||v===6&&D===6)}t.breakBetweenGraphemeBreakType=ae;var qe;(function(v){v[v.Other=0]="Other",v[v.Prepend=1]="Prepend",v[v.CR=2]="CR",v[v.LF=3]="LF",v[v.Control=4]="Control",v[v.Extend=5]="Extend",v[v.Regional_Indicator=6]="Regional_Indicator",v[v.SpacingMark=7]="SpacingMark",v[v.L=8]="L",v[v.V=9]="V",v[v.T=10]="T",v[v.LV=11]="LV",v[v.LVT=12]="LVT",v[v.ZWJ=13]="ZWJ",v[v.Extended_Pictographic=14]="Extended_Pictographic"})(qe=t.GraphemeBreakType||(t.GraphemeBreakType={}));class se{constructor(){this._data=Be()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(D){if(D<32)return D===10?3:D===13?2:4;if(D<127)return 0;const T=this._data,k=T.length/3;let B=1;for(;B<=k;)if(D<T[3*B])B=2*B;else if(D>T[3*B+1])B=2*B+1;else return T[3*B+2];return 0}}se._INSTANCE=null;function Be(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function He(v,D){if(v===0)return 0;const T=Ye(v,D);if(T!==void 0)return T;const k=H(D,v);return v-=ce(k),v}t.getLeftDeleteOffset=He;function Ye(v,D){let T=H(D,v);for(v-=ce(T);je(T)||T===65039||T===8419;){if(v===0)return;T=H(D,v),v-=ce(T)}if(!!me(T)){if(v>=0){const k=H(D,v);k===8205&&(v-=ce(k))}return v}}function ce(v){return v>=65536?2:1}function je(v){return 127995<=v&&v<=127999}var ve;(function(v){v[v.zwj=8205]="zwj",v[v.emojiVariantSelector=65039]="emojiVariantSelector",v[v.enclosingKeyCap=8419]="enclosingKeyCap"})(ve||(ve={}))}),z(V[22],Q([0,1,5]),function(I,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.doHash=t.hash=void 0;function U(S){return P(S,0)}t.hash=U;function P(S,n){switch(typeof S){case"object":return S===null?s(349,n):Array.isArray(S)?u(S,n):c(S,n);case"string":return l(S,n);case"boolean":return b(S,n);case"number":return s(S,n);case"undefined":return s(937,n);default:return s(617,n)}}t.doHash=P;function s(S,n){return(n<<5)-n+S|0}function b(S,n){return s(S?433:863,n)}function l(S,n){n=s(149417,n);for(let i=0,r=S.length;i<r;i++)n=s(S.charCodeAt(i),n);return n}t.stringHash=l;function u(S,n){return n=s(104579,n),S.reduce((i,r)=>P(r,i),n)}function c(S,n){return n=s(181387,n),Object.keys(S).sort().reduce((i,r)=>(i=l(r,i),P(S[r],i)),n)}class L{constructor(){this._value=0}get value(){return this._value}hash(n){return this._value=P(n,this._value),this._value}}t.Hasher=L;var w;(function(S){S[S.BLOCK_SIZE=64]="BLOCK_SIZE",S[S.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function m(S,n,i=32){const r=i-n,o=~((1<<r)-1);return(S<<n|(o&S)>>>r)>>>0}function f(S,n=0,i=S.byteLength,r=0){for(let o=0;o<i;o++)S[n+o]=r}function g(S,n,i="0"){for(;S.length<n;)S=i+S;return S}function A(S,n=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(i=>i.toString(16).padStart(2,"0")).join(""):g((S>>>0).toString(16),n/4)}t.toHexString=A;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(n){const i=n.length;if(i===0)return;const r=this._buff;let o=this._buffLen,h=this._leftoverHighSurrogate,_,a;for(h!==0?(_=h,a=-1,h=0):(_=n.charCodeAt(0),a=0);;){let d=_;if(p.isHighSurrogate(_))if(a+1<i){const N=n.charCodeAt(a+1);p.isLowSurrogate(N)?(a++,d=p.computeCodePoint(_,N)):d=65533}else{h=_;break}else p.isLowSurrogate(_)&&(d=65533);if(o=this._push(r,o,d),a++,a<i)_=n.charCodeAt(a);else break}this._buffLen=o,this._leftoverHighSurrogate=h}_push(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),A(this._h0)+A(this._h1)+A(this._h2)+A(this._h3)+A(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const n=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(n/4294967296),!1),this._buffDV.setUint32(60,n%4294967296,!1),this._step()}_step(){const n=E._bigBlock32,i=this._buffDV;for(let C=0;C<64;C+=4)n.setUint32(C,i.getUint32(C,!1),!1);for(let C=64;C<320;C+=4)n.setUint32(C,m(n.getUint32(C-12,!1)^n.getUint32(C-32,!1)^n.getUint32(C-56,!1)^n.getUint32(C-64,!1),1),!1);let r=this._h0,o=this._h1,h=this._h2,_=this._h3,a=this._h4,d,N,M;for(let C=0;C<80;C++)C<20?(d=o&h|~o&_,N=1518500249):C<40?(d=o^h^_,N=1859775393):C<60?(d=o&h|o&_|h&_,N=2400959708):(d=o^h^_,N=3395469782),M=m(r,5)+d+a+N+n.getUint32(C*4,!1)&4294967295,a=_,_=h,h=m(o,30),o=r,r=M;this._h0=this._h0+r&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+h&4294967295,this._h3=this._h3+_&4294967295,this._h4=this._h4+a&4294967295}}t.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),z(V[11],Q([0,1,15,22]),function(I,t,p,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class P{constructor(m){this.source=m}getElements(){const m=this.source,f=new Int32Array(m.length);for(let g=0,A=m.length;g<A;g++)f[g]=m.charCodeAt(g);return f}}t.StringDiffSequence=P;function s(w,m,f){return new L(new P(w),new P(m)).ComputeDiff(f).changes}t.stringDiff=s;class b{static Assert(m,f){if(!m)throw new Error(f)}}t.Debug=b;class l{static Copy(m,f,g,A,E){for(let S=0;S<E;S++)g[A+S]=m[f+S]}static Copy2(m,f,g,A,E){for(let S=0;S<E;S++)g[A+S]=m[f+S]}}t.MyArray=l;var u;(function(w){w[w.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class c{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new p.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(m,f){this.m_originalStart=Math.min(this.m_originalStart,m),this.m_modifiedStart=Math.min(this.m_modifiedStart,f),this.m_originalCount++}AddModifiedElement(m,f){this.m_originalStart=Math.min(this.m_originalStart,m),this.m_modifiedStart=Math.min(this.m_modifiedStart,f),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class L{constructor(m,f,g=null){this.ContinueProcessingPredicate=g,this._originalSequence=m,this._modifiedSequence=f;const[A,E,S]=L._getElements(m),[n,i,r]=L._getElements(f);this._hasStrings=S&&r,this._originalStringElements=A,this._originalElementsOrHash=E,this._modifiedStringElements=n,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(m){return m.length>0&&typeof m[0]=="string"}static _getElements(m){const f=m.getElements();if(L._isStringArray(f)){const g=new Int32Array(f.length);for(let A=0,E=f.length;A<E;A++)g[A]=(0,U.stringHash)(f[A],0);return[f,g,!0]}return f instanceof Int32Array?[[],f,!1]:[[],new Int32Array(f),!1]}ElementsAreEqual(m,f){return this._originalElementsOrHash[m]!==this._modifiedElementsOrHash[f]?!1:this._hasStrings?this._originalStringElements[m]===this._modifiedStringElements[f]:!0}ElementsAreStrictEqual(m,f){if(!this.ElementsAreEqual(m,f))return!1;const g=L._getStrictElement(this._originalSequence,m),A=L._getStrictElement(this._modifiedSequence,f);return g===A}static _getStrictElement(m,f){return typeof m.getStrictElement=="function"?m.getStrictElement(f):null}OriginalElementsAreEqual(m,f){return this._originalElementsOrHash[m]!==this._originalElementsOrHash[f]?!1:this._hasStrings?this._originalStringElements[m]===this._originalStringElements[f]:!0}ModifiedElementsAreEqual(m,f){return this._modifiedElementsOrHash[m]!==this._modifiedElementsOrHash[f]?!1:this._hasStrings?this._modifiedStringElements[m]===this._modifiedStringElements[f]:!0}ComputeDiff(m){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,m)}_ComputeDiff(m,f,g,A,E){const S=[!1];let n=this.ComputeDiffRecursive(m,f,g,A,S);return E&&(n=this.PrettifyChanges(n)),{quitEarly:S[0],changes:n}}ComputeDiffRecursive(m,f,g,A,E){for(E[0]=!1;m<=f&&g<=A&&this.ElementsAreEqual(m,g);)m++,g++;for(;f>=m&&A>=g&&this.ElementsAreEqual(f,A);)f--,A--;if(m>f||g>A){let h;return g<=A?(b.Assert(m===f+1,"originalStart should only be one more than originalEnd"),h=[new p.DiffChange(m,0,g,A-g+1)]):m<=f?(b.Assert(g===A+1,"modifiedStart should only be one more than modifiedEnd"),h=[new p.DiffChange(m,f-m+1,g,0)]):(b.Assert(m===f+1,"originalStart should only be one more than originalEnd"),b.Assert(g===A+1,"modifiedStart should only be one more than modifiedEnd"),h=[]),h}const S=[0],n=[0],i=this.ComputeRecursionPoint(m,f,g,A,S,n,E),r=S[0],o=n[0];if(i!==null)return i;if(!E[0]){const h=this.ComputeDiffRecursive(m,r,g,o,E);let _=[];return E[0]?_=[new p.DiffChange(r+1,f-(r+1)+1,o+1,A-(o+1)+1)]:_=this.ComputeDiffRecursive(r+1,f,o+1,A,E),this.ConcatenateChanges(h,_)}return[new p.DiffChange(m,f-m+1,g,A-g+1)]}WALKTRACE(m,f,g,A,E,S,n,i,r,o,h,_,a,d,N,M,C,R){let F=null,W=null,O=new c,j=f,J=g,G=a[0]-M[0]-A,x=-1073741824,e=this.m_forwardHistory.length-1;do{const q=G+m;q===j||q<J&&r[q-1]<r[q+1]?(h=r[q+1],d=h-G-A,h<x&&O.MarkNextChange(),x=h,O.AddModifiedElement(h+1,d),G=q+1-m):(h=r[q-1]+1,d=h-G-A,h<x&&O.MarkNextChange(),x=h-1,O.AddOriginalElement(h,d+1),G=q-1-m),e>=0&&(r=this.m_forwardHistory[e],m=r[0],j=1,J=r.length-1)}while(--e>=-1);if(F=O.getReverseChanges(),R[0]){let q=a[0]+1,y=M[0]+1;if(F!==null&&F.length>0){const H=F[F.length-1];q=Math.max(q,H.getOriginalEnd()),y=Math.max(y,H.getModifiedEnd())}W=[new p.DiffChange(q,_-q+1,y,N-y+1)]}else{O=new c,j=S,J=n,G=a[0]-M[0]-i,x=1073741824,e=C?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const q=G+E;q===j||q<J&&o[q-1]>=o[q+1]?(h=o[q+1]-1,d=h-G-i,h>x&&O.MarkNextChange(),x=h+1,O.AddOriginalElement(h+1,d+1),G=q+1-E):(h=o[q-1],d=h-G-i,h>x&&O.MarkNextChange(),x=h,O.AddModifiedElement(h+1,d+1),G=q-1-E),e>=0&&(o=this.m_reverseHistory[e],E=o[0],j=1,J=o.length-1)}while(--e>=-1);W=O.getChanges()}return this.ConcatenateChanges(F,W)}ComputeRecursionPoint(m,f,g,A,E,S,n){let i=0,r=0,o=0,h=0,_=0,a=0;m--,g--,E[0]=0,S[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const d=f-m+(A-g),N=d+1,M=new Int32Array(N),C=new Int32Array(N),R=A-g,F=f-m,W=m-g,O=f-A,J=(F-R)%2==0;M[R]=m,C[F]=f,n[0]=!1;for(let G=1;G<=d/2+1;G++){let x=0,e=0;o=this.ClipDiagonalBound(R-G,G,R,N),h=this.ClipDiagonalBound(R+G,G,R,N);for(let y=o;y<=h;y+=2){y===o||y<h&&M[y-1]<M[y+1]?i=M[y+1]:i=M[y-1]+1,r=i-(y-R)-W;const H=i;for(;i<f&&r<A&&this.ElementsAreEqual(i+1,r+1);)i++,r++;if(M[y]=i,i+r>x+e&&(x=i,e=r),!J&&Math.abs(y-F)<=G-1&&i>=C[y])return E[0]=i,S[0]=r,H<=C[y]&&1447>0&&G<=1447+1?this.WALKTRACE(R,o,h,W,F,_,a,O,M,C,i,f,E,r,A,S,J,n):null}const q=(x-m+(e-g)-G)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(x,q))return n[0]=!0,E[0]=x,S[0]=e,q>0&&1447>0&&G<=1447+1?this.WALKTRACE(R,o,h,W,F,_,a,O,M,C,i,f,E,r,A,S,J,n):(m++,g++,[new p.DiffChange(m,f-m+1,g,A-g+1)]);_=this.ClipDiagonalBound(F-G,G,F,N),a=this.ClipDiagonalBound(F+G,G,F,N);for(let y=_;y<=a;y+=2){y===_||y<a&&C[y-1]>=C[y+1]?i=C[y+1]-1:i=C[y-1],r=i-(y-F)-O;const H=i;for(;i>m&&r>g&&this.ElementsAreEqual(i,r);)i--,r--;if(C[y]=i,J&&Math.abs(y-R)<=G&&i<=M[y])return E[0]=i,S[0]=r,H>=M[y]&&1447>0&&G<=1447+1?this.WALKTRACE(R,o,h,W,F,_,a,O,M,C,i,f,E,r,A,S,J,n):null}if(G<=1447){let y=new Int32Array(h-o+2);y[0]=R-o+1,l.Copy2(M,o,y,1,h-o+1),this.m_forwardHistory.push(y),y=new Int32Array(a-_+2),y[0]=F-_+1,l.Copy2(C,_,y,1,a-_+1),this.m_reverseHistory.push(y)}}return this.WALKTRACE(R,o,h,W,F,_,a,O,M,C,i,f,E,r,A,S,J,n)}PrettifyChanges(m){for(let f=0;f<m.length;f++){const g=m[f],A=f<m.length-1?m[f+1].originalStart:this._originalElementsOrHash.length,E=f<m.length-1?m[f+1].modifiedStart:this._modifiedElementsOrHash.length,S=g.originalLength>0,n=g.modifiedLength>0;for(;g.originalStart+g.originalLength<A&&g.modifiedStart+g.modifiedLength<E&&(!S||this.OriginalElementsAreEqual(g.originalStart,g.originalStart+g.originalLength))&&(!n||this.ModifiedElementsAreEqual(g.modifiedStart,g.modifiedStart+g.modifiedLength));){const r=this.ElementsAreStrictEqual(g.originalStart,g.modifiedStart);if(this.ElementsAreStrictEqual(g.originalStart+g.originalLength,g.modifiedStart+g.modifiedLength)&&!r)break;g.originalStart++,g.modifiedStart++}let i=[null];if(f<m.length-1&&this.ChangesOverlap(m[f],m[f+1],i)){m[f]=i[0],m.splice(f+1,1),f--;continue}}for(let f=m.length-1;f>=0;f--){const g=m[f];let A=0,E=0;if(f>0){const h=m[f-1];A=h.originalStart+h.originalLength,E=h.modifiedStart+h.modifiedLength}const S=g.originalLength>0,n=g.modifiedLength>0;let i=0,r=this._boundaryScore(g.originalStart,g.originalLength,g.modifiedStart,g.modifiedLength);for(let h=1;;h++){const _=g.originalStart-h,a=g.modifiedStart-h;if(_<A||a<E||S&&!this.OriginalElementsAreEqual(_,_+g.originalLength)||n&&!this.ModifiedElementsAreEqual(a,a+g.modifiedLength))break;const N=(_===A&&a===E?5:0)+this._boundaryScore(_,g.originalLength,a,g.modifiedLength);N>r&&(r=N,i=h)}g.originalStart-=i,g.modifiedStart-=i;const o=[null];if(f>0&&this.ChangesOverlap(m[f-1],m[f],o)){m[f-1]=o[0],m.splice(f,1),f++;continue}}if(this._hasStrings)for(let f=1,g=m.length;f<g;f++){const A=m[f-1],E=m[f],S=E.originalStart-A.originalStart-A.originalLength,n=A.originalStart,i=E.originalStart+E.originalLength,r=i-n,o=A.modifiedStart,h=E.modifiedStart+E.modifiedLength,_=h-o;if(S<5&&r<20&&_<20){const a=this._findBetterContiguousSequence(n,r,o,_,S);if(a){const[d,N]=a;(d!==A.originalStart+A.originalLength||N!==A.modifiedStart+A.modifiedLength)&&(A.originalLength=d-A.originalStart,A.modifiedLength=N-A.modifiedStart,E.originalStart=d+S,E.modifiedStart=N+S,E.originalLength=i-E.originalStart,E.modifiedLength=h-E.modifiedStart)}}}return m}_findBetterContiguousSequence(m,f,g,A,E){if(f<E||A<E)return null;const S=m+f-E+1,n=g+A-E+1;let i=0,r=0,o=0;for(let h=m;h<S;h++)for(let _=g;_<n;_++){const a=this._contiguousSequenceScore(h,_,E);a>0&&a>i&&(i=a,r=h,o=_)}return i>0?[r,o]:null}_contiguousSequenceScore(m,f,g){let A=0;for(let E=0;E<g;E++){if(!this.ElementsAreEqual(m+E,f+E))return 0;A+=this._originalStringElements[m+E].length}return A}_OriginalIsBoundary(m){return m<=0||m>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[m])}_OriginalRegionIsBoundary(m,f){if(this._OriginalIsBoundary(m)||this._OriginalIsBoundary(m-1))return!0;if(f>0){const g=m+f;if(this._OriginalIsBoundary(g-1)||this._OriginalIsBoundary(g))return!0}return!1}_ModifiedIsBoundary(m){return m<=0||m>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[m])}_ModifiedRegionIsBoundary(m,f){if(this._ModifiedIsBoundary(m)||this._ModifiedIsBoundary(m-1))return!0;if(f>0){const g=m+f;if(this._ModifiedIsBoundary(g-1)||this._ModifiedIsBoundary(g))return!0}return!1}_boundaryScore(m,f,g,A){const E=this._OriginalRegionIsBoundary(m,f)?1:0,S=this._ModifiedRegionIsBoundary(g,A)?1:0;return E+S}ConcatenateChanges(m,f){let g=[];if(m.length===0||f.length===0)return f.length>0?f:m;if(this.ChangesOverlap(m[m.length-1],f[0],g)){const A=new Array(m.length+f.length-1);return l.Copy(m,0,A,0,m.length-1),A[m.length-1]=g[0],l.Copy(f,1,A,m.length,f.length-1),A}else{const A=new Array(m.length+f.length);return l.Copy(m,0,A,0,m.length),l.Copy(f,0,A,m.length,f.length),A}}ChangesOverlap(m,f,g){if(b.Assert(m.originalStart<=f.originalStart,"Left change is not less than or equal to right change"),b.Assert(m.modifiedStart<=f.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=f.originalStart||m.modifiedStart+m.modifiedLength>=f.modifiedStart){const A=m.originalStart;let E=m.originalLength;const S=m.modifiedStart;let n=m.modifiedLength;return m.originalStart+m.originalLength>=f.originalStart&&(E=f.originalStart+f.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=f.modifiedStart&&(n=f.modifiedStart+f.modifiedLength-m.modifiedStart),g[0]=new p.DiffChange(A,E,S,n),!0}else return g[0]=null,!1}ClipDiagonalBound(m,f,g,A){if(m>=0&&m<A)return m;const E=g,S=A-g-1,n=f%2==0;if(m<0){const i=E%2==0;return n===i?0:1}else{const i=S%2==0;return n===i?A-1:A-2}}}t.LcsDiff=L}),z(V[12],Q([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.assertNever=t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0;function p(C){return Array.isArray(C)}t.isArray=p;function U(C){return typeof C=="string"}t.isString=U;function P(C){return Array.isArray(C)&&C.every(R=>U(R))}t.isStringArray=P;function s(C){return typeof C=="object"&&C!==null&&!Array.isArray(C)&&!(C instanceof RegExp)&&!(C instanceof Date)}t.isObject=s;function b(C){return typeof C=="number"&&!isNaN(C)}t.isNumber=b;function l(C){return!!C&&typeof C[Symbol.iterator]=="function"}t.isIterable=l;function u(C){return C===!0||C===!1}t.isBoolean=u;function c(C){return typeof C=="undefined"}t.isUndefined=c;function L(C){return!w(C)}t.isDefined=L;function w(C){return c(C)||C===null}t.isUndefinedOrNull=w;function m(C,R){if(!C)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}t.assertType=m;function f(C){if(w(C))throw new Error("Assertion Failed: argument is undefined or null");return C}t.assertIsDefined=f;function g(...C){const R=[];for(let F=0;F<C.length;F++){const W=C[F];if(w(W))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);R.push(W)}return R}t.assertAllDefined=g;const A=Object.prototype.hasOwnProperty;function E(C){if(!s(C))return!1;for(let R in C)if(A.call(C,R))return!1;return!0}t.isEmptyObject=E;function S(C){return typeof C=="function"}t.isFunction=S;function n(...C){return C.length>0&&C.every(S)}t.areFunctions=n;function i(C,R){const F=Math.min(C.length,R.length);for(let W=0;W<F;W++)r(C[W],R[W])}t.validateConstraints=i;function r(C,R){if(U(R)){if(typeof C!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(S(R)){try{if(C instanceof R)return}catch{}if(!w(C)&&C.constructor===R||R.length===1&&R.call(void 0,C)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=r;function o(C){let R=[],F=Object.getPrototypeOf(C);for(;Object.prototype!==F;)R=R.concat(Object.getOwnPropertyNames(F)),F=Object.getPrototypeOf(F);return R}t.getAllPropertyNames=o;function h(C){const R=[];for(const F of o(C))typeof C[F]=="function"&&R.push(F);return R}t.getAllMethodNames=h;function _(C,R){const F=O=>function(){const j=Array.prototype.slice.call(arguments,0);return R(O,j)};let W={};for(const O of C)W[O]=F(O);return W}t.createProxyObject=_;function a(C){return C===null?void 0:C}t.withNullAsUndefined=a;function d(C){return typeof C=="undefined"?null:C}t.withUndefinedAsNull=d;function N(C){return class{constructor(){return new Proxy({},{get(R,F){if(R[F])return R[F];throw new Error(`Not Implemented: ${C}->${String(F)}`)}})}}}t.NotImplementedProxy=N;function M(C,R="Unreachable"){throw new Error(R)}t.assertNever=M}),z(V[13],Q([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var p;(function(s){s[s.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",s[s.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",s[s.MAX_UINT_8=255]="MAX_UINT_8",s[s.MAX_UINT_16=65535]="MAX_UINT_16",s[s.MAX_UINT_32=4294967295]="MAX_UINT_32",s[s.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(p=t.Constants||(t.Constants={}));function U(s){return s<0?0:s>255?255:s|0}t.toUint8=U;function P(s){return s<0?0:s>4294967295?4294967295:s|0}t.toUint32=P}),z(V[14],Q([0,1,20,2]),function(I,t,p,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const P=/^\w[\w\d+.-]*$/,s=/^\//,b=/^\/\//;function l(a,d){if(!a.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!P.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!s.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(a,d){return!a&&!d?"file":a}function c(a,d){switch(a){case"https":case"http":case"file":d?d[0]!==w&&(d=w+d):d=w;break}return d}const L="",w="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(d,N,M,C,R,F=!1){typeof d=="object"?(this.scheme=d.scheme||L,this.authority=d.authority||L,this.path=d.path||L,this.query=d.query||L,this.fragment=d.fragment||L):(this.scheme=u(d,F),this.authority=N||L,this.path=c(this.scheme,M||L),this.query=C||L,this.fragment=R||L,l(this,F))}static isUri(d){return d instanceof f?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}get fsPath(){return i(this,!1)}with(d){if(!d)return this;let{scheme:N,authority:M,path:C,query:R,fragment:F}=d;return N===void 0?N=this.scheme:N===null&&(N=L),M===void 0?M=this.authority:M===null&&(M=L),C===void 0?C=this.path:C===null&&(C=L),R===void 0?R=this.query:R===null&&(R=L),F===void 0?F=this.fragment:F===null&&(F=L),N===this.scheme&&M===this.authority&&C===this.path&&R===this.query&&F===this.fragment?this:new A(N,M,C,R,F)}static parse(d,N=!1){const M=m.exec(d);return M?new A(M[2]||L,_(M[4]||L),_(M[5]||L),_(M[7]||L),_(M[9]||L),N):new A(L,L,L,L,L)}static file(d){let N=L;if(U.isWindows&&(d=d.replace(/\\/g,w)),d[0]===w&&d[1]===w){const M=d.indexOf(w,2);M===-1?(N=d.substring(2),d=w):(N=d.substring(2,M),d=d.substring(M)||w)}return new A("file",N,d,L,L)}static from(d){const N=new A(d.scheme,d.authority,d.path,d.query,d.fragment);return l(N,!0),N}static joinPath(d,...N){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return U.isWindows&&d.scheme==="file"?M=f.file(p.win32.join(i(d,!0),...N)).path:M=p.posix.join(d.path,...N),d.with({path:M})}toString(d=!1){return r(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof f)return d;{const N=new A(d);return N._formatted=d.external,N._fsPath=d._sep===g?d.fsPath:null,N}}else return d}}t.URI=f;const g=U.isWindows?1:void 0;class A extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(d=!1){return d?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const d={$mid:1};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=g),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(a,d){let N,M=-1;for(let C=0;C<a.length;C++){const R=a.charCodeAt(C);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||d&&R===47)M!==-1&&(N+=encodeURIComponent(a.substring(M,C)),M=-1),N!==void 0&&(N+=a.charAt(C));else{N===void 0&&(N=a.substr(0,C));const F=E[R];F!==void 0?(M!==-1&&(N+=encodeURIComponent(a.substring(M,C)),M=-1),N+=F):M===-1&&(M=C)}}return M!==-1&&(N+=encodeURIComponent(a.substring(M))),N!==void 0?N:a}function n(a){let d;for(let N=0;N<a.length;N++){const M=a.charCodeAt(N);M===35||M===63?(d===void 0&&(d=a.substr(0,N)),d+=E[M]):d!==void 0&&(d+=a[N])}return d!==void 0?d:a}function i(a,d){let N;return a.authority&&a.path.length>1&&a.scheme==="file"?N=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?d?N=a.path.substr(1):N=a.path[1].toLowerCase()+a.path.substr(2):N=a.path,U.isWindows&&(N=N.replace(/\//g,"\\")),N}t.uriToFsPath=i;function r(a,d){const N=d?n:S;let M="",{scheme:C,authority:R,path:F,query:W,fragment:O}=a;if(C&&(M+=C,M+=":"),(R||C==="file")&&(M+=w,M+=w),R){let j=R.indexOf("@");if(j!==-1){const J=R.substr(0,j);R=R.substr(j+1),j=J.indexOf(":"),j===-1?M+=N(J,!1):(M+=N(J.substr(0,j),!1),M+=":",M+=N(J.substr(j+1),!1)),M+="@"}R=R.toLowerCase(),j=R.indexOf(":"),j===-1?M+=N(R,!1):(M+=N(R.substr(0,j),!1),M+=R.substr(j))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const j=F.charCodeAt(1);j>=65&&j<=90&&(F=`/${String.fromCharCode(j+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const j=F.charCodeAt(0);j>=65&&j<=90&&(F=`${String.fromCharCode(j+32)}:${F.substr(2)}`)}M+=N(F,!0)}return W&&(M+="?",M+=N(W,!1)),O&&(M+="#",M+=d?O:S(O,!1)),M}function o(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+o(a.substr(3)):a}}const h=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function _(a){return a.match(h)?a.replace(h,d=>o(d)):a}}),z(V[34],Q([0,1,4,8,2,12]),function(I,t,p,U,P,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const b="$initialize";let l=!1;function u(f){!P.isWeb||(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(f.message))}t.logOnceWebWorkerWarning=u;class c{constructor(g){this._workerId=-1,this._handler=g,this._lastSentReq=0,this._pendingReplies=Object.create(null)}setWorkerId(g){this._workerId=g}sendMessage(g,A){let E=String(++this._lastSentReq);return new Promise((S,n)=>{this._pendingReplies[E]={resolve:S,reject:n},this._send({vsWorker:this._workerId,req:E,method:g,args:A})})}handleMessage(g){!g||!g.vsWorker||this._workerId!==-1&&g.vsWorker!==this._workerId||this._handleMessage(g)}_handleMessage(g){if(g.seq){let n=g;if(!this._pendingReplies[n.seq]){console.warn("Got reply to unknown seq");return}let i=this._pendingReplies[n.seq];if(delete this._pendingReplies[n.seq],n.err){let r=n.err;n.err.$isError&&(r=new Error,r.name=n.err.name,r.message=n.err.message,r.stack=n.err.stack),i.reject(r);return}i.resolve(n.res);return}let A=g,E=A.req;this._handler.handleMessage(A.method,A.args).then(n=>{this._send({vsWorker:this._workerId,seq:E,res:n,err:void 0})},n=>{n.detail instanceof Error&&(n.detail=(0,p.transformErrorForSerialization)(n.detail)),this._send({vsWorker:this._workerId,seq:E,res:void 0,err:(0,p.transformErrorForSerialization)(n)})})}_send(g){let A=[];if(g.req){const E=g;for(let S=0;S<E.args.length;S++)E.args[S]instanceof ArrayBuffer&&A.push(E.args[S])}else{const E=g;E.res instanceof ArrayBuffer&&A.push(E.res)}this._handler.sendMessage(g,A)}}class L extends U.Disposable{constructor(g,A,E){super();let S=null;this._worker=this._register(g.create("vs/base/common/worker/simpleWorker",o=>{this._protocol.handleMessage(o)},o=>{S&&S(o)})),this._protocol=new c({sendMessage:(o,h)=>{this._worker.postMessage(o,h)},handleMessage:(o,h)=>{if(typeof E[o]!="function")return Promise.reject(new Error("Missing method "+o+" on main thread host."));try{return Promise.resolve(E[o].apply(E,h))}catch(_){return Promise.reject(_)}}}),this._protocol.setWorkerId(this._worker.getId());let n=null;typeof self.require!="undefined"&&typeof self.require.getConfig=="function"?n=self.require.getConfig():typeof self.requirejs!="undefined"&&(n=self.requirejs.s.contexts._.config);const i=s.getAllMethodNames(E);this._onModuleLoaded=this._protocol.sendMessage(b,[this._worker.getId(),JSON.parse(JSON.stringify(n)),A,i]);const r=(o,h)=>this._request(o,h);this._lazyProxy=new Promise((o,h)=>{S=h,this._onModuleLoaded.then(_=>{o(s.createProxyObject(_,r))},_=>{h(_),this._onError("Worker failed to load "+A,_)})})}getProxyObject(){return this._lazyProxy}_request(g,A){return new Promise((E,S)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(g,A).then(E,S)},S)})}_onError(g,A){console.error(g),console.info(A)}}t.SimpleWorkerClient=L;class w{constructor(g,A){this._requestHandlerFactory=A,this._requestHandler=null,this._protocol=new c({sendMessage:(E,S)=>{g(E,S)},handleMessage:(E,S)=>this._handleMessage(E,S)})}onmessage(g){this._protocol.handleMessage(g)}_handleMessage(g,A){if(g===b)return this.initialize(A[0],A[1],A[2],A[3]);if(!this._requestHandler||typeof this._requestHandler[g]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+g));try{return Promise.resolve(this._requestHandler[g].apply(this._requestHandler,A))}catch(E){return Promise.reject(E)}}initialize(g,A,E,S){this._protocol.setWorkerId(g);const n=(r,o)=>this._protocol.sendMessage(r,o),i=s.createProxyObject(S,n);return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(i),Promise.resolve(s.getAllMethodNames(this._requestHandler))):(A&&(typeof A.baseUrl!="undefined"&&delete A.baseUrl,typeof A.paths!="undefined"&&typeof A.paths.vs!="undefined"&&delete A.paths.vs,typeof A.trustedTypesPolicy!==void 0&&delete A.trustedTypesPolicy,A.catchError=!0,self.require.config(A)),new Promise((r,o)=>{self.require([E],h=>{if(this._requestHandler=h.create(i),!this._requestHandler){o(new Error("No RequestHandler!"));return}r(s.getAllMethodNames(this._requestHandler))},o)}))}}t.SimpleWorkerServer=w;function m(f){return new w(f,null)}t.create=m}),z(V[23],Q([0,1,13]),function(I,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class U{constructor(l){let u=(0,p.toUint8)(l);this._defaultValue=u,this._asciiMap=U._createAsciiMap(u),this._map=new Map}static _createAsciiMap(l){let u=new Uint8Array(256);for(let c=0;c<256;c++)u[c]=l;return u}set(l,u){let c=(0,p.toUint8)(u);l>=0&&l<256?this._asciiMap[l]=c:this._map.set(l,c)}get(l){return l>=0&&l<256?this._asciiMap[l]:this._map.get(l)||this._defaultValue}}t.CharacterClassifier=U;var P;(function(b){b[b.False=0]="False",b[b.True=1]="True"})(P||(P={}));class s{constructor(){this._actual=new U(0)}add(l){this._actual.set(l,1)}has(l){return this._actual.get(l)===1}}t.CharacterSet=s}),z(V[3],Q([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class p{constructor(P,s){this.lineNumber=P,this.column=s}with(P=this.lineNumber,s=this.column){return P===this.lineNumber&&s===this.column?this:new p(P,s)}delta(P=0,s=0){return this.with(this.lineNumber+P,this.column+s)}equals(P){return p.equals(this,P)}static equals(P,s){return!P&&!s?!0:!!P&&!!s&&P.lineNumber===s.lineNumber&&P.column===s.column}isBefore(P){return p.isBefore(this,P)}static isBefore(P,s){return P.lineNumber<s.lineNumber?!0:s.lineNumber<P.lineNumber?!1:P.column<s.column}isBeforeOrEqual(P){return p.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,s){return P.lineNumber<s.lineNumber?!0:s.lineNumber<P.lineNumber?!1:P.column<=s.column}static compare(P,s){let b=P.lineNumber|0,l=s.lineNumber|0;if(b===l){let u=P.column|0,c=s.column|0;return u-c}return b-l}clone(){return new p(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new p(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}}t.Position=p}),z(V[6],Q([0,1,3]),function(I,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class U{constructor(s,b,l,u){s>l||s===l&&b>u?(this.startLineNumber=l,this.startColumn=u,this.endLineNumber=s,this.endColumn=b):(this.startLineNumber=s,this.startColumn=b,this.endLineNumber=l,this.endColumn=u)}isEmpty(){return U.isEmpty(this)}static isEmpty(s){return s.startLineNumber===s.endLineNumber&&s.startColumn===s.endColumn}containsPosition(s){return U.containsPosition(this,s)}static containsPosition(s,b){return!(b.lineNumber<s.startLineNumber||b.lineNumber>s.endLineNumber||b.lineNumber===s.startLineNumber&&b.column<s.startColumn||b.lineNumber===s.endLineNumber&&b.column>s.endColumn)}containsRange(s){return U.containsRange(this,s)}static containsRange(s,b){return!(b.startLineNumber<s.startLineNumber||b.endLineNumber<s.startLineNumber||b.startLineNumber>s.endLineNumber||b.endLineNumber>s.endLineNumber||b.startLineNumber===s.startLineNumber&&b.startColumn<s.startColumn||b.endLineNumber===s.endLineNumber&&b.endColumn>s.endColumn)}strictContainsRange(s){return U.strictContainsRange(this,s)}static strictContainsRange(s,b){return!(b.startLineNumber<s.startLineNumber||b.endLineNumber<s.startLineNumber||b.startLineNumber>s.endLineNumber||b.endLineNumber>s.endLineNumber||b.startLineNumber===s.startLineNumber&&b.startColumn<=s.startColumn||b.endLineNumber===s.endLineNumber&&b.endColumn>=s.endColumn)}plusRange(s){return U.plusRange(this,s)}static plusRange(s,b){let l,u,c,L;return b.startLineNumber<s.startLineNumber?(l=b.startLineNumber,u=b.startColumn):b.startLineNumber===s.startLineNumber?(l=b.startLineNumber,u=Math.min(b.startColumn,s.startColumn)):(l=s.startLineNumber,u=s.startColumn),b.endLineNumber>s.endLineNumber?(c=b.endLineNumber,L=b.endColumn):b.endLineNumber===s.endLineNumber?(c=b.endLineNumber,L=Math.max(b.endColumn,s.endColumn)):(c=s.endLineNumber,L=s.endColumn),new U(l,u,c,L)}intersectRanges(s){return U.intersectRanges(this,s)}static intersectRanges(s,b){let l=s.startLineNumber,u=s.startColumn,c=s.endLineNumber,L=s.endColumn,w=b.startLineNumber,m=b.startColumn,f=b.endLineNumber,g=b.endColumn;return l<w?(l=w,u=m):l===w&&(u=Math.max(u,m)),c>f?(c=f,L=g):c===f&&(L=Math.min(L,g)),l>c||l===c&&u>L?null:new U(l,u,c,L)}equalsRange(s){return U.equalsRange(this,s)}static equalsRange(s,b){return!!s&&!!b&&s.startLineNumber===b.startLineNumber&&s.startColumn===b.startColumn&&s.endLineNumber===b.endLineNumber&&s.endColumn===b.endColumn}getEndPosition(){return U.getEndPosition(this)}static getEndPosition(s){return new p.Position(s.endLineNumber,s.endColumn)}getStartPosition(){return U.getStartPosition(this)}static getStartPosition(s){return new p.Position(s.startLineNumber,s.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(s,b){return new U(this.startLineNumber,this.startColumn,s,b)}setStartPosition(s,b){return new U(s,b,this.endLineNumber,this.endColumn)}collapseToStart(){return U.collapseToStart(this)}static collapseToStart(s){return new U(s.startLineNumber,s.startColumn,s.startLineNumber,s.startColumn)}static fromPositions(s,b=s){return new U(s.lineNumber,s.column,b.lineNumber,b.column)}static lift(s){return s?new U(s.startLineNumber,s.startColumn,s.endLineNumber,s.endColumn):null}static isIRange(s){return s&&typeof s.startLineNumber=="number"&&typeof s.startColumn=="number"&&typeof s.endLineNumber=="number"&&typeof s.endColumn=="number"}static areIntersectingOrTouching(s,b){return!(s.endLineNumber<b.startLineNumber||s.endLineNumber===b.startLineNumber&&s.endColumn<b.startColumn||b.endLineNumber<s.startLineNumber||b.endLineNumber===s.startLineNumber&&b.endColumn<s.startColumn)}static areIntersecting(s,b){return!(s.endLineNumber<b.startLineNumber||s.endLineNumber===b.startLineNumber&&s.endColumn<=b.startColumn||b.endLineNumber<s.startLineNumber||b.endLineNumber===s.startLineNumber&&b.endColumn<=s.startColumn)}static compareRangesUsingStarts(s,b){if(s&&b){const c=s.startLineNumber|0,L=b.startLineNumber|0;if(c===L){const w=s.startColumn|0,m=b.startColumn|0;if(w===m){const f=s.endLineNumber|0,g=b.endLineNumber|0;if(f===g){const A=s.endColumn|0,E=b.endColumn|0;return A-E}return f-g}return w-m}return c-L}return(s?1:0)-(b?1:0)}static compareRangesUsingEnds(s,b){return s.endLineNumber===b.endLineNumber?s.endColumn===b.endColumn?s.startLineNumber===b.startLineNumber?s.startColumn-b.startColumn:s.startLineNumber-b.startLineNumber:s.endColumn-b.endColumn:s.endLineNumber-b.endLineNumber}static spansMultipleLines(s){return s.endLineNumber>s.startLineNumber}}t.Range=U}),z(V[24],Q([0,1,3,6]),function(I,t,p,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var P;(function(b){b[b.LTR=0]="LTR",b[b.RTL=1]="RTL"})(P=t.SelectionDirection||(t.SelectionDirection={}));class s extends U.Range{constructor(l,u,c,L){super(l,u,c,L);this.selectionStartLineNumber=l,this.selectionStartColumn=u,this.positionLineNumber=c,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(l){return s.selectionsEqual(this,l)}static selectionsEqual(l,u){return l.selectionStartLineNumber===u.selectionStartLineNumber&&l.selectionStartColumn===u.selectionStartColumn&&l.positionLineNumber===u.positionLineNumber&&l.positionColumn===u.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(l,u){return this.getDirection()===0?new s(this.startLineNumber,this.startColumn,l,u):new s(l,u,this.startLineNumber,this.startColumn)}getPosition(){return new p.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(l,u){return this.getDirection()===0?new s(l,u,this.endLineNumber,this.endColumn):new s(this.endLineNumber,this.endColumn,l,u)}static fromPositions(l,u=l){return new s(l.lineNumber,l.column,u.lineNumber,u.column)}static liftSelection(l){return new s(l.selectionStartLineNumber,l.selectionStartColumn,l.positionLineNumber,l.positionColumn)}static selectionsArrEqual(l,u){if(l&&!u||!l&&u)return!1;if(!l&&!u)return!0;if(l.length!==u.length)return!1;for(let c=0,L=l.length;c<L;c++)if(!this.selectionsEqual(l[c],u[c]))return!1;return!0}static isISelection(l){return l&&typeof l.selectionStartLineNumber=="number"&&typeof l.selectionStartColumn=="number"&&typeof l.positionLineNumber=="number"&&typeof l.positionColumn=="number"}static createWithDirection(l,u,c,L,w){return w===0?new s(l,u,c,L):new s(c,L,l,u)}}t.Selection=s}),z(V[25],Q([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationResult2=t.TokenizationResult=t.Token=void 0;class p{constructor(b,l,u){this._tokenBrand=void 0,this.offset=b|0,this.type=l,this.language=u}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=p;class U{constructor(b,l){this._tokenizationResultBrand=void 0,this.tokens=b,this.endState=l}}t.TokenizationResult=U;class P{constructor(b,l){this._tokenizationResult2Brand=void 0,this.tokens=b,this.endState=l}}t.TokenizationResult2=P}),z(V[26],Q([0,1,11,5]),function(I,t,p,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=void 0;const P=3;function s(A,E,S,n){return new p.LcsDiff(A,E,S).ComputeDiff(n)}class b{constructor(E){const S=[],n=[];for(let i=0,r=E.length;i<r;i++)S[i]=m(E[i],1),n[i]=f(E[i],1);this.lines=E,this._startColumns=S,this._endColumns=n}getElements(){const E=[];for(let S=0,n=this.lines.length;S<n;S++)E[S]=this.lines[S].substring(this._startColumns[S]-1,this._endColumns[S]-1);return E}getStrictElement(E){return this.lines[E]}getStartLineNumber(E){return E+1}getEndLineNumber(E){return E+1}createCharSequence(E,S,n){const i=[],r=[],o=[];let h=0;for(let _=S;_<=n;_++){const a=this.lines[_],d=E?this._startColumns[_]:1,N=E?this._endColumns[_]:a.length+1;for(let M=d;M<N;M++)i[h]=a.charCodeAt(M-1),r[h]=_+1,o[h]=M,h++}return new l(i,r,o)}}class l{constructor(E,S,n){this._charCodes=E,this._lineNumbers=S,this._columns=n}getElements(){return this._charCodes}getStartLineNumber(E){return this._lineNumbers[E]}getStartColumn(E){return this._columns[E]}getEndLineNumber(E){return this._lineNumbers[E]}getEndColumn(E){return this._columns[E]+1}}class u{constructor(E,S,n,i,r,o,h,_){this.originalStartLineNumber=E,this.originalStartColumn=S,this.originalEndLineNumber=n,this.originalEndColumn=i,this.modifiedStartLineNumber=r,this.modifiedStartColumn=o,this.modifiedEndLineNumber=h,this.modifiedEndColumn=_}static createFromDiffChange(E,S,n){let i,r,o,h,_,a,d,N;return E.originalLength===0?(i=0,r=0,o=0,h=0):(i=S.getStartLineNumber(E.originalStart),r=S.getStartColumn(E.originalStart),o=S.getEndLineNumber(E.originalStart+E.originalLength-1),h=S.getEndColumn(E.originalStart+E.originalLength-1)),E.modifiedLength===0?(_=0,a=0,d=0,N=0):(_=n.getStartLineNumber(E.modifiedStart),a=n.getStartColumn(E.modifiedStart),d=n.getEndLineNumber(E.modifiedStart+E.modifiedLength-1),N=n.getEndColumn(E.modifiedStart+E.modifiedLength-1)),new u(i,r,o,h,_,a,d,N)}}function c(A){if(A.length<=1)return A;const E=[A[0]];let S=E[0];for(let n=1,i=A.length;n<i;n++){const r=A[n],o=r.originalStart-(S.originalStart+S.originalLength),h=r.modifiedStart-(S.modifiedStart+S.modifiedLength);Math.min(o,h)<P?(S.originalLength=r.originalStart+r.originalLength-S.originalStart,S.modifiedLength=r.modifiedStart+r.modifiedLength-S.modifiedStart):(E.push(r),S=r)}return E}class L{constructor(E,S,n,i,r){this.originalStartLineNumber=E,this.originalEndLineNumber=S,this.modifiedStartLineNumber=n,this.modifiedEndLineNumber=i,this.charChanges=r}static createFromDiffResult(E,S,n,i,r,o,h){let _,a,d,N,M;if(S.originalLength===0?(_=n.getStartLineNumber(S.originalStart)-1,a=0):(_=n.getStartLineNumber(S.originalStart),a=n.getEndLineNumber(S.originalStart+S.originalLength-1)),S.modifiedLength===0?(d=i.getStartLineNumber(S.modifiedStart)-1,N=0):(d=i.getStartLineNumber(S.modifiedStart),N=i.getEndLineNumber(S.modifiedStart+S.modifiedLength-1)),o&&S.originalLength>0&&S.originalLength<20&&S.modifiedLength>0&&S.modifiedLength<20&&r()){const C=n.createCharSequence(E,S.originalStart,S.originalStart+S.originalLength-1),R=i.createCharSequence(E,S.modifiedStart,S.modifiedStart+S.modifiedLength-1);let F=s(C,R,r,!0).changes;h&&(F=c(F)),M=[];for(let W=0,O=F.length;W<O;W++)M.push(u.createFromDiffChange(F[W],C,R))}return new L(_,a,d,N,M)}}class w{constructor(E,S,n){this.shouldComputeCharChanges=n.shouldComputeCharChanges,this.shouldPostProcessCharChanges=n.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=n.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=n.shouldMakePrettyDiff,this.originalLines=E,this.modifiedLines=S,this.original=new b(E),this.modified=new b(S),this.continueLineDiff=g(n.maxComputationTime),this.continueCharDiff=g(n.maxComputationTime===0?0:Math.min(n.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const E=s(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),S=E.changes,n=E.quitEarly;if(this.shouldIgnoreTrimWhitespace){const h=[];for(let _=0,a=S.length;_<a;_++)h.push(L.createFromDiffResult(this.shouldIgnoreTrimWhitespace,S[_],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:n,changes:h}}const i=[];let r=0,o=0;for(let h=-1,_=S.length;h<_;h++){const a=h+1<_?S[h+1]:null,d=a?a.originalStart:this.originalLines.length,N=a?a.modifiedStart:this.modifiedLines.length;for(;r<d&&o<N;){const M=this.originalLines[r],C=this.modifiedLines[o];if(M!==C){{let R=m(M,1),F=m(C,1);for(;R>1&&F>1;){const W=M.charCodeAt(R-2),O=C.charCodeAt(F-2);if(W!==O)break;R--,F--}(R>1||F>1)&&this._pushTrimWhitespaceCharChange(i,r+1,1,R,o+1,1,F)}{let R=f(M,1),F=f(C,1);const W=M.length+1,O=C.length+1;for(;R<W&&F<O;){const j=M.charCodeAt(R-1),J=M.charCodeAt(F-1);if(j!==J)break;R++,F++}(R<W||F<O)&&this._pushTrimWhitespaceCharChange(i,r+1,R,W,o+1,F,O)}}r++,o++}a&&(i.push(L.createFromDiffResult(this.shouldIgnoreTrimWhitespace,a,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),r+=a.originalLength,o+=a.modifiedLength)}return{quitEarly:n,changes:i}}_pushTrimWhitespaceCharChange(E,S,n,i,r,o,h){if(this._mergeTrimWhitespaceCharChange(E,S,n,i,r,o,h))return;let _;this.shouldComputeCharChanges&&(_=[new u(S,n,S,i,r,o,r,h)]),E.push(new L(S,S,r,r,_))}_mergeTrimWhitespaceCharChange(E,S,n,i,r,o,h){const _=E.length;if(_===0)return!1;const a=E[_-1];return a.originalEndLineNumber===0||a.modifiedEndLineNumber===0?!1:a.originalEndLineNumber+1===S&&a.modifiedEndLineNumber+1===r?(a.originalEndLineNumber=S,a.modifiedEndLineNumber=r,this.shouldComputeCharChanges&&a.charChanges&&a.charChanges.push(new u(S,n,S,i,r,o,r,h)),!0):!1}}t.DiffComputer=w;function m(A,E){const S=U.firstNonWhitespaceIndex(A);return S===-1?E:S+1}function f(A,E){const S=U.lastNonWhitespaceIndex(A);return S===-1?E:S+2}function g(A){if(A===0)return()=>!0;const E=Date.now();return()=>Date.now()-E<A}}),z(V[27],Q([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function p(l=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const c of t.USUAL_WORD_SEPARATORS)l.indexOf(c)>=0||(u+="\\"+c);return u+="\\s]+)",new RegExp(u,"g")}t.DEFAULT_WORD_REGEXP=p();function U(l){let u=t.DEFAULT_WORD_REGEXP;if(l&&l instanceof RegExp)if(l.global)u=l;else{let c="g";l.ignoreCase&&(c+="i"),l.multiline&&(c+="m"),l.unicode&&(c+="u"),u=new RegExp(l.source,c)}return u.lastIndex=0,u}t.ensureValidWordDefinition=U;const P={maxLen:1e3,windowSize:15,timeBudget:150};function s(l,u,c,L,w=P){if(c.length>w.maxLen){let E=l-w.maxLen/2;return E<0?E=0:L+=E,c=c.substring(E,l+w.maxLen/2),s(l,u,c,L,w)}const m=Date.now(),f=l-1-L;let g=-1,A=null;for(let E=1;!(Date.now()-m>=w.timeBudget);E++){const S=f-w.windowSize*E;u.lastIndex=Math.max(0,S);const n=b(u,c,f,g);if(!n&&A||(A=n,S<=0))break;g=S}if(A){let E={word:A[0],startColumn:L+1+A.index,endColumn:L+1+A.index+A[0].length};return u.lastIndex=0,E}return null}t.getWordAtText=s;function b(l,u,c,L){let w;for(;w=l.exec(u);){const m=w.index||0;if(m<=c&&l.lastIndex>=c)return w;if(L>0&&m>L)return null}return null}}),z(V[28],Q([0,1,23]),function(I,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.Uint8Matrix=t.State=void 0;var U;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(U=t.State||(t.State={}));class P{constructor(g,A,E){const S=new Uint8Array(g*A);for(let n=0,i=g*A;n<i;n++)S[n]=E;this._data=S,this.rows=g,this.cols=A}get(g,A){return this._data[g*this.cols+A]}set(g,A,E){this._data[g*this.cols+A]=E}}t.Uint8Matrix=P;class s{constructor(g){let A=0,E=0;for(let n=0,i=g.length;n<i;n++){let[r,o,h]=g[n];o>A&&(A=o),r>E&&(E=r),h>E&&(E=h)}A++,E++;let S=new P(E,A,0);for(let n=0,i=g.length;n<i;n++){let[r,o,h]=g[n];S.set(r,o,h)}this._states=S,this._maxCharCode=A}nextState(g,A){return A<0||A>=this._maxCharCode?0:this._states.get(g,A)}}t.StateMachine=s;let b=null;function l(){return b===null&&(b=new s([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),b}var u;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let c=null;function L(){if(c===null){c=new p.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let A=0;A<f.length;A++)c.set(f.charCodeAt(A),1);const g=".,;";for(let A=0;A<g.length;A++)c.set(g.charCodeAt(A),2)}return c}class w{static _createLink(g,A,E,S,n){let i=n-1;do{const r=A.charCodeAt(i);if(g.get(r)!==2)break;i--}while(i>S);if(S>0){const r=A.charCodeAt(S-1),o=A.charCodeAt(i);(r===40&&o===41||r===91&&o===93||r===123&&o===125)&&i--}return{range:{startLineNumber:E,startColumn:S+1,endLineNumber:E,endColumn:i+2},url:A.substring(S,i+1)}}static computeLinks(g,A=l()){const E=L();let S=[];for(let n=1,i=g.getLineCount();n<=i;n++){const r=g.getLineContent(n),o=r.length;let h=0,_=0,a=0,d=1,N=!1,M=!1,C=!1,R=!1;for(;h<o;){let F=!1;const W=r.charCodeAt(h);if(d===13){let O;switch(W){case 40:N=!0,O=0;break;case 41:O=N?0:1;break;case 91:C=!0,M=!0,O=0;break;case 93:C=!1,O=M?0:1;break;case 123:R=!0,O=0;break;case 125:O=R?0:1;break;case 39:O=a===34||a===96?0:1;break;case 34:O=a===39||a===96?0:1;break;case 96:O=a===39||a===34?0:1;break;case 42:O=a===42?1:0;break;case 124:O=a===124?1:0;break;case 32:O=C?0:1;break;default:O=E.get(W)}O===1&&(S.push(w._createLink(E,r,n,_,h)),F=!0)}else if(d===12){let O;W===91?(M=!0,O=0):O=E.get(W),O===1?F=!0:d=13}else d=A.nextState(d,W),d===0&&(F=!0);F&&(d=1,N=!1,M=!1,R=!1,_=h+1,a=W),h++}d===13&&S.push(w._createLink(E,r,n,_,o))}return S}}t.LinkComputer=w;function m(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:w.computeLinks(f)}t.computeLinks=m}),z(V[29],Q([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class p{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(P,s,b,l,u){if(P&&s){let c=this.doNavigateValueSet(s,u);if(c)return{range:P,value:c}}if(b&&l){let c=this.doNavigateValueSet(l,u);if(c)return{range:b,value:c}}return null}doNavigateValueSet(P,s){let b=this.numberReplace(P,s);return b!==null?b:this.textReplace(P,s)}numberReplace(P,s){let b=Math.pow(10,P.length-(P.lastIndexOf(".")+1)),l=Number(P),u=parseFloat(P);return!isNaN(l)&&!isNaN(u)&&l===u?l===0&&!s?null:(l=Math.floor(l*b),l+=s?b:-b,String(l/b)):null}textReplace(P,s){return this.valueSetsReplace(this._defaultValueSet,P,s)}valueSetsReplace(P,s,b){let l=null;for(let u=0,c=P.length;l===null&&u<c;u++)l=this.valueSetReplace(P[u],s,b);return l}valueSetReplace(P,s,b){let l=P.indexOf(s);return l>=0?(l+=b?1:-1,l<0?l=P.length-1:l%=P.length,P[l]):null}}t.BasicInplaceReplace=p,p.INSTANCE=new p}),z(V[30],Q([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.AccessibilitySupport=void 0;var p;(function(e){e[e.Unknown=0]="Unknown",e[e.Disabled=1]="Disabled",e[e.Enabled=2]="Enabled"})(p=t.AccessibilitySupport||(t.AccessibilitySupport={}));var U;(function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"})(U=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var P;(function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"})(P=t.CompletionItemKind||(t.CompletionItemKind={}));var s;(function(e){e[e.Deprecated=1]="Deprecated"})(s=t.CompletionItemTag||(t.CompletionItemTag={}));var b;(function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var l;(function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"})(l=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var u;(function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"})(u=t.CursorChangeReason||(t.CursorChangeReason={}));var c;(function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(c=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var L;(function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"})(L=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var w;(function(e){e[e.None=0]="None",e[e.Keep=1]="Keep",e[e.Brackets=2]="Brackets",e[e.Advanced=3]="Advanced",e[e.Full=4]="Full"})(w=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var m;(function(e){e[e.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",e[e.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",e[e.accessibilitySupport=2]="accessibilitySupport",e[e.accessibilityPageSize=3]="accessibilityPageSize",e[e.ariaLabel=4]="ariaLabel",e[e.autoClosingBrackets=5]="autoClosingBrackets",e[e.autoClosingDelete=6]="autoClosingDelete",e[e.autoClosingOvertype=7]="autoClosingOvertype",e[e.autoClosingQuotes=8]="autoClosingQuotes",e[e.autoIndent=9]="autoIndent",e[e.automaticLayout=10]="automaticLayout",e[e.autoSurround=11]="autoSurround",e[e.codeLens=12]="codeLens",e[e.codeLensFontFamily=13]="codeLensFontFamily",e[e.codeLensFontSize=14]="codeLensFontSize",e[e.colorDecorators=15]="colorDecorators",e[e.columnSelection=16]="columnSelection",e[e.comments=17]="comments",e[e.contextmenu=18]="contextmenu",e[e.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",e[e.cursorBlinking=20]="cursorBlinking",e[e.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",e[e.cursorStyle=22]="cursorStyle",e[e.cursorSurroundingLines=23]="cursorSurroundingLines",e[e.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",e[e.cursorWidth=25]="cursorWidth",e[e.disableLayerHinting=26]="disableLayerHinting",e[e.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",e[e.domReadOnly=28]="domReadOnly",e[e.dragAndDrop=29]="dragAndDrop",e[e.emptySelectionClipboard=30]="emptySelectionClipboard",e[e.extraEditorClassName=31]="extraEditorClassName",e[e.fastScrollSensitivity=32]="fastScrollSensitivity",e[e.find=33]="find",e[e.fixedOverflowWidgets=34]="fixedOverflowWidgets",e[e.folding=35]="folding",e[e.foldingStrategy=36]="foldingStrategy",e[e.foldingHighlight=37]="foldingHighlight",e[e.foldingImportsByDefault=38]="foldingImportsByDefault",e[e.unfoldOnClickAfterEndOfLine=39]="unfoldOnClickAfterEndOfLine",e[e.fontFamily=40]="fontFamily",e[e.fontInfo=41]="fontInfo",e[e.fontLigatures=42]="fontLigatures",e[e.fontSize=43]="fontSize",e[e.fontWeight=44]="fontWeight",e[e.formatOnPaste=45]="formatOnPaste",e[e.formatOnType=46]="formatOnType",e[e.glyphMargin=47]="glyphMargin",e[e.gotoLocation=48]="gotoLocation",e[e.hideCursorInOverviewRuler=49]="hideCursorInOverviewRuler",e[e.highlightActiveIndentGuide=50]="highlightActiveIndentGuide",e[e.hover=51]="hover",e[e.inDiffEditor=52]="inDiffEditor",e[e.inlineSuggest=53]="inlineSuggest",e[e.letterSpacing=54]="letterSpacing",e[e.lightbulb=55]="lightbulb",e[e.lineDecorationsWidth=56]="lineDecorationsWidth",e[e.lineHeight=57]="lineHeight",e[e.lineNumbers=58]="lineNumbers",e[e.lineNumbersMinChars=59]="lineNumbersMinChars",e[e.linkedEditing=60]="linkedEditing",e[e.links=61]="links",e[e.matchBrackets=62]="matchBrackets",e[e.minimap=63]="minimap",e[e.mouseStyle=64]="mouseStyle",e[e.mouseWheelScrollSensitivity=65]="mouseWheelScrollSensitivity",e[e.mouseWheelZoom=66]="mouseWheelZoom",e[e.multiCursorMergeOverlapping=67]="multiCursorMergeOverlapping",e[e.multiCursorModifier=68]="multiCursorModifier",e[e.multiCursorPaste=69]="multiCursorPaste",e[e.occurrencesHighlight=70]="occurrencesHighlight",e[e.overviewRulerBorder=71]="overviewRulerBorder",e[e.overviewRulerLanes=72]="overviewRulerLanes",e[e.padding=73]="padding",e[e.parameterHints=74]="parameterHints",e[e.peekWidgetDefaultFocus=75]="peekWidgetDefaultFocus",e[e.definitionLinkOpensInPeek=76]="definitionLinkOpensInPeek",e[e.quickSuggestions=77]="quickSuggestions",e[e.quickSuggestionsDelay=78]="quickSuggestionsDelay",e[e.readOnly=79]="readOnly",e[e.renameOnType=80]="renameOnType",e[e.renderControlCharacters=81]="renderControlCharacters",e[e.renderIndentGuides=82]="renderIndentGuides",e[e.renderFinalNewline=83]="renderFinalNewline",e[e.renderLineHighlight=84]="renderLineHighlight",e[e.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",e[e.renderValidationDecorations=86]="renderValidationDecorations",e[e.renderWhitespace=87]="renderWhitespace",e[e.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",e[e.roundedSelection=89]="roundedSelection",e[e.rulers=90]="rulers",e[e.scrollbar=91]="scrollbar",e[e.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",e[e.scrollBeyondLastLine=93]="scrollBeyondLastLine",e[e.scrollPredominantAxis=94]="scrollPredominantAxis",e[e.selectionClipboard=95]="selectionClipboard",e[e.selectionHighlight=96]="selectionHighlight",e[e.selectOnLineNumbers=97]="selectOnLineNumbers",e[e.showFoldingControls=98]="showFoldingControls",e[e.showUnused=99]="showUnused",e[e.snippetSuggestions=100]="snippetSuggestions",e[e.smartSelect=101]="smartSelect",e[e.smoothScrolling=102]="smoothScrolling",e[e.stickyTabStops=103]="stickyTabStops",e[e.stopRenderingLineAfter=104]="stopRenderingLineAfter",e[e.suggest=105]="suggest",e[e.suggestFontSize=106]="suggestFontSize",e[e.suggestLineHeight=107]="suggestLineHeight",e[e.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",e[e.suggestSelection=109]="suggestSelection",e[e.tabCompletion=110]="tabCompletion",e[e.tabIndex=111]="tabIndex",e[e.unusualLineTerminators=112]="unusualLineTerminators",e[e.useShadowDOM=113]="useShadowDOM",e[e.useTabStops=114]="useTabStops",e[e.wordSeparators=115]="wordSeparators",e[e.wordWrap=116]="wordWrap",e[e.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",e[e.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",e[e.wordWrapColumn=119]="wordWrapColumn",e[e.wordWrapOverride1=120]="wordWrapOverride1",e[e.wordWrapOverride2=121]="wordWrapOverride2",e[e.wrappingIndent=122]="wrappingIndent",e[e.wrappingStrategy=123]="wrappingStrategy",e[e.showDeprecated=124]="showDeprecated",e[e.inlayHints=125]="inlayHints",e[e.editorClassName=126]="editorClassName",e[e.pixelRatio=127]="pixelRatio",e[e.tabFocusMode=128]="tabFocusMode",e[e.layoutInfo=129]="layoutInfo",e[e.wrappingInfo=130]="wrappingInfo"})(m=t.EditorOption||(t.EditorOption={}));var f;(function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(f=t.EndOfLinePreference||(t.EndOfLinePreference={}));var g;(function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"})(g=t.EndOfLineSequence||(t.EndOfLineSequence={}));var A;(function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"})(A=t.IndentAction||(t.IndentAction={}));var E;(function(e){e[e.Other=0]="Other",e[e.Type=1]="Type",e[e.Parameter=2]="Parameter"})(E=t.InlayHintKind||(t.InlayHintKind={}));var S;(function(e){e[e.Automatic=0]="Automatic",e[e.Explicit=1]="Explicit"})(S=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"})(n=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"})(i=t.MarkerSeverity||(t.MarkerSeverity={}));var r;(function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"})(r=t.MarkerTag||(t.MarkerTag={}));var o;(function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"})(o=t.MinimapPosition||(t.MinimapPosition={}));var h;(function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(h=t.MouseTargetType||(t.MouseTargetType={}));var _;(function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"})(_=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var a;(function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"})(a=t.OverviewRulerLane||(t.OverviewRulerLane={}));var d;(function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"})(d=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var N;(function(e){e[e.None=0]="None",e[e.Text=1]="Text",e[e.Blocks=2]="Blocks"})(N=t.RenderMinimap||(t.RenderMinimap={}));var M;(function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"})(M=t.ScrollType||(t.ScrollType={}));var C;(function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"})(C=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var R;(function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"})(R=t.SelectionDirection||(t.SelectionDirection={}));var F;(function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"})(F=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var W;(function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"})(W=t.SymbolKind||(t.SymbolKind={}));var O;(function(e){e[e.Deprecated=1]="Deprecated"})(O=t.SymbolTag||(t.SymbolTag={}));var j;(function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"})(j=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var J;(function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"})(J=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var G;(function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(G=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var x;(function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"})(x=t.WrappingIndent||(t.WrappingIndent={}))}),z(V[31],Q([0,1,21,10,17,14,3,6,24,25,30]),function(I,t,p,U,P,s,b,l,u,c,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class w{static chord(g,A){return(0,P.KeyChord)(g,A)}}t.KeyMod=w,w.CtrlCmd=2048,w.Shift=1024,w.Alt=512,w.WinCtrl=256;function m(){return{editor:void 0,languages:void 0,CancellationTokenSource:p.CancellationTokenSource,Emitter:U.Emitter,KeyCode:L.KeyCode,KeyMod:w,Position:b.Position,Range:l.Range,Selection:u.Selection,SelectionDirection:L.SelectionDirection,MarkerSeverity:L.MarkerSeverity,MarkerTag:L.MarkerTag,Uri:s.URI,Token:c.Token}}t.createMonacoBaseAPI=m}),z(V[32],Q([0,1,13]),function(I,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumComputer=t.PrefixSumIndexOfResult=void 0;class U{constructor(b,l){this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=l}}t.PrefixSumIndexOfResult=U;class P{constructor(b){this.values=b,this.prefixSum=new Uint32Array(b.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(b,l){b=(0,p.toUint32)(b);const u=this.values,c=this.prefixSum,L=l.length;return L===0?!1:(this.values=new Uint32Array(u.length+L),this.values.set(u.subarray(0,b),0),this.values.set(u.subarray(b),b+L),this.values.set(l,b),b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(c.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(b,l){return b=(0,p.toUint32)(b),l=(0,p.toUint32)(l),this.values[b]===l?!1:(this.values[b]=l,b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),!0)}removeValues(b,l){b=(0,p.toUint32)(b),l=(0,p.toUint32)(l);const u=this.values,c=this.prefixSum;if(b>=u.length)return!1;let L=u.length-b;return l>=L&&(l=L),l===0?!1:(this.values=new Uint32Array(u.length-l),this.values.set(u.subarray(0,b),0),this.values.set(u.subarray(b+l),b),this.prefixSum=new Uint32Array(this.values.length),b-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=b-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(c.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(b){return b<0?0:(b=(0,p.toUint32)(b),this._getPrefixSum(b))}_getPrefixSum(b){if(b<=this.prefixSumValidIndex[0])return this.prefixSum[b];let l=this.prefixSumValidIndex[0]+1;l===0&&(this.prefixSum[0]=this.values[0],l++),b>=this.values.length&&(b=this.values.length-1);for(let u=l;u<=b;u++)this.prefixSum[u]=this.prefixSum[u-1]+this.values[u];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],b),this.prefixSum[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let l=0,u=this.values.length-1,c=0,L=0,w=0;for(;l<=u;)if(c=l+(u-l)/2|0,L=this.prefixSum[c],w=L-this.values[c],b<w)u=c-1;else if(b>=L)l=c+1;else break;return new U(c,b-w)}}t.PrefixSumComputer=P}),z(V[33],Q([0,1,5,3,32]),function(I,t,p,U,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class s{constructor(l,u,c,L){this._uri=l,this._lines=u,this._eol=c,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(l){l.eol&&l.eol!==this._eol&&(this._eol=l.eol,this._lineStarts=null);const u=l.changes;for(const c of u)this._acceptDeleteRange(c.range),this._acceptInsertText(new U.Position(c.range.startLineNumber,c.range.startColumn),c.text);this._versionId=l.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const l=this._eol.length,u=this._lines.length,c=new Uint32Array(u);for(let L=0;L<u;L++)c[L]=this._lines[L].length+l;this._lineStarts=new P.PrefixSumComputer(c)}}_setLineText(l,u){this._lines[l]=u,this._lineStarts&&this._lineStarts.changeValue(l,this._lines[l].length+this._eol.length)}_acceptDeleteRange(l){if(l.startLineNumber===l.endLineNumber){if(l.startColumn===l.endColumn)return;this._setLineText(l.startLineNumber-1,this._lines[l.startLineNumber-1].substring(0,l.startColumn-1)+this._lines[l.startLineNumber-1].substring(l.endColumn-1));return}this._setLineText(l.startLineNumber-1,this._lines[l.startLineNumber-1].substring(0,l.startColumn-1)+this._lines[l.endLineNumber-1].substring(l.endColumn-1)),this._lines.splice(l.startLineNumber,l.endLineNumber-l.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(l.startLineNumber,l.endLineNumber-l.startLineNumber)}_acceptInsertText(l,u){if(u.length===0)return;let c=(0,p.splitLines)(u);if(c.length===1){this._setLineText(l.lineNumber-1,this._lines[l.lineNumber-1].substring(0,l.column-1)+c[0]+this._lines[l.lineNumber-1].substring(l.column-1));return}c[c.length-1]+=this._lines[l.lineNumber-1].substring(l.column-1),this._setLineText(l.lineNumber-1,this._lines[l.lineNumber-1].substring(0,l.column-1)+c[0]);let L=new Uint32Array(c.length-1);for(let w=1;w<c.length;w++)this._lines.splice(l.lineNumber+w-1,0,c[w]),L[w-1]=c[w].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(l.lineNumber,L)}}t.MirrorTextModel=s}),z(V[35],Q([0,1,11,2,14,3,6,26,33,27,28,29,31,12,9]),function(I,t,p,U,P,s,b,l,u,c,L,w,m,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class A extends u.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,r){let o=(0,c.getWordAtText)(i.column,(0,c.ensureValidWordDefinition)(r),this._lines[i.lineNumber-1],0);return o?new b.Range(i.lineNumber,o.startColumn,i.lineNumber,o.endColumn):null}getWordUntilPosition(i,r){const o=this.getWordAtPosition(i,r);return o?{word:this._lines[i.lineNumber-1].substring(o.startColumn-1,i.column-1),startColumn:o.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const r=this._lines,o=this._wordenize.bind(this);let h=0,_="",a=0,d=[];return{*[Symbol.iterator](){for(;;)if(a<d.length){const N=_.substring(d[a].start,d[a].end);a+=1,yield N}else if(h<r.length)_=r[h],d=o(_,i),a=0,h+=1;else break}}}getLineWords(i,r){let o=this._lines[i-1],h=this._wordenize(o,r),_=[];for(const a of h)_.push({word:o.substring(a.start,a.end),startColumn:a.start+1,endColumn:a.end+1});return _}_wordenize(i,r){const o=[];let h;for(r.lastIndex=0;(h=r.exec(i))&&h[0].length!==0;)o.push({start:h.index,end:h.index+h[0].length});return o}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);let r=this._eol,o=i.startLineNumber-1,h=i.endLineNumber-1,_=[];_.push(this._lines[o].substring(i.startColumn-1));for(let a=o+1;a<h;a++)_.push(this._lines[a]);return _.push(this._lines[h].substring(0,i.endColumn-1)),_.join(r)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();let r=this._lineStarts.getIndexOf(i),o=this._lines[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,o)}}_validateRange(i){const r=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),o=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return r.lineNumber!==i.startLineNumber||r.column!==i.startColumn||o.lineNumber!==i.endLineNumber||o.column!==i.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:o.lineNumber,endColumn:o.column}:i}_validatePosition(i){if(!s.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:r,column:o}=i,h=!1;if(r<1)r=1,o=1,h=!0;else if(r>this._lines.length)r=this._lines.length,o=this._lines[r-1].length+1,h=!0;else{let _=this._lines[r-1].length+1;o<1?(o=1,h=!0):o>_&&(o=_,h=!0)}return h?{lineNumber:r,column:o}:i}}class E{constructor(i,r){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=r,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){let i=[];return Object.keys(this._models).forEach(r=>i.push(this._models[r])),i}acceptNewModel(i){this._models[i.url]=new A(P.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,r){if(!this._models[i])return;this._models[i].onEvents(r)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeDiff(i,r,o,h){const _=this._getModel(i),a=this._getModel(r);if(!_||!a)return null;const d=_.getLinesContent(),N=a.getLinesContent(),C=new l.DiffComputer(d,N,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:o,shouldMakePrettyDiff:!0,maxComputationTime:h}).computeDiff(),R=C.changes.length>0?!1:this._modelsAreIdentical(_,a);return{quitEarly:C.quitEarly,identical:R,changes:C.changes}}_modelsAreIdentical(i,r){const o=i.getLineCount(),h=r.getLineCount();if(o!==h)return!1;for(let _=1;_<=o;_++){const a=i.getLineContent(_),d=r.getLineContent(_);if(a!==d)return!1}return!0}async computeDirtyDiff(i,r,o){let h=this._getModel(i),_=this._getModel(r);if(!h||!_)return null;let a=h.getLinesContent(),d=_.getLinesContent();return new l.DiffComputer(a,d,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:o,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,r){const o=this._getModel(i);if(!o)return r;const h=[];let _;r=r.slice(0).sort((a,d)=>{if(a.range&&d.range)return b.Range.compareRangesUsingStarts(a.range,d.range);let N=a.range?0:1,M=d.range?0:1;return N-M});for(let{range:a,text:d,eol:N}of r){if(typeof N=="number"&&(_=N),b.Range.isEmpty(a)&&!d)continue;const M=o.getValueInRange(a);if(d=d.replace(/\r\n|\n|\r/g,o.eol),M===d)continue;if(Math.max(d.length,M.length)>E._diffLimit){h.push({range:a,text:d});continue}const C=(0,p.stringDiff)(M,d,!1),R=o.offsetAt(b.Range.lift(a).getStartPosition());for(const F of C){const W=o.positionAt(R+F.originalStart),O=o.positionAt(R+F.originalStart+F.originalLength),j={text:d.substr(F.modifiedStart,F.modifiedLength),range:{startLineNumber:W.lineNumber,startColumn:W.column,endLineNumber:O.lineNumber,endColumn:O.column}};o.getValueInRange(j.range)!==j.text&&h.push(j)}}return typeof _=="number"&&h.push({eol:_,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),h}async computeLinks(i){let r=this._getModel(i);return r?(0,L.computeLinks)(r):null}async textualSuggest(i,r,o,h){const _=new g.StopWatch(!0),a=new RegExp(o,h),d=new Set;e:for(let N of i){const M=this._getModel(N);if(!!M){for(let C of M.words(a))if(!(C===r||!isNaN(Number(C)))&&(d.add(C),d.size>E._suggestionsLimit))break e}}return{words:Array.from(d),duration:_.elapsed()}}async computeWordRanges(i,r,o,h){let _=this._getModel(i);if(!_)return Object.create(null);const a=new RegExp(o,h),d=Object.create(null);for(let N=r.startLineNumber;N<r.endLineNumber;N++){let M=_.getLineWords(N,a);for(const C of M){if(!isNaN(Number(C.word)))continue;let R=d[C.word];R||(R=[],d[C.word]=R),R.push({startLineNumber:N,startColumn:C.startColumn,endLineNumber:N,endColumn:C.endColumn})}}return d}async navigateValueSet(i,r,o,h,_){let a=this._getModel(i);if(!a)return null;let d=new RegExp(h,_);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});let N=a.getValueInRange(r),M=a.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},d);if(!M)return null;let C=a.getValueInRange(M);return w.BasicInplaceReplace.INSTANCE.navigateValueSet(r,N,M,C,o)}loadForeignModule(i,r,o){const h=(d,N)=>this._host.fhr(d,N);let a={host:f.createProxyObject(o,h),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(a,r),Promise.resolve(f.getAllMethodNames(this._foreignModule))):new Promise((d,N)=>{I([i],M=>{this._foreignModule=M.create(a,r),d(f.getAllMethodNames(this._foreignModule))},N)})}fmr(i,r){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,r))}catch(o){return Promise.reject(o)}}}t.EditorSimpleWorker=E,E._diffLimit=1e5,E._suggestionsLimit=1e4;function S(n){return new E(n,null)}t.create=S,typeof importScripts=="function"&&(U.globals.monaco=(0,m.createMonacoBaseAPI)())}),function(){const I=self.MonacoEnvironment,t=I&&I.baseUrl?I.baseUrl:"../../../",p=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:l=>l,createScript:(l,...u)=>{const c=u.slice(0,-1).join(","),L=u.pop().toString();return`(function anonymous(${c}) {
${L}
})`}}):void 0;function U(){return new Promise((l,u)=>{if(typeof self.define=="function"&&self.define.amd)return l();const c=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,self.origin.length)!==self.origin)){fetch(c).then(w=>{if(w.status!==200)throw new Error(w.statusText);return w.text()}).then(w=>{w=`${w}
//# sourceURL=${c}`,(p?self.eval(p.createScript("",w)):new Function(w)).call(self),l()}).then(void 0,u);return}p?importScripts(p.createScriptURL(c)):importScripts(c),l()})}const P=function(l){U().then(()=>{require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:p}),require([l],function(u){setTimeout(function(){let c=u.create((L,w)=>{self.postMessage(L,w)},null);for(self.onmessage=L=>c.onmessage(L.data);b.length>0;)self.onmessage(b.shift())},0)})})};let s=!0,b=[];self.onmessage=l=>{if(!s){b.push(l);return}s=!1,P(l.data)}}()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a4eb4d688477fb9f2176bb2ed932b0b1726caed3/core/vs/base/worker/workerMain.js.map
