/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/uri","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/errors","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/platform/log/common/log","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/base/common/strings","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/platform/userDataSync/common/userDataSync","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","os","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","child_process","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/platform/product/common/product","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","minimist","assert","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],E=0,R=K.length;E<R;E++)e[E]=Z[K[E]];return e};define(Z[90],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function E(R,L){if(!R)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=E}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const E=Object.prototype.hasOwnProperty;function R(n){const w=[];for(let g in n)E.call(n,g)&&w.push(n[g]);return w}e.values=R;function L(n,w){for(let g in n)if(E.call(n,g)&&w({key:g,value:n[g]},function(){delete n[g]})===!1)return}e.forEach=L;function k(n,w){const g=Object.create(null);for(const m of n){const u=w(m);let I=g[u];I||(I=g[u]=[]),I.push(m)}return g}e.groupBy=k;function A(n){const w=Object.create(null);return n&&n.forEach((g,m)=>{w[m]=g}),w}e.fromMap=A;function P(n,w){const g=[],m=[];for(let u of n)w.has(u)||g.push(u);for(let u of w)n.has(u)||m.push(u);return{removed:g,added:m}}e.diffSets=P;function p(n,w){const g=[],m=[];for(let[u,I]of n)w.has(u)||g.push(I);for(let[u,I]of w)n.has(u)||m.push(I);return{removed:g,added:m}}e.diffMaps=p;class y{constructor(){this.map=new Map}add(w,g){let m=this.map.get(w);m||(m=new Set,this.map.set(w,m)),m.add(g)}delete(w,g){const m=this.map.get(w);!m||(m.delete(g),m.size===0&&this.map.delete(w))}forEach(w,g){const m=this.map.get(w);!m||m.forEach(g)}}e.SetMap=y}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function E(A){return(P,p,y)=>{let n=null,w=null;if(typeof y.value=="function"?(n="value",w=y.value):typeof y.get=="function"&&(n="get",w=y.get),!w)throw new Error("not supported");y[n]=A(w,p)}}e.createDecorator=E;function R(A,P,p){let y=null,n=null;if(typeof p.value=="function"?(y="value",n=p.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(y="get",n=p.get),!n)throw new Error("not supported");const w=`$memoize$${P}`;p[y]=function(...g){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,g)}),this[w]}}e.memoize=R;function L(A,P,p){return E((y,n)=>{const w=`$debounce$${n}`,g=`$debounce$result$${n}`;return function(...m){this[g]||(this[g]=p?p():void 0),clearTimeout(this[w]),P&&(this[g]=P(this[g],...m),m=[this[g]]),this[w]=setTimeout(()=>{y.apply(this,m),this[g]=p?p():void 0},A)}})}e.debounce=L;function k(A,P,p){return E((y,n)=>{const w=`$throttle$timer$${n}`,g=`$throttle$result$${n}`,m=`$throttle$lastRun$${n}`,u=`$throttle$pending$${n}`;return function(...I){if(this[g]||(this[g]=p?p():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),P&&(this[g]=P(this[g],...I)),this[u])return;const C=this[m]+A;C<=Date.now()?(this[m]=Date.now(),y.apply(this,[this[g]]),this[g]=p?p():void 0):(this[u]=!0,this[w]=setTimeout(()=>{this[u]=!1,this[m]=Date.now(),y.apply(this,[this[g]]),this[g]=p?p():void 0},C-Date.now()))}})}e.throttle=k}),define(Z[11],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=E,e.errorHandler=new E;function R(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=R;function L(a){p(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=L;function k(a){p(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=k;function A(a){if(a instanceof Error){let{name:t,message:r}=a;const i=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:i}}return a}e.transformErrorForSerialization=A;const P="Canceled";function p(a){return a instanceof Error&&a.name===P&&a.message===P}e.isPromiseCanceledError=p;class y extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=y;function n(){const a=new Error(P);return a.name=a.message,a}e.canceled=n;function w(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=w;function g(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=g;function m(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function u(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function I(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=I;class C extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=C;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class D extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=D;function v(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=v;function o(a,t=Object.create(null)){const r=new Error(a);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=o}),define(Z[23],ee([0,1,11]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(_,G=0){return _[_.length-(1+G)]}e.tail=R;function L(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.tail2=L;function k(_,G,B=(X,Q)=>X===Q){if(_===G)return!0;if(!_||!G||_.length!==G.length)return!1;for(let X=0,Q=_.length;X<Q;X++)if(!B(_[X],G[X]))return!1;return!0}e.equals=k;function A(_,G,B){let X=0,Q=_.length-1;for(;X<=Q;){const ie=(X+Q)/2|0,ne=B(_[ie],G);if(ne<0)X=ie+1;else if(ne>0)Q=ie-1;else return ie}return-(X+1)}e.binarySearch=A;function P(_,G){let B=0,X=_.length;if(X===0)return 0;for(;B<X;){const Q=Math.floor((B+X)/2);G(_[Q])?X=Q:B=Q+1}return B}e.findFirstInSorted=P;function p(_,G,B){if(_=_|0,_>=G.length)throw new TypeError("invalid index");let X=G[Math.floor(G.length*Math.random())],Q=[],ie=[],ne=[];for(let le of G){const fe=B(le,X);fe<0?Q.push(le):fe>0?ie.push(le):ne.push(le)}return _<Q.length?p(_,Q,B):_<Q.length+ne.length?ne[0]:p(_-(Q.length+ne.length),ie,B)}e.quickSelect=p;function y(_,G){const B=[];let X;for(const Q of _.slice(0).sort(G))!X||G(X[0],Q)!==0?(X=[Q],B.push(X)):X.push(Q);return B}e.groupBy=y;function n(_,G,B){const X=[];function Q(le,fe,ye){if(fe===0&&ye.length===0)return;const Se=X[X.length-1];Se&&Se.start+Se.deleteCount===le?(Se.deleteCount+=fe,Se.toInsert.push(...ye)):X.push({start:le,deleteCount:fe,toInsert:ye})}let ie=0,ne=0;for(;;){if(ie===_.length){Q(ie,0,G.slice(ne));break}if(ne===G.length){Q(ie,_.length-ie,[]);break}const le=_[ie],fe=G[ne],ye=B(le,fe);ye===0?(ie+=1,ne+=1):ye<0?(Q(ie,1,[]),ie+=1):ye>0&&(Q(ie,0,[fe]),ne+=1)}return X}e.sortedDiff=n;function w(_,G,B){const X=n(_,G,B),Q=[],ie=[];for(const ne of X)Q.push(..._.slice(ne.start,ne.start+ne.deleteCount)),ie.push(...ne.toInsert);return{removed:Q,added:ie}}e.delta=w;function g(_,G,B){if(B===0)return[];const X=_.slice(0,B).sort(G);return u(_,G,X,B,_.length),X}e.top=g;function m(_,G,B,X,Q){return B===0?Promise.resolve([]):new Promise((ie,ne)=>{(async()=>{const le=_.length,fe=_.slice(0,B).sort(G);for(let ye=B,Se=Math.min(B+X,le);ye<le;ye=Se,Se=Math.min(Se+X,le)){if(ye>B&&await new Promise(Pe=>setTimeout(Pe)),Q&&Q.isCancellationRequested)throw(0,E.canceled)();u(_,G,fe,ye,Se)}return fe})().then(ie,ne)})}e.topAsync=m;function u(_,G,B,X,Q){for(const ie=B.length;X<Q;X++){const ne=_[X];if(G(ne,B[ie-1])<0){B.pop();const le=P(B,fe=>G(ne,fe)<0);B.splice(le,0,ne)}}}function I(_){return _.filter(G=>!!G)}e.coalesce=I;function C(_){let G=0;for(let B=0;B<_.length;B++)_[B]&&(_[G]=_[B],G+=1);_.length=G}e.coalesceInPlace=C;function b(_,G,B){_.splice(B,0,_.splice(G,1)[0])}e.move=b;function D(_){return!Array.isArray(_)||_.length===0}e.isFalsyOrEmpty=D;function v(_){return Array.isArray(_)&&_.length>0}e.isNonEmptyArray=v;function o(_,G){if(!G)return _.filter((X,Q)=>_.indexOf(X)===Q);const B=Object.create(null);return _.filter(X=>{const Q=G(X);return B[Q]?!1:(B[Q]=!0,!0)})}e.distinct=o;function a(_){const G=new Set;return _.filter(B=>G.has(B)?!1:(G.add(B),!0))}e.distinctES6=a;function t(_){const G=Object.create(null);return B=>{const X=_(B);return G[X]?!1:(G[X]=!0,!0)}}e.uniqueFilter=t;function r(_,G){for(let B=_.length-1;B>=0;B--){const X=_[B];if(G(X))return B}return-1}e.lastIndex=r;function i(_,G){return _.length>0?_[0]:G}e.firstOrDefault=i;function s(_,G,B=(X,Q)=>X===Q){let X=0;for(let Q=0,ie=Math.min(_.length,G.length);Q<ie&&B(_[Q],G[Q]);Q++)X++;return X}e.commonPrefixLength=s;function h(_){return[].concat(..._)}e.flatten=h;function c(_,G){let B=typeof G=="number"?_:0;typeof G=="number"?B=_:(B=0,G=_);const X=[];if(B<=G)for(let Q=B;Q<G;Q++)X.push(Q);else for(let Q=B;Q>G;Q--)X.push(Q);return X}e.range=c;function l(_,G,B){return _.reduce((X,Q)=>(X[G(Q)]=B?B(Q):Q,X),Object.create(null))}e.index=l;function f(_,G){return _.push(G),()=>S(_,G)}e.insert=f;function S(_,G){const B=_.indexOf(G);if(B>-1)return _.splice(B,1),G}e.remove=S;function d(_,G,B){const X=_.slice(0,G),Q=_.slice(G);return X.concat(B,Q)}e.arrayInsert=d;function T(_,G){let B;if(typeof G=="number"){let X=G;B=()=>{const Q=Math.sin(X++)*179426549;return Q-Math.floor(Q)}}else B=Math.random;for(let X=_.length-1;X>0;X-=1){const Q=Math.floor(B()*(X+1)),ie=_[X];_[X]=_[Q],_[Q]=ie}}e.shuffle=T;function O(_,G){const B=_.indexOf(G);B>-1&&(_.splice(B,1),_.unshift(G))}e.pushToStart=O;function x(_,G){const B=_.indexOf(G);B>-1&&(_.splice(B,1),_.push(G))}e.pushToEnd=x;function z(_,G){return Array.isArray(_)?_.map(G):G(_)}e.mapArrayOrNot=z;function H(_){return Array.isArray(_)?_:[_]}e.asArray=H;function V(_){return _[Math.floor(Math.random()*_.length)]}e.getRandomElement=V;function U(_,G){for(const B of _){const X=G(B);if(X!==void 0)return X}}e.mapFind=U;function $(_,G,B){const X=N(_,G),Q=_.length,ie=B.length;_.length=Q+ie;for(let ne=Q-1;ne>=X;ne--)_[ne+ie]=_[ne];for(let ne=0;ne<ie;ne++)_[ne+X]=B[ne]}e.insertInto=$;function M(_,G,B,X){const Q=N(_,G),ie=_.splice(Q,B);return $(_,Q,X),ie}e.splice=M;function N(_,G){return G<0?Math.max(G+_.length,0):Math.min(G,_.length)}function q(_,G){let B=Number.MAX_SAFE_INTEGER,X=0;return _.forEach((Q,ie)=>{const ne=G(Q);ne<B&&(B=ne,X=ie)}),X}e.minIndex=q;function F(_,G){let B=Number.MIN_SAFE_INTEGER,X=0;return _.forEach((Q,ie)=>{const ne=G(Q);ne>B&&(B=ne,X=ie)}),X}e.maxIndex=F;class j{constructor(G){this.items=G,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(G){let B=this.firstIdx;for(;B<this.items.length&&G(this.items[B]);)B++;const X=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,X}takeFromEndWhile(G){let B=this.lastIdx;for(;B>=0&&G(this.items[B]);)B--;const X=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,X}}e.ArrayQueue=j}),define(Z[65],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(R){const L=this;let k=!1,A;return function(){return k||(k=!0,A=R.apply(L,arguments)),A}}e.once=E}),define(Z[55],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(R){function L(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}R.is=L;const k=Object.freeze([]);function A(){return k}R.empty=A;function*P(a){yield a}R.single=P;function p(a){return a||k}R.from=p;function y(a){return!a||a[Symbol.iterator]().next().done===!0}R.isEmpty=y;function n(a){return a[Symbol.iterator]().next().value}R.first=n;function w(a,t){for(const r of a)if(t(r))return!0;return!1}R.some=w;function g(a,t){for(const r of a)if(t(r))return r}R.find=g;function*m(a,t){for(const r of a)t(r)&&(yield r)}R.filter=m;function*u(a,t){let r=0;for(const i of a)yield t(i,r++)}R.map=u;function*I(...a){for(const t of a)for(const r of t)yield r}R.concat=I;function*C(a){for(const t of a)for(const r of t)yield r}R.concatNested=C;function b(a,t,r){let i=r;for(const s of a)i=t(i,s);return i}R.reduce=b;function*D(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}R.slice=D;function v(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const i=a[Symbol.iterator]();for(let s=0;s<t;s++){const h=i.next();if(h.done)return[r,R.empty()];r.push(h.value)}return[r,{[Symbol.iterator](){return i}}]}R.consume=v;function o(a,t,r=(i,s)=>i===s){const i=a[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const h=i.next(),c=s.next();if(h.done!==c.done)return!1;if(h.done)return!0;if(!r(h.value,c.value))return!1}}R.equals=o})(E=e.Iterable||(e.Iterable={}))}),define(Z[33],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let i=0,s=t.length,h="",c=0,l=16,f=0;function S(V){let U=0,$=0;for(;U<V;){const M=t.charCodeAt(i);if(M>=48&&M<=57)$=$*16+M-48;else if(M>=65&&M<=70)$=$*16+M-65+10;else if(M>=97&&M<=102)$=$*16+M-97+10;else break;i++,U++}return U<V&&($=-1),$}function d(V){i=V,h="",c=0,l=16,f=0}function T(){const V=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&y(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&y(t.charCodeAt(i)))for(i++;i<t.length&&y(t.charCodeAt(i));)i++;else return f=3,t.substring(V,i);let U=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&y(t.charCodeAt(i))){for(i++;i<t.length&&y(t.charCodeAt(i));)i++;U=i}else f=3;return t.substring(V,U)}function O(){let V="",U=i;for(;;){if(i>=s){V+=t.substring(U,i),f=2;break}const $=t.charCodeAt(i);if($===34){V+=t.substring(U,i),i++;break}if($===92){if(V+=t.substring(U,i),i++,i>=s){f=2;break}switch(t.charCodeAt(i++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:const N=S(4);N>=0?V+=String.fromCharCode(N):f=4;break;default:f=5}U=i;continue}if($>=0&&$<=31)if(p($)){V+=t.substring(U,i),f=2;break}else f=6;i++}return V}function x(){if(h="",f=0,c=i,i>=s)return c=s,l=17;let V=t.charCodeAt(i);if(P(V)){do i++,h+=String.fromCharCode(V),V=t.charCodeAt(i);while(P(V));return l=15}if(p(V))return i++,h+=String.fromCharCode(V),V===13&&t.charCodeAt(i)===10&&(i++,h+=`
`),l=14;switch(V){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,h=O(),l=10;case 47:const U=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!p(t.charCodeAt(i));)i++;return h=t.substring(U,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const $=s-1;let M=!1;for(;i<$;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,M=!0;break}i++}return M||(i++,f=1),h=t.substring(U,i),l=13}return h+=String.fromCharCode(V),i++,l=16;case 45:if(h+=String.fromCharCode(V),i++,i===s||!y(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=T(),l=11;default:for(;i<s&&z(V);)i++,V=t.charCodeAt(i);if(c!==i){switch(h=t.substring(c,i),h){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return h+=String.fromCharCode(V),i++,l=16}}function z(V){if(P(V)||p(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let V;do V=x();while(V>=12&&V<=15);return V}return{setPosition:d,getPosition:()=>i,scan:r?H:x,getToken:()=>l,getTokenValue:()=>h,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>f}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function w(t,r){const i=[],s=new Object;let h;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function f(S,d,T,O){c.value=S,c.offset=d,c.length=T,c.type=O,c.colonOffset=void 0,h=c}try{v(t,{onObjectBegin:(S,d)=>{if(r<=S)throw s;h=void 0,l=r>S,i.push("")},onObjectProperty:(S,d,T)=>{if(r<d||(f(S,d,T,"property"),i[i.length-1]=S,r<=d+T))throw s},onObjectEnd:(S,d)=>{if(r<=S)throw s;h=void 0,i.pop()},onArrayBegin:(S,d)=>{if(r<=S)throw s;h=void 0,i.push(0)},onArrayEnd:(S,d)=>{if(r<=S)throw s;h=void 0,i.pop()},onLiteralValue:(S,d,T)=>{if(r<d||(f(S,d,T,a(S)),r<=d+T))throw s},onSeparator:(S,d,T)=>{if(r<=d)throw s;if(S===":"&&h&&h.type==="property")h.colonOffset=d,l=!1,h=void 0;else if(S===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(l=!0,i[i.length-1]=""),h=void 0}}})}catch(S){if(S!==s)throw S}return{path:i,previousNode:h,isAtPropertyKey:l,matches:S=>{let d=0;for(let T=0;d<S.length&&T<i.length;T++)if(S[d]===i[T]||S[d]==="*")d++;else if(S[d]!=="**")return!1;return d===S.length}}}e.getLocation=w;function g(t,r=[],i=k.DEFAULT){let s=null,h=[];const c=[];function l(S){Array.isArray(h)?h.push(S):s!==null&&(h[s]=S)}return v(t,{onObjectBegin:()=>{const S={};l(S),c.push(h),h=S,s=null},onObjectProperty:S=>{s=S},onObjectEnd:()=>{h=c.pop()},onArrayBegin:()=>{const S=[];l(S),c.push(h),h=S,s=null},onArrayEnd:()=>{h=c.pop()},onLiteralValue:l,onError:(S,d,T)=>{r.push({error:S,offset:d,length:T})}},i),h[0]}e.parse=g;function m(t,r=[],i=k.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(S){s.type==="property"&&(s.length=S-s.offset,s=s.parent)}function c(S){return s.children.push(S),S}v(t,{onObjectBegin:S=>{s=c({type:"object",offset:S,length:-1,parent:s,children:[]})},onObjectProperty:(S,d,T)=>{s=c({type:"property",offset:d,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:S,offset:d,length:T,parent:s})},onObjectEnd:(S,d)=>{s.length=S+d-s.offset,s=s.parent,h(S+d)},onArrayBegin:(S,d)=>{s=c({type:"array",offset:S,length:-1,parent:s,children:[]})},onArrayEnd:(S,d)=>{s.length=S+d-s.offset,s=s.parent,h(S+d)},onLiteralValue:(S,d,T)=>{c({type:a(S),offset:d,length:T,parent:s,value:S}),h(d+T)},onSeparator:(S,d,T)=>{s.type==="property"&&(S===":"?s.colonOffset=d:S===","&&h(d))},onError:(S,d,T)=>{r.push({error:S,offset:d,length:T})}},i);const f=s.children[0];return f&&delete f.parent,f}e.parseTree=m;function u(t,r){if(!t)return;let i=t;for(let s of r)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let h=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===s){i=c.children[1],h=!0;break}if(!h)return}else{const h=s;if(i.type!=="array"||h<0||!Array.isArray(i.children)||h>=i.children.length)return;i=i.children[h]}return i}e.findNodeAtLocation=u;function I(t){if(!t.parent||!t.parent.children)return[];const r=I(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=I;function C(t){switch(t.type){case"array":return t.children.map(C);case"object":const r=Object.create(null);for(let i of t.children){const s=i.children[1];s&&(r[i.children[0].value]=C(s))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=C;function b(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=b;function D(t,r,i=!1){if(b(t,r,i)){const s=t.children;if(Array.isArray(s))for(let h=0;h<s.length&&s[h].offset<=r;h++){const c=D(s[h],r,i);if(c)return c}return t}}e.findNodeAtOffset=D;function v(t,r,i=k.DEFAULT){const s=A(t,!1);function h(B){return B?()=>B(s.getTokenOffset(),s.getTokenLength()):()=>!0}function c(B){return B?X=>B(X,s.getTokenOffset(),s.getTokenLength()):()=>!0}const l=h(r.onObjectBegin),f=c(r.onObjectProperty),S=h(r.onObjectEnd),d=h(r.onArrayBegin),T=h(r.onArrayEnd),O=c(r.onLiteralValue),x=c(r.onSeparator),z=h(r.onComment),H=c(r.onError),V=i&&i.disallowComments,U=i&&i.allowTrailingComma;function $(){for(;;){const B=s.scan();switch(s.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:V||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(B){case 12:case 13:V?M(10):z();break;case 16:M(1);break;case 15:case 14:break;default:return B}}}function M(B,X=[],Q=[]){if(H(B),X.length+Q.length>0){let ie=s.getToken();for(;ie!==17;){if(X.indexOf(ie)!==-1){$();break}else if(Q.indexOf(ie)!==-1)break;ie=$()}}}function N(B){const X=s.getTokenValue();return B?O(X):f(X),$(),!0}function q(){switch(s.getToken()){case 11:let B=0;try{B=JSON.parse(s.getTokenValue()),typeof B!="number"&&(M(2),B=0)}catch(X){M(2)}O(B);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return $(),!0}function F(){return s.getToken()!==10?(M(3,[],[2,5]),!1):(N(!1),s.getToken()===6?(x(":"),$(),G()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function j(){l(),$();let B=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(B||M(4,[],[]),x(","),$(),s.getToken()===2&&U)break}else B&&M(6,[],[]);F()||M(4,[],[2,5]),B=!0}return S(),s.getToken()!==2?M(7,[2],[]):$(),!0}function _(){d(),$();let B=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(B||M(4,[],[]),x(","),$(),s.getToken()===4&&U)break}else B&&M(6,[],[]);G()||M(4,[],[4,5]),B=!0}return T(),s.getToken()!==4?M(8,[4],[]):$(),!0}function G(){switch(s.getToken()){case 3:return _();case 1:return j();case 10:return N(!0);default:return q()}}return $(),s.getToken()===17?i.allowEmptyContent?!0:(M(4,[],[]),!1):G()?(s.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=v;function o(t,r){let i=A(t),s=[],h,c=0,l;do switch(l=i.getPosition(),h=i.scan(),h){case 12:case 13:case 17:c!==l&&s.push(t.substring(c,l)),r!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,r)),c=i.getPosition();break}while(h!==17);return s.join("")}e.stripComments=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(Z[47],ee([0,1,33]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(p,y,n){let w,g,m,u,I;if(y){for(u=y.offset,I=u+y.length,m=u;m>0&&!P(p,m-1);)m--;let c=I;for(;c<p.length&&!P(p,c);)c++;g=p.substring(m,c),w=k(g,n)}else g=p,w=0,m=0,u=0,I=p.length;const C=A(n,p);let b=!1,D=0,v;n.insertSpaces?v=L(" ",n.tabSize||4):v="	";const o=(0,E.createScanner)(g,!1);let a=!1;function t(){return C+L(v,w+D)}function r(){let c=o.scan();for(b=!1;c===15||c===14;)b=b||c===14,c=o.scan();return a=c===16||o.getTokenError()!==0,c}const i=[];function s(c,l,f){!a&&l<I&&f>u&&p.substring(l,f)!==c&&i.push({offset:l,length:f-l,content:c})}let h=r();if(h!==17){const c=o.getTokenOffset()+m,l=L(v,w);s(l,m,c)}for(;h!==17;){let c=o.getTokenOffset()+o.getTokenLength()+m,l=r(),f="";for(;!b&&(l===12||l===13);){const d=o.getTokenOffset()+m;s(" ",c,d),c=o.getTokenOffset()+o.getTokenLength()+m,f=l===12?t():"",l=r()}if(l===2)h!==1&&(D--,f=t());else if(l===4)h!==3&&(D--,f=t());else{switch(h){case 3:case 1:D++,f=t();break;case 5:case 12:f=t();break;case 13:b?f=t():f=" ";break;case 6:f=" ";break;case 10:if(l===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?f=" ":l!==5&&l!==17&&(a=!0);break;case 16:a=!0;break}b&&(l===12||l===13)&&(f=t())}const S=o.getTokenOffset()+m;s(f,c,S),h=l}return i}e.format=R;function L(p,y){let n="";for(let w=0;w<y;w++)n+=p;return n}function k(p,y){let n=0,w=0;const g=y.tabSize||4;for(;n<p.length;){const m=p.charAt(n);if(m===" ")w++;else if(m==="	")w+=g;else break;n++}return Math.floor(w/g)}function A(p,y){for(let n=0;n<y.length;n++){const w=y.charAt(n);if(w==="\r")return n+1<y.length&&y.charAt(n+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=A;function P(p,y){return`\r
`.indexOf(p.charAt(y))!==-1}e.isEOL=P}),define(Z[43],ee([0,1,33,47]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(y,n,w){return k(y,n,void 0,w)}e.removeProperty=L;function k(y,n,w,g,m){const u=n.slice(),I=[],C=(0,E.parseTree)(y,I);let b,D;for(;u.length>0&&(D=u.pop(),b=(0,E.findNodeAtLocation)(C,u),b===void 0&&w!==void 0);)typeof D=="string"?w={[D]:w}:w=[w];if(b)if(b.type==="object"&&typeof D=="string"&&Array.isArray(b.children)){const v=(0,E.findNodeAtLocation)(b,[D]);if(v!==void 0)if(w===void 0){if(!v.parent)throw new Error("Malformed AST");const o=b.children.indexOf(v.parent);let a,t=v.parent.offset+v.parent.length;if(o>0){const r=b.children[o-1];a=r.offset+r.length}else a=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return A(y,{offset:a,length:t-a,content:""},g)}else return A(y,{offset:v.offset,length:v.length,content:JSON.stringify(w)},g);else{if(w===void 0)return[];const o=`${JSON.stringify(D)}: ${JSON.stringify(w)}`,a=m?m(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(a>0){const r=b.children[a-1];t={offset:r.offset+r.length,length:0,content:","+o}}else b.children.length===0?t={offset:b.offset+1,length:0,content:o}:t={offset:b.offset+1,length:0,content:o+","};return A(y,t,g)}}else if(b.type==="array"&&typeof D=="number"&&Array.isArray(b.children))if(w!==void 0){const v=`${JSON.stringify(w)}`;let o;if(b.children.length===0||D===0)o={offset:b.offset+1,length:0,content:b.children.length===0?v:v+","};else{const a=D===-1||D>b.children.length?b.children.length:D,t=b.children[a-1];o={offset:t.offset+t.length,length:0,content:","+v}}return A(y,o,g)}else{const v=D,o=b.children[v];let a;if(b.children.length===1)a={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===v){const t=b.children[v-1],r=t.offset+t.length,i=b.offset+b.length;a={offset:r,length:i-2-r,content:""}}else a={offset:o.offset,length:b.children[v+1].offset-o.offset,content:""};return A(y,a,g)}else throw new Error(`Can not add ${typeof D!="number"?"index":"property"} to parent of type ${b.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return A(y,{offset:C?C.offset:0,length:C?C.length:0,content:JSON.stringify(w)},g)}}e.setProperty=k;function A(y,n,w){let g=P(y,n),m=n.offset,u=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;m>0&&!(0,R.isEOL)(g,m-1);)m--;for(;u<g.length&&!(0,R.isEOL)(g,u);)u++}const I=(0,R.format)(g,{offset:m,length:u-m},w);for(let b=I.length-1;b>=0;b--){const D=I[b];g=P(g,D),m=Math.min(m,D.offset),u=Math.max(u,D.offset+D.length),u+=D.content.length-D.length}const C=y.length-(g.length-u)-m;return[{offset:m,length:C,content:g.substring(m,u)}]}e.withFormatting=A;function P(y,n){return y.substring(0,n.offset)+n.content+y.substring(n.offset+n.length)}e.applyEdit=P;function p(y,n){let w=n.slice(0).sort((m,u)=>{const I=m.offset-u.offset;return I===0?m.length-u.length:I}),g=y.length;for(let m=w.length-1;m>=0;m--){let u=w[m];if(u.offset+u.length<=g)y=P(y,u);else throw new Error("Overlapping edit");g=u.offset}return y}e.applyEdits=p}),define(Z[2],ee([0,1,65,55]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let k=null;function A(i){k=i}if(e.setDisposableTracker=A,L){const i="__is_disposable_tracked__";A(new class{trackDisposable(s){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[i]||console.log(h)},3e3)}setParent(s,h){if(s&&s!==D.None)try{s[i]=!0}catch{}}markAsDisposed(s){if(s&&s!==D.None)try{s[i]=!0}catch{}}markAsSingleton(s){}})}function P(i){return k?.trackDisposable(i),i}function p(i){k?.markAsDisposed(i)}function y(i,s){k?.setParent(i,s)}function n(i,s){if(!!k)for(const h of i)k.setParent(h,s)}function w(i){return k?.markAsSingleton(i),i}e.markAsSingleton=w;class g extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=g;function m(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=m;function u(i){if(R.Iterable.is(i)){let s=[];for(const h of i)if(h)try{h.dispose()}catch(c){s.push(c)}if(s.length===1)throw s[0];if(s.length>1)throw new g(s);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=u;function I(...i){const s=C(()=>u(i));return n(i,s),s}e.combinedDisposable=I;function C(i){const s=P({dispose:(0,E.once)(()=>{p(s),i()})});return s}e.toDisposable=C;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return y(s,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class D{constructor(){this._store=new b,P(this),y(this._store,this)}dispose(){p(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=D,D.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&y(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&y(s,null),s}}e.MutableDisposable=v;class o{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class a{constructor(){this.references=new Map}acquire(s,...h){let c=this.references.get(s);c||(c={counter:0,object:this.createReferencedObject(s,...h)},this.references.set(s,c));const{object:l}=c,f=(0,E.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(s,c.object),this.references.delete(s))});return c.counter++,{object:l,dispose:f}}}e.ReferenceCollection=a;class t{constructor(s){this.referenceCollection=s}async acquire(s,...h){const c=this.referenceCollection.acquire(s,...h);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(l){throw c.dispose(),l}}}e.AsyncReferenceCollection=t;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r}),define(Z[91],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(k){this.element=k,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class R{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let k=this._first;for(;k!==E.Undefined;){const A=k.next;k.prev=E.Undefined,k.next=E.Undefined,k=A}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,A){const P=new E(k);if(this._first===E.Undefined)this._first=P,this._last=P;else if(A){const y=this._last;this._last=P,P.prev=y,y.next=P}else{const y=this._first;this._first=P,P.next=y,y.prev=P}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(P))}}shift(){if(this._first!==E.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==E.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==E.Undefined&&k.next!==E.Undefined){const A=k.prev;A.next=k.next,k.next.prev=A}else k.prev===E.Undefined&&k.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):k.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):k.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==E.Undefined;)yield k.element,k=k.next}}e.LinkedList=R}),function(){function K(L){const k=[];typeof L=="number"&&k.push("code/timeOrigin",L);function A(p){k.push(p,Date.now())}function P(){const p=[];for(let y=0;y<k.length;y+=2)p.push({name:k[y],startTime:k[y+1]});return p}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const A of performance.getEntriesByType("mark"))k.push({name:A.name,startTime:Math.round(L+A.startTime)});return k}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function E(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=E(R))}(),define(Z[4],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const E="en";let R=!1,L=!1,k=!1,A=!1,P=!1,p=!1,y=!1,n,w=E,g,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const I=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=I&&u?.sandboxed,typeof navigator=="object"&&!I)m=navigator.userAgent,R=m.indexOf("Windows")>=0,L=m.indexOf("Macintosh")>=0,y=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=m.indexOf("Linux")>=0,p=!0,n=navigator.language,w=n;else if(typeof u=="object"){R=u.platform==="win32",L=u.platform==="darwin",k=u.platform==="linux",A=k&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,n=E,w=E;const i=u.env.VSCODE_NLS_CONFIG;if(i)try{const s=JSON.parse(i),h=s.availableLanguages["*"];n=s.locale,w=h||E,g=s._translationsConfigFile}catch(s){}P=!0}else console.error("Unable to resolve platform.");var C;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(C=e.Platform||(e.Platform={}));function b(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let D=0;L?D=1:R?D=3:k&&(D=2),e.isWindows=R,e.isMacintosh=L,e.isLinux=k,e.isLinuxSnap=A,e.isNative=P,e.isWeb=p,e.isIOS=y,e.platform=D,e.userAgent=m,e.language=w;var v;(function(i){function s(){return e.language}i.value=s;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=h;function c(){return e.language==="en"}i.isDefault=c})(v=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let h=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeSetImmediateId)for(let f=0,S=h.length;f<S;f++){const d=h[f];if(d.id===l.data.vscodeSetImmediateId){h.splice(f,1),d.callback();return}}});let c=0;return l=>{const f=++c;h.push({id:f,callback:l}),e.globals.postMessage({vscodeSetImmediateId:f},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const s=Promise.resolve();return h=>s.then(h)}();var o;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||y?2:R?1:3;let a=!0,t=!1;function r(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,a=new Uint16Array(i.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=r}),define(Z[35],ee([0,1,4]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof E.globals.vscode!="undefined"&&typeof E.globals.vscode.process!="undefined"){const L=E.globals.vscode.process;R={get platform(){return L.platform},get env(){return L.env},cwd(){return L.cwd()},nextTick(k){return(0,E.setImmediate)(k)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(L){return process.nextTick(L)}}:R={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},nextTick(L){return(0,E.setImmediate)(L)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(Z[8],ee([0,1,35]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,L=97,k=90,A=122,P=46,p=47,y=92,n=58,w=63;class g extends Error{constructor(o,a,t){let r;typeof a=="string"&&a.indexOf("not ")===0?(r="must not be",a=a.replace(/^not /,"")):r="must be";const i=o.indexOf(".")!==-1?"property":"argument";let s=`The "${o}" ${i} ${r} of type ${a}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function m(v,o){if(typeof v!="string")throw new g(o,"string",v)}function u(v){return v===p||v===y}function I(v){return v===p}function C(v){return v>=R&&v<=k||v>=L&&v<=A}function b(v,o,a,t){let r="",i=0,s=-1,h=0,c=0;for(let l=0;l<=v.length;++l){if(l<v.length)c=v.charCodeAt(l);else{if(t(c))break;c=p}if(t(c)){if(!(s===l-1||h===1))if(h===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const f=r.lastIndexOf(a);f===-1?(r="",i=0):(r=r.slice(0,f),i=r.length-1-r.lastIndexOf(a)),s=l,h=0;continue}else if(r.length!==0){r="",i=0,s=l,h=0;continue}}o&&(r+=r.length>0?`${a}..`:"..",i=2)}else r.length>0?r+=`${a}${v.slice(s+1,l)}`:r=v.slice(s+1,l),i=l-s-1;s=l,h=0}else c===P&&h!==-1?++h:h=-1}return r}function D(v,o){if(o===null||typeof o!="object")throw new g("pathObject","Object",o);const a=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return a?a===o.root?`${a}${t}`:`${a}${v}${t}`:t}e.win32={resolve(...v){let o="",a="",t=!1;for(let r=v.length-1;r>=-1;r--){let i;if(r>=0){if(i=v[r],m(i,"path"),i.length===0)continue}else o.length===0?i=E.cwd():(i=E.env[`=${o}`]||E.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==o.toLowerCase()&&i.charCodeAt(2)===y)&&(i=`${o}\\`));const s=i.length;let h=0,c="",l=!1;const f=i.charCodeAt(0);if(s===1)u(f)&&(h=1,l=!0);else if(u(f))if(l=!0,u(i.charCodeAt(1))){let S=2,d=S;for(;S<s&&!u(i.charCodeAt(S));)S++;if(S<s&&S!==d){const T=i.slice(d,S);for(d=S;S<s&&u(i.charCodeAt(S));)S++;if(S<s&&S!==d){for(d=S;S<s&&!u(i.charCodeAt(S));)S++;(S===s||S!==d)&&(c=`\\\\${T}\\${i.slice(d,S)}`,h=S)}}}else h=1;else C(f)&&i.charCodeAt(1)===n&&(c=i.slice(0,2),h=2,s>2&&u(i.charCodeAt(2))&&(l=!0,h=3));if(c.length>0)if(o.length>0){if(c.toLowerCase()!==o.toLowerCase())continue}else o=c;if(t){if(o.length>0)break}else if(a=`${i.slice(h)}\\${a}`,t=l,l&&o.length>0)break}return a=b(a,!t,"\\",u),t?`${o}\\${a}`:`${o}${a}`||"."},normalize(v){m(v,"path");const o=v.length;if(o===0)return".";let a=0,t,r=!1;const i=v.charCodeAt(0);if(o===1)return I(i)?"\\":v;if(u(i))if(r=!0,u(v.charCodeAt(1))){let h=2,c=h;for(;h<o&&!u(v.charCodeAt(h));)h++;if(h<o&&h!==c){const l=v.slice(c,h);for(c=h;h<o&&u(v.charCodeAt(h));)h++;if(h<o&&h!==c){for(c=h;h<o&&!u(v.charCodeAt(h));)h++;if(h===o)return`\\\\${l}\\${v.slice(c)}\\`;h!==c&&(t=`\\\\${l}\\${v.slice(c,h)}`,a=h)}}}else a=1;else C(i)&&v.charCodeAt(1)===n&&(t=v.slice(0,2),a=2,o>2&&u(v.charCodeAt(2))&&(r=!0,a=3));let s=a<o?b(v.slice(a),!r,"\\",u):"";return s.length===0&&!r&&(s="."),s.length>0&&u(v.charCodeAt(o-1))&&(s+="\\"),t===void 0?r?`\\${s}`:s:r?`${t}\\${s}`:`${t}${s}`},isAbsolute(v){m(v,"path");const o=v.length;if(o===0)return!1;const a=v.charCodeAt(0);return u(a)||o>2&&C(a)&&v.charCodeAt(1)===n&&u(v.charCodeAt(2))},join(...v){if(v.length===0)return".";let o,a;for(let i=0;i<v.length;++i){const s=v[i];m(s,"path"),s.length>0&&(o===void 0?o=a=s:o+=`\\${s}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof a=="string"&&u(a.charCodeAt(0))){++r;const i=a.length;i>1&&u(a.charCodeAt(1))&&(++r,i>2&&(u(a.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&u(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(v,o){if(m(v,"from"),m(o,"to"),v===o)return"";const a=e.win32.resolve(v),t=e.win32.resolve(o);if(a===t||(v=a.toLowerCase(),o=t.toLowerCase(),v===o))return"";let r=0;for(;r<v.length&&v.charCodeAt(r)===y;)r++;let i=v.length;for(;i-1>r&&v.charCodeAt(i-1)===y;)i--;const s=i-r;let h=0;for(;h<o.length&&o.charCodeAt(h)===y;)h++;let c=o.length;for(;c-1>h&&o.charCodeAt(c-1)===y;)c--;const l=c-h,f=s<l?s:l;let S=-1,d=0;for(;d<f;d++){const O=v.charCodeAt(r+d);if(O!==o.charCodeAt(h+d))break;O===y&&(S=d)}if(d!==f){if(S===-1)return t}else{if(l>f){if(o.charCodeAt(h+d)===y)return t.slice(h+d+1);if(d===2)return t.slice(h+d)}s>f&&(v.charCodeAt(r+d)===y?S=d:d===2&&(S=3)),S===-1&&(S=0)}let T="";for(d=r+S+1;d<=i;++d)(d===i||v.charCodeAt(d)===y)&&(T+=T.length===0?"..":"\\..");return h+=S,T.length>0?`${T}${t.slice(h,c)}`:(t.charCodeAt(h)===y&&++h,t.slice(h,c))},toNamespacedPath(v){if(typeof v!="string")return v;if(v.length===0)return"";const o=e.win32.resolve(v);if(o.length<=2)return v;if(o.charCodeAt(0)===y){if(o.charCodeAt(1)===y){const a=o.charCodeAt(2);if(a!==w&&a!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(C(o.charCodeAt(0))&&o.charCodeAt(1)===n&&o.charCodeAt(2)===y)return`\\\\?\\${o}`;return v},dirname(v){m(v,"path");const o=v.length;if(o===0)return".";let a=-1,t=0;const r=v.charCodeAt(0);if(o===1)return u(r)?v:".";if(u(r)){if(a=t=1,u(v.charCodeAt(1))){let h=2,c=h;for(;h<o&&!u(v.charCodeAt(h));)h++;if(h<o&&h!==c){for(c=h;h<o&&u(v.charCodeAt(h));)h++;if(h<o&&h!==c){for(c=h;h<o&&!u(v.charCodeAt(h));)h++;if(h===o)return v;h!==c&&(a=t=h+1)}}}}else C(r)&&v.charCodeAt(1)===n&&(a=o>2&&u(v.charCodeAt(2))?3:2,t=a);let i=-1,s=!0;for(let h=o-1;h>=t;--h)if(u(v.charCodeAt(h))){if(!s){i=h;break}}else s=!1;if(i===-1){if(a===-1)return".";i=a}return v.slice(0,i)},basename(v,o){o!==void 0&&m(o,"ext"),m(v,"path");let a=0,t=-1,r=!0,i;if(v.length>=2&&C(v.charCodeAt(0))&&v.charCodeAt(1)===n&&(a=2),o!==void 0&&o.length>0&&o.length<=v.length){if(o===v)return"";let s=o.length-1,h=-1;for(i=v.length-1;i>=a;--i){const c=v.charCodeAt(i);if(u(c)){if(!r){a=i+1;break}}else h===-1&&(r=!1,h=i+1),s>=0&&(c===o.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=h))}return a===t?t=h:t===-1&&(t=v.length),v.slice(a,t)}for(i=v.length-1;i>=a;--i)if(u(v.charCodeAt(i))){if(!r){a=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":v.slice(a,t)},extname(v){m(v,"path");let o=0,a=-1,t=0,r=-1,i=!0,s=0;v.length>=2&&v.charCodeAt(1)===n&&C(v.charCodeAt(0))&&(o=t=2);for(let h=v.length-1;h>=o;--h){const c=v.charCodeAt(h);if(u(c)){if(!i){t=h+1;break}continue}r===-1&&(i=!1,r=h+1),c===P?a===-1?a=h:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||r===-1||s===0||s===1&&a===r-1&&a===t+1?"":v.slice(a,r)},format:D.bind(null,"\\"),parse(v){m(v,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return o;const a=v.length;let t=0,r=v.charCodeAt(0);if(a===1)return u(r)?(o.root=o.dir=v,o):(o.base=o.name=v,o);if(u(r)){if(t=1,u(v.charCodeAt(1))){let S=2,d=S;for(;S<a&&!u(v.charCodeAt(S));)S++;if(S<a&&S!==d){for(d=S;S<a&&u(v.charCodeAt(S));)S++;if(S<a&&S!==d){for(d=S;S<a&&!u(v.charCodeAt(S));)S++;S===a?t=S:S!==d&&(t=S+1)}}}}else if(C(r)&&v.charCodeAt(1)===n){if(a<=2)return o.root=o.dir=v,o;if(t=2,u(v.charCodeAt(2))){if(a===3)return o.root=o.dir=v,o;t=3}}t>0&&(o.root=v.slice(0,t));let i=-1,s=t,h=-1,c=!0,l=v.length-1,f=0;for(;l>=t;--l){if(r=v.charCodeAt(l),u(r)){if(!c){s=l+1;break}continue}h===-1&&(c=!1,h=l+1),r===P?i===-1?i=l:f!==1&&(f=1):i!==-1&&(f=-1)}return h!==-1&&(i===-1||f===0||f===1&&i===h-1&&i===s+1?o.base=o.name=v.slice(s,h):(o.name=v.slice(s,i),o.base=v.slice(s,h),o.ext=v.slice(i,h))),s>0&&s!==t?o.dir=v.slice(0,s-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...v){let o="",a=!1;for(let t=v.length-1;t>=-1&&!a;t--){const r=t>=0?v[t]:E.cwd();m(r,"path"),r.length!==0&&(o=`${r}/${o}`,a=r.charCodeAt(0)===p)}return o=b(o,!a,"/",I),a?`/${o}`:o.length>0?o:"."},normalize(v){if(m(v,"path"),v.length===0)return".";const o=v.charCodeAt(0)===p,a=v.charCodeAt(v.length-1)===p;return v=b(v,!o,"/",I),v.length===0?o?"/":a?"./":".":(a&&(v+="/"),o?`/${v}`:v)},isAbsolute(v){return m(v,"path"),v.length>0&&v.charCodeAt(0)===p},join(...v){if(v.length===0)return".";let o;for(let a=0;a<v.length;++a){const t=v[a];m(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(v,o){if(m(v,"from"),m(o,"to"),v===o||(v=e.posix.resolve(v),o=e.posix.resolve(o),v===o))return"";const a=1,t=v.length,r=t-a,i=1,s=o.length-i,h=r<s?r:s;let c=-1,l=0;for(;l<h;l++){const S=v.charCodeAt(a+l);if(S!==o.charCodeAt(i+l))break;S===p&&(c=l)}if(l===h)if(s>h){if(o.charCodeAt(i+l)===p)return o.slice(i+l+1);if(l===0)return o.slice(i+l)}else r>h&&(v.charCodeAt(a+l)===p?c=l:l===0&&(c=0));let f="";for(l=a+c+1;l<=t;++l)(l===t||v.charCodeAt(l)===p)&&(f+=f.length===0?"..":"/..");return`${f}${o.slice(i+c)}`},toNamespacedPath(v){return v},dirname(v){if(m(v,"path"),v.length===0)return".";const o=v.charCodeAt(0)===p;let a=-1,t=!0;for(let r=v.length-1;r>=1;--r)if(v.charCodeAt(r)===p){if(!t){a=r;break}}else t=!1;return a===-1?o?"/":".":o&&a===1?"//":v.slice(0,a)},basename(v,o){o!==void 0&&m(o,"ext"),m(v,"path");let a=0,t=-1,r=!0,i;if(o!==void 0&&o.length>0&&o.length<=v.length){if(o===v)return"";let s=o.length-1,h=-1;for(i=v.length-1;i>=0;--i){const c=v.charCodeAt(i);if(c===p){if(!r){a=i+1;break}}else h===-1&&(r=!1,h=i+1),s>=0&&(c===o.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=h))}return a===t?t=h:t===-1&&(t=v.length),v.slice(a,t)}for(i=v.length-1;i>=0;--i)if(v.charCodeAt(i)===p){if(!r){a=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":v.slice(a,t)},extname(v){m(v,"path");let o=-1,a=0,t=-1,r=!0,i=0;for(let s=v.length-1;s>=0;--s){const h=v.charCodeAt(s);if(h===p){if(!r){a=s+1;break}continue}t===-1&&(r=!1,t=s+1),h===P?o===-1?o=s:i!==1&&(i=1):o!==-1&&(i=-1)}return o===-1||t===-1||i===0||i===1&&o===t-1&&o===a+1?"":v.slice(o,t)},format:D.bind(null,"/"),parse(v){m(v,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return o;const a=v.charCodeAt(0)===p;let t;a?(o.root="/",t=1):t=0;let r=-1,i=0,s=-1,h=!0,c=v.length-1,l=0;for(;c>=t;--c){const f=v.charCodeAt(c);if(f===p){if(!h){i=c+1;break}continue}s===-1&&(h=!1,s=c+1),f===P?r===-1?r=c:l!==1&&(l=1):r!==-1&&(l=-1)}if(s!==-1){const f=i===0&&a?1:i;r===-1||l===0||l===1&&r===s-1&&r===i+1?o.base=o.name=v.slice(f,s):(o.name=v.slice(f,r),o.base=v.slice(f,s),o.ext=v.slice(r,s))}return i>0?o.dir=v.slice(0,i-1):a&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var R in E)(typeof exports=="object"?exports:K)[R]=E[R]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function E(R){if(e[R])return e[R].exports;var L=e[R]={i:R,l:!1,exports:{}};return K[R].call(L.exports,L,L.exports,E),L.l=!0,L.exports}return E.m=K,E.c=e,E.d=function(R,L,k){E.o(R,L)||Object.defineProperty(R,L,{enumerable:!0,get:k})},E.r=function(R){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},E.t=function(R,L){if(1&L&&(R=E(R)),8&L||4&L&&typeof R=="object"&&R&&R.__esModule)return R;var k=Object.create(null);if(E.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:R}),2&L&&typeof R!="string")for(var A in R)E.d(k,A,function(P){return R[P]}.bind(null,A));return k},E.n=function(R){var L=R&&R.__esModule?function(){return R.default}:function(){return R};return E.d(L,"a",L),L},E.o=function(R,L){return Object.prototype.hasOwnProperty.call(R,L)},E.p="",E(E.s=0)}([function(K,e,E){(function(R){var L;e=K.exports=Q,L=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],p=e.src=[],y=0,n=y++;p[n]="0|[1-9]\\d*";var w=y++;p[w]="[0-9]+";var g=y++;p[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=y++;p[m]="("+p[n]+")\\.("+p[n]+")\\.("+p[n]+")";var u=y++;p[u]="("+p[w]+")\\.("+p[w]+")\\.("+p[w]+")";var I=y++;p[I]="(?:"+p[n]+"|"+p[g]+")";var C=y++;p[C]="(?:"+p[w]+"|"+p[g]+")";var b=y++;p[b]="(?:-("+p[I]+"(?:\\."+p[I]+")*))";var D=y++;p[D]="(?:-?("+p[C]+"(?:\\."+p[C]+")*))";var v=y++;p[v]="[0-9A-Za-z-]+";var o=y++;p[o]="(?:\\+("+p[v]+"(?:\\."+p[v]+")*))";var a=y++,t="v?"+p[m]+p[b]+"?"+p[o]+"?";p[a]="^"+t+"$";var r="[v=\\s]*"+p[u]+p[D]+"?"+p[o]+"?",i=y++;p[i]="^"+r+"$";var s=y++;p[s]="((?:<|>)?=?)";var h=y++;p[h]=p[w]+"|x|X|\\*";var c=y++;p[c]=p[n]+"|x|X|\\*";var l=y++;p[l]="[v=\\s]*("+p[c]+")(?:\\.("+p[c]+")(?:\\.("+p[c]+")(?:"+p[b]+")?"+p[o]+"?)?)?";var f=y++;p[f]="[v=\\s]*("+p[h]+")(?:\\.("+p[h]+")(?:\\.("+p[h]+")(?:"+p[D]+")?"+p[o]+"?)?)?";var S=y++;p[S]="^"+p[s]+"\\s*"+p[l]+"$";var d=y++;p[d]="^"+p[s]+"\\s*"+p[f]+"$";var T=y++;p[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=y++;p[O]="(?:~>?)";var x=y++;p[x]="(\\s*)"+p[O]+"\\s+",P[x]=new RegExp(p[x],"g");var z=y++;p[z]="^"+p[O]+p[l]+"$";var H=y++;p[H]="^"+p[O]+p[f]+"$";var V=y++;p[V]="(?:\\^)";var U=y++;p[U]="(\\s*)"+p[V]+"\\s+",P[U]=new RegExp(p[U],"g");var $=y++;p[$]="^"+p[V]+p[l]+"$";var M=y++;p[M]="^"+p[V]+p[f]+"$";var N=y++;p[N]="^"+p[s]+"\\s*("+r+")$|^$";var q=y++;p[q]="^"+p[s]+"\\s*("+t+")$|^$";var F=y++;p[F]="(\\s*)"+p[s]+"\\s*("+r+"|"+p[l]+")",P[F]=new RegExp(p[F],"g");var j=y++;p[j]="^\\s*("+p[l]+")\\s+-\\s+("+p[l]+")\\s*$";var _=y++;p[_]="^\\s*("+p[f]+")\\s+-\\s+("+p[f]+")\\s*$";var G=y++;p[G]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)L(B,p[B]),P[B]||(P[B]=new RegExp(p[B]));function X(J,re){if(J instanceof Q)return J;if(typeof J!="string"||J.length>k||!(re?P[i]:P[a]).test(J))return null;try{return new Q(J,re)}catch(se){return null}}function Q(J,re){if(J instanceof Q){if(J.loose===re)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof Q))return new Q(J,re);L("SemVer",J,re),this.loose=re;var se=J.trim().match(re?P[i]:P[a]);if(!se)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var me=+pe;if(me>=0&&me<A)return me}return pe}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=X,e.valid=function(J,re){var se=X(J,re);return se?se.version:null},e.clean=function(J,re){var se=X(J.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(J){return L("SemVer.compare",this.version,this.loose,J),J instanceof Q||(J=new Q(J,this.loose)),this.compareMain(J)||this.comparePre(J)},Q.prototype.compareMain=function(J){return J instanceof Q||(J=new Q(J,this.loose)),ne(this.major,J.major)||ne(this.minor,J.minor)||ne(this.patch,J.patch)},Q.prototype.comparePre=function(J){if(J instanceof Q||(J=new Q(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],pe=J.prerelease[re];if(L("prerelease compare",re,se,pe),se===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(se===void 0)return-1;if(se!==pe)return ne(se,pe)}while(++re)},Q.prototype.inc=function(J,re){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,re,se,pe){typeof se=="string"&&(pe=se,se=void 0);try{return new Q(J,se).inc(re,pe).version}catch(me){return null}},e.diff=function(J,re){if(Se(J,re))return null;var se=X(J),pe=X(re);if(se.prerelease.length||pe.prerelease.length){for(var me in se)if((me==="major"||me==="minor"||me==="patch")&&se[me]!==pe[me])return"pre"+me;return"prerelease"}for(var me in se)if((me==="major"||me==="minor"||me==="patch")&&se[me]!==pe[me])return me},e.compareIdentifiers=ne;var ie=/^[0-9]+$/;function ne(J,re){var se=ie.test(J),pe=ie.test(re);return se&&pe&&(J=+J,re=+re),se&&!pe?-1:pe&&!se?1:J<re?-1:J>re?1:0}function le(J,re,se){return new Q(J,se).compare(new Q(re,se))}function fe(J,re,se){return le(J,re,se)>0}function ye(J,re,se){return le(J,re,se)<0}function Se(J,re,se){return le(J,re,se)===0}function Pe(J,re,se){return le(J,re,se)!==0}function Te(J,re,se){return le(J,re,se)>=0}function Ne(J,re,se){return le(J,re,se)<=0}function Oe(J,re,se,pe){var me;switch(re){case"===":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),me=J===se;break;case"!==":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),me=J!==se;break;case"":case"=":case"==":me=Se(J,se,pe);break;case"!=":me=Pe(J,se,pe);break;case">":me=fe(J,se,pe);break;case">=":me=Te(J,se,pe);break;case"<":me=ye(J,se,pe);break;case"<=":me=Ne(J,se,pe);break;default:throw new TypeError("Invalid operator: "+re)}return me}function Ae(J,re){if(J instanceof Ae){if(J.loose===re)return J;J=J.value}if(!(this instanceof Ae))return new Ae(J,re);L("comparator",J,re),this.loose=re,this.parse(J),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(J,re){return ne(re,J)},e.major=function(J,re){return new Q(J,re).major},e.minor=function(J,re){return new Q(J,re).minor},e.patch=function(J,re){return new Q(J,re).patch},e.compare=le,e.compareLoose=function(J,re){return le(J,re,!0)},e.rcompare=function(J,re,se){return le(re,J,se)},e.sort=function(J,re){return J.sort(function(se,pe){return e.compare(se,pe,re)})},e.rsort=function(J,re){return J.sort(function(se,pe){return e.rcompare(se,pe,re)})},e.gt=fe,e.lt=ye,e.eq=Se,e.neq=Pe,e.gte=Te,e.lte=Ne,e.cmp=Oe,e.Comparator=Ae;var _e={};function Ie(J,re){if(J instanceof Ie)return J.loose===re?J:new Ie(J.raw,re);if(J instanceof Ae)return new Ie(J.value,re);if(!(this instanceof Ie))return new Ie(J,re);if(this.loose=re,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function ke(J){return!J||J.toLowerCase()==="x"||J==="*"}function Ye(J,re,se,pe,me,De,we,Re,be,Le,Ue,W,te){return((re=ke(se)?"":ke(pe)?">="+se+".0.0":ke(me)?">="+se+"."+pe+".0":">="+re)+" "+(Re=ke(be)?"":ke(Le)?"<"+(+be+1)+".0.0":ke(Ue)?"<"+be+"."+(+Le+1)+".0":W?"<="+be+"."+Le+"."+Ue+"-"+W:"<="+Re)).trim()}function Je(J,re){for(var se=0;se<J.length;se++)if(!J[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<J.length;se++)if(L(J[se].semver),J[se].semver!==_e&&J[se].semver.prerelease.length>0){var pe=J[se].semver;if(pe.major===re.major&&pe.minor===re.minor&&pe.patch===re.patch)return!0}return!1}return!0}function ze(J,re,se){try{re=new Ie(re,se)}catch(pe){return!1}return re.test(J)}function $e(J,re,se,pe){var me,De,we,Re,be;switch(J=new Q(J,pe),re=new Ie(re,pe),se){case">":me=fe,De=Ne,we=ye,Re=">",be=">=";break;case"<":me=ye,De=Te,we=fe,Re="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(J,re,pe))return!1;for(var Le=0;Le<re.set.length;++Le){var Ue=re.set[Le],W=null,te=null;if(Ue.forEach(function(ae){ae.semver===_e&&(ae=new Ae(">=0.0.0")),W=W||ae,te=te||ae,me(ae.semver,W.semver,pe)?W=ae:we(ae.semver,te.semver,pe)&&(te=ae)}),W.operator===Re||W.operator===be||(!te.operator||te.operator===Re)&&De(J,te.semver)||te.operator===be&&we(J,te.semver))return!1}return!0}Ae.prototype.parse=function(J){var re=this.loose?P[N]:P[q],se=J.match(re);if(!se)throw new TypeError("Invalid comparator: "+J);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new Q(se[2],this.loose):this.semver=_e},Ae.prototype.toString=function(){return this.value},Ae.prototype.test=function(J){return L("Comparator.test",J,this.loose),this.semver===_e||(typeof J=="string"&&(J=new Q(J,this.loose)),Oe(J,this.operator,this.semver,this.loose))},Ae.prototype.intersects=function(J,re){if(!(J instanceof Ae))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new Ie(J.value,re),ze(this.value,se,re);if(J.operator==="")return se=new Ie(this.value,re),ze(J.semver,se,re);var pe=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),De=this.semver.version===J.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Re=Oe(this.semver,"<",J.semver,re)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),be=Oe(this.semver,">",J.semver,re)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return pe||me||De&&we||Re||be},e.Range=Ie,Ie.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},Ie.prototype.toString=function(){return this.range},Ie.prototype.parseRange=function(J){var re=this.loose;J=J.trim(),L("range",J,re);var se=re?P[_]:P[j];J=J.replace(se,Ye),L("hyphen replace",J),J=J.replace(P[F],"$1$2$3"),L("comparator trim",J,P[F]),J=(J=(J=J.replace(P[x],"$1~")).replace(P[U],"$1^")).split(/\s+/).join(" ");var pe=re?P[N]:P[q],me=J.split(" ").map(function(De){return function(we,Re){return L("comp",we),we=function(be,Le){return be.trim().split(/\s+/).map(function(Ue){return function(W,te){L("caret",W,te);var ae=te?P[M]:P[$];return W.replace(ae,function(ce,oe,he,ge,ve){var ue;return L("caret",W,ce,oe,he,ge,ve),ke(oe)?ue="":ke(he)?ue=">="+oe+".0.0 <"+(+oe+1)+".0.0":ke(ge)?ue=oe==="0"?">="+oe+"."+he+".0 <"+oe+"."+(+he+1)+".0":">="+oe+"."+he+".0 <"+(+oe+1)+".0.0":ve?(L("replaceCaret pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),ue=oe==="0"?he==="0"?">="+oe+"."+he+"."+ge+ve+" <"+oe+"."+he+"."+(+ge+1):">="+oe+"."+he+"."+ge+ve+" <"+oe+"."+(+he+1)+".0":">="+oe+"."+he+"."+ge+ve+" <"+(+oe+1)+".0.0"):(L("no pr"),ue=oe==="0"?he==="0"?">="+oe+"."+he+"."+ge+" <"+oe+"."+he+"."+(+ge+1):">="+oe+"."+he+"."+ge+" <"+oe+"."+(+he+1)+".0":">="+oe+"."+he+"."+ge+" <"+(+oe+1)+".0.0"),L("caret return",ue),ue})}(Ue,Le)}).join(" ")}(we,Re),L("caret",we),we=function(be,Le){return be.trim().split(/\s+/).map(function(Ue){return function(W,te){var ae=te?P[H]:P[z];return W.replace(ae,function(ce,oe,he,ge,ve){var ue;return L("tilde",W,ce,oe,he,ge,ve),ke(oe)?ue="":ke(he)?ue=">="+oe+".0.0 <"+(+oe+1)+".0.0":ke(ge)?ue=">="+oe+"."+he+".0 <"+oe+"."+(+he+1)+".0":ve?(L("replaceTilde pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),ue=">="+oe+"."+he+"."+ge+ve+" <"+oe+"."+(+he+1)+".0"):ue=">="+oe+"."+he+"."+ge+" <"+oe+"."+(+he+1)+".0",L("tilde return",ue),ue})}(Ue,Le)}).join(" ")}(we,Re),L("tildes",we),we=function(be,Le){return L("replaceXRanges",be,Le),be.split(/\s+/).map(function(Ue){return function(W,te){W=W.trim();var ae=te?P[d]:P[S];return W.replace(ae,function(ce,oe,he,ge,ve,ue){L("xRange",W,ce,oe,he,ge,ve,ue);var Ee=ke(he),Ce=Ee||ke(ge),Fe=Ce||ke(ve);return oe==="="&&Fe&&(oe=""),Ee?ce=oe===">"||oe==="<"?"<0.0.0":"*":oe&&Fe?(Ce&&(ge=0),Fe&&(ve=0),oe===">"?(oe=">=",Ce?(he=+he+1,ge=0,ve=0):Fe&&(ge=+ge+1,ve=0)):oe==="<="&&(oe="<",Ce?he=+he+1:ge=+ge+1),ce=oe+he+"."+ge+"."+ve):Ce?ce=">="+he+".0.0 <"+(+he+1)+".0.0":Fe&&(ce=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0"),L("xRange return",ce),ce})}(Ue,Le)}).join(" ")}(we,Re),L("xrange",we),we=function(be,Le){return L("replaceStars",be,Le),be.trim().replace(P[G],"")}(we,Re),L("stars",we),we}(De,re)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(De){return!!De.match(pe)})),me=me.map(function(De){return new Ae(De,re)})},Ie.prototype.intersects=function(J,re){if(!(J instanceof Ie))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(pe){return J.set.some(function(me){return me.every(function(De){return pe.intersects(De,re)})})})})},e.toComparators=function(J,re){return new Ie(J,re).set.map(function(se){return se.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},Ie.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new Q(J,this.loose));for(var re=0;re<this.set.length;re++)if(Je(this.set[re],J))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(J,re,se){var pe=null,me=null;try{var De=new Ie(re,se)}catch(we){return null}return J.forEach(function(we){De.test(we)&&(pe&&me.compare(we)!==-1||(me=new Q(pe=we,se)))}),pe},e.minSatisfying=function(J,re,se){var pe=null,me=null;try{var De=new Ie(re,se)}catch(we){return null}return J.forEach(function(we){De.test(we)&&(pe&&me.compare(we)!==1||(me=new Q(pe=we,se)))}),pe},e.validRange=function(J,re){try{return new Ie(J,re).range||"*"}catch(se){return null}},e.ltr=function(J,re,se){return $e(J,re,"<",se)},e.gtr=function(J,re,se){return $e(J,re,">",se)},e.outside=$e,e.prerelease=function(J,re){var se=X(J,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(J,re,se){return J=new Ie(J,se),re=new Ie(re,se),J.intersects(re)},e.coerce=function(J){if(J instanceof Q)return J;if(typeof J!="string")return null;var re=J.match(P[T]);return re==null?null:X((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,E(1))},function(K,e){var E,R,L=K.exports={};function k(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(C){if(E===setTimeout)return setTimeout(C,0);if((E===k||!E)&&setTimeout)return E=setTimeout,setTimeout(C,0);try{return E(C,0)}catch(b){try{return E.call(null,C,0)}catch(D){return E.call(this,C,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:k}catch(C){E=k}try{R=typeof clearTimeout=="function"?clearTimeout:A}catch(C){R=A}})();var p,y=[],n=!1,w=-1;function g(){n&&p&&(n=!1,p.length?y=p.concat(y):w=-1,y.length&&m())}function m(){if(!n){var C=P(g);n=!0;for(var b=y.length;b;){for(p=y,y=[];++w<b;)p&&p[w].run();w=-1,b=y.length}p=null,n=!1,function(D){if(R===clearTimeout)return clearTimeout(D);if((R===A||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(D);try{R(D)}catch(v){try{return R.call(null,D)}catch(o){return R.call(this,D)}}}(C)}}function u(C,b){this.fun=C,this.array=b}function I(){}L.nextTick=function(C){var b=new Array(arguments.length-1);if(arguments.length>1)for(var D=1;D<arguments.length;D++)b[D-1]=arguments[D];y.push(new u(C,b)),y.length!==1||n||P(m)},u.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=I,L.addListener=I,L.once=I,L.off=I,L.removeListener=I,L.removeAllListeners=I,L.emit=I,L.prependListener=I,L.prependOnceListener=I,L.listeners=function(C){return[]},L.binding=function(C){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(C){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(Z[92],ee([0,1,4]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=E.globals.performance&&typeof E.globals.performance.now=="function";class L{constructor(A){this._highResolution=R&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new L(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=L}),define(Z[3],ee([0,1,11,65,2,91,92]),function(K,e,E,R,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(v){v.None=()=>L.Disposable.None;function o(V){return(U,$=null,M)=>{let N=!1,q;return q=V(F=>{if(!N)return q?q.dispose():N=!0,U.call($,F)},null,M),N&&q.dispose(),q}}v.once=o;function a(V,U){return c(($,M=null,N)=>V(q=>$.call(M,U(q)),null,N))}v.map=a;function t(V,U){return c(($,M=null,N)=>V(q=>{U(q),$.call(M,q)},null,N))}v.forEach=t;function r(V,U){return c(($,M=null,N)=>V(q=>U(q)&&$.call(M,q),null,N))}v.filter=r;function i(V){return V}v.signal=i;function s(...V){return(U,$=null,M)=>(0,L.combinedDisposable)(...V.map(N=>N(q=>U.call($,q),null,M)))}v.any=s;function h(V,U,$){let M=$;return a(V,N=>(M=U(M,N),M))}v.reduce=h;function c(V){let U;const $=new g({onFirstListenerAdd(){U=V($.fire,$)},onLastListenerRemove(){U.dispose()}});return $.event}function l(V,U,$=100,M=!1,N){let q,F,j,_=0;const G=new g({leakWarningThreshold:N,onFirstListenerAdd(){q=V(B=>{_++,F=U(F,B),M&&!j&&(G.fire(F),F=void 0),clearTimeout(j),j=setTimeout(()=>{const X=F;F=void 0,j=void 0,(!M||_>1)&&G.fire(X),_=0},$)})},onLastListenerRemove(){q.dispose()}});return G.event}v.debounce=l;function f(V,U=($,M)=>$===M){let $=!0,M;return r(V,N=>{const q=$||!U(N,M);return $=!1,M=N,q})}v.latch=f;function S(V,U){return[v.filter(V,U),v.filter(V,$=>!U($))]}v.split=S;function d(V,U=!1,$=[]){let M=$.slice(),N=V(j=>{M?M.push(j):F.fire(j)});const q=()=>{M&&M.forEach(j=>F.fire(j)),M=null},F=new g({onFirstListenerAdd(){N||(N=V(j=>F.fire(j)))},onFirstListenerDidAdd(){M&&(U?setTimeout(q):q())},onLastListenerRemove(){N&&N.dispose(),N=null}});return F.event}v.buffer=d;class T{constructor(U){this.event=U}map(U){return new T(a(this.event,U))}forEach(U){return new T(t(this.event,U))}filter(U){return new T(r(this.event,U))}reduce(U,$){return new T(h(this.event,U,$))}latch(){return new T(f(this.event))}debounce(U,$=100,M=!1,N){return new T(l(this.event,U,$,M,N))}on(U,$,M){return this.event(U,$,M)}once(U,$,M){return o(this.event)(U,$,M)}}function O(V){return new T(V)}v.chain=O;function x(V,U,$=M=>M){const M=(...j)=>F.fire($(...j)),N=()=>V.on(U,M),q=()=>V.removeListener(U,M),F=new g({onFirstListenerAdd:N,onLastListenerRemove:q});return F.event}v.fromNodeEventEmitter=x;function z(V,U,$=M=>M){const M=(...j)=>F.fire($(...j)),N=()=>V.addEventListener(U,M),q=()=>V.removeEventListener(U,M),F=new g({onFirstListenerAdd:N,onLastListenerRemove:q});return F.event}v.fromDOMEventEmitter=z;function H(V){return new Promise(U=>o(V)(U))}v.toPromise=H})(P=e.Event||(e.Event={}));class p{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${p._idPool++}`}start(o){this._stopWatch=new A.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}p._idPool=0;let y=-1;function n(v){const o=y;return y=v,{dispose(){y=o}}}e.setGlobalLeakWarningThreshold=n;class w{constructor(o,a=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let a=y;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||o<a)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let i,s=0;for(const[h,c]of this._stacks)(!i||s<c)&&(i=h,s=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(t)||0;this._stacks.set(t,i-1)}}}class g{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=y>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new p(this._options._profName):void 0}get event(){return this._event||(this._event=(o,a,t)=>{this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(a?[o,a]:o);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,a);const s=this._leakageMon?.check(this._listeners.size),h=(0,L.toDisposable)(()=>{s&&s(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof L.DisposableStore?t.add(h):Array.isArray(t)&&t.push(h),h}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(r){(0,E.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=g;class m extends g{async fireAsync(o,a,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,o]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),s=[],h={...i,waitUntil:c=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");t&&(c=t(c,typeof r=="function"?r:r[0])),s.push(c)}};try{typeof r=="function"?r.call(void 0,h):r[0].call(r[1],h)}catch(c){(0,E.onUnexpectedError)(c);continue}Object.freeze(s),await Promise.allSettled(s).then(c=>{for(const l of c)l.status==="rejected"&&(0,E.onUnexpectedError)(l.reason)})}}}}e.AsyncEmitter=m;class u extends g{constructor(o){super(o);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=u;class I extends u{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=I;class C{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const a={event:o,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const t=()=>{this.hasListeners&&this.unhook(a);const r=this.events.indexOf(a);this.events.splice(r,1)};return(0,L.toDisposable)((0,R.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(a=>this.emitter.fire(a))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=C;class b{constructor(){this.buffers=[]}wrapEvent(o){return(a,t,r)=>o(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>a.call(t,i)):a.call(t,i)},void 0,r)}bufferEvents(o){const a=[];this.buffers.push(a);const t=o();return this.buffers.pop(),a.forEach(r=>r()),t}}e.EventBufferer=b;class D{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=L.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D}),define(Z[29],ee([0,1,3]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(P,p){const y=setTimeout(P.bind(p),0);return{dispose(){clearTimeout(y)}}});var L;(function(P){function p(y){return y===P.None||y===P.Cancelled||y instanceof k?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}P.isCancellationToken=p,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(L=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=L.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=A}),define(Z[48],ee([0,1,3]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new E.Emitter}add(w){const g=this._icons.get(w.id);g?w.description?g.description=w.description:console.error(`Duplicate registration of codicon ${w.id}`):(this._icons.set(w.id,w),this._onDidRegister.fire(w))}get(w){return this._icons.get(w)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const L=new R;e.iconRegistry=L;function k(n,w){return new P(n,w)}e.registerCodicon=k;function A(n){return n?n.replace(/\$\((.*?)\)/g,(w,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=A;class P{constructor(w,g,m){this.id=w,this.definition=g,this.description=m,L.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function p(n,w){const g=["codicon","codicon-"+n];return w&&g.push("codicon-modifier-"+w),g}e.getClassNamesArray=p;var y;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const w=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function g(I){if(I instanceof P)return["codicon","codicon-"+I.id];const C=w.exec(I.id);if(!C)return g(P.error);let[,b,D]=C;const v=["codicon","codicon-"+b];return D&&v.push("codicon-modifier-"+D.substr(1)),v}n.asClassNameArray=g;function m(I){return g(I).join(" ")}n.asClassName=m;function u(I){return"."+g(I).join(".")}n.asCSSSelector=u})(y=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(Z[49],ee([0,1,11,2]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(v){const o=v;return o?[o.on,o.pause,o.resume,o.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=L;function k(v){const o=v;return o?L(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=k;function A(v,o){return new P(v,o)}e.newWriteableStream=A;class P{constructor(o,a){this.reducer=o,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(a=>a(o))}emitError(o){this.listeners.error.length===0?(0,E.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(a=>a(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,a){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(o,a){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(a);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(v,o){const a=[];let t;for(;(t=v.read())!==null;)a.push(t);return o(a)}e.consumeReadable=p;function y(v,o,a){const t=[];let r;for(;(r=v.read())!==null&&t.length<a;)t.push(r);return r===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return v.read()}}}e.peekReadable=y;function n(v,o){return new Promise((a,t)=>{const r=[];w(v,{onData:i=>{o&&r.push(i)},onError:i=>{o?t(i):a(void 0)},onEnd:()=>{a(o?o(r):void 0)}})})}e.consumeStream=n;function w(v,o){v.on("error",a=>o.onError(a)),v.on("end",()=>o.onEnd()),v.on("data",a=>o.onData(a))}e.listenStream=w;function g(v,o){return new Promise((a,t)=>{const r=new R.DisposableStore,i=[],s=l=>{if(i.push(l),i.length>o)return r.dispose(),v.pause(),a({stream:v,buffer:i,ended:!1})},h=l=>t(l),c=()=>a({stream:v,buffer:i,ended:!0});r.add((0,R.toDisposable)(()=>v.removeListener("error",h))),v.on("error",h),r.add((0,R.toDisposable)(()=>v.removeListener("end",c))),v.on("end",c),r.add((0,R.toDisposable)(()=>v.removeListener("data",s))),v.on("data",s)})}e.peekStream=g;function m(v,o){const a=A(o);return a.end(v),a}e.toStream=m;function u(){const v=A(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=u;function I(v){let o=!1;return{read:()=>o?null:(o=!0,v)}}e.toReadable=I;function C(v,o,a){const t=A(a);return w(v,{onData:r=>t.write(o.data(r)),onError:r=>t.error(o.error?o.error(r):r),onEnd:()=>t.end()}),t}e.transform=C;function b(v,o,a){let t=!1;return{read:()=>{const r=o.read();return t?r:(t=!0,r!==null?a([v,r]):v)}}}e.prefixedReadable=b;function D(v,o,a){let t=!1;const r=A(a);return w(o,{onData:i=>t?r.write(i):(t=!0,r.write(a([v,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(v)),r.end()}}),r}e.prefixedStream=D}),define(Z[19],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function E(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=E;const R=/{(\d+)}/g;function L(W,...te){return te.length===0?W:W.replace(R,function(ae,ce){const oe=parseInt(ce,10);return isNaN(oe)||oe<0||oe>=te.length?ae:te[oe]})}e.format=L;const k=/{([^}]+)}/g;function A(W,te){return W.replace(k,(ae,ce)=>te[ce]??ae)}e.format2=A;function P(W){return W.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=P;function p(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=p;function y(W,te){let ae=0;const ce=te.charCodeAt(0);for(let oe=W.length-1;oe>=0;oe--)W.charCodeAt(oe)===ce&&ae++;return ae}e.count=y;function n(W,te,ae="\u2026"){return W.length<=te?W:`${W.substr(0,te)}${ae}`}e.truncate=n;function w(W,te=" "){const ae=g(W,te);return m(ae,te)}e.trim=w;function g(W,te){if(!W||!te)return W;const ae=te.length;if(ae===0||W.length===0)return W;let ce=0;for(;W.indexOf(te,ce)===ce;)ce=ce+ae;return W.substring(ce)}e.ltrim=g;function m(W,te){if(!W||!te)return W;const ae=te.length,ce=W.length;if(ae===0||ce===0)return W;let oe=ce,he=-1;for(;he=W.lastIndexOf(te,oe-1),!(he===-1||he+ae!==oe);){if(he===0)return"";oe=he}return W.substring(0,oe)}e.rtrim=m;function u(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function I(W){return W.replace(/\*/g,"")}e.stripWildcards=I;function C(W,te,ae={}){if(!W)throw new Error("Cannot create regex from empty string");te||(W=p(W)),ae.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(W,ce)}e.createRegExp=C;function b(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function D(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function v(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=v;function o(W){return W.split(/\r\n|\r|\n/)}e.splitLines=o;function a(W){for(let te=0,ae=W.length;te<ae;te++){const ce=W.charCodeAt(te);if(ce!==32&&ce!==9)return te}return-1}e.firstNonWhitespaceIndex=a;function t(W,te=0,ae=W.length){for(let ce=te;ce<ae;ce++){const oe=W.charCodeAt(ce);if(oe!==32&&oe!==9)return W.substring(te,ce)}return W.substring(te,ae)}e.getLeadingWhitespace=t;function r(W,te=W.length-1){for(let ae=te;ae>=0;ae--){const ce=W.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=r;function i(W,te){return W<te?-1:W>te?1:0}e.compare=i;function s(W,te,ae=0,ce=W.length,oe=0,he=te.length){for(;ae<ce&&oe<he;ae++,oe++){let ue=W.charCodeAt(ae),Ee=te.charCodeAt(oe);if(ue<Ee)return-1;if(ue>Ee)return 1}const ge=ce-ae,ve=he-oe;return ge<ve?-1:ge>ve?1:0}e.compareSubstring=s;function h(W,te){return c(W,te,0,W.length,0,te.length)}e.compareIgnoreCase=h;function c(W,te,ae=0,ce=W.length,oe=0,he=te.length){for(;ae<ce&&oe<he;ae++,oe++){let ue=W.charCodeAt(ae),Ee=te.charCodeAt(oe);if(ue===Ee)continue;const Ce=ue-Ee;if(!(Ce===32&&f(Ee))&&!(Ce===-32&&f(ue)))return l(ue)&&l(Ee)?Ce:s(W.toLowerCase(),te.toLowerCase(),ae,ce,oe,he)}const ge=ce-ae,ve=he-oe;return ge<ve?-1:ge>ve?1:0}e.compareSubstringIgnoreCase=c;function l(W){return W>=97&&W<=122}e.isLowerAsciiLetter=l;function f(W){return W>=65&&W<=90}e.isUpperAsciiLetter=f;function S(W){return l(W)||f(W)}function d(W,te){return W.length===te.length&&T(W,te)}e.equalsIgnoreCase=d;function T(W,te,ae=W.length){for(let ce=0;ce<ae;ce++){const oe=W.charCodeAt(ce),he=te.charCodeAt(ce);if(oe!==he){if(S(oe)&&S(he)){const ge=Math.abs(oe-he);if(ge!==0&&ge!==32)return!1}else if(String.fromCharCode(oe).toLowerCase()!==String.fromCharCode(he).toLowerCase())return!1}}return!0}function O(W,te){const ae=te.length;return te.length>W.length?!1:T(W,te,ae)}e.startsWithIgnoreCase=O;function x(W,te){let ae,ce=Math.min(W.length,te.length);for(ae=0;ae<ce;ae++)if(W.charCodeAt(ae)!==te.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=x;function z(W,te){let ae,ce=Math.min(W.length,te.length);const oe=W.length-1,he=te.length-1;for(ae=0;ae<ce;ae++)if(W.charCodeAt(oe-ae)!==te.charCodeAt(he-ae))return ae;return ce}e.commonSuffixLength=z;function H(W){return 55296<=W&&W<=56319}e.isHighSurrogate=H;function V(W){return 56320<=W&&W<=57343}e.isLowSurrogate=V;function U(W,te){return(W-55296<<10)+(te-56320)+65536}e.computeCodePoint=U;function $(W,te,ae){const ce=W.charCodeAt(ae);if(H(ce)&&ae+1<te){const oe=W.charCodeAt(ae+1);if(V(oe))return U(ce,oe)}return ce}e.getNextCodePoint=$;function M(W,te){const ae=W.charCodeAt(te-1);if(V(ae)&&te>1){const ce=W.charCodeAt(te-2);if(H(ce))return U(ce,ae)}return ae}function N(W,te){const ae=me.getInstance(),ce=te,oe=W.length,he=$(W,oe,te);te+=he>=65536?2:1;let ge=ae.getGraphemeBreakType(he);for(;te<oe;){const ve=$(W,oe,te),ue=ae.getGraphemeBreakType(ve);if(se(ge,ue))break;te+=ve>=65536?2:1,ge=ue}return te-ce}e.nextCharLength=N;function q(W,te){const ae=me.getInstance(),ce=te,oe=M(W,te);te-=oe>=65536?2:1;let he=ae.getGraphemeBreakType(oe);for(;te>0;){const ge=M(W,te),ve=ae.getGraphemeBreakType(ge);if(se(ve,he))break;te-=ge>=65536?2:1,he=ve}return ce-te}e.prevCharLength=q;function F(W,te){const ae=me.getInstance(),ce=W.length,oe=te,he=$(W,ce,te),ge=ae.getGraphemeBreakType(he);te+=he>=65536?2:1;let ve=ge;for(;te<ce;){const Ee=$(W,ce,te),Ce=ae.getGraphemeBreakType(Ee);if(se(ve,Ce))break;te+=Ee>=65536?2:1,ve=Ce}const ue=te;for(te=oe,ve=ge;te>0;){const Ee=M(W,te),Ce=ae.getGraphemeBreakType(Ee);if(se(Ce,ve))break;te-=Ee>=65536?2:1,ve=Ce}return[te,ue]}function j(W,te){return te>0&&V(W.charCodeAt(te))?F(W,te-1):F(W,te)}e.getCharContainingOffset=j;function _(W){const te=W.length;let ae=0,ce=0;for(;ce<te;){const ge=$(W,te,ce);ce+=ge>=65536?2:1,ge<128?ae+=1:ge<2048?ae+=2:ge<65536?ae+=3:ae+=4}const oe=new Uint8Array(ae);ce=0;let he=0;for(;ce<te;){const ge=$(W,te,ce);ce+=ge>=65536?2:1,ge<128?oe[he++]=ge:ge<2048?(oe[he++]=192|(ge&1984)>>>6,oe[he++]=128|(ge&63)>>>0):ge<65536?(oe[he++]=224|(ge&61440)>>>12,oe[he++]=128|(ge&4032)>>>6,oe[he++]=128|(ge&63)>>>0):(oe[he++]=240|(ge&1835008)>>>18,oe[he++]=128|(ge&258048)>>>12,oe[he++]=128|(ge&4032)>>>6,oe[he++]=128|(ge&63)>>>0)}return oe}e.encodeUTF8=_;function G(W){const te=W.byteLength,ae=[];let ce=0;for(;ce<te;){const oe=W[ce];let he;if(oe>=240&&ce+3<te?he=(W[ce++]&7)<<18>>>0|(W[ce++]&63)<<12>>>0|(W[ce++]&63)<<6>>>0|(W[ce++]&63)<<0>>>0:oe>=224&&ce+2<te?he=(W[ce++]&15)<<12>>>0|(W[ce++]&63)<<6>>>0|(W[ce++]&63)<<0>>>0:oe>=192&&ce+1<te?he=(W[ce++]&31)<<6>>>0|(W[ce++]&63)<<0>>>0:he=W[ce++],he>=0&&he<=55295||he>=57344&&he<=65535)ae.push(String.fromCharCode(he));else if(he>=65536&&he<=1114111){const ge=he-65536,ve=55296+((ge&1047552)>>>10),ue=56320+((ge&1023)>>>0);ae.push(String.fromCharCode(ve)),ae.push(String.fromCharCode(ue))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=G;const B=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(W){return B.test(W)}e.containsRTL=X;const Q=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ie(W){return Q.test(W)}e.containsEmoji=ie;const ne=/^[\t\n\r\x20-\x7E]*$/;function le(W){return ne.test(W)}e.isBasicASCII=le,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function fe(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=fe;function ye(W){for(let te=0,ae=W.length;te<ae;te++)if(Se(W.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ye;function Se(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=Se;function Pe(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=Pe;function Te(W,te){if(W.length<te)return W;const ae=/\b/g;let ce=0;for(;ae.test(W)&&!(W.length-ae.lastIndex<te);)ce=ae.lastIndex,ae.lastIndex+=1;return W.substring(ce).replace(/^\s/,"")}e.lcut=Te;const Ne=/\x1B\x5B[12]?K/g,Oe=/\x1b\[\d+m/g,Ae=/\x1b\[0?m/g;function _e(W){return W&&(W=W.replace(Ne,""),W=W.replace(Oe,""),W=W.replace(Ae,"")),W}e.removeAnsiEscapeCodes=_e,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ie(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ie;function ke(W){return Ie(W)?W.substr(1):W}e.stripUTF8BOM=ke;function Ye(W,te){if(!W||!te||W.length<te.length)return!1;const ae=te.length,ce=W.toLowerCase();let oe=0,he=-1;for(;oe<ae;){const ge=ce.indexOf(te[oe],he+1);if(ge<0)return!1;he=ge,oe++}return!0}e.fuzzyContains=Ye;function Je(W,te=!1){return W?(te&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Je;function ze(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=ze;function $e(W,te=1){if(te===0)return"";let ae=-1;do ae=W.indexOf(`
`,ae+1),te--;while(te>0&&ae>=0);return ae===-1?W:(W[ae-1]==="\r"&&ae--,W.substr(0,ae))}e.getNLines=$e;function J(W){const te=90-65+1;return W=W%(2*te),W<te?String.fromCharCode(97+W):String.fromCharCode(65+W-te)}e.singleLetterHash=J;function re(W){return me.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=re;function se(W,te){return W===0?te!==5&&te!==7:W===2&&te===3?!1:W===4||W===2||W===3||te===4||te===2||te===3?!0:!(W===8&&(te===8||te===9||te===11||te===12)||(W===11||W===9)&&(te===9||te===10)||(W===12||W===10)&&te===10||te===5||te===13||te===7||W===1||W===13&&te===14||W===6&&te===6)}e.breakBetweenGraphemeBreakType=se;var pe;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class me{constructor(){this._data=De()}static getInstance(){return me._INSTANCE||(me._INSTANCE=new me),me._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const ae=this._data,ce=ae.length/3;let oe=1;for(;oe<=ce;)if(te<ae[3*oe])oe=2*oe;else if(te>ae[3*oe+1])oe=2*oe+1;else return ae[3*oe+2];return 0}}me._INSTANCE=null;function De(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function we(W,te){if(W===0)return 0;const ae=Re(W,te);if(ae!==void 0)return ae;const ce=M(te,W);return W-=be(ce),W}e.getLeftDeleteOffset=we;function Re(W,te){let ae=M(te,W);for(W-=be(ae);Le(ae)||ae===65039||ae===8419;){if(W===0)return;ae=M(te,W),W-=be(ae)}if(!!Pe(ae)){if(W>=0){const ce=M(te,W);ce===8205&&(W-=be(ce))}return W}}function be(W){return W>=65536?2:1}function Le(W){return 127995<=W&&W<=127999}var Ue;(function(W){W[W.zwj=8205]="zwj",W[W.emojiVariantSelector=65039]="emojiVariantSelector",W[W.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={}))}),define(Z[25],ee([0,1,49,19]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined",k=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let P,p;class y{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return L?new y(Buffer.allocUnsafe(l)):new y(new Uint8Array(l))}static wrap(l){return L&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new y(l)}static fromString(l,f){return!(f?.dontUseNodeBuffer||!1)&&L?new y(Buffer.from(l)):k?(P||(P=new TextEncoder),new y(P.encode(l))):new y(R.encodeUTF8(l))}static concat(l,f){if(typeof f=="undefined"){f=0;for(let T=0,O=l.length;T<O;T++)f+=l[T].byteLength}const S=y.alloc(f);let d=0;for(let T=0,O=l.length;T<O;T++){const x=l[T];S.set(x,d),d+=x.byteLength}return S}toString(){return L?this.buffer.toString():A?(p||(p=new TextDecoder),p.decode(this.buffer)):R.decodeUTF8(this.buffer)}slice(l,f){return new y(this.buffer.subarray(l,f))}set(l,f){l instanceof y?this.buffer.set(l.buffer,f):this.buffer.set(l,f)}readUInt32BE(l){return g(this.buffer,l)}writeUInt32BE(l,f){m(this.buffer,l,f)}readUInt32LE(l){return u(this.buffer,l)}writeUInt32LE(l,f){I(this.buffer,l,f)}readUInt8(l){return C(this.buffer,l)}writeUInt8(l,f){b(this.buffer,l,f)}}e.VSBuffer=y;function n(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0}e.readUInt16LE=n;function w(c,l,f){c[f+0]=l&255,l=l>>>8,c[f+1]=l&255}e.writeUInt16LE=w;function g(c,l){return c[l]*2**24+c[l+1]*2**16+c[l+2]*2**8+c[l+3]}e.readUInt32BE=g;function m(c,l,f){c[f+3]=l,l=l>>>8,c[f+2]=l,l=l>>>8,c[f+1]=l,l=l>>>8,c[f]=l}e.writeUInt32BE=m;function u(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0|c[l+2]<<16>>>0|c[l+3]<<24>>>0}e.readUInt32LE=u;function I(c,l,f){c[f+0]=l&255,l=l>>>8,c[f+1]=l&255,l=l>>>8,c[f+2]=l&255,l=l>>>8,c[f+3]=l&255}e.writeUInt32LE=I;function C(c,l){return c[l]}e.readUInt8=C;function b(c,l,f){c[f]=l}e.writeUInt8=b;function D(c){return E.consumeReadable(c,l=>y.concat(l))}e.readableToBuffer=D;function v(c){return E.toReadable(c)}e.bufferToReadable=v;function o(c){return E.consumeStream(c,l=>y.concat(l))}e.streamToBuffer=o;async function a(c){return c.ended?y.concat(c.buffer):y.concat([...c.buffer,await o(c.stream)])}e.bufferedStreamToBuffer=a;function t(c){return E.toStream(c,l=>y.concat(l))}e.bufferToStream=t;function r(c){return E.transform(c,{data:l=>typeof l=="string"?y.fromString(l):y.wrap(l)},l=>y.concat(l))}e.streamToBufferReadableStream=r;function i(c){return E.newWriteableStream(l=>y.concat(l),c)}e.newWriteableBufferStream=i;function s(c,l){return E.prefixedReadable(c,l,f=>y.concat(f))}e.prefixedBufferReadable=s;function h(c,l){return E.prefixedStream(c,l,f=>y.concat(f))}e.prefixedBufferStream=h}),define(Z[16],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function E(l){return Array.isArray(l)}e.isArray=E;function R(l){return typeof l=="string"}e.isString=R;function L(l){return Array.isArray(l)&&l.every(f=>R(f))}e.isStringArray=L;function k(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=k;function A(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=A;function P(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=P;function p(l){return l===!0||l===!1}e.isBoolean=p;function y(l){return typeof l=="undefined"}e.isUndefined=y;function n(l){return!w(l)}e.isDefined=n;function w(l){return y(l)||l===null}e.isUndefinedOrNull=w;function g(l,f){if(!l)throw new Error(f?`Unexpected type, expected '${f}'`:"Unexpected type")}e.assertType=g;function m(l){if(w(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=m;function u(...l){const f=[];for(let S=0;S<l.length;S++){const d=l[S];if(w(d))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);f.push(d)}return f}e.assertAllDefined=u;const I=Object.prototype.hasOwnProperty;function C(l){if(!k(l))return!1;for(let f in l)if(I.call(l,f))return!1;return!0}e.isEmptyObject=C;function b(l){return typeof l=="function"}e.isFunction=b;function D(...l){return l.length>0&&l.every(b)}e.areFunctions=D;function v(l,f){const S=Math.min(l.length,f.length);for(let d=0;d<S;d++)o(l[d],f[d])}e.validateConstraints=v;function o(l,f){if(R(f)){if(typeof l!==f)throw new Error(`argument does not match constraint: typeof ${f}`)}else if(b(f)){try{if(l instanceof f)return}catch{}if(!w(l)&&l.constructor===f||f.length===1&&f.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function a(l){let f=[],S=Object.getPrototypeOf(l);for(;Object.prototype!==S;)f=f.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return f}e.getAllPropertyNames=a;function t(l){const f=[];for(const S of a(l))typeof l[S]=="function"&&f.push(S);return f}e.getAllMethodNames=t;function r(l,f){const S=T=>function(){const O=Array.prototype.slice.call(arguments,0);return f(T,O)};let d={};for(const T of l)d[T]=S(T);return d}e.createProxyObject=r;function i(l){return l===null?void 0:l}e.withNullAsUndefined=i;function s(l){return typeof l=="undefined"?null:l}e.withUndefinedAsNull=s;function h(l){return class{constructor(){return new Proxy({},{get(f,S){if(f[S])return f[S];throw new Error(`Not Implemented: ${l}->${String(S)}`)}})}}}e.NotImplementedProxy=h;function c(l,f="Unreachable"){throw new Error(f)}e.assertNever=c}),define(Z[39],ee([0,1,8,4,19,16]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(i){return i===47||i===92}e.isPathSeparator=A;function P(i){return i.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=P;function p(i){return i.indexOf("/")===-1&&(i=P(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=p;function y(i,s=E.posix.sep){if(!i)return"";const h=i.length,c=i.charCodeAt(0);if(A(c)){if(A(i.charCodeAt(1))&&!A(i.charCodeAt(2))){let f=3;const S=f;for(;f<h&&!A(i.charCodeAt(f));f++);if(S!==f&&!A(i.charCodeAt(f+1))){for(f+=1;f<h;f++)if(A(i.charCodeAt(f)))return i.slice(0,f+1).replace(/[\\/]/g,s)}}return s}else if(b(c)&&i.charCodeAt(1)===58)return A(i.charCodeAt(2))?i.slice(0,2)+s:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<h;l++)if(A(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=y;function n(i){if(!R.isWindows||!i||i.length<5)return!1;let s=i.charCodeAt(0);if(s!==92||(s=i.charCodeAt(1),s!==92))return!1;let h=2;const c=h;for(;h<i.length&&(s=i.charCodeAt(h),s!==92);h++);return!(c===h||(s=i.charCodeAt(h+1),isNaN(s)||s===92))}e.isUNC=n;const w=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(i,s=R.isWindows){const h=s?w:g;return!(!i||i.length===0||/^\s+$/.test(i)||(h.lastIndex=0,h.test(i))||s&&m.test(i)||i==="."||i===".."||s&&i[i.length-1]==="."||s&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=u;function I(i,s,h){const c=i===s;return!h||c?c:!i||!s?!1:(0,L.equalsIgnoreCase)(i,s)}e.isEqual=I;function C(i,s,h,c=E.sep){if(i===s)return!0;if(!i||!s||s.length>i.length)return!1;if(h){if(!(0,L.startsWithIgnoreCase)(i,s))return!1;if(s.length===i.length)return!0;let f=s.length;return s.charAt(s.length-1)===c&&f--,i.charAt(f)===c}return s.charAt(s.length-1)!==c&&(s+=c),i.indexOf(s)===0}e.isEqualOrParent=C;function b(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=b;function D(i,s){return R.isWindows&&i.endsWith(":")&&(i+=E.sep),(0,E.isAbsolute)(i)||(i=(0,E.join)(s,i)),i=(0,E.normalize)(i),R.isWindows?(i=(0,L.rtrim)(i,E.sep),i.endsWith(":")&&(i+=E.sep)):(i=(0,L.rtrim)(i,E.sep),i||(i=E.sep)),i}e.sanitizeFilePath=D;function v(i){const s=(0,E.normalize)(i);return R.isWindows?i.length>3?!1:o(s)&&(i.length===2||s.charCodeAt(2)===92):s===E.posix.sep}e.isRootOrDriveLetter=v;function o(i){return R.isWindows?b(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function a(i){return o(i)?i[0]:void 0}e.getDriveLetter=a;function t(i,s,h){return s.length>i.length?-1:i===s?0:(h&&(i=i.toLowerCase(),s=s.toLowerCase()),i.indexOf(s))}e.indexOfPath=t;function r(i){const s=i.split(":");let h,c,l;if(s.forEach(f=>{const S=Number(f);(0,k.isNumber)(S)?c===void 0?c=S:l===void 0&&(l=S):h=h?[h,f].join(":"):f}),!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:c!==void 0?c:void 0,column:l!==void 0?l:c!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Z[26],ee([0,1,16]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(I){if(!I||typeof I!="object"||I instanceof RegExp)return I;const C=Array.isArray(I)?[]:{};return Object.keys(I).forEach(b=>{I[b]&&typeof I[b]=="object"?C[b]=R(I[b]):C[b]=I[b]}),C}e.deepClone=R;function L(I){if(!I||typeof I!="object")return I;const C=[I];for(;C.length>0;){const b=C.shift();Object.freeze(b);for(const D in b)if(k.call(b,D)){const v=b[D];typeof v=="object"&&!Object.isFrozen(v)&&C.push(v)}}return I}e.deepFreeze=L;const k=Object.prototype.hasOwnProperty;function A(I,C){return P(I,C,new Set)}e.cloneAndChange=A;function P(I,C,b){if((0,E.isUndefinedOrNull)(I))return I;const D=C(I);if(typeof D!="undefined")return D;if((0,E.isArray)(I)){const v=[];for(const o of I)v.push(P(o,C,b));return v}if((0,E.isObject)(I)){if(b.has(I))throw new Error("Cannot clone recursive data-structure");b.add(I);const v={};for(let o in I)k.call(I,o)&&(v[o]=P(I[o],C,b));return b.delete(I),v}return I}function p(I,C,b=!0){return(0,E.isObject)(I)?((0,E.isObject)(C)&&Object.keys(C).forEach(D=>{D in I?b&&((0,E.isObject)(I[D])&&(0,E.isObject)(C[D])?p(I[D],C[D],b):I[D]=C[D]):I[D]=C[D]}),I):C}e.mixin=p;function y(I,C){if(I===C)return!0;if(I==null||C===null||C===void 0||typeof I!=typeof C||typeof I!="object"||Array.isArray(I)!==Array.isArray(C))return!1;let b,D;if(Array.isArray(I)){if(I.length!==C.length)return!1;for(b=0;b<I.length;b++)if(!y(I[b],C[b]))return!1}else{const v=[];for(D in I)v.push(D);v.sort();const o=[];for(D in C)o.push(D);if(o.sort(),!y(v,o))return!1;for(b=0;b<v.length;b++)if(!y(I[v[b]],C[v[b]]))return!1}return!0}e.equals=y;function n(I){const C=new Set;return JSON.stringify(I,(b,D)=>{if((0,E.isObject)(D)||Array.isArray(D)){if(C.has(D))return"[Circular]";C.add(D)}return D})}e.safeStringify=n;function w(I,C,b){const D=C(I);return typeof D=="undefined"?b:D}e.getOrDefault=w;function g(I,C){const b=Object.create(null);return!I||!C||Object.keys(C).forEach(v=>{const o=I[v],a=C[v];y(o,a)||(b[v]=a)}),b}e.distinct=g;function m(I,C){const b=C.toLowerCase(),D=Object.keys(I).find(v=>v.toLowerCase()===b);return D?I[D]:I[C]}e.getCaseInsensitive=m;function u(I,C){const b=Object.create(null);for(const D of Object.keys(I))C(D,I[D])&&(b[D]=I[D]);return b}e.filter=u}),define(Z[5],ee([0,1,8,4]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,k=/^\//,A=/^\/\//;function P(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!k.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(i,s){return!i&&!s?"file":i}function y(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==w&&(s=w+s):s=w;break}return s}const n="",w="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(s,h,c,l,f,S=!1){typeof s=="object"?(this.scheme=s.scheme||n,this.authority=s.authority||n,this.path=s.path||n,this.query=s.query||n,this.fragment=s.fragment||n):(this.scheme=p(s,S),this.authority=h||n,this.path=y(this.scheme,c||n),this.query=l||n,this.fragment=f||n,P(this,S))}static isUri(s){return s instanceof m?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return v(this,!1)}with(s){if(!s)return this;let{scheme:h,authority:c,path:l,query:f,fragment:S}=s;return h===void 0?h=this.scheme:h===null&&(h=n),c===void 0?c=this.authority:c===null&&(c=n),l===void 0?l=this.path:l===null&&(l=n),f===void 0?f=this.query:f===null&&(f=n),S===void 0?S=this.fragment:S===null&&(S=n),h===this.scheme&&c===this.authority&&l===this.path&&f===this.query&&S===this.fragment?this:new I(h,c,l,f,S)}static parse(s,h=!1){const c=g.exec(s);return c?new I(c[2]||n,r(c[4]||n),r(c[5]||n),r(c[7]||n),r(c[9]||n),h):new I(n,n,n,n,n)}static file(s){let h=n;if(R.isWindows&&(s=s.replace(/\\/g,w)),s[0]===w&&s[1]===w){const c=s.indexOf(w,2);c===-1?(h=s.substring(2),s=w):(h=s.substring(2,c),s=s.substring(c)||w)}return new I("file",h,s,n,n)}static from(s){const h=new I(s.scheme,s.authority,s.path,s.query,s.fragment);return P(h,!0),h}static joinPath(s,...h){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return R.isWindows&&s.scheme==="file"?c=m.file(E.win32.join(v(s,!0),...h)).path:c=E.posix.join(s.path,...h),s.with({path:c})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof m)return s;{const h=new I(s);return h._formatted=s.external,h._fsPath=s._sep===u?s.fsPath:null,h}}else return s}}e.URI=m;const u=R.isWindows?1:void 0;class I extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=u),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(i,s){let h,c=-1;for(let l=0;l<i.length;l++){const f=i.charCodeAt(l);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||s&&f===47)c!==-1&&(h+=encodeURIComponent(i.substring(c,l)),c=-1),h!==void 0&&(h+=i.charAt(l));else{h===void 0&&(h=i.substr(0,l));const S=C[f];S!==void 0?(c!==-1&&(h+=encodeURIComponent(i.substring(c,l)),c=-1),h+=S):c===-1&&(c=l)}}return c!==-1&&(h+=encodeURIComponent(i.substring(c))),h!==void 0?h:i}function D(i){let s;for(let h=0;h<i.length;h++){const c=i.charCodeAt(h);c===35||c===63?(s===void 0&&(s=i.substr(0,h)),s+=C[c]):s!==void 0&&(s+=i[h])}return s!==void 0?s:i}function v(i,s){let h;return i.authority&&i.path.length>1&&i.scheme==="file"?h=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?h=i.path.substr(1):h=i.path[1].toLowerCase()+i.path.substr(2):h=i.path,R.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=v;function o(i,s){const h=s?D:b;let c="",{scheme:l,authority:f,path:S,query:d,fragment:T}=i;if(l&&(c+=l,c+=":"),(f||l==="file")&&(c+=w,c+=w),f){let O=f.indexOf("@");if(O!==-1){const x=f.substr(0,O);f=f.substr(O+1),O=x.indexOf(":"),O===-1?c+=h(x,!1):(c+=h(x.substr(0,O),!1),c+=":",c+=h(x.substr(O+1),!1)),c+="@"}f=f.toLowerCase(),O=f.indexOf(":"),O===-1?c+=h(f,!1):(c+=h(f.substr(0,O),!1),c+=f.substr(O))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const O=S.charCodeAt(1);O>=65&&O<=90&&(S=`/${String.fromCharCode(O+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const O=S.charCodeAt(0);O>=65&&O<=90&&(S=`${String.fromCharCode(O+32)}:${S.substr(2)}`)}c+=h(S,!0)}return d&&(c+="?",c+=h(d,!1)),T&&(c+="#",c+=s?T:b(T,!1)),c}function a(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+a(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,s=>a(s)):i}}),define(Z[93],ee([0,1,5]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(y){const n=y;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=R;function L(y){const n=[];let w;try{const g=JSON.parse(y.arguments),m=g[g.length-1];m&&m.__$stack&&(g.pop(),w=m.__$stack),n.push(...g)}catch(g){n.push("Unable to log remote console arguments",y.arguments)}return{args:n,stack:w}}e.parse=L;function k(y){if(typeof y!="string")return k(L(y).stack);const n=y;if(n){const w=A(n),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(g&&g.length===4)return{uri:E.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=k;function A(y){if(!y)return y;const n=y.indexOf(`
`);return n===-1?y:y.substring(0,n)}function P(y,n){const{args:w,stack:g}=L(y),m=typeof w[0]=="string"&&w.length===1;let u=A(g);u&&(u=`(${u.trim()})`);let I=[];if(typeof w[0]=="string"?u&&m?I=[`%c[${n}] %c${w[0]} %c${u}`,p("blue"),p(""),p("grey")]:I=[`%c[${n}] %c${w[0]}`,p("blue"),p(""),...w.slice(1)]:I=[`%c[${n}]%`,p("blue"),...w],u&&!m&&I.push(u),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,I)}e.log=P;function p(y){return`color: ${y}`}});var ut=this&&this.__classPrivateFieldSet||function(K,e,E,R,L){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?L.call(K,E):L?L.value=E:e.set(K,E),E},xe=this&&this.__classPrivateFieldGet||function(K,e,E,R){if(E==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?R:E==="a"?R.call(K):R?R.value:e.get(K)};define(Z[40],ee([0,1,19,5]),function(K,e,E,R){"use strict";var L,k,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,r,i){let s=t.get(r);return s===void 0&&(s=i,t.set(r,s)),s}e.getOrSet=P;function p(t){const r=[];return t.forEach((i,s)=>{r.push(`${s} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=p;function y(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=y;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),s=this._value.charCodeAt(this._pos);return i-s}value(){return this._value[this._pos]}}e.StringIterator=n;class w{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,E.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,E.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class g{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,E.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,E.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class u{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,E.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,E.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,E.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,E.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class I{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class C{constructor(r){this._iter=r}static forUris(r=()=>!1){return new C(new u(r))}static forPaths(){return new C(new g)}static forStrings(){return new C(new n)}static forConfigKeys(){return new C(new w)}clear(){this._root=void 0}set(r,i){const s=this._iter.reset(r);let h;for(this._root||(this._root=new I,this._root.segment=s.value()),h=this._root;;){const l=s.cmp(h.segment);if(l>0)h.left||(h.left=new I,h.left.segment=s.value()),h=h.left;else if(l<0)h.right||(h.right=new I,h.right.segment=s.value()),h=h.right;else if(s.hasNext())s.next(),h.mid||(h.mid=new I,h.mid.segment=s.value()),h=h.mid;else break}const c=h.value;return h.value=i,h.key=r,c}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const h=i.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else break}return s}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const s=this._iter.reset(r),h=[];let c=this._root;for(;c;){const l=s.cmp(c.segment);if(l>0)h.push([1,c]),c=c.left;else if(l<0)h.push([-1,c]),c=c.right;else if(s.hasNext())s.next(),h.push([0,c]),c=c.mid;else{for(i?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;h.length>0&&c.isEmpty();){let[f,S]=h.pop();switch(f){case 1:S.left=void 0;break;case 0:S.mid=void 0;break;case-1:S.right=void 0;break}c=S}break}}}findSubstr(r){const i=this._iter.reset(r);let s=this._root,h;for(;s;){const c=i.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(i.hasNext())i.next(),h=s.value||h,s=s.mid;else break}return s&&s.value||h}findSuperstr(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const h=i.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(r){for(const[i,s]of this)r(s,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const s=i.pop();s&&(s.value&&(yield[s.key,s.value]),s.left&&i.push(s.left),s.mid&&i.push(s.mid),s.right&&i.push(s.right))}}}e.TernarySearchTree=C;class b{constructor(r,i){this[L]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=i??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[s,h]of this.map)r(h,R.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield R.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[R.URI.parse(r[0]),r[1]]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[R.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var D;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class v{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const s=this._map.get(r);if(!!s)return i!==0&&this.touch(s,i),s.value}set(r,i,s=0){let h=this._map.get(r);if(h)h.value=i,s!==0&&this.touch(h,s);else{switch(h={key:r,value:i,next:void 0,previous:void 0},s){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(r,h),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const s=this._state;let h=this._head;for(;h;){if(i?r.bind(i)(h.value,h.key,this):r(h.value,h.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,i=this._state;let s=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const c={value:s.key,done:!1};return s=s.next,c}else return{value:void 0,done:!0}}};return h}values(){const r=this,i=this._state;let s=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const c={value:s.value,done:!1};return s=s.next,c}else return{value:void 0,done:!0}}};return h}entries(){const r=this,i=this._state;let s=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const c={value:[s.key,s.value],done:!1};return s=s.next,c}else return{value:void 0,done:!0}}};return h}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,s=this.size;for(;i&&s>r;)this._map.delete(i.key),i=i.next,s--;this._head=i,this._size=s,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,s=r.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const s=r.next,h=r.previous;r===this._tail?(h.next=void 0,this._tail=h):(s.previous=h,h.next=s),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const s=r.next,h=r.previous;r===this._head?(s.previous=void 0,this._head=s):(s.previous=h,h.next=s),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,s)=>{r.push([s,i])}),r}fromJSON(r){this.clear();for(const[i,s]of r)this.set(i,s)}}e.LinkedMap=v;class o extends v{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class a{constructor(r){A.set(this,void 0),ut(this,A,r,"f")}get size(){return xe(this,A,"f").size}forEach(r,i){xe(this,A,"f").forEach(r,i)}get(r){return xe(this,A,"f").get(r)}has(r){return xe(this,A,"f").has(r)}entries(){return xe(this,A,"f").entries()}keys(){return xe(this,A,"f").keys()}values(){return xe(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return xe(this,A,"f").entries()}}e.ReadonlyMapView=a}),define(Z[94],ee([0,1,25,19,5]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(n){return JSON.stringify(n,p)}e.stringify=k;function A(n){let w=JSON.parse(n);return w=y(w),w}e.parse=A;var P;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function p(n,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,R.regExpFlags)(w)}:w}function y(n,w=0){if(!n||w>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return L.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof E.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let g=0;g<n.length;++g)n[g]=y(n[g],w+1);else for(const g in n)Object.hasOwnProperty.call(n,g)&&(n[g]=y(n[g],w+1))}return n}e.revive=y}),define(Z[17],ee([0,1,4,5]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(L=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}set(p,y,n){this._hosts[p]=y,this._ports[p]=n}setConnectionToken(p,y){this._connectionTokens[p]=y}rewrite(p){if(this._delegate)return this._delegate(p);const y=p.authority;let n=this._hosts[y];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const w=this._ports[y],g=this._connectionTokens[y];let m=`path=${encodeURIComponent(p.path)}`;return typeof g=="string"&&(m+=`&tkn=${encodeURIComponent(g)}`),R.URI.from({scheme:E.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${n}:${w}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new k;class A{asBrowserUri(p,y){const n=this.toUri(p,y);return n.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===L.file&&(E.isNative||typeof E.globals.importScripts=="function"&&E.globals.origin===`${L.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?n.with({scheme:L.vscodeFileResource,authority:n.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(p,y){const n=this.toUri(p,y);return n.scheme===L.vscodeFileResource?n.with({scheme:L.file,authority:n.authority!==A.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(p,y){return R.URI.isUri(p)?p:R.URI.parse(y.toUrl(p))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(Z[66],ee([0,1,40]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new E.LRUCache(1e4);function L(y){return p(y,"NFC",R)}e.normalizeNFC=L;const k=new E.LRUCache(1e4);function A(y){return p(y,"NFD",k)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function p(y,n,w){if(!y)return y;const g=w.get(y);if(g)return g;let m;return P.test(y)?m=y.normalize(n):m=y,w.set(y,m),m}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(n){return A(n).replace(y,"")}}()}),define(Z[15],ee([0,1,39,17,8,4,19,5]),function(K,e,E,R,L,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(m){return(0,P.uriToFsPath)(m,!0)}e.originalFSPath=p;class y{constructor(u){this._ignorePathCasing=u}compare(u,I,C=!1){return u===I?0:(0,A.compare)(this.getComparisonKey(u,C),this.getComparisonKey(I,C))}isEqual(u,I,C=!1){return u===I?!0:!u||!I?!1:this.getComparisonKey(u,C)===this.getComparisonKey(I,C)}getComparisonKey(u,I=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:I?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,I,C=!1){if(u.scheme===I.scheme){if(u.scheme===R.Schemas.file)return E.isEqualOrParent(p(u),p(I),this._ignorePathCasing(u))&&u.query===I.query&&(C||u.fragment===I.fragment);if((0,e.isEqualAuthority)(u.authority,I.authority))return E.isEqualOrParent(u.path,I.path,this._ignorePathCasing(u),"/")&&u.query===I.query&&(C||u.fragment===I.fragment)}return!1}joinPath(u,...I){return P.URI.joinPath(u,...I)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return L.posix.basename(u.path)}extname(u){const I=L.posix.extname(u.path),C=I.indexOf("?");return C!==-1?I.substr(0,C):I}dirname(u){if(u.path.length===0)return u;let I;return u.scheme===R.Schemas.file?I=P.URI.file(L.dirname(p(u))).path:(I=L.posix.dirname(u.path),u.authority&&I.length&&I.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),I="/")),u.with({path:I})}normalizePath(u){if(!u.path.length)return u;let I;return u.scheme===R.Schemas.file?I=P.URI.file(L.normalize(p(u))).path:I=L.posix.normalize(u.path),u.with({path:I})}relativePath(u,I){if(u.scheme!==I.scheme||!(0,e.isEqualAuthority)(u.authority,I.authority))return;if(u.scheme===R.Schemas.file){const D=L.relative(p(u),p(I));return k.isWindows?E.toSlashes(D):D}let C=u.path||"/",b=I.path||"/";if(this._ignorePathCasing(u)){let D=0;for(const v=Math.min(C.length,b.length);D<v&&!(C.charCodeAt(D)!==b.charCodeAt(D)&&C.charAt(D).toLowerCase()!==b.charAt(D).toLowerCase());D++);C=b.substr(0,D)+C.substr(D)}return L.posix.relative(C,b)}resolvePath(u,I){if(u.scheme===R.Schemas.file){const C=P.URI.file(L.resolve(p(u),I));return u.with({authority:C.authority,path:C.path})}return I=E.toPosixPath(I),u.with({path:L.posix.resolve(u.path,I)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,I){return u===I||(0,A.equalsIgnoreCase)(u,I)}hasTrailingPathSeparator(u,I=L.sep){if(u.scheme===R.Schemas.file){const C=p(u);return C.length>E.getRoot(C).length&&C[C.length-1]===I}else{const C=u.path;return C.length>1&&C.charCodeAt(C.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,I=L.sep){return(0,e.hasTrailingPathSeparator)(u,I)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,I=L.sep){let C=!1;if(u.scheme===R.Schemas.file){const b=p(u);C=b!==void 0&&b.length===E.getRoot(b).length&&b[b.length-1]===I}else{I="/";const b=u.path;C=b.length===1&&b.charCodeAt(b.length-1)===47}return!C&&!(0,e.hasTrailingPathSeparator)(u,I)?u.with({path:u.path+"/"}):u}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(m=>m.scheme===R.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new y(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(m,u){const I=[];for(let C=0;C<m.length;C++){const b=u(m[C]);m.some((D,v)=>v===C?!1:(0,e.isEqualOrParent)(b,u(D)))||I.push(m[C])}return I}e.distinctParents=n;var w;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function u(I){const C=new Map;I.path.substring(I.path.indexOf(";")+1,I.path.lastIndexOf(";")).split(";").forEach(v=>{const[o,a]=v.split(":");o&&a&&C.set(o,a)});const D=I.path.substring(0,I.path.indexOf(";"));return D&&C.set(m.META_DATA_MIME,D),C}m.parseMetaData=u})(w=e.DataUri||(e.DataUri={}));function g(m,u,I){if(u){let C=m.path;return C&&C[0]!==L.posix.sep&&(C=L.posix.sep+C),m.with({scheme:I,authority:u,path:C})}return m.with({scheme:I})}e.toLocalResource=g}),define(Z[6],ee([0,1,29,11,3,2,15]),function(K,e,E,R,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P($){return!!$&&typeof $.then=="function"}e.isThenable=P;function p($){const M=new E.CancellationTokenSource,N=$(M.token),q=new Promise((F,j)=>{const _=M.token.onCancellationRequested(()=>{_.dispose(),M.dispose(),j((0,R.canceled)())});Promise.resolve(N).then(G=>{_.dispose(),M.dispose(),F(G)},G=>{_.dispose(),M.dispose(),j(G)})});return new class{cancel(){M.cancel()}then(F,j){return q.then(F,j)}catch(F){return this.then(void 0,F)}finally(F){return q.finally(F)}}}e.createCancelablePromise=p;function y($,M,N){return Promise.race([$,new Promise(q=>M.onCancellationRequested(()=>q(N)))])}e.raceCancellation=y;async function n($){let M=-1;const N=$.map((F,j)=>F.then(_=>(M=j,_))),q=await Promise.race(N);return $.forEach((F,j)=>{j!==M&&F.cancel()}),q}e.raceCancellablePromises=n;function w($,M,N){let q;const F=setTimeout(()=>{q?.(void 0),N?.()},M);return Promise.race([$.finally(()=>clearTimeout(F)),new Promise(j=>q=j)])}e.raceTimeout=w;function g($){return new Promise((M,N)=>{const q=$();P(q)?q.then(M,N):M(q)})}e.asPromise=g;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(N,N).then(q)})}return new Promise((N,q)=>{this.queuedPromise.then(N,q)})}return this.activePromise=M(),new Promise((N,q)=>{this.activePromise.then(F=>{this.activePromise=null,N(F)},F=>{this.activePromise=null,q(F)})})}}e.Throttler=m;class u{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=u;class I{constructor(){this.promiseMap=new Map}queue(M,N){const F=(this.promiseMap.get(M)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(M)===F&&this.promiseMap.delete(M)});return this.promiseMap.set(M,F),F}}e.SequencerByKey=I;class C{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,N=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,F)=>{this.doResolve=q,this.doReject=F}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},N),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=C;class b{constructor(M){this.delayer=new C(M),this.throttler=new m}trigger(M,N){return this.delayer.trigger(()=>this.throttler.queue(M),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class D{constructor(){this._isOpen=!1,this._promise=new Promise((M,N)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=D;class v extends D{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=v;function o($,M){return M?new Promise((N,q)=>{const F=setTimeout(()=>{j.dispose(),N()},$),j=M.onCancellationRequested(()=>{clearTimeout(F),j.dispose(),q((0,R.canceled)())})}):p(N=>o($,N))}e.timeout=o;function a($,M=0){const N=setTimeout($,M);return(0,k.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=a;function t($){const M=[];let N=0;const q=$.length;function F(){return N<q?$[N++]():null}function j(_){_!=null&&M.push(_);const G=F();return G?G.then(j):Promise.resolve(M)}return Promise.resolve(null).then(j)}e.sequence=t;function r($,M=q=>!!q,N=null){let q=0;const F=$.length,j=()=>{if(q>=F)return Promise.resolve(N);const _=$[q++];return Promise.resolve(_()).then(B=>M(B)?Promise.resolve(B):j())};return j()}e.first=r;function i($,M=q=>!!q,N=null){if($.length===0)return Promise.resolve(N);let q=$.length;const F=()=>{q=-1;for(const j of $)j.cancel?.()};return new Promise((j,_)=>{for(const G of $)G.then(B=>{--q>=0&&M(B)?(F(),j(B)):q===0&&j(N)}).catch(B=>{--q>=0&&(F(),_(B))})})}e.firstParallel=i;class s{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((N,q)=>{this.outstandingPromises.push({factory:M,c:N,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const N=M.factory();N.then(M.c,M.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class h extends s{constructor(){super(1)}}e.Queue=h;class c{constructor(){this.queues=new Map}queueFor(M,N=A.extUri){const q=N.getComparisonKey(M);let F=this.queues.get(q);return F||(F=new h,L.Event.once(F.onFinished)(()=>{F?.dispose(),this.queues.delete(q)}),this.queues.set(q,F)),F}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=c;class l{constructor(M,N){this._token=-1,typeof M=="function"&&typeof N=="number"&&this.setIfNotSet(M,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},N)}setIfNotSet(M,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},N))}}e.TimeoutTimer=l;class f{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,N){this.cancel(),this._token=setInterval(()=>{M()},N)}}e.IntervalTimer=f;class S{constructor(M,N){this.timeoutToken=-1,this.runner=M,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=S;class d extends S{constructor(M,N){super(M,N);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=d;class T extends k.Disposable{constructor(M,N,q,F){super();this.maxWorkChunkSize=M,this.maxPendingWork=N,this.throttleDelay=q,this.handler=F,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(M){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+M.length>this.maxPendingWork)return!1}else if(this.pending+M.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...M),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new S(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=T,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const $=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const N=setTimeout(()=>M($));let q=!1;return{dispose(){q||(q=!0,clearTimeout(N))}}}}else e.runWhenIdle=($,M)=>{const N=requestIdleCallback($,typeof M=="number"?{timeout:M}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(N))}}}}();class O{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=O;async function x($,M,N){let q;for(let F=0;F<N;F++)try{return await $()}catch(j){q=j,await o(M)}throw q}e.retry=x;class z{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(M,N,q){return this._pending={taskId:M,cancel:()=>q?.(),promise:N},N.then(()=>this.donePending(M),()=>this.donePending(M)),N}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let N,q;const F=new Promise((j,_)=>{N=j,q=_});this._next={run:M,promise:F,promiseResolve:N,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=z;class H{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,N)=>{this.completeCallback=M,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(N=>{this.completeCallback(M),this.resolved=!0,N()})}error(M){return new Promise(N=>{this.errorCallback(M),this.rejected=!0,N()})}cancel(){new Promise(M=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=V;var U;(function($){async function M(N){let q;const F=await Promise.all(N.map(j=>j.then(_=>_,_=>{q||(q=_)})));if(typeof q!="undefined")throw q;return F}$.settled=M})(U=e.Promises||(e.Promises={}))}),define(Z[67],ee([0,1,6,39,40,8,19]),function(K,e,E,R,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const p="**",y="/",n="[/\\\\]",w="[^/\\\\]",g=/\//g;function m(F){switch(F){case 0:return"";case 1:return`${w}*?`;default:return`(?:${n}|${w}+${n}|${n}${w}+)*?`}}function u(F,j){if(!F)return[];const _=[];let G=!1,B=!1,X="";for(const Q of F){switch(Q){case j:if(!G&&!B){_.push(X),X="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":B=!0;break;case"]":B=!1;break}X+=Q}return X&&_.push(X),_}e.splitGlobAware=u;function I(F){if(!F)return"";let j="";const _=u(F,y);if(_.every(G=>G===p))j=".*";else{let G=!1;_.forEach((B,X)=>{if(B===p){G||(j+=m(2),G=!0);return}let Q=!1,ie="",ne=!1,le="";for(const fe of B){if(fe!=="}"&&Q){ie+=fe;continue}if(ne&&(fe!=="]"||!le)){let ye;fe==="-"?ye=fe:(fe==="^"||fe==="!")&&!le?ye="^":fe===y?ye="":ye=A.escapeRegExpCharacters(fe),le+=ye;continue}switch(fe){case"{":Q=!0;continue;case"[":ne=!0;continue;case"}":j+=`(?:${u(ie,",").map(Pe=>I(Pe)).join("|")})`,Q=!1,ie="";break;case"]":j+="["+le+"]",ne=!1,le="";break;case"?":j+=w;continue;case"*":j+=m(1);continue;default:j+=A.escapeRegExpCharacters(fe)}}X<_.length-1&&(_[X+1]!==p||X+2<_.length)&&(j+=n),G=!1})}return j}const C=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,D=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.LRUCache(1e4),r=function(){return!1},i=function(){return null};function s(F,j){if(!F)return i;let _;typeof F!="string"?_=F.pattern:_=F,_=_.trim();const G=`${_}_${!!j.trimForExclusions}`;let B=t.get(G);if(B)return h(B,F);let X;if(C.test(_)){const Q=_.substr(4);B=function(ie,ne){return typeof ie=="string"&&ie.endsWith(Q)?_:null}}else(X=b.exec(c(_,j)))?B=l(X[1],_):(j.trimForExclusions?v:D).test(_)?B=f(_,j):(X=o.exec(c(_,j)))?B=S(X[1].substr(1),_,!0):(X=a.exec(c(_,j)))?B=S(X[1],_,!1):B=d(_);return t.set(G,B),h(B,F)}function h(F,j){return typeof j=="string"?F:function(_,G){return R.isEqualOrParent(_,j.base)?F(k.relative(j.base,_),G):null}}function c(F,j){return j.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function l(F,j){const _=`/${F}`,G=`\\${F}`,B=function(Q,ie){return typeof Q!="string"?null:ie?ie===F?j:null:Q===F||Q.endsWith(_)||Q.endsWith(G)?j:null},X=[F];return B.basenames=X,B.patterns=[j],B.allBasenames=X,B}function f(F,j){const _=q(F.slice(1,-1).split(",").map(ie=>s(ie,j)).filter(ie=>ie!==i),F),G=_.length;if(!G)return i;if(G===1)return _[0];const B=function(ie,ne){for(let le=0,fe=_.length;le<fe;le++)if(_[le](ie,ne))return F;return null},X=_.find(ie=>!!ie.allBasenames);X&&(B.allBasenames=X.allBasenames);const Q=_.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return Q.length&&(B.allPaths=Q),B}function S(F,j,_){const G=k.sep===k.posix.sep,B=G?F:F.replace(g,k.sep),X=k.sep+B,Q=k.posix.sep+F,ie=_?function(ne,le){return typeof ne=="string"&&(ne===B||ne.endsWith(X)||!G&&(ne===F||ne.endsWith(Q)))?j:null}:function(ne,le){return typeof ne=="string"&&(ne===B||!G&&ne===F)?j:null};return ie.allPaths=[(_?"*/":"./")+F],ie}function d(F){try{const j=new RegExp(`^${I(F)}$`);return function(_){return j.lastIndex=0,typeof _=="string"&&j.test(_)?F:null}}catch(j){return i}}function T(F,j,_){return!F||typeof j!="string"?!1:O(F)(j,void 0,_)}e.match=T;function O(F,j={}){if(!F)return r;if(typeof F=="string"||V(F)){const _=s(F,j);if(_===i)return r;const G=function(B,X){return!!_(B,X)};return _.allBasenames&&(G.allBasenames=_.allBasenames),_.allPaths&&(G.allPaths=_.allPaths),G}return M(F,j)}e.parse=O;function x(F){if(!F)return;let j;return _=>(j||(j=(F()||Promise.resolve([])).then(G=>G?H(G):{})),j.then(G=>!!G[_]))}e.hasSiblingPromiseFn=x;function z(F){if(!F)return;let j;return _=>{if(!j){const G=F();j=G?H(G):{}}return!!j[_]}}e.hasSiblingFn=z;function H(F){const j={};for(const _ of F)j[_]=!0;return j}function V(F){const j=F;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=V;function U(F){return F.allBasenames||[]}e.getBasenameTerms=U;function $(F){return F.allPaths||[]}e.getPathTerms=$;function M(F,j){const _=q(Object.getOwnPropertyNames(F).map(ie=>N(ie,F[ie],j)).filter(ie=>ie!==i)),G=_.length;if(!G)return i;if(!_.some(ie=>!!ie.requiresSiblings)){if(G===1)return _[0];const ie=function(fe,ye){for(let Se=0,Pe=_.length;Se<Pe;Se++){const Te=_[Se](fe,ye);if(Te)return Te}return null},ne=_.find(fe=>!!fe.allBasenames);ne&&(ie.allBasenames=ne.allBasenames);const le=_.reduce((fe,ye)=>ye.allPaths?fe.concat(ye.allPaths):fe,[]);return le.length&&(ie.allPaths=le),ie}const B=function(ie,ne,le){let fe;for(let ye=0,Se=_.length;ye<Se;ye++){const Pe=_[ye];Pe.requiresSiblings&&le&&(ne||(ne=k.basename(ie)),fe||(fe=ne.substr(0,ne.length-k.extname(ie).length)));const Te=Pe(ie,ne,fe,le);if(Te)return Te}return null},X=_.find(ie=>!!ie.allBasenames);X&&(B.allBasenames=X.allBasenames);const Q=_.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return Q.length&&(B.allPaths=Q),B}function N(F,j,_){if(j===!1)return i;const G=s(F,_);if(G===i)return i;if(typeof j=="boolean")return G;if(j){const B=j.when;if(typeof B=="string"){const X=(Q,ie,ne,le)=>{if(!le||!G(Q,ie))return null;const fe=B.replace("$(basename)",ne),ye=le(fe);return(0,E.isThenable)(ye)?ye.then(Se=>Se?F:null):ye?F:null};return X.requiresSiblings=!0,X}}return G}function q(F,j){const _=F.filter(ie=>!!ie.basenames);if(_.length<2)return F;const G=_.reduce((ie,ne)=>{const le=ne.basenames;return le?ie.concat(le):ie},[]);let B;if(j){B=[];for(let ie=0,ne=G.length;ie<ne;ie++)B.push(j)}else B=_.reduce((ie,ne)=>{const le=ne.patterns;return le?ie.concat(le):ie},[]);const X=function(ie,ne){if(typeof ie!="string")return null;if(!ne){let fe;for(fe=ie.length;fe>0;fe--){const ye=ie.charCodeAt(fe-1);if(ye===47||ye===92)break}ne=ie.substr(fe)}const le=G.indexOf(ne);return le!==-1?B[le]:null};X.basenames=G,X.patterns=B,X.allBasenames=G;const Q=F.filter(ie=>!ie.basenames);return Q.push(X),Q}}),define(Z[95],ee([0,1,67,17,8,15,19]),function(K,e,E,R,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let p=[],y=[],n=[];function w(r,i=!1){const s=g(r);p.push(s),s.userConfigured?n.push(s):y.push(s),i&&!s.userConfigured&&p.forEach(h=>{h.mime===s.mime||h.userConfigured||(s.extension&&h.extension===s.extension&&console.warn(`Overwriting extension <<${s.extension}>> to now point to mime <<${s.mime}>>`),s.filename&&h.filename===s.filename&&console.warn(`Overwriting filename <<${s.filename}>> to now point to mime <<${s.mime}>>`),s.filepattern&&h.filepattern===s.filepattern&&console.warn(`Overwriting filepattern <<${s.filepattern}>> to now point to mime <<${s.mime}>>`),s.firstline&&h.firstline===s.firstline&&console.warn(`Overwriting firstline <<${s.firstline}>> to now point to mime <<${s.mime}>>`))})}e.registerTextMime=w;function g(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(L.posix.sep)>=0:!1}}function m(r){r?(p=p.filter(i=>!i.userConfigured),n=[]):(p=[],y=[],n=[])}e.clearTextMimes=m;function u(r,i){let s;if(r)switch(r.scheme){case R.Schemas.file:s=r.fsPath;break;case R.Schemas.data:s=k.DataUri.parseMetaData(r).get(k.DataUri.META_DATA_LABEL);break;default:s=r.path}if(!s)return[P.unknown];s=s.toLowerCase();const h=(0,L.basename)(s),c=I(s,h,n);if(c)return[c,P.text];const l=I(s,h,y);if(l)return[l,P.text];if(i){const f=C(i);if(f)return[f,P.text]}return[P.unknown]}e.guessMimeTypes=u;function I(r,i,s){let h=null,c=null,l=null;for(let f=s.length-1;f>=0;f--){const S=s[f];if(i===S.filenameLowercase){h=S;break}if(S.filepattern&&(!c||S.filepattern.length>c.filepattern.length)){const d=S.filepatternOnPath?r:i;(0,E.match)(S.filepatternLowercase,d)&&(c=S)}S.extension&&(!l||S.extension.length>l.extension.length)&&i.endsWith(S.extensionLowercase)&&(l=S)}return h?h.mime:c?c.mime:l?l.mime:null}function C(r){if((0,A.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let i=p.length-1;i>=0;i--){const s=p[i];if(!s.firstline)continue;const h=r.match(s.firstline);if(h&&h.length>0)return s.mime}return null}function b(r){return r?typeof r=="string"?r===P.binary||r===P.text||r===P.unknown:r.length===1&&b(r[0]):!0}e.isUnspecific=b;const D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function v(r){const i=(0,L.extname)(r);return D[i.toLowerCase()]}e.getMediaMime=v;function o(r){for(const i in D)if(D[i]===r)return i}e.getExtensionForMimeType=o;const a=/^(.+)\/(.+?)(;.+)?$/;function t(r,i){const s=a.exec(r);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:i?void 0:r}e.normalizeMimeType=t}),define(Z[96],ee([0,1,5]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(n){return n.toJSON()}class L{constructor(w){this._uriTransformer=w}transformIncoming(w){const g=this._uriTransformer.transformIncoming(w);return g===w?w:R(E.URI.from(g))}transformOutgoing(w){const g=this._uriTransformer.transformOutgoing(w);return g===w?w:R(E.URI.from(g))}transformOutgoingURI(w){const g=this._uriTransformer.transformOutgoing(w);return g===w?w:E.URI.from(g)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function k(n,w,g){if(!n||g>200)return null;if(typeof n=="object"){if(n instanceof E.URI)return w.transformOutgoing(n);for(let m in n)if(Object.hasOwnProperty.call(n,m)){const u=k(n[m],w,g+1);u!==null&&(n[m]=u)}}return null}function A(n,w){const g=k(n,w,0);return g===null?n:g}e.transformOutgoingURIs=A;function P(n,w,g,m){if(!n||m>200)return null;if(typeof n=="object"){if(n.$mid===1)return g?E.URI.revive(w.transformIncoming(n)):w.transformIncoming(n);for(let u in n)if(Object.hasOwnProperty.call(n,u)){const I=P(n[u],w,g,m+1);I!==null&&(n[u]=I)}}return null}function p(n,w){const g=P(n,w,!1,0);return g===null?n:g}e.transformIncomingURIs=p;function y(n,w){const g=P(n,w,!0,0);return g===null?n:g}e.transformAndReviveIncomingURIs=y}),define(Z[30],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(p){return E.test(p)}e.isUUID=R;const L=new Uint8Array(16),k=[];for(let p=0;p<256;p++)k.push(p.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(p){for(let y=0;y<p.length;y++)p[y]=Math.floor(Math.random()*256);return p};function P(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let p=0,y="";return y+=k[L[p++]],y+=k[L[p++]],y+=k[L[p++]],y+=k[L[p++]],y+="-",y+=k[L[p++]],y+=k[L[p++]],y+="-",y+=k[L[p++]],y+=k[L[p++]],y+="-",y+=k[L[p++]],y+=k[L[p++]],y+="-",y+=k[L[p++]],y+=k[L[p++]],y+=k[L[p++]],y+=k[L[p++]],y+=k[L[p++]],y+=k[L[p++]],y}e.generateUuid=P}),define(Z[68],ee([0,1,218]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(k="utf8"){this.stringDecoder=new E.StringDecoder(k),this.remaining=null}write(k){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(P.length<1)return A;let p=0,y,n=p;for(;n<P.length;)if(y=P.charCodeAt(n),y===13||y===10){if(A.push(P.substring(p,n)),n++,n<P.length){const w=y;y=P.charCodeAt(n),(w===13&&y===10||w===10&&y===13)&&n++}p=n}else n++;return this.remaining=p<P.length?P.substr(p):null,A}end(){return this.remaining}}e.LineDecoder=R}),define(Z[97],ee([0,1,34]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(P){const p=P.replace(/\-/g,":").toLowerCase();return!R.has(p)}function k(){return new Promise(async(P,p)=>{const y=setTimeout(()=>p("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await A())}catch(n){p(n)}finally{clearTimeout(y)}})}e.getMac=k;function A(){return new Promise((P,p)=>{try{const y=(0,E.networkInterfaces)();for(let n in y){const w=y[n];if(w){for(const{mac:g}of w)if(L(g))return P(g)}}p("Unable to retrieve mac address (unexpected format)")}catch(y){p(y)}})}}),define(Z[98],ee([0,1,34,11,40,30,97]),function(K,e,E,R,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,w=0;const g=(0,E.networkInterfaces)();for(let m in g){const u=g[m];if(u)for(const{mac:I,internal:C}of u)C||(w+=1,this._isVirtualMachineMacAdress(I.toUpperCase())&&(n+=1))}this._value=w>0?n/w:0}return this._value}};let P;async function p(){return P||(P=(async()=>await y()||k.generateUuid())()),P}e.getMachineId=p;async function y(){try{const n=await new Promise((g,m)=>{K(["crypto"],g,m)}),w=await(0,A.getMac)();return n.createHash("sha256").update(w,"utf8").digest("hex")}catch(n){R.onUnexpectedError(n);return}}}),define(Z[18],ee([0,1,50,34,219,6,39,66,8,4,15,5,30]),function(K,e,E,R,L,k,A,P,p,y,n,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function u(U,$=m.UNLINK){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return $===m.UNLINK?C(U):I(U)}async function I(U){try{const $=(0,p.join)((0,R.tmpdir)(),(0,g.generateUuid)());try{await e.Promises.rename(U,$)}catch(M){return C(U)}C($).catch(M=>{})}catch($){if($.code!=="ENOENT")throw $}}async function C(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function b(U){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");E.rmdirSync(U,{recursive:!0})}e.rimrafSync=b;async function D(U,$){return a(await($?v(U):(0,L.promisify)(E.readdir)(U)))}async function v(U){try{return await(0,L.promisify)(E.readdir)(U,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const $=[],M=await D(U);for(const N of M){let q=!1,F=!1,j=!1;try{const _=await e.Promises.lstat((0,p.join)(U,N));q=_.isFile(),F=_.isDirectory(),j=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}$.push({name:N,isFile:()=>q,isDirectory:()=>F,isSymbolicLink:()=>j})}return $}function o(U){return a(E.readdirSync(U))}e.readdirSync=o;function a(U){return U.map($=>typeof $=="string"?y.isMacintosh?(0,P.normalizeNFC)($):$:($.name=y.isMacintosh?(0,P.normalizeNFC)($.name):$.name,$))}async function t(U){const $=await D(U),M=[];for(const N of $)await i.existsDirectory((0,p.join)(U,N))&&M.push(N);return M}function r(U,$=1e3){return new Promise(M=>{let N=!1;const q=setInterval(()=>{N||(N=!0,E.access(U,F=>{N=!1,F&&(clearInterval(q),M(void 0))}))},$)})}e.whenDeleted=r;var i;(function(U){async function $(q){let F;try{if(F=await e.Promises.lstat(q),!F.isSymbolicLink())return{stat:F}}catch(j){}try{return{stat:await e.Promises.stat(q),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(y.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw _}throw j}}U.stat=$;async function M(q){try{const{stat:F,symbolicLink:j}=await U.stat(q);return F.isFile()&&j?.dangling!==!0}catch(F){}return!1}U.existsFile=M;async function N(q){try{const{stat:F,symbolicLink:j}=await U.stat(q);return F.isDirectory()&&j?.dangling!==!0}catch(F){}return!1}U.existsDirectory=N})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new k.ResourceQueue;function h(U,$,M){return s.queueFor(w.URI.file(U),n.extUriBiasedIgnorePathCase).queue(()=>{const N=S(M);return new Promise((q,F)=>l(U,$,N,j=>j?F(j):q()))})}let c=!0;function l(U,$,M,N){if(!c)return E.writeFile(U,$,{mode:M.mode,flag:M.flag},N);E.open(U,M.flag,M.mode,(q,F)=>{if(q)return N(q);E.writeFile(F,$,j=>{if(j)return E.close(F,()=>N(j));E.fdatasync(F,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),c=!1),E.close(F,G=>N(G))))})})}function f(U,$,M){const N=S(M);if(!c)return E.writeFileSync(U,$,{mode:N.mode,flag:N.flag});const q=E.openSync(U,N.flag,N.mode);try{E.writeFileSync(q,$);try{E.fdatasyncSync(q)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),c=!1}}finally{E.closeSync(q)}}e.writeFileSync=f;function S(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function d(U,$){if(U===$)return;async function M(N){try{const q=await e.Promises.lstat(N);if(q.isDirectory()||q.isSymbolicLink())return;await e.Promises.utimes(N,q.atime,new Date)}catch(q){}}try{await e.Promises.rename(U,$),await M($)}catch(N){if(U.toLowerCase()!==$.toLowerCase()&&N.code==="EXDEV"||U.endsWith("."))await T(U,$,{preserveSymlinks:!1}),await u(U,m.MOVE),await M($);else throw N}}async function T(U,$,M){return x(U,$,{root:{source:U,target:$},options:M,handledSourcePaths:new Set})}const O=511;async function x(U,$,M){if(M.handledSourcePaths.has(U))return;M.handledSourcePaths.add(U);const{stat:N,symbolicLink:q}=await i.stat(U);if(q){if(M.options.preserveSymlinks)try{return await V(U,$,M)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(q.dangling)return}return N.isDirectory()?z(U,$,N.mode&O,M):H(U,$,N.mode&O)}async function z(U,$,M,N){await e.Promises.mkdir($,{recursive:!0,mode:M});const q=await D(U);for(const F of q)await x((0,p.join)(U,F),(0,p.join)($,F),N)}async function H(U,$,M){await e.Promises.copyFile(U,$),await e.Promises.chmod($,M)}async function V(U,$,M){let N=await e.Promises.readlink(U);(0,A.isEqualOrParent)(N,M.root.source,!y.isLinux)&&(N=(0,p.join)(M.root.target,N.substr(M.root.source.length+1))),await e.Promises.symlink(N,$)}e.Promises=new class{get access(){return(0,L.promisify)(E.access)}get stat(){return(0,L.promisify)(E.stat)}get lstat(){return(0,L.promisify)(E.lstat)}get utimes(){return(0,L.promisify)(E.utimes)}get read(){return(0,L.promisify)(E.read)}get readFile(){return(0,L.promisify)(E.readFile)}get write(){return(0,L.promisify)(E.write)}get appendFile(){return(0,L.promisify)(E.appendFile)}get fdatasync(){return(0,L.promisify)(E.fdatasync)}get truncate(){return(0,L.promisify)(E.truncate)}get rename(){return(0,L.promisify)(E.rename)}get copyFile(){return(0,L.promisify)(E.copyFile)}get open(){return(0,L.promisify)(E.open)}get close(){return(0,L.promisify)(E.close)}get symlink(){return(0,L.promisify)(E.symlink)}get readlink(){return(0,L.promisify)(E.readlink)}get chmod(){return(0,L.promisify)(E.chmod)}get mkdir(){return(0,L.promisify)(E.mkdir)}get unlink(){return(0,L.promisify)(E.unlink)}get rmdir(){return(0,L.promisify)(E.rmdir)}get realpath(){return(0,L.promisify)(E.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return D}get readDirsInDir(){return t}get writeFile(){return h}get rm(){return u}get move(){return d}get copy(){return T}}}),define(Z[99],ee([0,1,50,8,19,18]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(n){const w=(0,R.dirname)(n);if(n===w)return n;const g=((0,R.basename)(n)||n).toLowerCase();try{const u=(0,k.readdirSync)(w).filter(I=>I.toLowerCase()===g);if(u.length===1){const I=A(w);if(I)return(0,R.join)(I,u[0])}else if(u.length>1){const I=u.indexOf(g);if(I>=0){const C=A(w);if(C)return(0,R.join)(C,u[I])}}}catch(m){}return null}e.realcaseSync=A;async function P(n){try{return await k.Promises.realpath(n)}catch(w){const g=y(n);return await k.Promises.access(g,E.constants.R_OK),g}}e.realpath=P;function p(n){try{return E.realpathSync(n)}catch(w){const g=y(n);return E.accessSync(g,E.constants.R_OK),g}}e.realpathSync=p;function y(n){return(0,L.rtrim)((0,R.normalize)(n),R.sep)}}),define(Z[69],ee([0,1,34,8,18]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var p;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(p||(p={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class w{constructor(a,t,r){this.exePath=a,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:o=!1}={}){return o?y===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:o=!1,findPreview:a=!1}={}){const t=g({useAlternateBitness:o});if(!t)return null;const r=R.join(t,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(r))return null;let i=-1,s=null;for(const l of await L.Promises.readdir(r)){let f=-1;if(a){const d=l.indexOf("-");if(d<0)continue;const T=l.substring(0,d);if(!k.test(T)||l.substring(d+1)!=="preview")continue;f=parseInt(T,10)}else{if(!k.test(l))continue;f=parseInt(l,10)}if(f<=i)continue;const S=R.join(r,l,"pwsh.exe");!await L.SymlinkSupport.existsFile(S)||(s=S,i=f)}if(!s)return null;const h=t.includes("x86")?" (x86)":"",c=a?" Preview":"";return new w(s,`PowerShell${c}${h}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const a=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=o?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await L.Promises.readdir(a))if(t.test(i)){const s=R.join(a,i,"pwsh.exe");return new w(s,r)}return null}function I(){const o=R.join(E.homedir(),".dotnet","tools","pwsh.exe");return new w(o,".NET Core PowerShell Global Tool")}function C(){const o=R.join(process.env.windir,y===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(o,"Windows PowerShell",!0)}async function*b(){let o=await m();o&&(yield o),o=await m({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=I(),o&&(yield o),o=await m({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await m({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=C(),o&&(yield o)}async function*D(){for await(const o of b())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=D;async function v(){for await(const o of D())return o;return null}e.getFirstAvailablePowerShellInstallation=v}),define(Z[100],ee([0,1,41,17]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(A){return new Promise((P,p)=>{let y;const n=new Map;function w(m,u,I,C,b){const D=n.get(u);if(m===A||D){const v={name:g(I),cmd:I,pid:m,ppid:u,load:C,mem:b};n.set(m,v),m===A&&(y=v),D&&(D.children||(D.children=[]),D.children.push(v),D.children.length>1&&(D.children=D.children.sort((o,a)=>o.pid-a.pid)))}}function g(m){const u=/--disable-blink-features=Auxclick/,I=/\\watcher\\win32\\CodeHelper\.exe/,C=/--crashes-directory/,b=/\\pipe\\winpty-control/,D=/conhost\.exe/,v=/--type=([a-zA-Z-]+)/;if(I.exec(m))return"watcherService ";if(C.exec(m))return"electron-crash-reporter";if(b.exec(m))return"winpty-process";if(D.exec(m))return"console-window-host (Windows internal process)";let o=v.exec(m);if(o&&o.length===2)return o[1]==="renderer"?u.exec(m)?"shared-process":"window":o[1];const a=/[a-zA-Z-]+\.js/g;let t="";do o=a.exec(m),o&&(t+=o+" ");while(o);return t&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${t}`:m}if(process.platform==="win32"){const m=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,I)=>{K(["windows-process-tree"],u,I)}).then(u=>{u.getProcessList(A,I=>{u.getProcessCpuUsage(I,C=>{const b=new Map;C.forEach(D=>{const v=m(D.commandLine||"");b.set(D.pid,{name:g(v),cmd:v,pid:D.pid,ppid:D.ppid,load:D.cpu||0,mem:D.memory||0})}),y=b.get(A),y?(b.forEach(D=>{const v=b.get(D.ppid);v&&(v.children||(v.children=[]),v.children.push(D))}),b.forEach(D=>{D.children&&(D.children=D.children.sort((v,o)=>v.pid-o.pid))}),P(y)):p(new Error(`Root process ${A} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let m=function(){let u=[y];const I=[];for(;u.length;){const b=u.shift();b&&(I.push(b.pid),b.children&&(u=u.concat(b.children)))}let C=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);C+=" "+I.join(" "),(0,E.exec)(C,{},(b,D,v)=>{if(b||v)p(b||new Error(v.toString()));else{const o=D.toString().split(`
`);for(let a=0;a<I.length;a++){const t=n.get(I[a]);t.load=parseFloat(o[a])}if(!y){p(new Error(`Root process ${A} not found`));return}P(y)}})};(0,E.exec)("which ps",{},(u,I,C)=>{if(u||C)if(process.platform!=="linux")p(u||new Error(C.toString()));else{const b=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,E.exec)(b,{},(D,v,o)=>{D||o?p(D||new Error(o.toString())):(k(v,w),m())})}else{const b=I.toString().trim(),D="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${b} ${D}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,o,a)=>{v||a&&!a.includes("screen size is bogus")?p(v||new Error(a.toString())):(k(o,w),process.platform==="linux"?m():y?P(y):p(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=L;function k(A,P){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=A.toString().split(`
`);for(const n of y){const w=p.exec(n.trim());w&&w.length===6&&P(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(Z[101],ee([0,1,50,39,2,66,8,4,18]),function(K,e,E,R,L,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function y(g,m,u){return w({path:g,isDirectory:!1},m,u)}e.watchFile=y;function n(g,m,u){return w({path:g,isDirectory:!0},m,u)}e.watchFolder=n,e.CHANGE_BUFFER_DELAY=100;function w(g,m,u){if(P.isMacintosh&&(0,R.isEqualOrParent)(g.path,"/Volumes/"))return u(`Refusing to watch ${g.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const I=(0,A.basename)(g.path),C=new Map;let b=!1,D=[(0,L.toDisposable)(()=>{C.forEach(v=>(0,L.dispose)(v)),C.clear()})];try{const v=(0,E.watch)(g.path);D.push((0,L.toDisposable)(()=>{v.removeAllListeners(),v.close()}));const o=new Set;g.isDirectory&&p.Promises.readdir(g.path).then(a=>a.forEach(t=>o.add(t))),v.on("error",(a,t)=>{b||u(`Failed to watch ${g.path} for changes using fs.watch() (${a}, ${t})`)}),v.on("change",(a,t)=>{if(b)return;let r="";if(t&&(r=t.toString(),P.isMacintosh&&(r=(0,k.normalizeNFC)(r))),!r||a!=="change"&&a!=="rename")return;const i=g.isDirectory?(0,A.join)(g.path,r):g.path;if(g.isDirectory)if(a==="rename"){const s=C.get(i);s&&(0,L.dispose)(s);const h=setTimeout(async()=>{C.delete(i);const c=await p.Promises.exists(i);if(b)return;let l;c?o.has(r)?l="changed":(l="added",o.add(r)):(o.delete(r),l="deleted"),m(l,i)},e.CHANGE_BUFFER_DELAY);C.set(i,(0,L.toDisposable)(()=>clearTimeout(h)))}else{let s;o.has(r)?s="changed":(s="added",o.add(r)),m(s,i)}else if(a==="rename"||r!==I){const s=setTimeout(async()=>{const h=await p.Promises.exists(i);b||(h?(m("changed",i),D=[w(g,m,u)]):m("deleted",i))},e.CHANGE_BUFFER_DELAY);(0,L.dispose)(D),D=[(0,L.toDisposable)(()=>clearTimeout(s))]}else m("changed",i)})}catch(v){p.Promises.exists(g.path).then(o=>{o&&!b&&u(`Failed to watch ${g.path} for changes using fs.watch() (${v.toString()})`)})}return(0,L.toDisposable)(()=>{b=!0,D=(0,L.dispose)(D)})}});var de=this&&this.__decorate||function(K,e,E,R){var L=arguments.length,k=L<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,E):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(K,e,E,R);else for(var P=K.length-1;P>=0;P--)(A=K[P])&&(k=(L<3?A(k):L>3?A(e,E,k):A(e,E))||k);return L>3&&k&&Object.defineProperty(e,E,k),k};define(Z[36],ee([0,1,23,6,25,29,64,11,3,2,94,19,16]),function(K,e,E,R,L,k,A,P,p,y,n,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function u(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var I;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(I=e.ResponseType||(e.ResponseType={}));function C(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(b||(b={}));class D{constructor(F){this.buffer=F,this.pos=0}read(F){const j=this.buffer.slice(this.pos,this.pos+F);return this.pos+=j.byteLength,j}}class v{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var o;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(o||(o={}));function a(q){const F=L.VSBuffer.alloc(4);return F.writeUInt32BE(q,0),F}function t(q){return q.read(4).readUInt32BE(0)}function r(q){const F=L.VSBuffer.alloc(1);return F.writeUInt8(q,0),F}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object)},s=typeof Buffer!="undefined";function h(q,F){if(typeof F=="undefined")q.write(i.Undefined);else if(typeof F=="string"){const j=L.VSBuffer.fromString(F);q.write(i.String),q.write(a(j.byteLength)),q.write(j)}else if(s&&Buffer.isBuffer(F)){const j=L.VSBuffer.wrap(F);q.write(i.Buffer),q.write(a(j.byteLength)),q.write(j)}else if(F instanceof L.VSBuffer)q.write(i.VSBuffer),q.write(a(F.byteLength)),q.write(F);else if(Array.isArray(F)){q.write(i.Array),q.write(a(F.length));for(const j of F)h(q,j)}else{const j=L.VSBuffer.fromString(JSON.stringify(F));q.write(i.Object),q.write(a(j.byteLength)),q.write(j)}}function c(q){switch(q.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return q.read(t(q)).toString();case o.Buffer:return q.read(t(q)).buffer;case o.VSBuffer:return q.read(t(q));case o.Array:{const j=t(q),_=[];for(let G=0;G<j;G++)_.push(c(q));return _}case o.Object:return JSON.parse(q.read(t(q)).toString())}}class l{constructor(F,j,_=null,G=1e3){this.protocol=F,this.ctx=j,this.logger=_,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(F,j){this.channels.set(F,j),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const j=this.send([F.type]);this.logger&&this.logger.logOutgoing(j,0,1,C(F.type));return}case 201:case 202:case 204:case 203:{const j=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(j,F.id,1,C(F.type),F.data);return}}}send(F,j=void 0){const _=new v;return h(_,F),h(_,j),this.sendBuffer(_.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(j){return 0}}onRawMessage(F){const j=new D(F),_=c(j),G=c(j),B=_[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,_[1],1,`${u(B)}: ${_[2]}.${_[3]}`,G),this.onPromise({type:B,id:_[1],channelName:_[2],name:_[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,_[1],1,`${u(B)}: ${_[2]}.${_[3]}`,G),this.onEventListen({type:B,id:_[1],channelName:_[2],name:_[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,_[1],1,`${u(B)}`),this.disposeActiveRequest({type:B,id:_[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,_[1],1,`${u(B)}`),this.disposeActiveRequest({type:B,id:_[1]})}}onPromise(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const _=new k.CancellationTokenSource;let G;try{G=j.call(this.ctx,F.name,F.arg,_.token)}catch(Q){G=Promise.reject(Q)}const B=F.id;G.then(Q=>{this.sendResponse({id:B,data:Q,type:201}),this.activeRequests.delete(F.id)},Q=>{Q instanceof Error?this.sendResponse({id:B,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.sendResponse({id:B,data:Q,type:203}),this.activeRequests.delete(F.id)});const X=(0,y.toDisposable)(()=>_.cancel());this.activeRequests.set(F.id,X)}onEventListen(F){const j=this.channels.get(F.channelName);if(!j){this.collectPendingRequest(F);return}const _=F.id,B=j.listen(this.ctx,F.name,F.arg)(X=>this.sendResponse({id:_,data:X,type:204}));this.activeRequests.set(F.id,B)}disposeActiveRequest(F){const j=this.activeRequests.get(F.id);j&&(j.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let j=this.pendingRequests.get(F.channelName);j||(j=[],this.pendingRequests.set(F.channelName,j));const _=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:F,timeoutTimer:_})}flushPendingRequests(F){const j=this.pendingRequests.get(F);if(j){for(const _ of j)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.onPromise(_.request);break;case 102:this.onEventListen(_.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var f;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(F,j=null){this.protocol=F,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(_=>this.onBuffer(_)),this.logger=j}getChannel(F){const j=this;return{call(_,G,B){return j.isDisposed?Promise.reject(P.canceled()):j.requestPromise(F,_,G,B)},listen(_,G){return j.isDisposed?Promise.reject(P.canceled()):j.requestEvent(F,_,G)}}}requestPromise(F,j,_,G=k.CancellationToken.None){const B=this.lastRequestId++,Q={id:B,type:100,channelName:F,name:j,arg:_};if(G.isCancellationRequested)return Promise.reject(P.canceled());let ie;return new Promise((le,fe)=>{if(G.isCancellationRequested)return fe(P.canceled());const ye=()=>{const Ne=Oe=>{switch(Oe.type){case 201:this.handlers.delete(B),le(Oe.data);break;case 202:this.handlers.delete(B);const Ae=new Error(Oe.data.message);Ae.stack=Oe.data.stack,Ae.name=Oe.data.name,fe(Ae);break;case 203:this.handlers.delete(B),fe(Oe.data);break}};this.handlers.set(B,Ne),this.sendRequest(Q)};let Se=null;this.state===b.Idle?ye():(Se=(0,R.createCancelablePromise)(Ne=>this.whenInitialized()),Se.then(()=>{Se=null,ye()}));const Pe=()=>{Se?(Se.cancel(),Se=null):this.sendRequest({id:B,type:101}),fe(P.canceled())},Te=G.onCancellationRequested(Pe);ie=(0,y.combinedDisposable)((0,y.toDisposable)(Pe),Te),this.activeRequests.add(ie)}).finally(()=>{this.activeRequests.delete(ie)})}requestEvent(F,j,_){const G=this.lastRequestId++,X={id:G,type:102,channelName:F,name:j,arg:_};let Q=null;const ie=new p.Emitter({onFirstListenerAdd:()=>{Q=(0,R.createCancelablePromise)(le=>this.whenInitialized()),Q.then(()=>{Q=null,this.activeRequests.add(ie),this.sendRequest(X)})},onLastListenerRemove:()=>{Q?(Q.cancel(),Q=null):(this.activeRequests.delete(ie),this.sendRequest({id:G,type:103}))}}),ne=le=>ie.fire(le.data);return this.handlers.set(G,ne),ie.event}sendRequest(F){switch(F.type){case 100:case 102:{const j=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(j,F.id,0,`${u(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const j=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(j,F.id,0,u(F.type));return}}}send(F,j=void 0){const _=new v;return h(_,F),h(_,j),this.sendBuffer(_.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(j){return 0}}onBuffer(F){const j=new D(F),_=c(j),G=c(j),B=_[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,C(B)),this.onResponse({type:_[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,_[1],0,C(B),G),this.onResponse({type:_[0],id:_[1],data:G})}}onResponse(F){if(F.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(F.id);j&&j(F)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}de([A.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class d{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:j,onDidClientDisconnect:_})=>{p.Event.once(j.onMessage)(B=>{const X=new D(B),Q=c(X),ie=new l(j,Q),ne=new S(j);this.channels.forEach((fe,ye)=>ie.registerChannel(ye,fe));const le={channelServer:ie,channelClient:ne,ctx:Q};this._connections.add(le),this._onDidAddConnection.fire(le),_(()=>{ie.dispose(),ne.dispose(),this._connections.delete(le),this._onDidRemoveConnection.fire(le)})})})}get connections(){const F=[];return this._connections.forEach(j=>F.push(j)),F}getChannel(F,j){const _=this;return{call(G,B,X){let Q;if((0,g.isFunction)(j)){let ne=(0,E.getRandomElement)(_.connections.filter(j));Q=ne?Promise.resolve(ne):p.Event.toPromise(p.Event.filter(_.onDidAddConnection,j))}else Q=j.routeCall(_,G,B);const ie=Q.then(ne=>ne.channelClient.getChannel(F));return O(ie).call(G,B,X)},listen(G,B){if((0,g.isFunction)(j))return _.getMulticastEvent(F,j,G,B);const X=j.routeEvent(_,G,B).then(Q=>Q.channelClient.getChannel(F));return O(X).listen(G,B)}}}getMulticastEvent(F,j,_,G){const B=this;let X=new y.DisposableStore;const Q=new p.Emitter({onFirstListenerAdd:()=>{X=new y.DisposableStore;const ie=new p.EventMultiplexer,ne=new Map,le=ye=>{const Pe=ye.channelClient.getChannel(F).listen(_,G),Te=ie.add(Pe);ne.set(ye,Te)},fe=ye=>{const Se=ne.get(ye);!Se||(Se.dispose(),ne.delete(ye))};B.connections.filter(j).forEach(le),p.Event.filter(B.onDidAddConnection,j)(le,void 0,X),B.onDidRemoveConnection(fe,void 0,X),ie.event(Q.fire,Q,X),X.add(ie)},onLastListenerRemove:()=>{X.dispose()}});return Q.event}registerChannel(F,j){this.channels.set(F,j),this._connections.forEach(_=>{_.channelServer.registerChannel(F,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=d;class T{constructor(F,j,_=null){const G=new v;h(G,j),F.send(G.buffer),this.channelClient=new S(F,_),this.channelServer=new l(F,j,_)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,j){this.channelServer.registerChannel(F,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function O(q){return{call(F,j,_){return q.then(G=>G.call(F,j,_))},listen(F,j){const _=new p.Relay;return q.then(G=>_.input=G.listen(F,j)),_.event}}}e.getDelayedChannel=O;function x(q){let F=!1;return{call(j,_,G){return F?q.call(j,_,G):(0,R.timeout)(0).then(()=>F=!0).then(()=>q.call(j,_,G))},listen(j,_){if(F)return q.listen(j,_);const G=new p.Relay;return(0,R.timeout)(0).then(()=>F=!0).then(()=>G.input=q.listen(j,_)),G.event}}}e.getNextTickChannel=x;class z{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const j of F.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await p.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=z;var H;(function(q){function F(G,B){const X=G,Q=B&&B.disableMarshalling,ie=new Map;for(const ne in X)_(ne)&&ie.set(ne,p.Event.buffer(X[ne],!0));return new class{listen(ne,le){const fe=ie.get(le);if(fe)return fe;throw new Error(`Event not found: ${le}`)}call(ne,le,fe){const ye=X[le];if(typeof ye=="function"){if(!Q&&Array.isArray(fe))for(let Se=0;Se<fe.length;Se++)fe[Se]=(0,n.revive)(fe[Se]);return ye.apply(X,fe)}throw new Error(`Method not found: ${le}`)}}}q.fromService=F;function j(G,B){const X=B&&B.disableMarshalling;return new Proxy({},{get(Q,ie){if(typeof ie=="string")return B?.properties?.has(ie)?B.properties.get(ie):_(ie)?G.listen(ie):async function(...ne){let le;B&&!(0,g.isUndefinedOrNull)(B.context)?le=[B.context,...ne]:le=ne;const fe=await G.call(ie,le);return X?fe:(0,n.revive)(fe)};throw new Error(`Property not found: ${String(ie)}`)}})}q.toService=j;function _(G){return G[0]==="o"&&G[1]==="n"&&w.isUpperAsciiLetter(G.charCodeAt(2))}})(H=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let F=q.toString();if(F!=="[object Object]")return F}return q}function $(q){return Array.isArray(q)?q.map(U):U(q)}function M(q,F,j,_,G,B,X){X=$(X);const Q=V[G],ie=Q[_%Q.length];let ne=[`%c[${q}]%c[${String(F).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(B)?(ne=ne.concat(X),ne.push(")")):ne.push(X),console.log.apply(console,ne)}e.logWithColors=M;class N{constructor(F,j){this._outgoingPrefix=F,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,j,_,G,B){this._totalOutgoing+=F,M(this._outgoingPrefix,this._totalOutgoing,F,j,_,G,B)}logIncoming(F,j,_,G,B){this._totalIncoming+=F,M(this._incomingPrefix,this._totalIncoming,F,j,_,G,B)}}e.IPCLogger=N}),define(Z[102],ee([0,1,25,3,36]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(p){this.port=p,this.onMessage=R.Event.fromDOMEventEmitter(this.port,"message",y=>E.VSBuffer.wrap(y.data)),p.start()}send(p){this.port.postMessage(p.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class A extends L.IPCClient{constructor(p,y){const n=new k(p);super(n,y);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=A}),define(Z[103],ee([0,1,104,3,36,102]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends L.IPCServer{static getOnDidClientConnect(){const p=R.Event.fromNodeEventEmitter(E.ipcRenderer,"vscode:createMessageChannel",(y,n)=>n);return R.Event.map(p,y=>{const{port1:n,port2:w}=new MessageChannel,m={protocol:new k.Protocol(n),onDidClientDisconnect:R.Event.fromDOMEventEmitter(n,"close")};return E.ipcRenderer.postMessage("vscode:createMessageChannelResult",y,[w]),m})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(Z[105],ee([0,1,25,11]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(P,p){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const y=new XMLHttpRequest;return new Promise((n,w)=>{y.open(P.type||"GET",P.url||"",!0,P.user,P.password),k(y,P),y.responseType="arraybuffer",y.onerror=g=>w(new Error(y.statusText&&"XHR failed: "+y.statusText||"XHR failed")),y.onload=g=>{n({res:{statusCode:y.status,headers:A(y)},stream:(0,E.bufferToStream)(E.VSBuffer.wrap(new Uint8Array(y.response)))})},y.ontimeout=g=>w(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(y.timeout=P.timeout),y.send(P.data),p.onCancellationRequested(()=>{y.abort(),w((0,R.canceled)())})})}e.request=L;function k(P,p){if(p.headers){e:for(let y in p.headers){switch(y){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(y,p.headers[y])}}}function A(P){const p=Object.create(null);for(const y of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(y){const n=y.indexOf(":");p[y.substr(0,n).trim().toLowerCase()]=y.substr(n+1).trim()}return p}}),define(Z[70],ee([0,1,6,3,2,16]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var A;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));var P;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(P||(P={}));class p extends L.Disposable{constructor(w,g=Object.create(null)){super();this.database=w,this.options=g,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new E.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(w=>this.onDidChangeItemsExternal(w)))}onDidChangeItemsExternal(w){w.changed?.forEach((g,m)=>this.accept(m,g)),w.deleted?.forEach(g=>this.accept(g,void 0))}accept(w,g){if(this.state===P.Closed)return;let m=!1;(0,k.isUndefinedOrNull)(g)?m=this.cache.delete(w):this.cache.get(w)!==g&&(this.cache.set(w,g),m=!0),m&&this._onDidChangeStorage.fire(w)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(w,g){const m=this.cache.get(w);return(0,k.isUndefinedOrNull)(m)?g:m}getBoolean(w,g){const m=this.get(w);return(0,k.isUndefinedOrNull)(m)?g:m==="true"}getNumber(w,g){const m=this.get(w);return(0,k.isUndefinedOrNull)(m)?g:parseInt(m,10)}async set(w,g){if(this.state===P.Closed)return;if((0,k.isUndefinedOrNull)(g))return this.delete(w);const m=String(g);if(this.cache.get(w)!==m)return this.cache.set(w,m),this.pendingInserts.set(w,m),this.pendingDeletes.delete(w),this._onDidChangeStorage.fire(w),this.flushDelayer.trigger(()=>this.flushPending())}async delete(w){if(!(this.state===P.Closed||!this.cache.delete(w)))return this.pendingDeletes.has(w)||this.pendingDeletes.add(w),this.pendingInserts.delete(w),this._onDidChangeStorage.fire(w),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(w){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const w={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(w).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(w=>this.whenFlushedCallbacks.push(w))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(w){w.insert&&w.insert.forEach((g,m)=>this.items.set(m,g)),w.delete&&w.delete.forEach(g=>this.items.delete(g))}async close(){}}e.InMemoryStorageDatabase=y}),define(Z[106],ee([9,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[56],ee([0,1,106]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,L=R*60,k=L*24,A=k*7,P=k*30,p=k*365;function y(w,g){typeof w!="number"&&(w=w.getTime());const m=Math.round((new Date().getTime()-w)/1e3);if(m<-30)return(0,E.localize)(0,null,y(new Date().getTime()+m*1e3,!1));if(m<30)return(0,E.localize)(1,null);let u;return m<R?(u=m,g?u===1?(0,E.localize)(2,null,u):(0,E.localize)(3,null,u):u===1?(0,E.localize)(4,null,u):(0,E.localize)(5,null,u)):m<L?(u=Math.floor(m/R),g?u===1?(0,E.localize)(6,null,u):(0,E.localize)(7,null,u):u===1?(0,E.localize)(8,null,u):(0,E.localize)(9,null,u)):m<k?(u=Math.floor(m/L),g?u===1?(0,E.localize)(10,null,u):(0,E.localize)(11,null,u):u===1?(0,E.localize)(12,null,u):(0,E.localize)(13,null,u)):m<A?(u=Math.floor(m/k),g?u===1?(0,E.localize)(14,null,u):(0,E.localize)(15,null,u):u===1?(0,E.localize)(16,null,u):(0,E.localize)(17,null,u)):m<P?(u=Math.floor(m/A),g?u===1?(0,E.localize)(18,null,u):(0,E.localize)(19,null,u):u===1?(0,E.localize)(20,null,u):(0,E.localize)(21,null,u)):m<p?(u=Math.floor(m/P),g?u===1?(0,E.localize)(22,null,u):(0,E.localize)(23,null,u):u===1?(0,E.localize)(24,null,u):(0,E.localize)(25,null,u)):(u=Math.floor(m/p),g?u===1?(0,E.localize)(26,null,u):(0,E.localize)(27,null,u):u===1?(0,E.localize)(28,null,u):(0,E.localize)(29,null,u))}e.fromNow=y;function n(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(Z[107],ee([9,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[37],ee([0,1,23,16,107]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(y,n){return n&&(y.stack||y.stacktrace)?L.localize(0,null,P(y),A(y.stack)||A(y.stacktrace)):P(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function P(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?L.localize(1,null,y.message):y.message||L.localize(2,null)}function p(y=null,n=!1){if(!y)return L.localize(3,null);if(Array.isArray(y)){const w=E.coalesce(y),g=p(w[0],n);return w.length>1?L.localize(4,null,g,w.length):g}if(R.isString(y))return y;if(y.detail){const w=y.detail;if(w.error)return k(w.error,n);if(w.exception)return k(w.exception,n)}return y.stack?k(y,n):y.message?y.message:L.localize(5,null)}e.toErrorMessage=p}),define(Z[108],ee([9,10]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[71],ee([0,1,41,39,17,26,8,4,35,16,68,18,108]),function(K,e,E,R,L,k,A,P,p,y,n,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function m(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(o,a){if(P.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const r=E.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(i=>{r.once("error",s=>{i({success:!1,error:s})}),r.once("exit",(s,h)=>{i(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?m(t.status):1})}else if(P.isLinux||P.isMacintosh)try{const t=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(r=>{E.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(i,s,h)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function I(o=p.env){return o.comspec||"cmd.exe"}e.getWindowsShell=I;class C{constructor(a,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=a,this.args=t,this.shell=r,this.options=i;else{const s=a;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(p.env).forEach(h=>{s[h]=p.env[h]}),Object.keys(this.options.env).forEach(h=>{s[h]=this.options.env[h]}),this.options.env=s}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(A.sep);return t!==-1&&(a=a.substring(t+1)),C.WellKnowCommands[a]?a:"other"}start(a){return P.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(p.cwd()))?Promise.reject(new Error(g.localize(0,null))):this.useExec().then(t=>{let r,i;const s=new Promise((h,c)=>{r=h,i=c});if(t){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=E.exec(h,this.options,(c,l,f)=>{this.childProcess=null;const S=c;S&&S.killed?i({killed:this.terminateRequested,stdout:l.toString(),stderr:f.toString()}):this.handleExec(r,a,c,l,f)})}else{let h=null;const c=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,r,a,i);const f={terminated:this.terminateRequested};y.isNumber(l)&&(f.cmdCode=l),r(f)};if(this.shell&&P.isWindows){const l=k.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let f=!1,S=!1;const d=[];let T=this.ensureQuotes(this.cmd);d.push(T.value),f=T.quoted,this.args&&this.args.forEach(x=>{T=this.ensureQuotes(x),d.push(T.value),S=S&&T.quoted});const O=["/s","/c"];f?S?O.push('"'+d.join(" ")+'"'):d.length>1?O.push('"'+d[0]+'" '+d.slice(1).join(" ")):O.push('"'+d[0]+'"'):O.push(d.join(" ")),h=E.spawn(I(),O,l)}else this.cmd&&(h=E.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(y.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",l=>{this.childProcess=null,i({terminated:this.terminateRequested,error:l})}),h.pid&&(this.childProcess.on("close",c),this.handleSpawn(h,r,a,i,!0)))}return s})}handleClose(a,t,r,i){}ensureQuotes(a){return C.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,u(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!P.isWindows)return a(!1);const t=E.spawn(I(),["/s","/c"]);t.on("error",r=>a(!0)),t.on("exit",r=>a(!1))})}}e.AbstractProcess=C,C.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},C.regexp=/^[^"].* .*[^"]/;class b extends C{constructor(a,t,r,i){super(a,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,r,i,s){[i,s].forEach((h,c)=>{const l=new n.LineDecoder;l.write(h).forEach(d=>{t({line:d,source:c===0?0:1})});const S=l.end();S&&t({line:S,source:c===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,t,r,i,s){const h=new n.LineDecoder,c=new n.LineDecoder;a.stdout.on("data",l=>{h.write(l).forEach(S=>r({line:S,source:0}))}),a.stderr.on("data",l=>{c.write(l).forEach(S=>r({line:S,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=c}handleClose(a,t,r,i){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&r({line:s,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&r({line:h,source:1})}}e.LineProcess=b;function D(o){let a=[],t=!1;const r=function(i){if(t){a.push(i);return}(!o.send(i,h=>{if(h&&console.error(h),t=!1,a.length>0){const c=a.slice(0);a=[],c.forEach(l=>r(l))}})||P.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=D;var v;(function(o){async function a(t,r,i){if(A.isAbsolute(t))return t;if(r===void 0&&(r=p.cwd()),A.dirname(t)!=="."||(i===void 0&&y.isString(p.env.PATH)&&(i=p.env.PATH.split(A.delimiter)),i===void 0||i.length===0))return A.join(r,t);async function h(c){return await w.Promises.exists(c)?!(await w.Promises.stat(c)).isDirectory():!1}for(let c of i){let l;if(A.isAbsolute(c)?l=A.join(c,t):l=A.join(r,c,t),await h(l))return l;let f=l+".com";if(await h(f)||(f=l+".exe",await h(f)))return f}return A.join(r,t)}o.findExecutable=a})(v=e.win32||(e.win32={}))}),define(Z[109],ee([0,1,34,4,69,71]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(m,u){return m===1?R.isWindows?w():k.getWindowsShell(u):y(m,u)}e.getSystemShell=A;function P(m,u){return m===1?R.isWindows?g(u):k.getWindowsShell(u):y(m,u)}e.getSystemShellSync=P;let p=null;function y(m,u){if(R.isLinux&&m===2||R.isMacintosh&&m===3)return"/bin/bash";if(!p){let I;if(R.isWindows)I="/bin/bash";else{if(I=u.SHELL,!I)try{I=(0,E.userInfo)().shell}catch(C){}I||(I="sh"),I==="/bin/false"&&(I="/bin/bash")}p=I}return p}let n=null;async function w(){return n||(n=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),n}function g(m){if(n)return n;const u=R.isWindows&&parseFloat((0,E.release)())>=10,I=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),C=`${m.windir}\\${I?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?C:k.getWindowsShell(m)}}),define(Z[51],ee([0,1,41,6,25,29,93,11,3,2,26,4,71,36]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends m.ChannelServer{constructor(b){super({send:D=>{try{process.send&&process.send(D.buffer.toString("base64"))}catch(v){}},onMessage:p.Event.fromNodeEventEmitter(process,"message",D=>L.VSBuffer.wrap(Buffer.from(D,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=u;class I{constructor(b,D){this.modulePath=b,this.options=D,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=D&&D.timeout?D.timeout:6e4;this.disposeDelayer=new R.Delayer(v),this.child=null,this._client=null}getChannel(b){const D=this;return{call(v,o,a){return D.requestPromise(b,v,o,a)},listen(v,o){return D.requestEvent(b,v,o)}}}requestPromise(b,D,v,o=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(b),t=(0,R.createCancelablePromise)(s=>a.call(D,v,s)),r=o.onCancellationRequested(()=>t.cancel()),i=(0,y.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,D,v){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let o;const a=new p.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(b).listen(D,v)(a.fire,a),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],D=Object.create(null);D.env={...(0,n.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(D.env={...D.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(D.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(D.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(D.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),D.execArgv===void 0&&(D.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h))),w.isMacintosh&&D.env&&delete D.env.DYLD_LIBRARY_PATH,this.child=(0,E.fork)(this.modulePath,b,D);const v=new p.Emitter;p.Event.fromNodeEventEmitter(this.child,"message",h=>h)(h=>{if((0,A.isRemoteConsoleLog)(h)){(0,A.log)(h,`IPC Library: ${this.options.serverName}`);return}v.fire(L.VSBuffer.wrap(Buffer.from(h,"base64")))});const a=this.options.useQueue?(0,g.createQueuedSender)(this.child):this.child,t=h=>this.child&&this.child.connected&&a.send(h.buffer.toString("base64")),r=v.event,i={send:t,onMessage:r};this._client=new m.ChannelClient(i);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",h=>console.warn('IPC "'+this.options.serverName+'" errored with '+h)),this.child.on("exit",(h,c)=>{process.removeListener("exit",s),this.activeRequests.forEach(l=>(0,y.dispose)(l)),this.activeRequests.clear(),h!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+h+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:h,signal:c})})}return this._client}getCachedChannel(b){let D=this.channels.get(b);return D||(D=this.client.getChannel(b),this.channels.set(b,D)),D}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=I}),define(Z[110],ee([9,10]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[111],ee([9,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[112],ee([9,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(Z[113],ee([9,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(Z[114],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[115],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[116],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[117],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[118],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[119],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[120],ee([9,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[121],ee([9,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[122],ee([9,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[123],ee([9,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[124],ee([9,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[125],ee([9,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[126],ee([9,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[127],ee([9,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[128],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[129],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[130],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[131],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[132],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[133],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[134],ee([0,1,8,15,64,56,17,5,35]),function(K,e,E,R,L,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class y{constructor(u,I,C){this._args=u,this.paths=I,this.productService=C}get appRoot(){return(0,E.dirname)(A.FileAccess.asFileUri("",K).fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file((0,E.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,E.join)(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file((0,E.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(P.URI.file((0,E.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return P.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return P.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=p.env.VSCODE_PORTABLE;return u?P.URI.file((0,E.join)(u,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,E.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,E.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,E.resolve)(u):(0,E.normalize)((0,E.join)(A.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=this.args["extensions-download-dir"];return u?(0,E.resolve)(u):(0,E.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,E.resolve)(u);const I=p.env.VSCODE_EXTENSIONS;if(I)return I;const C=p.env.VSCODE_PORTABLE;return C?(0,E.join)(C,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(I=>/^[^:/?#]+?:\/\//.test(I)?P.URI.parse(I):P.URI.file((0,E.normalize)(I)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?P.URI.parse(u):P.URI.file((0,E.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!p.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return P.URI.file((0,E.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([L.memoize],y.prototype,"appRoot",null),de([L.memoize],y.prototype,"userHome",null),de([L.memoize],y.prototype,"userDataPath",null),de([L.memoize],y.prototype,"appSettingsHome",null),de([L.memoize],y.prototype,"tmpDir",null),de([L.memoize],y.prototype,"userRoamingDataHome",null),de([L.memoize],y.prototype,"settingsResource",null),de([L.memoize],y.prototype,"userDataSyncHome",null),de([L.memoize],y.prototype,"userDataSyncLogResource",null),de([L.memoize],y.prototype,"sync",null),de([L.memoize],y.prototype,"machineSettingsResource",null),de([L.memoize],y.prototype,"globalStorageHome",null),de([L.memoize],y.prototype,"workspaceStorageHome",null),de([L.memoize],y.prototype,"keybindingsResource",null),de([L.memoize],y.prototype,"keyboardLayoutResource",null),de([L.memoize],y.prototype,"argvResource",null),de([L.memoize],y.prototype,"snippetsHome",null),de([L.memoize],y.prototype,"isExtensionDevelopment",null),de([L.memoize],y.prototype,"untitledWorkspacesHome",null),de([L.memoize],y.prototype,"installSourcePath",null),de([L.memoize],y.prototype,"builtinExtensionsPath",null),de([L.memoize],y.prototype,"extensionsPath",null),de([L.memoize],y.prototype,"extensionDevelopmentLocationURI",null),de([L.memoize],y.prototype,"extensionDevelopmentKind",null),de([L.memoize],y.prototype,"extensionTestsLocationURI",null),de([L.memoize],y.prototype,"debugExtensionHost",null),de([L.memoize],y.prototype,"serviceMachineIdResource",null),de([L.memoize],y.prototype,"telemetryLogResource",null),de([L.memoize],y.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=y;function n(m,u){return g(m["inspect-extensions"],m["inspect-brk-extensions"],5870,u,m.debugId)}e.parseExtensionHostPort=n;function w(m,u){return g(m["inspect-search"],m["inspect-brk-search"],5876,u)}e.parseSearchPort=w;function g(m,u,I,C,b){const v=Number(u||m)||(C?null:I),o=v?Boolean(!!u):!1;return{port:v,break:o,debugId:b}}}),define(Z[135],ee([0,1,220,112,4]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(u,I,C=A){const b={},D=[],v=[];for(let r in I){const i=I[r];i.alias&&(b[r]=i.alias),i.type==="string"||i.type==="string[]"?(D.push(r),i.deprecates&&D.push(i.deprecates)):i.type==="boolean"&&(v.push(r),i.deprecates&&v.push(i.deprecates))}const o=E(u,{string:D,boolean:v,alias:b}),a={},t=o;a._=o._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in I){const i=I[r];i.alias&&delete t[i.alias];let s=t[r];i.deprecates&&t.hasOwnProperty(i.deprecates)&&(s||(s=t[i.deprecates]),delete t[i.deprecates]),typeof s!="undefined"&&(i.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):i.type==="string"&&Array.isArray(s)&&(s=s.pop(),C.onMultipleValues(r,s)),a[r]=s),delete t[r]}for(let r in t)C.onUnknownOption(r);return a}e.parseArgs=P;function p(u,I){let C="";return I.args&&(Array.isArray(I.args)?C=` <${I.args.join("> <")}>`:C=` <${I.args}>`),I.alias?`-${I.alias} --${u}${C}`:`--${u}${C}`}function y(u,I){let C=0,b=[];for(const a in u){const t=u[a],r=p(a,t);C=Math.max(C,r.length),b.push([r,t.description])}let D=C+2+1;if(I-D<25)return b.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let v=I-D-1,o=[];for(const a of b){let t=a[0],r=w(a[1],v),i=n(D-t.length-2);o.push("  "+t+i+r[0]);for(let s=1;s<r.length;s++)o.push(n(D)+r[s])}return o}e.formatOptions=y;function n(u){return" ".repeat(u)}function w(u,I){let C=[];for(;u.length;){let b=u.length<I?u.length:u.lastIndexOf(" ",I),D=u.slice(0,b).trim();u=u.slice(b),C.push(D)}return C}function g(u,I,C,b,D=!0){const v=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${u} ${C}`];o.push(""),o.push(`${(0,R.localize)(32,null)}: ${I} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),o.push(""),D&&(L.isWindows?o.push((0,R.localize)(35,null,I)):o.push((0,R.localize)(36,null,I)),o.push(""));const a={};for(const t in b){const r=b[t];if(r.description&&r.cat){let i=a[r.cat];i||(a[r.cat]=i={}),i[t]=r}}for(let t in a){const r=t;let i=a[r];i&&(o.push(k[r]),o.push(...y(i,v)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=g;function m(u,I){return`${u||(0,R.localize)(37,null)}
${I||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=m}),function(){"use strict";function K(e,E,R,L){function k(P){const p=A(P),y=[p];return e.isAbsolute(p)||y.unshift(L),e.resolve(...y)}function A(P){const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,R);const n=P["user-data-dir"];if(n)return n;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(w,"AppData","Roaming")}break;case"darwin":y=e.join(E.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,R)}return{getUserDataPath:k}}if(typeof define=="function")define(Z[136],ee([0,137,34,17,15,35]),function(e,E,R,L,k,A){const P=k.dirname(L.FileAccess.asFileUri("",e)),p=e.__$__nodeRequire(k.joinPath(P,"package.json").fsPath);return K(E,R,p.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),E=require("path"),R=require("os");module.exports=K(E,R,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[138],ee([0,1,34,136,134]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends L.AbstractNativeEnvironmentService{constructor(P,p){super(P,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P)},p)}}e.NativeEnvironmentService=k}),define(Z[139],ee([0,1,5]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const R=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,p=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function y(C){const b=C.match(A);return b?b[1]:null}function n(C){if(C.indexOf("://")===-1){const b=C.match(R);return b?y(b[2]):null}try{const b=E.URI.parse(C);if(b.authority)return y(b.authority)}catch(b){}return null}function w(C,b){const D=new Set;let v;for(;v=P.exec(C);){const a=n(v[1]);a&&D.add(a)}const o=new Set(b);return Array.from(D).map(a=>o.has(a)?a:a.replace(p,"a"))}e.getDomainsOfRemotes=w;function g(C){const b=C.match(k);return b?b[2]:null}function m(C,b,D){return C&&b?(D&&b.endsWith(".git")&&(b=b.substr(0,b.length-4)),b.indexOf("/")===0?`${C}${b}`:`${C}/${b}`):null}function u(C,b){if(C.indexOf("://")===-1){const D=C.match(L);if(D)return m(D[2],D[3],b)}try{const D=E.URI.parse(C);if(D.authority)return m(g(D.authority),D.path,b)}catch(D){}return null}function I(C,b=!1){const D=[];let v;for(;v=P.exec(C);){const o=u(v[1],b);o&&D.push(o)}return D}e.getRemotes=I}),define(Z[140],ee([0,1,3,5,96,26,2]),function(K,e,E,R,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(u,I){return R.URI.revive(I?I.transformIncoming(u):u)}function p(u,I){return I?I.transformOutgoingURI(u):u}function y(u,I){I=I||L.DefaultURITransformer;const C=u.manifest;return{...(0,L.transformAndReviveIncomingURIs)({...u,manifest:void 0},I),manifest:C}}function n(u,I){return I?(0,k.cloneAndChange)(u,C=>C instanceof R.URI?I.transformOutgoingURI(C):void 0):u}class w{constructor(I,C){this.service=I,this.getUriTransformer=C,this.onInstallExtension=E.Event.buffer(I.onInstallExtension,!0),this.onDidInstallExtensions=E.Event.buffer(I.onDidInstallExtensions,!0),this.onUninstallExtension=E.Event.buffer(I.onUninstallExtension,!0),this.onDidUninstallExtension=E.Event.buffer(I.onDidUninstallExtension,!0)}listen(I,C){const b=this.getUriTransformer(I);switch(C){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return E.Event.map(this.onDidInstallExtensions,D=>D.map(v=>({...v,local:v.local?n(v.local,b):v.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(I,C,b){const D=this.getUriTransformer(I);switch(C){case"zip":return this.service.zip(y(b[0],D)).then(v=>p(v,D));case"unzip":return this.service.unzip(P(b[0],D));case"install":return this.service.install(P(b[0],D),b[1]);case"getManifest":return this.service.getManifest(P(b[0],D));case"canInstall":return this.service.canInstall(b[0]);case"installFromGallery":return this.service.installFromGallery(b[0],b[1]);case"uninstall":return this.service.uninstall(y(b[0],D),b[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(y(b[0],D));case"getInstalled":return this.service.getInstalled(b[0]).then(v=>v.map(o=>n(o,D)));case"updateMetadata":return this.service.updateMetadata(y(b[0],D),b[1]).then(v=>n(v,D));case"updateExtensionScope":return this.service.updateExtensionScope(y(b[0],D),b[1]).then(v=>n(v,D));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=w;class g extends A.Disposable{constructor(I){super();this.channel=I,this._onInstallExtension=this._register(new E.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new E.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new E.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new E.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(C=>this._onInstallExtension.fire({identifier:C.identifier,source:this.isUriComponents(C.source)?R.URI.revive(C.source):C.source}))),this._register(this.channel.listen("onDidInstallExtensions")(C=>this._onDidInstallExtensions.fire(C.map(b=>({...b,local:b.local?y(b.local,null):b.local,source:this.isUriComponents(b.source)?R.URI.revive(b.source):b.source}))))),this._register(this.channel.listen("onUninstallExtension")(C=>this._onUninstallExtension.fire(C))),this._register(this.channel.listen("onDidUninstallExtension")(C=>this._onDidUninstallExtension.fire(C)))}isUriComponents(I){return I?typeof I.path=="string"&&typeof I.scheme=="string":!1}zip(I){return Promise.resolve(this.channel.call("zip",[I]).then(C=>R.URI.revive(C)))}unzip(I){return Promise.resolve(this.channel.call("unzip",[I]))}install(I,C){return Promise.resolve(this.channel.call("install",[I,C])).then(b=>y(b,null))}getManifest(I){return Promise.resolve(this.channel.call("getManifest",[I]))}async canInstall(I){return!0}installFromGallery(I,C){return Promise.resolve(this.channel.call("installFromGallery",[I,C])).then(b=>y(b,null))}uninstall(I,C){return Promise.resolve(this.channel.call("uninstall",[I,C]))}reinstallFromGallery(I){return Promise.resolve(this.channel.call("reinstallFromGallery",[I]))}getInstalled(I=null){return Promise.resolve(this.channel.call("getInstalled",[I])).then(C=>C.map(b=>y(b,null)))}updateMetadata(I,C){return Promise.resolve(this.channel.call("updateMetadata",[I,C])).then(b=>y(b,null))}updateExtensionScope(I,C){return Promise.resolve(this.channel.call("updateExtensionScope",[I,C])).then(b=>y(b,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=g;class m{constructor(I){this.service=I}listen(I,C){throw new Error("Invalid listen")}call(I,C,b){switch(C){case"getConfigBasedTips":return this.service.getConfigBasedTips(R.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=m}),define(Z[141],ee([0,1,26]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const R=/^%([\w\d.-]+)%$/i;function L(k,A){const P=p=>{if(typeof p!="string")return;const y=R.exec(p);if(!y)return;const n=A[y[1]]??p;return typeof n=="string"?n:typeof n.message=="string"?n.message:p};return(0,E.cloneAndChange)(k,P)}e.localizeManifest=L}),define(Z[142],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class E{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,A,P,p){return this.channel.call("promptImportantExtensionsInstallNotification",[k,A,P,p])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=E;class R{constructor(k){this.service=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,P){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=R}),define(Z[72],ee([0,1,120]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function k(g){return g=g.trim(),g==="*"||R.test(g)}e.isValidVersionStr=k;function A(g){if(!k(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=g.match(R);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=A;function P(g){if(!g)return null;let m=g.majorBase,u=g.majorMustEqual,I=g.minorBase,C=g.minorMustEqual,b=g.patchBase,D=g.patchMustEqual;g.hasCaret&&(m===0||(C=!1),D=!1);let v=0;if(g.preRelease){const o=L.exec(g.preRelease);if(o){const[,a,t,r]=o;v=Date.UTC(Number(a),Number(t)-1,Number(r))}}return{majorBase:m,majorMustEqual:u,minorBase:I,minorMustEqual:C,patchBase:b,patchMustEqual:D,isMinimum:g.hasGreaterEquals,notBefore:v}}e.normalizeVersion=P;function p(g,m,u){let I;typeof g=="string"?I=P(A(g)):I=g;let C;m instanceof Date?C=m.getTime():typeof m=="string"&&(C=new Date(m).getTime());let b;if(typeof u=="string"?b=P(A(u)):b=u,!I||!b)return!1;let D=I.majorBase,v=I.minorBase,o=I.patchBase,a=b.majorBase,t=b.minorBase,r=b.patchBase,i=b.notBefore,s=b.majorMustEqual,h=b.minorMustEqual,c=b.patchMustEqual;return b.isMinimum?D>a?!0:D<a?!1:v>t?!0:v<t||C&&C<i?!1:o>=r:(D===1&&a===0&&(!s||!h||!c)&&(a=1,t=0,r=0,s=!0,h=!1,c=!1),D<a?!1:D>a?!s:v<t?!1:v>t?!h:o<r?!1:o>r?!c:!(C&&C<i))}e.isValidVersion=p;function y(g,m,u,I){return u.isBuiltin||typeof u.main=="undefined"?!0:w(g,m,u.engines.vscode,I)}e.isValidExtensionVersion=y;function n(g,m,u){return g==="*"||w(m,u,g)}e.isEngineValid=n;function w(g,m,u,I=[]){let C=P(A(u));if(!C)return I.push(E.localize(0,null,u)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return I.push(E.localize(1,null,u)),!1}else if(!C.majorMustEqual)return I.push(E.localize(2,null,u)),!1;return p(g,m,C)?!0:(I.push(E.localize(3,null,g,u)),!1)}}),define(Z[143],ee([0,1,36,51,2,17]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends L.Disposable{constructor(p,y,n,w){super();this.folders=p,this.onDidFilesChange=y,this.onLogMessage=n,this.verboseLogging=w,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new R.Client(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=E.ProxyChannel.toService((0,E.getNextTickChannel)(p.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.setFolders(this.folders)}setVerboseLogging(p){this.verboseLogging=p,!this.isDisposed&&this.service&&this.service.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${p}`})}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[144],ee([0,1,36,51,2,17]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends L.Disposable{constructor(p,y,n,w,g={}){super();this.folders=p,this.onDidFilesChange=y,this.onLogMessage=n,this.verboseLogging=w,this.watcherOptions=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new R.Client(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=E.ProxyChannel.toService((0,E.getNextTickChannel)(p.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.service.setRoots(this.folders)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${p}`})}setVerboseLogging(p){this.verboseLogging=p,this.service&&this.service.setVerboseLogging(p)}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[145],ee([0,1,41,68,67,17]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class A{constructor(p,y,n,w,g){this.watchedFolder=p,this.eventCallback=n,this.logCallback=w,this.verboseLogging=g,this.restartCounter=0,Array.isArray(y)?this.ignored=y.map(m=>(0,L.parse)(m)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${p}, excludes: ${y.join(",")}`),this.startWatcher()}startWatcher(){const p=[this.watchedFolder];this.verboseLogging&&p.push("-verbose"),this.handle=(0,E.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,p);const y=new R.LineDecoder;this.handle.stdout.on("data",n=>{const w=[];for(const g of y.write(n)){const m=g.split("|");if(m.length===2){const u=Number(m[0]),I=m[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(C=>C(I))){this.verboseLogging&&this.log(I);continue}w.push({type:A.changeTypeMap[u],path:I})}else this.log(m[1])}}w.length>0&&this.eventCallback(w)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,w)=>this.onExit(n,w))}onError(p){this.error("process error: "+p.toString())}onExit(p,y){this.handle&&(this.error(`terminated unexpectedly (code: ${p}, signal: ${y})`),this.restartCounter<=A.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(p){this.logCallback({type:"error",message:`[File Watcher (C#)] ${p}`})}log(p){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${p}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=A,A.MAX_RESTARTS=5,A.changeTypeMap=[0,1,2]}),define(Z[146],ee([0,1,145,8,19]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k{constructor(P,p,y,n){this.onDidFilesChange=p,this.onLogMessage=y,this.verboseLogging=n,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(R.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,R.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new E.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=k}),define(Z[52],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(L,k=[],A=!1){this.ctor=L,this.staticArguments=k,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=E}),define(Z[147],ee([0,1,52]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function L(A,P,p){P instanceof E.SyncDescriptor||(P=new E.SyncDescriptor(P,[],p)),R.push([A,P])}e.registerSingleton=L;function k(){return R}e.getSingletonServiceDescriptors=k}),define(Z[148],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=E;class R{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let A of this._nodes.values())A.outgoing.size===0&&k.push(A);return k}insertEdge(k,A){const P=this.lookupOrInsertNode(k),p=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),p),p.incoming.set(this._hashFn(k),P)}removeNode(k){const A=this._hashFn(k);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(k){const A=this._hashFn(k);let P=this._nodes.get(A);return P||(P=new E(k),this._nodes.set(A,P)),P}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[A,P]of this._nodes)k.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,A]of this._nodes){const P=new Set([k]),p=this._findCycle(A,P);if(p)return p}}_findCycle(k,A){for(let[P,p]of k.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const y=this._findCycle(p,A);if(y)return y;A.delete(P)}}}e.Graph=R}),define(Z[7],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function p(y){return y[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=p})(E=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function R(P,p,y,n){p[E.DI_TARGET]===p?p[E.DI_DEPENDENCIES].push({id:P,index:y,optional:n}):(p[E.DI_DEPENDENCIES]=[{id:P,index:y,optional:n}],p[E.DI_TARGET]=p)}function L(P){if(E.serviceIds.has(P))return E.serviceIds.get(P);const p=function(y,n,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(p,y,w,!1)};return p.toString=()=>P,E.serviceIds.set(P,p),p}e.createDecorator=L;function k(P){return P}e.refineServiceDecorator=k;function A(P){return function(p,y,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(P,p,n,!0)}}e.optional=A}),define(Z[149],ee([0,1,7]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,E.createDecorator)("checksumService")}),define(Z[150],ee([0,1,19,7,4]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=L.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",L.isMacintosh),A.set("isLinux",L.isLinux),A.set("isWindows",L.isWindows),A.set("isWeb",L.isWeb),A.set("isMacNative",L.isMacintosh&&!L.isWeb),A.set("isEdge",k.indexOf("Edg/")>=0),A.set("isFirefox",k.indexOf("Firefox")>=0),A.set("isChrome",k.indexOf("Chrome")>=0),A.set("isSafari",k.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var p;(function(S){S[S.False=0]="False",S[S.True=1]="True",S[S.Defined=2]="Defined",S[S.Not=3]="Not",S[S.Equals=4]="Equals",S[S.NotEquals=5]="NotEquals",S[S.And=6]="And",S[S.Regex=7]="Regex",S[S.NotRegex=8]="NotRegex",S[S.Or=9]="Or",S[S.In=10]="In",S[S.NotIn=11]="NotIn",S[S.Greater=12]="Greater",S[S.GreaterEquals=13]="GreaterEquals",S[S.Smaller=14]="Smaller",S[S.SmallerEquals=15]="SmallerEquals"})(p=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return w.INSTANCE}static true(){return g.INSTANCE}static has(d){return m.create(d)}static equals(d,T){return u.create(d,T)}static notEquals(d,T){return b.create(d,T)}static regex(d,T){return r.create(d,T)}static in(d,T){return I.create(d,T)}static not(d){return D.create(d)}static and(...d){return s.create(d)}static or(...d){return h.create(d)}static greater(d,T){return v.create(d,T)}static less(d,T){return a.create(d,T)}static deserialize(d,T=!1){if(!!d)return this._deserializeOrExpression(d,T)}static _deserializeOrExpression(d,T){let O=d.split("||");return h.create(O.map(x=>this._deserializeAndExpression(x,T)))}static _deserializeAndExpression(d,T){let O=d.split("&&");return s.create(O.map(x=>this._deserializeOne(x,T)))}static _deserializeOne(d,T){if(d=d.trim(),d.indexOf("!=")>=0){let O=d.split("!=");return b.create(O[0].trim(),this._deserializeValue(O[1],T))}if(d.indexOf("==")>=0){let O=d.split("==");return u.create(O[0].trim(),this._deserializeValue(O[1],T))}if(d.indexOf("=~")>=0){let O=d.split("=~");return r.create(O[0].trim(),this._deserializeRegexValue(O[1],T))}if(d.indexOf(" in ")>=0){let O=d.split(" in ");return I.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(d)){const O=d.split(">=");return o.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(d)){const O=d.split(">");return v.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(d)){const O=d.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(d)){const O=d.split("<");return a.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(d)?D.create(d.substr(1).trim()):m.create(d)}static _deserializeValue(d,T){if(d=d.trim(),d==="true")return!0;if(d==="false")return!1;let O=/^'([^']*)'$/.exec(d);return O?O[1].trim():d}static _deserializeRegexValue(d,T){if((0,E.isFalsyOrWhitespace)(d)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=d.indexOf("/"),x=d.lastIndexOf("/");if(O===x||O<0){if(T)throw new Error(`bad regexp-value '${d}', missing /-enclosure`);return console.warn(`bad regexp-value '${d}', missing /-enclosure`),null}let z=d.slice(O+1,x),H=d[x+1]==="i"?"i":"";try{return new RegExp(z,H)}catch(V){if(T)throw new Error(`bad regexp-value '${d}', parse error: ${V}`);return console.warn(`bad regexp-value '${d}', parse error: ${V}`),null}}}e.ContextKeyExpr=y;function n(S,d){return S.cmp(d)}class w{constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class g{constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class m{constructor(d){this.key=d,this.type=2}static create(d){const T=A.get(d);return typeof T=="boolean"?T?g.INSTANCE:w.INSTANCE:new m(d)}cmp(d){return d.type!==this.type?this.type-d.type:l(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return D.create(this.key)}}e.ContextKeyDefinedExpr=m;class u{constructor(d,T){this.key=d,this.value=T,this.type=4}static create(d,T){if(typeof T=="boolean")return T?m.create(d):D.create(d);const O=A.get(d);return typeof O=="boolean"?T===(O?"true":"false")?g.INSTANCE:w.INSTANCE:new u(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:f(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(d){return d.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class I{constructor(d,T){this.key=d,this.valueKey=T,this.type=10}static create(d,T){return new I(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:f(this.key,this.valueKey,d.key,d.valueKey)}equals(d){return d.type===this.type?this.key===d.key&&this.valueKey===d.valueKey:!1}evaluate(d){const T=d.getValue(this.valueKey),O=d.getValue(this.key);return Array.isArray(T)?T.indexOf(O)>=0:typeof O=="string"&&typeof T=="object"&&T!==null?P.call(T,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(d){return d.mapIn(this.key,this.valueKey)}negate(){return C.create(this)}}e.ContextKeyInExpr=I;class C{constructor(d){this._actual=d,this.type=11}static create(d){return new C(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new C(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotInExpr=C;class b{constructor(d,T){this.key=d,this.value=T,this.type=5}static create(d,T){if(typeof T=="boolean")return T?D.create(d):m.create(d);const O=A.get(d);return typeof O=="boolean"?T===(O?"true":"false")?w.INSTANCE:g.INSTANCE:new b(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:f(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(d){return d.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class D{constructor(d){this.key=d,this.type=3}static create(d){const T=A.get(d);return typeof T=="boolean"?T?w.INSTANCE:g.INSTANCE:new D(d)}cmp(d){return d.type!==this.type?this.type-d.type:l(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!d.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(d){return d.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=D;class v{constructor(d,T){this.key=d,this.value=T,this.type=12}static create(d,T){return new v(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:f(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=v;class o{constructor(d,T){this.key=d,this.value=T,this.type=13}static create(d,T){return new o(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:f(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreaterEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=o;class a{constructor(d,T){this.key=d,this.value=T,this.type=14}static create(d,T){return new a(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:f(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmaller(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerExpr=a;class t{constructor(d,T){this.key=d,this.value=T,this.type=15}static create(d,T){return new t(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:f(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmallerEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(d,T){this.key=d,this.regexp=T,this.type=7}static create(d,T){return new r(d,T)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.key<d.key)return-1;if(this.key>d.key)return 1;const T=this.regexp?this.regexp.source:"",O=d.regexp?d.regexp.source:"";return T<O?-1:T>O?1:0}equals(d){if(d.type===this.type){const T=this.regexp?this.regexp.source:"",O=d.regexp?d.regexp.source:"";return this.key===d.key&&T===O}return!1}evaluate(d){let T=d.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const d=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${d}`}keys(){return[this.key]}map(d){return d.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(d){this._actual=d,this.type=8}static create(d){return new i(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new i(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class s{constructor(d){this.expr=d,this.type=6}static create(d){return s._normalizeArr(d)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const x=n(this.expr[T],d.expr[T]);if(x!==0)return x}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(d.expr[T]))return!1;return!0}return!1}evaluate(d){for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].evaluate(d))return!1;return!0}static _normalizeArr(d){const T=[];let O=!1;for(const x of d)if(!!x){if(x.type===1){O=!0;continue}if(x.type===0)return w.INSTANCE;if(x.type===6){T.push(...x.expr);continue}T.push(x)}if(T.length===0&&O)return g.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(n);T.length>1;){const x=T[T.length-1];if(x.type!==9)break;T.pop();const z=T.pop(),H=h.create(x.expr.map(V=>s.create([V,z])));H&&(T.push(H),T.sort(n))}return T.length===1?T[0]:new s(T)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(let T of this.expr)d.push(...T.keys());return d}map(d){return new s(this.expr.map(T=>T.map(d)))}negate(){let d=[];for(let T of this.expr)d.push(T.negate());return h.create(d)}}e.ContextKeyAndExpr=s;class h{constructor(d){this.expr=d,this.type=9}static create(d){const T=h._normalizeArr(d);if(T.length!==0)return T.length===1?T[0]:new h(T)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const x=n(this.expr[T],d.expr[T]);if(x!==0)return x}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(d.expr[T]))return!1;return!0}return!1}evaluate(d){for(let T=0,O=this.expr.length;T<O;T++)if(this.expr[T].evaluate(d))return!0;return!1}static _normalizeArr(d){let T=[],O=!1;if(d){for(let x=0,z=d.length;x<z;x++){const H=d[x];if(!!H){if(H.type===0){O=!0;continue}if(H.type===1)return[g.INSTANCE];if(H.type===9){T=T.concat(H.expr);continue}T.push(H)}}if(T.length===0&&O)return[w.INSTANCE];T.sort(n)}return T}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(let T of this.expr)d.push(...T.keys());return d}map(d){return new h(this.expr.map(T=>T.map(d)))}negate(){let d=[];for(let O of this.expr)d.push(O.negate());const T=O=>O.type===9?O.expr:[O];for(;d.length>1;){const O=d.shift(),x=d.shift(),z=[];for(const H of T(O))for(const V of T(x))z.push(y.and(H,V));d.unshift(y.or(...z))}return d[0]}}e.ContextKeyOrExpr=h;class c extends m{constructor(d,T,O){super(d);this._defaultValue=T,typeof O=="object"?c._info.push({...O,key:d}):O!==!0&&c._info.push({key:d,description:O,type:T!=null?typeof T:void 0})}static all(){return c._info.values()}bindTo(d){return d.createKey(this.key,this._defaultValue)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return y.not(this.key)}isEqualTo(d){return y.equals(this.key,d)}notEqualsTo(d){return y.notEquals(this.key,d)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function l(S,d){return S<d?-1:S>d?1:0}function f(S,d,T,O){return S<T?-1:S>T?1:d<O?-1:d>O?1:0}}),define(Z[73],ee([0,1,7]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function R(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=R}),define(Z[74],ee([0,1,7]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,E.createDecorator)("downloadService")}),define(Z[12],ee([0,1,7]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[27],ee([0,1,115,7,17]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=k;var A;(function(w){w[w.NoneOrRelevance=0]="NoneOrRelevance",w[w.LastUpdatedDate=1]="LastUpdatedDate",w[w.Title=2]="Title",w[w.PublisherName=3]="PublisherName",w[w.InstallCount=4]="InstallCount",w[w.PublishedDate=5]="PublishedDate",w[w.AverageRating=6]="AverageRating",w[w.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var P;(function(w){w[w.Default=0]="Default",w[w.Ascending=1]="Ascending",w[w.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var p;(function(w){w.Install="install",w.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var y;(function(w){w[w.None=0]="None",w[w.Install=1]="Install",w[w.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(g,m){super(g);this.code=m,this.name=m}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")});var Y=this&&this.__param||function(K,e){return function(E,R){e(E,R,K)}};define(Z[151],ee([0,1,2,27]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let L=class extends E.Disposable{constructor(A){super();this.extensionManagementService=A,this._register(A),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};L=de([Y(0,R.IExtensionManagementService)],L),e.DeprecatedExtensionsCleaner=L}),define(Z[75],ee([0,1,7]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var R;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(R=e.RecommendationSource||(e.RecommendationSource={}));function L(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var k;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,E.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[76],ee([0,1,19,7]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=L;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class P{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,g){if(typeof w=="undefined"||w===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof w=="string"||typeof g=="string"){let m=typeof w=="string"?w:w.value,u=typeof g=="string"?g:g.value;return E.equalsIgnoreCase(m,u)}return w._lower===g._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=P;function p(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function y(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[31],ee([0,1,19,76]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(u,I){return u.uuid&&I.uuid?u.uuid===I.uuid:u.id===I.id?!0:(0,E.compareIgnoreCase)(u.id,I.id)===0}e.areSameExtensions=L;class k{constructor(I,C){this.version=C,this.id=I.id,this.uuid=I.uuid}key(){return`${this.id}-${this.version}`}equals(I){return I instanceof k?L(this,I)&&this.version===I.version:!1}}e.ExtensionIdentifierWithVersion=k;function A(u,I){return`${u}.${I}`}e.getExtensionId=A;function P(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function p(u,I){return P(A(u,I))}e.getGalleryExtensionId=p;function y(u,I){const C=[],b=D=>{for(const v of C)if(v.some(o=>L(I(o),I(D))))return v;return null};for(const D of u){const v=b(D);v?v.push(D):C.push([D])}return C}e.groupByExtension=y;function n(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function w(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function g(u){const I=new Set;for(const C of u)C.malicious&&I.add(C.id.id);return I}e.getMaliciousExtensionsSet=g;function m(u,I){const C=[],b=I.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const D=b.shift();if(D&&C.every(v=>!L(v.identifier,{id:D}))){const v=u.filter(o=>L(o.identifier,{id:D}));v.length===1&&(C.push(v[0]),b.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return C}e.getExtensionDependencies=m}),define(Z[152],ee([0,1,2,8,76,18]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends E.Disposable{constructor(p,y){super();this.environmentService=p,this.extensionsManifestCache=(0,R.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(y.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(y.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(p){p.some(y=>!!y.local)&&this.invalidate()}onDidUnInstallExtension(p){p.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(Z[13],ee([0,1,122,8,5,7,19,16,40]),function(K,e,E,R,L,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,k.createDecorator)("fileService");function y(U){return U.create===!0}e.isFileOpenForWriteOptions=y;var n;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var w;(function(U){U[U.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var g;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=m;function u(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=u;function I(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=I;function C(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=C;var b;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class D extends Error{constructor($,M){super($);this.code=M}}e.FileSystemProviderError=D;function v(U,$){const M=new D(U.toString(),$);return a(M,$),M}e.createFileSystemProviderError=v;function o(U){return U||v((0,E.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=o;function a(U,$){return U.name=$?`${$} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=a;function t(U){if(!U)return b.Unknown;if(U instanceof D)return U.code;const $=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!$)return b.Unknown;switch($[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(U){if(U instanceof f)return U.fileOperationResult;switch(t(U)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor($,M,N){this.resource=$,this.operation=M,this.target=N}isOperation($){return this.operation===$}}e.FileOperationEvent=s;var h;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class c{constructor($,M){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const N of $)switch(N.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>M)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>M)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>M)),this.deleted.set(N.resource,N);break}}contains($,...M){return this.doContains($,{includeChildren:!1},...M)}affects($,...M){return this.doContains($,{includeChildren:!0},...M)}doContains($,M,...N){if(!$)return!1;const q=N.length>0;return!!((!q||N.includes(1))&&(this.added?.get($)||M.includeChildren&&this.added?.findSuperstr($))||(!q||N.includes(0))&&(this.updated?.get($)||M.includeChildren&&this.updated?.findSuperstr($))||(!q||N.includes(2))&&(this.deleted?.findSubstr($)||M.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function l(U,$,M){return!U||!$||U===$||$.length>U.length?!1:($.charAt($.length-1)!==R.sep&&($+=R.sep),M?(0,A.startsWithIgnoreCase)(U,$):U.indexOf($)===0)}e.isParent=l;class f extends Error{constructor($,M,N){super($);this.fileOperationResult=M,this.options=N}}e.FileOperationError=f;class S extends f{constructor($,M,N){super($,2,N);this.stat=M}}e.NotModifiedSinceFileOperationError=S;var d;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(d=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=O;async function x(U,$){if(!$.canHandleResource(L.URI.from({scheme:U.scheme})))return new Promise(M=>{const N=$.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===U.scheme&&q.added&&(N.dispose(),M())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize($){return(0,P.isNumber)($)||($=0),$<z.KB?(0,E.localize)(1,null,$.toFixed(0)):$<z.MB?(0,E.localize)(2,null,($/z.KB).toFixed(2)):$<z.GB?(0,E.localize)(3,null,($/z.MB).toFixed(2)):$<z.TB?(0,E.localize)(4,null,($/z.GB).toFixed(2)):(0,E.localize)(5,null,($/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var H;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function V(U){return{maxFileSize:U===0?300*z.MB:16*z.GB,maxHeapSize:U===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=V}),define(Z[153],ee([0,1,154,49,13]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(p,y)=>{const n=(0,E.createHash)("md5"),w=(await this.fileService.readFileStream(P)).value;(0,R.listenStream)(w,{onData:g=>n.update(g.buffer),onError:g=>y(g),onEnd:()=>p(n.digest("base64").replace(/=+$/,""))})})}};k=de([Y(0,L.IFileService)],k),e.ChecksumService=k}),define(Z[155],ee([0,1,221,113,13,135]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(g,m){const u={onUnknownOption:C=>{console.warn((0,R.localize)(0,null,C))},onMultipleValues:(C,b)=>{console.warn((0,R.localize)(1,null,C,b))}},I=(0,k.parseArgs)(g,k.OPTIONS,m?u:void 0);return I.goto&&I._.forEach(C=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(C),(0,R.localize)(2,null))),I["max-memory"]&&E(parseInt(I["max-memory"])>=L.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${L.MIN_MAX_MEMORY_SIZE_MB} MB.`),I}function P(g){const m=g.findIndex(u=>!/^-/.test(u));if(m>-1)return[...g.slice(0,m),...g.slice(m+1)]}function p(g){let[,...m]=g;process.env.VSCODE_DEV&&(m=P(m)||[]);const u=!w(process.env);return A(m,u)}e.parseMainProcessArgv=p;function y(g){const[,,...m]=g;return A(m,!0)}e.parseCLIProcessArgv=y;function n(g,...m){const u=g.indexOf("--");return u===-1?g.push(...m):g.splice(u,0,...m),g}e.addArg=n;function w(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),define(Z[156],ee([0,1,137,41,30,4,155,37,109,29,11]),function(K,e,E,R,L,k,A,P,p,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function w(u,I,C){return I["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):k.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,A.isLaunchedFromCli)(C)&&!I["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,A.isLaunchedFromCli)(C)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=new Promise(async b=>{const D=new y.CancellationTokenSource,v=setTimeout(()=>{u.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),D.dispose(!0),b({})},1e4);try{const o=await m(u,D.token);b(o)}catch(o){(0,n.isPromiseCanceledError)(o)||u.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),b({})}finally{clearTimeout(v),D.dispose()}})),g)}e.resolveShellEnv=w;let g;async function m(u,I){const C=new Promise(async(b,D)=>{const v=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",v);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",o);const a=(0,L.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",r);const i=await(0,p.getSystemShell)(k.OS,r);if(u.trace("getUnixShellEnvironment#shell",i),I.isCancellationRequested)return D(n.canceled);const s=E.basename(i);let h,c;/^pwsh(-preview)?$/.test(s)?(h=`& '${process.execPath}' -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,c=["-Login","-Command"]):(h=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,c=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(c),h);const l=(0,R.spawn)(i,[...c,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});I.onCancellationRequested(()=>(l.kill(),D(n.canceled))),l.on("error",d=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,P.toErrorMessage)(d)),b({})});const f=[];l.stdout.on("data",d=>f.push(d));const S=[];l.stderr.on("data",d=>S.push(d)),l.on("close",(d,T)=>{const O=Buffer.concat(f).toString("utf8");u.trace("getUnixShellEnvironment#raw",O);const x=Buffer.concat(S).toString("utf8");if(x.trim()&&u.trace("getUnixShellEnvironment#stderr",x),d||T)return D(new Error(`Failed to get environment (code ${d}, signal ${T})`));const z=t.exec(O),H=z?z[1]:"{}";try{const V=JSON.parse(H);v?V.ELECTRON_RUN_AS_NODE=v:delete V.ELECTRON_RUN_AS_NODE,o?V.ELECTRON_NO_ATTACH_CONSOLE=o:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",V),b(V)}catch(V){u.error("getUnixShellEnvironment#errorCaught",(0,P.toErrorMessage)(V)),D(V)}})});try{return await C}catch(b){return u.error("getUnixShellEnvironment#error",(0,P.toErrorMessage)(b)),{}}}}),define(Z[77],ee([0,1,5,13,4]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function k(p){return p.map(y=>({type:y.type,resource:E.URI.file(y.path)}))}e.toFileChanges=k;function A(p){const y=new P;for(const n of p)y.processEvent(n);return y.normalize()}e.normalizeFileChanges=A;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(y){const n=this.mapPathToChange.get(y.path);if(n){const w=n.type,g=y.type;w===1&&g===2?(this.mapPathToChange.delete(y.path),this.normalized.splice(this.normalized.indexOf(n),1)):w===2&&g===1?n.type=0:w===1&&g===0||(n.type=g)}else this.normalized.push(y),this.mapPathToChange.set(y.path,y)}normalize(){const y=[],n=[];return this.normalized.filter(w=>w.type!==2?(y.push(w),!1):!0).sort((w,g)=>w.path.length-g.path.length).filter(w=>n.some(g=>(0,R.isParent)(w.path,g,!L.isLinux))?!1:(n.push(w.path),!0)).concat(y)}}}),define(Z[157],ee([0,1,77,2,18,99,101,6,8]),function(K,e,E,R,L,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y extends R.Disposable{constructor(w,g,m,u){super();this.path=w,this.onDidFilesChange=g,this.onLogMessage=m,this.verboseLogging=u,this.fileChangesDelayer=this._register(new P.ThrottledDelayer(A.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(w){this.verboseLogging=w}async startWatching(){try{const{stat:w,symbolicLink:g}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let m=this.path;if(g)try{m=await(0,k.realpath)(m)}catch(u){if(this.onError(u),g.dangling)return}w.isDirectory()?this._register((0,A.watchFolder)(m,(u,I)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,p.join)(this.path,(0,p.basename)(I))})},u=>this.onError(u))):this._register((0,A.watchFile)(m,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(w){w.code!=="ENOENT"&&this.onError(w)}}onFileChange(w){this.fileChangesBuffer.push(w),this.verboseLogging&&this.onVerbose(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const m=(0,E.normalizeFileChanges)(g);if(this.verboseLogging)for(const u of m)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);m.length>0&&this.onDidFilesChange(m)})}onError(w){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${w}`})}onVerbose(w){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=y}),define(Z[78],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...L){this._entries=new Map;for(let[k,A]of L)this.set(k,A)}set(L,k){const A=this._entries.get(L);return this._entries.set(L,k),A}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=E}),define(Z[158],ee([0,1,11,148,52,7,78,6]),function(K,e,E,R,L,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const p=!1;class y extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class n{constructor(u=new A.ServiceCollection,I=!1,C){this._activeInstantiations=new Set,this._services=u,this._strict=I,this._parent=C,this._services.set(k.IInstantiationService,this)}createChild(u){return new n(u,this._strict,this)}invokeFunction(u,...I){let C=g.traceInvocation(u),b=!1;try{return u({get:(v,o)=>{if(b)throw(0,E.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(v,C);if(!a&&o!==k.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return a}},...I)}finally{b=!0,C.stop()}}createInstance(u,...I){let C,b;return u instanceof L.SyncDescriptor?(C=g.traceCreation(u.ctor),b=this._createInstance(u.ctor,u.staticArguments.concat(I),C)):(C=g.traceCreation(u),b=this._createInstance(u,I,C)),C.stop(),b}_createInstance(u,I=[],C){let b=k._util.getServiceDependencies(u).sort((o,a)=>o.index-a.index),D=[];for(const o of b){let a=this._getOrCreateServiceInstance(o.id,C);if(!a&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);D.push(a)}let v=b.length>0?b[0].index:I.length;if(I.length!==v){console.warn(`[createInstance] First service dependency of ${u.name} at position ${v+1} conflicts with ${I.length} static arguments`);let o=v-I.length;o>0?I=I.concat(new Array(o)):I=I.slice(0,v)}return new u(...[...I,...D])}_setServiceInstance(u,I){if(this._services.get(u)instanceof L.SyncDescriptor)this._services.set(u,I);else if(this._parent)this._parent._setServiceInstance(u,I);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let I=this._services.get(u);return!I&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):I}_getOrCreateServiceInstance(u,I){let C=this._getServiceInstanceOrDescriptor(u);return C instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,C,I.branch(u,!0)):(I.branch(u,!1),C)}_safeCreateAndCacheServiceInstance(u,I,C){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,I,C)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,I,C){const b=new R.Graph(o=>o.id.toString());let D=0;const v=[{id:u,desc:I,_trace:C}];for(;v.length;){const o=v.pop();if(b.lookupOrInsertNode(o),D++>1e3)throw new y(b);for(let a of k._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`),t instanceof L.SyncDescriptor){const r={id:a.id,desc:t,_trace:o._trace.branch(a.id,!0)};b.insertEdge(o,r),v.push(r)}}}for(;;){const o=b.roots();if(o.length===0){if(!b.isEmpty())throw new y(b);break}for(const{data:a}of o){if(this._getServiceInstanceOrDescriptor(a.id)instanceof L.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}b.removeNode(a)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,I,C=[],b,D){if(this._services.get(u)instanceof L.SyncDescriptor)return this._createServiceInstance(I,C,b,D);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,I,C,b,D);throw new Error(`illegalState - creating UNKNOWN service instance ${I.name}`)}_createServiceInstance(u,I=[],C,b){if(C){const D=new P.IdleValue(()=>this._createInstance(u,I,b));return new Proxy(Object.create(null),{get(v,o){if(o in v)return v[o];let a=D.value,t=a[o];return typeof t!="function"||(t=t.bind(a),v[o]=t),t},set(v,o,a){return D.value[o]=a,!0}})}else return this._createInstance(u,I,b)}}e.InstantiationService=n;var w;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(w||(w={}));class g{constructor(u,I){this.type=u,this.name=I,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return p?new g(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(u){return p?new g(0,u.name):g._None}branch(u,I){let C=new g(2,u.toString());return this._dep.push([u,I,C]),C}stop(){let u=Date.now()-this._start;g._totals+=u;let I=!1;function C(D,v){let o=[],a=new Array(D+1).join("	");for(const[t,r,i]of v._dep)if(r&&i){I=!0,o.push(`${a}CREATES -> ${t}`);let s=C(D+1,i);s&&o.push(s)}else o.push(`${a}uses -> ${t}`);return o.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${C(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(u>2||I)&&console.log(b.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(Z[159],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class E{constructor(L,k){this.server=L,this.router=k}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,k){this.server.registerChannel(L,k)}}e.MessagePortMainProcessService=E}),define(Z[160],ee([0,1,36,52,147,7]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(m,u,I){const C=I.getChannel(m);return P(u)?new u.channelClientCtor(C):E.ProxyChannel.toService(C,u?.proxyOptions)}}function P(g){return!!g?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let p=class extends A{constructor(m,u,I){super(m,u,I)}};p=de([Y(2,e.IMainProcessService)],p);function y(g,m,u){(0,L.registerSingleton)(g,new R.SyncDescriptor(p,[m,u],u?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=y,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let n=class extends A{constructor(m,u,I){super(m,u,I)}};n=de([Y(2,e.ISharedProcessService)],n);function w(g,m,u){(0,L.registerSingleton)(g,new R.SyncDescriptor(n,[m,u],u?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=w}),define(Z[57],ee([0,1,7]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,E.createDecorator)("localizationsService");function R(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const k of L.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=R}),define(Z[161],ee([0,1,2,57]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends E.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=de([Y(0,R.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(Z[14],ee([0,1,7,2,4,3,37]),function(K,e,E,R,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function P(){return new Date().toISOString()}var p;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;class y extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class n extends y{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(p.Trace)&&this.log(p.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(p.Debug)&&this.log(p.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(p.Info)&&this.log(p.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(p.Warning)&&this.log(p.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(p.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(p.Error,this.format(i))}else this.log(p.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(p.Critical)&&this.log(p.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let s=t[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch(h){}r+=(i>0?" ":"")+s}return r}}e.AbstractMessageLogger=n;class w extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!L.isWindows}trace(t,...r){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}debug(t,...r){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}info(t,...r){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}warn(t,...r){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...r):console.warn(`[main ${P()}]`,t,...r))}error(t,...r){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}critical(t,...r){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class g extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=g;class m extends y{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,A.toErrorMessage)(t,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class u extends y{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class I extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=I;class C extends R.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(i))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,r?.always?p.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),r?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=C;class b{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(t){}getLevel(){return p.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function D(a){if(a.verbose)return p.Trace;if(typeof a.logLevel=="string"){const t=v(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=D;function v(a){switch(a){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=v;function o(a){switch(a){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=o}),define(Z[162],ee([0,1,6,11,2,8,18,12,14]),function(K,e,E,R,L,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let y=class extends L.Disposable{constructor(w,g){super();this.environmentService=w,this.logService=g,this._register(new E.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,k.basename)(this.environmentService.logsPath),g=(0,k.dirname)(this.environmentService.logsPath),I=(await A.Promises.readdir(g)).filter(b=>/^\d{8}T\d{6}$/.test(b)).sort().filter(b=>b!==w),C=I.slice(0,Math.max(0,I.length-9));C.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${C.join(", ")}'`),await Promise.all(C.map(b=>A.Promises.rm((0,k.join)(g,b)))))}catch(w){(0,R.onUnexpectedError)(w)}}};y=de([Y(0,P.IEnvironmentService),Y(1,p.ILogService)],y),e.LogsDataCleaner=y}),define(Z[163],ee([0,1,6,11,2,8,18,12,14]),function(K,e,E,R,L,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let y=class lt extends L.Disposable{constructor(w,g,m){super();this.backupWorkspacesPath=w,this.environmentService=g,this.logService=m,this._register(new E.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const w=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),m=JSON.parse(w).emptyWorkspaceInfos.map(I=>I.backupFolder),u=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(u.map(async I=>{I.length!==lt.NON_EMPTY_WORKSPACE_ID_LENGTH&&m.indexOf(I)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${I}.`),await A.Promises.rm((0,k.join)(this.environmentService.workspaceStorageHome.fsPath,I)))}))}catch(w){(0,R.onUnexpectedError)(w)}}};y.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,y=de([Y(1,P.INativeEnvironmentService),Y(2,p.ILogService)],y),e.StorageDataCleaner=y}),define(Z[164],ee([0,1,18,2,13,27,12,5,15,31,14,30,58,4,6,11]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends R.Disposable{constructor(v,o,a,t){super();this.fileService=o,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=P.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,o){await this.cleanUpPromise;const a=this.getName(v),t=(0,p.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const r=(0,p.joinPath)(this.extensionsDownloadDir,`.${(0,w.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(v,r,o);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(s){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",v.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(v){}async rename(v,o,a){try{await E.Promises.rename(v.fsPath,o.fsPath)}catch(t){if(m.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${v} to ${o} with 'EPERM' error. Trying again...`),this.rename(v,o,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const o=[],a=[];for(const i of v.children){const s=this.parse(i.name);s&&a.push([s,i])}const t=(0,y.groupByExtension)(a,([i])=>i),r=[];for(const i of t)i.sort((s,h)=>g.rcompare(s[0].version,h[0].version)),o.push(...i.slice(1).map(s=>s[1].resource)),r.push(i[0][1]);r.sort((i,s)=>i.mtime-s.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await u.Promises.settled(o.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?new y.ExtensionIdentifierWithVersion(v.identifier,v.version).key().toLowerCase():(0,w.generateUuid)()}parse(v){const o=C.exec(v);return o&&o[1]&&o[2]?new y.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};b=de([Y(0,A.INativeEnvironmentService),Y(1,L.IFileService),Y(2,k.IExtensionGalleryService),Y(3,n.ILogService)],b),e.ExtensionsDownloader=b}),define(Z[165],ee([0,1,2,14,41,37,8,6,3,17,18,12]),function(K,e,E,R,L,k,A,P,p,y,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends E.Disposable{constructor(u,I){super();this.environmentService=u,this.logService=I,this.processesLimiter=new P.Limiter(5)}async postUninstall(u){const I=this.parseScript(u,"uninstall");return I&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(I.script,"uninstall",I.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),C=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${C}`)))),n.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,C=>this.logService.error("Error while removing extension storage path",C))}parseScript(u,I){const C=`vscode:${I}`;if(u.location.scheme===y.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[C]=="string"){const b=u.manifest.scripts[C].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${C} should be a node script`),null):{script:(0,A.join)(u.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(u,I,C,b,D){return new Promise((v,o)=>{const a=this.start(u,I,C,D);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?o(i):v(void 0)};a.on("error",i=>{r((0,k.toErrorMessage)(i)||"Unknown")}),a.on("exit",(i,s)=>{r(i?`post-${I} process exited with code ${i}`:void 0)}),b&&(t=setTimeout(()=>{t=null,a.kill(),o("timed out")},5e3))})}start(u,I,C,b){const D={silent:!0,execArgv:void 0},v=(0,L.fork)(u,[`--type=extension-post-${I}`,...C],D);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const o=p.Event.fromNodeEventEmitter(v.stdout,"data"),a=p.Event.fromNodeEventEmitter(v.stderr,"data");o(i=>this.logService.info(b.identifier.id,b.manifest.version,`post-${I}`,i)),a(i=>this.logService.error(b.identifier.id,b.manifest.version,`post-${I}`,i));const t=p.Event.any(p.Event.map(o,i=>({data:`%c${i}`,format:[""]})),p.Event.map(a,i=>({data:`%c${i}`,format:["color: red"]})));return p.Event.debounce(t,(i,s)=>i?{data:i.data+s.data,format:[...i.format,...s.format]}:{data:s.data,format:s.format},100)(i=>{console.group(b.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),v}getExtensionStoragePath(u){return(0,A.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};g=de([Y(0,w.IEnvironmentService),Y(1,R.ILogService)],g),e.ExtensionsLifecycle=g}),define(Z[166],ee([0,1,2,12,3,13,5,31,15,14]),function(K,e,E,R,L,k,A,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends E.Disposable{constructor(g,m,u,I){super();this.extensionsManagementService=g,this.logService=I,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(D=>{this.installedExtensions=D.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(D=>this.onInstallExtension(D))),this._register(g.onDidInstallExtensions(D=>this.onDidInstallExtensions(D))),this._register(g.onDidUninstallExtension(D=>this.onDidUninstallExtension(D)));const C=A.URI.file(u.extensionsPath),b=new p.ExtUri(D=>!m.hasCapability(D,1024));this._register(m.watch(C)),this._register(L.Event.filter(m.onDidChangeFilesRaw,D=>D.changes.some(v=>this.doesChangeAffects(v,C,b)))(()=>this.onDidChange()))}doesChangeAffects(g,m,u){return u.isEqual(u.dirname(g.resource),m)?u.isEqual(g.resource,u.joinPath(m,".obsolete"))?!0:!(g.type!==1&&g.type!==2||u.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const m of g)this.removeInstallingExtension(m.identifier),m.local&&this.addInstalledExtension(m.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(m=>!(0,P.areSameExtensions)(m,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(m=>!(0,P.areSameExtensions)(m,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),m=g.filter(I=>[...this.installingExtensions,...this.installedExtensions].some(C=>(0,P.areSameExtensions)(C,I.identifier))?!1:I.installedTimestamp&&I.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",I.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",I.identifier.id),!1)),u=this.installedExtensions.filter(I=>this.installingExtensions.some(C=>(0,P.areSameExtensions)(C,I))?!1:g.every(C=>!(0,P.areSameExtensions)(C.identifier,I))?(this.logService.info("Detected extension removed from another source",I.id),!0):!1);this.installedExtensions=g.map(I=>I.identifier),(m.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:m,removed:u})}}};n=de([Y(1,k.IFileService),Y(2,R.INativeEnvironmentService),Y(3,y.ILogService)],n),e.ExtensionsWatcher=n}),define(Z[167],ee([0,1,18,154,27,2,12,6,31,14,57,23,17,8]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let u=class extends k.Disposable{constructor(b,D,v){super();this.extensionManagementService=b,this.logService=v,this.cache=this._register(new I(D,v)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const b=await this.cache.getLanguagePacks(),D=["en",...Object.keys(b)];return(0,w.distinct)(D)}async postInstallExtension(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",b.identifier.id),await this.update())}async postUninstallExtension(b){const D=await this.cache.getLanguagePacks();Object.keys(D).some(v=>D[v]&&D[v].extensions.some(o=>(0,p.areSameExtensions)(o.extensionIdentifier,b.identifier)))&&(this.logService.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,D]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),v=await this.cache.update(D);return!(0,w.equals)(Object.keys(b),Object.keys(v))}};u=de([Y(0,L.IExtensionManagementService),Y(1,A.INativeEnvironmentService),Y(2,y.ILogService)],u),e.LocalizationsService=u;let I=class extends k.Disposable{constructor(b,D){super();this.logService=D,this.languagePacks={},this.languagePacksFilePath=(0,m.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(D=>{Object.keys(D).forEach(v=>delete D[v]),this.createLanguagePacksFromExtensions(D,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...D){for(const v of D)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,v);Object.keys(b).forEach(v=>this.updateHash(b[v]))}createLanguagePacksFromExtension(b,D){const v=D.identifier,o=D.manifest.contributes&&D.manifest.contributes.localizations?D.manifest.contributes.localizations:[];for(const a of o)if(D.location.scheme===g.Schemas.file&&(0,n.isValidLocalization)(a)){let t=b[a.languageId];t||(t={hash:"",extensions:[],translations:{}},b[a.languageId]=t);let r=t.extensions.filter(i=>(0,p.areSameExtensions)(i.extensionIdentifier,v))[0];r?r.version=D.manifest.version:t.extensions.push({extensionIdentifier:v,version:D.manifest.version});for(const i of a.translations)t.translations[i.id]=(0,m.join)(D.location.fsPath,i.path)}}updateHash(b){if(b){const D=(0,R.createHash)("md5");for(const v of b.extensions)D.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);b.hash=D.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let D=null;return E.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch(o){return{}}}).then(v=>(D=b(v),v)).then(v=>{for(const a of Object.keys(v))v[a]||delete v[a];this.languagePacks=v,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),E.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>D,v=>this.logService.error(v))})}};I=de([Y(0,A.INativeEnvironmentService),Y(1,y.ILogService)],I)}),define(Z[79],ee([0,1,14,3,5]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(g){this.service=g,this.onDidChangeLogLevel=R.Event.buffer(g.onDidChangeLogLevel,!0)}listen(g,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(g,m,u){switch(m){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=k;class A{constructor(g){this.channel=g}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(g){A.setLevel(this.channel,g)}static setLevel(g,m){return g.call("setLevel",m)}}e.LogLevelChannelClient=A;class P{constructor(g){this.loggerService=g,this.loggers=new Map}listen(g,m){throw new Error(`Event not found: ${m}`)}async call(g,m,u){switch(m){case"createLogger":this.createLogger(L.URI.revive(u[0]),u[1]);return;case"log":return this.log(L.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${m}`)}createLogger(g,m){this.loggers.set(g.toString(),this.loggerService.createLogger(g,m))}consoleLog(g,m){let u=console.log;switch(g){case E.LogLevel.Error:u=console.error;break;case E.LogLevel.Warning:u=console.warn;break;case E.LogLevel.Info:u=console.info;break}u.call(console,...m)}log(g,m){const u=this.loggers.get(g.toString());if(!u)throw new Error("Create the logger before logging");for(const[I,C]of m)switch(I){case E.LogLevel.Trace:u.trace(C);break;case E.LogLevel.Debug:u.debug(C);break;case E.LogLevel.Info:u.info(C);break;case E.LogLevel.Warning:u.warn(C);break;case E.LogLevel.Error:u.error(C);break;case E.LogLevel.Critical:u.critical(C);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class p extends E.AbstractLoggerService{constructor(g,m,u){super(g,m);this.channel=u}createConsoleMainLogger(){return new E.AdapterLogger({log:(g,m)=>{this.channel.call("consoleLog",[g,m])}})}doCreateLogger(g,m,u){return new y(this.channel,g,m,u)}}e.LoggerChannelClient=p;class y extends E.AbstractMessageLogger{constructor(g,m,u,I){super(I?.always);this.channel=g,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[m,I]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,m){const u=[[g,m]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(g){this.channel.call("log",[this.file,g])}}class n extends E.LogService{constructor(g,m){super(m);this.parent=g,this._register(g.onDidChangeLogLevel(u=>m.setLevel(u)))}setLevel(g){super.setLevel(g),this.parent.setLevel(g)}}e.FollowerLogService=n}),define(Z[59],ee([0,1,7]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,E.createDecorator)("nativeHostService")}),define(Z[44],ee([0,1,17,4,35,15]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const P=R.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const P=(0,k.dirname)(E.FileAccess.asFileUri("",K));A=K.__$__nodeRequire((0,k.joinPath)(P,"product.json").fsPath);const p=K.__$__nodeRequire((0,k.joinPath)(P,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:p.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.60.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(Z[80],ee([0,1,123,25,13,11,44]),function(K,e,E,R,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(w,g,m,u,I,C){let b;try{await p(w,g,m,u,I,C)}catch(D){b=D}finally{b&&I.errorTransformer&&(b=I.errorTransformer(b)),typeof b!="undefined"&&m.error(b),m.end()}}e.readFileIntoStream=P;async function p(w,g,m,u,I,C){y(C);const b=await w.open(g,{create:!1});try{y(C);let D=0,v=0,o=I&&typeof I.length=="number"?I.length:void 0,a=R.VSBuffer.alloc(Math.min(I.bufferSize,typeof o=="number"?o:I.bufferSize)),t=I&&typeof I.position=="number"?I.position:0,r=0;do v=await w.read(b,t,a.buffer,r,a.byteLength-r),t+=v,r+=v,D+=v,typeof o=="number"&&(o-=v),r===a.byteLength&&(await m.write(u(a)),a=R.VSBuffer.alloc(Math.min(I.bufferSize,typeof o=="number"?o:I.bufferSize)),r=0);while(v>0&&(typeof o!="number"||o>0)&&y(C)&&n(D,I));if(r>0){let i=r;typeof o=="number"&&(i=Math.min(r,o)),m.write(u(a.slice(0,i)))}}catch(D){throw(0,L.ensureFileSystemProviderError)(D)}finally{await w.close(b)}}function y(w){if(w.isCancellationRequested)throw(0,k.canceled)();return!0}function n(w,g){if(g?.limits){if(typeof g.limits.memory=="number"&&w>g.limits.memory)throw(0,L.createFileSystemProviderError)((0,E.localize)(0,null,A.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&w>g.limits.size)throw(0,L.createFileSystemProviderError)((0,E.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[168],ee([0,1,121,169,2,13,3,15,40,23,14,25,49,6,29,17,80,55]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let D=class qe extends L.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new A.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new m.ThrottledWorker(qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,qe.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new k.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new m.ThrottledWorker(qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,qe.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new k.FileChangesEvent(a,!0)))),this.watchedResources=p.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new m.ResourceQueue)}registerProvider(o,a){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,R.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:a});const t=new L.DisposableStore;return t.add(a.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:o}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,L.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:a}),this.provider.delete(o),(0,L.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){a.push(t)}}),!this.provider.has(o)&&await m.Promises.settled(a)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,a){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return b.Iterable.map(this.provider,([o,a])=>({scheme:o,capabilities:a.capabilities}))}async withProvider(o){if(!(0,P.isAbsolutePath)(o))throw new k.FileOperationError((0,E.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const a=this.provider.get(o.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,E.localize)(1,null,o.toString()),t}return a}async withReadProvider(o){const a=await this.withProvider(o);if((0,k.hasOpenReadWriteCloseCapability)(a)||(0,k.hasReadWriteCapability)(a)||(0,k.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const a=await this.withProvider(o);if((0,k.hasOpenReadWriteCloseCapability)(a)||(0,k.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,a){try{return await this.doResolveFile(o,a)}catch(t){throw(0,k.toFileSystemProviderErrorCode)(t)===k.FileSystemProviderErrorCode.FileNotFound?new k.FileOperationError((0,E.localize)(2,null,this.resourceForError(o)),1):(0,k.ensureFileSystemProviderError)(t)}}async doResolveFile(o,a){const t=await this.withProvider(o),r=this.isPathCaseSensitive(t),i=a?.resolveTo,s=a?.resolveSingleChildDescendants,h=a?.resolveMetadata,c=await t.stat(o);let l;return this.toFileStat(t,o,c,void 0,!!h,(f,S)=>(l||(l=p.TernarySearchTree.forUris(()=>!r),l.set(o,!0),(0,y.isNonEmptyArray)(i)&&i.forEach(d=>l.set(d,!0))),Boolean(l.findSuperstr(f.resource)||l.get(f.resource))?!0:f.isDirectory&&s?S===1:!1))}async toFileStat(o,a,t,r,i,s){const{providerExtUri:h}=this.getExtUri(o),c={resource:a,name:h.basename(a),isFile:(t.type&k.FileType.File)!=0,isDirectory:(t.type&k.FileType.Directory)!=0,isSymbolicLink:(t.type&k.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&k.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,k.etag)({mtime:t.mtime,size:t.size})};if(c.isDirectory&&s(c,r)){try{const l=await o.readdir(a),f=await m.Promises.settled(l.map(async([S,d])=>{try{const T=h.joinPath(a,S),O=i?await o.stat(T):{type:d};return await this.toFileStat(o,T,O,l.length,i,s)}catch(T){return this.logService.trace(T),null}}));c.children=(0,y.coalesce)(f)}catch(l){this.logService.trace(l),c.children=[]}return c}return c}async resolveAll(o){return m.Promises.settled(o.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const a=await this.withProvider(o);try{return!!await a.stat(o)}catch(t){return!1}}async canCreateFile(o,a){try{await this.doValidateCreateFile(o,a)}catch(t){return t}return!0}async doValidateCreateFile(o,a){if(!a?.overwrite&&await this.exists(o))throw new k.FileOperationError((0,E.localize)(3,null,this.resourceForError(o)),3,a)}async createFile(o,a=w.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const r=await this.writeFile(o,a);return this._onDidRunOperation.fire(new k.FileOperationEvent(o,0,r)),r}async writeFile(o,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,o,t)||await this.mkdirp(r,i.dirname(o));let h;if((0,k.hasReadWriteCapability)(r)&&!(a instanceof w.VSBuffer))if((0,g.isReadableStream)(a)){const c=await(0,g.peekStream)(a,3);c.ended?h=w.VSBuffer.concat(c.buffer):h=c}else h=(0,g.peekReadable)(a,c=>w.VSBuffer.concat(c),3);else h=a;!(0,k.hasOpenReadWriteCloseCapability)(r)||(0,k.hasReadWriteCapability)(r)&&h instanceof w.VSBuffer?await this.doWriteUnbuffered(r,o,t,h):await this.doWriteBuffered(r,o,t,h instanceof w.VSBuffer?(0,w.bufferToReadable)(h):h)}catch(s){throw new k.FileOperationError((0,E.localize)(4,null,this.resourceForError(o),(0,k.ensureFileSystemProviderError)(s).toString()),(0,k.toFileOperationResult)(s),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,a,t){if(!!t?.unlock&&!(o.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(a)));let i;try{i=await o.stat(a)}catch(s){return}if((i.type&k.FileType.Directory)!=0)throw new k.FileOperationError((0,E.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==(0,k.etag)({mtime:t.mtime,size:i.size}))throw new k.FileOperationError((0,E.localize)(7,null),3,t);return i}async readFile(o,a){const t=await this.withReadProvider(o);return a?.atomic?this.doReadFileAtomic(t,o,a):this.doReadFile(t,o,a)}async doReadFileAtomic(o,a,t){return new Promise((r,i)=>{this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,a,t);r(s)}catch(s){i(s)}})})}async doReadFile(o,a,t){const r=await this.doReadFileStream(o,a,{...t,preferUnbuffered:!0});return{...r,value:await(0,w.streamToBuffer)(r.value)}}async readFileStream(o,a){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,a)}async doReadFileStream(o,a,t){const r=new u.CancellationTokenSource,i=this.validateReadFile(a,t).then(h=>h,h=>{throw r.cancel(),h});let s;try{return t&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&await i,!((0,k.hasOpenReadWriteCloseCapability)(o)||(0,k.hasFileReadStreamCapability)(o))||(0,k.hasReadWriteCapability)(o)&&t?.preferUnbuffered?s=this.readFileUnbuffered(o,a,t):(0,k.hasFileReadStreamCapability)(o)?s=this.readFileStreamed(o,a,r.token,t):s=this.readFileBuffered(o,a,r.token,t),{...await i,value:s}}catch(h){s&&await(0,g.consumeStream)(s);const c=(0,E.localize)(8,null,this.resourceForError(a),(0,k.ensureFileSystemProviderError)(h).toString());throw h instanceof k.NotModifiedSinceFileOperationError?new k.NotModifiedSinceFileOperationError(c,h.stat,t):new k.FileOperationError(c,(0,k.toFileOperationResult)(h),t)}}readFileStreamed(o,a,t,r=Object.create(null)){const i=o.readFileStream(a,r,t);return(0,g.transform)(i,{data:s=>s instanceof w.VSBuffer?s:w.VSBuffer.wrap(s),error:s=>new k.FileOperationError((0,E.localize)(9,null,this.resourceForError(a),(0,k.ensureFileSystemProviderError)(s).toString()),(0,k.toFileOperationResult)(s),r)},s=>w.VSBuffer.concat(s))}readFileBuffered(o,a,t,r=Object.create(null)){const i=(0,w.newWriteableBufferStream)();return(0,C.readFileIntoStream)(o,a,i,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new k.FileOperationError((0,E.localize)(10,null,this.resourceForError(a),(0,k.ensureFileSystemProviderError)(s).toString()),(0,k.toFileOperationResult)(s),r)},t),i}readFileUnbuffered(o,a,t){const r=(0,g.newWriteableStream)(i=>w.VSBuffer.concat(i));return(async()=>{try{let i=await o.readFile(a);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(a,i.byteLength,t),r.end(w.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(o,a){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new k.FileOperationError((0,E.localize)(11,null,this.resourceForError(o)),0,a);if(a&&typeof a.etag=="string"&&a.etag!==k.ETAG_DISABLED&&a.etag===t.etag)throw new k.NotModifiedSinceFileOperationError((0,E.localize)(12,null),t,a);return this.validateReadFileLimits(o,t.size,a),t}validateReadFileLimits(o,a,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&a>t.limits.size&&(r=7),typeof r=="number")throw new k.FileOperationError((0,E.localize)(13,null,this.resourceForError(o)),r)}}async canMove(o,a,t){return this.doCanMoveCopy(o,a,"move",t)}async canCopy(o,a,t){return this.doCanMoveCopy(o,a,"copy",t)}async doCanMoveCopy(o,a,t,r){if(o.toString()!==a.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(i,o,s,a,t,r)}catch(i){return i}return!0}async move(o,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,o,i,a,"move",!!t),h=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(o,s==="move"?2:3,h)),h}async copy(o,a,t){const r=await this.withReadProvider(o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,o,i,a,"copy",!!t),h=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(o,s==="copy"?3:2,h)),h}async doMoveCopy(o,a,t,r,i,s){if(a.toString()===r.toString())return i;const{exists:h,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(o,a,t,r,i,s);if(h&&!c&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(o===t&&(0,k.hasFileFolderCopyCapability)(o))await o.copy(a,r,{overwrite:s});else{const l=await this.resolve(a);l.isDirectory?await this.doCopyFolder(o,l,t,r):await this.doCopyFile(o,a,t,r)}return i}else return o===t?(await o.rename(a,r,{overwrite:s}),i):(await this.doMoveCopy(o,a,t,r,"copy",s),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(o,a,t,r){if((0,k.hasOpenReadWriteCloseCapability)(o)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,a,t,r);if((0,k.hasOpenReadWriteCloseCapability)(o)&&(0,k.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,a,t,r);if((0,k.hasReadWriteCapability)(o)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,a,t,r);if((0,k.hasReadWriteCapability)(o)&&(0,k.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,a,t,r)}async doCopyFolder(o,a,t,r){await t.mkdir(r),Array.isArray(a.children)&&await m.Promises.settled(a.children.map(async i=>{const s=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(o,await this.resolve(i.resource),t,s):this.doCopyFile(o,i.resource,t,s)}))}async doValidateMoveCopy(o,a,t,r,i,s){let h=!1;if(o===t){const{providerExtUri:l,isPathCaseSensitive:f}=this.getExtUri(o);if(f||(h=l.isEqual(a,r)),h&&i==="copy")throw new Error((0,E.localize)(14,null,this.resourceForError(a),this.resourceForError(r)));if(!h&&l.isEqualOrParent(r,a))throw new Error((0,E.localize)(15,null,this.resourceForError(a),this.resourceForError(r)))}const c=await this.exists(r);if(c&&!h){if(!s)throw new k.FileOperationError((0,E.localize)(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(o===t){const{providerExtUri:l}=this.getExtUri(o);if(l.isEqualOrParent(a,r))throw new Error((0,E.localize)(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:c,isSameResourceWithDifferentPathCase:h}}getExtUri(o){const a=this.isPathCaseSensitive(o);return{providerExtUri:a?P.extUri:P.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(a,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(o,0,t)),t}async mkdirp(o,a){const t=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(a,r.dirname(a));)try{if(((await o.stat(a)).type&k.FileType.Directory)==0)throw new Error((0,E.localize)(18,null,this.resourceForError(a)));break}catch(i){if((0,k.toFileSystemProviderErrorCode)(i)!==k.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(a)),a=r.dirname(a)}for(let i=t.length-1;i>=0;i--){a=r.joinPath(a,t[i]);try{await o.mkdir(a)}catch(s){if((0,k.toFileSystemProviderErrorCode)(s)!==k.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,a){try{await this.doValidateDelete(o,a)}catch(t){return t}return!0}async doValidateDelete(o,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,E.localize)(19,null,this.resourceForError(o)));let i;try{i=await t.stat(o)}catch(h){}if(i)this.throwIfFileIsReadonly(o,i);else throw new k.FileOperationError((0,E.localize)(20,null,this.resourceForError(o)),1);if(!!!a?.recursive){const h=await this.resolve(o);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,E.localize)(21,null,this.resourceForError(o)))}return t}async del(o,a){const t=await this.doValidateDelete(o,a),r=!!a?.useTrash,i=!!a?.recursive;await t.delete(o,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new k.FileOperationEvent(o,1))}onDidChangeFile(o,a){this._onDidChangeFilesRaw.fire({changes:o});let t,r;{for(const i of o)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(r||(r=[]),r.push(i));t&&this._onDidFilesChange.fire(new k.FileChangesEvent(t,!a))}if(r){const i=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&qe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,a={recursive:!1,excludes:[]}){const t=new L.DisposableStore;{let r=!1,i=()=>{r=!0};t.add((0,L.toDisposable)(()=>i())),this.doWatch(o,a).then(s=>{r?(0,L.dispose)(s):i=()=>(0,L.dispose)(s)},s=>this.logService.error(s))}return a.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),t.add((0,L.toDisposable)(()=>{const r=this.watchedResources.get(o);typeof r=="number"&&(r<=1?this.watchedResources.delete(o):this.watchedResources.set(o,r-1))}))),t}async doWatch(o,a){const t=await this.withProvider(o),r=this.toWatchKey(t,o,a),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(o,a)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,(0,L.toDisposable)(()=>{i.count--,i.count===0&&((0,L.dispose)(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(o,a,t){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,L.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{const i=await o.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,g.isReadableStream)(r)||(0,g.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(o,i,r):await this.doWriteReadableBufferedQueued(o,i,r)}catch(s){throw(0,k.ensureFileSystemProviderError)(s)}finally{await o.close(i)}})}async doWriteStreamBufferedQueued(o,a,t){let r=0,i;if((0,g.isReadableBufferedStream)(t)){if(t.buffer.length>0){const s=w.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,a,s,s.byteLength,r,0),r+=s.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(s,h)=>{(0,g.listenStream)(i,{onData:async c=>{i.pause();try{await this.doWriteBuffer(o,a,c,c.byteLength,r,0)}catch(l){return h(l)}r+=c.byteLength,setTimeout(()=>i.resume())},onError:c=>h(c),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,a,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(o,a,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(o,a,t,r,i,s){let h=0;for(;h<r;)h+=await o.write(a,i+h,t.buffer,s+h,r-h)}async doWriteUnbuffered(o,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,a,t,r))}async doWriteUnbufferedQueued(o,a,t,r){let i;r instanceof w.VSBuffer?i=r:(0,g.isReadableStream)(r)?i=await(0,w.streamToBuffer)(r):(0,g.isReadableBufferedStream)(r)?i=await(0,w.bufferedStreamToBuffer)(r):i=(0,w.readableToBuffer)(r),await o.writeFile(a,i.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,a,t,r))}async doPipeBufferedQueued(o,a,t,r){let i,s;try{i=await o.open(a,{create:!1}),s=await t.open(r,{create:!0,unlock:!1});const h=w.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,l=0,f=0;do f=await o.read(i,c,h.buffer,l,h.byteLength-l),await this.doWriteBuffer(t,s,h,f,c,l),c+=f,l+=f,l===h.byteLength&&(l=0);while(f>0)}catch(h){throw(0,k.ensureFileSystemProviderError)(h)}finally{await m.Promises.settled([typeof i=="number"?o.close(i):Promise.resolve(),typeof s=="number"?t.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,a,t,r))}async doPipeUnbufferedQueued(o,a,t,r){return t.writeFile(r,await o.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,a,t,r))}async doPipeUnbufferedToBufferedQueued(o,a,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const s=await o.readFile(a);await this.doWriteBuffer(t,i,w.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,k.ensureFileSystemProviderError)(s)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(o,a,t,r){const i=await(0,w.streamToBuffer)(this.readFileBuffered(o,a,u.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(o,a){if(o.capabilities&2048)throw new k.FileOperationError((0,E.localize)(22,null,this.resourceForError(a)),6);return o}throwIfFileIsReadonly(o,a){if((a.permissions??0)&k.FilePermission.Readonly)throw new k.FileOperationError((0,E.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===I.Schemas.file?o.fsPath:o.toString(!0)}};D.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},D=de([Y(0,n.ILogService)],D),e.FileService=D}),define(Z[170],ee([0,1,2,13,3,4,18,8,15,39,6,14,124,77,144,146,143,157,49,80,23,25]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I,C,b,D,v,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends E.Disposable{constructor(i,s){super();this.logService=i,this.options=s,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=L.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new L.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:s,symbolicLink:h}=await A.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(s,h),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(i){try{const s=await A.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),h=[];return await Promise.all(s.map(async c=>{try{let l;c.isSymbolicLink()?l=(await this.stat((0,p.joinPath)(i,c.name))).type:l=this.toType(c),h.push([c.name,l])}catch(l){this.logService.trace(l)}})),h}catch(s){throw this.toFileSystemProviderError(s)}}toType(i,s){let h;return s?.dangling?h=R.FileType.Unknown:i.isFile()?h=R.FileType.File:i.isDirectory()?h=R.FileType.Directory:h=R.FileType.Unknown,s&&(h|=R.FileType.SymbolicLink),h}async readFile(i){try{const s=this.toFilePath(i);return await A.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(i,s,h){const c=(0,D.newWriteableStream)(l=>a.VSBuffer.concat(l.map(f=>a.VSBuffer.wrap(f))).buffer);return(0,v.readFileIntoStream)(this,i,c,l=>l.buffer,{...s,bufferSize:this.BUFFER_SIZE},h),c}async writeFile(i,s,h){let c;try{const l=this.toFilePath(i);if(!h.create||!h.overwrite){if(await A.Promises.exists(l)){if(!h.overwrite)throw(0,R.createFileSystemProviderError)((0,g.localize)(0,null),R.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw(0,R.createFileSystemProviderError)((0,g.localize)(1,null),R.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:h.unlock}),await this.write(c,0,s,0,s.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof c=="number"&&await this.close(c)}}async open(i,s){try{const h=this.toFilePath(i);if((0,R.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:f}=await A.SymlinkSupport.stat(h);f.mode&128||await A.Promises.chmod(h,f.mode|128)}catch(f){this.logService.trace(f)}let c;if((0,R.isFileOpenForWriteOptions)(s)){if(k.isWindows)try{await A.Promises.truncate(h,0),c="r+"}catch(f){f.code!=="ENOENT"&&this.logService.trace(f)}c||(c="w")}else c="r";const l=await A.Promises.open(h,c);return this.mapHandleToPos.set(l,0),(0,R.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(l,i),l}catch(h){throw(0,R.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(i,h):this.toFileSystemProviderError(h)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await A.Promises.fdatasync(i)}catch(s){this.canFlush=!1,this.logService.error(s)}return await A.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}}async read(i,s,h,c,l){const f=this.normalizePos(i,s);let S=null;try{const d=await A.Promises.read(i,h,c,l,f);return typeof d=="number"?S=d:S=d.bytesRead,S}catch(d){throw this.toFileSystemProviderError(d)}finally{this.updatePos(i,f,S)}}normalizePos(i,s){return s===this.mapHandleToPos.get(i)?null:s}updatePos(i,s,h){const c=this.mapHandleToPos.get(i);typeof c=="number"&&(typeof s=="number"||(typeof h=="number"?this.mapHandleToPos.set(i,c+h):this.mapHandleToPos.delete(i)))}async write(i,s,h,c,l){return(0,n.retry)(()=>this.doWrite(i,s,h,c,l),100,3)}async doWrite(i,s,h,c,l){const f=this.normalizePos(i,s);let S=null;try{const d=await A.Promises.write(i,h,c,l,f);return typeof d=="number"?S=d:S=d.bytesWritten,S}catch(d){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),d)}finally{this.updatePos(i,f,S)}}async mkdir(i){try{await A.Promises.mkdir(this.toFilePath(i))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(i,s){try{const h=this.toFilePath(i);await this.doDelete(h,s)}catch(h){throw this.toFileSystemProviderError(h)}}async doDelete(i,s){s.recursive?await A.Promises.rm(i,A.RimRafMode.MOVE):await A.Promises.unlink(i)}async rename(i,s,h){const c=this.toFilePath(i),l=this.toFilePath(s);if(c!==l)try{await this.validateTargetDeleted(i,s,"move",h.overwrite),await A.Promises.move(c,l)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,g.localize)(2,null,(0,P.basename)(c),(0,P.basename)((0,P.dirname)(l)),f.toString()))),this.toFileSystemProviderError(f)}}async copy(i,s,h){const c=this.toFilePath(i),l=this.toFilePath(s);if(c!==l)try{await this.validateTargetDeleted(i,s,"copy",h.overwrite),await A.Promises.copy(c,l,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,g.localize)(3,null,(0,P.basename)(c),(0,P.basename)((0,P.dirname)(l)),f.toString()))),this.toFileSystemProviderError(f)}}async validateTargetDeleted(i,s,h,c){const l=this.toFilePath(i),f=this.toFilePath(s);let S=!1;if(!!(this.capabilities&1024)||(S=(0,y.isEqual)(l,f,!0)),S&&h==="copy")throw(0,R.createFileSystemProviderError)((0,g.localize)(4,null),R.FileSystemProviderErrorCode.FileExists);if(!S&&await A.Promises.exists(f)){if(!c)throw(0,R.createFileSystemProviderError)((0,g.localize)(5,null),R.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(i,s){return s.recursive?this.watchRecursive(i,s.excludes):this.watchNonRecursive(i)}watchRecursive(i,s){const h={path:this.toFilePath(i),excludes:s},c=(0,o.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,E.toDisposable)(()=>{c(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof C.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,E.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,s;this.options?.watcher?.usePolling?(i=u.FileWatcher,s=this.options?.watcher):this.recursiveFoldersToWatch.length===1?k.isWindows?i=I.FileWatcher:i=u.FileWatcher:i=C.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,h=>this._onDidChangeFile.fire((0,m.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===w.LogLevel.Trace,s),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))}}watchNonRecursive(i){const s=new b.FileWatcher(this.toFilePath(i),c=>this._onDidChangeFile.fire((0,m.toFileChanges)(c)),c=>{c.type==="error"&&this._onDidWatchErrorOccur.fire(c.message),this.logService[c.type](c.message)},this.logService.getLevel()===w.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)});return(0,E.combinedDisposable)(s,h)}toFilePath(i){return(0,P.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof R.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=R.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=R.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=R.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=R.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=R.FileSystemProviderErrorCode.NoPermissions;break;default:s=R.FileSystemProviderErrorCode.Unknown}return(0,R.createFileSystemProviderError)(i,s)}async toFileSystemProviderWriteError(i,s){let h=this.toFileSystemProviderError(s);if(i&&h.code===R.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await A.SymlinkSupport.stat(this.toFilePath(i));c.mode&128||(h=(0,R.createFileSystemProviderError)(s,R.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return h}dispose(){super.dispose(),(0,E.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,E.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(Z[28],ee([0,1,7]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService")}),define(Z[171],ee([0,1,6,11,2,8,18,14,28]),function(K,e,E,R,L,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let y=class extends L.Disposable{constructor(w,g,m){super();this.productService=g,this.logService=m,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this._register(new E.RunOnceScheduler(()=>{this.cleanUpCodeCaches(w)},30*1e3)).schedule()}async cleanUpCodeCaches(w){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),m=(0,k.dirname)(w),u=(0,k.basename)(w),I=await A.Promises.readdir(m);await Promise.all(I.map(async C=>{if(C===u)return;const b=(0,k.join)(m,C),D=await A.Promises.stat(b);if(D.isDirectory()&&g-D.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${C}.`),A.Promises.rm(b)}))}catch(g){(0,R.onUnexpectedError)(g)}}};y=de([Y(1,p.IProductService),Y(2,P.ILogService)],y),e.CodeCacheCleaner=y}),define(Z[172],ee([0,1,6,11,2,8,18,12,14,28]),function(K,e,E,R,L,k,A,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends L.Disposable{constructor(g,m,u){super();this.environmentService=g,this.logService=m,this.productService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new E.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),m=JSON.parse(await A.Promises.readFile((0,k.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let D of Object.keys(m)){const v=m[D];g[`${v.hash}.${D}`]=!0}const u=(0,k.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(u))return;const C=await A.Promises.readdir(u);for(const D of C){if(g[D]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${D}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${D}`),await A.Promises.rm((0,k.join)(u,D))}const b=Date.now();for(const D of Object.keys(g)){const v=(0,k.join)(u,D),o=await A.Promises.readdir(v);for(const a of o){if(a==="tcf.json")continue;const t=(0,k.join)(v,a),r=await A.Promises.stat(t);r.isDirectory()&&b-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(D,a)}`),await A.Promises.rm(t))}}}catch(g){(0,R.onUnexpectedError)(g)}}};n=de([Y(0,P.INativeEnvironmentService),Y(1,p.ILogService),Y(2,y.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(Z[32],ee([0,1,16,90]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(A,P){R.ok(E.isString(A)),R.ok(E.isObject(P)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new L}),define(Z[81],ee([0,1,32,3]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class k{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,y){this.schemasById[L(p)]=y,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new k;E.Registry.add(e.Extensions.JSONContribution,A)}),define(Z[38],ee([0,1,111,3,32,16,81]),function(K,e,E,R,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=L.Registry.as(A.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(D,v=!0){this.registerConfigurations([D],v)}registerConfigurations(D,v=!0){const o=[];D.forEach(a=>{o.push(...this.validateAndRegisterProperties(a,v,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(D){const v=[],o=a=>{if(a.properties)for(const t in a.properties)v.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,a.properties[t]);a.allOf&&a.allOf.forEach(t=>o(t))};for(const a of D){o(a);const t=this.configurationContributors.indexOf(a);t!==-1&&this.configurationContributors.splice(t,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}registerDefaultConfigurations(D){const v=[],o=[];for(const a of D)for(const t in a)if(v.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...a[t]};const r={type:"object",default:this.defaultValues[t],description:E.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};o.push(g(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=a[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterDefaultConfigurations(D){const v=[];for(const o of D)for(const a in o)if(v.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}notifyConfigurationSchemaUpdated(...D){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(D){for(const v of D)this.overrideIdentifiers.add(v);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(D,v=!0,o,a=3){a=k.isUndefinedOrNull(D.scope)?a:D.scope;let t=[],r=D.properties;if(r)for(let s in r){if(v&&I(s)){delete r[s];continue}const h=r[s];if(this.updatePropertyDefaultValue(s,h),e.OVERRIDE_PROPERTY_PATTERN.test(s)?h.scope=void 0:(h.scope=k.isUndefinedOrNull(h.scope)?a:h.scope,h.restricted=k.isUndefinedOrNull(h.restricted)?!!o?.restrictedConfigurations?.includes(s):h.restricted),r[s].hasOwnProperty("included")&&!r[s].included){this.excludedConfigurationProperties[s]=r[s],delete r[s];continue}else this.configurationProperties[s]=r[s];!r[s].deprecationMessage&&r[s].markdownDeprecationMessage&&(r[s].deprecationMessage=r[s].markdownDeprecationMessage),t.push(s)}let i=D.allOf;if(i)for(let s of i)t.push(...this.validateAndRegisterProperties(s,v,o,a));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(D){const v=o=>{let a=o.properties;if(a)for(const r in a)this.updateSchema(r,a[r]);let t=o.allOf;t&&t.forEach(v)};v(D)}updateSchema(D,v){switch(e.allSettings.properties[D]=v,v.scope){case 1:e.applicationSettings.properties[D]=v;break;case 2:e.machineSettings.properties[D]=v;break;case 6:e.machineOverridableSettings.properties[D]=v;break;case 3:e.windowSettings.properties[D]=v;break;case 4:e.resourceSettings.properties[D]=v;break;case 5:e.resourceSettings.properties[D]=v,this.resourceLanguageSettingsSchema.properties[D]=v;break}}removeFromSchema(D,v){switch(delete e.allSettings.properties[D],v.scope){case 1:delete e.applicationSettings.properties[D];break;case 2:delete e.machineSettings.properties[D];break;case 6:delete e.machineOverridableSettings.properties[D];break;case 3:delete e.windowSettings.properties[D];break;case 4:case 5:delete e.resourceSettings.properties[D];break}}updateOverridePropertyPatternKey(){for(const D of this.overrideIdentifiers.values()){const v=`[${D}]`,o={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(v,o),e.allSettings.properties[v]=o,e.applicationSettings.properties[v]=o,e.machineSettings.properties[v]=o,e.machineOverridableSettings.properties[v]=o,e.windowSettings.properties[v]=o,e.resourceSettings.properties[v]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(D,v){let o=this.defaultValues[D];k.isUndefined(o)&&(o=v.default),k.isUndefined(o)&&(o=m(v.type)),v.default=o}}const w="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(w);function g(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=g;function m(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const u=new n;L.Registry.add(e.Extensions.Configuration,u);function I(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?E.localize(5,null,b):u.getConfigurationProperties()[b]!==void 0?E.localize(6,null,b):null:E.localize(4,null)}e.validateProperty=I;function C(){const b=[],D=u.getConfigurationProperties();for(const v of Object.keys(D))b.push([v,D[v].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=C}),define(Z[24],ee([0,1,26,16,5,32,7,38]),function(K,e,E,R,L,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function p(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=p;var y;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function w(r,i){const s=i?r?i.keys.filter(T=>r.keys.indexOf(T)===-1):[...i.keys]:[],h=r?i?r.keys.filter(T=>i.keys.indexOf(T)===-1):[...r.keys]:[],c=[];if(i&&r){for(const T of r.keys)if(i.keys.indexOf(T)!==-1){const O=b(r.contents,T),x=b(i.contents,T);E.equals(O,x)||c.push(T)}}const l=[],f=T=>{const O={};for(const x of T)for(const z of x.identifiers)O[a(z)]=x;return O},S=i?f(i.overrides):{},d=r?f(r.overrides):{};if(Object.keys(S).length)for(const T of s){const O=S[T];O&&l.push([(0,P.overrideIdentifierFromKey)(T),O.keys])}if(Object.keys(d).length)for(const T of h){const O=d[T];O&&l.push([(0,P.overrideIdentifierFromKey)(T),O.keys])}if(Object.keys(S).length&&Object.keys(d).length)for(const T of c){const O=d[T],x=S[T];if(O&&x){const z=w({contents:O.contents,keys:O.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});l.push([(0,P.overrideIdentifierFromKey)(T),[...z.added,...z.removed,...z.updated]])}}return{added:s,removed:h,updated:c,overrides:l}}e.compare=w;function g(r,i){const s=[];for(const h of Object.keys(r))if(P.OVERRIDE_PROPERTY_PATTERN.test(h)){const c={};for(const l in r[h])c[l]=r[h][l];s.push({identifiers:[(0,P.overrideIdentifierFromKey)(h).trim()],keys:Object.keys(c),contents:m(c,i)})}return s}e.toOverrides=g;function m(r,i){const s=Object.create(null);for(let h in r)u(s,h,r[h],i);return s}e.toValuesTree=m;function u(r,i,s,h){const c=i.split("."),l=c.pop();let f=r;for(let S=0;S<c.length;S++){let d=c[S],T=f[d];switch(typeof T){case"undefined":T=f[d]=Object.create(null);break;case"object":break;default:h(`Ignoring ${i} as ${c.slice(0,S+1).join(".")} is ${JSON.stringify(T)}`);return}f=T}if(typeof f=="object"&&f!==null)try{f[l]=s}catch(S){h(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(f)}`)}else h(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(f)}`)}e.addToValueTree=u;function I(r,i){const s=i.split(".");C(r,s)}e.removeFromValueTree=I;function C(r,i){const s=i.shift();if(i.length===0){delete r[s];return}if(Object.keys(r).indexOf(s)!==-1){const h=r[s];typeof h=="object"&&!Array.isArray(h)&&(C(h,i),Object.keys(h).length===0&&delete r[s])}}function b(r,i,s){function h(f,S){let d=f;for(const T of S){if(typeof d!="object"||d===null)return;d=d[T]}return d}const c=i.split("."),l=h(r,c);return typeof l=="undefined"?s:l}e.getConfigurationValue=b;function D(r,i,s){Object.keys(i).forEach(h=>{h!=="__proto__"&&(h in r?R.isObject(r[h])&&R.isObject(i[h])?D(r[h],i[h],s):s&&(r[h]=i[h]):r[h]=i[h])})}e.merge=D;function v(){const r=k.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=v;function o(){const r=Object.create(null),i=k.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let s in i){let h=i[s].default;u(r,s,h,c=>console.error(`Conflict in default settings: ${c}`))}return r}e.getDefaultValues=o;function a(r){return`[${r}]`}e.keyFromOverrideIdentifier=a;function t(r,i,s){const h=r.inspect(i),c=r.inspect(s);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:h.defaultValue}e.getMigratedSettingValue=t}),define(Z[173],ee([0,1,33,40,23,16,26,5,38,24,32,2,3]),function(K,e,E,R,L,k,A,P,p,y,n,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,y.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?(0,y.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const s of L.distinct([...Object.keys(this.contents),...Object.keys(r)])){let h=this.contents[s],c=r[s];c&&(typeof h=="object"&&typeof c=="object"?(h=A.deepClone(h),this.mergeContents(h,c)):h=c),i[s]=h}return new m(i,this.keys,this.overrides)}merge(...t){const r=A.deepClone(this.contents),i=A.deepClone(this.overrides),s=[...this.keys];for(const h of t){this.mergeContents(r,h.contents);for(const c of h.overrides){const[l]=i.filter(f=>L.equals(f.identifiers,c.identifiers));l?this.mergeContents(l.contents,c.contents):i.push(A.deepClone(c))}for(const c of h.keys)s.indexOf(c)===-1&&s.push(c)}return new m(r,s,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&k.isObject(t[i])&&k.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=A.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,y.addToValueTree)(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,y.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=m;class u extends m{constructor(){const t=(0,y.getDefaultValues)(),r=(0,y.getConfigurationKeys)(),i=[];for(const s of Object.keys(t))p.OVERRIDE_PROPERTY_PATTERN.test(s)&&i.push({identifiers:[(0,p.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,y.toValuesTree)(t[s],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,r,i)}}e.DefaultConfigurationModel=u;class I{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!k.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:s,overrides:h,restricted:c}=this.doParseRaw(t,r);this._configurationModel=new m(i,s,h),this._restrictedConfigurations=c||[]}doParseContent(t){let r={},i=null,s=[],h=[],c=[];function l(S){Array.isArray(s)?s.push(S):i!==null&&(s[i]=S)}let f={onObjectBegin:()=>{let S={};l(S),h.push(s),s=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{s=h.pop()},onArrayBegin:()=>{let S=[];l(S),h.push(s),s=S,i=null},onArrayEnd:()=>{s=h.pop()},onLiteralValue:l,onError:(S,d,T)=>{c.push({error:S,offset:d,length:T})}};if(t)try{E.visit(t,f),r=s[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return r}doParseRaw(t,r){const i=n.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,i,!0,r);t=s.raw;const h=(0,y.toValuesTree)(t,f=>console.error(`Conflict in settings file ${this._name}: ${f}`)),c=Object.keys(t),l=(0,y.toOverrides)(t,f=>console.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:h,keys:c,overrides:l,restricted:s.restricted}}filter(t,r,i,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:t,restricted:[]};const h={},c=[];for(let l in t)if(p.OVERRIDE_PROPERTY_PATTERN.test(l)&&i){const f=this.filter(t[l],r,!1,s);h[l]=f.raw,c.push(...f.restricted)}else{const f=r[l],S=f?typeof f.scope!="undefined"?f.scope:3:void 0;f?.restricted&&c.push(l),(S===void 0||s.scopes===void 0||s.scopes.includes(S))&&(s.skipRestricted&&f?.restricted||(h[l]=t[l]))}return{raw:h,restricted:c}}}e.ConfigurationModelParser=I;class C extends w.Disposable{constructor(t,r,i,s){super();this.userSettingsResource=t,this.scopes=r,this.fileService=s,this._onDidChange=this._register(new g.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new I(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(g.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=C;class b{constructor(t,r,i=new m,s=new m,h=new R.ResourceMap,c=new m,l=new R.ResourceMap,f=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=s,this._folderConfigurations=h,this._memoryConfiguration=c,this._memoryConfigurationByResource=l,this._freeze=f,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let s;i.resource?(s=this._memoryConfigurationByResource.get(i.resource),s||(s=new m,this._memoryConfigurationByResource.set(i.resource,s))):s=this._memoryConfiguration,r===void 0?s.removeValue(t):s.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const s=this.getConsolidateConfigurationModel(r,i),h=this.getFolderConfigurationModelForResource(r.resource,i),c=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,l=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),f=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),S=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),d=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=h?r.overrideIdentifier?h.freeze().override(r.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,x=r.overrideIdentifier?c.override(r.overrideIdentifier).getValue(t):c.getValue(t),z=s.getValue(t),H=L.distinct(L.flatten(s.overrides.map(V=>V.identifiers))).filter(V=>s.getOverrideValue(t,V)!==void 0);return{defaultValue:l,userValue:f,userLocalValue:S,userRemoteValue:d,workspaceValue:T,workspaceFolderValue:O,memoryValue:x,value:z,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:f!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:S!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:d!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:h?.freeze().getValue(t),override:r.overrideIdentifier?h?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:c.getValue(t),override:r.overrideIdentifier?c.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(s=>p.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const h=(0,p.overrideIdentifierFromKey)(s),c=this._defaultConfiguration.getKeysForOverrideIdentifier(h),l=t.getKeysForOverrideIdentifier(h),f=[...l.filter(S=>c.indexOf(S)===-1),...c.filter(S=>l.indexOf(S)===-1),...c.filter(S=>!A.equals(this._defaultConfiguration.override(h).getValue(S),t.override(h).getValue(S)))];return[h,f]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:h}=(0,y.compare)(this.localUserConfiguration,t),c=[...r,...i,...s];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:h}=(0,y.compare)(this.remoteUserConfiguration,t);let c=[...r,...i,...s];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:s,overrides:h}=(0,y.compare)(this.workspaceConfiguration,t);let c=[...r,...i,...s];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:h}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:s,updated:h,removed:c,overrides:l}=(0,y.compare)(i,r);let f=[...s,...h,...c];return(f.length||!i)&&this.updateFolderConfiguration(t,r),{keys:f,overrides:l}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:s,removed:h,overrides:c}=(0,y.compare)(r,void 0);return{keys:[...i,...s,...h],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const s=r.getFolder(t);s&&(i=this.getFolderConsolidatedConfiguration(s.uri)||i);const h=this._memoryConfigurationByResource.get(t);h&&(i=i.merge(h))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(r=i.merge(s),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:s,keys:h}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:s,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((c,l)=>(c.set(P.URI.revive(l[0]),this.parseConfigurationModel(l[1])),c),new R.ResourceMap);return new b(r,i,new m,s,h,new m,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function D(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,r=new Map;for(const s of a)s.keys.forEach(h=>t.add(h)),s.overrides.forEach(([h,c])=>{const l=(0,R.getOrSet)(r,h,new Set);c.forEach(f=>l.add(f))});const i=[];return r.forEach((s,h)=>i.push([h,[...s.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=D;class v{constructor(t,r,i,s){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=s,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(l=>h.add(l)),t.overrides.forEach(([,l])=>l.forEach(f=>h.add(f))),this.affectedKeys=[...h.values()];const c=new m;this.affectedKeys.forEach(l=>c.setValue(l,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!A.equals(i,s)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=(0,y.toValuesTree)({[r]:!0},()=>{}),s;for(;typeof i=="object"&&(s=Object.keys(i)[0]);){if(t=t[s],!t)return!1;i=i[s]}return!0}}e.ConfigurationChangeEvent=v;class o extends v{constructor(t,r,i,s){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=o}),define(Z[174],ee([0,1,32,38,2,24,173,3,6,15]),function(K,e,E,R,L,k,A,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends L.Disposable{constructor(g,m){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new A.UserSettings(this.settingsResource,void 0,y.extUriBiasedIgnorePathCase,m)),this.configuration=new A.Configuration(new A.DefaultConfigurationModel,new A.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(R.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new A.Configuration(new A.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,m){const u=typeof g=="string"?g:void 0,I=(0,k.isConfigurationOverrides)(g)?g:(0,k.isConfigurationOverrides)(m)?m:{};return this.configuration.getValue(u,I,void 0)}updateValue(g,m,u,I){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const m=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(u,m,1)}onDidDefaultConfigurationChange(g){const m=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new A.DefaultConfigurationModel,g);this.trigger(u,m,6)}trigger(g,m,u){const I=new A.ConfigurationChangeEvent(g,{data:m},this.configuration);I.source=u,I.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(I)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(Z[175],ee([0,1,24,14,105]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(P,p){this.configurationService=P,this.logService=p}request(P,p){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,L.request)(P,p)}async resolveProxy(P){}};k=de([Y(0,E.IConfigurationService),Y(1,R.ILogService)],k),e.RequestService=k}),define(Z[42],ee([0,1,125,7,38,32,25]),function(K,e,E,R,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function P(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=P;function p(u){return u.res.statusCode===204}async function y(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);return p(u)?null:(await(0,A.streamToBuffer)(u.stream)).toString()}e.asText=y;async function n(u){if(!P(u))throw new Error("Server returned "+u.res.statusCode);if(p(u))return null;const C=(await(0,A.streamToBuffer)(u.stream)).toString();try{return JSON.parse(C)}catch(b){throw b.message+=`:
`+C,b}}e.asJson=n;function w(u){m(u)}e.updateProxyConfigurationsScope=w;let g;function m(u){const I=k.Registry.as(L.Extensions.Configuration);g&&I.deregisterConfigurations([g]),g={id:"http",order:15,title:(0,E.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,E.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,E.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,E.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,E.localize)(4,null),(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],default:"override",description:(0,E.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,E.localize)(9,null),restricted:!0}}},I.registerConfiguration(g)}m(2)}),define(Z[176],ee([0,1,42,29,13,17]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(p,y){this.requestService=p,this.fileService=y}async download(p,y,n=R.CancellationToken.None){if(p.scheme===k.Schemas.file||p.scheme===k.Schemas.vscodeRemote){await this.fileService.copy(p,y);return}const w={type:"GET",url:p.toString()},g=await this.requestService.request(w,n);if(g.res.statusCode===200)await this.fileService.writeFile(y,g.stream);else{const m=await(0,E.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${m}`)}}};A=de([Y(0,E.IRequestService),Y(1,L.IFileService)],A),e.DownloadService=A}),define(Z[177],ee([0,1,28,13,23,63,42,29,14,15,139,2]),function(K,e,E,R,L,k,A,P,p,y,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let g=class extends w.Disposable{constructor(u,I,C,b){super();this.fileService=u,this.productService=I,this.requestService=C,this.logService=b,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,k.forEach)(this.productService.configBasedExtensionTips,({value:D})=>this.allConfigBasedTips.set(D.configPath,D))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const I=[];for(const[C,b]of this.allConfigBasedTips)try{const D=await this.fileService.readFile((0,y.joinPath)(u,C)),v=new Map;(0,k.forEach)(b.recommendations,({key:a,value:t})=>{if((0,L.isNonEmptyArray)(t.remotes))for(const r of t.remotes)v.set(r,{extensionId:a,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else I.push({extensionId:a,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=(0,n.getDomainsOfRemotes)(D.value.toString(),[...v.keys()]);for(const a of o){const t=v.get(a);t&&I.push(t)}}catch(D){}return I}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const u=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},P.CancellationToken.None);if(u.res.statusCode!==200)return[];const I=await(0,A.asJson)(u);return I?I.workspaceRecommendations||[]:[]}catch(u){return this.logService.error(u),[]}}};g=de([Y(0,R.IFileService),Y(1,E.IProductService),Y(2,A.IRequestService),Y(3,p.ILogService)],g),e.ExtensionTipsService=g}),define(Z[45],ee([0,1,30,25]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(k,A,P){let p=P&&P.get("storage.serviceMachineId",0)||null;if(p)return p;try{const n=(await A.readFile(k.serviceMachineIdResource)).value.toString();p=(0,E.isUUID)(n)?n:null}catch(y){p=null}if(!p){p=(0,E.generateUuid)();try{await A.writeFile(k.serviceMachineIdResource,R.VSBuffer.fromString(p))}catch(y){}}return P&&P.store("storage.serviceMachineId",p,0,1),p}e.getServiceMachineId=L}),define(Z[20],ee([0,1,7,3,2,16,70,6]),function(K,e,E,R,L,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";e.IStorageService=(0,E.createDecorator)("storageService");var y;(function(I){I[I.NONE=0]="NONE",I[I.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(I){I[I.GLOBAL=0]="GLOBAL",I[I.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var w;(function(I){I[I.USER=0]="USER",I[I.MACHINE=1]="MACHINE"})(w=e.StorageTarget||(e.StorageTarget={}));class g extends L.Disposable{constructor(C={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super();this.options=C,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new P.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,P.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(C,b){b===p?(C===0?this._globalKeyTargets=void 0:C===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:C})):this._onDidChangeValue.fire({scope:C,key:b,target:this.getKeyTargets(C)[b]})}emitWillSaveState(C){this._onWillSaveState.fire({reason:C})}get(C,b,D){return this.getStorage(b)?.get(C,D)}getBoolean(C,b,D){return this.getStorage(b)?.getBoolean(C,D)}getNumber(C,b,D){return this.getStorage(b)?.getNumber(C,D)}store(C,b,D,v){if((0,k.isUndefinedOrNull)(b)){this.remove(C,D);return}this.withPausedEmitters(()=>{this.updateKeyTarget(C,D,v),this.getStorage(D)?.set(C,b)})}remove(C,b){this.withPausedEmitters(()=>{this.updateKeyTarget(C,b,void 0),this.getStorage(b)?.delete(C)})}withPausedEmitters(C){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{C()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(C,b){const D=[],v=this.getKeyTargets(C);for(const o of Object.keys(v))v[o]===b&&D.push(o);return D}updateKeyTarget(C,b,D){const v=this.getKeyTargets(b);typeof D=="number"?v[C]!==D&&(v[C]=D,this.getStorage(b)?.set(p,JSON.stringify(v))):typeof v[C]=="number"&&(delete v[C],this.getStorage(b)?.set(p,JSON.stringify(v)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(C){return C===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(C){const b=this.get(p,C);if(b)try{return JSON.parse(b)}catch(D){}return Object.create(null)}isNew(C){return this.getBoolean(e.IS_NEW_KEY,C)===!0}async flush(C=y.NONE){this._onWillSaveState.fire({reason:C}),await P.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const C=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return u(C,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;class m extends g{constructor(){super();this.globalStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(C=>this.emitDidChangeValue(1,C))),this._register(this.globalStorage.onDidChangeStorage(C=>this.emitDidChangeValue(0,C)))}getStorage(C){return C===0?this.globalStorage:this.workspaceStorage}getLogDetails(C){return C===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(C){}}e.InMemoryStorageService=m;async function u(I,C,b,D){const v=h=>{try{return JSON.parse(h)}catch(c){return h}},o=new Map,a=new Map;I.forEach((h,c)=>{o.set(c,h),a.set(c,v(h))});const t=new Map,r=new Map;C.forEach((h,c)=>{t.set(c,h),r.set(c,v(h))}),console.group(`Storage: Global (path: ${b})`);let i=[];o.forEach((h,c)=>{i.push({key:c,value:h})}),console.table(i),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${D})`);let s=[];t.forEach((h,c)=>{s.push({key:c,value:h})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=u}),define(Z[178],ee([0,1,3,2,27,31,20,16]),function(K,e,E,R,L,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let p=class extends R.Disposable{constructor(w){super();this._onDidChangeEnablement=new E.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new y(w)),this._register(this.storageManger.onDidChange(g=>this._onDidChangeEnablement.fire({extensions:g,source:"storage"})))}async enableExtension(w,g){return this._removeFromDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:g}),!0):!1}async disableExtension(w,g){return this._addToDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:g}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(w){let g=this.getDisabledExtensions();return g.every(m=>!(0,k.areSameExtensions)(m,w))?(g.push(w),this._setDisabledExtensions(g),!0):!1}_removeFromDisabledExtensions(w){let g=this.getDisabledExtensions();for(let m=0;m<g.length;m++){const u=g[m];if((0,k.areSameExtensions)(u,w))return g.splice(m,1),this._setDisabledExtensions(g),!0}return!1}_setDisabledExtensions(w){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,w)}_getExtensions(w){return this.storageManger.get(w,0)}_setExtensions(w,g){this.storageManger.set(w,g,0)}};p=de([Y(0,A.IStorageService)],p),e.GlobalExtensionEnablementService=p;class y extends R.Disposable{constructor(w){super();this.storageService=w,this.storage=Object.create(null),this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._register(w.onDidChangeValue(g=>this.onDidStorageChange(g)))}get(w,g){let m;return g===0?((0,P.isUndefinedOrNull)(this.storage[w])&&(this.storage[w]=this._get(w,g)),m=this.storage[w]):m=this._get(w,g),JSON.parse(m)}set(w,g,m){let u=JSON.stringify(g.map(({id:C,uuid:b})=>({id:C,uuid:b})));this._get(w,m)!==u&&(m===0&&(g.length?this.storage[w]=u:delete this.storage[w]),this._set(w,g.length?u:void 0,m))}onDidStorageChange(w){if(w.scope===0&&!(0,P.isUndefinedOrNull)(this.storage[w.key])&&this._get(w.key,w.scope)!==this.storage[w.key]){const m=this.get(w.key,w.scope);delete this.storage[w.key];const u=this.get(w.key,w.scope),I=m.filter(b=>!u.some(D=>(0,k.areSameExtensions)(b,D))),C=u.filter(b=>!m.some(D=>(0,k.areSameExtensions)(D,b)));(I.length||C.length)&&this._onDidChange.fire([...I,...C])}}_get(w,g){return this.storageService.get(w,g,"[]")}_set(w,g,m){g?this.storageService.store(w,g,m,1):this.storageService.remove(w,m)}}e.StorageManager=y}),define(Z[179],ee([0,1,3,2]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends R.Disposable{constructor(y,n){super();this.channel=y,this.workspace=n}async getItems(){const y={workspace:this.workspace},n=await this.channel.call("getItems",y);return new Map(n)}updateItems(y){const n={workspace:this.workspace};return y.insert&&(n.insert=Array.from(y.insert.entries())),y.delete&&(n.delete=Array.from(y.delete.values())),this.channel.call("updateItems",n)}}class k extends L{constructor(y){super(y,void 0);this._onDidChangeItemsExternal=this._register(new E.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(y=>this.onDidChangeGlobalStorage(y)))}onDidChangeGlobalStorage(y){(Array.isArray(y.changed)||Array.isArray(y.deleted))&&this._onDidChangeItemsExternal.fire({changed:y.changed?new Map(y.changed):void 0,deleted:y.deleted?new Set(y.deleted):void 0})}async close(){this.dispose()}}class A extends L{constructor(y,n){super(y,n);this.onDidChangeItemsExternal=E.Event.None}async close(){const y={workspace:this.workspace};return this.channel.call("close",y)}}class P extends R.Disposable{constructor(y,n){super();this.channel=y,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new k(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(Z[180],ee([0,1,2,20,70,6,169,179,15]),function(K,e,E,R,L,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class y extends R.AbstractStorageService{constructor(w,g,m){super();this.mainProcessService=g,this.environmentService=m,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new E.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(w)}createGlobalStorage(){const w=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),g=new L.Storage(w.globalStorage);return this._register(g.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),g}createWorkspaceStorage(w){const g=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),w);if(g.workspaceStorage){const m=new L.Storage(g.workspaceStorage);return this.workspaceStorageDisposable.value=m.onDidChangeStorage(u=>this.emitDidChangeValue(1,u)),this.workspaceStorageId=w?.id,m}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,A.mark)("code/willInitStorage");try{await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,A.mark)("code/didInitStorage")}}getStorage(w){return w===0?this.globalStorage:this.workspaceStorage}getLogDetails(w){return w===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,p.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(R.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(w){const g=this.workspaceStorage,m=g?.items??new Map;g&&(await g.close(),g.dispose()),this.workspaceStorage=this.createWorkspaceStorage(w),await this.workspaceStorage.init();for(const[u,I]of m)this.workspaceStorage.set(u,I)}}e.NativeStorageService=y}),define(Z[181],ee([0,1,4,35,30,5]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(y){if(E.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function P(y,n,w,g,m,u,I,C,b,D){const v=Object.create(null);v["common.machineId"]=I,v.sessionID=(0,L.generateUuid)()+Date.now(),v.commitHash=m,v.version=u,v["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,E.PlatformToString)(E.platform),v["common.nodePlatform"]=R.platform,v["common.nodeArch"]=g,v["common.product"]=D||"desktop";const o=p(C||[]);o&&(v["common.msftInternal"]=o);let a=0;const t=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),E.isLinuxSnap&&(v["common.snap"]="true");const r=A(w);r&&(v["common.platformDetail"]=r);try{const i=await y.readFile(k.URI.file(b));v["common.source"]=i.value.toString().slice(0,30)}catch(i){}return v}e.resolveCommonProperties=P;function p(y){const n=R.env.USERDNSDOMAIN;if(!n)return!1;const w=n.toLowerCase();return y.some(g=>w===g)}e.verifyMicrosoftInternalDomain=p}),define(Z[21],ee([0,1,7]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[182],ee([0,1,34,98,73,8,33,100,28,4,5,21,55,17,13,18]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function C(a,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,s=new Map,h=2e4;function c(S,d,T,O){const x=d.substring(S.length+1);return new Promise(async z=>{let H;try{H=await I.Promises.readdir(d,{withFileTypes:!0})}catch($){z();return}if(O.count>=h){O.count+=H.length,O.maxReached=!0,z();return}let V=H.length;if(V===0){z();return}let U=H;O.count+H.length>h&&(O.maxReached=!0,V=h-O.count,U=H.slice(0,V)),O.count+=H.length;for(const $ of U)if($.isDirectory()){if(T.includes($.name)||await c(S,(0,k.join)(d,$.name),T,O),--V==0){z();return}}else{const M=$.name.lastIndexOf(".");if(M>=0){const N=$.name.substring(M+1);N&&i.set(N,(i.get(N)??0)+1)}for(const N of r)N.relativePathPattern?.test(x)!==!1&&N.filePattern.test($.name)&&s.set(N.tag,(s.get(N.tag)??0)+1);if(--V==0){z();return}}})}const l={count:0,maxReached:!1};await c(a,a,t,l);const f=await v(a);return{configFiles:b(s),fileTypes:b(i),fileCount:l.count,maxFilesReached:l.maxReached,launchConfigFiles:f}}e.collectWorkspaceStats=C;function b(a){return[...g.Iterable.map(a.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function D(){const a={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},t=E.cpus();return t&&t.length>0&&(a.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),a}e.getMachineInfo=D;async function v(a){try{const t=new Map,r=(0,k.join)(a,".vscode","launch.json"),i=await I.Promises.readFile(r),s=[],h=(0,A.parse)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,A.getNodeType)(h)==="object"&&h.configurations)for(const c of h.configurations){const l=c.type;l&&(t.has(l)?t.set(l,t.get(l)+1):t.set(l,1))}return b(t)}catch(t){return[]}}e.collectLaunchConfigs=v;let o=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const i=E.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),y.isWindows||r.push(`Load (avg):       ${E.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,P.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[s,h]=i,c=this.formatProcessList(t,s);return r.forEach(l=>{if((0,L.isRemoteDiagnosticError)(l))c+=`
${l.errorMessage}`,h+=`
${l.errorMessage}`;else if(c+=`

Remote: ${l.hostName}`,l.processes&&(c+=`
${this.formatProcessList(t,l.processes)}`),l.workspaceMetadata){h+=`
|  Remote: ${l.hostName}`;for(const f of Object.keys(l.workspaceMetadata)){const S=l.workspaceMetadata[f];let d=`${S.fileCount} files`;S.maxFilesReached&&(d=`more than ${d}`),h+=`|    Folder (${f}): ${d}`,h+=this.formatWorkspaceStats(S)}}}),{processInfo:c,workspaceInfo:h}})}async getSystemInfo(t,r){const{memory:i,vmHint:s,os:h,cpus:c}=D(),l={os:h,memory:i,cpus:c,vmHint:s,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return y.isWindows||(l.load=`${E.loadavg().map(f=>Math.round(f)).join(", ")}`),y.isLinux&&(l.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(l)}async getDiagnostics(t,r){const i=[];return(0,P.listProcesses)(t.mainPID).then(async s=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,s)),t.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),r.forEach(h=>{if((0,L.isRemoteDiagnosticError)(h))i.push(`
${h.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${h.hostName}`),i.push(this.formatMachineInfo(h.machineInfo)),h.processes&&i.push(this.formatProcessList(t,h.processes)),h.workspaceMetadata)for(const c of Object.keys(h.workspaceMetadata)){const l=h.workspaceMetadata[c];let f=`${l.fileCount} files`;l.maxFilesReached&&(f=`more than ${f}`),i.push(`Folder (${c}): ${f}`),i.push(this.formatWorkspaceStats(l))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const r=[],i=60;let s=0;const h=(S,d)=>{const T=` ${S}(${d})`;s+T.length>i?(r.push(c),c="|                 ",s=c.length):s+=T.length,c+=T};let c="|      File types:";const l=10;let f=t.fileTypes.length>l?l:t.fileTypes.length;for(let S=0;S<f;S++){const d=t.fileTypes[S];h(d.name,d.count)}if(r.push(c),t.configFiles.length>=0&&(c="|      Conf files:",s=0,t.configFiles.forEach(S=>{h(S.name,S.count)}),r.push(c)),t.launchConfigFiles.length>0){let S="|      Launch Configs:";t.launchConfigFiles.forEach(d=>{S+=d.count>1?` ${d.name}(${d.count})`:` ${d.name}`}),r.push(S)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],i=[];return t.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(h=>{const c=n.URI.revive(h);if(c.scheme===m.Schemas.file){const l=c.fsPath;i.push(C(l,["node_modules",".git"]).then(f=>{let S=`${f.fileCount} files`;f.maxFilesReached&&(S=`more than ${S}`),r.push(`|    Folder (${(0,k.basename)(l)}): ${S}`),r.push(this.formatWorkspaceStats(f))}).catch(f=>{r.push(`|      Error: Unable to collect workspace stats for folder ${l} (${f.toString()})`)}))}else r.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(t,r){const i=new Map;t.windows.forEach(h=>i.set(h.pid,h.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,i,s,r,0),s.join(`
`)}formatProcessItem(t,r,i,s,h){const c=h===0;let l;c?l=s.pid===t?`${this.productService.applicationName} main`:"remote agent":(l=`${"  ".repeat(h)} ${s.name}`,s.name==="window"&&(l=`${l} (${r.get(s.pid)})`));const f=process.platform==="win32"?s.mem:E.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(f/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${l}`),Array.isArray(s.children)&&s.children.forEach(S=>this.formatProcessItem(t,r,i,S,h+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const i=n.URI.revive(r);if(i.scheme!==m.Schemas.file)continue;const s=i.fsPath;try{const h=await C(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),h.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),h.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),h.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};o=de([Y(0,w.ITelemetryService),Y(1,p.IProductService)],o),e.DiagnosticsService=o}),define(Z[183],ee([0,1,114,2,27,31,3,44,14,21,29,11,5,6,4]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let I=class extends R.Disposable{constructor(o,a,t){super();this.galleryService=o,this.telemetryService=a,this.logService=t,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(o,a={}){if(!this.galleryService.isEnabled())throw new Error(E.localize(0,null));try{o=await this.checkAndGetCompatibleVersion(o)}catch(r){throw this.logService.error((0,w.getErrorMessage)(r)),b(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(o),void 0,r),r}if(!await this.canInstall(o)){const r=new L.ExtensionManagementError("Not supported",e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",o.identifier.id,r.message),b(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(o),void 0,r),r}const t=await this.galleryService.getManifest(o,n.CancellationToken.None);if(t===null){const r=new L.ExtensionManagementError(`Missing manifest for extension ${o.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",o.identifier.id,r.message),b(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(o),void 0,r),r}return this.installExtension(t,o,a)}async uninstall(o,a={}){return this.logService.trace("ExtensionManagementService#uninstall",o.identifier.id),this.unininstallExtension(o,a)}async reinstallFromGallery(o){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",o.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const a=await this.findGalleryExtension(o);if(!a)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(o,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(a)}getExtensionsReport(){const o=new Date().getTime();return(!this.reportedExtensions||o-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=o),this.reportedExtensions}registerParticipant(o){this.participants.push(o)}async installExtension(o,a,t){if(!g.URI.isUri(a)){let c=this.installingExtensions.get(new k.ExtensionIdentifierWithVersion(a.identifier,a.version).key());if(c)return this.logService.info("Extensions is already requested to install",a.identifier.id),c.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],i=[],s=this.createInstallExtensionTask(o,a,t);g.URI.isUri(a)||this.installingExtensions.set(new k.ExtensionIdentifierWithVersion(s.identifier,o.version).key(),s),this._onInstallExtension.fire({identifier:s.identifier,source:a}),this.logService.info("Installing extension:",s.identifier.id),r.push({task:s,manifest:o});let h=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",s.identifier.id);else try{const l=await this.getAllDepsAndPackExtensionsToInstall(s.identifier,o,!!t.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:f,manifest:S}of l)if(h=h||!!S.extensionDependencies?.some(d=>(0,k.areSameExtensions)({id:d},s.identifier)),this.installingExtensions.has(new k.ExtensionIdentifierWithVersion(f.identifier,f.version).key()))this.logService.info("Extension is already requested to install",f.identifier.id);else{const d=this.createInstallExtensionTask(S,f,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new k.ExtensionIdentifierWithVersion(d.identifier,S.version).key(),d),this._onInstallExtension.fire({identifier:d.identifier,source:f}),this.logService.info("Installing extension:",d.identifier.id),r.push({task:d,manifest:S})}}catch(l){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",s.identifier.id),this.logService.error(l),l}const c=r.reduce((l,{task:f,manifest:S})=>(l.set(f.identifier.id.toLowerCase(),{task:f,manifest:S}),l),new Map);for(;c.size;){let l;const f=[...c.values()].filter(({manifest:S})=>!S.extensionDependencies?.some(d=>c.has(d.toLowerCase())));f.length?l=c.size===1?f:f.filter(({task:S})=>!(S===s&&!h)):(this.logService.info("Found extensions with circular dependencies",f.map(({task:S})=>S.identifier.id)),l=[...c.values()]),await this.joinAllSettled(l.map(async({task:S})=>{const d=new Date().getTime();try{const T=await S.run();if(await this.joinAllSettled(this.participants.map(O=>O.postInstall(T,S.source,t,n.CancellationToken.None))),!g.URI.isUri(S.source)&&(b(this.telemetryService,S.operation===2?"extensionGallery:update":"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(S.source),new Date().getTime()-d,void 0),u.isWeb&&S.operation===1))try{await this.galleryService.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch(O){}i.push({local:T,identifier:S.identifier,operation:S.operation,source:S.source})}catch(T){throw g.URI.isUri(S.source)||b(this.telemetryService,S.operation===2?"extensionGallery:update":"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(S.source),new Date().getTime()-d,T),this.logService.error("Error while installing the extension:",S.identifier.id),this.logService.error(T),T}finally{c.delete(S.identifier.id.toLowerCase())}}))}return i.forEach(({identifier:l})=>this.logService.info("Extension installed successfully:",l.id)),this._onDidInstallExtensions.fire(i),i.filter(({identifier:l})=>(0,k.areSameExtensions)(l,s.identifier))[0].local}catch(c){if(r.forEach(({task:l})=>l.cancel()),i.length)try{const l=await Promise.allSettled(i.map(({local:f})=>this.createUninstallExtensionTask(f,{versionOnly:!0}).run()));for(let f=0;f<l.length;f++){const S=l[f],{identifier:d}=i[f];S.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",d.id):this.logService.warn("Rollback: Error while uninstalling extension",d.id,(0,w.getErrorMessage)(S.reason))}}catch(l){this.logService.warn("Error while rolling back extensions",(0,w.getErrorMessage)(l),i.map(({identifier:f})=>f.id))}throw this.logService.error("Failed to install extension:",s.identifier.id,(0,w.getErrorMessage)(c)),this._onDidInstallExtensions.fire(r.map(({task:l})=>({identifier:l.identifier,operation:1,source:l.source}))),c instanceof Error&&(c.name=c&&c.code?c.code:e.ERROR_UNKNOWN),c}finally{for(const{task:c,manifest:l}of r)if(!g.URI.isUri(c.source)){const f=new k.ExtensionIdentifierWithVersion(c.identifier,l.version).key();this.installingExtensions.delete(f)||this.logService.warn("Installation task is not found in the cache",f)}}}async joinAllSettled(o){const a=[],t=[],r=await Promise.allSettled(o);for(const i of r)i.status==="fulfilled"?a.push(i.value):t.push(i.reason);if(t.length)throw C(t);return a}async getAllDepsAndPackExtensionsToInstall(o,a,t){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const i=[o,...r.map(c=>c.identifier)],s=[],h=async(c,l)=>{const f=l.extensionDependencies||[];if(l.extensionPack){const S=t?r.find(d=>(0,k.areSameExtensions)(d.identifier,c)):void 0;for(const d of l.extensionPack)S&&S.manifest.extensionPack&&S.manifest.extensionPack.some(T=>(0,k.areSameExtensions)({id:T},{id:d}))||f.every(T=>!(0,k.areSameExtensions)({id:T},{id:d}))&&f.push(d)}if(f.length){const S=[...i,...s.map(T=>T.gallery.identifier)],d=f.filter(T=>S.every(O=>!(0,k.areSameExtensions)(O,{id:T})));if(d.length){const T=await this.galleryService.query({names:d,pageSize:f.length},n.CancellationToken.None);for(const O of T.firstPage){if(S.find(H=>(0,k.areSameExtensions)(H,O.identifier)))continue;const x=await this.checkAndGetCompatibleVersion(O);if(!await this.canInstall(x)){this.logService.info("Skipping the extension as it cannot be installed",x.identifier.id);continue}const z=await this.galleryService.getManifest(x,n.CancellationToken.None);if(z===null)throw new L.ExtensionManagementError(`Missing manifest for extension ${x.identifier.id}`,e.INSTALL_ERROR_VALIDATING);s.push({gallery:x,manifest:z}),await h(x.identifier,z)}}}};return await h(o,a),r=await this.getInstalled(),s.filter(c=>!r.some(l=>(0,k.areSameExtensions)(l.identifier,c.gallery.identifier)))}async checkAndGetCompatibleVersion(o){if(await this.isMalicious(o))throw new L.ExtensionManagementError(E.localize(3,null,o.identifier.id),L.INSTALL_ERROR_MALICIOUS);const a=await this.galleryService.getCompatibleExtension(o);if(!a)throw new L.ExtensionManagementError(E.localize(4,null,o.identifier.id,P.default.version),L.INSTALL_ERROR_INCOMPATIBLE);return a}async isMalicious(o){const a=await this.getExtensionsReport();return(0,k.getMaliciousExtensionsSet)(a).has(o.identifier.id)}async unininstallExtension(o,a){const t=this.uninstallingExtensions.get(o.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",o.identifier.id),t.waitUntilTaskIsFinished();const r=(c,l)=>{const f=this.createUninstallExtensionTask(c,l);return this.uninstallingExtensions.set(f.extension.identifier.id.toLowerCase(),f),this.logService.info("Uninstalling extension:",c.identifier.id),this._onUninstallExtension.fire(c.identifier),f},i=(c,l)=>{l?this.logService.error("Failed to uninstall extension:",c.identifier.id,l.message):this.logService.info("Successfully uninstalled extension:",c.identifier.id),b(this.telemetryService,"extensionGallery:uninstall",(0,k.getLocalExtensionTelemetryData)(c),void 0,l),this._onDidUninstallExtension.fire({identifier:c.identifier,error:l?.code})},s=[],h=[];try{s.push(r(o,{}));const c=await this.getInstalled(1);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",o.identifier.id);else{const l=this.getAllPackExtensionsToUninstall(o,c);for(const f of l)this.uninstallingExtensions.has(f.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",f.identifier.id):s.push(r(f,{}))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",o.identifier.id):this.checkForDependents(s.map(l=>l.extension),c,o),await this.joinAllSettled(s.map(async l=>{try{if(await l.run(),await this.joinAllSettled(this.participants.map(f=>f.postUninstall(l.extension,a,n.CancellationToken.None))),l.extension.identifier.uuid)try{await this.galleryService.reportStatistic(l.extension.manifest.publisher,l.extension.manifest.name,l.extension.manifest.version,"uninstall")}catch(f){}i(l.extension)}catch(f){const S=f instanceof L.ExtensionManagementError?f:new L.ExtensionManagementError((0,w.getErrorMessage)(f),e.ERROR_UNKNOWN);throw i(l.extension,S),S}finally{h.push(l)}}))}catch(c){const l=c instanceof L.ExtensionManagementError?c:new L.ExtensionManagementError((0,w.getErrorMessage)(c),e.ERROR_UNKNOWN);for(const f of s){try{f.cancel()}catch(S){}h.includes(f)||i(f.extension,l)}throw l}finally{for(const c of s)this.uninstallingExtensions.delete(c.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",c.extension.identifier.id)}}checkForDependents(o,a,t){for(const r of o){const i=this.getDependents(r,a);if(i.length){const s=i.filter(h=>o.indexOf(h)===-1);if(s.length)throw new Error(this.getDependentsErrorMessage(r,s,t))}}}getDependentsErrorMessage(o,a,t){return t===o?a.length===1?E.localize(5,null,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(6,null,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(7,null,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?E.localize(8,null,t.manifest.displayName||t.manifest.name,o.manifest.displayName||o.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(9,null,t.manifest.displayName||t.manifest.name,o.manifest.displayName||o.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(10,null,t.manifest.displayName||t.manifest.name,o.manifest.displayName||o.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}getAllPackExtensionsToUninstall(o,a,t=[]){if(t.indexOf(o)!==-1)return[];t.push(o);const r=o.manifest.extensionPack?o.manifest.extensionPack:[];if(r.length){const i=a.filter(h=>!h.isBuiltin&&r.some(c=>(0,k.areSameExtensions)({id:c},h.identifier))),s=[];for(const h of i)s.push(...this.getAllPackExtensionsToUninstall(h,a,t));return[...i,...s]}return[]}getDependents(o,a){return a.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(r=>(0,k.areSameExtensions)({id:r},o.identifier)))}async findGalleryExtension(o){if(o.identifier.uuid){const a=await this.findGalleryExtensionById(o.identifier.uuid);return a||this.findGalleryExtensionByName(o.identifier.id)}return this.findGalleryExtensionByName(o.identifier.id)}async findGalleryExtensionById(o){return(await this.galleryService.query({ids:[o],pageSize:1},n.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(o){return(await this.galleryService.query({names:[o],pageSize:1},n.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const o=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${o.length} reported extensions from service`),o}catch(o){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};I=de([Y(0,L.IExtensionGalleryService),Y(1,y.ITelemetryService),Y(2,p.ILogService)],I),e.AbstractExtensionManagementService=I;function C(v){const o=Array.isArray(v)?v:[v];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((a,t)=>new Error(`${a.message}${a.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=C;function b(v,o,a,t,r){const i=r?r instanceof L.ExtensionManagementError?r.code:e.ERROR_UNKNOWN:void 0;v.publicLogError(o,{...a,success:!r,duration:t,errorcode:i})}e.reportTelemetry=b;class D{constructor(){this.barrier=new m.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,m.createCancelablePromise)(o=>this.doRun(o))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,m.createCancelablePromise)(o=>new Promise((a,t)=>{const r=o.onCancellationRequested(()=>{r.dispose(),t((0,w.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=D}),define(Z[184],ee([0,1,11,27,31,26,21,42,72,12,29,14,13,5,28,20,45,7,4]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I,C,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var v;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished"})(v||(v={}));function o(...M){return String(M.reduce((N,q)=>N|q,0))}var a;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:v.None,criteria:[],assetTypes:[]};class h{constructor(N=s){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,q=this.state.pageSize){return new h({...this.state,pageNumber:N,pageSize:q})}withFilter(N,...q){const F=[...this.state.criteria,...q.length?q.map(j=>({filterType:N,value:j})):[{filterType:N}]];return new h({...this.state,criteria:F})}withSortBy(N){return new h({...this.state,sortBy:N})}withSortOrder(N){return new h({...this.state,sortOrder:N})}withFlags(...N){return new h({...this.state,flags:N.reduce((q,F)=>q|F,0)})}withAssetTypes(...N){return new h({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:q,pageSize:F,sortBy:j,sortOrder:_,flags:G,assetTypes:B}=this.state;return{filters:[{criteria:N,pageNumber:q,pageSize:F,sortBy:j,sortOrder:_}],assetTypes:B,flags:G}}get searchText(){const N=this.state.criteria.filter(q=>q.filterType===a.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function c(M,N){const q=(M||[]).filter(F=>F.statisticName===N)[0];return q?q.value:0}function l(M){const N="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(F=>F.assetType.indexOf(N)===0).reduce((F,j)=>{const _=T(M,j.assetType);return _&&F.push([j.assetType.substring(N.length),_]),F},[])}function f(M){if(M.properties){const N=M.properties.filter(j=>j.key===t.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=N.filter(j=>q.test(j.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return T(M,t.Repository)}function S(M){return{uri:`${M.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${M.fallbackAssetUri}/${t.VSIX}`}}function d(M){const N=T(M,t.Icon);if(N)return N;const q=R.DefaultIconPath;return{uri:q,fallbackUri:q}}function T(M,N){return M.files.filter(F=>F.assetType===N)[0]?{uri:`${M.assetUri}/${N}`,fallbackUri:`${M.fallbackAssetUri}/${N}`}:null}function O(M,N){const q=M.properties?M.properties.filter(j=>j.key===N):[],F=q.length>0&&q[0].value;return F?F.split(",").map(j=>(0,L.adoptToGalleryExtensionId)(j)):[]}function x(M){const N=M.properties?M.properties.filter(q=>q.key===r.Engine):[];return N.length>0&&N[0].value||""}function z(M){const N=M.properties?M.properties.filter(F=>F.key===r.LocalizedLanguages):[],q=N.length>0&&N[0].value||"";return q?q.split(","):[]}function H(M){return M.indexOf("preview")!==-1}function V(M,N,q,F,j){const _={manifest:T(N,t.Manifest),readme:T(N,t.Details),changelog:T(N,t.Changelog),license:T(N,t.License),repository:f(N),download:S(N),icon:d(N),coreTranslations:l(N)};return{identifier:{id:(0,L.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:N.version,date:N.lastUpdated,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,description:M.shortDescription||"",installCount:c(M.statistics,"install"),rating:c(M.statistics,"averagerating"),ratingCount:c(M.statistics,"ratingcount"),assetUri:m.URI.parse(N.assetUri),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),webExtension:!!M.tags?.includes(R.WEB_EXTENSION_TAG),assetTypes:N.files.map(({assetType:G})=>G),assets:_,properties:{dependencies:O(N,r.Dependency),extensionPack:O(N,r.ExtensionPack),engine:x(N),localizedLanguages:z(N)},telemetryData:{index:(F.pageNumber-1)*F.pageSize+q,querySource:j},preview:H(M.flags)}}let U=class{constructor(N,q,F,j,_,G,B){this.requestService=N,this.logService=q,this.environmentService=F,this.telemetryService=j,this.fileService=_,this.productService=G;const X=G.extensionsGallery;this.extensionsGalleryUrl=X&&X.serviceUrl,this.extensionsControlUrl=X&&X.controlUrl,this.commonHeadersPromise=$(G.version,this.environmentService,this.fileService,B)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,q){const F=[];let{total:j,firstPage:_,getPage:G}=await this.query({names:N,pageSize:N.length},q);F.push(..._);for(let B=1;F.length<j&&(_=await G(B,q),_.length);B++)F.push(..._);return F}async getCompatibleExtension(N,q){return this.getCompatibleExtensionByEngine(N,q)}async getCompatibleExtensionByEngine(N,q){const F=(0,R.isIExtensionIdentifier)(N)?null:N;if(F&&F.properties.engine&&(0,p.isEngineValid)(F.properties.engine,this.productService.version,this.productService.date))return F;const{id:j,uuid:_}=F?F.identifier:N;let G=new h().withFlags(v.IncludeAssetUri,v.IncludeStatistics,v.IncludeCategoryAndTags,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");_?G=G.withFilter(a.ExtensionId,_):G=G.withFilter(a.ExtensionName,j);const{galleryExtensions:B}=await this.queryGallery(G,n.CancellationToken.None),[X]=B;if(!X||!X.versions.length)return null;if(q){const ie=X.versions.filter(ne=>ne.version===q)[0];if(ie){const ne=V(X,ie,0,G);if(ne.properties.engine&&(0,p.isEngineValid)(ne.properties.engine,this.productService.version,this.productService.date))return ne}return null}const Q=await this.getLastValidExtensionVersion(X,X.versions);return Q?V(X,Q,0,G):null}async query(N,q){const F=n.CancellationToken.isCancellationToken(N)?{}:N,j=n.CancellationToken.isCancellationToken(N)?N:q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let _=F.text||"";const G=(0,k.getOrDefault)(F,le=>le.pageSize,50);let B=new h().withFlags(v.IncludeLatestVersionOnly,v.IncludeAssetUri,v.IncludeStatistics,v.IncludeCategoryAndTags,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,G).withFilter(a.Target,"Microsoft.VisualStudio.Code");_?(_=_.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,fe,ye)=>(B=B.withFilter(a.Category,ye||fe),"")),_=_.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,fe,ye)=>(B=B.withFilter(a.Tag,ye||fe),"")),_=_.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(a.Featured),"")),_=_.trim(),_&&(_=_.length<200?_:_.substring(0,200),B=B.withFilter(a.SearchText,_)),B=B.withSortBy(0)):F.ids?B=B.withFilter(a.ExtensionId,...F.ids):F.names?B=B.withFilter(a.ExtensionName,...F.names):B=B.withSortBy(4),typeof F.sortBy=="number"&&(B=B.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(B=B.withSortOrder(F.sortOrder));const{galleryExtensions:X,total:Q}=await this.queryGallery(B,j),ie=X.map((le,fe)=>V(le,le.versions[0],fe,B,F.source)),ne=async(le,fe)=>{if(fe.isCancellationRequested)throw(0,E.canceled)();const ye=B.withPage(le+1),{galleryExtensions:Se}=await this.queryGallery(ye,fe);return Se.map((Pe,Te)=>V(Pe,Pe.versions[0],Te,ye,F.source))};return{firstPage:ie,total:Q,pageSize:B.pageSize,getPage:ne}}async queryGallery(N,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,v.ExcludeNonValidated).withFilter(a.ExcludeWithFlags,o(v.Unpublished));const F=await this.commonHeadersPromise,j=JSON.stringify(N.raw),_={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(j.length)},G=new Date().getTime();let B,X,Q=0;try{if(B=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:j,headers:_},q),B.res.statusCode&&B.res.statusCode>=400&&B.res.statusCode<500)return{galleryExtensions:[],total:Q};const ie=await(0,P.asJson)(B);if(ie){const ne=ie.results[0],le=ne.extensions,fe=ne.resultMetadata&&ne.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return Q=fe&&fe.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:le,total:Q}}return{galleryExtensions:[],total:Q}}catch(ie){throw X=ie,ie}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(j.length),duration:new Date().getTime()-G,success:!!B&&(0,P.isSuccess)(B),responseBodySize:B?.res.headers["Content-Length"],statusCode:B?String(B.res.statusCode):void 0,errorCode:X?(0,E.isPromiseCanceledError)(X)?"canceled":(0,E.getErrorMessage)(X).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Q)})}}async reportStatistic(N,q,F,j){if(!this.isEnabled())return;const _=D.isWeb?this.api(`/itemName/${N}.${q}/version/${F}/statType/${j==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${q}/${F}/stats?statType=${j}`),G=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",X={...await this.commonHeadersPromise,Accept:G};try{await this.requestService.request({type:"POST",url:_,headers:X},n.CancellationToken.None)}catch(Q){}}async download(N,q,F){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const j=(0,L.getGalleryExtensionTelemetryData)(N),_=new Date().getTime(),G=ie=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...j,duration:ie}),B=F===1?"install":F===2?"update":"",X=B?{uri:`${N.assets.download.uri}&${B}=true`,fallbackUri:`${N.assets.download.fallbackUri}?${B}=true`}:N.assets.download,Q=await this.getAsset(X);await this.fileService.writeFile(q,Q.stream),G(new Date().getTime()-_)}async getReadme(N,q){if(N.assets.readme){const F=await this.getAsset(N.assets.readme,{},q);return await(0,P.asText)(F)||""}return""}async getManifest(N,q){if(N.assets.manifest){const F=await this.getAsset(N.assets.manifest,{},q),j=await(0,P.asText)(F);return j?JSON.parse(j):null}return null}async getCoreTranslation(N,q){const F=N.assets.coreTranslations.filter(j=>j[0]===q.toUpperCase())[0];if(F){const j=await this.getAsset(F[1]),_=await(0,P.asText)(j);return _?JSON.parse(_):null}return null}async getChangelog(N,q){if(N.assets.changelog){const F=await this.getAsset(N.assets.changelog,{},q);return await(0,P.asText)(F)||""}return""}async getAllVersions(N,q){let F=new h().withFlags(v.IncludeVersions,v.IncludeCategoryAndTags,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?F=F.withFilter(a.ExtensionId,N.identifier.uuid):F=F.withFilter(a.ExtensionName,N.identifier.id);const j=[],{galleryExtensions:_}=await this.queryGallery(F,n.CancellationToken.None);return _.length&&(q?await Promise.all(_[0].versions.map(async G=>{let B;try{B=await this.getEngine(G)}catch(X){}B&&(0,p.isEngineValid)(B,this.productService.version,this.productService.date)&&j.push({version:G.version,date:G.lastUpdated})})):j.push(..._[0].versions.map(G=>({version:G.version,date:G.lastUpdated})))),j}async getAsset(N,q={},F=n.CancellationToken.None){const j=await this.commonHeadersPromise,_={type:"GET"},G={...j,...q.headers||{}};q={...q,..._,headers:G};const B=N.uri,X=N.fallbackUri,Q={...q,url:B};try{const ie=await this.requestService.request(Q,F);if(ie.res.statusCode===200)return ie;const ne=await(0,P.asText)(ie);throw new Error(`Expected 200, got back ${ie.res.statusCode} instead.

${ne}`)}catch(ie){if((0,E.isPromiseCanceledError)(ie))throw ie;const ne=(0,E.getErrorMessage)(ie);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:B,message:ne});const le={...q,url:X};return this.requestService.request(le,F)}}async getLastValidExtensionVersion(N,q){const F=this.getLastValidExtensionVersionFromProperties(N,q);return F||this.getLastValidExtensionVersionRecursively(N,q)}getLastValidExtensionVersionFromProperties(N,q){for(const F of q){const j=x(F);if(!j)return null;if((0,p.isEngineValid)(j,this.productService.version,this.productService.date))return F}return null}async getEngine(N){const q=x(N);if(q)return q;const F=T(N,t.Manifest);if(!F)throw new Error("Manifest was not found");const j={"Accept-Encoding":"gzip"},_=await this.getAsset(F,{headers:j}),G=await(0,P.asJson)(_);if(G)return G.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(N,q){if(!q.length)return null;const F=q[0],j=await this.getEngine(F);return(0,p.isEngineValid)(j,this.productService.version,this.productService.date)?{...F,properties:[...F.properties||[],{key:r.Engine,value:j}]}:this.getLastValidExtensionVersionRecursively(N,q.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,P.asJson)(N),F=new Map;if(q)for(const j of q.malicious){const _=F.get(j)||{id:{id:j},malicious:!0,slow:!1};_.malicious=!0,F.set(j,_)}return[...F.values()]}};U=de([Y(0,P.IRequestService),Y(1,w.ILogService),Y(2,y.IEnvironmentService),Y(3,A.ITelemetryService),Y(4,g.IFileService),Y(5,u.IProductService),Y(6,(0,b.optional)(I.IStorageService))],U),e.ExtensionGalleryService=U;async function $(M,N,q,F){const j={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M}`},_=await(0,C.getServiceMachineId)(N,q,F);return j["X-Market-User-Id"]=_,j}e.resolveMarketplaceHeaders=$}),define(Z[185],ee([0,1,5,8,28,12,35,13,4,23,27,63,42,14,177,6,21,75,116,20,3,59]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I,C,b,D,v,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends u.ExtensionTipsService{constructor(h,c,l,f,S,d,T,O,x,z){super(T,O,x,z);this.environmentService=h,this.telemetryService=c,this.extensionManagementService=l,this.storageService=f,this.nativeHostService=S,this.extensionRecommendationNotificationService=d,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,w.forEach)(O.exeBasedExtensionTips,({key:H,value:V})=>{const U=[],$=[],M=[];(0,w.forEach)(V.recommendations,({key:N,value:q})=>{q.important?V.important?U.push({extensionId:N,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):$.push({extensionId:N,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):M.push({extensionId:N,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),U.length&&this.highImportanceExecutableTips.set(H,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:U}),$.length&&this.mediumImportanceExecutableTips.set(H,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:$}),M.length&&this.allOtherExecutableTips.set(H,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:M})}),(0,I.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const h=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...h,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const h=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(h,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,l)}groupImportantTipsByExe(h,c){const l=new Map;h.forEach(O=>l.set(O.extensionId.toLowerCase(),O));const{installed:f,uninstalled:S}=this.groupByInstalled([...l.keys()],c);for(const O of f){const x=l.get(O);x&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:x.exeName})}for(const O of S){const x=l.get(O);x&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:x.exeName})}const d=this.getPromptedExecutableTips(),T=new Map;for(const O of S){const x=l.get(O);if(x&&(!d[x.exeName]||!d[x.exeName].includes(x.extensionId))){let z=T.get(x.exeName);z||(z=[],T.set(x.exeName,z)),z.push(x)}}return T}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[h,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(h);break;case"incompatibleWindow":const f=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(f(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const S=this._register((0,I.disposableTimeout)(()=>{S.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const h=this.getLastPromptedMediumExeTime(),c=Date.now()-h,l=7*24*60*60*1e3;if(c<l){const d=this._register((0,I.disposableTimeout)(()=>{d.dispose(),this.promptMediumImportanceExeBasedTip()},l-c));return}const[f,S]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(S).then(d=>{switch(d){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(f),this.addToRecommendedExecutables(S[0].exeName,S);const T=this._register((0,I.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},l));break;case"ignored":this.mediumImportanceTipsByExe.delete(f),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=o.Event.once(o.Event.latch(o.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const x=this._register((0,I.disposableTimeout)(()=>{x.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(h){const c=h.map(({extensionId:f})=>f.toLowerCase()),l=(0,D.localize)(0,null,h[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,l,`@exe:"${h[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let h=this.storageService.getNumber(r,0);return h||(h=Date.now(),this.updateLastPromptedMediumExeTime(h)),h}updateLastPromptedMediumExeTime(h){this.storageService.store(r,h,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(h,c){const l=this.getPromptedExecutableTips();l[h]=c.map(({extensionId:f})=>f.toLowerCase()),this.storageService.store(t,JSON.stringify(l),0,0)}groupByInstalled(h,c){const l=[],f=[],S=c.reduce((d,T)=>(d.add(T.identifier.id.toLowerCase()),d),new Set);return h.forEach(d=>{S.has(d.toLowerCase())?l.push(d):f.push(d)}),{installed:l,uninstalled:f}}async getValidExecutableBasedExtensionTips(h){const c=[],l=new Map;for(const f of h.keys()){const S=h.get(f);if(!S||!(0,y.isNonEmptyArray)(S.recommendations))continue;const d=[];p.isWindows?S.windowsPath&&d.push(S.windowsPath.replace("%USERPROFILE%",A.env.USERPROFILE).replace("%ProgramFiles(x86)%",A.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",A.env.ProgramFiles).replace("%APPDATA%",A.env.APPDATA).replace("%WINDIR%",A.env.WINDIR)):(d.push((0,R.join)("/usr/local/bin",f)),d.push((0,R.join)("/usr/bin",f)),d.push((0,R.join)(this.environmentService.userHome.fsPath,f)));for(const T of d){let O=l.get(T);if(O===void 0&&(O=await this.fileService.exists(E.URI.file(T)),l.set(T,O)),O)for(const{extensionId:x,extensionName:z,isExtensionPack:H}of S.recommendations)c.push({extensionId:x,extensionName:z,isExtensionPack:H,exeName:f,exeFriendlyName:S.exeFriendlyName,windowsPath:S.windowsPath})}}return c}};i=de([Y(0,k.INativeEnvironmentService),Y(1,C.ITelemetryService),Y(2,n.IExtensionManagementService),Y(3,v.IStorageService),Y(4,a.INativeHostService),Y(5,b.IExtensionRecommendationNotificationService),Y(6,P.IFileService),Y(7,L.IProductService),Y(8,g.IRequestService),Y(9,m.ILogService)],i),e.ExtensionTipsService=i}),define(Z[82],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(k){this.appender=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,{eventName:P,data:p}){return this.appender.log(P,p),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class R{constructor(k){this.channel=k}log(k,A){return this.channel.call("log",{eventName:k,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(Z[83],ee([0,1,44,126,19,7,24,38,2,26,32]),function(K,e,E,R,L,k,A,P,p,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(u,I){this._configurationService=I,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let C of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(C),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(C=>{const b=/^[a-f0-9]+$/i.test(C["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(u,I){this._experimentProperties[u]=I}setEnabled(u){this._enabled=u}_updateUserOptIn(){const u=this._configurationService?.getValue(g);this._userOptIn=u?u.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let I=u.sessionID,C=u["common.instanceId"],b=u["common.machineId"],D=u["common.firstSessionDate"],v=u["common.msftInternal"];return{sessionId:I,instanceId:C,machineId:b,firstSessionDate:D,msftInternal:v}}dispose(){this._disposables.dispose()}publicLog(u,I,C){return this.isOptedIn?this._commonProperties.then(b=>{I=(0,y.mixin)(I,b),I=(0,y.mixin)(I,this._experimentProperties),I=(0,y.cloneAndChange)(I,D=>{if(typeof D=="string")return this._cleanupInfo(D,C)}),this._appender.log(u,I)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(u,I,C){return this.publicLog(u,I,C)}publicLogError(u,I){return this.sendErrorTelemetry?this.publicLog(u,I,!0):Promise.resolve(void 0)}publicLogError2(u,I){return this.publicLogError(u,I)}_cleanupInfo(u,I){let C=u;if(I){const b=[];for(let a of this._cleanupPatterns)for(;;){const t=a.exec(u);if(!t)break;b.push([t.index,a.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(C="";;){const a=v.exec(u);if(!a)break;!D.test(a[0])&&b.every(([t,r])=>a.index<t||a.index>=r)&&(C+=u.substring(o,a.index)+"<REDACTED: user-file-path>",o=v.lastIndex)}o<u.length&&(C+=u.substr(o))}for(let b of this._cleanupPatterns)C=C.replace(b,"");return C}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=de([Y(1,(0,k.optional)(A.IConfigurationService))],w),e.TelemetryService=w;const g="telemetry";n.Registry.as(P.Extensions.Configuration).registerConfiguration({id:g,order:110,type:"object",title:(0,R.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,R.localize)(2,null,E.default.nameLong,E.default.privacyStatementUrl):(0,R.localize)(1,null,E.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[53],ee([0,1,24,26,16,6]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(u,I){return Promise.resolve(void 0)}publicLog2(u,I){return this.publicLog(u,I)}publicLogError(u,I){return Promise.resolve(void 0)}publicLogError2(u,I){return this.publicLogError(u,I)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class A{async publicLog(I,C,b){}async publicLogError(I,C,b){}}e.NullEndpointTelemetryService=A;function P(...u){return{log:(I,C)=>u.forEach(b=>b.log(I,C)),flush:()=>k.Promises.settled(u.map(I=>I.flush()))}}e.combinedAppender=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(u,I){return I.onDidChangeConfiguration(C=>{C.source!==6&&u.publicLog2("updateConfiguration",{configurationSource:(0,E.ConfigurationTargetToString)(C.source),configurationKeys:g(C.sourceConfig)})})}e.configurationTelemetry=p;function y(u){const I=Object.create(null),C=Object.create(null),b=Object.create(null);w(u,b);for(let D in b){D=D.length>150?D.substr(D.length-149):D;const v=b[D];typeof v=="number"?C[D]=v:typeof v=="boolean"?C[D]=v?1:0:typeof v=="string"?I[D]=v.substring(0,1023):typeof v!="undefined"&&v!==null&&(I[D]=v)}return{properties:I,measurements:C}}e.validateTelemetryData=y;function n(u){if(!u)return"none";let I="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{u.indexOf(`${b}+`)===0&&(I=b)}),I}e.cleanRemoteAuthority=n;function w(u,I,C=0,b){if(!!u)for(let D of Object.getOwnPropertyNames(u)){const v=u[D],o=b?b+D:D;Array.isArray(v)?I[o]=(0,R.safeStringify)(v):v instanceof Date?I[o]=v.toISOString():(0,L.isObject)(v)?C<2?w(v,I,C+1,o+"."):I[o]=(0,R.safeStringify)(v):I[o]=v}}function g(u){if(!u)return[];const I=[];return m(I,"",u),I}function m(u,I,C){C&&typeof C=="object"&&!Array.isArray(C)?Object.keys(C).forEach(b=>m(u,I?`${I}.${b}`:b,C[b])):u.push(I)}}),define(Z[84],ee([0,1,2,12,14,53]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends E.Disposable{constructor(p,y,n=""){super();this.prefix=n;const w=p.getLogger(y.telemetryLogResource);w?this.logger=this._register(w):(this.logger=this._register(p.createLogger(y.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(p,y){this.logger.trace(`${this.prefix}telemetry/${p}`,(0,k.validateTelemetryData)(y))}};A=de([Y(0,L.ILoggerService),Y(1,R.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(Z[186],ee([0,1,11,26,53]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(P){const p=await new Promise((n,w)=>{K(["applicationinsights"],n,w)});let y;return p.defaultClient?(y=new p.TelemetryClient(P),y.channel.setUseDiskRetryCaching(!0)):(p.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),y=p.defaultClient),P.indexOf("AIF-")===0&&(y.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),y}class A{constructor(p,y,n){this._eventPrefix=p,this._defaultData=y,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(p){if(!!this._aiClient){if(typeof this._aiClient!="string"){p(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient)),this._asyncAIClient.then(y=>{p(y)},y=>{(0,E.onUnexpectedError)(y),console.error(y)})}}log(p,y){!this._aiClient||(y=(0,R.mixin)(y,this._defaultData),y=(0,L.validateTelemetryData)(y),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+p,properties:y.properties,measurements:y.measurements})))}flush(){return this._aiClient?new Promise(p=>{this._withAIClient(y=>{y.flush({callback:()=>{this._aiClient=void 0,p(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(Z[187],ee([0,1,51,82,17,83,24,21,53,12,14,84]),function(K,e,E,R,L,k,A,P,p,y,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let g=class{constructor(u,I,C,b){this.configurationService=u,this.telemetryService=I,this.loggerService=C,this.environmentService=b,this.customTelemetryServices=new Map}async getCustomTelemetryService(u){if(!this.customTelemetryServices.has(u.id)){const{machineId:I,sessionId:C}=await this.telemetryService.getTelemetryInfo(),b=Object.create(null);b["common.vscodemachineid"]=I,b["common.vscodesessionid"]=C;const D=[u.id,JSON.stringify(b),u.aiKey],o=new E.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:D,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),a=(0,p.combinedAppender)(new R.TelemetryAppenderClient(o),new w.TelemetryLogAppender(this.loggerService,this.environmentService,`[${u.id}] `));this.customTelemetryServices.set(u.id,new k.TelemetryService({appender:a,sendErrorTelemetry:u.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(u.id)}async publicLog(u,I,C){await(await this.getCustomTelemetryService(u)).publicLog(I,C)}async publicLogError(u,I,C){await(await this.getCustomTelemetryService(u)).publicLogError(I,C)}};g=de([Y(0,A.IConfigurationService),Y(1,P.ITelemetryService),Y(2,n.ILoggerService),Y(3,y.IEnvironmentService)],g),e.CustomEndpointTelemetryService=g}),define(Z[188],ee([0,1,6,29,3,2,14]),function(K,e,E,R,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends k.Disposable{constructor(y,n){super();this._logService=n,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=y===void 0?15e3:y}createRequest(y){return new Promise((n,w)=>{const g=++this._lastRequestId;this._pendingRequests.set(g,n),this._onCreateRequest.fire({requestId:g,...y});const m=new R.CancellationTokenSource;(0,E.timeout)(this._timeout,m.token).then(()=>w(`Request ${g} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(g,[(0,k.toDisposable)(()=>m.cancel())])})}acceptReply(y,n){const w=this._pendingRequests.get(y);w?(this._pendingRequests.delete(y),(0,k.dispose)(this._pendingRequestDisposables.get(y)||[]),this._pendingRequestDisposables.delete(y),w(n)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${y}`)}};P=de([Y(1,A.ILogService)],P),e.RequestStore=P}),define(Z[85],ee([0,1,7]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var R;(function(m){m.Shell="terminal.integrated.shell.",m.ShellArgs="terminal.integrated.shellArgs.",m.DefaultProfile="terminal.integrated.defaultProfile.",m.Profiles="terminal.integrated.profiles."})(R=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(m){m.ShellLinux="terminal.integrated.shell.linux",m.ShellMacOs="terminal.integrated.shell.osx",m.ShellWindows="terminal.integrated.shell.windows",m.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",m.AutomationShellLinux="terminal.integrated.automationShell.linux",m.AutomationShellMacOs="terminal.integrated.automationShell.osx",m.AutomationShellWindows="terminal.integrated.automationShell.windows",m.ShellArgsLinux="terminal.integrated.shellArgs.linux",m.ShellArgsMacOs="terminal.integrated.shellArgs.osx",m.ShellArgsWindows="terminal.integrated.shellArgs.windows",m.ProfilesWindows="terminal.integrated.profiles.windows",m.ProfilesMacOs="terminal.integrated.profiles.osx",m.ProfilesLinux="terminal.integrated.profiles.linux",m.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",m.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",m.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",m.UseWslProfiles="terminal.integrated.useWslProfiles",m.TabsEnabled="terminal.integrated.tabs.enabled",m.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",m.TabsHideCondition="terminal.integrated.tabs.hideCondition",m.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",m.TabsShowActions="terminal.integrated.tabs.showActions",m.TabsLocation="terminal.integrated.tabs.location",m.TabsFocusMode="terminal.integrated.tabs.focusMode",m.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",m.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",m.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",m.CopyOnSelection="terminal.integrated.copyOnSelection",m.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",m.FontFamily="terminal.integrated.fontFamily",m.FontSize="terminal.integrated.fontSize",m.LetterSpacing="terminal.integrated.letterSpacing",m.LineHeight="terminal.integrated.lineHeight",m.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",m.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",m.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",m.BellDuration="terminal.integrated.bellDuration",m.FontWeight="terminal.integrated.fontWeight",m.FontWeightBold="terminal.integrated.fontWeightBold",m.CursorBlinking="terminal.integrated.cursorBlinking",m.CursorStyle="terminal.integrated.cursorStyle",m.CursorWidth="terminal.integrated.cursorWidth",m.Scrollback="terminal.integrated.scrollback",m.DetectLocale="terminal.integrated.detectLocale",m.DefaultLocation="terminal.integrated.defaultLocation",m.GpuAcceleration="terminal.integrated.gpuAcceleration",m.RightClickBehavior="terminal.integrated.rightClickBehavior",m.Cwd="terminal.integrated.cwd",m.ConfirmOnExit="terminal.integrated.confirmOnExit",m.ConfirmOnKill="terminal.integrated.confirmOnKill",m.EnableBell="terminal.integrated.enableBell",m.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",m.AllowChords="terminal.integrated.allowChords",m.AllowMnemonics="terminal.integrated.allowMnemonics",m.EnvMacOs="terminal.integrated.env.osx",m.EnvLinux="terminal.integrated.env.linux",m.EnvWindows="terminal.integrated.env.windows",m.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",m.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",m.ShowExitAlert="terminal.integrated.showExitAlert",m.SplitCwd="terminal.integrated.splitCwd",m.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",m.WordSeparators="terminal.integrated.wordSeparators",m.TitleMode="terminal.integrated.titleMode",m.EnableFileLinks="terminal.integrated.enableFileLinks",m.UnicodeVersion="terminal.integrated.unicodeVersion",m.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",m.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",m.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",m.LocalEchoStyle="terminal.integrated.localEchoStyle",m.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",m.InheritEnv="terminal.integrated.inheritEnv",m.ShowLinkHover="terminal.integrated.showLinkHover"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(m){m.CommandPrompt="cmd",m.PowerShell="pwsh",m.Wsl="wsl",m.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(m){m[m.Api=0]="Api",m[m.Process=1]="Process",m[m.Sequence=2]="Sequence"})(A=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(m){m.LocalPty="localPty",m.PtyHost="ptyHost",m.Log="log",m.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,E.createDecorator)("ptyService");var p;(function(m){m[m.BeatInterval=5e3]="BeatInterval",m[m.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",m[m.SecondWaitMultiplier=1]="SecondWaitMultiplier",m[m.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p=e.HeartbeatConstants||(e.HeartbeatConstants={}));var y;(function(m){m.TerminalView="view",m.Editor="editor"})(y=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(m){m[m.GraceTime=6e4]="GraceTime",m[m.ShortGraceTime=6e3]="ShortGraceTime"})(n=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var w;(function(m){m[m.HighWatermarkChars=1e5]="HighWatermarkChars",m[m.LowWatermarkChars=5e3]="LowWatermarkChars",m[m.CharCountAckSize=5e3]="CharCountAckSize"})(w=e.FlowControlConstants||(e.FlowControlConstants={}));var g;(function(m){m.GitBash="Git Bash",m.Pwsh="PowerShell"})(g=e.ProfileSource||(e.ProfileSource={}))}),define(Z[189],ee([0,1,7]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,E.createDecorator)("localPtyService")}),define(Z[190],ee([0,1,34,8,35,18,16,26,4]),function(K,e,E,R,L,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function y(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let g=0;return w&&w.length===4&&(g=parseInt(w[3])),g}e.getWindowsBuildNumber=y;async function n(w,g,m,u=L.env,I=k.Promises.exists){if(R.isAbsolute(w))return await I(w)?w:void 0;if(g===void 0&&(g=L.cwd()),R.dirname(w)!=="."){const v=R.join(g,w);return await I(v)?v:void 0}const b=(0,P.getCaseInsensitive)(u,"PATH");if(m===void 0&&(0,A.isString)(b)&&(m=b.split(R.delimiter)),m===void 0||m.length===0){const v=R.join(g,w);return await I(v)?v:void 0}for(let v of m){let o;if(R.isAbsolute(v)?o=R.join(v,w):o=R.join(g,v,w),await I(o))return o;if(p.isWindows){let a=o+".com";if(await I(a)||(a=o+".exe",await I(a)))return a}}const D=R.join(g,w);return await I(D)?D:void 0}e.findExecutable=n}),define(Z[191],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var E;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(E=e.ColorScheme||(e.ColorScheme={}))}),define(Z[86],ee([0,1,7,2,32,3,191,48]),function(K,e,E,R,L,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,E.createDecorator)("themeService");var p;(function(C){function b(D){return D&&typeof D=="object"&&typeof D.id=="string"}C.isThemeColor=b})(p=e.ThemeColor||(e.ThemeColor={}));function y(C){return{id:C}}e.themeColorFromId=y;var n;(function(C){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||p.isThemeColor(r.color))}C.isThemeIcon=b;const D=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function v(r){const i=D.exec(r);if(!i)return;let[,s]=i;return{id:s}}C.fromString=v;function o(r,i){let s=r.id;const h=s.lastIndexOf("~");return h!==-1&&(s=s.substring(0,h)),i&&(s=`${s}~${i}`),{id:s}}C.modify=o;function a(r,i){return r.id===i.id&&r.color?.id===i.color?.id}C.isEqual=a;function t(r,i){return{id:r.id,color:i?y(i):void 0}}C.asThemeIcon=t,C.asClassNameArray=P.CSSIcon.asClassNameArray,C.asClassName=P.CSSIcon.asClassName,C.asCSSSelector=P.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function w(C){switch(C){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new k.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,R.toDisposable)(()=>{const D=this.themingParticipants.indexOf(b);this.themingParticipants.splice(D,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new g;L.Registry.add(e.Extensions.ThemingContribution,m);function u(C){return m.onColorThemeChange(C)}e.registerThemingParticipant=u;class I extends R.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(D=>this.onThemeChange(D)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,D){let v=this.theme.getColor(b);return v&&D&&(v=D(v,this.theme)),v?v.toString():null}}e.Themable=I}),define(Z[192],ee([0,1,48,86]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function L(P,p){const y=P.map(n=>({name:n.profileName,description:k(n)}));return p&&y.push(...p.map(n=>({name:n.title,description:A(n)}))),{values:y.map(n=>n.name),markdownDescriptions:y.map(n=>n.description)}}e.createProfileSchemaEnums=L;function k(P){let p=`$(${R.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:E.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?p+=`
- args: "${P.args}"`:p+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(p+=`
- overrideName: ${P.overrideName}`),P.color&&(p+=`
- color: ${P.color}`),P.env&&(p+=`
- env: ${JSON.stringify(P.env)}`),p}function A(P){return`$(${R.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:E.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(Z[193],ee([0,1,48,127,38,32,192]),function(K,e,E,R,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,R.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,R.localize)(1,null),type:"boolean"},icon:{description:(0,R.localize)(2,null),type:"string",enum:Array.from(E.iconRegistry.all,C=>C.id),markdownEnumDescriptions:Array.from(E.iconRegistry.all,C=>`$(${C.id})`)},color:{description:(0,R.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,R.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},p={type:"object",required:["path"],properties:{path:{description:(0,R.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},y=(0,R.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,R.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),w=(0,R.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),g={id:"terminal",order:100,title:(0,R.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:y},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,R.localize)(19,null)}},{type:"string",markdownDescription:(0,R.localize)(20,null)}],default:[],markdownDeprecationMessage:w},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,R.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,R.localize)(23,null),type:"string"},id:{description:(0,R.localize)(24,null),type:"string"},title:{description:(0,R.localize)(25,null),type:"string"},...P}},{type:"null"},p]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,R.localize)(27,null),type:"string"},id:{description:(0,R.localize)(28,null),type:"string"},title:{description:(0,R.localize)(29,null),type:"string"},...P}},{type:"null"},p]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,R.localize)(31,null),type:"string"},id:{description:(0,R.localize)(32,null),type:"string"},title:{description:(0,R.localize)(33,null),type:"string"},...P}},{type:"null"},p]}},["terminal.integrated.useWslProfiles"]:{description:(0,R.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,R.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,R.localize)(36,null),type:"boolean",default:!0}}};function m(){k.Registry.as(L.Extensions.Configuration).registerConfiguration(g),I()}e.registerTerminalPlatformConfiguration=m;let u;function I(C,b){const D=k.Registry.as(L.Extensions.Configuration);u&&D.deregisterConfigurations([u]);let v;C&&(v=(0,A.createProfileSchemaEnums)(C?.profiles,b)),u={id:"terminal",order:100,title:(0,R.localize)(37,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,R.localize)(38,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:C?.os===3?v?.values:void 0,markdownEnumDescriptions:C?.os===3?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,R.localize)(39,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:C?.os===2?v?.values:void 0,markdownEnumDescriptions:C?.os===2?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,R.localize)(40,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:C?.os===1?v?.values:void 0,markdownEnumDescriptions:C?.os===1?v?.markdownDescriptions:void 0}}},D.registerConfiguration(u)}e.registerTerminalDefaultProfileConfiguration=I}),define(Z[194],ee([0,1,8,69,190,41,18,48,4,86]),function(K,e,E,R,L,k,A,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function w(t,r,i,s,h=process.env,c,l,f,S){return c=c||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},p.isWindows?g(i,c,h,l,s.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:s.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:s.getValue("terminal.integrated.defaultProfile.windows"),S,f):v(c,l,i,t&&typeof t=="object"?{...t}:s.getValue(p.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:s.getValue(p.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),S,f,h)}e.detectAvailableProfiles=w;async function g(t,r,i,s,h,c,l,f,S){const d=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),T=`${process.env.windir}\\${d?"Sysnative":"System32"}`;let O=!1;(0,L.getWindowsBuildNumber)()>=16299&&(O=!0),await I(f);const x=new Map;t&&(x.set("PowerShell",{source:"PowerShell",icon:P.Codicon.terminalPowershell,isAutoDetected:!0}),x.set("Windows PowerShell",{path:`${T}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:P.Codicon.terminalPowershell,isAutoDetected:!0}),x.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),x.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),x.set("Command Prompt",{path:`${T}\\cmd.exe`,icon:P.Codicon.terminalCmd,isAutoDetected:!0})),o(c,x);const z=await m(x.entries(),l,r,i,s,S);if(t||!t&&h)try{const H=await b(`${T}\\${O?"wsl":"bash"}.exe`,l);for(const V of H)(!c||!(V.profileName in c))&&z.push(V)}catch(H){s?.info("WSL is not installed, so could not detect WSL profiles")}return z}async function m(t,r,i,s=process.env,h,c){const l=[];for(const[f,S]of t){if(S===null)continue;let d,T,O;if("source"in S){const H=n?.get(S.source);if(!H)continue;d=H.paths,T=S.args||H.args,S.icon?O=u(S.icon):H.icon&&(O=H.icon)}else d=Array.isArray(S.path)?S.path:[S.path],T=p.isWindows||Array.isArray(S.args)?S.args:void 0,O=u(S.icon)||void 0;const x=await c?.(d)||d.slice(),z=await a(f,r,x,i,s,T,S.env,S.overrideName,S.isAutoDetected,h);z?(z.isAutoDetected=S.isAutoDetected,z.icon=O,z.color=S.color,l.push(z)):h?.trace("profile not validated",f,d)}return l}function u(t){return typeof t=="string"?{id:t}:t}async function I(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await C(),icon:y.ThemeIcon.asThemeIcon(P.Codicon.terminalPowershell)}))}async function C(){const t=[];for await(const r of(0,R.enumeratePowerShellInstallations)())t.push(r.exePath);return t}async function b(t,r){const i=[],s=await new Promise((l,f)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le"},(S,d)=>{if(S)return f("Problem occurred when getting wsl distros");l(d)})});if(!s)return[];const h=new RegExp(/[\r?\n]/),c=s.split(h).filter(l=>l.trim().length>0&&l!=="");for(const l of c){if(l===""||l.startsWith("docker-desktop"))continue;const f=`${l} (WSL)`,S={profileName:f,path:t,args:["-d",`${l}`],isDefault:f===r,icon:D(l)};i.push(S)}return i}function D(t){return t.includes("Ubuntu")?y.ThemeIcon.asThemeIcon(P.Codicon.terminalUbuntu):t.includes("Debian")?y.ThemeIcon.asThemeIcon(P.Codicon.terminalDebian):y.ThemeIcon.asThemeIcon(P.Codicon.terminalLinux)}async function v(t,r,i,s,h,c,l,f){const S=new Map;if(i){const d=(await t.readFile("/etc/shells")).toString(),T=c||d.split(`
`).filter(x=>x.trim().indexOf("#")!==0&&x.trim().length>0),O=new Map;for(const x of T){let z=(0,E.basename)(x),H=O.get(z)||0;H++,H>1&&(z=`${z} (${H})`),O.set(z,H),S.set(z,{path:x,isAutoDetected:!0})}}return o(s,S),await m(S.entries(),h,t,f,r,l)}function o(t,r){if(!!t)for(const[i,s]of Object.entries(t))s===null||!("path"in s)&&!("source"in s)?r.delete(i):r.set(i,s)}async function a(t,r,i,s,h,c,l,f,S,d){if(i.length===0)return Promise.resolve(void 0);const T=i.shift();if(T==="")return a(t,r,i,s,h,c,l,f,S);const O={profileName:t,path:T,args:c,env:l,overrideName:f,isAutoDetected:S,isDefault:t===r};if((0,E.basename)(T)===T){const z=h.PATH?h.PATH.split(E.delimiter):void 0;return await(0,L.findExecutable)(T,void 0,z,void 0,s.existsFile)?O:a(t,r,i,s,h,c)}return await s.existsFile((0,E.normalize)(T))?O:a(t,r,i,s,h,c,l,f,S)}}),define(Z[195],ee([0,1,2,14,85,51,17,36,4,3,79,21,194,24,193,188,156]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var b;(function(o){o[o.MaxRestarts=5]="MaxRestarts"})(b||(b={}));let D=0,v=class extends E.Disposable{constructor(a,t,r,i){super();this._reconnectConstants=a,this._configurationService=t,this._logService=r,this._telemetryService=i,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new y.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new y.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new y.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new y.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new y.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new y.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new y.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new y.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new y.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new y.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new y.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new y.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new y.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new y.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new y.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new y.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,(0,u.registerTerminalPlatformConfiguration)(),this._shellEnv=p.isWindows?Promise.resolve(process.env):(0,C.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,E.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new I.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const a=new k.Client(A.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),P.ProxyChannel.toService(a.getChannel(L.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(a.onDidProcessExit(s=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(s.code),this._isDisposed||(this._restartCount<=b.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const r=a.getChannel(L.TerminalIpcChannels.Log);n.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{n.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const i=P.ProxyChannel.toService(a.getChannel(L.TerminalIpcChannels.PtyHost));return this._register(i.onProcessData(s=>this._onProcessData.fire(s))),this._register(i.onProcessExit(s=>this._onProcessExit.fire(s))),this._register(i.onProcessReady(s=>this._onProcessReady.fire(s))),this._register(i.onProcessTitleChanged(s=>this._onProcessTitleChanged.fire(s))),this._register(i.onProcessShellTypeChanged(s=>this._onProcessShellTypeChanged.fire(s))),this._register(i.onProcessOverrideDimensions(s=>this._onProcessOverrideDimensions.fire(s))),this._register(i.onProcessResolvedShellLaunchConfig(s=>this._onProcessResolvedShellLaunchConfig.fire(s))),this._register(i.onProcessDidChangeHasChildProcesses(s=>this._onProcessDidChangeHasChildProcesses.fire(s))),this._register(i.onProcessReplay(s=>this._onProcessReplay.fire(s))),this._register(i.onProcessOrphanQuestion(s=>this._onProcessOrphanQuestion.fire(s))),this._register(i.onDidRequestDetach(s=>this._onDidRequestDetach.fire(s))),[a,i]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,t,r,i,s,h,c,l,f,S){const d=setTimeout(()=>this._handleUnresponsiveCreateProcess(),L.HeartbeatConstants.CreateProcessTimeout),T=await this._proxy.createProcess(a,t,r,i,s,h,c,l,f,S);return clearTimeout(d),D=Math.max(D,T),T}updateTitle(a,t,r){return this._proxy.updateTitle(a,t,r)}updateIcon(a,t,r){return this._proxy.updateIcon(a,t,r)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,t){return this._proxy.shutdown(a,t)}input(a,t){return this._proxy.input(a,t)}processBinary(a,t){return this._proxy.processBinary(a,t)}resize(a,t,r){return this._proxy.resize(a,t,r)}acknowledgeDataEvent(a,t){return this._proxy.acknowledgeDataEvent(a,t)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,t,r,i=!1){const s=await this._shellEnv;return(0,g.detectAvailableProfiles)(t,r,i,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,t){return this._proxy.requestDetachInstance(a,t)}async acceptDetachInstanceReply(a,t){return this._proxy.acceptDetachInstanceReply(a,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier+L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${L.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,t){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:t})}async acceptPtyHostResolvedVariables(a,t){this._resolveVariablesRequestStore.acceptReply(a,t)}};v=de([Y(1,m.IConfigurationService),Y(2,R.ILogService),Y(3,w.ITelemetryService)],v),e.PtyHostService=v}),define(Z[54],ee([0,1,43]),function(K,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function R(A,P,p,y){const n=(0,E.setProperty)(A,P,p,y)[0];return n&&(A=A.substring(0,n.offset)+n.content+A.substring(n.offset+n.length)),A}e.edit=R;function L(A,P,p){let y=p;for(;y>=0;){if(A.charAt(y)===P.charAt(P.length-1)&&P.length===1)return y+1;if(y--,P.length===2&&y>=0&&A.charAt(y)===P.charAt(0))return y+2}return 0}e.getLineStartOffset=L;function k(A,P,p){let y=p;for(;y>=0;)if(A.charAt(y)===P.charAt(P.length-1)&&P.length===1||(y++,P.length===2&&y>=0&&A.charAt(y)===P.charAt(1)))return y;return A.length-1}e.getLineEndOffset=k}),define(Z[196],ee([0,1,26,58]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(w,g,m,u,I){const C=[],b=[],D=[];if(!g){const T=w.filter(({identifier:O})=>I.every(x=>x.toLowerCase()!==O.id.toLowerCase()));return{local:{added:C,removed:b,updated:D},remote:T.length>0?{added:T,updated:[],removed:[],all:T}:null}}w=w.map(y),g=g.map(y),m=m?m.map(y):null;const v=new Map,o=T=>{T.uuid&&v.set(T.id.toLowerCase(),T.uuid)};w.forEach(({identifier:T})=>o(T)),g.forEach(({identifier:T})=>o(T)),m&&m.forEach(({identifier:T})=>o(T));const a=T=>{const O=T.identifier.uuid||v.get(T.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${T.identifier.id.toLowerCase()}`},t=(T,O)=>(T.set(a(O),O),T),r=w.reduce(t,new Map),i=g.reduce(t,new Map),s=g.reduce((T,O)=>{const x=a(O);O=(0,E.deepClone)(O);const z=r.get(x);return z&&(z.installed&&(O.installed=!0),O.version||(O.version=z.version)),t(T,O)},new Map),h=m?m.reduce(t,new Map):null,c=u.reduce(t,new Map),l=I.reduce((T,O)=>{const x=v.get(O.toLowerCase());return T.add(x?`uuid:${x}`:`id:${O.toLowerCase()}`)},new Set),f=k(r,i,l);if(f.added.size>0||f.removed.size>0||f.updated.size>0){const T=k(h,r,l),O=k(h,i,l),x=(z,H)=>{const V=r.get(z);if(V){const U=i.get(z);return{...H?U:V,version:(U.version&&R.gt(U.version,V.version),V.version),state:A(V,U,h?.get(z))}}};for(const z of O.removed.values()){const H=r.get(z);H&&b.push(H.identifier)}for(const z of O.added.values())if(T.added.has(z)){if(f.updated.has(z)){const H=x(z,!0);H&&(D.push(n(H,z)),s.set(z,H))}}else{const H=i.get(z);H.installed&&C.push(n(H,z))}for(const z of O.updated.values()){const H=x(z,!0);H&&(D.push(n(H,z)),s.set(z,H))}for(const z of T.added.values())O.added.has(z)||s.set(z,r.get(z));for(const z of T.updated.values())if(!O.removed.has(z)&&!O.updated.has(z)){const H=x(z,!1);H&&(s.get(z)?.installed&&(H.installed=!0),s.set(z,H))}for(const z of T.removed.values())!c.has(z)&&!O.updated.has(z)&&h?.get(z)?.installed&&s.delete(z)}const S=[],d=k(i,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(d.added.size>0||d.updated.size>0||d.removed.size>0)&&s.forEach((T,O)=>S.push(n(T,O))),{local:{added:C,removed:b,updated:D},remote:S.length?{added:[...d.added].map(T=>s.get(T)),updated:[...d.updated].map(T=>s.get(T)),removed:[...d.removed].map(T=>i.get(T)),all:S}:null}}e.merge=L;function k(w,g,m,{checkInstalledProperty:u,checkVersionProperty:I}={checkInstalledProperty:!1,checkVersionProperty:!1}){const C=w?[...w.keys()].filter(a=>!m.has(a)):[],b=[...g.keys()].filter(a=>!m.has(a)),D=b.filter(a=>C.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),v=C.filter(a=>b.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),o=new Set;for(const a of C){if(v.has(a))continue;const t=w.get(a),r=g.get(a);(!r||t.disabled!==r.disabled||!p(t.state,r.state)||I&&t.version!==r.version||u&&t.installed!==r.installed)&&o.add(a)}return{added:D,removed:v,updated:o}}function A(w,g,m){const u=w.state,I=g.state,C=m?.state;if(!g.version||u&&R.gt(w.version,g.version))return u;if(I&&R.gt(g.version,w.version)||!u)return I;if(!I)return u;const b=(0,E.deepClone)(u),D=C?P(C,I):{added:Object.keys(I).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set},v=C?P(C,u):{added:Object.keys(u).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set};for(const o of[...D.added.values(),...D.updated.values()])b[o]=I[o];for(const o of D.removed.values())v.updated.has(o)||delete b[o];return b}function P(w,g){const m=Object.keys(w),u=Object.keys(g),I=u.filter(D=>m.indexOf(D)===-1).reduce((D,v)=>(D.add(v),D),new Set),C=m.filter(D=>u.indexOf(D)===-1).reduce((D,v)=>(D.add(v),D),new Set),b=new Set;for(const D of m){if(C.has(D))continue;const v=w[D],o=g[D];(0,E.equals)(v,o)||b.add(D)}return{added:I,removed:C,updated:b}}function p(w={},g={}){const{added:m,removed:u,updated:I}=P(w,g);return m.size===0&&u.size===0&&I.size===0}function y(w){return{...w,disabled:!!w.disabled,installed:!!w.installed}}function n(w,g){const m={identifier:{id:w.identifier.id,uuid:g.startsWith("uuid:")?g.substring("uuid:".length):void 0}};return w.version&&(m.version=w.version),w.disabled&&(m.disabled=!0),w.installed&&(m.installed=!0),w.state&&(m.state=w.state),m}}),define(Z[87],ee([0,1,23,3,2,31,7,28,20]),function(K,e,E,R,L,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,A.createDecorator)("IExtensionsStorageSyncService");const y=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class Ze extends L.Disposable{constructor(g,m){super();this.storageService=g,this.productService=m,this._onDidChangeExtensionsStorage=this._register(new R.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}static toKey(g){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(g.id)}@${g.version}`}static fromKey(g){const m=y.exec(g);if(m&&m[1])return{id:m[1],version:m[2]}}initialize(){const g=this.storageService.keys(0,1);for(const m of g){const u=Ze.fromKey(m);u&&this.extensionsWithKeysForSync.add(u.id.toLowerCase())}}onDidChangeStorageValue(g){if(g.scope!==0)return;if(this.extensionsWithKeysForSync.has(g.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const m=Ze.fromKey(g.key);if(m){this.extensionsWithKeysForSync.add(m.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(g,m){this.storageService.store(Ze.toKey(g),JSON.stringify(m),0,1)}getKeysForSync(g){const m=this.productService.extensionSyncedKeys?.[g.id.toLowerCase()],u=this.storageService.get(Ze.toKey(g),0),I=u?JSON.parse(u):void 0;return I&&m?(0,E.distinct)([...I,...m]):I||m}};n=de([Y(0,p.IStorageService),Y(1,P.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(Z[88],ee([0,1,23,24,7]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,p){let y=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return y=y.filter(n=>n!==P&&n!==`-${P}`),p&&y.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,1)}updateSynchronizedExtensions(P,p){let y=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return y=y.filter(n=>n!==P&&n!==`-${P}`),p&&y.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,1)}getIgnoredExtensions(P){const p=P.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),y=this.getConfiguredIgnoredExtensions().map(g=>g.toLowerCase()),n=[],w=[];if(Array.isArray(y))for(const g of y)g.startsWith("-")?w.push(g.substring(1)):n.push(g);return(0,E.distinct)([...p,...n].filter(g=>w.indexOf(g)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(p=>p.toLowerCase())}};k=de([Y(0,R.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(Z[197],ee([0,1,26,33,23,150,54]),function(K,e,E,R,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(o){return(0,R.parse)(o)||[]}e.parseKeybindings=P;async function p(o,a,t,r,i){const s=P(o),h=P(a),c=t?P(t):null,l=[...s,...h,...c||[]].map($=>$.key),f=await i.resolveUserBindings(l);let S=n(s,h,c,f);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const d=g(s),T=g(h),O=c?g(c):null,x=u(d,T,f),z=O?u(O,d,f):{added:[...d.keys()].reduce(($,M)=>($.add(M),$),new Set),removed:new Set,updated:new Set},H=O?u(O,T,f):{added:[...T.keys()].reduce(($,M)=>($.add(M),$),new Set),removed:new Set,updated:new Set},V=y(x,z,H);let U=o;for(const $ of V.removed.values())V.conflicts.has($)||(U=D(U,$,r));for(const $ of V.added.values()){if(V.conflicts.has($))continue;const M=T.get($);if(M.some(N=>N.command!==`-${$}`&&S.conflicts.has(f[N.key]))){V.conflicts.add($);continue}U=b(U,M,r)}for(const $ of V.updated.values()){if(V.conflicts.has($))continue;const M=T.get($);if(M.some(N=>N.command!==`-${$}`&&S.conflicts.has(f[N.key]))){V.conflicts.add($);continue}U=v(U,$,M,r)}return{mergeContent:U,hasChanges:!0,hasConflicts:V.conflicts.size>0}}e.merge=p;function y(o,a,t){const r=new Set,i=new Set,s=new Set,h=new Set;for(const c of a.removed.values())t.updated.has(c)&&h.add(c);for(const c of t.removed.values())h.has(c)||(a.updated.has(c)?h.add(c):i.add(c));for(const c of a.added.values())h.has(c)||t.added.has(c)&&o.updated.has(c)&&h.add(c);for(const c of t.added.values())h.has(c)||(a.added.has(c)?o.updated.has(c)&&h.add(c):r.add(c));for(const c of a.updated.values())h.has(c)||t.updated.has(c)&&o.updated.has(c)&&h.add(c);for(const c of t.updated.values())h.has(c)||(a.updated.has(c)?o.updated.has(c)&&h.add(c):s.add(c));return{added:r,removed:i,updated:s,conflicts:h}}function n(o,a,t,r){const i=new Set,s=w(o,r),h=w(a,r),c=t?w(t,r):null,l=m(s,h);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const f=c?m(c,s):{added:[...s.keys()].reduce((z,H)=>(z.add(H),z),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const S=c?m(c,h):{added:[...h.keys()].reduce((z,H)=>(z.add(H),z),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:d,removed:T,updated:O,conflicts:x}=y(l,f,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:d,removed:T,updated:O,conflicts:x}}function w(o,a){const t=new Map;for(const r of o){const i=a[r.key];let s=t.get(i);s||(s=[],t.set(i,s)),s.push(r)}return t}function g(o){const a=new Map;for(const t of o){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=a.get(r);i||(i=[],a.set(r,i)),i.push(t)}return a}function m(o,a){const t=[...o.keys()],r=[...a.keys()],i=r.filter(c=>t.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),s=t.filter(c=>r.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),h=new Set;for(const c of t){if(s.has(c))continue;const l=o.get(c).map(S=>({...S,key:c})),f=a.get(c).map(S=>({...S,key:c}));(0,L.equals)(l,f,(S,d)=>C(S,d))||h.add(c)}return{added:i,removed:s,updated:h}}function u(o,a,t){const r=[...o.keys()],i=[...a.keys()],s=i.filter(l=>r.indexOf(l)===-1).reduce((l,f)=>(l.add(f),l),new Set),h=r.filter(l=>i.indexOf(l)===-1).reduce((l,f)=>(l.add(f),l),new Set),c=new Set;for(const l of r){if(h.has(l))continue;const f=o.get(l).map(d=>({...d,key:t[d.key]})),S=a.get(l).map(d=>({...d,key:t[d.key]}));I(f,S)||c.add(l)}return{added:s,removed:h,updated:c}}function I(o,a){return!(!(0,L.equals)(o.filter(({command:t})=>t[0]!=="-"),a.filter(({command:t})=>t[0]!=="-"),(t,r)=>C(t,r))||!(0,L.equals)(o.filter(({command:t})=>t[0]==="-"),a.filter(({command:t})=>t[0]==="-"),(t,r)=>C(t,r)))}function C(o,a){if(o.command!==a.command||o.key!==a.key)return!1;const t=k.ContextKeyExpr.deserialize(o.when),r=k.ContextKeyExpr.deserialize(a.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!E.equals(o.args,a.args))}function b(o,a,t){for(const r of a)o=A.edit(o,[-1],r,t);return o}function D(o,a,t){const r=P(o);for(let i=r.length-1;i>=0;i--)(r[i].command===a||r[i].command===`-${a}`)&&(o=A.edit(o,[i],void 0,t));return o}function v(o,a,t,r){const i=P(o),s=i.findIndex(h=>h.command===a||h.command===`-${a}`);for(let h=i.length-1;h>=0;h--)(i[h].command===a||i[h].command===`-${a}`)&&(o=A.edit(o,[h],void 0,r));for(let h=t.length-1;h>=0;h--)o=A.edit(o,[s],t[h],r);return o}}),define(Z[198],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function E(k,A,P){const p={},y={},n=new Set;if(!A)return{local:{added:p,updated:y,removed:[...n.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const w=R(k,A);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:p,updated:y,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=R(P,k),m=R(P,A),u={},I={},C=new Set,b=new Set;for(const D of g.removed.values())m.updated.has(D)?p[D]=A[D]:C.add(D);for(const D of m.removed.values())b.has(D)||(g.updated.has(D)?b.add(D):n.add(D));for(const D of g.updated.values())b.has(D)||(m.updated.has(D)?w.updated.has(D)&&b.add(D):I[D]=k[D]);for(const D of m.updated.values())b.has(D)||(g.updated.has(D)?w.updated.has(D)&&b.add(D):k[D]!==void 0&&(y[D]=A[D]));for(const D of g.added.values())b.has(D)||(m.added.has(D)?w.updated.has(D)&&b.add(D):u[D]=k[D]);for(const D of m.added.values())b.has(D)||(g.added.has(D)?w.updated.has(D)&&b.add(D):p[D]=A[D]);return{local:{added:p,removed:[...n.values()],updated:y},remote:{added:u,removed:[...C.values()],updated:I},conflicts:[...b.values()]}}e.merge=E;function R(k,A){const P=k?Object.keys(k):[],p=A?Object.keys(A):[],y=p.filter(g=>P.indexOf(g)===-1).reduce((g,m)=>(g.add(m),g),new Set),n=P.filter(g=>p.indexOf(g)===-1).reduce((g,m)=>(g.add(m),g),new Set),w=new Set;for(const g of P){if(n.has(g))continue;const m=k[g],u=A[g];m!==u&&w.add(g)}return{added:y,removed:n,updated:w}}function L(k,A){const{added:P,removed:p,updated:y}=R(k,A);return P.size===0&&p.size===0&&y.size===0}e.areSame=L}),define(Z[22],ee([0,1,7,27,32,38,132,81,15,23,16]),function(K,e,E,R,L,k,A,P,p,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function w(){const c=L.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(l=>!!c[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=w;function g(){const c=L.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(c).filter(d=>!!c[d].ignoreSync),f=Object.keys(c).filter(d=>c[d].scope===2||c[d].scope===6),S=w();return(0,y.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...f,...S])}e.getDefaultIgnoredSettings=g;function m(){const c="vscode://schemas/ignoredSettings",l=L.Registry.as(k.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const f=L.Registry.as(P.Extensions.JSONContribution),S=()=>{const d=w(),T=g().filter(H=>H!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(k.allSettings.properties).filter(H=>T.indexOf(H)===-1),x=T.filter(H=>d.indexOf(H)===-1),z={items:{type:"string",enum:[...O,...x.map(H=>`-${H}`)]}};f.registerSchema(c,z)};return l.onDidUpdateConfiguration(()=>S())}e.registerConfiguration=m;function u(c){return c&&(0,n.isObject)(c)&&(0,n.isString)(c.id)&&(0,n.isArray)(c.scopes)}e.isAuthenticationProvider=u;var I;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(I=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function C(c,l,f){return f.joinPath(l.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=C,e.IUserDataSyncStoreManagementService=(0,E.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,E.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,E.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function b(c){const l={};return l[e.HEADER_EXECUTION_ID]=c,l}e.createSyncHeaders=b;var D;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.RequestProtocolNotSupported="RequestProtocolNotSupported",c.RequestPathNotEscaped="RequestPathNotEscaped",c.RequestHeadersNotObject="RequestHeadersNotObject",c.NoRef="NoRef",c.EmptyResponse="EmptyResponse",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(D=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class v extends Error{constructor(l,f,S,d){super(l);this.code=f,this.resource=S,this.operationId=d,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=v;class o extends v{constructor(l,f,S,d,T){super(l,S,void 0,T);this.url=f,this.serverCode=d}}e.UserDataSyncStoreError=o;class a extends v{constructor(l,f){super(l,f)}}e.UserDataAutoSyncError=a,function(c){function l(f){if(f instanceof c)return f;const S=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(f.name);if(S&&S[1]){const d=S[2]==="unknown"?void 0:S[2],T=S[3]==="unknown"?void 0:S[3];return new c(f.message,S[1],d,T)}return new c(f.message,"Unknown")}c.toUserDataSyncError=l}(v=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(c){return`sync.enable.${c}`}e.getEnablementKey=s,e.IUserDataSyncResourceEnablementService=(0,E.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,E.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,E.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,E.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,E.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,E.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function h(c,l){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(f=>(0,p.isEqualOrParent)(c,(0,p.joinPath)(l.userDataSyncHome,f,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=h}),define(Z[46],ee([0,1,2,13,25,5,22,12,15,6,3,21,33,128,24,16,19,23,45,20,29]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I,C,b,D,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function a(h){return!!(h&&h.version!==void 0&&typeof h.version=="number"&&h.content!==void 0&&typeof h.content=="string"&&(Object.keys(h).length===2||Object.keys(h).length===3&&h.machineId!==void 0&&typeof h.machineId=="string"))}e.isSyncData=a;let t=class extends E.Disposable{constructor(c,l,f,S,d,T,O,x,z,H){super();this.resource=c,this.fileService=l,this.environmentService=f,this.userDataSyncStoreService=d,this.userDataSyncBackupStoreService=T,this.userDataSyncResourceEnablementService=O,this.telemetryService=x,this.logService=z,this.configurationService=H,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new n.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new n.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new y.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new n.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,C.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(f.userDataSyncHome,1024)?p.extUri:p.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(f.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,A.PREVIEW_DIR_NAME),this.lastSyncResource=(0,A.getLastSyncResourceUri)(c,f,this.extUri),this.currentMachineIdPromise=(0,D.getServiceMachineId)(f,l,S)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0);this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?(await this.doGenerateSyncResourcePreview(c,c,!0,o.CancellationToken.None)).resourcePreviews.some(({remoteChange:f})=>f!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const l=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),l==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,l={}){await this._sync(c,!0,l)}async preview(c,l={}){return this._sync(c,!1,l)}async apply(c,l={}){try{this.syncHeaders={...l};const f=await this.doApply(c);return this.setStatus(f),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,l,f){try{if(this.syncHeaders={...f},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let S="idle";try{const d=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(c,d);return S=await this.performSync(T,d,l),S==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):S==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(S)}}finally{this.syncHeaders={}}}async replace(c){const l=await this.resolveContent(c);if(!l)return!1;const f=this.parseSyncData(l);if(!f)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const S=await this.getLastSyncUserData(),d=await this.getLatestRemoteUserData(null,S),T=await this.isRemoteDataFromCurrentMachine(d),O=await this.generateSyncPreview({ref:d.ref,syncData:f},S,T,o.CancellationToken.None),x=[];for(const z of O){const H=await this.getAcceptResult(z,z.remoteResource,void 0,o.CancellationToken.None),{remoteChange:V}=await this.getAcceptResult(z,z.previewResource,z.remoteContent,o.CancellationToken.None);x.push([z,{...H,remoteChange:V!==0?V:2}])}await this.applyResult(d,S,x,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const l=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===l}async getLatestRemoteUserData(c,l){if(l){const f=c&&c.latest?c.latest[this.resource]:void 0;if(l.ref===f||f===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(c,l,f){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new A.UserDataSyncError((0,m.localize)(0,null,this.resource,this.version,c.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(c,l,f)}catch(S){if(S instanceof A.UserDataSyncError)switch(S.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,l,f);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(c,l,f)}throw S}}async doSync(c,l,f){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,y.createCancelablePromise)(d=>this.doGenerateSyncResourcePreview(c,l,f,d)));const S=await this.syncPreviewPromise;return this.updateConflicts(S.resourcePreviews),S.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":f?await this.doApply(!1):"syncing"}catch(S){throw this.syncPreviewPromise=null,S}}async merge(c){return await this.updateSyncResourcePreview(c,async l=>{const f=await this.getMergeResult(l,o.CancellationToken.None);await this.fileService.writeFile(l.previewResource,L.VSBuffer.fromString(f?.content||""));const S=f&&!f.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,o.CancellationToken.None):void 0;return l.acceptResult=S,l.mergeState=f.hasConflicts?"conflict":S?"accepted":"preview",l.localChange=S?S.localChange:f.localChange,l.remoteChange=S?S.remoteChange:f.remoteChange,l}),this.syncPreviewPromise}async accept(c,l){return await this.updateSyncResourcePreview(c,async f=>{const S=await this.getAcceptResult(f,c,l,o.CancellationToken.None);return f.acceptResult=S,f.mergeState="accepted",f.localChange=S.localChange,f.remoteChange=S.remoteChange,f}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async l=>{const f=await this.getMergeResult(l,o.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,L.VSBuffer.fromString(f.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=f.localChange,l.remoteChange=f.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(c,l){if(!this.syncPreviewPromise)return;let f=await this.syncPreviewPromise;const S=f.resourcePreviews.findIndex(({localResource:d,remoteResource:T,previewResource:O})=>this.extUri.isEqual(d,c)||this.extUri.isEqual(T,c)||this.extUri.isEqual(O,c));S!==-1&&(this.syncPreviewPromise=(0,y.createCancelablePromise)(async d=>{const T=[...f.resourcePreviews];return T[S]=await l(T[S]),{...f,resourcePreviews:T}}),f=await this.syncPreviewPromise,this.updateConflicts(f.resourcePreviews),f.resourcePreviews.some(({mergeState:d})=>d==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:f})=>f==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:f})=>f!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(f=>[f,f.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(c){}}updateConflicts(c){const l=c.filter(({mergeState:f})=>f==="conflict");(0,b.equals)(this._conflicts,l,(f,S)=>this.extUri.isEqual(f.previewResource,S.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:l,ref:f})=>({created:l,uri:this.toRemoteBackupResource(f)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:l,ref:f})=>({created:l,uri:this.toLocalBackupResource(f)}))}toRemoteBackupResource(c){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const l=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(l))){const{content:f}=await this.getUserData(l);if(f)return this.parseSyncData(f)?.machineId}}async resolveContent(c){const l=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(l))){const{content:f}=await this.getUserData(l);return f}return this.extUri.isEqual(c,this.toLocalBackupResource(l))?this.userDataSyncBackupStoreService.resolveContent(this.resource,l):null}async resolvePreviewContent(c){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const f of l.resourcePreviews){if(this.extUri.isEqual(f.acceptedResource,c))return f.acceptResult?f.acceptResult.content:null;if(this.extUri.isEqual(f.remoteResource,c))return f.remoteContent;if(this.extUri.isEqual(f.localResource,c))return f.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(c){}}async doGenerateSyncResourcePreview(c,l,f,S){const d=await this.isRemoteDataFromCurrentMachine(c),T=await this.generateSyncPreview(c,l,d,S),O=[];for(const x of T){const z=x.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(x.localChange===0&&x.remoteChange===0)O.push({...x,acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const H=f?await this.getMergeResult(x,S):void 0;if(S.isCancellationRequested)break;await this.fileService.writeFile(x.previewResource,L.VSBuffer.fromString(H?.content||""));const V=H&&!H.hasConflicts?await this.getAcceptResult(x,x.previewResource,void 0,S):void 0;O.push({...x,acceptResult:V,mergeState:H?.hasConflicts?"conflict":V?"accepted":"preview",localChange:V?V.localChange:H?H.localChange:x.localChange,remoteChange:V?V.remoteChange:H?H.remoteChange:x.remoteChange})}}return{remoteUserData:c,lastSyncUserData:l,resourcePreviews:O,isLastSyncFromCurrentMachine:d}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(c.value.toString()),f=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=l.version&&f&&l.version!==f,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${f}.`),await this.resetLocal(),null;const S=l;if(S.content===null)return{ref:l.ref,syncData:null};const d=JSON.parse(S.content);if(a(d))return{...l,syncData:d,content:void 0}}catch(c){c instanceof R.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,l={}){if(l.ref||l.content||l.version)throw new Error("Cannot have core properties as additional");const f=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),S={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:f,...l};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(S)))}async getRemoteUserData(c){const{ref:l,content:f}=await this.getUserData(c);let S=null;return f!==null&&(S=this.parseSyncData(f)),{ref:l,syncData:S}}parseSyncData(c){try{const l=JSON.parse(c);if(a(l))return l}catch(l){this.logService.error(l)}throw new A.UserDataSyncError((0,m.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(c){if((0,I.isString)(c)){const l=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:l}}else{const l=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,l,this.syncHeaders)}}async updateRemoteUserData(c,l){const f=await this.currentMachineIdPromise,S={version:this.version,machineId:f,content:c};return l=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(S),l,this.syncHeaders),{ref:l,syncData:S}}async backupLocal(c){const l={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=de([Y(1,R.IFileService),Y(2,P.IEnvironmentService),Y(3,v.IStorageService),Y(4,A.IUserDataSyncStoreService),Y(5,A.IUserDataSyncBackupStoreService),Y(6,A.IUserDataSyncResourceEnablementService),Y(7,w.ITelemetryService),Y(8,A.IUserDataSyncLogService),Y(9,u.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(c,l,f,S,d,T,O,x,z,H,V){super(l,f,S,d,T,O,x,z,H,V);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(U=>this.onFileChanges(U)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(c){return null}}async updateLocalFileContent(c,l,f){try{l?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(c),f?void 0:l):await this.fileService.createFile(this.file,L.VSBuffer.fromString(c),{overwrite:f})}catch(S){throw S instanceof R.FileOperationError&&S.fileOperationResult===1||S instanceof R.FileOperationError&&S.fileOperationResult===3?new A.UserDataSyncError(S.message,"LocalPreconditionFailed"):S}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};r=de([Y(2,R.IFileService),Y(3,P.IEnvironmentService),Y(4,v.IStorageService),Y(5,A.IUserDataSyncStoreService),Y(6,A.IUserDataSyncBackupStoreService),Y(7,A.IUserDataSyncResourceEnablementService),Y(8,w.ITelemetryService),Y(9,A.IUserDataSyncLogService),Y(10,u.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let i=class extends r{constructor(c,l,f,S,d,T,O,x,z,H,V,U){super(c,l,f,S,d,T,O,x,z,H,U);this.userDataSyncUtilService=V,this._formattingOptions=void 0}hasErrors(c){const l=[];return(0,g.parse)(c,l,{allowEmptyContent:!0,allowTrailingComma:!0}),l.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=de([Y(2,R.IFileService),Y(3,P.IEnvironmentService),Y(4,v.IStorageService),Y(5,A.IUserDataSyncStoreService),Y(6,A.IUserDataSyncBackupStoreService),Y(7,A.IUserDataSyncResourceEnablementService),Y(8,w.ITelemetryService),Y(9,A.IUserDataSyncLogService),Y(10,A.IUserDataSyncUtilService),Y(11,u.IConfigurationService)],i),e.AbstractJsonFileSynchroniser=i;let s=class{constructor(c,l,f,S){this.resource=c,this.environmentService=l,this.logService=f,this.fileService=S,this.extUri=this.fileService.hasCapability(l.userDataSyncHome,1024)?p.extUri:p.extUriIgnorePathCase,this.lastSyncResource=(0,A.getLastSyncResourceUri)(this.resource,l,p.extUri)}async initialize({ref:c,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const f=this.parseSyncData(l);if(!f)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:c,syncData:f})}catch(d){this.logService.error(d)}}parseSyncData(c){try{const l=JSON.parse(c);if(a(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,l={}){const f={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...l};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(f)))}};s=de([Y(1,P.IEnvironmentService),Y(2,A.IUserDataSyncLogService),Y(3,R.IFileService)],s),e.AbstractInitializer=s}),define(Z[199],ee([0,1,22,3,12,27,31,13,24,196,46,21,5,47,43,19,20,88,11,87,6]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I,C,b,D,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function a(h,c){const l=JSON.parse(h.content);if(h.version===1||h.version===2){const f=(await c.getInstalled(0)).filter(S=>S.isBuiltin);for(const S of l)h.version===1&&(S.enabled===!1&&(S.disabled=!0),delete S.enabled),h.version===2&&f.every(d=>!(0,A.areSameExtensions)(d.identifier,S.identifier))&&(S.installed=!0)}return l}function t(h,c,l){const f=l.get((0,A.getExtensionId)(h,c),0)||"{}";return JSON.parse(f)}e.getExtensionStorageState=t;function r(h,c,l,f){f.store((0,A.getExtensionId)(h,c),JSON.stringify(l),0,1)}e.storeExtensionStorageState=r;let i=class at extends n.AbstractSynchroniser{constructor(c,l,f,S,d,T,O,x,z,H,V,U,$,M){super("extensions",l,c,f,S,d,U,$,z,V);this.storageService=f,this.extensionManagementService=T,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=x,this.extensionGalleryService=H,this.extensionsStorageSyncService=M,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.debounce(R.Event.any(R.Event.filter(this.extensionManagementService.onDidInstallExtensions,N=>N.some(({local:q})=>!!q)),R.Event.filter(this.extensionManagementService.onDidUninstallExtension,N=>!N.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(c,l){const f=c.syncData?await a(c.syncData,this.extensionManagementService):null,S=l?.skippedExtensions||[],d=l?.syncData?await a(l.syncData,this.extensionManagementService):null,T=await this.extensionManagementService.getInstalled(),O=this.getLocalExtensions(T),x=this.ignoredExtensionsManagementService.getIgnoredExtensions(T);f?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:H}=(0,y.merge)(O,f,d,S,x),V={local:z,remote:H,content:this.getPreviewContent(O,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:H!==null?2:0};return[{skippedExtensions:S,localResource:this.localResource,localContent:this.format(O),localExtensions:O,remoteResource:this.remoteResource,remoteContent:f?this.format(f):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(c,l,f,S){const d=[...l,...f],T=new Set,O=x=>{T.add(x.id.toLowerCase()),x.uuid&&T.add(x.uuid)};d.forEach(({identifier:x})=>O(x)),S.forEach(O);for(const x of c)T.has(x.identifier.id.toLowerCase())||x.identifier.uuid&&T.has(x.identifier.uuid)||d.push(x);return this.format(d)}async getMergeResult(c,l){return{...c.previewResult,hasConflicts:!1}}async getAcceptResult(c,l,f,S){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(c);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(c);if(this.extUri.isEqual(l,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(c){const l=await this.extensionManagementService.getInstalled(),f=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),S=(0,y.merge)(c.localExtensions,null,null,c.skippedExtensions,f),{local:d,remote:T}=S;return{content:c.localContent,local:d,remote:T,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:T!==null?2:0}}async acceptRemote(c){const l=await this.extensionManagementService.getInstalled(),f=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),S=c.remoteContent?JSON.parse(c.remoteContent):null;if(S!==null){const d=(0,y.merge)(c.localExtensions,S,c.localExtensions,[],f),{local:T,remote:O}=d;return{content:c.remoteContent,local:T,remote:O,localChange:T.added.length>0||T.removed.length>0||T.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(c,l,f,S){let{skippedExtensions:d,localExtensions:T}=f[0][0],{local:O,remote:x,localChange:z,remoteChange:H}=f[0][1];if(z===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(T)),d=await this.updateLocalExtensions(O.added,O.removed,O.updated,d)),x){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const V=JSON.stringify(x.all);c=await this.updateRemoteUserData(V,S?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${x.added.length?` Added: ${JSON.stringify(x.added.map(U=>U.identifier.id))}.`:""}${x.updated.length?` Updated: ${JSON.stringify(x.updated.map(U=>U.identifier.id))}.`:""}${x.removed.length?` Removed: ${JSON.stringify(x.removed.map(U=>U.identifier.id))}.`:""}`)}l?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(c,{skippedExtensions:d}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${d.length?` Skipped: ${JSON.stringify(d.map(V=>V.identifier.id))}.`:""}`))}async getAssociatedResources({uri:c}){return[{resource:this.extUri.joinPath(c,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(c){if(this.extUri.isEqual(c,at.EXTENSIONS_DATA_URI)){const f=await this.extensionManagementService.getInstalled(),S=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),d=this.getLocalExtensions(f).filter(T=>!S.some(O=>(0,A.areSameExtensions)({id:O},T.identifier)));return this.format(d)}if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let l=await super.resolveContent(c);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(c)),l){const f=this.parseSyncData(l);if(f)switch(this.extUri.basename(c)){case"extensions.json":return this.format(this.parseExtensions(f))}}return null}format(c){c.sort((S,d)=>!S.identifier.uuid&&d.identifier.uuid?-1:S.identifier.uuid&&!d.identifier.uuid?1:(0,I.compare)(S.identifier.id,d.identifier.id));const l=JSON.stringify(c),f=(0,m.format)(l,void 0,{});return(0,u.applyEdits)(l,f)}async hasLocalData(){try{const c=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(c).some(f=>f.installed||f.disabled))return!0}catch(c){}return!1}async updateLocalExtensions(c,l,f,S){const d=[],T=[],O=await this.extensionManagementService.getInstalled();if(l.length){const z=O.filter(({identifier:H,isBuiltin:V})=>!V&&l.some(U=>(0,A.areSameExtensions)(H,U)));await o.Promises.settled(z.map(async H=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,H.identifier.id),await this.extensionManagementService.uninstall(H,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,H.identifier.id),d.push(H.identifier)}))}(c.length||f.length)&&await o.Promises.settled([...c,...f].map(async z=>{const H=O.find(U=>(0,A.areSameExtensions)(U.identifier,z.identifier));if(H&&H.isBuiltin){z.state&&H.manifest.version===z.version&&this.updateExtensionState(z.state,H.manifest.publisher,H.manifest.name,H.manifest.version),z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id)),d.push(z.identifier);return}const V=await this.extensionGalleryService.getCompatibleExtension(z.identifier);if(z.state&&(H?H.manifest.version===z.version:!!V)){const U=H?H.manifest.publisher:V.publisher,$=H?H.manifest.name:V.name;this.updateExtensionState(z.state,U,$,H?.manifest.version)}if(V)try{z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,V.version),await this.extensionEnablementService.disableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,V.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,V.version),await this.extensionEnablementService.enableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,V.version)),H||(await this.extensionManagementService.canInstall(V)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,V.version),await this.extensionManagementService.installFromGallery(V,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,V.version),d.push(V.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,V.displayName||V.identifier.id),T.push(z)))}catch(U){T.push(z),this.logService.error(U),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,V.displayName||V.identifier.id)}else this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,z.identifier.id),T.push(z)}));const x=[];for(const z of S)d.some(H=>(0,A.areSameExtensions)(H,z.identifier))||x.push(z);for(const z of T)x.some(H=>(0,A.areSameExtensions)(H.identifier,z.identifier))||x.push(z);return x}updateExtensionState(c,l,f,S){const d=t(l,f,this.storageService),T=S?this.extensionsStorageSyncService.getKeysForSync({id:(0,A.getGalleryExtensionId)(l,f),version:S}):void 0;T?T.forEach(O=>{d[O]=c[O]}):Object.keys(c).forEach(O=>d[O]=c[O]),r(l,f,d,this.storageService)}parseExtensions(c){return JSON.parse(c.content)}getLocalExtensions(c){const l=this.extensionEnablementService.getDisabledExtensions();return c.map(({identifier:f,isBuiltin:S,manifest:d})=>{const T={identifier:f,version:d.version};l.some(O=>(0,A.areSameExtensions)(O,f))&&(T.disabled=!0),S||(T.installed=!0);try{const O=this.extensionsStorageSyncService.getKeysForSync({id:f.id,version:d.version});if(O){const x=t(d.publisher,d.name,this.storageService);T.state=Object.keys(x).reduce((z,H)=>(O.includes(H)&&(z[H]=x[H]),z),{})}}catch(O){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(O))}return T})}};i.EXTENSIONS_DATA_URI=g.URI.from({scheme:E.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([Y(0,L.IEnvironmentService),Y(1,P.IFileService),Y(2,C.IStorageService),Y(3,E.IUserDataSyncStoreService),Y(4,E.IUserDataSyncBackupStoreService),Y(5,k.IExtensionManagementService),Y(6,k.IGlobalExtensionEnablementService),Y(7,b.IIgnoredExtensionsManagementService),Y(8,E.IUserDataSyncLogService),Y(9,k.IExtensionGalleryService),Y(10,p.IConfigurationService),Y(11,E.IUserDataSyncResourceEnablementService),Y(12,w.ITelemetryService),Y(13,v.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let s=class extends n.AbstractInitializer{constructor(c,l,f,S,d){super("extensions",S,d,f);this.extensionManagementService=c,this.ignoredExtensionsManagementService=l}async parseExtensions(c){return c.syncData?await a(c.syncData,this.extensionManagementService):null}generatePreview(c,l){const f=[],S=[],d=[];for(const T of c){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(T.identifier.id))continue;const O=l.find(x=>(0,A.areSameExtensions)(x.identifier,T.identifier));O?(f.push(O),T.disabled&&d.push(T.identifier)):T.installed&&(S.push(T.identifier),T.disabled&&d.push(T.identifier))}return{installedExtensions:f,newExtensions:S,disabledExtensions:d,remoteExtensions:c}}};s=de([Y(0,k.IExtensionManagementService),Y(1,b.IIgnoredExtensionsManagementService),Y(2,P.IFileService),Y(3,L.IEnvironmentService),Y(4,E.IUserDataSyncLogService)],s),e.AbstractExtensionsInitializer=s}),define(Z[200],ee([0,1,26,22]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(P,p,y,n,w){if(!p)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const g=k(P,p);if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const m=y?k(y,p):{added:Object.keys(p).reduce((D,v)=>(D.add(v),D),new Set),removed:new Set,updated:new Set},u=y?k(y,P):{added:Object.keys(P).reduce((D,v)=>(D.add(v),D),new Set),removed:new Set,updated:new Set},I={added:{},removed:[],updated:{}},C=E.deepClone(p),b=!y;for(const D of u.added.values())D!==R.SYNC_SERVICE_URL_TYPE&&b&&m.added.has(D)||(C[D]=P[D]);for(const D of u.updated.values())C[D]=P[D];for(const D of u.removed.values())n.unregistered.includes(D)||delete C[D];for(const D of m.added.values()){const v=p[D];if(n.machine.includes(D)){w.info(`GlobalState: Skipped adding ${D} in local storage because it is declared as machine scoped.`);continue}if(y&&u.added.has(D))continue;const o=P[D];o&&o.value===v.value||D===R.SYNC_SERVICE_URL_TYPE&&b&&u.added.has(D)||(o?I.updated[D]=v:I.added[D]=v)}for(const D of m.updated.values()){const v=p[D];if(n.machine.includes(D)){w.info(`GlobalState: Skipped updating ${D} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(D)||u.removed.has(D))continue;const o=P[D];o&&o.value===v.value||(I.updated[D]=v)}for(const D of m.removed.values()){if(n.machine.includes(D)){w.trace(`GlobalState: Skipped removing ${D} in local storage because it is declared as machine scoped.`);continue}u.updated.has(D)||u.removed.has(D)||I.removed.push(D)}return{local:I,remote:A(C,p)?null:C}}e.merge=L;function k(P,p){const y=Object.keys(P),n=Object.keys(p),w=n.filter(u=>y.indexOf(u)===-1).reduce((u,I)=>(u.add(I),u),new Set),g=y.filter(u=>n.indexOf(u)===-1).reduce((u,I)=>(u.add(I),u),new Set),m=new Set;for(const u of y){if(g.has(u))continue;const I=P[u],C=p[u];E.equals(I,C)||m.add(u)}return{added:w,removed:g,updated:m}}function A(P,p){const{added:y,removed:n,updated:w}=k(P,p);return y.size===0&&n.size===0&&w.size===0}}),define(Z[201],ee([0,1,22,25,3,12,13,54,200,33,46,21,24,5,47,43,20,4,45,30,14]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I,C,b,D,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const a="globalState.argv.",t=["locale"];function r(l){const f=l.storage?Object.keys(l.storage).sort():[],S={};f.forEach(O=>S[O]=l.storage[O]),l.storage=S;const d=JSON.stringify(l),T=(0,u.format)(d,void 0,{});return(0,I.applyEdits)(d,T)}const i=1;let s=class ot extends n.AbstractSynchroniser{constructor(f,S,d,T,O,x,z,H,V){super("globalState",f,O,V,S,d,x,z,T,H);this.storageService=V,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(f.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(f.onDidFilesChange,U=>U.contains(this.environmentService.argvResource)),L.Event.filter(V.onDidChangeValue,U=>U.scope===0&&U.target!==void 0?U.target===0:V.keys(0,0).includes(U.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(f,S,d,T){const O=f.syncData?JSON.parse(f.syncData.content):null;S=S===null&&d?f:S;const x=S&&S.syncData?JSON.parse(S.syncData.content):null,z=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=this.getStorageKeys(x),{local:V,remote:U}=(0,p.merge)(z.storage,O?O.storage:null,x?x.storage:null,H,this.logService),$={content:null,local:V,remote:U,localChange:Object.keys(V.added).length>0||Object.keys(V.updated).length>0||V.removed.length>0?2:0,remoteChange:U!==null?2:0};return[{localResource:this.localResource,localContent:r(z),localUserData:z,remoteResource:this.remoteResource,remoteContent:O?r(O):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource,storageKeys:H}]}async getMergeResult(f,S){return{...f.previewResult,hasConflicts:!1}}async getAcceptResult(f,S,d,T){if(this.extUri.isEqual(S,this.localResource))return this.acceptLocal(f);if(this.extUri.isEqual(S,this.remoteResource))return this.acceptRemote(f);if(this.extUri.isEqual(S,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${S.toString()}`)}async acceptLocal(f){return{content:f.localContent,local:{added:{},removed:[],updated:{}},remote:f.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(f){if(f.remoteContent!==null){const S=JSON.parse(f.remoteContent),{local:d,remote:T}=(0,p.merge)(f.localUserData.storage,S.storage,null,f.storageKeys,this.logService);return{content:f.remoteContent,local:d,remote:T,localChange:Object.keys(d.added).length>0||Object.keys(d.updated).length>0||d.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:f.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(f,S,d,T){let{localUserData:O}=d[0][0],{local:x,remote:z,localChange:H,remoteChange:V}=d[0][1];if(H===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),H!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(O)),await this.writeLocalGlobalState(x),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),V!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:z});f=await this.updateRemoteUserData(U,T?null:f.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}S?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:f}){return[{resource:this.extUri.joinPath(f,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(f){if(this.extUri.isEqual(f,ot.GLOBAL_STATE_DATA_URI)){const d=await this.getLocalGlobalState();return r(d)}if(this.extUri.isEqual(this.remoteResource,f)||this.extUri.isEqual(this.localResource,f)||this.extUri.isEqual(this.acceptedResource,f))return this.resolvePreviewContent(f);let S=await super.resolveContent(f);if(S)return S;if(S=await super.resolveContent(this.extUri.dirname(f)),S){const d=this.parseSyncData(S);if(d)switch(this.extUri.basename(f)){case"globalState.json":return r(JSON.parse(d.content))}}return null}async hasLocalData(){try{const{storage:f}=await this.getLocalGlobalState();if(Object.keys(f).length>1||f[`${a}.locale`]?.value!=="en")return!0}catch(f){}return!1}async getLocalGlobalState(){const f={},S=await this.getLocalArgvContent(),d=(0,y.parse)(S);for(const T of t)d[T]!==void 0&&(f[`${a}${T}`]={version:1,value:d[T]});for(const T of this.storageService.keys(0,0)){const O=this.storageService.get(T,0);O&&(f[T]={version:1,value:O})}return{storage:f}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(f){}return"{}"}async writeLocalGlobalState({added:f,removed:S,updated:d}){const T={},O={},x=(H,V)=>{for(const U of H){if(U.startsWith(a)){T[U.substring(a.length)]=V?V[U].value:void 0;continue}if(V){const $=V[U];$.value!==String(this.storageService.get(U,0))&&(O[U]=$.value)}else this.storageService.get(U,0)!==void 0&&(O[U]=void 0)}};if(x(Object.keys(f),f),x(Object.keys(d),d),x(S),Object.keys(T).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(T),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(O).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const H of Object.keys(O))this.storageService.store(H,O[H],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(O))}}async updateArgv(f){const S=await this.getLocalArgvContent();let d=S;for(const T of Object.keys(f))d=(0,P.edit)(d,[T],f[T],{});S!==d&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(d)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(f){const S=this.storageService.keys(0,0),d=this.storageService.keys(0,1),T=[...S,...d],O=f?.storage?Object.keys(f.storage).filter(x=>!x.startsWith(a)&&!T.includes(x)&&this.storageService.get(x,0)!==void 0):[];if(!b.isWeb){const x=[...E.ALL_SYNC_RESOURCES.map(z=>(0,E.getEnablementKey)(z)),E.SYNC_SERVICE_URL_TYPE];O.push(...x),d.push(...x)}return{user:S,machine:d,unregistered:O}}};s.GLOBAL_STATE_DATA_URI=m.URI.from({scheme:E.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=de([Y(0,A.IFileService),Y(1,E.IUserDataSyncStoreService),Y(2,E.IUserDataSyncBackupStoreService),Y(3,E.IUserDataSyncLogService),Y(4,k.IEnvironmentService),Y(5,E.IUserDataSyncResourceEnablementService),Y(6,w.ITelemetryService),Y(7,g.IConfigurationService),Y(8,C.IStorageService)],s),e.GlobalStateSynchroniser=s;let h=class extends n.AbstractInitializer{constructor(f,S,d,T){super("globalState",d,T,S);this.storageService=f}async doInitialize(f){const S=f.syncData?JSON.parse(f.syncData.content):null;if(!S){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const d={},T={};for(const O of Object.keys(S.storage))O.startsWith(a)?d[O.substring(a.length)]=S.storage[O].value:this.storageService.get(O,0)===void 0&&(T[O]=S.storage[O].value);if(Object.keys(d).length){let O="{}";try{O=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(x){}for(const x of Object.keys(d))O=(0,P.edit)(O,[x],d[x],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(O))}if(Object.keys(T).length)for(const O of Object.keys(T))this.storageService.store(O,T[O],0,0)}};h=de([Y(0,C.IStorageService),Y(1,A.IFileService),Y(2,k.IEnvironmentService),Y(3,E.IUserDataSyncLogService)],h),e.GlobalStateInitializer=h;let c=class{constructor(f,S,d,T,O){this.userDataSyncStoreClient=f,this.storageService=S,this.environmentService=d,this.fileService=T,this.logService=O}getSyncStoreType(f){return this.parseGlobalState(f)?.storage[E.SYNC_SERVICE_URL_TYPE]?.value}async sync(f){const S=(0,E.createSyncHeaders)((0,v.generateUuid)());try{return await this.doSync(f,S)}catch(d){if(d instanceof E.UserDataSyncError)switch(d.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(f,S)}throw d}}async doSync(f,S){const d=await this.userDataSyncStoreClient.read("globalState",null,S),T=this.parseGlobalState(d)||{storage:{}};T.storage[E.SYNC_SERVICE_URL_TYPE]={value:f,version:i};const O=await(0,D.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),x={version:i,machineId:O,content:r(T)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(x),d.ref,S)}parseGlobalState({content:f}){if(!f)return null;const S=JSON.parse(f);if((0,n.isSyncData)(S))return S?JSON.parse(S.content):null;throw new Error("Invalid remote data")}};c=de([Y(1,C.IStorageService),Y(2,k.IEnvironmentService),Y(3,A.IFileService),Y(4,o.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(Z[202],ee([0,1,13,22,197,33,129,12,24,4,16,23,46,21,20,25,3]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(o,a){const t=JSON.parse(o);if(!a)return(0,n.isUndefined)(t.all)?null:t.all;switch(y.OS){case 2:return(0,n.isUndefined)(t.mac)?null:t.mac;case 3:return(0,n.isUndefined)(t.linux)?null:t.linux;case 1:return(0,n.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=b;let D=class extends g.AbstractJsonFileSynchroniser{constructor(a,t,r,i,s,h,c,l,f,S){super(c.keybindingsResource,"keybindings",h,c,l,a,t,s,S,r,f,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(C.Event.filter(i.onDidChangeConfiguration,d=>d.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(a,t,r,i){const s=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;t=t===null&&r?a:t;const h=t?this.getKeybindingsContentFromLastSyncUserData(t):null,c=await this.getLocalFileContent(),l=await this.getFormattingOptions();let f=null,S=!1,d=!1,T=!1;if(s){let x=c?c.value.toString():"[]";if(x=x||"[]",this.hasErrors(x))throw new R.UserDataSyncError((0,A.localize)(0,null),"LocalInvalidContent",this.resource);if(!h||h!==x||h!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await(0,L.merge)(x,s,h,l,this.userDataSyncUtilService);z.hasChanges&&(f=z.mergeContent,T=z.hasConflicts,S=T||z.mergeContent!==x,d=T||z.mergeContent!==s)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=c.value.toString(),d=!0);const O={content:f,localChange:S?c?2:1:0,remoteChange:d?2:0,hasConflicts:T};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(a,t){return a.previewResult}async getAcceptResult(a,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(a,t,r,i){const{fileContent:s}=r[0][0];let{content:h,localChange:c,remoteChange:l}=r[0][1];if(c===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),h!==null&&(h=h.trim(),h=h||"[]",this.hasErrors(h)))throw new R.UserDataSyncError((0,A.localize)(1,null),"LocalInvalidContent",this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(h||"[]",s,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),l!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const f=this.toSyncContent(h||"[]",a.syncData?.content);a=await this.updateRemoteUserData(f,i?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(f){}t?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(a,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const t=(0,k.parse)(a.value.toString());if((0,w.isNonEmptyArray)(t))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"keybindings.json"),comparableResource:t}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let t=await super.resolveContent(a);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(a)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(a)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(a.syncData.content)}getKeybindingsContentFromSyncContent(a){try{return b(a,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(a,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=a,y.OS){case 2:r.mac=a;break;case 3:r.linux=a;break;case 1:r.windows=a;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let a=!!this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return a!==void 0||(a=!!this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,a!==void 0)?a:!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};D=de([Y(0,R.IUserDataSyncStoreService),Y(1,R.IUserDataSyncBackupStoreService),Y(2,R.IUserDataSyncLogService),Y(3,p.IConfigurationService),Y(4,R.IUserDataSyncResourceEnablementService),Y(5,E.IFileService),Y(6,P.IEnvironmentService),Y(7,u.IStorageService),Y(8,R.IUserDataSyncUtilService),Y(9,m.ITelemetryService)],D),e.KeybindingsSynchroniser=D;let v=class extends g.AbstractInitializer{constructor(a,t,r){super("keybindings",t,r,a)}async doInitialize(a){const t=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,I.VSBuffer.fromString(t)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,k.parse)(a.value.toString());return!(0,w.isNonEmptyArray)(t)}catch(a){return a.fileOperationResult===1}}getKeybindingsContentFromSyncContent(a){try{return b(a,!0)}catch(t){return this.logService.error(t),null}}};v=de([Y(0,E.IFileService),Y(1,P.IEnvironmentService),Y(2,R.IUserDataSyncLogService)],v),e.KeybindingsInitializer=v}),define(Z[203],ee([0,1,26,33,43,47,54,22,23]),function(K,e,E,R,L,k,A,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function y(c,l,f){let S=[];f?S=w(f):S=n(l);const d=[],T=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(S))for(const O of S)O.startsWith("-")?T.push(O.substring(1)):d.push(O);return(0,p.distinct)([...c,...d].filter(O=>T.indexOf(O)===-1))}e.getIgnoredSettings=y;function n(c){let l=c.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=c.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:c.getValue("settingsSync.ignoredSettings")||[]}function w(c){const l=(0,R.parse)(c);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function g(c,l,f,S){if(f.length){const d=h(l),T=(0,R.parse)(l),O=(0,R.parse)(c),x=[];for(const z of f){const H=T[z],V=O[z];H===void 0?c=A.edit(c,[z],void 0,S):V!==void 0?c=A.edit(c,[z],H,S):x.push(a(z,d))}x.sort((z,H)=>z.startOffset-H.startOffset),x.forEach(z=>c=b(z.setting.key,l,c,S))}return c}e.updateIgnoredSettings=g;function m(c,l,f,S,d,T){const O=g(c,l,S,T),x=f!==O,z=f!==l;if(!x&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(x&&!z)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(z&&!x)return{conflictsSettings:[],localContent:g(l,c,S,T),remoteContent:null,hasConflicts:!1};if(f===null&&I(c)){const ne=u(c,l,S)?null:g(l,c,S,T);return{conflictsSettings:[],localContent:ne,remoteContent:null,hasConflicts:!1}}let H=c,V=l;const U=(0,R.parse)(c),$=(0,R.parse)(l),M=f?(0,R.parse)(f):null,N=S.reduce((ne,le)=>(ne.add(le),ne),new Set),q=C(U,$,N),F=C(M,U,N),j=C(M,$,N),_=new Map,G=new Set,B=ne=>{G.add(ne);const le=d.filter(({key:fe})=>fe===ne)[0];le?(H=A.edit(H,[ne],le.value,T),V=A.edit(V,[ne],le.value,T)):_.set(ne,{key:ne,localValue:U[ne],remoteValue:$[ne]})};for(const ne of F.removed.values())j.updated.has(ne)?B(ne):V=A.edit(V,[ne],void 0,T);for(const ne of j.removed.values())G.has(ne)||(F.updated.has(ne)?B(ne):H=A.edit(H,[ne],void 0,T));for(const ne of F.updated.values())G.has(ne)||(j.updated.has(ne)?q.updated.has(ne)&&B(ne):V=A.edit(V,[ne],U[ne],T));for(const ne of j.updated.values())G.has(ne)||(F.updated.has(ne)?q.updated.has(ne)&&B(ne):H=A.edit(H,[ne],$[ne],T));for(const ne of F.added.values())G.has(ne)||(j.added.has(ne)?q.updated.has(ne)&&B(ne):V=b(ne,H,V,T));for(const ne of j.added.values())G.has(ne)||(F.added.has(ne)?q.updated.has(ne)&&B(ne):H=b(ne,V,H,T));const X=_.size>0||!u(H,V,S),Q=X||!u(H,c,[]),ie=X||!u(V,l,[]);return{localContent:Q?H:null,remoteContent:ie?V:null,conflictsSettings:[..._.values()],hasConflicts:X}}e.merge=m;function u(c,l,f){if(c===l)return!0;const S=(0,R.parse)(c),d=(0,R.parse)(l),T=f.reduce((z,H)=>(z.add(H),z),new Set),O=h(c).filter(z=>!(z.setting&&T.has(z.setting.key))),x=h(l).filter(z=>!(z.setting&&T.has(z.setting.key)));if(O.length!==x.length)return!1;for(let z=0;z<O.length;z++){const H=O[z],V=x[z];if(H.setting&&V.setting){if(H.setting.key!==V.setting.key||!E.equals(S[H.setting.key],d[H.setting.key]))return!1}else if(!H.setting&&!V.setting){if(H.value!==V.value)return!1}else return!1}return!0}e.areSame=u;function I(c){return c?h(c).length===0:!0}e.isEmpty=I;function C(c,l,f){const S=c?Object.keys(c).filter(z=>!f.has(z)):[],d=Object.keys(l).filter(z=>!f.has(z)),T=d.filter(z=>S.indexOf(z)===-1).reduce((z,H)=>(z.add(H),z),new Set),O=S.filter(z=>d.indexOf(z)===-1).reduce((z,H)=>(z.add(H),z),new Set),x=new Set;if(c)for(const z of S){if(O.has(z))continue;const H=c[z],V=l[z];E.equals(H,V)||x.add(z)}return{added:T,removed:O,updated:x}}function b(c,l,f,S){const d=(0,R.parse)(l),T=h(l),O=h(f),x=D(c,T,O);return v(f,c,d[c],x,O,S)}e.addSetting=b;function D(c,l,f){const S=l.findIndex(T=>T.setting?.key===c),d=l[S-1];if(d){if(d.setting){const O=a(d.setting.key,f);if(O)return{index:f.indexOf(O),insertAfter:!0}}else{const O=t(S,l);if(O){const x=a(O.setting.key,f);if(x){const z=r(f.indexOf(x),f),H=i(l,O,l[S]);if(z){const V=i(f,x,z),U=s(H,V);return U?{index:f.indexOf(U),insertAfter:!0}:{index:f.indexOf(z),insertAfter:!1}}else{const V=i(f,x,f[f.length-1]),U=s(H,V);return U?{index:f.indexOf(U),insertAfter:!0}:{index:f.length-1,insertAfter:!0}}}}}const T=l[S+1];if(T)if(T.setting){const O=a(T.setting.key,f);if(O)return{index:f.indexOf(O),insertAfter:!1}}else{const O=r(S,l);if(O){const x=a(O.setting.key,f);if(x){const z=t(f.indexOf(x),f),H=i(l,l[S],O);if(z){const V=i(f,z,x),U=s(H.reverse(),V.reverse());return U?{index:f.indexOf(U),insertAfter:!1}:{index:f.indexOf(z),insertAfter:!0}}else{const V=i(f,f[0],x),U=s(H.reverse(),V.reverse());return U?{index:f.indexOf(U),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:f.length-1,insertAfter:!0}}function v(c,l,f,S,d,T){let O;return S.index===-1?O=(0,L.setProperty)(c,[l],f,T):O=o(c,l,f,S,d,T).map(x=>(0,L.withFormatting)(c,x,T)[0]),(0,L.applyEdits)(c,O)}function o(c,l,f,S,d,T){const O=`${JSON.stringify(l)}: ${JSON.stringify(f)}`,x=(0,k.getEOL)(T,c),z=d[S.index];if(S.insertAfter){const H=[];if(z.setting)H.push({offset:z.endOffset,length:0,content:","+O});else{const V=r(S.index,d),U=t(S.index,d),$=U?.setting?.commaOffset;U&&$===void 0&&H.push({offset:U.endOffset,length:0,content:","});const M=$!==void 0&&$>z.endOffset;H.push({offset:M?$+1:z.endOffset,length:0,content:V?x+O+",":x+O})}return H}else{if(z.setting)return[{offset:z.startOffset,length:0,content:O+","}];const H=(d[S.index-1]&&!d[S.index-1].setting?x:"")+O+(r(S.index,d)?",":"")+x;return[{offset:z.startOffset,length:0,content:H}]}}function a(c,l){return l.filter(f=>f.setting?.key===c)[0]}function t(c,l){for(let f=c-1;f>=0;f--)if(l[f].setting)return l[f]}function r(c,l){for(let f=c+1;f<l.length;f++)if(l[f].setting)return l[f]}function i(c,l,f){const S=c.indexOf(l),d=c.indexOf(f);return c.filter((T,O)=>S<O&&O<d)}function s(c,l){if(c.length&&l.length){let f=0;for(;f<l.length&&f<c.length;f++)if(c[f].value!==l[f].value)return l[f-1];return l[f-1]}}function h(c){const l=[];let f=-1,S,d;const T={onObjectBegin:O=>{f++},onObjectProperty:(O,x,z)=>{f===0&&(S=x,d=O)},onObjectEnd:(O,x)=>{f--,f===0&&l.push({startOffset:S,endOffset:O+x,value:c.substring(S,O+x),setting:{key:d,commaOffset:void 0}})},onArrayBegin:(O,x)=>{f++},onArrayEnd:(O,x)=>{f--,f===0&&l.push({startOffset:S,endOffset:O+x,value:c.substring(S,O+x),setting:{key:d,commaOffset:void 0}})},onLiteralValue:(O,x,z)=>{f===0&&l.push({startOffset:S,endOffset:x+z,value:c.substring(S,x+z),setting:{key:d,commaOffset:void 0}})},onSeparator:(O,x,z)=>{if(f===0&&O===","){let H=l.length-1;for(;H>=0&&!l[H].setting;H--);const V=l[H];V&&l.splice(H,1,{startOffset:V.startOffset,endOffset:V.endOffset,value:V.value,setting:{key:V.setting.key,commaOffset:x}})}},onComment:(O,x)=>{f===0&&l.push({startOffset:O,endOffset:O+x,value:c.substring(O,O+x)})}};return(0,R.visit)(c,T),l}}),define(Z[204],ee([0,1,13,22,25,130,3,12,24,203,54,46,21,27,20,43]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function C(a){return a&&a.settings&&typeof a.settings=="string"&&Object.keys(a).length===1}function b(a){const t=JSON.parse(a);return C(t)?t:{settings:a}}e.parseSettingsSyncContent=b;let D=class extends w.AbstractJsonFileSynchroniser{constructor(t,r,i,s,h,c,l,f,S,d,T){super(r.settingsResource,"settings",t,r,i,s,h,S,d,c,l,f);this.extensionManagementService=T,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i,s){const h=await this.getLocalFileContent(),c=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t);r=r===null&&i?t:r;const f=r?this.getSettingsSyncContent(r):null,S=await this.getIgnoredSettings();let d=null,T=!1,O=!1,x=!1;if(l){let H=h?h.value.toString().trim():"{}";H=H||"{}",this.validateContent(H),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const V=(0,y.merge)(H,l.settings,f?f.settings:null,S,[],c);d=V.localContent||V.remoteContent,T=V.localContent!==null,O=V.remoteContent!==null,x=V.hasConflicts}else h&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),d=h.value.toString(),O=!0);const z={content:d,localChange:T?2:0,remoteChange:O?2:0,hasConflicts:x};return[{fileContent:h,localResource:this.localResource,localContent:h?h.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,y.updateIgnoredSettings)(t.previewResult.content,"{}",s,i):null}}async getAcceptResult(t,r,i,s){const h=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,y.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",c,h):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,y.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",c,h):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?(0,y.updateIgnoredSettings)(i,t.fileContent?t.fileContent.value.toString():"{}",c,h):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,s){const{fileContent:h}=i[0][0];let{content:c,localChange:l,remoteChange:f}=i[0][1];if(l===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),h&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(h.value.toString()))),await this.updateLocalFileContent(c,h,s),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),f!==0){const S=await this.getFormattingOptions(),d=this.getSettingsSyncContent(t),T=await this.getIgnoredSettings(c);c=(0,y.updateIgnoredSettings)(c,d?d.settings:"{}",T,S),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),s?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(S){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=(0,n.edit)(t.value.toString(),[R.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,y.isEmpty)(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const s=this.parseSettingsSyncContent(i.content);if(s)switch(this.extUri.basename(t)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),s=await this.getIgnoredSettings();r=(0,y.updateIgnoredSettings)(r,"{}",s,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:h})=>!!h)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,y.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new R.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!o(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let s=i.settings;const h=await this.getFormattingOptions();for(const c in r)if(["version","content","machineId"].indexOf(c)===-1&&r[c]!==void 0){const l=(0,I.setProperty)(s,[c],r[c],h);l.length&&(s=(0,I.applyEdits)(s,l))}await this.fileService.writeFile(this.file,L.VSBuffer.fromString(s))}catch(t){}}};D=de([Y(0,E.IFileService),Y(1,P.IEnvironmentService),Y(2,u.IStorageService),Y(3,R.IUserDataSyncStoreService),Y(4,R.IUserDataSyncBackupStoreService),Y(5,R.IUserDataSyncLogService),Y(6,R.IUserDataSyncUtilService),Y(7,p.IConfigurationService),Y(8,R.IUserDataSyncResourceEnablementService),Y(9,g.ITelemetryService),Y(10,m.IExtensionManagementService)],D),e.SettingsSynchroniser=D;let v=class extends w.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,y.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}};v=de([Y(0,E.IFileService),Y(1,P.IEnvironmentService),Y(2,R.IUserDataSyncLogService)],v),e.SettingsInitializer=v;function o(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&a.machineId!==void 0&&typeof a.machineId=="string")}}),define(Z[205],ee([0,1,22,12,13,24,46,21,25,198,20,26,3]),function(K,e,E,R,L,k,A,P,p,y,n,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let m=class extends A.AbstractSynchroniser{constructor(C,b,D,v,o,a,t,r,i){super("snippets",b,C,D,v,o,r,i,a,t);this.version=1,this.snippetsFolder=C.snippetsHome,this._register(this.fileService.watch(C.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(g.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(C,b,D,v){const o=await this.getSnippetsFileContents(),a=this.toSnippetsContents(o),t=C.syncData?this.parseSnippets(C.syncData):null;b=b===null&&D?C:b;const r=b&&b.syncData?this.parseSnippets(b.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,y.merge)(a,t,r);return this.getResourcePreviews(i,o,t||{})}async getMergeResult(C,b){return C.previewResult}async getAcceptResult(C,b,D,v){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:C.fileContent?C.fileContent.value.toString():null,localChange:0,remoteChange:C.fileContent?C.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:C.remoteContent,localChange:C.remoteContent!==null?C.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return D===void 0?{content:C.previewResult.content,localChange:C.previewResult.localChange,remoteChange:C.previewResult.remoteChange}:{content:D,localChange:D===null?C.fileContent!==null?3:0:2,remoteChange:D===null?C.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(C,b,D,v){const o=D.map(([a,t])=>({...a,acceptResult:t}));o.every(({localChange:a,remoteChange:t})=>a===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:a})=>a!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,v)),o.some(({remoteChange:a})=>a!==0)&&(C=await this.updateRemoteSnippets(o,C,v)),b?.ref!==C.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(C),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:a}of o)try{await this.fileService.del(a)}catch(t){}}getResourcePreviews(C,b,D){const v=new Map;for(const o of Object.keys(C.local.added)){const a={content:C.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};v.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(C.local.updated)){const a={content:C.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o],localContent:b[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of C.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o],localContent:b[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(C.remote.added)){const a={content:C.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o],localContent:b[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(C.remote.updated)){const a={content:C.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o],localContent:b[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of C.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of C.conflicts){const a={content:b[o]?b[o].value.toString():null,hasConflicts:!0,localChange:b[o]?2:1,remoteChange:D[o]?2:1};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o]||null,localContent:b[o]?b[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(b))if(!v.has(o)){const a={content:b[o]?b[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[o]||null,localContent:b[o]?b[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...v.values()]}async getAssociatedResources({uri:C}){let b=await super.resolveContent(C);if(b){const D=this.parseSyncData(b);if(D){const v=this.parseSnippets(D),o=[];for(const a of Object.keys(v)){const t=this.extUri.joinPath(C,a),r=this.extUri.joinPath(this.snippetsFolder,a),i=await this.fileService.exists(r);o.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(C){if(this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(C);let b=await super.resolveContent(C);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(C)),b){const D=this.parseSyncData(b);if(D)return this.parseSnippets(D)[this.extUri.basename(C)]||null}return null}async hasLocalData(){try{const C=await this.getSnippetsFileContents();if(Object.keys(C).length)return!0}catch(C){}return!1}async updateLocalBackup(C){const b={};for(const D of C)D.fileContent&&(b[this.extUri.basename(D.localResource)]=D.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(C,b){for(const{fileContent:D,acceptResult:v,localResource:o,remoteResource:a,localChange:t}of C)if(t!==0){const r=a?this.extUri.basename(a):this.extUri.basename(o),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,p.VSBuffer.fromString(v.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,p.VSBuffer.fromString(v.content),b?void 0:D),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(C,b,D){const v=b.syncData?this.parseSnippets(b.syncData):{},o=(0,w.deepClone)(v);for(const{acceptResult:a,localResource:t,remoteResource:r,remoteChange:i}of C)if(i!==0){const s=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete o[s]:o[s]=a.content}return(0,y.areSame)(v,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(o),D?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(C){return JSON.parse(C.content)}toSnippetsContents(C){const b={};for(const D of Object.keys(C))b[D]=C[D].value.toString();return b}async getSnippetsFileContents(){const C={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(D){if(D instanceof L.FileOperationError&&D.fileOperationResult===1)return C;throw D}for(const D of b.children||[]){const v=D.resource,o=this.extUri.extname(v);if(o===".json"||o===".code-snippets"){const a=this.extUri.relativePath(this.snippetsFolder,v),t=await this.fileService.readFile(v);C[a]=t}}return C}};m=de([Y(0,R.IEnvironmentService),Y(1,L.IFileService),Y(2,n.IStorageService),Y(3,E.IUserDataSyncStoreService),Y(4,E.IUserDataSyncBackupStoreService),Y(5,E.IUserDataSyncLogService),Y(6,k.IConfigurationService),Y(7,E.IUserDataSyncResourceEnablementService),Y(8,P.ITelemetryService)],m),e.SnippetsSynchroniser=m;let u=class extends A.AbstractInitializer{constructor(C,b,D){super("snippets",b,D,C)}async doInitialize(C){const b=C.syncData?JSON.parse(C.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const v of Object.keys(b)){const o=b[v];if(o){const a=this.extUri.joinPath(this.environmentService.snippetsHome,v);await this.fileService.createFile(a,p.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(a))}}await this.updateLastSyncUserData(C)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(C){return C.fileOperationResult===1}}};u=de([Y(0,L.IFileService),Y(1,R.IEnvironmentService),Y(2,E.IUserDataSyncLogService)],u),e.SnippetsInitializer=u}),define(Z[60],ee([0,1,7,3,2,22]),function(K,e,E,R,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,E.createDecorator)("IUserDataSyncAccountService");let A=class extends L.Disposable{constructor(p){super();this.userDataSyncStoreService=p,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(p.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(p.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(p){(p&&this._account?p.token!==this._account.token||p.authenticationProviderId!==this._account.authenticationProviderId:p!==this._account)&&(this._account=p,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(p))}};A=de([Y(0,k.IUserDataSyncStoreService)],A),e.UserDataSyncAccountService=A}),define(Z[206],ee([0,1,2,22,15,24,13,12,56,25,6]),function(K,e,E,R,L,k,A,P,p,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let w=class extends E.Disposable{constructor(m,u,I,C){super();this.environmentService=m,this.fileService=u,this.configurationService=I,this.logService=C,R.ALL_SYNC_RESOURCES.forEach(b=>this.cleanUpBackup(b))}async getAllRefs(m){const u=(0,L.joinPath)(this.environmentService.userDataSyncHome,m),I=await this.fileService.resolve(u);return I.children?I.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.getCreationTime(b)})):[]}async resolveContent(m,u){if(!u){const I=await this.getAllRefs(m);I.length&&(u=I[I.length-1].ref)}if(u){const I=(0,L.joinPath)(this.environmentService.userDataSyncHome,m,u);return(await this.fileService.readFile(I)).value.toString()}return null}async backup(m,u){const I=(0,L.joinPath)(this.environmentService.userDataSyncHome,m),C=(0,L.joinPath)(I,`${(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(C,y.VSBuffer.fromString(u))}catch(b){this.logService.error(b)}try{this.cleanUpBackup(m)}catch(b){}}async cleanUpBackup(m){const u=(0,L.joinPath)(this.environmentService.userDataSyncHome,m);try{try{if(!await this.fileService.exists(u))return}catch(C){return}const I=await this.fileService.resolve(u);if(I.children){const C=I.children.filter(o=>o.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(o.name)).sort(),b=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let D=C.filter(o=>Date.now()-this.getCreationTime(o)>b);const v=C.length-D.length;v<10&&(D=D.slice(10-v)),await n.Promises.settled(D.map(async o=>{this.logService.info("Deleting from backup",o.resource.path),await this.fileService.del(o.resource)}))}}catch(I){this.logService.error(I)}}getCreationTime(m){return m.ctime||new Date(parseInt(m.name.substring(0,4)),parseInt(m.name.substring(4,6))-1,parseInt(m.name.substring(6,8)),parseInt(m.name.substring(9,11)),parseInt(m.name.substring(11,13)),parseInt(m.name.substring(13,15))).getTime()}};w=de([Y(0,P.IEnvironmentService),Y(1,A.IFileService),Y(2,k.IConfigurationService),Y(3,R.IUserDataSyncLogService)],w),e.UserDataSyncBackupStoreService=w}),define(Z[207],ee([0,1,5,2]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(g){this.service=g}listen(g,m){switch(m){case"onError":return this.service.onError}throw new Error(`Event not found: ${m}`)}call(g,m,u){switch(m){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class k{constructor(g){this.service=g}listen(g,m){throw new Error(`Event not found: ${m}`)}call(g,m,u){switch(m){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(E.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class A{constructor(g){this.channel=g}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.channel.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.channel.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=A;class P{constructor(g){this.service=g}listen(g,m){switch(m){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${m}`)}async call(g,m,u){switch(m){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class p{constructor(g){this.service=g}listen(g,m){switch(m){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${m}`)}call(g,m,u){switch(m){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=p;class y{constructor(g){this.service=g}listen(g,m){switch(m){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${m}`)}call(g,m,u){switch(m){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=y;class n extends R.Disposable{constructor(g){super();this.channel=g,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.channel.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(g)}revive(g){return{url:E.URI.revive(g.url),type:g.type,defaultUrl:E.URI.revive(g.defaultUrl),insidersUrl:E.URI.revive(g.insidersUrl),stableUrl:E.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(Z[208],ee([0,1,14,12]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends E.AbstractLogger{constructor(A,P){super();this.logger=this._register(A.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}critical(A,...P){this.logger.critical(A,...P)}flush(){this.logger.flush()}};L=de([Y(0,E.ILoggerService),Y(1,R.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(Z[61],ee([0,1,7,2,45,12,13,20,22,133,28,4,19,3]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName";let I=class Ke extends R.Disposable{constructor(b,D,v,o,a,t){super();this.storageService=v,this.userDataSyncStoreService=o,this.logService=a,this.productService=t,this._onDidChange=this._register(new m.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,L.getServiceMachineId)(b,D,v)}async getMachines(b){const D=await this.currentMachineIdPromise;return(await this.readMachinesData(b)).machines.map(o=>({...o,isCurrent:o.id===D}))}async addCurrentMachine(b){const D=await this.currentMachineIdPromise,v=await this.readMachinesData(b);v.machines.some(({id:o})=>o===D)||(v.machines.push({id:D,name:this.computeCurrentMachineName(v.machines)}),await this.writeMachinesData(v))}async removeCurrentMachine(b){const D=await this.currentMachineIdPromise,v=await this.readMachinesData(b),o=v.machines.filter(({id:a})=>a!==D);o.length!==v.machines.length&&(v.machines=o,await this.writeMachinesData(v))}async renameMachine(b,D,v){const o=await this.currentMachineIdPromise,a=await this.readMachinesData(v),t=a.machines.find(({id:r})=>r===b);t&&(t.name=D,await this.writeMachinesData(a),a.machines.some(({id:r})=>r===o)&&this.storageService.store(u,D,0,1))}async setEnablement(b,D){const v=await this.readMachinesData(),o=v.machines.find(({id:a})=>a===b);o&&(o.disabled=D?void 0:!0,await this.writeMachinesData(v))}computeCurrentMachineName(b){const D=this.storageService.get(u,0);if(D)return D;const v=`${this.productService.nameLong} (${(0,w.PlatformToString)(w.isWeb?0:w.platform)})`,o=new RegExp(`${(0,g.escapeRegExpCharacters)(v)}\\s#(\\d+)`);let a=0;for(const t of b){const r=o.exec(t.name),i=r?parseInt(r[1]):0;a=i>a?i:a}return`${v} #${a+1}`}async readMachinesData(b){this.userData=await this.readUserData(b);const D=this.parse(this.userData);if(D.version!==Ke.VERSION)throw new Error((0,y.localize)(0,null,this.productService.nameLong));return D}async writeMachinesData(b){const D=JSON.stringify(b),v=await this.userDataSyncStoreService.write(Ke.RESOURCE,D,this.userData?.ref||null);this.userData={ref:v,content:D},this._onDidChange.fire()}async readUserData(b){if(this.userData){const D=b&&b.latest?b.latest[Ke.RESOURCE]:void 0;if(this.userData.ref===D)return this.userData;if(D===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ke.RESOURCE,this.userData)}parse(b){if(b.content!==null)try{return JSON.parse(b.content)}catch(D){this.logService.error(D)}return{version:Ke.VERSION,machines:[]}}};I.VERSION=1,I.RESOURCE="machines",I=de([Y(0,k.IEnvironmentService),Y(1,A.IFileService),Y(2,P.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncLogService),Y(5,n.IProductService)],I),e.UserDataSyncMachinesService=I}),define(Z[89],ee([0,1,6,3,2,22,60,21,11,20,12,61,131,56,5,15,4,28,37]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I,C,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const v="sync.enable",o="sync.disableMachineEventually",a="sync.sessionId",t="sync.storeUrl",r="sync.productQuality";let i=class extends L.Disposable{constructor(l,f,S){super();this.storageService=l,this.environmentService=f,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(l.onDidChangeValue(d=>this.onDidStorageChange(d)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(v,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(l){l&&!this.canToggleEnablement()||this.storageService.store(v,l,0,1)}onDidStorageChange(l){if(l.scope===0&&v===l.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};i=de([Y(0,y.IStorageService),Y(1,n.IEnvironmentService),Y(2,k.IUserDataSyncStoreManagementService)],i),e.UserDataAutoSyncEnablementService=i;let s=class extends L.Disposable{constructor(l,f,S,d,T,O,x,z,H,V,U){super();this.userDataSyncStoreManagementService=f,this.userDataSyncStoreService=S,this.userDataSyncResourceEnablementService=d,this.userDataSyncService=T,this.logService=O,this.userDataSyncAccountService=x,this.telemetryService=z,this.userDataSyncMachinesService=H,this.storageService=V,this.autoSync=this._register(new L.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=U,this.syncTriggerDelayer=this._register(new E.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=f.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=l.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(f.onDidChangeUserDataSyncStore(()=>{(0,I.isEqual)(this.syncUrl,f.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=f.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(x.onDidChangeAccount(()=>this.updateAutoSync())),this._register(S.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(R.Event.debounce(T.onDidChangeLocal,($,M)=>$?[...$,M]:[M],1e3)($=>this.triggerSync($,!1,!1))),this._register(R.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const l=this.storageService.get(t,0);return l?u.URI.parse(l):void 0}set syncUrl(l){l?this.storageService.store(t,l.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(r,0)}set productQuality(l){l?this.storageService.store(r,l,0,1):this.storageService.remove(r,0)}updateAutoSync(){const{enabled:l,message:f}=this.isAutoSyncEnabled();l?this.autoSync.value===void 0&&(this.autoSync.value=new h(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(S=>this.onDidFinishSync(S))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(f&&this.logService.info(f),this.autoSync.clear()):f&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(f))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,m.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(l,f,S){try{this.userDataSyncAccountService.account&&!S&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,0),l?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(d){if(f)this.logService.error(d),this.updateEnablement(!1);else throw d}}updateEnablement(l){this.userDataAutoSyncEnablementService.isEnabled()!==l&&(this.telemetryService.publicLog2(v,{enabled:l}),this.userDataAutoSyncEnablementService.setEnablement(l),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(l){if(!l){this.successiveFailures=0;return}const f=k.UserDataSyncError.toUserDataSyncError(l);f instanceof k.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:f.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),f.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):f.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):f.code==="LocalTooManyRequests"||f.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):f.code==="UpgradeRequired"||f.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):f.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${f.resource} content with newer version than of client. Requires client upgrade.`)):f.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${f.resource} content with older version than of client. Requires server reset.`)):f.code==="ServiceChanged"||f.code==="DefaultServiceChanged"?C.isWeb&&f.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(f),this.successiveFailures++),this._onError.fire(f)}async disableMachineEventually(){this.storageService.store(o,!0,0,1),await(0,E.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(o,0,!1)}stopDisableMachineEventually(){this.storageService.remove(o,0)}async triggerSync(l,f,S){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(f&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...l),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",S)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};s=de([Y(0,b.IProductService),Y(1,k.IUserDataSyncStoreManagementService),Y(2,k.IUserDataSyncStoreService),Y(3,k.IUserDataSyncResourceEnablementService),Y(4,k.IUserDataSyncService),Y(5,k.IUserDataSyncLogService),Y(6,A.IUserDataSyncAccountService),Y(7,P.ITelemetryService),Y(8,w.IUserDataSyncMachinesService),Y(9,y.IStorageService),Y(10,k.IUserDataAutoSyncEnablementService)],s),e.UserDataAutoSyncService=s;class h extends L.Disposable{constructor(l,f,S,d,T,O,x,z){super();this.lastSyncUrl=l,this.interval=f,this.userDataSyncStoreManagementService=S,this.userDataSyncStoreService=d,this.userDataSyncService=T,this.userDataSyncMachinesService=O,this.logService=x,this.storageService=z,this.intervalHandler=this._register(new L.MutableDisposable),this._onDidStartSync=this._register(new R.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new R.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,L.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(h.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,E.disposableTimeout)(()=>this.sync(h.INTERVAL_SYNCING,!1),this.interval)}sync(l,f){const S=(0,E.createCancelablePromise)(async d=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(T){if((0,p.isPromiseCanceledError)(T))return}return this.doSync(l,f,d)});return this.syncPromise=S,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,I.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const l=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),f=this.userDataSyncStoreManagementService.userDataSyncStore;return!!f&&!!l&&(!(0,I.isEqual)(f.defaultUrl,l.defaultUrl)||!(0,I.isEqual)(f.insidersUrl,l.insidersUrl)||!(0,I.isEqual)(f.stableUrl,l.stableUrl))}async doSync(l,f,S){this.logService.info(`Auto Sync: Triggered by ${l}`),this._onDidStartSync.fire();let d;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,f),S.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,g.localize)(0,null),"DefaultServiceChanged"):new k.UserDataAutoSyncError((0,g.localize)(1,null),"ServiceChanged"):new k.UserDataAutoSyncError((0,g.localize)(2,null),"TurnedOff");const T=this.storageService.get(a,0);if(T&&this.manifest&&T!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,g.localize)(3,null),"DefaultServiceChanged"):new k.UserDataAutoSyncError((0,g.localize)(4,null),"ServiceChanged"):new k.UserDataAutoSyncError((0,g.localize)(5,null),"SessionExpired");const O=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(S.isCancellationRequested)return;const x=O.find(z=>z.isCurrent);if(x?.disabled)throw new k.UserDataAutoSyncError((0,g.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(z){throw new k.UserDataAutoSyncError((0,D.toErrorMessage)(z),z instanceof k.UserDataSyncError?z.code:"Unknown")}if(this.manifest&&this.manifest.session!==T&&this.storageService.store(a,this.manifest.session,0,1),S.isCancellationRequested)return;x||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(T){this.logService.error(T),d=T}this._onDidFinishSync.fire(d)}register(l){return super._register(l)}}h.INTERVAL_SYNCING="Interval"}),define(Z[209],ee([0,1,22,2,3,20,21,4]),function(K,e,E,R,L,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let p=class extends R.Disposable{constructor(n,w){super();this.storageService=n,this.telemetryService=w,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(g=>this.onDidStorageChange(g)))}isResourceEnabled(n){return this.storageService.getBoolean((0,E.getEnablementKey)(n),0,!0)}setResourceEnablement(n,w){if(this.isResourceEnabled(n)!==w){const g=(0,E.getEnablementKey)(n);this.telemetryService.publicLog2(g,{enabled:w}),this.storeResourceEnablement(g,w)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,w){this.storageService.store(n,w,0,P.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const w=E.ALL_SYNC_RESOURCES.filter(g=>(0,E.getEnablementKey)(g)===n.key)[0];if(w){this._onDidChangeResourceEnablement.fire([w,this.isResourceEnabled(w)]);return}}}};p=de([Y(0,k.IStorageService),Y(1,A.ITelemetryService)],p),e.UserDataSyncResourceEnablementService=p}),define(Z[210],ee([0,1,22,2,7,3,199,202,201,37,21,23,20,204,15,205,30,6,11]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I,C,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const v="sync.lastSyncTime";let o=class extends R.Disposable{constructor(i,s,h,c,l,f){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=s,this.instantiationService=h,this.logService=c,this.telemetryService=l,this.storageService=f,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(m.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(P.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(I.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(p.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(A.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(S=>k.Event.map(S.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(S=>k.Event.map(S.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(v,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(S=>k.Event.map(S.onDidChangeLocal,()=>S.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i,s){await this.checkEnablement();const h=(0,C.generateUuid)();try{const S=(0,E.createSyncHeaders)(h);s&&(S["Cache-Control"]="no-cache"),i=await this.userDataSyncStoreService.manifest(i,S)}catch(S){const d=E.UserDataSyncError.toUserDataSyncError(S);throw this.reportUserDataSyncError(d,h),d}let c=!1;const l=this;let f;return{manifest:i,run(){if(c)throw new Error("Can run a task only once");return f=(0,b.createCancelablePromise)(S=>l.sync(i,h,S)),f.finally(()=>f=void 0)},async stop(){if(f&&f.cancel(),l.status!=="idle")return l.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=(0,C.generateUuid)(),s=(0,E.createSyncHeaders)(i);let h;try{h=await this.userDataSyncStoreService.manifest(null,s)}catch(c){const l=E.UserDataSyncError.toUserDataSyncError(c);throw this.reportUserDataSyncError(l,i),l}return new a(i,h,s,this.synchronisers,this.logService)}async sync(i,s,h){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),h.isCancellationRequested)return;const c=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const l=(0,E.createSyncHeaders)(s);for(const f of this.synchronisers){if(h.isCancellationRequested)return;try{await f.sync(i,l)}catch(S){let d=!1;if(S instanceof E.UserDataSyncError)switch(S.code){case"TooLarge":S=new E.UserDataSyncError(S.message,S.code,f.resource),d=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":d=!0;break}const T=E.UserDataSyncError.toUserDataSyncError(S);if(this.reportUserDataSyncError(T,s),d)throw T;this.logService.error(S),this.logService.error(`${f.resource}: ${(0,y.toErrorMessage)(S)}`),this._syncErrors.push([f.resource,T])}}this.logService.info(`Sync done. Took ${new Date().getTime()-c}ms`),this.updateLastSyncTime()}catch(l){const f=E.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(f,s),f}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(s){this.logService.error(s)}}async replace(i){await this.checkEnablement();for(const s of this.synchronisers)if(await s.replace(i))return}async accept(i,s,h,c){await this.checkEnablement();const l=this.getSynchroniser(i);await l.accept(s,h),c&&await l.apply(!1,(0,E.createSyncHeaders)((0,C.generateUuid)()))}async resolveContent(i){for(const s of this.synchronisers){const h=await s.resolveContent(i);if(h)return h}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,s){return this.getSynchroniser(i).getAssociatedResources(s)}getMachineId(i,s){return this.getSynchroniser(i).getMachineId(s)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const s of i)if(await s.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(v,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(s){this.logService.error(`${i.resource}: ${(0,y.toErrorMessage)(s)}`),this.logService.error(s)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const s=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),s==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();(0,w.equals)(this._conflicts,i,([s,h],[c,l])=>s===s&&(0,w.equals)(h,l,(f,S)=>(0,u.isEqual)(f.previewResource,S.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(v,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,s){this.telemetryService.publicLog2("sync/error",{code:i.code,serverCode:i instanceof E.UserDataSyncStoreError?String(i.serverCode):void 0,url:i instanceof E.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:s,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(t)])}getSynchroniser(i){return this.synchronisers.find(s=>s.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=de([Y(0,E.IUserDataSyncStoreService),Y(1,E.IUserDataSyncStoreManagementService),Y(2,L.IInstantiationService),Y(3,E.IUserDataSyncLogService),Y(4,n.ITelemetryService),Y(5,g.IStorageService)],o),e.UserDataSyncService=o;class a extends R.Disposable{constructor(i,s,h,c,l){super();this.id=i,this.manifest=s,this.syncHeaders=h,this.synchronisers=c,this.logService=l,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,b.createCancelablePromise)(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,s){try{return await this.performAction(i,h=>h.accept(i,s))}catch(h){throw this.logService.error(h),h}}async merge(i){try{return i?await this.performAction(i,s=>s.merge(i)):await this.mergeAll()}catch(s){throw this.logService.error(s),s}}async discard(i){try{return await this.performAction(i,s=>s.discard(i))}catch(s){throw this.logService.error(s),s}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,s]of this.previews)for(const h of s.resourcePreviews)h.mergeState==="conflict"&&i.push(h.previewResource);for(const s of i)await this.discard(s);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[s,h]of this.previews){this.synchronizingResources.push([s,h.resourcePreviews.map(f=>f.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(f=>f.resource===s);for(const f of h.resourcePreviews)(f.localChange!==0||f.remoteChange!==0)&&f.mergeState==="preview"&&await c.merge(f.previewResource);const l=await c.apply(!1,this.syncHeaders);l&&i.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(f=>f[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,s]of this.previews){this.synchronizingResources.push([i,s.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(c=>c.resource===i);for(const c of s.resourcePreviews)await h.accept(c.remoteResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,s]of this.previews){this.synchronizingResources.push([i,s.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(c=>c.resource===i);for(const c of s.resourcePreviews)await h.accept(c.localResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(s){(0,D.isPromiseCanceledError)(s)||this.logService.error(s)}this.reset()}async performAction(i,s){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const h=this.previews.findIndex(([,x])=>x.resourcePreviews.some(({localResource:z,previewResource:H,remoteResource:V})=>(0,u.isEqual)(i,z)||(0,u.isEqual)(i,H)||(0,u.isEqual)(i,V)));if(h===-1)return this.previews;const[c,l]=this.previews[h],f=l.resourcePreviews.find(({localResource:x,remoteResource:z,previewResource:H})=>(0,u.isEqual)(x,i)||(0,u.isEqual)(z,i)||(0,u.isEqual)(H,i));if(!f)return this.previews;let S=this.synchronizingResources.find(x=>x[0]===c);S||(S=[c,[]],this.synchronizingResources.push(S)),S[1].some(x=>(0,u.isEqual)(x,f.localResource))||(S[1].push(f.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const d=this.synchronisers.find(x=>x.resource===this.previews[h][0]),T=await s(d);T?this.previews.splice(h,1,this.toSyncResourcePreview(d.resource,T)):this.previews.splice(h,1);const O=this.synchronizingResources.findIndex(x=>x[0]===c);return this.synchronizingResources[O][1].splice(S[1].findIndex(x=>(0,u.isEqual)(x,f.localResource)),1),S[1].length||(this.synchronizingResources.splice(O,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[s,h]of this.previews){this.synchronizingResources.push([s,h.resourcePreviews.map(f=>f.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(f=>f.resource===s);let l=h;for(const f of h.resourcePreviews)(f.localChange!==0||f.remoteChange!==0)&&f.mergeState==="preview"&&(l=await c.merge(f.previewResource));l&&i.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(f=>f[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const s=[];for(const h of this.synchronisers){if(i.isCancellationRequested)return[];const c=await h.preview(this.manifest,this.syncHeaders);c&&s.push(this.toSyncResourcePreview(h.resource,c))}return s}toSyncResourcePreview(i,s){return[i,{isLastSyncFromCurrentMachine:s.isLastSyncFromCurrentMachine,resourcePreviews:s.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(Z[211],ee([0,1,3,22,5,2,16]),function(K,e,E,R,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(w,g){this.service=w,this.logService=g,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new E.Emitter}listen(w,g){switch(g){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${g}`)}async call(w,g,m){try{return await this._call(w,g,m)}catch(u){throw this.logService.error(u),u}}async _call(w,g,m){switch(g){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(m[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(m[0],L.URI.revive(m[1]),m[2],m[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(m[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(m[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(m[0]);case"getAssociatedResources":return this.service.getAssociatedResources(m[0],{created:m[1].created,uri:L.URI.revive(m[1].uri)});case"getMachineId":return this.service.getMachineId(m[0],{created:m[1].created,uri:L.URI.revive(m[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(g.startsWith("manualSync/")){const u=g.substring("manualSync/".length),I=m[0],C=this.getManualSyncTask(I);switch(m=m.slice(1),u){case"preview":return C.preview();case"accept":return C.accept(L.URI.revive(m[0]),m[1]);case"merge":return C.merge(L.URI.revive(m[0]));case"discard":return C.discard(L.URI.revive(m[0]));case"discardConflicts":return C.discardConflicts();case"apply":return C.apply();case"pull":return C.pull();case"push":return C.push();case"stop":return C.stop();case"_getStatus":return C.status;case"dispose":return this.disposeManualSyncTask(C)}}throw new Error("Invalid call")}getManualSyncTask(w){const g=this.manualSyncTasks.get(this.createKey(w));if(!g)throw new Error(`Manual sync taks not found: ${w}`);return g.manualSyncTask}async createManualSyncTask(){const w=new k.DisposableStore,g=w.add(await this.service.createManualSyncTask());return w.add(g.onSynchronizeResources(m=>this.onManualSynchronizeResources.fire({manualSyncTaskId:g.id,data:m}))),this.manualSyncTasks.set(this.createKey(g.id),{manualSyncTask:g,disposables:w}),{id:g.id,manifest:g.manifest,status:g.status}}disposeManualSyncTask(w){w.dispose();const g=this.createKey(w.id);this.manualSyncTasks.get(g)?.disposables.dispose(),this.manualSyncTasks.delete(g)}createKey(w){return`manualSyncTask-${w}`}}e.UserDataSyncChannel=P;class p extends k.Disposable{constructor(w){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new E.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new E.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new E.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new E.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(g,m,u){return w.call(g,m,u).then(null,I=>{throw R.UserDataSyncError.toUserDataSyncError(I)})},listen(g,m){return w.listen(g,m)}},this.channel.call("_getInitialData").then(([g,m,u])=>{this.updateStatus(g),this.updateConflicts(m),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(I=>this.updateStatus(I))),this._register(this.channel.listen("onDidChangeLastSyncTime")(I=>this.updateLastSyncTime(I)))}),this._register(this.channel.listen("onDidChangeConflicts")(g=>this.updateConflicts(g))),this._register(this.channel.listen("onSyncErrors")(g=>this._onSyncErrors.fire(g.map(([m,u])=>[m,R.UserDataSyncError.toUserDataSyncError(u)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:w,manifest:g,status:m}=await this.channel.call("createManualSyncTask"),u=this,I=new y(w,g,m,{async call(C,b,D){return u.channel.call(`manualSync/${C}`,[w,...(0,A.isArray)(b)?b:[b]],D)},listen(C,b){return E.Event.map(E.Event.filter(u.channel.listen(`manualSync/${C}`,b),D=>!I.isDiposed()&&D.manualSyncTaskId===w),D=>D.data)}});return I}replace(w){return this.channel.call("replace",[w])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(w,g,m,u){return this.channel.call("accept",[w,g,m,u])}resolveContent(w){return this.channel.call("resolveContent",[w])}async getLocalSyncResourceHandles(w){return(await this.channel.call("getLocalSyncResourceHandles",[w])).map(({created:m,uri:u})=>({created:m,uri:L.URI.revive(u)}))}async getRemoteSyncResourceHandles(w){return(await this.channel.call("getRemoteSyncResourceHandles",[w])).map(({created:m,uri:u})=>({created:m,uri:L.URI.revive(u)}))}async getAssociatedResources(w,g){return(await this.channel.call("getAssociatedResources",[w,g])).map(({resource:u,comparableResource:I})=>({resource:L.URI.revive(u),comparableResource:L.URI.revive(I)}))}async getMachineId(w,g){return this.channel.call("getMachineId",[w,g])}async updateStatus(w){this._status=w,this._onDidChangeStatus.fire(w)}async updateConflicts(w){this._conflicts=w.map(([g,m])=>[g,m.map(u=>({...u,localResource:L.URI.revive(u.localResource),remoteResource:L.URI.revive(u.remoteResource),previewResource:L.URI.revive(u.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(w){this._lastSyncTime!==w&&(this._lastSyncTime=w,this._onDidChangeLastSyncTime.fire(w))}}e.UserDataSyncChannelClient=p;class y extends k.Disposable{constructor(w,g,m,u){super();this.id=w,this.manifest=g,this._disposed=!1,this._status=m;const I=this;this.channel={async call(C,b,D){try{const v=await u.call(C,b,D);return I.isDiposed()||(I._status=await u.call("_getStatus")),v}catch(v){throw R.UserDataSyncError.toUserDataSyncError(v)}},listen(C,b){return u.listen(C,b)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const w=await this.channel.call("preview");return this.deserializePreviews(w)}async accept(w,g){const m=await this.channel.call("accept",[w,g]);return this.deserializePreviews(m)}async merge(w){const g=await this.channel.call("merge",[w]);return this.deserializePreviews(g)}async discard(w){const g=await this.channel.call("discard",[w]);return this.deserializePreviews(g)}async discardConflicts(){const w=await this.channel.call("discardConflicts");return this.deserializePreviews(w)}async apply(){const w=await this.channel.call("apply");return this.deserializePreviews(w)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(w){return w.map(([g,m])=>[g,{isLastSyncFromCurrentMachine:m.isLastSyncFromCurrentMachine,resourcePreviews:m.resourcePreviews.map(u=>({...u,localResource:L.URI.revive(u.localResource),remoteResource:L.URI.revive(u.remoteResource),previewResource:L.URI.revive(u.previewResource),acceptedResource:L.URI.revive(u.acceptedResource)}))}])}}}),define(Z[212],ee([0,1,2,22,42,15,29,24,28,45,12,13,20,30,4,3,6,16,5,11,95]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I,C,b,D,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",s=100,h=1e3*60*5;let c=class extends E.Disposable{constructor(O,x,z){super();this.productService=O,this.configurationService=x,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new I.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(I.Event.filter(z.onDidChangeValue,H=>H.key===R.SYNC_SERVICE_URL_TYPE&&H.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(R.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(R.SYNC_SERVICE_URL_TYPE,O,0,u.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[R.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(R.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,x){O=u.isWeb&&O?.web?{...O,...O.web}:O;const z={...O||{},...x||{}};if(z&&(0,b.isString)(z.url)&&(0,b.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(H=>(0,b.isArray)(z.authenticationProviders[H].scopes))){const H=z,V=!!H.canSwitch&&!x?.url,U=H.url===H.insidersUrl?"insiders":"stable",$=(V?this.userDataSyncStoreType:void 0)||U,M=x?.url||($==="insiders"?H.insidersUrl:$==="stable"?H.stableUrl:H.url);return{url:D.URI.parse(M),type:$,defaultType:U,defaultUrl:D.URI.parse(H.url),stableUrl:D.URI.parse(H.stableUrl),insidersUrl:D.URI.parse(H.insidersUrl),canSwitch:V,authenticationProviders:Object.keys(H.authenticationProviders).reduce((N,q)=>(N.push({id:q,scopes:H.authenticationProviders[q].scopes}),N),[])}}}};c=de([Y(0,p.IProductService),Y(1,P.IConfigurationService),Y(2,g.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let l=class extends c{constructor(O,x,z){super(O,x,z);const H=this.storageService.get(a,0);H&&(this.previousConfigurationSyncStore=JSON.parse(H));const V=this.productService[R.CONFIGURATION_SYNC_STORE_KEY];V?this.storageService.store(a,JSON.stringify(V),0,1):this.storageService.remove(a,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=de([Y(0,p.IProductService),Y(1,P.IConfigurationService),Y(2,g.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let f=class extends E.Disposable{constructor(O,x,z,H,V,U,$){super();this.requestService=z,this.logService=H,this.storageService=$,this._onTokenFailed=this._register(new I.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new I.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new I.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,y.getServiceMachineId)(V,U,$).then(M=>{const N={"X-Client-Name":`${x.applicationName}${u.isWeb?"-web":""}`,"X-Client-Version":x.version,"X-Machine-Id":M};return x.commit&&(N["X-Client-Commit"]=x.commit),N}),this.session=new d(s,h,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,E.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,x){this.authToken={token:O,type:x}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,k.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,C.createCancelablePromise)(x=>(0,C.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),x).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,x=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O),z={},H=await this.request(x.toString(),{type:"GET",headers:z},[],A.CancellationToken.None);return(await(0,L.asJson)(H)||[]).map(({url:U,created:$})=>({ref:(0,k.relativePath)(x,x.with({path:U})),created:$*1e3}))}async resolveContent(O,x){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O,x).toString(),H={};H["Cache-Control"]="no-cache";const V=await this.request(z,{type:"GET",headers:H},[],A.CancellationToken.None);return await(0,L.asText)(V)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),z={};await this.request(x,{type:"DELETE",headers:z},[],A.CancellationToken.None)}async read(O,x,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();z={...z},z["Cache-Control"]="no-cache",x&&(z["If-None-Match"]=x.ref);const V=await this.request(H,{type:"GET",headers:z},[304],A.CancellationToken.None);let U=null;if(V.res.statusCode===304&&(U=x),U===null){const $=V.res.headers.etag;if(!$)throw new R.UserDataSyncStoreError("Server did not return the ref",H,"NoRef",V.res.statusCode,V.res.headers[R.HEADER_OPERATION_ID]);const M=await(0,L.asText)(V);if(!M&&V.res.statusCode===304)throw new R.UserDataSyncStoreError("Empty response",H,"EmptyResponse",V.res.statusCode,V.res.headers[R.HEADER_OPERATION_ID]);U={ref:$,content:M}}return U}async write(O,x,z,H={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();H={...H},H["Content-Type"]=o.Mimes.text,z&&(H["If-Match"]=z);const U=await this.request(V,{type:"POST",data:x,headers:H},[],A.CancellationToken.None),$=U.res.headers.etag;if(!$)throw new R.UserDataSyncStoreError("Server did not return the ref",V,"NoRef",U.res.statusCode,U.res.headers[R.HEADER_OPERATION_ID]);return $}async manifest(O,x={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,k.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();x={...x},x["Content-Type"]="application/json",O&&(x["If-None-Match"]=O.ref);const H=await this.request(z,{type:"GET",headers:x},[304],A.CancellationToken.None);let V=null;if(H.res.statusCode===304&&(V=O),!V){const $=H.res.headers.etag;if(!$)throw new R.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",H.res.statusCode,H.res.headers[R.HEADER_OPERATION_ID]);const M=await(0,L.asText)(H);if(!M&&H.res.statusCode===304)throw new R.UserDataSyncStoreError("Empty response",z,"EmptyResponse",H.res.statusCode,H.res.headers[R.HEADER_OPERATION_ID]);M&&(V={...JSON.parse(M),ref:$})}const U=this.storageService.get(r,0);return U&&V&&U!==V.session&&this.clearSession(),V===null&&U&&this.clearSession(),V&&this.storageService.store(r,V.session,0,1),V}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),x={"Content-Type":o.Mimes.text};await this.request(O,{type:"DELETE",headers:x},[],A.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(i,0)}async request(O,x,z,H){if(!this.authToken)throw new R.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new R.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const V=await this.commonHeadersPromise;x.headers={...x.headers||{},...V,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(x.headers),this.logService.trace("Sending request to server",{url:O,type:x.type,headers:{...x.headers,authorization:void 0}});let U;try{U=await this.session.request(O,x,H)}catch(q){if(!(q instanceof R.UserDataSyncStoreError)){let F="RequestFailed";const j=(0,v.getErrorMessage)(q).toLowerCase();j.includes("xhr timeout")?F="RequestTimeout":j.includes("protocol")&&j.includes("not supported")?F="RequestProtocolNotSupported":j.includes("request path contains unescaped characters")?F="RequestPathNotEscaped":j.includes("headers must be an object")?F="RequestHeadersNotObject":(0,v.isPromiseCanceledError)(q)&&(F="RequestCanceled"),q=new R.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,F,void 0,void 0)}throw this.logService.info("Request failed",O),q}const $=U.res.headers[R.HEADER_OPERATION_ID],M={url:O,status:U.res.statusCode,"execution-id":x.headers[R.HEADER_EXECUTION_ID],"operation-id":$},N=(0,L.isSuccess)(U)||U.res.statusCode&&z.indexOf(U.res.statusCode)!==-1;if(N?this.logService.trace("Request succeeded",M):this.logService.info("Request failed",M),U.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new R.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",U.res.statusCode,$);if(this._onTokenSucceed.fire(),U.res.statusCode===409)throw new R.UserDataSyncStoreError(`${x.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",U.res.statusCode,$);if(U.res.statusCode===410)throw new R.UserDataSyncStoreError(`${x.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",U.res.statusCode,$);if(U.res.statusCode===412)throw new R.UserDataSyncStoreError(`${x.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",U.res.statusCode,$);if(U.res.statusCode===413)throw new R.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",U.res.statusCode,$);if(U.res.statusCode===426)throw new R.UserDataSyncStoreError(`${x.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",U.res.statusCode,$);if(U.res.statusCode===429){const q=U.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new R.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",U.res.statusCode,$)):new R.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",U.res.statusCode,$)}if(!N)throw new R.UserDataSyncStoreError("Server returned "+U.res.statusCode,O,"Unknown",U.res.statusCode,$);return U}addSessionHeaders(O){let x=this.storageService.get(i,0);x===void 0&&(x=(0,m.generateUuid)(),this.storageService.store(i,x,0,1)),O["X-Machine-Session-Id"]=x;const z=this.storageService.get(r,0);z!==void 0&&(O["X-User-Session-Id"]=z)}};f=de([Y(1,p.IProductService),Y(2,L.IRequestService),Y(3,R.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,w.IFileService),Y(6,g.IStorageService)],f),e.UserDataSyncStoreClient=f;let S=class extends f{constructor(O,x,z,H,V,U,$){super(O.userDataSyncStore?.url,x,z,H,V,U,$);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};S=de([Y(0,R.IUserDataSyncStoreManagementService),Y(1,p.IProductService),Y(2,L.IRequestService),Y(3,R.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,w.IFileService),Y(6,g.IStorageService)],S),e.UserDataSyncStoreService=S;class d{constructor(O,x,z,H){this.limit=O,this.interval=x,this.requestService=z,this.logService=H,this.requests=[],this.startTime=void 0}request(O,x,z){if(this.isExpired()&&this.reset(),x.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new R.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(x,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=d}),define(Z[213],ee([0,1,22,3,59,89,60,21,20,61,28]),function(K,e,E,R,L,k,A,P,p,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends k.UserDataAutoSyncService{constructor(m,u,I,C,b,D,v,o,a,t,r,i){super(m,u,I,C,b,v,o,a,t,r,i);this._register(R.Event.debounce(R.Event.any(R.Event.map(D.onDidFocusWindow,()=>"windowFocus"),R.Event.map(D.onDidOpenWindow,()=>"windowOpen")),(s,h)=>s?[...s,h]:[h],1e3)(s=>this.triggerSync(s,!0,!1)))}};w=de([Y(0,n.IProductService),Y(1,E.IUserDataSyncStoreManagementService),Y(2,E.IUserDataSyncStoreService),Y(3,E.IUserDataSyncResourceEnablementService),Y(4,E.IUserDataSyncService),Y(5,L.INativeHostService),Y(6,E.IUserDataSyncLogService),Y(7,A.IUserDataSyncAccountService),Y(8,P.ITelemetryService),Y(9,y.IUserDataSyncMachinesService),Y(10,p.IStorageService),Y(11,E.IUserDataAutoSyncEnablementService)],w),e.UserDataAutoSyncService=w}),define(Z[214],ee([0,1,3,2,6]),function(K,e,E,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:p,getActiveWindowId:y}){super();this.disposables=this._register(new R.DisposableStore),E.Event.latch(E.Event.any(P,p))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>y()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch(w){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(Z[62],ee([0,1,50,6,8,16,18,110,222,223]),function(K,e,E,R,L,k,A,P,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function w(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function g(a){if(a instanceof n)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new n(t,a)}function m(a,t,r,i,s,h){const c=L.dirname(t),l=L.join(i,c);if(!l.startsWith(i))return Promise.reject(new Error(P.localize(0,null,t)));const f=L.join(i,t);let S;return h.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(A.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((d,T)=>{if(!h.isCancellationRequested)try{S=(0,E.createWriteStream)(f,{mode:r}),S.once("close",()=>d()),S.once("error",T),a.once("error",T),a.pipe(S)}catch(O){T(O)}}))}function u(a,t,r,i){let s=(0,R.createCancelablePromise)(()=>Promise.resolve()),h=0;return i.onCancellationRequested(()=>{s.cancel(),a.close()}),new Promise((c,l)=>{const f=new R.Sequencer,S=d=>{d.isCancellationRequested||(h++,a.readEntry())};a.once("error",l),a.once("close",()=>s.then(()=>{i.isCancellationRequested||a.entryCount===h?c():l(new n("Incomplete",new Error(P.localize(1,null,h,a.entryCount))))},l)),a.readEntry(),a.on("entry",d=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(d.fileName)){S(i);return}const T=d.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(T)){const z=L.join(t,T);s=(0,R.createCancelablePromise)(H=>A.Promises.mkdir(z,{recursive:!0}).then(()=>S(H)).then(void 0,l));return}const O=C(a,d),x=w(d);s=(0,R.createCancelablePromise)(z=>f.queue(()=>O.then(H=>m(H,T,x,t,r,z).then(()=>S(z)))).then(null,l))})})}function I(a,t=!1){return new Promise((r,i)=>{(0,p.open)(a,t?{lazyEntries:!0}:void 0,(s,h)=>{s?i(g(s)):r((0,k.assertIsDefined)(h))})})}function C(a,t){return new Promise((r,i)=>{a.openReadStream(t,(s,h)=>{s?i(g(s)):r((0,k.assertIsDefined)(h))})})}function b(a,t){return new Promise((r,i)=>{const s=new y.ZipFile;t.forEach(c=>{c.contents?s.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&s.addFile(c.localPath,c.path)}),s.end();const h=(0,E.createWriteStream)(a);s.outputStream.pipe(h),s.outputStream.once("error",i),h.once("error",i),h.once("finish",()=>r(a))})}e.zip=b;function D(a,t,r={},i){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let h=I(a,!0);return r.overwrite&&(h=h.then(c=>A.Promises.rm(t).then(()=>c))),h.then(c=>u(c,t,{sourcePathRegex:s},i))}e.extract=D;function v(a,t){return I(a).then(r=>new Promise((i,s)=>{r.on("entry",h=>{h.fileName===t&&C(r,h).then(c=>i(c),c=>s(c))}),r.once("close",()=>s(new Error(P.localize(2,null,t))))}))}function o(a,t){return v(a,t).then(r=>new Promise((i,s)=>{const h=[];r.once("error",s),r.on("data",c=>h.push(c)),r.on("end",()=>i(Buffer.concat(h)))}))}e.buffer=o}),define(Z[215],ee([0,1,62,118]),function(K,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(k){return(0,E.buffer)(k,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(P){throw new Error((0,R.localize)(0,null))}})}e.getManifest=L}),define(Z[216],ee([0,1,58,2,18,8,14,27,31,6,5,12,141,119,28,62,4,23,17,13,15,30,11]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I,C,b,D,v,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",s="extracting",h="deleting",c="renaming";let l=class extends R.Disposable{constructor(S,d,T,O,x){super();this.beforeRemovingExtension=S,this.fileService=d,this.logService=T,this.environmentService=O,this.productService=x,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new y.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(S){const d=[];(S===null||S===0)&&d.push(this.scanSystemExtensions().then(null,T=>Promise.reject(new P.ExtensionManagementError(this.joinErrors(T).message,r)))),(S===null||S===1)&&d.push(this.scanUserExtensions(!0).then(null,T=>Promise.reject(new P.ExtensionManagementError(this.joinErrors(T).message,i))));try{const T=await Promise.all(d);return(0,b.flatten)(T)}catch(T){throw this.joinErrors(T)}}async scanUserExtensions(S){this.logService.trace("Started scanning user extensions");let[d,T]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return T=T.filter(O=>!d[new p.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),S&&(T=(0,p.groupByExtension)(T,x=>x.identifier).map(x=>x.sort((z,H)=>E.rcompare(z.manifest.version,H.manifest.version))[0])),this.logService.trace("Scanned user extensions:",T.length),T}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(S,d,T){const O=S.key(),x=k.join(this.extensionsPath,`.${(0,a.generateUuid)()}`),z=k.join(this.extensionsPath,O);try{await L.Promises.rm(z)}catch(V){try{await L.Promises.rm(z)}catch(U){}throw new P.ExtensionManagementError((0,m.localize)(0,null,z,S.id),h)}await this.extractAtLocation(S,d,x,T);let H=await this.scanExtension(n.URI.file(x),1);if(!H)throw new Error((0,m.localize)(1,null,x));await this.storeMetadata(H,{installedTimestamp:Date.now()});try{await this.rename(S,x,z,Date.now()+2*60*1e3),this.logService.info("Renamed to",z)}catch(V){try{await L.Promises.rm(x)}catch(U){}if(V.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",S.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(V)}. Deleted from extracted location`,x),V}try{H=await this.scanExtension(n.URI.file(z),1)}catch(V){}if(H)return H;throw new Error((0,m.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(S,d){return this.setMetadata(S,d),await this.storeMetadata(S,{...d,installedTimestamp:S.installedTimestamp}),S}async storeMetadata(S,d){d.isMachineScoped=d.isMachineScoped||void 0,d.isBuiltin=d.isBuiltin||void 0,d.installedTimestamp=d.installedTimestamp||void 0;const T=k.join(S.location.fsPath,"package.json"),O=await L.Promises.readFile(T,"utf8"),{manifest:x}=await this.parseManifest(O);return x.__metadata=d,await L.Promises.writeFile(T,JSON.stringify(x,null,"	")),S}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...S){const d=S.map(T=>new p.ExtensionIdentifierWithVersion(T.identifier,T.manifest.version));await this.withUninstalledExtensions(T=>{d.forEach(O=>T[O.key()]=!0)})}async setInstalled(S){await this.withUninstalledExtensions(O=>delete O[S.key()]);const T=(await this.scanExtensions(1)).find(O=>new p.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(S))||null;return T?(await this.storeMetadata(T,{installedTimestamp:Date.now()}),this.scanExtension(T.location,1)):null}async withUninstalledExtensions(S){return this.uninstalledFileLimiter.queue(async()=>{let d;try{d=await L.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let T={};if(d)try{T=JSON.parse(d)}catch(O){}return S&&(S(T),Object.keys(T).length?await L.Promises.writeFile(this.uninstalledPath,JSON.stringify(T)):await L.Promises.rm(this.uninstalledPath)),T})}async removeExtension(S,d){this.logService.trace(`Deleting ${d} extension from disk`,S.identifier.id,S.location.fsPath),await L.Promises.rm(S.location.fsPath),this.logService.info("Deleted from disk",S.identifier.id,S.location.fsPath)}async removeUninstalledExtension(S){await this.removeExtension(S,"uninstalled"),await this.withUninstalledExtensions(d=>delete d[new p.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()])}async extractAtLocation(S,d,T,O){this.logService.trace(`Started extracting the extension from ${d} to ${T}`);try{await L.Promises.rm(T)}catch(x){throw new P.ExtensionManagementError(this.joinErrors(x).message,h)}try{await(0,I.extract)(d,T,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${T}:`,S.id)}catch(x){try{await L.Promises.rm(T)}catch(z){}throw new P.ExtensionManagementError(x.message,x instanceof I.ExtractError&&x.type?x.type:s)}}async rename(S,d,T,O){try{await L.Promises.rename(d,T)}catch(x){if(C.isWindows&&x&&x.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${d} to ${T} with 'EPERM' error. Trying again...`,S.id),this.rename(S,d,T,O);throw new P.ExtensionManagementError(x.message||(0,m.localize)(3,null,d,T),x.code||c)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const S=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return S;const d=this.scanDevSystemExtensions(),[T,O]=await Promise.all([S,d]);return[...T,...O]}async scanExtensionsInDir(S,d){const T=new y.Limiter(10),O=await this.fileService.resolve(n.URI.file(S));return O.children?(await Promise.all(O.children.filter(z=>z.isDirectory).map(z=>T.queue(async()=>d===1&&(0,o.basename)(z.resource).indexOf(".")===0?null:this.scanExtension(z.resource,d))))).filter(z=>z&&z.identifier):[]}async scanExtension(S,d){try{const T=await this.fileService.resolve(S);if(T.children){const{manifest:O,metadata:x}=await this.readManifest(S.fsPath),z=T.children.find(({name:$})=>/^readme(\.txt|\.md|)$/i.test($))?.resource,H=T.children.find(({name:$})=>/^changelog(\.txt|\.md|)$/i.test($))?.resource,V={id:(0,p.getGalleryExtensionId)(O.publisher,O.name)},U={type:d,identifier:V,manifest:O,location:S,readmeUrl:z,changelogUrl:H,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:d===0};return x&&(this.setMetadata(U,x),U.installedTimestamp=x.installedTimestamp),U}}catch(T){d!==0&&this.logService.trace(T)}return null}async scanDefaultSystemExtensions(){const S=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",S.length),S}async scanDevSystemExtensions(){const S=this.getDevSystemExtensionsList();if(S.length){const d=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",d.length),d.filter(T=>S.some(O=>(0,p.areSameExtensions)(T.identifier,{id:O})))}else return[]}setMetadata(S,d){S.publisherDisplayName=d.publisherDisplayName||null,S.publisherId=d.publisherId||null,S.identifier.uuid=d.id,S.isMachineScoped=!!d.isMachineScoped,S.isBuiltin=S.type===0||!!d.isBuiltin}async removeUninstalledExtensions(){const S=await this.getUninstalledExtensions(),d=await this.scanAllUserExtensions(),T=new Set;for(const z of d)S[new p.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]||T.add(z.identifier.id.toLowerCase());const O=(0,p.groupByExtension)(d,z=>z.identifier);await y.Promises.settled(O.map(async z=>{const H=z.sort((V,U)=>E.rcompare(V.manifest.version,U.manifest.version))[0];T.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(H)}));const x=d.filter(z=>S[new p.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]);await y.Promises.settled(x.map(z=>this.removeUninstalledExtension(z)))}async removeOutdatedExtensions(){const S=await this.scanAllUserExtensions(),d=[],T=(0,p.groupByExtension)(S,O=>O.identifier);d.push(...(0,b.flatten)(T.map(O=>O.sort((x,z)=>E.rcompare(x.manifest.version,z.manifest.version)).slice(1)))),await y.Promises.settled(d.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(S=>S.name)}joinErrors(S){const d=Array.isArray(S)?S:[S];return d.length===1?d[0]instanceof Error?d[0]:new Error(d[0]):d.reduce((T,O)=>new Error(`${T.message}${T.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(D.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(S){const d=[L.Promises.readFile(k.join(S,"package.json"),"utf8").then(z=>this.parseManifest(z)),L.Promises.readFile(k.join(S,"package.nls.json"),"utf8").then(void 0,z=>z.code!=="ENOENT"?Promise.reject(z):"{}").then(z=>JSON.parse(z))],[{manifest:T,metadata:O},x]=await Promise.all(d);return{manifest:(0,g.localizeManifest)(T,x),metadata:O}}parseManifest(S){return new Promise((d,T)=>{try{const O=JSON.parse(S),x=O.__metadata||null;d({manifest:O,metadata:x})}catch(O){T(new Error((0,m.localize)(4,null)))}})}};l=de([Y(1,v.IFileService),Y(2,A.ILogService),Y(3,w.INativeEnvironmentService),Y(4,u.IProductService)],l),e.ExtensionsScanner=l}),define(Z[217],ee([0,1,117,8,18,62,27,31,12,58,5,44,4,14,152,37,21,72,15,30,74,7,17,215,164,216,165,166,13,183]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I,C,b,D,v,o,a,t,r,i,s,h,c,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const S="unsetUninstalled",d="downloading";let T=class extends f.AbstractExtensionManagementService{constructor(U,$,M,N,q,F,j){super(U,$,M);this.environmentService=N,this.downloadService=q;const _=this._register(F.createInstance(h.ExtensionsLifecycle));this.extensionsScanner=this._register(F.createInstance(s.ExtensionsScanner,B=>_.postUninstall(B))),this.manifestCache=this._register(new u.ExtensionsManifestCache(N,this)),this.extensionsDownloader=this._register(F.createInstance(i.ExtensionsDownloader));const G=this._register(new c.ExtensionsWatcher(this,j,N,M));this._register(G.onDidChangeExtensionsByAnotherSource(({added:B,removed:X})=>{B.length&&this._onDidInstallExtensions.fire(B.map(Q=>({identifier:Q.identifier,operation:0,local:Q}))),X.forEach(Q=>this._onDidUninstallExtension.fire({identifier:Q}))}))}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const $=await this.collectFiles(U),M=await(0,k.zip)((0,D.joinPath)(this.environmentService.tmpDir,(0,v.generateUuid)()).fsPath,$);return n.URI.file(M)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const $=await this.downloadVsix(U),M=R.resolve($.fsPath);return(0,r.getManifest)(M)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async canInstall(U){return!0}async install(U,$={}){this.logService.trace("ExtensionManagementService#install",U.toString());const M=await this.downloadVsix(U),N=await(0,r.getManifest)(R.resolve(M.fsPath));if(N.engines&&N.engines.vscode&&!(0,b.isEngineValid)(N.engines.vscode,w.default.version,w.default.date))throw new Error(E.localize(0,null,(0,P.getGalleryExtensionId)(N.publisher,N.name),w.default.version));return this.installExtension(N,M,$)}async updateMetadata(U,$){return this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...$}),this.manifestCache.invalidate(),U}async updateExtensionScope(U,$){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:$}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===t.Schemas.file)return U;if(!this.downloadService)throw new Error("Download service is not available");const $=(0,D.joinPath)(this.environmentService.tmpDir,(0,v.generateUuid)());return await this.downloadService.download(U,$),$}createInstallExtensionTask(U,$,M){return n.URI.isUri($)?new z(U,$,M,this.galleryService,this.extensionsScanner,this.logService):new x($,M,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,$){return new H(U,$,this.extensionsScanner)}async collectFiles(U){const $=async N=>{let q=await L.Promises.readdir(N);q=q.map(_=>R.join(N,_));const F=await Promise.all(q.map(_=>L.Promises.stat(_)));let j=Promise.resolve([]);return F.forEach((_,G)=>{const B=q[G];_.isFile()&&(j=j.then(X=>[...X,B])),_.isDirectory()&&(j=j.then(X=>$(B).then(Q=>[...X,...Q])))}),j};return(await $(U.location.fsPath)).map(N=>({path:`extension/${R.relative(U.location.fsPath,N)}`,localPath:N}))}};T=de([Y(0,A.IExtensionGalleryService),Y(1,C.ITelemetryService),Y(2,m.ILogService),Y(3,p.INativeEnvironmentService),Y(4,(0,a.optional)(o.IDownloadService)),Y(5,a.IInstantiationService),Y(6,l.IFileService)],T),e.ExtensionManagementService=T;class O extends f.AbstractExtensionTask{constructor(U,$,M,N){super();this.identifier=U,this.source=$,this.extensionsScanner=M,this.logService=N,this._operation=1}get operation(){return this._operation}async installExtension(U,$){try{const M=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(M)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(M,U.metadata):M}catch(M){throw g.isMacintosh?new A.ExtensionManagementError(E.localize(1,null),S):new A.ExtensionManagementError(E.localize(2,null),S)}return this.extract(U,$)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const M=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),M}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:$,metadata:M},N){let q=await this.extensionsScanner.extractUserExtension($,U,N);return this.logService.info("Extracting completed.",$.id),M&&(q=await this.extensionsScanner.saveMetadataForLocalExtension(q,M)),q}}class x extends O{constructor(U,$,M,N,q){super(U.identifier,U,N,q);this.gallery=U,this.options=$,this.extensionsDownloader=M}async doRun(U){const M=(await this.extensionsScanner.scanExtensions(null)).find(F=>(0,P.areSameExtensions)(F.identifier,this.gallery.identifier));M&&(this._operation=2);const N=await this.downloadInstallableExtension(this.gallery,this._operation);N.metadata.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,N.metadata.isBuiltin=this.options.isBuiltin||M?.isBuiltin;const q=await this.installExtension(N,U);M&&y.neq(M.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(M);try{await this.extensionsDownloader.delete(n.URI.file(N.zipPath))}catch(F){}return q}async downloadInstallableExtension(U,$){const M={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",U.identifier.id),N=(await this.extensionsDownloader.downloadExtension(U,$)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,N)}catch(q){throw new A.ExtensionManagementError((0,f.joinErrors)(q).message,d)}try{const q=await(0,r.getManifest)(N);return{zipPath:N,identifierWithVersion:new P.ExtensionIdentifierWithVersion(U.identifier,q.version),metadata:M}}catch(q){throw new A.ExtensionManagementError((0,f.joinErrors)(q).message,f.INSTALL_ERROR_VALIDATING)}}}class z extends O{constructor(U,$,M,N,q,F){super({id:(0,P.getGalleryExtensionId)(U.publisher,U.name)},$,q,F);this.manifest=U,this.location=$,this.options=M,this.galleryService=N}async doRun(U){const $=new P.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),N=(await this.extensionsScanner.scanExtensions(1)).find(F=>(0,P.areSameExtensions)(this.identifier,F.identifier)),q=await this.getMetadata(this.identifier.id,U);if(N)if(q.isMachineScoped=this.options.isMachineScoped||N.isMachineScoped,q.isBuiltin=this.options.isBuiltin||N.isBuiltin,this._operation=2,$.equals(new P.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version)))try{await this.extensionsScanner.removeExtension(N,"existing")}catch(F){throw new Error(E.localize(3,null,this.manifest.displayName||this.manifest.name))}else y.gt(N.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(N);else{const F=await this.unsetUninstalledAndGetLocal($);if(F)try{await this.extensionsScanner.removeExtension(F,"existing")}catch(j){throw new Error(E.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:$,metadata:q},U)}async getMetadata(U,$){try{const M=(await this.galleryService.query({names:[U],pageSize:1},$)).firstPage[0];if(M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId}}catch(M){}return{}}}class H extends f.AbstractExtensionTask{constructor(U,$,M){super();this.extension=U,this.options=$,this.extensionsScanner=M}async doRun(U){const $=[],M=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const N=new P.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);$.push(...M.filter(q=>N.equals(new P.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version))))}else $.push(...M.filter(N=>(0,P.areSameExtensions)(N.identifier,this.extension.identifier)));if(!$.length)throw new Error(E.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...$),this.options.remove)for(const N of $)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(N)}catch(q){throw new Error(E.localize(6,null,(0,I.toErrorMessage)(q)))}}}}),define(Z[224],ee([0,1,104,50,225,34,37,11,2,17,15,5,36,103,171,151,172,161,162,163,149,153,24,174,73,182,74,176,12,138,178,184,27,140,185,217,75,142,13,168,170,52,7,158,78,159,160,57,167,14,79,59,44,28,175,42,20,180,181,21,82,84,83,53,186,187,85,189,195,87,88,89,22,60,206,207,208,61,209,210,211,212,213,214]),function(K,e,E,R,L,k,A,P,p,y,n,w,g,m,u,I,C,b,D,v,o,a,t,r,i,s,h,c,l,f,S,d,T,O,x,z,H,V,U,$,M,N,q,F,j,_,G,B,X,Q,ie,ne,le,fe,ye,Se,Pe,Te,Ne,Oe,Ae,_e,Ie,ke,Ye,Je,ze,$e,J,re,se,pe,me,De,we,Re,be,Le,Ue,W,te,ae,ce,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class he extends p.Disposable{constructor(ue){super();this.configuration=ue,this.server=this._register(new m.Server),(0,L.gracefulify)(R),this.registerListeners()}registerListeners(){const ue=()=>this.dispose();process.once("exit",ue),E.ipcRenderer.once("vscode:electron-main->shared-process=exit",ue)}async open(){const ue=await this.initServices();(0,me.registerConfiguration)(),ue.invokeFunction(Ee=>{const Ce=Ee.get(Q.ILogService);Ce.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ee),this.registerErrorHandler(Ce)}),this._register((0,p.combinedDisposable)(ue.createInstance(u.CodeCacheCleaner,this.configuration.codeCachePath),ue.createInstance(C.LanguagePackCachedDataCleaner),ue.createInstance(v.StorageDataCleaner,this.configuration.backupWorkspacesPath),ue.createInstance(D.LogsDataCleaner),ue.createInstance(b.LocalizationsUpdater),ue.createInstance(I.DeprecatedExtensionsCleaner)))}async initServices(){const ue=new j.ServiceCollection,Ee={_serviceBrand:void 0,...le.default};ue.set(fe.IProductService,Ee);const Ce=new g.StaticRouter(We=>We==="main"),Fe=new _.MessagePortMainProcessService(this.server,Ce);ue.set(G.IMainProcessService,Fe);const Me=new f.NativeEnvironmentService(this.configuration.args,Ee);ue.set(l.INativeEnvironmentService,Me);const et=new ie.LogLevelChannelClient(this.server.getChannel("logLevel",Ce)),Be=new ie.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,Fe.getChannel("logger"));ue.set(Q.ILoggerService,Be);const nt=this._register(new Q.MultiplexLogService([this._register(new Q.ConsoleLogger(this.configuration.logLevel)),this._register(Be.createLogger((0,n.joinPath)(w.URI.file(Me.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ve=this._register(new ie.FollowerLogService(et,nt));ue.set(Q.ILogService,Ve);const He=this._register(new $.FileService(Ve));ue.set(U.IFileService,He);const it=this._register(new M.DiskFileSystemProvider(Ve));He.registerProvider(y.Schemas.file,it);const je=this._register(new r.ConfigurationService(Me.settingsResource,He));ue.set(t.IConfigurationService,je),await je.initialize();const Xe=new Te.NativeStorageService(void 0,Fe,Me);ue.set(Pe.IStorageService,Xe),await Xe.initialize(),this._register((0,p.toDisposable)(()=>Xe.flush())),ue.set(Se.IRequestService,new N.SyncDescriptor(ye.RequestService)),ue.set(o.IChecksumService,new N.SyncDescriptor(a.ChecksumService));const tt=g.ProxyChannel.toService(Fe.getChannel("nativeHost"),{context:this.configuration.windowId});ue.set(ne.INativeHostService,tt),ue.set(h.IDownloadService,new N.SyncDescriptor(c.DownloadService));const rt=this._register(new oe.ActiveWindowManager(tt)),ht=new g.StaticRouter(We=>rt.getActiveClientId().then(st=>We===st));ue.set(H.IExtensionRecommendationNotificationService,new V.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));let Qe,Ge;if(!Me.isExtensionDevelopment&&!Me.disableTelemetry&&Ee.enableTelemetry){Ge=new _e.TelemetryLogAppender(Be,Me);const{appRoot:We,extensionsPath:st,isBuilt:dt,installSourcePath:gt}=Me;if(Ee.aiConfig&&Ee.aiConfig.asimovKey&&dt){const ct=new Ye.AppInsightsAppender("monacoworkbench",null,Ee.aiConfig.asimovKey);this._register((0,p.toDisposable)(()=>ct.flush())),Ge=(0,ke.combinedAppender)(ct,Ge)}Qe=new Ie.TelemetryService({appender:Ge,commonProperties:(0,Ne.resolveCommonProperties)(He,(0,k.release)(),(0,k.hostname)(),process.arch,Ee.commit,Ee.version,this.configuration.machineId,Ee.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[We,st]},je)}else Qe=ke.NullTelemetryService,Ge=ke.NullAppender;this.server.registerChannel("telemetryAppender",new Ae.TelemetryAppenderChannel(Ge)),ue.set(Oe.ITelemetryService,Qe);const ft=new Je.CustomEndpointTelemetryService(je,Qe,Be,Me);return ue.set(Oe.ICustomEndpointTelemetryService,ft),ue.set(T.IExtensionManagementService,new N.SyncDescriptor(z.ExtensionManagementService)),ue.set(T.IExtensionGalleryService,new N.SyncDescriptor(d.ExtensionGalleryService)),ue.set(T.IExtensionTipsService,new N.SyncDescriptor(x.ExtensionTipsService)),ue.set(B.ILocalizationsService,new N.SyncDescriptor(X.LocalizationsService)),ue.set(i.IDiagnosticsService,new N.SyncDescriptor(s.DiagnosticsService)),ue.set(De.IUserDataSyncAccountService,new N.SyncDescriptor(De.UserDataSyncAccountService)),ue.set(me.IUserDataSyncLogService,new N.SyncDescriptor(be.UserDataSyncLogService)),ue.set(me.IUserDataSyncUtilService,new Re.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),ue.set(T.IGlobalExtensionEnablementService,new N.SyncDescriptor(S.GlobalExtensionEnablementService)),ue.set(se.IIgnoredExtensionsManagementService,new N.SyncDescriptor(se.IgnoredExtensionsManagementService)),ue.set(re.IExtensionsStorageSyncService,new N.SyncDescriptor(re.ExtensionsStorageSyncService)),ue.set(me.IUserDataSyncStoreManagementService,new N.SyncDescriptor(ae.UserDataSyncStoreManagementService)),ue.set(me.IUserDataSyncStoreService,new N.SyncDescriptor(ae.UserDataSyncStoreService)),ue.set(Le.IUserDataSyncMachinesService,new N.SyncDescriptor(Le.UserDataSyncMachinesService)),ue.set(me.IUserDataSyncBackupStoreService,new N.SyncDescriptor(we.UserDataSyncBackupStoreService)),ue.set(me.IUserDataAutoSyncEnablementService,new N.SyncDescriptor(pe.UserDataAutoSyncEnablementService)),ue.set(me.IUserDataSyncResourceEnablementService,new N.SyncDescriptor(Ue.UserDataSyncResourceEnablementService)),ue.set(me.IUserDataSyncService,new N.SyncDescriptor(W.UserDataSyncService)),ue.set($e.ILocalPtyService,this._register(new J.PtyHostService({GraceTime:6e4,ShortGraceTime:6e3},je,Ve,Qe))),new F.InstantiationService(ue)}initChannels(ue){const Ee=new O.ExtensionManagementChannel(ue.get(T.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ee);const Ce=g.ProxyChannel.fromService(ue.get(B.ILocalizationsService));this.server.registerChannel("localizations",Ce);const Fe=g.ProxyChannel.fromService(ue.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",Fe);const Me=new O.ExtensionTipsChannel(ue.get(T.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Me);const et=g.ProxyChannel.fromService(ue.get(o.IChecksumService));this.server.registerChannel("checksum",et);const Be=new Re.UserDataSyncMachinesServiceChannel(ue.get(Le.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Be);const nt=g.ProxyChannel.fromService(ue.get(Oe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const Ve=new Re.UserDataSyncAccountServiceChannel(ue.get(De.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const He=new Re.UserDataSyncStoreManagementServiceChannel(ue.get(me.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",He);const it=new te.UserDataSyncChannel(ue.get(me.IUserDataSyncService),ue.get(Q.ILogService));this.server.registerChannel("userDataSync",it);const je=this._register(ue.get(q.IInstantiationService).createInstance(ce.UserDataAutoSyncService)),Xe=new Re.UserDataAutoSyncChannel(je);this.server.registerChannel("userDataAutoSync",Xe);const tt=ue.get($e.ILocalPtyService),rt=g.ProxyChannel.fromService(tt);this.server.registerChannel(ze.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(ue){window.addEventListener("unhandledrejection",Ee=>{(0,P.onUnexpectedError)(Ee.reason),Ee.preventDefault()}),(0,P.setUnexpectedErrorHandler)(Ee=>{const Ce=(0,A.toErrorMessage)(Ee,!0);!Ce||ue.error(`[uncaught exception in sharedProcess]: ${Ce}`)})}}async function ge(ve){const ue=new he(ve);E.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ue.open(),E.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a4eb4d688477fb9f2176bb2ed932b0b1726caed3/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
