/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/errors","vs/base/common/network","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/event","vs/platform/log/common/log","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/arrays","vs/platform/registry/common/platform","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","os","child_process","vs/base/common/process","vs/platform/product/common/product","vs/platform/telemetry/common/telemetry","vs/base/common/stream","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],te=function(q){for(var t=[],m=0,T=q.length;m<T;m++)t[m]=Z[q[m]];return t};define(Z[57],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function m(T,v){if(!T)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}t.ok=m}),define(Z[44],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function m(F){return(L,c,d)=>{let S=null,p=null;if(typeof d.value=="function"?(S="value",p=d.value):typeof d.get=="function"&&(S="get",p=d.get),!p)throw new Error("not supported");d[S]=F(p,c)}}t.createDecorator=m;function T(F,L,c){let d=null,S=null;if(typeof c.value=="function"?(d="value",S=c.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(d="get",S=c.get),!S)throw new Error("not supported");const p=`$memoize$${L}`;c[d]=function(...y){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,y)}),this[p]}}t.memoize=T;function v(F,L,c){return m((d,S)=>{const p=`$debounce$${S}`,y=`$debounce$result$${S}`;return function(...O){this[y]||(this[y]=c?c():void 0),clearTimeout(this[p]),L&&(this[y]=L(this[y],...O),O=[this[y]]),this[p]=setTimeout(()=>{d.apply(this,O),this[y]=c?c():void 0},F)}})}t.debounce=v;function I(F,L,c){return m((d,S)=>{const p=`$throttle$timer$${S}`,y=`$throttle$result$${S}`,O=`$throttle$lastRun$${S}`,l=`$throttle$pending$${S}`;return function(...u){if(this[y]||(this[y]=c?c():void 0),(this[O]===null||this[O]===void 0)&&(this[O]=-Number.MAX_VALUE),L&&(this[y]=L(this[y],...u)),this[l])return;const D=this[O]+F;D<=Date.now()?(this[O]=Date.now(),d.apply(this,[this[y]]),this[y]=c?c():void 0):(this[l]=!0,this[p]=setTimeout(()=>{this[l]=!1,this[O]=Date.now(),d.apply(this,[this[y]]),this[y]=c?c():void 0},D-Date.now()))}})}t.throttle=I}),define(Z[24],te([0,1,8]),function(q,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayQueue=t.maxIndex=t.minIndex=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function T(E,A=0){return E[E.length-(1+A)]}t.tail=T;function v(E){if(E.length===0)throw new Error("Invalid tail call");return[E.slice(0,E.length-1),E[E.length-1]]}t.tail2=v;function I(E,A,C=(z,j)=>z===j){if(E===A)return!0;if(!E||!A||E.length!==A.length)return!1;for(let z=0,j=E.length;z<j;z++)if(!C(E[z],A[z]))return!1;return!0}t.equals=I;function F(E,A,C){let z=0,j=E.length-1;for(;z<=j;){const $=(z+j)/2|0,H=C(E[$],A);if(H<0)z=$+1;else if(H>0)j=$-1;else return $}return-(z+1)}t.binarySearch=F;function L(E,A){let C=0,z=E.length;if(z===0)return 0;for(;C<z;){const j=Math.floor((C+z)/2);A(E[j])?z=j:C=j+1}return C}t.findFirstInSorted=L;function c(E,A,C){if(E=E|0,E>=A.length)throw new TypeError("invalid index");let z=A[Math.floor(A.length*Math.random())],j=[],$=[],H=[];for(let ee of A){const ne=C(ee,z);ne<0?j.push(ee):ne>0?$.push(ee):H.push(ee)}return E<j.length?c(E,j,C):E<j.length+H.length?H[0]:c(E-(j.length+H.length),$,C)}t.quickSelect=c;function d(E,A){const C=[];let z;for(const j of E.slice(0).sort(A))!z||A(z[0],j)!==0?(z=[j],C.push(z)):z.push(j);return C}t.groupBy=d;function S(E,A,C){const z=[];function j(ee,ne,re){if(ne===0&&re.length===0)return;const ce=z[z.length-1];ce&&ce.start+ce.deleteCount===ee?(ce.deleteCount+=ne,ce.toInsert.push(...re)):z.push({start:ee,deleteCount:ne,toInsert:re})}let $=0,H=0;for(;;){if($===E.length){j($,0,A.slice(H));break}if(H===A.length){j($,E.length-$,[]);break}const ee=E[$],ne=A[H],re=C(ee,ne);re===0?($+=1,H+=1):re<0?(j($,1,[]),$+=1):re>0&&(j($,0,[ne]),H+=1)}return z}t.sortedDiff=S;function p(E,A,C){const z=S(E,A,C),j=[],$=[];for(const H of z)j.push(...E.slice(H.start,H.start+H.deleteCount)),$.push(...H.toInsert);return{removed:j,added:$}}t.delta=p;function y(E,A,C){if(C===0)return[];const z=E.slice(0,C).sort(A);return l(E,A,z,C,E.length),z}t.top=y;function O(E,A,C,z,j){return C===0?Promise.resolve([]):new Promise(($,H)=>{(async()=>{const ee=E.length,ne=E.slice(0,C).sort(A);for(let re=C,ce=Math.min(C+z,ee);re<ee;re=ce,ce=Math.min(ce+z,ee)){if(re>C&&await new Promise(me=>setTimeout(me)),j&&j.isCancellationRequested)throw(0,m.canceled)();l(E,A,ne,re,ce)}return ne})().then($,H)})}t.topAsync=O;function l(E,A,C,z,j){for(const $=C.length;z<j;z++){const H=E[z];if(A(H,C[$-1])<0){C.pop();const ee=L(C,ne=>A(H,ne)<0);C.splice(ee,0,H)}}}function u(E){return E.filter(A=>!!A)}t.coalesce=u;function D(E){let A=0;for(let C=0;C<E.length;C++)E[C]&&(E[A]=E[C],A+=1);E.length=A}t.coalesceInPlace=D;function b(E,A,C){E.splice(C,0,E.splice(A,1)[0])}t.move=b;function R(E){return!Array.isArray(E)||E.length===0}t.isFalsyOrEmpty=R;function f(E){return Array.isArray(E)&&E.length>0}t.isNonEmptyArray=f;function r(E,A){if(!A)return E.filter((z,j)=>E.indexOf(z)===j);const C=Object.create(null);return E.filter(z=>{const j=A(z);return C[j]?!1:(C[j]=!0,!0)})}t.distinct=r;function s(E){const A=new Set;return E.filter(C=>A.has(C)?!1:(A.add(C),!0))}t.distinctES6=s;function e(E){const A=Object.create(null);return C=>{const z=E(C);return A[z]?!1:(A[z]=!0,!0)}}t.uniqueFilter=e;function i(E,A){for(let C=E.length-1;C>=0;C--){const z=E[C];if(A(z))return C}return-1}t.lastIndex=i;function n(E,A){return E.length>0?E[0]:A}t.firstOrDefault=n;function o(E,A,C=(z,j)=>z===j){let z=0;for(let j=0,$=Math.min(E.length,A.length);j<$&&C(E[j],A[j]);j++)z++;return z}t.commonPrefixLength=o;function a(E){return[].concat(...E)}t.flatten=a;function h(E,A){let C=typeof A=="number"?E:0;typeof A=="number"?C=E:(C=0,A=E);const z=[];if(C<=A)for(let j=C;j<A;j++)z.push(j);else for(let j=C;j>A;j--)z.push(j);return z}t.range=h;function g(E,A,C){return E.reduce((z,j)=>(z[A(j)]=C?C(j):j,z),Object.create(null))}t.index=g;function k(E,A){return E.push(A),()=>P(E,A)}t.insert=k;function P(E,A){const C=E.indexOf(A);if(C>-1)return E.splice(C,1),A}t.remove=P;function N(E,A,C){const z=E.slice(0,A),j=E.slice(A);return z.concat(C,j)}t.arrayInsert=N;function x(E,A){let C;if(typeof A=="number"){let z=A;C=()=>{const j=Math.sin(z++)*179426549;return j-Math.floor(j)}}else C=Math.random;for(let z=E.length-1;z>0;z-=1){const j=Math.floor(C()*(z+1)),$=E[z];E[z]=E[j],E[j]=$}}t.shuffle=x;function _(E,A){const C=E.indexOf(A);C>-1&&(E.splice(C,1),E.unshift(A))}t.pushToStart=_;function J(E,A){const C=E.indexOf(A);C>-1&&(E.splice(C,1),E.push(A))}t.pushToEnd=J;function ie(E,A){return Array.isArray(E)?E.map(A):A(E)}t.mapArrayOrNot=ie;function se(E){return Array.isArray(E)?E:[E]}t.asArray=se;function Y(E){return E[Math.floor(Math.random()*E.length)]}t.getRandomElement=Y;function X(E,A){for(const C of E){const z=A(C);if(z!==void 0)return z}}t.mapFind=X;function Q(E,A,C){const z=W(E,A),j=E.length,$=C.length;E.length=j+$;for(let H=j-1;H>=z;H--)E[H+$]=E[H];for(let H=0;H<$;H++)E[H+z]=C[H]}t.insertInto=Q;function B(E,A,C,z){const j=W(E,A),$=E.splice(j,C);return Q(E,j,z),$}t.splice=B;function W(E,A){return A<0?Math.max(A+E.length,0):Math.min(A,E.length)}function U(E,A){let C=Number.MAX_SAFE_INTEGER,z=0;return E.forEach((j,$)=>{const H=A(j);H<C&&(C=H,z=$)}),z}t.minIndex=U;function w(E,A){let C=Number.MIN_SAFE_INTEGER,z=0;return E.forEach((j,$)=>{const H=A(j);H>C&&(C=H,z=$)}),z}t.maxIndex=w;class M{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let C=this.firstIdx;for(;C<this.items.length&&A(this.items[C]);)C++;const z=C===this.firstIdx?null:this.items.slice(this.firstIdx,C);return this.firstIdx=C,z}takeFromEndWhile(A){let C=this.lastIdx;for(;C>=0&&A(this.items[C]);)C--;const z=C===this.lastIdx?null:this.items.slice(C+1,this.lastIdx+1);return this.lastIdx=C,z}}t.ArrayQueue=M}),define(Z[58],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var m;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(m=t.ScanError||(t.ScanError={}));var T;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(T=t.SyntaxKind||(t.SyntaxKind={}));var v;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(v=t.ParseErrorCode||(t.ParseErrorCode={}));var I;(function(e){e.DEFAULT={allowTrailingComma:!0}})(I=t.ParseOptions||(t.ParseOptions={}));function F(e,i=!1){let n=0,o=e.length,a="",h=0,g=16,k=0;function P(Y){let X=0,Q=0;for(;X<Y;){const B=e.charCodeAt(n);if(B>=48&&B<=57)Q=Q*16+B-48;else if(B>=65&&B<=70)Q=Q*16+B-65+10;else if(B>=97&&B<=102)Q=Q*16+B-97+10;else break;n++,X++}return X<Y&&(Q=-1),Q}function N(Y){n=Y,a="",h=0,g=16,k=0}function x(){const Y=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&d(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&d(e.charCodeAt(n)))for(n++;n<e.length&&d(e.charCodeAt(n));)n++;else return k=3,e.substring(Y,n);let X=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&d(e.charCodeAt(n))){for(n++;n<e.length&&d(e.charCodeAt(n));)n++;X=n}else k=3;return e.substring(Y,X)}function _(){let Y="",X=n;for(;;){if(n>=o){Y+=e.substring(X,n),k=2;break}const Q=e.charCodeAt(n);if(Q===34){Y+=e.substring(X,n),n++;break}if(Q===92){if(Y+=e.substring(X,n),n++,n>=o){k=2;break}switch(e.charCodeAt(n++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:const W=P(4);W>=0?Y+=String.fromCharCode(W):k=4;break;default:k=5}X=n;continue}if(Q>=0&&Q<=31)if(c(Q)){Y+=e.substring(X,n),k=2;break}else k=6;n++}return Y}function J(){if(a="",k=0,h=n,n>=o)return h=o,g=17;let Y=e.charCodeAt(n);if(L(Y)){do n++,a+=String.fromCharCode(Y),Y=e.charCodeAt(n);while(L(Y));return g=15}if(c(Y))return n++,a+=String.fromCharCode(Y),Y===13&&e.charCodeAt(n)===10&&(n++,a+=`
`),g=14;switch(Y){case 123:return n++,g=1;case 125:return n++,g=2;case 91:return n++,g=3;case 93:return n++,g=4;case 58:return n++,g=6;case 44:return n++,g=5;case 34:return n++,a=_(),g=10;case 47:const X=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<o&&!c(e.charCodeAt(n));)n++;return a=e.substring(X,n),g=12}if(e.charCodeAt(n+1)===42){n+=2;const Q=o-1;let B=!1;for(;n<Q;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,B=!0;break}n++}return B||(n++,k=1),a=e.substring(X,n),g=13}return a+=String.fromCharCode(Y),n++,g=16;case 45:if(a+=String.fromCharCode(Y),n++,n===o||!d(e.charCodeAt(n)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=x(),g=11;default:for(;n<o&&ie(Y);)n++,Y=e.charCodeAt(n);if(h!==n){switch(a=e.substring(h,n),a){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return a+=String.fromCharCode(Y),n++,g=16}}function ie(Y){if(L(Y)||c(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let Y;do Y=J();while(Y>=12&&Y<=15);return Y}return{setPosition:N,getPosition:()=>n,scan:i?se:J,getToken:()=>g,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>n-h,getTokenError:()=>k}}t.createScanner=F;function L(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var S;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(S||(S={}));function p(e,i){const n=[],o=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function k(P,N,x,_){h.value=P,h.offset=N,h.length=x,h.type=_,h.colonOffset=void 0,a=h}try{f(e,{onObjectBegin:(P,N)=>{if(i<=P)throw o;a=void 0,g=i>P,n.push("")},onObjectProperty:(P,N,x)=>{if(i<N||(k(P,N,x,"property"),n[n.length-1]=P,i<=N+x))throw o},onObjectEnd:(P,N)=>{if(i<=P)throw o;a=void 0,n.pop()},onArrayBegin:(P,N)=>{if(i<=P)throw o;a=void 0,n.push(0)},onArrayEnd:(P,N)=>{if(i<=P)throw o;a=void 0,n.pop()},onLiteralValue:(P,N,x)=>{if(i<N||(k(P,N,x,s(P)),i<=N+x))throw o},onSeparator:(P,N,x)=>{if(i<=N)throw o;if(P===":"&&a&&a.type==="property")a.colonOffset=N,g=!1,a=void 0;else if(P===","){const _=n[n.length-1];typeof _=="number"?n[n.length-1]=_+1:(g=!0,n[n.length-1]=""),a=void 0}}})}catch(P){if(P!==o)throw P}return{path:n,previousNode:a,isAtPropertyKey:g,matches:P=>{let N=0;for(let x=0;N<P.length&&x<n.length;x++)if(P[N]===n[x]||P[N]==="*")N++;else if(P[N]!=="**")return!1;return N===P.length}}}t.getLocation=p;function y(e,i=[],n=I.DEFAULT){let o=null,a=[];const h=[];function g(P){Array.isArray(a)?a.push(P):o!==null&&(a[o]=P)}return f(e,{onObjectBegin:()=>{const P={};g(P),h.push(a),a=P,o=null},onObjectProperty:P=>{o=P},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const P=[];g(P),h.push(a),a=P,o=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:g,onError:(P,N,x)=>{i.push({error:P,offset:N,length:x})}},n),a[0]}t.parse=y;function O(e,i=[],n=I.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(P){o.type==="property"&&(o.length=P-o.offset,o=o.parent)}function h(P){return o.children.push(P),P}f(e,{onObjectBegin:P=>{o=h({type:"object",offset:P,length:-1,parent:o,children:[]})},onObjectProperty:(P,N,x)=>{o=h({type:"property",offset:N,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:P,offset:N,length:x,parent:o})},onObjectEnd:(P,N)=>{o.length=P+N-o.offset,o=o.parent,a(P+N)},onArrayBegin:(P,N)=>{o=h({type:"array",offset:P,length:-1,parent:o,children:[]})},onArrayEnd:(P,N)=>{o.length=P+N-o.offset,o=o.parent,a(P+N)},onLiteralValue:(P,N,x)=>{h({type:s(P),offset:N,length:x,parent:o,value:P}),a(N+x)},onSeparator:(P,N,x)=>{o.type==="property"&&(P===":"?o.colonOffset=N:P===","&&a(N))},onError:(P,N,x)=>{i.push({error:P,offset:N,length:x})}},n);const k=o.children[0];return k&&delete k.parent,k}t.parseTree=O;function l(e,i){if(!e)return;let n=e;for(let o of i)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const h of n.children)if(Array.isArray(h.children)&&h.children[0].value===o){n=h.children[1],a=!0;break}if(!a)return}else{const a=o;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}t.findNodeAtLocation=l;function u(e){if(!e.parent||!e.parent.children)return[];const i=u(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=u;function D(e){switch(e.type){case"array":return e.children.map(D);case"object":const i=Object.create(null);for(let n of e.children){const o=n.children[1];o&&(i[n.children[0].value]=D(o))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=D;function b(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=b;function R(e,i,n=!1){if(b(e,i,n)){const o=e.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=i;a++){const h=R(o[a],i,n);if(h)return h}return e}}t.findNodeAtOffset=R;function f(e,i,n=I.DEFAULT){const o=F(e,!1);function a(C){return C?()=>C(o.getTokenOffset(),o.getTokenLength()):()=>!0}function h(C){return C?z=>C(z,o.getTokenOffset(),o.getTokenLength()):()=>!0}const g=a(i.onObjectBegin),k=h(i.onObjectProperty),P=a(i.onObjectEnd),N=a(i.onArrayBegin),x=a(i.onArrayEnd),_=h(i.onLiteralValue),J=h(i.onSeparator),ie=a(i.onComment),se=h(i.onError),Y=n&&n.disallowComments,X=n&&n.allowTrailingComma;function Q(){for(;;){const C=o.scan();switch(o.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:Y||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(C){case 12:case 13:Y?B(10):ie();break;case 16:B(1);break;case 15:case 14:break;default:return C}}}function B(C,z=[],j=[]){if(se(C),z.length+j.length>0){let $=o.getToken();for(;$!==17;){if(z.indexOf($)!==-1){Q();break}else if(j.indexOf($)!==-1)break;$=Q()}}}function W(C){const z=o.getTokenValue();return C?_(z):k(z),Q(),!0}function U(){switch(o.getToken()){case 11:let C=0;try{C=JSON.parse(o.getTokenValue()),typeof C!="number"&&(B(2),C=0)}catch(z){B(2)}_(C);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return Q(),!0}function w(){return o.getToken()!==10?(B(3,[],[2,5]),!1):(W(!1),o.getToken()===6?(J(":"),Q(),A()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function M(){g(),Q();let C=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(C||B(4,[],[]),J(","),Q(),o.getToken()===2&&X)break}else C&&B(6,[],[]);w()||B(4,[],[2,5]),C=!0}return P(),o.getToken()!==2?B(7,[2],[]):Q(),!0}function E(){N(),Q();let C=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(C||B(4,[],[]),J(","),Q(),o.getToken()===4&&X)break}else C&&B(6,[],[]);A()||B(4,[],[4,5]),C=!0}return x(),o.getToken()!==4?B(8,[4],[]):Q(),!0}function A(){switch(o.getToken()){case 3:return E();case 1:return M();case 10:return W(!0);default:return U()}}return Q(),o.getToken()===17?n.allowEmptyContent?!0:(B(4,[],[]),!1):A()?(o.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}t.visit=f;function r(e,i){let n=F(e),o=[],a,h=0,g;do switch(g=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:h!==g&&o.push(e.substring(h,g)),i!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,i)),h=n.getPosition();break}while(a!==17);return o.join("")}t.stripComments=r;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function q(v){const I=[];typeof v=="number"&&I.push("code/timeOrigin",v);function F(c){I.push(c,Date.now())}function L(){const c=[];for(let d=0;d<I.length;d+=2)c.push({name:I[d],startTime:I[d+1]});return c}return{mark:F,getMarks:L}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(v){performance.mark(v)},getMarks(){let v=performance.timeOrigin;typeof v!="number"&&(v=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(v)}];for(const F of performance.getEntriesByType("mark"))I.push({name:F.name,startTime:Math.round(v+F.startTime)});return I}};if(typeof process=="object"){const v=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(v)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function m(v){return v.MonacoPerformanceMarks||(v.MonacoPerformanceMarks=t()),v.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=m(T))}(),function(q,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var m=t();for(var T in m)(typeof exports=="object"?exports:q)[T]=m[T]}}(typeof self!="undefined"?self:this,function(){return function(q){var t={};function m(T){if(t[T])return t[T].exports;var v=t[T]={i:T,l:!1,exports:{}};return q[T].call(v.exports,v,v.exports,m),v.l=!0,v.exports}return m.m=q,m.c=t,m.d=function(T,v,I){m.o(T,v)||Object.defineProperty(T,v,{enumerable:!0,get:I})},m.r=function(T){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},m.t=function(T,v){if(1&v&&(T=m(T)),8&v||4&v&&typeof T=="object"&&T&&T.__esModule)return T;var I=Object.create(null);if(m.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:T}),2&v&&typeof T!="string")for(var F in T)m.d(I,F,function(L){return T[L]}.bind(null,F));return I},m.n=function(T){var v=T&&T.__esModule?function(){return T.default}:function(){return T};return m.d(v,"a",v),v},m.o=function(T,v){return Object.prototype.hasOwnProperty.call(T,v)},m.p="",m(m.s=0)}([function(q,t,m){(function(T){var v;t=q.exports=j,v=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var I=256,F=Number.MAX_SAFE_INTEGER||9007199254740991,L=t.re=[],c=t.src=[],d=0,S=d++;c[S]="0|[1-9]\\d*";var p=d++;c[p]="[0-9]+";var y=d++;c[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var O=d++;c[O]="("+c[S]+")\\.("+c[S]+")\\.("+c[S]+")";var l=d++;c[l]="("+c[p]+")\\.("+c[p]+")\\.("+c[p]+")";var u=d++;c[u]="(?:"+c[S]+"|"+c[y]+")";var D=d++;c[D]="(?:"+c[p]+"|"+c[y]+")";var b=d++;c[b]="(?:-("+c[u]+"(?:\\."+c[u]+")*))";var R=d++;c[R]="(?:-?("+c[D]+"(?:\\."+c[D]+")*))";var f=d++;c[f]="[0-9A-Za-z-]+";var r=d++;c[r]="(?:\\+("+c[f]+"(?:\\."+c[f]+")*))";var s=d++,e="v?"+c[O]+c[b]+"?"+c[r]+"?";c[s]="^"+e+"$";var i="[v=\\s]*"+c[l]+c[R]+"?"+c[r]+"?",n=d++;c[n]="^"+i+"$";var o=d++;c[o]="((?:<|>)?=?)";var a=d++;c[a]=c[p]+"|x|X|\\*";var h=d++;c[h]=c[S]+"|x|X|\\*";var g=d++;c[g]="[v=\\s]*("+c[h]+")(?:\\.("+c[h]+")(?:\\.("+c[h]+")(?:"+c[b]+")?"+c[r]+"?)?)?";var k=d++;c[k]="[v=\\s]*("+c[a]+")(?:\\.("+c[a]+")(?:\\.("+c[a]+")(?:"+c[R]+")?"+c[r]+"?)?)?";var P=d++;c[P]="^"+c[o]+"\\s*"+c[g]+"$";var N=d++;c[N]="^"+c[o]+"\\s*"+c[k]+"$";var x=d++;c[x]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=d++;c[_]="(?:~>?)";var J=d++;c[J]="(\\s*)"+c[_]+"\\s+",L[J]=new RegExp(c[J],"g");var ie=d++;c[ie]="^"+c[_]+c[g]+"$";var se=d++;c[se]="^"+c[_]+c[k]+"$";var Y=d++;c[Y]="(?:\\^)";var X=d++;c[X]="(\\s*)"+c[Y]+"\\s+",L[X]=new RegExp(c[X],"g");var Q=d++;c[Q]="^"+c[Y]+c[g]+"$";var B=d++;c[B]="^"+c[Y]+c[k]+"$";var W=d++;c[W]="^"+c[o]+"\\s*("+i+")$|^$";var U=d++;c[U]="^"+c[o]+"\\s*("+e+")$|^$";var w=d++;c[w]="(\\s*)"+c[o]+"\\s*("+i+"|"+c[g]+")",L[w]=new RegExp(c[w],"g");var M=d++;c[M]="^\\s*("+c[g]+")\\s+-\\s+("+c[g]+")\\s*$";var E=d++;c[E]="^\\s*("+c[k]+")\\s+-\\s+("+c[k]+")\\s*$";var A=d++;c[A]="(<|>)?=?\\s*\\*";for(var C=0;C<35;C++)v(C,c[C]),L[C]||(L[C]=new RegExp(c[C]));function z(V,G){if(V instanceof j)return V;if(typeof V!="string"||V.length>I||!(G?L[n]:L[s]).test(V))return null;try{return new j(V,G)}catch(K){return null}}function j(V,G){if(V instanceof j){if(V.loose===G)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof j))return new j(V,G);v("SemVer",V,G),this.loose=G;var K=V.trim().match(G?L[n]:L[s]);if(!K)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>F||this.major<0)throw new TypeError("Invalid major version");if(this.minor>F||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>F||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(oe){if(/^[0-9]+$/.test(oe)){var ae=+oe;if(ae>=0&&ae<F)return ae}return oe}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=z,t.valid=function(V,G){var K=z(V,G);return K?K.version:null},t.clean=function(V,G){var K=z(V.trim().replace(/^[=v]+/,""),G);return K?K.version:null},t.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(V){return v("SemVer.compare",this.version,this.loose,V),V instanceof j||(V=new j(V,this.loose)),this.compareMain(V)||this.comparePre(V)},j.prototype.compareMain=function(V){return V instanceof j||(V=new j(V,this.loose)),H(this.major,V.major)||H(this.minor,V.minor)||H(this.patch,V.patch)},j.prototype.comparePre=function(V){if(V instanceof j||(V=new j(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var G=0;do{var K=this.prerelease[G],oe=V.prerelease[G];if(v("prerelease compare",G,K,oe),K===void 0&&oe===void 0)return 0;if(oe===void 0)return 1;if(K===void 0)return-1;if(K!==oe)return H(K,oe)}while(++G)},j.prototype.inc=function(V,G){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},t.inc=function(V,G,K,oe){typeof K=="string"&&(oe=K,K=void 0);try{return new j(V,K).inc(G,oe).version}catch(ae){return null}},t.diff=function(V,G){if(ce(V,G))return null;var K=z(V),oe=z(G);if(K.prerelease.length||oe.prerelease.length){for(var ae in K)if((ae==="major"||ae==="minor"||ae==="patch")&&K[ae]!==oe[ae])return"pre"+ae;return"prerelease"}for(var ae in K)if((ae==="major"||ae==="minor"||ae==="patch")&&K[ae]!==oe[ae])return ae},t.compareIdentifiers=H;var $=/^[0-9]+$/;function H(V,G){var K=$.test(V),oe=$.test(G);return K&&oe&&(V=+V,G=+G),K&&!oe?-1:oe&&!K?1:V<G?-1:V>G?1:0}function ee(V,G,K){return new j(V,K).compare(new j(G,K))}function ne(V,G,K){return ee(V,G,K)>0}function re(V,G,K){return ee(V,G,K)<0}function ce(V,G,K){return ee(V,G,K)===0}function me(V,G,K){return ee(V,G,K)!==0}function be(V,G,K){return ee(V,G,K)>=0}function ke(V,G,K){return ee(V,G,K)<=0}function Te(V,G,K,oe){var ae;switch(G){case"===":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),ae=V===K;break;case"!==":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),ae=V!==K;break;case"":case"=":case"==":ae=ce(V,K,oe);break;case"!=":ae=me(V,K,oe);break;case">":ae=ne(V,K,oe);break;case">=":ae=be(V,K,oe);break;case"<":ae=re(V,K,oe);break;case"<=":ae=ke(V,K,oe);break;default:throw new TypeError("Invalid operator: "+G)}return ae}function we(V,G){if(V instanceof we){if(V.loose===G)return V;V=V.value}if(!(this instanceof we))return new we(V,G);v("comparator",V,G),this.loose=G,this.parse(V),this.semver===Fe?this.value="":this.value=this.operator+this.semver.version,v("comp",this)}t.rcompareIdentifiers=function(V,G){return H(G,V)},t.major=function(V,G){return new j(V,G).major},t.minor=function(V,G){return new j(V,G).minor},t.patch=function(V,G){return new j(V,G).patch},t.compare=ee,t.compareLoose=function(V,G){return ee(V,G,!0)},t.rcompare=function(V,G,K){return ee(G,V,K)},t.sort=function(V,G){return V.sort(function(K,oe){return t.compare(K,oe,G)})},t.rsort=function(V,G){return V.sort(function(K,oe){return t.rcompare(K,oe,G)})},t.gt=ne,t.lt=re,t.eq=ce,t.neq=me,t.gte=be,t.lte=ke,t.cmp=Te,t.Comparator=we;var Fe={};function ve(V,G){if(V instanceof ve)return V.loose===G?V:new ve(V.raw,G);if(V instanceof we)return new ve(V.value,G);if(!(this instanceof ve))return new ve(V,G);if(this.loose=G,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Re(V){return!V||V.toLowerCase()==="x"||V==="*"}function je(V,G,K,oe,ae,Se,de,Le,ye,De,Ae,Ee,Ie){return((G=Re(K)?"":Re(oe)?">="+K+".0.0":Re(ae)?">="+K+"."+oe+".0":">="+G)+" "+(Le=Re(ye)?"":Re(De)?"<"+(+ye+1)+".0.0":Re(Ae)?"<"+ye+"."+(+De+1)+".0":Ee?"<="+ye+"."+De+"."+Ae+"-"+Ee:"<="+Le)).trim()}function Be(V,G){for(var K=0;K<V.length;K++)if(!V[K].test(G))return!1;if(G.prerelease.length){for(K=0;K<V.length;K++)if(v(V[K].semver),V[K].semver!==Fe&&V[K].semver.prerelease.length>0){var oe=V[K].semver;if(oe.major===G.major&&oe.minor===G.minor&&oe.patch===G.patch)return!0}return!1}return!0}function xe(V,G,K){try{G=new ve(G,K)}catch(oe){return!1}return G.test(V)}function ze(V,G,K,oe){var ae,Se,de,Le,ye;switch(V=new j(V,oe),G=new ve(G,oe),K){case">":ae=ne,Se=ke,de=re,Le=">",ye=">=";break;case"<":ae=re,Se=be,de=ne,Le="<",ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(V,G,oe))return!1;for(var De=0;De<G.set.length;++De){var Ae=G.set[De],Ee=null,Ie=null;if(Ae.forEach(function(Ce){Ce.semver===Fe&&(Ce=new we(">=0.0.0")),Ee=Ee||Ce,Ie=Ie||Ce,ae(Ce.semver,Ee.semver,oe)?Ee=Ce:de(Ce.semver,Ie.semver,oe)&&(Ie=Ce)}),Ee.operator===Le||Ee.operator===ye||(!Ie.operator||Ie.operator===Le)&&Se(V,Ie.semver)||Ie.operator===ye&&de(V,Ie.semver))return!1}return!0}we.prototype.parse=function(V){var G=this.loose?L[W]:L[U],K=V.match(G);if(!K)throw new TypeError("Invalid comparator: "+V);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new j(K[2],this.loose):this.semver=Fe},we.prototype.toString=function(){return this.value},we.prototype.test=function(V){return v("Comparator.test",V,this.loose),this.semver===Fe||(typeof V=="string"&&(V=new j(V,this.loose)),Te(V,this.operator,this.semver,this.loose))},we.prototype.intersects=function(V,G){if(!(V instanceof we))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new ve(V.value,G),xe(this.value,K,G);if(V.operator==="")return K=new ve(this.value,G),xe(V.semver,K,G);var oe=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ae=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Se=this.semver.version===V.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=Te(this.semver,"<",V.semver,G)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),ye=Te(this.semver,">",V.semver,G)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return oe||ae||Se&&de||Le||ye},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(V){var G=this.loose;V=V.trim(),v("range",V,G);var K=G?L[E]:L[M];V=V.replace(K,je),v("hyphen replace",V),V=V.replace(L[w],"$1$2$3"),v("comparator trim",V,L[w]),V=(V=(V=V.replace(L[J],"$1~")).replace(L[X],"$1^")).split(/\s+/).join(" ");var oe=G?L[W]:L[U],ae=V.split(" ").map(function(Se){return function(de,Le){return v("comp",de),de=function(ye,De){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,Ie){v("caret",Ee,Ie);var Ce=Ie?L[B]:L[Q];return Ee.replace(Ce,function(Oe,le,he,ge,pe){var Pe;return v("caret",Ee,Oe,le,he,ge,pe),Re(le)?Pe="":Re(he)?Pe=">="+le+".0.0 <"+(+le+1)+".0.0":Re(ge)?Pe=le==="0"?">="+le+"."+he+".0 <"+le+"."+(+he+1)+".0":">="+le+"."+he+".0 <"+(+le+1)+".0.0":pe?(v("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Pe=le==="0"?he==="0"?">="+le+"."+he+"."+ge+pe+" <"+le+"."+he+"."+(+ge+1):">="+le+"."+he+"."+ge+pe+" <"+le+"."+(+he+1)+".0":">="+le+"."+he+"."+ge+pe+" <"+(+le+1)+".0.0"):(v("no pr"),Pe=le==="0"?he==="0"?">="+le+"."+he+"."+ge+" <"+le+"."+he+"."+(+ge+1):">="+le+"."+he+"."+ge+" <"+le+"."+(+he+1)+".0":">="+le+"."+he+"."+ge+" <"+(+le+1)+".0.0"),v("caret return",Pe),Pe})}(Ae,De)}).join(" ")}(de,Le),v("caret",de),de=function(ye,De){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,Ie){var Ce=Ie?L[se]:L[ie];return Ee.replace(Ce,function(Oe,le,he,ge,pe){var Pe;return v("tilde",Ee,Oe,le,he,ge,pe),Re(le)?Pe="":Re(he)?Pe=">="+le+".0.0 <"+(+le+1)+".0.0":Re(ge)?Pe=">="+le+"."+he+".0 <"+le+"."+(+he+1)+".0":pe?(v("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Pe=">="+le+"."+he+"."+ge+pe+" <"+le+"."+(+he+1)+".0"):Pe=">="+le+"."+he+"."+ge+" <"+le+"."+(+he+1)+".0",v("tilde return",Pe),Pe})}(Ae,De)}).join(" ")}(de,Le),v("tildes",de),de=function(ye,De){return v("replaceXRanges",ye,De),ye.split(/\s+/).map(function(Ae){return function(Ee,Ie){Ee=Ee.trim();var Ce=Ie?L[N]:L[P];return Ee.replace(Ce,function(Oe,le,he,ge,pe,Pe){v("xRange",Ee,Oe,le,he,ge,pe,Pe);var Ve=Re(he),Me=Ve||Re(ge),Ue=Me||Re(pe);return le==="="&&Ue&&(le=""),Ve?Oe=le===">"||le==="<"?"<0.0.0":"*":le&&Ue?(Me&&(ge=0),Ue&&(pe=0),le===">"?(le=">=",Me?(he=+he+1,ge=0,pe=0):Ue&&(ge=+ge+1,pe=0)):le==="<="&&(le="<",Me?he=+he+1:ge=+ge+1),Oe=le+he+"."+ge+"."+pe):Me?Oe=">="+he+".0.0 <"+(+he+1)+".0.0":Ue&&(Oe=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0"),v("xRange return",Oe),Oe})}(Ae,De)}).join(" ")}(de,Le),v("xrange",de),de=function(ye,De){return v("replaceStars",ye,De),ye.trim().replace(L[A],"")}(de,Le),v("stars",de),de}(Se,G)}).join(" ").split(/\s+/);return this.loose&&(ae=ae.filter(function(Se){return!!Se.match(oe)})),ae=ae.map(function(Se){return new we(Se,G)})},ve.prototype.intersects=function(V,G){if(!(V instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(oe){return V.set.some(function(ae){return ae.every(function(Se){return oe.intersects(Se,G)})})})})},t.toComparators=function(V,G){return new ve(V,G).set.map(function(K){return K.map(function(oe){return oe.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new j(V,this.loose));for(var G=0;G<this.set.length;G++)if(Be(this.set[G],V))return!0;return!1},t.satisfies=xe,t.maxSatisfying=function(V,G,K){var oe=null,ae=null;try{var Se=new ve(G,K)}catch(de){return null}return V.forEach(function(de){Se.test(de)&&(oe&&ae.compare(de)!==-1||(ae=new j(oe=de,K)))}),oe},t.minSatisfying=function(V,G,K){var oe=null,ae=null;try{var Se=new ve(G,K)}catch(de){return null}return V.forEach(function(de){Se.test(de)&&(oe&&ae.compare(de)!==1||(ae=new j(oe=de,K)))}),oe},t.validRange=function(V,G){try{return new ve(V,G).range||"*"}catch(K){return null}},t.ltr=function(V,G,K){return ze(V,G,"<",K)},t.gtr=function(V,G,K){return ze(V,G,">",K)},t.outside=ze,t.prerelease=function(V,G){var K=z(V,G);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(V,G,K){return V=new ve(V,K),G=new ve(G,K),V.intersects(G)},t.coerce=function(V){if(V instanceof j)return V;if(typeof V!="string")return null;var G=V.match(L[x]);return G==null?null:z((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,m(1))},function(q,t){var m,T,v=q.exports={};function I(){throw new Error("setTimeout has not been defined")}function F(){throw new Error("clearTimeout has not been defined")}function L(D){if(m===setTimeout)return setTimeout(D,0);if((m===I||!m)&&setTimeout)return m=setTimeout,setTimeout(D,0);try{return m(D,0)}catch(b){try{return m.call(null,D,0)}catch(R){return m.call(this,D,0)}}}(function(){try{m=typeof setTimeout=="function"?setTimeout:I}catch(D){m=I}try{T=typeof clearTimeout=="function"?clearTimeout:F}catch(D){T=F}})();var c,d=[],S=!1,p=-1;function y(){S&&c&&(S=!1,c.length?d=c.concat(d):p=-1,d.length&&O())}function O(){if(!S){var D=L(y);S=!0;for(var b=d.length;b;){for(c=d,d=[];++p<b;)c&&c[p].run();p=-1,b=d.length}c=null,S=!1,function(R){if(T===clearTimeout)return clearTimeout(R);if((T===F||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(R);try{T(R)}catch(f){try{return T.call(null,R)}catch(r){return T.call(this,R)}}}(D)}}function l(D,b){this.fun=D,this.array=b}function u(){}v.nextTick=function(D){var b=new Array(arguments.length-1);if(arguments.length>1)for(var R=1;R<arguments.length;R++)b[R-1]=arguments[R];d.push(new l(D,b)),d.length!==1||S||L(O)},l.prototype.run=function(){this.fun.apply(null,this.array)},v.title="browser",v.browser=!0,v.env={},v.argv=[],v.version="",v.versions={},v.on=u,v.addListener=u,v.once=u,v.off=u,v.removeListener=u,v.removeAllListeners=u,v.emit=u,v.prependListener=u,v.prependOnceListener=u,v.listeners=function(D){return[]},v.binding=function(D){throw new Error("process.binding is not supported")},v.cwd=function(){return"/"},v.chdir=function(D){throw new Error("process.chdir is not supported")},v.umask=function(){return 0}}])}),define(Z[37],te([0,1,8,2]),function(q,t,m,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function v(f){const r=f;return r?[r.on,r.pause,r.resume,r.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=v;function I(f){const r=f;return r?v(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}t.isReadableBufferedStream=I;function F(f,r){return new L(f,r)}t.newWriteableStream=F;class L{constructor(r,s){this.reducer=r,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(s=>s(r))}emitError(r){this.listeners.error.length===0?(0,m.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(s=>s(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,s){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(r,s){if(this.state.destroyed)return;let e;switch(r){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(s);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(f,r){const s=[];let e;for(;(e=f.read())!==null;)s.push(e);return r(s)}t.consumeReadable=c;function d(f,r,s){const e=[];let i;for(;(i=f.read())!==null&&e.length<s;)e.push(i);return i===null&&e.length>0?r(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return f.read()}}}t.peekReadable=d;function S(f,r){return new Promise((s,e)=>{const i=[];p(f,{onData:n=>{r&&i.push(n)},onError:n=>{r?e(n):s(void 0)},onEnd:()=>{s(r?r(i):void 0)}})})}t.consumeStream=S;function p(f,r){f.on("error",s=>r.onError(s)),f.on("end",()=>r.onEnd()),f.on("data",s=>r.onData(s))}t.listenStream=p;function y(f,r){return new Promise((s,e)=>{const i=new T.DisposableStore,n=[],o=g=>{if(n.push(g),n.length>r)return i.dispose(),f.pause(),s({stream:f,buffer:n,ended:!1})},a=g=>e(g),h=()=>s({stream:f,buffer:n,ended:!0});i.add((0,T.toDisposable)(()=>f.removeListener("error",a))),f.on("error",a),i.add((0,T.toDisposable)(()=>f.removeListener("end",h))),f.on("end",h),i.add((0,T.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}t.peekStream=y;function O(f,r){const s=F(r);return s.end(f),s}t.toStream=O;function l(){const f=F(()=>{throw new Error("not supported")});return f.end(),f}t.emptyStream=l;function u(f){let r=!1;return{read:()=>r?null:(r=!0,f)}}t.toReadable=u;function D(f,r,s){const e=F(s);return p(f,{onData:i=>e.write(r.data(i)),onError:i=>e.error(r.error?r.error(i):i),onEnd:()=>e.end()}),e}t.transform=D;function b(f,r,s){let e=!1;return{read:()=>{const i=r.read();return e?i:(e=!0,i!==null?s([f,i]):f)}}}t.prefixedReadable=b;function R(f,r,s){let e=!1;const i=F(s);return p(r,{onData:n=>e?i.write(n):(e=!0,i.write(s([f,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(f)),i.end()}}),i}t.prefixedStream=R}),define(Z[16],te([0,1,37,18]),function(q,t,m,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const v=typeof Buffer!="undefined",I=typeof TextEncoder!="undefined",F=typeof TextDecoder!="undefined";let L,c;class d{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return v?new d(Buffer.allocUnsafe(g)):new d(new Uint8Array(g))}static wrap(g){return v&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new d(g)}static fromString(g,k){return!(k?.dontUseNodeBuffer||!1)&&v?new d(Buffer.from(g)):I?(L||(L=new TextEncoder),new d(L.encode(g))):new d(T.encodeUTF8(g))}static concat(g,k){if(typeof k=="undefined"){k=0;for(let x=0,_=g.length;x<_;x++)k+=g[x].byteLength}const P=d.alloc(k);let N=0;for(let x=0,_=g.length;x<_;x++){const J=g[x];P.set(J,N),N+=J.byteLength}return P}toString(){return v?this.buffer.toString():F?(c||(c=new TextDecoder),c.decode(this.buffer)):T.decodeUTF8(this.buffer)}slice(g,k){return new d(this.buffer.subarray(g,k))}set(g,k){g instanceof d?this.buffer.set(g.buffer,k):this.buffer.set(g,k)}readUInt32BE(g){return y(this.buffer,g)}writeUInt32BE(g,k){O(this.buffer,g,k)}readUInt32LE(g){return l(this.buffer,g)}writeUInt32LE(g,k){u(this.buffer,g,k)}readUInt8(g){return D(this.buffer,g)}writeUInt8(g,k){b(this.buffer,g,k)}}t.VSBuffer=d;function S(h,g){return h[g+0]<<0>>>0|h[g+1]<<8>>>0}t.readUInt16LE=S;function p(h,g,k){h[k+0]=g&255,g=g>>>8,h[k+1]=g&255}t.writeUInt16LE=p;function y(h,g){return h[g]*2**24+h[g+1]*2**16+h[g+2]*2**8+h[g+3]}t.readUInt32BE=y;function O(h,g,k){h[k+3]=g,g=g>>>8,h[k+2]=g,g=g>>>8,h[k+1]=g,g=g>>>8,h[k]=g}t.writeUInt32BE=O;function l(h,g){return h[g+0]<<0>>>0|h[g+1]<<8>>>0|h[g+2]<<16>>>0|h[g+3]<<24>>>0}t.readUInt32LE=l;function u(h,g,k){h[k+0]=g&255,g=g>>>8,h[k+1]=g&255,g=g>>>8,h[k+2]=g&255,g=g>>>8,h[k+3]=g&255}t.writeUInt32LE=u;function D(h,g){return h[g]}t.readUInt8=D;function b(h,g,k){h[k]=g}t.writeUInt8=b;function R(h){return m.consumeReadable(h,g=>d.concat(g))}t.readableToBuffer=R;function f(h){return m.toReadable(h)}t.bufferToReadable=f;function r(h){return m.consumeStream(h,g=>d.concat(g))}t.streamToBuffer=r;async function s(h){return h.ended?d.concat(h.buffer):d.concat([...h.buffer,await r(h.stream)])}t.bufferedStreamToBuffer=s;function e(h){return m.toStream(h,g=>d.concat(g))}t.bufferToStream=e;function i(h){return m.transform(h,{data:g=>typeof g=="string"?d.fromString(g):d.wrap(g)},g=>d.concat(g))}t.streamToBufferReadableStream=i;function n(h){return m.newWriteableStream(g=>d.concat(g),h)}t.newWriteableBufferStream=n;function o(h,g){return m.prefixedReadable(h,g,k=>d.concat(k))}t.prefixedBufferReadable=o;function a(h,g){return m.prefixedStream(h,g,k=>d.concat(k))}t.prefixedBufferStream=a}),define(Z[19],te([0,1,13]),function(q,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function T(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const D=Array.isArray(u)?[]:{};return Object.keys(u).forEach(b=>{u[b]&&typeof u[b]=="object"?D[b]=T(u[b]):D[b]=u[b]}),D}t.deepClone=T;function v(u){if(!u||typeof u!="object")return u;const D=[u];for(;D.length>0;){const b=D.shift();Object.freeze(b);for(const R in b)if(I.call(b,R)){const f=b[R];typeof f=="object"&&!Object.isFrozen(f)&&D.push(f)}}return u}t.deepFreeze=v;const I=Object.prototype.hasOwnProperty;function F(u,D){return L(u,D,new Set)}t.cloneAndChange=F;function L(u,D,b){if((0,m.isUndefinedOrNull)(u))return u;const R=D(u);if(typeof R!="undefined")return R;if((0,m.isArray)(u)){const f=[];for(const r of u)f.push(L(r,D,b));return f}if((0,m.isObject)(u)){if(b.has(u))throw new Error("Cannot clone recursive data-structure");b.add(u);const f={};for(let r in u)I.call(u,r)&&(f[r]=L(u[r],D,b));return b.delete(u),f}return u}function c(u,D,b=!0){return(0,m.isObject)(u)?((0,m.isObject)(D)&&Object.keys(D).forEach(R=>{R in u?b&&((0,m.isObject)(u[R])&&(0,m.isObject)(D[R])?c(u[R],D[R],b):u[R]=D[R]):u[R]=D[R]}),u):D}t.mixin=c;function d(u,D){if(u===D)return!0;if(u==null||D===null||D===void 0||typeof u!=typeof D||typeof u!="object"||Array.isArray(u)!==Array.isArray(D))return!1;let b,R;if(Array.isArray(u)){if(u.length!==D.length)return!1;for(b=0;b<u.length;b++)if(!d(u[b],D[b]))return!1}else{const f=[];for(R in u)f.push(R);f.sort();const r=[];for(R in D)r.push(R);if(r.sort(),!d(f,r))return!1;for(b=0;b<f.length;b++)if(!d(u[f[b]],D[f[b]]))return!1}return!0}t.equals=d;function S(u){const D=new Set;return JSON.stringify(u,(b,R)=>{if((0,m.isObject)(R)||Array.isArray(R)){if(D.has(R))return"[Circular]";D.add(R)}return R})}t.safeStringify=S;function p(u,D,b){const R=D(u);return typeof R=="undefined"?b:R}t.getOrDefault=p;function y(u,D){const b=Object.create(null);return!u||!D||Object.keys(D).forEach(f=>{const r=u[f],s=D[f];d(r,s)||(b[f]=s)}),b}t.distinct=y;function O(u,D){const b=D.toLowerCase(),R=Object.keys(u).find(f=>f.toLowerCase()===b);return R?u[R]:u[D]}t.getCaseInsensitive=O;function l(u,D){const b=Object.create(null);for(const R of Object.keys(u))D(R,u[R])&&(b[R]=u[R]);return b}t.filter=l}),define(Z[59],te([0,1,7]),function(q,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function T(d){const S=d;return S&&typeof S.type=="string"&&typeof S.severity=="string"}t.isRemoteConsoleLog=T;function v(d){const S=[];let p;try{const y=JSON.parse(d.arguments),O=y[y.length-1];O&&O.__$stack&&(y.pop(),p=O.__$stack),S.push(...y)}catch(y){S.push("Unable to log remote console arguments",d.arguments)}return{args:S,stack:p}}t.parse=v;function I(d){if(typeof d!="string")return I(v(d).stack);const S=d;if(S){const p=F(S),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(y&&y.length===4)return{uri:m.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}t.getFirstFrame=I;function F(d){if(!d)return d;const S=d.indexOf(`
`);return S===-1?d:d.substring(0,S)}function L(d,S){const{args:p,stack:y}=v(d),O=typeof p[0]=="string"&&p.length===1;let l=F(y);l&&(l=`(${l.trim()})`);let u=[];if(typeof p[0]=="string"?l&&O?u=[`%c[${S}] %c${p[0]} %c${l}`,c("blue"),c(""),c("grey")]:u=[`%c[${S}] %c${p[0]}`,c("blue"),c(""),...p.slice(1)]:u=[`%c[${S}]%`,c("blue"),...p],l&&!O&&u.push(l),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,u)}t.log=L;function c(d){return`color: ${d}`}}),define(Z[60],te([0,1,16,18,7]),function(q,t,m,T,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function I(S){return JSON.stringify(S,c)}t.stringify=I;function F(S){let p=JSON.parse(S);return p=d(p),p}t.parse=F;var L;(function(S){S[S.Uri=1]="Uri",S[S.Regexp=2]="Regexp",S[S.ScmResource=3]="ScmResource",S[S.ScmResourceGroup=4]="ScmResourceGroup",S[S.ScmProvider=5]="ScmProvider",S[S.CommentController=6]="CommentController",S[S.CommentThread=7]="CommentThread",S[S.CommentThreadReply=8]="CommentThreadReply",S[S.CommentNode=9]="CommentNode",S[S.CommentThreadNode=10]="CommentThreadNode",S[S.TimelineActionContext=11]="TimelineActionContext",S[S.NotebookCellActionContext=12]="NotebookCellActionContext",S[S.TestItemContext=13]="TestItemContext"})(L=t.MarshalledId||(t.MarshalledId={}));function c(S,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,T.regExpFlags)(p)}:p}function d(S,p=0){if(!S||p>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return v.URI.revive(S);case 2:return new RegExp(S.source,S.flags)}if(S instanceof m.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let y=0;y<S.length;++y)S[y]=d(S[y],p+1);else for(const y in S)Object.hasOwnProperty.call(S,y)&&(S[y]=d(S[y],p+1))}return S}t.revive=d}),define(Z[61],te([0,1,3,31,45,4,18]),function(q,t,m,T,v,I,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function L(){return Object.create(null)}t.getEmptyExpression=L;const c="**",d="/",S="[/\\\\]",p="[^/\\\\]",y=/\//g;function O(w){switch(w){case 0:return"";case 1:return`${p}*?`;default:return`(?:${S}|${p}+${S}|${S}${p}+)*?`}}function l(w,M){if(!w)return[];const E=[];let A=!1,C=!1,z="";for(const j of w){switch(j){case M:if(!A&&!C){E.push(z),z="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":C=!0;break;case"]":C=!1;break}z+=j}return z&&E.push(z),E}t.splitGlobAware=l;function u(w){if(!w)return"";let M="";const E=l(w,d);if(E.every(A=>A===c))M=".*";else{let A=!1;E.forEach((C,z)=>{if(C===c){A||(M+=O(2),A=!0);return}let j=!1,$="",H=!1,ee="";for(const ne of C){if(ne!=="}"&&j){$+=ne;continue}if(H&&(ne!=="]"||!ee)){let re;ne==="-"?re=ne:(ne==="^"||ne==="!")&&!ee?re="^":ne===d?re="":re=F.escapeRegExpCharacters(ne),ee+=re;continue}switch(ne){case"{":j=!0;continue;case"[":H=!0;continue;case"}":M+=`(?:${l($,",").map(me=>u(me)).join("|")})`,j=!1,$="";break;case"]":M+="["+ee+"]",H=!1,ee="";break;case"?":M+=p;continue;case"*":M+=O(1);continue;default:M+=F.escapeRegExpCharacters(ne)}}z<E.length-1&&(E[z+1]!==c||z+2<E.length)&&(M+=S),A=!1})}return M}const D=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,R=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new v.LRUCache(1e4),i=function(){return!1},n=function(){return null};function o(w,M){if(!w)return n;let E;typeof w!="string"?E=w.pattern:E=w,E=E.trim();const A=`${E}_${!!M.trimForExclusions}`;let C=e.get(A);if(C)return a(C,w);let z;if(D.test(E)){const j=E.substr(4);C=function($,H){return typeof $=="string"&&$.endsWith(j)?E:null}}else(z=b.exec(h(E,M)))?C=g(z[1],E):(M.trimForExclusions?f:R).test(E)?C=k(E,M):(z=r.exec(h(E,M)))?C=P(z[1].substr(1),E,!0):(z=s.exec(h(E,M)))?C=P(z[1],E,!1):C=N(E);return e.set(A,C),a(C,w)}function a(w,M){return typeof M=="string"?w:function(E,A){return T.isEqualOrParent(E,M.base)?w(I.relative(M.base,E),A):null}}function h(w,M){return M.trimForExclusions&&w.endsWith("/**")?w.substr(0,w.length-2):w}function g(w,M){const E=`/${w}`,A=`\\${w}`,C=function(j,$){return typeof j!="string"?null:$?$===w?M:null:j===w||j.endsWith(E)||j.endsWith(A)?M:null},z=[w];return C.basenames=z,C.patterns=[M],C.allBasenames=z,C}function k(w,M){const E=U(w.slice(1,-1).split(",").map($=>o($,M)).filter($=>$!==n),w),A=E.length;if(!A)return n;if(A===1)return E[0];const C=function($,H){for(let ee=0,ne=E.length;ee<ne;ee++)if(E[ee]($,H))return w;return null},z=E.find($=>!!$.allBasenames);z&&(C.allBasenames=z.allBasenames);const j=E.reduce(($,H)=>H.allPaths?$.concat(H.allPaths):$,[]);return j.length&&(C.allPaths=j),C}function P(w,M,E){const A=I.sep===I.posix.sep,C=A?w:w.replace(y,I.sep),z=I.sep+C,j=I.posix.sep+w,$=E?function(H,ee){return typeof H=="string"&&(H===C||H.endsWith(z)||!A&&(H===w||H.endsWith(j)))?M:null}:function(H,ee){return typeof H=="string"&&(H===C||!A&&H===w)?M:null};return $.allPaths=[(E?"*/":"./")+w],$}function N(w){try{const M=new RegExp(`^${u(w)}$`);return function(E){return M.lastIndex=0,typeof E=="string"&&M.test(E)?w:null}}catch(M){return n}}function x(w,M,E){return!w||typeof M!="string"?!1:_(w)(M,void 0,E)}t.match=x;function _(w,M={}){if(!w)return i;if(typeof w=="string"||Y(w)){const E=o(w,M);if(E===n)return i;const A=function(C,z){return!!E(C,z)};return E.allBasenames&&(A.allBasenames=E.allBasenames),E.allPaths&&(A.allPaths=E.allPaths),A}return B(w,M)}t.parse=_;function J(w){if(!w)return;let M;return E=>(M||(M=(w()||Promise.resolve([])).then(A=>A?se(A):{})),M.then(A=>!!A[E]))}t.hasSiblingPromiseFn=J;function ie(w){if(!w)return;let M;return E=>{if(!M){const A=w();M=A?se(A):{}}return!!M[E]}}t.hasSiblingFn=ie;function se(w){const M={};for(const E of w)M[E]=!0;return M}function Y(w){const M=w;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}t.isRelativePattern=Y;function X(w){return w.allBasenames||[]}t.getBasenameTerms=X;function Q(w){return w.allPaths||[]}t.getPathTerms=Q;function B(w,M){const E=U(Object.getOwnPropertyNames(w).map($=>W($,w[$],M)).filter($=>$!==n)),A=E.length;if(!A)return n;if(!E.some($=>!!$.requiresSiblings)){if(A===1)return E[0];const $=function(ne,re){for(let ce=0,me=E.length;ce<me;ce++){const be=E[ce](ne,re);if(be)return be}return null},H=E.find(ne=>!!ne.allBasenames);H&&($.allBasenames=H.allBasenames);const ee=E.reduce((ne,re)=>re.allPaths?ne.concat(re.allPaths):ne,[]);return ee.length&&($.allPaths=ee),$}const C=function($,H,ee){let ne;for(let re=0,ce=E.length;re<ce;re++){const me=E[re];me.requiresSiblings&&ee&&(H||(H=I.basename($)),ne||(ne=H.substr(0,H.length-I.extname($).length)));const be=me($,H,ne,ee);if(be)return be}return null},z=E.find($=>!!$.allBasenames);z&&(C.allBasenames=z.allBasenames);const j=E.reduce(($,H)=>H.allPaths?$.concat(H.allPaths):$,[]);return j.length&&(C.allPaths=j),C}function W(w,M,E){if(M===!1)return n;const A=o(w,E);if(A===n)return n;if(typeof M=="boolean")return A;if(M){const C=M.when;if(typeof C=="string"){const z=(j,$,H,ee)=>{if(!ee||!A(j,$))return null;const ne=C.replace("$(basename)",H),re=ee(ne);return(0,m.isThenable)(re)?re.then(ce=>ce?w:null):re?w:null};return z.requiresSiblings=!0,z}}return A}function U(w,M){const E=w.filter($=>!!$.basenames);if(E.length<2)return w;const A=E.reduce(($,H)=>{const ee=H.basenames;return ee?$.concat(ee):$},[]);let C;if(M){C=[];for(let $=0,H=A.length;$<H;$++)C.push(M)}else C=E.reduce(($,H)=>{const ee=H.patterns;return ee?$.concat(ee):$},[]);const z=function($,H){if(typeof $!="string")return null;if(!H){let ne;for(ne=$.length;ne>0;ne--){const re=$.charCodeAt(ne-1);if(re===47||re===92)break}H=$.substr(ne)}const ee=A.indexOf(H);return ee!==-1?C[ee]:null};z.basenames=A,z.patterns=C,z.allBasenames=A;const j=w.filter($=>!$.basenames);return j.push(z),j}}),define(Z[62],te([0,1,31,9,4,10,20,18,7]),function(q,t,m,T,v,I,F,L,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(o,a,h){if(typeof o=="string"&&(o=c.URI.file(o)),h){const k=h.getWorkspaceFolder(o);if(k){const P=h.getWorkspace().folders.length>1;let N;if((0,F.isEqual)(k.uri,o)?N="":N=(0,F.relativePath)(k.uri,o),P){const x=k.name?k.name:(0,F.basename)(k.uri);N=N?x+" \u2022 "+N:x}return N}}if(o.scheme!==T.Schemas.file&&o.scheme!==T.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(o.fsPath))return(0,v.normalize)(p(o.fsPath));let g=(0,v.normalize)(o.fsPath);return!I.isWindows&&a?.userHome&&(g=O(g,a.userHome.fsPath)),g}t.getPathLabel=d;function S(o){if(!o)return;typeof o=="string"&&(o=c.URI.file(o));const a=(0,F.basename)(o)||(o.scheme===T.Schemas.file?o.fsPath:o.path);return I.isWindows&&(0,m.isRootOrDriveLetter)(a)?p(a):a}t.getBaseLabel=S;function p(o){return(0,m.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}t.normalizeDriveLetter=p;let y=Object.create(null);function O(o,a){if(I.isWindows||!o||!a)return o;let h=y.original===a?y.normalized:void 0;return h||(h=`${(0,L.rtrim)(a,v.posix.sep)}${v.posix.sep}`,y={original:a,normalized:h}),(I.isLinux?o.startsWith(h):(0,L.startsWithIgnoreCase)(o,h))&&(o=`~/${o.substr(h.length)}`),o}t.tildify=O;function l(o,a){return o.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=l;const u="\u2026",D="\\\\",b="~";function R(o,a=v.sep){const h=new Array(o.length);let g=!1;for(let k=0;k<o.length;k++){let P=o[k];if(P===""){h[k]=`.${a}`;continue}if(!P){h[k]=P;continue}g=!0;let N="";P.indexOf(D)===0?(N=P.substr(0,P.indexOf(D)+D.length),P=P.substr(P.indexOf(D)+D.length)):P.indexOf(a)===0?(N=P.substr(0,P.indexOf(a)+a.length),P=P.substr(P.indexOf(a)+a.length)):P.indexOf(b)===0&&(N=P.substr(0,P.indexOf(b)+b.length),P=P.substr(P.indexOf(b)+b.length));const x=P.split(a);for(let _=1;g&&_<=x.length;_++)for(let J=x.length-_;g&&J>=0;J--){g=!1;let ie=x.slice(J,J+_).join(a);for(let se=0;!g&&se<o.length;se++)if(se!==k&&o[se]&&o[se].indexOf(ie)>-1){const Y=J+_===x.length,X=J>0&&o[se].indexOf(a)>-1?a+ie:ie,Q=o[se].endsWith(X);g=!Y||Q}if(!g){let se="";(x[0].endsWith(":")||N!=="")&&(J===1&&(J=0,_++,ie=x[0]+a+ie),J>0&&(se=x[0]+a),se=N+se),J>0&&(se=se+u+a),se=se+ie,J+_<x.length&&(se=se+a+u),h[k]=se}}g&&(h[k]=P)}return h}t.shorten=R;var f;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function r(o,a=Object.create(null)){const h=[];let g=!1,k="";for(const P of o)if(P==="$"||g&&P==="{")k&&h.push({value:k,type:f.TEXT}),k="",g=!0;else if(P==="}"&&g){const N=a[k];if(typeof N=="string")N.length&&h.push({value:N,type:f.VARIABLE});else if(N){const x=h[h.length-1];(!x||x.type!==f.SEPARATOR)&&h.push({value:N.label,type:f.SEPARATOR})}k="",g=!1}else k+=P;return k&&!g&&h.push({value:k,type:f.TEXT}),h.filter((P,N)=>{if(P.type===f.SEPARATOR){const x=h[N-1],_=h[N+1];return[x,_].every(J=>J&&(J.type===f.VARIABLE||J.type===f.TEXT)&&J.value.length>0)}return!0}).map(P=>P.value).join("")}t.template=r;function s(o,a){return I.isMacintosh||a?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):o.replace(/&&|&/g,h=>h==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(o,a){return I.isMacintosh||a?o.replace(/\(&&\w\)|&&/g,""):I.isWindows?o.replace(/&&|&/g,h=>h==="&"?"&&":"&"):o.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(o){return o.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(o){const a=o.indexOf("/")!==-1?v.posix:v.win32,h=a.basename(o),g=a.dirname(o);return h.length?{name:h,parentPath:g}:{name:g,parentPath:""}}t.splitName=n}),define(Z[46],te([0,1,126]),function(q,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class T{constructor(I="utf8"){this.stringDecoder=new m.StringDecoder(I),this.remaining=null}write(I){const F=[],L=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(L.length<1)return F;let c=0,d,S=c;for(;S<L.length;)if(d=L.charCodeAt(S),d===13||d===10){if(F.push(L.substring(c,S)),S++,S<L.length){const p=d;d=L.charCodeAt(S),(p===13&&d===10||p===10&&d===13)&&S++}c=S}else S++;return this.remaining=c<L.length?L.substr(c):null,F}end(){return this.remaining}}t.LineDecoder=T}),define(Z[63],te([0,1,38,4,18,11]),function(q,t,m,T,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function F(S){const p=(0,T.dirname)(S);if(S===p)return S;const y=((0,T.basename)(S)||S).toLowerCase();try{const l=(0,I.readdirSync)(p).filter(u=>u.toLowerCase()===y);if(l.length===1){const u=F(p);if(u)return(0,T.join)(u,l[0])}else if(l.length>1){const u=l.indexOf(y);if(u>=0){const D=F(p);if(D)return(0,T.join)(D,l[u])}}}catch(O){}return null}t.realcaseSync=F;async function L(S){try{return await I.Promises.realpath(S)}catch(p){const y=d(S);return await I.Promises.access(y,m.constants.R_OK),y}}t.realpath=L;function c(S){try{return m.realpathSync(S)}catch(p){const y=d(S);return m.accessSync(y,m.constants.R_OK),y}}t.realpathSync=c;function d(S){return(0,v.rtrim)((0,T.normalize)(S),T.sep)}}),define(Z[64],te([0,1,32,4,11]),function(q,t,m,T,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,F=/^Microsoft.PowerShell_.*/,L=/^Microsoft.PowerShellPreview_.*/;var c;(function(r){r[r.x64=0]="x64",r[r.x86=1]="x86",r[r.ARM=2]="ARM"})(c||(c={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class p{constructor(s,e,i){this.exePath=s,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await v.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function y({useAlternateBitness:r=!1}={}){return r?d===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function O({useAlternateBitness:r=!1,findPreview:s=!1}={}){const e=y({useAlternateBitness:r});if(!e)return null;const i=T.join(e,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(i))return null;let n=-1,o=null;for(const g of await v.Promises.readdir(i)){let k=-1;if(s){const N=g.indexOf("-");if(N<0)continue;const x=g.substring(0,N);if(!I.test(x)||g.substring(N+1)!=="preview")continue;k=parseInt(x,10)}else{if(!I.test(g))continue;k=parseInt(g,10)}if(k<=n)continue;const P=T.join(i,g,"pwsh.exe");!await v.SymlinkSupport.existsFile(P)||(o=P,n=k)}if(!o)return null;const a=e.includes("x86")?" (x86)":"",h=s?" Preview":"";return new p(o,`PowerShell${h}${a}`,!0)}async function l({findPreview:r}={}){if(!process.env.LOCALAPPDATA)return null;const s=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=r?{pwshMsixDirRegex:L,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:F,pwshMsixName:"PowerShell (Store)"};for(const n of await v.Promises.readdir(s))if(e.test(n)){const o=T.join(s,n,"pwsh.exe");return new p(o,i)}return null}function u(){const r=T.join(m.homedir(),".dotnet","tools","pwsh.exe");return new p(r,".NET Core PowerShell Global Tool")}function D(){const r=T.join(process.env.windir,d===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(r,"Windows PowerShell",!0)}async function*b(){let r=await O();r&&(yield r),r=await O({useAlternateBitness:!0}),r&&(yield r),r=await l(),r&&(yield r),r=u(),r&&(yield r),r=await O({findPreview:!0}),r&&(yield r),r=await l({findPreview:!0}),r&&(yield r),r=await O({useAlternateBitness:!0,findPreview:!0}),r&&(yield r),r=D(),r&&(yield r)}async function*R(){for await(const r of b())await r.exists()&&(yield r)}t.enumeratePowerShellInstallations=R;async function f(){for await(const r of R())return r;return null}t.getFirstAvailablePowerShellInstallation=f}),define(Z[65],te([0,1,38,31,2,127,4,10,11]),function(q,t,m,T,v,I,F,L,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function d(y,O,l){return p({path:y,isDirectory:!1},O,l)}t.watchFile=d;function S(y,O,l){return p({path:y,isDirectory:!0},O,l)}t.watchFolder=S,t.CHANGE_BUFFER_DELAY=100;function p(y,O,l){if(L.isMacintosh&&(0,T.isEqualOrParent)(y.path,"/Volumes/"))return l(`Refusing to watch ${y.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),v.Disposable.None;const u=(0,F.basename)(y.path),D=new Map;let b=!1,R=[(0,v.toDisposable)(()=>{D.forEach(f=>(0,v.dispose)(f)),D.clear()})];try{const f=(0,m.watch)(y.path);R.push((0,v.toDisposable)(()=>{f.removeAllListeners(),f.close()}));const r=new Set;y.isDirectory&&c.Promises.readdir(y.path).then(s=>s.forEach(e=>r.add(e))),f.on("error",(s,e)=>{b||l(`Failed to watch ${y.path} for changes using fs.watch() (${s}, ${e})`)}),f.on("change",(s,e)=>{if(b)return;let i="";if(e&&(i=e.toString(),L.isMacintosh&&(i=(0,I.normalizeNFC)(i))),!i||s!=="change"&&s!=="rename")return;const n=y.isDirectory?(0,F.join)(y.path,i):y.path;if(y.isDirectory)if(s==="rename"){const o=D.get(n);o&&(0,v.dispose)(o);const a=setTimeout(async()=>{D.delete(n);const h=await c.Promises.exists(n);if(b)return;let g;h?r.has(i)?g="changed":(g="added",r.add(i)):(r.delete(i),g="deleted"),O(g,n)},t.CHANGE_BUFFER_DELAY);D.set(n,(0,v.toDisposable)(()=>clearTimeout(a)))}else{let o;r.has(i)?o="changed":(o="added",r.add(i)),O(o,n)}else if(s==="rename"||i!==u){const o=setTimeout(async()=>{const a=await c.Promises.exists(n);b||(a?(O("changed",n),R=[p(y,O,l)]):O("deleted",n))},t.CHANGE_BUFFER_DELAY);(0,v.dispose)(R),R=[(0,v.toDisposable)(()=>clearTimeout(o))]}else O("changed",n)})}catch(f){c.Promises.exists(y.path).then(r=>{r&&!b&&l(`Failed to watch ${y.path} for changes using fs.watch() (${f.toString()})`)})}return(0,v.toDisposable)(()=>{b=!0,R=(0,v.dispose)(R)})}});var ue=this&&this.__decorate||function(q,t,m,T){var v=arguments.length,I=v<3?t:T===null?T=Object.getOwnPropertyDescriptor(t,m):T,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(q,t,m,T);else for(var L=q.length-1;L>=0;L--)(F=q[L])&&(I=(v<3?F(I):v>3?F(t,m,I):F(t,m))||I);return v>3&&I&&Object.defineProperty(t,m,I),I};define(Z[39],te([0,1,24,3,16,26,44,8,14,2,60,18,13]),function(q,t,m,T,v,I,F,L,c,d,S,p,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var O;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(O=t.RequestType||(t.RequestType={}));function l(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(u=t.ResponseType||(t.ResponseType={}));function D(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(b||(b={}));class R{constructor(w){this.buffer=w,this.pos=0}read(w){const M=this.buffer.slice(this.pos,this.pos+w);return this.pos+=M.byteLength,M}}class f{constructor(){this.buffers=[]}get buffer(){return v.VSBuffer.concat(this.buffers)}write(w){this.buffers.push(w)}}var r;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(r||(r={}));function s(U){const w=v.VSBuffer.alloc(4);return w.writeUInt32BE(U,0),w}function e(U){return U.read(4).readUInt32BE(0)}function i(U){const w=v.VSBuffer.alloc(1);return w.writeUInt8(U,0),w}const n={Undefined:i(r.Undefined),String:i(r.String),Buffer:i(r.Buffer),VSBuffer:i(r.VSBuffer),Array:i(r.Array),Object:i(r.Object)},o=typeof Buffer!="undefined";function a(U,w){if(typeof w=="undefined")U.write(n.Undefined);else if(typeof w=="string"){const M=v.VSBuffer.fromString(w);U.write(n.String),U.write(s(M.byteLength)),U.write(M)}else if(o&&Buffer.isBuffer(w)){const M=v.VSBuffer.wrap(w);U.write(n.Buffer),U.write(s(M.byteLength)),U.write(M)}else if(w instanceof v.VSBuffer)U.write(n.VSBuffer),U.write(s(w.byteLength)),U.write(w);else if(Array.isArray(w)){U.write(n.Array),U.write(s(w.length));for(const M of w)a(U,M)}else{const M=v.VSBuffer.fromString(JSON.stringify(w));U.write(n.Object),U.write(s(M.byteLength)),U.write(M)}}function h(U){switch(U.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return U.read(e(U)).toString();case r.Buffer:return U.read(e(U)).buffer;case r.VSBuffer:return U.read(e(U));case r.Array:{const M=e(U),E=[];for(let A=0;A<M;A++)E.push(h(U));return E}case r.Object:return JSON.parse(U.read(e(U)).toString())}}class g{constructor(w,M,E=null,A=1e3){this.protocol=w,this.ctx=M,this.logger=E,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(C=>this.onRawMessage(C)),this.sendResponse({type:200})}registerChannel(w,M){this.channels.set(w,M),setTimeout(()=>this.flushPendingRequests(w),0)}sendResponse(w){switch(w.type){case 200:{const M=this.send([w.type]);this.logger&&this.logger.logOutgoing(M,0,1,D(w.type));return}case 201:case 202:case 204:case 203:{const M=this.send([w.type,w.id],w.data);this.logger&&this.logger.logOutgoing(M,w.id,1,D(w.type),w.data);return}}}send(w,M=void 0){const E=new f;return a(E,w),a(E,M),this.sendBuffer(E.buffer)}sendBuffer(w){try{return this.protocol.send(w),w.byteLength}catch(M){return 0}}onRawMessage(w){const M=new R(w),E=h(M),A=h(M),C=E[0];switch(C){case 100:return this.logger&&this.logger.logIncoming(w.byteLength,E[1],1,`${l(C)}: ${E[2]}.${E[3]}`,A),this.onPromise({type:C,id:E[1],channelName:E[2],name:E[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(w.byteLength,E[1],1,`${l(C)}: ${E[2]}.${E[3]}`,A),this.onEventListen({type:C,id:E[1],channelName:E[2],name:E[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(w.byteLength,E[1],1,`${l(C)}`),this.disposeActiveRequest({type:C,id:E[1]});case 103:return this.logger&&this.logger.logIncoming(w.byteLength,E[1],1,`${l(C)}`),this.disposeActiveRequest({type:C,id:E[1]})}}onPromise(w){const M=this.channels.get(w.channelName);if(!M){this.collectPendingRequest(w);return}const E=new I.CancellationTokenSource;let A;try{A=M.call(this.ctx,w.name,w.arg,E.token)}catch(j){A=Promise.reject(j)}const C=w.id;A.then(j=>{this.sendResponse({id:C,data:j,type:201}),this.activeRequests.delete(w.id)},j=>{j instanceof Error?this.sendResponse({id:C,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.sendResponse({id:C,data:j,type:203}),this.activeRequests.delete(w.id)});const z=(0,d.toDisposable)(()=>E.cancel());this.activeRequests.set(w.id,z)}onEventListen(w){const M=this.channels.get(w.channelName);if(!M){this.collectPendingRequest(w);return}const E=w.id,C=M.listen(this.ctx,w.name,w.arg)(z=>this.sendResponse({id:E,data:z,type:204}));this.activeRequests.set(w.id,C)}disposeActiveRequest(w){const M=this.activeRequests.get(w.id);M&&(M.dispose(),this.activeRequests.delete(w.id))}collectPendingRequest(w){let M=this.pendingRequests.get(w.channelName);M||(M=[],this.pendingRequests.set(w.channelName,M));const E=setTimeout(()=>{console.error(`Unknown channel: ${w.channelName}`),w.type===100&&this.sendResponse({id:w.id,data:{name:"Unknown channel",message:`Channel name '${w.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:w,timeoutTimer:E})}flushPendingRequests(w){const M=this.pendingRequests.get(w);if(M){for(const E of M)switch(clearTimeout(E.timeoutTimer),E.request.type){case 100:this.onPromise(E.request);break;case 102:this.onEventListen(E.request);break}this.pendingRequests.delete(w)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(w=>w.dispose()),this.activeRequests.clear()}}t.ChannelServer=g;var k;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(k=t.RequestInitiator||(t.RequestInitiator={}));class P{constructor(w,M=null){this.protocol=w,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(E=>this.onBuffer(E)),this.logger=M}getChannel(w){const M=this;return{call(E,A,C){return M.isDisposed?Promise.reject(L.canceled()):M.requestPromise(w,E,A,C)},listen(E,A){return M.isDisposed?Promise.reject(L.canceled()):M.requestEvent(w,E,A)}}}requestPromise(w,M,E,A=I.CancellationToken.None){const C=this.lastRequestId++,j={id:C,type:100,channelName:w,name:M,arg:E};if(A.isCancellationRequested)return Promise.reject(L.canceled());let $;return new Promise((ee,ne)=>{if(A.isCancellationRequested)return ne(L.canceled());const re=()=>{const ke=Te=>{switch(Te.type){case 201:this.handlers.delete(C),ee(Te.data);break;case 202:this.handlers.delete(C);const we=new Error(Te.data.message);we.stack=Te.data.stack,we.name=Te.data.name,ne(we);break;case 203:this.handlers.delete(C),ne(Te.data);break}};this.handlers.set(C,ke),this.sendRequest(j)};let ce=null;this.state===b.Idle?re():(ce=(0,T.createCancelablePromise)(ke=>this.whenInitialized()),ce.then(()=>{ce=null,re()}));const me=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:C,type:101}),ne(L.canceled())},be=A.onCancellationRequested(me);$=(0,d.combinedDisposable)((0,d.toDisposable)(me),be),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(w,M,E){const A=this.lastRequestId++,z={id:A,type:102,channelName:w,name:M,arg:E};let j=null;const $=new c.Emitter({onFirstListenerAdd:()=>{j=(0,T.createCancelablePromise)(ee=>this.whenInitialized()),j.then(()=>{j=null,this.activeRequests.add($),this.sendRequest(z)})},onLastListenerRemove:()=>{j?(j.cancel(),j=null):(this.activeRequests.delete($),this.sendRequest({id:A,type:103}))}}),H=ee=>$.fire(ee.data);return this.handlers.set(A,H),$.event}sendRequest(w){switch(w.type){case 100:case 102:{const M=this.send([w.type,w.id,w.channelName,w.name],w.arg);this.logger&&this.logger.logOutgoing(M,w.id,0,`${l(w.type)}: ${w.channelName}.${w.name}`,w.arg);return}case 101:case 103:{const M=this.send([w.type,w.id]);this.logger&&this.logger.logOutgoing(M,w.id,0,l(w.type));return}}}send(w,M=void 0){const E=new f;return a(E,w),a(E,M),this.sendBuffer(E.buffer)}sendBuffer(w){try{return this.protocol.send(w),w.byteLength}catch(M){return 0}}onBuffer(w){const M=new R(w),E=h(M),A=h(M),C=E[0];switch(C){case 200:return this.logger&&this.logger.logIncoming(w.byteLength,0,0,D(C)),this.onResponse({type:E[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(w.byteLength,E[1],0,D(C),A),this.onResponse({type:E[0],id:E[1],data:A})}}onResponse(w){if(w.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(w.id);M&&M(w)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(w=>w.dispose()),this.activeRequests.clear()}}ue([F.memoize],P.prototype,"onDidInitializePromise",null),t.ChannelClient=P;class N{constructor(w){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,w(({protocol:M,onDidClientDisconnect:E})=>{c.Event.once(M.onMessage)(C=>{const z=new R(C),j=h(z),$=new g(M,j),H=new P(M);this.channels.forEach((ne,re)=>$.registerChannel(re,ne));const ee={channelServer:$,channelClient:H,ctx:j};this._connections.add(ee),this._onDidAddConnection.fire(ee),E(()=>{$.dispose(),H.dispose(),this._connections.delete(ee),this._onDidRemoveConnection.fire(ee)})})})}get connections(){const w=[];return this._connections.forEach(M=>w.push(M)),w}getChannel(w,M){const E=this;return{call(A,C,z){let j;if((0,y.isFunction)(M)){let H=(0,m.getRandomElement)(E.connections.filter(M));j=H?Promise.resolve(H):c.Event.toPromise(c.Event.filter(E.onDidAddConnection,M))}else j=M.routeCall(E,A,C);const $=j.then(H=>H.channelClient.getChannel(w));return _($).call(A,C,z)},listen(A,C){if((0,y.isFunction)(M))return E.getMulticastEvent(w,M,A,C);const z=M.routeEvent(E,A,C).then(j=>j.channelClient.getChannel(w));return _(z).listen(A,C)}}}getMulticastEvent(w,M,E,A){const C=this;let z=new d.DisposableStore;const j=new c.Emitter({onFirstListenerAdd:()=>{z=new d.DisposableStore;const $=new c.EventMultiplexer,H=new Map,ee=re=>{const me=re.channelClient.getChannel(w).listen(E,A),be=$.add(me);H.set(re,be)},ne=re=>{const ce=H.get(re);!ce||(ce.dispose(),H.delete(re))};C.connections.filter(M).forEach(ee),c.Event.filter(C.onDidAddConnection,M)(ee,void 0,z),C.onDidRemoveConnection(ne,void 0,z),$.event(j.fire,j,z),z.add($)},onLastListenerRemove:()=>{z.dispose()}});return j.event}registerChannel(w,M){this.channels.set(w,M),this._connections.forEach(E=>{E.channelServer.registerChannel(w,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=N;class x{constructor(w,M,E=null){const A=new f;a(A,M),w.send(A.buffer),this.channelClient=new P(w,E),this.channelServer=new g(w,M,E)}getChannel(w){return this.channelClient.getChannel(w)}registerChannel(w,M){this.channelServer.registerChannel(w,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=x;function _(U){return{call(w,M,E){return U.then(A=>A.call(w,M,E))},listen(w,M){const E=new c.Relay;return U.then(A=>E.input=A.listen(w,M)),E.event}}}t.getDelayedChannel=_;function J(U){let w=!1;return{call(M,E,A){return w?U.call(M,E,A):(0,T.timeout)(0).then(()=>w=!0).then(()=>U.call(M,E,A))},listen(M,E){if(w)return U.listen(M,E);const A=new c.Relay;return(0,T.timeout)(0).then(()=>w=!0).then(()=>A.input=U.listen(M,E)),A.event}}}t.getNextTickChannel=J;class ie{constructor(w){this.fn=w}routeCall(w){return this.route(w)}routeEvent(w){return this.route(w)}async route(w){for(const M of w.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await c.Event.toPromise(w.onDidAddConnection),await this.route(w)}}t.StaticRouter=ie;var se;(function(U){function w(A,C){const z=A,j=C&&C.disableMarshalling,$=new Map;for(const H in z)E(H)&&$.set(H,c.Event.buffer(z[H],!0));return new class{listen(H,ee){const ne=$.get(ee);if(ne)return ne;throw new Error(`Event not found: ${ee}`)}call(H,ee,ne){const re=z[ee];if(typeof re=="function"){if(!j&&Array.isArray(ne))for(let ce=0;ce<ne.length;ce++)ne[ce]=(0,S.revive)(ne[ce]);return re.apply(z,ne)}throw new Error(`Method not found: ${ee}`)}}}U.fromService=w;function M(A,C){const z=C&&C.disableMarshalling;return new Proxy({},{get(j,$){if(typeof $=="string")return C?.properties?.has($)?C.properties.get($):E($)?A.listen($):async function(...H){let ee;C&&!(0,y.isUndefinedOrNull)(C.context)?ee=[C.context,...H]:ee=H;const ne=await A.call($,ee);return z?ne:(0,S.revive)(ne)};throw new Error(`Property not found: ${String($)}`)}})}U.toService=M;function E(A){return A[0]==="o"&&A[1]==="n"&&p.isUpperAsciiLetter(A.charCodeAt(2))}})(se=t.ProxyChannel||(t.ProxyChannel={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let w=U.toString();if(w!=="[object Object]")return w}return U}function Q(U){return Array.isArray(U)?U.map(X):X(U)}function B(U,w,M,E,A,C,z){z=Q(z);const j=Y[A],$=j[E%j.length];let H=[`%c[${U}]%c[${String(w).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(E).padStart(5," ")} - ${C}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(C)?(H=H.concat(z),H.push(")")):H.push(z),console.log.apply(console,H)}t.logWithColors=B;class W{constructor(w,M){this._outgoingPrefix=w,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(w,M,E,A,C){this._totalOutgoing+=w,B(this._outgoingPrefix,this._totalOutgoing,w,M,E,A,C)}logIncoming(w,M,E,A,C){this._totalIncoming+=w,B(this._incomingPrefix,this._totalIncoming,w,M,E,A,C)}}t.IPCLogger=W}),define(Z[66],te([0,1,3,14,2,13]),function(q,t,m,T,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var F;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(F=t.StorageHint||(t.StorageHint={}));var L;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(L||(L={}));class c extends v.Disposable{constructor(p,y=Object.create(null)){super();this.database=p,this.options=y,this._onDidChangeStorage=this._register(new T.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=L.None,this.cache=new Map,this.flushDelayer=new m.ThrottledDelayer(c.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((y,O)=>this.accept(O,y)),p.deleted?.forEach(y=>this.accept(y,void 0))}accept(p,y){if(this.state===L.Closed)return;let O=!1;(0,I.isUndefinedOrNull)(y)?O=this.cache.delete(p):this.cache.get(p)!==y&&(this.cache.set(p,y),O=!0),O&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===L.None&&(this.state=L.Initialized,this.options.hint!==F.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,y){const O=this.cache.get(p);return(0,I.isUndefinedOrNull)(O)?y:O}getBoolean(p,y){const O=this.get(p);return(0,I.isUndefinedOrNull)(O)?y:O==="true"}getNumber(p,y){const O=this.get(p);return(0,I.isUndefinedOrNull)(O)?y:parseInt(O,10)}async set(p,y){if(this.state===L.Closed)return;if((0,I.isUndefinedOrNull)(y))return this.delete(p);const O=String(y);if(this.cache.get(p)!==O)return this.cache.set(p,O),this.pendingInserts.set(p,O),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.flushDelayer.trigger(()=>this.flushPending())}async delete(p){if(!(this.state===L.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=L.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(p){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=c,c.DEFAULT_FLUSH_DELAY=100;class d{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert&&p.insert.forEach((y,O)=>this.items.set(O,y)),p.delete&&p.delete.forEach(y=>this.items.delete(y))}async close(){}}t.InMemoryStorageDatabase=d}),define(Z[67],te([5,6]),function(q,t){return q.create("vs/base/common/date",t)}),define(Z[68],te([0,1,67]),function(q,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const T=60,v=T*60,I=v*24,F=I*7,L=I*30,c=I*365;function d(p,y){typeof p!="number"&&(p=p.getTime());const O=Math.round((new Date().getTime()-p)/1e3);if(O<-30)return(0,m.localize)(0,null,d(new Date().getTime()+O*1e3,!1));if(O<30)return(0,m.localize)(1,null);let l;return O<T?(l=O,y?l===1?(0,m.localize)(2,null,l):(0,m.localize)(3,null,l):l===1?(0,m.localize)(4,null,l):(0,m.localize)(5,null,l)):O<v?(l=Math.floor(O/T),y?l===1?(0,m.localize)(6,null,l):(0,m.localize)(7,null,l):l===1?(0,m.localize)(8,null,l):(0,m.localize)(9,null,l)):O<I?(l=Math.floor(O/v),y?l===1?(0,m.localize)(10,null,l):(0,m.localize)(11,null,l):l===1?(0,m.localize)(12,null,l):(0,m.localize)(13,null,l)):O<F?(l=Math.floor(O/I),y?l===1?(0,m.localize)(14,null,l):(0,m.localize)(15,null,l):l===1?(0,m.localize)(16,null,l):(0,m.localize)(17,null,l)):O<L?(l=Math.floor(O/F),y?l===1?(0,m.localize)(18,null,l):(0,m.localize)(19,null,l):l===1?(0,m.localize)(20,null,l):(0,m.localize)(21,null,l)):O<c?(l=Math.floor(O/L),y?l===1?(0,m.localize)(22,null,l):(0,m.localize)(23,null,l):l===1?(0,m.localize)(24,null,l):(0,m.localize)(25,null,l)):(l=Math.floor(O/c),y?l===1?(0,m.localize)(26,null,l):(0,m.localize)(27,null,l):l===1?(0,m.localize)(28,null,l):(0,m.localize)(29,null,l))}t.fromNow=d;function S(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=S}),define(Z[69],te([5,6]),function(q,t){return q.create("vs/base/common/errorMessage",t)}),define(Z[28],te([0,1,24,13,69]),function(q,t,m,T,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function I(d,S){return S&&(d.stack||d.stacktrace)?v.localize(0,null,L(d),F(d.stack)||F(d.stacktrace)):L(d)}function F(d){return Array.isArray(d)?d.join(`
`):d}function L(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?v.localize(1,null,d.message):d.message||v.localize(2,null)}function c(d=null,S=!1){if(!d)return v.localize(3,null);if(Array.isArray(d)){const p=m.coalesce(d),y=c(p[0],S);return p.length>1?v.localize(4,null,y,p.length):y}if(T.isString(d))return d;if(d.detail){const p=d.detail;if(p.error)return I(p.error,S);if(p.exception)return I(p.exception,S)}return d.stack?I(d,S):d.message?d.message:v.localize(5,null)}t.toErrorMessage=c}),define(Z[70],te([5,6]),function(q,t){return q.create("vs/base/node/processes",t)}),define(Z[47],te([0,1,33,31,9,19,4,10,34,13,46,11,70]),function(q,t,m,T,v,I,F,L,c,d,S,p,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function O(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(r,s){if(L.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};s&&(e.cwd=s);const i=m.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],e);return new Promise(n=>{i.once("error",o=>{n({success:!1,error:o})}),i.once("exit",(o,a)=>{n(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?O(e.status):1})}else if(L.isLinux||L.isMacintosh)try{const e=v.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",q).fsPath;return new Promise(i=>{m.execFile(e,[r.pid.toString()],{encoding:"utf8",shell:!0},(n,o,a)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function u(r=c.env){return r.comspec||"cmd.exe"}t.getWindowsShell=u;class D{constructor(s,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=s,this.args=e,this.shell=i,this.options=n;else{const o=s;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(c.env).forEach(a=>{o[a]=c.env[a]}),Object.keys(this.options.env).forEach(a=>{o[a]=this.options.env[a]}),this.options.env=o}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const e=s.lastIndexOf(F.sep);return e!==-1&&(s=s.substring(e+1)),D.WellKnowCommands[s]?s:"other"}start(s){return L.isWindows&&(this.options&&this.options.cwd&&T.isUNC(this.options.cwd)||!this.options&&T.isUNC(c.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(e=>{let i,n;const o=new Promise((a,h)=>{i=a,n=h});if(e){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=m.exec(a,this.options,(h,g,k)=>{this.childProcess=null;const P=h;P&&P.killed?n({killed:this.terminateRequested,stdout:g.toString(),stderr:k.toString()}):this.handleExec(i,s,h,g,k)})}else{let a=null;const h=g=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(g,i,s,n);const k={terminated:this.terminateRequested};d.isNumber(g)&&(k.cmdCode=g),i(k)};if(this.shell&&L.isWindows){const g=I.deepClone(this.options);g.windowsVerbatimArguments=!0,g.detached=!1;let k=!1,P=!1;const N=[];let x=this.ensureQuotes(this.cmd);N.push(x.value),k=x.quoted,this.args&&this.args.forEach(J=>{x=this.ensureQuotes(J),N.push(x.value),P=P&&x.quoted});const _=["/s","/c"];k?P?_.push('"'+N.join(" ")+'"'):N.length>1?_.push('"'+N[0]+'" '+N.slice(1).join(" ")):_.push('"'+N[0]+'"'):_.push(N.join(" ")),a=m.spawn(u(),_,g)}else this.cmd&&(a=m.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(d.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",g=>{this.childProcess=null,n({terminated:this.terminateRequested,error:g})}),a.pid&&(this.childProcess.on("close",h),this.handleSpawn(a,i,s,n,!0)))}return o})}handleClose(s,e,i,n){}ensureQuotes(s){return D.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,l(s,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!L.isWindows)return s(!1);const e=m.spawn(u(),["/s","/c"]);e.on("error",i=>s(!0)),e.on("exit",i=>s(!1))})}}t.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class b extends D{constructor(s,e,i,n){super(s,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,e,i,n,o){[n,o].forEach((a,h)=>{const g=new S.LineDecoder;g.write(a).forEach(N=>{e({line:N,source:h===0?0:1})});const P=g.end();P&&e({line:P,source:h===0?0:1})}),s({terminated:this.terminateRequested,error:i})}handleSpawn(s,e,i,n,o){const a=new S.LineDecoder,h=new S.LineDecoder;s.stdout.on("data",g=>{a.write(g).forEach(P=>i({line:P,source:0}))}),s.stderr.on("data",g=>{h.write(g).forEach(P=>i({line:P,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=h}handleClose(s,e,i,n){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}t.LineProcess=b;function R(r){let s=[],e=!1;const i=function(n){if(e){s.push(n);return}(!r.send(n,a=>{if(a&&console.error(a),e=!1,s.length>0){const h=s.slice(0);s=[],h.forEach(g=>i(g))}})||L.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=R;var f;(function(r){async function s(e,i,n){if(F.isAbsolute(e))return e;if(i===void 0&&(i=c.cwd()),F.dirname(e)!=="."||(n===void 0&&d.isString(c.env.PATH)&&(n=c.env.PATH.split(F.delimiter)),n===void 0||n.length===0))return F.join(i,e);async function a(h){return await p.Promises.exists(h)?!(await p.Promises.stat(h)).isDirectory():!1}for(let h of n){let g;if(F.isAbsolute(h)?g=F.join(h,e):g=F.join(i,h,e),await a(g))return g;let k=g+".com";if(await a(k)||(k=g+".exe",await a(k)))return k}return F.join(i,e)}r.findExecutable=s})(f=t.win32||(t.win32={}))}),define(Z[71],te([0,1,32,10,64,47]),function(q,t,m,T,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function F(O,l){return O===1?T.isWindows?p():I.getWindowsShell(l):d(O,l)}t.getSystemShell=F;function L(O,l){return O===1?T.isWindows?y(l):I.getWindowsShell(l):d(O,l)}t.getSystemShellSync=L;let c=null;function d(O,l){if(T.isLinux&&O===2||T.isMacintosh&&O===3)return"/bin/bash";if(!c){let u;if(T.isWindows)u="/bin/bash";else{if(u=l.SHELL,!u)try{u=(0,m.userInfo)().shell}catch(D){}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}c=u}return c}let S=null;async function p(){return S||(S=(await(0,v.getFirstAvailablePowerShellInstallation)()).exePath),S}function y(O){if(S)return S;const l=T.isWindows&&parseFloat((0,m.release)())>=10,u=O.hasOwnProperty("PROCESSOR_ARCHITEW6432"),D=`${O.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?D:I.getWindowsShell(O)}}),define(Z[48],te([0,1,33,3,16,26,59,8,14,2,19,10,47,39]),function(q,t,m,T,v,I,F,L,c,d,S,p,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class l extends O.ChannelServer{constructor(b){super({send:R=>{try{process.send&&process.send(R.buffer.toString("base64"))}catch(f){}},onMessage:c.Event.fromNodeEventEmitter(process,"message",R=>v.VSBuffer.wrap(Buffer.from(R,"base64")))},b);process.once("disconnect",()=>this.dispose())}}t.Server=l;class u{constructor(b,R){this.modulePath=b,this.options=R,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=R&&R.timeout?R.timeout:6e4;this.disposeDelayer=new T.Delayer(f),this.child=null,this._client=null}getChannel(b){const R=this;return{call(f,r,s){return R.requestPromise(b,f,r,s)},listen(f,r){return R.requestEvent(b,f,r)}}}requestPromise(b,R,f,r=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(L.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(b),e=(0,T.createCancelablePromise)(o=>s.call(R,f,o)),i=r.onCancellationRequested(()=>e.cancel()),n=(0,d.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(b,R,f){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let r;const s=new c.Emitter({onFirstListenerAdd:()=>{r=this.getCachedChannel(b).listen(R,f)(s.fire,s),this.activeRequests.add(r)},onLastListenerRemove:()=>{this.activeRequests.delete(r),r.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],R=Object.create(null);R.env={...(0,S.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(R.env={...R.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(R.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(R.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(R.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),R.execArgv===void 0&&(R.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),p.isMacintosh&&R.env&&delete R.env.DYLD_LIBRARY_PATH,this.child=(0,m.fork)(this.modulePath,b,R);const f=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,F.isRemoteConsoleLog)(a)){(0,F.log)(a,`IPC Library: ${this.options.serverName}`);return}f.fire(v.VSBuffer.wrap(Buffer.from(a,"base64")))});const s=this.options.useQueue?(0,y.createQueuedSender)(this.child):this.child,e=a=>this.child&&this.child.connected&&s.send(a.buffer.toString("base64")),i=f.event,n={send:e,onMessage:i};this._client=new O.ChannelClient(n);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,h)=>{process.removeListener("exit",o),this.activeRequests.forEach(g=>(0,d.dispose)(g)),this.activeRequests.clear(),a!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+h),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:h})})}return this._client}getCachedChannel(b){let R=this.channels.get(b);return R||(R=this.client.getChannel(b),this.channels.set(b,R)),R}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=u}),define(Z[72],te([5,6]),function(q,t){return q.create("vs/base/node/zip",t)}),define(Z[73],te([5,6]),function(q,t){return q.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Z[74],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Z[75],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Z[76],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Z[77],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Z[78],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Z[79],te([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Z[80],te([5,6]),function(q,t){return q.create("vs/platform/extensions/common/extensionValidator",t)}),define(Z[81],te([5,6]),function(q,t){return q.create("vs/platform/files/common/fileService",t)}),define(Z[82],te([5,6]),function(q,t){return q.create("vs/platform/files/common/io",t)}),define(Z[83],te([5,6]),function(q,t){return q.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Z[84],te([5,6]),function(q,t){return q.create("vs/platform/request/common/request",t)}),define(Z[85],te([5,6]),function(q,t){return q.create("vs/platform/telemetry/common/telemetryService",t)}),define(Z[86],te([0,1,4,20,44,68,9,7,34]),function(q,t,m,T,v,I,F,L,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(l,u,D){this._args=l,this.paths=u,this.productService=D}get appRoot(){return(0,m.dirname)(F.FileAccess.asFileUri("",q).fsPath)}get userHome(){return L.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return L.URI.file((0,m.join)(this.userDataPath,"User"))}get tmpDir(){return L.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,T.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const l=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,m.join)(this.userDataPath,"logs",l)}return this.args.logsPath}get userDataSyncLogResource(){return L.URI.file((0,m.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.joinPath)(L.URI.file((0,m.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return L.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return L.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=c.env.VSCODE_PORTABLE;return l?L.URI.file((0,m.join)(l,"argv.json")):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,T.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return L.URI.file((0,m.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,m.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,m.resolve)(l):(0,m.normalize)((0,m.join)(F.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const l=this.args["extensions-download-dir"];return l?(0,m.resolve)(l):(0,m.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,m.resolve)(l);const u=c.env.VSCODE_EXTENSIONS;if(u)return u;const D=c.env.VSCODE_PORTABLE;return D?(0,m.join)(D,"extensions"):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(u=>/^[^:/?#]+?:\/\//.test(u)?L.URI.parse(u):L.URI.file((0,m.normalize)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?L.URI.parse(l):L.URI.file((0,m.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!c.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,T.joinPath)(L.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return L.URI.file((0,m.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([v.memoize],d.prototype,"appRoot",null),ue([v.memoize],d.prototype,"userHome",null),ue([v.memoize],d.prototype,"userDataPath",null),ue([v.memoize],d.prototype,"appSettingsHome",null),ue([v.memoize],d.prototype,"tmpDir",null),ue([v.memoize],d.prototype,"userRoamingDataHome",null),ue([v.memoize],d.prototype,"settingsResource",null),ue([v.memoize],d.prototype,"userDataSyncHome",null),ue([v.memoize],d.prototype,"userDataSyncLogResource",null),ue([v.memoize],d.prototype,"sync",null),ue([v.memoize],d.prototype,"machineSettingsResource",null),ue([v.memoize],d.prototype,"globalStorageHome",null),ue([v.memoize],d.prototype,"workspaceStorageHome",null),ue([v.memoize],d.prototype,"keybindingsResource",null),ue([v.memoize],d.prototype,"keyboardLayoutResource",null),ue([v.memoize],d.prototype,"argvResource",null),ue([v.memoize],d.prototype,"snippetsHome",null),ue([v.memoize],d.prototype,"isExtensionDevelopment",null),ue([v.memoize],d.prototype,"untitledWorkspacesHome",null),ue([v.memoize],d.prototype,"installSourcePath",null),ue([v.memoize],d.prototype,"builtinExtensionsPath",null),ue([v.memoize],d.prototype,"extensionsPath",null),ue([v.memoize],d.prototype,"extensionDevelopmentLocationURI",null),ue([v.memoize],d.prototype,"extensionDevelopmentKind",null),ue([v.memoize],d.prototype,"extensionTestsLocationURI",null),ue([v.memoize],d.prototype,"debugExtensionHost",null),ue([v.memoize],d.prototype,"serviceMachineIdResource",null),ue([v.memoize],d.prototype,"telemetryLogResource",null),ue([v.memoize],d.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=d;function S(O,l){return y(O["inspect-extensions"],O["inspect-brk-extensions"],5870,l,O.debugId)}t.parseExtensionHostPort=S;function p(O,l){return y(O["inspect-search"],O["inspect-brk-search"],5876,l)}t.parseSearchPort=p;function y(O,l,u,D,b){const f=Number(l||O)||(D?null:u),r=f?Boolean(!!l):!1;return{port:f,break:r,debugId:b}}}),function(){"use strict";function q(t,m,T,v){function I(L){const c=F(L),d=[c];return t.isAbsolute(c)||d.unshift(v),t.resolve(...d)}function F(L){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,T);const S=L["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(p,"AppData","Roaming")}break;case"darwin":d=t.join(m.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,T)}return{getUserDataPath:I}}if(typeof define=="function")define(Z[87],te([0,88,32,9,20,34]),function(t,m,T,v,I,F){const L=I.dirname(v.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(I.joinPath(L,"package.json").fsPath);return q(m,T,c.name,F.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),m=require("path"),T=require("os");module.exports=q(m,T,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[89],te([0,1,32,87,86]),function(q,t,m,T,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class I extends v.AbstractNativeEnvironmentService{constructor(L,c){super(L,{homeDir:(0,m.homedir)(),tmpDir:(0,m.tmpdir)(),userDataDir:(0,T.getUserDataPath)(L)},c)}}t.NativeEnvironmentService=I}),define(Z[90],te([0,1,19]),function(q,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const T=/^%([\w\d.-]+)%$/i;function v(I,F){const L=c=>{if(typeof c!="string")return;const d=T.exec(c);if(!d)return;const S=F[d[1]]??c;return typeof S=="string"?S:typeof S.message=="string"?S.message:c};return(0,m.cloneAndChange)(I,L)}t.localizeManifest=v}),define(Z[49],te([0,1,80]),function(q,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function I(y){return y=y.trim(),y==="*"||T.test(y)}t.isValidVersionStr=I;function F(y){if(!I(y))return null;if(y=y.trim(),y==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let O=y.match(T);return O?{hasCaret:O[1]==="^",hasGreaterEquals:O[1]===">=",majorBase:O[2]==="x"?0:parseInt(O[2],10),majorMustEqual:O[2]!=="x",minorBase:O[4]==="x"?0:parseInt(O[4],10),minorMustEqual:O[4]!=="x",patchBase:O[6]==="x"?0:parseInt(O[6],10),patchMustEqual:O[6]!=="x",preRelease:O[8]||null}:null}t.parseVersion=F;function L(y){if(!y)return null;let O=y.majorBase,l=y.majorMustEqual,u=y.minorBase,D=y.minorMustEqual,b=y.patchBase,R=y.patchMustEqual;y.hasCaret&&(O===0||(D=!1),R=!1);let f=0;if(y.preRelease){const r=v.exec(y.preRelease);if(r){const[,s,e,i]=r;f=Date.UTC(Number(s),Number(e)-1,Number(i))}}return{majorBase:O,majorMustEqual:l,minorBase:u,minorMustEqual:D,patchBase:b,patchMustEqual:R,isMinimum:y.hasGreaterEquals,notBefore:f}}t.normalizeVersion=L;function c(y,O,l){let u;typeof y=="string"?u=L(F(y)):u=y;let D;O instanceof Date?D=O.getTime():typeof O=="string"&&(D=new Date(O).getTime());let b;if(typeof l=="string"?b=L(F(l)):b=l,!u||!b)return!1;let R=u.majorBase,f=u.minorBase,r=u.patchBase,s=b.majorBase,e=b.minorBase,i=b.patchBase,n=b.notBefore,o=b.majorMustEqual,a=b.minorMustEqual,h=b.patchMustEqual;return b.isMinimum?R>s?!0:R<s?!1:f>e?!0:f<e||D&&D<n?!1:r>=i:(R===1&&s===0&&(!o||!a||!h)&&(s=1,e=0,i=0,o=!0,a=!1,h=!1),R<s?!1:R>s?!o:f<e?!1:f>e?!a:r<i?!1:r>i?!h:!(D&&D<n))}t.isValidVersion=c;function d(y,O,l,u){return l.isBuiltin||typeof l.main=="undefined"?!0:p(y,O,l.engines.vscode,u)}t.isValidExtensionVersion=d;function S(y,O,l){return y==="*"||p(O,l,y)}t.isEngineValid=S;function p(y,O,l,u=[]){let D=L(F(l));if(!D)return u.push(m.localize(0,null,l)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return u.push(m.localize(1,null,l)),!1}else if(!D.majorMustEqual)return u.push(m.localize(2,null,l)),!1;return c(y,O,D)?!0:(u.push(m.localize(3,null,y,l)),!1)}}),define(Z[91],te([0,1,39,48,2,9]),function(q,t,m,T,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends v.Disposable{constructor(c,d,S,p){super();this.folders=c,this.onDidFilesChange=d,this.onLogMessage=S,this.verboseLogging=p,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new T.Client(I.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(c.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.setFolders(this.folders)}setVerboseLogging(c){this.verboseLogging=c,!this.isDisposed&&this.service&&this.service.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${c}`})}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(Z[92],te([0,1,39,48,2,9]),function(q,t,m,T,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends v.Disposable{constructor(c,d,S,p,y={}){super();this.folders=c,this.onDidFilesChange=d,this.onLogMessage=S,this.verboseLogging=p,this.watcherOptions=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new T.Client(I.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(c.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.service.setRoots(this.folders)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${c}`})}setVerboseLogging(c){this.verboseLogging=c,this.service&&this.service.setVerboseLogging(c)}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(Z[93],te([0,1,33,46,61,9]),function(q,t,m,T,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class F{constructor(c,d,S,p,y){this.watchedFolder=c,this.eventCallback=S,this.logCallback=p,this.verboseLogging=y,this.restartCounter=0,Array.isArray(d)?this.ignored=d.map(O=>(0,v.parse)(O)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${c}, excludes: ${d.join(",")}`),this.startWatcher()}startWatcher(){const c=[this.watchedFolder];this.verboseLogging&&c.push("-verbose"),this.handle=(0,m.spawn)(I.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",q).fsPath,c);const d=new T.LineDecoder;this.handle.stdout.on("data",S=>{const p=[];for(const y of d.write(S)){const O=y.split("|");if(O.length===2){const l=Number(O[0]),u=O[1];if(l>=0&&l<3){if(this.ignored&&this.ignored.some(D=>D(u))){this.verboseLogging&&this.log(u);continue}p.push({type:F.changeTypeMap[l],path:u})}else this.log(O[1])}}p.length>0&&this.eventCallback(p)}),this.handle.on("error",S=>this.onError(S)),this.handle.stderr.on("data",S=>this.onError(S)),this.handle.on("exit",(S,p)=>this.onExit(S,p))}onError(c){this.error("process error: "+c.toString())}onExit(c,d){this.handle&&(this.error(`terminated unexpectedly (code: ${c}, signal: ${d})`),this.restartCounter<=F.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(c){this.logCallback({type:"error",message:`[File Watcher (C#)] ${c}`})}log(c){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${c}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=F,F.MAX_RESTARTS=5,F.changeTypeMap=[0,1,2]}),define(Z[94],te([0,1,93,4,18]),function(q,t,m,T,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class I{constructor(L,c,d,S){this.onDidFilesChange=c,this.onLogMessage=d,this.verboseLogging=S,this.service=void 0,this.folder=L[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(T.posix.sep)&&(this.folder.path=(0,v.rtrim)(this.folder.path,T.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,L=>this.onFileEvents(L),L=>this.onLogMessage(L),this.verboseLogging)}setVerboseLogging(L){this.verboseLogging=L,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(L){this.isDisposed||L.length>0&&this.onDidFilesChange(L)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=I}),define(Z[50],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class m{constructor(v,I=[],F=!1){this.ctor=v,this.staticArguments=I,this.supportsDelayedInstantiation=F}}t.SyncDescriptor=m}),define(Z[95],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class m{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}t.Node=m;class T{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let F of this._nodes.values())F.outgoing.size===0&&I.push(F);return I}insertEdge(I,F){const L=this.lookupOrInsertNode(I),c=this.lookupOrInsertNode(F);L.outgoing.set(this._hashFn(F),c),c.incoming.set(this._hashFn(I),L)}removeNode(I){const F=this._hashFn(I);this._nodes.delete(F);for(let L of this._nodes.values())L.outgoing.delete(F),L.incoming.delete(F)}lookupOrInsertNode(I){const F=this._hashFn(I);let L=this._nodes.get(F);return L||(L=new m(I),this._nodes.set(F,L)),L}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[F,L]of this._nodes)I.push(`${F}, (incoming)[${[...L.incoming.keys()].join(", ")}], (outgoing)[${[...L.outgoing.keys()].join(",")}]`);return I.join(`
`)}findCycleSlow(){for(let[I,F]of this._nodes){const L=new Set([I]),c=this._findCycle(F,L);if(c)return c}}_findCycle(I,F){for(let[L,c]of I.outgoing){if(F.has(L))return[...F,L].join(" -> ");F.add(L);const d=this._findCycle(c,F);if(d)return d;F.delete(L)}}}t.Graph=T}),define(Z[96],te([0,1,12]),function(q,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,m.createDecorator)("downloadService")}),define(Z[21],te([0,1,12]),function(q,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,m.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,m.refineServiceDecorator)(t.IEnvironmentService)}),define(Z[22],te([0,1,75,12,9]),function(q,t,m,T,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function I(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}t.isIExtensionIdentifier=I;var F;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=5]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(F=t.SortBy||(t.SortBy={}));var L;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(L=t.SortOrder||(t.SortOrder={}));var c;(function(p){p.Install="install",p.Uninstall="uninstall"})(c=t.StatisticType||(t.StatisticType={}));var d;(function(p){p[p.None=0]="None",p[p.Install=1]="Install",p[p.Update=2]="Update"})(d=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class S extends Error{constructor(y,O){super(y);this.code=O,this.name=O}}t.ExtensionManagementError=S,t.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=v.FileAccess.asBrowserUri("./media/defaultIcon.png",q).toString(!0),t.ExtensionsLabel=(0,m.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,m.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(Z[40],te([0,1,18,12]),function(q,t,m,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function v(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}t.getWorkspaceSupportTypeMessage=v;function I(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(!S.uuid||typeof S.uuid=="string")}t.isIExtensionIdentifier=I,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(F=t.ExtensionType||(t.ExtensionType={}));class L{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,y){if(typeof p=="undefined"||p===null)return typeof y=="undefined"||y===null;if(typeof y=="undefined"||y===null)return!1;if(typeof p=="string"||typeof y=="string"){let O=typeof p=="string"?p:p.value,l=typeof y=="string"?y:y.value;return m.equalsIgnoreCase(O,l)}return p._lower===y._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}t.ExtensionIdentifier=L;function c(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}t.isLanguagePackExtension=c;function d(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=d,t.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[23],te([0,1,18,40]),function(q,t,m,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function v(l,u){return l.uuid&&u.uuid?l.uuid===u.uuid:l.id===u.id?!0:(0,m.compareIgnoreCase)(l.id,u.id)===0}t.areSameExtensions=v;class I{constructor(u,D){this.version=D,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof I?v(this,u)&&this.version===u.version:!1}}t.ExtensionIdentifierWithVersion=I;function F(l,u){return`${l}.${u}`}t.getExtensionId=F;function L(l){return l.toLocaleLowerCase()}t.adoptToGalleryExtensionId=L;function c(l,u){return L(F(l,u))}t.getGalleryExtensionId=c;function d(l,u){const D=[],b=R=>{for(const f of D)if(f.some(r=>v(u(r),u(R))))return f;return null};for(const R of l){const f=b(R);f?f.push(R):D.push([R])}return D}t.groupByExtension=d;function S(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=S;function p(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}t.getGalleryExtensionTelemetryData=p,t.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function y(l){const u=new Set;for(const D of l)D.malicious&&u.add(D.id.id);return u}t.getMaliciousExtensionsSet=y;function O(l,u){const D=[],b=u.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const R=b.shift();if(R&&D.every(f=>!v(f.identifier,{id:R}))){const f=l.filter(r=>v(r.identifier,{id:R}));f.length===1&&(D.push(f[0]),b.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return D}t.getExtensionDependencies=O});var fe=this&&this.__param||function(q,t){return function(m,T){t(m,T,q)}};define(Z[97],te([0,1,76,8,7,41,22,23,40,62,26,9]),function(q,t,m,T,v,I,F,L,c,d,S,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const y=R=>(0,m.localize)(0,null,R),O=(0,m.localize)(1,null,"ms-dotnettools.csharp");function l(R,f){return f?`${R.publisher}.${R.name}@${R.version}`:`${R.publisher}.${R.name}`}const u=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function D(R){const f=u.exec(R);return f&&f[1]?[(0,L.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,L.adoptToGalleryExtensionId)(R),void 0]}t.getIdAndVersion=D;let b=class{constructor(f,r){this.extensionManagementService=f,this.extensionGalleryService=r}get location(){}async listExtensions(f,r,s=console){let e=await this.extensionManagementService.getInstalled(1);const i=c.EXTENSION_CATEGORIES.map(o=>o.toLowerCase());if(r&&r!==""){if(i.indexOf(r.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(o=>o.manifest.categories?o.manifest.categories.map(h=>h.toLowerCase()).indexOf(r.toLowerCase())>-1:!1)}else if(r===""){s.log("Possible Categories: "),i.forEach(o=>{s.log(o)});return}this.location&&s.log((0,m.localize)(2,null,this.location)),e=e.sort((o,a)=>o.identifier.id.localeCompare(a.identifier.id));let n;for(let o of e)n!==o.identifier.id&&(n=o.identifier.id,s.log(l(o.manifest,f)))}async installExtensions(f,r,s,e,i=console){const n=[],o=[];f.length&&i.log(this.location?(0,m.localize)(3,null,this.location):(0,m.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),h=(P,N)=>{const x=a.find(_=>(0,L.areSameExtensions)(_.identifier,{id:P}));if(x){if(!N&&!e)return i.log((0,m.localize)(5,null,P,x.manifest.version,P)),!1;if(N&&x.manifest.version===N)return i.log((0,m.localize)(6,null,`${P}@${N}`)),!1}return!0},g=[],k=[];for(const P of f)if(P instanceof v.URI)g.push(P);else{const[N,x]=D(P);h(N,x)&&k.push({id:N,version:x,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const P of r){const[N,x]=D(P);h(N,x)&&k.push({id:N,version:x,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(g.length&&await Promise.all(g.map(async P=>{try{const N=await this.installVSIX(P,{isBuiltin:!1,isMachineScoped:s},e,i);N&&o.push(N)}catch(N){i.error(N.message||N.stack||N),n.push(P.toString())}})),k.length){const P=await this.getGalleryExtensions(k);await Promise.all(k.map(async N=>{const x=P.get(N.id.toLowerCase());if(x)try{const _=await this.installFromGallery(N,x,a,e,i);_&&o.push(_)}catch(_){i.error(_.message||_.stack||_),n.push(N.id)}else i.error(`${y(N.version?`${N.id}@${N.version}`:N.id)}
${O}`),n.push(N.id)}))}if(n.length)throw new Error((0,m.localize)(7,null,n.join(", ")))}async installVSIX(f,r,s,e){const i=await this.extensionManagementService.getManifest(f);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,e))try{return await this.extensionManagementService.install(f,r),e.log((0,m.localize)(8,null,(0,d.getBaseLabel)(f))),i}catch(o){if((0,T.isPromiseCanceledError)(o))return e.log((0,m.localize)(9,null,(0,d.getBaseLabel)(f))),null;throw o}return null}async getGalleryExtensions(f){const r=f.filter(({version:i})=>i===void 0).map(({id:i})=>i),s=f.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(r,S.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(s.map(async({id:i,version:n})=>{const o=await this.extensionGalleryService.getCompatibleExtension({id:i},n);o&&e.set(o.identifier.id.toLowerCase(),o)}))]),e}async installFromGallery({id:f,version:r,installOptions:s},e,i,n,o){const a=await this.extensionGalleryService.getManifest(e,S.CancellationToken.None);if(a&&!this.validateExtensionKind(a,o))return null;const h=i.find(g=>(0,L.areSameExtensions)(g.identifier,e.identifier));if(h){if(e.version===h.manifest.version)return o.log((0,m.localize)(10,null,r?`${f}@${r}`:f)),null;o.log((0,m.localize)(11,null,f,e.version))}try{return s.isBuiltin?o.log(r?(0,m.localize)(12,null,f,r):(0,m.localize)(13,null,f)):o.log(r?(0,m.localize)(14,null,f,r):(0,m.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(e,s),o.log((0,m.localize)(16,null,f,e.version)),a}catch(g){if((0,T.isPromiseCanceledError)(g))return o.log((0,m.localize)(17,null,f)),null;throw g}}validateExtensionKind(f,r){return!0}async validateVSIX(f,r,s){const e={id:(0,L.getGalleryExtensionId)(f.publisher,f.name)},n=(await this.extensionManagementService.getInstalled(1)).find(o=>(0,L.areSameExtensions)(e,o.identifier)&&(0,I.gt)(o.manifest.version,f.version));return n&&!r?(s.log((0,m.localize)(18,null,n.identifier.id,n.manifest.version,f.version)),!1):this.validateExtensionKind(f,s)}async uninstallExtensions(f,r,s=console){const e=async n=>{if(n instanceof v.URI){const o=await this.extensionManagementService.getManifest(n);return l(o)}return n},i=[];for(const n of f){const o=await e(n),h=(await this.extensionManagementService.getInstalled()).filter(g=>(0,L.areSameExtensions)(g.identifier,{id:o}));if(!h.length)throw new Error(`${this.notInstalled(o)}
${O}`);if(h.some(g=>g.type===0)){s.log((0,m.localize)(19,null,o));return}if(!r&&h.some(g=>g.isBuiltin)){s.log((0,m.localize)(20,null,o));return}s.log((0,m.localize)(21,null,o));for(const g of h)await this.extensionManagementService.uninstall(g),i.push(g);this.location?s.log((0,m.localize)(22,null,o,this.location)):s.log((0,m.localize)(23,null,o))}}async locateExtension(f,r=console){const s=await this.extensionManagementService.getInstalled();f.forEach(e=>{s.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===p.Schemas.file){r.log(i.location.fsPath);return}})})}notInstalled(f){return this.location?(0,m.localize)(24,null,f,this.location):(0,m.localize)(25,null,f)}};b=ue([fe(0,F.IExtensionManagementService),fe(1,F.IExtensionGalleryService)],b),t.ExtensionManagementCLIService=b}),define(Z[98],te([0,1,2,4,40,11]),function(q,t,m,T,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class F extends m.Disposable{constructor(c,d){super();this.environmentService=c,this.extensionsManifestCache=(0,T.join)(this.environmentService.userDataPath,v.MANIFEST_CACHE_FOLDER,v.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(S=>this.onDidInstallExtensions(S))),this._register(d.onDidUninstallExtension(S=>this.onDidUnInstallExtension(S)))}onDidInstallExtensions(c){c.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){I.Promises.rm(this.extensionsManifestCache,I.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=F}),define(Z[99],te([0,1,88,33,29,10,128,28,71,26,8]),function(q,t,m,T,v,I,F,L,c,d,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function p(l,u,D){return u["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,F.isLaunchedFromCli)(D)&&!u["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,F.isLaunchedFromCli)(D)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=new Promise(async b=>{const R=new d.CancellationTokenSource,f=setTimeout(()=>{l.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),R.dispose(!0),b({})},1e4);try{const r=await O(l,R.token);b(r)}catch(r){(0,S.isPromiseCanceledError)(r)||l.error(`[resolve shell env] Unable to resolve shell environment (${r}). Proceeding without shell environment...`),b({})}finally{clearTimeout(f),R.dispose()}})),y)}t.resolveShellEnv=p;let y;async function O(l,u){const D=new Promise(async(b,R)=>{const f=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",f);const r=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",r);const s=(0,v.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",i);const n=await(0,c.getSystemShell)(I.OS,i);if(l.trace("getUnixShellEnvironment#shell",n),u.isCancellationRequested)return R(S.canceled);const o=m.basename(n);let a,h;/^pwsh(-preview)?$/.test(o)?(a=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,h=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const g=(0,T.spawn)(n,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});u.onCancellationRequested(()=>(g.kill(),R(S.canceled))),g.on("error",N=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(N)),b({})});const k=[];g.stdout.on("data",N=>k.push(N));const P=[];g.stderr.on("data",N=>P.push(N)),g.on("close",(N,x)=>{const _=Buffer.concat(k).toString("utf8");l.trace("getUnixShellEnvironment#raw",_);const J=Buffer.concat(P).toString("utf8");if(J.trim()&&l.trace("getUnixShellEnvironment#stderr",J),N||x)return R(new Error(`Failed to get environment (code ${N}, signal ${x})`));const ie=e.exec(_),se=ie?ie[1]:"{}";try{const Y=JSON.parse(se);f?Y.ELECTRON_RUN_AS_NODE=f:delete Y.ELECTRON_RUN_AS_NODE,r?Y.ELECTRON_NO_ATTACH_CONSOLE=r:delete Y.ELECTRON_NO_ATTACH_CONSOLE,delete Y.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",Y),b(Y)}catch(Y){l.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(Y)),R(Y)}})});try{return await D}catch(b){return l.error("getUnixShellEnvironment#error",(0,L.toErrorMessage)(b)),{}}}}),define(Z[51],te([0,1,7,17,10]),function(q,t,m,T,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function I(c){return c.map(d=>({type:d.type,resource:m.URI.file(d.path)}))}t.toFileChanges=I;function F(c){const d=new L;for(const S of c)d.processEvent(S);return d.normalize()}t.normalizeFileChanges=F;class L{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(d){const S=this.mapPathToChange.get(d.path);if(S){const p=S.type,y=d.type;p===1&&y===2?(this.mapPathToChange.delete(d.path),this.normalized.splice(this.normalized.indexOf(S),1)):p===2&&y===1?S.type=0:p===1&&y===0||(S.type=y)}else this.normalized.push(d),this.mapPathToChange.set(d.path,d)}normalize(){const d=[],S=[];return this.normalized.filter(p=>p.type!==2?(d.push(p),!1):!0).sort((p,y)=>p.path.length-y.path.length).filter(p=>S.some(y=>(0,T.isParent)(p.path,y,!v.isLinux))?!1:(S.push(p.path),!0)).concat(d)}}}),define(Z[100],te([0,1,51,2,11,63,65,3,4]),function(q,t,m,T,v,I,F,L,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends T.Disposable{constructor(p,y,O,l){super();this.path=p,this.onDidFilesChange=y,this.onLogMessage=O,this.verboseLogging=l,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(F.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(p){this.verboseLogging=p}async startWatching(){try{const{stat:p,symbolicLink:y}=await v.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let O=this.path;if(y)try{O=await(0,I.realpath)(O)}catch(l){if(this.onError(l),y.dangling)return}p.isDirectory()?this._register((0,F.watchFolder)(O,(l,u)=>{this.onFileChange({type:l==="changed"?0:l==="added"?1:2,path:(0,c.join)(this.path,(0,c.basename)(u))})},l=>this.onError(l))):this._register((0,F.watchFile)(O,l=>{this.onFileChange({type:l==="changed"?0:2,path:this.path})},l=>this.onError(l)))}catch(p){p.code!=="ENOENT"&&this.onError(p)}}onFileChange(p){this.fileChangesBuffer.push(p),this.verboseLogging&&this.onVerbose(`${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`),this.fileChangesDelayer.trigger(async()=>{const y=this.fileChangesBuffer;this.fileChangesBuffer=[];const O=(0,m.normalizeFileChanges)(y);if(this.verboseLogging)for(const l of O)this.onVerbose(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);O.length>0&&this.onDidFilesChange(O)})}onError(p){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${p}`})}onVerbose(p){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${p}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(Z[52],te([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class m{constructor(...v){this._entries=new Map;for(let[I,F]of v)this.set(I,F)}set(v,I){const F=this._entries.get(v);return this._entries.set(v,I),F}has(v){return this._entries.has(v)}get(v){return this._entries.get(v)}}t.ServiceCollection=m}),define(Z[101],te([0,1,8,95,50,12,52,3]),function(q,t,m,T,v,I,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class d extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class S{constructor(l=new F.ServiceCollection,u=!1,D){this._activeInstantiations=new Set,this._services=l,this._strict=u,this._parent=D,this._services.set(I.IInstantiationService,this)}createChild(l){return new S(l,this._strict,this)}invokeFunction(l,...u){let D=y.traceInvocation(l),b=!1;try{return l({get:(f,r)=>{if(b)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(f,D);if(!s&&r!==I.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return s}},...u)}finally{b=!0,D.stop()}}createInstance(l,...u){let D,b;return l instanceof v.SyncDescriptor?(D=y.traceCreation(l.ctor),b=this._createInstance(l.ctor,l.staticArguments.concat(u),D)):(D=y.traceCreation(l),b=this._createInstance(l,u,D)),D.stop(),b}_createInstance(l,u=[],D){let b=I._util.getServiceDependencies(l).sort((r,s)=>r.index-s.index),R=[];for(const r of b){let s=this._getOrCreateServiceInstance(r.id,D);if(!s&&this._strict&&!r.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${r.id}.`);R.push(s)}let f=b.length>0?b[0].index:u.length;if(u.length!==f){console.warn(`[createInstance] First service dependency of ${l.name} at position ${f+1} conflicts with ${u.length} static arguments`);let r=f-u.length;r>0?u=u.concat(new Array(r)):u=u.slice(0,f)}return new l(...[...u,...R])}_setServiceInstance(l,u){if(this._services.get(l)instanceof v.SyncDescriptor)this._services.set(l,u);else if(this._parent)this._parent._setServiceInstance(l,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let u=this._services.get(l);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):u}_getOrCreateServiceInstance(l,u){let D=this._getServiceInstanceOrDescriptor(l);return D instanceof v.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,D,u.branch(l,!0)):(u.branch(l,!1),D)}_safeCreateAndCacheServiceInstance(l,u,D){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,u,D)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,u,D){const b=new T.Graph(r=>r.id.toString());let R=0;const f=[{id:l,desc:u,_trace:D}];for(;f.length;){const r=f.pop();if(b.lookupOrInsertNode(r),R++>1e3)throw new d(b);for(let s of I._util.getServiceDependencies(r.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${l} depends on ${s.id} which is NOT registered.`),e instanceof v.SyncDescriptor){const i={id:s.id,desc:e,_trace:r._trace.branch(s.id,!0)};b.insertEdge(r,i),f.push(i)}}}for(;;){const r=b.roots();if(r.length===0){if(!b.isEmpty())throw new d(b);break}for(const{data:s}of r){if(this._getServiceInstanceOrDescriptor(s.id)instanceof v.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}b.removeNode(s)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,u,D=[],b,R){if(this._services.get(l)instanceof v.SyncDescriptor)return this._createServiceInstance(u,D,b,R);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,u,D,b,R);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(l,u=[],D,b){if(D){const R=new L.IdleValue(()=>this._createInstance(l,u,b));return new Proxy(Object.create(null),{get(f,r){if(r in f)return f[r];let s=R.value,e=s[r];return typeof e!="function"||(e=e.bind(s),f[r]=e),e},set(f,r,s){return R.value[r]=s,!0}})}else return this._createInstance(l,u,b)}}t.InstantiationService=S;var p;(function(O){O[O.Creation=0]="Creation",O[O.Invocation=1]="Invocation",O[O.Branch=2]="Branch"})(p||(p={}));class y{constructor(l,u){this.type=l,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return c?new y(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(l){return c?new y(0,l.name):y._None}branch(l,u){let D=new y(2,l.toString());return this._dep.push([l,u,D]),D}stop(){let l=Date.now()-this._start;y._totals+=l;let u=!1;function D(R,f){let r=[],s=new Array(R+1).join("	");for(const[e,i,n]of f._dep)if(i&&n){u=!0,r.push(`${s}CREATES -> ${e}`);let o=D(R+1,n);o&&r.push(o)}else r.push(`${s}uses -> ${e}`);return r.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(l>2||u)&&console.log(b.join(`
`))}}y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(Z[53],te([0,1,12]),function(q,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,m.createDecorator)("localizationsService");function T(v){if(typeof v.languageId!="string"||!Array.isArray(v.translations)||v.translations.length===0)return!1;for(const I of v.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(v.languageName&&typeof v.languageName!="string"||v.localizedLanguageName&&typeof v.localizedLanguageName!="string")}t.isValidLocalization=T}),define(Z[15],te([0,1,12,2,10,14,28]),function(q,t,m,T,v,I,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,m.createDecorator)("logService"),t.ILoggerService=(0,m.createDecorator)("loggerService");function L(){return new Date().toISOString()}var c;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;class d extends T.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=d;class S extends d{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(c.Trace)&&this.log(c.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(c.Debug)&&this.log(c.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(c.Info)&&this.log(c.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(c.Warning)&&this.log(c.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(c.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(c.Error,this.format(n))}else this.log(c.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(c.Critical)&&this.log(c.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let o=e[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(a){}i+=(n>0?" ":"")+o}return i}}t.AbstractMessageLogger=S;class p extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!v.isWindows}trace(e,...i){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}debug(e,...i){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}info(e,...i){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}warn(e,...i){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${L()}][0m`,e,...i):console.warn(`[main ${L()}]`,e,...i))}error(e,...i){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}critical(e,...i){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=p;class y extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=y;class O extends d{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,F.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=O;class l extends d{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=l;class u extends T.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=u;class D extends T.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(n))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?c.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=D;class b{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=b;function R(s){if(s.verbose)return c.Trace;if(typeof s.logLevel=="string"){const e=f(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=R;function f(s){switch(s){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=f;function r(s){switch(s){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=r}),define(Z[102],te([0,1,11,2,17,22,21,7,20,23,15,29,41,10,3,8]),function(q,t,m,T,v,I,F,L,c,d,S,p,y,O,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends T.Disposable{constructor(f,r,s,e){super();this.fileService=r,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=L.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,r){await this.cleanUpPromise;const s=this.getName(f),e=(0,c.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const i=(0,c.joinPath)(this.extensionsDownloadDir,`.${(0,p.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(f,i,r);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(o){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,u.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(f){}async rename(f,r,s){try{await m.Promises.rename(f.fsPath,r.fsPath)}catch(e){if(O.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${f} to ${r} with 'EPERM' error. Trying again...`),this.rename(f,r,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const r=[],s=[];for(const n of f.children){const o=this.parse(n.name);o&&s.push([o,n])}const e=(0,d.groupByExtension)(s,([n])=>n),i=[];for(const n of e)n.sort((o,a)=>y.rcompare(o[0].version,a[0].version)),r.push(...n.slice(1).map(o=>o[1].resource)),i.push(n[0][1]);i.sort((n,o)=>n.mtime-o.mtime),r.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await l.Promises.settled(r.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?new d.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase():(0,p.generateUuid)()}parse(f){const r=D.exec(f);return r&&r[1]&&r[2]?new d.ExtensionIdentifierWithVersion({id:r[1]},r[2]):null}};b=ue([fe(0,F.INativeEnvironmentService),fe(1,v.IFileService),fe(2,I.IExtensionGalleryService),fe(3,S.ILogService)],b),t.ExtensionsDownloader=b}),define(Z[103],te([0,1,2,15,33,28,4,3,14,9,11,21]),function(q,t,m,T,v,I,F,L,c,d,S,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let y=class extends m.Disposable{constructor(l,u){super();this.environmentService=l,this.logService=u,this.processesLimiter=new L.Limiter(5)}async postUninstall(l){const u=this.parseScript(l,"uninstall");return u&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(u.script,"uninstall",u.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),D=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${D}`)))),S.Promises.rm(this.getExtensionStoragePath(l)).then(void 0,D=>this.logService.error("Error while removing extension storage path",D))}parseScript(l,u){const D=`vscode:${u}`;if(l.location.scheme===d.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[D]=="string"){const b=l.manifest.scripts[D].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${D} should be a node script`),null):{script:(0,F.join)(l.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(l,u,D,b,R){return new Promise((f,r)=>{const s=this.start(l,u,D,R);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?r(n):f(void 0)};s.on("error",n=>{i((0,I.toErrorMessage)(n)||"Unknown")}),s.on("exit",(n,o)=>{i(n?`post-${u} process exited with code ${n}`:void 0)}),b&&(e=setTimeout(()=>{e=null,s.kill(),r("timed out")},5e3))})}start(l,u,D,b){const R={silent:!0,execArgv:void 0},f=(0,v.fork)(l,[`--type=extension-post-${u}`,...D],R);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const r=c.Event.fromNodeEventEmitter(f.stdout,"data"),s=c.Event.fromNodeEventEmitter(f.stderr,"data");r(n=>this.logService.info(b.identifier.id,b.manifest.version,`post-${u}`,n)),s(n=>this.logService.error(b.identifier.id,b.manifest.version,`post-${u}`,n));const e=c.Event.any(c.Event.map(r,n=>({data:`%c${n}`,format:[""]})),c.Event.map(s,n=>({data:`%c${n}`,format:["color: red"]})));return c.Event.debounce(e,(n,o)=>n?{data:n.data+o.data,format:[...n.format,...o.format]}:{data:o.data,format:o.format},100)(n=>{console.group(b.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(l){return(0,F.join)(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};y=ue([fe(0,p.IEnvironmentService),fe(1,T.ILogService)],y),t.ExtensionsLifecycle=y}),define(Z[104],te([0,1,2,21,14,17,7,23,20,15]),function(q,t,m,T,v,I,F,L,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let S=class extends m.Disposable{constructor(y,O,l,u){super();this.extensionsManagementService=y,this.logService=u,this._onDidChangeExtensionsByAnotherSource=this._register(new v.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(R=>{this.installedExtensions=R.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(y.onInstallExtension(R=>this.onInstallExtension(R))),this._register(y.onDidInstallExtensions(R=>this.onDidInstallExtensions(R))),this._register(y.onDidUninstallExtension(R=>this.onDidUninstallExtension(R)));const D=F.URI.file(l.extensionsPath),b=new c.ExtUri(R=>!O.hasCapability(R,1024));this._register(O.watch(D)),this._register(v.Event.filter(O.onDidChangeFilesRaw,R=>R.changes.some(f=>this.doesChangeAffects(f,D,b)))(()=>this.onDidChange()))}doesChangeAffects(y,O,l){return l.isEqual(l.dirname(y.resource),O)?l.isEqual(y.resource,l.joinPath(O,".obsolete"))?!0:!(y.type!==1&&y.type!==2||l.basename(y.resource).startsWith(".")):!1}onInstallExtension(y){this.addInstallingExtension(y.identifier)}onDidInstallExtensions(y){for(const O of y)this.removeInstallingExtension(O.identifier),O.local&&this.addInstalledExtension(O.identifier)}onDidUninstallExtension(y){y.error||this.removeInstalledExtension(y.identifier)}addInstallingExtension(y){this.removeInstallingExtension(y),this.installingExtensions.push(y)}removeInstallingExtension(y){this.installingExtensions=this.installingExtensions.filter(O=>!(0,L.areSameExtensions)(O,y))}addInstalledExtension(y){this.installedExtensions&&(this.removeInstalledExtension(y),this.installedExtensions.push(y))}removeInstalledExtension(y){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(O=>!(0,L.areSameExtensions)(O,y)))}async onDidChange(){if(this.installedExtensions){const y=await this.extensionsManagementService.getInstalled(1),O=y.filter(u=>[...this.installingExtensions,...this.installedExtensions].some(D=>(0,L.areSameExtensions)(D,u.identifier))?!1:u.installedTimestamp&&u.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",u.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",u.identifier.id),!1)),l=this.installedExtensions.filter(u=>this.installingExtensions.some(D=>(0,L.areSameExtensions)(D,u))?!1:y.every(D=>!(0,L.areSameExtensions)(D.identifier,u))?(this.logService.info("Detected extension removed from another source",u.id),!0):!1);this.installedExtensions=y.map(u=>u.identifier),(O.length||l.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:O,removed:l})}}};S=ue([fe(1,I.IFileService),fe(2,T.INativeEnvironmentService),fe(3,d.ILogService)],S),t.ExtensionsWatcher=S}),define(Z[105],te([0,1,11,129,22,2,21,3,23,15,53,24,9,4]),function(q,t,m,T,v,I,F,L,c,d,S,p,y,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let l=class extends I.Disposable{constructor(b,R,f){super();this.extensionManagementService=b,this.logService=f,this.cache=this._register(new u(R,f)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getLanguageIds(){const b=await this.cache.getLanguagePacks(),R=["en",...Object.keys(b)];return(0,p.distinct)(R)}async postInstallExtension(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",b.identifier.id),await this.update())}async postUninstallExtension(b){const R=await this.cache.getLanguagePacks();Object.keys(R).some(f=>R[f]&&R[f].extensions.some(r=>(0,c.areSameExtensions)(r.extensionIdentifier,b.identifier)))&&(this.logService.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,R]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(R);return!(0,p.equals)(Object.keys(b),Object.keys(f))}};l=ue([fe(0,v.IExtensionManagementService),fe(1,F.INativeEnvironmentService),fe(2,d.ILogService)],l),t.LocalizationsService=l;let u=class extends I.Disposable{constructor(b,R){super();this.logService=R,this.languagePacks={},this.languagePacksFilePath=(0,O.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(R=>{Object.keys(R).forEach(f=>delete R[f]),this.createLanguagePacksFromExtensions(R,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...R){for(const f of R)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,f);Object.keys(b).forEach(f=>this.updateHash(b[f]))}createLanguagePacksFromExtension(b,R){const f=R.identifier,r=R.manifest.contributes&&R.manifest.contributes.localizations?R.manifest.contributes.localizations:[];for(const s of r)if(R.location.scheme===y.Schemas.file&&(0,S.isValidLocalization)(s)){let e=b[s.languageId];e||(e={hash:"",extensions:[],translations:{}},b[s.languageId]=e);let i=e.extensions.filter(n=>(0,c.areSameExtensions)(n.extensionIdentifier,f))[0];i?i.version=R.manifest.version:e.extensions.push({extensionIdentifier:f,version:R.manifest.version});for(const n of s.translations)e.translations[n.id]=(0,O.join)(R.location.fsPath,n.path)}}updateHash(b){if(b){const R=(0,T.createHash)("md5");for(const f of b.extensions)R.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);b.hash=R.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let R=null;return m.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(r){return{}}}).then(f=>(R=b(f),f)).then(f=>{for(const s of Object.keys(f))f[s]||delete f[s];this.languagePacks=f,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),m.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>R,f=>this.logService.error(f))})}};u=ue([fe(0,F.INativeEnvironmentService),fe(1,d.ILogService)],u)}),define(Z[106],te([0,1,15,17]),function(q,t,m,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function v(c,d,S,p){try{const y=await new Promise((O,l)=>{q(["spdlog"],O,l)});return y.setFlushOn(m.LogLevel.Trace),y.createAsyncRotatingLogger(c,d,S,p)}catch(y){console.error(y)}return null}function I(c,d,S,p){const y=q.__$__nodeRequire("spdlog");return y.setFlushOn(m.LogLevel.Trace),y.createRotatingLogger(c,d,S,p)}t.createRotatingLogger=I;function F(c,d,S){switch(d){case m.LogLevel.Trace:c.trace(S);break;case m.LogLevel.Debug:c.debug(S);break;case m.LogLevel.Info:c.info(S);break;case m.LogLevel.Warning:c.warn(S);break;case m.LogLevel.Error:c.error(S);break;case m.LogLevel.Critical:c.critical(S);break;default:throw new Error("Invalid log level")}}class L extends m.AbstractMessageLogger{constructor(d,S,p,y){super();this.name=d,this.filepath=S,this.rotating=p,this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(O=>{this._logger&&this._logger.setLevel(O)}))}_createSpdLogLogger(){const d=this.rotating?6:1,S=30/d*T.ByteSize.MB;return v(this.name,this.filepath,S,d).then(p=>{if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:y,message:O}of this.buffer)F(this._logger,y,O);this.buffer=[]}})}log(d,S){this._logger?F(this._logger,d,S):this.getLevel()<=d&&this.buffer.push({level:d,message:S})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=L}),define(Z[54],te([0,1,82,16,17,8,35]),function(q,t,m,T,v,I,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function L(p,y,O,l,u,D){let b;try{await c(p,y,O,l,u,D)}catch(R){b=R}finally{b&&u.errorTransformer&&(b=u.errorTransformer(b)),typeof b!="undefined"&&O.error(b),O.end()}}t.readFileIntoStream=L;async function c(p,y,O,l,u,D){d(D);const b=await p.open(y,{create:!1});try{d(D);let R=0,f=0,r=u&&typeof u.length=="number"?u.length:void 0,s=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof r=="number"?r:u.bufferSize)),e=u&&typeof u.position=="number"?u.position:0,i=0;do f=await p.read(b,e,s.buffer,i,s.byteLength-i),e+=f,i+=f,R+=f,typeof r=="number"&&(r-=f),i===s.byteLength&&(await O.write(l(s)),s=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof r=="number"?r:u.bufferSize)),i=0);while(f>0&&(typeof r!="number"||r>0)&&d(D)&&S(R,u));if(i>0){let n=i;typeof r=="number"&&(n=Math.min(i,r)),O.write(l(s.slice(0,n)))}}catch(R){throw(0,v.ensureFileSystemProviderError)(R)}finally{await p.close(b)}}function d(p){if(p.isCancellationRequested)throw(0,I.canceled)();return!0}function S(p,y){if(y?.limits){if(typeof y.limits.memory=="number"&&p>y.limits.memory)throw(0,v.createFileSystemProviderError)((0,m.localize)(0,null,F.default.nameShort),v.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&p>y.limits.size)throw(0,v.createFileSystemProviderError)((0,m.localize)(1,null),v.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[107],te([0,1,81,130,2,17,14,20,45,24,15,16,37,3,26,9,54,131]),function(q,t,m,T,v,I,F,L,c,d,S,p,y,O,l,u,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let R=class Ne extends v.Disposable{constructor(r){super();this.logService=r,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new F.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new F.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new F.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new F.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new F.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new F.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new F.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new O.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new I.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new O.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new I.FileChangesEvent(s,!0)))),this.watchedResources=c.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(r,s){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,T.mark)(`code/registerFilesystem/${r}`),this.provider.set(r,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:s});const e=new v.DisposableStore;return e.add(s.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:r}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,v.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:s}),this.provider.delete(r),(0,v.dispose)(e)})}getProvider(r){return this.provider.get(r)}async activateProvider(r){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(e){s.push(e)}}),!this.provider.has(r)&&await O.Promises.settled(s)}canHandleResource(r){return this.provider.has(r.scheme)}hasCapability(r,s){const e=this.provider.get(r.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return b.Iterable.map(this.provider,([r,s])=>({scheme:r,capabilities:s.capabilities}))}async withProvider(r){if(!(0,L.isAbsolutePath)(r))throw new I.FileOperationError((0,m.localize)(0,null,this.resourceForError(r)),8);await this.activateProvider(r.scheme);const s=this.provider.get(r.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,m.localize)(1,null,r.toString()),e}return s}async withReadProvider(r){const s=await this.withProvider(r);if((0,I.hasOpenReadWriteCloseCapability)(s)||(0,I.hasReadWriteCapability)(s)||(0,I.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const s=await this.withProvider(r);if((0,I.hasOpenReadWriteCloseCapability)(s)||(0,I.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,s){try{return await this.doResolveFile(r,s)}catch(e){throw(0,I.toFileSystemProviderErrorCode)(e)===I.FileSystemProviderErrorCode.FileNotFound?new I.FileOperationError((0,m.localize)(2,null,this.resourceForError(r)),1):(0,I.ensureFileSystemProviderError)(e)}}async doResolveFile(r,s){const e=await this.withProvider(r),i=this.isPathCaseSensitive(e),n=s?.resolveTo,o=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,h=await e.stat(r);let g;return this.toFileStat(e,r,h,void 0,!!a,(k,P)=>(g||(g=c.TernarySearchTree.forUris(()=>!i),g.set(r,!0),(0,d.isNonEmptyArray)(n)&&n.forEach(N=>g.set(N,!0))),Boolean(g.findSuperstr(k.resource)||g.get(k.resource))?!0:k.isDirectory&&o?P===1:!1))}async toFileStat(r,s,e,i,n,o){const{providerExtUri:a}=this.getExtUri(r),h={resource:s,name:a.basename(s),isFile:(e.type&I.FileType.File)!=0,isDirectory:(e.type&I.FileType.Directory)!=0,isSymbolicLink:(e.type&I.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&I.FilePermission.Readonly)||Boolean(r.capabilities&2048),etag:(0,I.etag)({mtime:e.mtime,size:e.size})};if(h.isDirectory&&o(h,i)){try{const g=await r.readdir(s),k=await O.Promises.settled(g.map(async([P,N])=>{try{const x=a.joinPath(s,P),_=n?await r.stat(x):{type:N};return await this.toFileStat(r,x,_,g.length,n,o)}catch(x){return this.logService.trace(x),null}}));h.children=(0,d.coalesce)(k)}catch(g){this.logService.trace(g),h.children=[]}return h}return h}async resolveAll(r){return O.Promises.settled(r.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(r){const s=await this.withProvider(r);try{return!!await s.stat(r)}catch(e){return!1}}async canCreateFile(r,s){try{await this.doValidateCreateFile(r,s)}catch(e){return e}return!0}async doValidateCreateFile(r,s){if(!s?.overwrite&&await this.exists(r))throw new I.FileOperationError((0,m.localize)(3,null,this.resourceForError(r)),3,s)}async createFile(r,s=p.VSBuffer.fromString(""),e){await this.doValidateCreateFile(r,e);const i=await this.writeFile(r,s);return this._onDidRunOperation.fire(new I.FileOperationEvent(r,0,i)),i}async writeFile(r,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,r,e)||await this.mkdirp(i,n.dirname(r));let a;if((0,I.hasReadWriteCapability)(i)&&!(s instanceof p.VSBuffer))if((0,y.isReadableStream)(s)){const h=await(0,y.peekStream)(s,3);h.ended?a=p.VSBuffer.concat(h.buffer):a=h}else a=(0,y.peekReadable)(s,h=>p.VSBuffer.concat(h),3);else a=s;!(0,I.hasOpenReadWriteCloseCapability)(i)||(0,I.hasReadWriteCapability)(i)&&a instanceof p.VSBuffer?await this.doWriteUnbuffered(i,r,e,a):await this.doWriteBuffered(i,r,e,a instanceof p.VSBuffer?(0,p.bufferToReadable)(a):a)}catch(o){throw new I.FileOperationError((0,m.localize)(4,null,this.resourceForError(r),(0,I.ensureFileSystemProviderError)(o).toString()),(0,I.toFileOperationResult)(o),e)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,s,e){if(!!e?.unlock&&!(r.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(s)));let n;try{n=await r.stat(s)}catch(o){return}if((n.type&I.FileType.Directory)!=0)throw new I.FileOperationError((0,m.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,n),e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==I.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,I.etag)({mtime:e.mtime,size:n.size}))throw new I.FileOperationError((0,m.localize)(7,null),3,e);return n}async readFile(r,s){const e=await this.withReadProvider(r);return s?.atomic?this.doReadFileAtomic(e,r,s):this.doReadFile(e,r,s)}async doReadFileAtomic(r,s,e){return new Promise((i,n)=>{this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(r,s,e);i(o)}catch(o){n(o)}})})}async doReadFile(r,s,e){const i=await this.doReadFileStream(r,s,{...e,preferUnbuffered:!0});return{...i,value:await(0,p.streamToBuffer)(i.value)}}async readFileStream(r,s){const e=await this.withReadProvider(r);return this.doReadFileStream(e,r,s)}async doReadFileStream(r,s,e){const i=new l.CancellationTokenSource,n=this.validateReadFile(s,e).then(a=>a,a=>{throw i.cancel(),a});let o;try{return e&&typeof e.etag=="string"&&e.etag!==I.ETAG_DISABLED&&await n,!((0,I.hasOpenReadWriteCloseCapability)(r)||(0,I.hasFileReadStreamCapability)(r))||(0,I.hasReadWriteCapability)(r)&&e?.preferUnbuffered?o=this.readFileUnbuffered(r,s,e):(0,I.hasFileReadStreamCapability)(r)?o=this.readFileStreamed(r,s,i.token,e):o=this.readFileBuffered(r,s,i.token,e),{...await n,value:o}}catch(a){o&&await(0,y.consumeStream)(o);const h=(0,m.localize)(8,null,this.resourceForError(s),(0,I.ensureFileSystemProviderError)(a).toString());throw a instanceof I.NotModifiedSinceFileOperationError?new I.NotModifiedSinceFileOperationError(h,a.stat,e):new I.FileOperationError(h,(0,I.toFileOperationResult)(a),e)}}readFileStreamed(r,s,e,i=Object.create(null)){const n=r.readFileStream(s,i,e);return(0,y.transform)(n,{data:o=>o instanceof p.VSBuffer?o:p.VSBuffer.wrap(o),error:o=>new I.FileOperationError((0,m.localize)(9,null,this.resourceForError(s),(0,I.ensureFileSystemProviderError)(o).toString()),(0,I.toFileOperationResult)(o),i)},o=>p.VSBuffer.concat(o))}readFileBuffered(r,s,e,i=Object.create(null)){const n=(0,p.newWriteableBufferStream)();return(0,D.readFileIntoStream)(r,s,n,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new I.FileOperationError((0,m.localize)(10,null,this.resourceForError(s),(0,I.ensureFileSystemProviderError)(o).toString()),(0,I.toFileOperationResult)(o),i)},e),n}readFileUnbuffered(r,s,e){const i=(0,y.newWriteableStream)(n=>p.VSBuffer.concat(n));return(async()=>{try{let n=await r.readFile(s);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(s,n.byteLength,e),i.end(p.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(r,s){const e=await this.resolve(r,{resolveMetadata:!0});if(e.isDirectory)throw new I.FileOperationError((0,m.localize)(11,null,this.resourceForError(r)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==I.ETAG_DISABLED&&s.etag===e.etag)throw new I.NotModifiedSinceFileOperationError((0,m.localize)(12,null),e,s);return this.validateReadFileLimits(r,e.size,s),e}validateReadFileLimits(r,s,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&s>e.limits.size&&(i=7),typeof i=="number")throw new I.FileOperationError((0,m.localize)(13,null,this.resourceForError(r)),i)}}async canMove(r,s,e){return this.doCanMoveCopy(r,s,"move",e)}async canCopy(r,s,e){return this.doCanMoveCopy(r,s,"copy",e)}async doCanMoveCopy(r,s,e,i){if(r.toString()!==s.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,r,o,s,e,i)}catch(n){return n}return!0}async move(r,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,r,n,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new I.FileOperationEvent(r,o==="move"?2:3,a)),a}async copy(r,s,e){const i=await this.withReadProvider(r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,r,n,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new I.FileOperationEvent(r,o==="copy"?3:2,a)),a}async doMoveCopy(r,s,e,i,n,o){if(s.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(r,s,e,i,n,o);if(a&&!h&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(r===e&&(0,I.hasFileFolderCopyCapability)(r))await r.copy(s,i,{overwrite:o});else{const g=await this.resolve(s);g.isDirectory?await this.doCopyFolder(r,g,e,i):await this.doCopyFile(r,s,e,i)}return n}else return r===e?(await r.rename(s,i,{overwrite:o}),n):(await this.doMoveCopy(r,s,e,i,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(r,s,e,i){if((0,I.hasOpenReadWriteCloseCapability)(r)&&(0,I.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(r,s,e,i);if((0,I.hasOpenReadWriteCloseCapability)(r)&&(0,I.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(r,s,e,i);if((0,I.hasReadWriteCapability)(r)&&(0,I.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(r,s,e,i);if((0,I.hasReadWriteCapability)(r)&&(0,I.hasReadWriteCapability)(e))return this.doPipeUnbuffered(r,s,e,i)}async doCopyFolder(r,s,e,i){await e.mkdir(i),Array.isArray(s.children)&&await O.Promises.settled(s.children.map(async n=>{const o=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(r,await this.resolve(n.resource),e,o):this.doCopyFile(r,n.resource,e,o)}))}async doValidateMoveCopy(r,s,e,i,n,o){let a=!1;if(r===e){const{providerExtUri:g,isPathCaseSensitive:k}=this.getExtUri(r);if(k||(a=g.isEqual(s,i)),a&&n==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&g.isEqualOrParent(i,s))throw new Error((0,m.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const h=await this.exists(i);if(h&&!a){if(!o)throw new I.FileOperationError((0,m.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(r===e){const{providerExtUri:g}=this.getExtUri(r);if(g.isEqualOrParent(s,i))throw new Error((0,m.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:h,isSameResourceWithDifferentPathCase:a}}getExtUri(r){const s=this.isPathCaseSensitive(r);return{providerExtUri:s?L.extUri:L.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(r){return!!(r.capabilities&1024)}async createFolder(r){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(s,r);const e=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new I.FileOperationEvent(r,0,e)),e}async mkdirp(r,s){const e=[],{providerExtUri:i}=this.getExtUri(r);for(;!i.isEqual(s,i.dirname(s));)try{if(((await r.stat(s)).type&I.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,I.toFileSystemProviderErrorCode)(n)!==I.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(s)),s=i.dirname(s)}for(let n=e.length-1;n>=0;n--){s=i.joinPath(s,e[n]);try{await r.mkdir(s)}catch(o){if((0,I.toFileSystemProviderErrorCode)(o)!==I.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(r,s){try{await this.doValidateDelete(r,s)}catch(e){return e}return!0}async doValidateDelete(r,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(r)));let n;try{n=await e.stat(r)}catch(a){}if(n)this.throwIfFileIsReadonly(r,n);else throw new I.FileOperationError((0,m.localize)(20,null,this.resourceForError(r)),1);if(!!!s?.recursive){const a=await this.resolve(r);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(r)))}return e}async del(r,s){const e=await this.doValidateDelete(r,s),i=!!s?.useTrash,n=!!s?.recursive;await e.delete(r,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new I.FileOperationEvent(r,1))}onDidChangeFile(r,s){this._onDidChangeFilesRaw.fire({changes:r});let e,i;{for(const n of r)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new I.FileChangesEvent(e,!s))}if(i){const n=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(r,s={recursive:!1,excludes:[]}){const e=new v.DisposableStore;{let i=!1,n=()=>{i=!0};e.add((0,v.toDisposable)(()=>n())),this.doWatch(r,s).then(o=>{i?(0,v.dispose)(o):n=()=>(0,v.dispose)(o)},o=>this.logService.error(o))}return s.recursive||(this.watchedResources.set(r,(this.watchedResources.get(r)??0)+1),e.add((0,v.toDisposable)(()=>{const i=this.watchedResources.get(r);typeof i=="number"&&(i<=1?this.watchedResources.delete(r):this.watchedResources.set(r,i-1))}))),e}async doWatch(r,s){const e=await this.withProvider(r),i=this.toWatchKey(e,r,s),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(r,s)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,v.toDisposable)(()=>{n.count--,n.count===0&&((0,v.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(r,s,e){const{providerExtUri:i}=this.getExtUri(r);return[i.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,r]of this.activeWatchers)(0,v.dispose)(r.disposable);this.activeWatchers.clear()}async doWriteBuffered(r,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri).queue(async()=>{const n=await r.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,y.isReadableStream)(i)||(0,y.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(r,n,i):await this.doWriteReadableBufferedQueued(r,n,i)}catch(o){throw(0,I.ensureFileSystemProviderError)(o)}finally{await r.close(n)}})}async doWriteStreamBufferedQueued(r,s,e){let i=0,n;if((0,y.isReadableBufferedStream)(e)){if(e.buffer.length>0){const o=p.VSBuffer.concat(e.buffer);await this.doWriteBuffer(r,s,o,o.byteLength,i,0),i+=o.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(o,a)=>{(0,y.listenStream)(n,{onData:async h=>{n.pause();try{await this.doWriteBuffer(r,s,h,h.byteLength,i,0)}catch(g){return a(g)}i+=h.byteLength,setTimeout(()=>n.resume())},onError:h=>a(h),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(r,s,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(r,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(r,s,e,i,n,o){let a=0;for(;a<i;)a+=await r.write(s,n+a,e.buffer,o+a,i-a)}async doWriteUnbuffered(r,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(r,s,e,i))}async doWriteUnbufferedQueued(r,s,e,i){let n;i instanceof p.VSBuffer?n=i:(0,y.isReadableStream)(i)?n=await(0,p.streamToBuffer)(i):(0,y.isReadableBufferedStream)(i)?n=await(0,p.bufferedStreamToBuffer)(i):n=(0,p.readableToBuffer)(i),await r.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(r,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(r,s,e,i))}async doPipeBufferedQueued(r,s,e,i){let n,o;try{n=await r.open(s,{create:!1}),o=await e.open(i,{create:!0,unlock:!1});const a=p.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,g=0,k=0;do k=await r.read(n,h,a.buffer,g,a.byteLength-g),await this.doWriteBuffer(e,o,a,k,h,g),h+=k,g+=k,g===a.byteLength&&(g=0);while(k>0)}catch(a){throw(0,I.ensureFileSystemProviderError)(a)}finally{await O.Promises.settled([typeof n=="number"?r.close(n):Promise.resolve(),typeof o=="number"?e.close(o):Promise.resolve()])}}async doPipeUnbuffered(r,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(r,s,e,i))}async doPipeUnbufferedQueued(r,s,e,i){return e.writeFile(i,await r.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(r,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(r,s,e,i))}async doPipeUnbufferedToBufferedQueued(r,s,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const o=await r.readFile(s);await this.doWriteBuffer(e,n,p.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,I.ensureFileSystemProviderError)(o)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(r,s,e,i){const n=await(0,p.streamToBuffer)(this.readFileBuffered(r,s,l.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(r,s){if(r.capabilities&2048)throw new I.FileOperationError((0,m.localize)(22,null,this.resourceForError(s)),6);return r}throwIfFileIsReadonly(r,s){if((s.permissions??0)&I.FilePermission.Readonly)throw new I.FileOperationError((0,m.localize)(23,null,this.resourceForError(r)),6)}resourceForError(r){return r.scheme===u.Schemas.file?r.fsPath:r.toString(!0)}};R.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},R=ue([fe(0,S.ILogService)],R),t.FileService=R}),define(Z[108],te([0,1,2,17,14,10,11,4,20,31,3,15,83,51,92,94,91,100,37,54,24,16]),function(q,t,m,T,v,I,F,L,c,d,S,p,y,O,l,u,D,b,R,f,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends m.Disposable{constructor(n,o){super();this.logService=n,this.options=o,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=v.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new v.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new v.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new S.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:o,symbolicLink:a}=await F.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(o,a),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(n){try{const o=await F.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),a=[];return await Promise.all(o.map(async h=>{try{let g;h.isSymbolicLink()?g=(await this.stat((0,c.joinPath)(n,h.name))).type:g=this.toType(h),a.push([h.name,g])}catch(g){this.logService.trace(g)}})),a}catch(o){throw this.toFileSystemProviderError(o)}}toType(n,o){let a;return o?.dangling?a=T.FileType.Unknown:n.isFile()?a=T.FileType.File:n.isDirectory()?a=T.FileType.Directory:a=T.FileType.Unknown,o&&(a|=T.FileType.SymbolicLink),a}async readFile(n){try{const o=this.toFilePath(n);return await F.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(n,o,a){const h=(0,R.newWriteableStream)(g=>s.VSBuffer.concat(g.map(k=>s.VSBuffer.wrap(k))).buffer);return(0,f.readFileIntoStream)(this,n,h,g=>g.buffer,{...o,bufferSize:this.BUFFER_SIZE},a),h}async writeFile(n,o,a){let h;try{const g=this.toFilePath(n);if(!a.create||!a.overwrite){if(await F.Promises.exists(g)){if(!a.overwrite)throw(0,T.createFileSystemProviderError)((0,y.localize)(0,null),T.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,T.createFileSystemProviderError)((0,y.localize)(1,null),T.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(n,{create:!0,unlock:a.unlock}),await this.write(h,0,o,0,o.byteLength)}catch(g){throw await this.toFileSystemProviderWriteError(n,g)}finally{typeof h=="number"&&await this.close(h)}}async open(n,o){try{const a=this.toFilePath(n);if((0,T.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:k}=await F.SymlinkSupport.stat(a);k.mode&128||await F.Promises.chmod(a,k.mode|128)}catch(k){this.logService.trace(k)}let h;if((0,T.isFileOpenForWriteOptions)(o)){if(I.isWindows)try{await F.Promises.truncate(a,0),h="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}h||(h="w")}else h="r";const g=await F.Promises.open(a,h);return this.mapHandleToPos.set(g,0),(0,T.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(g,n),g}catch(a){throw(0,T.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(n,a):this.toFileSystemProviderError(a)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await F.Promises.fdatasync(n)}catch(o){this.canFlush=!1,this.logService.error(o)}return await F.Promises.close(n)}catch(o){throw this.toFileSystemProviderError(o)}}async read(n,o,a,h,g){const k=this.normalizePos(n,o);let P=null;try{const N=await F.Promises.read(n,a,h,g,k);return typeof N=="number"?P=N:P=N.bytesRead,P}catch(N){throw this.toFileSystemProviderError(N)}finally{this.updatePos(n,k,P)}}normalizePos(n,o){return o===this.mapHandleToPos.get(n)?null:o}updatePos(n,o,a){const h=this.mapHandleToPos.get(n);typeof h=="number"&&(typeof o=="number"||(typeof a=="number"?this.mapHandleToPos.set(n,h+a):this.mapHandleToPos.delete(n)))}async write(n,o,a,h,g){return(0,S.retry)(()=>this.doWrite(n,o,a,h,g),100,3)}async doWrite(n,o,a,h,g){const k=this.normalizePos(n,o);let P=null;try{const N=await F.Promises.write(n,a,h,g,k);return typeof N=="number"?P=N:P=N.bytesWritten,P}catch(N){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),N)}finally{this.updatePos(n,k,P)}}async mkdir(n){try{await F.Promises.mkdir(this.toFilePath(n))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(n,o){try{const a=this.toFilePath(n);await this.doDelete(a,o)}catch(a){throw this.toFileSystemProviderError(a)}}async doDelete(n,o){o.recursive?await F.Promises.rm(n,F.RimRafMode.MOVE):await F.Promises.unlink(n)}async rename(n,o,a){const h=this.toFilePath(n),g=this.toFilePath(o);if(h!==g)try{await this.validateTargetDeleted(n,o,"move",a.overwrite),await F.Promises.move(h,g)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,y.localize)(2,null,(0,L.basename)(h),(0,L.basename)((0,L.dirname)(g)),k.toString()))),this.toFileSystemProviderError(k)}}async copy(n,o,a){const h=this.toFilePath(n),g=this.toFilePath(o);if(h!==g)try{await this.validateTargetDeleted(n,o,"copy",a.overwrite),await F.Promises.copy(h,g,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,y.localize)(3,null,(0,L.basename)(h),(0,L.basename)((0,L.dirname)(g)),k.toString()))),this.toFileSystemProviderError(k)}}async validateTargetDeleted(n,o,a,h){const g=this.toFilePath(n),k=this.toFilePath(o);let P=!1;if(!!(this.capabilities&1024)||(P=(0,d.isEqual)(g,k,!0)),P&&a==="copy")throw(0,T.createFileSystemProviderError)((0,y.localize)(4,null),T.FileSystemProviderErrorCode.FileExists);if(!P&&await F.Promises.exists(k)){if(!h)throw(0,T.createFileSystemProviderError)((0,y.localize)(5,null),T.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(n,o){return o.recursive?this.watchRecursive(n,o.excludes):this.watchNonRecursive(n)}watchRecursive(n,o){const a={path:this.toFilePath(n),excludes:o},h=(0,r.insert)(this.recursiveFoldersToWatch,a);return this.refreshRecursiveWatchers(),(0,m.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,m.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,o;this.options?.watcher?.usePolling?(n=l.FileWatcher,o=this.options?.watcher):this.recursiveFoldersToWatch.length===1?I.isWindows?n=u.FileWatcher:n=l.FileWatcher:n=D.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,a=>this._onDidChangeFile.fire((0,O.toFileChanges)(a)),a=>{a.type==="error"&&this._onDidWatchErrorOccur.fire(a.message),this.logService[a.type](a.message)},this.logService.getLevel()===p.LogLevel.Trace,o),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))}}watchNonRecursive(n){const o=new b.FileWatcher(this.toFilePath(n),h=>this._onDidChangeFile.fire((0,O.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===p.LogLevel.Trace),a=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)});return(0,m.combinedDisposable)(o,a)}toFilePath(n){return(0,L.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof T.FileSystemProviderError)return n;let o;switch(n.code){case"ENOENT":o=T.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=T.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=T.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=T.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=T.FileSystemProviderErrorCode.NoPermissions;break;default:o=T.FileSystemProviderErrorCode.Unknown}return(0,T.createFileSystemProviderError)(n,o)}async toFileSystemProviderWriteError(n,o){let a=this.toFileSystemProviderError(o);if(n&&a.code===T.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await F.SymlinkSupport.stat(this.toFilePath(n));h.mode&128||(a=(0,T.createFileSystemProviderError)(o,T.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.logService.trace(h)}return a}dispose(){super.dispose(),(0,m.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,m.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(Z[42],te([0,1,12]),function(q,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,m.createDecorator)("productService")}),define(Z[25],te([0,1,13,57]),function(q,t,m,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class v{constructor(){this.data=new Map}add(F,L){T.ok(m.isString(F)),T.ok(m.isObject(L)),T.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,L)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}t.Registry=new v}),define(Z[109],te([0,1,25,14]),function(q,t,m,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function v(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class I{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,d){this.schemasById[v(c)]=d,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new I;m.Registry.add(t.Extensions.JSONContribution,F)}),define(Z[30],te([0,1,73,14,25,13,109]),function(q,t,m,T,v,I,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var L;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(L=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var c;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(c=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const d=v.Registry.as(F.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(R,f=!0){this.registerConfigurations([R],f)}registerConfigurations(R,f=!0){const r=[];R.forEach(s=>{r.push(...this.validateAndRegisterProperties(s,f,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterConfigurations(R){const f=[],r=s=>{if(s.properties)for(const e in s.properties)f.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,s.properties[e]);s.allOf&&s.allOf.forEach(e=>r(e))};for(const s of R){r(s);const e=this.configurationContributors.indexOf(s);e!==-1&&this.configurationContributors.splice(e,1)}d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}registerDefaultConfigurations(R){const f=[],r=[];for(const s of R)for(const e in s)if(f.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...s[e]};const i={type:"object",default:this.defaultValues[e],description:m.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};r.push(y(e)),this.configurationProperties[e]=i,this.defaultLanguageConfigurationOverridesNode.properties[e]=i}else{this.defaultValues[e]=s[e];const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(R){const f=[];for(const r of R)for(const s in r)if(f.push(s),delete this.defaultValues[s],t.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const e=this.configurationProperties[s];e&&(this.updatePropertyDefaultValue(s,e),this.updateSchema(s,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(...R){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(R){for(const f of R)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(R,f=!0,r,s=3){s=I.isUndefinedOrNull(R.scope)?s:R.scope;let e=[],i=R.properties;if(i)for(let o in i){if(f&&u(o)){delete i[o];continue}const a=i[o];if(this.updatePropertyDefaultValue(o,a),t.OVERRIDE_PROPERTY_PATTERN.test(o)?a.scope=void 0:(a.scope=I.isUndefinedOrNull(a.scope)?s:a.scope,a.restricted=I.isUndefinedOrNull(a.restricted)?!!r?.restrictedConfigurations?.includes(o):a.restricted),i[o].hasOwnProperty("included")&&!i[o].included){this.excludedConfigurationProperties[o]=i[o],delete i[o];continue}else this.configurationProperties[o]=i[o];!i[o].deprecationMessage&&i[o].markdownDeprecationMessage&&(i[o].deprecationMessage=i[o].markdownDeprecationMessage),e.push(o)}let n=R.allOf;if(n)for(let o of n)e.push(...this.validateAndRegisterProperties(o,f,r,s));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(R){const f=r=>{let s=r.properties;if(s)for(const i in s)this.updateSchema(i,s[i]);let e=r.allOf;e&&e.forEach(f)};f(R)}updateSchema(R,f){switch(t.allSettings.properties[R]=f,f.scope){case 1:t.applicationSettings.properties[R]=f;break;case 2:t.machineSettings.properties[R]=f;break;case 6:t.machineOverridableSettings.properties[R]=f;break;case 3:t.windowSettings.properties[R]=f;break;case 4:t.resourceSettings.properties[R]=f;break;case 5:t.resourceSettings.properties[R]=f,this.resourceLanguageSettingsSchema.properties[R]=f;break}}removeFromSchema(R,f){switch(delete t.allSettings.properties[R],f.scope){case 1:delete t.applicationSettings.properties[R];break;case 2:delete t.machineSettings.properties[R];break;case 6:delete t.machineOverridableSettings.properties[R];break;case 3:delete t.windowSettings.properties[R];break;case 4:case 5:delete t.resourceSettings.properties[R];break}}updateOverridePropertyPatternKey(){for(const R of this.overrideIdentifiers.values()){const f=`[${R}]`,r={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,r),t.allSettings.properties[f]=r,t.applicationSettings.properties[f]=r,t.machineSettings.properties[f]=r,t.machineOverridableSettings.properties[f]=r,t.windowSettings.properties[f]=r,t.resourceSettings.properties[f]=r}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(R,f){let r=this.defaultValues[R];I.isUndefined(r)&&(r=f.default),I.isUndefined(r)&&(r=O(f.type)),f.default=r}}const p="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(p);function y(b){return b.substring(1,b.length-1)}t.overrideIdentifierFromKey=y;function O(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=O;const l=new S;v.Registry.add(t.Extensions.Configuration,l);function u(b){return b.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(b)?m.localize(5,null,b):l.getConfigurationProperties()[b]!==void 0?m.localize(6,null,b):null:m.localize(4,null)}t.validateProperty=u;function D(){const b=[],R=l.getConfigurationProperties();for(const f of Object.keys(R))b.push([f,R[f].scope]);return b.push(["launch",4]),b.push(["task",4]),b}t.getScopes=D}),define(Z[27],te([0,1,19,13,7,25,12,30]),function(q,t,m,T,v,I,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,F.createDecorator)("configurationService");function c(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof v.URI)}t.isConfigurationOverrides=c;var d;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function S(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=S;function p(i,n){const o=n?i?n.keys.filter(x=>i.keys.indexOf(x)===-1):[...n.keys]:[],a=i?n?i.keys.filter(x=>n.keys.indexOf(x)===-1):[...i.keys]:[],h=[];if(n&&i){for(const x of i.keys)if(n.keys.indexOf(x)!==-1){const _=b(i.contents,x),J=b(n.contents,x);m.equals(_,J)||h.push(x)}}const g=[],k=x=>{const _={};for(const J of x)for(const ie of J.identifiers)_[s(ie)]=J;return _},P=n?k(n.overrides):{},N=i?k(i.overrides):{};if(Object.keys(P).length)for(const x of o){const _=P[x];_&&g.push([(0,L.overrideIdentifierFromKey)(x),_.keys])}if(Object.keys(N).length)for(const x of a){const _=N[x];_&&g.push([(0,L.overrideIdentifierFromKey)(x),_.keys])}if(Object.keys(P).length&&Object.keys(N).length)for(const x of h){const _=N[x],J=P[x];if(_&&J){const ie=p({contents:_.contents,keys:_.keys,overrides:[]},{contents:J.contents,keys:J.keys,overrides:[]});g.push([(0,L.overrideIdentifierFromKey)(x),[...ie.added,...ie.removed,...ie.updated]])}}return{added:o,removed:a,updated:h,overrides:g}}t.compare=p;function y(i,n){const o=[];for(const a of Object.keys(i))if(L.OVERRIDE_PROPERTY_PATTERN.test(a)){const h={};for(const g in i[a])h[g]=i[a][g];o.push({identifiers:[(0,L.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(h),contents:O(h,n)})}return o}t.toOverrides=y;function O(i,n){const o=Object.create(null);for(let a in i)l(o,a,i[a],n);return o}t.toValuesTree=O;function l(i,n,o,a){const h=n.split("."),g=h.pop();let k=i;for(let P=0;P<h.length;P++){let N=h[P],x=k[N];switch(typeof x){case"undefined":x=k[N]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${h.slice(0,P+1).join(".")} is ${JSON.stringify(x)}`);return}k=x}if(typeof k=="object"&&k!==null)try{k[g]=o}catch(P){a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(k)}`)}else a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(k)}`)}t.addToValueTree=l;function u(i,n){const o=n.split(".");D(i,o)}t.removeFromValueTree=u;function D(i,n){const o=n.shift();if(n.length===0){delete i[o];return}if(Object.keys(i).indexOf(o)!==-1){const a=i[o];typeof a=="object"&&!Array.isArray(a)&&(D(a,n),Object.keys(a).length===0&&delete i[o])}}function b(i,n,o){function a(k,P){let N=k;for(const x of P){if(typeof N!="object"||N===null)return;N=N[x]}return N}const h=n.split("."),g=a(i,h);return typeof g=="undefined"?o:g}t.getConfigurationValue=b;function R(i,n,o){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?T.isObject(i[a])&&T.isObject(n[a])?R(i[a],n[a],o):o&&(i[a]=n[a]):i[a]=n[a])})}t.merge=R;function f(){const i=I.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=f;function r(){const i=Object.create(null),n=I.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let o in n){let a=n[o].default;l(i,o,a,h=>console.error(`Conflict in default settings: ${h}`))}return i}t.getDefaultValues=r;function s(i){return`[${i}]`}t.keyFromOverrideIdentifier=s;function e(i,n,o){const a=i.inspect(n),h=i.inspect(o);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:a.defaultValue}t.getMigratedSettingValue=e}),define(Z[110],te([0,1,58,45,24,13,19,7,30,27,25,2,14]),function(q,t,m,T,v,I,F,L,c,d,S,p,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class O{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,d.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,d.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const o of v.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[o],h=i[o];h&&(typeof a=="object"&&typeof h=="object"?(a=F.deepClone(a),this.mergeContents(a,h)):a=h),n[o]=a}return new O(n,this.keys,this.overrides)}merge(...e){const i=F.deepClone(this.contents),n=F.deepClone(this.overrides),o=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const h of a.overrides){const[g]=n.filter(k=>v.equals(k.identifiers,h.identifiers));g?this.mergeContents(g.contents,h.contents):n.push(F.deepClone(h))}for(const h of a.keys)o.indexOf(h)===-1&&o.push(h)}return new O(i,o,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&I.isObject(e[n])&&I.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=F.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?F.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,d.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,d.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=O;class l extends O{constructor(){const e=(0,d.getDefaultValues)(),i=(0,d.getConfigurationKeys)(),n=[];for(const o of Object.keys(e))c.OVERRIDE_PROPERTY_PATTERN.test(o)&&n.push({identifiers:[(0,c.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(e[o]),contents:(0,d.toValuesTree)(e[o],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,n)}}t.DefaultConfigurationModel=l;class u{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new O}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!I.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:o,overrides:a,restricted:h}=this.doParseRaw(e,i);this._configurationModel=new O(n,o,a),this._restrictedConfigurations=h||[]}doParseContent(e){let i={},n=null,o=[],a=[],h=[];function g(P){Array.isArray(o)?o.push(P):n!==null&&(o[n]=P)}let k={onObjectBegin:()=>{let P={};g(P),a.push(o),o=P,n=null},onObjectProperty:P=>{n=P},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{let P=[];g(P),a.push(o),o=P,n=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:g,onError:(P,N,x)=>{h.push({error:P,offset:N,length:x})}};if(e)try{m.visit(e,k),i=o[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return i}doParseRaw(e,i){const n=S.Registry.as(c.Extensions.Configuration).getConfigurationProperties(),o=this.filter(e,n,!0,i);e=o.raw;const a=(0,d.toValuesTree)(e,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),h=Object.keys(e),g=(0,d.toOverrides)(e,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:a,keys:h,overrides:g,restricted:o.restricted}}filter(e,i,n,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:e,restricted:[]};const a={},h=[];for(let g in e)if(c.OVERRIDE_PROPERTY_PATTERN.test(g)&&n){const k=this.filter(e[g],i,!1,o);a[g]=k.raw,h.push(...k.restricted)}else{const k=i[g],P=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&h.push(g),(P===void 0||o.scopes===void 0||o.scopes.includes(P))&&(o.skipRestricted&&k?.restricted||(a[g]=e[g]))}return{raw:a,restricted:h}}}t.ConfigurationModelParser=u;class D extends p.Disposable{constructor(e,i,n,o){super();this.userSettingsResource=e,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(y.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new O}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=D;class b{constructor(e,i,n=new O,o=new O,a=new T.ResourceMap,h=new O,g=new T.ResourceMap,k=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=o,this._folderConfigurations=a,this._memoryConfiguration=h,this._memoryConfigurationByResource=g,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new O,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(e):o.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const o=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),h=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,g=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),k=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),P=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),N=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),x=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,_=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,J=i.overrideIdentifier?h.override(i.overrideIdentifier).getValue(e):h.getValue(e),ie=o.getValue(e),se=v.distinct(v.flatten(o.overrides.map(Y=>Y.identifiers))).filter(Y=>o.getOverrideValue(e,Y)!==void 0);return{defaultValue:g,userValue:k,userLocalValue:P,userRemoteValue:N,workspaceValue:x,workspaceFolderValue:_,memoryValue:J,value:ie,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:N!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:x!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:J!==void 0?{value:h.getValue(e),override:i.overrideIdentifier?h.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(o=>c.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const a=(0,c.overrideIdentifierFromKey)(o),h=this._defaultConfiguration.getKeysForOverrideIdentifier(a),g=e.getKeysForOverrideIdentifier(a),k=[...g.filter(P=>h.indexOf(P)===-1),...h.filter(P=>g.indexOf(P)===-1),...h.filter(P=>!F.equals(this._defaultConfiguration.override(a).getValue(P),e.override(a).getValue(P)))];return[a,k]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:o,overrides:a}=(0,d.compare)(this.localUserConfiguration,e),h=[...i,...n,...o];return h.length&&this.updateLocalUserConfiguration(e),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:o,overrides:a}=(0,d.compare)(this.remoteUserConfiguration,e);let h=[...i,...n,...o];return h.length&&this.updateRemoteUserConfiguration(e),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:o,overrides:a}=(0,d.compare)(this.workspaceConfiguration,e);let h=[...i,...n,...o];return h.length&&this.updateWorkspaceConfiguration(e),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:o,updated:a,removed:h,overrides:g}=(0,d.compare)(n,i);let k=[...o,...a,...h];return(k.length||!n)&&this.updateFolderConfiguration(e,i),{keys:k,overrides:g}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:o,removed:a,overrides:h}=(0,d.compare)(i,void 0);return{keys:[...n,...o,...a],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const o=i.getFolder(e);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const a=this._memoryConfigurationByResource.get(e);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(e);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:o,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:o,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(o=>i.add(o))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),o=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((h,g)=>(h.set(L.URI.revive(g[0]),this.parseConfigurationModel(g[1])),h),new T.ResourceMap);return new b(i,n,new O,o,a,new O,new T.ResourceMap,!1)}static parseConfigurationModel(e){return new O(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=b;function R(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,i=new Map;for(const o of s)o.keys.forEach(a=>e.add(a)),o.overrides.forEach(([a,h])=>{const g=(0,T.getOrSet)(i,a,new Set);h.forEach(k=>g.add(k))});const n=[];return i.forEach((o,a)=>n.push([a,[...o.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=R;class f{constructor(e,i,n,o){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(g=>a.add(g)),e.overrides.forEach(([,g])=>g.forEach(k=>a.add(k))),this.affectedKeys=[...a.values()];const h=new O;this.affectedKeys.forEach(g=>h.setValue(g,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!F.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,d.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(e=e[o],!e)return!1;n=n[o]}return!0}}t.ConfigurationChangeEvent=f;class r extends f{constructor(e,i,n,o){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=o}}t.AllKeysConfigurationChangeEvent=r}),define(Z[111],te([0,1,25,30,2,27,110,14,3,20]),function(q,t,m,T,v,I,F,L,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class S extends v.Disposable{constructor(y,O){super();this.settingsResource=y,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new F.UserSettings(this.settingsResource,void 0,d.extUriBiasedIgnorePathCase,O)),this.configuration=new F.Configuration(new F.DefaultConfigurationModel,new F.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new c.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(T.Extensions.Configuration).onDidUpdateConfiguration(l=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const y=await this.userConfiguration.loadConfiguration();this.configuration=new F.Configuration(new F.DefaultConfigurationModel,y)}getConfigurationData(){return this.configuration.toData()}getValue(y,O){const l=typeof y=="string"?y:void 0,u=(0,I.isConfigurationOverrides)(y)?y:(0,I.isConfigurationOverrides)(O)?O:{};return this.configuration.getValue(l,u,void 0)}updateValue(y,O,l,u){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const O=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(l,O,1)}onDidDefaultConfigurationChange(y){const O=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new F.DefaultConfigurationModel,y);this.trigger(l,O,6)}trigger(y,O,l){const u=new F.ConfigurationChangeEvent(y,{data:O},this.configuration);u.source=l,u.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(u)}getTargetConfiguration(y){switch(y){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=S}),define(Z[55],te([0,1,84,12,30,25,16]),function(q,t,m,T,v,I,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,T.createDecorator)("requestService");function L(l){return l.res.statusCode&&l.res.statusCode>=200&&l.res.statusCode<300||l.res.statusCode===1223}t.isSuccess=L;function c(l){return l.res.statusCode===204}async function d(l){if(!L(l))throw new Error("Server returned "+l.res.statusCode);return c(l)?null:(await(0,F.streamToBuffer)(l.stream)).toString()}t.asText=d;async function S(l){if(!L(l))throw new Error("Server returned "+l.res.statusCode);if(c(l))return null;const D=(await(0,F.streamToBuffer)(l.stream)).toString();try{return JSON.parse(D)}catch(b){throw b.message+=`:
`+D,b}}t.asJson=S;function p(l){O(l)}t.updateProxyConfigurationsScope=p;let y;function O(l){const u=I.Registry.as(v.Extensions.Configuration);y&&u.deregisterConfigurations([y]),y={id:"http",order:15,title:(0,m.localize)(0,null),type:"object",scope:l,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,m.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,m.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,m.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,m.localize)(4,null),(0,m.localize)(5,null),(0,m.localize)(6,null),(0,m.localize)(7,null)],default:"override",description:(0,m.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,m.localize)(9,null),restricted:!0}}},u.registerConfiguration(y)}O(2)}),define(Z[112],te([0,1,113,13]),function(q,t,m,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function v(F,L){return F.protocol==="http:"?L.HTTP_PROXY||L.http_proxy||null:F.protocol==="https:"&&(L.HTTPS_PROXY||L.https_proxy||L.HTTP_PROXY||L.http_proxy)||null}async function I(F,L,c={}){const d=(0,m.parse)(F),S=c.proxyUrl||v(d,L);if(!S)return null;const p=(0,m.parse)(S);if(!/^https?:$/.test(p.protocol||""))return null;const y={host:p.hostname||"",port:p.port||(p.protocol==="https"?"443":"80"),auth:p.auth,rejectUnauthorized:(0,T.isBoolean)(c.strictSSL)?c.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((O,l)=>{q(["http-proxy-agent"],O,l)}))(y):new(await new Promise((O,l)=>{q(["https-proxy-agent"],O,l)}))(y)}t.getProxyAgent=I}),define(Z[114],te([0,1,29,16]),function(q,t,m,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function v(I,F,L){let c=L&&L.get("storage.serviceMachineId",0)||null;if(c)return c;try{const S=(await F.readFile(I.serviceMachineIdResource)).value.toString();c=(0,m.isUUID)(S)?S:null}catch(d){c=null}if(!c){c=(0,m.generateUuid)();try{await F.writeFile(I.serviceMachineIdResource,T.VSBuffer.fromString(c))}catch(d){}}return L&&L.store("storage.serviceMachineId",c,0,1),c}t.getServiceMachineId=v}),define(Z[115],te([0,1,12,14,2,13,66,3]),function(q,t,m,T,v,I,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const c="__$__targetStorageMarker";t.IStorageService=(0,m.createDecorator)("storageService");var d;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(d=t.WillSaveStateReason||(t.WillSaveStateReason={}));var S;(function(u){u[u.GLOBAL=0]="GLOBAL",u[u.WORKSPACE=1]="WORKSPACE"})(S=t.StorageScope||(t.StorageScope={}));var p;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(p=t.StorageTarget||(t.StorageTarget={}));class y extends v.Disposable{constructor(D={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new T.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new v.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,v.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,b){b===c?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:b,target:this.getKeyTargets(D)[b]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,b,R){return this.getStorage(b)?.get(D,R)}getBoolean(D,b,R){return this.getStorage(b)?.getBoolean(D,R)}getNumber(D,b,R){return this.getStorage(b)?.getNumber(D,R)}store(D,b,R,f){if((0,I.isUndefinedOrNull)(b)){this.remove(D,R);return}this.withPausedEmitters(()=>{this.updateKeyTarget(D,R,f),this.getStorage(R)?.set(D,b)})}remove(D,b){this.withPausedEmitters(()=>{this.updateKeyTarget(D,b,void 0),this.getStorage(b)?.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,b){const R=[],f=this.getKeyTargets(D);for(const r of Object.keys(f))f[r]===b&&R.push(r);return R}updateKeyTarget(D,b,R){const f=this.getKeyTargets(b);typeof R=="number"?f[D]!==R&&(f[D]=R,this.getStorage(b)?.set(c,JSON.stringify(f))):typeof f[D]=="number"&&(delete f[D],this.getStorage(b)?.set(c,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const b=this.get(c,D);if(b)try{return JSON.parse(b)}catch(R){}return Object.create(null)}isNew(D){return this.getBoolean(t.IS_NEW_KEY,D)===!0}async flush(D=d.NONE){this._onWillSaveState.fire({reason:D}),await L.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const D=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return l(D,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class O extends y{constructor(){super();this.globalStorage=this._register(new F.Storage(new F.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new F.Storage(new F.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}t.InMemoryStorageService=O;async function l(u,D,b,R){const f=a=>{try{return JSON.parse(a)}catch(h){return a}},r=new Map,s=new Map;u.forEach((a,h)=>{r.set(h,a),s.set(h,f(a))});const e=new Map,i=new Map;D.forEach((a,h)=>{e.set(h,a),i.set(h,f(a))}),console.group(`Storage: Global (path: ${b})`);let n=[];r.forEach((a,h)=>{n.push({key:h,value:a})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${R})`);let o=[];e.forEach((a,h)=>{o.push({key:h,value:a})}),console.table(o),console.groupEnd(),console.log(i)}t.logStorage=l}),define(Z[116],te([0,1,10,34,29,7]),function(q,t,m,T,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function F(d){if(m.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function L(d,S,p,y,O,l,u,D,b,R){const f=Object.create(null);f["common.machineId"]=u,f.sessionID=(0,v.generateUuid)()+Date.now(),f.commitHash=O,f.version=l,f["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,m.PlatformToString)(m.platform),f["common.nodePlatform"]=T.platform,f["common.nodeArch"]=y,f["common.product"]=R||"desktop";const r=c(D||[]);r&&(f["common.msftInternal"]=r);let s=0;const e=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),m.isLinuxSnap&&(f["common.snap"]="true");const i=F(p);i&&(f["common.platformDetail"]=i);try{const n=await d.readFile(I.URI.file(b));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}t.resolveCommonProperties=L;function c(d){const S=T.env.USERDNSDOMAIN;if(!S)return!1;const p=S.toLowerCase();return d.some(y=>p===y)}t.verifyMicrosoftInternalDomain=c}),define(Z[36],te([0,1,12]),function(q,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,m.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Z[117],te([0,1,74,2,22,23,14,35,15,36,26,8,7,3,10]),function(q,t,m,T,v,I,F,L,c,d,S,p,y,O,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let u=class extends T.Disposable{constructor(r,s,e){super();this.galleryService=r,this.telemetryService=s,this.logService=e,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new F.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new F.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new F.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new F.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(i=>i.cancel()),this.uninstallingExtensions.forEach(i=>i.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(r,s={}){if(!this.galleryService.isEnabled())throw new Error(m.localize(0,null));try{r=await this.checkAndGetCompatibleVersion(r)}catch(i){throw this.logService.error((0,p.getErrorMessage)(i)),b(this.telemetryService,"extensionGallery:install",(0,I.getGalleryExtensionTelemetryData)(r),void 0,i),i}if(!await this.canInstall(r)){const i=new v.ExtensionManagementError("Not supported",t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",r.identifier.id,i.message),b(this.telemetryService,"extensionGallery:install",(0,I.getGalleryExtensionTelemetryData)(r),void 0,i),i}const e=await this.galleryService.getManifest(r,S.CancellationToken.None);if(e===null){const i=new v.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",r.identifier.id,i.message),b(this.telemetryService,"extensionGallery:install",(0,I.getGalleryExtensionTelemetryData)(r),void 0,i),i}return this.installExtension(e,r,s)}async uninstall(r,s={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,s)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(m.localize(1,null));const s=await this.findGalleryExtension(r);if(!s)throw new Error(m.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsReport(){const r=new Date().getTime();return(!this.reportedExtensions||r-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=r),this.reportedExtensions}registerParticipant(r){this.participants.push(r)}async installExtension(r,s,e){if(!y.URI.isUri(s)){let h=this.installingExtensions.get(new I.ExtensionIdentifierWithVersion(s.identifier,s.version).key());if(h)return this.logService.info("Extensions is already requested to install",s.identifier.id),h.waitUntilTaskIsFinished();e={...e,installOnlyNewlyAddedFromExtensionPack:!0}}const i=[],n=[],o=this.createInstallExtensionTask(r,s,e);y.URI.isUri(s)||this.installingExtensions.set(new I.ExtensionIdentifierWithVersion(o.identifier,r.version).key(),o),this._onInstallExtension.fire({identifier:o.identifier,source:s}),this.logService.info("Installing extension:",o.identifier.id),i.push({task:o,manifest:r});let a=!1;try{if(e.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",o.identifier.id);else try{const g=await this.getAllDepsAndPackExtensionsToInstall(o.identifier,r,!!e.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:k,manifest:P}of g)if(a=a||!!P.extensionDependencies?.some(N=>(0,I.areSameExtensions)({id:N},o.identifier)),this.installingExtensions.has(new I.ExtensionIdentifierWithVersion(k.identifier,k.version).key()))this.logService.info("Extension is already requested to install",k.identifier.id);else{const N=this.createInstallExtensionTask(P,k,{...e,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new I.ExtensionIdentifierWithVersion(N.identifier,P.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:k}),this.logService.info("Installing extension:",N.identifier.id),i.push({task:N,manifest:P})}}catch(g){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",o.identifier.id),this.logService.error(g),g}const h=i.reduce((g,{task:k,manifest:P})=>(g.set(k.identifier.id.toLowerCase(),{task:k,manifest:P}),g),new Map);for(;h.size;){let g;const k=[...h.values()].filter(({manifest:P})=>!P.extensionDependencies?.some(N=>h.has(N.toLowerCase())));k.length?g=h.size===1?k:k.filter(({task:P})=>!(P===o&&!a)):(this.logService.info("Found extensions with circular dependencies",k.map(({task:P})=>P.identifier.id)),g=[...h.values()]),await this.joinAllSettled(g.map(async({task:P})=>{const N=new Date().getTime();try{const x=await P.run();if(await this.joinAllSettled(this.participants.map(_=>_.postInstall(x,P.source,e,S.CancellationToken.None))),!y.URI.isUri(P.source)&&(b(this.telemetryService,P.operation===2?"extensionGallery:update":"extensionGallery:install",(0,I.getGalleryExtensionTelemetryData)(P.source),new Date().getTime()-N,void 0),l.isWeb&&P.operation===1))try{await this.galleryService.reportStatistic(x.manifest.publisher,x.manifest.name,x.manifest.version,"install")}catch(_){}n.push({local:x,identifier:P.identifier,operation:P.operation,source:P.source})}catch(x){throw y.URI.isUri(P.source)||b(this.telemetryService,P.operation===2?"extensionGallery:update":"extensionGallery:install",(0,I.getGalleryExtensionTelemetryData)(P.source),new Date().getTime()-N,x),this.logService.error("Error while installing the extension:",P.identifier.id),this.logService.error(x),x}finally{h.delete(P.identifier.id.toLowerCase())}}))}return n.forEach(({identifier:g})=>this.logService.info("Extension installed successfully:",g.id)),this._onDidInstallExtensions.fire(n),n.filter(({identifier:g})=>(0,I.areSameExtensions)(g,o.identifier))[0].local}catch(h){if(i.forEach(({task:g})=>g.cancel()),n.length)try{const g=await Promise.allSettled(n.map(({local:k})=>this.createUninstallExtensionTask(k,{versionOnly:!0}).run()));for(let k=0;k<g.length;k++){const P=g[k],{identifier:N}=n[k];P.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,p.getErrorMessage)(P.reason))}}catch(g){this.logService.warn("Error while rolling back extensions",(0,p.getErrorMessage)(g),n.map(({identifier:k})=>k.id))}throw this.logService.error("Failed to install extension:",o.identifier.id,(0,p.getErrorMessage)(h)),this._onDidInstallExtensions.fire(i.map(({task:g})=>({identifier:g.identifier,operation:1,source:g.source}))),h instanceof Error&&(h.name=h&&h.code?h.code:t.ERROR_UNKNOWN),h}finally{for(const{task:h,manifest:g}of i)if(!y.URI.isUri(h.source)){const k=new I.ExtensionIdentifierWithVersion(h.identifier,g.version).key();this.installingExtensions.delete(k)||this.logService.warn("Installation task is not found in the cache",k)}}}async joinAllSettled(r){const s=[],e=[],i=await Promise.allSettled(r);for(const n of i)n.status==="fulfilled"?s.push(n.value):e.push(n.reason);if(e.length)throw D(e);return s}async getAllDepsAndPackExtensionsToInstall(r,s,e){if(!this.galleryService.isEnabled())return[];let i=await this.getInstalled();const n=[r,...i.map(h=>h.identifier)],o=[],a=async(h,g)=>{const k=g.extensionDependencies||[];if(g.extensionPack){const P=e?i.find(N=>(0,I.areSameExtensions)(N.identifier,h)):void 0;for(const N of g.extensionPack)P&&P.manifest.extensionPack&&P.manifest.extensionPack.some(x=>(0,I.areSameExtensions)({id:x},{id:N}))||k.every(x=>!(0,I.areSameExtensions)({id:x},{id:N}))&&k.push(N)}if(k.length){const P=[...n,...o.map(x=>x.gallery.identifier)],N=k.filter(x=>P.every(_=>!(0,I.areSameExtensions)(_,{id:x})));if(N.length){const x=await this.galleryService.query({names:N,pageSize:k.length},S.CancellationToken.None);for(const _ of x.firstPage){if(P.find(se=>(0,I.areSameExtensions)(se,_.identifier)))continue;const J=await this.checkAndGetCompatibleVersion(_);if(!await this.canInstall(J)){this.logService.info("Skipping the extension as it cannot be installed",J.identifier.id);continue}const ie=await this.galleryService.getManifest(J,S.CancellationToken.None);if(ie===null)throw new v.ExtensionManagementError(`Missing manifest for extension ${J.identifier.id}`,t.INSTALL_ERROR_VALIDATING);o.push({gallery:J,manifest:ie}),await a(J.identifier,ie)}}}};return await a(r,s),i=await this.getInstalled(),o.filter(h=>!i.some(g=>(0,I.areSameExtensions)(g.identifier,h.gallery.identifier)))}async checkAndGetCompatibleVersion(r){if(await this.isMalicious(r))throw new v.ExtensionManagementError(m.localize(3,null,r.identifier.id),v.INSTALL_ERROR_MALICIOUS);const s=await this.galleryService.getCompatibleExtension(r);if(!s)throw new v.ExtensionManagementError(m.localize(4,null,r.identifier.id,L.default.version),v.INSTALL_ERROR_INCOMPATIBLE);return s}async isMalicious(r){const s=await this.getExtensionsReport();return(0,I.getMaliciousExtensionsSet)(s).has(r.identifier.id)}async unininstallExtension(r,s){const e=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(e)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),e.waitUntilTaskIsFinished();const i=(h,g)=>{const k=this.createUninstallExtensionTask(h,g);return this.uninstallingExtensions.set(k.extension.identifier.id.toLowerCase(),k),this.logService.info("Uninstalling extension:",h.identifier.id),this._onUninstallExtension.fire(h.identifier),k},n=(h,g)=>{g?this.logService.error("Failed to uninstall extension:",h.identifier.id,g.message):this.logService.info("Successfully uninstalled extension:",h.identifier.id),b(this.telemetryService,"extensionGallery:uninstall",(0,I.getLocalExtensionTelemetryData)(h),void 0,g),this._onDidUninstallExtension.fire({identifier:h.identifier,error:g?.code})},o=[],a=[];try{o.push(i(r,{}));const h=await this.getInstalled(1);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const g=this.getAllPackExtensionsToUninstall(r,h);for(const k of g)this.uninstallingExtensions.has(k.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",k.identifier.id):o.push(i(k,{}))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(o.map(g=>g.extension),h,r),await this.joinAllSettled(o.map(async g=>{try{if(await g.run(),await this.joinAllSettled(this.participants.map(k=>k.postUninstall(g.extension,s,S.CancellationToken.None))),g.extension.identifier.uuid)try{await this.galleryService.reportStatistic(g.extension.manifest.publisher,g.extension.manifest.name,g.extension.manifest.version,"uninstall")}catch(k){}n(g.extension)}catch(k){const P=k instanceof v.ExtensionManagementError?k:new v.ExtensionManagementError((0,p.getErrorMessage)(k),t.ERROR_UNKNOWN);throw n(g.extension,P),P}finally{a.push(g)}}))}catch(h){const g=h instanceof v.ExtensionManagementError?h:new v.ExtensionManagementError((0,p.getErrorMessage)(h),t.ERROR_UNKNOWN);for(const k of o){try{k.cancel()}catch(P){}a.includes(k)||n(k.extension,g)}throw g}finally{for(const h of o)this.uninstallingExtensions.delete(h.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",h.extension.identifier.id)}}checkForDependents(r,s,e){for(const i of r){const n=this.getDependents(i,s);if(n.length){const o=n.filter(a=>r.indexOf(a)===-1);if(o.length)throw new Error(this.getDependentsErrorMessage(i,o,e))}}}getDependentsErrorMessage(r,s,e){return e===r?s.length===1?m.localize(5,null,e.manifest.displayName||e.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?m.localize(6,null,e.manifest.displayName||e.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):m.localize(7,null,e.manifest.displayName||e.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?m.localize(8,null,e.manifest.displayName||e.manifest.name,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?m.localize(9,null,e.manifest.displayName||e.manifest.name,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):m.localize(10,null,e.manifest.displayName||e.manifest.name,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(r,s,e=[]){if(e.indexOf(r)!==-1)return[];e.push(r);const i=r.manifest.extensionPack?r.manifest.extensionPack:[];if(i.length){const n=s.filter(a=>!a.isBuiltin&&i.some(h=>(0,I.areSameExtensions)({id:h},a.identifier))),o=[];for(const a of n)o.push(...this.getAllPackExtensionsToUninstall(a,s,e));return[...n,...o]}return[]}getDependents(r,s){return s.filter(e=>e.manifest.extensionDependencies&&e.manifest.extensionDependencies.some(i=>(0,I.areSameExtensions)({id:i},r.identifier)))}async findGalleryExtension(r){if(r.identifier.uuid){const s=await this.findGalleryExtensionById(r.identifier.uuid);return s||this.findGalleryExtensionByName(r.identifier.id)}return this.findGalleryExtensionByName(r.identifier.id)}async findGalleryExtensionById(r){return(await this.galleryService.query({ids:[r],pageSize:1},S.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(r){return(await this.galleryService.query({names:[r],pageSize:1},S.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${r.length} reported extensions from service`),r}catch(r){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};u=ue([fe(0,v.IExtensionGalleryService),fe(1,d.ITelemetryService),fe(2,c.ILogService)],u),t.AbstractExtensionManagementService=u;function D(f){const r=Array.isArray(f)?f:[f];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((s,e)=>new Error(`${s.message}${s.message?",":""}${e instanceof Error?e.message:e}`),new Error(""))}t.joinErrors=D;function b(f,r,s,e,i){const n=i?i instanceof v.ExtensionManagementError?i.code:t.ERROR_UNKNOWN:void 0;f.publicLogError(r,{...s,success:!i,duration:e,errorcode:n})}t.reportTelemetry=b;class R{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(r=>new Promise((s,e)=>{const i=r.onCancellationRequested(()=>{i.dispose(),e((0,p.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=R}),define(Z[118],te([0,1,8,22,23,19,36,55,49,21,26,15,17,7,42,115,114,12,10]),function(q,t,m,T,v,I,F,L,c,d,S,p,y,O,l,u,D,b,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var f;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished"})(f||(f={}));function r(...B){return String(B.reduce((W,U)=>W|U,0))}var s;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:f.None,criteria:[],assetTypes:[]};class a{constructor(W=o){this.state=W}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(W,U=this.state.pageSize){return new a({...this.state,pageNumber:W,pageSize:U})}withFilter(W,...U){const w=[...this.state.criteria,...U.length?U.map(M=>({filterType:W,value:M})):[{filterType:W}]];return new a({...this.state,criteria:w})}withSortBy(W){return new a({...this.state,sortBy:W})}withSortOrder(W){return new a({...this.state,sortOrder:W})}withFlags(...W){return new a({...this.state,flags:W.reduce((U,w)=>U|w,0)})}withAssetTypes(...W){return new a({...this.state,assetTypes:W})}get raw(){const{criteria:W,pageNumber:U,pageSize:w,sortBy:M,sortOrder:E,flags:A,assetTypes:C}=this.state;return{filters:[{criteria:W,pageNumber:U,pageSize:w,sortBy:M,sortOrder:E}],assetTypes:C,flags:A}}get searchText(){const W=this.state.criteria.filter(U=>U.filterType===s.SearchText)[0];return W&&W.value?W.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(W=>String(W.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function h(B,W){const U=(B||[]).filter(w=>w.statisticName===W)[0];return U?U.value:0}function g(B){const W="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(w=>w.assetType.indexOf(W)===0).reduce((w,M)=>{const E=x(B,M.assetType);return E&&w.push([M.assetType.substring(W.length),E]),w},[])}function k(B){if(B.properties){const W=B.properties.filter(M=>M.key===e.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),w=W.filter(M=>U.test(M.value))[0];return w?{uri:w.value,fallbackUri:w.value}:null}return x(B,e.Repository)}function P(B){return{uri:`${B.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${B.fallbackAssetUri}/${e.VSIX}`}}function N(B){const W=x(B,e.Icon);if(W)return W;const U=T.DefaultIconPath;return{uri:U,fallbackUri:U}}function x(B,W){return B.files.filter(w=>w.assetType===W)[0]?{uri:`${B.assetUri}/${W}`,fallbackUri:`${B.fallbackAssetUri}/${W}`}:null}function _(B,W){const U=B.properties?B.properties.filter(M=>M.key===W):[],w=U.length>0&&U[0].value;return w?w.split(",").map(M=>(0,v.adoptToGalleryExtensionId)(M)):[]}function J(B){const W=B.properties?B.properties.filter(U=>U.key===i.Engine):[];return W.length>0&&W[0].value||""}function ie(B){const W=B.properties?B.properties.filter(w=>w.key===i.LocalizedLanguages):[],U=W.length>0&&W[0].value||"";return U?U.split(","):[]}function se(B){return B.indexOf("preview")!==-1}function Y(B,W,U,w,M){const E={manifest:x(W,e.Manifest),readme:x(W,e.Details),changelog:x(W,e.Changelog),license:x(W,e.License),repository:k(W),download:P(W),icon:N(W),coreTranslations:g(W)};return{identifier:{id:(0,v.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:W.version,date:W.lastUpdated,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,description:B.shortDescription||"",installCount:h(B.statistics,"install"),rating:h(B.statistics,"averagerating"),ratingCount:h(B.statistics,"ratingcount"),assetUri:O.URI.parse(W.assetUri),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),webExtension:!!B.tags?.includes(T.WEB_EXTENSION_TAG),assetTypes:W.files.map(({assetType:A})=>A),assets:E,properties:{dependencies:_(W,i.Dependency),extensionPack:_(W,i.ExtensionPack),engine:J(W),localizedLanguages:ie(W)},telemetryData:{index:(w.pageNumber-1)*w.pageSize+U,querySource:M},preview:se(B.flags)}}let X=class{constructor(W,U,w,M,E,A,C){this.requestService=W,this.logService=U,this.environmentService=w,this.telemetryService=M,this.fileService=E,this.productService=A;const z=A.extensionsGallery;this.extensionsGalleryUrl=z&&z.serviceUrl,this.extensionsControlUrl=z&&z.controlUrl,this.commonHeadersPromise=Q(A.version,this.environmentService,this.fileService,C)}api(W=""){return`${this.extensionsGalleryUrl}${W}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(W,U){const w=[];let{total:M,firstPage:E,getPage:A}=await this.query({names:W,pageSize:W.length},U);w.push(...E);for(let C=1;w.length<M&&(E=await A(C,U),E.length);C++)w.push(...E);return w}async getCompatibleExtension(W,U){return this.getCompatibleExtensionByEngine(W,U)}async getCompatibleExtensionByEngine(W,U){const w=(0,T.isIExtensionIdentifier)(W)?null:W;if(w&&w.properties.engine&&(0,c.isEngineValid)(w.properties.engine,this.productService.version,this.productService.date))return w;const{id:M,uuid:E}=w?w.identifier:W;let A=new a().withFlags(f.IncludeAssetUri,f.IncludeStatistics,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");E?A=A.withFilter(s.ExtensionId,E):A=A.withFilter(s.ExtensionName,M);const{galleryExtensions:C}=await this.queryGallery(A,S.CancellationToken.None),[z]=C;if(!z||!z.versions.length)return null;if(U){const $=z.versions.filter(H=>H.version===U)[0];if($){const H=Y(z,$,0,A);if(H.properties.engine&&(0,c.isEngineValid)(H.properties.engine,this.productService.version,this.productService.date))return H}return null}const j=await this.getLastValidExtensionVersion(z,z.versions);return j?Y(z,j,0,A):null}async query(W,U){const w=S.CancellationToken.isCancellationToken(W)?{}:W,M=S.CancellationToken.isCancellationToken(W)?W:U;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let E=w.text||"";const A=(0,I.getOrDefault)(w,ee=>ee.pageSize,50);let C=new a().withFlags(f.IncludeLatestVersionOnly,f.IncludeAssetUri,f.IncludeStatistics,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,A).withFilter(s.Target,"Microsoft.VisualStudio.Code");E?(E=E.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ee,ne,re)=>(C=C.withFilter(s.Category,re||ne),"")),E=E.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ee,ne,re)=>(C=C.withFilter(s.Tag,re||ne),"")),E=E.replace(/\bfeatured(\s+|\b|$)/g,()=>(C=C.withFilter(s.Featured),"")),E=E.trim(),E&&(E=E.length<200?E:E.substring(0,200),C=C.withFilter(s.SearchText,E)),C=C.withSortBy(0)):w.ids?C=C.withFilter(s.ExtensionId,...w.ids):w.names?C=C.withFilter(s.ExtensionName,...w.names):C=C.withSortBy(4),typeof w.sortBy=="number"&&(C=C.withSortBy(w.sortBy)),typeof w.sortOrder=="number"&&(C=C.withSortOrder(w.sortOrder));const{galleryExtensions:z,total:j}=await this.queryGallery(C,M),$=z.map((ee,ne)=>Y(ee,ee.versions[0],ne,C,w.source)),H=async(ee,ne)=>{if(ne.isCancellationRequested)throw(0,m.canceled)();const re=C.withPage(ee+1),{galleryExtensions:ce}=await this.queryGallery(re,ne);return ce.map((me,be)=>Y(me,me.versions[0],be,re,w.source))};return{firstPage:$,total:j,pageSize:C.pageSize,getPage:H}}async queryGallery(W,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");W=W.withFlags(W.flags,f.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,r(f.Unpublished));const w=await this.commonHeadersPromise,M=JSON.stringify(W.raw),E={...w,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(M.length)},A=new Date().getTime();let C,z,j=0;try{if(C=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:M,headers:E},U),C.res.statusCode&&C.res.statusCode>=400&&C.res.statusCode<500)return{galleryExtensions:[],total:j};const $=await(0,L.asJson)(C);if($){const H=$.results[0],ee=H.extensions,ne=H.resultMetadata&&H.resultMetadata.filter(re=>re.metadataType==="ResultCount")[0];return j=ne&&ne.metadataItems.filter(re=>re.name==="TotalCount")[0].count||0,{galleryExtensions:ee,total:j}}return{galleryExtensions:[],total:j}}catch($){throw z=$,$}finally{this.telemetryService.publicLog2("galleryService:query",{...W.telemetryData,requestBodySize:String(M.length),duration:new Date().getTime()-A,success:!!C&&(0,L.isSuccess)(C),responseBodySize:C?.res.headers["Content-Length"],statusCode:C?String(C.res.statusCode):void 0,errorCode:z?(0,m.isPromiseCanceledError)(z)?"canceled":(0,m.getErrorMessage)(z).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(j)})}}async reportStatistic(W,U,w,M){if(!this.isEnabled())return;const E=R.isWeb?this.api(`/itemName/${W}.${U}/version/${w}/statType/${M==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${W}/extensions/${U}/${w}/stats?statType=${M}`),A=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",z={...await this.commonHeadersPromise,Accept:A};try{await this.requestService.request({type:"POST",url:E,headers:z},S.CancellationToken.None)}catch(j){}}async download(W,U,w){this.logService.trace("ExtensionGalleryService#download",W.identifier.id);const M=(0,v.getGalleryExtensionTelemetryData)(W),E=new Date().getTime(),A=$=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...M,duration:$}),C=w===1?"install":w===2?"update":"",z=C?{uri:`${W.assets.download.uri}&${C}=true`,fallbackUri:`${W.assets.download.fallbackUri}?${C}=true`}:W.assets.download,j=await this.getAsset(z);await this.fileService.writeFile(U,j.stream),A(new Date().getTime()-E)}async getReadme(W,U){if(W.assets.readme){const w=await this.getAsset(W.assets.readme,{},U);return await(0,L.asText)(w)||""}return""}async getManifest(W,U){if(W.assets.manifest){const w=await this.getAsset(W.assets.manifest,{},U),M=await(0,L.asText)(w);return M?JSON.parse(M):null}return null}async getCoreTranslation(W,U){const w=W.assets.coreTranslations.filter(M=>M[0]===U.toUpperCase())[0];if(w){const M=await this.getAsset(w[1]),E=await(0,L.asText)(M);return E?JSON.parse(E):null}return null}async getChangelog(W,U){if(W.assets.changelog){const w=await this.getAsset(W.assets.changelog,{},U);return await(0,L.asText)(w)||""}return""}async getAllVersions(W,U){let w=new a().withFlags(f.IncludeVersions,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");W.identifier.uuid?w=w.withFilter(s.ExtensionId,W.identifier.uuid):w=w.withFilter(s.ExtensionName,W.identifier.id);const M=[],{galleryExtensions:E}=await this.queryGallery(w,S.CancellationToken.None);return E.length&&(U?await Promise.all(E[0].versions.map(async A=>{let C;try{C=await this.getEngine(A)}catch(z){}C&&(0,c.isEngineValid)(C,this.productService.version,this.productService.date)&&M.push({version:A.version,date:A.lastUpdated})})):M.push(...E[0].versions.map(A=>({version:A.version,date:A.lastUpdated})))),M}async getAsset(W,U={},w=S.CancellationToken.None){const M=await this.commonHeadersPromise,E={type:"GET"},A={...M,...U.headers||{}};U={...U,...E,headers:A};const C=W.uri,z=W.fallbackUri,j={...U,url:C};try{const $=await this.requestService.request(j,w);if($.res.statusCode===200)return $;const H=await(0,L.asText)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${H}`)}catch($){if((0,m.isPromiseCanceledError)($))throw $;const H=(0,m.getErrorMessage)($);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:C,message:H});const ee={...U,url:z};return this.requestService.request(ee,w)}}async getLastValidExtensionVersion(W,U){const w=this.getLastValidExtensionVersionFromProperties(W,U);return w||this.getLastValidExtensionVersionRecursively(W,U)}getLastValidExtensionVersionFromProperties(W,U){for(const w of U){const M=J(w);if(!M)return null;if((0,c.isEngineValid)(M,this.productService.version,this.productService.date))return w}return null}async getEngine(W){const U=J(W);if(U)return U;const w=x(W,e.Manifest);if(!w)throw new Error("Manifest was not found");const M={"Accept-Encoding":"gzip"},E=await this.getAsset(w,{headers:M}),A=await(0,L.asJson)(E);if(A)return A.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(W,U){if(!U.length)return null;const w=U[0],M=await this.getEngine(w);return(0,c.isEngineValid)(M,this.productService.version,this.productService.date)?{...w,properties:[...w.properties||[],{key:i.Engine,value:M}]}:this.getLastValidExtensionVersionRecursively(W,U.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const W=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},S.CancellationToken.None);if(W.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,L.asJson)(W),w=new Map;if(U)for(const M of U.malicious){const E=w.get(M)||{id:{id:M},malicious:!0,slow:!1};E.malicious=!0,w.set(M,E)}return[...w.values()]}};X=ue([fe(0,L.IRequestService),fe(1,p.ILogService),fe(2,d.IEnvironmentService),fe(3,F.ITelemetryService),fe(4,y.IFileService),fe(5,l.IProductService),fe(6,(0,b.optional)(u.IStorageService))],X),t.ExtensionGalleryService=X;async function Q(B,W,U,w){const M={"X-Market-Client-Id":`VSCode ${B}`,"User-Agent":`VSCode ${B}`},E=await(0,D.getServiceMachineId)(W,U,w);return M["X-Market-User-Id"]=E,M}t.resolveMarketplaceHeaders=Q}),define(Z[119],te([0,1,35,85,18,12,27,30,2,19,25]),function(q,t,m,T,v,I,F,L,c,d,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let p=class{constructor(l,u){this._configurationService=u,this._experimentProperties={},this._disposables=new c.DisposableStore,this._cleanupPatterns=[],this._appender=l.appender,this._commonProperties=l.commonProperties||Promise.resolve({}),this._piiPaths=l.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,v.escapeRegExpCharacters)(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const b=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(l,u){this._experimentProperties[l]=u}setEnabled(l){this._enabled=l}_updateUserOptIn(){const l=this._configurationService?.getValue(y);this._userOptIn=l?l.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const l=await this._commonProperties;let u=l.sessionID,D=l["common.instanceId"],b=l["common.machineId"],R=l["common.firstSessionDate"],f=l["common.msftInternal"];return{sessionId:u,instanceId:D,machineId:b,firstSessionDate:R,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(l,u,D){return this.isOptedIn?this._commonProperties.then(b=>{u=(0,d.mixin)(u,b),u=(0,d.mixin)(u,this._experimentProperties),u=(0,d.cloneAndChange)(u,R=>{if(typeof R=="string")return this._cleanupInfo(R,D)}),this._appender.log(l,u)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(l,u,D){return this.publicLog(l,u,D)}publicLogError(l,u){return this.sendErrorTelemetry?this.publicLog(l,u,!0):Promise.resolve(void 0)}publicLogError2(l,u){return this.publicLogError(l,u)}_cleanupInfo(l,u){let D=l;if(u){const b=[];for(let s of this._cleanupPatterns)for(;;){const e=s.exec(l);if(!e)break;b.push([e.index,s.lastIndex])}const R=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(D="";;){const s=f.exec(l);if(!s)break;!R.test(s[0])&&b.every(([e,i])=>s.index<e||s.index>=i)&&(D+=l.substring(r,s.index)+"<REDACTED: user-file-path>",r=f.lastIndex)}r<l.length&&(D+=l.substr(r))}for(let b of this._cleanupPatterns)D=D.replace(b,"");return D}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=ue([fe(1,(0,I.optional)(F.IConfigurationService))],p),t.TelemetryService=p;const y="telemetry";S.Registry.as(L.Extensions.Configuration).registerConfiguration({id:y,order:110,type:"object",title:(0,T.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,T.localize)(2,null,m.default.nameLong,m.default.privacyStatementUrl):(0,T.localize)(1,null,m.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[56],te([0,1,27,19,13,3]),function(q,t,m,T,v,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(l,u){return Promise.resolve(void 0)}publicLog2(l,u){return this.publicLog(l,u)}publicLogError(l,u){return Promise.resolve(void 0)}publicLogError2(l,u){return this.publicLogError(l,u)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class F{async publicLog(u,D,b){}async publicLogError(u,D,b){}}t.NullEndpointTelemetryService=F;function L(...l){return{log:(u,D)=>l.forEach(b=>b.log(u,D)),flush:()=>I.Promises.settled(l.map(u=>u.flush()))}}t.combinedAppender=L,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(l,u){return u.onDidChangeConfiguration(D=>{D.source!==6&&l.publicLog2("updateConfiguration",{configurationSource:(0,m.ConfigurationTargetToString)(D.source),configurationKeys:y(D.sourceConfig)})})}t.configurationTelemetry=c;function d(l){const u=Object.create(null),D=Object.create(null),b=Object.create(null);p(l,b);for(let R in b){R=R.length>150?R.substr(R.length-149):R;const f=b[R];typeof f=="number"?D[R]=f:typeof f=="boolean"?D[R]=f?1:0:typeof f=="string"?u[R]=f.substring(0,1023):typeof f!="undefined"&&f!==null&&(u[R]=f)}return{properties:u,measurements:D}}t.validateTelemetryData=d;function S(l){if(!l)return"none";let u="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{l.indexOf(`${b}+`)===0&&(u=b)}),u}t.cleanRemoteAuthority=S;function p(l,u,D=0,b){if(!!l)for(let R of Object.getOwnPropertyNames(l)){const f=l[R],r=b?b+R:R;Array.isArray(f)?u[r]=(0,T.safeStringify)(f):f instanceof Date?u[r]=f.toISOString():(0,v.isObject)(f)?D<2?p(f,u,D+1,r+"."):u[r]=(0,T.safeStringify)(f):u[r]=f}}function y(l){if(!l)return[];const u=[];return O(u,"",l),u}function O(l,u,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(b=>O(l,u?`${u}.${b}`:b,D[b])):l.push(u)}}),define(Z[120],te([0,1,8,19,56]),function(q,t,m,T,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function I(L){const c=await new Promise((S,p)=>{q(["applicationinsights"],S,p)});let d;return c.defaultClient?(d=new c.TelemetryClient(L),d.channel.setUseDiskRetryCaching(!0)):(c.setup(L).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),d=c.defaultClient),L.indexOf("AIF-")===0&&(d.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),d}class F{constructor(c,d,S){this._eventPrefix=c,this._defaultData=d,this._defaultData||(this._defaultData=Object.create(null)),typeof S=="function"?this._aiClient=S():this._aiClient=S,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=I(this._aiClient)),this._asyncAIClient.then(d=>{c(d)},d=>{(0,m.onUnexpectedError)(d),console.error(d)})}}log(c,d){!this._aiClient||(d=(0,T.mixin)(d,this._defaultData),d=(0,v.validateTelemetryData)(d),this._withAIClient(S=>S.trackEvent({name:this._eventPrefix+"/"+c,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=F}),define(Z[121],te([0,1,11,4]),function(q,t,m,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function v(I,F){const L=Object.create(null),c=(S,p)=>{const y=JSON.parse(S);L[p]=y};if(F){const S=[],p=await m.Promises.readdir(F);for(const O of p)try{(await m.Promises.stat((0,T.join)(F,O))).isDirectory()&&S.push(O)}catch{}const y=[];for(const O of S)(await m.Promises.readdir((0,T.join)(F,O))).filter(u=>u==="telemetry.json").length===1&&y.push(O);for(const O of y){const l=(await m.Promises.readFile((0,T.join)(F,O,"telemetry.json"))).toString();c(l,O)}}let d=(await m.Promises.readFile((0,T.join)(I,"telemetry-core.json"))).toString();return c(d,"vscode-core"),d=(await m.Promises.readFile((0,T.join)(I,"telemetry-extensions.json"))).toString(),c(d,"vscode-extensions"),JSON.stringify(L,null,4)}t.buildTelemetryMessage=v}),define(Z[43],te([0,1,38,3,4,13,11,72,132,133]),function(q,t,m,T,v,I,F,L,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class S extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=S;function p(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function y(s){if(s instanceof S)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new S(e,s)}function O(s,e,i,n,o,a){const h=v.dirname(e),g=v.join(n,h);if(!g.startsWith(n))return Promise.reject(new Error(L.localize(0,null,e)));const k=v.join(n,e);let P;return a.onCancellationRequested(()=>{P&&P.destroy()}),Promise.resolve(F.Promises.mkdir(g,{recursive:!0})).then(()=>new Promise((N,x)=>{if(!a.isCancellationRequested)try{P=(0,m.createWriteStream)(k,{mode:i}),P.once("close",()=>N()),P.once("error",x),s.once("error",x),s.pipe(P)}catch(_){x(_)}}))}function l(s,e,i,n){let o=(0,T.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{o.cancel(),s.close()}),new Promise((h,g)=>{const k=new T.Sequencer,P=N=>{N.isCancellationRequested||(a++,s.readEntry())};s.once("error",g),s.once("close",()=>o.then(()=>{n.isCancellationRequested||s.entryCount===a?h():g(new S("Incomplete",new Error(L.localize(1,null,a,s.entryCount))))},g)),s.readEntry(),s.on("entry",N=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(N.fileName)){P(n);return}const x=N.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(x)){const ie=v.join(e,x);o=(0,T.createCancelablePromise)(se=>F.Promises.mkdir(ie,{recursive:!0}).then(()=>P(se)).then(void 0,g));return}const _=D(s,N),J=p(N);o=(0,T.createCancelablePromise)(ie=>k.queue(()=>_.then(se=>O(se,x,J,e,i,ie).then(()=>P(ie)))).then(null,g))})})}function u(s,e=!1){return new Promise((i,n)=>{(0,c.open)(s,e?{lazyEntries:!0}:void 0,(o,a)=>{o?n(y(o)):i((0,I.assertIsDefined)(a))})})}function D(s,e){return new Promise((i,n)=>{s.openReadStream(e,(o,a)=>{o?n(y(o)):i((0,I.assertIsDefined)(a))})})}function b(s,e){return new Promise((i,n)=>{const o=new d.ZipFile;e.forEach(h=>{h.contents?o.addBuffer(typeof h.contents=="string"?Buffer.from(h.contents,"utf8"):h.contents,h.path):h.localPath&&o.addFile(h.localPath,h.path)}),o.end();const a=(0,m.createWriteStream)(s);o.outputStream.pipe(a),o.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(s))})}t.zip=b;function R(s,e,i={},n){const o=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=u(s,!0);return i.overwrite&&(a=a.then(h=>F.Promises.rm(e).then(()=>h))),a.then(h=>l(h,e,{sourcePathRegex:o},n))}t.extract=R;function f(s,e){return u(s).then(i=>new Promise((n,o)=>{i.on("entry",a=>{a.fileName===e&&D(i,a).then(h=>n(h),h=>o(h))}),i.once("close",()=>o(new Error(L.localize(2,null,e))))}))}function r(s,e){return f(s,e).then(i=>new Promise((n,o)=>{const a=[];i.once("error",o),i.on("data",h=>a.push(h)),i.on("end",()=>n(Buffer.concat(a)))}))}t.buffer=r}),define(Z[122],te([0,1,43,78]),function(q,t,m,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function v(I){return(0,m.buffer)(I,"extension/package.json").then(F=>{try{return JSON.parse(F.toString("utf8"))}catch(L){throw new Error((0,T.localize)(0,null))}})}t.getManifest=v}),define(Z[123],te([0,1,41,2,11,4,15,22,23,3,7,21,90,79,42,43,10,24,9,17,20,29,8]),function(q,t,m,T,v,I,F,L,c,d,S,p,y,O,l,u,D,b,R,f,r,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",o="extracting",a="deleting",h="renaming";let g=class extends T.Disposable{constructor(P,N,x,_,J){super();this.beforeRemovingExtension=P,this.fileService=N,this.logService=x,this.environmentService=_,this.productService=J,this._devSystemExtensionsPath=null,this.systemExtensionsPath=_.builtinExtensionsPath,this.extensionsPath=_.extensionsPath,this.uninstalledPath=I.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new d.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(P){const N=[];(P===null||P===0)&&N.push(this.scanSystemExtensions().then(null,x=>Promise.reject(new L.ExtensionManagementError(this.joinErrors(x).message,i)))),(P===null||P===1)&&N.push(this.scanUserExtensions(!0).then(null,x=>Promise.reject(new L.ExtensionManagementError(this.joinErrors(x).message,n))));try{const x=await Promise.all(N);return(0,b.flatten)(x)}catch(x){throw this.joinErrors(x)}}async scanUserExtensions(P){this.logService.trace("Started scanning user extensions");let[N,x]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return x=x.filter(_=>!N[new c.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version).key()]),P&&(x=(0,c.groupByExtension)(x,J=>J.identifier).map(J=>J.sort((ie,se)=>m.rcompare(ie.manifest.version,se.manifest.version))[0])),this.logService.trace("Scanned user extensions:",x.length),x}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(P,N,x){const _=P.key(),J=I.join(this.extensionsPath,`.${(0,s.generateUuid)()}`),ie=I.join(this.extensionsPath,_);try{await v.Promises.rm(ie)}catch(Y){try{await v.Promises.rm(ie)}catch(X){}throw new L.ExtensionManagementError((0,O.localize)(0,null,ie,P.id),a)}await this.extractAtLocation(P,N,J,x);let se=await this.scanExtension(S.URI.file(J),1);if(!se)throw new Error((0,O.localize)(1,null,J));await this.storeMetadata(se,{installedTimestamp:Date.now()});try{await this.rename(P,J,ie,Date.now()+2*60*1e3),this.logService.info("Renamed to",ie)}catch(Y){try{await v.Promises.rm(J)}catch(X){}if(Y.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",P.id);else throw this.logService.info(`Rename failed because of ${(0,e.getErrorMessage)(Y)}. Deleted from extracted location`,J),Y}try{se=await this.scanExtension(S.URI.file(ie),1)}catch(Y){}if(se)return se;throw new Error((0,O.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(P,N){return this.setMetadata(P,N),await this.storeMetadata(P,{...N,installedTimestamp:P.installedTimestamp}),P}async storeMetadata(P,N){N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0;const x=I.join(P.location.fsPath,"package.json"),_=await v.Promises.readFile(x,"utf8"),{manifest:J}=await this.parseManifest(_);return J.__metadata=N,await v.Promises.writeFile(x,JSON.stringify(J,null,"	")),P}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...P){const N=P.map(x=>new c.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version));await this.withUninstalledExtensions(x=>{N.forEach(_=>x[_.key()]=!0)})}async setInstalled(P){await this.withUninstalledExtensions(_=>delete _[P.key()]);const x=(await this.scanExtensions(1)).find(_=>new c.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version).equals(P))||null;return x?(await this.storeMetadata(x,{installedTimestamp:Date.now()}),this.scanExtension(x.location,1)):null}async withUninstalledExtensions(P){return this.uninstalledFileLimiter.queue(async()=>{let N;try{N=await v.Promises.readFile(this.uninstalledPath,"utf8")}catch(_){if(_.code!=="ENOENT")throw _}let x={};if(N)try{x=JSON.parse(N)}catch(_){}return P&&(P(x),Object.keys(x).length?await v.Promises.writeFile(this.uninstalledPath,JSON.stringify(x)):await v.Promises.rm(this.uninstalledPath)),x})}async removeExtension(P,N){this.logService.trace(`Deleting ${N} extension from disk`,P.identifier.id,P.location.fsPath),await v.Promises.rm(P.location.fsPath),this.logService.info("Deleted from disk",P.identifier.id,P.location.fsPath)}async removeUninstalledExtension(P){await this.removeExtension(P,"uninstalled"),await this.withUninstalledExtensions(N=>delete N[new c.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()])}async extractAtLocation(P,N,x,_){this.logService.trace(`Started extracting the extension from ${N} to ${x}`);try{await v.Promises.rm(x)}catch(J){throw new L.ExtensionManagementError(this.joinErrors(J).message,a)}try{await(0,u.extract)(N,x,{sourcePath:"extension",overwrite:!0},_),this.logService.info(`Extracted extension to ${x}:`,P.id)}catch(J){try{await v.Promises.rm(x)}catch(ie){}throw new L.ExtensionManagementError(J.message,J instanceof u.ExtractError&&J.type?J.type:o)}}async rename(P,N,x,_){try{await v.Promises.rename(N,x)}catch(J){if(D.isWindows&&J&&J.code==="EPERM"&&Date.now()<_)return this.logService.info(`Failed renaming ${N} to ${x} with 'EPERM' error. Trying again...`,P.id),this.rename(P,N,x,_);throw new L.ExtensionManagementError(J.message||(0,O.localize)(3,null,N,x),J.code||h)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const P=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return P;const N=this.scanDevSystemExtensions(),[x,_]=await Promise.all([P,N]);return[...x,..._]}async scanExtensionsInDir(P,N){const x=new d.Limiter(10),_=await this.fileService.resolve(S.URI.file(P));return _.children?(await Promise.all(_.children.filter(ie=>ie.isDirectory).map(ie=>x.queue(async()=>N===1&&(0,r.basename)(ie.resource).indexOf(".")===0?null:this.scanExtension(ie.resource,N))))).filter(ie=>ie&&ie.identifier):[]}async scanExtension(P,N){try{const x=await this.fileService.resolve(P);if(x.children){const{manifest:_,metadata:J}=await this.readManifest(P.fsPath),ie=x.children.find(({name:Q})=>/^readme(\.txt|\.md|)$/i.test(Q))?.resource,se=x.children.find(({name:Q})=>/^changelog(\.txt|\.md|)$/i.test(Q))?.resource,Y={id:(0,c.getGalleryExtensionId)(_.publisher,_.name)},X={type:N,identifier:Y,manifest:_,location:P,readmeUrl:ie,changelogUrl:se,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:N===0};return J&&(this.setMetadata(X,J),X.installedTimestamp=J.installedTimestamp),X}}catch(x){N!==0&&this.logService.trace(x)}return null}async scanDefaultSystemExtensions(){const P=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",P.length),P}async scanDevSystemExtensions(){const P=this.getDevSystemExtensionsList();if(P.length){const N=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",N.length),N.filter(x=>P.some(_=>(0,c.areSameExtensions)(x.identifier,{id:_})))}else return[]}setMetadata(P,N){P.publisherDisplayName=N.publisherDisplayName||null,P.publisherId=N.publisherId||null,P.identifier.uuid=N.id,P.isMachineScoped=!!N.isMachineScoped,P.isBuiltin=P.type===0||!!N.isBuiltin}async removeUninstalledExtensions(){const P=await this.getUninstalledExtensions(),N=await this.scanAllUserExtensions(),x=new Set;for(const ie of N)P[new c.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]||x.add(ie.identifier.id.toLowerCase());const _=(0,c.groupByExtension)(N,ie=>ie.identifier);await d.Promises.settled(_.map(async ie=>{const se=ie.sort((Y,X)=>m.rcompare(Y.manifest.version,X.manifest.version))[0];x.has(se.identifier.id.toLowerCase())||await this.beforeRemovingExtension(se)}));const J=N.filter(ie=>P[new c.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]);await d.Promises.settled(J.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const P=await this.scanAllUserExtensions(),N=[],x=(0,c.groupByExtension)(P,_=>_.identifier);N.push(...(0,b.flatten)(x.map(_=>_.sort((J,ie)=>m.rcompare(J.manifest.version,ie.manifest.version)).slice(1)))),await d.Promises.settled(N.map(_=>this.removeExtension(_,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(P=>P.name)}joinErrors(P){const N=Array.isArray(P)?P:[P];return N.length===1?N[0]instanceof Error?N[0]:new Error(N[0]):N.reduce((x,_)=>new Error(`${x.message}${x.message?",":""}${_ instanceof Error?_.message:_}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=I.normalize(I.join(R.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(P){const N=[v.Promises.readFile(I.join(P,"package.json"),"utf8").then(ie=>this.parseManifest(ie)),v.Promises.readFile(I.join(P,"package.nls.json"),"utf8").then(void 0,ie=>ie.code!=="ENOENT"?Promise.reject(ie):"{}").then(ie=>JSON.parse(ie))],[{manifest:x,metadata:_},J]=await Promise.all(N);return{manifest:(0,y.localizeManifest)(x,J),metadata:_}}parseManifest(P){return new Promise((N,x)=>{try{const _=JSON.parse(P),J=_.__metadata||null;N({manifest:_,metadata:J})}catch(_){x(new Error((0,O.localize)(4,null)))}})}};g=ue([fe(1,f.IFileService),fe(2,F.ILogService),fe(3,p.INativeEnvironmentService),fe(4,l.IProductService)],g),t.ExtensionsScanner=g}),define(Z[124],te([0,1,77,4,11,43,22,23,21,41,7,35,10,15,98,28,36,49,20,29,96,12,9,122,102,123,103,104,17,117]),function(q,t,m,T,v,I,F,L,c,d,S,p,y,O,l,u,D,b,R,f,r,s,e,i,n,o,a,h,g,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const P="unsetUninstalled",N="downloading";let x=class extends k.AbstractExtensionManagementService{constructor(X,Q,B,W,U,w,M){super(X,Q,B);this.environmentService=W,this.downloadService=U;const E=this._register(w.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(w.createInstance(o.ExtensionsScanner,C=>E.postUninstall(C))),this.manifestCache=this._register(new l.ExtensionsManifestCache(W,this)),this.extensionsDownloader=this._register(w.createInstance(n.ExtensionsDownloader));const A=this._register(new h.ExtensionsWatcher(this,M,W,B));this._register(A.onDidChangeExtensionsByAnotherSource(({added:C,removed:z})=>{C.length&&this._onDidInstallExtensions.fire(C.map(j=>({identifier:j.identifier,operation:0,local:j}))),z.forEach(j=>this._onDidUninstallExtension.fire({identifier:j}))}))}async zip(X){this.logService.trace("ExtensionManagementService#zip",X.identifier.id);const Q=await this.collectFiles(X),B=await(0,I.zip)((0,R.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)()).fsPath,Q);return S.URI.file(B)}async unzip(X){return this.logService.trace("ExtensionManagementService#unzip",X.toString()),(await this.install(X)).identifier}async getManifest(X){const Q=await this.downloadVsix(X),B=T.resolve(Q.fsPath);return(0,i.getManifest)(B)}getInstalled(X=null){return this.extensionsScanner.scanExtensions(X)}async canInstall(X){return!0}async install(X,Q={}){this.logService.trace("ExtensionManagementService#install",X.toString());const B=await this.downloadVsix(X),W=await(0,i.getManifest)(T.resolve(B.fsPath));if(W.engines&&W.engines.vscode&&!(0,b.isEngineValid)(W.engines.vscode,p.default.version,p.default.date))throw new Error(m.localize(0,null,(0,L.getGalleryExtensionId)(W.publisher,W.name),p.default.version));return this.installExtension(W,B,Q)}async updateMetadata(X,Q){return this.logService.trace("ExtensionManagementService#updateMetadata",X.identifier.id),X=await this.extensionsScanner.saveMetadataForLocalExtension(X,{...X.manifest.__metadata||{},...Q}),this.manifestCache.invalidate(),X}async updateExtensionScope(X,Q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",X.identifier.id),X=await this.extensionsScanner.saveMetadataForLocalExtension(X,{...X.manifest.__metadata||{},isMachineScoped:Q}),this.manifestCache.invalidate(),X}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(X){if(X.scheme===e.Schemas.file)return X;if(!this.downloadService)throw new Error("Download service is not available");const Q=(0,R.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)());return await this.downloadService.download(X,Q),Q}createInstallExtensionTask(X,Q,B){return S.URI.isUri(Q)?new ie(X,Q,B,this.galleryService,this.extensionsScanner,this.logService):new J(Q,B,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(X,Q){return new se(X,Q,this.extensionsScanner)}async collectFiles(X){const Q=async W=>{let U=await v.Promises.readdir(W);U=U.map(E=>T.join(W,E));const w=await Promise.all(U.map(E=>v.Promises.stat(E)));let M=Promise.resolve([]);return w.forEach((E,A)=>{const C=U[A];E.isFile()&&(M=M.then(z=>[...z,C])),E.isDirectory()&&(M=M.then(z=>Q(C).then(j=>[...z,...j])))}),M};return(await Q(X.location.fsPath)).map(W=>({path:`extension/${T.relative(X.location.fsPath,W)}`,localPath:W}))}};x=ue([fe(0,F.IExtensionGalleryService),fe(1,D.ITelemetryService),fe(2,O.ILogService),fe(3,c.INativeEnvironmentService),fe(4,(0,s.optional)(r.IDownloadService)),fe(5,s.IInstantiationService),fe(6,g.IFileService)],x),t.ExtensionManagementService=x;class _ extends k.AbstractExtensionTask{constructor(X,Q,B,W){super();this.identifier=X,this.source=Q,this.extensionsScanner=B,this.logService=W,this._operation=1}get operation(){return this._operation}async installExtension(X,Q){try{const B=await this.unsetUninstalledAndGetLocal(X.identifierWithVersion);if(B)return X.metadata?this.extensionsScanner.saveMetadataForLocalExtension(B,X.metadata):B}catch(B){throw y.isMacintosh?new F.ExtensionManagementError(m.localize(1,null),P):new F.ExtensionManagementError(m.localize(2,null),P)}return this.extract(X,Q)}async unsetUninstalledAndGetLocal(X){if(!await this.isUninstalled(X))return null;this.logService.trace("Removing the extension from uninstalled list:",X.id);const B=await this.extensionsScanner.setInstalled(X);return this.logService.info("Removed the extension from uninstalled list:",X.id),B}async isUninstalled(X){return!!(await this.extensionsScanner.getUninstalledExtensions())[X.key()]}async extract({zipPath:X,identifierWithVersion:Q,metadata:B},W){let U=await this.extensionsScanner.extractUserExtension(Q,X,W);return this.logService.info("Extracting completed.",Q.id),B&&(U=await this.extensionsScanner.saveMetadataForLocalExtension(U,B)),U}}class J extends _{constructor(X,Q,B,W,U){super(X.identifier,X,W,U);this.gallery=X,this.options=Q,this.extensionsDownloader=B}async doRun(X){const B=(await this.extensionsScanner.scanExtensions(null)).find(w=>(0,L.areSameExtensions)(w.identifier,this.gallery.identifier));B&&(this._operation=2);const W=await this.downloadInstallableExtension(this.gallery,this._operation);W.metadata.isMachineScoped=this.options.isMachineScoped||B?.isMachineScoped,W.metadata.isBuiltin=this.options.isBuiltin||B?.isBuiltin;const U=await this.installExtension(W,X);B&&d.neq(B.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(B);try{await this.extensionsDownloader.delete(S.URI.file(W.zipPath))}catch(w){}return U}async downloadInstallableExtension(X,Q){const B={id:X.identifier.uuid,publisherId:X.publisherId,publisherDisplayName:X.publisherDisplayName};let W;try{this.logService.trace("Started downloading extension:",X.identifier.id),W=(await this.extensionsDownloader.downloadExtension(X,Q)).fsPath,this.logService.info("Downloaded extension:",X.identifier.id,W)}catch(U){throw new F.ExtensionManagementError((0,k.joinErrors)(U).message,N)}try{const U=await(0,i.getManifest)(W);return{zipPath:W,identifierWithVersion:new L.ExtensionIdentifierWithVersion(X.identifier,U.version),metadata:B}}catch(U){throw new F.ExtensionManagementError((0,k.joinErrors)(U).message,k.INSTALL_ERROR_VALIDATING)}}}class ie extends _{constructor(X,Q,B,W,U,w){super({id:(0,L.getGalleryExtensionId)(X.publisher,X.name)},Q,U,w);this.manifest=X,this.location=Q,this.options=B,this.galleryService=W}async doRun(X){const Q=new L.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),W=(await this.extensionsScanner.scanExtensions(1)).find(w=>(0,L.areSameExtensions)(this.identifier,w.identifier)),U=await this.getMetadata(this.identifier.id,X);if(W)if(U.isMachineScoped=this.options.isMachineScoped||W.isMachineScoped,U.isBuiltin=this.options.isBuiltin||W.isBuiltin,this._operation=2,Q.equals(new L.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version)))try{await this.extensionsScanner.removeExtension(W,"existing")}catch(w){throw new Error(m.localize(3,null,this.manifest.displayName||this.manifest.name))}else d.gt(W.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(W);else{const w=await this.unsetUninstalledAndGetLocal(Q);if(w)try{await this.extensionsScanner.removeExtension(w,"existing")}catch(M){throw new Error(m.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:Q,metadata:U},X)}async getMetadata(X,Q){try{const B=(await this.galleryService.query({names:[X],pageSize:1},Q)).firstPage[0];if(B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId}}catch(B){}return{}}}class se extends k.AbstractExtensionTask{constructor(X,Q,B){super();this.extension=X,this.options=Q,this.extensionsScanner=B}async doRun(X){const Q=[],B=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const W=new L.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);Q.push(...B.filter(U=>W.equals(new L.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version))))}else Q.push(...B.filter(W=>(0,L.areSameExtensions)(W.identifier,this.extension.identifier)));if(!Q.length)throw new Error(m.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...Q),this.options.remove)for(const W of Q)try{X.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(W)}catch(U){throw new Error(m.localize(6,null,(0,u.toErrorMessage)(U)))}}}}),define(Z[125],te([0,1,134,113,2,13,8,112,27,15,16,21,99]),function(q,t,m,T,v,I,F,L,c,d,S,p,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let O=class extends v.Disposable{constructor(u,D,b){super();this.environmentService=D,this.logService=b,this.configure(u.getValue()),this._register(u.onDidChangeConfiguration(()=>this.configure(u.getValue()),this))}configure(u){this.proxyUrl=u.http&&u.http.proxy,this.strictSSL=!!(u.http&&u.http.proxyStrictSSL),this.authorization=u.http&&u.http.proxyAuthorization}async request(u,D){this.logService.trace("RequestService#request",u.url);const{proxyUrl:b,strictSSL:R}=this,f={...process.env,...await(0,y.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},r=u.agent?u.agent:await(0,L.getProxyAgent)(u.url||"",f,{proxyUrl:b,strictSSL:R});return u.agent=r,u.strictSSL=R,this.authorization&&(u.headers={...u.headers||{},"Proxy-Authorization":this.authorization}),this._request(u,D)}async getNodeRequest(u){return((0,T.parse)(u.url).protocol==="https:"?await new Promise((R,f)=>{q(["https"],R,f)}):await new Promise((R,f)=>{q(["http"],R,f)})).request}_request(u,D){return new Promise(async(b,R)=>{let f;const r=(0,T.parse)(u.url),s=u.getRawRequest?u.getRawRequest(u):await this.getNodeRequest(u),e={hostname:r.hostname,port:r.port?parseInt(r.port):r.protocol==="https:"?443:80,protocol:r.protocol,path:r.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,I.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(e.auth=u.user+":"+u.password),f=s(e,i=>{const n=(0,I.isNumber)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...u,url:i.headers.location,followRedirects:n-1},D).then(b,R);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,m.createGunzip)())),b({res:i,stream:(0,S.streamToBufferReadableStream)(o)})}}),f.on("error",R),u.timeout&&f.setTimeout(u.timeout),u.data&&typeof u.data=="string"&&f.write(u.data),f.end(),D.onCancellationRequested(()=>{f.abort(),R((0,F.canceled)())})})}async resolveProxy(u){}};O=ue([fe(0,c.IConfigurationService),fe(1,p.INativeEnvironmentService),fe(2,d.ILogService)],O),t.RequestService=O}),define(Z[135],te([0,1,38,136,32,3,16,28,8,2,9,4,34,7,11,27,111,21,89,118,22,97,124,17,107,108,50,101,52,53,105,15,106,35,42,55,125,116,36,119,56,120,121]),function(q,t,m,T,v,I,F,L,c,d,S,p,y,O,l,u,D,b,R,f,r,s,e,i,n,o,a,h,g,k,P,N,x,_,J,ie,se,Y,X,Q,B,W,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class w extends d.Disposable{constructor(A){super();this.argv=A,(0,T.gracefulify)(m),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[A,C]=await this.initServices();return A.invokeFunction(async z=>{const j=z.get(N.ILogService),$=z.get(i.IFileService),H=z.get(b.INativeEnvironmentService),ee=z.get(r.IExtensionManagementCLIService);return j.info("CLI main",this.argv),this.registerErrorHandler(j),await this.doRun(H,ee,$),(0,I.raceTimeout)((0,B.combinedAppender)(...C).flush(),1e3)})}async initServices(){const A=new g.ServiceCollection,C={_serviceBrand:void 0,..._.default};A.set(J.IProductService,C);const z=new R.NativeEnvironmentService(this.argv,C);A.set(b.INativeEnvironmentService,z),await Promise.all([z.appSettingsHome.fsPath,z.extensionsPath].map(me=>me?l.Promises.mkdir(me,{recursive:!0}):void 0));const j=(0,N.getLogLevel)(z),$=[];$.push(new x.SpdLogLogger("cli",(0,p.join)(z.logsPath,"cli.log"),!0,j)),j===N.LogLevel.Trace&&$.push(new N.ConsoleLogger(j));const H=this._register(new N.MultiplexLogService($));A.set(N.ILogService,H);const ee=this._register(new n.FileService(H));A.set(i.IFileService,ee);const ne=this._register(new o.DiskFileSystemProvider(H));ee.registerProvider(S.Schemas.file,ne);const re=this._register(new D.ConfigurationService(z.settingsResource,ee));A.set(u.IConfigurationService,re),await re.initialize(),A.set(ie.IRequestService,new a.SyncDescriptor(se.RequestService)),A.set(r.IExtensionManagementService,new a.SyncDescriptor(e.ExtensionManagementService)),A.set(r.IExtensionGalleryService,new a.SyncDescriptor(f.ExtensionGalleryService)),A.set(r.IExtensionManagementCLIService,new a.SyncDescriptor(s.ExtensionManagementCLIService)),A.set(k.ILocalizationsService,new a.SyncDescriptor(P.LocalizationsService));const ce=[];if(z.isBuilt&&!z.isExtensionDevelopment&&!z.disableTelemetry&&C.enableTelemetry){C.aiConfig&&C.aiConfig.asimovKey&&ce.push(new W.AppInsightsAppender("monacoworkbench",null,C.aiConfig.asimovKey));const{appRoot:me,extensionsPath:be,installSourcePath:ke}=z,Te={appender:(0,B.combinedAppender)(...ce),sendErrorTelemetry:!1,commonProperties:(async()=>{let we;try{const Fe=await l.Promises.readFile((0,p.join)(z.userDataPath,"storage.json"));we=JSON.parse(Fe.toString())[X.machineIdKey]}catch(Fe){Fe.code!=="ENOENT"&&H.error(Fe)}return(0,Y.resolveCommonProperties)(ee,(0,v.release)(),(0,v.hostname)(),process.arch,C.commit,C.version,we,C.msftInternalDomains,ke)})(),piiPaths:[me,be]};A.set(X.ITelemetryService,new a.SyncDescriptor(Q.TelemetryService,[Te]))}else A.set(X.ITelemetryService,B.NullTelemetryService);return[new h.InstantiationService(A),ce]}registerErrorHandler(A){(0,c.setUnexpectedErrorHandler)(C=>{const z=(0,L.toErrorMessage)(C,!0);!z||A.error(`[uncaught exception in CLI]: ${z}`)}),process.on("uncaughtException",C=>(0,c.onUnexpectedError)(C)),process.on("unhandledRejection",C=>(0,c.onUnexpectedError)(C))}async doRun(A,C,z){if(this.argv["install-source"])return this.setInstallSource(A,z,this.argv["install-source"]);if(this.argv["list-extensions"])return C.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return C.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return C.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return C.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(A.appRoot,A.extensionsPath))}asExtensionIdOrVSIX(A){return A.map(C=>/\.vsix$/i.test(C)?O.URI.file((0,p.isAbsolute)(C)?C:(0,p.join)((0,y.cwd)(),C)):C)}async setInstallSource(A,C,z){await C.writeFile(O.URI.file(A.installSourcePath),F.VSBuffer.fromString(z.slice(0,30)))}}async function M(E){const A=new w(E);try{await A.run()}finally{A.dispose()}}t.main=M})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a4eb4d688477fb9f2176bb2ed932b0b1726caed3/core/vs/code/node/cliProcessMain.js.map
