/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/map","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(J){for(var e=[],g=0,L=J.length;g<L;g++)e[g]=me[J[g]];return e};define(me[54],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=g}),define(me[55],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function L(i){const I=[];for(let u in i)g.call(i,u)&&I.push(i[u]);return I}e.values=L;function k(i,I){for(let u in i)if(g.call(i,u)&&I({key:u,value:i[u]},function(){delete i[u]})===!1)return}e.forEach=k;function y(i,I){const u=Object.create(null);for(const m of i){const l=I(m);let v=u[l];v||(v=u[l]=[]),v.push(m)}return u}e.groupBy=y;function T(i){const I=Object.create(null);return i&&i.forEach((u,m)=>{I[m]=u}),I}e.fromMap=T;function C(i,I){const u=[],m=[];for(let l of i)I.has(l)||u.push(l);for(let l of I)i.has(l)||m.push(l);return{removed:u,added:m}}e.diffSets=C;function S(i,I){const u=[],m=[];for(let[l,v]of i)I.has(l)||u.push(v);for(let[l,v]of I)i.has(l)||m.push(v);return{removed:u,added:m}}e.diffMaps=S;class P{constructor(){this.map=new Map}add(I,u){let m=this.map.get(I);m||(m=new Set,this.map.set(I,m)),m.add(u)}delete(I,u){const m=this.map.get(I);!m||(m.delete(u),m.size===0&&this.map.delete(I))}forEach(I,u){const m=this.map.get(I);!m||m.forEach(u)}}e.SetMap=P}),define(me[56],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(T){return(C,S,P)=>{let i=null,I=null;if(typeof P.value=="function"?(i="value",I=P.value):typeof P.get=="function"&&(i="get",I=P.get),!I)throw new Error("not supported");P[i]=T(I,S)}}e.createDecorator=g;function L(T,C,S){let P=null,i=null;if(typeof S.value=="function"?(P="value",i=S.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(P="get",i=S.get),!i)throw new Error("not supported");const I=`$memoize$${C}`;S[P]=function(...u){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,u)}),this[I]}}e.memoize=L;function k(T,C,S){return g((P,i)=>{const I=`$debounce$${i}`,u=`$debounce$result$${i}`;return function(...m){this[u]||(this[u]=S?S():void 0),clearTimeout(this[I]),C&&(this[u]=C(this[u],...m),m=[this[u]]),this[I]=setTimeout(()=>{P.apply(this,m),this[u]=S?S():void 0},T)}})}e.debounce=k;function y(T,C,S){return g((P,i)=>{const I=`$throttle$timer$${i}`,u=`$throttle$result$${i}`,m=`$throttle$lastRun$${i}`,l=`$throttle$pending$${i}`;return function(...v){if(this[u]||(this[u]=S?S():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),C&&(this[u]=C(this[u],...v)),this[l])return;const _=this[m]+T;_<=Date.now()?(this[m]=Date.now(),P.apply(this,[this[u]]),this[u]=S?S():void 0):(this[l]=!0,this[I]=setTimeout(()=>{this[l]=!1,this[m]=Date.now(),P.apply(this,[this[u]]),this[u]=S?S():void 0},_-Date.now()))}})}e.throttle=y}),define(me[16],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function L(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=L;function k(p){S(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=k;function y(p){S(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=y;function T(p){if(p instanceof Error){let{name:t,message:r}=p;const o=p.stacktrace||p.stack;return{$isError:!0,name:t,message:r,stack:o}}return p}e.transformErrorForSerialization=T;const C="Canceled";function S(p){return p instanceof Error&&p.name===C&&p.message===C}e.isPromiseCanceledError=S;class P extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=P;function i(){const p=new Error(C);return p.name=p.message,p}e.canceled=i;function I(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=I;function u(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=u;function m(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function l(p){const t=new Error(`${p} has been disposed`);return t.name="DISPOSED",t}e.disposed=l;function v(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=v;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class A extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=A;function c(p){const t=p;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function h(p,t=Object.create(null)){const r=new Error(p);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=h}),define(me[20],ge([0,1,16]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(B,G=0){return B[B.length-(1+G)]}e.tail=L;function k(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=k;function y(B,G,re=(he,ye)=>he===ye){if(B===G)return!0;if(!B||!G||B.length!==G.length)return!1;for(let he=0,ye=B.length;he<ye;he++)if(!re(B[he],G[he]))return!1;return!0}e.equals=y;function T(B,G,re){let he=0,ye=B.length-1;for(;he<=ye;){const Ie=(he+ye)/2|0,Le=re(B[Ie],G);if(Le<0)he=Ie+1;else if(Le>0)ye=Ie-1;else return Ie}return-(he+1)}e.binarySearch=T;function C(B,G){let re=0,he=B.length;if(he===0)return 0;for(;re<he;){const ye=Math.floor((re+he)/2);G(B[ye])?he=ye:re=ye+1}return re}e.findFirstInSorted=C;function S(B,G,re){if(B=B|0,B>=G.length)throw new TypeError("invalid index");let he=G[Math.floor(G.length*Math.random())],ye=[],Ie=[],Le=[];for(let qe of G){const We=re(qe,he);We<0?ye.push(qe):We>0?Ie.push(qe):Le.push(qe)}return B<ye.length?S(B,ye,re):B<ye.length+Le.length?Le[0]:S(B-(ye.length+Le.length),Ie,re)}e.quickSelect=S;function P(B,G){const re=[];let he;for(const ye of B.slice(0).sort(G))!he||G(he[0],ye)!==0?(he=[ye],re.push(he)):he.push(ye);return re}e.groupBy=P;function i(B,G,re){const he=[];function ye(qe,We,je){if(We===0&&je.length===0)return;const W=he[he.length-1];W&&W.start+W.deleteCount===qe?(W.deleteCount+=We,W.toInsert.push(...je)):he.push({start:qe,deleteCount:We,toInsert:je})}let Ie=0,Le=0;for(;;){if(Ie===B.length){ye(Ie,0,G.slice(Le));break}if(Le===G.length){ye(Ie,B.length-Ie,[]);break}const qe=B[Ie],We=G[Le],je=re(qe,We);je===0?(Ie+=1,Le+=1):je<0?(ye(Ie,1,[]),Ie+=1):je>0&&(ye(Ie,0,[We]),Le+=1)}return he}e.sortedDiff=i;function I(B,G,re){const he=i(B,G,re),ye=[],Ie=[];for(const Le of he)ye.push(...B.slice(Le.start,Le.start+Le.deleteCount)),Ie.push(...Le.toInsert);return{removed:ye,added:Ie}}e.delta=I;function u(B,G,re){if(re===0)return[];const he=B.slice(0,re).sort(G);return l(B,G,he,re,B.length),he}e.top=u;function m(B,G,re,he,ye){return re===0?Promise.resolve([]):new Promise((Ie,Le)=>{(async()=>{const qe=B.length,We=B.slice(0,re).sort(G);for(let je=re,W=Math.min(re+he,qe);je<qe;je=W,W=Math.min(W+he,qe)){if(je>re&&await new Promise(Z=>setTimeout(Z)),ye&&ye.isCancellationRequested)throw(0,g.canceled)();l(B,G,We,je,W)}return We})().then(Ie,Le)})}e.topAsync=m;function l(B,G,re,he,ye){for(const Ie=re.length;he<ye;he++){const Le=B[he];if(G(Le,re[Ie-1])<0){re.pop();const qe=C(re,We=>G(Le,We)<0);re.splice(qe,0,Le)}}}function v(B){return B.filter(G=>!!G)}e.coalesce=v;function _(B){let G=0;for(let re=0;re<B.length;re++)B[re]&&(B[G]=B[re],G+=1);B.length=G}e.coalesceInPlace=_;function b(B,G,re){B.splice(re,0,B.splice(G,1)[0])}e.move=b;function A(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=A;function c(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=c;function h(B,G){if(!G)return B.filter((he,ye)=>B.indexOf(he)===ye);const re=Object.create(null);return B.filter(he=>{const ye=G(he);return re[ye]?!1:(re[ye]=!0,!0)})}e.distinct=h;function p(B){const G=new Set;return B.filter(re=>G.has(re)?!1:(G.add(re),!0))}e.distinctES6=p;function t(B){const G=Object.create(null);return re=>{const he=B(re);return G[he]?!1:(G[he]=!0,!0)}}e.uniqueFilter=t;function r(B,G){for(let re=B.length-1;re>=0;re--){const he=B[re];if(G(he))return re}return-1}e.lastIndex=r;function o(B,G){return B.length>0?B[0]:G}e.firstOrDefault=o;function n(B,G,re=(he,ye)=>he===ye){let he=0;for(let ye=0,Ie=Math.min(B.length,G.length);ye<Ie&&re(B[ye],G[ye]);ye++)he++;return he}e.commonPrefixLength=n;function a(B){return[].concat(...B)}e.flatten=a;function f(B,G){let re=typeof G=="number"?B:0;typeof G=="number"?re=B:(re=0,G=B);const he=[];if(re<=G)for(let ye=re;ye<G;ye++)he.push(ye);else for(let ye=re;ye>G;ye--)he.push(ye);return he}e.range=f;function d(B,G,re){return B.reduce((he,ye)=>(he[G(ye)]=re?re(ye):ye,he),Object.create(null))}e.index=d;function w(B,G){return B.push(G),()=>E(B,G)}e.insert=w;function E(B,G){const re=B.indexOf(G);if(re>-1)return B.splice(re,1),G}e.remove=E;function s(B,G,re){const he=B.slice(0,G),ye=B.slice(G);return he.concat(re,ye)}e.arrayInsert=s;function D(B,G){let re;if(typeof G=="number"){let he=G;re=()=>{const ye=Math.sin(he++)*179426549;return ye-Math.floor(ye)}}else re=Math.random;for(let he=B.length-1;he>0;he-=1){const ye=Math.floor(re()*(he+1)),Ie=B[he];B[he]=B[ye],B[ye]=Ie}}e.shuffle=D;function R(B,G){const re=B.indexOf(G);re>-1&&(B.splice(re,1),B.unshift(G))}e.pushToStart=R;function U(B,G){const re=B.indexOf(G);re>-1&&(B.splice(re,1),B.push(G))}e.pushToEnd=U;function V(B,G){return Array.isArray(B)?B.map(G):G(B)}e.mapArrayOrNot=V;function ee(B){return Array.isArray(B)?B:[B]}e.asArray=ee;function K(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=K;function O(B,G){for(const re of B){const he=G(re);if(he!==void 0)return he}}e.mapFind=O;function x(B,G,re){const he=z(B,G),ye=B.length,Ie=re.length;B.length=ye+Ie;for(let Le=ye-1;Le>=he;Le--)B[Le+Ie]=B[Le];for(let Le=0;Le<Ie;Le++)B[Le+he]=re[Le]}e.insertInto=x;function F(B,G,re,he){const ye=z(B,G),Ie=B.splice(ye,re);return x(B,ye,he),Ie}e.splice=F;function z(B,G){return G<0?Math.max(G+B.length,0):Math.min(G,B.length)}function M(B,G){let re=Number.MAX_SAFE_INTEGER,he=0;return B.forEach((ye,Ie)=>{const Le=G(ye);Le<re&&(re=Le,he=Ie)}),he}e.minIndex=M;function N(B,G){let re=Number.MIN_SAFE_INTEGER,he=0;return B.forEach((ye,Ie)=>{const Le=G(ye);Le>re&&(re=Le,he=Ie)}),he}e.maxIndex=N;class q{constructor(G){this.items=G,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(G){let re=this.firstIdx;for(;re<this.items.length&&G(this.items[re]);)re++;const he=re===this.firstIdx?null:this.items.slice(this.firstIdx,re);return this.firstIdx=re,he}takeFromEndWhile(G){let re=this.lastIdx;for(;re>=0&&G(this.items[re]);)re--;const he=re===this.lastIdx?null:this.items.slice(re+1,this.lastIdx+1);return this.lastIdx=re,he}}e.ArrayQueue=q}),define(me[72],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(L){const k=this;let y=!1,T;return function(){return y||(y=!0,T=L.apply(k,arguments)),T}}e.once=g}),define(me[73],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(me[74],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(L){function k(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}L.is=k;const y=Object.freeze([]);function T(){return y}L.empty=T;function*C(p){yield p}L.single=C;function S(p){return p||y}L.from=S;function P(p){return!p||p[Symbol.iterator]().next().done===!0}L.isEmpty=P;function i(p){return p[Symbol.iterator]().next().value}L.first=i;function I(p,t){for(const r of p)if(t(r))return!0;return!1}L.some=I;function u(p,t){for(const r of p)if(t(r))return r}L.find=u;function*m(p,t){for(const r of p)t(r)&&(yield r)}L.filter=m;function*l(p,t){let r=0;for(const o of p)yield t(o,r++)}L.map=l;function*v(...p){for(const t of p)for(const r of t)yield r}L.concat=v;function*_(p){for(const t of p)for(const r of t)yield r}L.concatNested=_;function b(p,t,r){let o=r;for(const n of p)o=t(o,n);return o}L.reduce=b;function*A(p,t,r=p.length){for(t<0&&(t+=p.length),r<0?r+=p.length:r>p.length&&(r=p.length);t<r;t++)yield p[t]}L.slice=A;function c(p,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,p];const o=p[Symbol.iterator]();for(let n=0;n<t;n++){const a=o.next();if(a.done)return[r,L.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return o}}]}L.consume=c;function h(p,t,r=(o,n)=>o===n){const o=p[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const a=o.next(),f=n.next();if(a.done!==f.done)return!1;if(a.done)return!0;if(!r(a.value,f.value))return!1}}L.equals=h})(g=e.Iterable||(e.Iterable={}))}),define(me[57],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function T(t,r=!1){let o=0,n=t.length,a="",f=0,d=16,w=0;function E(K){let O=0,x=0;for(;O<K;){const F=t.charCodeAt(o);if(F>=48&&F<=57)x=x*16+F-48;else if(F>=65&&F<=70)x=x*16+F-65+10;else if(F>=97&&F<=102)x=x*16+F-97+10;else break;o++,O++}return O<K&&(x=-1),x}function s(K){o=K,a="",f=0,d=16,w=0}function D(){const K=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&P(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&P(t.charCodeAt(o)))for(o++;o<t.length&&P(t.charCodeAt(o));)o++;else return w=3,t.substring(K,o);let O=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&P(t.charCodeAt(o))){for(o++;o<t.length&&P(t.charCodeAt(o));)o++;O=o}else w=3;return t.substring(K,O)}function R(){let K="",O=o;for(;;){if(o>=n){K+=t.substring(O,o),w=2;break}const x=t.charCodeAt(o);if(x===34){K+=t.substring(O,o),o++;break}if(x===92){if(K+=t.substring(O,o),o++,o>=n){w=2;break}switch(t.charCodeAt(o++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const z=E(4);z>=0?K+=String.fromCharCode(z):w=4;break;default:w=5}O=o;continue}if(x>=0&&x<=31)if(S(x)){K+=t.substring(O,o),w=2;break}else w=6;o++}return K}function U(){if(a="",w=0,f=o,o>=n)return f=n,d=17;let K=t.charCodeAt(o);if(C(K)){do o++,a+=String.fromCharCode(K),K=t.charCodeAt(o);while(C(K));return d=15}if(S(K))return o++,a+=String.fromCharCode(K),K===13&&t.charCodeAt(o)===10&&(o++,a+=`
`),d=14;switch(K){case 123:return o++,d=1;case 125:return o++,d=2;case 91:return o++,d=3;case 93:return o++,d=4;case 58:return o++,d=6;case 44:return o++,d=5;case 34:return o++,a=R(),d=10;case 47:const O=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<n&&!S(t.charCodeAt(o));)o++;return a=t.substring(O,o),d=12}if(t.charCodeAt(o+1)===42){o+=2;const x=n-1;let F=!1;for(;o<x;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,F=!0;break}o++}return F||(o++,w=1),a=t.substring(O,o),d=13}return a+=String.fromCharCode(K),o++,d=16;case 45:if(a+=String.fromCharCode(K),o++,o===n||!P(t.charCodeAt(o)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=D(),d=11;default:for(;o<n&&V(K);)o++,K=t.charCodeAt(o);if(f!==o){switch(a=t.substring(f,o),a){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return a+=String.fromCharCode(K),o++,d=16}}function V(K){if(C(K)||S(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let K;do K=U();while(K>=12&&K<=15);return K}return{setPosition:s,getPosition:()=>o,scan:r?ee:U,getToken:()=>d,getTokenValue:()=>a,getTokenOffset:()=>f,getTokenLength:()=>o-f,getTokenError:()=>w}}e.createScanner=T;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,r){const o=[],n=new Object;let a;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function w(E,s,D,R){f.value=E,f.offset=s,f.length=D,f.type=R,f.colonOffset=void 0,a=f}try{c(t,{onObjectBegin:(E,s)=>{if(r<=E)throw n;a=void 0,d=r>E,o.push("")},onObjectProperty:(E,s,D)=>{if(r<s||(w(E,s,D,"property"),o[o.length-1]=E,r<=s+D))throw n},onObjectEnd:(E,s)=>{if(r<=E)throw n;a=void 0,o.pop()},onArrayBegin:(E,s)=>{if(r<=E)throw n;a=void 0,o.push(0)},onArrayEnd:(E,s)=>{if(r<=E)throw n;a=void 0,o.pop()},onLiteralValue:(E,s,D)=>{if(r<s||(w(E,s,D,p(E)),r<=s+D))throw n},onSeparator:(E,s,D)=>{if(r<=s)throw n;if(E===":"&&a&&a.type==="property")a.colonOffset=s,d=!1,a=void 0;else if(E===","){const R=o[o.length-1];typeof R=="number"?o[o.length-1]=R+1:(d=!0,o[o.length-1]=""),a=void 0}}})}catch(E){if(E!==n)throw E}return{path:o,previousNode:a,isAtPropertyKey:d,matches:E=>{let s=0;for(let D=0;s<E.length&&D<o.length;D++)if(E[s]===o[D]||E[s]==="*")s++;else if(E[s]!=="**")return!1;return s===E.length}}}e.getLocation=I;function u(t,r=[],o=y.DEFAULT){let n=null,a=[];const f=[];function d(E){Array.isArray(a)?a.push(E):n!==null&&(a[n]=E)}return c(t,{onObjectBegin:()=>{const E={};d(E),f.push(a),a=E,n=null},onObjectProperty:E=>{n=E},onObjectEnd:()=>{a=f.pop()},onArrayBegin:()=>{const E=[];d(E),f.push(a),a=E,n=null},onArrayEnd:()=>{a=f.pop()},onLiteralValue:d,onError:(E,s,D)=>{r.push({error:E,offset:s,length:D})}},o),a[0]}e.parse=u;function m(t,r=[],o=y.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(E){n.type==="property"&&(n.length=E-n.offset,n=n.parent)}function f(E){return n.children.push(E),E}c(t,{onObjectBegin:E=>{n=f({type:"object",offset:E,length:-1,parent:n,children:[]})},onObjectProperty:(E,s,D)=>{n=f({type:"property",offset:s,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:E,offset:s,length:D,parent:n})},onObjectEnd:(E,s)=>{n.length=E+s-n.offset,n=n.parent,a(E+s)},onArrayBegin:(E,s)=>{n=f({type:"array",offset:E,length:-1,parent:n,children:[]})},onArrayEnd:(E,s)=>{n.length=E+s-n.offset,n=n.parent,a(E+s)},onLiteralValue:(E,s,D)=>{f({type:p(E),offset:s,length:D,parent:n,value:E}),a(s+D)},onSeparator:(E,s,D)=>{n.type==="property"&&(E===":"?n.colonOffset=s:E===","&&a(s))},onError:(E,s,D)=>{r.push({error:E,offset:s,length:D})}},o);const w=n.children[0];return w&&delete w.parent,w}e.parseTree=m;function l(t,r){if(!t)return;let o=t;for(let n of r)if(typeof n=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let a=!1;for(const f of o.children)if(Array.isArray(f.children)&&f.children[0].value===n){o=f.children[1],a=!0;break}if(!a)return}else{const a=n;if(o.type!=="array"||a<0||!Array.isArray(o.children)||a>=o.children.length)return;o=o.children[a]}return o}e.findNodeAtLocation=l;function v(t){if(!t.parent||!t.parent.children)return[];const r=v(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;r.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&r.push(o)}return r}e.getNodePath=v;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const r=Object.create(null);for(let o of t.children){const n=o.children[1];n&&(r[o.children[0].value]=_(n))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function b(t,r,o=!1){return r>=t.offset&&r<t.offset+t.length||o&&r===t.offset+t.length}e.contains=b;function A(t,r,o=!1){if(b(t,r,o)){const n=t.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=r;a++){const f=A(n[a],r,o);if(f)return f}return t}}e.findNodeAtOffset=A;function c(t,r,o=y.DEFAULT){const n=T(t,!1);function a(re){return re?()=>re(n.getTokenOffset(),n.getTokenLength()):()=>!0}function f(re){return re?he=>re(he,n.getTokenOffset(),n.getTokenLength()):()=>!0}const d=a(r.onObjectBegin),w=f(r.onObjectProperty),E=a(r.onObjectEnd),s=a(r.onArrayBegin),D=a(r.onArrayEnd),R=f(r.onLiteralValue),U=f(r.onSeparator),V=a(r.onComment),ee=f(r.onError),K=o&&o.disallowComments,O=o&&o.allowTrailingComma;function x(){for(;;){const re=n.scan();switch(n.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:K||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(re){case 12:case 13:K?F(10):V();break;case 16:F(1);break;case 15:case 14:break;default:return re}}}function F(re,he=[],ye=[]){if(ee(re),he.length+ye.length>0){let Ie=n.getToken();for(;Ie!==17;){if(he.indexOf(Ie)!==-1){x();break}else if(ye.indexOf(Ie)!==-1)break;Ie=x()}}}function z(re){const he=n.getTokenValue();return re?R(he):w(he),x(),!0}function M(){switch(n.getToken()){case 11:let re=0;try{re=JSON.parse(n.getTokenValue()),typeof re!="number"&&(F(2),re=0)}catch(he){F(2)}R(re);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return x(),!0}function N(){return n.getToken()!==10?(F(3,[],[2,5]),!1):(z(!1),n.getToken()===6?(U(":"),x(),G()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function q(){d(),x();let re=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(re||F(4,[],[]),U(","),x(),n.getToken()===2&&O)break}else re&&F(6,[],[]);N()||F(4,[],[2,5]),re=!0}return E(),n.getToken()!==2?F(7,[2],[]):x(),!0}function B(){s(),x();let re=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(re||F(4,[],[]),U(","),x(),n.getToken()===4&&O)break}else re&&F(6,[],[]);G()||F(4,[],[4,5]),re=!0}return D(),n.getToken()!==4?F(8,[4],[]):x(),!0}function G(){switch(n.getToken()){case 3:return B();case 1:return q();case 10:return z(!0);default:return M()}}return x(),n.getToken()===17?o.allowEmptyContent?!0:(F(4,[],[]),!1):G()?(n.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=c;function h(t,r){let o=T(t),n=[],a,f=0,d;do switch(d=o.getPosition(),a=o.scan(),a){case 12:case 13:case 17:f!==d&&n.push(t.substring(f,d)),r!==void 0&&n.push(o.getTokenValue().replace(/[^\r\n]/g,r)),f=o.getPosition();break}while(a!==17);return n.join("")}e.stripComments=h;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(me[137],ge([0,1,57]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,P,i){let I,u,m,l,v;if(P){for(l=P.offset,v=l+P.length,m=l;m>0&&!C(S,m-1);)m--;let f=v;for(;f<S.length&&!C(S,f);)f++;u=S.substring(m,f),I=y(u,i)}else u=S,I=0,m=0,l=0,v=S.length;const _=T(i,S);let b=!1,A=0,c;i.insertSpaces?c=k(" ",i.tabSize||4):c="	";const h=(0,g.createScanner)(u,!1);let p=!1;function t(){return _+k(c,I+A)}function r(){let f=h.scan();for(b=!1;f===15||f===14;)b=b||f===14,f=h.scan();return p=f===16||h.getTokenError()!==0,f}const o=[];function n(f,d,w){!p&&d<v&&w>l&&S.substring(d,w)!==f&&o.push({offset:d,length:w-d,content:f})}let a=r();if(a!==17){const f=h.getTokenOffset()+m,d=k(c,I);n(d,m,f)}for(;a!==17;){let f=h.getTokenOffset()+h.getTokenLength()+m,d=r(),w="";for(;!b&&(d===12||d===13);){const s=h.getTokenOffset()+m;n(" ",f,s),f=h.getTokenOffset()+h.getTokenLength()+m,w=d===12?t():"",d=r()}if(d===2)a!==1&&(A--,w=t());else if(d===4)a!==3&&(A--,w=t());else{switch(a){case 3:case 1:A++,w=t();break;case 5:case 12:w=t();break;case 13:b?w=t():w=" ";break;case 6:w=" ";break;case 10:if(d===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?w=" ":d!==5&&d!==17&&(p=!0);break;case 16:p=!0;break}b&&(d===12||d===13)&&(w=t())}const E=h.getTokenOffset()+m;n(w,f,E),a=d}return o}e.format=L;function k(S,P){let i="";for(let I=0;I<P;I++)i+=S;return i}function y(S,P){let i=0,I=0;const u=P.tabSize||4;for(;i<S.length;){const m=S.charAt(i);if(m===" ")I++;else if(m==="	")I+=u;else break;i++}return Math.floor(I/u)}function T(S,P){for(let i=0;i<P.length;i++){const I=P.charAt(i);if(I==="\r")return i+1<P.length&&P.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=T;function C(S,P){return`\r
`.indexOf(S.charAt(P))!==-1}e.isEOL=C}),define(me[138],ge([0,1,57,137]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(P,i,I){return y(P,i,void 0,I)}e.removeProperty=k;function y(P,i,I,u,m){const l=i.slice(),v=[],_=(0,g.parseTree)(P,v);let b,A;for(;l.length>0&&(A=l.pop(),b=(0,g.findNodeAtLocation)(_,l),b===void 0&&I!==void 0);)typeof A=="string"?I={[A]:I}:I=[I];if(b)if(b.type==="object"&&typeof A=="string"&&Array.isArray(b.children)){const c=(0,g.findNodeAtLocation)(b,[A]);if(c!==void 0)if(I===void 0){if(!c.parent)throw new Error("Malformed AST");const h=b.children.indexOf(c.parent);let p,t=c.parent.offset+c.parent.length;if(h>0){const r=b.children[h-1];p=r.offset+r.length}else p=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return T(P,{offset:p,length:t-p,content:""},u)}else return T(P,{offset:c.offset,length:c.length,content:JSON.stringify(I)},u);else{if(I===void 0)return[];const h=`${JSON.stringify(A)}: ${JSON.stringify(I)}`,p=m?m(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(p>0){const r=b.children[p-1];t={offset:r.offset+r.length,length:0,content:","+h}}else b.children.length===0?t={offset:b.offset+1,length:0,content:h}:t={offset:b.offset+1,length:0,content:h+","};return T(P,t,u)}}else if(b.type==="array"&&typeof A=="number"&&Array.isArray(b.children))if(I!==void 0){const c=`${JSON.stringify(I)}`;let h;if(b.children.length===0||A===0)h={offset:b.offset+1,length:0,content:b.children.length===0?c:c+","};else{const p=A===-1||A>b.children.length?b.children.length:A,t=b.children[p-1];h={offset:t.offset+t.length,length:0,content:","+c}}return T(P,h,u)}else{const c=A,h=b.children[c];let p;if(b.children.length===1)p={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===c){const t=b.children[c-1],r=t.offset+t.length,o=b.offset+b.length;p={offset:r,length:o-2-r,content:""}}else p={offset:h.offset,length:b.children[c+1].offset-h.offset,content:""};return T(P,p,u)}else throw new Error(`Can not add ${typeof A!="number"?"index":"property"} to parent of type ${b.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return T(P,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(I)},u)}}e.setProperty=y;function T(P,i,I){let u=C(P,i),m=i.offset,l=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;m>0&&!(0,L.isEOL)(u,m-1);)m--;for(;l<u.length&&!(0,L.isEOL)(u,l);)l++}const v=(0,L.format)(u,{offset:m,length:l-m},I);for(let b=v.length-1;b>=0;b--){const A=v[b];u=C(u,A),m=Math.min(m,A.offset),l=Math.max(l,A.offset+A.length),l+=A.content.length-A.length}const _=P.length-(u.length-l)-m;return[{offset:m,length:_,content:u.substring(m,l)}]}e.withFormatting=T;function C(P,i){return P.substring(0,i.offset)+i.content+P.substring(i.offset+i.length)}e.applyEdit=C;function S(P,i){let I=i.slice(0).sort((m,l)=>{const v=m.offset-l.offset;return v===0?m.length-l.length:v}),u=P.length;for(let m=I.length-1;m>=0;m--){let l=I[m];if(l.offset+l.length<=u)P=C(P,l);else throw new Error("Overlapping edit");u=l.offset}return P}e.applyEdits=S}),define(me[139],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new g(()=>k(this.getValue()))}}e.Lazy=g}),define(me[6],ge([0,1,72,74]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let y=null;function T(o){y=o}if(e.setDisposableTracker=T,k){const o="__is_disposable_tracked__";T(new class{trackDisposable(n){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[o]||console.log(a)},3e3)}setParent(n,a){if(n&&n!==A.None)try{n[o]=!0}catch{}}markAsDisposed(n){if(n&&n!==A.None)try{n[o]=!0}catch{}}markAsSingleton(n){}})}function C(o){return y?.trackDisposable(o),o}function S(o){y?.markAsDisposed(o)}function P(o,n){y?.setParent(o,n)}function i(o,n){if(!!y)for(const a of o)y.setParent(a,n)}function I(o){return y?.markAsSingleton(o),o}e.markAsSingleton=I;class u extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=u;function m(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=m;function l(o){if(L.Iterable.is(o)){let n=[];for(const a of o)if(a)try{a.dispose()}catch(f){n.push(f)}if(n.length===1)throw n[0];if(n.length>1)throw new u(n);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=l;function v(...o){const n=_(()=>l(o));return i(o,n),n}e.combinedDisposable=v;function _(o){const n=C({dispose:(0,g.once)(()=>{S(n),o()})});return n}e.toDisposable=_;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{l(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return P(n,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class A{constructor(){this._store=new b,C(this),P(this._store,this)}dispose(){S(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=A,A.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&P(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&P(n,null),n}}e.MutableDisposable=c;class h{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class p{constructor(){this.references=new Map}acquire(n,...a){let f=this.references.get(n);f||(f={counter:0,object:this.createReferencedObject(n,...a)},this.references.set(n,f));const{object:d}=f,w=(0,g.once)(()=>{--f.counter==0&&(this.destroyReferencedObject(n,f.object),this.references.delete(n))});return f.counter++,{object:d,dispose:w}}}e.ReferenceCollection=p;class t{constructor(n){this.referenceCollection=n}async acquire(n,...a){const f=this.referenceCollection.acquire(n,...a);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(d){throw f.dispose(),d}}}e.AsyncReferenceCollection=t;class r{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=r}),define(me[95],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(y){this.element=y,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class L{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let y=this._first;for(;y!==g.Undefined;){const T=y.next;y.prev=g.Undefined,y.next=g.Undefined,y=T}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,T){const C=new g(y);if(this._first===g.Undefined)this._first=C,this._last=C;else if(T){const P=this._last;this._last=C,C.prev=P,P.next=C}else{const P=this._first;this._first=C,C.next=P,P.prev=C}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(C))}}shift(){if(this._first!==g.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==g.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==g.Undefined&&y.next!==g.Undefined){const T=y.prev;T.next=y.next,y.next.prev=T}else y.prev===g.Undefined&&y.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):y.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):y.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==g.Undefined;)yield y.element,y=y.next}}e.LinkedList=L}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(Ce,De){for(var Te=0;Te<De.length;Te++){var ce=De[Te];ce.enumerable=ce.enumerable||!1,ce.configurable=!0,"value"in ce&&(ce.writable=!0),Object.defineProperty(Ce,ce.key,ce)}}function e(Ce,De,Te){return De&&J(Ce.prototype,De),Te&&J(Ce,Te),Ce}function g(Ce,De){if(!!Ce){if(typeof Ce=="string")return L(Ce,De);var Te=Object.prototype.toString.call(Ce).slice(8,-1);if(Te==="Object"&&Ce.constructor&&(Te=Ce.constructor.name),Te==="Map"||Te==="Set")return Array.from(Ce);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return L(Ce,De)}}function L(Ce,De){(De==null||De>Ce.length)&&(De=Ce.length);for(var Te=0,ce=new Array(De);Te<De;Te++)ce[Te]=Ce[Te];return ce}function k(Ce,De){var Te;if(typeof Symbol=="undefined"||Ce[Symbol.iterator]==null){if(Array.isArray(Ce)||(Te=g(Ce))||De&&Ce&&typeof Ce.length=="number"){Te&&(Ce=Te);var ce=0;return function(){return ce>=Ce.length?{done:!0}:{done:!1,value:Ce[ce++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Te=Ce[Symbol.iterator](),Te.next.bind(Te)}function y(Ce){var De={exports:{}};return Ce(De,De.exports),De.exports}var T=y(function(Ce){function De(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Te(ce){Ce.exports.defaults=ce}Ce.exports={defaults:De(),getDefaults:De,changeDefaults:Te}}),C=/[&<>"']/,S=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u=function(De){return I[De]};function m(Ce,De){if(De){if(C.test(Ce))return Ce.replace(S,u)}else if(P.test(Ce))return Ce.replace(i,u);return Ce}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Ce){return Ce.replace(l,function(De,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var _=/(^|[^\[])\^/g;function b(Ce,De){Ce=Ce.source||Ce,De=De||"";var Te={replace:function(ue,pe){return pe=pe.source||pe,pe=pe.replace(_,"$1"),Ce=Ce.replace(ue,pe),Te},getRegex:function(){return new RegExp(Ce,De)}};return Te}var A=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ce,De,Te){if(Ce){var ce;try{ce=decodeURIComponent(v(Te)).replace(A,"").toLowerCase()}catch(ue){return null}if(ce.indexOf("javascript:")===0||ce.indexOf("vbscript:")===0||ce.indexOf("data:")===0)return null}De&&!c.test(Te)&&(Te=n(De,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch(ue){return null}return Te}var p={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Ce,De){p[" "+Ce]||(t.test(Ce)?p[" "+Ce]=Ce+"/":p[" "+Ce]=w(Ce,"/",!0)),Ce=p[" "+Ce];var Te=Ce.indexOf(":")===-1;return De.substring(0,2)==="//"?Te?De:Ce.replace(r,"$1")+De:De.charAt(0)==="/"?Te?De:Ce.replace(o,"$1")+De:Ce+De}var a={exec:function(){}};function f(Ce){for(var De=1,Te,ce;De<arguments.length;De++){Te=arguments[De];for(ce in Te)Object.prototype.hasOwnProperty.call(Te,ce)&&(Ce[ce]=Te[ce])}return Ce}function d(Ce,De){var Te=Ce.replace(/\|/g,function(pe,be,j){for(var we=!1,_e=be;--_e>=0&&j[_e]==="\\";)we=!we;return we?"|":" |"}),ce=Te.split(/ \|/),ue=0;if(ce.length>De)ce.splice(De);else for(;ce.length<De;)ce.push("");for(;ue<ce.length;ue++)ce[ue]=ce[ue].trim().replace(/\\\|/g,"|");return ce}function w(Ce,De,Te){var ce=Ce.length;if(ce===0)return"";for(var ue=0;ue<ce;){var pe=Ce.charAt(ce-ue-1);if(pe===De&&!Te)ue++;else if(pe!==De&&Te)ue++;else break}return Ce.substr(0,ce-ue)}function E(Ce,De){if(Ce.indexOf(De[1])===-1)return-1;for(var Te=Ce.length,ce=0,ue=0;ue<Te;ue++)if(Ce[ue]==="\\")ue++;else if(Ce[ue]===De[0])ce++;else if(Ce[ue]===De[1]&&(ce--,ce<0))return ue;return-1}function s(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function D(Ce,De){if(De<1)return"";for(var Te="";De>1;)De&1&&(Te+=Ce),De>>=1,Ce+=Ce;return Te+Ce}var R={escape:m,unescape:v,edit:b,cleanUrl:h,resolveUrl:n,noopTest:a,merge:f,splitCells:d,rtrim:w,findClosingBracket:E,checkSanitizeDeprecation:s,repeatString:D},U=T.defaults,V=R.rtrim,ee=R.splitCells,K=R.escape,O=R.findClosingBracket;function x(Ce,De,Te){var ce=De.href,ue=De.title?K(De.title):null,pe=Ce[1].replace(/\\([\[\]])/g,"$1");return Ce[0].charAt(0)!=="!"?{type:"link",raw:Te,href:ce,title:ue,text:pe}:{type:"image",raw:Te,href:ce,title:ue,text:K(pe)}}function F(Ce,De){var Te=Ce.match(/^(\s+)(?:```)/);if(Te===null)return De;var ce=Te[1];return De.split(`
`).map(function(ue){var pe=ue.match(/^\s+/);if(pe===null)return ue;var be=pe[0];return be.length>=ce.length?ue.slice(ce.length):ue}).join(`
`)}var z=function(){function Ce(Te){this.options=Te||U}var De=Ce.prototype;return De.space=function(ce){var ue=this.rules.block.newline.exec(ce);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},De.code=function(ce){var ue=this.rules.block.code.exec(ce);if(ue){var pe=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:V(pe,`
`)}}},De.fences=function(ce){var ue=this.rules.block.fences.exec(ce);if(ue){var pe=ue[0],be=F(pe,ue[3]||"");return{type:"code",raw:pe,lang:ue[2]?ue[2].trim():ue[2],text:be}}},De.heading=function(ce){var ue=this.rules.block.heading.exec(ce);if(ue){var pe=ue[2].trim();if(/#$/.test(pe)){var be=V(pe,"#");(this.options.pedantic||!be||/ $/.test(be))&&(pe=be.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:pe}}},De.nptable=function(ce){var ue=this.rules.block.nptable.exec(ce);if(ue){var pe={type:"table",header:ee(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[],raw:ue[0]};if(pe.header.length===pe.align.length){var be=pe.align.length,j;for(j=0;j<be;j++)/^ *-+: *$/.test(pe.align[j])?pe.align[j]="right":/^ *:-+: *$/.test(pe.align[j])?pe.align[j]="center":/^ *:-+ *$/.test(pe.align[j])?pe.align[j]="left":pe.align[j]=null;for(be=pe.cells.length,j=0;j<be;j++)pe.cells[j]=ee(pe.cells[j],pe.header.length);return pe}}},De.hr=function(ce){var ue=this.rules.block.hr.exec(ce);if(ue)return{type:"hr",raw:ue[0]}},De.blockquote=function(ce){var ue=this.rules.block.blockquote.exec(ce);if(ue){var pe=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],text:pe}}},De.list=function(ce){var ue=this.rules.block.list.exec(ce);if(ue){var pe=ue[0],be=ue[2],j=be.length>1,we={type:"list",raw:pe,ordered:j,start:j?+be.slice(0,-1):"",loose:!1,items:[]},_e=ue[0].match(this.rules.block.item),Ae=!1,Ue,Ge,Ze,Qe,Xe,ct,mt,bt,ot=_e.length;Ze=this.rules.block.listItemStart.exec(_e[0]);for(var at=0;at<ot;at++){if(Ue=_e[at],pe=Ue,at!==ot-1){if(Qe=this.rules.block.listItemStart.exec(_e[at+1]),this.options.pedantic?Qe[1].length>Ze[1].length:Qe[1].length>Ze[0].length||Qe[1].length>3){_e.splice(at,2,_e[at]+`
`+_e[at+1]),at--,ot--;continue}else(!this.options.pedantic||this.options.smartLists?Qe[2][Qe[2].length-1]!==be[be.length-1]:j===(Qe[2].length===1))&&(Xe=_e.slice(at+1).join(`
`),we.raw=we.raw.substring(0,we.raw.length-Xe.length),at=ot-1);Ze=Qe}Ge=Ue.length,Ue=Ue.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ue.indexOf(`
 `)&&(Ge-=Ue.length,Ue=this.options.pedantic?Ue.replace(/^ {1,4}/gm,""):Ue.replace(new RegExp("^ {1,"+Ge+"}","gm"),"")),ct=Ae||/\n\n(?!\s*$)/.test(Ue),at!==ot-1&&(Ae=Ue.charAt(Ue.length-1)===`
`,ct||(ct=Ae)),ct&&(we.loose=!0),this.options.gfm&&(mt=/^\[[ xX]\] /.test(Ue),bt=void 0,mt&&(bt=Ue[1]!==" ",Ue=Ue.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:pe,task:mt,checked:bt,loose:ct,text:Ue})}return we}},De.html=function(ce){var ue=this.rules.block.html.exec(ce);if(ue)return{type:this.options.sanitize?"paragraph":"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):K(ue[0]):ue[0]}},De.def=function(ce){var ue=this.rules.block.def.exec(ce);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var pe=ue[1].toLowerCase().replace(/\s+/g," ");return{tag:pe,raw:ue[0],href:ue[2],title:ue[3]}}},De.table=function(ce){var ue=this.rules.block.table.exec(ce);if(ue){var pe={type:"table",header:ee(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=ue[0];var be=pe.align.length,j;for(j=0;j<be;j++)/^ *-+: *$/.test(pe.align[j])?pe.align[j]="right":/^ *:-+: *$/.test(pe.align[j])?pe.align[j]="center":/^ *:-+ *$/.test(pe.align[j])?pe.align[j]="left":pe.align[j]=null;for(be=pe.cells.length,j=0;j<be;j++)pe.cells[j]=ee(pe.cells[j].replace(/^ *\| *| *\| *$/g,""),pe.header.length);return pe}}},De.lheading=function(ce){var ue=this.rules.block.lheading.exec(ce);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1]}},De.paragraph=function(ce){var ue=this.rules.block.paragraph.exec(ce);if(ue)return{type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1]}},De.text=function(ce){var ue=this.rules.block.text.exec(ce);if(ue)return{type:"text",raw:ue[0],text:ue[0]}},De.escape=function(ce){var ue=this.rules.inline.escape.exec(ce);if(ue)return{type:"escape",raw:ue[0],text:K(ue[1])}},De.tag=function(ce,ue,pe){var be=this.rules.inline.tag.exec(ce);if(be)return!ue&&/^<a /i.test(be[0])?ue=!0:ue&&/^<\/a>/i.test(be[0])&&(ue=!1),!pe&&/^<(pre|code|kbd|script)(\s|>)/i.test(be[0])?pe=!0:pe&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(be[0])&&(pe=!1),{type:this.options.sanitize?"text":"html",raw:be[0],inLink:ue,inRawBlock:pe,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):K(be[0]):be[0]}},De.link=function(ce){var ue=this.rules.inline.link.exec(ce);if(ue){var pe=ue[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var be=V(pe.slice(0,-1),"\\");if((pe.length-be.length)%2==0)return}else{var j=O(ue[2],"()");if(j>-1){var we=ue[0].indexOf("!")===0?5:4,_e=we+ue[1].length+j;ue[2]=ue[2].substring(0,j),ue[0]=ue[0].substring(0,_e).trim(),ue[3]=""}}var Ae=ue[2],Ue="";if(this.options.pedantic){var Ge=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);Ge&&(Ae=Ge[1],Ue=Ge[3])}else Ue=ue[3]?ue[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(pe)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),x(ue,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},ue[0])}},De.reflink=function(ce,ue){var pe;if((pe=this.rules.inline.reflink.exec(ce))||(pe=this.rules.inline.nolink.exec(ce))){var be=(pe[2]||pe[1]).replace(/\s+/g," ");if(be=ue[be.toLowerCase()],!be||!be.href){var j=pe[0].charAt(0);return{type:"text",raw:j,text:j}}return x(pe,be,pe[0])}},De.emStrong=function(ce,ue,pe){pe===void 0&&(pe="");var be=this.rules.inline.emStrong.lDelim.exec(ce);if(!!be&&!(be[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=be[1]||be[2]||"";if(!j||j&&(pe===""||this.rules.inline.punctuation.exec(pe))){var we=be[0].length-1,_e,Ae,Ue=we,Ge=0,Ze=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ze.lastIndex=0,ue=ue.slice(-1*ce.length+we);(be=Ze.exec(ue))!=null;)if(_e=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!_e){if(Ae=_e.length,be[3]||be[4]){Ue+=Ae;continue}else if((be[5]||be[6])&&we%3&&!((we+Ae)%3)){Ge+=Ae;continue}if(Ue-=Ae,!(Ue>0)){if(Ue+Ge-Ae<=0&&!ue.slice(Ze.lastIndex).match(Ze)&&(Ae=Math.min(Ae,Ae+Ue+Ge)),Math.min(we,Ae)%2)return{type:"em",raw:ce.slice(0,we+be.index+Ae+1),text:ce.slice(1,we+be.index+Ae)};if(Math.min(we,Ae)%2==0)return{type:"strong",raw:ce.slice(0,we+be.index+Ae+1),text:ce.slice(2,we+be.index+Ae-1)}}}}}},De.codespan=function(ce){var ue=this.rules.inline.code.exec(ce);if(ue){var pe=ue[2].replace(/\n/g," "),be=/[^ ]/.test(pe),j=/^ /.test(pe)&&/ $/.test(pe);return be&&j&&(pe=pe.substring(1,pe.length-1)),pe=K(pe,!0),{type:"codespan",raw:ue[0],text:pe}}},De.br=function(ce){var ue=this.rules.inline.br.exec(ce);if(ue)return{type:"br",raw:ue[0]}},De.del=function(ce){var ue=this.rules.inline.del.exec(ce);if(ue)return{type:"del",raw:ue[0],text:ue[2]}},De.autolink=function(ce,ue){var pe=this.rules.inline.autolink.exec(ce);if(pe){var be,j;return pe[2]==="@"?(be=K(this.options.mangle?ue(pe[1]):pe[1]),j="mailto:"+be):(be=K(pe[1]),j=be),{type:"link",raw:pe[0],text:be,href:j,tokens:[{type:"text",raw:be,text:be}]}}},De.url=function(ce,ue){var pe;if(pe=this.rules.inline.url.exec(ce)){var be,j;if(pe[2]==="@")be=K(this.options.mangle?ue(pe[0]):pe[0]),j="mailto:"+be;else{var we;do we=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(we!==pe[0]);be=K(pe[0]),pe[1]==="www."?j="http://"+be:j=be}return{type:"link",raw:pe[0],text:be,href:j,tokens:[{type:"text",raw:be,text:be}]}}},De.inlineText=function(ce,ue,pe){var be=this.rules.inline.text.exec(ce);if(be){var j;return ue?j=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):K(be[0]):be[0]:j=K(this.options.smartypants?pe(be[0]):be[0]),{type:"text",raw:be[0],text:j}}},Ce}(),M=R.noopTest,N=R.edit,q=R.merge,B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=N(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,B.item=N(B.item,"gm").replace(/bull/g,B.bullet).getRegex(),B.listItemStart=N(/^( *)(bull)/).replace("bull",B.bullet).getRegex(),B.list=N(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=N(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=N(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.blockquote=N(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=q({},B),B.gfm=q({},B.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.nptable=N(B.gfm.nptable).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.gfm.table=N(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.pedantic=q({},B.normal,{html:N(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:N(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var G={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};G._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",G.punctuation=N(G.punctuation).replace(/punctuation/g,G._punctuation).getRegex(),G.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,G.escapedEmSt=/\\\*|\\_/g,G._comment=N(B._comment).replace("(?:-->|$)","-->").getRegex(),G.emStrong.lDelim=N(G.emStrong.lDelim).replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimAst=N(G.emStrong.rDelimAst,"g").replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimUnd=N(G.emStrong.rDelimUnd,"g").replace(/punct/g,G._punctuation).getRegex(),G._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,G._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,G._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,G.autolink=N(G.autolink).replace("scheme",G._scheme).replace("email",G._email).getRegex(),G._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,G.tag=N(G.tag).replace("comment",G._comment).replace("attribute",G._attribute).getRegex(),G._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,G._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,G._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,G.link=N(G.link).replace("label",G._label).replace("href",G._href).replace("title",G._title).getRegex(),G.reflink=N(G.reflink).replace("label",G._label).getRegex(),G.reflinkSearch=N(G.reflinkSearch,"g").replace("reflink",G.reflink).replace("nolink",G.nolink).getRegex(),G.normal=q({},G),G.pedantic=q({},G.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:N(/^!?\[(label)\]\((.*?)\)/).replace("label",G._label).getRegex(),reflink:N(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",G._label).getRegex()}),G.gfm=q({},G.normal,{escape:N(G.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),G.gfm.url=N(G.gfm.url,"i").replace("email",G.gfm._extended_email).getRegex(),G.breaks=q({},G.gfm,{br:N(G.br).replace("{2,}","*").getRegex(),text:N(G.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var re={block:B,inline:G},he=T.defaults,ye=re.block,Ie=re.inline,Le=R.repeatString;function qe(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function We(Ce){var De="",Te,ce,ue=Ce.length;for(Te=0;Te<ue;Te++)ce=Ce.charCodeAt(Te),Math.random()>.5&&(ce="x"+ce.toString(16)),De+="&#"+ce+";";return De}var je=function(){function Ce(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||he,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ce={block:ye.normal,inline:Ie.normal};this.options.pedantic?(ce.block=ye.pedantic,ce.inline=Ie.pedantic):this.options.gfm&&(ce.block=ye.gfm,this.options.breaks?ce.inline=Ie.breaks:ce.inline=Ie.gfm),this.tokenizer.rules=ce}Ce.lex=function(ce,ue){var pe=new Ce(ue);return pe.lex(ce)},Ce.lexInline=function(ce,ue){var pe=new Ce(ue);return pe.inlineTokens(ce)};var De=Ce.prototype;return De.lex=function(ce){return ce=ce.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ce,this.tokens,!0),this.inline(this.tokens),this.tokens},De.blockTokens=function(ce,ue,pe){ue===void 0&&(ue=[]),pe===void 0&&(pe=!0),this.options.pedantic&&(ce=ce.replace(/^ +$/gm,""));for(var be,j,we,_e;ce;){if(be=this.tokenizer.space(ce)){ce=ce.substring(be.raw.length),be.type&&ue.push(be);continue}if(be=this.tokenizer.code(ce)){ce=ce.substring(be.raw.length),_e=ue[ue.length-1],_e&&_e.type==="paragraph"?(_e.raw+=`
`+be.raw,_e.text+=`
`+be.text):ue.push(be);continue}if(be=this.tokenizer.fences(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.heading(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.nptable(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.hr(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.blockquote(ce)){ce=ce.substring(be.raw.length),be.tokens=this.blockTokens(be.text,[],pe),ue.push(be);continue}if(be=this.tokenizer.list(ce)){for(ce=ce.substring(be.raw.length),we=be.items.length,j=0;j<we;j++)be.items[j].tokens=this.blockTokens(be.items[j].text,[],!1);ue.push(be);continue}if(be=this.tokenizer.html(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(pe&&(be=this.tokenizer.def(ce))){ce=ce.substring(be.raw.length),this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.lheading(ce)){ce=ce.substring(be.raw.length),ue.push(be);continue}if(pe&&(be=this.tokenizer.paragraph(ce))){ce=ce.substring(be.raw.length),ue.push(be);continue}if(be=this.tokenizer.text(ce)){ce=ce.substring(be.raw.length),_e=ue[ue.length-1],_e&&_e.type==="text"?(_e.raw+=`
`+be.raw,_e.text+=`
`+be.text):ue.push(be);continue}if(ce){var Ae="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return ue},De.inline=function(ce){var ue,pe,be,j,we,_e,Ae=ce.length;for(ue=0;ue<Ae;ue++)switch(_e=ce[ue],_e.type){case"paragraph":case"text":case"heading":{_e.tokens=[],this.inlineTokens(_e.text,_e.tokens);break}case"table":{for(_e.tokens={header:[],cells:[]},j=_e.header.length,pe=0;pe<j;pe++)_e.tokens.header[pe]=[],this.inlineTokens(_e.header[pe],_e.tokens.header[pe]);for(j=_e.cells.length,pe=0;pe<j;pe++)for(we=_e.cells[pe],_e.tokens.cells[pe]=[],be=0;be<we.length;be++)_e.tokens.cells[pe][be]=[],this.inlineTokens(we[be],_e.tokens.cells[pe][be]);break}case"blockquote":{this.inline(_e.tokens);break}case"list":{for(j=_e.items.length,pe=0;pe<j;pe++)this.inline(_e.items[pe].tokens);break}}return ce},De.inlineTokens=function(ce,ue,pe,be){ue===void 0&&(ue=[]),pe===void 0&&(pe=!1),be===void 0&&(be=!1);var j,we,_e=ce,Ae,Ue,Ge;if(this.tokens.links){var Ze=Object.keys(this.tokens.links);if(Ze.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(_e))!=null;)Ze.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(_e=_e.slice(0,Ae.index)+"["+Le("a",Ae[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(_e))!=null;)_e=_e.slice(0,Ae.index)+"["+Le("a",Ae[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(_e))!=null;)_e=_e.slice(0,Ae.index)+"++"+_e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ce;){if(Ue||(Ge=""),Ue=!1,j=this.tokenizer.escape(ce)){ce=ce.substring(j.raw.length),ue.push(j);continue}if(j=this.tokenizer.tag(ce,pe,be)){ce=ce.substring(j.raw.length),pe=j.inLink,be=j.inRawBlock;var Qe=ue[ue.length-1];Qe&&j.type==="text"&&Qe.type==="text"?(Qe.raw+=j.raw,Qe.text+=j.text):ue.push(j);continue}if(j=this.tokenizer.link(ce)){ce=ce.substring(j.raw.length),j.type==="link"&&(j.tokens=this.inlineTokens(j.text,[],!0,be)),ue.push(j);continue}if(j=this.tokenizer.reflink(ce,this.tokens.links)){ce=ce.substring(j.raw.length);var Xe=ue[ue.length-1];j.type==="link"?(j.tokens=this.inlineTokens(j.text,[],!0,be),ue.push(j)):Xe&&j.type==="text"&&Xe.type==="text"?(Xe.raw+=j.raw,Xe.text+=j.text):ue.push(j);continue}if(j=this.tokenizer.emStrong(ce,_e,Ge)){ce=ce.substring(j.raw.length),j.tokens=this.inlineTokens(j.text,[],pe,be),ue.push(j);continue}if(j=this.tokenizer.codespan(ce)){ce=ce.substring(j.raw.length),ue.push(j);continue}if(j=this.tokenizer.br(ce)){ce=ce.substring(j.raw.length),ue.push(j);continue}if(j=this.tokenizer.del(ce)){ce=ce.substring(j.raw.length),j.tokens=this.inlineTokens(j.text,[],pe,be),ue.push(j);continue}if(j=this.tokenizer.autolink(ce,We)){ce=ce.substring(j.raw.length),ue.push(j);continue}if(!pe&&(j=this.tokenizer.url(ce,We))){ce=ce.substring(j.raw.length),ue.push(j);continue}if(j=this.tokenizer.inlineText(ce,be,qe)){ce=ce.substring(j.raw.length),j.raw.slice(-1)!=="_"&&(Ge=j.raw.slice(-1)),Ue=!0,we=ue[ue.length-1],we&&we.type==="text"?(we.raw+=j.raw,we.text+=j.text):ue.push(j);continue}if(ce){var ct="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(ct);break}else throw new Error(ct)}}return ue},e(Ce,null,[{key:"rules",get:function(){return{block:ye,inline:Ie}}}]),Ce}(),W=T.defaults,Z=R.cleanUrl,ne=R.escape,le=function(){function Ce(Te){this.options=Te||W}var De=Ce.prototype;return De.code=function(ce,ue,pe){var be=(ue||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(ce,be);j!=null&&j!==ce&&(pe=!0,ce=j)}return ce=ce.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+ne(be,!0)+'">'+(pe?ce:ne(ce,!0))+`</code></pre>
`:"<pre><code>"+(pe?ce:ne(ce,!0))+`</code></pre>
`},De.blockquote=function(ce){return`<blockquote>
`+ce+`</blockquote>
`},De.html=function(ce){return ce},De.heading=function(ce,ue,pe,be){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+be.slug(pe)+'">'+ce+"</h"+ue+`>
`:"<h"+ue+">"+ce+"</h"+ue+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(ce,ue,pe){var be=ue?"ol":"ul",j=ue&&pe!==1?' start="'+pe+'"':"";return"<"+be+j+`>
`+ce+"</"+be+`>
`},De.listitem=function(ce){return"<li>"+ce+`</li>
`},De.checkbox=function(ce){return"<input "+(ce?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(ce){return"<p>"+ce+`</p>
`},De.table=function(ce,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ce+`</thead>
`+ue+`</table>
`},De.tablerow=function(ce){return`<tr>
`+ce+`</tr>
`},De.tablecell=function(ce,ue){var pe=ue.header?"th":"td",be=ue.align?"<"+pe+' align="'+ue.align+'">':"<"+pe+">";return be+ce+"</"+pe+`>
`},De.strong=function(ce){return"<strong>"+ce+"</strong>"},De.em=function(ce){return"<em>"+ce+"</em>"},De.codespan=function(ce){return"<code>"+ce+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(ce){return"<del>"+ce+"</del>"},De.link=function(ce,ue,pe){if(ce=Z(this.options.sanitize,this.options.baseUrl,ce),ce===null)return pe;var be='<a href="'+ne(ce)+'"';return ue&&(be+=' title="'+ue+'"'),be+=">"+pe+"</a>",be},De.image=function(ce,ue,pe){if(ce=Z(this.options.sanitize,this.options.baseUrl,ce),ce===null)return pe;var be='<img src="'+ce+'" alt="'+pe+'"';return ue&&(be+=' title="'+ue+'"'),be+=this.options.xhtml?"/>":">",be},De.text=function(ce){return ce},Ce}(),Y=function(){function Ce(){}var De=Ce.prototype;return De.strong=function(ce){return ce},De.em=function(ce){return ce},De.codespan=function(ce){return ce},De.del=function(ce){return ce},De.html=function(ce){return ce},De.text=function(ce){return ce},De.link=function(ce,ue,pe){return""+pe},De.image=function(ce,ue,pe){return""+pe},De.br=function(){return""},Ce}(),ae=function(){function Ce(){this.seen={}}var De=Ce.prototype;return De.serialize=function(ce){return ce.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(ce,ue){var pe=ce,be=0;if(this.seen.hasOwnProperty(pe)){be=this.seen[ce];do be++,pe=ce+"-"+be;while(this.seen.hasOwnProperty(pe))}return ue||(this.seen[ce]=be,this.seen[pe]=0),pe},De.slug=function(ce,ue){ue===void 0&&(ue={});var pe=this.serialize(ce);return this.getNextSafeSlug(pe,ue.dryrun)},Ce}(),ve=T.defaults,Me=R.unescape,ze=function(){function Ce(Te){this.options=Te||ve,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new ae}Ce.parse=function(ce,ue){var pe=new Ce(ue);return pe.parse(ce)},Ce.parseInline=function(ce,ue){var pe=new Ce(ue);return pe.parseInline(ce)};var De=Ce.prototype;return De.parse=function(ce,ue){ue===void 0&&(ue=!0);var pe="",be,j,we,_e,Ae,Ue,Ge,Ze,Qe,Xe,ct,mt,bt,ot,at,Se,Pe,te,Q=ce.length;for(be=0;be<Q;be++)switch(Xe=ce[be],Xe.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(Xe.tokens),Xe.depth,Me(this.parseInline(Xe.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(Xe.text,Xe.lang,Xe.escaped);continue}case"table":{for(Ze="",Ge="",_e=Xe.header.length,j=0;j<_e;j++)Ge+=this.renderer.tablecell(this.parseInline(Xe.tokens.header[j]),{header:!0,align:Xe.align[j]});for(Ze+=this.renderer.tablerow(Ge),Qe="",_e=Xe.cells.length,j=0;j<_e;j++){for(Ue=Xe.tokens.cells[j],Ge="",Ae=Ue.length,we=0;we<Ae;we++)Ge+=this.renderer.tablecell(this.parseInline(Ue[we]),{header:!1,align:Xe.align[we]});Qe+=this.renderer.tablerow(Ge)}pe+=this.renderer.table(Ze,Qe);continue}case"blockquote":{Qe=this.parse(Xe.tokens),pe+=this.renderer.blockquote(Qe);continue}case"list":{for(ct=Xe.ordered,mt=Xe.start,bt=Xe.loose,_e=Xe.items.length,Qe="",j=0;j<_e;j++)at=Xe.items[j],Se=at.checked,Pe=at.task,ot="",at.task&&(te=this.renderer.checkbox(Se),bt?at.tokens.length>0&&at.tokens[0].type==="text"?(at.tokens[0].text=te+" "+at.tokens[0].text,at.tokens[0].tokens&&at.tokens[0].tokens.length>0&&at.tokens[0].tokens[0].type==="text"&&(at.tokens[0].tokens[0].text=te+" "+at.tokens[0].tokens[0].text)):at.tokens.unshift({type:"text",text:te}):ot+=te),ot+=this.parse(at.tokens,bt),Qe+=this.renderer.listitem(ot,Pe,Se);pe+=this.renderer.list(Qe,ct,mt);continue}case"html":{pe+=this.renderer.html(Xe.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(Xe.tokens));continue}case"text":{for(Qe=Xe.tokens?this.parseInline(Xe.tokens):Xe.text;be+1<Q&&ce[be+1].type==="text";)Xe=ce[++be],Qe+=`
`+(Xe.tokens?this.parseInline(Xe.tokens):Xe.text);pe+=ue?this.renderer.paragraph(Qe):Qe;continue}default:{var Oe='Token with "'+Xe.type+'" type was not found.';if(this.options.silent){console.error(Oe);return}else throw new Error(Oe)}}return pe},De.parseInline=function(ce,ue){ue=ue||this.renderer;var pe="",be,j,we=ce.length;for(be=0;be<we;be++)switch(j=ce[be],j.type){case"escape":{pe+=ue.text(j.text);break}case"html":{pe+=ue.html(j.text);break}case"link":{pe+=ue.link(j.href,j.title,this.parseInline(j.tokens,ue));break}case"image":{pe+=ue.image(j.href,j.title,j.text);break}case"strong":{pe+=ue.strong(this.parseInline(j.tokens,ue));break}case"em":{pe+=ue.em(this.parseInline(j.tokens,ue));break}case"codespan":{pe+=ue.codespan(j.text);break}case"br":{pe+=ue.br();break}case"del":{pe+=ue.del(this.parseInline(j.tokens,ue));break}case"text":{pe+=ue.text(j.text);break}default:{var _e='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(_e);return}else throw new Error(_e)}}return pe},Ce}(),Ee=R.merge,Je=R.checkSanitizeDeprecation,X=R.escape,se=T.getDefaults,fe=T.changeDefaults,xe=T.defaults;function Be(Ce,De,Te){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof De=="function"&&(Te=De,De=null),De=Ee({},Be.defaults,De||{}),Je(De),Te){var ce=De.highlight,ue;try{ue=je.lex(Ce,De)}catch(we){return Te(we)}var pe=function(_e){var Ae;if(!_e)try{Ae=ze.parse(ue,De)}catch(Ue){_e=Ue}return De.highlight=ce,_e?Te(_e):Te(null,Ae)};if(!ce||ce.length<3||(delete De.highlight,!ue.length))return pe();var be=0;Be.walkTokens(ue,function(we){we.type==="code"&&(be++,setTimeout(function(){ce(we.text,we.lang,function(_e,Ae){if(_e)return pe(_e);Ae!=null&&Ae!==we.text&&(we.text=Ae,we.escaped=!0),be--,be===0&&pe()})},0))}),be===0&&pe();return}try{var j=je.lex(Ce,De);return De.walkTokens&&Be.walkTokens(j,De.walkTokens),ze.parse(j,De)}catch(we){if(we.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+X(we.message+"",!0)+"</pre>";throw we}}Be.options=Be.setOptions=function(Ce){return Ee(Be.defaults,Ce),fe(Be.defaults),Be},Be.getDefaults=se,Be.defaults=xe,Be.use=function(Ce){var De=Ee({},Ce);if(Ce.renderer&&function(){var ce=Be.defaults.renderer||new le,ue=function(j){var we=ce[j];ce[j]=function(){for(var _e=arguments.length,Ae=new Array(_e),Ue=0;Ue<_e;Ue++)Ae[Ue]=arguments[Ue];var Ge=Ce.renderer[j].apply(ce,Ae);return Ge===!1&&(Ge=we.apply(ce,Ae)),Ge}};for(var pe in Ce.renderer)ue(pe);De.renderer=ce}(),Ce.tokenizer&&function(){var ce=Be.defaults.tokenizer||new z,ue=function(j){var we=ce[j];ce[j]=function(){for(var _e=arguments.length,Ae=new Array(_e),Ue=0;Ue<_e;Ue++)Ae[Ue]=arguments[Ue];var Ge=Ce.tokenizer[j].apply(ce,Ae);return Ge===!1&&(Ge=we.apply(ce,Ae)),Ge}};for(var pe in Ce.tokenizer)ue(pe);De.tokenizer=ce}(),Ce.walkTokens){var Te=Be.defaults.walkTokens;De.walkTokens=function(ce){Ce.walkTokens(ce),Te&&Te(ce)}}Be.setOptions(De)},Be.walkTokens=function(Ce,De){for(var Te=k(Ce),ce;!(ce=Te()).done;){var ue=ce.value;switch(De(ue),ue.type){case"table":{for(var pe=k(ue.tokens.header),be;!(be=pe()).done;){var j=be.value;Be.walkTokens(j,De)}for(var we=k(ue.tokens.cells),_e;!(_e=we()).done;)for(var Ae=_e.value,Ue=k(Ae),Ge;!(Ge=Ue()).done;){var Ze=Ge.value;Be.walkTokens(Ze,De)}break}case"list":{Be.walkTokens(ue.items,De);break}default:ue.tokens&&Be.walkTokens(ue.tokens,De)}}},Be.parseInline=function(Ce,De){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");De=Ee({},Be.defaults,De||{}),Je(De);try{var Te=je.lexInline(Ce,De);return De.walkTokens&&Be.walkTokens(Te,De.walkTokens),ze.parseInline(Te,De)}catch(ce){if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+X(ce.message+"",!0)+"</pre>";throw ce}},Be.Parser=ze,Be.parser=ze.parse,Be.Renderer=le,Be.TextRenderer=Y,Be.Lexer=je,Be.lexer=je.lex,Be.Tokenizer=z,Be.Slugger=ae,Be.parse=Be;var et=Be;return et}),define(me[75],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(T,C,S){return Math.min(Math.max(T,C),S)}e.clamp=g;function L(T,C){return(C+T%C)%C}e.rot=L;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class y{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function J(k){const y=[];typeof k=="number"&&y.push("code/timeOrigin",k);function T(S){y.push(S,Date.now())}function C(){const S=[];for(let P=0;P<y.length;P+=2)S.push({name:y[P],startTime:y[P+1]});return S}return{mark:T,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))y.push({name:T.name,startTime:Math.round(k+T.startTime)});return y}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function g(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=g(L))}(),define(me[11],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let L=!1,k=!1,y=!1,T=!1,C=!1,S=!1,P=!1,i,I=g,u,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?l=e.globals.vscode.process:typeof process!="undefined"&&(l=process);const v=typeof l?.versions?.electron=="string"&&l.type==="renderer";if(e.isElectronSandboxed=v&&l?.sandboxed,typeof navigator=="object"&&!v)m=navigator.userAgent,L=m.indexOf("Windows")>=0,k=m.indexOf("Macintosh")>=0,P=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=m.indexOf("Linux")>=0,S=!0,i=navigator.language,I=i;else if(typeof l=="object"){L=l.platform==="win32",k=l.platform==="darwin",y=l.platform==="linux",T=y&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,i=g,I=g;const o=l.env.VSCODE_NLS_CONFIG;if(o)try{const n=JSON.parse(o),a=n.availableLanguages["*"];i=n.locale,I=a||g,u=n._translationsConfigFile}catch(n){}C=!0}else console.error("Unable to resolve platform.");var _;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(_=e.Platform||(e.Platform={}));function b(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let A=0;k?A=1:L?A=3:y&&(A=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=y,e.isLinuxSnap=T,e.isNative=C,e.isWeb=S,e.isIOS=P,e.platform=A,e.userAgent=m,e.language=I;var c;(function(o){function n(){return e.language}o.value=n;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=a;function f(){return e.language==="en"}o.isDefault=f})(c=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=u,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let w=0,E=a.length;w<E;w++){const s=a[w];if(s.id===d.data.vscodeSetImmediateId){a.splice(w,1),s.callback();return}}});let f=0;return d=>{const w=++f;a.push({id:w,callback:d}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof l?.nextTick=="function")return l.nextTick.bind(l);const n=Promise.resolve();return a=>n.then(a)}();var h;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(h=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||P?2:L?1:3;let p=!0,t=!1;function r(){if(!t){t=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,p=new Uint16Array(o.buffer)[0]===(2<<8)+1}return p}e.isLittleEndian=r}),define(me[38],ge([0,1,11]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const k=g.globals.vscode.process;L={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(y){return(0,g.setImmediate)(y)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(k){return(0,g.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(me[9],ge([0,1,38]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,y=90,T=122,C=46,S=47,P=92,i=58,I=63;class u extends Error{constructor(h,p,t){let r;typeof p=="string"&&p.indexOf("not ")===0?(r="must not be",p=p.replace(/^not /,"")):r="must be";const o=h.indexOf(".")!==-1?"property":"argument";let n=`The "${h}" ${o} ${r} of type ${p}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function m(c,h){if(typeof c!="string")throw new u(h,"string",c)}function l(c){return c===S||c===P}function v(c){return c===S}function _(c){return c>=L&&c<=y||c>=k&&c<=T}function b(c,h,p,t){let r="",o=0,n=-1,a=0,f=0;for(let d=0;d<=c.length;++d){if(d<c.length)f=c.charCodeAt(d);else{if(t(f))break;f=S}if(t(f)){if(!(n===d-1||a===1))if(a===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==C||r.charCodeAt(r.length-2)!==C){if(r.length>2){const w=r.lastIndexOf(p);w===-1?(r="",o=0):(r=r.slice(0,w),o=r.length-1-r.lastIndexOf(p)),n=d,a=0;continue}else if(r.length!==0){r="",o=0,n=d,a=0;continue}}h&&(r+=r.length>0?`${p}..`:"..",o=2)}else r.length>0?r+=`${p}${c.slice(n+1,d)}`:r=c.slice(n+1,d),o=d-n-1;n=d,a=0}else f===C&&a!==-1?++a:a=-1}return r}function A(c,h){if(h===null||typeof h!="object")throw new u("pathObject","Object",h);const p=h.dir||h.root,t=h.base||`${h.name||""}${h.ext||""}`;return p?p===h.root?`${p}${t}`:`${p}${c}${t}`:t}e.win32={resolve(...c){let h="",p="",t=!1;for(let r=c.length-1;r>=-1;r--){let o;if(r>=0){if(o=c[r],m(o,"path"),o.length===0)continue}else h.length===0?o=g.cwd():(o=g.env[`=${h}`]||g.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==h.toLowerCase()&&o.charCodeAt(2)===P)&&(o=`${h}\\`));const n=o.length;let a=0,f="",d=!1;const w=o.charCodeAt(0);if(n===1)l(w)&&(a=1,d=!0);else if(l(w))if(d=!0,l(o.charCodeAt(1))){let E=2,s=E;for(;E<n&&!l(o.charCodeAt(E));)E++;if(E<n&&E!==s){const D=o.slice(s,E);for(s=E;E<n&&l(o.charCodeAt(E));)E++;if(E<n&&E!==s){for(s=E;E<n&&!l(o.charCodeAt(E));)E++;(E===n||E!==s)&&(f=`\\\\${D}\\${o.slice(s,E)}`,a=E)}}}else a=1;else _(w)&&o.charCodeAt(1)===i&&(f=o.slice(0,2),a=2,n>2&&l(o.charCodeAt(2))&&(d=!0,a=3));if(f.length>0)if(h.length>0){if(f.toLowerCase()!==h.toLowerCase())continue}else h=f;if(t){if(h.length>0)break}else if(p=`${o.slice(a)}\\${p}`,t=d,d&&h.length>0)break}return p=b(p,!t,"\\",l),t?`${h}\\${p}`:`${h}${p}`||"."},normalize(c){m(c,"path");const h=c.length;if(h===0)return".";let p=0,t,r=!1;const o=c.charCodeAt(0);if(h===1)return v(o)?"\\":c;if(l(o))if(r=!0,l(c.charCodeAt(1))){let a=2,f=a;for(;a<h&&!l(c.charCodeAt(a));)a++;if(a<h&&a!==f){const d=c.slice(f,a);for(f=a;a<h&&l(c.charCodeAt(a));)a++;if(a<h&&a!==f){for(f=a;a<h&&!l(c.charCodeAt(a));)a++;if(a===h)return`\\\\${d}\\${c.slice(f)}\\`;a!==f&&(t=`\\\\${d}\\${c.slice(f,a)}`,p=a)}}}else p=1;else _(o)&&c.charCodeAt(1)===i&&(t=c.slice(0,2),p=2,h>2&&l(c.charCodeAt(2))&&(r=!0,p=3));let n=p<h?b(c.slice(p),!r,"\\",l):"";return n.length===0&&!r&&(n="."),n.length>0&&l(c.charCodeAt(h-1))&&(n+="\\"),t===void 0?r?`\\${n}`:n:r?`${t}\\${n}`:`${t}${n}`},isAbsolute(c){m(c,"path");const h=c.length;if(h===0)return!1;const p=c.charCodeAt(0);return l(p)||h>2&&_(p)&&c.charCodeAt(1)===i&&l(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let h,p;for(let o=0;o<c.length;++o){const n=c[o];m(n,"path"),n.length>0&&(h===void 0?h=p=n:h+=`\\${n}`)}if(h===void 0)return".";let t=!0,r=0;if(typeof p=="string"&&l(p.charCodeAt(0))){++r;const o=p.length;o>1&&l(p.charCodeAt(1))&&(++r,o>2&&(l(p.charCodeAt(2))?++r:t=!1))}if(t){for(;r<h.length&&l(h.charCodeAt(r));)r++;r>=2&&(h=`\\${h.slice(r)}`)}return e.win32.normalize(h)},relative(c,h){if(m(c,"from"),m(h,"to"),c===h)return"";const p=e.win32.resolve(c),t=e.win32.resolve(h);if(p===t||(c=p.toLowerCase(),h=t.toLowerCase(),c===h))return"";let r=0;for(;r<c.length&&c.charCodeAt(r)===P;)r++;let o=c.length;for(;o-1>r&&c.charCodeAt(o-1)===P;)o--;const n=o-r;let a=0;for(;a<h.length&&h.charCodeAt(a)===P;)a++;let f=h.length;for(;f-1>a&&h.charCodeAt(f-1)===P;)f--;const d=f-a,w=n<d?n:d;let E=-1,s=0;for(;s<w;s++){const R=c.charCodeAt(r+s);if(R!==h.charCodeAt(a+s))break;R===P&&(E=s)}if(s!==w){if(E===-1)return t}else{if(d>w){if(h.charCodeAt(a+s)===P)return t.slice(a+s+1);if(s===2)return t.slice(a+s)}n>w&&(c.charCodeAt(r+s)===P?E=s:s===2&&(E=3)),E===-1&&(E=0)}let D="";for(s=r+E+1;s<=o;++s)(s===o||c.charCodeAt(s)===P)&&(D+=D.length===0?"..":"\\..");return a+=E,D.length>0?`${D}${t.slice(a,f)}`:(t.charCodeAt(a)===P&&++a,t.slice(a,f))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const h=e.win32.resolve(c);if(h.length<=2)return c;if(h.charCodeAt(0)===P){if(h.charCodeAt(1)===P){const p=h.charCodeAt(2);if(p!==I&&p!==C)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(_(h.charCodeAt(0))&&h.charCodeAt(1)===i&&h.charCodeAt(2)===P)return`\\\\?\\${h}`;return c},dirname(c){m(c,"path");const h=c.length;if(h===0)return".";let p=-1,t=0;const r=c.charCodeAt(0);if(h===1)return l(r)?c:".";if(l(r)){if(p=t=1,l(c.charCodeAt(1))){let a=2,f=a;for(;a<h&&!l(c.charCodeAt(a));)a++;if(a<h&&a!==f){for(f=a;a<h&&l(c.charCodeAt(a));)a++;if(a<h&&a!==f){for(f=a;a<h&&!l(c.charCodeAt(a));)a++;if(a===h)return c;a!==f&&(p=t=a+1)}}}}else _(r)&&c.charCodeAt(1)===i&&(p=h>2&&l(c.charCodeAt(2))?3:2,t=p);let o=-1,n=!0;for(let a=h-1;a>=t;--a)if(l(c.charCodeAt(a))){if(!n){o=a;break}}else n=!1;if(o===-1){if(p===-1)return".";o=p}return c.slice(0,o)},basename(c,h){h!==void 0&&m(h,"ext"),m(c,"path");let p=0,t=-1,r=!0,o;if(c.length>=2&&_(c.charCodeAt(0))&&c.charCodeAt(1)===i&&(p=2),h!==void 0&&h.length>0&&h.length<=c.length){if(h===c)return"";let n=h.length-1,a=-1;for(o=c.length-1;o>=p;--o){const f=c.charCodeAt(o);if(l(f)){if(!r){p=o+1;break}}else a===-1&&(r=!1,a=o+1),n>=0&&(f===h.charCodeAt(n)?--n==-1&&(t=o):(n=-1,t=a))}return p===t?t=a:t===-1&&(t=c.length),c.slice(p,t)}for(o=c.length-1;o>=p;--o)if(l(c.charCodeAt(o))){if(!r){p=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":c.slice(p,t)},extname(c){m(c,"path");let h=0,p=-1,t=0,r=-1,o=!0,n=0;c.length>=2&&c.charCodeAt(1)===i&&_(c.charCodeAt(0))&&(h=t=2);for(let a=c.length-1;a>=h;--a){const f=c.charCodeAt(a);if(l(f)){if(!o){t=a+1;break}continue}r===-1&&(o=!1,r=a+1),f===C?p===-1?p=a:n!==1&&(n=1):p!==-1&&(n=-1)}return p===-1||r===-1||n===0||n===1&&p===r-1&&p===t+1?"":c.slice(p,r)},format:A.bind(null,"\\"),parse(c){m(c,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return h;const p=c.length;let t=0,r=c.charCodeAt(0);if(p===1)return l(r)?(h.root=h.dir=c,h):(h.base=h.name=c,h);if(l(r)){if(t=1,l(c.charCodeAt(1))){let E=2,s=E;for(;E<p&&!l(c.charCodeAt(E));)E++;if(E<p&&E!==s){for(s=E;E<p&&l(c.charCodeAt(E));)E++;if(E<p&&E!==s){for(s=E;E<p&&!l(c.charCodeAt(E));)E++;E===p?t=E:E!==s&&(t=E+1)}}}}else if(_(r)&&c.charCodeAt(1)===i){if(p<=2)return h.root=h.dir=c,h;if(t=2,l(c.charCodeAt(2))){if(p===3)return h.root=h.dir=c,h;t=3}}t>0&&(h.root=c.slice(0,t));let o=-1,n=t,a=-1,f=!0,d=c.length-1,w=0;for(;d>=t;--d){if(r=c.charCodeAt(d),l(r)){if(!f){n=d+1;break}continue}a===-1&&(f=!1,a=d+1),r===C?o===-1?o=d:w!==1&&(w=1):o!==-1&&(w=-1)}return a!==-1&&(o===-1||w===0||w===1&&o===a-1&&o===n+1?h.base=h.name=c.slice(n,a):(h.name=c.slice(n,o),h.base=c.slice(n,a),h.ext=c.slice(o,a))),n>0&&n!==t?h.dir=c.slice(0,n-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let h="",p=!1;for(let t=c.length-1;t>=-1&&!p;t--){const r=t>=0?c[t]:g.cwd();m(r,"path"),r.length!==0&&(h=`${r}/${h}`,p=r.charCodeAt(0)===S)}return h=b(h,!p,"/",v),p?`/${h}`:h.length>0?h:"."},normalize(c){if(m(c,"path"),c.length===0)return".";const h=c.charCodeAt(0)===S,p=c.charCodeAt(c.length-1)===S;return c=b(c,!h,"/",v),c.length===0?h?"/":p?"./":".":(p&&(c+="/"),h?`/${c}`:c)},isAbsolute(c){return m(c,"path"),c.length>0&&c.charCodeAt(0)===S},join(...c){if(c.length===0)return".";let h;for(let p=0;p<c.length;++p){const t=c[p];m(t,"path"),t.length>0&&(h===void 0?h=t:h+=`/${t}`)}return h===void 0?".":e.posix.normalize(h)},relative(c,h){if(m(c,"from"),m(h,"to"),c===h||(c=e.posix.resolve(c),h=e.posix.resolve(h),c===h))return"";const p=1,t=c.length,r=t-p,o=1,n=h.length-o,a=r<n?r:n;let f=-1,d=0;for(;d<a;d++){const E=c.charCodeAt(p+d);if(E!==h.charCodeAt(o+d))break;E===S&&(f=d)}if(d===a)if(n>a){if(h.charCodeAt(o+d)===S)return h.slice(o+d+1);if(d===0)return h.slice(o+d)}else r>a&&(c.charCodeAt(p+d)===S?f=d:d===0&&(f=0));let w="";for(d=p+f+1;d<=t;++d)(d===t||c.charCodeAt(d)===S)&&(w+=w.length===0?"..":"/..");return`${w}${h.slice(o+f)}`},toNamespacedPath(c){return c},dirname(c){if(m(c,"path"),c.length===0)return".";const h=c.charCodeAt(0)===S;let p=-1,t=!0;for(let r=c.length-1;r>=1;--r)if(c.charCodeAt(r)===S){if(!t){p=r;break}}else t=!1;return p===-1?h?"/":".":h&&p===1?"//":c.slice(0,p)},basename(c,h){h!==void 0&&m(h,"ext"),m(c,"path");let p=0,t=-1,r=!0,o;if(h!==void 0&&h.length>0&&h.length<=c.length){if(h===c)return"";let n=h.length-1,a=-1;for(o=c.length-1;o>=0;--o){const f=c.charCodeAt(o);if(f===S){if(!r){p=o+1;break}}else a===-1&&(r=!1,a=o+1),n>=0&&(f===h.charCodeAt(n)?--n==-1&&(t=o):(n=-1,t=a))}return p===t?t=a:t===-1&&(t=c.length),c.slice(p,t)}for(o=c.length-1;o>=0;--o)if(c.charCodeAt(o)===S){if(!r){p=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":c.slice(p,t)},extname(c){m(c,"path");let h=-1,p=0,t=-1,r=!0,o=0;for(let n=c.length-1;n>=0;--n){const a=c.charCodeAt(n);if(a===S){if(!r){p=n+1;break}continue}t===-1&&(r=!1,t=n+1),a===C?h===-1?h=n:o!==1&&(o=1):h!==-1&&(o=-1)}return h===-1||t===-1||o===0||o===1&&h===t-1&&h===p+1?"":c.slice(h,t)},format:A.bind(null,"/"),parse(c){m(c,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return h;const p=c.charCodeAt(0)===S;let t;p?(h.root="/",t=1):t=0;let r=-1,o=0,n=-1,a=!0,f=c.length-1,d=0;for(;f>=t;--f){const w=c.charCodeAt(f);if(w===S){if(!a){o=f+1;break}continue}n===-1&&(a=!1,n=f+1),w===C?r===-1?r=f:d!==1&&(d=1):r!==-1&&(d=-1)}if(n!==-1){const w=o===0&&p?1:o;r===-1||d===0||d===1&&r===n-1&&r===o+1?h.base=h.name=c.slice(w,n):(h.name=c.slice(w,r),h.base=c.slice(w,n),h.ext=c.slice(r,n))}return o>0?h.dir=c.slice(0,o-1):p&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[140],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var L;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(y,...T){const C=T.reduce((i,I)=>(i[I]=!0,i),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(i=>!C[i]).forEach(i=>{for(let I=0;I<S.length;I++)if(i.search(S[I])!==-1){delete y[i];break}})}e.sanitizeProcessEnvironment=k}),define(me[46],ge([0,1,11]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=g.globals.performance&&typeof g.globals.performance.now=="function";class k{constructor(T){this._highResolution=L&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new k(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=k}),define(me[3],ge([0,1,16,72,6,95,46]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(c){c.None=()=>k.Disposable.None;function h(K){return(O,x=null,F)=>{let z=!1,M;return M=K(N=>{if(!z)return M?M.dispose():z=!0,O.call(x,N)},null,F),z&&M.dispose(),M}}c.once=h;function p(K,O){return f((x,F=null,z)=>K(M=>x.call(F,O(M)),null,z))}c.map=p;function t(K,O){return f((x,F=null,z)=>K(M=>{O(M),x.call(F,M)},null,z))}c.forEach=t;function r(K,O){return f((x,F=null,z)=>K(M=>O(M)&&x.call(F,M),null,z))}c.filter=r;function o(K){return K}c.signal=o;function n(...K){return(O,x=null,F)=>(0,k.combinedDisposable)(...K.map(z=>z(M=>O.call(x,M),null,F)))}c.any=n;function a(K,O,x){let F=x;return p(K,z=>(F=O(F,z),F))}c.reduce=a;function f(K){let O;const x=new u({onFirstListenerAdd(){O=K(x.fire,x)},onLastListenerRemove(){O.dispose()}});return x.event}function d(K,O,x=100,F=!1,z){let M,N,q,B=0;const G=new u({leakWarningThreshold:z,onFirstListenerAdd(){M=K(re=>{B++,N=O(N,re),F&&!q&&(G.fire(N),N=void 0),clearTimeout(q),q=setTimeout(()=>{const he=N;N=void 0,q=void 0,(!F||B>1)&&G.fire(he),B=0},x)})},onLastListenerRemove(){M.dispose()}});return G.event}c.debounce=d;function w(K,O=(x,F)=>x===F){let x=!0,F;return r(K,z=>{const M=x||!O(z,F);return x=!1,F=z,M})}c.latch=w;function E(K,O){return[c.filter(K,O),c.filter(K,x=>!O(x))]}c.split=E;function s(K,O=!1,x=[]){let F=x.slice(),z=K(q=>{F?F.push(q):N.fire(q)});const M=()=>{F&&F.forEach(q=>N.fire(q)),F=null},N=new u({onFirstListenerAdd(){z||(z=K(q=>N.fire(q)))},onFirstListenerDidAdd(){F&&(O?setTimeout(M):M())},onLastListenerRemove(){z&&z.dispose(),z=null}});return N.event}c.buffer=s;class D{constructor(O){this.event=O}map(O){return new D(p(this.event,O))}forEach(O){return new D(t(this.event,O))}filter(O){return new D(r(this.event,O))}reduce(O,x){return new D(a(this.event,O,x))}latch(){return new D(w(this.event))}debounce(O,x=100,F=!1,z){return new D(d(this.event,O,x,F,z))}on(O,x,F){return this.event(O,x,F)}once(O,x,F){return h(this.event)(O,x,F)}}function R(K){return new D(K)}c.chain=R;function U(K,O,x=F=>F){const F=(...q)=>N.fire(x(...q)),z=()=>K.on(O,F),M=()=>K.removeListener(O,F),N=new u({onFirstListenerAdd:z,onLastListenerRemove:M});return N.event}c.fromNodeEventEmitter=U;function V(K,O,x=F=>F){const F=(...q)=>N.fire(x(...q)),z=()=>K.addEventListener(O,F),M=()=>K.removeEventListener(O,F),N=new u({onFirstListenerAdd:z,onLastListenerRemove:M});return N.event}c.fromDOMEventEmitter=V;function ee(K){return new Promise(O=>h(K)(O))}c.toPromise=ee})(C=e.Event||(e.Event={}));class S{constructor(h){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${h}_${S._idPool++}`}start(h){this._stopWatch=new T.StopWatch(!0),this._listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this._elapsedOverall+=h,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${h.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let P=-1;function i(c){const h=P;return P=c,{dispose(){P=h}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(h,p=Math.random().toString(18).slice(2,5)){this.customThreshold=h,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(h){let p=P;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),p<=0||h<p)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let o,n=0;for(const[a,f]of this._stacks)(!o||n<f)&&(o=a,n=f);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${n}):`),console.warn(o)}return()=>{const o=this._stacks.get(t)||0;this._stacks.set(t,o-1)}}}class u{constructor(h){this._disposed=!1,this._options=h,this._leakageMon=P>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(h,p,t)=>{this._listeners||(this._listeners=new y.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const o=this._listeners.push(p?[h,p]:h);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,h,p);const n=this._leakageMon?.check(this._listeners.size),a=(0,k.toDisposable)(()=>{n&&n(),this._disposed||(o(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof k.DisposableStore?t.add(a):Array.isArray(t)&&t.push(a),a}),this._event}fire(h){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let p of this._listeners)this._deliveryQueue.push([p,h]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[p,t]=this._deliveryQueue.shift();try{typeof p=="function"?p.call(void 0,t):p[0].call(p[1],t)}catch(r){(0,g.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=u;class m extends u{async fireAsync(h,p,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,h]);for(;this._asyncDeliveryQueue.size>0&&!p.isCancellationRequested;){const[r,o]=this._asyncDeliveryQueue.shift(),n=[],a={...o,waitUntil:f=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous");t&&(f=t(f,typeof r=="function"?r:r[0])),n.push(f)}};try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(f){(0,g.onUnexpectedError)(f);continue}Object.freeze(n),await Promise.allSettled(n).then(f=>{for(const d of f)d.status==="rejected"&&(0,g.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=m;class l extends u{constructor(h){super(h);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=h?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._listeners&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}e.PauseableEmitter=l;class v extends l{constructor(h){super(h);this._delay=h.delay??100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}e.DebounceEmitter=v;class _{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new u({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const p={event:h,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const t=()=>{this.hasListeners&&this.unhook(p);const r=this.events.indexOf(p);this.events.splice(r,1)};return(0,k.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(p=>this.emitter.fire(p))}unhook(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=_;class b{constructor(){this.buffers=[]}wrapEvent(h){return(p,t,r)=>h(o=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>p.call(t,o)):p.call(t,o)},void 0,r)}bufferEvents(h){const p=[];this.buffers.push(p);const t=h();return this.buffers.pop(),p.forEach(r=>r()),t}}e.EventBufferer=b;class A{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=k.Disposable.None,this.emitter=new u({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=A}),define(me[21],ge([0,1,3]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(C,S){const P=setTimeout(C.bind(S),0);return{dispose(){clearTimeout(P)}}});var k;(function(C){function S(P){return P===C.None||P===C.Cancelled||P instanceof y?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}C.isCancellationToken=S,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=k.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=T}),define(me[47],ge([0,1,3]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const u=this._icons.get(I.id);u?I.description?u.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function y(i,I){return new C(i,I)}e.registerCodicon=y;function T(i){return i?i.replace(/\$\((.*?)\)/g,(I,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=T;class C{constructor(I,u,m){this.id=I,this.definition=u,this.description=m,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function S(i,I){const u=["codicon","codicon-"+i];return I&&u.push("codicon-modifier-"+I),u}e.getClassNamesArray=S;var P;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function u(v){if(v instanceof C)return["codicon","codicon-"+v.id];const _=I.exec(v.id);if(!_)return u(C.error);let[,b,A]=_;const c=["codicon","codicon-"+b];return A&&c.push("codicon-modifier-"+A.substr(1)),c}i.asClassNameArray=u;function m(v){return u(v).join(" ")}i.asClassName=m;function l(v){return"."+u(v).join(".")}i.asCSSSelector=l})(P=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(me[96],ge([0,1,16,6]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=k;function y(c){const h=c;return h?k(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=y;function T(c,h){return new C(c,h)}e.newWriteableStream=T;class C{constructor(h,p){this.reducer=h,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(p=>this.pendingWritePromises.push(p))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(p=>p(h))}emitError(h){this.listeners.error.length===0?(0,g.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(p=>p(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,p){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(h,p){if(this.state.destroyed)return;let t;switch(h){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(p);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(c,h){const p=[];let t;for(;(t=c.read())!==null;)p.push(t);return h(p)}e.consumeReadable=S;function P(c,h,p){const t=[];let r;for(;(r=c.read())!==null&&t.length<p;)t.push(r);return r===null&&t.length>0?h(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const o=r;return r=void 0,o}return c.read()}}}e.peekReadable=P;function i(c,h){return new Promise((p,t)=>{const r=[];I(c,{onData:o=>{h&&r.push(o)},onError:o=>{h?t(o):p(void 0)},onEnd:()=>{p(h?h(r):void 0)}})})}e.consumeStream=i;function I(c,h){c.on("error",p=>h.onError(p)),c.on("end",()=>h.onEnd()),c.on("data",p=>h.onData(p))}e.listenStream=I;function u(c,h){return new Promise((p,t)=>{const r=new L.DisposableStore,o=[],n=d=>{if(o.push(d),o.length>h)return r.dispose(),c.pause(),p({stream:c,buffer:o,ended:!1})},a=d=>t(d),f=()=>p({stream:c,buffer:o,ended:!0});r.add((0,L.toDisposable)(()=>c.removeListener("error",a))),c.on("error",a),r.add((0,L.toDisposable)(()=>c.removeListener("end",f))),c.on("end",f),r.add((0,L.toDisposable)(()=>c.removeListener("data",n))),c.on("data",n)})}e.peekStream=u;function m(c,h){const p=T(h);return p.end(c),p}e.toStream=m;function l(){const c=T(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=l;function v(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}e.toReadable=v;function _(c,h,p){const t=T(p);return I(c,{onData:r=>t.write(h.data(r)),onError:r=>t.error(h.error?h.error(r):r),onEnd:()=>t.end()}),t}e.transform=_;function b(c,h,p){let t=!1;return{read:()=>{const r=h.read();return t?r:(t=!0,r!==null?p([c,r]):c)}}}e.prefixedReadable=b;function A(c,h,p){let t=!1;const r=T(p);return I(h,{onData:o=>t?r.write(o):(t=!0,r.write(p([c,o]))),onError:o=>r.error(o),onEnd:()=>{t||(t=!0,r.write(c)),r.end()}}),r}e.prefixedStream=A}),define(me[8],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=g;const L=/{(\d+)}/g;function k(j,...we){return we.length===0?j:j.replace(L,function(_e,Ae){const Ue=parseInt(Ae,10);return isNaN(Ue)||Ue<0||Ue>=we.length?_e:we[Ue]})}e.format=k;const y=/{([^}]+)}/g;function T(j,we){return j.replace(y,(_e,Ae)=>we[Ae]??_e)}e.format2=T;function C(j){return j.replace(/[<>&]/g,function(we){switch(we){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return we}})}e.escape=C;function S(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function P(j,we){let _e=0;const Ae=we.charCodeAt(0);for(let Ue=j.length-1;Ue>=0;Ue--)j.charCodeAt(Ue)===Ae&&_e++;return _e}e.count=P;function i(j,we,_e="\u2026"){return j.length<=we?j:`${j.substr(0,we)}${_e}`}e.truncate=i;function I(j,we=" "){const _e=u(j,we);return m(_e,we)}e.trim=I;function u(j,we){if(!j||!we)return j;const _e=we.length;if(_e===0||j.length===0)return j;let Ae=0;for(;j.indexOf(we,Ae)===Ae;)Ae=Ae+_e;return j.substring(Ae)}e.ltrim=u;function m(j,we){if(!j||!we)return j;const _e=we.length,Ae=j.length;if(_e===0||Ae===0)return j;let Ue=Ae,Ge=-1;for(;Ge=j.lastIndexOf(we,Ue-1),!(Ge===-1||Ge+_e!==Ue);){if(Ge===0)return"";Ue=Ge}return j.substring(0,Ue)}e.rtrim=m;function l(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function v(j){return j.replace(/\*/g,"")}e.stripWildcards=v;function _(j,we,_e={}){if(!j)throw new Error("Cannot create regex from empty string");we||(j=S(j)),_e.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let Ae="";return _e.global&&(Ae+="g"),_e.matchCase||(Ae+="i"),_e.multiline&&(Ae+="m"),_e.unicode&&(Ae+="u"),new RegExp(j,Ae)}e.createRegExp=_;function b(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function A(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=A;function c(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=c;function h(j){return j.split(/\r\n|\r|\n/)}e.splitLines=h;function p(j){for(let we=0,_e=j.length;we<_e;we++){const Ae=j.charCodeAt(we);if(Ae!==32&&Ae!==9)return we}return-1}e.firstNonWhitespaceIndex=p;function t(j,we=0,_e=j.length){for(let Ae=we;Ae<_e;Ae++){const Ue=j.charCodeAt(Ae);if(Ue!==32&&Ue!==9)return j.substring(we,Ae)}return j.substring(we,_e)}e.getLeadingWhitespace=t;function r(j,we=j.length-1){for(let _e=we;_e>=0;_e--){const Ae=j.charCodeAt(_e);if(Ae!==32&&Ae!==9)return _e}return-1}e.lastNonWhitespaceIndex=r;function o(j,we){return j<we?-1:j>we?1:0}e.compare=o;function n(j,we,_e=0,Ae=j.length,Ue=0,Ge=we.length){for(;_e<Ae&&Ue<Ge;_e++,Ue++){let Xe=j.charCodeAt(_e),ct=we.charCodeAt(Ue);if(Xe<ct)return-1;if(Xe>ct)return 1}const Ze=Ae-_e,Qe=Ge-Ue;return Ze<Qe?-1:Ze>Qe?1:0}e.compareSubstring=n;function a(j,we){return f(j,we,0,j.length,0,we.length)}e.compareIgnoreCase=a;function f(j,we,_e=0,Ae=j.length,Ue=0,Ge=we.length){for(;_e<Ae&&Ue<Ge;_e++,Ue++){let Xe=j.charCodeAt(_e),ct=we.charCodeAt(Ue);if(Xe===ct)continue;const mt=Xe-ct;if(!(mt===32&&w(ct))&&!(mt===-32&&w(Xe)))return d(Xe)&&d(ct)?mt:n(j.toLowerCase(),we.toLowerCase(),_e,Ae,Ue,Ge)}const Ze=Ae-_e,Qe=Ge-Ue;return Ze<Qe?-1:Ze>Qe?1:0}e.compareSubstringIgnoreCase=f;function d(j){return j>=97&&j<=122}e.isLowerAsciiLetter=d;function w(j){return j>=65&&j<=90}e.isUpperAsciiLetter=w;function E(j){return d(j)||w(j)}function s(j,we){return j.length===we.length&&D(j,we)}e.equalsIgnoreCase=s;function D(j,we,_e=j.length){for(let Ae=0;Ae<_e;Ae++){const Ue=j.charCodeAt(Ae),Ge=we.charCodeAt(Ae);if(Ue!==Ge){if(E(Ue)&&E(Ge)){const Ze=Math.abs(Ue-Ge);if(Ze!==0&&Ze!==32)return!1}else if(String.fromCharCode(Ue).toLowerCase()!==String.fromCharCode(Ge).toLowerCase())return!1}}return!0}function R(j,we){const _e=we.length;return we.length>j.length?!1:D(j,we,_e)}e.startsWithIgnoreCase=R;function U(j,we){let _e,Ae=Math.min(j.length,we.length);for(_e=0;_e<Ae;_e++)if(j.charCodeAt(_e)!==we.charCodeAt(_e))return _e;return Ae}e.commonPrefixLength=U;function V(j,we){let _e,Ae=Math.min(j.length,we.length);const Ue=j.length-1,Ge=we.length-1;for(_e=0;_e<Ae;_e++)if(j.charCodeAt(Ue-_e)!==we.charCodeAt(Ge-_e))return _e;return Ae}e.commonSuffixLength=V;function ee(j){return 55296<=j&&j<=56319}e.isHighSurrogate=ee;function K(j){return 56320<=j&&j<=57343}e.isLowSurrogate=K;function O(j,we){return(j-55296<<10)+(we-56320)+65536}e.computeCodePoint=O;function x(j,we,_e){const Ae=j.charCodeAt(_e);if(ee(Ae)&&_e+1<we){const Ue=j.charCodeAt(_e+1);if(K(Ue))return O(Ae,Ue)}return Ae}e.getNextCodePoint=x;function F(j,we){const _e=j.charCodeAt(we-1);if(K(_e)&&we>1){const Ae=j.charCodeAt(we-2);if(ee(Ae))return O(Ae,_e)}return _e}function z(j,we){const _e=Ce.getInstance(),Ae=we,Ue=j.length,Ge=x(j,Ue,we);we+=Ge>=65536?2:1;let Ze=_e.getGraphemeBreakType(Ge);for(;we<Ue;){const Qe=x(j,Ue,we),Xe=_e.getGraphemeBreakType(Qe);if(Be(Ze,Xe))break;we+=Qe>=65536?2:1,Ze=Xe}return we-Ae}e.nextCharLength=z;function M(j,we){const _e=Ce.getInstance(),Ae=we,Ue=F(j,we);we-=Ue>=65536?2:1;let Ge=_e.getGraphemeBreakType(Ue);for(;we>0;){const Ze=F(j,we),Qe=_e.getGraphemeBreakType(Ze);if(Be(Qe,Ge))break;we-=Ze>=65536?2:1,Ge=Qe}return Ae-we}e.prevCharLength=M;function N(j,we){const _e=Ce.getInstance(),Ae=j.length,Ue=we,Ge=x(j,Ae,we),Ze=_e.getGraphemeBreakType(Ge);we+=Ge>=65536?2:1;let Qe=Ze;for(;we<Ae;){const ct=x(j,Ae,we),mt=_e.getGraphemeBreakType(ct);if(Be(Qe,mt))break;we+=ct>=65536?2:1,Qe=mt}const Xe=we;for(we=Ue,Qe=Ze;we>0;){const ct=F(j,we),mt=_e.getGraphemeBreakType(ct);if(Be(mt,Qe))break;we-=ct>=65536?2:1,Qe=mt}return[we,Xe]}function q(j,we){return we>0&&K(j.charCodeAt(we))?N(j,we-1):N(j,we)}e.getCharContainingOffset=q;function B(j){const we=j.length;let _e=0,Ae=0;for(;Ae<we;){const Ze=x(j,we,Ae);Ae+=Ze>=65536?2:1,Ze<128?_e+=1:Ze<2048?_e+=2:Ze<65536?_e+=3:_e+=4}const Ue=new Uint8Array(_e);Ae=0;let Ge=0;for(;Ae<we;){const Ze=x(j,we,Ae);Ae+=Ze>=65536?2:1,Ze<128?Ue[Ge++]=Ze:Ze<2048?(Ue[Ge++]=192|(Ze&1984)>>>6,Ue[Ge++]=128|(Ze&63)>>>0):Ze<65536?(Ue[Ge++]=224|(Ze&61440)>>>12,Ue[Ge++]=128|(Ze&4032)>>>6,Ue[Ge++]=128|(Ze&63)>>>0):(Ue[Ge++]=240|(Ze&1835008)>>>18,Ue[Ge++]=128|(Ze&258048)>>>12,Ue[Ge++]=128|(Ze&4032)>>>6,Ue[Ge++]=128|(Ze&63)>>>0)}return Ue}e.encodeUTF8=B;function G(j){const we=j.byteLength,_e=[];let Ae=0;for(;Ae<we;){const Ue=j[Ae];let Ge;if(Ue>=240&&Ae+3<we?Ge=(j[Ae++]&7)<<18>>>0|(j[Ae++]&63)<<12>>>0|(j[Ae++]&63)<<6>>>0|(j[Ae++]&63)<<0>>>0:Ue>=224&&Ae+2<we?Ge=(j[Ae++]&15)<<12>>>0|(j[Ae++]&63)<<6>>>0|(j[Ae++]&63)<<0>>>0:Ue>=192&&Ae+1<we?Ge=(j[Ae++]&31)<<6>>>0|(j[Ae++]&63)<<0>>>0:Ge=j[Ae++],Ge>=0&&Ge<=55295||Ge>=57344&&Ge<=65535)_e.push(String.fromCharCode(Ge));else if(Ge>=65536&&Ge<=1114111){const Ze=Ge-65536,Qe=55296+((Ze&1047552)>>>10),Xe=56320+((Ze&1023)>>>0);_e.push(String.fromCharCode(Qe)),_e.push(String.fromCharCode(Xe))}else _e.push(String.fromCharCode(65533))}return _e.join("")}e.decodeUTF8=G;const re=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function he(j){return re.test(j)}e.containsRTL=he;const ye=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ie(j){return ye.test(j)}e.containsEmoji=Ie;const Le=/^[\t\n\r\x20-\x7E]*$/;function qe(j){return Le.test(j)}e.isBasicASCII=qe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function We(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=We;function je(j){for(let we=0,_e=j.length;we<_e;we++)if(W(j.charCodeAt(we)))return!0;return!1}e.containsFullWidthCharacter=je;function W(j){return j=+j,j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=W;function Z(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129003||j>=129280&&j<=129535||j>=129648&&j<=129750}e.isEmojiImprecise=Z;function ne(j,we){if(j.length<we)return j;const _e=/\b/g;let Ae=0;for(;_e.test(j)&&!(j.length-_e.lastIndex<we);)Ae=_e.lastIndex,_e.lastIndex+=1;return j.substring(Ae).replace(/^\s/,"")}e.lcut=ne;const le=/\x1B\x5B[12]?K/g,Y=/\x1b\[\d+m/g,ae=/\x1b\[0?m/g;function ve(j){return j&&(j=j.replace(le,""),j=j.replace(Y,""),j=j.replace(ae,"")),j}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Me(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Me;function ze(j){return Me(j)?j.substr(1):j}e.stripUTF8BOM=ze;function Ee(j,we){if(!j||!we||j.length<we.length)return!1;const _e=we.length,Ae=j.toLowerCase();let Ue=0,Ge=-1;for(;Ue<_e;){const Ze=Ae.indexOf(we[Ue],Ge+1);if(Ze<0)return!1;Ge=Ze,Ue++}return!0}e.fuzzyContains=Ee;function Je(j,we=!1){return j?(we&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=Je;function X(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=X;function se(j,we=1){if(we===0)return"";let _e=-1;do _e=j.indexOf(`
`,_e+1),we--;while(we>0&&_e>=0);return _e===-1?j:(j[_e-1]==="\r"&&_e--,j.substr(0,_e))}e.getNLines=se;function fe(j){const we=90-65+1;return j=j%(2*we),j<we?String.fromCharCode(97+j):String.fromCharCode(65+j-we)}e.singleLetterHash=fe;function xe(j){return Ce.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=xe;function Be(j,we){return j===0?we!==5&&we!==7:j===2&&we===3?!1:j===4||j===2||j===3||we===4||we===2||we===3?!0:!(j===8&&(we===8||we===9||we===11||we===12)||(j===11||j===9)&&(we===9||we===10)||(j===12||j===10)&&we===10||we===5||we===13||we===7||j===1||j===13&&we===14||j===6&&we===6)}e.breakBetweenGraphemeBreakType=Be;var et;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ce{constructor(){this._data=De()}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}getGraphemeBreakType(we){if(we<32)return we===10?3:we===13?2:4;if(we<127)return 0;const _e=this._data,Ae=_e.length/3;let Ue=1;for(;Ue<=Ae;)if(we<_e[3*Ue])Ue=2*Ue;else if(we>_e[3*Ue+1])Ue=2*Ue+1;else return _e[3*Ue+2];return 0}}Ce._INSTANCE=null;function De(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Te(j,we){if(j===0)return 0;const _e=ce(j,we);if(_e!==void 0)return _e;const Ae=F(we,j);return j-=ue(Ae),j}e.getLeftDeleteOffset=Te;function ce(j,we){let _e=F(we,j);for(j-=ue(_e);pe(_e)||_e===65039||_e===8419;){if(j===0)return;_e=F(we,j),j-=ue(_e)}if(!!Z(_e)){if(j>=0){const Ae=F(we,j);Ae===8205&&(j-=ue(Ae))}return j}}function ue(j){return j>=65536?2:1}function pe(j){return 127995<=j&&j<=127999}var be;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(be||(be={}))}),define(me[24],ge([0,1,96,8]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let C,S;class P{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return k?new P(Buffer.allocUnsafe(d)):new P(new Uint8Array(d))}static wrap(d){return k&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new P(d)}static fromString(d,w){return!(w?.dontUseNodeBuffer||!1)&&k?new P(Buffer.from(d)):y?(C||(C=new TextEncoder),new P(C.encode(d))):new P(L.encodeUTF8(d))}static concat(d,w){if(typeof w=="undefined"){w=0;for(let D=0,R=d.length;D<R;D++)w+=d[D].byteLength}const E=P.alloc(w);let s=0;for(let D=0,R=d.length;D<R;D++){const U=d[D];E.set(U,s),s+=U.byteLength}return E}toString(){return k?this.buffer.toString():T?(S||(S=new TextDecoder),S.decode(this.buffer)):L.decodeUTF8(this.buffer)}slice(d,w){return new P(this.buffer.subarray(d,w))}set(d,w){d instanceof P?this.buffer.set(d.buffer,w):this.buffer.set(d,w)}readUInt32BE(d){return u(this.buffer,d)}writeUInt32BE(d,w){m(this.buffer,d,w)}readUInt32LE(d){return l(this.buffer,d)}writeUInt32LE(d,w){v(this.buffer,d,w)}readUInt8(d){return _(this.buffer,d)}writeUInt8(d,w){b(this.buffer,d,w)}}e.VSBuffer=P;function i(f,d){return f[d+0]<<0>>>0|f[d+1]<<8>>>0}e.readUInt16LE=i;function I(f,d,w){f[w+0]=d&255,d=d>>>8,f[w+1]=d&255}e.writeUInt16LE=I;function u(f,d){return f[d]*2**24+f[d+1]*2**16+f[d+2]*2**8+f[d+3]}e.readUInt32BE=u;function m(f,d,w){f[w+3]=d,d=d>>>8,f[w+2]=d,d=d>>>8,f[w+1]=d,d=d>>>8,f[w]=d}e.writeUInt32BE=m;function l(f,d){return f[d+0]<<0>>>0|f[d+1]<<8>>>0|f[d+2]<<16>>>0|f[d+3]<<24>>>0}e.readUInt32LE=l;function v(f,d,w){f[w+0]=d&255,d=d>>>8,f[w+1]=d&255,d=d>>>8,f[w+2]=d&255,d=d>>>8,f[w+3]=d&255}e.writeUInt32LE=v;function _(f,d){return f[d]}e.readUInt8=_;function b(f,d,w){f[w]=d}e.writeUInt8=b;function A(f){return g.consumeReadable(f,d=>P.concat(d))}e.readableToBuffer=A;function c(f){return g.toReadable(f)}e.bufferToReadable=c;function h(f){return g.consumeStream(f,d=>P.concat(d))}e.streamToBuffer=h;async function p(f){return f.ended?P.concat(f.buffer):P.concat([...f.buffer,await h(f.stream)])}e.bufferedStreamToBuffer=p;function t(f){return g.toStream(f,d=>P.concat(d))}e.bufferToStream=t;function r(f){return g.transform(f,{data:d=>typeof d=="string"?P.fromString(d):P.wrap(d)},d=>P.concat(d))}e.streamToBufferReadableStream=r;function o(f){return g.newWriteableStream(d=>P.concat(d),f)}e.newWriteableBufferStream=o;function n(f,d){return g.prefixedReadable(f,d,w=>P.concat(w))}e.prefixedBufferReadable=n;function a(f,d){return g.prefixedStream(f,d,w=>P.concat(w))}e.prefixedBufferStream=a}),define(me[58],ge([0,1,8]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(b){return k(b,0)}e.hash=L;function k(b,A){switch(typeof b){case"object":return b===null?y(349,A):Array.isArray(b)?S(b,A):P(b,A);case"string":return C(b,A);case"boolean":return T(b,A);case"number":return y(b,A);case"undefined":return y(937,A);default:return y(617,A)}}e.doHash=k;function y(b,A){return(A<<5)-A+b|0}function T(b,A){return y(b?433:863,A)}function C(b,A){A=y(149417,A);for(let c=0,h=b.length;c<h;c++)A=y(b.charCodeAt(c),A);return A}e.stringHash=C;function S(b,A){return A=y(104579,A),b.reduce((c,h)=>k(h,c),A)}function P(b,A){return A=y(181387,A),Object.keys(b).sort().reduce((c,h)=>(c=C(h,c),k(b[h],c)),A)}class i{constructor(){this._value=0}get value(){return this._value}hash(A){return this._value=k(A,this._value),this._value}}e.Hasher=i;var I;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function u(b,A,c=32){const h=c-A,p=~((1<<h)-1);return(b<<A|(p&b)>>>h)>>>0}function m(b,A=0,c=b.byteLength,h=0){for(let p=0;p<c;p++)b[A+p]=h}function l(b,A,c="0"){for(;b.length<A;)b=c+b;return b}function v(b,A=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(c=>c.toString(16).padStart(2,"0")).join(""):l((b>>>0).toString(16),A/4)}e.toHexString=v;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(A){const c=A.length;if(c===0)return;const h=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,r,o;for(t!==0?(r=t,o=-1,t=0):(r=A.charCodeAt(0),o=0);;){let n=r;if(g.isHighSurrogate(r))if(o+1<c){const a=A.charCodeAt(o+1);g.isLowSurrogate(a)?(o++,n=g.computeCodePoint(r,a)):n=65533}else{t=r;break}else g.isLowSurrogate(r)&&(n=65533);if(p=this._push(h,p,n),o++,o<c)r=A.charCodeAt(o);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(A,c,h){return h<128?A[c++]=h:h<2048?(A[c++]=192|(h&1984)>>>6,A[c++]=128|(h&63)>>>0):h<65536?(A[c++]=224|(h&61440)>>>12,A[c++]=128|(h&4032)>>>6,A[c++]=128|(h&63)>>>0):(A[c++]=240|(h&1835008)>>>18,A[c++]=128|(h&258048)>>>12,A[c++]=128|(h&4032)>>>6,A[c++]=128|(h&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,A[0]=A[64+0],A[1]=A[64+1],A[2]=A[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const A=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(A/4294967296),!1),this._buffDV.setUint32(60,A%4294967296,!1),this._step()}_step(){const A=_._bigBlock32,c=this._buffDV;for(let d=0;d<64;d+=4)A.setUint32(d,c.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)A.setUint32(d,u(A.getUint32(d-12,!1)^A.getUint32(d-32,!1)^A.getUint32(d-56,!1)^A.getUint32(d-64,!1),1),!1);let h=this._h0,p=this._h1,t=this._h2,r=this._h3,o=this._h4,n,a,f;for(let d=0;d<80;d++)d<20?(n=p&t|~p&r,a=1518500249):d<40?(n=p^t^r,a=1859775393):d<60?(n=p&t|p&r|t&r,a=2400959708):(n=p^t^r,a=3395469782),f=u(h,5)+n+o+a+A.getUint32(d*4,!1)&4294967295,o=r,r=t,t=u(p,30),p=h,h=f;this._h0=this._h0+h&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[48],ge([0,1,8]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(L||(L={})),function(k){const y="error",T="warning",C="warn",S="info",P="ignore";function i(u){return u?g.equalsIgnoreCase(y,u)?k.Error:g.equalsIgnoreCase(T,u)||g.equalsIgnoreCase(C,u)?k.Warning:g.equalsIgnoreCase(S,u)?k.Info:k.Ignore:k.Ignore}k.fromValue=i;function I(u){switch(u){case k.Error:return y;case k.Warning:return T;case k.Info:return S;default:return P}}k.toString=I}(L||(L={})),e.default=L}),define(me[14],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(d){return Array.isArray(d)}e.isArray=g;function L(d){return typeof d=="string"}e.isString=L;function k(d){return Array.isArray(d)&&d.every(w=>L(w))}e.isStringArray=k;function y(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=y;function T(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=T;function C(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=C;function S(d){return d===!0||d===!1}e.isBoolean=S;function P(d){return typeof d=="undefined"}e.isUndefined=P;function i(d){return!I(d)}e.isDefined=i;function I(d){return P(d)||d===null}e.isUndefinedOrNull=I;function u(d,w){if(!d)throw new Error(w?`Unexpected type, expected '${w}'`:"Unexpected type")}e.assertType=u;function m(d){if(I(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=m;function l(...d){const w=[];for(let E=0;E<d.length;E++){const s=d[E];if(I(s))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);w.push(s)}return w}e.assertAllDefined=l;const v=Object.prototype.hasOwnProperty;function _(d){if(!y(d))return!1;for(let w in d)if(v.call(d,w))return!1;return!0}e.isEmptyObject=_;function b(d){return typeof d=="function"}e.isFunction=b;function A(...d){return d.length>0&&d.every(b)}e.areFunctions=A;function c(d,w){const E=Math.min(d.length,w.length);for(let s=0;s<E;s++)h(d[s],w[s])}e.validateConstraints=c;function h(d,w){if(L(w)){if(typeof d!==w)throw new Error(`argument does not match constraint: typeof ${w}`)}else if(b(w)){try{if(d instanceof w)return}catch{}if(!I(d)&&d.constructor===w||w.length===1&&w.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function p(d){let w=[],E=Object.getPrototypeOf(d);for(;Object.prototype!==E;)w=w.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return w}e.getAllPropertyNames=p;function t(d){const w=[];for(const E of p(d))typeof d[E]=="function"&&w.push(E);return w}e.getAllMethodNames=t;function r(d,w){const E=D=>function(){const R=Array.prototype.slice.call(arguments,0);return w(D,R)};let s={};for(const D of d)s[D]=E(D);return s}e.createProxyObject=r;function o(d){return d===null?void 0:d}e.withNullAsUndefined=o;function n(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=n;function a(d){return class{constructor(){return new Proxy({},{get(w,E){if(w[E])return w[E];throw new Error(`Not Implemented: ${d}->${String(E)}`)}})}}}e.NotImplementedProxy=a;function f(d,w="Unreachable"){throw new Error(w)}e.assertNever=f}),define(me[29],ge([0,1,9,11,8,14]),function(J,e,g,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(o){return o===47||o===92}e.isPathSeparator=T;function C(o){return o.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=C;function S(o){return o.indexOf("/")===-1&&(o=C(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=S;function P(o,n=g.posix.sep){if(!o)return"";const a=o.length,f=o.charCodeAt(0);if(T(f)){if(T(o.charCodeAt(1))&&!T(o.charCodeAt(2))){let w=3;const E=w;for(;w<a&&!T(o.charCodeAt(w));w++);if(E!==w&&!T(o.charCodeAt(w+1))){for(w+=1;w<a;w++)if(T(o.charCodeAt(w)))return o.slice(0,w+1).replace(/[\\/]/g,n)}}return n}else if(b(f)&&o.charCodeAt(1)===58)return T(o.charCodeAt(2))?o.slice(0,2)+n:o.slice(0,2);let d=o.indexOf("://");if(d!==-1){for(d+=3;d<a;d++)if(T(o.charCodeAt(d)))return o.slice(0,d+1)}return""}e.getRoot=P;function i(o){if(!L.isWindows||!o||o.length<5)return!1;let n=o.charCodeAt(0);if(n!==92||(n=o.charCodeAt(1),n!==92))return!1;let a=2;const f=a;for(;a<o.length&&(n=o.charCodeAt(a),n!==92);a++);return!(f===a||(n=o.charCodeAt(a+1),isNaN(n)||n===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(o,n=L.isWindows){const a=n?I:u;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||n&&m.test(o)||o==="."||o===".."||n&&o[o.length-1]==="."||n&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=l;function v(o,n,a){const f=o===n;return!a||f?f:!o||!n?!1:(0,k.equalsIgnoreCase)(o,n)}e.isEqual=v;function _(o,n,a,f=g.sep){if(o===n)return!0;if(!o||!n||n.length>o.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(o,n))return!1;if(n.length===o.length)return!0;let w=n.length;return n.charAt(n.length-1)===f&&w--,o.charAt(w)===f}return n.charAt(n.length-1)!==f&&(n+=f),o.indexOf(n)===0}e.isEqualOrParent=_;function b(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=b;function A(o,n){return L.isWindows&&o.endsWith(":")&&(o+=g.sep),(0,g.isAbsolute)(o)||(o=(0,g.join)(n,o)),o=(0,g.normalize)(o),L.isWindows?(o=(0,k.rtrim)(o,g.sep),o.endsWith(":")&&(o+=g.sep)):(o=(0,k.rtrim)(o,g.sep),o||(o=g.sep)),o}e.sanitizeFilePath=A;function c(o){const n=(0,g.normalize)(o);return L.isWindows?o.length>3?!1:h(n)&&(o.length===2||n.charCodeAt(2)===92):n===g.posix.sep}e.isRootOrDriveLetter=c;function h(o){return L.isWindows?b(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function p(o){return h(o)?o[0]:void 0}e.getDriveLetter=p;function t(o,n,a){return n.length>o.length?-1:o===n?0:(a&&(o=o.toLowerCase(),n=n.toLowerCase()),o.indexOf(n))}e.indexOfPath=t;function r(o){const n=o.split(":");let a,f,d;if(n.forEach(w=>{const E=Number(w);(0,y.isNumber)(E)?f===void 0?f=E:d===void 0&&(d=E):a=a?[a,w].join(":"):w}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:f!==void 0?f:void 0,column:d!==void 0?d:f!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(me[25],ge([0,1,14]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const _=Array.isArray(v)?[]:{};return Object.keys(v).forEach(b=>{v[b]&&typeof v[b]=="object"?_[b]=L(v[b]):_[b]=v[b]}),_}e.deepClone=L;function k(v){if(!v||typeof v!="object")return v;const _=[v];for(;_.length>0;){const b=_.shift();Object.freeze(b);for(const A in b)if(y.call(b,A)){const c=b[A];typeof c=="object"&&!Object.isFrozen(c)&&_.push(c)}}return v}e.deepFreeze=k;const y=Object.prototype.hasOwnProperty;function T(v,_){return C(v,_,new Set)}e.cloneAndChange=T;function C(v,_,b){if((0,g.isUndefinedOrNull)(v))return v;const A=_(v);if(typeof A!="undefined")return A;if((0,g.isArray)(v)){const c=[];for(const h of v)c.push(C(h,_,b));return c}if((0,g.isObject)(v)){if(b.has(v))throw new Error("Cannot clone recursive data-structure");b.add(v);const c={};for(let h in v)y.call(v,h)&&(c[h]=C(v[h],_,b));return b.delete(v),c}return v}function S(v,_,b=!0){return(0,g.isObject)(v)?((0,g.isObject)(_)&&Object.keys(_).forEach(A=>{A in v?b&&((0,g.isObject)(v[A])&&(0,g.isObject)(_[A])?S(v[A],_[A],b):v[A]=_[A]):v[A]=_[A]}),v):_}e.mixin=S;function P(v,_){if(v===_)return!0;if(v==null||_===null||_===void 0||typeof v!=typeof _||typeof v!="object"||Array.isArray(v)!==Array.isArray(_))return!1;let b,A;if(Array.isArray(v)){if(v.length!==_.length)return!1;for(b=0;b<v.length;b++)if(!P(v[b],_[b]))return!1}else{const c=[];for(A in v)c.push(A);c.sort();const h=[];for(A in _)h.push(A);if(h.sort(),!P(c,h))return!1;for(b=0;b<c.length;b++)if(!P(v[c[b]],_[c[b]]))return!1}return!0}e.equals=P;function i(v){const _=new Set;return JSON.stringify(v,(b,A)=>{if((0,g.isObject)(A)||Array.isArray(A)){if(_.has(A))return"[Circular]";_.add(A)}return A})}e.safeStringify=i;function I(v,_,b){const A=_(v);return typeof A=="undefined"?b:A}e.getOrDefault=I;function u(v,_){const b=Object.create(null);return!v||!_||Object.keys(_).forEach(c=>{const h=v[c],p=_[c];P(h,p)||(b[c]=p)}),b}e.distinct=u;function m(v,_){const b=_.toLowerCase(),A=Object.keys(v).find(c=>c.toLowerCase()===b);return A?v[A]:v[_]}e.getCaseInsensitive=m;function l(v,_){const b=Object.create(null);for(const A of Object.keys(v))_(A,v[A])&&(b[A]=v[A]);return b}e.filter=l}),define(me[97],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function L(y){return y<0?0:y>255?255:y|0}e.toUint8=L;function k(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=k}),define(me[2],ge([0,1,9,11]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,y=/^\//,T=/^\/\//;function C(o,n){if(!o.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!k.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!y.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(o,n){return!o&&!n?"file":o}function P(o,n){switch(o){case"https":case"http":case"file":n?n[0]!==I&&(n=I+n):n=I;break}return n}const i="",I="/",u=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(n,a,f,d,w,E=!1){typeof n=="object"?(this.scheme=n.scheme||i,this.authority=n.authority||i,this.path=n.path||i,this.query=n.query||i,this.fragment=n.fragment||i):(this.scheme=S(n,E),this.authority=a||i,this.path=P(this.scheme,f||i),this.query=d||i,this.fragment=w||i,C(this,E))}static isUri(n){return n instanceof m?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return c(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:f,path:d,query:w,fragment:E}=n;return a===void 0?a=this.scheme:a===null&&(a=i),f===void 0?f=this.authority:f===null&&(f=i),d===void 0?d=this.path:d===null&&(d=i),w===void 0?w=this.query:w===null&&(w=i),E===void 0?E=this.fragment:E===null&&(E=i),a===this.scheme&&f===this.authority&&d===this.path&&w===this.query&&E===this.fragment?this:new v(a,f,d,w,E)}static parse(n,a=!1){const f=u.exec(n);return f?new v(f[2]||i,r(f[4]||i),r(f[5]||i),r(f[7]||i),r(f[9]||i),a):new v(i,i,i,i,i)}static file(n){let a=i;if(L.isWindows&&(n=n.replace(/\\/g,I)),n[0]===I&&n[1]===I){const f=n.indexOf(I,2);f===-1?(a=n.substring(2),n=I):(a=n.substring(2,f),n=n.substring(f)||I)}return new v("file",a,n,i,i)}static from(n){const a=new v(n.scheme,n.authority,n.path,n.query,n.fragment);return C(a,!0),a}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return L.isWindows&&n.scheme==="file"?f=m.file(g.win32.join(c(n,!0),...a)).path:f=g.posix.join(n.path,...a),n.with({path:f})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof m)return n;{const a=new v(n);return a._formatted=n.external,a._fsPath=n._sep===l?n.fsPath:null,a}}else return n}}e.URI=m;const l=L.isWindows?1:void 0;class v extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=l),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(o,n){let a,f=-1;for(let d=0;d<o.length;d++){const w=o.charCodeAt(d);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||n&&w===47)f!==-1&&(a+=encodeURIComponent(o.substring(f,d)),f=-1),a!==void 0&&(a+=o.charAt(d));else{a===void 0&&(a=o.substr(0,d));const E=_[w];E!==void 0?(f!==-1&&(a+=encodeURIComponent(o.substring(f,d)),f=-1),a+=E):f===-1&&(f=d)}}return f!==-1&&(a+=encodeURIComponent(o.substring(f))),a!==void 0?a:o}function A(o){let n;for(let a=0;a<o.length;a++){const f=o.charCodeAt(a);f===35||f===63?(n===void 0&&(n=o.substr(0,a)),n+=_[f]):n!==void 0&&(n+=o[a])}return n!==void 0?n:o}function c(o,n){let a;return o.authority&&o.path.length>1&&o.scheme==="file"?a=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?n?a=o.path.substr(1):a=o.path[1].toLowerCase()+o.path.substr(2):a=o.path,L.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=c;function h(o,n){const a=n?A:b;let f="",{scheme:d,authority:w,path:E,query:s,fragment:D}=o;if(d&&(f+=d,f+=":"),(w||d==="file")&&(f+=I,f+=I),w){let R=w.indexOf("@");if(R!==-1){const U=w.substr(0,R);w=w.substr(R+1),R=U.indexOf(":"),R===-1?f+=a(U,!1):(f+=a(U.substr(0,R),!1),f+=":",f+=a(U.substr(R+1),!1)),f+="@"}w=w.toLowerCase(),R=w.indexOf(":"),R===-1?f+=a(w,!1):(f+=a(w.substr(0,R),!1),f+=w.substr(R))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const R=E.charCodeAt(1);R>=65&&R<=90&&(E=`/${String.fromCharCode(R+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const R=E.charCodeAt(0);R>=65&&R<=90&&(E=`${String.fromCharCode(R+32)}:${E.substr(2)}`)}f+=a(E,!0)}return s&&(f+="?",f+=a(s,!1)),D&&(f+="#",f+=n?D:b(D,!1)),f}function p(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+p(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(o){return o.match(t)?o.replace(t,n=>p(n)):o}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(me[22],ge([0,1,8,2]),function(J,e,g,L){"use strict";var k,y,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,r,o){let n=t.get(r);return n===void 0&&(n=o,t.set(r,n)),n}e.getOrSet=C;function S(t){const r=[];return t.forEach((o,n)=>{r.push(`${n} => ${o}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=S;function P(t){const r=[];return t.forEach(o=>{r.push(o)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=P;class i{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const o=r.charCodeAt(0),n=this._value.charCodeAt(this._pos);return o-n}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,g.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,g.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class u{constructor(r=!0,o=!0){this._splitOnBackslash=r,this._caseSensitive=o}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,g.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,g.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=u;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class l{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new u(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,g.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,g.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,g.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,g.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class _{constructor(r){this._iter=r}static forUris(r=()=>!1){return new _(new l(r))}static forPaths(){return new _(new u)}static forStrings(){return new _(new i)}static forConfigKeys(){return new _(new I)}clear(){this._root=void 0}set(r,o){const n=this._iter.reset(r);let a;for(this._root||(this._root=new v,this._root.segment=n.value()),a=this._root;;){const d=n.cmp(a.segment);if(d>0)a.left||(a.left=new v,a.left.segment=n.value()),a=a.left;else if(d<0)a.right||(a.right=new v,a.right.segment=n.value()),a=a.right;else if(n.hasNext())n.next(),a.mid||(a.mid=new v,a.mid.segment=n.value()),a=a.mid;else break}const f=a.value;return a.value=o,a.key=r,f}get(r){return this._getNode(r)?.value}_getNode(r){const o=this._iter.reset(r);let n=this._root;for(;n;){const a=o.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(o.hasNext())o.next(),n=n.mid;else break}return n}has(r){const o=this._getNode(r);return!(o?.value===void 0&&o?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,o){const n=this._iter.reset(r),a=[];let f=this._root;for(;f;){const d=n.cmp(f.segment);if(d>0)a.push([1,f]),f=f.left;else if(d<0)a.push([-1,f]),f=f.right;else if(n.hasNext())n.next(),a.push([0,f]),f=f.mid;else{for(o?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;a.length>0&&f.isEmpty();){let[w,E]=a.pop();switch(w){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}f=E}break}}}findSubstr(r){const o=this._iter.reset(r);let n=this._root,a;for(;n;){const f=o.cmp(n.segment);if(f>0)n=n.left;else if(f<0)n=n.right;else if(o.hasNext())o.next(),a=n.value||a,n=n.mid;else break}return n&&n.value||a}findSuperstr(r){const o=this._iter.reset(r);let n=this._root;for(;n;){const a=o.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(o.hasNext())o.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(r){for(const[o,n]of this)r(n,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const o=[r];for(;o.length>0;){const n=o.pop();n&&(n.value&&(yield[n.key,n.value]),n.left&&o.push(n.left),n.mid&&o.push(n.mid),n.right&&o.push(n.right))}}}e.TernarySearchTree=_;class b{constructor(r,o){this[k]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=o??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,o){return this.map.set(this.toKey(r),o),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,o){typeof o!="undefined"&&(r=r.bind(o));for(let[n,a]of this.map)r(a,L.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield L.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[L.URI.parse(r[0]),r[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[L.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var A;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(A=e.Touch||(e.Touch={}));class c{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,o=0){const n=this._map.get(r);if(!!n)return o!==0&&this.touch(n,o),n.value}set(r,o,n=0){let a=this._map.get(r);if(a)a.value=o,n!==0&&this.touch(a,n);else{switch(a={key:r,value:o,next:void 0,previous:void 0},n){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(r,a),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const o=this._map.get(r);if(!!o)return this._map.delete(r),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,o){const n=this._state;let a=this._head;for(;a;){if(o?r.bind(o)(a.value,a.key,this):r(a.value,a.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const r=this,o=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(n){const f={value:n.key,done:!1};return n=n.next,f}else return{value:void 0,done:!0}}};return a}values(){const r=this,o=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(n){const f={value:n.value,done:!1};return n=n.next,f}else return{value:void 0,done:!0}}};return a}entries(){const r=this,o=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(n){const f={value:[n.key,n.value],done:!1};return n=n.next,f}else return{value:void 0,done:!0}}};return a}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let o=this._head,n=this.size;for(;o&&n>r;)this._map.delete(o.key),o=o.next,n--;this._head=o,this._size=n,o&&(o.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const o=r.next,n=r.previous;if(!o||!n)throw new Error("Invalid list");o.previous=n,n.next=o}r.next=void 0,r.previous=void 0,this._state++}touch(r,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(r===this._head)return;const n=r.next,a=r.previous;r===this._tail?(a.next=void 0,this._tail=a):(n.previous=a,a.next=n),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(o===2){if(r===this._tail)return;const n=r.next,a=r.previous;r===this._head?(n.previous=void 0,this._head=n):(n.previous=a,a.next=n),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((o,n)=>{r.push([n,o])}),r}fromJSON(r){this.clear();for(const[o,n]of r)this.set(o,n)}}e.LinkedMap=c;class h extends c{constructor(r,o=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,o=2){return super.get(r,o)}peek(r){return super.get(r,0)}set(r,o){return super.set(r,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h;class p{constructor(r){T.set(this,void 0),it(this,T,r,"f")}get size(){return He(this,T,"f").size}forEach(r,o){He(this,T,"f").forEach(r,o)}get(r){return He(this,T,"f").get(r)}has(r){return He(this,T,"f").has(r)}entries(){return He(this,T,"f").entries()}keys(){return He(this,T,"f").keys()}values(){return He(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return He(this,T,"f").entries()}}e.ReadonlyMapView=p}),define(me[98],ge([0,1,22,8]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...Y){return function(ae,ve){for(let Me=0,ze=Y.length;Me<ze;Me++){const Ee=Y[Me](ae,ve);if(Ee)return Ee}return null}}e.or=k,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(Y,ae,ve){if(!ve||ve.length<ae.length)return null;let Me;return Y?Me=L.startsWithIgnoreCase(ve,ae):Me=ve.indexOf(ae)===0,Me?ae.length>0?[{start:0,end:ae.length}]:[]:null}function T(Y,ae){const ve=ae.toLowerCase().indexOf(Y.toLowerCase());return ve===-1?null:[{start:ve,end:ve+Y.length}]}e.matchesContiguousSubString=T;function C(Y,ae){return S(Y.toLowerCase(),ae.toLowerCase(),0,0)}e.matchesSubString=C;function S(Y,ae,ve,Me){if(ve===Y.length)return[];if(Me===ae.length)return null;if(Y[ve]===ae[Me]){let ze=null;return(ze=S(Y,ae,ve+1,Me+1))?b({start:Me,end:Me+1},ze):null}return S(Y,ae,ve,Me+1)}function P(Y){return 97<=Y&&Y<=122}function i(Y){return 65<=Y&&Y<=90}e.isUpper=i;function I(Y){return 48<=Y&&Y<=57}function u(Y){return Y===32||Y===9||Y===10||Y===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>m.add(Y.charCodeAt(0)));function l(Y){return u(Y)||m.has(Y)}function v(Y,ae){return Y===ae||l(Y)&&l(ae)}function _(Y){return P(Y)||i(Y)||I(Y)}function b(Y,ae){return ae.length===0?ae=[Y]:Y.end===ae[0].start?ae[0].start=Y.start:ae.unshift(Y),ae}function A(Y,ae){for(let ve=ae;ve<Y.length;ve++){const Me=Y.charCodeAt(ve);if(i(Me)||I(Me)||ve>0&&!_(Y.charCodeAt(ve-1)))return ve}return Y.length}function c(Y,ae,ve,Me){if(ve===Y.length)return[];if(Me===ae.length)return null;if(Y[ve]!==ae[Me].toLowerCase())return null;{let ze=null,Ee=Me+1;for(ze=c(Y,ae,ve+1,Me+1);!ze&&(Ee=A(ae,Ee))<ae.length;)ze=c(Y,ae,ve+1,Ee),Ee++;return ze===null?null:b({start:Me,end:Me+1},ze)}}function h(Y){let ae=0,ve=0,Me=0,ze=0,Ee=0;for(let xe=0;xe<Y.length;xe++)Ee=Y.charCodeAt(xe),i(Ee)&&ae++,P(Ee)&&ve++,_(Ee)&&Me++,I(Ee)&&ze++;const Je=ae/Y.length,X=ve/Y.length,se=Me/Y.length,fe=ze/Y.length;return{upperPercent:Je,lowerPercent:X,alphaPercent:se,numericPercent:fe}}function p(Y){const{upperPercent:ae,lowerPercent:ve}=Y;return ve===0&&ae>.6}function t(Y){const{upperPercent:ae,lowerPercent:ve,alphaPercent:Me,numericPercent:ze}=Y;return ve>.2&&ae<.8&&Me>.6&&ze<.2}function r(Y){let ae=0,ve=0,Me=0,ze=0;for(let Ee=0;Ee<Y.length;Ee++)Me=Y.charCodeAt(Ee),i(Me)&&ae++,P(Me)&&ve++,u(Me)&&ze++;return(ae===0||ve===0)&&ze===0?Y.length<=30:ae<=5}function o(Y,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!r(Y)||ae.length>60)return null;const ve=h(ae);if(!t(ve)){if(!p(ve))return null;ae=ae.toLowerCase()}let Me=null,ze=0;for(Y=Y.toLowerCase();ze<ae.length&&(Me=c(Y,ae,0,ze))===null;)ze=A(ae,ze+1);return Me}e.matchesCamelCase=o;function n(Y,ae,ve=!1){if(!ae||ae.length===0)return null;let Me=null,ze=0;for(Y=Y.toLowerCase(),ae=ae.toLowerCase();ze<ae.length&&(Me=a(Y,ae,0,ze,ve))===null;)ze=f(ae,ze+1);return Me}e.matchesWords=n;function a(Y,ae,ve,Me,ze){if(ve===Y.length)return[];if(Me===ae.length)return null;if(v(Y.charCodeAt(ve),ae.charCodeAt(Me))){let Ee=null,Je=Me+1;if(Ee=a(Y,ae,ve+1,Me+1,ze),!ze)for(;!Ee&&(Je=f(ae,Je))<ae.length;)Ee=a(Y,ae,ve+1,Je,ze),Je++;return Ee===null?null:b({start:Me,end:Me+1},Ee)}else return null}function f(Y,ae){for(let ve=ae;ve<Y.length;ve++)if(l(Y.charCodeAt(ve))||ve>0&&l(Y.charCodeAt(ve-1)))return ve;return Y.length}const d=k(e.matchesPrefix,o,T),w=k(e.matchesPrefix,o,C),E=new g.LRUCache(1e4);function s(Y,ae,ve=!1){if(typeof Y!="string"||typeof ae!="string")return null;let Me=E.get(Y);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Y),"i"),E.set(Y,Me));const ze=Me.exec(ae);return ze?[{start:ze.index,end:ze.index+ze[0].length}]:ve?w(Y,ae):d(Y,ae)}e.matchesFuzzy=s;function D(Y,ae){const ve=qe(Y,Y.toLowerCase(),0,ae,ae.toLowerCase(),0,!0);return ve?U(ve):null}e.matchesFuzzy2=D;function R(Y,ae,ve,Me,ze,Ee){const Je=Math.min(13,Y.length);for(;ve<Je;ve++){const X=qe(Y,ae,ve,Me,ze,Ee,!1);if(X)return X}return[0,Ee]}e.anyScore=R;function U(Y){if(typeof Y=="undefined")return[];const ae=[],ve=Y[1];for(let Me=Y.length-1;Me>1;Me--){const ze=Y[Me]+ve,Ee=ae[ae.length-1];Ee&&Ee.end===ze?Ee.end=ze+1:ae.push({start:ze,end:ze+1})}return ae}e.createMatches=U;const V=128;function ee(){const Y=[],ae=[];for(let ve=0;ve<=V;ve++)ae[ve]=0;for(let ve=0;ve<=V;ve++)Y.push(ae.slice(0));return Y}function K(Y){const ae=[];for(let ve=0;ve<=Y;ve++)ae[ve]=0;return ae}const O=K(2*V),x=K(2*V),F=ee(),z=ee(),M=ee(),N=!1;function q(Y,ae,ve,Me,ze){function Ee(X,se,fe=" "){for(;X.length<se;)X=fe+X;return X}let Je=` |   |${Me.split("").map(X=>Ee(X,3)).join("|")}
`;for(let X=0;X<=ve;X++)X===0?Je+=" |":Je+=`${ae[X-1]}|`,Je+=Y[X].slice(0,ze+1).map(se=>Ee(se.toString(),3)).join("|")+`
`;return Je}function B(Y,ae,ve,Me){Y=Y.substr(ae),ve=ve.substr(Me),console.log(q(z,Y,Y.length,ve,ve.length)),console.log(q(M,Y,Y.length,ve,ve.length)),console.log(q(F,Y,Y.length,ve,ve.length))}function G(Y,ae){if(ae<0||ae>=Y.length)return!1;const ve=Y.codePointAt(ae);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(ve)}}function re(Y,ae){if(ae<0||ae>=Y.length)return!1;switch(Y.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function he(Y,ae,ve){return ae[Y]!==ve[Y]}function ye(Y,ae,ve,Me,ze,Ee,Je=!1){for(;ae<ve&&ze<Ee;)Y[ae]===Me[ze]&&(Je&&(O[ae]=ze),ae+=1),ze+=1;return ae===ve}e.isPatternInWord=ye;var Ie;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Le;(function(Y){Y.Default=[-100,0];function ae(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}Y.isDefault=ae})(Le=e.FuzzyScore||(e.FuzzyScore={}));function qe(Y,ae,ve,Me,ze,Ee,Je){const X=Y.length>V?V:Y.length,se=Me.length>V?V:Me.length;if(ve>=X||Ee>=se||X-ve>se-Ee||!ye(ae,ve,X,ze,Ee,se,!0))return;We(X,se,ve,Ee,ae,ze);let fe=1,xe=1,Be=ve,et=Ee;const Ce=[!1];for(fe=1,Be=ve;Be<X;fe++,Be++){const pe=O[Be],be=x[Be],j=Be+1<X?x[Be+1]:se;for(xe=pe-Ee+1,et=pe;et<j;xe++,et++){let we=Number.MIN_SAFE_INTEGER,_e=!1;et<=be&&(we=je(Y,ae,Be,ve,Me,ze,et,se,Ee,F[fe-1][xe-1]===0,Ce));let Ae=0;we!==Number.MAX_SAFE_INTEGER&&(_e=!0,Ae=we+z[fe-1][xe-1]);const Ue=et>pe,Ge=Ue?z[fe][xe-1]+(F[fe][xe-1]>0?-5:0):0,Ze=et>pe+1&&F[fe][xe-1]>0,Qe=Ze?z[fe][xe-2]+(F[fe][xe-2]>0?-5:0):0;if(Ze&&(!Ue||Qe>=Ge)&&(!_e||Qe>=Ae))z[fe][xe]=Qe,M[fe][xe]=3,F[fe][xe]=0;else if(Ue&&(!_e||Ge>=Ae))z[fe][xe]=Ge,M[fe][xe]=2,F[fe][xe]=0;else if(_e)z[fe][xe]=Ae,M[fe][xe]=1,F[fe][xe]=F[fe-1][xe-1]+1;else throw new Error("not possible")}}if(N&&B(Y,ve,Me,Ee),!Ce[0]&&!Je)return;fe--,xe--;const De=[z[fe][xe],Ee];let Te=0,ce=0;for(;fe>=1;){let pe=xe;do{const be=M[fe][pe];if(be===3)pe=pe-2;else if(be===2)pe=pe-1;else break}while(pe>=1);Te>1&&ae[ve+fe-1]===ze[Ee+xe-1]&&!he(pe+Ee-1,Me,ze)&&Te+1>F[fe][pe]&&(pe=xe),pe===xe?Te++:Te=1,ce||(ce=pe),fe--,xe=pe-1,De.push(xe)}se===X&&(De[0]+=2);const ue=ce-X;return De[0]-=ue,De}e.fuzzyScore=qe;function We(Y,ae,ve,Me,ze,Ee){let Je=Y-1,X=ae-1;for(;Je>=ve&&X>=Me;)ze[Je]===Ee[X]&&(x[Je]=X,Je--),X--}function je(Y,ae,ve,Me,ze,Ee,Je,X,se,fe,xe){if(ae[ve]!==Ee[Je])return Number.MIN_SAFE_INTEGER;let Be=1,et=!1;return Je===ve-Me?Be=Y[ve]===ze[Je]?7:5:he(Je,ze,Ee)&&(Je===0||!he(Je-1,ze,Ee))?(Be=Y[ve]===ze[Je]?7:5,et=!0):G(Ee,Je)&&(Je===0||!G(Ee,Je-1))?Be=5:(G(Ee,Je-1)||re(Ee,Je-1))&&(Be=5,et=!0),Be>1&&ve===Me&&(xe[0]=!0),et||(et=he(Je,ze,Ee)||G(Ee,Je-1)||re(Ee,Je-1)),ve===Me?Je>se&&(Be-=et?3:5):fe?Be+=et?2:0:Be+=et?0:1,Je+1===X&&(Be-=et?3:5),Be}function W(Y,ae,ve,Me,ze,Ee,Je){return ne(Y,ae,ve,Me,ze,Ee,!0,Je)}e.fuzzyScoreGracefulAggressive=W;function Z(Y,ae,ve,Me,ze,Ee,Je){return ne(Y,ae,ve,Me,ze,Ee,!1,Je)}e.fuzzyScoreGraceful=Z;function ne(Y,ae,ve,Me,ze,Ee,Je,X){let se=qe(Y,ae,ve,Me,ze,Ee,X);if(se&&!Je)return se;if(Y.length>=3){const fe=Math.min(7,Y.length-1);for(let xe=ve+1;xe<fe;xe++){const Be=le(Y,xe);if(Be){const et=qe(Be,Be.toLowerCase(),ve,Me,ze,Ee,X);et&&(et[0]-=3,(!se||et[0]>se[0])&&(se=et))}}}return se}function le(Y,ae){if(ae+1>=Y.length)return;const ve=Y[ae],Me=Y[ae+1];if(ve!==Me)return Y.slice(0,ae)+Me+ve+Y.slice(ae+2)}}),define(me[141],ge([0,1,47,98,8]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${y.source}`,"g");function C(v){return v.replace(T,(_,b)=>b?_:`\\${_}`)}e.escapeIcons=C;const S=new RegExp(`\\\\${y.source}`,"g");function P(v){return v.replace(S,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=P;const i=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function I(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(i,(_,b,A,c)=>A?_:b||c||"")}e.stripIcons=I;function u(v){const _=v.indexOf(e.iconStartMarker);return _===-1?{text:v}:m(v,_)}e.parseLabelWithIcons=u;function m(v,_){const b=[];let A="";function c(f){if(f){A+=f;for(const d of f)b.push(t)}}let h=-1,p="",t=0,r,o,n=_;const a=v.length;for(c(v.substr(0,_));n<a;)r=v[n],o=v[n+1],r===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(h=n,c(p),p=e.iconStartMarker,n++):r===")"&&h!==-1?(t+=n-h+1,h=-1,p=""):h!==-1?/^[a-z0-9\-]$/i.test(r)?p+=r:(c(p),h=-1,p=""):c(r),n++;return c(p),{text:A,iconOffsets:b}}function l(v,_,b=!1){const{text:A,iconOffsets:c}=_;if(!c||c.length===0)return(0,L.matchesFuzzy)(v,A,b);const h=(0,k.ltrim)(A," "),p=A.length-h.length,t=(0,L.matchesFuzzy)(v,h,b);if(t)for(const r of t){const o=c[r.start+p]+p;r.start+=o,r.end+=o}return t}e.matchesFuzzyIconAware=l}),define(me[99],ge([0,1,16,141]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(m="",l=!1){if(this.value=m,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1)}appendText(m,l=0){return this.value+=P(this.supportThemeIcons?(0,L.escapeIcons)(m):m).replace(/([ \t]+)/g,(v,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,l){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}}e.MarkdownString=y;function T(u){return C(u)?!u.value:Array.isArray(u)?u.every(T):!0}e.isEmptyMarkdownString=T;function C(u){return u instanceof y?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function S(u,m){return u===m?!0:!u||!m?!1:u.value===m.value&&u.isTrusted===m.isTrusted&&u.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=S;function P(u){return u.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function i(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function I(u){const m=[],l=u.split("|").map(_=>_.trim());u=l[0];const v=l[1];if(v){const _=/height=(\d+)/.exec(v),b=/width=(\d+)/.exec(v),A=_?_[1]:"",c=b?b[1]:"",h=isFinite(parseInt(c)),p=isFinite(parseInt(A));h&&m.push(`width="${c}"`),p&&m.push(`height="${A}"`)}return{href:u,dimensions:m}}e.parseHrefAndDimensions=I}),define(me[59],ge([0,1,24,8,2]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function y(i){return JSON.stringify(i,S)}e.stringify=y;function T(i){let I=JSON.parse(i);return I=P(I),I}e.parse=T;var C;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function S(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function P(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return k.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof g.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let u=0;u<i.length;++u)i[u]=P(i[u],I+1);else for(const u in i)Object.hasOwnProperty.call(i,u)&&(i[u]=P(i[u],I+1))}return i}e.revive=P}),define(me[10],ge([0,1,11,2]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,P,i){this._hosts[S]=P,this._ports[S]=i}setConnectionToken(S,P){this._connectionTokens[S]=P}rewrite(S){if(this._delegate)return this._delegate(S);const P=S.authority;let i=this._hosts[P];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[P],u=this._connectionTokens[P];let m=`path=${encodeURIComponent(S.path)}`;return typeof u=="string"&&(m+=`&tkn=${encodeURIComponent(u)}`),L.URI.from({scheme:g.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new y;class T{asBrowserUri(S,P){const i=this.toUri(S,P);return i.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===k.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${k.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?i.with({scheme:k.vscodeFileResource,authority:i.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(S,P){const i=this.toUri(S,P);return i.scheme===k.vscodeFileResource?i.with({scheme:k.file,authority:i.authority!==T.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(S,P){return L.URI.isUri(S)?S:L.URI.parse(P.toUrl(S))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(me[76],ge([0,1,22]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new g.LRUCache(1e4);function k(P){return S(P,"NFC",L)}e.normalizeNFC=k;const y=new g.LRUCache(1e4);function T(P){return S(P,"NFD",y)}e.normalizeNFD=T;const C=/[^\u0000-\u0080]/;function S(P,i,I){if(!P)return P;const u=I.get(P);if(u)return u;let m;return C.test(P)?m=P.normalize(i):m=P,I.set(P,m),m}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(i){return T(i).replace(P,"")}}()}),define(me[23],ge([0,1,29,10,9,11,8,2]),function(J,e,g,L,k,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(m){return(0,C.uriToFsPath)(m,!0)}e.originalFSPath=S;class P{constructor(l){this._ignorePathCasing=l}compare(l,v,_=!1){return l===v?0:(0,T.compare)(this.getComparisonKey(l,_),this.getComparisonKey(v,_))}isEqual(l,v,_=!1){return l===v?!0:!l||!v?!1:this.getComparisonKey(l,_)===this.getComparisonKey(v,_)}getComparisonKey(l,v=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,v,_=!1){if(l.scheme===v.scheme){if(l.scheme===L.Schemas.file)return g.isEqualOrParent(S(l),S(v),this._ignorePathCasing(l))&&l.query===v.query&&(_||l.fragment===v.fragment);if((0,e.isEqualAuthority)(l.authority,v.authority))return g.isEqualOrParent(l.path,v.path,this._ignorePathCasing(l),"/")&&l.query===v.query&&(_||l.fragment===v.fragment)}return!1}joinPath(l,...v){return C.URI.joinPath(l,...v)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return k.posix.basename(l.path)}extname(l){const v=k.posix.extname(l.path),_=v.indexOf("?");return _!==-1?v.substr(0,_):v}dirname(l){if(l.path.length===0)return l;let v;return l.scheme===L.Schemas.file?v=C.URI.file(k.dirname(S(l))).path:(v=k.posix.dirname(l.path),l.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),v="/")),l.with({path:v})}normalizePath(l){if(!l.path.length)return l;let v;return l.scheme===L.Schemas.file?v=C.URI.file(k.normalize(S(l))).path:v=k.posix.normalize(l.path),l.with({path:v})}relativePath(l,v){if(l.scheme!==v.scheme||!(0,e.isEqualAuthority)(l.authority,v.authority))return;if(l.scheme===L.Schemas.file){const A=k.relative(S(l),S(v));return y.isWindows?g.toSlashes(A):A}let _=l.path||"/",b=v.path||"/";if(this._ignorePathCasing(l)){let A=0;for(const c=Math.min(_.length,b.length);A<c&&!(_.charCodeAt(A)!==b.charCodeAt(A)&&_.charAt(A).toLowerCase()!==b.charAt(A).toLowerCase());A++);_=b.substr(0,A)+_.substr(A)}return k.posix.relative(_,b)}resolvePath(l,v){if(l.scheme===L.Schemas.file){const _=C.URI.file(k.resolve(S(l),v));return l.with({authority:_.authority,path:_.path})}return v=g.toPosixPath(v),l.with({path:k.posix.resolve(l.path,v)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,v){return l===v||(0,T.equalsIgnoreCase)(l,v)}hasTrailingPathSeparator(l,v=k.sep){if(l.scheme===L.Schemas.file){const _=S(l);return _.length>g.getRoot(_).length&&_[_.length-1]===v}else{const _=l.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,v=k.sep){return(0,e.hasTrailingPathSeparator)(l,v)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,v=k.sep){let _=!1;if(l.scheme===L.Schemas.file){const b=S(l);_=b!==void 0&&b.length===g.getRoot(b).length&&b[b.length-1]===v}else{v="/";const b=l.path;_=b.length===1&&b.charCodeAt(b.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(l,v)?l.with({path:l.path+"/"}):l}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(m=>m.scheme===L.Schemas.file?!y.isLinux:!0),e.extUriIgnorePathCase=new P(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(m,l){const v=[];for(let _=0;_<m.length;_++){const b=l(m[_]);m.some((A,c)=>c===_?!1:(0,e.isEqualOrParent)(b,l(A)))||v.push(m[_])}return v}e.distinctParents=i;var I;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function l(v){const _=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(c=>{const[h,p]=c.split(":");h&&p&&_.set(h,p)});const A=v.path.substring(0,v.path.indexOf(";"));return A&&_.set(m.META_DATA_MIME,A),_}m.parseMetaData=l})(I=e.DataUri||(e.DataUri={}));function u(m,l,v){if(l){let _=m.path;return _&&_[0]!==k.posix.sep&&(_=k.posix.sep+_),m.with({scheme:v,authority:l,path:_})}return m.with({scheme:v})}e.toLocalResource=u}),define(me[17],ge([0,1,21,16,3,6,23]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(x){return!!x&&typeof x.then=="function"}e.isThenable=C;function S(x){const F=new g.CancellationTokenSource,z=x(F.token),M=new Promise((N,q)=>{const B=F.token.onCancellationRequested(()=>{B.dispose(),F.dispose(),q((0,L.canceled)())});Promise.resolve(z).then(G=>{B.dispose(),F.dispose(),N(G)},G=>{B.dispose(),F.dispose(),q(G)})});return new class{cancel(){F.cancel()}then(N,q){return M.then(N,q)}catch(N){return this.then(void 0,N)}finally(N){return M.finally(N)}}}e.createCancelablePromise=S;function P(x,F,z){return Promise.race([x,new Promise(M=>F.onCancellationRequested(()=>M(z)))])}e.raceCancellation=P;async function i(x){let F=-1;const z=x.map((N,q)=>N.then(B=>(F=q,B))),M=await Promise.race(z);return x.forEach((N,q)=>{q!==F&&N.cancel()}),M}e.raceCancellablePromises=i;function I(x,F,z){let M;const N=setTimeout(()=>{M?.(void 0),z?.()},F);return Promise.race([x.finally(()=>clearTimeout(N)),new Promise(q=>M=q)])}e.raceTimeout=I;function u(x){return new Promise((F,z)=>{const M=x();C(M)?M.then(F,z):F(M)})}e.asPromise=u;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const z=()=>{this.queuedPromise=null;const M=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,M};this.queuedPromise=new Promise(M=>{this.activePromise.then(z,z).then(M)})}return new Promise((z,M)=>{this.queuedPromise.then(z,M)})}return this.activePromise=F(),new Promise((z,M)=>{this.activePromise.then(N=>{this.activePromise=null,z(N)},N=>{this.activePromise=null,M(N)})})}}e.Throttler=m;class l{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=l;class v{constructor(){this.promiseMap=new Map}queue(F,z){const N=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.promiseMap.get(F)===N&&this.promiseMap.delete(F)});return this.promiseMap.set(F,N),N}}e.SequencerByKey=v;class _{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,z=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((M,N)=>{this.doResolve=M,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const M=this.task;return this.task=null,M()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=_;class b{constructor(F){this.delayer=new _(F),this.throttler=new m}trigger(F,z){return this.delayer.trigger(()=>this.throttler.queue(F),z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class A{constructor(){this._isOpen=!1,this._promise=new Promise((F,z)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=A;class c extends A{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function h(x,F){return F?new Promise((z,M)=>{const N=setTimeout(()=>{q.dispose(),z()},x),q=F.onCancellationRequested(()=>{clearTimeout(N),q.dispose(),M((0,L.canceled)())})}):S(z=>h(x,z))}e.timeout=h;function p(x,F=0){const z=setTimeout(x,F);return(0,y.toDisposable)(()=>clearTimeout(z))}e.disposableTimeout=p;function t(x){const F=[];let z=0;const M=x.length;function N(){return z<M?x[z++]():null}function q(B){B!=null&&F.push(B);const G=N();return G?G.then(q):Promise.resolve(F)}return Promise.resolve(null).then(q)}e.sequence=t;function r(x,F=M=>!!M,z=null){let M=0;const N=x.length,q=()=>{if(M>=N)return Promise.resolve(z);const B=x[M++];return Promise.resolve(B()).then(re=>F(re)?Promise.resolve(re):q())};return q()}e.first=r;function o(x,F=M=>!!M,z=null){if(x.length===0)return Promise.resolve(z);let M=x.length;const N=()=>{M=-1;for(const q of x)q.cancel?.()};return new Promise((q,B)=>{for(const G of x)G.then(re=>{--M>=0&&F(re)?(N(),q(re)):M===0&&q(z)}).catch(re=>{--M>=0&&(N(),B(re))})})}e.firstParallel=o;class n{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((z,M)=>{this.outstandingPromises.push({factory:F,c:z,e:M}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const z=F.factory();z.then(F.c,F.e),z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class a extends n{constructor(){super(1)}}e.Queue=a;class f{constructor(){this.queues=new Map}queueFor(F,z=T.extUri){const M=z.getComparisonKey(F);let N=this.queues.get(M);return N||(N=new a,k.Event.once(N.onFinished)(()=>{N?.dispose(),this.queues.delete(M)}),this.queues.set(M,N)),N}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=f;class d{constructor(F,z){this._token=-1,typeof F=="function"&&typeof z=="number"&&this.setIfNotSet(F,z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},z)}setIfNotSet(F,z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},z))}}e.TimeoutTimer=d;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,z){this.cancel(),this._token=setInterval(()=>{F()},z)}}e.IntervalTimer=w;class E{constructor(F,z){this.timeoutToken=-1,this.runner=F,this.timeout=z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class s extends E{constructor(F,z){super(F,z);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=s;class D extends y.Disposable{constructor(F,z,M,N){super();this.maxWorkChunkSize=F,this.maxPendingWork=z,this.throttleDelay=M,this.handler=N,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=D,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const z=setTimeout(()=>F(x));let M=!1;return{dispose(){M||(M=!0,clearTimeout(z))}}}}else e.runWhenIdle=(x,F)=>{const z=requestIdleCallback(x,typeof F=="number"?{timeout:F}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(z))}}}}();class R{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(z){this._error=z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=R;async function U(x,F,z){let M;for(let N=0;N<z;N++)try{return await x()}catch(q){M=q,await h(F)}throw M}e.retry=U;class V{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,z,M){return this._pending={taskId:F,cancel:()=>M?.(),promise:z},z.then(()=>this.donePending(F),()=>this.donePending(F)),z}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let z,M;const N=new Promise((q,B)=>{z=q,M=B});this._next={run:F,promise:N,promiseResolve:z,promiseReject:M}}return this._next.promise}}e.TaskSequentializer=V;class ee{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;class K{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,z)=>{this.completeCallback=F,this.errorCallback=z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(z=>{this.completeCallback(F),this.resolved=!0,z()})}error(F){return new Promise(z=>{this.errorCallback(F),this.rejected=!0,z()})}cancel(){new Promise(F=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=K;var O;(function(x){async function F(z){let M;const N=await Promise.all(z.map(q=>q.then(B=>B,B=>{M||(M=B)})));if(typeof M!="undefined")throw M;return N}x.settled=F})(O=e.Promises||(e.Promises={}))}),define(me[100],ge([0,1,17,9]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new g.IdleValue(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),y=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(E,s,D=!1){const R=E||"",U=s||"",V=k.value.collator.compare(R,U);return k.value.collatorIsNumeric&&V===0&&R!==U?R<U?-1:1:V}e.compareFileNames=C;function S(E,s){const D=y.value.collator;return E=E||"",s=s||"",p(D,E,s)}e.compareFileNamesDefault=S;function P(E,s){const D=y.value.collator;return E=E||"",s=s||"",n(E,s)||p(D,E,s)}e.compareFileNamesUpper=P;function i(E,s){const D=y.value.collator;return E=E||"",s=s||"",o(E,s)||p(D,E,s)}e.compareFileNamesLower=i;function I(E,s){return E=E||"",s=s||"",E===s?0:E<s?-1:1}e.compareFileNamesUnicode=I;function u(E,s,D=!1){D||(E=E&&E.toLowerCase(),s=s&&s.toLowerCase());const[R,U]=c(E),[V,ee]=c(s);return R!==V?R<V?-1:1:U===ee?0:U<ee?-1:1}e.noIntlCompareFileNames=u;function m(E,s){const[D,R]=c(E),[U,V]=c(s);let ee=k.value.collator.compare(R,V);if(ee===0){if(k.value.collatorIsNumeric&&R!==V)return R<V?-1:1;if(ee=k.value.collator.compare(D,U),k.value.collatorIsNumeric&&ee===0&&D!==U)return D<U?-1:1}return ee}e.compareFileExtensions=m;function l(E,s){E=E||"",s=s||"";const D=h(E),R=h(s),U=y.value.collator,V=T.value.collator;return p(V,D,R)||p(U,E,s)}e.compareFileExtensionsDefault=l;function v(E,s){E=E||"",s=s||"";const D=h(E),R=h(s),U=y.value.collator,V=T.value.collator;return p(V,D,R)||n(E,s)||p(U,E,s)}e.compareFileExtensionsUpper=v;function _(E,s){E=E||"",s=s||"";const D=h(E),R=h(s),U=y.value.collator,V=T.value.collator;return p(V,D,R)||o(E,s)||p(U,E,s)}e.compareFileExtensionsLower=_;function b(E,s){E=E||"",s=s||"";const D=h(E).toLowerCase(),R=h(s).toLowerCase();return D!==R?D<R?-1:1:E!==s?E<s?-1:1:0}e.compareFileExtensionsUnicode=b;const A=/^(.*?)(\.([^.]*))?$/;function c(E,s=!1){const D=E?A.exec(E):[];let R=[D&&D[1]||"",D&&D[3]||""];return s&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function h(E){const s=E?A.exec(E):[];return s&&s[1]&&s[1].charAt(0)!=="."&&s[3]||""}function p(E,s,D){let R=E.compare(s,D);return R!==0?R:s.length!==D.length?s.length<D.length?-1:1:0}function t(E){const s=E.charAt(0);return s.toLocaleUpperCase()!==s}function r(E){const s=E.charAt(0);return s.toLocaleLowerCase()!==s}function o(E,s){return t(E)&&r(s)?-1:r(E)&&t(s)?1:0}function n(E,s){return r(E)&&t(s)?-1:t(E)&&r(s)?1:0}function a(E,s,D=!1){return D||(E=E&&E.toLowerCase(),s=s&&s.toLowerCase()),E===s?0:E<s?-1:1}function f(E,s,D=!1){const R=E.split(L.sep),U=s.split(L.sep),V=R.length-1,ee=U.length-1;let K,O;for(let x=0;;x++){if(K=V===x,O=ee===x,K&&O)return C(R[x],U[x],D);if(K)return-1;if(O)return 1;const F=a(R[x],U[x],D);if(F!==0)return F}}e.comparePaths=f;function d(E,s,D){const R=E.toLowerCase(),U=s.toLowerCase(),V=w(E,s,D);if(V)return V;const ee=R.endsWith(D),K=U.endsWith(D);if(ee!==K)return ee?-1:1;const O=C(R,U);return O!==0?O:R.localeCompare(U)}e.compareAnything=d;function w(E,s,D){const R=E.toLowerCase(),U=s.toLowerCase(),V=R.startsWith(D),ee=U.startsWith(D);if(V!==ee)return V?-1:1;if(V&&ee){if(R.length<U.length)return-1;if(R.length>U.length)return 1}return 0}e.compareByPrefix=w}),define(me[101],ge([0,1,100,98,9,11,8]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const C=0,S=[C,[]];function P(K,O,x,F){if(!K||!O)return S;const z=K.length,M=O.length;if(z<M)return S;const N=K.toLowerCase();return!F&&!N.includes(x)?S:i(O,x,M,K,N,z)}e.scoreFuzzy=P;function i(K,O,x,F,z,M){const N=[],q=[];for(let he=0;he<x;he++){const ye=he*M,Ie=ye-M,Le=he>0,qe=K[he],We=O[he];for(let je=0;je<M;je++){const W=je>0,Z=ye+je,ne=Z-1,le=Ie+je-1,Y=W?N[ne]:0,ae=Le&&W?N[le]:0,ve=Le&&W?q[le]:0;let Me;!ae&&Le?Me=0:Me=I(qe,We,F,z,je,ve),Me&&ae+Me>=Y?(q[Z]=ve+1,N[Z]=ae+Me):(q[Z]=C,N[Z]=Y)}}const B=[];let G=x-1,re=M-1;for(;G>=0&&re>=0;){const he=G*M+re;q[he]===C||(B.push(re),G--),re--}return[N[x*M-1],B.reverse()]}function I(K,O,x,F,z,M){let N=0;if(!u(O,F[z]))return N;if(N+=1,M>0&&(N+=M*5),K===x[z]&&(N+=1),z===0)N+=8;else{const q=m(x.charCodeAt(z-1));q?N+=q:(0,L.isUpper)(x.charCodeAt(z))&&(N+=2)}return N}function u(K,O){return K===O?!0:K==="/"||K==="\\"?O==="/"||O==="\\":!1}function m(K){switch(K){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function v(K,O,x=0,F=0){const z=O;return z.values&&z.values.length>1?_(K,z.values,x,F):b(K,O,x,F)}e.scoreFuzzy2=v;function _(K,O,x,F){let z=0;const M=[];for(const N of O){const[q,B]=b(K,N,x,F);if(typeof q!="number")return l;z+=q,M.push(...B)}return[z,f(M)]}function b(K,O,x,F){const z=(0,L.fuzzyScore)(O.original,O.originalLowercase,x,K,K.toLowerCase(),F,!0);return z?[z[0],(0,L.createMatches)(z)]:l}const A=Object.freeze({score:0}),c=1<<18,h=1<<17,p=1<<16;function t(K,O,x,F,z){if(!K||!O.normalized)return A;const M=F.getItemLabel(K);if(!M)return A;const N=F.getItemDescription(K);let q;N?q=`${M}${N}${O.normalized}${Array.isArray(O.values)?O.values.length:""}${x}`:q=`${M}${O.normalized}${Array.isArray(O.values)?O.values.length:""}${x}`;const B=z[q];if(B)return B;const G=r(M,N,F.getItemPath(K),O,x);return z[q]=G,G}e.scoreItemFuzzy=t;function r(K,O,x,F,z){const M=!x||!F.containsPathSeparator;return x&&(y.isLinux?F.pathNormalized===x:(0,T.equalsIgnoreCase)(F.pathNormalized,x))?{score:c,labelMatch:[{start:0,end:K.length}],descriptionMatch:O?[{start:0,end:O.length}]:void 0}:F.values&&F.values.length>1?o(K,O,x,F.values,M,z):n(K,O,x,F,M,z)}function o(K,O,x,F,z,M){let N=0;const q=[],B=[];for(const G of F){const{score:re,labelMatch:he,descriptionMatch:ye}=n(K,O,x,G,z,M);if(re===C)return A;N+=re,he&&q.push(...he),ye&&B.push(...ye)}return{score:N,labelMatch:f(q),descriptionMatch:f(B)}}function n(K,O,x,F,z,M){if(z||!O){const[N,q]=P(K,F.normalized,F.normalizedLowercase,M);if(N){const B=(0,L.matchesPrefix)(F.normalized,K);let G;return B?(G=h,G+=Math.round(F.normalized.length/K.length*100)):G=p,{score:G+N,labelMatch:B||a(q)}}}if(O){let N=O;x&&(N=`${O}${k.sep}`);const q=N.length,B=`${N}${K}`,[G,re]=P(B,F.normalized,F.normalizedLowercase,M);if(G){const he=a(re),ye=[],Ie=[];return he.forEach(Le=>{Le.start<q&&Le.end>q?(ye.push({start:0,end:Le.end-q}),Ie.push({start:Le.start,end:q})):Le.start>=q?ye.push({start:Le.start-q,end:Le.end-q}):Ie.push(Le)}),{score:G,labelMatch:ye,descriptionMatch:Ie}}}return A}function a(K){const O=[];if(!K)return O;let x;for(const F of K)x&&x.end===F?x.end+=1:(x={start:F,end:F+1},O.push(x));return O}function f(K){const O=K.sort((z,M)=>z.start-M.start),x=[];let F;for(const z of O)!F||!d(F,z)?(F=z,x.push(z)):(F.start=Math.min(F.start,z.start),F.end=Math.max(F.end,z.end));return x}function d(K,O){return!(K.end<O.start||O.end<K.start)}function w(K,O,x,F,z,M){const N=t(K,x,F,z,M),q=t(O,x,F,z,M),B=N.score,G=q.score;if((B===c||G===c)&&B!==G)return B===c?-1:1;if(B>p||G>p){if(B!==G)return B>G?-1:1;if(B<h&&G<h){const We=s(N.labelMatch,q.labelMatch);if(We!==0)return We}const Le=z.getItemLabel(K)||"",qe=z.getItemLabel(O)||"";if(Le.length!==qe.length)return Le.length-qe.length}if(B!==G)return B>G?-1:1;const re=Array.isArray(N.labelMatch)&&N.labelMatch.length>0,he=Array.isArray(q.labelMatch)&&q.labelMatch.length>0;if(re&&!he)return-1;if(he&&!re)return 1;const ye=E(K,N,z),Ie=E(O,q,z);return ye&&Ie&&ye!==Ie?Ie>ye?-1:1:D(K,O,x,z)}e.compareItemsByFuzzyScore=w;function E(K,O,x){let F=-1,z=-1;if(O.descriptionMatch&&O.descriptionMatch.length?F=O.descriptionMatch[0].start:O.labelMatch&&O.labelMatch.length&&(F=O.labelMatch[0].start),O.labelMatch&&O.labelMatch.length){if(z=O.labelMatch[O.labelMatch.length-1].end,O.descriptionMatch&&O.descriptionMatch.length){const M=x.getItemDescription(K);M&&(z+=M.length)}}else O.descriptionMatch&&O.descriptionMatch.length&&(z=O.descriptionMatch[O.descriptionMatch.length-1].end);return z-F}function s(K,O){if(!K&&!O||(!K||!K.length)&&(!O||!O.length))return 0;if(!O||!O.length)return-1;if(!K||!K.length)return 1;const x=K[0].start,z=K[K.length-1].end-x,M=O[0].start,q=O[O.length-1].end-M;return z===q?0:q<z?1:-1}function D(K,O,x,F){const z=F.getItemLabel(K)||"",M=F.getItemLabel(O)||"",N=F.getItemDescription(K),q=F.getItemDescription(O),B=z.length+(N?N.length:0),G=M.length+(q?q.length:0);if(B!==G)return B-G;const re=F.getItemPath(K),he=F.getItemPath(O);return re&&he&&re.length!==he.length?re.length-he.length:z!==M?(0,g.compareAnything)(z,M,x.normalized):N&&q&&N!==q?(0,g.compareAnything)(N,q,x.normalized):re&&he&&re!==he?(0,g.compareAnything)(re,he,x.normalized):0}const R=" ";function U(K){typeof K!="string"&&(K="");const O=K.toLowerCase(),{pathNormalized:x,normalized:F,normalizedLowercase:z}=V(K),M=x.indexOf(k.sep)>=0;let N;const q=K.split(R);if(q.length>1)for(const B of q){const{pathNormalized:G,normalized:re,normalizedLowercase:he}=V(B);re&&(N||(N=[]),N.push({original:B,originalLowercase:B.toLowerCase(),pathNormalized:G,normalized:re,normalizedLowercase:he}))}return{original:K,originalLowercase:O,pathNormalized:x,normalized:F,normalizedLowercase:z,values:N,containsPathSeparator:M}}e.prepareQuery=U;function V(K){let O;y.isWindows?O=K.replace(/\//g,k.sep):O=K.replace(/\\/g,k.sep);const x=(0,T.stripWildcards)(O).replace(/\s/g,"");return{pathNormalized:O,normalized:x,normalizedLowercase:x.toLowerCase()}}function ee(K){return Array.isArray(K)?U(K.map(O=>O.original).join(R)):U(K.original)}e.pieceToQuery=ee}),define(me[30],ge([0,1,17,29,22,9,8]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const S="**",P="/",i="[/\\\\]",I="[^/\\\\]",u=/\//g;function m(N){switch(N){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function l(N,q){if(!N)return[];const B=[];let G=!1,re=!1,he="";for(const ye of N){switch(ye){case q:if(!G&&!re){B.push(he),he="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":re=!0;break;case"]":re=!1;break}he+=ye}return he&&B.push(he),B}e.splitGlobAware=l;function v(N){if(!N)return"";let q="";const B=l(N,P);if(B.every(G=>G===S))q=".*";else{let G=!1;B.forEach((re,he)=>{if(re===S){G||(q+=m(2),G=!0);return}let ye=!1,Ie="",Le=!1,qe="";for(const We of re){if(We!=="}"&&ye){Ie+=We;continue}if(Le&&(We!=="]"||!qe)){let je;We==="-"?je=We:(We==="^"||We==="!")&&!qe?je="^":We===P?je="":je=T.escapeRegExpCharacters(We),qe+=je;continue}switch(We){case"{":ye=!0;continue;case"[":Le=!0;continue;case"}":q+=`(?:${l(Ie,",").map(Z=>v(Z)).join("|")})`,ye=!1,Ie="";break;case"]":q+="["+qe+"]",Le=!1,qe="";break;case"?":q+=I;continue;case"*":q+=m(1);continue;default:q+=T.escapeRegExpCharacters(We)}}he<B.length-1&&(B[he+1]!==S||he+2<B.length)&&(q+=i),G=!1})}return q}const _=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,A=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),r=function(){return!1},o=function(){return null};function n(N,q){if(!N)return o;let B;typeof N!="string"?B=N.pattern:B=N,B=B.trim();const G=`${B}_${!!q.trimForExclusions}`;let re=t.get(G);if(re)return a(re,N);let he;if(_.test(B)){const ye=B.substr(4);re=function(Ie,Le){return typeof Ie=="string"&&Ie.endsWith(ye)?B:null}}else(he=b.exec(f(B,q)))?re=d(he[1],B):(q.trimForExclusions?c:A).test(B)?re=w(B,q):(he=h.exec(f(B,q)))?re=E(he[1].substr(1),B,!0):(he=p.exec(f(B,q)))?re=E(he[1],B,!1):re=s(B);return t.set(G,re),a(re,N)}function a(N,q){return typeof q=="string"?N:function(B,G){return L.isEqualOrParent(B,q.base)?N(y.relative(q.base,B),G):null}}function f(N,q){return q.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function d(N,q){const B=`/${N}`,G=`\\${N}`,re=function(ye,Ie){return typeof ye!="string"?null:Ie?Ie===N?q:null:ye===N||ye.endsWith(B)||ye.endsWith(G)?q:null},he=[N];return re.basenames=he,re.patterns=[q],re.allBasenames=he,re}function w(N,q){const B=M(N.slice(1,-1).split(",").map(Ie=>n(Ie,q)).filter(Ie=>Ie!==o),N),G=B.length;if(!G)return o;if(G===1)return B[0];const re=function(Ie,Le){for(let qe=0,We=B.length;qe<We;qe++)if(B[qe](Ie,Le))return N;return null},he=B.find(Ie=>!!Ie.allBasenames);he&&(re.allBasenames=he.allBasenames);const ye=B.reduce((Ie,Le)=>Le.allPaths?Ie.concat(Le.allPaths):Ie,[]);return ye.length&&(re.allPaths=ye),re}function E(N,q,B){const G=y.sep===y.posix.sep,re=G?N:N.replace(u,y.sep),he=y.sep+re,ye=y.posix.sep+N,Ie=B?function(Le,qe){return typeof Le=="string"&&(Le===re||Le.endsWith(he)||!G&&(Le===N||Le.endsWith(ye)))?q:null}:function(Le,qe){return typeof Le=="string"&&(Le===re||!G&&Le===N)?q:null};return Ie.allPaths=[(B?"*/":"./")+N],Ie}function s(N){try{const q=new RegExp(`^${v(N)}$`);return function(B){return q.lastIndex=0,typeof B=="string"&&q.test(B)?N:null}}catch(q){return o}}function D(N,q,B){return!N||typeof q!="string"?!1:R(N)(q,void 0,B)}e.match=D;function R(N,q={}){if(!N)return r;if(typeof N=="string"||K(N)){const B=n(N,q);if(B===o)return r;const G=function(re,he){return!!B(re,he)};return B.allBasenames&&(G.allBasenames=B.allBasenames),B.allPaths&&(G.allPaths=B.allPaths),G}return F(N,q)}e.parse=R;function U(N){if(!N)return;let q;return B=>(q||(q=(N()||Promise.resolve([])).then(G=>G?ee(G):{})),q.then(G=>!!G[B]))}e.hasSiblingPromiseFn=U;function V(N){if(!N)return;let q;return B=>{if(!q){const G=N();q=G?ee(G):{}}return!!q[B]}}e.hasSiblingFn=V;function ee(N){const q={};for(const B of N)q[B]=!0;return q}function K(N){const q=N;return q&&typeof q.base=="string"&&typeof q.pattern=="string"}e.isRelativePattern=K;function O(N){return N.allBasenames||[]}e.getBasenameTerms=O;function x(N){return N.allPaths||[]}e.getPathTerms=x;function F(N,q){const B=M(Object.getOwnPropertyNames(N).map(Ie=>z(Ie,N[Ie],q)).filter(Ie=>Ie!==o)),G=B.length;if(!G)return o;if(!B.some(Ie=>!!Ie.requiresSiblings)){if(G===1)return B[0];const Ie=function(We,je){for(let W=0,Z=B.length;W<Z;W++){const ne=B[W](We,je);if(ne)return ne}return null},Le=B.find(We=>!!We.allBasenames);Le&&(Ie.allBasenames=Le.allBasenames);const qe=B.reduce((We,je)=>je.allPaths?We.concat(je.allPaths):We,[]);return qe.length&&(Ie.allPaths=qe),Ie}const re=function(Ie,Le,qe){let We;for(let je=0,W=B.length;je<W;je++){const Z=B[je];Z.requiresSiblings&&qe&&(Le||(Le=y.basename(Ie)),We||(We=Le.substr(0,Le.length-y.extname(Ie).length)));const ne=Z(Ie,Le,We,qe);if(ne)return ne}return null},he=B.find(Ie=>!!Ie.allBasenames);he&&(re.allBasenames=he.allBasenames);const ye=B.reduce((Ie,Le)=>Le.allPaths?Ie.concat(Le.allPaths):Ie,[]);return ye.length&&(re.allPaths=ye),re}function z(N,q,B){if(q===!1)return o;const G=n(N,B);if(G===o)return o;if(typeof q=="boolean")return G;if(q){const re=q.when;if(typeof re=="string"){const he=(ye,Ie,Le,qe)=>{if(!qe||!G(ye,Ie))return null;const We=re.replace("$(basename)",Le),je=qe(We);return(0,g.isThenable)(je)?je.then(W=>W?N:null):je?N:null};return he.requiresSiblings=!0,he}}return G}function M(N,q){const B=N.filter(Ie=>!!Ie.basenames);if(B.length<2)return N;const G=B.reduce((Ie,Le)=>{const qe=Le.basenames;return qe?Ie.concat(qe):Ie},[]);let re;if(q){re=[];for(let Ie=0,Le=G.length;Ie<Le;Ie++)re.push(q)}else re=B.reduce((Ie,Le)=>{const qe=Le.patterns;return qe?Ie.concat(qe):Ie},[]);const he=function(Ie,Le){if(typeof Ie!="string")return null;if(!Le){let We;for(We=Ie.length;We>0;We--){const je=Ie.charCodeAt(We-1);if(je===47||je===92)break}Le=Ie.substr(We)}const qe=G.indexOf(Le);return qe!==-1?re[qe]:null};he.basenames=G,he.patterns=re,he.allBasenames=G;const ye=N.filter(Ie=>!Ie.basenames);return ye.push(he),ye}}),define(me[77],ge([0,1,29,10,9,11,23,8,2]),function(J,e,g,L,k,y,T,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(n,a,f){if(typeof n=="string"&&(n=S.URI.file(n)),f){const w=f.getWorkspaceFolder(n);if(w){const E=f.getWorkspace().folders.length>1;let s;if((0,T.isEqual)(w.uri,n)?s="":s=(0,T.relativePath)(w.uri,n),E){const D=w.name?w.name:(0,T.basename)(w.uri);s=s?D+" \u2022 "+s:D}return s}}if(n.scheme!==L.Schemas.file&&n.scheme!==L.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(n.fsPath))return(0,k.normalize)(I(n.fsPath));let d=(0,k.normalize)(n.fsPath);return!y.isWindows&&a?.userHome&&(d=m(d,a.userHome.fsPath)),d}e.getPathLabel=P;function i(n){if(!n)return;typeof n=="string"&&(n=S.URI.file(n));const a=(0,T.basename)(n)||(n.scheme===L.Schemas.file?n.fsPath:n.path);return y.isWindows&&(0,g.isRootOrDriveLetter)(a)?I(a):a}e.getBaseLabel=i;function I(n){return(0,g.hasDriveLetter)(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=I;let u=Object.create(null);function m(n,a){if(y.isWindows||!n||!a)return n;let f=u.original===a?u.normalized:void 0;return f||(f=`${(0,C.rtrim)(a,k.posix.sep)}${k.posix.sep}`,u={original:a,normalized:f}),(y.isLinux?n.startsWith(f):(0,C.startsWithIgnoreCase)(n,f))&&(n=`~/${n.substr(f.length)}`),n}e.tildify=m;function l(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=l;const v="\u2026",_="\\\\",b="~";function A(n,a=k.sep){const f=new Array(n.length);let d=!1;for(let w=0;w<n.length;w++){let E=n[w];if(E===""){f[w]=`.${a}`;continue}if(!E){f[w]=E;continue}d=!0;let s="";E.indexOf(_)===0?(s=E.substr(0,E.indexOf(_)+_.length),E=E.substr(E.indexOf(_)+_.length)):E.indexOf(a)===0?(s=E.substr(0,E.indexOf(a)+a.length),E=E.substr(E.indexOf(a)+a.length)):E.indexOf(b)===0&&(s=E.substr(0,E.indexOf(b)+b.length),E=E.substr(E.indexOf(b)+b.length));const D=E.split(a);for(let R=1;d&&R<=D.length;R++)for(let U=D.length-R;d&&U>=0;U--){d=!1;let V=D.slice(U,U+R).join(a);for(let ee=0;!d&&ee<n.length;ee++)if(ee!==w&&n[ee]&&n[ee].indexOf(V)>-1){const K=U+R===D.length,O=U>0&&n[ee].indexOf(a)>-1?a+V:V,x=n[ee].endsWith(O);d=!K||x}if(!d){let ee="";(D[0].endsWith(":")||s!=="")&&(U===1&&(U=0,R++,V=D[0]+a+V),U>0&&(ee=D[0]+a),ee=s+ee),U>0&&(ee=ee+v+a),ee=ee+V,U+R<D.length&&(ee=ee+a+v),f[w]=ee}}d&&(f[w]=E)}return f}e.shorten=A;var c;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function h(n,a=Object.create(null)){const f=[];let d=!1,w="";for(const E of n)if(E==="$"||d&&E==="{")w&&f.push({value:w,type:c.TEXT}),w="",d=!0;else if(E==="}"&&d){const s=a[w];if(typeof s=="string")s.length&&f.push({value:s,type:c.VARIABLE});else if(s){const D=f[f.length-1];(!D||D.type!==c.SEPARATOR)&&f.push({value:s.label,type:c.SEPARATOR})}w="",d=!1}else w+=E;return w&&!d&&f.push({value:w,type:c.TEXT}),f.filter((E,s)=>{if(E.type===c.SEPARATOR){const D=f[s-1],R=f[s+1];return[D,R].every(U=>U&&(U.type===c.VARIABLE||U.type===c.TEXT)&&U.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=h;function p(n,a){return y.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):n.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function t(n,a){return y.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):y.isWindows?n.replace(/&&|&/g,f=>f==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(n){const a=n.indexOf("/")!==-1?k.posix:k.win32,f=a.basename(n),d=a.dirname(n);return f.length?{name:f,parentPath:d}:{name:d,parentPath:""}}e.splitName=o}),define(me[102],ge([0,1,30,10,9,23,8]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(C=e.Mimes||(e.Mimes={}));let S=[],P=[],i=[];function I(r,o=!1){const n=u(r);S.push(n),n.userConfigured?i.push(n):P.push(n),o&&!n.userConfigured&&S.forEach(a=>{a.mime===n.mime||a.userConfigured||(n.extension&&a.extension===n.extension&&console.warn(`Overwriting extension <<${n.extension}>> to now point to mime <<${n.mime}>>`),n.filename&&a.filename===n.filename&&console.warn(`Overwriting filename <<${n.filename}>> to now point to mime <<${n.mime}>>`),n.filepattern&&a.filepattern===n.filepattern&&console.warn(`Overwriting filepattern <<${n.filepattern}>> to now point to mime <<${n.mime}>>`),n.firstline&&a.firstline===n.firstline&&console.warn(`Overwriting firstline <<${n.firstline}>> to now point to mime <<${n.mime}>>`))})}e.registerTextMime=I;function u(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(k.posix.sep)>=0:!1}}function m(r){r?(S=S.filter(o=>!o.userConfigured),i=[]):(S=[],P=[],i=[])}e.clearTextMimes=m;function l(r,o){let n;if(r)switch(r.scheme){case L.Schemas.file:n=r.fsPath;break;case L.Schemas.data:n=y.DataUri.parseMetaData(r).get(y.DataUri.META_DATA_LABEL);break;default:n=r.path}if(!n)return[C.unknown];n=n.toLowerCase();const a=(0,k.basename)(n),f=v(n,a,i);if(f)return[f,C.text];const d=v(n,a,P);if(d)return[d,C.text];if(o){const w=_(o);if(w)return[w,C.text]}return[C.unknown]}e.guessMimeTypes=l;function v(r,o,n){let a=null,f=null,d=null;for(let w=n.length-1;w>=0;w--){const E=n[w];if(o===E.filenameLowercase){a=E;break}if(E.filepattern&&(!f||E.filepattern.length>f.filepattern.length)){const s=E.filepatternOnPath?r:o;(0,g.match)(E.filepatternLowercase,s)&&(f=E)}E.extension&&(!d||E.extension.length>d.extension.length)&&o.endsWith(E.extensionLowercase)&&(d=E)}return a?a.mime:f?f.mime:d?d.mime:null}function _(r){if((0,T.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let o=S.length-1;o>=0;o--){const n=S[o];if(!n.firstline)continue;const a=r.match(n.firstline);if(a&&a.length>0)return n.mime}return null}function b(r){return r?typeof r=="string"?r===C.binary||r===C.text||r===C.unknown:r.length===1&&b(r[0]):!0}e.isUnspecific=b;const A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(r){const o=(0,k.extname)(r);return A[o.toLowerCase()]}e.getMediaMime=c;function h(r){for(const o in A)if(A[o]===r)return o}e.getExtensionForMimeType=h;const p=/^(.+)\/(.+?)(;.+)?$/;function t(r,o){const n=p.exec(r);return n?`${n[1].toLowerCase()}/${n[2].toLowerCase()}${n[3]??""}`:o?void 0:r}e.normalizeMimeType=t}),define(me[103],ge([0,1,2]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const u=this._uriTransformer.transformIncoming(I);return u===I?I:L(g.URI.from(u))}transformOutgoing(I){const u=this._uriTransformer.transformOutgoing(I);return u===I?I:L(g.URI.from(u))}transformOutgoingURI(I){const u=this._uriTransformer.transformOutgoing(I);return u===I?I:g.URI.from(u)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function y(i,I,u){if(!i||u>200)return null;if(typeof i=="object"){if(i instanceof g.URI)return I.transformOutgoing(i);for(let m in i)if(Object.hasOwnProperty.call(i,m)){const l=y(i[m],I,u+1);l!==null&&(i[m]=l)}}return null}function T(i,I){const u=y(i,I,0);return u===null?i:u}e.transformOutgoingURIs=T;function C(i,I,u,m){if(!i||m>200)return null;if(typeof i=="object"){if(i.$mid===1)return u?g.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let l in i)if(Object.hasOwnProperty.call(i,l)){const v=C(i[l],I,u,m+1);v!==null&&(i[l]=v)}}return null}function S(i,I){const u=C(i,I,!1,0);return u===null?i:u}e.transformIncomingURIs=S;function P(i,I){const u=C(i,I,!0,0);return u===null?i:u}e.transformAndReviveIncomingURIs=P}),define(me[32],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return g.test(S)}e.isUUID=L;const k=new Uint8Array(16),y=[];for(let S=0;S<256;S++)y.push(S.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(S){for(let P=0;P<S.length;P++)S[P]=Math.floor(Math.random()*256);return S};function C(){T(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let S=0,P="";return P+=y[k[S++]],P+=y[k[S++]],P+=y[k[S++]],P+=y[k[S++]],P+="-",P+=y[k[S++]],P+=y[k[S++]],P+="-",P+=y[k[S++]],P+=y[k[S++]],P+="-",P+=y[k[S++]],P+=y[k[S++]],P+="-",P+=y[k[S++]],P+=y[k[S++]],P+=y[k[S++]],P+=y[k[S++]],P+=y[k[S++]],P+=y[k[S++]],P}e.generateUuid=C}),define(me[142],ge([0,1,104]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(y="utf8"){this.stringDecoder=new g.StringDecoder(y),this.remaining=null}write(y){const T=[],C=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(C.length<1)return T;let S=0,P,i=S;for(;i<C.length;)if(P=C.charCodeAt(i),P===13||P===10){if(T.push(C.substring(S,i)),i++,i<C.length){const I=P;P=C.charCodeAt(i),(I===13&&P===10||I===10&&P===13)&&i++}S=i}else i++;return this.remaining=S<C.length?C.substr(S):null,T}end(){return this.remaining}}e.LineDecoder=L}),define(me[28],ge([0,1,49,78,289,17,29,76,9,11,23,2,32]),function(J,e,g,L,k,y,T,C,S,P,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function l(O,x=m.UNLINK){if((0,T.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?_(O):v(O)}async function v(O){try{const x=(0,S.join)((0,L.tmpdir)(),(0,u.generateUuid)());try{await e.Promises.rename(O,x)}catch(F){return _(O)}_(x).catch(F=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function _(O){return e.Promises.rmdir(O,{recursive:!0,maxRetries:3})}function b(O){if((0,T.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(O,{recursive:!0})}e.rimrafSync=b;async function A(O,x){return p(await(x?c(O):(0,k.promisify)(g.readdir)(O)))}async function c(O){try{return await(0,k.promisify)(g.readdir)(O,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const x=[],F=await A(O);for(const z of F){let M=!1,N=!1,q=!1;try{const B=await e.Promises.lstat((0,S.join)(O,z));M=B.isFile(),N=B.isDirectory(),q=B.isSymbolicLink()}catch(B){console.warn("[node.js fs] unexpected error from lstat after readdir: ",B)}x.push({name:z,isFile:()=>M,isDirectory:()=>N,isSymbolicLink:()=>q})}return x}function h(O){return p(g.readdirSync(O))}e.readdirSync=h;function p(O){return O.map(x=>typeof x=="string"?P.isMacintosh?(0,C.normalizeNFC)(x):x:(x.name=P.isMacintosh?(0,C.normalizeNFC)(x.name):x.name,x))}async function t(O){const x=await A(O),F=[];for(const z of x)await o.existsDirectory((0,S.join)(O,z))&&F.push(z);return F}function r(O,x=1e3){return new Promise(F=>{let z=!1;const M=setInterval(()=>{z||(z=!0,g.access(O,N=>{z=!1,N&&(clearInterval(M),F(void 0))}))},x)})}e.whenDeleted=r;var o;(function(O){async function x(M){let N;try{if(N=await e.Promises.lstat(M),!N.isSymbolicLink())return{stat:N}}catch(q){}try{return{stat:await e.Promises.stat(M),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(P.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(B){if(B.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw B}throw q}}O.stat=x;async function F(M){try{const{stat:N,symbolicLink:q}=await O.stat(M);return N.isFile()&&q?.dangling!==!0}catch(N){}return!1}O.existsFile=F;async function z(M){try{const{stat:N,symbolicLink:q}=await O.stat(M);return N.isDirectory()&&q?.dangling!==!0}catch(N){}return!1}O.existsDirectory=z})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new y.ResourceQueue;function a(O,x,F){return n.queueFor(I.URI.file(O),i.extUriBiasedIgnorePathCase).queue(()=>{const z=E(F);return new Promise((M,N)=>d(O,x,z,q=>q?N(q):M()))})}let f=!0;function d(O,x,F,z){if(!f)return g.writeFile(O,x,{mode:F.mode,flag:F.flag},z);g.open(O,F.flag,F.mode,(M,N)=>{if(M)return z(M);g.writeFile(N,x,q=>{if(q)return g.close(N,()=>z(q));g.fdatasync(N,B=>(B&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",B),f=!1),g.close(N,G=>z(G))))})})}function w(O,x,F){const z=E(F);if(!f)return g.writeFileSync(O,x,{mode:z.mode,flag:z.flag});const M=g.openSync(O,z.flag,z.mode);try{g.writeFileSync(M,x);try{g.fdatasyncSync(M)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),f=!1}}finally{g.closeSync(M)}}e.writeFileSync=w;function E(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function s(O,x){if(O===x)return;async function F(z){try{const M=await e.Promises.lstat(z);if(M.isDirectory()||M.isSymbolicLink())return;await e.Promises.utimes(z,M.atime,new Date)}catch(M){}}try{await e.Promises.rename(O,x),await F(x)}catch(z){if(O.toLowerCase()!==x.toLowerCase()&&z.code==="EXDEV"||O.endsWith("."))await D(O,x,{preserveSymlinks:!1}),await l(O,m.MOVE),await F(x);else throw z}}async function D(O,x,F){return U(O,x,{root:{source:O,target:x},options:F,handledSourcePaths:new Set})}const R=511;async function U(O,x,F){if(F.handledSourcePaths.has(O))return;F.handledSourcePaths.add(O);const{stat:z,symbolicLink:M}=await o.stat(O);if(M){if(F.options.preserveSymlinks)try{return await K(O,x,F)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(M.dangling)return}return z.isDirectory()?V(O,x,z.mode&R,F):ee(O,x,z.mode&R)}async function V(O,x,F,z){await e.Promises.mkdir(x,{recursive:!0,mode:F});const M=await A(O);for(const N of M)await U((0,S.join)(O,N),(0,S.join)(x,N),z)}async function ee(O,x,F){await e.Promises.copyFile(O,x),await e.Promises.chmod(x,F)}async function K(O,x,F){let z=await e.Promises.readlink(O);(0,T.isEqualOrParent)(z,F.root.source,!P.isLinux)&&(z=(0,S.join)(F.root.target,z.substr(F.root.source.length+1))),await e.Promises.symlink(z,x)}e.Promises=new class{get access(){return(0,k.promisify)(g.access)}get stat(){return(0,k.promisify)(g.stat)}get lstat(){return(0,k.promisify)(g.lstat)}get utimes(){return(0,k.promisify)(g.utimes)}get read(){return(0,k.promisify)(g.read)}get readFile(){return(0,k.promisify)(g.readFile)}get write(){return(0,k.promisify)(g.write)}get appendFile(){return(0,k.promisify)(g.appendFile)}get fdatasync(){return(0,k.promisify)(g.fdatasync)}get truncate(){return(0,k.promisify)(g.truncate)}get rename(){return(0,k.promisify)(g.rename)}get copyFile(){return(0,k.promisify)(g.copyFile)}get open(){return(0,k.promisify)(g.open)}get close(){return(0,k.promisify)(g.close)}get symlink(){return(0,k.promisify)(g.symlink)}get readlink(){return(0,k.promisify)(g.readlink)}get chmod(){return(0,k.promisify)(g.chmod)}get mkdir(){return(0,k.promisify)(g.mkdir)}get unlink(){return(0,k.promisify)(g.unlink)}get rmdir(){return(0,k.promisify)(g.rmdir)}get realpath(){return(0,k.promisify)(g.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return A}get readDirsInDir(){return t}get writeFile(){return a}get rm(){return l}get move(){return s}get copy(){return D}}}),define(me[105],ge([0,1,49,9,8,28]),function(J,e,g,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(i){const I=(0,L.dirname)(i);if(i===I)return i;const u=((0,L.basename)(i)||i).toLowerCase();try{const l=(0,y.readdirSync)(I).filter(v=>v.toLowerCase()===u);if(l.length===1){const v=T(I);if(v)return(0,L.join)(v,l[0])}else if(l.length>1){const v=l.indexOf(u);if(v>=0){const _=T(I);if(_)return(0,L.join)(_,l[v])}}}catch(m){}return null}e.realcaseSync=T;async function C(i){try{return await y.Promises.realpath(i)}catch(I){const u=P(i);return await y.Promises.access(u,g.constants.R_OK),u}}e.realpath=C;function S(i){try{return g.realpathSync(i)}catch(I){const u=P(i);return g.accessSync(u,g.constants.R_OK),u}}e.realpathSync=S;function P(i){return(0,k.rtrim)((0,L.normalize)(i),L.sep)}});var Ve=this&&this.__decorate||function(J,e,g,L){var k=arguments.length,y=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,g):L,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(J,e,g,L);else for(var C=J.length-1;C>=0;C--)(T=J[C])&&(y=(k<3?T(y):k>3?T(e,g,y):T(e,g))||y);return k>3&&y&&Object.defineProperty(e,g,y),y};define(me[106],ge([0,1,20,17,24,21,56,16,3,6,59,8,14]),function(J,e,g,L,k,y,T,C,S,P,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function l(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function _(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(b||(b={}));class A{constructor(N){this.buffer=N,this.pos=0}read(N){const q=this.buffer.slice(this.pos,this.pos+N);return this.pos+=q.byteLength,q}}class c{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var h;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(h||(h={}));function p(M){const N=k.VSBuffer.alloc(4);return N.writeUInt32BE(M,0),N}function t(M){return M.read(4).readUInt32BE(0)}function r(M){const N=k.VSBuffer.alloc(1);return N.writeUInt8(M,0),N}const o={Undefined:r(h.Undefined),String:r(h.String),Buffer:r(h.Buffer),VSBuffer:r(h.VSBuffer),Array:r(h.Array),Object:r(h.Object)},n=typeof Buffer!="undefined";function a(M,N){if(typeof N=="undefined")M.write(o.Undefined);else if(typeof N=="string"){const q=k.VSBuffer.fromString(N);M.write(o.String),M.write(p(q.byteLength)),M.write(q)}else if(n&&Buffer.isBuffer(N)){const q=k.VSBuffer.wrap(N);M.write(o.Buffer),M.write(p(q.byteLength)),M.write(q)}else if(N instanceof k.VSBuffer)M.write(o.VSBuffer),M.write(p(N.byteLength)),M.write(N);else if(Array.isArray(N)){M.write(o.Array),M.write(p(N.length));for(const q of N)a(M,q)}else{const q=k.VSBuffer.fromString(JSON.stringify(N));M.write(o.Object),M.write(p(q.byteLength)),M.write(q)}}function f(M){switch(M.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return M.read(t(M)).toString();case h.Buffer:return M.read(t(M)).buffer;case h.VSBuffer:return M.read(t(M));case h.Array:{const q=t(M),B=[];for(let G=0;G<q;G++)B.push(f(M));return B}case h.Object:return JSON.parse(M.read(t(M)).toString())}}class d{constructor(N,q,B=null,G=1e3){this.protocol=N,this.ctx=q,this.logger=B,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(re=>this.onRawMessage(re)),this.sendResponse({type:200})}registerChannel(N,q){this.channels.set(N,q),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const q=this.send([N.type]);this.logger&&this.logger.logOutgoing(q,0,1,_(N.type));return}case 201:case 202:case 204:case 203:{const q=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(q,N.id,1,_(N.type),N.data);return}}}send(N,q=void 0){const B=new c;return a(B,N),a(B,q),this.sendBuffer(B.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(q){return 0}}onRawMessage(N){const q=new A(N),B=f(q),G=f(q),re=B[0];switch(re){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,B[1],1,`${l(re)}: ${B[2]}.${B[3]}`,G),this.onPromise({type:re,id:B[1],channelName:B[2],name:B[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,B[1],1,`${l(re)}: ${B[2]}.${B[3]}`,G),this.onEventListen({type:re,id:B[1],channelName:B[2],name:B[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,B[1],1,`${l(re)}`),this.disposeActiveRequest({type:re,id:B[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,B[1],1,`${l(re)}`),this.disposeActiveRequest({type:re,id:B[1]})}}onPromise(N){const q=this.channels.get(N.channelName);if(!q){this.collectPendingRequest(N);return}const B=new y.CancellationTokenSource;let G;try{G=q.call(this.ctx,N.name,N.arg,B.token)}catch(ye){G=Promise.reject(ye)}const re=N.id;G.then(ye=>{this.sendResponse({id:re,data:ye,type:201}),this.activeRequests.delete(N.id)},ye=>{ye instanceof Error?this.sendResponse({id:re,data:{message:ye.message,name:ye.name,stack:ye.stack?ye.stack.split?ye.stack.split(`
`):ye.stack:void 0},type:202}):this.sendResponse({id:re,data:ye,type:203}),this.activeRequests.delete(N.id)});const he=(0,P.toDisposable)(()=>B.cancel());this.activeRequests.set(N.id,he)}onEventListen(N){const q=this.channels.get(N.channelName);if(!q){this.collectPendingRequest(N);return}const B=N.id,re=q.listen(this.ctx,N.name,N.arg)(he=>this.sendResponse({id:B,data:he,type:204}));this.activeRequests.set(N.id,re)}disposeActiveRequest(N){const q=this.activeRequests.get(N.id);q&&(q.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let q=this.pendingRequests.get(N.channelName);q||(q=[],this.pendingRequests.set(N.channelName,q));const B=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:N,timeoutTimer:B})}flushPendingRequests(N){const q=this.pendingRequests.get(N);if(q){for(const B of q)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var w;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(N,q=null){this.protocol=N,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=q}getChannel(N){const q=this;return{call(B,G,re){return q.isDisposed?Promise.reject(C.canceled()):q.requestPromise(N,B,G,re)},listen(B,G){return q.isDisposed?Promise.reject(C.canceled()):q.requestEvent(N,B,G)}}}requestPromise(N,q,B,G=y.CancellationToken.None){const re=this.lastRequestId++,ye={id:re,type:100,channelName:N,name:q,arg:B};if(G.isCancellationRequested)return Promise.reject(C.canceled());let Ie;return new Promise((qe,We)=>{if(G.isCancellationRequested)return We(C.canceled());const je=()=>{const le=Y=>{switch(Y.type){case 201:this.handlers.delete(re),qe(Y.data);break;case 202:this.handlers.delete(re);const ae=new Error(Y.data.message);ae.stack=Y.data.stack,ae.name=Y.data.name,We(ae);break;case 203:this.handlers.delete(re),We(Y.data);break}};this.handlers.set(re,le),this.sendRequest(ye)};let W=null;this.state===b.Idle?je():(W=(0,L.createCancelablePromise)(le=>this.whenInitialized()),W.then(()=>{W=null,je()}));const Z=()=>{W?(W.cancel(),W=null):this.sendRequest({id:re,type:101}),We(C.canceled())},ne=G.onCancellationRequested(Z);Ie=(0,P.combinedDisposable)((0,P.toDisposable)(Z),ne),this.activeRequests.add(Ie)}).finally(()=>{this.activeRequests.delete(Ie)})}requestEvent(N,q,B){const G=this.lastRequestId++,he={id:G,type:102,channelName:N,name:q,arg:B};let ye=null;const Ie=new S.Emitter({onFirstListenerAdd:()=>{ye=(0,L.createCancelablePromise)(qe=>this.whenInitialized()),ye.then(()=>{ye=null,this.activeRequests.add(Ie),this.sendRequest(he)})},onLastListenerRemove:()=>{ye?(ye.cancel(),ye=null):(this.activeRequests.delete(Ie),this.sendRequest({id:G,type:103}))}}),Le=qe=>Ie.fire(qe.data);return this.handlers.set(G,Le),Ie.event}sendRequest(N){switch(N.type){case 100:case 102:{const q=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(q,N.id,0,`${l(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const q=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(q,N.id,0,l(N.type));return}}}send(N,q=void 0){const B=new c;return a(B,N),a(B,q),this.sendBuffer(B.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(q){return 0}}onBuffer(N){const q=new A(N),B=f(q),G=f(q),re=B[0];switch(re){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,_(re)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,B[1],0,_(re),G),this.onResponse({type:B[0],id:B[1],data:G})}}onResponse(N){if(N.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(N.id);q&&q(N)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}Ve([T.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class s{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:q,onDidClientDisconnect:B})=>{S.Event.once(q.onMessage)(re=>{const he=new A(re),ye=f(he),Ie=new d(q,ye),Le=new E(q);this.channels.forEach((We,je)=>Ie.registerChannel(je,We));const qe={channelServer:Ie,channelClient:Le,ctx:ye};this._connections.add(qe),this._onDidAddConnection.fire(qe),B(()=>{Ie.dispose(),Le.dispose(),this._connections.delete(qe),this._onDidRemoveConnection.fire(qe)})})})}get connections(){const N=[];return this._connections.forEach(q=>N.push(q)),N}getChannel(N,q){const B=this;return{call(G,re,he){let ye;if((0,u.isFunction)(q)){let Le=(0,g.getRandomElement)(B.connections.filter(q));ye=Le?Promise.resolve(Le):S.Event.toPromise(S.Event.filter(B.onDidAddConnection,q))}else ye=q.routeCall(B,G,re);const Ie=ye.then(Le=>Le.channelClient.getChannel(N));return R(Ie).call(G,re,he)},listen(G,re){if((0,u.isFunction)(q))return B.getMulticastEvent(N,q,G,re);const he=q.routeEvent(B,G,re).then(ye=>ye.channelClient.getChannel(N));return R(he).listen(G,re)}}}getMulticastEvent(N,q,B,G){const re=this;let he=new P.DisposableStore;const ye=new S.Emitter({onFirstListenerAdd:()=>{he=new P.DisposableStore;const Ie=new S.EventMultiplexer,Le=new Map,qe=je=>{const Z=je.channelClient.getChannel(N).listen(B,G),ne=Ie.add(Z);Le.set(je,ne)},We=je=>{const W=Le.get(je);!W||(W.dispose(),Le.delete(je))};re.connections.filter(q).forEach(qe),S.Event.filter(re.onDidAddConnection,q)(qe,void 0,he),re.onDidRemoveConnection(We,void 0,he),Ie.event(ye.fire,ye,he),he.add(Ie)},onLastListenerRemove:()=>{he.dispose()}});return ye.event}registerChannel(N,q){this.channels.set(N,q),this._connections.forEach(B=>{B.channelServer.registerChannel(N,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=s;class D{constructor(N,q,B=null){const G=new c;a(G,q),N.send(G.buffer),this.channelClient=new E(N,B),this.channelServer=new d(N,q,B)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,q){this.channelServer.registerChannel(N,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=D;function R(M){return{call(N,q,B){return M.then(G=>G.call(N,q,B))},listen(N,q){const B=new S.Relay;return M.then(G=>B.input=G.listen(N,q)),B.event}}}e.getDelayedChannel=R;function U(M){let N=!1;return{call(q,B,G){return N?M.call(q,B,G):(0,L.timeout)(0).then(()=>N=!0).then(()=>M.call(q,B,G))},listen(q,B){if(N)return M.listen(q,B);const G=new S.Relay;return(0,L.timeout)(0).then(()=>N=!0).then(()=>G.input=M.listen(q,B)),G.event}}}e.getNextTickChannel=U;class V{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const q of N.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await S.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=V;var ee;(function(M){function N(G,re){const he=G,ye=re&&re.disableMarshalling,Ie=new Map;for(const Le in he)B(Le)&&Ie.set(Le,S.Event.buffer(he[Le],!0));return new class{listen(Le,qe){const We=Ie.get(qe);if(We)return We;throw new Error(`Event not found: ${qe}`)}call(Le,qe,We){const je=he[qe];if(typeof je=="function"){if(!ye&&Array.isArray(We))for(let W=0;W<We.length;W++)We[W]=(0,i.revive)(We[W]);return je.apply(he,We)}throw new Error(`Method not found: ${qe}`)}}}M.fromService=N;function q(G,re){const he=re&&re.disableMarshalling;return new Proxy({},{get(ye,Ie){if(typeof Ie=="string")return re?.properties?.has(Ie)?re.properties.get(Ie):B(Ie)?G.listen(Ie):async function(...Le){let qe;re&&!(0,u.isUndefinedOrNull)(re.context)?qe=[re.context,...Le]:qe=Le;const We=await G.call(Ie,qe);return he?We:(0,i.revive)(We)};throw new Error(`Property not found: ${String(Ie)}`)}})}M.toService=q;function B(G){return G[0]==="o"&&G[1]==="n"&&I.isUpperAsciiLetter(G.charCodeAt(2))}})(ee=e.ProxyChannel||(e.ProxyChannel={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let N=M.toString();if(N!=="[object Object]")return N}return M}function x(M){return Array.isArray(M)?M.map(O):O(M)}function F(M,N,q,B,G,re,he){he=x(he);const ye=K[G],Ie=ye[B%ye.length];let Le=[`%c[${M}]%c[${String(N).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${Ie}`];/\($/.test(re)?(Le=Le.concat(he),Le.push(")")):Le.push(he),console.log.apply(console,Le)}e.logWithColors=F;class z{constructor(N,q){this._outgoingPrefix=N,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,q,B,G,re){this._totalOutgoing+=N,F(this._outgoingPrefix,this._totalOutgoing,N,q,B,G,re)}logIncoming(N,q,B,G,re){this._totalIncoming+=N,F(this._incomingPrefix,this._totalIncoming,N,q,B,G,re)}}e.IPCLogger=z}),define(me[107],ge([0,1,24,3,6,11,38,106]),function(J,e,g,L,k,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var S;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function i(){return P||(P=g.VSBuffer.alloc(0)),P}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,a){if(n===0)return i();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const E=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=n),E}if(this._chunks[0].byteLength>n){const E=this._chunks[0].slice(0,n);return a&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),E}let f=g.VSBuffer.alloc(n),d=0,w=0;for(;n>0;){const E=this._chunks[w];if(E.byteLength>n){const s=E.slice(0,n);f.set(s,d),d+=n,a&&(this._chunks[w]=E.slice(n),this._totalLength-=n),n-=n}else f.set(E,d),d+=E.byteLength,a?(this._chunks.shift(),this._totalLength-=E.byteLength):w++,n-=E.byteLength}return f}}e.ChunkStream=I;var u;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.KeepAlive=4]="KeepAlive",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest"})(u||(u={}));var m;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",o[o.KeepAliveTime=5e3]="KeepAliveTime",o[o.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class l{constructor(n,a,f,d){this.type=n,this.id=a,this.ack=f,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends k.Disposable{constructor(n){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const f=this._state.messageType,d=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new l(f,d,w,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class _{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=g.VSBuffer.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this._writeSoon(a,n.data)}_bufferAdd(n,a){const f=this._totalLength===0;return this._data.push(n,a),this._totalLength+=n.byteLength+a.byteLength,f}_bufferTake(){const n=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,a){this._bufferAdd(n,a)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends k.Disposable{constructor(n){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new _(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new l(1,0,0,n))}}e.Protocol=b;class A extends C.IPCClient{constructor(n,a,f=null){super(n,a,f);this.protocol=n}static fromSocket(n,a){return new A(new b(n),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=A;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,T.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class h{constructor(n){this.data=n,this.next=null}}class p{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],a=0,f=this._first;for(;f;)n[a++]=f.data,f=f.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const a=new h(n);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let a=0;a<t._HISTORY_LENGTH;a++)this.lastRuns[a]=n-1e3*a;setInterval(()=>{for(let a=t._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),a=(1+t._HISTORY_LENGTH)*1e3;let f=0;for(let d=0;d<t._HISTORY_LENGTH;d++)n-this.lastRuns[d]<=a&&f++;return 1-f/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class r{constructor(n,a=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new p,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new l(5,0,0,i());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const a=new l(4,0,0,i());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,a){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let a=0,f=n.length;a<f;a++)this._socketWriter.write(n[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new l(6,0,0,i())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const a=this._outgoingUnackMsg.toArray();for(let f=0,d=a.length;f<d;f++)this._socketWriter.write(a[f]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const f=new l(1,a,this._incomingAckId,n);this._outgoingUnackMsg.push(f),this._isReconnecting||(this._socketWriter.write(f),this._recvAckCheck())}sendControl(n){const a=new l(2,0,0,n);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const n=this._outgoingUnackMsg.peek(),a=Date.now()-n.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new l(3,0,this._incomingAckId,i());this._socketWriter.write(n)}}e.PersistentProtocol=r}),define(me[108],ge([0,1,97]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(C){let S=(0,g.toUint8)(C);this._defaultValue=S,this._asciiMap=L._createAsciiMap(S),this._map=new Map}static _createAsciiMap(C){let S=new Uint8Array(256);for(let P=0;P<256;P++)S[P]=C;return S}set(C,S){let P=(0,g.toUint8)(S);C>=0&&C<256?this._asciiMap[C]=P:this._map.set(C,P)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=L;var k;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(k||(k={}));class y{constructor(){this._actual=new L(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=y}),define(me[143],ge([0,1,108]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends g.CharacterClassifier{constructor(C){super(0);for(let S=0,P=C.length;S<P;S++)this.set(C.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function y(T){let C={};return S=>(C.hasOwnProperty(S)||(C[S]=T(S)),C[S])}e.getMapForWordSeparators=y(T=>new k(T))}),define(me[50],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(k,y){this.lineNumber=k,this.column=y}with(k=this.lineNumber,y=this.column){return k===this.lineNumber&&y===this.column?this:new g(k,y)}delta(k=0,y=0){return this.with(this.lineNumber+k,this.column+y)}equals(k){return g.equals(this,k)}static equals(k,y){return!k&&!y?!0:!!k&&!!y&&k.lineNumber===y.lineNumber&&k.column===y.column}isBefore(k){return g.isBefore(this,k)}static isBefore(k,y){return k.lineNumber<y.lineNumber?!0:y.lineNumber<k.lineNumber?!1:k.column<y.column}isBeforeOrEqual(k){return g.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,y){return k.lineNumber<y.lineNumber?!0:y.lineNumber<k.lineNumber?!1:k.column<=y.column}static compare(k,y){let T=k.lineNumber|0,C=y.lineNumber|0;if(T===C){let S=k.column|0,P=y.column|0;return S-P}return T-C}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new g(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=g}),define(me[41],ge([0,1,50]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(y,T,C,S){y>C||y===C&&T>S?(this.startLineNumber=C,this.startColumn=S,this.endLineNumber=y,this.endColumn=T):(this.startLineNumber=y,this.startColumn=T,this.endLineNumber=C,this.endColumn=S)}isEmpty(){return L.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return L.containsPosition(this,y)}static containsPosition(y,T){return!(T.lineNumber<y.startLineNumber||T.lineNumber>y.endLineNumber||T.lineNumber===y.startLineNumber&&T.column<y.startColumn||T.lineNumber===y.endLineNumber&&T.column>y.endColumn)}containsRange(y){return L.containsRange(this,y)}static containsRange(y,T){return!(T.startLineNumber<y.startLineNumber||T.endLineNumber<y.startLineNumber||T.startLineNumber>y.endLineNumber||T.endLineNumber>y.endLineNumber||T.startLineNumber===y.startLineNumber&&T.startColumn<y.startColumn||T.endLineNumber===y.endLineNumber&&T.endColumn>y.endColumn)}strictContainsRange(y){return L.strictContainsRange(this,y)}static strictContainsRange(y,T){return!(T.startLineNumber<y.startLineNumber||T.endLineNumber<y.startLineNumber||T.startLineNumber>y.endLineNumber||T.endLineNumber>y.endLineNumber||T.startLineNumber===y.startLineNumber&&T.startColumn<=y.startColumn||T.endLineNumber===y.endLineNumber&&T.endColumn>=y.endColumn)}plusRange(y){return L.plusRange(this,y)}static plusRange(y,T){let C,S,P,i;return T.startLineNumber<y.startLineNumber?(C=T.startLineNumber,S=T.startColumn):T.startLineNumber===y.startLineNumber?(C=T.startLineNumber,S=Math.min(T.startColumn,y.startColumn)):(C=y.startLineNumber,S=y.startColumn),T.endLineNumber>y.endLineNumber?(P=T.endLineNumber,i=T.endColumn):T.endLineNumber===y.endLineNumber?(P=T.endLineNumber,i=Math.max(T.endColumn,y.endColumn)):(P=y.endLineNumber,i=y.endColumn),new L(C,S,P,i)}intersectRanges(y){return L.intersectRanges(this,y)}static intersectRanges(y,T){let C=y.startLineNumber,S=y.startColumn,P=y.endLineNumber,i=y.endColumn,I=T.startLineNumber,u=T.startColumn,m=T.endLineNumber,l=T.endColumn;return C<I?(C=I,S=u):C===I&&(S=Math.max(S,u)),P>m?(P=m,i=l):P===m&&(i=Math.min(i,l)),C>P||C===P&&S>i?null:new L(C,S,P,i)}equalsRange(y){return L.equalsRange(this,y)}static equalsRange(y,T){return!!y&&!!T&&y.startLineNumber===T.startLineNumber&&y.startColumn===T.startColumn&&y.endLineNumber===T.endLineNumber&&y.endColumn===T.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(y){return new g.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(y){return new g.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,T){return new L(this.startLineNumber,this.startColumn,y,T)}setStartPosition(y,T){return new L(y,T,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(y){return new L(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,T=y){return new L(y.lineNumber,y.column,T.lineNumber,T.column)}static lift(y){return y?new L(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,T){return!(y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<T.startColumn||T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<y.startColumn)}static areIntersecting(y,T){return!(y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<=T.startColumn||T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,T){if(y&&T){const P=y.startLineNumber|0,i=T.startLineNumber|0;if(P===i){const I=y.startColumn|0,u=T.startColumn|0;if(I===u){const m=y.endLineNumber|0,l=T.endLineNumber|0;if(m===l){const v=y.endColumn|0,_=T.endColumn|0;return v-_}return m-l}return I-u}return P-i}return(y?1:0)-(T?1:0)}static compareRangesUsingEnds(y,T){return y.endLineNumber===T.endLineNumber?y.endColumn===T.endColumn?y.startLineNumber===T.startLineNumber?y.startColumn-T.startColumn:y.startLineNumber-T.startLineNumber:y.endColumn-T.endColumn:y.endLineNumber-T.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=L}),define(me[144],ge([0,1,50,41]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class y extends L.Range{constructor(C,S,P,i){super(C,S,P,i);this.selectionStartLineNumber=C,this.selectionStartColumn=S,this.positionLineNumber=P,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return y.selectionsEqual(this,C)}static selectionsEqual(C,S){return C.selectionStartLineNumber===S.selectionStartLineNumber&&C.selectionStartColumn===S.selectionStartColumn&&C.positionLineNumber===S.positionLineNumber&&C.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,S){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,C,S):new y(C,S,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,S){return this.getDirection()===0?new y(C,S,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,C,S)}static fromPositions(C,S=C){return new y(C.lineNumber,C.column,S.lineNumber,S.column)}static liftSelection(C){return new y(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,S){if(C&&!S||!C&&S)return!1;if(!C&&!S)return!0;if(C.length!==S.length)return!1;for(let P=0,i=C.length;P<i;P++)if(!this.selectionsEqual(C[P],S[P]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,S,P,i,I){return I===0?new y(C,S,P,i):new y(P,i,C,S)}}e.Selection=y}),define(me[109],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var g;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(g=e.OverviewRulerLane||(e.OverviewRulerLane={}));var L;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(L=e.MinimapPosition||(e.MinimapPosition={}));var k;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var T;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(T=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace)}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class S{constructor(v,_){this._findMatchBrand=void 0,this.range=v,this.matches=_}}e.FindMatch=S;var P;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None"})(i=e.PositionAffinity||(e.PositionAffinity={}));var I;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class u{constructor(v,_,b,A,c,h){this.identifier=v,this.range=_,this.text=b,this.forceMoveMarkers=A,this.isAutoWhitespaceEdit=c,this._isTracked=h}}e.ValidAnnotatedEditOperation=u;class m{constructor(v,_,b){this.reverseEdits=v,this.changes=_,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=m}),define(me[145],ge([0,1,8,143,50,41,109]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class S{constructor(c,h,p,t){this.searchString=c,this.isRegex=h,this.matchCase=p,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=P(this.searchString):c=this.searchString.indexOf(`
`)>=0;let h=null;try{h=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(t){return null}if(!h)return null;let p=!this.isRegex&&!c;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new i(h,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=S;function P(A){if(!A||A.length===0)return!1;for(let c=0,h=A.length;c<h;c++)if(A.charCodeAt(c)===92){if(c++,c>=h)break;const t=A.charCodeAt(c);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=P;class i{constructor(c,h,p){this.regex=c,this.wordSeparators=h,this.simpleSearch=p}}e.SearchData=i;function I(A,c,h){if(!h)return new T.FindMatch(A,null);let p=[];for(let t=0,r=c.length;t<r;t++)p[t]=c[t];return new T.FindMatch(A,p)}e.createFindMatch=I;class u{constructor(c){let h=[],p=0;for(let t=0,r=c.length;t<r;t++)c.charCodeAt(t)===10&&(h[p++]=t);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(c){const h=this._lineFeedsOffsets;let p=0,t=h.length-1;if(t===-1||c<=h[0])return 0;for(;p<t;){const r=p+((t-p)/2>>0);h[r]>=c?t=r-1:h[r+1]>=c?(p=r,t=r):p=r+1}return p+1}}class m{static findMatches(c,h,p,t,r){const o=h.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(c,p,new b(o.wordSeparators,o.regex),t,r):this._doFindMatchesLineByLine(c,p,o,t,r):[]}static _getMultilineMatchRange(c,h,p,t,r,o){let n,a=0;t?(a=t.findLineFeedCountBeforeOffset(r),n=h+r+a):n=h+r;let f;if(t){let s=t.findLineFeedCountBeforeOffset(r+o.length)-a;f=n+o.length+s}else f=n+o.length;const d=c.getPositionAt(n),w=c.getPositionAt(f);return new y.Range(d.lineNumber,d.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(c,h,p,t,r){const o=c.getOffsetAt(h.getStartPosition()),n=c.getValueInRange(h,1),a=c.getEOL()===`\r
`?new u(n):null,f=[];let d=0,w;for(p.reset(0);w=p.next(n);)if(f[d++]=I(this._getMultilineMatchRange(c,o,n,a,w.index,w[0]),w,t),d>=r)return f;return f}static _doFindMatchesLineByLine(c,h,p,t,r){const o=[];let n=0;if(h.startLineNumber===h.endLineNumber){const f=c.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return n=this._findMatchesInLine(p,f,h.startLineNumber,h.startColumn-1,n,o,t,r),o}const a=c.getLineContent(h.startLineNumber).substring(h.startColumn-1);n=this._findMatchesInLine(p,a,h.startLineNumber,h.startColumn-1,n,o,t,r);for(let f=h.startLineNumber+1;f<h.endLineNumber&&n<r;f++)n=this._findMatchesInLine(p,c.getLineContent(f),f,0,n,o,t,r);if(n<r){const f=c.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);n=this._findMatchesInLine(p,f,h.endLineNumber,0,n,o,t,r)}return o}static _findMatchesInLine(c,h,p,t,r,o,n,a){const f=c.wordSeparators;if(!n&&c.simpleSearch){const E=c.simpleSearch,s=E.length,D=h.length;let R=-s;for(;(R=h.indexOf(E,R+s))!==-1;)if((!f||_(f,h,D,R,s))&&(o[r++]=new T.FindMatch(new y.Range(p,R+1+t,p,R+1+s+t),null),r>=a))return r;return r}const d=new b(c.wordSeparators,c.regex);let w;d.reset(0);do if(w=d.next(h),w&&(o[r++]=I(new y.Range(p,w.index+1+t,p,w.index+1+w[0].length+t),w,n),r>=a))return r;while(w);return r}static findNextMatch(c,h,p,t){const r=h.parseSearchRequest();if(!r)return null;const o=new b(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(c,p,o,t):this._doFindNextMatchLineByLine(c,p,o,t)}static _doFindNextMatchMultiline(c,h,p,t){const r=new k.Position(h.lineNumber,1),o=c.getOffsetAt(r),n=c.getLineCount(),a=c.getValueInRange(new y.Range(r.lineNumber,r.column,n,c.getLineMaxColumn(n)),1),f=c.getEOL()===`\r
`?new u(a):null;p.reset(h.column-1);let d=p.next(a);return d?I(this._getMultilineMatchRange(c,o,a,f,d.index,d[0]),d,t):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(c,new k.Position(1,1),p,t):null}static _doFindNextMatchLineByLine(c,h,p,t){const r=c.getLineCount(),o=h.lineNumber,n=c.getLineContent(o),a=this._findFirstMatchInLine(p,n,o,h.column,t);if(a)return a;for(let f=1;f<=r;f++){const d=(o+f-1)%r,w=c.getLineContent(d+1),E=this._findFirstMatchInLine(p,w,d+1,1,t);if(E)return E}return null}static _findFirstMatchInLine(c,h,p,t,r){c.reset(t-1);const o=c.next(h);return o?I(new y.Range(p,o.index+1,p,o.index+1+o[0].length),o,r):null}static findPreviousMatch(c,h,p,t){const r=h.parseSearchRequest();if(!r)return null;const o=new b(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(c,p,o,t):this._doFindPreviousMatchLineByLine(c,p,o,t)}static _doFindPreviousMatchMultiline(c,h,p,t){const r=this._doFindMatchesMultiline(c,new y.Range(1,1,h.lineNumber,h.column),p,t,10*C);if(r.length>0)return r[r.length-1];const o=c.getLineCount();return h.lineNumber!==o||h.column!==c.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(c,new k.Position(o,c.getLineMaxColumn(o)),p,t):null}static _doFindPreviousMatchLineByLine(c,h,p,t){const r=c.getLineCount(),o=h.lineNumber,n=c.getLineContent(o).substring(0,h.column-1),a=this._findLastMatchInLine(p,n,o,t);if(a)return a;for(let f=1;f<=r;f++){const d=(r+o-f-1)%r,w=c.getLineContent(d+1),E=this._findLastMatchInLine(p,w,d+1,t);if(E)return E}return null}static _findLastMatchInLine(c,h,p,t){let r=null,o;for(c.reset(0);o=c.next(h);)r=I(new y.Range(p,o.index+1,p,o.index+1+o[0].length),o,t);return r}}e.TextModelSearch=m;function l(A,c,h,p,t){if(p===0)return!0;const r=c.charCodeAt(p-1);if(A.get(r)!==0||r===13||r===10)return!0;if(t>0){const o=c.charCodeAt(p);if(A.get(o)!==0)return!0}return!1}function v(A,c,h,p,t){if(p+t===h)return!0;const r=c.charCodeAt(p+t);if(A.get(r)!==0||r===13||r===10)return!0;if(t>0){const o=c.charCodeAt(p+t-1);if(A.get(o)!==0)return!0}return!1}function _(A,c,h,p,t){return l(A,c,h,p,t)&&v(A,c,h,p,t)}e.isValidMatch=_;class b{constructor(c,h){this._wordSeparators=c,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const h=c.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(p=this._searchRegex.exec(c),!p))return null;const t=p.index,r=p[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){g.getNextCodePoint(c,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||_(this._wordSeparators,c,h,t,r))return p}while(p);return null}}e.Searcher=b}),define(me[110],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(C=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)C.indexOf(P)>=0||(S+="\\"+P);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=g();function L(C){let S=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)S=C;else{let P="g";C.ignoreCase&&(P+="i"),C.multiline&&(P+="m"),C.unicode&&(P+="u"),S=new RegExp(C.source,P)}return S.lastIndex=0,S}e.ensureValidWordDefinition=L;const k={maxLen:1e3,windowSize:15,timeBudget:150};function y(C,S,P,i,I=k){if(P.length>I.maxLen){let _=C-I.maxLen/2;return _<0?_=0:i+=_,P=P.substring(_,C+I.maxLen/2),y(C,S,P,i,I)}const u=Date.now(),m=C-1-i;let l=-1,v=null;for(let _=1;!(Date.now()-u>=I.timeBudget);_++){const b=m-I.windowSize*_;S.lastIndex=Math.max(0,b);const A=T(S,P,m,l);if(!A&&v||(v=A,b<=0))break;l=b}if(v){let _={word:v[0],startColumn:i+1+v.index,endColumn:i+1+v.index+v[0].length};return S.lastIndex=0,_}return null}e.getWordAtText=y;function T(C,S,P,i){let I;for(;I=C.exec(S);){const u=I.index||0;if(u<=P&&C.lastIndex>=P)return I;if(i>0&&u>i)return null}return null}}),define(me[146],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class L{constructor(C){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let S=0,P=C.notIn.length;S<P;S++)switch(C.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=L;class k{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of C)y(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),y(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),y(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),y(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&y(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=k;function y(T,C,S){T.has(C)?T.get(C).push(S):T.set(C,[S])}}),define(me[79],ge([0,1,30,9]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(y,T,C,S){if(Array.isArray(y)){let P=0;for(const i of y){const I=k(i,T,C,S);if(I===10)return I;I>P&&(P=I)}return P}else{if(typeof y=="string")return S?y==="*"?5:y===C?10:0:0;if(y){const{language:P,pattern:i,scheme:I,hasAccessToAllModels:u}=y;if(!S&&!u)return 0;let m=0;if(I)if(I===T.scheme)m=10;else if(I==="*")m=5;else return 0;if(P)if(P===C)m=10;else if(P==="*")m=Math.max(m,5);else return 0;if(i){let l;if(typeof i=="string"?l=i:l={...i,base:(0,L.normalize)(i.base)},l===T.fsPath||(0,g.match)(l,T.fsPath))m=10;else return 0}return m}else return 0}}e.score=k}),define(me[147],ge([0,1,108]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class k{constructor(l,v,_){const b=new Uint8Array(l*v);for(let A=0,c=l*v;A<c;A++)b[A]=_;this._data=b,this.rows=l,this.cols=v}get(l,v){return this._data[l*this.cols+v]}set(l,v,_){this._data[l*this.cols+v]=_}}e.Uint8Matrix=k;class y{constructor(l){let v=0,_=0;for(let A=0,c=l.length;A<c;A++){let[h,p,t]=l[A];p>v&&(v=p),h>_&&(_=h),t>_&&(_=t)}v++,_++;let b=new k(_,v,0);for(let A=0,c=l.length;A<c;A++){let[h,p,t]=l[A];b.set(h,p,t)}this._states=b,this._maxCharCode=v}nextState(l,v){return v<0||v>=this._maxCharCode?0:this._states.get(l,v)}}e.StateMachine=y;let T=null;function C(){return T===null&&(T=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var S;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let P=null;function i(){if(P===null){P=new g.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<m.length;v++)P.set(m.charCodeAt(v),1);const l=".,;";for(let v=0;v<l.length;v++)P.set(l.charCodeAt(v),2)}return P}class I{static _createLink(l,v,_,b,A){let c=A-1;do{const h=v.charCodeAt(c);if(l.get(h)!==2)break;c--}while(c>b);if(b>0){const h=v.charCodeAt(b-1),p=v.charCodeAt(c);(h===40&&p===41||h===91&&p===93||h===123&&p===125)&&c--}return{range:{startLineNumber:_,startColumn:b+1,endLineNumber:_,endColumn:c+2},url:v.substring(b,c+1)}}static computeLinks(l,v=C()){const _=i();let b=[];for(let A=1,c=l.getLineCount();A<=c;A++){const h=l.getLineContent(A),p=h.length;let t=0,r=0,o=0,n=1,a=!1,f=!1,d=!1,w=!1;for(;t<p;){let E=!1;const s=h.charCodeAt(t);if(n===13){let D;switch(s){case 40:a=!0,D=0;break;case 41:D=a?0:1;break;case 91:d=!0,f=!0,D=0;break;case 93:d=!1,D=f?0:1;break;case 123:w=!0,D=0;break;case 125:D=w?0:1;break;case 39:D=o===34||o===96?0:1;break;case 34:D=o===39||o===96?0:1;break;case 96:D=o===39||o===34?0:1;break;case 42:D=o===42?1:0;break;case 124:D=o===124?1:0;break;case 32:D=d?0:1;break;default:D=_.get(s)}D===1&&(b.push(I._createLink(_,h,A,r,t)),E=!0)}else if(n===12){let D;s===91?(f=!0,D=0):D=_.get(s),D===1?E=!0:n=13}else n=v.nextState(n,s),n===0&&(E=!0);E&&(n=1,a=!1,f=!1,w=!1,r=t+1,o=s),t++}n===13&&b.push(I._createLink(_,h,A,r,p))}return b}}e.LinkComputer=I;function u(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:I.computeLinks(m)}e.computeLinks=u}),define(me[148],ge([0,1,3,6]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class k{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,C){return this._map.set(T,C),this.fire([T]),(0,L.toDisposable)(()=>{this._map.get(T)===C&&(this._map.delete(T),this.fire([T]))})}registerPromise(T,C){let S=null,P=!1;return this._promises.set(T,C.then(i=>{this._promises.delete(T),!(P||!i)&&(S=this.register(T,i))})),(0,L.toDisposable)(()=>{P=!0,S&&S.dispose()})}getPromise(T){const C=this.get(T);if(C)return Promise.resolve(C);const S=this._promises.get(T);return S?S.then(P=>this.get(T)):null}get(T){return this._map.get(T)||null}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=k}),define(me[111],ge([0,1,24,11]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(k||(k={}));function y(I){for(let u=0,m=I.length;u<m;u+=4){const l=I[u+0],v=I[u+1],_=I[u+2],b=I[u+3];I[u+0]=b,I[u+1]=_,I[u+2]=v,I[u+3]=l}}function T(I){const u=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.isLittleEndian()||y(u),g.VSBuffer.wrap(u)}function C(I){const u=I.buffer;if(L.isLittleEndian()||y(u),u.byteOffset%4==0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const m=new Uint8Array(u.byteLength);return m.set(u),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function S(I){const u=new Uint32Array(P(I));let m=0;if(u[m++]=I.id,I.type==="full")u[m++]=1,u[m++]=I.data.length,u.set(I.data,m),m+=I.data.length;else{u[m++]=2,u[m++]=I.deltas.length;for(const l of I.deltas)u[m++]=l.start,u[m++]=l.deleteCount,l.data?(u[m++]=l.data.length,u.set(l.data,m),m+=l.data.length):u[m++]=0}return T(u)}e.encodeSemanticTokensDto=S;function P(I){let u=0;if(u+=1+1,I.type==="full")u+=1+I.data.length;else{u+=1,u+=(1+1+1)*I.deltas.length;for(const m of I.deltas)m.data&&(u+=m.data.length)}return u}function i(I){const u=C(I);let m=0;const l=u[m++];if(u[m++]===1){const A=u[m++],c=u.subarray(m,m+A);return m+=A,{id:l,type:"full",data:c}}const _=u[m++];let b=[];for(let A=0;A<_;A++){const c=u[m++],h=u[m++],p=u[m++];let t;p>0&&(t=u.subarray(m,m+p),m+=p),b[A]={start:c,deleteCount:h,data:t}}return{id:l,type:"delta",deltas:b}}e.decodeSemanticTokensDto=i}),define(me[112],ge([0,1,97]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(T,C){this._prefixSumIndexOfResultBrand=void 0,this.index=T,this.remainder=C}}e.PrefixSumIndexOfResult=L;class k{constructor(T){this.values=T,this.prefixSum=new Uint32Array(T.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(T,C){T=(0,g.toUint32)(T);const S=this.values,P=this.prefixSum,i=C.length;return i===0?!1:(this.values=new Uint32Array(S.length+i),this.values.set(S.subarray(0,T),0),this.values.set(S.subarray(T),T+i),this.values.set(C,T),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(T,C){return T=(0,g.toUint32)(T),C=(0,g.toUint32)(C),this.values[T]===C?!1:(this.values[T]=C,T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),!0)}removeValues(T,C){T=(0,g.toUint32)(T),C=(0,g.toUint32)(C);const S=this.values,P=this.prefixSum;if(T>=S.length)return!1;let i=S.length-T;return C>=i&&(C=i),C===0?!1:(this.values=new Uint32Array(S.length-C),this.values.set(S.subarray(0,T),0),this.values.set(S.subarray(T+C),T),this.prefixSum=new Uint32Array(this.values.length),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(T){return T<0?0:(T=(0,g.toUint32)(T),this._getPrefixSum(T))}_getPrefixSum(T){if(T<=this.prefixSumValidIndex[0])return this.prefixSum[T];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),T>=this.values.length&&(T=this.values.length-1);for(let S=C;S<=T;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],T),this.prefixSum[T]}getIndexOf(T){T=Math.floor(T),this.getTotalSum();let C=0,S=this.values.length-1,P=0,i=0,I=0;for(;C<=S;)if(P=C+(S-C)/2|0,i=this.prefixSum[P],I=i-this.values[P],T<I)S=P-1;else if(T>=i)C=P+1;else break;return new L(P,T-I)}}e.PrefixSumComputer=k}),define(me[149],ge([0,1,8,50,112]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(C,S,P,i){this._uri=C,this._lines=S,this._eol=P,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const S=C.changes;for(const P of S)this._acceptDeleteRange(P.range),this._acceptInsertText(new L.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,S=this._lines.length,P=new Uint32Array(S);for(let i=0;i<S;i++)P[i]=this._lines[i].length+C;this._lineStarts=new k.PrefixSumComputer(P)}}_setLineText(C,S){this._lines[C]=S,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,S){if(S.length===0)return;let P=(0,g.splitLines)(S);if(P.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+P[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}P[P.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+P[0]);let i=new Uint32Array(P.length-1);for(let I=1;I<P.length;I++)this._lines.splice(C.lineNumber+I-1,0,P[I]),i[I-1]=P[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,i)}}e.MirrorTextModel=y}),define(me[150],ge([18,19]),function(J,e){return J.create("vs/base/common/date",e)}),define(me[151],ge([0,1,150]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,y=k*24,T=y*7,C=y*30,S=y*365;function P(I,u){typeof I!="number"&&(I=I.getTime());const m=Math.round((new Date().getTime()-I)/1e3);if(m<-30)return(0,g.localize)(0,null,P(new Date().getTime()+m*1e3,!1));if(m<30)return(0,g.localize)(1,null);let l;return m<L?(l=m,u?l===1?(0,g.localize)(2,null,l):(0,g.localize)(3,null,l):l===1?(0,g.localize)(4,null,l):(0,g.localize)(5,null,l)):m<k?(l=Math.floor(m/L),u?l===1?(0,g.localize)(6,null,l):(0,g.localize)(7,null,l):l===1?(0,g.localize)(8,null,l):(0,g.localize)(9,null,l)):m<y?(l=Math.floor(m/k),u?l===1?(0,g.localize)(10,null,l):(0,g.localize)(11,null,l):l===1?(0,g.localize)(12,null,l):(0,g.localize)(13,null,l)):m<T?(l=Math.floor(m/y),u?l===1?(0,g.localize)(14,null,l):(0,g.localize)(15,null,l):l===1?(0,g.localize)(16,null,l):(0,g.localize)(17,null,l)):m<C?(l=Math.floor(m/T),u?l===1?(0,g.localize)(18,null,l):(0,g.localize)(19,null,l):l===1?(0,g.localize)(20,null,l):(0,g.localize)(21,null,l)):m<S?(l=Math.floor(m/C),u?l===1?(0,g.localize)(22,null,l):(0,g.localize)(23,null,l):l===1?(0,g.localize)(24,null,l):(0,g.localize)(25,null,l)):(l=Math.floor(m/S),u?l===1?(0,g.localize)(26,null,l):(0,g.localize)(27,null,l):l===1?(0,g.localize)(28,null,l):(0,g.localize)(29,null,l))}e.fromNow=P;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(me[152],ge([18,19]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(me[60],ge([0,1,20,14,152]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(P,i){return i&&(P.stack||P.stacktrace)?k.localize(0,null,C(P),T(P.stack)||T(P.stacktrace)):C(P)}function T(P){return Array.isArray(P)?P.join(`
`):P}function C(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?k.localize(1,null,P.message):P.message||k.localize(2,null)}function S(P=null,i=!1){if(!P)return k.localize(3,null);if(Array.isArray(P)){const I=g.coalesce(P),u=S(I[0],i);return I.length>1?k.localize(4,null,u,I.length):u}if(L.isString(P))return P;if(P.detail){const I=P.detail;if(I.error)return y(I.error,i);if(I.exception)return y(I.exception,i)}return P.stack?y(P,i):P.message?P.message:k.localize(5,null)}e.toErrorMessage=S}),define(me[153],ge([18,19]),function(J,e){return J.create("vs/base/node/processes",e)}),define(me[113],ge([0,1,39,29,10,25,9,11,38,14,142,28,153]),function(J,e,g,L,k,y,T,C,S,P,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function m(h){switch(h){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(h,p){if(C.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};p&&(t.cwd=p);const r=g.execFile("taskkill",["/T","/F","/PID",h.pid.toString()],t);return new Promise(o=>{r.once("error",n=>{o({success:!1,error:n})}),r.once("exit",(n,a)=>{o(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?m(t.status):1})}else if(C.isLinux||C.isMacintosh)try{const t=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(r=>{g.execFile(t,[h.pid.toString()],{encoding:"utf8",shell:!0},(o,n,a)=>{r(o?{success:!1,error:o}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else h.kill("SIGKILL");return Promise.resolve({success:!0})}function v(h=S.env){return h.comspec||"cmd.exe"}e.getWindowsShell=v;class _{constructor(p,t,r,o){if(t!==void 0&&r!==void 0&&o!==void 0)this.cmd=p,this.args=t,this.shell=r,this.options=o;else{const n=p;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(S.env).forEach(a=>{n[a]=S.env[a]}),Object.keys(this.options.env).forEach(a=>{n[a]=this.options.env[a]}),this.options.env=n}}getSanitizedCommand(){let p=this.cmd.toLowerCase();const t=p.lastIndexOf(T.sep);return t!==-1&&(p=p.substring(t+1)),_.WellKnowCommands[p]?p:"other"}start(p){return C.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(S.cwd()))?Promise.reject(new Error(u.localize(0,null))):this.useExec().then(t=>{let r,o;const n=new Promise((a,f)=>{r=a,o=f});if(t){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=g.exec(a,this.options,(f,d,w)=>{this.childProcess=null;const E=f;E&&E.killed?o({killed:this.terminateRequested,stdout:d.toString(),stderr:w.toString()}):this.handleExec(r,p,f,d,w)})}else{let a=null;const f=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,r,p,o);const w={terminated:this.terminateRequested};P.isNumber(d)&&(w.cmdCode=d),r(w)};if(this.shell&&C.isWindows){const d=y.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let w=!1,E=!1;const s=[];let D=this.ensureQuotes(this.cmd);s.push(D.value),w=D.quoted,this.args&&this.args.forEach(U=>{D=this.ensureQuotes(U),s.push(D.value),E=E&&D.quoted});const R=["/s","/c"];w?E?R.push('"'+s.join(" ")+'"'):s.length>1?R.push('"'+s[0]+'" '+s.slice(1).join(" ")):R.push('"'+s[0]+'"'):R.push(s.join(" ")),a=g.spawn(v(),R,d)}else this.cmd&&(a=g.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(P.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",d=>{this.childProcess=null,o({terminated:this.terminateRequested,error:d})}),a.pid&&(this.childProcess.on("close",f),this.handleSpawn(a,r,p,o,!0)))}return n})}handleClose(p,t,r,o){}ensureQuotes(p){return _.regexp.test(p)?{value:'"'+p+'"',quoted:!0}:{value:p,quoted:p.length>0&&p[0]==='"'&&p[p.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(p=>p.pid,p=>-1):new Promise(p=>{this.pidResolve=p})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(p=>(this.terminateRequested=!0,l(p,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),p=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(p=>{if(!this.shell||!C.isWindows)return p(!1);const t=g.spawn(v(),["/s","/c"]);t.on("error",r=>p(!0)),t.on("exit",r=>p(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class b extends _{constructor(p,t,r,o){super(p,t,r,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(p,t,r,o,n){[o,n].forEach((a,f)=>{const d=new i.LineDecoder;d.write(a).forEach(s=>{t({line:s,source:f===0?0:1})});const E=d.end();E&&t({line:E,source:f===0?0:1})}),p({terminated:this.terminateRequested,error:r})}handleSpawn(p,t,r,o,n){const a=new i.LineDecoder,f=new i.LineDecoder;p.stdout.on("data",d=>{a.write(d).forEach(E=>r({line:E,source:0}))}),p.stderr.on("data",d=>{f.write(d).forEach(E=>r({line:E,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=f}handleClose(p,t,r,o){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&r({line:n,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&r({line:a,source:1})}}e.LineProcess=b;function A(h){let p=[],t=!1;const r=function(o){if(t){p.push(o);return}(!h.send(o,a=>{if(a&&console.error(a),t=!1,p.length>0){const f=p.slice(0);p=[],f.forEach(d=>r(d))}})||C.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=A;var c;(function(h){async function p(t,r,o){if(T.isAbsolute(t))return t;if(r===void 0&&(r=S.cwd()),T.dirname(t)!=="."||(o===void 0&&P.isString(S.env.PATH)&&(o=S.env.PATH.split(T.delimiter)),o===void 0||o.length===0))return T.join(r,t);async function a(f){return await I.Promises.exists(f)?!(await I.Promises.stat(f)).isDirectory():!1}for(let f of o){let d;if(T.isAbsolute(f)?d=T.join(f,t):d=T.join(r,f,t),await a(d))return d;let w=d+".com";if(await a(w)||(w=d+".exe",await a(w)))return w}return T.join(r,t)}h.findExecutable=p})(c=e.win32||(e.win32={}))}),define(me[154],ge([18,19]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(me[114],ge([0,1,154,11,110]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=T;class C{constructor(){this._values=[]}_read(se){return this._values[se]}get(se){return this._values[se]}_write(se,fe){this._values[se]=fe}}e.ValidatedEditorOptions=C;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class P{constructor(se,fe,xe,Be){this.id=se,this.name=fe,this.defaultValue=xe,this.schema=Be}compute(se,fe,xe){return xe}}class i{constructor(se,fe=null){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0,this.deps=fe}validate(se){return this.defaultValue}}class I{constructor(se,fe,xe,Be){this.id=se,this.name=fe,this.defaultValue=xe,this.schema=Be}validate(se){return typeof se=="undefined"?this.defaultValue:se}compute(se,fe,xe){return xe}}function u(X,se){return typeof X=="undefined"?se:X==="false"?!1:Boolean(X)}e.boolean=u;class m extends I{constructor(se,fe,xe,Be=void 0){typeof Be!="undefined"&&(Be.type="boolean",Be.default=xe),super(se,fe,xe,Be)}validate(se){return u(se,this.defaultValue)}}class l extends I{constructor(se,fe,xe,Be,et,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="integer",Ce.default=xe,Ce.minimum=Be,Ce.maximum=et),super(se,fe,xe,Ce),this.minimum=Be,this.maximum=et}static clampedInt(se,fe,xe,Be){if(typeof se=="undefined")return fe;let et=parseInt(se,10);return isNaN(et)?fe:(et=Math.max(xe,et),et=Math.min(Be,et),et|0)}validate(se){return l.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class v extends I{constructor(se,fe,xe,Be,et){typeof et!="undefined"&&(et.type="number",et.default=xe),super(se,fe,xe,et),this.validationFn=Be}static clamp(se,fe,xe){return se<fe?fe:se>xe?xe:se}static float(se,fe){if(typeof se=="number")return se;if(typeof se=="undefined")return fe;const xe=parseFloat(se);return isNaN(xe)?fe:xe}validate(se){return this.validationFn(v.float(se,this.defaultValue))}}class _ extends I{static string(se,fe){return typeof se!="string"?fe:se}constructor(se,fe,xe,Be=void 0){typeof Be!="undefined"&&(Be.type="string",Be.default=xe),super(se,fe,xe,Be)}validate(se){return _.string(se,this.defaultValue)}}function b(X,se,fe){return typeof X!="string"||fe.indexOf(X)===-1?se:X}e.stringSet=b;class A extends I{constructor(se,fe,xe,Be,et=void 0){typeof et!="undefined"&&(et.type="string",et.enum=Be,et.default=xe),super(se,fe,xe,et),this._allowedValues=Be}validate(se){return b(se,this.defaultValue,this._allowedValues)}}class c extends P{constructor(se,fe,xe,Be,et,Ce,De=void 0){typeof De!="undefined"&&(De.type="string",De.enum=et,De.default=Be),super(se,fe,xe,De),this._allowedValues=et,this._convert=Ce}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function h(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,fe,xe){return xe===0?se.accessibilitySupport:xe}}class t extends P{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:g.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{insertSpace:u(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var n;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(n=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(X){switch(X){case n.Line:return"line";case n.Block:return"block";case n.Underline:return"underline";case n.LineThin:return"line-thin";case n.BlockOutline:return"block-outline";case n.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function f(X){switch(X){case"line":return n.Line;case"block":return n.Block;case"underline":return n.Underline;case"line-thin":return n.LineThin;case"block-outline":return n.BlockOutline;case"underline-thin":return n.UnderlineThin}}class d extends i{constructor(){super(126,[64,31])}compute(se,fe,xe){const Be=["monaco-editor"];return fe.get(31)&&Be.push(fe.get(31)),se.extraEditorClassName&&Be.push(se.extraEditorClassName),fe.get(64)==="default"?Be.push("mouse-default"):fe.get(64)==="copy"&&Be.push("mouse-copy"),fe.get(99)&&Be.push("showUnused"),fe.get(124)&&Be.push("showDeprecated"),Be.join(" ")}}class w extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(se,fe,xe){return xe&&se.emptySelectionClipboard}}class E extends P{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:g.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:g.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{cursorMoveOnType:u(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":b(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":b(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(fe.loop,this.defaultValue.loop)}}}class s extends P{constructor(){super(42,"fontLigatures",s.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(se){return typeof se=="undefined"?this.defaultValue:typeof se=="string"?se==="false"?s.OFF:se==="true"?s.ON:se:Boolean(se)?s.ON:s.OFF}}e.EditorFontLigatures=s,s.OFF='"liga" off, "calt" off',s.ON='"liga" on, "calt" on';class D extends i{constructor(){super(41)}compute(se,fe,xe){return se.fontInfo}}class R extends I{constructor(){super(43,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(se){let fe=v.float(se,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(fe,6,100)}compute(se,fe,xe){return se.fontInfo.fontSize}}class U extends P{constructor(){super(44,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.MINIMUM_VALUE,maximum:U.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(l.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,U.MINIMUM_VALUE,U.MAXIMUM_VALUE))}}U.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],U.MINIMUM_VALUE=1,U.MAXIMUM_VALUE=1e3;class V extends P{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(48,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),...fe},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),...fe},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:xe,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:xe,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:xe,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:xe,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:xe,description:g.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{multiple:b(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??b(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??b(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??b(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??b(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??b(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends P{constructor(){const se={enabled:!0,delay:300,sticky:!0};super(51,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:g.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{enabled:u(fe.enabled,this.defaultValue.enabled),delay:l.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:u(fe.sticky,this.defaultValue.sticky)}}}var K;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(K=e.RenderMinimap||(e.RenderMinimap={}));class O extends i{constructor(){super(129,[47,56,35,63,91,58,59,93,116,119,120,121,2])}compute(se,fe,xe){return O.computeLayout(fe,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const fe=se.height/se.lineHeight,xe=se.scrollBeyondLastLine?fe-1:0,Be=(se.viewLineCount+xe)/(se.pixelRatio*se.height),et=Math.floor(se.viewLineCount/Be);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:xe,desiredRatio:Be,minimapLineCount:et}}static _computeMinimapLayout(se,fe){const xe=se.outerWidth,Be=se.outerHeight,et=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const Ce=fe.stableMinimapLayoutInput,De=Ce&&se.outerHeight===Ce.outerHeight&&se.lineHeight===Ce.lineHeight&&se.typicalHalfwidthCharacterWidth===Ce.typicalHalfwidthCharacterWidth&&se.pixelRatio===Ce.pixelRatio&&se.scrollBeyondLastLine===Ce.scrollBeyondLastLine&&se.minimap.enabled===Ce.minimap.enabled&&se.minimap.side===Ce.minimap.side&&se.minimap.size===Ce.minimap.size&&se.minimap.showSlider===Ce.minimap.showSlider&&se.minimap.renderCharacters===Ce.minimap.renderCharacters&&se.minimap.maxColumn===Ce.minimap.maxColumn&&se.minimap.scale===Ce.minimap.scale&&se.verticalScrollbarWidth===Ce.verticalScrollbarWidth&&se.isViewportWrapping===Ce.isViewportWrapping,Te=se.lineHeight,ce=se.typicalHalfwidthCharacterWidth,ue=se.scrollBeyondLastLine,pe=se.minimap.renderCharacters;let be=et>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const j=se.minimap.maxColumn,we=se.minimap.size,_e=se.minimap.side,Ae=se.verticalScrollbarWidth,Ue=se.viewLineCount,Ge=se.remainingWidth,Ze=se.isViewportWrapping,Qe=pe?2:3;let Xe=Math.floor(et*Be);const ct=Xe/et;let mt=!1,bt=!1,ot=Qe*be,at=be/et,Se=1;if(we==="fill"||we==="fit"){const{typicalViewportLineCount:Ke,extraLinesBeyondLastLine:ut,desiredRatio:St,minimapLineCount:kt}=O.computeContainedMinimapLineCount({viewLineCount:Ue,scrollBeyondLastLine:ue,height:Be,lineHeight:Te,pixelRatio:et});if(Ue/kt>1)mt=!0,bt=!0,be=1,ot=1,at=be/et;else{let ft=!1,dt=be+1;if(we==="fit"){const vt=Math.ceil((Ue+ut)*ot);Ze&&De&&Ge<=fe.stableFitRemainingWidth?(ft=!0,dt=fe.stableFitMaxMinimapScale):ft=vt>Xe}if(we==="fill"||ft){mt=!0;const vt=be;ot=Math.min(Te*et,Math.max(1,Math.floor(1/St))),Ze&&De&&Ge<=fe.stableFitRemainingWidth&&(dt=fe.stableFitMaxMinimapScale),be=Math.min(dt,Math.max(1,Math.floor(ot/Qe))),be>vt&&(Se=Math.min(2,be/vt)),at=be/et/Se,Xe=Math.ceil(Math.max(Ke,Ue+ut)*ot),Ze?(fe.stableMinimapLayoutInput=se,fe.stableFitRemainingWidth=Ge,fe.stableFitMaxMinimapScale=be):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const Pe=Math.floor(j*at),te=Math.min(Pe,Math.max(0,Math.floor((Ge-Ae-2)*at/(ce+at)))+e.MINIMAP_GUTTER_WIDTH);let Q=Math.floor(et*te);const Oe=Q/et;Q=Math.floor(Q*Se);const Fe=pe?1:2,tt=_e==="left"?0:xe-te-Ae;return{renderMinimap:Fe,minimapLeft:tt,minimapWidth:te,minimapHeightIsEditorHeight:mt,minimapIsSampling:bt,minimapScale:be,minimapLineHeight:ot,minimapCanvasInnerWidth:Q,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:Oe,minimapCanvasOuterHeight:ct}}static computeLayout(se,fe){const xe=fe.outerWidth|0,Be=fe.outerHeight|0,et=fe.lineHeight|0,Ce=fe.lineNumbersDigitCount|0,De=fe.typicalHalfwidthCharacterWidth,Te=fe.maxDigitWidth,ce=fe.pixelRatio,ue=fe.viewLineCount,pe=se.get(121),be=pe==="inherit"?se.get(120):pe,j=be==="inherit"?se.get(116):be,we=se.get(119),_e=se.get(2),Ae=fe.isDominatedByLongLines,Ue=se.get(47),Ge=se.get(58).renderType!==0,Ze=se.get(59),Qe=se.get(93),Xe=se.get(63),ct=se.get(91),mt=ct.verticalScrollbarSize,bt=ct.verticalHasArrows,ot=ct.arrowSize,at=ct.horizontalScrollbarSize,Se=se.get(56),Pe=se.get(35);let te;if(typeof Se=="string"&&/^\d+(\.\d+)?ch$/.test(Se)){const It=parseFloat(Se.substr(0,Se.length-2));te=l.clampedInt(It*De,0,0,1e3)}else te=l.clampedInt(Se,0,0,1e3);Pe&&(te+=16);let Q=0;if(Ge){const It=Math.max(Ce,Ze);Q=Math.round(It*Te)}let Oe=0;Ue&&(Oe=et);let Fe=0,tt=Fe+Oe,Ke=tt+Q,ut=Ke+te;const St=xe-Oe-Q-te;let kt=!1,Dt=!1,ft=-1;_e!==2&&(be==="inherit"&&Ae?(kt=!0,Dt=!0):j==="on"||j==="bounded"?Dt=!0:j==="wordWrapColumn"&&(ft=we));const dt=O._computeMinimapLayout({outerWidth:xe,outerHeight:Be,lineHeight:et,typicalHalfwidthCharacterWidth:De,pixelRatio:ce,scrollBeyondLastLine:Qe,minimap:Xe,verticalScrollbarWidth:mt,viewLineCount:ue,remainingWidth:St,isViewportWrapping:Dt},fe.memory||new S);dt.renderMinimap!==0&&dt.minimapLeft===0&&(Fe+=dt.minimapWidth,tt+=dt.minimapWidth,Ke+=dt.minimapWidth,ut+=dt.minimapWidth);const vt=St-dt.minimapWidth,Et=Math.max(1,Math.floor((vt-mt-2)/De)),Tt=bt?ot:0;return Dt&&(ft=Math.max(1,Et),j==="bounded"&&(ft=Math.min(ft,we))),{width:xe,height:Be,glyphMarginLeft:Fe,glyphMarginWidth:Oe,lineNumbersLeft:tt,lineNumbersWidth:Q,decorationsLeft:Ke,decorationsWidth:te,contentLeft:ut,contentWidth:vt,minimap:dt,viewportColumn:Et,isWordWrapMinified:kt,isViewportWrapping:Dt,wrappingColumn:ft,verticalScrollbarWidth:mt,horizontalScrollbarHeight:at,overviewRuler:{top:Tt,width:mt,height:Be-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=O;class x extends P{constructor(){const se={enabled:!0};super(55,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:g.localize(42,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:u(se.enabled,this.defaultValue.enabled)}}}class F extends P{constructor(){const se={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",se,{"editor.inlayHints.enabled":{type:"boolean",default:se.enabled,description:g.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:g.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,description:g.localize(45,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{enabled:u(fe.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(fe.fontFamily,this.defaultValue.fontFamily)}}}class z extends v{constructor(){super(57,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>v.clamp(se,0,150),{markdownDescription:g.localize(46,null)})}compute(se,fe,xe){return se.fontInfo.lineHeight}}class M extends P{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(63,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:g.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(48,null),g.localize(49,null),g.localize(50,null)],default:se.size,description:g.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:g.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:g.localize(53,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:g.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:g.localize(56,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{enabled:u(fe.enabled,this.defaultValue.enabled),size:b(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(fe.side,this.defaultValue.side,["right","left"]),showSlider:b(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(fe.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(fe.scale,1,1,3),maxColumn:l.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function N(X){return X==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class q extends P{constructor(){super(73,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{top:l.clampedInt(fe.top,0,0,1e3),bottom:l.clampedInt(fe.bottom,0,0,1e3)}}}class B extends P{constructor(){const se={enabled:!0,cycle:!1};super(74,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:g.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:g.localize(60,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{enabled:u(fe.enabled,this.defaultValue.enabled),cycle:u(fe.cycle,this.defaultValue.cycle)}}}class G extends i{constructor(){super(127)}compute(se,fe,xe){return se.pixelRatio}}class re extends P{constructor(){const se={other:!0,comments:!1,strings:!1};super(77,"quickSuggestions",se,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:se.strings,description:g.localize(61,null)},comments:{type:"boolean",default:se.comments,description:g.localize(62,null)},other:{type:"boolean",default:se.other,description:g.localize(63,null)}}}],default:se,description:g.localize(64,null)});this.defaultValue=se}validate(se){if(typeof se=="boolean")return se;if(se&&typeof se=="object"){const fe=se,xe={other:u(fe.other,this.defaultValue.other),comments:u(fe.comments,this.defaultValue.comments),strings:u(fe.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var he;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(he=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ye extends P{constructor(){super(58,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(65,null),g.localize(66,null),g.localize(67,null),g.localize(68,null)],default:"on",description:g.localize(69,null)})}validate(se){let fe=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof se!="undefined"&&(typeof se=="function"?(fe=4,xe=se):se==="interval"?fe=3:se==="relative"?fe=2:se==="on"?fe=1:fe=0),{renderType:fe,renderFn:xe}}}function Ie(X){const se=X.get(86);return se==="editable"?X.get(79):se!=="on"}e.filterValidationDecorations=Ie;class Le extends P{constructor(){const se=[],fe={type:"number",description:g.localize(70,null)};super(90,"rulers",se,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:g.localize(71,null),format:"color-hex"}}}]},default:se,description:g.localize(72,null)})}validate(se){if(Array.isArray(se)){let fe=[];for(let xe of se)if(typeof xe=="number")fe.push({column:l.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const Be=xe;fe.push({column:l.clampedInt(Be.column,0,0,1e4),color:Be.color})}return fe.sort((xe,Be)=>xe.column-Be.column),fe}return this.defaultValue}}function qe(X,se){if(typeof X!="string")return se;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class We extends P{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(73,null),g.localize(74,null),g.localize(75,null)],default:"auto",description:g.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(77,null),g.localize(78,null),g.localize(79,null)],default:"auto",description:g.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:g.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:g.localize(83,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se,xe=l.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=l.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:qe(fe.vertical,this.defaultValue.vertical),horizontal:qe(fe.horizontal,this.defaultValue.horizontal),useShadows:u(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:l.clampedInt(fe.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:l.clampedInt(fe.verticalSliderSize,Be,0,1e3),scrollByPage:u(fe.scrollByPage,this.defaultValue.scrollByPage)}}}class je extends P{constructor(){const se={enabled:!1,mode:"subwordSmart"};super(53,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:g.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(85,null),g.localize(86,null),g.localize(87,null)],default:se.mode,description:g.localize(88,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{enabled:u(fe.enabled,this.defaultValue.enabled),mode:b(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class W extends P{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(89,null),g.localize(90,null)],default:se.insertMode,description:g.localize(91,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:g.localize(92,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:g.localize(93,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:g.localize(94,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:g.localize(95,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:g.localize(96,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:g.localize(97,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:g.localize(98,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(99,null),g.localize(100,null),g.localize(101,null)],default:se.previewMode,description:g.localize(102,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:g.localize(103,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(104,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(105,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(106,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(133,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(134,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const fe=se;return{insertMode:b(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u(fe.showIcons,this.defaultValue.showIcons),showStatusBar:u(fe.showStatusBar,this.defaultValue.showStatusBar),preview:u(fe.preview,this.defaultValue.preview),previewMode:b(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(fe.showMethods,this.defaultValue.showMethods),showFunctions:u(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:u(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(fe.showDeprecated,this.defaultValue.showDeprecated),showFields:u(fe.showFields,this.defaultValue.showFields),showVariables:u(fe.showVariables,this.defaultValue.showVariables),showClasses:u(fe.showClasses,this.defaultValue.showClasses),showStructs:u(fe.showStructs,this.defaultValue.showStructs),showInterfaces:u(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:u(fe.showModules,this.defaultValue.showModules),showProperties:u(fe.showProperties,this.defaultValue.showProperties),showEvents:u(fe.showEvents,this.defaultValue.showEvents),showOperators:u(fe.showOperators,this.defaultValue.showOperators),showUnits:u(fe.showUnits,this.defaultValue.showUnits),showValues:u(fe.showValues,this.defaultValue.showValues),showConstants:u(fe.showConstants,this.defaultValue.showConstants),showEnums:u(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:u(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(fe.showKeywords,this.defaultValue.showKeywords),showWords:u(fe.showWords,this.defaultValue.showWords),showColors:u(fe.showColors,this.defaultValue.showColors),showFiles:u(fe.showFiles,this.defaultValue.showFiles),showReferences:u(fe.showReferences,this.defaultValue.showReferences),showFolders:u(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:u(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(fe.showSnippets,this.defaultValue.showSnippets),showUsers:u(fe.showUsers,this.defaultValue.showUsers),showIssues:u(fe.showIssues,this.defaultValue.showIssues)}}}class Z extends P{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(135,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ne extends i{constructor(){super(128,[79])}compute(se,fe,xe){return fe.get(79)?!0:se.tabFocusMode}}var le;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(le=e.WrappingIndent||(e.WrappingIndent={}));function Y(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ae extends i{constructor(){super(130,[129])}compute(se,fe,xe){const Be=fe.get(129);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}const ve="Consolas, 'Courier New', monospace",Me="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?Me:L.isLinux?ze:ve,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(X){return e.editorOptionsRegistry[X.id]=X,X}var Je;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.foldingImportsByDefault=38]="foldingImportsByDefault",X[X.unfoldOnClickAfterEndOfLine=39]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=40]="fontFamily",X[X.fontInfo=41]="fontInfo",X[X.fontLigatures=42]="fontLigatures",X[X.fontSize=43]="fontSize",X[X.fontWeight=44]="fontWeight",X[X.formatOnPaste=45]="formatOnPaste",X[X.formatOnType=46]="formatOnType",X[X.glyphMargin=47]="glyphMargin",X[X.gotoLocation=48]="gotoLocation",X[X.hideCursorInOverviewRuler=49]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=50]="highlightActiveIndentGuide",X[X.hover=51]="hover",X[X.inDiffEditor=52]="inDiffEditor",X[X.inlineSuggest=53]="inlineSuggest",X[X.letterSpacing=54]="letterSpacing",X[X.lightbulb=55]="lightbulb",X[X.lineDecorationsWidth=56]="lineDecorationsWidth",X[X.lineHeight=57]="lineHeight",X[X.lineNumbers=58]="lineNumbers",X[X.lineNumbersMinChars=59]="lineNumbersMinChars",X[X.linkedEditing=60]="linkedEditing",X[X.links=61]="links",X[X.matchBrackets=62]="matchBrackets",X[X.minimap=63]="minimap",X[X.mouseStyle=64]="mouseStyle",X[X.mouseWheelScrollSensitivity=65]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=66]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=67]="multiCursorMergeOverlapping",X[X.multiCursorModifier=68]="multiCursorModifier",X[X.multiCursorPaste=69]="multiCursorPaste",X[X.occurrencesHighlight=70]="occurrencesHighlight",X[X.overviewRulerBorder=71]="overviewRulerBorder",X[X.overviewRulerLanes=72]="overviewRulerLanes",X[X.padding=73]="padding",X[X.parameterHints=74]="parameterHints",X[X.peekWidgetDefaultFocus=75]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=76]="definitionLinkOpensInPeek",X[X.quickSuggestions=77]="quickSuggestions",X[X.quickSuggestionsDelay=78]="quickSuggestionsDelay",X[X.readOnly=79]="readOnly",X[X.renameOnType=80]="renameOnType",X[X.renderControlCharacters=81]="renderControlCharacters",X[X.renderIndentGuides=82]="renderIndentGuides",X[X.renderFinalNewline=83]="renderFinalNewline",X[X.renderLineHighlight=84]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=86]="renderValidationDecorations",X[X.renderWhitespace=87]="renderWhitespace",X[X.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",X[X.roundedSelection=89]="roundedSelection",X[X.rulers=90]="rulers",X[X.scrollbar=91]="scrollbar",X[X.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=93]="scrollBeyondLastLine",X[X.scrollPredominantAxis=94]="scrollPredominantAxis",X[X.selectionClipboard=95]="selectionClipboard",X[X.selectionHighlight=96]="selectionHighlight",X[X.selectOnLineNumbers=97]="selectOnLineNumbers",X[X.showFoldingControls=98]="showFoldingControls",X[X.showUnused=99]="showUnused",X[X.snippetSuggestions=100]="snippetSuggestions",X[X.smartSelect=101]="smartSelect",X[X.smoothScrolling=102]="smoothScrolling",X[X.stickyTabStops=103]="stickyTabStops",X[X.stopRenderingLineAfter=104]="stopRenderingLineAfter",X[X.suggest=105]="suggest",X[X.suggestFontSize=106]="suggestFontSize",X[X.suggestLineHeight=107]="suggestLineHeight",X[X.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",X[X.suggestSelection=109]="suggestSelection",X[X.tabCompletion=110]="tabCompletion",X[X.tabIndex=111]="tabIndex",X[X.unusualLineTerminators=112]="unusualLineTerminators",X[X.useShadowDOM=113]="useShadowDOM",X[X.useTabStops=114]="useTabStops",X[X.wordSeparators=115]="wordSeparators",X[X.wordWrap=116]="wordWrap",X[X.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=119]="wordWrapColumn",X[X.wordWrapOverride1=120]="wordWrapOverride1",X[X.wordWrapOverride2=121]="wordWrapOverride2",X[X.wrappingIndent=122]="wrappingIndent",X[X.wrappingStrategy=123]="wrappingStrategy",X[X.showDeprecated=124]="showDeprecated",X[X.inlayHints=125]="inlayHints",X[X.editorClassName=126]="editorClassName",X[X.pixelRatio=127]="pixelRatio",X[X.tabFocusMode=128]="tabFocusMode",X[X.layoutInfo=129]="layoutInfo",X[X.wrappingInfo=130]="wrappingInfo"})(Je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(136,null)})),acceptSuggestionOnEnter:Ee(new A(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(137,null),""],markdownDescription:g.localize(138,null)})),accessibilitySupport:Ee(new p),accessibilityPageSize:Ee(new l(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(139,null)})),ariaLabel:Ee(new _(4,"ariaLabel",g.localize(140,null))),autoClosingBrackets:Ee(new A(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(141,null),g.localize(142,null),""],description:g.localize(143,null)})),autoClosingDelete:Ee(new A(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(144,null),""],description:g.localize(145,null)})),autoClosingOvertype:Ee(new A(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(146,null),""],description:g.localize(147,null)})),autoClosingQuotes:Ee(new A(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(148,null),g.localize(149,null),""],description:g.localize(150,null)})),autoIndent:Ee(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[g.localize(151,null),g.localize(152,null),g.localize(153,null),g.localize(154,null),g.localize(155,null)],description:g.localize(156,null)})),automaticLayout:Ee(new m(10,"automaticLayout",!1)),autoSurround:Ee(new A(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(157,null),g.localize(158,null),g.localize(159,null),""],description:g.localize(160,null)})),stickyTabStops:Ee(new m(103,"stickyTabStops",!1,{description:g.localize(161,null)})),codeLens:Ee(new m(12,"codeLens",!0,{description:g.localize(162,null)})),codeLensFontFamily:Ee(new _(13,"codeLensFontFamily","",{description:g.localize(163,null)})),codeLensFontSize:Ee(new l(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(164,null)})),colorDecorators:Ee(new m(15,"colorDecorators",!0,{description:g.localize(165,null)})),columnSelection:Ee(new m(16,"columnSelection",!1,{description:g.localize(166,null)})),comments:Ee(new t),contextmenu:Ee(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new m(19,"copyWithSyntaxHighlighting",!0,{description:g.localize(167,null)})),cursorBlinking:Ee(new c(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:g.localize(168,null)})),cursorSmoothCaretAnimation:Ee(new m(21,"cursorSmoothCaretAnimation",!1,{description:g.localize(169,null)})),cursorStyle:Ee(new c(22,"cursorStyle",n.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:g.localize(170,null)})),cursorSurroundingLines:Ee(new l(23,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(171,null)})),cursorSurroundingLinesStyle:Ee(new A(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(172,null),g.localize(173,null)],description:g.localize(174,null)})),cursorWidth:Ee(new l(25,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(175,null)})),disableLayerHinting:Ee(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new m(28,"domReadOnly",!1)),dragAndDrop:Ee(new m(29,"dragAndDrop",!0,{description:g.localize(176,null)})),emptySelectionClipboard:Ee(new w),extraEditorClassName:Ee(new _(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new v(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:g.localize(177,null)})),find:Ee(new E),fixedOverflowWidgets:Ee(new m(34,"fixedOverflowWidgets",!1)),folding:Ee(new m(35,"folding",!0,{description:g.localize(178,null)})),foldingStrategy:Ee(new A(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(179,null),g.localize(180,null)],description:g.localize(181,null)})),foldingHighlight:Ee(new m(37,"foldingHighlight",!0,{description:g.localize(182,null)})),foldingImportsByDefault:Ee(new m(38,"foldingImportsByDefault",!1,{description:g.localize(183,null)})),unfoldOnClickAfterEndOfLine:Ee(new m(39,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(184,null)})),fontFamily:Ee(new _(40,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(185,null)})),fontInfo:Ee(new D),fontLigatures2:Ee(new s),fontSize:Ee(new R),fontWeight:Ee(new U),formatOnPaste:Ee(new m(45,"formatOnPaste",!1,{description:g.localize(186,null)})),formatOnType:Ee(new m(46,"formatOnType",!1,{description:g.localize(187,null)})),glyphMargin:Ee(new m(47,"glyphMargin",!0,{description:g.localize(188,null)})),gotoLocation:Ee(new V),hideCursorInOverviewRuler:Ee(new m(49,"hideCursorInOverviewRuler",!1,{description:g.localize(189,null)})),highlightActiveIndentGuide:Ee(new m(50,"highlightActiveIndentGuide",!0,{description:g.localize(190,null)})),hover:Ee(new ee),inDiffEditor:Ee(new m(52,"inDiffEditor",!1)),letterSpacing:Ee(new v(54,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>v.clamp(X,-5,20),{description:g.localize(191,null)})),lightbulb:Ee(new x),lineDecorationsWidth:Ee(new I(56,"lineDecorationsWidth",10)),lineHeight:Ee(new z),lineNumbers:Ee(new ye),lineNumbersMinChars:Ee(new l(59,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new m(60,"linkedEditing",!1,{description:g.localize(192,null)})),links:Ee(new m(61,"links",!0,{description:g.localize(193,null)})),matchBrackets:Ee(new A(62,"matchBrackets","always",["always","near","never"],{description:g.localize(194,null)})),minimap:Ee(new M),mouseStyle:Ee(new A(64,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new v(65,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:g.localize(195,null)})),mouseWheelZoom:Ee(new m(66,"mouseWheelZoom",!1,{markdownDescription:g.localize(196,null)})),multiCursorMergeOverlapping:Ee(new m(67,"multiCursorMergeOverlapping",!0,{description:g.localize(197,null)})),multiCursorModifier:Ee(new c(68,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],N,{markdownEnumDescriptions:[g.localize(198,null),g.localize(199,null)],markdownDescription:g.localize(200,null)})),multiCursorPaste:Ee(new A(69,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(201,null),g.localize(202,null)],markdownDescription:g.localize(203,null)})),occurrencesHighlight:Ee(new m(70,"occurrencesHighlight",!0,{description:g.localize(204,null)})),overviewRulerBorder:Ee(new m(71,"overviewRulerBorder",!0,{description:g.localize(205,null)})),overviewRulerLanes:Ee(new l(72,"overviewRulerLanes",3,0,3)),padding:Ee(new q),parameterHints:Ee(new B),peekWidgetDefaultFocus:Ee(new A(75,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(206,null),g.localize(207,null)],description:g.localize(208,null)})),definitionLinkOpensInPeek:Ee(new m(76,"definitionLinkOpensInPeek",!1,{description:g.localize(209,null)})),quickSuggestions:Ee(new re),quickSuggestionsDelay:Ee(new l(78,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(210,null)})),readOnly:Ee(new m(79,"readOnly",!1)),renameOnType:Ee(new m(80,"renameOnType",!1,{description:g.localize(211,null),markdownDeprecationMessage:g.localize(212,null)})),renderControlCharacters:Ee(new m(81,"renderControlCharacters",!1,{description:g.localize(213,null)})),renderIndentGuides:Ee(new m(82,"renderIndentGuides",!0,{description:g.localize(214,null)})),renderFinalNewline:Ee(new m(83,"renderFinalNewline",!0,{description:g.localize(215,null)})),renderLineHighlight:Ee(new A(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(216,null)],description:g.localize(217,null)})),renderLineHighlightOnlyWhenFocus:Ee(new m(85,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(218,null)})),renderValidationDecorations:Ee(new A(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new A(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(219,null),g.localize(220,null),g.localize(221,null),""],description:g.localize(222,null)})),revealHorizontalRightPadding:Ee(new l(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new m(89,"roundedSelection",!0,{description:g.localize(223,null)})),rulers:Ee(new Le),scrollbar:Ee(new We),scrollBeyondLastColumn:Ee(new l(92,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(224,null)})),scrollBeyondLastLine:Ee(new m(93,"scrollBeyondLastLine",!0,{description:g.localize(225,null)})),scrollPredominantAxis:Ee(new m(94,"scrollPredominantAxis",!0,{description:g.localize(226,null)})),selectionClipboard:Ee(new m(95,"selectionClipboard",!0,{description:g.localize(227,null),included:L.isLinux})),selectionHighlight:Ee(new m(96,"selectionHighlight",!0,{description:g.localize(228,null)})),selectOnLineNumbers:Ee(new m(97,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new A(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(229,null),g.localize(230,null)],description:g.localize(231,null)})),showUnused:Ee(new m(99,"showUnused",!0,{description:g.localize(232,null)})),showDeprecated:Ee(new m(124,"showDeprecated",!0,{description:g.localize(233,null)})),inlayHints:Ee(new F),snippetSuggestions:Ee(new A(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(234,null),g.localize(235,null),g.localize(236,null),g.localize(237,null)],description:g.localize(238,null)})),smartSelect:Ee(new Z),smoothScrolling:Ee(new m(102,"smoothScrolling",!1,{description:g.localize(239,null)})),stopRenderingLineAfter:Ee(new l(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new W),inlineSuggest:Ee(new je),suggestFontSize:Ee(new l(106,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(240,null)})),suggestLineHeight:Ee(new l(107,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(241,null)})),suggestOnTriggerCharacters:Ee(new m(108,"suggestOnTriggerCharacters",!0,{description:g.localize(242,null)})),suggestSelection:Ee(new A(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(243,null),g.localize(244,null),g.localize(245,null)],description:g.localize(246,null)})),tabCompletion:Ee(new A(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(247,null),g.localize(248,null),g.localize(249,null)],description:g.localize(250,null)})),tabIndex:Ee(new l(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new A(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(251,null),g.localize(252,null),g.localize(253,null)],description:g.localize(254,null)})),useShadowDOM:Ee(new m(113,"useShadowDOM",!0)),useTabStops:Ee(new m(114,"useTabStops",!0,{description:g.localize(255,null)})),wordSeparators:Ee(new _(115,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:g.localize(256,null)})),wordWrap:Ee(new A(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(257,null),g.localize(258,null),g.localize(259,null),g.localize(260,null)],description:g.localize(261,null)})),wordWrapBreakAfterCharacters:Ee(new _(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new _(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new l(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(262,null)})),wordWrapOverride1:Ee(new A(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new A(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new c(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Y,{enumDescriptions:[g.localize(263,null),g.localize(264,null),g.localize(265,null),g.localize(266,null)],description:g.localize(267,null)})),wrappingStrategy:Ee(new A(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(268,null),g.localize(269,null)],description:g.localize(270,null)})),editorClassName:Ee(new d),pixelRatio:Ee(new G),tabFocusMode:Ee(new ne),layoutInfo:Ee(new O),wrappingInfo:Ee(new ae)}}),define(me[155],ge([18,19]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[156],ge([18,19]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[157],ge([18,19]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[158],ge([18,19]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[159],ge([18,19]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(me[160],ge([18,19]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(me[161],ge([18,19]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(me[162],ge([18,19]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(me[163],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[164],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[165],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(me[166],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[167],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[168],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[169],ge([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[170],ge([18,19]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[171],ge([18,19]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(me[172],ge([18,19]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(me[173],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[174],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[175],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[176],ge([18,19]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[177],ge([18,19]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[178],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var L;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var k;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var y;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(y=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[179],ge([0,1,157]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function y(u){return u=u.trim(),u==="*"||L.test(u)}e.isValidVersionStr=y;function T(u){if(!y(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=u.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=T;function C(u){if(!u)return null;let m=u.majorBase,l=u.majorMustEqual,v=u.minorBase,_=u.minorMustEqual,b=u.patchBase,A=u.patchMustEqual;u.hasCaret&&(m===0||(_=!1),A=!1);let c=0;if(u.preRelease){const h=k.exec(u.preRelease);if(h){const[,p,t,r]=h;c=Date.UTC(Number(p),Number(t)-1,Number(r))}}return{majorBase:m,majorMustEqual:l,minorBase:v,minorMustEqual:_,patchBase:b,patchMustEqual:A,isMinimum:u.hasGreaterEquals,notBefore:c}}e.normalizeVersion=C;function S(u,m,l){let v;typeof u=="string"?v=C(T(u)):v=u;let _;m instanceof Date?_=m.getTime():typeof m=="string"&&(_=new Date(m).getTime());let b;if(typeof l=="string"?b=C(T(l)):b=l,!v||!b)return!1;let A=v.majorBase,c=v.minorBase,h=v.patchBase,p=b.majorBase,t=b.minorBase,r=b.patchBase,o=b.notBefore,n=b.majorMustEqual,a=b.minorMustEqual,f=b.patchMustEqual;return b.isMinimum?A>p?!0:A<p?!1:c>t?!0:c<t||_&&_<o?!1:h>=r:(A===1&&p===0&&(!n||!a||!f)&&(p=1,t=0,r=0,n=!0,a=!1,f=!1),A<p?!1:A>p?!n:c<t?!1:c>t?!a:h<r?!1:h>r?!f:!(_&&_<o))}e.isValidVersion=S;function P(u,m,l,v){return l.isBuiltin||typeof l.main=="undefined"?!0:I(u,m,l.engines.vscode,v)}e.isValidExtensionVersion=P;function i(u,m,l){return u==="*"||I(m,l,u)}e.isEngineValid=i;function I(u,m,l,v=[]){let _=C(T(l));if(!_)return v.push(g.localize(0,null,l)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return v.push(g.localize(1,null,l)),!1}else if(!_.majorMustEqual)return v.push(g.localize(2,null,l)),!1;return S(u,m,_)?!0:(v.push(g.localize(3,null,u,l)),!1)}}),define(me[115],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(k,y=[],T=!1){this.ctor=k,this.staticArguments=y,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=g}),define(me[80],ge([0,1,115]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function k(T,C,S){C instanceof g.SyncDescriptor||(C=new g.SyncDescriptor(C,[],S)),L.push([T,C])}e.registerSingleton=k;function y(){return L}e.getSingletonServiceDescriptors=y}),define(me[180],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=g;class L{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let T of this._nodes.values())T.outgoing.size===0&&y.push(T);return y}insertEdge(y,T){const C=this.lookupOrInsertNode(y),S=this.lookupOrInsertNode(T);C.outgoing.set(this._hashFn(T),S),S.incoming.set(this._hashFn(y),C)}removeNode(y){const T=this._hashFn(y);this._nodes.delete(T);for(let C of this._nodes.values())C.outgoing.delete(T),C.incoming.delete(T)}lookupOrInsertNode(y){const T=this._hashFn(y);let C=this._nodes.get(T);return C||(C=new g(y),this._nodes.set(T,C)),C}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[T,C]of this._nodes)y.push(`${T}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,T]of this._nodes){const C=new Set([y]),S=this._findCycle(T,C);if(S)return S}}_findCycle(y,T){for(let[C,S]of y.outgoing){if(T.has(C))return[...T,C].join(" -> ");T.add(C);const P=this._findCycle(S,T);if(P)return P;T.delete(C)}}}e.Graph=L}),define(me[4],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function S(P){return P[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=S})(g=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(C,S,P,i){S[g.DI_TARGET]===S?S[g.DI_DEPENDENCIES].push({id:C,index:P,optional:i}):(S[g.DI_DEPENDENCIES]=[{id:C,index:P,optional:i}],S[g.DI_TARGET]=S)}function k(C){if(g.serviceIds.has(C))return g.serviceIds.get(C);const S=function(P,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(S,P,I,!1)};return S.toString=()=>C,g.serviceIds.set(C,S),S}e.createDecorator=k;function y(C){return C}e.refineServiceDecorator=y;function T(C){return function(S,P,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(C,S,i,!0)}}e.optional=T}),define(me[181],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function L(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(me[182],ge([0,1,3,58,6,22,75,79,181]),function(J,e,g,L,k,y,T,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(P):!!u.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(m,l){let v={selector:m,provider:l,_score:-1,_time:this._clock++};return this._entries.push(v),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,k.toDisposable)(()=>{if(v){let _=this._entries.indexOf(v);_>=0&&(this._entries.splice(_,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),v=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const l=[];for(let v of this._entries)v._score>0&&l.push(v.provider);return l}ordered(m){const l=[];return this._orderedForEach(m,v=>l.push(v.provider)),l}orderedGroups(m){const l=[];let v,_;return this._orderedForEach(m,b=>{v&&_===b._score?v.push(b.provider):(_=b._score,v=[b.provider],l.push(v))}),l}_orderedForEach(m,l){if(!!m){this._updateScores(m);for(const v of this._entries)v._score>0&&l(v)}}_updateScores(m){let l={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===l.language&&this._lastCandidate.uri===l.uri)){this._lastCandidate=l;for(let v of this._entries)if(v._score=(0,C.score)(v.selector,m.uri,m.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(m)),P(v.selector)&&v._score>0){for(let _ of this._entries)_._score=0;v._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(m,l){return m._score<l._score?1:m._score>l._score?-1:m._time<l._time?1:m._time>l._time?-1:0}}e.LanguageFeatureRegistry=i;class I{constructor(m,l,v=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=l,this.max=v,this._cache=new y.LRUCache(50,.7)}_key(m){return m.id+(0,L.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const l=this._key(m),v=this._cache.get(l);return this._clamp(v?.value)}update(m,l){const v=this._key(m);let _=this._cache.get(v);return _||(_=new T.MovingAverage,this._cache.set(v,_)),_.update(l),this.get(m)}}e.LanguageFeatureRequestDelays=I}),define(me[81],ge([0,1,2,41,182,148,47]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(s){s[s.Null=0]="Null",s[s.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class S{constructor(D,R){this.language=D,this.id=R}}e.LanguageIdentifier=S;var P;(function(s){s[s.NotSet=-1]="NotSet",s[s.None=0]="None",s[s.Italic=1]="Italic",s[s.Bold=2]="Bold",s[s.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var i;(function(s){s[s.None=0]="None",s[s.DefaultForeground=1]="DefaultForeground",s[s.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var I;(function(s){s[s.Other=0]="Other",s[s.Comment=1]="Comment",s[s.String=2]="String",s[s.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var u;(function(s){s[s.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",s[s.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",s[s.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",s[s.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",s[s.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",s[s.ITALIC_MASK=2048]="ITALIC_MASK",s[s.BOLD_MASK=4096]="BOLD_MASK",s[s.UNDERLINE_MASK=8192]="UNDERLINE_MASK",s[s.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",s[s.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",s[s.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",s[s.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",s[s.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",s[s.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",s[s.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",s[s.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",s[s.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",s[s.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(u=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(D){return(D&255)>>>0}static getTokenType(D){return(D&1792)>>>8}static getFontStyle(D){return(D&14336)>>>11}static getForeground(D){return(D&8372224)>>>14}static getBackground(D){return(D&4286578688)>>>23}static getClassNameFromMetadata(D){let R=this.getForeground(D),U="mtk"+R,V=this.getFontStyle(D);return V&1&&(U+=" mtki"),V&2&&(U+=" mtkb"),V&4&&(U+=" mtku"),U}static getInlineStyleFromMetadata(D,R){const U=this.getForeground(D),V=this.getFontStyle(D);let ee=`color: ${R[U]};`;return V&1&&(ee+="font-style: italic;"),V&2&&(ee+="font-weight: bold;"),V&4&&(ee+="text-decoration: underline;"),ee}}e.TokenMetadata=m;var l;(function(s){s[s.Method=0]="Method",s[s.Function=1]="Function",s[s.Constructor=2]="Constructor",s[s.Field=3]="Field",s[s.Variable=4]="Variable",s[s.Class=5]="Class",s[s.Struct=6]="Struct",s[s.Interface=7]="Interface",s[s.Module=8]="Module",s[s.Property=9]="Property",s[s.Event=10]="Event",s[s.Operator=11]="Operator",s[s.Unit=12]="Unit",s[s.Value=13]="Value",s[s.Constant=14]="Constant",s[s.Enum=15]="Enum",s[s.EnumMember=16]="EnumMember",s[s.Keyword=17]="Keyword",s[s.Text=18]="Text",s[s.Color=19]="Color",s[s.File=20]="File",s[s.Reference=21]="Reference",s[s.Customcolor=22]="Customcolor",s[s.Folder=23]="Folder",s[s.TypeParameter=24]="TypeParameter",s[s.User=25]="User",s[s.Issue=26]="Issue",s[s.Snippet=27]="Snippet"})(l=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let s=Object.create(null);return s[0]="symbol-method",s[1]="symbol-function",s[2]="symbol-constructor",s[3]="symbol-field",s[4]="symbol-variable",s[5]="symbol-class",s[6]="symbol-struct",s[7]="symbol-interface",s[8]="symbol-module",s[9]="symbol-property",s[10]="symbol-event",s[11]="symbol-operator",s[12]="symbol-unit",s[13]="symbol-value",s[14]="symbol-constant",s[15]="symbol-enum",s[16]="symbol-enum-member",s[17]="symbol-keyword",s[27]="symbol-snippet",s[18]="symbol-text",s[19]="symbol-color",s[20]="symbol-file",s[21]="symbol-reference",s[22]="symbol-customcolor",s[23]="symbol-folder",s[24]="symbol-type-parameter",s[25]="account",s[26]="issues",function(D){const R=s[D];let U=R&&T.iconRegistry.get(R);return U||(console.info("No codicon found for CompletionItemKind "+D),U=T.Codicon.symbolProperty),U.classNames}}(),e.completionKindFromString=function(){let s=Object.create(null);return s.method=0,s.function=1,s.constructor=2,s.field=3,s.variable=4,s.class=5,s.struct=6,s.interface=7,s.module=8,s.property=9,s.event=10,s.operator=11,s.unit=12,s.value=13,s.constant=14,s.enum=15,s["enum-member"]=16,s.enumMember=16,s.keyword=17,s.snippet=27,s.text=18,s.color=19,s.file=20,s.reference=21,s.customcolor=22,s.folder=23,s["type-parameter"]=24,s.typeParameter=24,s.account=25,s.issue=26,function(D,R){let U=s[D];return typeof U=="undefined"&&!R&&(U=9),U}}();var v;(function(s){s[s.Deprecated=1]="Deprecated"})(v=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(s){s[s.KeepWhitespace=1]="KeepWhitespace",s[s.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var b;(function(s){s[s.Invoke=0]="Invoke",s[s.TriggerCharacter=1]="TriggerCharacter",s[s.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var A;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(A=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var c;(function(s){s[s.Invoke=1]="Invoke",s[s.Auto=2]="Auto"})(c=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(s){return s&&g.URI.isUri(s.uri)&&L.Range.isIRange(s.range)&&(L.Range.isIRange(s.originSelectionRange)||L.Range.isIRange(s.targetSelectionRange))}e.isLocationLink=t;var r;(function(s){s[s.File=0]="File",s[s.Module=1]="Module",s[s.Namespace=2]="Namespace",s[s.Package=3]="Package",s[s.Class=4]="Class",s[s.Method=5]="Method",s[s.Property=6]="Property",s[s.Field=7]="Field",s[s.Constructor=8]="Constructor",s[s.Enum=9]="Enum",s[s.Interface=10]="Interface",s[s.Function=11]="Function",s[s.Variable=12]="Variable",s[s.Constant=13]="Constant",s[s.String=14]="String",s[s.Number=15]="Number",s[s.Boolean=16]="Boolean",s[s.Array=17]="Array",s[s.Object=18]="Object",s[s.Key=19]="Key",s[s.Null=20]="Null",s[s.EnumMember=21]="EnumMember",s[s.Struct=22]="Struct",s[s.Event=23]="Event",s[s.Operator=24]="Operator",s[s.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var o;(function(s){s[s.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var n;(function(s){const D=new Map;D.set("file",0),D.set("module",1),D.set("namespace",2),D.set("package",3),D.set("class",4),D.set("method",5),D.set("property",6),D.set("field",7),D.set("constructor",8),D.set("enum",9),D.set("interface",10),D.set("function",11),D.set("variable",12),D.set("constant",13),D.set("string",14),D.set("number",15),D.set("boolean",16),D.set("array",17),D.set("object",18),D.set("key",19),D.set("null",20),D.set("enum-member",21),D.set("struct",22),D.set("event",23),D.set("operator",24),D.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function U(K){return D.get(K)}s.fromString=U;function V(K){return R.get(K)}s.toString=V;function ee(K,O){const x=R.get(K);let F=x&&T.iconRegistry.get("symbol-"+x);return F||(console.info("No codicon found for SymbolKind "+K),F=T.Codicon.symbolProperty),`${O?"inline":"block"} ${F.classNames}`}s.toCssClassName=ee})(n=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(D){this.value=D}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var f;(function(s){s[s.Collapsed=0]="Collapsed",s[s.Expanded=1]="Expanded"})(f=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(s){s[s.Editing=0]="Editing",s[s.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var w;(function(s){s[s.Other=0]="Other",s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(w=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var E;(function(s){s[s.None=0]="None",s[s.Option=1]="Option",s[s.Default=2]="Default",s[s.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[61],ge([0,1,8,4,11]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=k.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",k.isMacintosh),T.set("isLinux",k.isLinux),T.set("isWindows",k.isWindows),T.set("isWeb",k.isWeb),T.set("isMacNative",k.isMacintosh&&!k.isWeb),T.set("isEdge",y.indexOf("Edg/")>=0),T.set("isFirefox",y.indexOf("Firefox")>=0),T.set("isChrome",y.indexOf("Chrome")>=0),T.set("isSafari",y.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var S;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return I.INSTANCE}static true(){return u.INSTANCE}static has(s){return m.create(s)}static equals(s,D){return l.create(s,D)}static notEquals(s,D){return b.create(s,D)}static regex(s,D){return r.create(s,D)}static in(s,D){return v.create(s,D)}static not(s){return A.create(s)}static and(...s){return n.create(s)}static or(...s){return a.create(s)}static greater(s,D){return c.create(s,D)}static less(s,D){return p.create(s,D)}static deserialize(s,D=!1){if(!!s)return this._deserializeOrExpression(s,D)}static _deserializeOrExpression(s,D){let R=s.split("||");return a.create(R.map(U=>this._deserializeAndExpression(U,D)))}static _deserializeAndExpression(s,D){let R=s.split("&&");return n.create(R.map(U=>this._deserializeOne(U,D)))}static _deserializeOne(s,D){if(s=s.trim(),s.indexOf("!=")>=0){let R=s.split("!=");return b.create(R[0].trim(),this._deserializeValue(R[1],D))}if(s.indexOf("==")>=0){let R=s.split("==");return l.create(R[0].trim(),this._deserializeValue(R[1],D))}if(s.indexOf("=~")>=0){let R=s.split("=~");return r.create(R[0].trim(),this._deserializeRegexValue(R[1],D))}if(s.indexOf(" in ")>=0){let R=s.split(" in ");return v.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(s)){const R=s.split(">=");return h.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(s)){const R=s.split(">");return c.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(s)){const R=s.split("<=");return t.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(s)){const R=s.split("<");return p.create(R[0].trim(),R[1].trim())}return/^\!\s*/.test(s)?A.create(s.substr(1).trim()):m.create(s)}static _deserializeValue(s,D){if(s=s.trim(),s==="true")return!0;if(s==="false")return!1;let R=/^'([^']*)'$/.exec(s);return R?R[1].trim():s}static _deserializeRegexValue(s,D){if((0,g.isFalsyOrWhitespace)(s)){if(D)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let R=s.indexOf("/"),U=s.lastIndexOf("/");if(R===U||R<0){if(D)throw new Error(`bad regexp-value '${s}', missing /-enclosure`);return console.warn(`bad regexp-value '${s}', missing /-enclosure`),null}let V=s.slice(R+1,U),ee=s[U+1]==="i"?"i":"";try{return new RegExp(V,ee)}catch(K){if(D)throw new Error(`bad regexp-value '${s}', parse error: ${K}`);return console.warn(`bad regexp-value '${s}', parse error: ${K}`),null}}}e.ContextKeyExpr=P;function i(E,s){return E.cmp(s)}class I{constructor(){this.type=0}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}evaluate(s){return!1}serialize(){return"false"}keys(){return[]}map(s){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class u{constructor(){this.type=1}cmp(s){return this.type-s.type}equals(s){return s.type===this.type}evaluate(s){return!0}serialize(){return"true"}keys(){return[]}map(s){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=u,u.INSTANCE=new u;class m{constructor(s){this.key=s,this.type=2}static create(s){const D=T.get(s);return typeof D=="boolean"?D?u.INSTANCE:I.INSTANCE:new m(s)}cmp(s){return s.type!==this.type?this.type-s.type:d(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}evaluate(s){return!!s.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(s){return s.mapDefined(this.key)}negate(){return A.create(this.key)}}e.ContextKeyDefinedExpr=m;class l{constructor(s,D){this.key=s,this.value=D,this.type=4}static create(s,D){if(typeof D=="boolean")return D?m.create(s):A.create(s);const R=T.get(s);return typeof R=="boolean"?D===(R?"true":"false")?u.INSTANCE:I.INSTANCE:new l(s,D)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return s.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(s){return s.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=l;class v{constructor(s,D){this.key=s,this.valueKey=D,this.type=10}static create(s,D){return new v(s,D)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.valueKey,s.key,s.valueKey)}equals(s){return s.type===this.type?this.key===s.key&&this.valueKey===s.valueKey:!1}evaluate(s){const D=s.getValue(this.valueKey),R=s.getValue(this.key);return Array.isArray(D)?D.indexOf(R)>=0:typeof R=="string"&&typeof D=="object"&&D!==null?C.call(D,R):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(s){return s.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=v;class _{constructor(s){this._actual=s,this.type=11}static create(s){return new _(s)}cmp(s){return s.type!==this.type?this.type-s.type:this._actual.cmp(s._actual)}equals(s){return s.type===this.type?this._actual.equals(s._actual):!1}evaluate(s){return!this._actual.evaluate(s)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(s){return new _(this._actual.map(s))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class b{constructor(s,D){this.key=s,this.value=D,this.type=5}static create(s,D){if(typeof D=="boolean")return D?A.create(s):m.create(s);const R=T.get(s);return typeof R=="boolean"?D===(R?"true":"false")?I.INSTANCE:u.INSTANCE:new b(s,D)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return s.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(s){return s.mapNotEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class A{constructor(s){this.key=s,this.type=3}static create(s){const D=T.get(s);return typeof D=="boolean"?D?I.INSTANCE:u.INSTANCE:new A(s)}cmp(s){return s.type!==this.type?this.type-s.type:d(this.key,s.key)}equals(s){return s.type===this.type?this.key===s.key:!1}evaluate(s){return!s.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(s){return s.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=A;class c{constructor(s,D){this.key=s,this.value=D,this.type=12}static create(s,D){return new c(s,D)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=c;class h{constructor(s,D){this.key=s,this.value=D,this.type=13}static create(s,D){return new h(s,D)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(s){return s.mapGreaterEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=h;class p{constructor(s,D){this.key=s,this.value=D,this.type=14}static create(s,D){return new p(s,D)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmaller(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerExpr=p;class t{constructor(s,D){this.key=s,this.value=D,this.type=15}static create(s,D){return new t(s,D)}cmp(s){return s.type!==this.type?this.type-s.type:w(this.key,this.value,s.key,s.value)}equals(s){return s.type===this.type?this.key===s.key&&this.value===s.value:!1}evaluate(s){return parseFloat(s.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(s){return s.mapSmallerEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(s,D){this.key=s,this.regexp=D,this.type=7}static create(s,D){return new r(s,D)}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.key<s.key)return-1;if(this.key>s.key)return 1;const D=this.regexp?this.regexp.source:"",R=s.regexp?s.regexp.source:"";return D<R?-1:D>R?1:0}equals(s){if(s.type===this.type){const D=this.regexp?this.regexp.source:"",R=s.regexp?s.regexp.source:"";return this.key===s.key&&D===R}return!1}evaluate(s){let D=s.getValue(this.key);return this.regexp?this.regexp.test(D):!1}serialize(){const s=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${s}`}keys(){return[this.key]}map(s){return s.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=r;class o{constructor(s){this._actual=s,this.type=8}static create(s){return new o(s)}cmp(s){return s.type!==this.type?this.type-s.type:this._actual.cmp(s._actual)}equals(s){return s.type===this.type?this._actual.equals(s._actual):!1}evaluate(s){return!this._actual.evaluate(s)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(s){return new o(this._actual.map(s))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class n{constructor(s){this.expr=s,this.type=6}static create(s){return n._normalizeArr(s)}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let D=0,R=this.expr.length;D<R;D++){const U=i(this.expr[D],s.expr[D]);if(U!==0)return U}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let D=0,R=this.expr.length;D<R;D++)if(!this.expr[D].equals(s.expr[D]))return!1;return!0}return!1}evaluate(s){for(let D=0,R=this.expr.length;D<R;D++)if(!this.expr[D].evaluate(s))return!1;return!0}static _normalizeArr(s){const D=[];let R=!1;for(const U of s)if(!!U){if(U.type===1){R=!0;continue}if(U.type===0)return I.INSTANCE;if(U.type===6){D.push(...U.expr);continue}D.push(U)}if(D.length===0&&R)return u.INSTANCE;if(D.length!==0){if(D.length===1)return D[0];for(D.sort(i);D.length>1;){const U=D[D.length-1];if(U.type!==9)break;D.pop();const V=D.pop(),ee=a.create(U.expr.map(K=>n.create([K,V])));ee&&(D.push(ee),D.sort(i))}return D.length===1?D[0]:new n(D)}}serialize(){return this.expr.map(s=>s.serialize()).join(" && ")}keys(){const s=[];for(let D of this.expr)s.push(...D.keys());return s}map(s){return new n(this.expr.map(D=>D.map(s)))}negate(){let s=[];for(let D of this.expr)s.push(D.negate());return a.create(s)}}e.ContextKeyAndExpr=n;class a{constructor(s){this.expr=s,this.type=9}static create(s){const D=a._normalizeArr(s);if(D.length!==0)return D.length===1?D[0]:new a(D)}cmp(s){if(s.type!==this.type)return this.type-s.type;if(this.expr.length<s.expr.length)return-1;if(this.expr.length>s.expr.length)return 1;for(let D=0,R=this.expr.length;D<R;D++){const U=i(this.expr[D],s.expr[D]);if(U!==0)return U}return 0}equals(s){if(s.type===this.type){if(this.expr.length!==s.expr.length)return!1;for(let D=0,R=this.expr.length;D<R;D++)if(!this.expr[D].equals(s.expr[D]))return!1;return!0}return!1}evaluate(s){for(let D=0,R=this.expr.length;D<R;D++)if(this.expr[D].evaluate(s))return!0;return!1}static _normalizeArr(s){let D=[],R=!1;if(s){for(let U=0,V=s.length;U<V;U++){const ee=s[U];if(!!ee){if(ee.type===0){R=!0;continue}if(ee.type===1)return[u.INSTANCE];if(ee.type===9){D=D.concat(ee.expr);continue}D.push(ee)}}if(D.length===0&&R)return[I.INSTANCE];D.sort(i)}return D}serialize(){return this.expr.map(s=>s.serialize()).join(" || ")}keys(){const s=[];for(let D of this.expr)s.push(...D.keys());return s}map(s){return new a(this.expr.map(D=>D.map(s)))}negate(){let s=[];for(let R of this.expr)s.push(R.negate());const D=R=>R.type===9?R.expr:[R];for(;s.length>1;){const R=s.shift(),U=s.shift(),V=[];for(const ee of D(R))for(const K of D(U))V.push(P.and(ee,K));s.unshift(P.or(...V))}return s[0]}}e.ContextKeyOrExpr=a;class f extends m{constructor(s,D,R){super(s);this._defaultValue=D,typeof R=="object"?f._info.push({...R,key:s}):R!==!0&&f._info.push({key:s,description:R,type:D!=null?typeof D:void 0})}static all(){return f._info.values()}bindTo(s){return s.createKey(this.key,this._defaultValue)}getValue(s){return s.getContextKeyValue(this.key)}toNegated(){return P.not(this.key)}isEqualTo(s){return P.equals(this.key,s)}notEqualsTo(s){return P.notEquals(this.key,s)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(E,s){return E<s?-1:E>s?1:0}function w(E,s,D,R){return E<D?-1:E>D?1:s<R?-1:s>R?1:0}}),define(me[183],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(me[184],ge([0,1,156,4,10]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=y;var T;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var C;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var S;(function(I){I.Install="install",I.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var P;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(P=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(u,m){super(u);this.code=m,this.name=m}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,g.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,g.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,8,4]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=k;function y(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class C{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,u){if(typeof I=="undefined"||I===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof I=="string"||typeof u=="string"){let m=typeof I=="string"?I:I.value,l=typeof u=="string"?u:u.value;return g.equalsIgnoreCase(m,l)}return I._lower===u._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=C;function S(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function P(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[185],ge([0,1,8,26]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(l,v){return l.uuid&&v.uuid?l.uuid===v.uuid:l.id===v.id?!0:(0,g.compareIgnoreCase)(l.id,v.id)===0}e.areSameExtensions=k;class y{constructor(v,_){this.version=_,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof y?k(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=y;function T(l,v){return`${l}.${v}`}e.getExtensionId=T;function C(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function S(l,v){return C(T(l,v))}e.getGalleryExtensionId=S;function P(l,v){const _=[],b=A=>{for(const c of _)if(c.some(h=>k(v(h),v(A))))return c;return null};for(const A of l){const c=b(A);c?c.push(A):_.push([A])}return _}e.groupByExtension=P;function i(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function u(l){const v=new Set;for(const _ of l)_.malicious&&v.add(_.id.id);return v}e.getMaliciousExtensionsSet=u;function m(l,v){const _=[],b=v.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const A=b.shift();if(A&&_.every(c=>!k(c.identifier,{id:A}))){const c=l.filter(h=>k(h.identifier,{id:A}));c.length===1&&(_.push(c[0]),b.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return _}e.getExtensionDependencies=m}),define(me[186],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(me[187],ge([0,1,39,9,113,158,28,11,186,10,140]),function(J,e,g,L,k,y,T,C,S,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=y.localize(0,null);class u{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends u{openTerminal(h,p){return this.spawnTerminal(g,h,k.getWindowsShell(),p)}spawnTerminal(h,p,t,r){const o=p.windowsExec||m.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const n=L.basename(o).toLowerCase();if(n==="cmder"||n==="cmder.exe")return h.spawn(o,r?[r]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return o.indexOf(" ")>=0&&a.push('""'),a.push(o),(n==="wt"||n==="wt.exe")&&a.push("-d ."),new Promise((f,d)=>{const w=_(process),E=h.spawn(t,a,{cwd:r,env:w});E.on("error",d),E.on("exit",()=>f())})}runInTerminal(h,p,t,r,o){const n="windowsExec"in o&&o.windowsExec?o.windowsExec:m.getDefaultTerminalWindows();return new Promise((a,f)=>{const d=`"${p} - ${I}"`,w=`""${t.join('" "')}" & pause"`,E=["/c","start",d,"/wait",n,"/c",w],s=Object.assign({},_(process),r);Object.keys(s).filter(U=>s[U]===null).forEach(U=>delete s[U]);const D={cwd:p,env:s,windowsVerbatimArguments:!0};g.spawn(m.CMD,E,D).on("error",U=>{f(b(U))}),a(void 0)})}static getDefaultTerminalWindows(){if(!m._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return m._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=m,m.CMD="cmd.exe";class l extends u{openTerminal(h,p){return this.spawnTerminal(g,h,p)}runInTerminal(h,p,t,r,o){const n=o.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((a,f)=>{if(n===S.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const d=n===S.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[P.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${d}.scpt`,J).fsPath,"-t",h||I,"-w",p];for(let R of t)E.push("-a"),E.push(R);if(r){const R=Object.assign({},_(process),r);for(let U in R){const V=R[U];V===null?(E.push("-u"),E.push(U)):(E.push("-e"),E.push(`${U}=${V}`))}}let s="";const D=g.spawn(l.OSASCRIPT,E);D.on("error",R=>{f(b(R))}),D.stderr.on("data",R=>{s+=R.toString()}),D.on("exit",R=>{if(R===0)a(void 0);else if(s){const U=s.split(`
`,1);f(new Error(U[0]))}else f(new Error(y.localize(1,null,d,R)))})}else f(new Error(y.localize(2,null,n)))})}spawnTerminal(h,p,t){const r=p.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((o,n)=>{const a=["-a",r];t&&a.push(t);const f=_(process),d=h.spawn("/usr/bin/open",a,{cwd:t,env:f});d.on("error",n),d.on("exit",()=>o())})}}e.MacExternalTerminalService=l,l.OSASCRIPT="/usr/bin/osascript";class v extends u{openTerminal(h,p){return this.spawnTerminal(g,h,p)}runInTerminal(h,p,t,r,o){const n=o.linuxExec?Promise.resolve(o.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((a,f)=>{let d=[];n.then(w=>{w.indexOf("gnome-terminal")>=0?d.push("-x"):d.push("-e"),d.push("bash"),d.push("-c");const E=`${A(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;d.push(`''${E}''`);const s=Object.assign({},_(process),r);Object.keys(s).filter(V=>s[V]===null).forEach(V=>delete s[V]);const D={cwd:p,env:s};let R="";const U=g.spawn(w,d,D);U.on("error",V=>{f(b(V))}),U.stderr.on("data",V=>{R+=V.toString()}),U.on("exit",V=>{if(V===0)a(void 0);else if(R){const ee=R.split(`
`,1);f(new Error(ee[0]))}else f(new Error(y.localize(4,null,w,V)))})})})}static async getDefaultTerminalLinuxReady(){return v._DEFAULT_TERMINAL_LINUX_READY||(v._DEFAULT_TERMINAL_LINUX_READY=new Promise(async h=>{C.isLinux?await T.Promises.exists("/etc/debian_version")?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm"):h("xterm")})),v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(h,p,t){const r=p.linuxExec?Promise.resolve(p.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((o,n)=>{r.then(a=>{const f=_(process),d=h.spawn(a,[],{cwd:t,env:f});d.on("error",n),d.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=y.localize(3,null);function _(c){const h={...c.env};return(0,i.sanitizeProcessEnvironment)(h),h}function b(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(y.localize(5,null,c.path)):c}function A(c){let h="";for(let p of c)p.indexOf(" ")>=0?h+='"'+p+'"':h+=p,h+=" ";return h}}),define(me[42],ge([0,1,159,9,2,4,8,14,22]),function(J,e,g,L,k,y,T,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function P(O){return O.create===!0}e.isFileOpenForWriteOptions=P;var i;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(O){O[O.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var u;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(u=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=m;function l(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=l;function v(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function _(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=_;var b;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class A extends Error{constructor(x,F){super(x);this.code=F}}e.FileSystemProviderError=A;function c(O,x){const F=new A(O.toString(),x);return p(F,x),F}e.createFileSystemProviderError=c;function h(O){return O||c((0,g.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=h;function p(O,x){return O.name=x?`${x} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=p;function t(O){if(!O)return b.Unknown;if(O instanceof A)return O.code;const x=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!x)return b.Unknown;switch(x[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(O){if(O instanceof w)return O.fileOperationResult;switch(t(O)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var o;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(o=e.FileOperation||(e.FileOperation={}));class n{constructor(x,F,z){this.resource=x,this.operation=F,this.target=z}isOperation(x){return this.operation===x}}e.FileOperationEvent=n;var a;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class f{constructor(x,F){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const z of x)switch(z.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>F)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>F)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>F)),this.deleted.set(z.resource,z);break}}contains(x,...F){return this.doContains(x,{includeChildren:!1},...F)}affects(x,...F){return this.doContains(x,{includeChildren:!0},...F)}doContains(x,F,...z){if(!x)return!1;const M=z.length>0;return!!((!M||z.includes(1))&&(this.added?.get(x)||F.includeChildren&&this.added?.findSuperstr(x))||(!M||z.includes(0))&&(this.updated?.get(x)||F.includeChildren&&this.updated?.findSuperstr(x))||(!M||z.includes(2))&&(this.deleted?.findSubstr(x)||F.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function d(O,x,F){return!O||!x||O===x||x.length>O.length?!1:(x.charAt(x.length-1)!==L.sep&&(x+=L.sep),F?(0,T.startsWithIgnoreCase)(O,x):O.indexOf(x)===0)}e.isParent=d;class w extends Error{constructor(x,F,z){super(x);this.fileOperationResult=F,this.options=z}}e.FileOperationError=w;class E extends w{constructor(x,F,z){super(x,2,z);this.stat=F}}e.NotModifiedSinceFileOperationError=E;var s;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(s=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var D;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(D=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=R;async function U(O,x){if(!x.canHandleResource(k.URI.from({scheme:O.scheme})))return new Promise(F=>{const z=x.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===O.scheme&&M.added&&(z.dispose(),F())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class V{static formatSize(x){return(0,C.isNumber)(x)||(x=0),x<V.KB?(0,g.localize)(1,null,x.toFixed(0)):x<V.MB?(0,g.localize)(2,null,(x/V.KB).toFixed(2)):x<V.GB?(0,g.localize)(3,null,(x/V.MB).toFixed(2)):x<V.TB?(0,g.localize)(4,null,(x/V.GB).toFixed(2)):(0,g.localize)(5,null,(x/V.TB).toFixed(2))}}e.ByteSize=V,V.KB=1024,V.MB=V.KB*V.KB,V.GB=V.MB*V.KB,V.TB=V.GB*V.KB;var ee;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(ee=e.Arch||(e.Arch={}));function K(O){return{maxFileSize:O===0?300*V.MB:16*V.GB,maxHeapSize:O===0?700*V.MB:2*700*V.MB}}e.getPlatformLimits=K}),define(me[82],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...k){this._entries=new Map;for(let[y,T]of k)this.set(y,T)}set(k,y){const T=this._entries.get(k);return this._entries.set(k,y),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=g}),define(me[188],ge([0,1,16,180,115,4,82,17]),function(J,e,g,L,k,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class P extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class i{constructor(l=new T.ServiceCollection,v=!1,_){this._activeInstantiations=new Set,this._services=l,this._strict=v,this._parent=_,this._services.set(y.IInstantiationService,this)}createChild(l){return new i(l,this._strict,this)}invokeFunction(l,...v){let _=u.traceInvocation(l),b=!1;try{return l({get:(c,h)=>{if(b)throw(0,g.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(c,_);if(!p&&h!==y.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return p}},...v)}finally{b=!0,_.stop()}}createInstance(l,...v){let _,b;return l instanceof k.SyncDescriptor?(_=u.traceCreation(l.ctor),b=this._createInstance(l.ctor,l.staticArguments.concat(v),_)):(_=u.traceCreation(l),b=this._createInstance(l,v,_)),_.stop(),b}_createInstance(l,v=[],_){let b=y._util.getServiceDependencies(l).sort((h,p)=>h.index-p.index),A=[];for(const h of b){let p=this._getOrCreateServiceInstance(h.id,_);if(!p&&this._strict&&!h.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${h.id}.`);A.push(p)}let c=b.length>0?b[0].index:v.length;if(v.length!==c){console.warn(`[createInstance] First service dependency of ${l.name} at position ${c+1} conflicts with ${v.length} static arguments`);let h=c-v.length;h>0?v=v.concat(new Array(h)):v=v.slice(0,c)}return new l(...[...v,...A])}_setServiceInstance(l,v){if(this._services.get(l)instanceof k.SyncDescriptor)this._services.set(l,v);else if(this._parent)this._parent._setServiceInstance(l,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let v=this._services.get(l);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):v}_getOrCreateServiceInstance(l,v){let _=this._getServiceInstanceOrDescriptor(l);return _ instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,_,v.branch(l,!0)):(v.branch(l,!1),_)}_safeCreateAndCacheServiceInstance(l,v,_){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,v,_)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,v,_){const b=new L.Graph(h=>h.id.toString());let A=0;const c=[{id:l,desc:v,_trace:_}];for(;c.length;){const h=c.pop();if(b.lookupOrInsertNode(h),A++>1e3)throw new P(b);for(let p of y._util.getServiceDependencies(h.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(p.id);if(!t&&!p.optional&&console.warn(`[createInstance] ${l} depends on ${p.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const r={id:p.id,desc:t,_trace:h._trace.branch(p.id,!0)};b.insertEdge(h,r),c.push(r)}}}for(;;){const h=b.roots();if(h.length===0){if(!b.isEmpty())throw new P(b);break}for(const{data:p}of h){if(this._getServiceInstanceOrDescriptor(p.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,r)}b.removeNode(p)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,v,_=[],b,A){if(this._services.get(l)instanceof k.SyncDescriptor)return this._createServiceInstance(v,_,b,A);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,v,_,b,A);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(l,v=[],_,b){if(_){const A=new C.IdleValue(()=>this._createInstance(l,v,b));return new Proxy(Object.create(null),{get(c,h){if(h in c)return c[h];let p=A.value,t=p[h];return typeof t!="function"||(t=t.bind(p),c[h]=t),t},set(c,h,p){return A.value[h]=p,!0}})}else return this._createInstance(l,v,b)}}e.InstantiationService=i;var I;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(I||(I={}));class u{constructor(l,v){this.type=l,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return S?new u(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):u._None}static traceCreation(l){return S?new u(0,l.name):u._None}branch(l,v){let _=new u(2,l.toString());return this._dep.push([l,v,_]),_}stop(){let l=Date.now()-this._start;u._totals+=l;let v=!1;function _(A,c){let h=[],p=new Array(A+1).join("	");for(const[t,r,o]of c._dep)if(r&&o){v=!0,h.push(`${p}CREATES -> ${t}`);let n=_(A+1,o);n&&h.push(n)}else h.push(`${p}uses -> ${t}`);return h.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${u._totals.toFixed(2)}ms)`];(l>2||v)&&console.log(b.join(`
`))}}u._None=new class extends u{constructor(){super(-1,null)}stop(){}branch(){return this}},u._totals=0}),define(me[12],ge([0,1,4,6,11,3,60]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function C(){return new Date().toISOString()}var S;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class P extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class i extends P{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(S.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(S.Error,this.format(o))}else this.log(S.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let o=0;o<t.length;o++){let n=t[o];if(typeof n=="object")try{n=JSON.stringify(n)}catch(a){}r+=(o>0?" ":"")+n}return r}}e.AbstractMessageLogger=i;class I extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...r){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}debug(t,...r){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}info(t,...r){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}warn(t,...r){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...r):console.warn(`[main ${C()}]`,t,...r))}error(t,...r){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}critical(t,...r){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class u extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=u;class m extends P{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,T.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class l extends P{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const o of this.logServices)o.trace(t,...r)}debug(t,...r){for(const o of this.logServices)o.debug(t,...r)}info(t,...r){for(const o of this.logServices)o.info(t,...r)}warn(t,...r){for(const o of this.logServices)o.warn(t,...r)}error(t,...r){for(const o of this.logServices)o.error(t,...r)}critical(t,...r){for(const o of this.logServices)o.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=l;class v extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=v;class _ extends L.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,r?.always?S.Trace:this.logLevel,r),this.loggers.set(t.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class b{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function A(p){if(p.verbose)return S.Trace;if(typeof p.logLevel=="string"){const t=c(p.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=A;function c(p){switch(p){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=c;function h(p){switch(p){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=h}),define(me[116],ge([0,1,12,42]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(S,P,i,I){try{const u=await new Promise((m,l)=>{J(["spdlog"],m,l)});return u.setFlushOn(g.LogLevel.Trace),u.createAsyncRotatingLogger(S,P,i,I)}catch(u){console.error(u)}return null}function y(S,P,i,I){const u=J.__$__nodeRequire("spdlog");return u.setFlushOn(g.LogLevel.Trace),u.createRotatingLogger(S,P,i,I)}e.createRotatingLogger=y;function T(S,P,i){switch(P){case g.LogLevel.Trace:S.trace(i);break;case g.LogLevel.Debug:S.debug(i);break;case g.LogLevel.Info:S.info(i);break;case g.LogLevel.Warning:S.warn(i);break;case g.LogLevel.Error:S.error(i);break;case g.LogLevel.Critical:S.critical(i);break;default:throw new Error("Invalid log level")}}class C extends g.AbstractMessageLogger{constructor(P,i,I,u){super();this.name=P,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(u),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const P=this.rotating?6:1,i=30/P*L.ByteSize.MB;return k(this.name,this.filepath,i,P).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:u,message:m}of this.buffer)T(this._logger,u,m);this.buffer=[]}})}log(P,i){this._logger?T(this._logger,P,i):this.getLevel()<=P&&this.buffer.push({level:P,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(me[117],ge([0,1,4,160,48]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var T;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function P(l,v){return v-l}S.compare=P;const i=Object.create(null);i[S.Error]=(0,L.localize)(0,null),i[S.Warning]=(0,L.localize)(1,null),i[S.Info]=(0,L.localize)(2,null);function I(l){return i[l]||""}S.toString=I;function u(l){switch(l){case k.default.Error:return S.Error;case k.default.Warning:return S.Warning;case k.default.Info:return S.Info;case k.default.Ignore:return S.Hint}}S.fromSeverity=u;function m(l){switch(l){case S.Error:return k.default.Error;case S.Warning:return k.default.Warning;case S.Info:return k.default.Info;case S.Hint:return k.default.Ignore}}S.toSeverity=m}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(S){const P="";function i(u){return I(u,!0)}S.makeKey=i;function I(u,m){let l=[P];return u.source?l.push(u.source.replace("\xA6","\\\xA6")):l.push(P),u.code?typeof u.code=="string"?l.push(u.code.replace("\xA6","\\\xA6")):l.push(u.code.value.replace("\xA6","\\\xA6")):l.push(P),u.severity!==void 0&&u.severity!==null?l.push(T.toString(u.severity)):l.push(P),u.message&&m?l.push(u.message.replace("\xA6","\\\xA6")):l.push(P),u.startLineNumber!==void 0&&u.startLineNumber!==null?l.push(u.startLineNumber.toString()):l.push(P),u.startColumn!==void 0&&u.startColumn!==null?l.push(u.startColumn.toString()):l.push(P),u.endLineNumber!==void 0&&u.endLineNumber!==null?l.push(u.endLineNumber.toString()):l.push(P),u.endColumn!==void 0&&u.endColumn!==null?l.push(u.endColumn.toString()):l.push(P),l.push(P),l.join("\xA6")}S.makeKeyOptionalMessage=I})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,g.createDecorator)("markerService")}),define(me[189],ge([0,1,48,4,3]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=g.default,e.INotificationService=(0,L.createDecorator)("notificationService");var y;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new S,this.onDidClose=k.Event.None,this.onDidChangeVisibility=k.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=C;class S{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=S}),define(me[190],ge([0,1,6,8,2,4]),function(J,e,g,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function T(C,S){return k.URI.isUri(C)?(0,L.equalsIgnoreCase)(C.scheme,S):(0,L.startsWithIgnoreCase)(C,S+":")}e.matchesScheme=T}),define(me[191],ge([0,1,10,11,38,23]),function(J,e,g,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const C=L.globals.vscode.context.configuration();if(C)T=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const C=(0,y.dirname)(g.FileAccess.asFileUri("",J));T=J.__$__nodeRequire((0,y.joinPath)(C,"product.json").fsPath);const S=J.__$__nodeRequire((0,y.joinPath)(C,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:S.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.60.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T});var $e=this&&this.__param||function(J,e){return function(g,L){e(g,L,J)}};define(me[118],ge([0,1,4,21,6,17]),function(J,e,g,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,g.createDecorator)("progressService");var T;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let S=class extends k.Disposable{constructor(I,u){super();this.deferred=new y.DeferredPromise,u.withProgress(I,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};S=Ve([$e(1,e.IProgressService)],S),e.UnmanagedProgress=S;class P extends k.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(I){this.stop();const u=++this.currentOperationId,m=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{u===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:u,token:m.token,stop:()=>this.doStop(u),isCurrent:()=>this.currentOperationId===u}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,g.createDecorator)("editorProgressService")}),define(me[34],ge([0,1,14,54]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,C){L.ok(g.isString(T)),L.ok(g.isObject(C)),L.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,C)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(me[119],ge([0,1,34,3]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class y{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,P){this.schemasById[k(S)]=P,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new y;g.Registry.add(e.Extensions.JSONContribution,T)}),define(me[83],ge([0,1,155,3,34,14,119]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const P=k.Registry.as(T.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(A,c=!0){this.registerConfigurations([A],c)}registerConfigurations(A,c=!0){const h=[];A.forEach(p=>{h.push(...this.validateAndRegisterProperties(p,c,p.extensionInfo)),this.configurationContributors.push(p),this.registerJSONConfiguration(p)}),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterConfigurations(A){const c=[],h=p=>{if(p.properties)for(const t in p.properties)c.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,p.properties[t]);p.allOf&&p.allOf.forEach(t=>h(t))};for(const p of A){h(p);const t=this.configurationContributors.indexOf(p);t!==-1&&this.configurationContributors.splice(t,1)}P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}registerDefaultConfigurations(A){const c=[],h=[];for(const p of A)for(const t in p)if(c.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...p[t]};const r={type:"object",default:this.defaultValues[t],description:g.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};h.push(u(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=p[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(A){const c=[];for(const h of A)for(const p in h)if(c.push(p),delete this.defaultValues[p],e.OVERRIDE_PROPERTY_PATTERN.test(p))delete this.configurationProperties[p],delete this.defaultLanguageConfigurationOverridesNode.properties[p];else{const t=this.configurationProperties[p];t&&(this.updatePropertyDefaultValue(p,t),this.updateSchema(p,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...A){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(A){for(const c of A)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(A,c=!0,h,p=3){p=y.isUndefinedOrNull(A.scope)?p:A.scope;let t=[],r=A.properties;if(r)for(let n in r){if(c&&v(n)){delete r[n];continue}const a=r[n];if(this.updatePropertyDefaultValue(n,a),e.OVERRIDE_PROPERTY_PATTERN.test(n)?a.scope=void 0:(a.scope=y.isUndefinedOrNull(a.scope)?p:a.scope,a.restricted=y.isUndefinedOrNull(a.restricted)?!!h?.restrictedConfigurations?.includes(n):a.restricted),r[n].hasOwnProperty("included")&&!r[n].included){this.excludedConfigurationProperties[n]=r[n],delete r[n];continue}else this.configurationProperties[n]=r[n];!r[n].deprecationMessage&&r[n].markdownDeprecationMessage&&(r[n].deprecationMessage=r[n].markdownDeprecationMessage),t.push(n)}let o=A.allOf;if(o)for(let n of o)t.push(...this.validateAndRegisterProperties(n,c,h,p));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(A){const c=h=>{let p=h.properties;if(p)for(const r in p)this.updateSchema(r,p[r]);let t=h.allOf;t&&t.forEach(c)};c(A)}updateSchema(A,c){switch(e.allSettings.properties[A]=c,c.scope){case 1:e.applicationSettings.properties[A]=c;break;case 2:e.machineSettings.properties[A]=c;break;case 6:e.machineOverridableSettings.properties[A]=c;break;case 3:e.windowSettings.properties[A]=c;break;case 4:e.resourceSettings.properties[A]=c;break;case 5:e.resourceSettings.properties[A]=c,this.resourceLanguageSettingsSchema.properties[A]=c;break}}removeFromSchema(A,c){switch(delete e.allSettings.properties[A],c.scope){case 1:delete e.applicationSettings.properties[A];break;case 2:delete e.machineSettings.properties[A];break;case 6:delete e.machineOverridableSettings.properties[A];break;case 3:delete e.windowSettings.properties[A];break;case 4:case 5:delete e.resourceSettings.properties[A];break}}updateOverridePropertyPatternKey(){for(const A of this.overrideIdentifiers.values()){const c=`[${A}]`,h={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,h),e.allSettings.properties[c]=h,e.applicationSettings.properties[c]=h,e.machineSettings.properties[c]=h,e.machineOverridableSettings.properties[c]=h,e.windowSettings.properties[c]=h,e.resourceSettings.properties[c]=h}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(A,c){let h=this.defaultValues[A];y.isUndefined(h)&&(h=c.default),y.isUndefined(h)&&(h=m(c.type)),c.default=h}}const I="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function u(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=u;function m(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const l=new i;k.Registry.add(e.Extensions.Configuration,l);function v(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?g.localize(5,null,b):l.getConfigurationProperties()[b]!==void 0?g.localize(6,null,b):null:g.localize(4,null)}e.validateProperty=v;function _(){const b=[],A=l.getConfigurationProperties();for(const c of Object.keys(A))b.push([c,A[c].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=_}),define(me[120],ge([0,1,25,14,2,34,4,83]),function(J,e,g,L,k,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function S(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof k.URI)}e.isConfigurationOverrides=S;var P;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(r,o){const n=o?r?o.keys.filter(D=>r.keys.indexOf(D)===-1):[...o.keys]:[],a=r?o?r.keys.filter(D=>o.keys.indexOf(D)===-1):[...r.keys]:[],f=[];if(o&&r){for(const D of r.keys)if(o.keys.indexOf(D)!==-1){const R=b(r.contents,D),U=b(o.contents,D);g.equals(R,U)||f.push(D)}}const d=[],w=D=>{const R={};for(const U of D)for(const V of U.identifiers)R[p(V)]=U;return R},E=o?w(o.overrides):{},s=r?w(r.overrides):{};if(Object.keys(E).length)for(const D of n){const R=E[D];R&&d.push([(0,C.overrideIdentifierFromKey)(D),R.keys])}if(Object.keys(s).length)for(const D of a){const R=s[D];R&&d.push([(0,C.overrideIdentifierFromKey)(D),R.keys])}if(Object.keys(E).length&&Object.keys(s).length)for(const D of f){const R=s[D],U=E[D];if(R&&U){const V=I({contents:R.contents,keys:R.keys,overrides:[]},{contents:U.contents,keys:U.keys,overrides:[]});d.push([(0,C.overrideIdentifierFromKey)(D),[...V.added,...V.removed,...V.updated]])}}return{added:n,removed:a,updated:f,overrides:d}}e.compare=I;function u(r,o){const n=[];for(const a of Object.keys(r))if(C.OVERRIDE_PROPERTY_PATTERN.test(a)){const f={};for(const d in r[a])f[d]=r[a][d];n.push({identifiers:[(0,C.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(f),contents:m(f,o)})}return n}e.toOverrides=u;function m(r,o){const n=Object.create(null);for(let a in r)l(n,a,r[a],o);return n}e.toValuesTree=m;function l(r,o,n,a){const f=o.split("."),d=f.pop();let w=r;for(let E=0;E<f.length;E++){let s=f[E],D=w[s];switch(typeof D){case"undefined":D=w[s]=Object.create(null);break;case"object":break;default:a(`Ignoring ${o} as ${f.slice(0,E+1).join(".")} is ${JSON.stringify(D)}`);return}w=D}if(typeof w=="object"&&w!==null)try{w[d]=n}catch(E){a(`Ignoring ${o} as ${f.join(".")} is ${JSON.stringify(w)}`)}else a(`Ignoring ${o} as ${f.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=l;function v(r,o){const n=o.split(".");_(r,n)}e.removeFromValueTree=v;function _(r,o){const n=o.shift();if(o.length===0){delete r[n];return}if(Object.keys(r).indexOf(n)!==-1){const a=r[n];typeof a=="object"&&!Array.isArray(a)&&(_(a,o),Object.keys(a).length===0&&delete r[n])}}function b(r,o,n){function a(w,E){let s=w;for(const D of E){if(typeof s!="object"||s===null)return;s=s[D]}return s}const f=o.split("."),d=a(r,f);return typeof d=="undefined"?n:d}e.getConfigurationValue=b;function A(r,o,n){Object.keys(o).forEach(a=>{a!=="__proto__"&&(a in r?L.isObject(r[a])&&L.isObject(o[a])?A(r[a],o[a],n):n&&(r[a]=o[a]):r[a]=o[a])})}e.merge=A;function c(){const r=y.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=c;function h(){const r=Object.create(null),o=y.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let n in o){let a=o[n].default;l(r,n,a,f=>console.error(`Conflict in default settings: ${f}`))}return r}e.getDefaultValues=h;function p(r){return`[${r}]`}e.keyFromOverrideIdentifier=p;function t(r,o,n){const a=r.inspect(o),f=r.inspect(n);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:a.defaultValue}e.getMigratedSettingValue=t}),define(me[192],ge([0,1,57,22,20,14,25,2,83,120,34,6,3]),function(J,e,g,L,k,y,T,C,S,P,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},r=[],o=[]){this._contents=t,this._keys=r,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,P.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const o=this.getContentsForOverrideIdentifer(r);return o?t?(0,P.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let o={};for(const n of k.distinct([...Object.keys(this.contents),...Object.keys(r)])){let a=this.contents[n],f=r[n];f&&(typeof a=="object"&&typeof f=="object"?(a=T.deepClone(a),this.mergeContents(a,f)):a=f),o[n]=a}return new m(o,this.keys,this.overrides)}merge(...t){const r=T.deepClone(this.contents),o=T.deepClone(this.overrides),n=[...this.keys];for(const a of t){this.mergeContents(r,a.contents);for(const f of a.overrides){const[d]=o.filter(w=>k.equals(w.identifiers,f.identifiers));d?this.mergeContents(d.contents,f.contents):o.push(T.deepClone(f))}for(const f of a.keys)n.indexOf(f)===-1&&n.push(f)}return new m(r,n,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const o of Object.keys(r)){if(o in t&&y.isObject(t[o])&&y.isObject(r[o])){this.mergeContents(t[o],r[o]);continue}t[o]=T.deepClone(r[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?T.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,P.addToValueTree)(this.contents,t,r,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,P.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let o=0;o<r;o++)t.indexOf(this.keys[o])===0&&(r=o);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=m;class l extends m{constructor(){const t=(0,P.getDefaultValues)(),r=(0,P.getConfigurationKeys)(),o=[];for(const n of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(n)&&o.push({identifiers:[(0,S.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(t[n]),contents:(0,P.toValuesTree)(t[n],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,r,o)}}e.DefaultConfigurationModel=l;class v{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!y.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:o,keys:n,overrides:a,restricted:f}=this.doParseRaw(t,r);this._configurationModel=new m(o,n,a),this._restrictedConfigurations=f||[]}doParseContent(t){let r={},o=null,n=[],a=[],f=[];function d(E){Array.isArray(n)?n.push(E):o!==null&&(n[o]=E)}let w={onObjectBegin:()=>{let E={};d(E),a.push(n),n=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{let E=[];d(E),a.push(n),n=E,o=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:d,onError:(E,s,D)=>{f.push({error:E,offset:s,length:D})}};if(t)try{g.visit(t,w),r=n[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return r}doParseRaw(t,r){const o=i.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,o,!0,r);t=n.raw;const a=(0,P.toValuesTree)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),f=Object.keys(t),d=(0,P.toOverrides)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:a,keys:f,overrides:d,restricted:n.restricted}}filter(t,r,o,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[]};const a={},f=[];for(let d in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(d)&&o){const w=this.filter(t[d],r,!1,n);a[d]=w.raw,f.push(...w.restricted)}else{const w=r[d],E=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&f.push(d),(E===void 0||n.scopes===void 0||n.scopes.includes(E))&&(n.skipRestricted&&w?.restricted||(a[d]=t[d]))}return{raw:a,restricted:f}}}e.ConfigurationModelParser=v;class _ extends I.Disposable{constructor(t,r,o,n){super();this.userSettingsResource=t,this.scopes=r,this.fileService=n,this._onDidChange=this._register(new u.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(u.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class b{constructor(t,r,o=new m,n=new m,a=new L.ResourceMap,f=new m,d=new L.ResourceMap,w=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=n,this._folderConfigurations=a,this._memoryConfiguration=f,this._memoryConfigurationByResource=d,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,r,o){return this.getConsolidateConfigurationModel(r,o).getValue(t)}updateValue(t,r,o={}){let n;o.resource?(n=this._memoryConfigurationByResource.get(o.resource),n||(n=new m,this._memoryConfigurationByResource.set(o.resource,n))):n=this._memoryConfiguration,r===void 0?n.removeValue(t):n.setValue(t,r),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,o){const n=this.getConsolidateConfigurationModel(r,o),a=this.getFolderConfigurationModelForResource(r.resource,o),f=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,d=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),w=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),s=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),D=o?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,R=a?r.overrideIdentifier?a.freeze().override(r.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,U=r.overrideIdentifier?f.override(r.overrideIdentifier).getValue(t):f.getValue(t),V=n.getValue(t),ee=k.distinct(k.flatten(n.overrides.map(K=>K.identifiers))).filter(K=>n.getOverrideValue(t,K)!==void 0);return{defaultValue:d,userValue:w,userLocalValue:E,userRemoteValue:s,workspaceValue:D,workspaceFolderValue:R,memoryValue:U,value:V,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:s!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:D!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:R!==void 0?{value:a?.freeze().getValue(t),override:r.overrideIdentifier?a?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:f.getValue(t),override:r.overrideIdentifier?f.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ee.length?ee:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const o=r.filter(n=>S.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const a=(0,S.overrideIdentifierFromKey)(n),f=this._defaultConfiguration.getKeysForOverrideIdentifier(a),d=t.getKeysForOverrideIdentifier(a),w=[...d.filter(E=>f.indexOf(E)===-1),...f.filter(E=>d.indexOf(E)===-1),...f.filter(E=>!T.equals(this._defaultConfiguration.override(a).getValue(E),t.override(a).getValue(E)))];return[a,w]});return this.updateDefaultConfiguration(t),{keys:r,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:o,removed:n,overrides:a}=(0,P.compare)(this.localUserConfiguration,t),f=[...r,...o,...n];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:o,removed:n,overrides:a}=(0,P.compare)(this.remoteUserConfiguration,t);let f=[...r,...o,...n];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:o,removed:n,overrides:a}=(0,P.compare)(this.workspaceConfiguration,t);let f=[...r,...o,...n];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:a}}compareAndUpdateFolderConfiguration(t,r){const o=this.folderConfigurations.get(t),{added:n,updated:a,removed:f,overrides:d}=(0,P.compare)(o,r);let w=[...n,...a,...f];return(w.length||!o)&&this.updateFolderConfiguration(t,r),{keys:w,overrides:d}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:n,removed:a,overrides:f}=(0,P.compare)(r,void 0);return{keys:[...o,...n,...a],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let o=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},r){let o=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const n=r.getFolder(t);n&&(o=this.getFolderConsolidatedConfiguration(n.uri)||o);const a=this._memoryConfigurationByResource.get(t);a&&(o=o.merge(a))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const o=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(r=o.merge(n),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=o}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const o=r.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:o,overrides:n,keys:a}=this._folderConfigurations.get(r);return t.push([r,{contents:o,overrides:n,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((f,d)=>(f.set(C.URI.revive(d[0]),this.parseConfigurationModel(d[1])),f),new L.ResourceMap);return new b(r,o,new m,n,a,new m,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function A(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const t=new Set,r=new Map;for(const n of p)n.keys.forEach(a=>t.add(a)),n.overrides.forEach(([a,f])=>{const d=(0,L.getOrSet)(r,a,new Set);f.forEach(w=>d.add(w))});const o=[];return r.forEach((n,a)=>o.push([a,[...n.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=A;class c{constructor(t,r,o,n){this.change=t,this.previous=r,this.currentConfiguraiton=o,this.currentWorkspace=n,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(d=>a.add(d)),t.overrides.forEach(([,d])=>d.forEach(w=>a.add(w))),this.affectedKeys=[...a.values()];const f=new m;this.affectedKeys.forEach(d=>f.setValue(d,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!T.equals(o,n)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let o=(0,P.toValuesTree)({[r]:!0},()=>{}),n;for(;typeof o=="object"&&(n=Object.keys(o)[0]);){if(t=t[n],!t)return!1;o=o[n]}return!0}}e.ConfigurationChangeEvent=c;class h extends c{constructor(t,r,o,n){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=o,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=h}),define(me[121],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var L;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(T,C=L.Unknown,S){super(T);this._message=T,this._code=C,this._detail=S,this.isHandled=C===L.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(T){return T instanceof k&&T._code===L.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof k&&T._code===L.NoResolverFound}static isHandled(T){return T instanceof k&&T.isHandled}}e.RemoteAuthorityResolverError=k}),define(me[84],ge([0,1,10]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(P){return P.scheme===g.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=L;function k(P){if(!P)return;const i=P.indexOf("+");return i<0?P:P.substr(0,i)}e.getRemoteName=k;function y(P){return P.scheme!==g.Schemas.file&&P.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=y;function T(P){if(P.folders.length)return P.folders.every(i=>y(i.uri))?P.folders[0].uri:void 0;if(P.configuration&&y(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=T;function C(P){return T(P)?.scheme}e.getVirtualWorkspaceScheme=C;function S(P){return T(P)!==void 0}e.isVirtualWorkspace=S}),define(me[193],ge([0,1,3,11,4,12]),function(J,e,g,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var T;(function(m){m.Http="http",m.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=i;function I(m,l){return l?l!==1&&m<1024:!L.isWindows&&m<1024}e.isPortPrivileged=I;let u=class{constructor(l){this.logService=l,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(l,v){return this._tunnelProvider=l,l?(this._canElevate=v.elevation,this._canMakePublic=v.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async l=>{const v=[],_=Array.from(this._tunnels.values());for(let b of _){const A=Array.from(b.values());for(let c of A){const h=await c.value;h&&v.push(h)}}l(v)})}async dispose(){for(const l of this._tunnels.values()){for(const{value:v}of l.values())await v.then(_=>_?.dispose());l.clear()}this._tunnels.clear()}openTunnel(l,v,_,b,A=!1,c=!1,h){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${_} on local port ${b}.`),!l)return;v||(v="localhost");const p=this.retainOrCreateTunnel(l,v,_,b,A,c,h);return p?p.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,_);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(t);return(t.tunnelRemoteHost!==v||t.tunnelRemotePort!==_)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}makeTunnel(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,public:l.public,protocol:l.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const v=this._tunnels.get(l.tunnelRemoteHost);if(v){const _=v.get(l.tunnelRemotePort);_&&(_.refcount--,await this.tryDisposeTunnel(l.tunnelRemoteHost,l.tunnelRemotePort,_))}}}}async tryDisposeTunnel(l,v,_){if(_.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${v}.`);const b=_.value.then(async A=>{A&&(await A.dispose(!0),this._onTunnelClosed.fire({host:A.tunnelRemoteHost,port:A.tunnelRemotePort}))});return this._tunnels.has(l)&&this._tunnels.get(l).delete(v),b}}async closeTunnel(l,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${v} `);const _=this._tunnels.get(l);if(_&&_.has(v)){const b=_.get(v);b.refcount=0,await this.tryDisposeTunnel(l,v,b)}}addTunnelToMap(l,v,_){this._tunnels.has(l)||this._tunnels.set(l,new Map),this._tunnels.get(l).set(v,{refcount:1,value:_})}async removeEmptyTunnelFromMap(l,v){const _=this._tunnels.get(l);_&&(await _.get(v)||_.delete(v),_.size===0&&this._tunnels.delete(l))}getTunnelFromMap(l,v){let _=[l];P(l)?(_.push(...e.LOCALHOST_ADDRESSES),_.push(...e.ALL_INTERFACES_ADDRESSES)):i(l)&&_.push(...e.ALL_INTERFACES_ADDRESSES);const b=_.map(A=>this._tunnels.get(A));for(const A of b){const c=A?.get(v);if(c)return c}}canTunnel(l){return!!S(l)}createWithProvider(l,v,_,b,A,c,h){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${_} on local port ${b}.`);const t={elevationRequired:A?I(b===void 0?_:b):!1},r={remoteAddress:{host:v,port:_},localAddressPort:b,public:c,protocol:h},o=l.forwardPort(r,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),o&&this.addTunnelToMap(v,_,o),o}};u=Ve([$e(0,y.ILogService)],u),e.AbstractTunnelService=u}),define(me[194],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{vsda(){return new Promise((k,y)=>J(["vsda"],k,y))}async sign(k){try{const y=await this.vsda(),T=new y.signer;if(T)return T.sign(k)}catch(y){}return k}}e.SignService=g}),define(me[195],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,y,T=5){let C;return C=y(S=>{const P=typeof S=="string"?S:S.data;let i=this._terminalBufferMap.get(k);if(i){i.data.push(P);return}const I=setTimeout(()=>this.flushBuffer(k),T);i={data:[P],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(k),C.dispose()}},this._terminalBufferMap.set(k,i)}),C}stopBuffering(k){const y=this._terminalBufferMap.get(k);y&&y.dispose()}flushBuffer(k){const y=this._terminalBufferMap.get(k);y&&(this._terminalBufferMap.delete(k),this._callback(k,y.data.join("")))}}e.TerminalDataBufferer=g}),define(me[196],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(me[85],ge([0,1,4,6,34,3,196,47]),function(J,e,g,L,k,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,g.createDecorator)("themeService");var S;(function(_){function b(A){return A&&typeof A=="object"&&typeof A.id=="string"}_.isThemeColor=b})(S=e.ThemeColor||(e.ThemeColor={}));function P(_){return{id:_}}e.themeColorFromId=P;var i;(function(_){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||S.isThemeColor(r.color))}_.isThemeIcon=b;const A=new RegExp(`^\\$\\((${C.CSSIcon.iconNameExpression}(?:${C.CSSIcon.iconModifierExpression})?)\\)$`);function c(r){const o=A.exec(r);if(!o)return;let[,n]=o;return{id:n}}_.fromString=c;function h(r,o){let n=r.id;const a=n.lastIndexOf("~");return a!==-1&&(n=n.substring(0,a)),o&&(n=`${n}~${o}`),{id:n}}_.modify=h;function p(r,o){return r.id===o.id&&r.color?.id===o.color?.id}_.isEqual=p;function t(r,o){return{id:r.id,color:o?P(o):void 0}}_.asThemeIcon=t,_.asClassNameArray=C.CSSIcon.asClassNameArray,_.asClassName=C.CSSIcon.asClassName,_.asCSSSelector=C.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=C.Codicon.file,e.FolderThemeIcon=C.Codicon.folder;function I(_){switch(_){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class u{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new y.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,L.toDisposable)(()=>{const A=this.themingParticipants.indexOf(b);this.themingParticipants.splice(A,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new u;k.Registry.add(e.Extensions.ThemingContribution,m);function l(_){return m.onColorThemeChange(_)}e.registerThemingParticipant=l;class v extends L.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(A=>this.onThemeChange(A)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,A){let c=this.theme.getColor(b);return c&&A&&(c=A(c,this.theme)),c?c.toString():null}}e.Themable=v}),define(me[197],ge([0,1,34,85,3,161,119,17,47]),function(J,e,g,L,k,y,T,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${S.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(b,A,c,h){const p=this.iconsById[b];if(p){if(c&&!p.description){p.description=c,this.iconSchema.properties[b].markdownDescription=`${c} $(${b})`;const o=this.iconReferenceSchema.enum.indexOf(b);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=c),this._onDidChange.fire()}return p}let t={id:b,description:c,defaults:A,deprecationMessage:h};this.iconsById[b]=t;let r={$ref:"#/definitions/icons"};return h&&(r.deprecationMessage=h),c&&(r.markdownDescription=`${c}: $(${b})`),this.iconSchema.properties[b]=r,this.iconReferenceSchema.enum.push(b),this.iconReferenceSchema.enumDescriptions.push(c||""),this._onDidChange.fire(),{id:b}}deregisterIcon(b){delete this.iconsById[b],delete this.iconSchema.properties[b];const A=this.iconReferenceSchema.enum.indexOf(b);A!==-1&&(this.iconReferenceSchema.enum.splice(A,1),this.iconReferenceSchema.enumDescriptions.splice(A,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(b=>this.iconsById[b])}getIcon(b){return this.iconsById[b]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(b,A){const c=this.iconFontsById[b];if(c)return c;let h={id:b,definition:A};return this.iconFontsById[b]=h,this._onDidChange.fire(),h}deregisterIconFont(b){delete this.iconFontsById[b]}getIconFonts(){return Object.keys(this.iconFontsById).map(b=>this.iconFontsById[b])}getIconFont(b){return this.iconFontsById[b]}toString(){const b=(p,t)=>p.id.localeCompare(t.id),A=p=>{for(;L.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`};let c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of h.filter(t=>!!t.description).sort(b))c.push(`|<i class="${A(p)}"></i>|${p.id}|${L.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const p of h.filter(t=>!L.ThemeIcon.isThemeIcon(t.defaults)).sort(b))c.push(`|<i class="${A(p)}"></i>|${p.id}|`);return c.join(`
`)}}const i=new P;g.Registry.add(e.Extensions.IconContribution,i);function I(_,b,A,c){return i.registerIcon(_,b,A,c)}e.registerIcon=I;function u(){return i}e.getIconRegistry=u;function m(){for(const _ of S.iconRegistry.all)i.registerIcon(_.id,_.definition,_.description);S.iconRegistry.onDidRegister(_=>i.registerIcon(_.id,_.definition,_.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let l=g.Registry.as(T.Extensions.JSONContribution);l.registerSchema(e.iconsSchemaId,i.getIconSchema());const v=new C.RunOnceScheduler(()=>l.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.widgetClose=I("widget-close",S.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",S.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",S.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=L.ThemeIcon.modify(S.Codicon.sync,"spin")}),define(me[43],ge([0,1,2,23,4,22]),function(J,e,g,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var T;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function C(u){const m=u;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=C;function S(u){const m=u;return!!(m&&typeof m=="object"&&g.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=S;class P{constructor(m,l,v,_){this._id=m,this._configuration=v,this._ignorePathCasing=_,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class i{constructor(m,l){this.raw=l,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,L.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(u){return new i({uri:u,index:0,name:(0,L.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=I}),define(me[198],ge([0,1,4,162,43,2,11,9,23,138,57,10,77,29,84]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(O){return(typeof O=="string"?(0,C.extname)(O):(0,S.extname)(O))===v}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,g.createDecorator)("workspacesService");function b(O){return O.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function A(O){return O.hasOwnProperty("folderUri")}e.isRecentFolder=A;function c(O){return O.hasOwnProperty("fileUri")}e.isRecentFile=c;function h(O){const x=O;return typeof x?.id=="string"&&y.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=h;function p(O){if(O.configuration)return{id:O.id,configPath:O.configuration};if(O.folders.length===1)return{id:O.id,uri:O.folders[0].uri}}e.toWorkspaceIdentifier=p;function t(O){const x=O;return typeof x?.id=="string"&&y.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function r(O){const x=O;if(x?.uri)return{id:x.id,uri:y.URI.revive(x.uri)};const F=O;if(F?.configPath)return{id:F.id,configPath:y.URI.revive(F.configPath)};if(O?.id)return{id:O.id}}e.reviveIdentifier=r;function o(O,x){return S.extUriBiasedIgnorePathCase.isEqualOrParent(O,x.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function n(O){return a(O)||f(O)}e.isStoredWorkspaceFolder=n;function a(O){const x=O;return typeof x?.path=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=a;function f(O){const x=O;return typeof x?.uri=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=f;function d(O,x,F,z,M=!T.isWindows,N){if(O.scheme!==z.scheme)return{name:F,uri:O.toString(!0)};let q=x?void 0:N.relativePath(z,O);if(q!==void 0)q.length===0?q=".":T.isWindows&&O.scheme===I.Schemas.file&&!M&&(q=q.replace(/\//g,"\\"));else if(O.scheme===I.Schemas.file)q=O.fsPath,T.isWindows&&(q=(0,u.normalizeDriveLetter)(q),M&&(q=(0,m.toSlashes)(q)));else{if(!N.isEqualAuthority(O.authority,z.authority))return{name:F,uri:O.toString(!0)};q=O.path}return{name:F,path:q}}e.getStoredWorkspaceFolder=d;function w(O,x,F){let z=[],M=new Set;const N=F.dirname(x);for(let q of O){let B;if(a(q))q.path&&(B=F.resolvePath(N,q.path));else if(f(q))try{B=y.URI.parse(q.uri),B.path[0]!=="/"&&(B=B.with({path:"/"+B.path}))}catch(G){console.warn(G)}if(B){let G=F.getComparisonKey(B);if(!M.has(G)){M.add(G);const re=q.name||F.basenameOrAuthority(B);z.push(new k.WorkspaceFolder({uri:B,name:re,index:z.length},q))}}}return z}e.toWorkspaceFolders=w;function E(O,x,F,z,M){let N=s(x,O);const q=M.dirname(x),B=M.dirname(z),G=[],re=D(N.folders);for(const Le of N.folders){const qe=a(Le)?M.resolvePath(q,Le.path):y.URI.parse(Le.uri);let We;F?We=!1:We=!a(Le)||(0,C.isAbsolute)(Le.path),G.push(d(qe,We,Le.name,B,re,M))}const he={insertSpaces:!1,tabSize:4,eol:T.isLinux||T.isMacintosh?`
`:`\r
`},ye=P.setProperty(O,["folders"],G,he);let Ie=P.applyEdits(O,ye);return N.remoteAuthority===(0,l.getRemoteAuthority)(z)&&(Ie=P.applyEdits(Ie,P.removeProperty(Ie,["remoteAuthority"],he))),Ie}e.rewriteWorkspaceFileForNewLocation=E;function s(O,x){let F=i.parse(x);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(z=>n(z));else throw new Error(`${O} looks like an invalid workspace file.`);return F}function D(O){return T.isWindows?O.some(x=>a(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=D;function R(O){return O.workspace&&typeof O.workspace=="object"&&typeof O.workspace.id=="string"&&typeof O.workspace.configPath=="string"}function U(O){return typeof O.folderUri=="string"}function V(O){return typeof O.fileUri=="string"}function ee(O,x){const F={workspaces:[],files:[]};if(O){const z=function(N,q){for(let B=0;B<N.length;B++)try{q(N[B],B)}catch(G){x.warn(`Error restoring recent entry ${JSON.stringify(N[B])}: ${G.toString()}. Skip entry.`)}},M=O;if(Array.isArray(M.entries))z(M.entries,N=>{const q=N.label,B=N.remoteAuthority;R(N)?F.workspaces.push({label:q,remoteAuthority:B,workspace:{id:N.workspace.id,configPath:y.URI.parse(N.workspace.configPath)}}):U(N)?F.workspaces.push({label:q,remoteAuthority:B,folderUri:y.URI.parse(N.folderUri)}):V(N)&&F.files.push({label:q,remoteAuthority:B,fileUri:y.URI.parse(N.fileUri)})});else{const N=O;Array.isArray(N.workspaces3)&&z(N.workspaces3,(q,B)=>{const G=Array.isArray(N.workspaceLabels)&&N.workspaceLabels[B]||void 0;typeof q=="object"&&typeof q.id=="string"&&typeof q.configURIPath=="string"?F.workspaces.push({label:G,workspace:{id:q.id,configPath:y.URI.parse(q.configURIPath)}}):typeof q=="string"&&F.workspaces.push({label:G,folderUri:y.URI.parse(q)})}),Array.isArray(N.files2)&&z(N.files2,(q,B)=>{const G=Array.isArray(N.fileLabels)&&N.fileLabels[B]||void 0;typeof q=="string"&&F.files.push({label:G,fileUri:y.URI.parse(q)})})}}return F}e.restoreRecentlyOpened=ee;function K(O){const x={entries:[]};for(const F of O.workspaces)A(F)?x.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):x.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of O.files)x.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return x}e.toStoreData=K}),define(me[86],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const y=this._idPool++;return this._data.set(y,k),this.logDebugInfo(),y}get(k,y){return this._data.has(k)?this._data.get(k)[y]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(me[51],ge([0,1,2,3,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");class y{constructor(){this._onDidChangeTabs=new L.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(C){this._tabs=C.map(S=>({name:S.name,group:S.group,resource:g.URI.revive(S.resource),isActive:S.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=y}),define(me[62],ge([0,1,10,4]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(T,C){C===null?this._providerInfo.delete(T):this._providerInfo.set(T,C)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=(0,L.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(me[199],ge([0,1,17]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(T,C,S){this._deferredPromises=new Map,this._id=T,this._shared=C,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of P.values())i.complete()}catch(i){for(const I of P.values())I.error(i)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,C){let S=this._value[T];return typeof S=="undefined"&&(S=C),S}update(T,C){this._value[T]=C;let S=this._deferredPromises.get(T);if(S!==void 0)return S.p;const P=new g.DeferredPromise;return this._deferredPromises.set(T,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class k extends L{constructor(T,C){super(T.identifier.value,!0,C);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=k}),define(me[200],ge([0,1,3,2,12]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(C,S){this._logService=C,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(C,S,P){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C)).acceptModelChanged(S,P)}$acceptDirtyStateChanged(C,S){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C)).acceptDirty(S)}$acceptModelSaved(C){const S=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(C,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",C.path,S);const P=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(C));P.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};y=Ve([$e(0,k.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(me[13],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class L{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=L});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(me[201],ge([0,1,26,3]),function(J,e,g,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(C,S){k.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(C.identifier),it(this,k,S,"f"),He(this,k,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(C){return He(this,k,"f").get(this._id,C)}store(C,S){return He(this,k,"f").store(this._id,C,S)}delete(C){return He(this,k,"f").delete(this._id,C)}}e.ExtensionSecrets=y,k=new WeakMap}),define(me[122],ge([0,1,4,3]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(me[87],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(A){A[A.Upsert=0]="Upsert",A[A.RemoveChild=1]="RemoveChild",A[A.Invalidated=2]="Invalidated",A[A.SetProp=3]="SetProp",A[A.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,k=(A,c)=>{const h={controllerId:c};return L.set(A,h),h};e.createPrivateApiFor=k;const y=A=>L.get(A);e.getPrivateApiFor=y;const T=(A,c,h,p)=>{let t=h;return{enumerable:!0,configurable:!1,get(){return t},set(r){p(t,r)||(t=r,A.listener?.({op:3,key:c,value:r}))}}},C=(A,c)=>A===c,S={range:(A,c)=>A===c?!0:!A||!c?!1:A.isEqual(c),label:C,description:C,busy:C,error:C,canResolveChildren:C},P=Object.keys(S),i=(A,c)=>({range:T(A,"range",void 0,S.range),label:T(A,"label",c,S.label),description:T(A,"description",void 0,S.description),canResolveChildren:T(A,"canResolveChildren",!1,S.canResolveChildren),busy:T(A,"busy",!1,S.busy),error:T(A,"error",void 0,S.error)}),I=(A,c)=>{const h=new Map;for(const p of P)S[p](A[p],c[p])||h.set(p,c[p]);return h};e.diffTestItems=I;class u extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.DuplicateTestItemError=u;class m extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class l extends Error{constructor(c,h,p){super(`TestItem with ID "${c}" is from controller "${h}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=l;const v=A=>{const c=(0,e.getPrivateApiFor)(A);let h=new Map;return{get size(){return h.size},forEach(p,t){for(const r of h.values())p.call(t,r,this)},replace(p){const t=new Map,r=new Set(h.keys()),o={op:4,ops:[]};for(const n of p){if(!(n instanceof _))throw new m(n.id);const a=(0,e.getPrivateApiFor)(n).controllerId;if(a!==c.controllerId)throw new l(n.id,a,c.controllerId);if(t.has(n.id))throw new u(n.id);t.set(n.id,n),r.delete(n.id),o.ops.push({op:0,item:n})}for(const n of r.keys())o.ops.push({op:1,id:n});c.listener?.(o),h=t},add(p){if(!(p instanceof _))throw new m(p.id);h.set(p.id,p),c.listener?.({op:0,item:p})},delete(p){h.delete(p)&&c.listener?.({op:1,id:p})},get(p){return h.get(p)},toJSON(){return Array.from(h.values())},[Symbol.iterator](){return h.values()}}};class _{constructor(c,h,p,t){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const r=(0,e.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof b?void 0:r.parent}},children:{value:v(this),enumerable:!0,writable:!1},...i(r,p)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=_;class b extends _{constructor(c,h){super(c,c,h,void 0)}}e.TestItemRootImpl=b}),define(me[52],ge([0,1,4,3,13]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(C){function S(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,protocol:i.protocol}}C.fromApiTunnel=S;function P(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public,protocol:i.protocol}}C.fromServiceTunnel=P})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let T=class{constructor(S){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,P){return{dispose:()=>{}}}async $providePortAttributes(S,P,i,I,u){return[]}async $forwardPort(S,P){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ve([$e(0,k.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(me[7],ge([0,1,20,16,99,22,102,14,2,32,42,121]),function(J,e,g,L,k,y,T,C,S,P,i,I){"use strict";var u,m,l,v,_,b,A,c,h,p,t,r,o,n,a,f,d,w,E,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function D(H){function $(){return Reflect.construct(H,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(H,"name")),Object.setPrototypeOf($,H),Object.setPrototypeOf($.prototype,H.prototype),$}let R=_=class{constructor($){u.set(this,void 0),it(this,u,$,"f")}static from(...$){let oe=$;return new _(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}dispose(){typeof He(this,u,"f")=="function"&&(He(this,u,"f").call(this),it(this,u,void 0,"f"))}};u=new WeakMap,R=_=Ve([D],R),e.Disposable=R;let U=b=class{constructor($,oe){if($<0)throw(0,L.illegalArgument)("line must be non-negative");if(oe<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=$,this._character=oe}static Min(...$){if($.length===0)throw new TypeError;let oe=$[0];for(let ke=1;ke<$.length;ke++){const Ye=$[ke];Ye.isBefore(oe)&&(oe=Ye)}return oe}static Max(...$){if($.length===0)throw new TypeError;let oe=$[0];for(let ke=1;ke<$.length;ke++){const Ye=$[ke];Ye.isAfter(oe)&&(oe=Ye)}return oe}static isPosition($){if(!$)return!1;if($ instanceof b)return!0;let{line:oe,character:ke}=$;return typeof oe=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,oe=0){if($===null||oe===null)throw(0,L.illegalArgument)();let ke;return typeof $=="undefined"?ke=0:typeof $=="number"?ke=$:(ke=typeof $.lineDelta=="number"?$.lineDelta:0,oe=typeof $.characterDelta=="number"?$.characterDelta:0),ke===0&&oe===0?this:new b(this.line+ke,this.character+oe)}with($,oe=this.character){if($===null||oe===null)throw(0,L.illegalArgument)();let ke;return typeof $=="undefined"?ke=this.line:typeof $=="number"?ke=$:(ke=typeof $.line=="number"?$.line:this.line,oe=typeof $.character=="number"?$.character:this.character),ke===this.line&&oe===this.character?this:new b(ke,oe)}toJSON(){return{line:this.line,character:this.character}}};U=b=Ve([D],U),e.Position=U;let V=A=class{constructor($,oe,ke,Ye){let nt,rt;if(typeof $=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ye=="number"?(nt=new U($,oe),rt=new U(ke,Ye)):$ instanceof U&&oe instanceof U&&(nt=$,rt=oe),!nt||!rt)throw new Error("Invalid arguments");nt.isBefore(rt)?(this._start=nt,this._end=rt):(this._start=rt,this._end=nt)}static isRange($){return $ instanceof A?!0:$?U.isPosition($.start)&&U.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof A?this.contains($._start)&&this.contains($._end):$ instanceof U?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const oe=U.Max($.start,this._start),ke=U.Min($.end,this._end);if(!oe.isAfter(ke))return new A(oe,ke)}union($){if(this.contains($))return this;if($.contains(this))return $;const oe=U.Min($.start,this._start),ke=U.Max($.end,this.end);return new A(oe,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,oe=this.end){if($===null||oe===null)throw(0,L.illegalArgument)();let ke;return $?U.isPosition($)?ke=$:(ke=$.start||this.start,oe=$.end||this.end):ke=this.start,ke.isEqual(this._start)&&oe.isEqual(this.end)?this:new A(ke,oe)}toJSON(){return[this.start,this.end]}};V=A=Ve([D],V),e.Range=V;let ee=c=class extends V{constructor($,oe,ke,Ye){let nt,rt;if(typeof $=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ye=="number"?(nt=new U($,oe),rt=new U(ke,Ye)):$ instanceof U&&oe instanceof U&&(nt=$,rt=oe),!nt||!rt)throw new Error("Invalid arguments");super(nt,rt);this._anchor=nt,this._active=rt}static isSelection($){return $ instanceof c?!0:$?V.isRange($)&&U.isPosition($.anchor)&&U.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ee=c=Ve([D],ee),e.Selection=ee;class K{constructor($,oe,ke){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,L.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,L.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(oe),this.connectionToken=ke}}e.ResolvedAuthority=K;class O extends Error{constructor($,oe=I.RemoteAuthorityResolverErrorCode.Unknown,ke){super($);this._message=$,this._code=oe,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,O.prototype)}static NotAvailable($,oe){return new O($,I.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable($){return new O($,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=O;var x;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var F;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(F=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let z=h=class{constructor($,oe){this._range=$,this._newText=oe}static isTextEdit($){return $ instanceof h?!0:$?V.isRange($)&&typeof $.newText=="string":!1}static replace($,oe){return new h($,oe)}static insert($,oe){return h.replace(new V($,$),oe)}static delete($){return h.replace($,"")}static setEndOfLine($){const oe=new h(new V(new U(0,0),new U(0,0)),"");return oe.newEol=$,oe}get range(){return this._range}set range($){if($&&!V.isRange($))throw(0,L.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,L.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,L.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};z=h=Ve([D],z),e.TextEdit=z;var M;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace"})(M=e.FileEditType||(e.FileEditType={}));let N=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,oe,ke,Ye){this._edits.push({_type:1,from:$,to:oe,options:ke,metadata:Ye})}createFile($,oe,ke){this._edits.push({_type:1,from:void 0,to:$,options:oe,metadata:ke})}deleteFile($,oe,ke){this._edits.push({_type:1,from:$,to:void 0,options:oe,metadata:ke})}replaceNotebookMetadata($,oe,ke){this._edits.push({_type:3,metadata:ke,uri:$,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells($,oe,ke,Ye,nt){let rt,lt,yt=[],At;if(Bt.isNotebookRange(oe)&&Lt.isNotebookCellDataArray(ke)&&!Lt.isNotebookCellDataArray(Ye)?(rt=oe.start,lt=oe.end,yt=ke,At=Ye):typeof oe=="number"&&typeof ke=="number"&&Lt.isNotebookCellDataArray(Ye)&&(rt=oe,lt=ke,yt=Ye,At=nt),rt===void 0||lt===void 0)throw new Error("Invalid arguments");(rt!==lt||yt.length>0)&&this._edits.push({_type:5,uri:$,index:rt,count:lt-rt,cells:yt,metadata:At})}replaceNotebookCellMetadata($,oe,ke,Ye){this._edits.push({_type:3,metadata:Ye,uri:$,edit:{editType:8,index:oe,metadata:ke}})}replace($,oe,ke,Ye){this._edits.push({_type:2,uri:$,edit:new z(oe,ke),metadata:Ye})}insert($,oe,ke,Ye){this.replace($,new V(oe,oe),ke,Ye)}delete($,oe,ke){this.replace($,oe,"",ke)}has($){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===$.toString())}set($,oe){if(oe)for(const ke of oe)ke&&this._edits.push({_type:2,uri:$,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Ye=this._edits[ke];Ye._type===2&&Ye.uri.toString()===$.toString()&&(this._edits[ke]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get($){const oe=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===$.toString()&&oe.push(ke.edit);return oe}entries(){const $=new y.ResourceMap;for(let oe of this._edits)if(oe._type===2){let ke=$.get(oe.uri);ke||(ke=[oe.uri,[]],$.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};N=Ve([D],N),e.WorkspaceEdit=N;let q=p=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof p?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=p._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,oe=this._tabstop++){if(typeof $=="function"){const ke=new p;ke._tabstop=this._tabstop,$(ke),this._tabstop=ke._tabstop,$=ke.value}else $=p._escape($);return this.value+="${",this.value+=oe,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,oe=this._tabstop++){const ke=$.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable($,oe){if(typeof oe=="function"){const ke=new p;ke._tabstop=this._tabstop,oe(ke),this._tabstop=ke._tabstop,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};q=p=Ve([D],q),e.SnippetString=q;var B;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(B=e.DiagnosticTag||(e.DiagnosticTag={}));var G;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(G=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let re=t=class{constructor($,oe){if(this.uri=$,oe)if(oe instanceof V)this.range=oe;else if(oe instanceof U)this.range=new V(oe,oe);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof t?!0:$?V.isRange($.range)&&S.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};re=t=Ve([D],re),e.Location=re;let he=class{constructor($,oe){this.location=$,this.message=oe}static is($){return $?typeof $.message=="string"&&$.location&&V.isRange($.location.range)&&S.URI.isUri($.location.uri):!1}static isEqual($,oe){return $===oe?!0:!$||!oe?!1:$.message===oe.message&&$.location.range.isEqual(oe.location.range)&&$.location.uri.toString()===oe.location.uri.toString()}};he=Ve([D],he),e.DiagnosticRelatedInformation=he;let ye=class{constructor($,oe,ke=G.Error){if(!V.isRange($))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=$,this.message=oe,this.severity=ke}toJSON(){return{severity:G[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,oe){return $===oe?!0:!$||!oe?!1:$.message===oe.message&&$.severity===oe.severity&&$.code===oe.code&&$.severity===oe.severity&&$.source===oe.source&&$.range.isEqual(oe.range)&&(0,g.equals)($.tags,oe.tags)&&(0,g.equals)($.relatedInformation,oe.relatedInformation,he.isEqual)}};ye=Ve([D],ye),e.Diagnostic=ye;let Ie=class{constructor($,oe){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=oe}};Ie=Ve([D],Ie),e.Hover=Ie;var Le;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(Le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let qe=class{constructor($,oe=Le.Text){this.range=$,this.kind=oe}toJSON(){return{range:this.range,kind:Le[this.kind]}}};qe=Ve([D],qe),e.DocumentHighlight=qe;var We;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(We=e.SymbolKind||(e.SymbolKind={}));var je;(function(H){H[H.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let W=r=class{constructor($,oe,ke,Ye,nt){this.name=$,this.kind=oe,this.containerName=nt,typeof ke=="string"&&(this.containerName=ke),Ye instanceof re?this.location=Ye:ke instanceof V&&(this.location=new re(Ye,ke)),r.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:We[this.kind],location:this.location,containerName:this.containerName}}};W=r=Ve([D],W),e.SymbolInformation=W;let Z=o=class{constructor($,oe,ke,Ye,nt){this.name=$,this.detail=oe,this.kind=ke,this.range=Ye,this.selectionRange=nt,this.children=[],o.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(o.validate)}};Z=o=Ve([D],Z),e.DocumentSymbol=Z;var ne;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(ne=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor($,oe){this.title=$,this.kind=oe}};le=Ve([D],le),e.CodeAction=le;let Y=n=class{constructor($){this.value=$}append($){return new n(this.value?this.value+n.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+n.sep)}};Y.sep=".",Y=n=Ve([D],Y),e.CodeActionKind=Y,Y.Empty=new Y(""),Y.QuickFix=Y.Empty.append("quickfix"),Y.Refactor=Y.Empty.append("refactor"),Y.RefactorExtract=Y.Refactor.append("extract"),Y.RefactorInline=Y.Refactor.append("inline"),Y.RefactorRewrite=Y.Refactor.append("rewrite"),Y.Source=Y.Empty.append("source"),Y.SourceOrganizeImports=Y.Source.append("organizeImports"),Y.SourceFixAll=Y.Source.append("fixAll");let ae=class{constructor($,oe){if(this.range=$,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=Ve([D],ae),e.SelectionRange=ae;class ve{constructor($,oe,ke,Ye,nt,rt){this.kind=$,this.name=oe,this.detail=ke,this.uri=Ye,this.range=nt,this.selectionRange=rt}}e.CallHierarchyItem=ve;class Me{constructor($,oe){this.fromRanges=oe,this.from=$}}e.CallHierarchyIncomingCall=Me;class ze{constructor($,oe){this.fromRanges=oe,this.to=$}}e.CallHierarchyOutgoingCall=ze;var Ee;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Ee=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor($,oe){this.range=$,this.command=oe}get isResolved(){return!!this.command}};Je=Ve([D],Je),e.CodeLens=Je;let X=a=class{constructor($,oe=!1){m.set(this,void 0),it(this,m,new k.MarkdownString($,{supportThemeIcons:oe}),"f")}static isMarkdownString($){return $ instanceof a?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return He(this,m,"f").value}set value($){He(this,m,"f").value=$}get isTrusted(){return He(this,m,"f").isTrusted}set isTrusted($){He(this,m,"f").isTrusted=$}get supportThemeIcons(){return He(this,m,"f").supportThemeIcons}set supportThemeIcons($){He(this,m,"f").supportThemeIcons=$}appendText($){return He(this,m,"f").appendText($),this}appendMarkdown($){return He(this,m,"f").appendMarkdown($),this}appendCodeblock($,oe){return He(this,m,"f").appendCodeblock(oe??"",$),this}};m=new WeakMap,X=a=Ve([D],X),e.MarkdownString=X;let se=class{constructor($,oe){this.label=$,this.documentation=oe}};se=Ve([D],se),e.ParameterInformation=se;let fe=class{constructor($,oe){this.label=$,this.documentation=oe,this.parameters=[]}};fe=Ve([D],fe),e.SignatureInformation=fe;let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};xe=Ve([D],xe),e.SignatureHelp=xe;var Be;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(Be=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(H){H[H.Other=0]="Other",H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let Ce=class{constructor($,oe,ke){this.text=$,this.position=oe,this.kind=ke}};Ce=Ve([D],Ce),e.InlayHint=Ce;var De;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Te;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(Te=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(H){H[H.Deprecated=1]="Deprecated"})(ce=e.CompletionItemTag||(e.CompletionItemTag={}));let ue=class{constructor($,oe){this.label=$,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Te[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ue=Ve([D],ue),e.CompletionItem=ue;let pe=class{constructor($=[],oe=!1){this.items=$,this.isIncomplete=oe}};pe=Ve([D],pe),e.CompletionList=pe;let be=class{constructor($,oe,ke){this.text=$,this.range=oe,this.command=ke}};be=Ve([D],be),e.InlineSuggestion=be;let j=class{constructor($){this.items=$}};j=Ve([D],j),e.InlineSuggestions=j;var we;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(we=e.ViewColumn||(e.ViewColumn={}));var _e;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(_e=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ue;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Ue=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ge;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ge=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ze;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Qe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Xe;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Xe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(H){function $(oe){switch(oe){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=$}(Ze=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ct=class{constructor($,oe){if(oe&&!S.URI.isUri(oe))throw(0,L.illegalArgument)("target");if(!V.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.target=oe}};ct=Ve([D],ct),e.DocumentLink=ct;let mt=class{constructor($,oe,ke,Ye){this.red=$,this.green=oe,this.blue=ke,this.alpha=Ye}};mt=Ve([D],mt),e.Color=mt;let bt=class{constructor($,oe){if(oe&&!(oe instanceof mt))throw(0,L.illegalArgument)("color");if(!V.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.color=oe}};bt=Ve([D],bt),e.ColorInformation=bt;let ot=class{constructor($){if(!$||typeof $!="string")throw(0,L.illegalArgument)("label");this.label=$}};ot=Ve([D],ot),e.ColorPresentation=ot;var at;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(at=e.ColorFormat||(e.ColorFormat={}));var Se;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Se=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Pe{constructor($,oe,ke){if(this.startIndex=$,this.length=oe,this.tooltip=ke,typeof $!="number"||$<0)throw(0,L.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,L.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=Pe;class te{constructor($){this.options=$,typeof $!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=te;var Q;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Q=e.TaskRevealKind||(e.TaskRevealKind={}));var Oe;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(Oe=e.TaskPanelKind||(e.TaskPanelKind={}));let Fe=f=class{constructor($,oe){if(typeof $!="string"||typeof oe!="string")throw(0,L.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}get id(){return this._id}};Fe.Clean=new f("clean","Clean"),Fe.Build=new f("build","Build"),Fe.Rebuild=new f("rebuild","Rebuild"),Fe.Test=new f("test","Test"),Fe=f=Ve([D],Fe),e.TaskGroup=Fe;function tt(H){let $="";for(let oe=0;oe<H.length;oe++)$+=H[oe].replace(/,/g,",,")+",";return $}let Ke=class{constructor($,oe,ke){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=$,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=ke):this._options=oe)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)$.push(oe);return tt($)}};Ke=Ve([D],Ke),e.ProcessExecution=Ke;let ut=class{constructor($,oe,ke){if(this._args=[],Array.isArray(oe)){if(!$)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$,this._args=oe,this._options=ke}else{if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$,this._options=oe}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)$.push(typeof oe=="string"?oe:oe.value);return tt($)}};ut=Ve([D],ut),e.ShellExecution=ut;var St;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(St=e.ShellQuoting||(e.ShellQuoting={}));var kt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(kt=e.TaskScope||(e.TaskScope={}));class Dt{constructor($){this._callback=$}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=Dt;let ft=d=class{constructor($,oe,ke,Ye,nt,rt){this.__deprecated=!1,this._definition=this.definition=$;let lt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=ke,this.execution=Ye,lt=nt,this.__deprecated=!0):oe===kt.Global||oe===kt.Workspace?(this.target=oe,this._name=this.name=ke,this._source=this.source=Ye,this.execution=nt,lt=rt):(this.target=oe,this._name=this.name=ke,this._source=this.source=Ye,this.execution=nt,lt=rt),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ke?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof ut?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof Dt?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const oe=this._definition.type;(d.EmptyType===oe||d.ProcessType===oe||d.ShellType===oe||d.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=d=Ve([D],ft),e.Task=ft;var dt;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor($,oe=Et.None){this.collapsibleState=oe,S.URI.isUri($)?this.resourceUri=$:this.label=$}};vt=Ve([D],vt),e.TreeItem=vt;var Et;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Tt=class{constructor($,oe){this.id=$,this.color=oe}};Tt=Ve([D],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let It=class{constructor($){this.id=$}};It=Ve([D],It),e.ThemeColor=It;var bn;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(bn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor($,oe){if(typeof $!="string"&&(!$||!S.URI.isUri($)&&!S.URI.isUri($.uri)))throw(0,L.illegalArgument)("base");if(typeof oe!="string")throw(0,L.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=S.URI.file($),this.base=$):S.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=oe}};Vt=Ve([D],Vt),e.RelativePattern=Vt;let _t=class{constructor($,oe,ke,Ye){this.enabled=typeof $=="boolean"?$:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};_t=Ve([D],_t),e.Breakpoint=_t;let Xt=class extends _t{constructor($,oe,ke,Ye,nt){super(oe,ke,Ye,nt);if($===null)throw(0,L.illegalArgument)("location");this.location=$}};Xt=Ve([D],Xt),e.SourceBreakpoint=Xt;let Yt=class extends _t{constructor($,oe,ke,Ye,nt){super(oe,ke,Ye,nt);this.functionName=$}};Yt=Ve([D],Yt),e.FunctionBreakpoint=Yt;let gt=class extends _t{constructor($,oe,ke,Ye,nt,rt,lt){super(Ye,nt,rt,lt);if(!oe)throw(0,L.illegalArgument)("dataId");this.label=$,this.dataId=oe,this.canPersist=ke}};gt=Ve([D],gt),e.DataBreakpoint=gt;let jt=class{constructor($,oe,ke){this.command=$,this.args=oe||[],this.options=ke}};jt=Ve([D],jt),e.DebugAdapterExecutable=jt;let Wt=class{constructor($,oe){this.port=$,this.host=oe}};Wt=Ve([D],Wt),e.DebugAdapterServer=Wt;let Jt=class{constructor($){this.path=$}};Jt=Ve([D],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor($){this.implementation=$}};Zt=Ve([D],Zt),e.DebugAdapterInlineImplementation=Zt;let Pt=class{constructor($,oe){this.range=$,this.expression=oe}};Pt=Ve([D],Pt),e.EvaluatableExpression=Pt;var dn;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(dn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor($,oe){this.range=$,this.text=oe}};en=Ve([D],en),e.InlineValueText=en;let xt=class{constructor($,oe,ke=!0){this.range=$,this.variableName=oe,this.caseSensitiveLookup=ke}};xt=Ve([D],xt),e.InlineValueVariableLookup=xt;let ht=class{constructor($,oe){this.range=$,this.expression=oe}};ht=Ve([D],ht),e.InlineValueEvaluatableExpression=ht;let tn=class{constructor($,oe){this.frameId=$,this.stoppedLocation=oe}};tn=Ve([D],tn),e.InlineValueContext=tn;var Mt;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Mt=e.FileChangeType||(e.FileChangeType={}));let Ot=w=class extends Error{constructor($,oe=i.FileSystemProviderErrorCode.Unknown,ke){super(S.URI.isUri($)?$.toString(!0):$);this.code=ke?.name??"Unknown",(0,i.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists($){return new w($,i.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound($){return new w($,i.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory($){return new w($,i.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory($){return new w($,i.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions($){return new w($,i.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable($){return new w($,i.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};Ot=w=Ve([D],Ot),e.FileSystemError=Ot;let qt=class{constructor($,oe,ke){this.start=$,this.end=oe,this.kind=ke}};qt=Ve([D],qt),e.FoldingRange=qt;var En;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class fn{constructor($,oe=[]){this.tokenTypes=$,this.tokenModifiers=oe}}e.SemanticTokensLegend=fn;function nn(H){return typeof H=="undefined"||(0,C.isStringArray)(H)}class rn{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let oe=0,ke=$.tokenTypes.length;oe<ke;oe++)this._tokenTypeStrToInt.set($.tokenTypes[oe],oe);for(let oe=0,ke=$.tokenModifiers.length;oe<ke;oe++)this._tokenModifierStrToInt.set($.tokenModifiers[oe],oe)}}push($,oe,ke,Ye,nt){if(typeof $=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ye=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded($,oe,ke,Ye,nt);if(V.isRange($)&&typeof oe=="string"&&nn(ke))return this._push($,oe,ke);throw(0,L.illegalArgument)()}_push($,oe,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ye=$.start.line,nt=$.start.character,rt=$.end.character-$.start.character,lt=this._tokenTypeStrToInt.get(oe);let yt=0;if(ke)for(const At of ke){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(At);yt|=1<<Rt>>>0}this._pushEncoded(Ye,nt,rt,lt,yt)}_pushEncoded($,oe,ke,Ye,nt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let At=0,Rt=0;for(let Ft=0;Ft<yt;Ft++){let Nt=this._data[5*Ft],cn=this._data[5*Ft+1];Nt===0?(Nt=At,cn+=Rt):Nt+=At,this._data[5*Ft]=Nt,this._data[5*Ft+1]=cn,At=Nt,Rt=cn}}let rt=$,lt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=nt,this._prevLine=$,this._prevChar=oe}static _sortAndDeltaEncode($){let oe=[];const ke=$.length/5|0;for(let lt=0;lt<ke;lt++)oe[lt]=lt;oe.sort((lt,yt)=>{const At=$[5*lt],Rt=$[5*yt];if(At===Rt){const Ft=$[5*lt+1],Nt=$[5*yt+1];return Ft-Nt}return At-Rt});const Ye=new Uint32Array($.length);let nt=0,rt=0;for(let lt=0;lt<ke;lt++){const yt=5*oe[lt],At=$[yt+0],Rt=$[yt+1],Ft=$[yt+2],Nt=$[yt+3],cn=$[yt+4],Un=At-nt,qn=Un===0?Rt-rt:Rt,un=5*lt;Ye[un+0]=Un,Ye[un+1]=qn,Ye[un+2]=Ft,Ye[un+3]=Nt,Ye[un+4]=cn,nt=At,rt=Rt}return Ye}build($){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),$):new Ht(rn._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=rn;class Ht{constructor($,oe){this.resultId=oe,this.data=$}}e.SemanticTokens=Ht;class sn{constructor($,oe,ke){this.start=$,this.deleteCount=oe,this.data=ke}}e.SemanticTokensEdit=sn;class Sn{constructor($,oe){this.resultId=oe,this.edits=$}}e.SemanticTokensEdits=Sn;var yn;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var zt;(function(H){H[H.Initial=1]="Initial",H[H.Dynamic=2]="Dynamic"})(zt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new Tt("arrow-left")},Gt=Ve([D],Gt),e.QuickInputButtons=Gt;var Dn;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor($,oe,ke){this.badge=$,this.tooltip=oe,this.color=ke}static validate($){if($.badge&&$.badge.length!==1&&$.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let on=class{constructor($){this.kind=$}};on=Ve([D],on),e.ColorTheme=on;var an;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor($,oe){if($<0)throw(0,L.illegalArgument)("start must be positive");if(oe<0)throw(0,L.illegalArgument)("end must be positive");$<=oe?(this._start=$,this._end=oe):(this._start=oe,this._end=$)}static isNotebookRange($){return $ instanceof Bt?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let oe=this._start,ke=this._end;return $.start!==void 0&&(oe=$.start),$.end!==void 0&&(ke=$.end),oe===this._start&&ke===this._end?this:new Bt(oe,ke)}}e.NotebookRange=Bt;class Lt{constructor($,oe,ke,Ye,nt,rt,lt){this.kind=$,this.value=oe,this.languageId=ke,this.mime=Ye,this.outputs=nt??[],this.metadata=rt,this.executionSummary=lt,Lt.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(oe=>Lt.isNotebookCellData(oe))}static isNotebookCellData($){return!0}}e.NotebookCellData=Lt;class Kt{constructor($){this.cells=$}}e.NotebookData=Kt;class Ne{constructor($,oe){this.data=$,this.mime=oe;const ke=(0,T.normalizeMimeType)(oe,!0);if(!ke)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}static isNotebookCellOutputItem($){return $ instanceof Ne?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const oe={name:$.name,message:$.message,stack:$.stack};return Ne.json(oe,"application/vnd.code.notebook.error")}static stdout($){return Ne.text($,"application/vnd.code.notebook.stdout")}static stderr($){return Ne.text($,"application/vnd.code.notebook.stderr")}static bytes($,oe="application/octet-stream"){return new Ne($,oe)}static text($,oe=T.Mimes.text){const ke=He(Ne,l,"f",v).encode(String($));return new Ne(ke,oe)}static json($,oe="application/json"){const ke=JSON.stringify($,void 0,"	");return Ne.text(ke,oe)}}e.NotebookCellOutputItem=Ne,l=Ne,v={value:new TextEncoder};class $t{constructor($,oe,ke){this.items=$t.ensureUniqueMimeTypes($,!0),typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=(0,P.generateUuid)(),this.metadata=oe??ke)}static isNotebookCellOutput($){return $ instanceof $t?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,C.isArray)($.items)}static ensureUniqueMimeTypes($,oe=!1){const ke=new Set,Ye=new Set;for(let nt=0;nt<$.length;nt++){const rt=$[nt],lt=(0,T.normalizeMimeType)(rt.mime);if(!ke.has(lt)){ke.add(lt);continue}Ye.add(nt),oe&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Ye.size===0?$:$.filter((nt,rt)=>!Ye.has(rt))}}e.NotebookCellOutput=$t;var mn;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(mn=e.NotebookCellKind||(e.NotebookCellKind={}));var pt;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(pt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var kn;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(kn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var In;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(In=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gn{constructor($,oe){this.text=$,this.alignment=oe}}e.NotebookCellStatusBarItem=gn;var pn;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pn{constructor($,oe=[]){this.uri=$,this.provides=(0,g.asArray)(oe)}}e.NotebookRendererScript=Pn;let ln=class{constructor($,oe){this.label=$,this.timestamp=oe}};ln=Ve([D],ln),e.TimelineItem=ln;var An;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var vn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=4]="RegEx"})(vn=e.StandardTokenType||(e.StandardTokenType={}));class Rn{constructor($,oe){this.ranges=$,this.wordPattern=oe}}e.LinkedEditingRanges=Rn;class Ln{constructor($,oe){this._port=$,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ln;var Fn;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var Mn;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information",H[H.Hint=3]="Hint"})(Mn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var On;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ie=class{constructor($,oe,ke){this.include=$,this.exclude=oe,this.profile=ke}};ie=Ve([D],ie),e.TestRunRequest=ie;let de=E=class{constructor($){this.message=$}static diff($,oe,ke){const Ye=new E($);return Ye.expectedOutput=oe,Ye.actualOutput=ke,Ye}};de=E=Ve([D],de),e.TestMessage=de;let Re=class{constructor($,oe){this.covered=$,this.total=oe}};Re=Ve([D],Re),e.CoveredCount=Re;let st=s=class{constructor($,oe,ke,Ye){this.uri=$,this.statementCoverage=oe,this.branchCoverage=ke,this.functionCoverage=Ye}static fromDetails($,oe){const ke=new Re(0,0),Ye=new Re(0,0),nt=new Re(0,0);for(const lt of oe)if("branches"in lt){ke.total+=1,ke.covered+=lt.executionCount>0?1:0;for(const yt of lt.branches)Ye.total+=1,Ye.covered+=yt.executionCount>0?1:0}else nt.total+=1,nt.covered+=lt.executionCount>0?1:0;const rt=new s($,ke,Ye.total>0?Ye:void 0,nt.total>0?nt:void 0);return rt.detailedCoverage=oe,rt}};st=s=Ve([D],st),e.FileCoverage=st;let wt=class{constructor($,oe,ke=[]){this.executionCount=$,this.location=oe,this.branches=ke}};wt=Ve([D],wt),e.StatementCoverage=wt;let Ct=class{constructor($,oe){this.executionCount=$,this.location=oe}};Ct=Ve([D],Ct),e.BranchCoverage=Ct;let Nn=class{constructor($,oe){this.executionCount=$,this.location=oe}};Nn=Ve([D],Nn),e.FunctionCoverage=Nn;var Hn;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zn;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(zn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vn;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class jn{constructor($,oe,ke,Ye,nt,rt){this.kind=$,this.name=oe,this.detail=ke,this.uri=Ye,this.range=nt,this.selectionRange=rt}}e.TypeHierarchyItem=jn}),define(me[123],ge([0,1,54,10,8,149,110,7,20]),function(J,e,g,L,k,y,T,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function i(l,v){v?P.set(l,v):P.delete(l)}e.setWordDefinitionFor=i;function I(l){return P.get(l)}e.getWordDefinitionFor=I;class u extends y.MirrorTextModel{constructor(v,_,b,A,c,h,p,t){super(_,b,A,c);this._proxy=v,this._languageId=h,this._isDirty=p,this._notebook=t,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,S.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===L.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(_){return _?v._getTextInRange(_):v.getText()},get eol(){return v._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(_){return v._lineAt(_)},offsetAt(_){return v._offsetAt(_)},positionAt(_){return v._positionAt(_)},validateRange(_){return v._validateRange(_)},validatePosition(_){return v._validatePosition(_)},getWordRangeAtPosition(_,b){return v._getWordRangeAtPosition(_,b)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,g.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,g.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const _=this._validateRange(v);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const b=this._eol,A=_.start.line,c=_.end.line,h=[];h.push(this._lines[A].substring(_.start.character));for(let p=A+1;p<c;p++)h.push(this._lines[p]);return h.push(this._lines[c].substring(0,_.end.character)),h.join(b)}_lineAt(v){let _;if(v instanceof C.Position?_=v.line:typeof v=="number"&&(_=v),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new m(_,this._lines[_],_===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(v),b=this._lines[_.index].length;return new C.Position(_.index,Math.min(_.remainder,b))}_validateRange(v){if(!(v instanceof C.Range))throw new Error("Invalid argument");const _=this._validatePosition(v.start),b=this._validatePosition(v.end);return _===v.start&&b===v.end?v:new C.Range(_.line,_.character,b.line,b.character)}_validatePosition(v){if(!(v instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:_,character:b}=v,A=!1;if(_<0)_=0,b=0,A=!0;else if(_>=this._lines.length)_=this._lines.length-1,b=this._lines[_].length,A=!0;else{const c=this._lines[_].length;b<0?(b=0,A=!0):b>c&&(b=c,A=!0)}return A?new C.Position(_,b):v}_getWordRangeAtPosition(v,_){const b=this._validatePosition(v);if(!_)_=I(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const A=(0,T.getWordAtText)(b.character+1,(0,T.ensureValidWordDefinition)(_),this._lines[b.line],0);if(A)return new C.Range(b.line,A.startColumn-1,b.line,A.endColumn-1)}}e.ExtHostDocumentData=u;class m{constructor(v,_,b){this._line=v,this._text=_,this._isLastLine=b}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(me[202],ge([0,1,7,3,112,6,79,22,2,32]),function(J,e,g,L,k,y,T,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(u,m,l,v){this._notebook=l,this._selector=v,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(b=>{const A=this._cellUris.get(b.document.uri);A!==void 0&&(this._cellLengths.changeValue(A,this._cells[A].document.getText().length+1),this._cellLines.changeValue(A,this._cells[A].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=b=>{b===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(u.onDidChangeNotebookCells(b=>_(b.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const u=[],m=[];for(const l of this._notebook.getCells())l.kind===g.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),u.push(l.document.getText().length+1),m.push(l.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(u)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(u){if(!u){let A="";for(const c of this._cells)A+=c.document.getText()+`
`;return A=A.slice(0,-1),A}if(u.isEmpty)return"";const m=this.locationAt(u.start),l=this.locationAt(u.end),v=this._cellUris.get(m.uri),_=this._cellUris.get(l.uri);if(v===void 0||_===void 0)return"";if(v===_)return this._cells[v].document.getText(new g.Range(m.range.start,l.range.end));const b=[this._cells[v].document.getText(new g.Range(m.range.start,new g.Position(this._cells[v].document.lineCount,0)))];for(let A=v+1;A<_;A++)b.push(this._cells[A].document.getText());return b.push(this._cells[_].document.getText(new g.Range(new g.Position(0,0),l.range.end))),b.join(`
`)}offsetAt(u){const m=this._cellLines.getIndexOf(u.line),l=this._cellLengths.getPrefixSum(m.index-1),v=this._cells[m.index].document.offsetAt(u.with(m.remainder));return l+v}positionAt(u){if(typeof u=="number"){const l=this._cellLengths.getIndexOf(u),v=this._cellLines.getPrefixSum(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(v)}const m=this._cellUris.get(u.uri);if(m!==void 0){const l=this._cellLines.getPrefixSum(m-1);return new g.Position(l+u.range.start.line,u.range.start.character)}return new g.Position(0,0)}locationAt(u){g.Range.isRange(u)||(u=new g.Range(u,u));const m=this._cellLines.getIndexOf(u.start.line);let l=m;u.isEmpty||(l=this._cellLines.getIndexOf(u.end.line));const v=new g.Position(m.remainder,u.start.character),_=new g.Position(l.remainder,u.end.character),b=new g.Range(v,_),A=this._cells[m.index];return new g.Location(A.document.uri,A.document.validateRange(b))}contains(u){return this._cellUris.has(u)}validateRange(u){const m=this.validatePosition(u.start),l=this.validatePosition(u.end);return u.with(m,l)}validatePosition(u){const m=this._cellLines.getIndexOf(u.line),l=new g.Position(m.remainder,u.character),v=this._cells[m.index].document.validatePosition(l),_=this._cellLines.getPrefixSum(m.index-1);return new g.Position(_+v.line,v.character)}}e.ExtHostNotebookConcatDocument=i}),define(me[203],ge([0,1,7,13,3]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(C){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let S=C==="light"?g.ColorThemeKind.Light:C==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=Ve([$e(0,L.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(me[63],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class L{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=L}),define(me[204],ge([0,1,24]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(S){let P=this.buffers.indexOf(S);return P<0&&(P=this.buffers.length,this.buffers.push(S)),P}}function k(C,S){if(S.serializeBuffersForPostMessage){const P=new L,i=(m,l)=>{if(l instanceof ArrayBuffer){const v=P.add(l);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(l)){const v=y(l);if(v){const _=P.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:v,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},I=JSON.stringify(C,i),u=P.buffers.map(m=>{const l=new Uint8Array(m);return g.VSBuffer.wrap(l)});return{message:I,buffers:u}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=k;function y(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(C,S){const P=S.map(u=>{const m=new ArrayBuffer(u.byteLength);return new Uint8Array(m).set(u.buffer),m}),i=S.length?(u,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const l=m,{index:v}=l,_=P[v];if(l.view)switch(l.view.type){case 1:return new Int8Array(_,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return m}:void 0;return{message:JSON.parse(C,i),arrayBuffers:P}}e.deserializeWebviewMessage=T}),define(me[205],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(L){function k(T){const C={items:new Map};return T.types.forEach((S,P)=>{C.items.set(S,{asString:async()=>T.items[P].asString})}),C}L.toITreeDataTransfer=k;async function y(T){const C={types:[],items:[]},S=Array.from(T.items.entries());for(const P of S)C.types.push(P[0]),C.items.push({asString:await P[1].asString()});return C}L.toTreeDataTransferDTO=y})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(me[88],ge([0,1,10,2]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(y,T){return y.scheme===g.Schemas.http||y.scheme===g.Schemas.https?y:(T&&T.authority&&T.isRemote&&y.scheme===g.Schemas.file&&(y=L.URI.from({scheme:g.Schemas.vscodeRemote,authority:T.authority,path:y.path})),L.URI.from({scheme:g.Schemas.https,authority:`${y.scheme}+${y.authority}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=k}),define(me[206],ge([0,1,3,6,88]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(C,S,P){this._proxy=C,this._editors=S,this._initData=P,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const i=S.getVisibleTextEditors();for(const I of this._insets.values())i.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,S,P,i,I){let u;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===C){u=c;break}if(!u)throw new Error("not a visible editor");const m=this,l=this._handlePool++,v=new g.Emitter,_=new g.Emitter,b=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,k.asWebviewUri)(c,m._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(c){this._options=c,m._proxy.$setOptions(l,c)}get options(){return this._options}set html(c){this._html=c,m._proxy.$setHtml(l,c)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(c){return m._proxy.$postMessage(l,c)}},A=new class{constructor(){this.editor=C,this.line=S,this.height=P,this.webview=b,this.onDidDispose=_.event}dispose(){m._insets.has(l)&&(m._insets.delete(l),m._proxy.$disposeEditorInset(l),_.fire(),_.dispose(),v.dispose())}};return this._proxy.$createEditorInset(l,u.id,u.value.document.uri,S+1,P,i||{},I.identifier,I.extensionLocation),this._insets.set(l,{editor:C,inset:A,onDidReceiveMessage:v}),A}$onDidDispose(C){const S=this._insets.get(C);S&&S.inset.dispose()}$onDidReceiveMessage(C,S){const P=this._insets.get(C);P&&P.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=y}),define(me[207],ge([0,1,171,14,2,6,4,61,34,20,10]),function(J,e,g,L,k,y,T,C,S,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new C.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new C.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new C.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new C.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new C.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorContext=new C.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new C.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new C.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new C.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.EditorGroupEditorsCountContext=new C.RawContextKey("groupEditorsCount",0,(0,g.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new C.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(12,null)),e.ActiveEditorGroupIndexContext=new C.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(13,null)),e.ActiveEditorGroupLastContext=new C.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(14,null)),e.MultipleEditorGroupsContext=new C.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new C.RawContextKey("editorIsOpen",!1,(0,g.localize)(16,null)),e.InEditorZenModeContext=new C.RawContextKey("inZenMode",!1,(0,g.localize)(17,null)),e.IsCenteredLayoutContext=new C.RawContextKey("isCenteredLayout",!1,(0,g.localize)(18,null)),e.SplitEditorsVertically=new C.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(19,null)),e.EditorAreaVisibleContext=new C.RawContextKey("editorAreaVisible",!0,(0,g.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function I(s){return typeof s?.getViewState=="function"}e.isTextEditorPane=I;function u(s){if(c(s))return!1;const D=s;return k.URI.isUri(D?.resource)}e.isResourceEditorInput=u;function m(s){if(c(s))return!1;const D=s;return D?.original!==void 0&&D.modified!==void 0}e.isResourceDiffEditorInput=m;function l(s){if(c(s))return!1;const D=s;return D?D?.resource===void 0||D.resource.scheme===i.Schemas.untitled||D.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;var v;(function(s){s[s.SHORT=0]="SHORT",s[s.MEDIUM=1]="MEDIUM",s[s.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var _;(function(s){s[s.EXPLICIT=1]="EXPLICIT",s[s.AUTO=2]="AUTO",s[s.FOCUS_CHANGE=3]="FOCUS_CHANGE",s[s.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(_=e.SaveReason||(e.SaveReason={}));var b;(function(s){s[s.None=0]="None",s[s.Readonly=2]="Readonly",s[s.Untitled=4]="Untitled",s[s.Singleton=8]="Singleton",s[s.RequiresTrust=16]="RequiresTrust"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class A extends y.Disposable{}e.AbstractEditorInput=A;function c(s){return s instanceof A}e.isEditorInput=c;function h(s){const D=s;return k.URI.isUri(D?.preferredResource)}function p(s){const D=s;return c(D?.primary)&&c(D?.secondary)}e.isSideBySideEditorInput=p;function t(s){return c(s?.editor)}e.isEditorInputWithOptions=t;function r(s){const D=s;return t(s)&&D?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function o(s){const D=s;return typeof D?.groupId=="number"&&c(D.editor)}e.isEditorIdentifier=o;var n;(function(s){s[s.PRIMARY=1]="PRIMARY",s[s.SECONDARY=2]="SECONDARY",s[s.BOTH=3]="BOTH"})(n=e.SideBySideEditor||(e.SideBySideEditor={}));class a{getOriginalUri(D,R){if(!D)return;const U=p(D)?D.primary:m(D)?D.modified:void 0,V=p(D)?D.secondary:m(D)?D.original:void 0;if(R?.supportSideBySide&&U&&V){if(R?.supportSideBySide===n.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:R.filterByScheme}),secondary:this.getOriginalUri(V,{filterByScheme:R.filterByScheme})};D=R.supportSideBySide===n.PRIMARY?U:V}if(m(D))return;const ee=h(D)?D.preferredResource:D.resource;return!ee||!R||!R.filterByScheme?ee:this.filterUri(ee,R.filterByScheme)}getCanonicalUri(D,R){if(!D)return;const U=p(D)?D.primary:m(D)?D.modified:void 0,V=p(D)?D.secondary:m(D)?D.original:void 0;if(R?.supportSideBySide&&U&&V){if(R?.supportSideBySide===n.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:R.filterByScheme}),secondary:this.getCanonicalUri(V,{filterByScheme:R.filterByScheme})};D=R.supportSideBySide===n.PRIMARY?U:V}if(m(D))return;const ee=D.resource;return!ee||!R||!R.filterByScheme?ee:this.filterUri(ee,R.filterByScheme)}filterUri(D,R){if(Array.isArray(R)){if(R.some(U=>D.scheme===U))return D}else if(R===D.scheme)return D}}e.EditorResourceAccessor=new a;var f;(function(s){s[s.LEFT=0]="LEFT",s[s.RIGHT=1]="RIGHT"})(f=e.CloseDirection||(e.CloseDirection={}));class d{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(D){const R=this.instantiationService=D.get(T.IInstantiationService);for(const[U,V]of this.editorSerializerConstructors)this.createEditorSerializer(U,V,R);this.editorSerializerConstructors.clear()}createEditorSerializer(D,R,U){const V=U.createInstance(R);this.editorSerializerInstances.set(D,V)}registerFileEditorFactory(D){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=D}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(D,R){if(this.editorSerializerConstructors.has(D)||this.editorSerializerInstances.has(D))throw new Error(`A editor serializer with type ID '${D}' was already registered.`);return this.instantiationService?this.createEditorSerializer(D,R,this.instantiationService):this.editorSerializerConstructors.set(D,R),(0,y.toDisposable)(()=>{this.editorSerializerConstructors.delete(D),this.editorSerializerInstances.delete(D)})}getEditorSerializer(D){return this.editorSerializerInstances.get(typeof D=="string"?D:D.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new d);async function w(s,D){if(!s||!s.length)return[];const R=await Promise.all(s.map(async U=>{const V=k.URI.revive(U.fileUri);if(!V||(await D.activateProvider(V.scheme),!D.canHandleResource(V)))return;const ee=typeof U.exists=="boolean"?U.exists:await D.exists(V);if(!ee&&U.openOnlyIfExists)return;const K=ee&&!(0,L.isUndefined)(U.selection)?{selection:U.selection,pinned:!0,override:U.editorOverrideId}:{pinned:!0,override:U.editorOverrideId};let O;return ee?O={resource:V,options:K,forceFile:!0}:O={resource:V,options:K,forceUntitled:!0},O}));return(0,P.coalesce)(R)}e.pathsToEditors=w;var E;(function(s){s[s.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",s[s.SEQUENTIAL=1]="SEQUENTIAL"})(E=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[208],ge([0,1,3,61,172,4,6,22,34,20,55,25,47,197]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",u.Codicon.window,(0,k.localize)(0,null));var l;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(l=e.Extensions||(e.Extensions={}));var v;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel"})(v=e.ViewContainerLocation||(e.ViewContainerLocation={}));function _(a){switch(a){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=_;function b(a){return`viewContainer.${a}.enabled`}e.getEnabledViewContainerContextKey=b;class A extends T.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(f,d,w){const E=this.get(f.id);if(E)return E;const s=f;return s.openCommandActionDescriptor=w?.donotRegisterOpenCommand?void 0:s.openCommandActionDescriptor??{id:s.id},(0,C.getOrSet)(this.viewContainers,d,[]).push(s),w?.isDefault&&this.defaultViewContainers.push(s),this._onDidRegister.fire({viewContainer:s,viewContainerLocation:d}),s}deregisterViewContainer(f){for(const d of this.viewContainers.keys()){const w=this.viewContainers.get(d),E=w?.indexOf(f);if(E!==-1){w?.splice(E,1),w.length===0&&this.viewContainers.delete(d),this._onDidDeregister.fire({viewContainer:f,viewContainerLocation:d});return}}}get(f){return this.all.filter(d=>d.id===f)[0]}getViewContainers(f){return[...this.viewContainers.get(f)||[]]}getViewContainerLocation(f){return[...this.viewContainers.keys()].filter(d=>this.getViewContainers(d).filter(w=>w?.id===f.id).length>0)[0]}getDefaultViewContainer(f){return this.defaultViewContainers.find(d=>this.getViewContainerLocation(d)===f)}}S.Registry.add(l.ViewContainersRegistry,new A);var c;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(c=e.ViewContentGroups||(e.ViewContentGroups={}));function h(a,f){const d=a.group??c.More,w=f.group??c.More;return d!==w?d.localeCompare(w):(a.order??5)-(f.order??5)}class p extends T.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(f,d){this.registerViews2([{views:f,viewContainer:d}])}registerViews2(f){f.forEach(({views:d,viewContainer:w})=>this.addViews(d,w)),this._onViewsRegistered.fire(f)}deregisterViews(f,d){const w=this.removeViews(f,d);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:d})}moveViews(f,d){for(const w of this._views.keys())if(w!==d){const E=this.removeViews(f,w);E.length&&(this.addViews(E,d),this._onDidChangeContainer.fire({views:E,from:w,to:d}))}}getViews(f){return this._views.get(f)||[]}getView(f){for(const d of this._viewContainers){const w=(this._views.get(d)||[]).filter(E=>E.id===f)[0];if(w)return w}return null}getViewContainer(f){for(const d of this._viewContainers)if((this._views.get(d)||[]).filter(E=>E.id===f)[0])return d;return null}registerViewWelcomeContent(f,d){return this._viewWelcomeContents.add(f,d),this._onDidChangeViewWelcomeContent.fire(f),(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(f,d),this._onDidChangeViewWelcomeContent.fire(f)})}registerViewWelcomeContent2(f,d){const w=new Map;for(const[E,s]of d)this._viewWelcomeContents.add(f,s),w.set(E,(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(f,s),this._onDidChangeViewWelcomeContent.fire(f)}));return this._onDidChangeViewWelcomeContent.fire(f),w}getViewWelcomeContent(f){const d=[];return this._viewWelcomeContents.forEach(f,w=>d.push(w)),d.sort(h)}addViews(f,d){let w=this._views.get(d);w||(w=[],this._views.set(d,w),this._viewContainers.push(d));for(const E of f){if(this.getView(E.id)!==null)throw new Error((0,k.localize)(1,null,E.id));w.push(E)}}removeViews(f,d){const w=this._views.get(d);if(!w)return[];const E=[],s=[];for(const D of w)f.includes(D)?E.push(D):s.push(D);return E.length&&(s.length?this._views.set(d,s):(this._views.delete(d),this._viewContainers.splice(this._viewContainers.indexOf(d),1))),E}}S.Registry.add(l.ViewsRegistry,new p),e.IViewsService=(0,y.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,k.localize)(2,null));function t(a){return`view.${a}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,y.createDecorator)("viewDescriptorService");var r;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class n{constructor(f,d){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,f),this._hasResolve=!!d,this.resolve=async w=>{if(d&&!this.resolved){const E=await d(w);E&&(this.tooltip=this.tooltip??E.tooltip,this.command=this.command??E.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(me[124],ge([0,1,3,17,173]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,S,P,i){const I={command:C};if(S&&Object.keys(S).length>0&&(I.arguments=S),this.internalSend("request",I),typeof i=="number"){const u=setTimeout(()=>{clearTimeout(u);const m=this.pendingRequests.get(I.seq);if(m){this.pendingRequests.delete(I.seq);const l={type:"response",seq:0,request_seq:I.seq,success:!1,command:C,message:(0,k.localize)(0,null,i,C)};m(l)}},i)}return P&&this.pendingRequests.set(I.seq,P),I.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,S){return C.type!=="event"||S.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,L.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const S=C,P=this.pendingRequests.get(S.request_seq);P&&(this.pendingRequests.delete(S.request_seq),P(S));break}}}internalSend(C,S){S.type=C,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((S,P)=>C.set(P,S)),await(0,L.timeout)(500),C.forEach((S,P)=>{S({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(me[209],ge([0,1,8,2,9,25,10]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function S(r,o,n){return r.replace(C,function(a,f){return o&&f.length>0&&f[0]!=="_"?a:n&&n.hasOwnProperty(f)?n[f]:a})}e.formatPII=S;function P(r){const o={};for(const n of Object.keys(r))n.startsWith("!")||(o[n]=r[n]);return o}e.filterExceptionsFromTelemetry=P;function i(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||i(r.parentSession))}e.isSessionAttach=i;function I(r){let o=r.configuration.type;if(!!o)return o==="vslsShare"&&(o=r.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(o,"extensionhost")||(0,g.equalsIgnoreCase)(o,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function u(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=u;function m(r,o,n){let a,f=0,d=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,w=null;for(;w=d.exec(r);){let E=w.index+1,s=E+w[0].length;if(E<=o&&s>=n){a=w[0],f=E;break}}if(a){let E=/\w+/g,s=null;for(;(s=E.exec(a))&&!(s.index+1+f+s[0].length>=n););s&&(a=a.substring(0,E.lastIndex))}return a?{start:f,end:f+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(r){return!!(r&&r.match(l))}e.isUri=v;function _(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(v(r.path))return L.URI.parse(r.path);if((0,k.isAbsolute)(r.path))return L.URI.file(r.path)}return r.path}function b(r){if(typeof r.path=="object"){const o=L.URI.revive(r.path);if(o)return o.scheme===T.Schemas.file?o.fsPath:o.toString()}return r.path}function A(r,o){const n=o?_:b,a=(0,y.deepClone)(r);return h(a,(f,d)=>{f&&d&&(d.path=n(d))}),a}e.convertToDAPaths=A;function c(r,o){const n=o?_:b,a=(0,y.deepClone)(r);return h(a,(f,d)=>{!f&&d&&(d.path=n(d))}),a}e.convertToVSCPaths=c;function h(r,o){switch(r.type){case"event":const n=r;switch(n.event){case"output":o(!1,n.body.source);break;case"loadedSource":o(!1,n.body.source);break;case"breakpoint":o(!1,n.body.breakpoint.source);break;default:break}break;case"request":const a=r;switch(a.command){case"setBreakpoints":o(!0,a.arguments.source);break;case"breakpointLocations":o(!0,a.arguments.source);break;case"source":o(!0,a.arguments.source);break;case"gotoTargets":o(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(d=>o(!1,d));break;default:break}break;case"response":const f=r;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(d=>o(!1,d.source));break;case"loadedSources":f.body.sources.forEach(d=>o(!1,d));break;case"scopes":f.body.scopes.forEach(d=>o(!1,d.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(d=>o(!1,d.source));break;case"setBreakpoints":f.body.breakpoints.forEach(d=>o(!1,d.source));break;default:break}break}}function p(r){return r.filter(o=>!o.presentation?.hidden).sort((o,n)=>o.presentation?n.presentation?o.presentation.group?n.presentation.group?o.presentation.group!==n.presentation.group?o.presentation.group.localeCompare(n.presentation.group):t(o.presentation.order,n.presentation.order):-1:n.presentation.group?1:t(o.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=p;function t(r,o){return typeof r!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:r-o}}),define(me[210],ge([0,1,28,39,174,125,9,8,25,11,184,124]),function(J,e,g,L,k,y,T,C,S,P,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class u extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(A,c){this.outputStream=c,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,A.on("data",h=>this.handleData(h))}sendMessage(A){if(this.outputStream){const c=JSON.stringify(A);this.outputStream.write(`Content-Length: ${Buffer.byteLength(c,"utf8")}${u.TWO_CRLF}${c}`,"utf8")}}handleData(A){for(this.rawData=Buffer.concat([this.rawData,A]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const c=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,c.length>0)try{this.acceptMessage(JSON.parse(c))}catch(h){this._onError.fire(new Error((h.message||h)+`
`+c))}continue}}else{const c=this.rawData.indexOf(u.TWO_CRLF);if(c!==-1){const p=this.rawData.toString("utf8",0,c).split(u.HEADER_LINESEPARATOR);for(const t of p){const r=t.split(u.HEADER_FIELDSEPARATOR);r[0]==="Content-Length"&&(this.contentLength=Number(r[1]))}this.rawData=this.rawData.slice(c+u.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=u,u.TWO_CRLF=`\r
\r
`,u.HEADER_LINESEPARATOR=/\r?\n/,u.HEADER_FIELDSEPARATOR=/: */;class m extends u{startSession(){return new Promise((A,c)=>{let h=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),A(),h=!0}),this.socket.on("close",()=>{h?this._onError.fire(new Error("connection closed")):c(new Error("connection closed"))}),this.socket.on("error",p=>{h?this._onError.fire(p):c(p)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class l extends m{constructor(A){super();this.adapterServer=A}createConnection(A){return y.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",A)}}e.SocketDebugAdapter=l;class v extends m{constructor(A){super();this.adapterServer=A}createConnection(A){return y.createConnection(this.adapterServer.path,A)}}e.NamedPipeDebugAdapter=v;class _ extends u{constructor(A,c,h){super();this.adapterExecutable=A,this.debugType=c,this.outputService=h}async startSession(){const A=this.adapterExecutable.command,c=this.adapterExecutable.args,h=this.adapterExecutable.options||{};try{if(A)if(T.isAbsolute(A)){if(!await g.Promises.exists(A))throw new Error(k.localize(0,null,A))}else A.indexOf("/")<0&&A.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let p=process.env;if(h.env&&Object.keys(h.env).length>0&&(p=S.mixin(S.deepClone(process.env),h.env)),A==="node")if(Array.isArray(c)&&c.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:p,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};h.cwd&&(o.cwd=h.cwd);const n=L.fork(c[0],c.slice(1),o);if(!n.pid)throw new Error(k.localize(2,null,c[0]));this.serverProcess=n}else throw new Error(k.localize(3,null));else{const r={env:p};h.cwd&&(r.cwd=h.cwd),this.serverProcess=L.spawn(A,c,r)}this.serverProcess.on("error",r=>{this._onError.fire(r)}),this.serverProcess.on("exit",(r,o)=>{this._onExit.fire(r)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",r=>{this._onError.fire(r)}),this.serverProcess.stdin.on("error",r=>{this._onError.fire(r)});const t=this.outputService;if(t){const r=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const n=t.getChannel(i.ExtensionsChannelId);n&&n.append(r(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(p){this._onError.fire(p)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((A,c)=>{const h=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(p,t,r){if(p)return c(p)});h.on("exit",A),h.on("error",c)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(A,c){if(!A)return;const h=Object.create(null);A.runtime&&(A.runtime.indexOf("./")===0?h.runtime=T.join(c,A.runtime):h.runtime=A.runtime),A.runtimeArgs&&(h.runtimeArgs=A.runtimeArgs),A.program&&(T.isAbsolute(A.program)?h.program=A.program:h.program=T.join(c,A.program)),A.args&&(h.args=A.args);const p=A;return p.win&&(h.win=_.extract(p.win,c)),p.winx86&&(h.winx86=_.extract(p.winx86,c)),p.windows&&(h.windows=_.extract(p.windows,c)),p.osx&&(h.osx=_.extract(p.osx,c)),p.linux&&(h.linux=_.extract(p.linux,c)),h}static platformAdapterExecutable(A,c){let h=Object.create(null);c=c.toLowerCase();for(const a of A)if(a.contributes){const f=a.contributes.debuggers;f&&f.length>0&&f.filter(d=>typeof d.type=="string"&&C.equalsIgnoreCase(d.type,c)).forEach(d=>{const w=_.extract(d,a.extensionLocation.fsPath);h=S.mixin(h,w,a.isBuiltin)})}let p;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=h.winx86||h.win||h.windows:P.isWindows?p=h.win||h.windows:P.isMacintosh?p=h.osx:P.isLinux&&(p=h.linux),p=p||h;let t=p.program||h.program;const r=p.args||h.args;let o=p.runtime||h.runtime;const n=p.runtimeArgs||h.runtimeArgs;if(o)return{type:"executable",command:o,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(r||[])};if(t)return{type:"executable",command:t,args:r||[]}}}e.ExecutableDebugAdapter=_}),define(me[211],ge([0,1,39,11,29,187]),function(J,e,g,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(u,m){return new Promise((l,v)=>{let _="";const b=g.spawn(u,m);b.pid&&b.stdout.on("data",A=>{_+=A.toString()}),b.on("error",A=>{v(A)}),b.on("close",A=>{l(_)})})}let C;function S(u,m){if(!C)if(L.isWindows)C=new y.WindowsExternalTerminalService;else if(L.isMacintosh)C=new y.MacExternalTerminalService;else if(L.isLinux)C=new y.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const l=m.getConfiguration("terminal");return C.runInTerminal(u.title,u.cwd,u.args,u.env||{},l.external||{})}e.runInExternalTerminal=S;function P(u){return u?L.isWindows?new Promise(async m=>{(await new Promise((v,_)=>{J(["windows-process-tree"],v,_)})).getProcessTree(u,v=>{m(v.children.length>0)})}):T("/usr/bin/pgrep",["-lP",String(u)]).then(m=>{const l=m.trim();return!(l.length===0||l.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=P;var i;(function(u){u[u.cmd=0]="cmd",u[u.powershell=1]="powershell",u[u.bash=2]="bash"})(i||(i={}));function I(u,m,l,v){u=u.trim().toLowerCase();let _;u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0?_=1:u.indexOf("cmd.exe")>=0?_=0:u.indexOf("bash")>=0?_=2:L.isWindows?_=0:_=2;let b,A=" ";switch(_){case 1:if(b=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),l){const h=(0,k.getDriveLetter)(l);h&&(A+=`${h}:; `),A+=`cd ${b(l)}; `}if(v)for(let h in v){const p=v[h];p===null?A+=`Remove-Item env:${h}; `:A+=`\${env:${h}}='${p}'; `}if(m.length>0){const h=b(m.shift());A+=h[0]==="'"?`& ${h} `:`${h} `;for(let p of m)A+=`${b(p)} `}break;case 0:if(b=h=>(h=h.replace(/\"/g,'""'),h.indexOf(" ")>=0||h.indexOf('"')>=0||h.length===0?`"${h}"`:h),l){const h=(0,k.getDriveLetter)(l);h&&(A+=`${h}: && `),A+=`cd ${b(l)} && `}if(v){A+='cmd /C "';for(let h in v){let p=v[h];p===null?A+=`set "${h}=" && `:(p=p.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),A+=`set "${h}=${p}" && `)}}for(let h of m)A+=`${b(h)} `;v&&(A+='"');break;case 2:b=h=>(h=h.replace(/(["'\\\$])/g,"\\$1"),h.indexOf(" ")>=0||h.indexOf(";")>=0||h.length===0?`"${h}"`:h);const c=h=>/[^\w@%\/+=,.:^-]/.test(h)?`'${h.replace(/'/g,"'\\''")}'`:h;if(l&&(A+=`cd ${b(l)} ; `),v){A+="/usr/bin/env";for(let h in v){const p=v[h];p===null?A+=` -u ${c(h)}`:A+=` ${c(`${h}=${p}`)}`}A+=" "}for(let h of m)A+=`${b(h)} `;break}return A}e.prepareCommand=I}),define(me[89],ge([0,1,30,102,10,9,11,61]),function(J,e,g,L,k,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(s){s[s.Markup=1]="Markup",s[s.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(s){s[s.Running=1]="Running",s[s.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var i;(function(s){s[s.Pending=2]="Pending",s[s.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(s){s[s.WithHardKernelDependency=0]="WithHardKernelDependency",s[s.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",s[s.Pure=2]="Pure",s[s.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var u;(function(s){s.Always="always",s.Never="never",s.Optional="optional"})(u=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(s){s[s.ModelChange=1]="ModelChange",s[s.Move=2]="Move",s[s.ChangeLanguage=5]="ChangeLanguage",s[s.Initialize=6]="Initialize",s[s.ChangeCellMetadata=7]="ChangeCellMetadata",s[s.Output=8]="Output",s[s.OutputItem=9]="OutputItem",s[s.ChangeCellContent=10]="ChangeCellContent",s[s.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",s[s.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",s[s.ChangeCellMime=13]="ChangeCellMime",s[s.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var l;(function(s){s[s.Handle=0]="Handle",s[s.Index=1]="Index"})(l=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(s){s[s.Replace=1]="Replace",s[s.Output=2]="Output",s[s.Metadata=3]="Metadata",s[s.CellLanguage=4]="CellLanguage",s[s.DocumentMetadata=5]="DocumentMetadata",s[s.Move=6]="Move",s[s.OutputItems=7]="OutputItems",s[s.PartialMetadata=8]="PartialMetadata",s[s.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var _;(function(s){s.scheme=k.Schemas.vscodeNotebookCell;const D=/^ch(\d{7,})/;function R(O,x){return O.with({scheme:s.scheme,fragment:`ch${x.toString().padStart(7,"0")}${O.scheme!==k.Schemas.file?O.scheme:""}`})}s.generate=R;function U(O){if(O.scheme!==s.scheme)return;const x=D.exec(O.fragment);return x?{handle:Number(x[1]),notebook:O.with({scheme:O.fragment.substr(x[0].length)||k.Schemas.file,fragment:null})}:void 0}s.parse=U;function V(O){if(O.scheme!==k.Schemas.vscodeNotebookCellMetadata)return;const x=D.exec(O.fragment);return x?{handle:Number(x[1]),notebook:O.with({scheme:O.fragment.substr(x[0].length)||k.Schemas.file,fragment:null})}:void 0}s.parseCellMetadataUri=V;function ee(O,x,F){return O.with({scheme:F,fragment:`ch${x.toString().padStart(7,"0")}${O.scheme!==k.Schemas.file?O.scheme:""}`})}s.generateCellUri=ee;function K(O,x){if(O.scheme!==x)return;const F=D.exec(O.fragment);return F?{handle:Number(F[1]),notebook:O.with({scheme:O.fragment.substr(F[0].length)||k.Schemas.file,fragment:null})}:void 0}s.parseCellUri=K})(_=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function A(s){return b.get(s)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=A;function c(s){return b.get(s)?.supportedByCore??!1}e.mimeTypeSupportedByCore=c;function h(s){return b.get(s)?.mergeable??!1}e.mimeTypeIsMergeable=h;function p(s,D){return T.isWindows&&(s=s.replace(/\//g,"\\"),D=D.replace(/\//g,"\\")),g.match(s,D)}function t(s,D,R){let U=0;for(let V=0;V<D.length;V++){if(p(D[V],s))return U;U++}for(let V=0;V<R.length;V++){if(p(R[V],s))return U;U++}return U}function r(s,D,R){return s.sort((U,V)=>t(U,D,R)-t(V,D,R))}e.sortMimeTypes=r;function o(s,D,R,U=(V,ee)=>V===ee){const V=[];function ee(x,F,z){if(F===0&&z.length===0)return;const M=V[V.length-1];M&&M.start+M.deleteCount===x?(M.deleteCount+=F,M.toInsert.push(...z)):V.push({start:x,deleteCount:F,toInsert:z})}let K=0,O=0;for(;;){if(K===s.length){ee(K,0,D.slice(O));break}if(O===D.length){ee(K,s.length-K,[]);break}const x=s[K],F=D[O];if(U(x,F)){K+=1,O+=1;continue}R(F)?(ee(K,1,[]),K+=1):(ee(K,0,[F]),O+=1)}return V}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(s){s.default="default",s.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(s){const D=s;return!!((typeof D.include=="string"||g.isRelativePattern(D.include))&&(typeof D.exclude=="string"||g.isRelativePattern(D.exclude)))}e.isDocumentExcludePattern=a;function f(s,D,R){if(Array.isArray(s.viewType)&&s.viewType.indexOf(D)>=0||s.viewType===D)return!0;if(s.filenamePattern){let U=a(s.filenamePattern)?s.filenamePattern.include:s.filenamePattern,V=a(s.filenamePattern)?s.filenamePattern.exclude:void 0;if(g.match(U,(0,y.basename)(R.fsPath).toLowerCase()))return!(V&&g.match(V,(0,y.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=f;class d{constructor(D){this.textModel=D}getElements(){const D=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)D[R]=this.textModel.cells[R].getHashValue();return D}}e.CellSequence=d,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var w;(function(s){s[s.Left=1]="Left",s[s.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class E{static create(D){return`${E._prefix}${D}`}static parse(D){if(D.startsWith(E._prefix))return D.substr(E._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=E,E._prefix="notebook/"}),define(me[212],ge([0,1,176,4,61]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[213],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=g;function L(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=L}),define(me[126],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.identifyTest=e.TestResultState=void 0;var g;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));const L=I=>({testId:I.item.extId,controllerId:I.controllerId});e.identifyTest=L;var k;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(k=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(y=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(I,u)=>{u.expand!==void 0&&(I.expand=u.expand),u.item!==void 0&&(I.item=I.item?Object.assign(I.item,u.item):u.item)};e.applyTestItemUpdate=T;var C;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(C=e.DetailType||(e.DetailType={}));var S;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(u){}update(u){}remove(u,m){}complete(){}}e.IncrementalChangeCollector=P;class i{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(u){const m=this.createChangeCollector();for(const l of u)switch(l[0]){case 0:{const v=l[1];if(v.parent){if(this.items.has(v.parent)){const _=this.items.get(v.parent);_.children.add(v.item.extId);const b=this.createItem(v,_);this.items.set(v.item.extId,b),m.add(b)}}else{const _=this.createItem(v);this.roots.add(_),this.items.set(v.item.extId,_),m.add(_)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=l[1],_=this.items.get(v.extId);if(!_)break;v.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,v),m.update(_);break}case 2:{const v=this.items.get(l[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const _=[[l[1]]];for(;_.length;)for(const b of _.pop()){const A=this.items.get(b);A&&(_.push(A.children),this.items.delete(b),m.remove(A,A!==v),A.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(l[1]);break;case 3:this.updatePendingRoots(l[1]);break}m.complete()}retireTest(u){}updatePendingRoots(u){this.pendingRootCount+=u}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=i}),define(me[90],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(y){y.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(y){y[y.IsSame=0]="IsSame",y[y.Disconnected=1]="Disconnected",y[y.IsChild=2]="IsChild",y[y.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class k{constructor(T,C=T.length){if(this.path=T,this.viewEnd=C,T.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,C,S=T.parent){if(T.id===C)return new k([C]);let P=[T.id];for(let i=S;i&&i.id!==C;i=i.parent)P.push(i.id);return P.push(C),new k(P.reverse())}static fromString(T){return new k(T.split("\0"))}static join(T,C){return new k([...T.path,C])}static joinToString(T,C){return T.toString()+"\0"+C}static compare(T,C){return T===C?0:C.startsWith(T+"\0")?2:T.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new k(this.path,T)}compare(T){if(typeof T=="string")return k.compare(this.toString(),T);for(let C=0;C<T.viewEnd&&C<this.viewEnd;C++)if(T.path[C]!==this.path[C])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=k}),define(me[214],ge([0,1,9,38,14,25,11,77,177]),function(J,e,g,L,k,y,T,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(I,u,m){this._contributedVariables=new Map,this._context=I,this._labelService=u,m&&(this._envVariablesPromise=m.then(l=>this.prepareEnv(l)))}prepareEnv(I){if(T.isWindows){const u=Object.create(null);return Object.keys(I).forEach(m=>{u[m.toLowerCase()]=I[m]}),u}return I}resolveWithEnvironment(I,u,m){return this.recursiveResolve(this.prepareEnv(I),u?u.uri:void 0,m)}async resolveAsync(I,u){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,u)}async resolveAnyBase(I,u,m,l){const v=y.deepClone(u);return T.isWindows&&v.windows?Object.keys(v.windows).forEach(_=>v[_]=v.windows[_]):T.isMacintosh&&v.osx?Object.keys(v.osx).forEach(_=>v[_]=v.osx[_]):T.isLinux&&v.linux&&Object.keys(v.linux).forEach(_=>v[_]=v.linux[_]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,v,m,l)}async resolveAnyAsync(I,u,m){return this.resolveAnyBase(I,u,m)}async resolveAnyMap(I,u,m){const l=new Map;return{newConfig:await this.resolveAnyBase(I,u,m,l),resolvedVariables:l}}resolveWithInteractionReplace(I,u,m,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,u,m,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,u){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,u)}recursiveResolve(I,u,m,l,v){if(k.isString(m))return this.resolveString(I,u,m,l,v);if(k.isArray(m))return m.map(_=>this.recursiveResolve(I,u,_,l,v));if(k.isObject(m)){let _=Object.create(null);return Object.keys(m).forEach(b=>{const A=this.resolveString(I,u,b,l,v);_[A]=this.recursiveResolve(I,u,m[b],l,v)}),_}return m}resolveString(I,u,m,l,v){return m.replace(P.VARIABLE_REGEXP,(b,A)=>{if(A.includes(P.VARIABLE_LHS))return b;let c=this.evaluateSingleVariable(I,b,A,u,l);return v&&v.set(A,c),c!==b&&k.isString(c)&&c.match(P.VARIABLE_REGEXP)&&(c=this.resolveString(I,u,c,l,v)),c})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,u,m,l,v){let _;const b=m.split(":");b.length>1&&(m=b[0],_=b[1]);const A=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,S.localize)(0,null,u))},c=()=>{const p=A();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,S.localize)(1,null,u,g.basename(p)))},h=()=>{if(_){const p=this._context.getFolderUri(_);if(p)return p;throw new Error((0,S.localize)(2,null,u,_))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,u)):new Error((0,S.localize)(4,null,u))};switch(m){case"env":if(_){if(I){const p=I[T.isWindows?_.toLowerCase():_];if(k.isString(p))return p}return""}throw new Error((0,S.localize)(5,null,u));case"config":if(_){const p=this._context.getConfigurationValue(l,_);if(k.isUndefinedOrNull(p))throw new Error((0,S.localize)(6,null,u,_));if(k.isObject(p))throw new Error((0,S.localize)(7,null,u,_));return p}throw new Error((0,S.localize)(8,null,u));case"command":return this.resolveFromMap(u,_,v,"command");case"input":return this.resolveFromMap(u,_,v,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return l||_?(0,C.normalizeDriveLetter)(this.fsPath(h())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(h()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error((0,S.localize)(9,null,u));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,S.localize)(10,null,u));case"file":return A();case"fileWorkspaceFolder":return c();case"relativeFile":return l||_?g.relative(this.fsPath(h()),A()):A();case"relativeFileDirname":const r=g.dirname(A());if(l||_){const f=g.relative(this.fsPath(h()),r);return f.length===0?".":f}return r;case"fileDirname":return g.dirname(A());case"fileExtname":return g.extname(A());case"fileBasename":return g.basename(A());case"fileBasenameNoExtension":const o=g.basename(A());return o.slice(0,o.length-g.extname(o).length);case"fileDirnameBasename":return g.basename(g.dirname(A()));case"execPath":const n=this._context.getExecPath();return n||u;case"execInstallFolder":const a=this._context.getAppRoot();return a||u;case"pathSeparator":return g.sep;default:try{const f=_?`${m}:${_}`:m;return this.resolveFromMap(u,f,v,void 0)}catch(f){return u}}}}resolveFromMap(I,u,m,l){if(u&&m){const v=l===void 0?m[u]:m[l+":"+u];if(typeof v=="string")return v;throw new Error((0,S.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[127],ge([0,1,4,207]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var k;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var y;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(y=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var C;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function P(v){const _=v;return(0,L.isEditorInput)(_?.editor)&&(0,L.isEditorInput)(_?.replacement)}e.isEditorReplacement=P;var i;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.EDITOR_OPEN=2]="EDITOR_OPEN",v[v.EDITOR_CLOSE=3]="EDITOR_CLOSE",v[v.EDITOR_MOVE=4]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=6]="EDITOR_LABEL",v[v.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",v[v.EDITOR_PIN=8]="EDITOR_PIN",v[v.EDITOR_STICKY=9]="EDITOR_STICKY",v[v.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var u;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(u=e.OpenEditorContext||(e.OpenEditorContext={}));function m(v){const _=v;return!!_&&typeof _.id=="number"&&Array.isArray(_.editors)}e.isEditorGroup=m;function l(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=l}),define(me[215],ge([0,1,4,127]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(y){const T=y;return typeof y=="number"||(0,L.isEditorGroup)(T)}e.isPreferredGroup=k}),define(me[15],ge([0,1,20,99,290,59,25,14,2,41,81,178,117,87,89,90,215,7]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var A;(function(Se){function Pe(Q){const{selectionStartLineNumber:Oe,selectionStartColumn:Fe,positionLineNumber:tt,positionColumn:Ke}=Q,ut=new b.Position(Oe-1,Fe-1),St=new b.Position(tt-1,Ke-1);return new b.Selection(ut,St)}Se.to=Pe;function te(Q){const{anchor:Oe,active:Fe}=Q;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}Se.from=te})(A=e.Selection||(e.Selection={}));var c;(function(Se){function Pe(Q){if(!Q)return;const{start:Oe,end:Fe}=Q;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}Se.from=Pe;function te(Q){if(!Q)return;const{startLineNumber:Oe,startColumn:Fe,endLineNumber:tt,endColumn:Ke}=Q;return new b.Range(Oe-1,Fe-1,tt-1,Ke-1)}Se.to=te})(c=e.Range||(e.Range={}));var h;(function(Se){function Pe(te){switch(te){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}Se.to=Pe})(h=e.TokenType||(e.TokenType={}));var p;(function(Se){function Pe(Q){return new b.Position(Q.lineNumber-1,Q.column-1)}Se.to=Pe;function te(Q){return{lineNumber:Q.line+1,column:Q.character+1}}Se.from=te})(p=e.Position||(e.Position={}));var t;(function(Se){function Pe(Q){switch(Q){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}Se.from=Pe;function te(Q){switch(Q){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}Se.to=te})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(Se){function Pe(Q){let Oe;return Q.code&&((0,C.isString)(Q.code)||(0,C.isNumber)(Q.code)?Oe=String(Q.code):Oe={value:String(Q.code.value),target:Q.code.target}),{...c.from(Q.range),message:Q.message,source:Q.source,code:Oe,severity:n.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(o.from),tags:Array.isArray(Q.tags)?(0,g.coalesce)(Q.tags.map(t.from)):void 0}}Se.from=Pe;function te(Q){const Oe=new b.Diagnostic(c.to(Q),Q.message,n.to(Q.severity));return Oe.source=Q.source,Oe.code=(0,C.isString)(Q.code)?Q.code:Q.code?.value,Oe.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(o.to),Oe.tags=Q.tags&&(0,g.coalesce)(Q.tags.map(t.to)),Oe}Se.to=te})(r=e.Diagnostic||(e.Diagnostic={}));var o;(function(Se){function Pe(Q){return{...c.from(Q.location.range),message:Q.message,resource:Q.location.uri}}Se.from=Pe;function te(Q){return new b.DiagnosticRelatedInformation(new b.Location(Q.resource,c.to(Q)),Q.message)}Se.to=te})(o=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(Se){function Pe(Q){switch(Q){case b.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}Se.from=Pe;function te(Q){switch(Q){case u.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}Se.to=te})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var a;(function(Se){function Pe(Q){return typeof Q=="number"&&Q>=b.ViewColumn.One?Q-1:Q===b.ViewColumn.Beside?_.SIDE_GROUP:_.ACTIVE_GROUP}Se.from=Pe;function te(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=te})(a=e.ViewColumn||(e.ViewColumn={}));function f(Se){return typeof Se.range!="undefined"}function d(Se){return Se.length===0?!0:!!f(Se[0])}e.isDecorationOptionsArr=d;var w;(function(Se){function Pe(Ke){return Ke.map(Se.from)}Se.fromMany=Pe;function te(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Q(Ke){let ut;if(te(Ke)){const{language:ft,value:dt}=Ke;ut={value:"```"+ft+`
`+dt+"\n```\n"}}else b.MarkdownString.isMarkdownString(Ke)?ut={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons}:typeof Ke=="string"?ut={value:Ke}:ut={value:""};const St=Object.create(null);ut.uris=St;const kt=ft=>{try{let dt=S.URI.parse(ft,!0);dt=dt.with({query:Oe(dt.query,St)}),St[ft]=dt}catch(dt){}return""},Dt=new k.Renderer;return Dt.link=kt,Dt.image=ft=>kt(L.parseHrefAndDimensions(ft).href),k(ut.value,{renderer:Dt}),ut}Se.from=Q;function Oe(Ke,ut){if(!Ke)return Ke;let St;try{St=(0,y.parse)(Ke)}catch(Dt){}if(!St)return Ke;let kt=!1;return St=(0,T.cloneAndChange)(St,Dt=>{if(S.URI.isUri(Dt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ft]=Dt,kt=!0,ft}else return}),kt?JSON.stringify(St):Ke}function Fe(Ke){const ut=new b.MarkdownString(Ke.value,Ke.supportThemeIcons);return ut.isTrusted=Ke.isTrusted,ut}Se.to=Fe;function tt(Ke){if(!!Ke)return typeof Ke=="string"?Ke:Se.from(Ke)}Se.fromStrict=tt})(w=e.MarkdownString||(e.MarkdownString={}));function E(Se){return d(Se)?Se.map(Pe=>({range:c.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?w.fromMany(Pe.hoverMessage):Pe.hoverMessage?w.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):Se.map(Pe=>({range:c.from(Pe)}))}e.fromRangeOrRangeWithMessage=E;function s(Se){return typeof Se=="undefined"?Se:typeof Se=="string"?S.URI.file(Se):Se}e.pathOrURIToURI=s;var D;(function(Se){function Pe(te){return typeof te=="undefined"?te:{contentText:te.contentText,contentIconPath:te.contentIconPath?s(te.contentIconPath):void 0,border:te.border,borderColor:te.borderColor,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,color:te.color,backgroundColor:te.backgroundColor,margin:te.margin,width:te.width,height:te.height}}Se.from=Pe})(D=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var R;(function(Se){function Pe(te){return typeof te=="undefined"?te:{backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?s(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?D.from(te.before):void 0,after:te.after?D.from(te.after):void 0}}Se.from=Pe})(R=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var U;(function(Se){function Pe(te){if(typeof te=="undefined")return te;switch(te){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Pe})(U=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var V;(function(Se){function Pe(te){return{isWholeLine:te.isWholeLine,rangeBehavior:te.rangeBehavior?U.from(te.rangeBehavior):void 0,overviewRulerLane:te.overviewRulerLane,light:te.light?R.from(te.light):void 0,dark:te.dark?R.from(te.dark):void 0,backgroundColor:te.backgroundColor,outline:te.outline,outlineColor:te.outlineColor,outlineStyle:te.outlineStyle,outlineWidth:te.outlineWidth,border:te.border,borderColor:te.borderColor,borderRadius:te.borderRadius,borderSpacing:te.borderSpacing,borderStyle:te.borderStyle,borderWidth:te.borderWidth,fontStyle:te.fontStyle,fontWeight:te.fontWeight,textDecoration:te.textDecoration,cursor:te.cursor,color:te.color,opacity:te.opacity,letterSpacing:te.letterSpacing,gutterIconPath:te.gutterIconPath?s(te.gutterIconPath):void 0,gutterIconSize:te.gutterIconSize,overviewRulerColor:te.overviewRulerColor,before:te.before?D.from(te.before):void 0,after:te.after?D.from(te.after):void 0}}Se.from=Pe})(V=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ee;(function(Se){function Pe(Q){return{text:Q.newText,eol:Q.newEol&&fe.from(Q.newEol),range:c.from(Q.range)}}Se.from=Pe;function te(Q){const Oe=new b.TextEdit(c.to(Q.range),Q.text);return Oe.newEol=typeof Q.eol=="undefined"?void 0:fe.to(Q.eol),Oe}Se.to=te})(ee=e.TextEdit||(e.TextEdit={}));var K;(function(Se){function Pe(Q,Oe,Fe){const tt={edits:[]};if(Q instanceof b.WorkspaceEdit)for(let Ke of Q._allEntries())if(Ke._type===1)tt.edits.push({_type:1,oldUri:Ke.from,newUri:Ke.to,options:Ke.options,metadata:Ke.metadata});else if(Ke._type===2){const ut=Oe?.getDocument(Ke.uri);tt.edits.push({_type:2,resource:Ke.uri,edit:ee.from(Ke.edit),modelVersionId:ut?.version,metadata:Ke.metadata})}else Ke._type===3?tt.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,edit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Fe?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version}):Ke._type===5&&tt.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Fe?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(j.from)}});return tt}Se.from=Pe;function te(Q){const Oe=new b.WorkspaceEdit;for(const Fe of Q.edits)Fe.edit?Oe.replace(S.URI.revive(Fe.resource),c.to(Fe.edit.range),Fe.edit.text):Oe.renameFile(S.URI.revive(Fe.oldUri),S.URI.revive(Fe.newUri),Fe.options);return Oe}Se.to=te})(K=e.WorkspaceEdit||(e.WorkspaceEdit={}));var O;(function(Se){const Pe=Object.create(null);Pe[b.SymbolKind.File]=0,Pe[b.SymbolKind.Module]=1,Pe[b.SymbolKind.Namespace]=2,Pe[b.SymbolKind.Package]=3,Pe[b.SymbolKind.Class]=4,Pe[b.SymbolKind.Method]=5,Pe[b.SymbolKind.Property]=6,Pe[b.SymbolKind.Field]=7,Pe[b.SymbolKind.Constructor]=8,Pe[b.SymbolKind.Enum]=9,Pe[b.SymbolKind.Interface]=10,Pe[b.SymbolKind.Function]=11,Pe[b.SymbolKind.Variable]=12,Pe[b.SymbolKind.Constant]=13,Pe[b.SymbolKind.String]=14,Pe[b.SymbolKind.Number]=15,Pe[b.SymbolKind.Boolean]=16,Pe[b.SymbolKind.Array]=17,Pe[b.SymbolKind.Object]=18,Pe[b.SymbolKind.Key]=19,Pe[b.SymbolKind.Null]=20,Pe[b.SymbolKind.EnumMember]=21,Pe[b.SymbolKind.Struct]=22,Pe[b.SymbolKind.Event]=23,Pe[b.SymbolKind.Operator]=24,Pe[b.SymbolKind.TypeParameter]=25;function te(Oe){return typeof Pe[Oe]=="number"?Pe[Oe]:6}Se.from=te;function Q(Oe){for(const Fe in Pe)if(Pe[Fe]===Oe)return Number(Fe);return b.SymbolKind.Property}Se.to=Q})(O=e.SymbolKind||(e.SymbolKind={}));var x;(function(Se){function Pe(Q){switch(Q){case b.SymbolTag.Deprecated:return 1}}Se.from=Pe;function te(Q){switch(Q){case 1:return b.SymbolTag.Deprecated}}Se.to=te})(x=e.SymbolTag||(e.SymbolTag={}));var F;(function(Se){function Pe(Q){return{name:Q.name,kind:O.from(Q.kind),tags:Q.tags&&Q.tags.map(x.from),containerName:Q.containerName,location:B.from(Q.location)}}Se.from=Pe;function te(Q){const Oe=new b.SymbolInformation(Q.name,O.to(Q.kind),Q.containerName,B.to(Q.location));return Oe.tags=Q.tags&&Q.tags.map(x.to),Oe}Se.to=te})(F=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var z;(function(Se){function Pe(Q){const Oe={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:c.from(Q.range),selectionRange:c.from(Q.selectionRange),kind:O.from(Q.kind),tags:Q.tags?.map(x.from)??[]};return Q.children&&(Oe.children=Q.children.map(Pe)),Oe}Se.from=Pe;function te(Q){const Oe=new b.DocumentSymbol(Q.name,Q.detail,O.to(Q.kind),c.to(Q.range),c.to(Q.selectionRange));return(0,g.isNonEmptyArray)(Q.tags)&&(Oe.tags=Q.tags.map(x.to)),Q.children&&(Oe.children=Q.children.map(te)),Oe}Se.to=te})(z=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(Se){function Pe(Q){const Oe=new b.CallHierarchyItem(O.to(Q.kind),Q.name,Q.detail||"",S.URI.revive(Q.uri),c.to(Q.range),c.to(Q.selectionRange));return Oe._sessionId=Q._sessionId,Oe._itemId=Q._itemId,Oe}Se.to=Pe;function te(Q,Oe,Fe){if(Oe=Oe??Q._sessionId,Fe=Fe??Q._itemId,Oe===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Fe,name:Q.name,detail:Q.detail,kind:O.from(Q.kind),uri:Q.uri,range:c.from(Q.range),selectionRange:c.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}Se.from=te})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(Se){function Pe(te){return new b.CallHierarchyIncomingCall(M.to(te.from),te.fromRanges.map(Q=>c.to(Q)))}Se.to=Pe})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var q;(function(Se){function Pe(te){return new b.CallHierarchyOutgoingCall(M.to(te.to),te.fromRanges.map(Q=>c.to(Q)))}Se.to=Pe})(q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var B;(function(Se){function Pe(Q){return{range:Q.range&&c.from(Q.range),uri:Q.uri}}Se.from=Pe;function te(Q){return new b.Location(S.URI.revive(Q.uri),c.to(Q.range))}Se.to=te})(B=e.location||(e.location={}));var G;(function(Se){function Pe(Q){const Oe=Q,Fe=Q;return{originSelectionRange:Oe.originSelectionRange?c.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Fe.uri,range:c.from(Oe.targetRange?Oe.targetRange:Fe.range),targetSelectionRange:Oe.targetSelectionRange?c.from(Oe.targetSelectionRange):void 0}}Se.from=Pe;function te(Q){return{targetUri:S.URI.revive(Q.uri),targetRange:c.to(Q.range),targetSelectionRange:Q.targetSelectionRange?c.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?c.to(Q.originSelectionRange):void 0}}Se.to=te})(G=e.DefinitionLink||(e.DefinitionLink={}));var re;(function(Se){function Pe(Q){return{range:c.from(Q.range),contents:w.fromMany(Q.contents)}}Se.from=Pe;function te(Q){return new b.Hover(Q.contents.map(w.to),c.to(Q.range))}Se.to=te})(re=e.Hover||(e.Hover={}));var he;(function(Se){function Pe(Q){return{range:c.from(Q.range),expression:Q.expression}}Se.from=Pe;function te(Q){return new b.EvaluatableExpression(c.to(Q.range),Q.expression)}Se.to=te})(he=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(Se){function Pe(Q){if(Q instanceof b.InlineValueText)return{type:"text",range:c.from(Q.range),text:Q.text};if(Q instanceof b.InlineValueVariableLookup)return{type:"variable",range:c.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Pe;function te(Q){switch(Q.type){case"text":return{range:c.to(Q.range),text:Q.text};case"variable":return{range:c.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:c.to(Q.range),expression:Q.expression}}}Se.to=te})(ye=e.InlineValue||(e.InlineValue={}));var Ie;(function(Se){function Pe(Q){return{frameId:Q.frameId,stoppedLocation:c.from(Q.stoppedLocation)}}Se.from=Pe;function te(Q){return new b.InlineValueContext(Q.frameId,c.to(Q.stoppedLocation))}Se.to=te})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var Le;(function(Se){function Pe(Q){return{range:c.from(Q.range),kind:Q.kind}}Se.from=Pe;function te(Q){return new b.DocumentHighlight(c.to(Q.range),Q.kind)}Se.to=te})(Le=e.DocumentHighlight||(e.DocumentHighlight={}));var qe;(function(Se){function Pe(te){switch(te){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}Se.to=Pe})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var We;(function(Se){function Pe(te){return{triggerKind:qe.to(te.triggerKind),triggerCharacter:te.triggerCharacter}}Se.to=Pe})(We=e.CompletionContext||(e.CompletionContext={}));var je;(function(Se){function Pe(Q){switch(Q){case b.CompletionItemTag.Deprecated:return 1}}Se.from=Pe;function te(Q){switch(Q){case 1:return b.CompletionItemTag.Deprecated}}Se.to=te})(je=e.CompletionItemTag||(e.CompletionItemTag={}));var W;(function(Se){const Pe=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function te(Fe){return Pe.get(Fe)??9}Se.from=te;const Q=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Oe(Fe){return Q.get(Fe)??b.CompletionItemKind.Property}Se.to=Oe})(W=e.CompletionItemKind||(e.CompletionItemKind={}));var Z;(function(Se){function Pe(te,Q){const Oe=new b.CompletionItem(te.label);return Oe.insertText=te.insertText,Oe.kind=W.to(te.kind),Oe.tags=te.tags?.map(je.to),Oe.detail=te.detail,Oe.documentation=L.isMarkdownString(te.documentation)?w.to(te.documentation):te.documentation,Oe.sortText=te.sortText,Oe.filterText=te.filterText,Oe.preselect=te.preselect,Oe.commitCharacters=te.commitCharacters,P.Range.isIRange(te.range)?Oe.range=c.to(te.range):typeof te.range=="object"&&(Oe.range={inserting:c.to(te.range.insert),replacing:c.to(te.range.replace)}),Oe.keepWhitespace=typeof te.insertTextRules=="undefined"?!1:Boolean(te.insertTextRules&1),typeof te.insertTextRules!="undefined"&&te.insertTextRules&4?Oe.insertText=new b.SnippetString(te.insertText):(Oe.insertText=te.insertText,Oe.textEdit=Oe.range instanceof b.Range?new b.TextEdit(Oe.range,Oe.insertText):void 0),te.additionalTextEdits&&te.additionalTextEdits.length>0&&(Oe.additionalTextEdits=te.additionalTextEdits.map(Fe=>ee.to(Fe))),Oe.command=Q&&te.command?Q.fromInternal(te.command):void 0,Oe}Se.to=Pe})(Z=e.CompletionItem||(e.CompletionItem={}));var ne;(function(Se){function Pe(Q){return{label:Q.label,documentation:Q.documentation?w.fromStrict(Q.documentation):void 0}}Se.from=Pe;function te(Q){return{label:Q.label,documentation:L.isMarkdownString(Q.documentation)?w.to(Q.documentation):Q.documentation}}Se.to=te})(ne=e.ParameterInformation||(e.ParameterInformation={}));var le;(function(Se){function Pe(Q){return{label:Q.label,documentation:Q.documentation?w.fromStrict(Q.documentation):void 0,parameters:Array.isArray(Q.parameters)?Q.parameters.map(ne.from):[],activeParameter:Q.activeParameter}}Se.from=Pe;function te(Q){return{label:Q.label,documentation:L.isMarkdownString(Q.documentation)?w.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(ne.to):[],activeParameter:Q.activeParameter}}Se.to=te})(le=e.SignatureInformation||(e.SignatureInformation={}));var Y;(function(Se){function Pe(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(le.from):[]}}Se.from=Pe;function te(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(le.to):[]}}Se.to=te})(Y=e.SignatureHelp||(e.SignatureHelp={}));var ae;(function(Se){function Pe(Q){return{text:Q.text,position:p.from(Q.position),kind:ve.from(Q.kind??b.InlayHintKind.Other),whitespaceBefore:Q.whitespaceBefore,whitespaceAfter:Q.whitespaceAfter}}Se.from=Pe;function te(Q){const Oe=new b.InlayHint(Q.text,p.to(Q.position),ve.to(Q.kind));return Oe.whitespaceAfter=Q.whitespaceAfter,Oe.whitespaceBefore=Q.whitespaceBefore,Oe}Se.to=te})(ae=e.InlayHint||(e.InlayHint={}));var ve;(function(Se){function Pe(Q){return Q}Se.from=Pe;function te(Q){return Q}Se.to=te})(ve=e.InlayHintKind||(e.InlayHintKind={}));var Me;(function(Se){function Pe(Q){return{range:c.from(Q.range),url:Q.target,tooltip:Q.tooltip}}Se.from=Pe;function te(Q){let Oe;if(Q.url)try{Oe=typeof Q.url=="string"?S.URI.parse(Q.url,!0):S.URI.revive(Q.url)}catch(Fe){}return new b.DocumentLink(c.to(Q.range),Oe)}Se.to=te})(Me=e.DocumentLink||(e.DocumentLink={}));var ze;(function(Se){function Pe(Q){const Oe=new b.ColorPresentation(Q.label);return Q.textEdit&&(Oe.textEdit=ee.to(Q.textEdit)),Q.additionalTextEdits&&(Oe.additionalTextEdits=Q.additionalTextEdits.map(Fe=>ee.to(Fe))),Oe}Se.to=Pe;function te(Q){return{label:Q.label,textEdit:Q.textEdit?ee.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Oe=>ee.from(Oe)):void 0}}Se.from=te})(ze=e.ColorPresentation||(e.ColorPresentation={}));var Ee;(function(Se){function Pe(Q){return new b.Color(Q[0],Q[1],Q[2],Q[3])}Se.to=Pe;function te(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}Se.from=te})(Ee=e.Color||(e.Color={}));var Je;(function(Se){function Pe(Q){return{range:c.from(Q.range)}}Se.from=Pe;function te(Q){return new b.SelectionRange(c.to(Q.range))}Se.to=te})(Je=e.SelectionRange||(e.SelectionRange={}));var X;(function(Se){function Pe(te){switch(te){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}Se.to=Pe})(X=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var se;(function(Se){function Pe(Q){switch(Q){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Pe;function te(Q){switch(Q){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}Se.to=te})(se=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var fe;(function(Se){function Pe(Q){if(Q===b.EndOfLine.CRLF)return 1;if(Q===b.EndOfLine.LF)return 0}Se.from=Pe;function te(Q){if(Q===1)return b.EndOfLine.CRLF;if(Q===0)return b.EndOfLine.LF}Se.to=te})(fe=e.EndOfLine||(e.EndOfLine={}));var xe;(function(Se){function Pe(te){if(typeof te=="object")return te.viewId;switch(te){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Pe})(xe=e.ProgressLocation||(e.ProgressLocation={}));var Be;(function(Se){function Pe(te){const Q={start:te.start+1,end:te.end+1};return te.kind&&(Q.kind=et.from(te.kind)),Q}Se.from=Pe})(Be=e.FoldingRange||(e.FoldingRange={}));var et;(function(Se){function Pe(te){if(te)switch(te){case b.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}Se.from=Pe})(et=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ce;(function(Se){function Pe(te){if(te)return{pinned:typeof te.preview=="boolean"?!te.preview:void 0,inactive:te.background,preserveFocus:te.preserveFocus,selection:typeof te.selection=="object"?c.from(te.selection):void 0,override:typeof te.override=="boolean"?I.EditorResolution.DISABLED:void 0}}Se.from=Pe})(Ce=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var De;(function(Se){function Pe(Q){return Q instanceof b.RelativePattern||typeof Q=="string"?Q:te(Q)?new b.RelativePattern(Q.base,Q.pattern):Q}Se.from=Pe;function te(Q){const Oe=Q;return Oe&&typeof Oe.base=="string"&&typeof Oe.pattern=="string"}})(De=e.GlobPattern||(e.GlobPattern={}));var Te;(function(Se){function Pe(te){if(te){if(Array.isArray(te))return te.map(Pe);if(typeof te=="string")return te;{const Q=te;return{language:Q.language,scheme:Q.scheme,pattern:typeof Q.pattern=="undefined"?void 0:De.from(Q.pattern),exclusive:Q.exclusive}}}else return}Se.from=Pe})(Te=e.LanguageSelector||(e.LanguageSelector={}));var ce;(function(Se){function Pe(Q){return{start:Q.start,end:Q.end}}Se.from=Pe;function te(Q){return new b.NotebookRange(Q.start,Q.end)}Se.to=te})(ce=e.NotebookRange||(e.NotebookRange={}));var ue;(function(Se){function Pe(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}Se.to=Pe;function te(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}Se.from=te})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var pe;(function(Se){function Pe(Q){switch(Q){case b.NotebookCellKind.Markup:return l.CellKind.Markup;case b.NotebookCellKind.Code:default:return l.CellKind.Code}}Se.from=Pe;function te(Q){switch(Q){case l.CellKind.Markup:return b.NotebookCellKind.Markup;case l.CellKind.Code:default:return b.NotebookCellKind.Code}}Se.to=te})(pe=e.NotebookCellKind||(e.NotebookCellKind={}));var be;(function(Se){function Pe(Q){const Oe={metadata:Q.metadata??Object.create(null),cells:[]};for(let Fe of Q.cells)b.NotebookCellData.validate(Fe),Oe.cells.push(j.from(Fe));return Oe}Se.from=Pe;function te(Q){const Oe=new b.NotebookData(Q.cells.map(j.to));return(0,C.isEmptyObject)(Q.metadata)||(Oe.metadata=Q.metadata),Oe}Se.to=te})(be=e.NotebookData||(e.NotebookData={}));var j;(function(Se){function Pe(Q){return{cellKind:pe.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:ue.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(_e.from):[]}}Se.from=Pe;function te(Q){return new b.NotebookCellData(pe.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(_e.to):void 0,Q.metadata,Q.internalMetadata?ue.to(Q.internalMetadata):void 0)}Se.to=te})(j=e.NotebookCellData||(e.NotebookCellData={}));var we;(function(Se){function Pe(Q){return{mime:Q.mime,valueBytes:Array.from(Q.data)}}Se.from=Pe;function te(Q){return new b.NotebookCellOutputItem(new Uint8Array(Q.valueBytes),Q.mime)}Se.to=te})(we=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var _e;(function(Se){function Pe(Q){return{outputId:Q.id,items:Q.items.map(we.from),metadata:Q.metadata}}Se.from=Pe;function te(Q){const Oe=Q.items.map(we.to);return new b.NotebookCellOutput(Oe,Q.outputId,Q.metadata)}Se.to=te})(_e=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ae;(function(Se){function Pe(Fe){if(Fe!=null){if(Fe instanceof b.RelativePattern||typeof Fe=="string")return Fe;if(Oe(Fe))return new b.RelativePattern(Fe.base,Fe.pattern);if(Q(Fe))return{include:De.from(Fe.include)||void 0,exclude:De.from(Fe.exclude)||void 0}}}Se.from=Pe;function te(Fe){return typeof Fe=="string"?Fe:Oe(Fe)?{base:Fe.base,pattern:Fe.pattern}:{include:Fe.include,exclude:Fe.exclude}}Se.to=te;function Q(Fe){const tt=Fe,Ke=De.from(tt.include);if(!(Ke&&Ke instanceof b.RelativePattern||typeof Ke=="string"))return!1;const ut=De.from(tt.exclude);return!!(ut&&ut instanceof b.RelativePattern||typeof ut=="string")}function Oe(Fe){const tt=Fe;return tt&&typeof tt.base=="string"&&typeof tt.pattern=="string"}})(Ae=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ue;(function(Se){function Pe(te){return{backgroundColor:te.backgroundColor,borderColor:te.borderColor,top:te.top?D.from(te.top):void 0}}Se.from=Pe})(Ue=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ge;(function(Se){function Pe(te,Q,Oe){const Fe=typeof te.command=="string"?{title:"",command:te.command}:te.command;return{alignment:te.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Fe,Oe),text:te.text,tooltip:te.tooltip,accessibilityInformation:te.accessibilityInformation,priority:te.priority}}Se.from=Pe})(Ge=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ze;(function(Se){function Pe(te){return{transientOutputs:te?.transientOutputs??!1,transientCellMetadata:te?.transientCellMetadata??{},transientDocumentMetadata:te?.transientDocumentMetadata??{}}}Se.from=Pe})(Ze=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Qe;(function(Se){function Pe(Q){return{uri:Q.uri,provides:Q.provides}}Se.from=Pe;function te(Q){return new b.NotebookRendererScript(S.URI.revive(Q.uri),Q.provides)}Se.to=te})(Qe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Xe;(function(Se){function Pe(Q){return{message:w.fromStrict(Q.message)||"",severity:b.TestMessageSeverity.Error,expectedOutput:Q.expectedOutput,actualOutput:Q.actualOutput,location:Q.location?B.from(Q.location):void 0}}Se.from=Pe;function te(Q){const Oe=new b.TestMessage(typeof Q.message=="string"?Q.message:w.to(Q.message));return Oe.actualOutput=Q.actualOutput,Oe.expectedOutput=Q.expectedOutput,Oe}Se.to=te})(Xe=e.TestMessage||(e.TestMessage={}));var ct;(function(Se){function Pe(Fe){return{extId:v.TestId.fromExtHostTestItem(Fe,(0,m.getPrivateApiFor)(Fe).controllerId).toString(),label:Fe.label,uri:Fe.uri,range:c.from(Fe.range)||null,description:Fe.description||null,error:Fe.error&&w.fromStrict(Fe.error)||null}}Se.from=Pe;function te(Fe){return{id:v.TestId.fromString(Fe.extId).localId,label:Fe.label,uri:S.URI.revive(Fe.uri),range:c.to(Fe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Fe.description||void 0}}Se.toPlain=te;function Q(Fe){const tt=v.TestId.fromString(Fe.extId),Ke=new m.TestItemImpl(tt.controllerId,tt.localId,Fe.label,S.URI.revive(Fe.uri));return Ke.range=c.to(Fe.range||void 0),Ke.description=Fe.description||void 0,Ke}function Oe(Fe){let tt;for(const Ke of Fe.tests){const ut=Q(Ke.item);(0,m.getPrivateApiFor)(ut).parent=tt,tt=ut}return tt}Se.toItemFromContext=Oe})(ct=e.TestItem||(e.TestItem={}));var mt;(function(Se){const Pe=(Q,Oe)=>{const Fe={...ct.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(tt=>({state:tt.state,duration:tt.duration,messages:tt.messages.map(Xe.to)})),children:Q.children.map(tt=>Oe.get(tt)).filter(C.isDefined).map(tt=>Pe(tt,Oe))};for(const tt of Fe.children)tt.parent=Fe;return Fe};function te(Q){const Oe=[],Fe=new Map;for(const tt of Q.items)Fe.set(tt.item.extId,tt),Q.request.targets.some(Ke=>Ke.controllerId===tt.controllerId&&Ke.testIds.includes(tt.item.extId))&&Oe.push(tt);return{completedAt:Q.completedAt,results:Oe.map(tt=>Pe(tt,Fe))}}Se.to=te})(mt=e.TestResults||(e.TestResults={}));var bt;(function(Se){function Pe(Fe){return{covered:Fe.covered,total:Fe.covered}}function te(Fe){return"line"in Fe?p.from(Fe):c.from(Fe)}function Q(Fe){return"branches"in Fe?{count:Fe.executionCount,location:te(Fe.location),type:1,branches:Fe.branches.length?Fe.branches.map(tt=>({count:tt.executionCount,location:tt.location&&te(tt.location)})):void 0}:{type:0,count:Fe.executionCount,location:te(Fe.location)}}Se.fromDetailed=Q;function Oe(Fe){return{uri:Fe.uri,statement:Pe(Fe.statementCoverage),branch:Fe.branchCoverage&&Pe(Fe.branchCoverage),function:Fe.functionCoverage&&Pe(Fe.functionCoverage),details:Fe.detailedCoverage?.map(Q)}}Se.fromFile=Oe})(bt=e.TestCoverage||(e.TestCoverage={}));var ot;(function(Se){function Pe(te){switch(te){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}Se.to=Pe})(ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var at;(function(Se){function Pe(Q){const Oe=new b.TypeHierarchyItem(O.to(Q.kind),Q.name,Q.detail||"",S.URI.revive(Q.uri),c.to(Q.range),c.to(Q.selectionRange));return Oe._sessionId=Q._sessionId,Oe._itemId=Q._itemId,Oe}Se.to=Pe;function te(Q,Oe,Fe){if(Oe=Oe??Q._sessionId,Fe=Fe??Q._itemId,Oe===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Fe,kind:O.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:c.from(Q.range),selectionRange:c.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}Se.from=te})(at=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[216],ge([0,1,2,16,7,15,95]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(P,i,I,u={timeout:1500,errors:3}){this._logService=P,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=u,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(i,I,u)=>{const l={dispose:this._callbacks.push([i,I,P])};return Array.isArray(u)&&u.push(l),l}}async $participateInSave(P,i){const I=g.URI.revive(P);let u=!1;const m=setTimeout(()=>u=!0,this._thresholds.timeout),l=[];try{for(let v of[...this._callbacks]){if(u)break;const _=this._documents.getDocument(I),b=await this._deliverEventAsyncAndBlameBadListeners(v,{document:_,reason:y.TextDocumentSaveReason.to(i)});l.push(b)}}finally{clearTimeout(m)}return l}_deliverEventAsyncAndBlameBadListeners([P,i,I],u){const m=this._badListeners.get(P);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,P,i,u).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const v=this._badListeners.get(P);this._badListeners.set(P,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,i,I,u){const m=[],l=Date.now(),{document:v,reason:_}=u,{version:b}=v,A=Object.freeze({document:v,reason:_,waitUntil(c){if(Object.isFrozen(m))throw(0,L.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(c))}});try{i.apply(I,[A])}catch(c){return Promise.reject(c)}return Object.freeze(m),new Promise((c,h)=>{const p=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(p),c(t)}).catch(t=>{clearTimeout(p),h(t)})}).then(c=>{const h={edits:[]};for(const p of c)if(Array.isArray(p)&&p.every(t=>t instanceof k.TextEdit))for(const{newText:t,newEol:r,range:o}of p)h.edits.push({_type:2,resource:v.uri,edit:{range:o&&y.Range.from(o),text:t,eol:r&&y.EndOfLine.from(r)}});if(h.edits.length!==0)return b===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(me[217],ge([0,1,3,30,2,15,7]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(i,I,u,m,l){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,u&&(this._config+=1),m&&(this._config+=2),l&&(this._config+=4);const v=(0,L.parse)(I),_=i(b=>{if(!u)for(let A of b.created){const c=k.URI.revive(A);v(c.fsPath)&&this._onDidCreate.fire(c)}if(!m)for(let A of b.changed){const c=k.URI.revive(A);v(c.fsPath)&&this._onDidChange.fire(c)}if(!l)for(let A of b.deleted){const c=k.URI.revive(A);v(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=T.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,_)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(i,I,u){this._logService=I,this._extHostDocumentsAndEditors=u,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(i,I,u,m){return new C(this._onFileSystemEvent.event,i,I,u,m)}$onFileEvent(i){this._onFileSystemEvent.fire(i)}$onDidRunFileOperation(i,I){switch(i){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(u=>({oldUri:k.URI.revive(u.source),newUri:k.URI.revive(u.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(u=>k.URI.revive(u.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(u=>k.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(i){return this._createWillExecuteEvent(i,this._onWillRenameFile)}getOnWillCreateFileEvent(i){return this._createWillExecuteEvent(i,this._onWillCreateFile)}getOnWillDeleteFileEvent(i){return this._createWillExecuteEvent(i,this._onWillDeleteFile)}_createWillExecuteEvent(i,I){return(u,m,l)=>{const v=function(b){u.call(m,b)};return v.extension=i,I.event(v,void 0,l)}}async $onWillRunFileOperation(i,I,u,m){switch(i){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(l=>({oldUri:k.URI.revive(l.source),newUri:k.URI.revive(l.target)}))},u,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(l=>k.URI.revive(l.target))},u,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(l=>k.URI.revive(l.target))},u,m)}}async _fireWillEvent(i,I,u,m){const l=new Set,v=[];if(await i.fireAsync(I,m,async(b,A)=>{const c=Date.now(),h=await Promise.resolve(b);h instanceof T.WorkspaceEdit&&(v.push(h),l.add(A.extension.displayName??A.extension.identifier.value)),Date.now()-c>u&&this._logService.warn("SLOW file-participant",A.extension.identifier)}),m.isCancellationRequested||v.length===0)return;const _={edits:[]};for(let b of v){let{edits:A}=y.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);_.edits=_.edits.concat(A)}return{edit:_,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=S}),define(me[218],ge([0,1,10,25,2,15,7,89]),function(J,e,g,L,k,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(u,m,l,v){this.start=u,this.deletedCount=m,this.deletedItems=l,this.items=v}static asApiEvents(u){return u.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(l=>l.apiCell)}))}}class P{constructor(u,m,l){this.notebook=u,this._extHostDocument=m,this._cellData=l,this.handle=l.handle,this.uri=k.URI.revive(l.uri),this.cellKind=l.cellKind,this._outputs=l.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=l.internalMetadata??{},this._metadata=Object.freeze(l.metadata??{}),this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(l.internalMetadata??{}))}static asModelAddData(u,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:u}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const u=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return u.notebook.getCellIndex(u)},notebook:u.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return u._mime},set mime(l){u._mime=l},get outputs(){return u._outputs.slice(0)},get metadata(){return u._metadata},get executionSummary(){return u._previousResult}})}return this._apiCell}setOutputs(u){this._outputs=u.map(y.NotebookCellOutput.to)}setOutputItems(u,m,l){const v=l.map(y.NotebookCellOutputItem.to),_=this._outputs.find(b=>b.id===u);_&&(m||(_.items.length=0),_.items.push(...v))}setMetadata(u){this._metadata=Object.freeze(u)}setInternalMetadata(u){this._internalMetadata=u,this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(u))}setMime(u){}}e.ExtHostCell=P;class i{constructor(u,m,l,v,_,b){this._proxy=u,this._textDocumentsAndEditors=m,this._textDocuments=l,this._emitter=v,this.uri=_,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=Object.freeze(b.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,b.cells]],!0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const u=this;this._notebook={get uri(){return u.uri},get version(){return u._versionId},get notebookType(){return u._notebookType},get isDirty(){return u._isDirty},get isUntitled(){return u.uri.scheme===g.Schemas.untitled},get isClosed(){return u._disposed},get metadata(){return u._metadata},get cellCount(){return u._cells.length},cellAt(m){return m=u._validateIndex(m),u._cells[m].apiCell},getCells(m){return(m?u._getCells(m):u._cells).map(v=>v.apiCell)},save(){return u._save()}}}return this._notebook}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(u){u.metadata&&(this._metadata=Object.freeze({...this._metadata,...u.metadata}))}acceptDirty(u){this._isDirty=u}acceptModelChanged(u,m){this._versionId=u.versionId,this._isDirty=m;for(const l of u.rawEvents)l.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1):l.kind===C.NotebookCellsChangeType.Move?this._moveCell(l.index,l.newIdx):l.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(l.index,l.outputs):l.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems):l.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(l.index,l.language):l.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(l.index,l.mime):l.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(l.index,l.metadata):l.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(l.index,l.internalMetadata)}_validateIndex(u){return u=u|0,u<0?0:u>=this._cells.length?this._cells.length-1:u}_validateRange(u){let m=u.start|0,l=u.end|0;return m<0&&(m=0),l>this._cells.length&&(l=this._cells.length),u.with({start:m,end:l})}_getCells(u){u=this._validateRange(u);const m=[];for(let l=u.start;l<u.end;l++)m.push(this._cells[l]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(u,m){if(this._disposed)return;const l=[],v=[],_=[];u.reverse().forEach(b=>{const c=b[2].map(t=>{const r=new P(this,this._textDocumentsAndEditors,t);return m||v.push(P.asModelAddData(this.apiNotebook,t)),r}),h=new S(b[0],b[1],[],c),p=this._cells.splice(b[0],b[1],...c);for(const t of p)_.push(t.uri),h.deletedItems.push(t.apiCell);l.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:_}),m||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(l)}))}_moveCell(u,m){const l=this._cells.splice(u,1);this._cells.splice(m,0,...l);const v=[new S(u,1,l.map(_=>_.apiCell),[]),new S(m,0,[],l)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(v)}))}_setCellOutputs(u,m){const l=this._cells[u];l.setOutputs(m),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[l.apiCell]}))}_setCellOutputItems(u,m,l,v){const _=this._cells[u];_.setOutputItems(m,l,v),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(u,m){const l=this._cells[u];l.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(l.uri,m)}_changeCellMime(u,m){const l=this._cells[u];l.apiCell.mime=m}_changeCellMetadata(u,m){const l=this._cells[u],v=l.apiCell.metadata;l.setMetadata(m);const _=l.apiCell.metadata;(0,L.equals)(v,_)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:l.apiCell}))}_changeCellInternalMetadata(u,m){const l=this._cells[u],v=l.internalMetadata;if(l.setInternalMetadata(m),v.runState!==m.runState){const _=m.runState??T.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:l.apiCell,state:_}))}}getCellFromApiCell(u){return this._cells.find(m=>m.apiCell===u)}getCellFromIndex(u){return this._cells[u]}getCell(u){return this._cells.find(m=>m.handle===u)}getCellIndex(u){return this._cells.indexOf(u)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(me[128],ge([0,1,7,15,16]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:P})}replaceCells(S,P,i){this._throwIfFinalized(),!(S===P&&i.length===0)&&this._collectedEdits.push({editType:1,index:S,count:P-S,cells:i.map(L.NotebookCellData.from)})}}class T{constructor(S,P,i,I,u,m){this.id=S,this._proxy=P,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._visibleRanges=I,this._viewColumn=m}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(P){if(!Array.isArray(P)||!P.every(g.NotebookRange.isNotebookRange))throw(0,k.illegalArgument)("selections");S._selections=P,S._trySetSelections(P)},get visibleRanges(){return S._visibleRanges},revealRange(P,i){S._proxy.$tryRevealRange(S.id,L.NotebookRange.from(P),i??g.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(P){const i=new y(this.document.version);return P(i),S._applyEdit(i.finalize())},setDecorations(P,i){return S.setDecorations(P,i)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(L.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const P=[];let i=-1;for(let I=0;I<S.cellEdits.length;I++){if(i<0){P.push(S.cellEdits[I]),i++;continue}const m=P[i],l=S.cellEdits[I];if(m.editType===1&&l.editType===1&&m.index===l.index){m.cells.push(...S.cellEdits[I].cells),m.count+=S.cellEdits[I].count;continue}P.push(S.cellEdits[I]),i++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,P)}setDecorations(S,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return P.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(P),S.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(me[219],ge([0,1,15,118,165,21,56]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,u,m){const l=this._handles++,{title:v,location:_,cancellable:b}=u,A={label:(0,k.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(l,{location:g.ProgressLocation.from(_),title:v,source:A,cancellable:b},I),this._withProgress(l,m,!!b)}_withProgress(I,u,m){let l;m&&(l=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,l));const v=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),l&&l.dispose()};let _;try{_=u(new P(this._proxy,I),m&&l?l.token:y.CancellationToken.None)}catch(b){throw v(I),b}return _.then(b=>v(I),b=>v(I)),_}$acceptProgressCanceled(I){const u=this._mapHandleToCancellationSource.get(I);u&&(u.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=C;function S(i,I){return i.message=I.message,typeof I.increment=="number"&&(typeof i.increment=="number"?i.increment+=I.increment:i.increment=I.increment),i}class P extends L.Progress{constructor(I,u){super(m=>this.throttledReport(m));this._proxy=I,this._handle=u}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ve([(0,T.throttle)(100,(i,I)=>S(i,I),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(me[129],ge([0,1,54,16,73,15,7]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(u,m,l){const v=C._Keys.nextId();u.$registerTextEditorDecorationType(m.identifier,v,y.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:v,dispose(){u.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=C,C._Keys=new k.IdGenerator("TextEditorDecorationType");class S{constructor(u,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,m){this._throwIfFinalized();let l=null;if(u instanceof T.Position)l=new T.Range(u,u);else if(u instanceof T.Range)l=u;else throw new Error("Unrecognized location");this._pushEdit(l,m,!1)}insert(u,m){this._throwIfFinalized(),this._pushEdit(new T.Range(u,u),m,!0)}delete(u){this._throwIfFinalized();let m=null;if(u instanceof T.Range)m=u;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(u,m,l){const v=this._document.validateRange(u);this._collectedEdits.push({range:v,text:m,forceMoveMarkers:l})}setEndOfLine(u){if(this._throwIfFinalized(),u!==T.EndOfLine.LF&&u!==T.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=u}}e.TextEditorEdit=S;class P{constructor(u,m,l,v){this._proxy=u,this._id=m,this._accept(l),this._logService=v;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(b){_._setTabSize(b)},get insertSpaces(){return _._insertSpaces},set insertSpaces(b){_._setInsertSpaces(b)},get cursorStyle(){return _._cursorStyle},set cursorStyle(b){_._setCursorStyle(b)},get lineNumbers(){return _._lineNumbers},set lineNumbers(b){_._setLineNumbers(b)}}}_accept(u){this._tabSize=u.tabSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const m=Math.floor(u);return m>0?m:null}if(typeof u=="string"){const m=parseInt(u,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(u){const m=this._validateTabSize(u);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:Boolean(u)}_setInsertSpaces(u){const m=this._validateInsertSpaces(u);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(u)})))}assign(u){const m={};let l=!1;if(typeof u.tabSize!="undefined"){const v=this._validateTabSize(u.tabSize);v==="auto"?(l=!0,m.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,l=!0,m.tabSize=v)}if(typeof u.insertSpaces!="undefined"){const v=this._validateInsertSpaces(u.insertSpaces);v==="auto"?(l=!0,m.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,l=!0,m.insertSpaces=v)}typeof u.cursorStyle!="undefined"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,l=!0,m.cursorStyle=u.cursorStyle),typeof u.lineNumbers!="undefined"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,l=!0,m.lineNumbers=y.TextEditorLineNumbersStyle.from(u.lineNumbers)),l&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(u){u.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=P;class i{constructor(u,m,l,v,_,b,A,c){this.id=u,this._proxy=m,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new P(this._proxy,this.id,b,l),this._visibleRanges=A,this._viewColumn=c;const h=this;this.value=Object.freeze({get document(){return v.getValue()},set document(p){throw(0,L.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(p){if(!(p instanceof T.Selection))throw(0,L.illegalArgument)("selection");h._selections=[p],h._trySetSelection()},get selections(){return h._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof T.Selection)))throw(0,L.illegalArgument)("selections");h._selections=p,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(p){throw(0,L.readonly)("visibleRanges")},get options(){return h._options.value},set options(p){h._disposed||h._options.assign(p)},get viewColumn(){return h._viewColumn},set viewColumn(p){throw(0,L.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new S(v.getValue(),t);return p(r),h._applyEdit(r)},insertSnippet(p,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=h._selections.map(n=>y.Range.from(n));else if(t instanceof T.Position){const{lineNumber:n,column:a}=y.Position.from(t);o=[{startLineNumber:n,startColumn:a,endLineNumber:n,endColumn:a}]}else if(t instanceof T.Range)o=[y.Range.from(t)];else{o=[];for(const n of t)if(n instanceof T.Range)o.push(y.Range.from(n));else{const{lineNumber:a,column:f}=y.Position.from(n);o.push({startLineNumber:a,startColumn:f,endLineNumber:a,endColumn:f})}}return m.$tryInsertSnippet(u,p.value,o,r)},setDecorations(p,t){const r=t.length===0;r&&!h._hasDecorationsForKey.has(p.key)||(r?h._hasDecorationsForKey.delete(p.key):h._hasDecorationsForKey.add(p.key),h._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return m.$trySetDecorations(u,p.key,y.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let n=0,a=t.length;n<a;n++){const f=t[n];o[4*n]=f.start.line+1,o[4*n+1]=f.start.character+1,o[4*n+2]=f.end.line+1,o[4*n+3]=f.end.character+1}return m.$trySetDecorationsFast(u,p.key,o)}}))},revealRange(p,t){h._runOnProxy(()=>m.$tryRevealRange(u,y.Range.from(p),t||T.TextEditorRevealType.Default))},show(p){m.$tryShowEditor(u,y.ViewColumn.from(p))},hide(){m.$tryHideEditor(u)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,g.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,g.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,g.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,g.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const m=u.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const l=m.edits.map(_=>_.range);l.sort((_,b)=>_.end.line===b.end.line?_.end.character===b.end.character?_.start.line===b.start.line?_.start.character-b.start.character:_.start.line-b.start.line:_.end.character-b.end.character:_.end.line-b.end.line);for(let _=0,b=l.length-1;_<b;_++){const A=l[_].end;if(l[_+1].start.isBefore(A))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=m.edits.map(_=>({range:y.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,v,{setEndOfLine:typeof m.setEndOfLine=="number"?y.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=i}),define(me[220],ge([0,1,168,23,2,3,6,208,17,7,14,20,15,21,205]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(A,c){if((0,i.isString)(A))return{label:A};if(A&&typeof A=="object"&&typeof A.label=="string"){let h;return Array.isArray(A.highlights)&&(h=A.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),h=h.length?h:void 0),{label:A.label,highlights:h}}}class _{constructor(c,h,p){this._proxy=c,this.commands=h,this.logService=p,this.treeViews=new Map;function t(r){return r&&r.$treeViewId&&r.$treeItemHandle}h.registerArgumentProcessor({processArgument:r=>t(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(o=>t(o)?this.convertArgument(o):o):r})}registerTreeDataProvider(c,h,p){const t=this.createTreeView(c,{treeDataProvider:h},p);return{dispose:()=>t.dispose()}}createTreeView(c,h,p){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=h.dragAndDropController!==void 0,r=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,canDragAndDrop:t}),o=this.createExtHostTreeView(c,h,p);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get message(){return o.message},set message(n){o.message=n},get title(){return o.title},set title(n){o.title=n},get description(){return o.description},set description(n){o.description=n},reveal:(n,a)=>o.reveal(n,a),dispose:async()=>{await r,this.treeViews.delete(c),o.dispose()}}}$getChildren(c,h){const p=this.treeViews.get(c);return p?p.getChildren(h):Promise.reject(new Error((0,g.localize)(0,null,c)))}async $onDrop(c,h,p){const t=this.treeViews.get(c);if(!t)return Promise.reject(new Error((0,g.localize)(1,null,c)));const r=l.TreeDataTransferConverter.toITreeDataTransfer(h);if(r.items.has(C.TREE_ITEM_DATA_TRANSFER_TYPE)){const n=JSON.parse(await r.items.get(C.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(a=>t.getExtensionElement(a)).filter(a=>!!a);n.length>0?r.items.set(C.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(n)}):r.items.delete(C.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(r,p)}async $hasResolve(c){const h=this.treeViews.get(c);if(!h)throw new Error((0,g.localize)(2,null,c));return h.hasResolve}$resolve(c,h,p){const t=this.treeViews.get(c);if(!t)throw new Error((0,g.localize)(3,null,c));return t.resolveTreeItem(h,p)}$setExpanded(c,h,p){const t=this.treeViews.get(c);if(!t)throw new Error((0,g.localize)(4,null,c));t.setExpanded(h,p)}$setSelection(c,h){const p=this.treeViews.get(c);if(!p)throw new Error((0,g.localize)(5,null,c));p.setSelection(h)}$setVisible(c,h){const p=this.treeViews.get(c);if(!p)throw new Error((0,g.localize)(6,null,c));p.setVisible(h)}createExtHostTreeView(c,h,p){const t=new b(c,h,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(c,t),t}convertArgument(c){const h=this.treeViews.get(c.$treeViewId);return h?h.getExtensionElement(c.$treeItemHandle):null}}e.ExtHostTreeViews=_;class b extends T.Disposable{constructor(c,h,p,t,r,o){super();if(this.viewId=c,this.proxy=p,this.commands=t,this.logService=r,this.extension=o,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,o.contributes&&o.contributes.views)for(const f in o.contributes.views)for(const d of o.contributes.views[f])d.id===c&&(this._title=d.name);this.dataProvider=h.treeDataProvider,this.dndController=h.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(f=>this._onDidChangeData.fire({message:!1,element:f}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(f=>this._onDidChangeData.fire({message:!1,element:f})));let n,a;this._register(y.Event.debounce(this._onDidChangeData.event,(f,d)=>(f||(f={message:!1,elements:[]}),d.element!==!1&&(n||(n=new Promise(w=>a=w),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(d.element)?f.elements.push(...d.element):f.elements.push(d.element)),d.message&&(f.message=!0),f),200,!0)(({message:f,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=a;return n=null,this.refresh(d).then(()=>w())})),f&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,i.isUndefinedOrNull)(c))}getChildren(c){const h=c?this.getExtensionElement(c):void 0;if(c&&!h)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);const p=this.getChildrenNodes(c);return(p?Promise.resolve(p):this.fetchChildrenNodes(h)).then(t=>t.map(r=>r.item))}getExtensionElement(c){return this.elements.get(c)}reveal(c,h){h=h||{select:!0,focus:!1};const p=(0,i.isUndefinedOrNull)(h.select)?!0:h.select,t=(0,i.isUndefinedOrNull)(h.focus)?!1:h.focus,r=(0,i.isUndefinedOrNull)(h.expand)?!1:h.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(o=>this.resolveTreeNode(c,o[o.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:o.map(a=>a.item)},{select:p,focus:t,expand:r})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:t,expand:r})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}setExpanded(c,h){const p=this.getExtensionElement(c);p&&(h?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(c){(0,I.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(c,h){const p=this.getExtensionElement(h);if(!!p)return(0,S.asPromise)(()=>this.dndController?.onDrop(c,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,h){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(c);if(p){const t=this.nodes.get(p);if(t){const r=await this.dataProvider.resolveTreeItem(t.extensionItem,p,h)??t.extensionItem;return t.item.tooltip=this.getTooltip(r.tooltip),t.item.command=this.getCommand(t.disposableStore,r.command),t.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(h=>h?this.resolveUnknownParentChain(h).then(p=>this.resolveTreeNode(h,p[p.length-1]).then(t=>(p.push(t),p))):Promise.resolve([]))}resolveParent(c){const h=this.nodes.get(c);return h?Promise.resolve(h.parent?this.elements.get(h.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,h){const p=this.nodes.get(c);return p?Promise.resolve(p):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(t=>this.createHandle(c,t,h,!0)).then(t=>this.getChildren(h?h.item.handle:void 0).then(()=>{const r=this.getExtensionElement(t);if(r){const o=this.nodes.get(r);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(c){if(c){let h;if(typeof c=="string"){const p=this.getExtensionElement(c);h=p?this.nodes.get(p):void 0}else h=c;return h&&h.children||null}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const h=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=c?this.nodes.get(c):void 0,t=await this.dataProvider.getChildren(c);if(h.token.isCancellationRequested)return[];const r=await Promise.all((0,I.coalesce)(t||[]).map(async o=>{const n=await this.dataProvider.getTreeItem(o);return n&&!h.token.isCancellationRequested?this.createAndRegisterTreeNode(o,n,p):null}));return h.token.isCancellationRequested?[]:(0,I.coalesce)(r)}finally{h.dispose()}}refresh(c){if(c.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(c);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const h=new Set,p=c.map(r=>this.nodes.get(r));for(const r of p)if(r&&!h.has(r.item.handle)){let o=r;for(;o&&o.parent&&p.findIndex(n=>o&&o.parent&&n&&n.item.handle===o.parent.item.handle)===-1;){const n=this.elements.get(o.parent.item.handle);o=n?this.nodes.get(n):void 0}o&&!o.parent&&h.add(r.item.handle)}const t=[];return h.forEach(r=>{const o=this.elements.get(r);if(o){const n=this.nodes.get(o);n&&(!n.parent||!h.has(n.parent.item.handle))&&t.push(r)}}),t}refreshHandles(c){const h={};return Promise.all(c.map(p=>this.refreshNode(p).then(t=>{t&&(h[p]=t.item)}))).then(()=>Object.keys(h).length?this.proxy.$refresh(this.viewId,h):void 0)}refreshNode(c){const h=this.getExtensionElement(c);if(h){const p=this.nodes.get(h);if(p)return this.clearChildren(h),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(t=>{if(t){const r=this.createTreeNode(h,t,p.parent);return this.updateNodeCache(h,r,p,p.parent),p.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,h,p){const t=this.createTreeNode(c,h,p);if(h.id&&this.elements.has(t.item.handle))throw new Error((0,g.localize)(7,null,h.id));return this.addNodeToCache(c,t),this.addNodeToParentCache(t,p),t}getTooltip(c){return P.MarkdownString.isMarkdownString(c)?u.MarkdownString.from(c):c}getCommand(c,h){return h?this.commands.toInternal(h,c):void 0}createTreeNode(c,h,p){const t=new T.DisposableStore,r=this.createHandle(c,h,p),o=this.getLightIconPath(h);return{item:{handle:r,parentHandle:p?p.item.handle:void 0,label:v(h.label,this.extension),description:h.description,resourceUri:h.resourceUri,tooltip:this.getTooltip(h.tooltip),command:this.getCommand(t,h.command),contextValue:h.contextValue,icon:o,iconDark:this.getDarkIconPath(h)||o,themeIcon:this.getThemeIcon(h),collapsibleState:(0,i.isUndefinedOrNull)(h.collapsibleState)?P.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation},extensionItem:h,parent:p,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(c){return c.iconPath instanceof P.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:h,label:p,resourceUri:t},r,o){if(h)return`${b.ID_HANDLE_PREFIX}/${h}`;const n=v(p,this.extension),a=r?r.item.handle:b.LABEL_HANDLE_PREFIX;let f=n?n.label:t?(0,L.basename)(t):"";f=f.indexOf("/")!==-1?f.replace("/","//"):f;const d=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,w=this.getChildrenNodes(r)||[];let E,s=0;do{if(E=`${a}/${s}:${f}`,o||!this.elements.has(E)||d===E)break;s++}while(s<=w.length);return E}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof P.ThemeIcon))return typeof c.iconPath=="string"||k.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof P.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return k.URI.isUri(c)?c:k.URI.file(c)}addNodeToCache(c,h){this.elements.set(h.item.handle,c),this.nodes.set(c,h)}updateNodeCache(c,h,p,t){this.elements.delete(h.item.handle),this.nodes.delete(c),h.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(c,h);const r=this.getChildrenNodes(t)||[],o=r.filter(n=>n.item.handle===p.item.handle)[0];o&&r.splice(r.indexOf(o),1,h)}addNodeToParentCache(c,h){h?(h.children||(h.children=[]),h.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const h=this.nodes.get(c);if(h){if(h.children)for(const p of h.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}h.children=void 0}}else this.clearAll()}clear(c){const h=this.nodes.get(c);if(h){if(h.children)for(const p of h.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}this.nodes.delete(c),this.elements.delete(h.item.handle),h.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}b.LABEL_HANDLE_PREFIX="0",b.ID_HANDLE_PREFIX="1"}),define(me[221],ge([0,1,17,3,6,14,87,15,126,90]),function(J,e,g,L,k,y,T,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class i extends k.Disposable{constructor(u){super();this.controllerId=u,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new T.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(u){this._resolveHandler=u;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const u=this.diff;return this.diff=[],u}pushDiff(u){const m=this.diff[this.diff.length-1];if(m&&u[0]===1){if(m[0]===1&&m[1].extId===u[1].extId){(0,S.applyTestItemUpdate)(m[1],u[1]);return}if(m[0]===0&&m[1].item.extId===u[1].extId){(0,S.applyTestItemUpdate)(m[1],u[1]);return}}this.diff.push(u),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(u,m){const l=this.tree.get(u);if(!!l){if((l.expandLevels===void 0||m>l.expandLevels)&&(l.expandLevels=m),l.expand===1){const v=this.resolveChildren(l);return v.isOpen()?this.expandChildren(l,m-1):v.wait().then(()=>this.expandChildren(l,m-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,m-1)):this.expandChildren(l,m-1)}}dispose(){for(const u of this.tree.values())(0,T.getPrivateApiFor)(u.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(u,m){switch(m.op){case 2:this.pushDiff([4,u.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(u.fullId,m.id));break;case 0:this.upsertItem(m.item,u);break;case 4:for(const b of m.ops)this.onTestItemEvent(u,b);break;case 3:const{key:l,value:v}=m,_=u.fullId.toString();switch(l){case"canResolveChildren":this.updateExpandability(u);break;case"range":this.pushDiff([1,{extId:_,item:{range:C.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:_,item:{error:C.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:_,item:{[l]:v??null}}]);break}break;default:(0,y.assertNever)(m)}}upsertItem(u,m){if(!(u instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${u.id} did not`);const l=P.TestId.fromExtHostTestItem(u,this.root.id,m?.actual),v=(0,T.getPrivateApiFor)(u);v.parent&&v.parent!==m?.actual&&v.parent.children.delete(u.id);let _=this.tree.get(l.toString());if(!_){_={fullId:l,actual:u,parent:m?l.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},this.tree.set(_.fullId.toString(),_),this.setItemParent(u,m),this.pushDiff([0,{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:C.TestItem.from(u)}]),this.connectItemAndChildren(u,_,m);return}if(_.actual===u){this.connectItem(u,_,m);return}const b=_.actual.children,A=_.actual,c=(0,T.diffTestItems)(A,u);(0,T.getPrivateApiFor)(A).listener=void 0,_.actual=u,_.expand=0;for(const[h,p]of c)this.onTestItemEvent(_,{op:3,key:h,value:p});this.connectItemAndChildren(u,_,m);for(const h of b)u.children.get(h.id)||this.removeItem(P.TestId.joinToString(l,h.id))}setItemParent(u,m){(0,T.getPrivateApiFor)(u).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(u,m,l){this.setItemParent(u,l);const v=(0,T.getPrivateApiFor)(u);v.parent=l?.actual,v.listener=_=>this.onTestItemEvent(m,_),this.updateExpandability(m)}connectItemAndChildren(u,m,l){this.connectItem(u,m,l);for(const v of u.children)this.upsertItem(v,m)}updateExpandability(u){let m;this._resolveHandler?u.resolveBarrier?m=u.resolveBarrier.isOpen()?3:2:m=u.actual.canResolveChildren?1:0:m=0,m!==u.expand&&(u.expand=m,this.pushDiff([1,{extId:u.fullId.toString(),expand:m}]),m===1&&u.expandLevels!==void 0&&this.resolveChildren(u))}expandChildren(u,m){if(m<0)return;const l=[];for(const v of u.actual.children){const _=this.expand(P.TestId.joinToString(u.fullId,v.id),m);(0,g.isThenable)(_)&&l.push(_)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this._resolveHandler){const _=new g.Barrier;return _.open(),_}u.expand=2,this.pushExpandStateUpdate(u);const m=u.resolveBarrier=new g.Barrier,l=_=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),u.actual!==this.root&&(u.actual.error=_.stack||_.message||String(_))};let v;try{v=this._resolveHandler(u.actual===this.root?void 0:u.actual)}catch(_){l(_)}return(0,g.isThenable)(v)?v.catch(l).then(()=>{m.open(),this.updateExpandability(u)}):(m.open(),this.updateExpandability(u)),u.resolveBarrier}pushExpandStateUpdate(u){this.pushDiff([1,{extId:u.fullId.toString(),expand:u.expand}])}removeItem(u){const m=this.tree.get(u);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,u]);const l=[m];for(;l.length;){const v=l.pop();if(!!v){(0,T.getPrivateApiFor)(v.actual).listener=void 0,this.tree.delete(v.fullId.toString());for(const _ of v.actual.children)l.push(this.tree.get(P.TestId.joinToString(v.fullId,_.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.diffOpEmitter.fire(u)}}e.SingleUseTestCollection=i}),define(me[222],ge([0,1,4,183]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(L.IEnvironmentService)}),define(me[223],ge([0,1,26,3,9]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=y;class T{constructor(i){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(u=>I.add(g.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>I.has(g.ExtensionIdentifier.toKey(u.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const u=T._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(u.map(m=>m.identifier)),I.length>0){const m=new Set;I.forEach(l=>m.add(g.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!m.has(g.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(u)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,b){this.addNode(_),this.addNode(b),this._arcs.has(_)?this._arcs.get(_).push(b):this._arcs.set(_,[b])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,b){const A=I.getArcs(_);for(let c=0;c<A.length;c++)if(!b.has(A[c]))return!1;return!0}getNodes(){return this._nodesArr}};let u=new Map;for(let _ of i){const b=g.ExtensionIdentifier.toKey(_.identifier);if(u.set(b,_),_.extensionDependencies)for(let A of _.extensionDependencies){const c=g.ExtensionIdentifier.toKey(A);I.addArc(b,c)}}let m=new Set;I.getNodes().filter(_=>I.getArcs(_).length===0).forEach(_=>m.add(_));let l=I.getNodes().filter(_=>!m.has(_)),v;do{v=!1;for(let _=0;_<l.length;_++){const b=l[_];I.hasOnlyGoodArcs(b,m)&&(l.splice(_,1),_--,m.add(b),v=!0)}}while(v);return l.map(_=>u.get(_))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=T;var C;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(C||(C={}));function S(P,i){const I=P.isBuiltin?0:P.isUnderDevelopment?2:1,u=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==u)return I-u;const m=k.posix.basename(P.extensionLocation.path),l=k.posix.basename(i.extensionLocation.path);return m<l?-1:m>l?1:0}}),define(me[224],ge([0,1,24]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function y(C){const S=g.VSBuffer.alloc(1);switch(C){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=y;function T(C,S){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=T}),define(me[35],ge([0,1,3,2,4,26,185]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");class C{constructor(A){this.dependency=A}}e.MissingExtensionDependency=C;var S;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));class P{constructor(A,c,h,p){this.codeLoadingTime=A,this.activateCallTime=c,this.activateResolvedTime=h,this.activationReason=p}}e.ActivationTimes=P;class i{constructor(A,c){this.description=A,this.value=c}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var I;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function u(b){b.enableProposedApi||m(b)}e.checkProposedApiEnabled=u;function m(b){throw new Error(`[${b.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.throwProposedApiError=m;function l(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=l;function v(b,A){return{identifier:new y.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!!A,extensionLocation:b.location,...b.manifest,uuid:b.identifier.uuid}}e.toExtensionDescription=v;class _{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(A){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(A){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(A){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(A){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(A,c){return Promise.resolve()}_onWillActivateExtension(A){}_onDidActivateExtension(A,c,h,p,t){}_onDidActivateExtensionError(A,c){}_onExtensionRuntimeError(A,c){}_onExtensionHostExit(A){}}e.NullExtensionService=_}),define(me[225],ge([0,1,26,35,12]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class T{constructor(l,v,_,b){this.startup=l,this.codeLoadingTime=v,this.activateCallTime=_,this.activateResolvedTime=b}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class C{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,v){return l===-1||v===-1?-1:v-l}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class S{constructor(l,v,_,b,A,c){this.activationFailed=l,this.activationFailedError=v,this.activationTimes=_,this.module=b,this.exports=A,this.subscriptions=c}}e.ActivatedExtension=S;class P extends S{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class i extends S{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class I extends S{constructor(l){super(!0,l,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let u=class{constructor(l,v,_,b,A){this._logService=A,this._registry=l,this._resolvedExtensionsSet=new Set,v.forEach(c=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,_.forEach(c=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(c),c)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(l){const v=g.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(v)}getActivatedExtension(l){const v=g.ExtensionIdentifier.toKey(l),_=this._activatedExtensions.get(v);if(!_)throw new Error("Extension `"+l.value+"` is not known or not activated");return _}activateByEvent(l,v){if(this._alreadyActivatedEvents[l])return y;const _=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(_.map(b=>({id:b.identifier,reason:{startup:v,extensionId:b.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,v){const _=this._registry.getExtensionDescription(l);if(!_)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:_.identifier,reason:v}])}_handleActivateRequest(l,v,_){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(l.id))){v[g.ExtensionIdentifier.toKey(l.id)]=l;return}const b=this._registry.getExtensionDescription(l.id);if(!b){const h=new Error(`Cannot activate unknown extension '${l.id.value}'`);this._host.onExtensionActivationError(l.id,h,new L.MissingExtensionDependency(l.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(l.id),new I(h));return}const A=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let c=!0;for(let h=0,p=A.length;h<p;h++){const t=A[h];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const f=b.displayName||b.identifier.value,d=this._registry.getExtensionDescription(t),w=d&&d.displayName||t,E=new Error(`Cannot activate the '${f}' extension because its dependency '${w}' failed to activate`);E.detail=r.activationFailedError,this._host.onExtensionActivationError(b.identifier,E,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(b.identifier),new I(E));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){c=!1,v[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:l.reason};continue}const o=this._registry.getExtensionDescription(t);if(o){c=!1,v[g.ExtensionIdentifier.toKey(t)]={id:o.identifier,reason:l.reason};continue}const n=b.displayName||b.identifier.value,a=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(b.identifier,a,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(b.identifier),new I(a));return}c?v[g.ExtensionIdentifier.toKey(b.identifier)]=l:_.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(A=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(A.id))),l.length===0))return Promise.resolve(void 0);const v=Object.create(null),_=[];for(let A=0,c=l.length;A<c;A++)this._handleActivateRequest(l[A],v,_);for(let A=0,c=_.length;A<c;A++){const h=g.ExtensionIdentifier.toKey(_[A].id);v[h]&&delete v[h]}const b=Object.keys(v).map(A=>v[A]);return _.length===0?Promise.all(b.map(A=>this._activateExtension(A.id,A.reason))).then(A=>{}):this._activateExtensions(b).then(A=>this._activateExtensions(_))}_activateExtension(l,v){const _=g.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const b=this._activatingExtensions.get(_);if(b)return b;const A=this._host.actualActivateExtension(l,v).then(void 0,c=>{const h=new Error;return c&&c.name&&(h.name=c.name),c&&c.message?h.message=`Activating extension '${l.value}' failed: ${c.message}.`:h.message=`Activating extension '${l.value}' failed: ${c}.`,c&&c.stack&&(h.stack=c.stack),this._host.onExtensionActivationError(l,h,null),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(c),new I(c)}).then(c=>{this._activatedExtensions.set(_,c),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,A),A}};u=Ve([$e(4,k.ILogService)],u),e.ExtensionsActivator=u}),define(me[226],ge([0,1,12,35,27,10,116]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends g.LogService{constructor(P){if(P.logFile.scheme!==y.Schemas.file)throw new Error("Only file-logging supported");super(new T.SpdLogLogger(L.ExtensionHostLogFileName,P.logFile.fsPath,!0,P.logLevel))}$setLevel(P){this.setLevel(P)}};C=Ve([$e(0,k.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(me[227],ge([0,1,16]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,T)=>{this._actualOk=y,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,g.onUnexpectedError)(y))}then(y,T){return this._ensureActual().then(y,T)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=L}),define(me[130],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(S,P){this._proxyIdentifierBrand=void 0,this.isMain=S,this.sid=P,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const L=[];function k(C){const S=new g(!0,C);return L[S.nid]=S,S}e.createMainContextProxyIdentifier=k;function y(C){const S=new g(!1,C);return L[S.nid]=S,S}e.createExtHostContextProxyIdentifier=y;function T(C){return L[C].sid}e.getStringIdentifierForProxy=T}),define(me[5],ge([0,1,59,2,130]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var T;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var u;(function(c){c.name="$ident";function h(t,r){return Object.defineProperty(t,c.name,{value:r,enumerable:!0}),t}c.mixin=h;function p(t){return t[c.name]}c.of=p})(u=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(h){return h._id=m._n++,h}}e.IdObject=m,m._n=0;var l;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(c){if(c&&c.edits)for(const h of c.edits)typeof h.resource=="object"?h.resource=L.URI.revive(h.resource):(h.newUri=L.URI.revive(h.newUri),h.oldUri=L.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,g.revive)(h.metadata));return c}e.reviveWorkspaceEditDto=b;var A;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(A=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,k.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[91],ge([0,1,5,3,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(C){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,S){return this._proxy.$getPassword(C,S)}store(C,S,P){return this._proxy.$setPassword(C,S,P)}delete(C,S){return this._proxy.$deletePassword(C,S)}}e.ExtHostSecretState=y,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(me[64],ge([0,1,4,12,5,13]),function(J,e,g,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(S,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(k.MainContext.MainThreadTelemetry)}report(S,P,i){const I=this.getUsageKey(S,P);this._reportedUsages.has(I)||(this._reportedUsages.add(I),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:S}))}getUsageKey(S,P){return`${S}-${P.identifier.value}`}};T=Ve([$e(0,y.IExtHostRpcService),$e(1,L.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(C,S,P){}})}),define(me[228],ge([0,1,3,5,7,26]),function(J,e,g,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,P,i,I={}){const u=y.ExtensionIdentifier.toKey(S.identifier),m=this._inFlightRequests.get(u)||[],l=[...i].sort().join(" ");let v=m.find(_=>_.scopes===l);if(v)return v.result;{const _=this._getSession(S,u,P,i,I);v={scopes:l,result:_},m.push(v),this._inFlightRequests.set(u,m);try{await _}finally{const b=m.findIndex(A=>A.scopes===l);b>-1&&(m.splice(b),this._inFlightRequests.set(u,m))}return _}}async _getSession(S,P,i,I,u={}){await this._proxy.$ensureProvider(i);const m=S.displayName||S.name;return this._proxy.$getSession(i,I,P,m,u)}async removeSession(S,P){const i=this._authenticationProviders.get(S);return i?i.provider.removeSession(P):this._proxy.$removeSession(S,P)}registerAuthenticationProvider(S,P,i,I){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:P,provider:i,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===S)||this._providers.push({id:S,label:P});const u=i.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(S,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,P,I?.supportsMultipleAccounts??!1),new k.Disposable(()=>{u.dispose(),this._authenticationProviders.delete(S);const m=this._providers.findIndex(l=>l.id===S);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,P){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,P){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,P){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,P){return this._onDidChangeSessions.fire({provider:{id:S,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(me[229],ge([0,1,5,13,15]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(C,S){this._extHostDocumentsAndEditors=S,this._proxy=C.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const S=k.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};y=Ve([$e(0,L.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(me[230],ge([0,1,5]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(y){const T=y.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(C){return T.$writeText(C)}})}}e.ExtHostClipboard=L}),define(me[44],ge([0,1,14,7,15,25,5,20,12,59,41,50,2,6,4,13]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(T.MainContext.MainThreadCommands),this._logService=r,this.converter=new b(this,o=>{const n=this._apiCommands.get(o);return n?.result===c.Void?n:void 0},r),this._argumentProcessors=[{processArgument(o){return(0,P.revive)(o)}},{processArgument(o){return(0,y.cloneAndChange)(o,function(n){if(i.Range.isIRange(n))return k.Range.to(n);if(I.Position.isIPosition(n))return k.Position.to(n);if(i.Range.isIRange(n.range)&&u.URI.isUri(n.uri))return k.location.to(n);if(!Array.isArray(n))return n})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...o)=>{const n=t.args.map((f,d)=>{if(!f.validate(o[d]))throw new Error(`Invalid argument '${f.name}' when running '${t.id}', received: ${o[d]}`);return f.convert(o[d])}),a=await this.executeCommand(t.internalId,...n);return t.result.convert(a,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new L.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,o,n,a){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:o,thisArg:n,description:a}),t&&this._proxy.$registerCommand(r),new L.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,o){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const n=(0,y.cloneAndChange)(r,function(a){if(a instanceof L.Position)return k.Position.from(a);if(a instanceof L.Range)return k.Range.from(a);if(a instanceof L.Location)return k.location.from(a);if(L.NotebookRange.isNotebookRange(a))return k.NotebookRange.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,n,o);return(0,P.revive)(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw a}}}async _executeContributedCommand(t,r){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:n,thisArg:a,description:f}=o;if(f)for(let d=0;d<f.args.length;d++)try{(0,g.validateConstraint)(r[d],f.args[d].constraint)}catch(w){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${f.args[d].name}' - ${f.args[d].description}`)}try{return await n.apply(a,r)}catch(d){if(t===this.converter.delegatingCommandId){const w=this.converter.getActualCommand(...r);w&&(t=w.command)}throw this._logService.error(d,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(o=>this._argumentProcessors.reduce((n,a)=>a.processArgument(n),o)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(o=>o[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,o]of this._commands){let{description:n}=o;n&&(t[r]=n)}return Promise.resolve(t)}};_=Ve([$e(0,v.IExtHostRpcService),$e(1,S.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class b{constructor(t,r,o){this._commands=t,this._lookupApiCommand=r,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const n=this._lookupApiCommand(t.command);if(n)o.id=n.internalId,o.arguments=n.args.map((a,f)=>a.convert(t.arguments&&t.arguments[f]));else if((0,C.isNonEmptyArray)(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),r.add((0,m.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),o.$ident=a,o.id=this.delegatingCommandId,o.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return o}fromInternal(t){const r=T.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=b;class A{constructor(t,r,o,n){this.name=t,this.description=r,this.validate=o,this.convert=n}optional(){return new A(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new A(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=A,A.Uri=new A("uri","Uri of a text document",p=>u.URI.isUri(p),p=>p),A.Position=new A("position","A position in a text document",p=>L.Position.isPosition(p),k.Position.from),A.Range=new A("range","A range in a text document",p=>L.Range.isRange(p),k.Range.from),A.Selection=new A("selection","A selection in a text document",p=>L.Selection.isSelection(p),k.Selection.from),A.Number=new A("number","",p=>typeof p=="number",p=>p),A.String=new A("string","",p=>typeof p=="string",p=>p),A.CallHierarchyItem=new A("item","A call hierarchy item",p=>p instanceof L.CallHierarchyItem,k.CallHierarchyItem.from),A.TypeHierarchyItem=new A("item","A type hierarchy item",p=>p instanceof L.TypeHierarchyItem,k.TypeHierarchyItem.from);class c{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=c,c.Void=new c("no result",p=>p);class h{constructor(t,r,o,n,a){this.id=t,this.internalId=r,this.description=o,this.args=n,this.result=a}}e.ApiCommand=h}),define(me[231],ge([0,1,15,7,81,44,20,111]),function(J,e,g,L,k,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(g.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,m)=>{if((0,T.isFalsyOrEmpty)(u))return;class l extends L.SymbolInformation{static to(_){const b=new l(_.name,g.SymbolKind.to(_.kind),_.containerName||"",new L.Location(m[0],g.Range.to(_.range)));return b.detail=_.detail,b.range=b.location.range,b.selectionRange=g.Range.to(_.selectionRange),b.children=_.children?_.children.map(l.to):[],b}}return u.map(l.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new y.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(g.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(g.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(m=>L.Position.isPosition(m)),u=>u.map(g.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(m=>{let l;for(const v of m.reverse())l=new L.SelectionRange(g.Range.to(v),l);return l}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>{const m=[];if(Array.isArray(u))for(let l of u)m.push(...l[1].map(g.WorkspaceSymbol.to));return m})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(g.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(g.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(g.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return g.WorkspaceEdit.to(u)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(g.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new L.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,C.decodeSemanticTokensDto)(u);if(m.type==="full")return new L.SemanticTokens(m.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new L.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,C.decodeSemanticTokensDto)(u);if(m.type==="full")return new L.SemanticTokens(m.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,m,l)=>{if(!u)return new L.CompletionList([]);const v=u.suggestions.map(_=>g.CompletionItem.to(_,l));return new L.CompletionList(v,u.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return g.SignatureHelp.to(u)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,m,l)=>i(v=>new L.CodeLens(g.Range.to(v.range),v.command&&l.fromInternal(v.command)))(u))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>L.Range.isRange(u),u=>L.Selection.isSelection(u)?g.Selection.from(u):g.Range.from(u)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,m,l)=>i(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(v.command)}else{const _=new L.CodeAction(v.title,v.kind?new L.CodeActionKind(v.kind):void 0);return v.edit&&(_.edit=g.WorkspaceEdit.to(v.edit)),v.command&&(_.command=l.fromInternal(v.command)),_.isPreferred=v.isPreferred,_}})(u))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(m=>new L.ColorInformation(g.Range.to(m.range),g.Color.to(m.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",u=>u instanceof L.Color,g.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:g.Range.from(u.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(g.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",u=>u.map(g.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(m=>g.NotebookExclusiveDocumentPattern.to(m))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(g.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[g.ViewColumn.from(u.viewColumn),g.TextEditorOpenOptions.from(u)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[g.ViewColumn.from(u.viewColumn),g.TextEditorOpenOptions.from(u)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[g.ViewColumn.from(u.viewColumn),g.TextEditorOpenOptions.from(u)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(g.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(g.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(g.TypeHierarchyItem.to)))];class P{static register(m){S.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=P;function i(u){return m=>{if(Array.isArray(m))return m.map(u)}}function I(u){if(!Array.isArray(u))return;const m=[];for(const l of u)k.isLocationLink(l)?m.push(g.DefinitionLink.to(l)):m.push(g.location.to(l));return m}}),define(me[232],ge([0,1,17,56,3,6,2,81,26,15,7,5]),function(J,e,g,L,k,y,T,C,S,P,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function u(m,l,v){const _=m.getProxy(I.MainContext.MainThreadComments);class b{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,l.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const a=this._commentControllers.get(n.handle);return a||n}else if(n&&n.$mid===7){const a=this._commentControllers.get(n.commentControlHandle);if(!a)return n;const f=a.getCommentThread(n.commentThreadHandle);return f||n}else if(n&&n.$mid===8){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const f=a.getCommentThread(n.thread.commentThreadHandle);return f?{thread:f,text:n.text}:n}else if(n&&n.$mid===9){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const f=a.getCommentThread(n.thread.commentThreadHandle);if(!f)return n;let d=n.commentUniqueId,w=f.getCommentByUniqueId(d);return w||n}else if(n&&n.$mid===10){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const f=a.getCommentThread(n.thread.commentThreadHandle);if(!f)return n;let d=n.text,w=n.commentUniqueId,E=f.getCommentByUniqueId(w);return E?(E.body=d,E):n}return n}})}createCommentController(n,a,f){const d=b.handlePool++,w=new c(n,d,a,f);this._commentControllers.set(w.handle,w);const E=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(n.identifier))||[];return E.push(w),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(n.identifier),E),w.value}$createCommentThreadTemplate(n,a,f){const d=this._commentControllers.get(n);!d||d.$createCommentThreadTemplate(a,f)}async $updateCommentThreadTemplate(n,a,f){const d=this._commentControllers.get(n);!d||d.$updateCommentThreadTemplate(a,f)}$deleteCommentThread(n,a){const f=this._commentControllers.get(n);f&&f.$deleteCommentThread(a)}$provideCommentingRanges(n,a,f){const d=this._commentControllers.get(n);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const w=v.getDocument(T.URI.revive(a));return(0,g.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(w,f)).then(E=>E?E.map(s=>P.Range.from(s)):void 0)}$toggleReaction(n,a,f,d,w){const E=this._commentControllers.get(n);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const s=E.getCommentThread(a);if(s){const D=s.getCommentByUniqueId(d.uniqueIdInThread);if(E!==void 0&&D&&E.reactionHandler)return E.reactionHandler(D,t(w))}return Promise.resolve(void 0)})}dispose(){}}b.handlePool=0;class A{constructor(n,a,f,d,w,E,s){this._commentControllerHandle=a,this._id=f,this._uri=d,this._range=w,this._comments=E,this.handle=A._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),_.$createCommentThread(a,this.handle,this._id,this._uri,P.Range.from(this._range),s),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this._localDisposables.push({dispose:()=>{_.$deleteCommentThread(a,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(R){D.range=R},get comments(){return D.comments},set comments(R){D.comments=R},get collapsibleState(){return D.collapsibleState},set collapsibleState(R){D.collapsibleState=R},get canReply(){return D.canReply},set canReply(R){D.canReply=R},get contextValue(){return D.contextValue},set contextValue(R){D.contextValue=R},get label(){return D.label},set label(R){D.label=R},dispose:()=>{D.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const n=f=>Object.prototype.hasOwnProperty.call(this.modifications,f),a={};n("range")&&(a.range=P.Range.from(this._range)),n("label")&&(a.label=this.label),n("contextValue")&&(a.contextValue=this.contextValue),n("comments")&&(a.comments=this._comments.map(f=>h(this,f,this._commentsMap))),n("collapsibleState")&&(a.collapseState=r(this._collapseState)),n("canReply")&&(a.canReply=this.canReply),this.modifications={},_.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,a)}getCommentByUniqueId(n){for(let a of this._commentsMap){let f=a[0],d=a[1];if(n===d)return f}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}A._handlePool=0,Ve([(0,L.debounce)(100)],A.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(n,a,f,d){this._extension=n,this._handle=a,this._id=f,this._label=d,this._threads=new Map,_.$registerCommentController(this.handle,f,d);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(E){w.options=E},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(E){w.commentingRangeProvider=E},get reactionHandler(){return w.reactionHandler},set reactionHandler(E){w.reactionHandler=E},createCommentThread(E,s,D){return w.createCommentThread(E,s,D).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{_.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,_.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,_.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,a,f,d){if(typeof n=="string"){const w=new A(this.id,this.handle,n,a,f,d,this._extension.identifier);return this._threads.set(w.handle,w),w}else{const w=new A(this.id,this.handle,void 0,n,a,f,this._extension.identifier);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(n,a){const f=new A(this.id,this.handle,void 0,T.URI.revive(n),P.Range.to(a),[],this._extension.identifier);return f.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(n,a){let f=this._threads.get(n);f&&(f.range=P.Range.to(a))}$deleteCommentThread(n){let a=this._threads.get(n);a&&a.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function h(o,n,a){let f=a.get(n);f||(f=++o.commentHandle,a.set(n,f));const d=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:f,body:P.MarkdownString.from(n.body),userName:n.author.name,userIconPath:d,label:n.label,commentReactions:n.reactions?n.reactions.map(w=>p(w)):void 0}}function p(o){return{label:o.label,iconPath:o.iconPath?P.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function t(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?T.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function r(o){if(o!==void 0)switch(o){case i.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}return new b}e.createExtHostComments=u}),define(me[131],ge([0,1,2,5,7,4,13,12,20,8,9]),function(J,e,g,L,k,y,T,C,S,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wn{constructor(m,l){this._logService=l,this._provider=new Map,this._proxy=m.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,l){const v=wn._handlePool++;this._provider.set(v,{provider:m,extensionId:l}),this._proxy.$registerDecorationProvider(v,l.value);const _=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(b=>{if(!b){this._proxy.$onDidChange(v,null);return}let A=(0,S.asArray)(b);if(A.length<=wn._maxEventSize){this._proxy.$onDidChange(v,A);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,A.length);const c=A.map(t=>({uri:t,rank:(0,P.count)(t.path,"/")})),h=(0,S.groupBy)(c,(t,r)=>t.rank-r.rank||(0,P.compare)(t.uri.path,r.uri.path));let p=[];e:for(let t of h){let r;for(let o of t){let n=(0,i.dirname)(o.uri.path);if(r!==n&&(r=n,p.push(o.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(v,p)});return new k.Disposable(()=>{_?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(m,l,v){if(!this._provider.has(m))return Object.create(null);const _=Object.create(null),{provider:b,extensionId:A}=this._provider.get(m);return await Promise.all(l.map(async c=>{try{const{uri:h,id:p}=c,t=await Promise.resolve(b.provideFileDecoration(g.URI.revive(h),v));if(!t)return;try{k.FileDecoration.validate(t),_[p]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${A.value}': ${r}`)}}catch(h){this._logService.error(h)}})),_}};I._handlePool=0,I._maxEventSize=250,I=Ve([$e(0,T.IExtHostRpcService),$e(1,C.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,y.createDecorator)("IExtHostDecorations")}),define(me[233],ge([0,1,163,117,2,5,7,15,3,12,22]),function(J,e,g,L,k,y,T,C,S,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(l,v,_,b,A){this._name=l,this._owner=v,this._maxDiagnosticsPerFile=_,this._proxy=b,this._onDidChangeDiagnostics=A,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(l,v){if(!l){this.clear();return}this._checkDisposed();let _=[];if(k.URI.isUri(l)){if(!v){this.delete(l);return}this._data.set(l,v.slice()),_=[l]}else if(Array.isArray(l)){_=[];let A;l=[...l].sort(I._compareIndexedTuplesByUri);for(const c of l){const[h,p]=c;if((!A||h.toString()!==A.toString())&&(A&&this._data.get(A).length===0&&this._data.delete(A),A=h,_.push(h),this._data.set(h,[])),p){const t=this._data.get(h);t&&t.push(...p)}else{const t=this._data.get(h);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!this._proxy)return;const b=[];for(let A of _){let c=[];const h=this._data.get(A);if(h)if(h.length>this._maxDiagnosticsPerFile){c=[];const p=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of h)if(r.severity===p[t]&&c.push(C.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;c.push({severity:L.MarkerSeverity.Info,message:(0,g.localize)(0,null,h.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=h.map(p=>C.Diagnostic.from(p));b.push([A,c])}this._proxy.$changeMany(this._owner,b)}delete(l){this._checkDisposed(),this._onDidChangeDiagnostics.fire([l]),this._data.delete(l),this._proxy&&this._proxy.$changeMany(this._owner,[[l,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(l,v){this._checkDisposed();for(let _ of this._data.keys())l.apply(v,[_,this.get(_),this])}get(l){this._checkDisposed();const v=this._data.get(l);return Array.isArray(v)?Object.freeze(v.slice(0)):[]}has(l){return this._checkDisposed(),Array.isArray(this._data.get(l))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(l,v){return l[0].toString()<v[0].toString()?-1:l[0].toString()>v[0].toString()?1:0}}e.DiagnosticCollection=I;let u=class Qt{constructor(l,v){this._logService=v,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,Qt._mapper),this._proxy=l.getProxy(y.MainContext.MainThreadDiagnostics)}static _mapper(l){const v=new i.ResourceMap;for(const _ of l)v.set(_,_);return{uris:Object.freeze(Array.from(v.values()))}}createDiagnosticCollection(l,v){const{_collections:_,_proxy:b,_onDidChangeDiagnostics:A,_logService:c}=this,h=new class{$changeMany(r,o){b.$changeMany(r,o),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,r,o.length===0?"CLEARING":o)}$clear(r){b.$clear(r),c.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,r)}dispose(){b.dispose()}};let p;if(!v)v="_generated_diagnostic_collection_name_#"+Qt._idPool++,p=v;else if(!_.has(v))p=v;else{this._logService.warn(`DiagnosticCollection with name '${v}' does already exist.`);do p=v+Qt._idPool++;while(_.has(p))}return new class extends I{constructor(){super(v,p,Qt._maxDiagnosticsPerFile,h,A);_.set(p,this)}dispose(){super.dispose(),_.delete(p)}}}getDiagnostics(l){if(l)return this._getDiagnostics(l);{const v=new Map,_=[];for(const b of this._collections.values())b.forEach((A,c)=>{let h=v.get(A.toString());typeof h=="undefined"&&(h=_.length,v.set(A.toString(),h),_.push([A,[]])),_[h][1]=_[h][1].concat(...c)});return _}}_getDiagnostics(l){let v=[];for(let _ of this._collections.values())_.has(l)&&(v=v.concat(_.get(l)));return v}$acceptMarkersChange(l){if(!this._mirrorCollection){const v="_generated_mirror",_=new I(v,v,Qt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(v,_),this._mirrorCollection=_}for(const[v,_]of l)this._mirrorCollection.set(k.URI.revive(v),_.map(C.Diagnostic.to))}};u._idPool=0,u._maxDiagnosticsPerFile=1e3,u=Ve([$e(1,P.ILogService)],u),e.ExtHostDiagnostics=u}),define(me[234],ge([0,1,2,5]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(T){this._proxy=T.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(C=>C?C.map(S=>g.URI.revive(S)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(C=>C?g.URI.revive(C):void 0)}}e.ExtHostDialogs=k}),define(me[235],ge([0,1,16,2,7,5,10,21,8]),function(J,e,g,L,k,y,T,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(I,u,m){this._documentsAndEditors=u,this._logService=m,this._documentContentProviders=new Map,this._proxy=I.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,u){if(Object.keys(T.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const m=P._handlePool++;this._documentContentProviders.set(m,u),this._proxy.$registerTextContentProvider(m,I);let l;return typeof u.onDidChange=="function"&&(l=u.onDidChange(v=>{if(v.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(m,v).then(_=>{if(!_&&typeof _!="string")return;const b=this._documentsAndEditors.getDocument(v);if(!b)return;const A=(0,S.splitLines)(_);if(!b.equalLines(A))return this._proxy.$onVirtualDocumentChange(v,_)},g.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(I,u){const m=this._documentContentProviders.get(I);return m?Promise.resolve(m.provideTextDocumentContent(L.URI.revive(u),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(me[236],ge([0,1,3,6,2,5,123,15,14,25,7]),function(J,e,g,L,k,y,T,C,S,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(m,l){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const _ of v)this._onDidRemoveDocument.fire(_.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const _ of v)this._onDidAddDocument.fire(_.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const l=this._documentsAndEditors.getDocument(m);if(l)return l}getDocument(m){const l=this.getDocumentData(m);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return l.document}ensureDocumentData(m){const l=this._documentsAndEditors.getDocument(m);if(l)return Promise.resolve(l);let v=this._documentLoader.get(m.toString());return v||(v=this._proxy.$tryOpenDocument(m).then(_=>{this._documentLoader.delete(m.toString());const b=k.URI.revive(_);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(b))},_=>(this._documentLoader.delete(m.toString()),Promise.reject(_))),this._documentLoader.set(m.toString(),v)),v}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(l=>k.URI.revive(l))}$acceptModelModeChanged(m,l){const v=k.URI.revive(m),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");this._onDidRemoveDocument.fire(_.document),_._acceptLanguageId(l),this._onDidAddDocument.fire(_.document)}$acceptModelSaved(m){const l=k.URI.revive(m),v=this._documentsAndEditors.getDocument(l);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(m,l){const v=k.URI.revive(m),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");_._acceptIsDirty(l),this._onDidChangeDocument.fire({document:_.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,l,v){const _=k.URI.revive(m),b=this._documentsAndEditors.getDocument(_);if(!b)throw new Error("unknown document");b._acceptIsDirty(v),b.onEvents(l);let A;l.isUndoing?A=i.TextDocumentChangeReason.Undo:l.isRedoing&&(A=i.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:b.document,contentChanges:l.changes.map(c=>({range:C.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:A}))}setWordDefinitionFor(m,l){(0,T.setWordDefinitionFor)(m,l)}}e.ExtHostDocuments=I}),define(me[45],ge([0,1,54,3,6,2,4,5,123,13,129,15,12,22,10,74,139]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class b{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let A=class{constructor(h,p){this._extHostRpc=h,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const p=[],t=[],r=[];if(h.removedDocuments)for(const o of h.removedDocuments){const n=y.URI.revive(o),a=this._documents.get(n);a?.unref()&&(this._documents.delete(n),p.push(a.value))}if(h.addedDocuments)for(const o of h.addedDocuments){const n=y.URI.revive(o.uri);let a=this._documents.get(n);if(a&&n.scheme!==l.Schemas.vscodeNotebookCell&&n.scheme!==l.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);a||(a=new b(new S.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),n,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(n,a),t.push(a.value)),a.ref()}if(h.removedEditors)for(const o of h.removedEditors){const n=this._editors.get(o);this._editors.delete(o),n&&r.push(n)}if(h.addedEditors)for(const o of h.addedEditors){const n=y.URI.revive(o.documentUri);g.ok(this._documents.has(n),`document '${n}' does not exist`),g.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const a=this._documents.get(n).value,f=new i.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>a.document),o.selections.map(I.Selection.to),o.options,o.visibleRanges.map(d=>I.Range.to(d)),typeof o.editorPosition=="number"?I.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,f)}h.newActiveEditor!==void 0&&(g.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,k.dispose)(p),(0,k.dispose)(r),h.removedDocuments&&this._onDidRemoveDocuments.fire(p),h.addedDocuments&&this._onDidAddDocuments.fire(t),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return h?p:p?.value}allEditors(){return[...this._editors.values()]}};A=Ve([$e(0,P.IExtHostRpcService),$e(1,u.ILogService)],A),e.ExtHostDocumentsAndEditors=A,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[237],ge([0,1,2,5,6,7,15,147,8,24]),function(J,e,g,L,k,y,T,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const l=this._schemes.indexOf(m);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),l=[];let v,_,b=14,A=14;for(const c of m){let h=v?(0,S.commonPrefixLength)(v,c):0;for(h===0?_=1:_=A;h<c.length;h++)h+1===c.length?(b=A,A=9):A+=1,l.push([_,c.toUpperCase().charCodeAt(h),A]),l.push([_,c.toLowerCase().charCodeAt(h),A]),_=A;v=c,A=b}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new C.StateMachine(l)}}provideDocumentLinks(m){this._initStateMachine();const l=[],v=C.LinkComputer.computeLinks({getLineContent(_){return m.lineAt(_-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const _ of v){const b=T.DocumentLink.to(_);b.target&&l.push(b)}return l}}class I{constructor(m,l){this._extHostLanguageFeatures=l,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=m.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,l,v,_={},b){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const A=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(A,v),this._enableProposedApi.set(A,b??!1);let c=2;_.isCaseSensitive&&(c+=1024),_.isReadonly&&(c+=2048),typeof v.copy=="function"&&(c+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&(c+=4),this._proxy.$registerFileSystemProvider(A,l,c).catch(p=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${l}`),console.error(p)});const h=v.onDidChangeFile(p=>{const t=[];for(const r of p){let{uri:o,type:n}=r;if(o.scheme!==l)continue;let a;switch(n){case y.FileChangeType.Changed:a=0;break;case y.FileChangeType.Created:a=1;break;case y.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:o,type:a})}this._proxy.$onFileSystemChange(A,t)});return(0,k.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(A),this._enableProposedApi.delete(A),this._proxy.$unregisterProvider(A)})}static _asIStat(m,l){const{type:v,ctime:_,mtime:b,size:A,permissions:c}=m;return l?{type:v,ctime:_,mtime:b,size:A,permissions:c}:{type:v,ctime:_,mtime:b,size:A}}$stat(m,l){return Promise.resolve(this._getFsProvider(m).stat(g.URI.revive(l))).then(v=>I._asIStat(v,this._enableProposedApi.get(m)??!1))}$readdir(m,l){return Promise.resolve(this._getFsProvider(m).readDirectory(g.URI.revive(l)))}$readFile(m,l){return Promise.resolve(this._getFsProvider(m).readFile(g.URI.revive(l))).then(v=>P.VSBuffer.wrap(v))}$writeFile(m,l,v,_){return Promise.resolve(this._getFsProvider(m).writeFile(g.URI.revive(l),v.buffer,_))}$delete(m,l,v){return Promise.resolve(this._getFsProvider(m).delete(g.URI.revive(l),v))}$rename(m,l,v,_){return Promise.resolve(this._getFsProvider(m).rename(g.URI.revive(l),g.URI.revive(v),_))}$copy(m,l,v,_){const b=this._getFsProvider(m);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(g.URI.revive(l),g.URI.revive(v),_))}$mkdir(m,l){return Promise.resolve(this._getFsProvider(m).createDirectory(g.URI.revive(l)))}$watch(m,l,v,_){const b=this._getFsProvider(m).watch(g.URI.revive(v),_);this._watches.set(l,b)}$unwatch(m,l){const v=this._watches.get(l);v&&(v.dispose(),this._watches.delete(l))}$open(m,l,v){const _=this._getFsProvider(m);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(g.URI.revive(l),v))}$close(m,l){const v=this._getFsProvider(m);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(l))}$read(m,l,v,_){const b=this._getFsProvider(m);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const A=P.VSBuffer.alloc(_);return Promise.resolve(b.read(l,v,A.buffer,0,_)).then(c=>A.slice(0,c))}$write(m,l,v,_){const b=this._getFsProvider(m);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(l,v,_.buffer,0,_.byteLength))}_getFsProvider(m){const l=this._fsProvider.get(m);if(!l){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return l}}e.ExtHostFileSystem=I}),define(me[92],ge([0,1,5,42,7,24,4,13,62]),function(J,e,g,L,k,y,T,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Ut{constructor(I,u){const m=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(l){return m.$stat(l).catch(Ut._handleError)},readDirectory(l){return m.$readdir(l).catch(Ut._handleError)},createDirectory(l){return m.$mkdir(l).catch(Ut._handleError)},async readFile(l){return m.$readFile(l).then(v=>v.buffer).catch(Ut._handleError)},writeFile(l,v){return m.$writeFile(l,y.VSBuffer.wrap(v)).catch(Ut._handleError)},delete(l,v){return m.$delete(l,{recursive:!1,useTrash:!1,...v}).catch(Ut._handleError)},rename(l,v,_){return m.$rename(l,v,{overwrite:!1,..._}).catch(Ut._handleError)},copy(l,v,_){return m.$copy(l,v,{overwrite:!1,..._}).catch(Ut._handleError)},isWritableFileSystem(l){const v=u.getCapabilities(l);if(typeof v=="number")return!(v&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new k.FileSystemError(String(I));if(I.name==="ENOPRO")throw k.FileSystemError.Unavailable(I.message);switch(I.name){case L.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(I.message);case L.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(I.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(I.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(I.message);case L.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(I.message);case L.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(I.message);default:throw new k.FileSystemError(I.message,I.name)}}};P=Ve([$e(0,C.IExtHostRpcService),$e(1,S.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(me[238],ge([0,1,2,44]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(T,C,S,P){this._extHostNotebooks=C,this._textDocumentsAndEditors=S,this._commands=P;const i=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new L.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new L.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new L.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new L.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const u=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri),notebookEditor:u.apiEditor}}return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(i)}$willAddInteractiveDocument(T,C,S,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],modeId:S,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=k}),define(me[239],ge([0,1,6,5]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(T){this._handlePool=0,this._proxy=T.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,T),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=k}),define(me[240],ge([0,1,2,25,15,7,5,8,41,20,14,144,6,111,73,86,46,16,3]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class c{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentSymbols(W,Z){const ne=this._documents.getDocument(W),le=await this._provider.provideDocumentSymbols(ne,Z);if(!(0,P.isFalsyOrEmpty)(le))return le[0]instanceof y.DocumentSymbol?le.map(k.DocumentSymbol.from):c._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(W){W=W.slice(0).sort((le,Y)=>{let ae=le.location.range.start.compareTo(Y.location.range.start);return ae===0&&(ae=Y.location.range.end.compareTo(le.location.range.end)),ae});const Z=[],ne=[];for(const le of W){const Y={name:le.name||"!!MISSING: name!!",kind:k.SymbolKind.from(le.kind),tags:le.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:k.Range.from(le.location.range),selectionRange:k.Range.from(le.location.range),children:[]};for(;;){if(ne.length===0){ne.push(Y),Z.push(Y);break}const ae=ne[ne.length-1];if(S.Range.containsRange(ae.range,Y.range)&&!S.Range.equalsRange(ae.range,Y.range)){ae.children&&ae.children.push(Y),ne.push(Y);break}ne.pop()}}return Z}}class h{constructor(W,Z,ne){this._documents=W,this._commands=Z,this._provider=ne,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,Z){const ne=this._documents.getDocument(W),le=await this._provider.provideCodeLenses(ne,Z);if(!le||Z.isCancellationRequested)return;const Y=this._cache.add(le),ae=new u.DisposableStore;this._disposables.set(Y,ae);const ve={cacheId:Y,lenses:[]};for(let Me=0;Me<le.length;Me++)ve.lenses.push({cacheId:[Y,Me],range:k.Range.from(le[Me].range),command:this._commands.toInternal(le[Me].command,ae)});return ve}async resolveCodeLens(W,Z){const ne=W.cacheId&&this._cache.get(...W.cacheId);if(!ne)return;let le;if(typeof this._provider.resolveCodeLens!="function"||ne.isResolved?le=ne:le=await this._provider.resolveCodeLens(ne,Z),le||(le=ne),Z.isCancellationRequested)return;const Y=W.cacheId&&this._disposables.get(W.cacheId[0]);if(!!Y)return W.command=this._commands.toInternal(le.command??h._badCmd,Y),W}releaseCodeLenses(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(je){return Array.isArray(je)?je.map(k.DefinitionLink.from):je?[k.DefinitionLink.from(je)]:[]}class t{constructor(W,Z){this._documents=W,this._provider=Z}async provideDefinition(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideDefinition(le,Y,ne);return p(ae)}}class r{constructor(W,Z){this._documents=W,this._provider=Z}async provideDeclaration(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideDeclaration(le,Y,ne);return p(ae)}}class o{constructor(W,Z){this._documents=W,this._provider=Z}async provideImplementation(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideImplementation(le,Y,ne);return p(ae)}}class n{constructor(W,Z){this._documents=W,this._provider=Z}async provideTypeDefinition(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideTypeDefinition(le,Y,ne);return p(ae)}}class a{constructor(W,Z){this._documents=W,this._provider=Z}async provideHover(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideHover(le,Y,ne);if(!(!ae||(0,P.isFalsyOrEmpty)(ae.contents)))return ae.range||(ae.range=le.getWordRangeAtPosition(Y)),ae.range||(ae.range=new y.Range(Y,Y)),k.Hover.from(ae)}}class f{constructor(W,Z){this._documents=W,this._provider=Z}async provideEvaluatableExpression(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideEvaluatableExpression(le,Y,ne);if(ae)return k.EvaluatableExpression.from(ae)}}class d{constructor(W,Z){this._documents=W,this._provider=Z}async provideInlineValues(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=await this._provider.provideInlineValues(Y,k.Range.to(Z),k.InlineValueContext.to(ne),le);if(Array.isArray(ae))return ae.map(ve=>k.InlineValue.from(ve))}}class w{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentHighlights(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideDocumentHighlights(le,Y,ne);if(Array.isArray(ae))return ae.map(k.DocumentHighlight.from)}}class E{constructor(W,Z){this._documents=W,this._provider=Z}async provideLinkedEditingRanges(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.provideLinkedEditingRanges(le,Y,ne);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,P.coalesce)(ae.ranges.map(k.Range.from)),wordPattern:ae.wordPattern}}}class s{constructor(W,Z){this._documents=W,this._provider=Z}async provideReferences(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=k.Position.to(Z),ve=await this._provider.provideReferences(Y,ae,ne,le);if(Array.isArray(ve))return ve.map(k.location.from)}}class D{constructor(W,Z,ne,le,Y,ae,ve){this._documents=W,this._commands=Z,this._diagnostics=ne,this._provider=le,this._logService=Y,this._extension=ae,this._apiDeprecation=ve,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=I.Selection.isISelection(Z)?k.Selection.to(Z):k.Range.to(Z),ve=[];for(const se of this._diagnostics.getDiagnostics(W))if(ae.intersection(se.range)&&ve.push(se)>D._maxCodeActionsPerFile)break;const Me={diagnostics:ve,only:ne.only?new y.CodeActionKind(ne.only):void 0,triggerKind:k.CodeActionTriggerKind.to(ne.trigger)},ze=await this._provider.provideCodeActions(Y,ae,Me,le);if(!(0,P.isNonEmptyArray)(ze)||le.isCancellationRequested)return;const Ee=this._cache.add(ze),Je=new u.DisposableStore;this._disposables.set(Ee,Je);const X=[];for(let se=0;se<ze.length;se++){const fe=ze[se];!fe||(D._isCommand(fe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),X.push({_isSynthetic:!0,title:fe.title,command:this._commands.toInternal(fe,Je)})):(Me.only&&(fe.kind?Me.only.contains(fe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${fe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),X.push({cacheId:[Ee,se],title:fe.title,command:fe.command&&this._commands.toInternal(fe.command,Je),diagnostics:fe.diagnostics&&fe.diagnostics.map(k.Diagnostic.from),edit:fe.edit&&k.WorkspaceEdit.from(fe.edit),kind:fe.kind&&fe.kind.value,isPreferred:fe.isPreferred,disabled:fe.disabled?.reason})))}return{cacheId:Ee,actions:X}}async resolveCodeAction(W,Z){const[ne,le]=W,Y=this._cache.get(ne,le);if(!Y||D._isCommand(Y)||!this._provider.resolveCodeAction)return;const ae=await this._provider.resolveCodeAction(Y,Z)??Y;return ae?.edit?k.WorkspaceEdit.from(ae.edit):void 0}releaseCodeActions(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}D._maxCodeActionsPerFile=1e3;class R{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentFormattingEdits(W,Z,ne){const le=this._documents.getDocument(W),Y=await this._provider.provideDocumentFormattingEdits(le,Z,ne);if(Array.isArray(Y))return Y.map(k.TextEdit.from)}}class U{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentRangeFormattingEdits(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=k.Range.to(Z),ve=await this._provider.provideDocumentRangeFormattingEdits(Y,ae,ne,le);if(Array.isArray(ve))return ve.map(k.TextEdit.from)}}class V{constructor(W,Z){this._documents=W,this._provider=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,Z,ne,le,Y){const ae=this._documents.getDocument(W),ve=k.Position.to(Z),Me=await this._provider.provideOnTypeFormattingEdits(ae,ve,ne,le,Y);if(Array.isArray(Me))return Me.map(k.TextEdit.from)}}class ee{constructor(W,Z){this._provider=W,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(W,Z){const ne=T.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(W,Z);if((0,P.isNonEmptyArray)(le))for(const Y of le){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const ae=T.IdObject.mixin(k.WorkspaceSymbol.from(Y));this._symbolCache.set(ae._id,Y),ne.symbols.push(ae)}return ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne}async resolveWorkspaceSymbol(W,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return W;const ne=this._symbolCache.get(W._id);if(ne){const le=await this._provider.resolveWorkspaceSymbol(ne,Z);return le&&(0,L.mixin)(W,k.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(W){const Z=this._resultCache.get(W);if(Z){for(let[ne,le]=Z;ne<=le;ne++)this._symbolCache.delete(ne);this._resultCache.delete(W)}}}class K{constructor(W,Z,ne){this._documents=W,this._provider=Z,this._logService=ne}static supportsResolving(W){return typeof W.prepareRename=="function"}async provideRenameEdits(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=k.Position.to(Z);try{const ve=await this._provider.provideRenameEdits(Y,ae,ne,le);return ve?k.WorkspaceEdit.from(ve):void 0}catch(ve){const Me=K._asMessage(ve);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(W,Z,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(W),Y=k.Position.to(Z);try{const ae=await this._provider.prepareRename(le,Y,ne);let ve,Me;if(y.Range.isRange(ae)?(ve=ae,Me=le.getText(ae)):(0,i.isObject)(ae)&&(ve=ae.range,Me=ae.placeholder),!ve||!Me)return;if(ve.start.line>Y.line||ve.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(ve),text:Me}}catch(ae){const ve=K._asMessage(ae);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(ae)}}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class O{constructor(W,Z){this.resultId=W,this.tokens=Z}}class x{constructor(W,Z){this._documents=W,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(W,Z,ne){const le=this._documents.getDocument(W),Y=Z!==0?this._previousResults.get(Z):null;let ae=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,Y.resultId,ne):await this._provider.provideDocumentSemanticTokens(le,ne);return Y&&this._previousResults.delete(Z),ae?(ae=x._fixProvidedSemanticTokens(ae),this._send(x._convertToEdits(Y,ae),ae)):null}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return x._isSemanticTokens(W)?x._isCorrectSemanticTokens(W)?W:new y.SemanticTokens(new Uint32Array(W.data),W.resultId):x._isSemanticTokensEdits(W)?x._isCorrectSemanticTokensEdits(W)?W:new y.SemanticTokensEdits(W.edits.map(Z=>new y.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const Z of W.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,Z){if(!x._isSemanticTokens(Z)||!W||!W.tokens)return Z;const ne=W.tokens,le=ne.length,Y=Z.data,ae=Y.length;let ve=0;const Me=Math.min(le,ae);for(;ve<Me&&ne[ve]===Y[ve];)ve++;if(ve===le&&ve===ae)return new y.SemanticTokensEdits([],Z.resultId);let ze=0;const Ee=Me-ve;for(;ze<Ee&&ne[le-ze-1]===Y[ae-ze-1];)ze++;return new y.SemanticTokensEdits([{start:ve,deleteCount:le-ve-ze,data:Y.subarray(ve,ae-ze)}],Z.resultId)}_send(W,Z){if(x._isSemanticTokens(W)){const ne=this._nextResultId++;return this._previousResults.set(ne,new O(W.resultId,W.data)),(0,m.encodeSemanticTokensDto)({id:ne,type:"full",data:W.data})}if(x._isSemanticTokensEdits(W)){const ne=this._nextResultId++;return x._isSemanticTokens(Z)?this._previousResults.set(ne,new O(Z.resultId,Z.data)):this._previousResults.set(ne,new O(W.resultId)),(0,m.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(W.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class F{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentRangeSemanticTokens(W,Z,ne){const le=this._documents.getDocument(W),Y=await this._provider.provideDocumentRangeSemanticTokens(le,k.Range.to(Z),ne);return Y?this._send(Y):null}_send(W){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:W.data})}}e.DocumentRangeSemanticTokensAdapter=F;class z{constructor(W,Z,ne,le,Y){this._documents=W,this._commands=Z,this._provider=ne,this._apiDeprecation=le,this._extension=Y,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}async provideCompletionItems(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=k.Position.to(Z),ve=Y.getWordRangeAtPosition(ae)||new y.Range(ae,ae),Me=ve.with({end:ae}),ze=new _.StopWatch(!0),Ee=await this._provider.provideCompletionItems(Y,ae,le,k.CompletionContext.to(ne));if(!Ee||le.isCancellationRequested)return;const Je=Array.isArray(Ee)?new y.CompletionList(Ee):Ee,X=z.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),se=new u.DisposableStore;this._disposables.set(X,se);const fe=[],xe={x:X,b:fe,a:{replace:k.Range.from(ve),insert:k.Range.from(Me)},c:Je.isIncomplete||void 0,d:ze.elapsed()};for(let Be=0;Be<Je.items.length;Be++){const et=Je.items[Be],Ce=this._convertCompletionItem(et,[X,Be],Me,ve);fe.push(Ce)}return xe}async resolveCompletionItem(W,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...W);if(!ne)return;const le=await this._provider.resolveCompletionItem(ne,Z);if(!!le)return this._convertCompletionItem(le,W)}releaseCompletionItems(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,Z,ne,le){const Y=this._disposables.get(Z[0]);if(!Y)throw Error("DisposableStore is missing...");const ae={x:Z,a:W.label,b:W.kind!==void 0?k.CompletionItemKind.from(W.kind):void 0,n:W.tags&&W.tags.map(k.CompletionItemTag.from),c:W.detail,d:typeof W.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters,l:W.additionalTextEdits&&W.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(W.command,Y)};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=W.textEdit.newText):typeof W.insertText=="string"?ae.h=W.insertText:W.insertText instanceof y.SnippetString&&(ae.h=W.insertText.value,ae.i|=4);let ve;return W.textEdit?ve=W.textEdit.range:W.range&&(ve=W.range),y.Range.isRange(ve)?ae.j=k.Range.from(ve):ve&&(!ne?.isEqual(ve.inserting)||!le?.isEqual(ve.replacing))&&(ae.j={insert:k.Range.from(ve.inserting),replace:k.Range.from(ve.replacing)}),ae}}class M{constructor(W,Z,ne){this._documents=W,this._provider=Z,this._commands=ne,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=k.Position.to(Z),ve=await this._provider.provideInlineCompletionItems(Y,ae,ne,le);if(!ve||le.isCancellationRequested)return;const Me=(0,i.isArray)(ve)?{items:ve}:ve,ze=this._cache.add(Me.items);let Ee;return{pid:ze,items:Me.items.map((Je,X)=>{let se;return Je.command&&(Ee||(Ee=new u.DisposableStore,this._disposables.set(ze,Ee)),se=this._commands.toInternal(Je.command,Ee)),{text:Je.text,range:Je.range?k.Range.from(Je.range):void 0,command:se,idx:X}})}}disposeCompletions(W){this._cache.delete(W);const Z=this._disposables.get(W);Z&&Z.clear(),this._disposables.delete(W)}handleDidShowCompletionItem(W,Z){const ne=this._cache.get(W,Z);ne&&N.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class N{constructor(){this._onDidShowCompletionItemEmitter=new A.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(W){let Z=N.map.get(W);return Z||(Z=new N,N.map.set(W,Z)),Z}fireOnDidShowCompletionItem(W){this._onDidShowCompletionItemEmitter.fire(W)}}e.InlineCompletionController=N,N.map=new WeakMap;class q{constructor(W,Z){this._documents=W,this._provider=Z,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(W,Z,ne,le){const Y=this._documents.getDocument(W),ae=k.Position.to(Z),ve=this.reviveContext(ne),Me=await this._provider.provideSignatureHelp(Y,ae,le,ve);if(Me){const ze=this._cache.add([Me]);return{...k.SignatureHelp.from(Me),id:ze}}}reviveContext(W){let Z;if(W.activeSignatureHelp){const ne=k.SignatureHelp.to(W.activeSignatureHelp),le=this._cache.get(W.activeSignatureHelp.id,0);le?(Z=le,Z.activeSignature=ne.activeSignature,Z.activeParameter=ne.activeParameter):Z=ne}return{...W,activeSignatureHelp:Z}}releaseSignatureHelp(W){this._cache.delete(W)}}class B{constructor(W,Z){this._documents=W,this._provider=Z}async provideInlayHints(W,Z,ne){const le=this._documents.getDocument(W),Y=await this._provider.provideInlayHints(le,k.Range.to(Z),ne);return Y?{hints:Y.map(k.InlayHint.from)}:void 0}}class G{constructor(W,Z){this._documents=W,this._provider=Z,this._cache=new v.Cache("DocumentLink")}async provideLinks(W,Z){const ne=this._documents.getDocument(W),le=await this._provider.provideDocumentLinks(ne,Z);if(!(!Array.isArray(le)||le.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(G._validateLink).map(k.DocumentLink.from)};{const Y=this._cache.add(le),ae={links:[],id:Y};for(let ve=0;ve<le.length;ve++){if(!G._validateLink(le[ve]))continue;const Me=k.DocumentLink.from(le[ve]);Me.cacheId=[Y,ve],ae.links.push(Me)}return ae}}}static _validateLink(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const ne=this._cache.get(...W);if(!ne)return;const le=await this._provider.resolveDocumentLink(ne,Z);if(!(!le||!G._validateLink(le)))return k.DocumentLink.from(le)}releaseLinks(W){this._cache.delete(W)}}class re{constructor(W,Z){this._documents=W,this._provider=Z}async provideColors(W,Z){const ne=this._documents.getDocument(W),le=await this._provider.provideDocumentColors(ne,Z);return Array.isArray(le)?le.map(ae=>({color:k.Color.from(ae.color),range:k.Range.from(ae.range)})):[]}async provideColorPresentations(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Range.to(Z.range),ae=k.Color.to(Z.color),ve=await this._provider.provideColorPresentations(ae,{document:le,range:Y},ne);if(!!Array.isArray(ve))return ve.map(k.ColorPresentation.from)}}class he{constructor(W,Z){this._documents=W,this._provider=Z}async provideFoldingRanges(W,Z,ne){const le=this._documents.getDocument(W),Y=await this._provider.provideFoldingRanges(le,Z,ne);if(!!Array.isArray(Y))return Y.map(k.FoldingRange.from)}}class ye{constructor(W,Z,ne){this._documents=W,this._provider=Z,this._logService=ne}async provideSelectionRanges(W,Z,ne){const le=this._documents.getDocument(W),Y=Z.map(k.Position.to),ae=await this._provider.provideSelectionRanges(le,Y,ne);if(!(0,P.isNonEmptyArray)(ae))return[];if(ae.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Me=0;Me<Y.length;Me++){const ze=[];ve.push(ze);let Ee=Y[Me],Je=ae[Me];for(;;){if(!Je.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(ze.push(k.SelectionRange.from(Je)),!Je.parent)break;Ee=Je.range,Je=Je.parent}}return ve}}class Ie{constructor(W,Z){this._documents=W,this._provider=Z,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.prepareCallHierarchy(le,Y,ne);if(!ae)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ae)?ae.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,ae)]}async provideCallsTo(W,Z,ne){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(le,ne);if(!!Y)return Y.map(ae=>({from:this._cacheAndConvertItem(W,ae.from),fromRanges:ae.fromRanges.map(ve=>k.Range.from(ve))}))}async provideCallsFrom(W,Z,ne){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(le,ne);if(!!Y)return Y.map(ae=>({to:this._cacheAndConvertItem(W,ae.to),fromRanges:ae.fromRanges.map(ve=>k.Range.from(ve))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Z){const ne=this._cache.get(W),le=k.CallHierarchyItem.from(Z,W,ne.size.toString(36));return ne.set(le._itemId,Z),le}_itemFromCache(W,Z){return this._cache.get(W)?.get(Z)}}class Le{constructor(W,Z){this._documents=W,this._provider=Z,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(W,Z,ne){const le=this._documents.getDocument(W),Y=k.Position.to(Z),ae=await this._provider.prepareTypeHierarchy(le,Y,ne);if(!ae)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(ae)?ae.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,ae)]}async provideSupertypes(W,Z,ne){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(le,ne);if(!!Y)return Y.map(ae=>this._cacheAndConvertItem(W,ae))}async provideSubtypes(W,Z,ne){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(le,ne);if(!!Y)return Y.map(ae=>this._cacheAndConvertItem(W,ae))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Z){const ne=this._cache.get(W),le=k.TypeHierarchyItem.from(Z,W,ne.size.toString(36));return ne.set(le._itemId,Z),le}_itemFromCache(W,Z){return this._cache.get(W)?.get(Z)}}class qe{constructor(W,Z){this.adapter=W,this.extension=Z}}class We{constructor(W,Z,ne,le,Y,ae,ve){this._adapter=new Map,this._uriTransformer=Z,this._proxy=W.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=le,this._diagnostics=Y,this._logService=ae,this._apiDeprecation=ve}_transformDocumentSelector(W){return(0,P.coalesce)((0,P.asArray)(W).map(Z=>this._doTransformDocumentSelector(Z)))}_doTransformDocumentSelector(W){if(typeof W=="string")return{$serialized:!0,language:W};if(W)return{$serialized:!0,language:W.language,scheme:this._transformScheme(W.scheme),pattern:typeof W.pattern=="undefined"?void 0:k.GlobPattern.from(W.pattern),exclusive:W.exclusive}}_transformScheme(W){return this._uriTransformer&&typeof W=="string"?this._uriTransformer.transformOutgoingScheme(W):W}_createDisposable(W){return new y.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return We._handlePool++}_withAdapter(W,Z,ne,le,Y=!1){const ae=this._adapter.get(W);if(!ae)return Promise.resolve(le);if(ae.adapter instanceof Z){let ve;ae.extension&&(ve=Date.now(),this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Me=ne(ae.adapter,ae.extension),ze=ae.extension;return ze&&Promise.resolve(Me).then(()=>this._logService.trace(`[${ze.identifier.value}] provider DONE after ${Date.now()-ve}ms`),Ee=>{Y&&Ee instanceof b.CancellationError||(this._logService.error(`[${ze.identifier.value}] provider FAILED`),this._logService.error(Ee))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(W,Z){const ne=this._nextHandle();return this._adapter.set(ne,new qe(W,Z)),ne}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,Z,ne,le){const Y=this._addNewAdapter(new c(this._documents,ne),W),ae=le&&le.label||We._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(Z),ae),this._createDisposable(Y)}$provideDocumentSymbols(W,Z,ne){return this._withAdapter(W,c,le=>le.provideDocumentSymbols(g.URI.revive(Z),ne),void 0)}registerCodeLensProvider(W,Z,ne){const le=this._nextHandle(),Y=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new qe(new h(this._documents,this._commands.converter,ne),W)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(Z),Y);let ae=this._createDisposable(le);if(Y!==void 0){const ve=ne.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Y));ae=y.Disposable.from(ae,ve)}return ae}$provideCodeLenses(W,Z,ne){return this._withAdapter(W,h,le=>le.provideCodeLenses(g.URI.revive(Z),ne),void 0)}$resolveCodeLens(W,Z,ne){return this._withAdapter(W,h,le=>le.resolveCodeLens(Z,ne),void 0)}$releaseCodeLenses(W,Z){this._withAdapter(W,h,ne=>Promise.resolve(ne.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(W,Z,ne){const le=this._addNewAdapter(new t(this._documents,ne),W);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDefinition(W,Z,ne,le){return this._withAdapter(W,t,Y=>Y.provideDefinition(g.URI.revive(Z),ne,le),[])}registerDeclarationProvider(W,Z,ne){const le=this._addNewAdapter(new r(this._documents,ne),W);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDeclaration(W,Z,ne,le){return this._withAdapter(W,r,Y=>Y.provideDeclaration(g.URI.revive(Z),ne,le),[])}registerImplementationProvider(W,Z,ne){const le=this._addNewAdapter(new o(this._documents,ne),W);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideImplementation(W,Z,ne,le){return this._withAdapter(W,o,Y=>Y.provideImplementation(g.URI.revive(Z),ne,le),[])}registerTypeDefinitionProvider(W,Z,ne){const le=this._addNewAdapter(new n(this._documents,ne),W);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideTypeDefinition(W,Z,ne,le){return this._withAdapter(W,n,Y=>Y.provideTypeDefinition(g.URI.revive(Z),ne,le),[])}registerHoverProvider(W,Z,ne,le){const Y=this._addNewAdapter(new a(this._documents,ne),W);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideHover(W,Z,ne,le){return this._withAdapter(W,a,Y=>Y.provideHover(g.URI.revive(Z),ne,le),void 0)}registerEvaluatableExpressionProvider(W,Z,ne,le){const Y=this._addNewAdapter(new f(this._documents,ne),W);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideEvaluatableExpression(W,Z,ne,le){return this._withAdapter(W,f,Y=>Y.provideEvaluatableExpression(g.URI.revive(Z),ne,le),void 0)}registerInlineValuesProvider(W,Z,ne,le){const Y=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new d(this._documents,ne),W);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(Z),Y);let ve=this._createDisposable(ae);if(Y!==void 0){const Me=ne.onDidChangeInlineValues(ze=>this._proxy.$emitInlineValuesEvent(Y));ve=y.Disposable.from(ve,Me)}return ve}$provideInlineValues(W,Z,ne,le,Y){return this._withAdapter(W,d,ae=>ae.provideInlineValues(g.URI.revive(Z),ne,le,Y),void 0)}registerDocumentHighlightProvider(W,Z,ne){const le=this._addNewAdapter(new w(this._documents,ne),W);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDocumentHighlights(W,Z,ne,le){return this._withAdapter(W,w,Y=>Y.provideDocumentHighlights(g.URI.revive(Z),ne,le),void 0)}registerLinkedEditingRangeProvider(W,Z,ne){const le=this._addNewAdapter(new E(this._documents,ne),W);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideLinkedEditingRanges(W,Z,ne,le){return this._withAdapter(W,E,async Y=>{const ae=await Y.provideLinkedEditingRanges(g.URI.revive(Z),ne,le);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?We._serializeRegExp(ae.wordPattern):void 0}},void 0)}registerReferenceProvider(W,Z,ne){const le=this._addNewAdapter(new s(this._documents,ne),W);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideReferences(W,Z,ne,le,Y){return this._withAdapter(W,s,ae=>ae.provideReferences(g.URI.revive(Z),ne,le,Y),void 0)}registerCodeActionProvider(W,Z,ne,le){const Y=new u.DisposableStore,ae=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(ae,this._transformDocumentSelector(Z),{providedKinds:le?.providedCodeActionKinds?.map(ve=>ve.value),documentation:le?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,Y)}))},We._extLabel(W),Boolean(ne.resolveCodeAction)),Y.add(this._createDisposable(ae)),Y}$provideCodeActions(W,Z,ne,le,Y){return this._withAdapter(W,D,ae=>ae.provideCodeActions(g.URI.revive(Z),ne,le,Y),void 0)}$resolveCodeAction(W,Z,ne){return this._withAdapter(W,D,le=>le.resolveCodeAction(Z,ne),void 0)}$releaseCodeActions(W,Z){this._withAdapter(W,D,ne=>Promise.resolve(ne.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(W,Z,ne){const le=this._addNewAdapter(new R(this._documents,ne),W);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(Z),W.identifier,W.displayName||W.name),this._createDisposable(le)}$provideDocumentFormattingEdits(W,Z,ne,le){return this._withAdapter(W,R,Y=>Y.provideDocumentFormattingEdits(g.URI.revive(Z),ne,le),void 0)}registerDocumentRangeFormattingEditProvider(W,Z,ne){const le=this._addNewAdapter(new U(this._documents,ne),W);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(Z),W.identifier,W.displayName||W.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(W,Z,ne,le,Y){return this._withAdapter(W,U,ae=>ae.provideDocumentRangeFormattingEdits(g.URI.revive(Z),ne,le,Y),void 0)}registerOnTypeFormattingEditProvider(W,Z,ne,le){const Y=this._addNewAdapter(new V(this._documents,ne),W);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(Z),le,W.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(W,Z,ne,le,Y,ae){return this._withAdapter(W,V,ve=>ve.provideOnTypeFormattingEdits(g.URI.revive(Z),ne,le,Y,ae),void 0)}registerWorkspaceSymbolProvider(W,Z){const ne=this._addNewAdapter(new ee(Z,this._logService),W);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(W,Z,ne){return this._withAdapter(W,ee,le=>le.provideWorkspaceSymbols(Z,ne),{symbols:[]})}$resolveWorkspaceSymbol(W,Z,ne){return this._withAdapter(W,ee,le=>le.resolveWorkspaceSymbol(Z,ne),void 0)}$releaseWorkspaceSymbols(W,Z){this._withAdapter(W,ee,ne=>ne.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(W,Z,ne){const le=this._addNewAdapter(new K(this._documents,ne,this._logService),W);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(Z),K.supportsResolving(ne)),this._createDisposable(le)}$provideRenameEdits(W,Z,ne,le,Y){return this._withAdapter(W,K,ae=>ae.provideRenameEdits(g.URI.revive(Z),ne,le,Y),void 0)}$resolveRenameLocation(W,Z,ne,le){return this._withAdapter(W,K,Y=>Y.resolveRenameLocation(g.URI.revive(Z),ne,le),void 0)}registerDocumentSemanticTokensProvider(W,Z,ne,le){const Y=this._nextHandle(),ae=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new qe(new x(this._documents,ne),W)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(Z),le,ae);let ve=this._createDisposable(Y);if(ae){const Me=ne.onDidChangeSemanticTokens(ze=>this._proxy.$emitDocumentSemanticTokensEvent(ae));ve=y.Disposable.from(ve,Me)}return ve}$provideDocumentSemanticTokens(W,Z,ne,le){return this._withAdapter(W,x,Y=>Y.provideDocumentSemanticTokens(g.URI.revive(Z),ne,le),null,!0)}$releaseDocumentSemanticTokens(W,Z){this._withAdapter(W,x,ne=>ne.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(W,Z,ne,le){const Y=this._addNewAdapter(new F(this._documents,ne),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(Z),le),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(W,Z,ne,le){return this._withAdapter(W,F,Y=>Y.provideDocumentRangeSemanticTokens(g.URI.revive(Z),ne,le),null,!0)}registerCompletionItemProvider(W,Z,ne,le){const Y=this._addNewAdapter(new z(this._documents,this._commands.converter,ne,this._apiDeprecation,W),W);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(Z),le,z.supportsResolving(ne),`${W.identifier.value}(${le.join("")})`),this._createDisposable(Y)}$provideCompletionItems(W,Z,ne,le,Y){return this._withAdapter(W,z,ae=>ae.provideCompletionItems(g.URI.revive(Z),ne,le,Y),void 0)}$resolveCompletionItem(W,Z,ne){return this._withAdapter(W,z,le=>le.resolveCompletionItem(Z,ne),void 0)}$releaseCompletionItems(W,Z){this._withAdapter(W,z,ne=>ne.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(W,Z,ne){const le=this._addNewAdapter(new M(this._documents,ne,this._commands.converter),W);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideInlineCompletions(W,Z,ne,le,Y){return this._withAdapter(W,M,ae=>ae.provideInlineCompletions(g.URI.revive(Z),ne,le,Y),void 0)}$handleInlineCompletionDidShow(W,Z,ne){this._withAdapter(W,M,async le=>{le.handleDidShowCompletionItem(Z,ne)},void 0)}$freeInlineCompletionsList(W,Z){this._withAdapter(W,M,async ne=>{ne.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(W,Z,ne,le){const Y=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,ae=this._addNewAdapter(new q(this._documents,ne),W);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(Z),Y),this._createDisposable(ae)}$provideSignatureHelp(W,Z,ne,le,Y){return this._withAdapter(W,q,ae=>ae.provideSignatureHelp(g.URI.revive(Z),ne,le,Y),void 0)}$releaseSignatureHelp(W,Z){this._withAdapter(W,q,ne=>ne.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(W,Z,ne){const le=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new B(this._documents,ne),W);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(Z),le);let ae=this._createDisposable(Y);if(le!==void 0){const ve=ne.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(le));ae=y.Disposable.from(ae,ve)}return ae}$provideInlayHints(W,Z,ne,le){return this._withAdapter(W,B,Y=>Y.provideInlayHints(g.URI.revive(Z),ne,le),void 0)}registerDocumentLinkProvider(W,Z,ne){const le=this._addNewAdapter(new G(this._documents,ne),W);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(Z),typeof ne.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(W,Z,ne){return this._withAdapter(W,G,le=>le.provideLinks(g.URI.revive(Z),ne),void 0)}$resolveDocumentLink(W,Z,ne){return this._withAdapter(W,G,le=>le.resolveLink(Z,ne),void 0)}$releaseDocumentLinks(W,Z){this._withAdapter(W,G,ne=>ne.releaseLinks(Z),void 0)}registerColorProvider(W,Z,ne){const le=this._addNewAdapter(new re(this._documents,ne),W);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDocumentColors(W,Z,ne){return this._withAdapter(W,re,le=>le.provideColors(g.URI.revive(Z),ne),[])}$provideColorPresentations(W,Z,ne,le){return this._withAdapter(W,re,Y=>Y.provideColorPresentations(g.URI.revive(Z),ne,le),void 0)}registerFoldingRangeProvider(W,Z,ne){const le=this._nextHandle(),Y=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new qe(new he(this._documents,ne),W)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(Z),Y);let ae=this._createDisposable(le);if(Y!==void 0){const ve=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));ae=y.Disposable.from(ae,ve)}return ae}$provideFoldingRanges(W,Z,ne,le){return this._withAdapter(W,he,Y=>Y.provideFoldingRanges(g.URI.revive(Z),ne,le),void 0)}registerSelectionRangeProvider(W,Z,ne){const le=this._addNewAdapter(new ye(this._documents,ne,this._logService),W);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideSelectionRanges(W,Z,ne,le){return this._withAdapter(W,ye,Y=>Y.provideSelectionRanges(g.URI.revive(Z),ne,le),[])}registerCallHierarchyProvider(W,Z,ne){const le=this._addNewAdapter(new Ie(this._documents,ne),W);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$prepareCallHierarchy(W,Z,ne,le){return this._withAdapter(W,Ie,Y=>Promise.resolve(Y.prepareSession(g.URI.revive(Z),ne,le)),void 0)}$provideCallHierarchyIncomingCalls(W,Z,ne,le){return this._withAdapter(W,Ie,Y=>Y.provideCallsTo(Z,ne,le),void 0)}$provideCallHierarchyOutgoingCalls(W,Z,ne,le){return this._withAdapter(W,Ie,Y=>Y.provideCallsFrom(Z,ne,le),void 0)}$releaseCallHierarchy(W,Z){this._withAdapter(W,Ie,ne=>Promise.resolve(ne.releaseSession(Z)),void 0)}registerTypeHierarchyProvider(W,Z,ne){const le=this._addNewAdapter(new Le(this._documents,ne),W);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$prepareTypeHierarchy(W,Z,ne,le){return this._withAdapter(W,Le,Y=>Promise.resolve(Y.prepareSession(g.URI.revive(Z),ne,le)),void 0)}$provideTypeHierarchySupertypes(W,Z,ne,le){return this._withAdapter(W,Le,Y=>Y.provideSupertypes(Z,ne,le),void 0)}$provideTypeHierarchySubtypes(W,Z,ne,le){return this._withAdapter(W,Le,Y=>Y.provideSubtypes(Z,ne,le),void 0)}$releaseTypeHierarchy(W,Z){this._withAdapter(W,Le,ne=>Promise.resolve(ne.releaseSession(Z)),void 0)}static _serializeRegExp(W){return{pattern:W.source,flags:(0,C.regExpFlags)(W)}}static _serializeIndentationRule(W){return{decreaseIndentPattern:We._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:We._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?We._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?We._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:We._serializeRegExp(W.beforeText),afterText:W.afterText?We._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?We._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(We._serializeOnEnterRule)}setLanguageConfiguration(W,Z,ne){let{wordPattern:le}=ne;if(le&&(0,C.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(Z,le):this._documents.setWordDefinitionFor(Z,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const Y=this._nextHandle(),ae={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?We._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?We._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?We._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,Z,ae),this._createDisposable(Y)}$setWordDefinitions(W){for(const Z of W)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=We,We._handlePool=0}),define(me[241],ge([0,1,5,15,7,48,17]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(P,i){this._handlePool=0,this._proxy=P.getProxy(g.MainContext.MainThreadLanguages),this._documents=i}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,i){await this._proxy.$changeLanguage(P,i);const I=this._documents.getDocumentData(P);if(!I)throw new Error(`document '${P.toString}' NOT found`);return I.document}async tokenAtPosition(P,i){const I=P.version,u=L.Position.from(i),m=await this._proxy.$tokensAtPosition(P.uri,u),l={type:k.StandardTokenType.Other,range:P.getWordRangeAtPosition(i)??new k.Range(i.line,i.character,i.line,i.character)};if(!m)return l;const v={range:L.Range.to(m.range),type:L.TokenType.to(m.type)};return!v.range.contains(i)||I!==P.version?l:v}createLanguageStatusItem(P){const i=this._handlePool++,I=this._proxy,u={selector:P,text:"",detail:"",severity:k.LanguageStatusSeverity.Information};let m;const l=()=>{m?.dispose(),m=(0,T.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(i,{selector:u.selector,text:u.text,message:typeof u.detail=="string"?u.detail:L.MarkdownString.from(u.detail),severity:u.severity===k.LanguageStatusSeverity.Error?y.default.Error:u.severity===k.LanguageStatusSeverity.Warning?y.default.Warning:y.default.Info})},0)},v={get selector(){return u.selector},set selector(_){u.selector=_,l()},get text(){return u.text},set text(_){u.text=_,l()},get detail(){return u.detail},set detail(_){u.detail=_,l()},get severity(){return u.severity},set severity(_){u.severity=_,l()},dispose(){m?.dispose(),I.$removeLanguageStatus(i)}};return l(),v}}e.ExtHostLanguages=C}),define(me[242],ge([0,1,5,12,35]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(C){return C&&C.title}let T=class{constructor(S,P){this._logService=P,this._proxy=S.getProxy(g.MainContext.MainThreadMessageService)}showMessage(S,P,i,I,u){const m={extension:S};let l;typeof I=="string"||y(I)?l=[I,...u]:(m.modal=I?.modal,m.useCustom=I?.useCustom,m.detail=I?.detail,l=u),m.useCustom&&(0,k.checkProposedApiEnabled)(S);const v=[];for(let _=0;_<l.length;_++){const b=l[_];if(typeof b=="string")v.push({title:b,handle:_,isCloseAffordance:!1});else if(typeof b=="object"){let{title:A,isCloseAffordance:c}=b;v.push({title:A,isCloseAffordance:!!c,handle:_})}else this._logService.warn("Invalid message item:",b)}return this._proxy.$showMessage(P,i,m,v).then(_=>{if(typeof _=="number")return l[_]})}};T=Ve([$e(1,L.ILogService)],T),e.ExtHostMessageService=T}),define(me[243],ge([0,1,24,3,58,6,22,8,14,2,86,5,15,7,218,128]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class _{constructor(A,c,h,p,t){this._textDocumentsAndEditors=h,this._textDocuments=p,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=A.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=A.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=A.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const o=r.notebookEditor?.notebookUri,n=r.cell.handle,f=this._documents.get(o)?.getCell(n);if(f)return f.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(A=>A.apiEditor)}getEditorById(A){const c=this._editors.get(A);if(!c)throw new Error(`unknown text editor: ${A}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(A){for(const[c,h]of this._editors)if(h.apiEditor===A)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(A,c){const h=this._documents.get(A);if(!h&&!c)throw new Error(`NO notebook document for '${A}'`);return h}_getProviderData(A){const c=this._notebookContentProviders.get(A);if(!c)throw new Error(`NO provider for '${A}'`);return c}registerNotebookContentProvider(A,c,h,p,t){if((0,C.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:A,provider:h});let r;return h.onDidChangeNotebookContentOptions&&(r=h.onDidChangeNotebookContentOptions(()=>{const o=u.NotebookDocumentContentOptions.from(h.options);this._notebookProxy.$updateNotebookProviderOptions(c,o)})),this._notebookProxy.$registerNotebookProvider({id:A.identifier,location:A.extensionLocation},c,u.NotebookDocumentContentOptions.from(p),_._convertNotebookRegistrationData(A,t)),new m.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(A,c){if(!c)return;const h=c.filenamePattern.map(p=>u.NotebookExclusiveDocumentPattern.from(p)).filter(p=>p!==void 0);if(c.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:A.identifier,providerDisplayName:A.displayName||A.name,displayName:c.displayName,filenamePattern:h,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(A,c,h){const p=_._notebookStatusBarItemProviderHandlePool++,t=typeof h.onDidChangeCellStatusBarItems=="function"?_._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(p,h),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(p,t,c);let r;return t!==void 0&&(r=h.onDidChangeCellStatusBarItems(o=>this._notebookProxy.$emitCellStatusBarEvent(t))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(p),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(p,t),r&&r.dispose()})}async createNotebookDocument(A){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:A.viewType,content:A.content&&u.NotebookData.from(A.content)});return P.URI.revive(c)}async openNotebookDocument(A){const c=this._documents.get(A);if(c)return c.apiNotebook;const h=await this._notebookDocumentsProxy.$tryOpenNotebook(A),p=this._documents.get(P.URI.revive(h));return(0,S.assertIsDefined)(p?.apiNotebook)}async showNotebookDocument(A,c){P.URI.isUri(A)&&(A=await this.openNotebookDocument(A));let h;typeof c=="object"?h={position:u.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(u.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:h={preserveFocus:!1};const p=await this._notebookEditorsProxy.$tryShowNotebookDocument(A.uri,A.notebookType,h),t=p&&this._editors.get(p)?.apiEditor;if(t)return t;throw p?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(A,c,h,p){const t=this._notebookStatusBarItemProviders.get(A),r=P.URI.revive(c),o=this._documents.get(r);if(!o||!t)return;const n=o.getCellFromIndex(h);if(!n)return;const a=await t.provideCellStatusBarItems(n.apiCell,p);if(!a)return;const f=new y.DisposableStore,d=this._statusBarCache.add([f]),E=(Array.isArray(a)?a:[a]).map(s=>u.NotebookStatusBarItem.from(s,this._commandsConverter,f));return{cacheId:d,items:E}}$releaseNotebookCellStatusBarItems(A){this._statusBarCache.delete(A)}registerNotebookSerializer(A,c,h,p,t){if((0,C.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,h),this._notebookProxy.$registerNotebookSerializer(r,{id:A.identifier,location:A.extensionLocation},c,u.NotebookDocumentContentOptions.from(p),_._convertNotebookRegistrationData(A,t)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(A,c,h){const p=this._notebookSerializer.get(A);if(!p)throw new Error("NO serializer found");const t=await p.deserializeNotebook(c.buffer,h);return u.NotebookData.from(t)}async $notebookToData(A,c,h){const p=this._notebookSerializer.get(A);if(!p)throw new Error("NO serializer found");const t=await p.serializeNotebook(u.NotebookData.to(c),h);return g.VSBuffer.wrap(t)}async $openNotebook(A,c,h,p,t){const{provider:r}=this._getProviderData(A),o=await r.openNotebook(P.URI.revive(c),{backupId:h,untitledDocumentData:p?.buffer},t);return{metadata:o.metadata??Object.create(null),cells:o.cells.map(u.NotebookCellData.from)}}async $saveNotebook(A,c,h){const p=this.getNotebookDocument(P.URI.revive(c)),{provider:t}=this._getProviderData(A);return await t.saveNotebook(p.apiNotebook,h),!0}async $saveNotebookAs(A,c,h,p){const t=this.getNotebookDocument(P.URI.revive(c)),{provider:r}=this._getProviderData(A);return await r.saveNotebookAs(P.URI.revive(h),t.apiNotebook,p),!0}async $backupNotebook(A,c,h){const p=this.getNotebookDocument(P.URI.revive(c)),t=this._getProviderData(A),r=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),o=String((0,k.hash)([p.uri.toString(),this._backupIdPool++])),n=P.URI.joinPath(r,o),a=await t.provider.backupNotebook(p.apiNotebook,{destination:n},h);return p.updateBackup(a),a.id}_createExtHostEditor(A,c,h){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const p=new v.ExtHostNotebookEditor(c,this._notebookEditorsProxy,A,h.visibleRanges.map(u.NotebookRange.to),h.selections.map(u.NotebookRange.to),typeof h.viewColumn=="number"?u.ViewColumn.to(h.viewColumn):void 0);this._editors.set(c,p)}$acceptDocumentAndEditorsDelta(A){if(A.removedDocuments)for(const h of A.removedDocuments){const p=P.URI.revive(h),t=this._documents.get(p);t&&(t.dispose(),this._documents.delete(p),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===p.toString()&&this._editors.delete(r.id)}if(A.addedDocuments){const h=[];for(const p of A.addedDocuments){const t=P.URI.revive(p.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const r=this,o=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(n){r._onDidChangeNotebookCells.fire(n)},emitCellOutputsChange(n){r._onDidChangeCellOutputs.fire(n)},emitCellMetadataChange(n){r._onDidChangeCellMetadata.fire(n)},emitCellExecutionStateChange(n){r._onDidChangeCellExecutionState.fire(n)}},t,p);h.push(...p.cells.map(n=>l.ExtHostCell.asModelAddData(o.apiNotebook,n))),this._documents.get(t)?.dispose(),this._documents.set(t,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:h}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(A.addedEditors)for(const h of A.addedEditors){if(this._editors.has(h.id))return;const p=P.URI.revive(h.documentUri),t=this._documents.get(p);t&&this._createExtHostEditor(t,h.id,h)}const c=[];if(A.removedEditors)for(const h of A.removedEditors){const p=this._editors.get(h);p&&(this._editors.delete(h),this._activeNotebookEditor?.id===p.id&&(this._activeNotebookEditor=void 0),c.push(p))}if(A.visibleEditors){this._visibleNotebookEditors=A.visibleEditors.map(p=>this._editors.get(p)).filter(p=>!!p);const h=new Set;this._visibleNotebookEditors.forEach(p=>h.add(p.id));for(const p of this._editors.values()){const t=h.has(p.id);p._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(p=>p).filter(p=>p.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}A.newActiveEditor===null?this._activeNotebookEditor=void 0:A.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(A.newActiveEditor)),A.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=_,_._notebookStatusBarItemProviderHandlePool=0}),define(me[244],ge([0,1,3,73,12,5,13,15]),function(J,e,g,L,k,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(I,u){const m=S._Keys.nextId();I.$registerNotebookEditorDecorationType(m,C.NotebookDecorationRenderOptions.from(u)),this.value={key:m,dispose(){I.$removeNotebookEditorDecorationType(m)}}}}S._Keys=new L.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(I,u,m){this._logService=I,this._extHostRpc=u,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new S(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,u){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,u);const m=this._notebooksAndEditors.getEditorById(I);u.visibleRanges&&m._acceptVisibleRanges(u.visibleRanges.ranges.map(C.NotebookRange.to)),u.selections&&m._acceptSelections(u.selections.selections.map(C.NotebookRange.to)),u.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),u.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const u in I)this._notebooksAndEditors.getEditorById(u)._acceptViewColumn(C.ViewColumn.to(I[u]))}};P=Ve([$e(0,k.ILogService),$e(1,T.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(me[245],ge([0,1,3,6,5,26,2,15,88,22,17,89,21,20,12,7,35]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(t,r,o,n){this._initData=r,this._extHostNotebook=o,this._logService=n,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(k.MainContext.MainThreadNotebookKernels)}createNotebookController(t,r,o,n,a,f){for(let M of this._kernelData.values())if(M.controller.id===r&&y.ExtensionIdentifier.equals(t.identifier,M.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const d=this._handlePool++,w=this;this._logService.trace(`NotebookController[${d}], CREATED by ${t.identifier.value}, ${r}`);const E=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${t.identifier}'`);let s=!1;const D=new L.DisposableStore,R=new g.Emitter,U=new g.Emitter,V={id:`${t.identifier.value}/${r}`,notebookType:o,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:n||t.identifier.value,preloads:f?f.map(C.NotebookRendererScript.from):[]};let ee=a??E,K;this._proxy.$addKernel(d,V).catch(M=>{console.log(M),s=!0});let O=0;const x=()=>{if(s)return;const M=++O;Promise.resolve().then(()=>{M===O&&this._proxy.$updateKernel(d,V)})},F=new P.ResourceMap,z={get id(){return r},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return V.label},set label(M){V.label=M??t.displayName??t.name,x()},get detail(){return V.detail??""},set detail(M){V.detail=M,x()},get description(){return V.description??""},set description(M){V.description=M,x()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(M){V.supportedLanguages=M,x()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(M){V.supportsExecutionOrder=M,x()},get rendererScripts(){return V.preloads?V.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return ee},set executeHandler(M){ee=M??E},get interruptHandler(){return K},set interruptHandler(M){K=M,V.supportsInterrupt=Boolean(M),x()},createNotebookCellExecution(M){if(s)throw new Error("notebook controller is DISPOSED");if(!F.has(M.notebook.uri))throw w._logService.trace(`NotebookController[${d}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(F.keys()).map(N=>N.toString())),new Error(`notebook controller is NOT associated to notebook: ${M.notebook.uri.toString()}`);return w._createNotebookCellExecution(M)},dispose:()=>{s||(this._logService.trace(`NotebookController[${d}], DISPOSED`),s=!0,this._kernelData.delete(d),D.dispose(),R.dispose(),U.dispose(),this._proxy.$removeKernel(d))},updateNotebookAffinity(M,N){w._proxy.$updateNotebookPriority(d,M.uri,N)},onDidReceiveMessage:U.event,postMessage(M,N){return(0,_.checkProposedApiEnabled)(t),w._proxy.$postMessage(d,N&&w._extHostNotebook.getIdByEditor(N),M)},asWebviewUri(M){return(0,_.checkProposedApiEnabled)(t),(0,S.asWebviewUri)(M,w._initData.remote)}};return this._kernelData.set(d,{extensionId:t.identifier,controller:z,onDidReceiveMessage:U,onDidChangeSelection:R,associatedNotebooks:F}),z}$acceptNotebookAssociation(t,r,o){const n=this._kernelData.get(t);if(n){const a=this._extHostNotebook.getNotebookDocument(T.URI.revive(r));o?n.associatedNotebooks.set(a.uri,!0):n.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,a.uri.toString(),o),n.onDidChangeSelection.fire({selected:o,notebook:a.apiNotebook})}}async $executeCells(t,r,o){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getNotebookDocument(T.URI.revive(r)),f=[];for(let d of o){const w=a.getCell(d);w&&f.push(w.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,a.uri.toString(),f.length),await n.controller.executeHandler.call(n.controller,f,a.apiNotebook,n.controller)}catch(d){this._logService.error(`NotebookController[${t}] execute cells FAILED`,d),console.error(d)}}async $cancelCells(t,r,o){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getNotebookDocument(T.URI.revive(r));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,a.apiNotebook);else for(let f of o){const d=a.getCell(f);d&&this._activeExecutions.get(d.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,r,o){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getEditorById(r);n.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:o}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const n=new c(o.notebook,o,this._proxy);this._activeExecutions.set(o.uri,n);const a=n.onDidChangeState(()=>{n.state===A.Resolved&&(n.dispose(),a.dispose(),this._activeExecutions.delete(o.uri))});return n.asApiObject()}};b=Ve([$e(3,l.ILogService)],b),e.ExtHostNotebookKernels=b;var A;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(A||(A={}));class c extends L.Disposable{constructor(t,r,o){super();this._document=t,this._cell=r,this._proxy=o,this._onDidChangeState=new g.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=A.Init,this._tokenSource=this._register(new u.CancellationTokenSource),this._collector=new h(10,n=>this.applyEdits(n)),this._executionOrder=r.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===A.Init)throw new Error("Must call start before modifying cell output");if(this._state===A.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let r=this._cell;if(t&&(r=this._document.getCellFromApiCell(t)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(t){return t.map(r=>{const o=v.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return o===r.items?C.NotebookCellOutput.from(r):C.NotebookCellOutput.from({items:o,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,o){const n=this.cellIndexToHandle(r),a=this.validateAndConvertOutputs((0,m.asArray)(t));return this.applyEditSoon({editType:2,handle:n,append:o,outputs:a})}async updateOutputItems(t,r,o){return t=v.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(C.NotebookCellOutputItem.from),outputId:r.id,append:o})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(o){t._executionOrder=o,t.mixinMetadata({executionOrder:o})},start(o){if(t._state===A.Resolved||t._state===A.Started)throw new Error("Cannot call start again");t._state=A.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:o??null})},end(o,n){if(t._state===A.Resolved)throw new Error("Cannot call resolve twice");t._state=A.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:o??null,runEndTime:n??null})},clearOutput(o){return t.verifyStateForOutput(),t.updateOutputs([],o,!1)},appendOutput(o,n){return t.verifyStateForOutput(),t.updateOutputs(o,n,!0)},replaceOutput(o,n){return t.verifyStateForOutput(),t.updateOutputs(o,n,!1)},appendOutputItems(o,n){return t.verifyStateForOutput(),t.updateOutputItems(o,n,!0)},replaceOutputItems(o,n){return t.verifyStateForOutput(),t.updateOutputItems(o,n,!1)}})}}class h{constructor(t,r){this.delay=t,this.callback=r,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)})),this.waitPromise}}}),define(me[246],ge([0,1,3,5,128]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(C,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,S,P){const i=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(S)?.fire({editor:i.apiEditor,message:P})}createRendererMessaging(C,S){if(!C.contributes?.notebookRenderer?.some(u=>u.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);const P=!!C.enableProposedApi,i=new WeakMap;return{onDidReceiveMessage:(u,m,l)=>{const v=P?u:_=>{const b={};i.set(b,_.editor),u({editor:b,message:_.message})};return this.getOrCreateEmitterFor(S).event(v,m,l)},postMessage:(u,m)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(u)&&([u,m]=[m,u]);const l=P?m:i.get(m),v=l&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(l);return this.proxy.$postMessage(v?.id,S,u)}}}getOrCreateEmitterFor(C){let S=this._rendererMessageEmitters.get(C);return S||(S=new g.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,S),S)}}e.ExtHostNotebookRenderers=y}),define(me[65],ge([0,1,5,3,6,24,4,13]),function(J,e,g,L,k,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends k.Disposable{constructor(l,v,_,b,A){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=l,this._proxy=A,this._id=A.$register(this.name,v,_,b),this._disposed=!1,this._offset=0}get name(){return this._name}append(l){this.validate(),this._offset+=l?y.VSBuffer.fromString(l).byteLength:0}update(){this._id.then(l=>this._proxy.$update(l))}appendLine(l){this.validate(),this.append(l+`
`)}clear(){this.validate();const l=this._offset;this._id.then(v=>this._proxy.$clear(v,l))}show(l,v){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof l=="boolean"?l:v)))}hide(){this.validate(),this._id.then(l=>this._proxy.$close(l))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(l=>this._proxy.$dispose(l)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class P extends S{constructor(l,v,_){super(l,!1,void 0,v,_)}append(l){super.append(l),this._id.then(v=>this._proxy.$append(v,l)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class i extends S{constructor(l,v,_){super(l,!0,v,void 0,_)}append(l){throw new Error("Not supported")}}class I{constructor(l,v){this.name=l,this._channel=v}append(l){this._channel.then(v=>v.append(l))}appendLine(l){this._channel.then(v=>v.appendLine(l))}clear(){this._channel.then(l=>l.clear())}show(l,v){this._channel.then(_=>_.show(l,v))}hide(){this._channel.then(l=>l.hide())}dispose(){this._channel.then(l=>l.dispose())}}e.LazyOutputChannel=I;let u=class{constructor(l){this._proxy=l.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(l){}createOutputChannel(l,v){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");return new P(l,v.identifier.value,this._proxy)}createOutputChannelFromLogFile(l,v){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");if(!v)throw new Error("illegal argument `file`. must not be falsy");return new i(l,v,this._proxy)}};u=Ve([$e(0,C.IExtHostRpcService)],u),e.ExtHostOutputService=u,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(me[247],ge([0,1,17,21,3,6,5,2,7,16,20,48]),function(J,e,g,L,k,y,T,C,S,P,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function u(m,l,v){const _=m.getProxy(T.MainContext.MainThreadQuickOpen);class b{constructor(n,a){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=a}showQuickPick(n,a,f,d=L.CancellationToken.None){this._onDidSelectItem=void 0;const w=Promise.resolve(n),E=++this._instances,s=_.$show(E,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},d),D={},R=s.then(()=>D);return Promise.race([R,w]).then(U=>{if(U!==D)return w.then(V=>{const ee=[];for(let K=0;K<V.length;K++){const O=V[K];let x,F,z,M,N;typeof O=="string"?x=O:(x=O.label,F=O.description,z=O.detail,M=O.picked,N=O.alwaysShow),ee.push({label:x,description:F,handle:K,detail:z,picked:M,alwaysShow:N})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=K=>{f.onDidSelectItem(V[K])}),_.$setItems(E,ee),s.then(K=>{if(typeof K=="number")return V[K];if(Array.isArray(K))return K.map(O=>V[O])})})}).then(void 0,U=>{if(!(0,P.isPromiseCanceledError)(U))return _.$setError(E,U),Promise.reject(U)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,a=L.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,_.$input(n,typeof this._validateInput=="function",a).then(void 0,f=>{if(!(0,P.isPromiseCanceledError)(f))return Promise.reject(f)})}$validateInput(n){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,a=L.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!f)return;const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(w=>w.uri.toString()===f.uri.toString())}createQuickPick(n,a){const f=new t(n,a,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(n){const a=new r(n,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(n,a){const f=this._sessions.get(n);f&&f._fireDidChangeValue(a)}$onDidAccept(n){const a=this._sessions.get(n);a&&a._fireDidAccept()}$onDidChangeActive(n,a){const f=this._sessions.get(n);f instanceof t&&f._fireDidChangeActive(a)}$onDidChangeSelection(n,a){const f=this._sessions.get(n);f instanceof t&&f._fireDidChangeSelection(a)}$onDidTriggerButton(n,a){const f=this._sessions.get(n);f&&f._fireDidTriggerButton(a)}$onDidHide(n){const a=this._sessions.get(n);a&&a._fireDidHide()}}class A{constructor(n,a){this._extensionId=n,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((a,f)=>{const d=a===S.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(d,a)}),this.update({buttons:n.map((a,f)=>({iconPath:c(a.iconPath),tooltip:a.tooltip,handle:a===S.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const a=this._handlesToButtons.get(n);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,y.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(n){if(!this._disposed){for(const a of Object.keys(n)){const f=n[a];this._pendingUpdate[a]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}A._nextId=1;function c(o){if(o instanceof S.ThemeIcon)return{id:o.id};const n=p(o),a=h(o);return{dark:typeof n=="string"?C.URI.file(n):n,light:typeof a=="string"?C.URI.file(a):a}}function h(o){return typeof o=="object"&&"light"in o?o.light:o}function p(o){return typeof o=="object"&&"dark"in o?o.dark:o}class t extends A{constructor(n,a,f){super(n,f);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((a,f)=>{this._handlesToItems.set(f,a),this._itemsToHandles.set(a,f)}),this.update({items:n.map((a,f)=>({label:a.label,description:a.description,handle:f,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(n){const a=(0,i.coalesce)(n.map(f=>this._handlesToItems.get(f)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(n){const a=(0,i.coalesce)(n.map(f=>this._handlesToItems.get(f)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class r extends A{constructor(n,a){super(n,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n,severity:n?I.default.Error:I.default.Ignore})}}return new b(l,v)}e.createExtHostQuickOpen=u}),define(me[248],ge([0,1,2,3,56,6,17,5,20,100,12,26,35,85,15]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function v(f){if(f)return typeof f.iconPath=="string"?g.URI.file(f.iconPath):g.URI.isUri(f.iconPath)||m.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function _(f,d){if(!f.iconPath&&!d.iconPath)return 0;if(f.iconPath){if(!d.iconPath)return 1}else return-1;const w=typeof f.iconPath=="string"?f.iconPath:g.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,E=typeof d.iconPath=="string"?d.iconPath:g.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,P.comparePaths)(w,E)}function b(f,d){let w=0;if(f.strikeThrough!==d.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==d.faded)return f.faded?1:-1;if(f.tooltip!==d.tooltip)return(f.tooltip||"").localeCompare(d.tooltip||"");if(w=_(f,d),w!==0)return w;if(f.light&&d.light)w=_(f.light,d.light);else{if(f.light)return 1;if(d.light)return-1}if(w!==0)return w;if(f.dark&&d.dark)w=_(f.dark,d.dark);else{if(f.dark)return 1;if(d.dark)return-1}return w}function A(f,d){if(f.command!==d.command)return f.command<d.command?-1:1;if(f.title!==d.title)return f.title<d.title?-1:1;if(f.tooltip!==d.tooltip){if(f.tooltip!==void 0&&d.tooltip!==void 0)return f.tooltip<d.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(f.arguments===d.arguments)return 0;if(f.arguments)if(d.arguments){if(f.arguments.length!==d.arguments.length)return f.arguments.length-d.arguments.length}else return 1;else return-1;for(let w=0;w<f.arguments.length;w++){const E=f.arguments[w],s=d.arguments[w];if(E!==s)return E<s?-1:1}return 0}function c(f,d){let w=(0,P.comparePaths)(f.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(w!==0)return w;if(f.command&&d.command)w=A(f.command,d.command);else{if(f.command)return 1;if(d.command)return-1}if(w!==0)return w;if(f.decorations&&d.decorations)w=b(f.decorations,d.decorations);else{if(f.decorations)return 1;if(d.decorations)return-1}return w}function h(f,d){for(let w=0;w<f.length;w++)if(f[w]!==d[w])return!1;return!0}function p(f,d){return f.command===d.command&&f.title===d.title&&f.tooltip===d.tooltip&&(f.arguments&&d.arguments?h(f.arguments,d.arguments):f.arguments===d.arguments)}function t(f,d){return(0,S.equals)(f,d,p)}class r{constructor(d,w,E){this._extension=d,this._proxy=w,this._sourceControlHandle=E,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(d){this._proxy.$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,u.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(d){if((0,u.checkProposedApiEnabled)(this._extension),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,d))}focus(){(0,u.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(d,w){(0,u.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,d,w)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=r;class o{constructor(d,w,E,s,D){this._proxy=d,this._commands=w,this._sourceControlHandle=E,this._id=s,this._label=D,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=o._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,w){const E=this._resourceStatesCommandsMap.get(d);return E?(0,T.asPromise)(()=>this._commands.executeCommand(E.command,...E.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(c),E=(0,S.sortedDiff)(this._resourceSnapshot,d,c).map(R=>{const U=R.toInsert.map(V=>{const ee=this._resourceHandlePool++;this._resourceStatesMap.set(ee,V);const K=V.resourceUri;let O;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"){const he=new y.DisposableStore;O=this._commands.converter.toInternal(V.command,he),this._resourceStatesDisposablesMap.set(ee,he)}else this._resourceStatesCommandsMap.set(ee,V.command);const x=v(V.decorations),F=V.decorations&&v(V.decorations.light)||x,z=V.decorations&&v(V.decorations.dark)||x,M=[F,z],N=V.decorations&&V.decorations.tooltip||"",q=V.decorations&&!!V.decorations.strikeThrough,B=V.decorations&&!!V.decorations.faded,G=V.contextValue||"";return{rawResource:[ee,K,M,N,q,B,G,O],handle:ee}});return{start:R.start,deleteCount:R.deleteCount,toInsert:U}}),s=E.map(({start:R,deleteCount:U,toInsert:V})=>[R,U,V.map(ee=>ee.rawResource)]),D=E.reverse();for(const{start:R,deleteCount:U,toInsert:V}of D){const ee=V.map(O=>O.handle),K=this._handlesSnapshot.splice(R,U,...ee);for(const O of K)this._resourceStatesMap.delete(O),this._resourceStatesCommandsMap.delete(O),this._resourceStatesDisposablesMap.get(O)?.dispose(),this._resourceStatesDisposablesMap.delete(O)}return this._resourceSnapshot=d,s}dispose(){this._disposed=!0,this._onDidDispose.fire()}}o._handlePool=0;class n{constructor(d,w,E,s,D,R){this._proxy=w,this._commands=E,this._id=s,this._label=D,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new r(d,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,s,D,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,this._proxy.$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,this._proxy.$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=d;const w=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&t(this._statusBarCommands,d))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=d;const w=(d||[]).map(E=>this._commands.converter.toInternal(E,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(d,w){const E=new o(this._proxy,this._commands,this.handle,d,w),s=L.Event.once(E.onDidDispose)(()=>this.createdResourceGroups.delete(E));return this.createdResourceGroups.set(E,s),this.eventuallyAddResourceGroups(),E}eventuallyAddResourceGroups(){const d=[],w=[];for(const[E,s]of this.createdResourceGroups){s.dispose();const D=E.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(E),this.eventuallyUpdateResourceStates()});L.Event.once(E.onDidDispose)(()=>{this.updatedResourceGroups.delete(E),D.dispose(),this._groups.delete(E.handle),this._proxy.$unregisterGroup(this.handle,E.handle)}),d.push([E.handle,E.id,E.label,E.features]);const R=E._takeResourceStateSnapshot();R.length>0&&w.push([E.handle,R]),this._groups.set(E.handle,E)}this._proxy.$registerGroups(this.handle,d,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(w=>{const E=w._takeResourceStateSnapshot();E.length!==0&&d.push([w.handle,E])}),d.length>0&&this._proxy.$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([(0,k.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([(0,k.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let a=class xn{constructor(d,w,E){this._commands=w,this.logService=E,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=d.getProxy(C.MainContext.MainThreadSCM),this._telemetry=d.getProxy(C.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===3){const D=this._sourceControls.get(s.sourceControlHandle);if(!D)return s;const R=D.getResourceGroup(s.groupHandle);return R?R.getResourceState(s.handle):s}else if(s&&s.$mid===4){const D=this._sourceControls.get(s.sourceControlHandle);return D?D.getResourceGroup(s.groupHandle):s}else if(s&&s.$mid===5){const D=this._sourceControls.get(s.handle);return D||s}return s}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,w,E,s){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,w,E,s),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const D=xn._handlePool++,R=new n(d,this._proxy,this._commands,w,E,s);this._sourceControls.set(D,R);const U=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(d.identifier))||[];return U.push(R),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(d.identifier),U),R}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const w=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(d.identifier)),E=w&&w[w.length-1];return E&&E.inputBox}$provideOriginalResource(d,w,E){const s=g.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,s.toString());const D=this._sourceControls.get(d);return!D||!D.quickDiffProvider||!D.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>D.quickDiffProvider.provideOriginalResource(s,E)).then(R=>R||null)}$onInputBoxValueChange(d,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const E=this._sourceControls.get(d);return E&&E.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(d,w,E,s){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,w,E);const D=this._sourceControls.get(d);if(!D)return Promise.resolve(void 0);const R=D.getResourceGroup(w);return R?R.$executeResourceCommand(E,s):Promise.resolve(void 0)}$validateInput(d,w,E){this.logService.trace("ExtHostSCM#$validateInput",d);const s=this._sourceControls.get(d);return!s||!s.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>s.inputBox.validateInput(w,E)).then(D=>{if(!D)return Promise.resolve(void 0);const R=l.MarkdownString.fromStrict(D.message);return R?Promise.resolve([R,D.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};a._handlePool=0,a=Ve([$e(2,i.ILogService)],a),e.ExtHostSCM=a});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(me[249],ge([0,1,7,5,166,6,15]),function(J,e,g,L,k,y,T){"use strict";var C,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class P{constructor(m,l,v,_,b=g.StatusBarAlignment.Left,A){C.set(this,void 0),S.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,it(this,C,m,"f"),it(this,S,l,"f"),this._entryId=P.ID_GEN++,this._extension=v,this._id=_,this._alignment=b,this._priority=A}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(m){this._text=m,this.update()}set name(m){this._name=m,this.update()}set tooltip(m){this._tooltip=m,this.update()}set color(m){this._color=m,this.update()}set backgroundColor(m){m&&!P.ALLOWED_BACKGROUND_COLORS.has(m.id)&&(m=void 0),this._backgroundColor=m,this.update()}set command(m){this._command?.fromApi!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:He(this,S,"f").toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:He(this,S,"f").toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,He(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let m;this._extension?this._id?m=`${this._extension.identifier.value}.${this._id}`:m=this._extension.identifier.value:m=this._id;let l;this._name?l=this._name:l=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=P.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const _=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;He(this,C,"f").$setEntry(this._entryId,m,l,this._text,_,this._command?.internal,v,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=P,C=new WeakMap,S=new WeakMap,P.ID_GEN=0,P.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class i{constructor(m){this._messages=[],this._item=m.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(m){const l={message:m};return this._messages.unshift(l),this._update(),new g.Disposable(()=>{const v=this._messages.indexOf(l);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(m,l){this._proxy=m.getProxy(L.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new i(this)}createStatusBarEntry(m,l,v,_){return new P(this._proxy,this._commands,m,l,v,_)}setStatusBarMessage(m,l){const v=this._statusMessage.setMessage(m);let _;return typeof l=="number"?_=setTimeout(()=>v.dispose(),l):typeof l!="undefined"&&l.then(()=>v.dispose(),()=>v.dispose()),new g.Disposable(()=>{v.dispose(),clearTimeout(_)})}}e.ExtHostStatusBar=I}),define(me[93],ge([0,1,5,3,4]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(C){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,S){this._proxy.$registerExtensionStorageKeysToSync(C,S)}getValue(C,S,P){return this._proxy.$getValue(C,S).then(i=>i||P)}setValue(C,S,P){return this._proxy.$setValue(C,S,P)}$acceptValue(C,S,P){this._onDidChangeStorage.fire({shared:C,key:S,value:P})}}e.ExtHostStorage=y,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(me[66],ge([0,1,4,27,12,92,2]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let C=class{constructor(P,i,I){this._logService=i,this._extHostFileSystem=I,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(P){return T.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,i=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(i),this._logService.trace("[ExtHostStorage] storage dir already exists",i),i}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",i),await this._extHostFileSystem.value.createDirectory(i),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(i,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),i}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(P){if(this._value)return T.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return T.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=Ve([$e(0,L.IExtHostInitDataService),$e(1,k.ILogService),$e(2,y.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(me[33],ge([0,1,3,5,4,2,13,6,7,167,16,213,21,32,195,85,14]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class b{constructor(a,f,d,w){this._proxy=a,this._id=f,this._creationOptions=d,this._name=w,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(s=>this._pidPromiseComplete=s);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},sendText(s,D=!0){E._checkDisposed(),E._proxy.$sendText(E._id,s,D)},show(s){E._checkDisposed(),E._proxy.$show(E._id,s)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(a,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:a.name,shellPath:(0,_.withNullAsUndefined)(a.shellPath),shellArgs:(0,_.withNullAsUndefined)(a.shellArgs),cwd:(0,_.withNullAsUndefined)(a.cwd),env:(0,_.withNullAsUndefined)(a.env),icon:(0,_.withNullAsUndefined)(r(a.iconPath)),color:v.ThemeColor.isThemeColor(a.color)?a.color.id:void 0,initialText:(0,_.withNullAsUndefined)(a.message),strictEnv:(0,_.withNullAsUndefined)(a.strictEnv),hideFromUser:(0,_.withNullAsUndefined)(a.hideFromUser),isFeatureTerminal:(0,_.withNullAsUndefined)(f?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,_.withNullAsUndefined)(f?.useShellEnvironment),isSplitTerminal:f?.isSplitTerminal,target:f?.target})}async createExtensionTerminal(a,f,d,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,color:v.ThemeColor.isThemeColor(w)?w.id:void 0,isSplitTerminal:a,target:f}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(a){this._name=a}setExitCode(a){this._exitStatus=Object.freeze({code:a})}setDimensions(a,f){return a===this._cols&&f===this._rows||a===0||f===0?!1:(this._cols=a,this._rows=f,!0)}_setProcessId(a){this._pidPromiseComplete?(this._pidPromiseComplete(a),this._pidPromiseComplete=void 0):this._pidPromise.then(f=>{f!==a&&(this._pidPromise=Promise.resolve(a))})}}e.ExtHostTerminal=b;class A{constructor(a){this._pty=a,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(a){this._pty.handleInput&&this._pty.handleInput(a)}resize(a,f){this._pty.setDimensions&&this._pty.setDimensions({columns:a,rows:f})}async processBinary(a){}acknowledgeDataEvent(a){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(a){this._pty.onDidWrite(f=>this._onProcessData.fire(f)),this._pty.onDidClose&&this._pty.onDidClose((f=void 0)=>{this._onProcessExit.fire(f===void 0?void 0:f)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(f=>this._onProcessOverrideDimensions.fire(f&&{cols:f.columns,rows:f.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(f=>this._onProcessTitleChanged.fire(f)),this._pty.open(a||void 0),this._pty.setDimensions&&a&&this._pty.setDimensions(a),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=A;let c=1,h=class extends C.Disposable{constructor(a,f){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this._onDidOpenTerminal=new g.Emitter,this._onDidChangeActiveTerminal=new g.Emitter,this._onDidChangeTerminalDimensions=new g.Emitter,this._proxy=f.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(a),this._register({dispose:()=>{for(const[d,w]of this._terminalProcesses)w.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(a=>a.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(a,f){const d=new b(this._proxy,(0,m.generateUuid)(),a,a.name),w=new A(a.pty);return d.createExtensionTerminal(f?.isSplitTerminal,f?.target,r(a.iconPath),o(a.color)).then(E=>{const s=this._setupExtHostProcessListeners(E,w);this._terminalProcessDisposables[E]=s}),this._terminals.push(d),d.value}attachPtyToTerminal(a,f){if(!this._getTerminalById(a))throw new Error(`Cannot resolve terminal with id ${a} for virtual process`);const w=new A(f),E=this._setupExtHostProcessListeners(a,w);this._terminalProcessDisposables[a]=E}async $acceptActiveTerminalChanged(a){const f=this._activeTerminal;if(a===null){this._activeTerminal=void 0,f!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(a);d&&(this._activeTerminal=d,f!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(a,f){const d=this._getTerminalById(a);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:f})}async $acceptTerminalDimensions(a,f,d){const w=this._getTerminalById(a);w&&w.setDimensions(f,d)&&this._onDidChangeTerminalDimensions.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(a,f,d){this._terminalProcesses.get(a)?.resize(f,d)}async $acceptTerminalTitleChange(a,f){const d=this._getTerminalById(a);d&&(d.name=f)}async $acceptTerminalClosed(a,f){const d=this._getTerminalObjectIndexById(this._terminals,a);if(d!==null){const w=this._terminals.splice(d,1)[0];w.setExitCode(f),this._onDidCloseTerminal.fire(w.value)}}$acceptTerminalOpened(a,f,d,w){if(f){const D=this._getTerminalObjectIndexById(this._terminals,f);if(D!==null){this._terminals[D]._id=a,this._onDidOpenTerminal.fire(this.terminals[D]),this._terminals[D].isOpen=!0;return}}const E={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:y.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},s=new b(this._proxy,a,E,d);this._terminals.push(s),this._onDidOpenTerminal.fire(s.value),s.isOpen=!0}async $acceptTerminalProcessId(a,f){const d=this._getTerminalById(a);d&&d._setProcessId(f)}async $startExtensionTerminal(a,f){const d=this._getTerminalById(a);if(!d)return{message:(0,P.localize)(0,null,a)};d.isOpen||await new Promise(E=>{const s=this.onDidOpenTerminal(async D=>{D===d.value&&(s.dispose(),E())})});const w=this._terminalProcesses.get(a);w?w.startSendingEvents(f):this._extensionTerminalAwaitingStart[a]={initialDimensions:f}}_setupExtHostProcessListeners(a,f){const d=new C.DisposableStore;d.add(f.onProcessReady(E=>this._proxy.$sendProcessReady(a,E.pid,E.cwd))),d.add(f.onProcessTitleChanged(E=>this._proxy.$sendProcessTitle(a,E))),this._bufferer.startBuffering(a,f.onProcessData),d.add(f.onProcessExit(E=>this._onProcessExit(a,E))),f.onProcessOverrideDimensions&&d.add(f.onProcessOverrideDimensions(E=>this._proxy.$sendOverrideDimensions(a,E))),this._terminalProcesses.set(a,f);const w=this._extensionTerminalAwaitingStart[a];return w&&f instanceof A&&(f.startSendingEvents(w.initialDimensions),delete this._extensionTerminalAwaitingStart[a]),d}$acceptProcessAckDataEvent(a,f){this._terminalProcesses.get(a)?.acknowledgeDataEvent(f)}$acceptProcessInput(a,f){this._terminalProcesses.get(a)?.input(f)}$acceptProcessResize(a,f,d){try{this._terminalProcesses.get(a)?.resize(f,d)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(a,f){this._terminalProcesses.get(a)?.shutdown(f)}$acceptProcessRequestInitialCwd(a){this._terminalProcesses.get(a)?.getInitialCwd().then(f=>this._proxy.$sendProcessInitialCwd(a,f))}$acceptProcessRequestCwd(a){this._terminalProcesses.get(a)?.getCwd().then(f=>this._proxy.$sendProcessCwd(a,f))}$acceptProcessRequestLatency(a){return a}registerLinkProvider(a){return this._linkProviders.add(a),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(a),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(a,f,d){if(this._profileProviders.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this._profileProviders.set(f,d),this._proxy.$registerProfileProvider(f,a.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(f),this._proxy.$unregisterProfileProvider(f)})}async $createContributedProfileTerminal(a,f){const d=new u.CancellationTokenSource().token,w=await this._profileProviders.get(a)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${a}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,f);return}this.createTerminalFromOptions(w.options,f)}}async $provideLinks(a,f){const d=this._getTerminalById(a);if(!d)return[];this._terminalLinkCache.delete(a);const w=this._terminalLinkCancellationSource.get(a);w&&w.dispose(!0);const E=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(a,E);const s=[],D={terminal:d.value,line:f},R=[];for(const ee of this._linkProviders)R.push(new Promise(async K=>{E.token.onCancellationRequested(()=>K({provider:ee,links:[]}));const O=await ee.provideTerminalLinks(D,E.token)||[];E.token.isCancellationRequested||K({provider:ee,links:O})}));const U=await Promise.all(R);if(E.token.isCancellationRequested)return[];const V=new Map;for(const ee of U)ee&&ee.links.length>0&&s.push(...ee.links.map(K=>{const O={id:c++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return V.set(O.id,{provider:ee.provider,link:K}),O}));return this._terminalLinkCache.set(a,V),s}$activateLink(a,f){const d=this._terminalLinkCache.get(a)?.get(f);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(a,f){this._bufferer.stopBuffering(a),this._terminalProcesses.delete(a),delete this._extensionTerminalAwaitingStart[a];const d=this._terminalProcessDisposables[a];d&&(d.dispose(),delete this._terminalProcessDisposables[a]),this._proxy.$sendProcessExit(a,f)}_getTerminalById(a){return this._getTerminalObjectById(this._terminals,a)}_getTerminalObjectById(a,f){const d=this._getTerminalObjectIndexById(a,f);return d!==null?a[d]:null}_getTerminalObjectIndexById(a,f){let d=null;return a.some((w,E)=>w._id===f?(d=E,!0):!1),d}getEnvironmentVariableCollection(a){let f=this._environmentVariableCollections.get(a.identifier.value);return f||(f=new p,this._setEnvironmentVariableCollection(a.identifier.value,f)),f}_syncEnvironmentVariableCollection(a,f){const d=(0,I.serializeEnvironmentVariableCollection)(f.map);this._proxy.$setEnvironmentVariableCollection(a,f.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(a){a.forEach(f=>{const d=f[0],w=new p(f[1]);this._setEnvironmentVariableCollection(d,w)})}$acceptDefaultProfile(a,f){this._defaultProfile=a,this._defaultAutomationProfile=f}_setEnvironmentVariableCollection(a,f){this._environmentVariableCollections.set(a,f),f.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(a,f)})}};h=Ve([$e(1,T.IExtHostRpcService)],h),e.BaseExtHostTerminalService=h;class p{constructor(a){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(a)}get persistent(){return this._persistent}set persistent(a){this._persistent=a,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(a,f){this._setIfDiffers(a,{value:f,type:S.EnvironmentVariableMutatorType.Replace})}append(a,f){this._setIfDiffers(a,{value:f,type:S.EnvironmentVariableMutatorType.Append})}prepend(a,f){this._setIfDiffers(a,{value:f,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(a,f){const d=this.map.get(a);(!d||d.value!==f.value||d.type!==f.type)&&(this.map.set(a,f),this._onDidChangeCollection.fire())}get(a){return this.map.get(a)}forEach(a,f){this.map.forEach((d,w)=>a.call(f,w,d,this))}delete(a){this.map.delete(a),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=p;let t=class extends h{constructor(a){super(!1,a)}createTerminal(a,f,d){throw new i.NotSupportedError}createTerminalFromOptions(a,f){throw new i.NotSupportedError}};t=Ve([$e(0,T.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function r(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function o(n){return v.ThemeColor.isThemeColor(n)?n:void 0}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(me[250],ge([0,1,24,21,3,72,58,74,6,25,14,32,5,13,87,15,7,221,126,90]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_,b,A,c){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let p=class{constructor(R,U){this.resultsChangedEmitter=new k.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(u.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new r(this.proxy),U.registerArgumentProcessor({processArgument:V=>V?.$mid===13?v.TestItem.toItemFromContext(V):V})}createTestController(R,U){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const V=new S.DisposableStore,ee=V.add(new b.SingleUseTestCollection(R));ee.root.label=U;const K=new Map,O=this.proxy,x={items:ee.root.children,get label(){return U},set label(z){U=z,ee.root.label=z,O.$updateControllerLabel(R,U)},get id(){return R},createRunProfile:(z,M,N,q)=>{let B=(0,T.hash)(z);for(;K.has(B);)B++;const G=new E(this.proxy,R,B,z,M,N,q);return K.set(B,G),G},createTestItem(z,M,N){return new l.TestItemImpl(R,z,M,N)},createTestRun:(z,M,N=!0)=>this.runTracker.createTestRun(R,ee,z,M,N),set resolveHandler(z){ee.resolveHandler=z},get resolveHandler(){return ee.resolveHandler},dispose:()=>{V.dispose()}};x.createRunConfiguration=x.createRunProfile,O.$registerTestController(R,U),V.add((0,S.toDisposable)(()=>O.$unregisterTestController(R)));const F={controller:x,collection:ee,profiles:K};return this.controllers.set(R,F),V.add((0,S.toDisposable)(()=>this.controllers.delete(R))),V.add(ee.onDidGenerateDiff(z=>O.$publishDiff(R,z))),x}createTestObserver(){return this.observer.checkout()}async runTests(R,U=L.CancellationToken.None){const V=o(R);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ee=this.controllers.get(V.controllerId);if(!ee)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map(K=>K.id)??[ee.collection.root.id],profileGroup:s[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:R.exclude?.map(K=>({testId:K.id,controllerId:V.controllerId}))},U)}$provideFileCoverage(R,U,V){return C.Iterable.find(this.runTracker.trackers,ee=>ee.id===R)?.getCoverage(U)?.provideFileCoverage(V)??Promise.resolve([])}$resolveFileCoverage(R,U,V,ee){return C.Iterable.find(this.runTracker.trackers,K=>K.id===R)?.getCoverage(U)?.resolveFileCoverage(V,ee)??Promise.resolve([])}$configureRunProfile(R,U){this.controllers.get(R)?.profiles.get(U)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(U=>(0,P.deepFreeze)(v.TestResults.to(U))).concat(this.results).sort((U,V)=>V.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:R,testId:U},V){const ee=this.controllers.get(R)?.collection;ee&&(await ee.expand(U,V<0?Infinity:V),ee.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,U){const V=this.controllers.get(R.controllerId);if(!V)return;const{collection:ee,profiles:K}=V,O=K.get(R.profileId);if(!O)return;const x=R.testIds.map(N=>ee.tree.get(N)).filter(i.isDefined),F=R.excludeExtIds.map(N=>V.collection.tree.get(N)).filter(i.isDefined).filter(N=>x.some(q=>q.fullId.compare(N.fullId)===2));if(!x.length)return;const z=new _.TestRunRequest(x.some(N=>N.actual instanceof l.TestItemRootImpl)?void 0:x.map(N=>N.actual),F.map(N=>N.actual),O),M=this.runTracker.prepareForMainThreadTestRun(z,n.fromInternal(R,V.collection),U);try{await O.runHandler(z,U)}finally{M.isRunning&&!U.isCancellationRequested&&await k.Event.toPromise(M.onEnd),this.runTracker.cancelRunById(R.runId)}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};p=Ve([$e(0,m.IExtHostRpcService)],p),e.ExtHostTesting=p;class t extends S.Disposable{constructor(R,U,V){super();this.dto=R,this.proxy=U,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new k.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new L.CancellationTokenSource(V)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:ee}of this.tasks.values())ee.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const U=this.dto.id,V=this.dto.controllerId,ee=(0,I.generateUuid)(),K=new a(this.proxy,U,ee),O=z=>(M,...N)=>{if(x){console.warn(`Setting the state of test "${M.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(M)||(this.ensureTestIsKnown(M),z(M,...N))};let x=!1;const F={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return K.coverageProvider},set coverageProvider(z){K.coverageProvider=z},enqueued:O(z=>{this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),1)}),skipped:O(z=>{this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),5)}),started:O(z=>{this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),2)}),errored:O((z,M,N)=>{this.proxy.$appendTestMessagesInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),M instanceof Array?M.map(v.TestMessage.from):[v.TestMessage.from(M)]),this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),6,N)}),failed:O((z,M,N)=>{this.proxy.$appendTestMessagesInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),M instanceof Array?M.map(v.TestMessage.from):[v.TestMessage.from(M)]),this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,V).toString(),4,N)}),passed:O((z,M)=>{this.proxy.$updateTestStateInRun(U,ee,c.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,M)}),appendOutput:z=>{x||this.proxy.$appendOutputToRun(U,ee,g.VSBuffer.fromString(z))},end:()=>{x||(x=!0,this.proxy.$finishedTestRunTask(U,ee),this.tasks.delete(ee),this.isRunning||this.dispose())}};return this.tasks.set(ee,{run:F,coverage:K}),this.proxy.$startedTestRunTask(U,{id:ee,name:R,running:!0}),F}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof l.TestItemImpl))throw new l.InvalidTestItemError(R.id);if(this.sharedTestIds.has(R.id))return;const U=[];for(;U.unshift(v.TestItem.from(R)),!(this.sharedTestIds.has(R.id)||(this.sharedTestIds.add(R.id),!R.parent));)R=R.parent;const V=this.dto.colllection.root;this.sharedTestIds.has(V.id)||(this.sharedTestIds.add(V.id),U.unshift(v.TestItem.from(V))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,U)}}class r{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,U,V){return this.getTracker(R,U,V)}cancelRunById(R){for(const U of this.tracked.values())if(U.id===R){U.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,U,V,ee,K){const O=this.tracked.get(V);if(O)return O.createRun(ee);const x=n.fromPublic(R,U,V,K),F=o(V);this.proxy.$startedExtensionTestRun({controllerId:R,profile:F&&{group:s[F.kind],id:F.profileId},exclude:V.exclude?.map(M=>M.id)??[],id:x.id,include:V.include?.map(M=>M.id)??[U.root.id],persist:K});const z=this.getTracker(V,x);return z.onEnd(()=>this.proxy.$finishedExtensionTestRun(x.id)),z.createRun(ee)}getTracker(R,U,V){const ee=new t(U,this.proxy,V);return this.tracked.set(R,ee),ee.onEnd(()=>this.tracked.delete(R)),ee}}e.TestRunCoordinator=r;const o=D=>{if(!!D.profile){if(!(D.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return D.profile}};class n{constructor(R,U,V,ee,K,O){this.controllerId=R,this.id=U,this.isPersisted=K,this.colllection=O,this.includePrefix=V.map(x=>x+"\0"),this.excludePrefix=ee.map(x=>x+"\0")}static fromPublic(R,U,V,ee){return new n(R,(0,I.generateUuid)(),V.include?.map(K=>c.TestId.fromExtHostTestItem(K,R).toString())??[R],V.exclude?.map(K=>c.TestId.fromExtHostTestItem(K,R).toString())??[],ee,U)}static fromInternal(R,U){return new n(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,U)}isIncluded(R){const U=c.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const V of this.excludePrefix)if(U===V||U.startsWith(V))return!1;for(const V of this.includePrefix)if(U===V||U.startsWith(V))return!0;return!1}}e.TestRunDto=n;class a{constructor(R,U,V){this.proxy=R,this.runId=U,this.taskId=V}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(U){throw this.fileCoverage=void 0,U}}async resolveFileCoverage(R,U){const V=await this.fileCoverage;let ee=V?.[R];return!this._coverageProvider||!V||!ee?[]:(ee.detailedCoverage||(ee=V[R]=await this._coverageProvider.resolveFileCoverage?.(ee,U)??ee),ee.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class f extends A.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,v.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:U,removed:V}=this;return{get added(){return[...R].map(ee=>ee.revived)},get updated(){return[...U].map(ee=>ee.revived)},get removed(){return[...V].map(ee=>ee.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends A.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,U){return{...R,revived:v.TestItem.toPlain(R.item),depth:U?U.depth+1:0,children:new Set}}createChangeCollector(){return new f(this.changeEmitter)}}e.MirroredTestCollection=d;class w{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(U=>U.revived)},dispose:(0,y.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class E{constructor(R,U,V,ee,K,O,x=!1){this.controllerId=U,this.profileId=V,this._label=ee,this.kind=K,this.runHandler=O,this._isDefault=x,h.set(this,void 0),it(this,h,R,"f");const F=s[K];if(typeof F!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);He(this,h,"f").$publishTestRunProfile({profileId:V,controllerId:U,label:ee,group:F,isDefault:x,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,He(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,He(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,He(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){He(this,h,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=E,h=new WeakMap;const s={[_.TestRunProfileKind.Coverage]:8,[_.TestRunProfileKind.Debug]:4,[_.TestRunProfileKind.Run]:2}}),define(me[251],ge([0,1,3,20,5,129,15,7]),function(J,e,g,L,k,y,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(u=>this._onDidChangeVisibleTextEditors.fire(u)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(u=>this._onDidChangeActiveTextEditor.fire(u))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(u=>u.value)}async showTextDocument(i,I,u){let m;typeof I=="number"?m={position:T.ViewColumn.from(I),preserveFocus:u}:typeof I=="object"?m={position:T.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?T.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:m={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(i.uri,m),v=l&&this._extHostDocumentsAndEditors.getEditor(l);if(v)return v.value;throw l?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,I){return new y.TextEditorDecorationType(this._proxy,i,I).value}$acceptEditorPropertiesChanged(i,I){const u=this._extHostDocumentsAndEditors.getEditor(i);if(!u)throw new Error("unknown text editor");if(I.options&&u._acceptOptions(I.options),I.selections){const m=I.selections.selections.map(T.Selection.to);u._acceptSelections(m)}if(I.visibleRanges){const m=L.coalesce(I.visibleRanges.map(T.Range.to));u._acceptVisibleRanges(m)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:u.value,options:{...I.options,lineNumbers:T.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const m=C.TextEditorSelectionChangeKind.fromValue(I.selections.source),l=I.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:u.value,selections:l,kind:m})}if(I.visibleRanges){const m=L.coalesce(I.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:u.value,visibleRanges:m})}}$acceptEditorPositionData(i){for(const I in i){const u=this._extHostDocumentsAndEditors.getEditor(I);if(!u)throw new Error("Unknown text editor");const m=T.ViewColumn.to(i[I]);u.value.viewColumn!==m&&(u._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:u.value,viewColumn:m}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=S}),define(me[252],ge([0,1,2,4,5,6,7]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class C{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(k.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===11){const m=u.uri===void 0?void 0:g.URI.revive(u.uri);return this._itemsBySourceAndUriMap.get(u.source)?.get(S(m))?.get(u.handle)}return u}})}async $getTimeline(i,I,u,m,l){return this._providers.get(i)?.provideTimeline(g.URI.revive(I),u,m,l)}registerTimelineProvider(i,I,u,m){const l=new y.DisposableStore,v=this.convertTimelineItem(I.id,m,l).bind(this);let _;I.onDidChange&&(_=I.onDidChange(A=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...A,id:I.id}),this));const b=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:i,onDidChange:void 0,async provideTimeline(A,c,h,p){p?.resetCache&&(l.clear(),b.get(I.id)?.clear());const t=await I.provideTimeline(A,c,h);if(t==null)return;const r=v(A,p);return{...t,source:I.id,items:t.items.map(r)}},dispose(){for(const A of b.values())A.get(I.id)?.clear();_?.dispose(),l.dispose()}})}convertTimelineItem(i,I,u){return(m,l)=>{let v;if(l?.cacheResults){let _=this._itemsBySourceAndUriMap.get(i);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(i,_));const b=S(m);v=_.get(b),v===void 0&&(v=new Map,_.set(b,v))}return _=>{const{iconPath:b,...A}=_,c=`${i}|${_.id??_.timestamp}`;v?.set(c,_);let h,p,t;return _.iconPath&&(b instanceof T.ThemeIcon?t={id:b.id,color:b.color}:g.URI.isUri(b)?(h=b,p=b):{light:h,dark:p}=b),{...A,id:A.id??void 0,handle:c,source:i,command:_.command?I.toInternal(_.command,u):void 0,icon:h,iconDark:p,themeIcon:t,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,y.toDisposable)(()=>{for(const u of this._itemsBySourceAndUriMap.values())u.get(i.id)?.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=C;function S(P){return P?.toString()}}),define(me[253],ge([0,1,6,10,2,5]),function(J,e,g,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(S){this._openers=new Map,this._proxy=S.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,P,i,I){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const u=I.schemes.find(m=>!T.supportedSchemes.has(m));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,i),this._proxy.$registerUriOpener(P,I.schemes,S,I.label),(0,g.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(S,P,i){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener with id: ${S}`);const u=k.URI.revive(P);return I.canOpenExternalUri(u,i)}async $openUri(S,P,i){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener id: '${S}'`);return I.openExternalUri(k.URI.revive(P.resolvedUri),{sourceUri:k.URI.revive(P.sourceUri)},i)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(me[254],ge([0,1,5,2,6,16,26]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(P,i){if(this.handles.has(T.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const I=C.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(P)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,P),(0,k.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(P)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(P,i){const I=this.handlers.get(P);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(i))}catch(u){(0,y.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(P){return L.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=C,C.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(me[67],ge([0,1,3,2,179,204,88,5]),function(J,e,g,L,k,y,T,C){"use strict";var S,P,i,I,u,m,l,v,_,b,A,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(d,w,E,s,D,R,U){S.set(this,void 0),P.set(this,void 0),i.set(this,void 0),I.set(this,void 0),u.set(this,void 0),m.set(this,void 0),l.set(this,""),v.set(this,void 0),_.set(this,!1),b.set(this,!1),A.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new g.Emitter),this._onDidDispose=He(this,c,"f").event,it(this,S,d,"f"),it(this,P,w,"f"),it(this,v,E,"f"),it(this,I,s,"f"),it(this,u,D,"f"),it(this,m,R,"f"),it(this,A,p(R),"f"),it(this,i,U,"f")}dispose(){it(this,_,!0,"f"),He(this,c,"f").fire(),He(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return it(this,b,!0,"f"),(0,T.asWebviewUri)(d,He(this,I,"f").remote)}get cspSource(){return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),He(this,l,"f")}set html(d){this.assertNotDisposed(),He(this,l,"f")!==d&&(it(this,l,d,"f"),!He(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(it(this,b,!0,"f"),He(this,i,"f").report("Webview vscode-resource: uris",He(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),He(this,P,"f").$setHtml(He(this,S,"f"),d))}get options(){return this.assertNotDisposed(),He(this,v,"f")}set options(d){this.assertNotDisposed(),He(this,P,"f").$setOptions(He(this,S,"f"),o(He(this,m,"f"),He(this,u,"f"),d)),it(this,v,d,"f")}async postMessage(d){if(He(this,_,"f"))return!1;const w=(0,y.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:He(this,A,"f")});return He(this,P,"f").$postMessage(He(this,S,"f"),w.message,...w.buffers)}assertNotDisposed(){if(He(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,S=new WeakMap,P=new WeakMap,i=new WeakMap,I=new WeakMap,u=new WeakMap,m=new WeakMap,l=new WeakMap,v=new WeakMap,_=new WeakMap,b=new WeakMap,A=new WeakMap,c=new WeakMap;function p(f){try{const d=(0,k.normalizeVersion)((0,k.parseVersion)(f.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=p;class t{constructor(d,w,E,s,D){this.initData=w,this.workspace=E,this._logService=s,this._deprecationService=D,this._webviews=new Map,this._webviewProxy=d.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(d,w,...E){const s=this.getWebview(d);if(s){const{message:D}=(0,y.deserializeWebviewMessage)(w,E);s._onMessageEmitter.fire(D)}}$onMissingCsp(d,w){this._logService.warn(`${w} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,w,E){const s=new h(d,this._webviewProxy,n(w),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(d,s),s._onDidDispose(()=>{this._webviews.delete(d)}),s}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=t;function r(f){return{id:f.identifier,location:f.extensionLocation}}e.toExtensionData=r;function o(f,d,w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots||a(f,d)}}e.serializeWebviewOptions=o;function n(f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots?.map(d=>L.URI.from(d))}}e.reviveOptions=n;function a(f,d){return[...(d?.getWorkspaceFolders()||[]).map(w=>w.uri),f.extensionLocation]}}),define(me[255],ge([0,1,21,58,6,10,23,2,15,67,86,5,7]),function(J,e,g,L,k,y,T,C,S,P,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=h(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class l{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,o){const n=this.key(t,r.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const a=new m(r,o);return this._documents.set(n,a),a}delete(t,r){const o=this.key(t,r.uri);this._documents.delete(o)}key(t,r){return`${t}@@@${r}`}}var v;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(v||(v={}));class _{constructor(){this._providers=new Map}addTextProvider(t,r,o){return this.add(0,t,r,o)}addCustomProvider(t,r,o){return this.add(1,t,r,o)}get(t){return this._providers.get(t)}add(t,r,o,n){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:o,provider:n}),new u.Disposable(()=>this._providers.delete(r))}}class b{constructor(t,r,o,n,a){this._extHostDocuments=r,this._extensionStoragePaths=o,this._extHostWebview=n,this._extHostWebviewPanels=a,this._editorProviders=new _,this._documents=new l,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,o,n){const a=new k.DisposableStore;return A(o)?(a.add(this._editorProviders.addTextProvider(r,t,o)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(t),r,n.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(t))):(a.add(this._editorProviders.addCustomProvider(r,t,o)),this.supportEditing(o)&&a.add(o.onDidChangeCustomDocument(f=>{const d=this.getCustomDocumentEntry(r,f.document.uri);if(c(f)){const w=d.addEdit(f);this._proxy.$onDidEdit(f.document.uri,r,w,f.label)}else this._proxy.$onContentChange(f.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(t),r,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(t))),u.Disposable.from(a,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,o,n,a){const f=this._editorProviders.get(r);if(!f)throw new Error(`No provider found for '${r}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${r}'`);const d=C.URI.revive(t),w=await f.provider.openCustomDocument(d,{backupId:o,untitledDocumentData:n?.buffer},a);let E;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(E=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(r,w,E),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(t,r){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${r}'`);const n=C.URI.revive(t),{document:a}=this.getCustomDocumentEntry(r,n);this._documents.delete(r,a),a.dispose()}async $resolveWebviewEditor(t,r,o,n,a,f){const d=this._editorProviders.get(o);if(!d)throw new Error(`No provider found for '${o}'`);const w=S.ViewColumn.to(a),E=this._extHostWebview.createNewWebview(r,n.webviewOptions,d.extension),s=this._extHostWebviewPanels.createNewWebviewPanel(r,o,n.title,w,n.panelOptions,E),D=C.URI.revive(t);switch(d.type){case 1:{const{document:R}=this.getCustomDocumentEntry(o,D);return d.provider.resolveCustomEditor(R,s,f)}case 0:{const R=this._extHostDocuments.getDocument(D);return d.provider.resolveCustomTextEditor(R,s,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,o){this.getCustomDocumentEntry(r,t).disposeEdits(o)}async $onMoveCustomEditor(t,r,o){const n=this._editorProviders.get(o);if(!n)throw new Error(`No provider found for '${o}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const f=C.URI.revive(r),d=this._extHostDocuments.getDocument(f);await n.provider.moveCustomTextEditor(d,a,g.CancellationToken.None)}async $undo(t,r,o,n){return this.getCustomDocumentEntry(r,t).undo(o,n)}async $redo(t,r,o,n){return this.getCustomDocumentEntry(r,t).redo(o,n)}async $revert(t,r,o){const n=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(n.document,o),n.disposeBackup()}async $onSave(t,r,o){const n=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(n.document,o),n.disposeBackup()}async $onSaveAs(t,r,o,n){const a=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(a.document,C.URI.revive(o),n)}async $backup(t,r,o){const n=this.getCustomDocumentEntry(r,t),f=await this.getCustomEditorProvider(r).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},o);return n.updateBackup(f),f.id}getCustomDocumentEntry(t,r){const o=this._documents.get(t,C.URI.revive(r));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const o=this._editorProviders.get(t)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=b;function A(p){return typeof p.resolveCustomTextEditor=="function"}function c(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function h(p){const t=p.scheme===y.Schemas.file||p.scheme===y.Schemas.untitled?p.fsPath:p.toString();return(0,L.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(me[256],ge([0,1,3,6,2,32,15,67,5,7]),function(J,e,g,L,k,y,T,C,S,P){"use strict";var i,I,u,m,l,v,_,b,A,c,h,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends L.Disposable{constructor(f,d,w,E,s,D,R){super();i.set(this,void 0),I.set(this,void 0),u.set(this,void 0),m.set(this,void 0),l.set(this,void 0),v.set(this,void 0),_.set(this,void 0),b.set(this,void 0),A.set(this,!0),c.set(this,!0),h.set(this,!1),p.set(this,this._register(new g.Emitter)),this.onDidDispose=He(this,p,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=He(this,t,"f").event,it(this,i,f,"f"),it(this,I,d,"f"),it(this,u,w,"f"),it(this,l,D,"f"),it(this,b,s,"f"),it(this,v,E,"f"),it(this,m,R,"f")}dispose(){He(this,h,"f")||(it(this,h,!0,"f"),He(this,p,"f").fire(),He(this,I,"f").$disposeWebview(He(this,i,"f")),He(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),He(this,m,"f")}get viewType(){return this.assertNotDisposed(),He(this,u,"f")}get title(){return this.assertNotDisposed(),He(this,v,"f")}set title(f){this.assertNotDisposed(),He(this,v,"f")!==f&&(it(this,v,f,"f"),He(this,I,"f").$setTitle(He(this,i,"f"),f))}get iconPath(){return this.assertNotDisposed(),He(this,_,"f")}set iconPath(f){this.assertNotDisposed(),He(this,_,"f")!==f&&(it(this,_,f,"f"),He(this,I,"f").$setIconPath(He(this,i,"f"),k.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return He(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof He(this,b,"f")=="number"&&He(this,b,"f")<0))return He(this,b,"f")}get active(){return this.assertNotDisposed(),He(this,c,"f")}get visible(){return this.assertNotDisposed(),He(this,A,"f")}_updateViewState(f){He(this,h,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(it(this,c,f.active,"f"),it(this,A,f.visible,"f"),it(this,b,f.viewColumn,"f"),He(this,t,"f").fire({webviewPanel:this}))}reveal(f,d){this.assertNotDisposed(),He(this,I,"f").$reveal(He(this,i,"f"),{viewColumn:f?T.ViewColumn.from(f):void 0,preserveFocus:!!d})}assertNotDisposed(){if(He(this,h,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,u=new WeakMap,m=new WeakMap,l=new WeakMap,v=new WeakMap,_=new WeakMap,b=new WeakMap,A=new WeakMap,c=new WeakMap,h=new WeakMap,p=new WeakMap,t=new WeakMap;class o{constructor(f,d,w){this.webviews=d,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,y.generateUuid)()}createWebviewPanel(f,d,w,E,s={}){const D=typeof E=="object"?E.viewColumn:E,R={viewColumn:T.ViewColumn.from(D),preserveFocus:typeof E=="object"&&!!E.preserveFocus},U=(0,C.shouldSerializeBuffersForPostMessage)(f),V=o.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(f),V,d,{title:w,panelOptions:n(s),webviewOptions:(0,C.serializeWebviewOptions)(f,this.workspace,s),serializeBuffersForPostMessage:U},R);const ee=this.webviews.createNewWebview(V,s,f);return this.createNewWebviewPanel(V,d,w,D,s,ee)}$onDidChangeWebviewPanelViewStates(f){const d=Object.keys(f);d.sort((w,E)=>{const s=f[w],D=f[E];return s.active?1:D.active?-1:+s.visible-+D.visible});for(const w of d){const E=this.getWebviewPanel(w);if(!E)continue;const s=f[w];E._updateViewState({active:s.active,visible:s.visible,viewColumn:T.ViewColumn.to(s.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,d,w){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:w,extension:f}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(f)}),new P.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(f,d,w,E){const s=this._serializers.get(d);if(!s)throw new Error(`No serializer found for '${d}'`);const{serializer:D,extension:R}=s,U=this.webviews.createNewWebview(f,w.webviewOptions,R),V=this.createNewWebviewPanel(f,d,w.title,E,w.panelOptions,U);await D.deserializeWebviewPanel(V,w.state)}createNewWebviewPanel(f,d,w,E,s,D){const R=new r(f,this._proxy,d,w,E,s,D);return this._webviewPanels.set(f,R),R}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=o;function n(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(me[257],ge([0,1,3,6,67,5,7]),function(J,e,g,L,k,y,T){"use strict";var C,S,P,i,I,u,m,l,v,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends L.Disposable{constructor(h,p,t,r,o,n){super();C.set(this,void 0),S.set(this,void 0),P.set(this,void 0),i.set(this,void 0),I.set(this,!1),u.set(this,void 0),m.set(this,void 0),l.set(this,void 0),v.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=He(this,v,"f").event,_.set(this,this._register(new g.Emitter)),this.onDidDispose=He(this,_,"f").event,it(this,P,t,"f"),it(this,m,r,"f"),it(this,C,h,"f"),it(this,S,p,"f"),it(this,i,o,"f"),it(this,u,n,"f")}dispose(){He(this,I,"f")||(it(this,I,!0,"f"),He(this,_,"f").fire(),He(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),He(this,m,"f")}set title(h){this.assertNotDisposed(),He(this,m,"f")!==h&&(it(this,m,h,"f"),He(this,S,"f").$setWebviewViewTitle(He(this,C,"f"),h))}get description(){return this.assertNotDisposed(),He(this,l,"f")}set description(h){this.assertNotDisposed(),He(this,l,"f")!==h&&(it(this,l,h,"f"),He(this,S,"f").$setWebviewViewDescription(He(this,C,"f"),h))}get visible(){return He(this,u,"f")}get webview(){return He(this,i,"f")}get viewType(){return He(this,P,"f")}_setVisible(h){h===He(this,u,"f")||He(this,I,"f")||(it(this,u,h,"f"),He(this,v,"f").fire())}show(h){this.assertNotDisposed(),He(this,S,"f").$show(He(this,C,"f"),!!h)}assertNotDisposed(){if(He(this,I,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,S=new WeakMap,P=new WeakMap,i=new WeakMap,I=new WeakMap,u=new WeakMap,m=new WeakMap,l=new WeakMap,v=new WeakMap,_=new WeakMap;class A{constructor(h,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,p,t,r){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:t,extension:h}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(h),p,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(h,p,t,r,o){const n=this._viewProviders.get(p);if(!n)throw new Error(`No view provider found for '${p}'`);const{provider:a,extension:f}=n,d=this._extHostWebview.createNewWebview(h,{},f),w=new b(h,this._proxy,p,t,d,!0);this._webviewViews.set(h,w),await a.resolveWebviewView(w,{state:r},o)}async $onDidChangeWebviewViewVisibility(h,p){this.getWebviewView(h)._setVisible(p)}async $disposeWebviewView(h){const p=this.getWebviewView(h);this._webviewViews.delete(h),p.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const p=this._webviewViews.get(h);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=A}),define(me[132],ge([0,1,3,5,2,10,8,4,13]),function(J,e,g,L,k,y,T,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Bn{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Bn.InitialState,this._proxy=I.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(u=>this.$onDidChangeWindowFocus(u))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,u){let m;if(typeof I=="string"){m=I;try{I=k.URI.parse(I)}catch(l){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,T.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,m,u)}async asExternalUri(I,u){if((0,T.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(I,u);return k.URI.from(m)}};P.InitialState={focused:!0},P=Ve([$e(0,S.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(me[258],ge([0,1,9,78,32,44,6,5,2,13]),function(J,e,g,L,k,y,T,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends T.Disposable{constructor(u,m){super();const l=u.getProxy(C.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async v=>{const _=S.URI.file((0,g.join)((0,L.tmpdir)(),(0,k.generateUuid)()));return await l.$download(v,_),_})}};i=Ve([$e(0,P.IExtHostRpcService),$e(1,y.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(me[259],ge([0,1,2,9,151,28,65,27,13,6,12,116,42]),function(J,e,g,L,k,y,T,C,S,P,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class m{constructor(b,A,c){this.name=b,this.file=A,this.appender=c}static async create(b,A){const c=await(0,I.createRotatingLogger)(b,A,30*u.ByteSize.MB,1);return c.clearFormatters(),new m(b,A,c)}append(b){this.appender.critical(b)}flush(){this.appender.flush()}}class l extends T.AbstractExtHostOutputChannel{constructor(b,A,c,h){super(b,!1,g.URI.file(A.file),c,h);this._appender=A}append(b){super.append(b),this._appender.append(b),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(b,A){this._appender.flush(),super.show(b,A)}clear(){this._appender.flush(),super.clear()}}let v=class extends T.ExtHostOutputService{constructor(b,A,c){super(b);this.logService=A,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new P.MutableDisposable,this._logsLocation=c.logsLocation}$setVisibleChannel(b){if(b){const A=this._channels.get(b);A&&(this._visibleChannelDisposable.value=A.onDidAppend(()=>A.update()))}}createOutputChannel(b,A){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const c=this._doCreateOutChannel(b,A);return c.then(h=>h._id.then(p=>this._channels.set(p,h))),new T.LazyOutputChannel(b,c)}async _doCreateOutChannel(b,A){try{const c=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await y.SymlinkSupport.existsDirectory(c)||await y.Promises.mkdir(c,{recursive:!0});const p=`${this._namePool++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=g.URI.file((0,L.join)(c,`${p}.log`)),r=await m.create(p,t.fsPath);return new l(b,r,A.identifier.value,this._proxy)}catch(c){return this.logService.error(c),new T.ExtHostPushOutputChannel(b,A.identifier.value,this._proxy)}}};v=Ve([$e(0,S.IExtHostRpcService),$e(1,i.ILogService),$e(2,C.IExtHostInitDataService)],v),e.ExtHostOutputService2=v}),define(me[260],ge([0,1,49,291,2,66,6,10,17]),function(J,e,g,L,k,y,T,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class P extends y.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(p){const t=await super._getWorkspaceStorageURI(p);if(t.scheme!==C.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const r=t.fsPath;let o=0;do{let n;o===0?n=r:n=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${o}`:`${r}-${o}`,await i(n);const a=L.join(n,"vscode.lock"),f=await l(this._logService,a,!1);if(f)return this._workspaceStorageLock=f,process.on("exit",()=>{f.dispose()}),k.URI.file(n);o++}while(o<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=P;async function i(h){try{await g.promises.stat(h);return}catch{}try{await g.promises.mkdir(h,{recursive:!0})}catch{}}const I=1e3,u=10*60*1e3;class m extends T.Disposable{constructor(p,t){super();this.logService=p,this.filename=t,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await v(p,t);(!r||r.pid!==process.pid)&&(p.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await g.promises.utimes(t,new Date,new Date)}catch(o){p.error(o),p.info(`Lock '${t}': Could not update mtime.`)}},I)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(p){}}async setWillRelease(p){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${p} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+p};await g.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function l(h,p,t){try{const o={pid:process.pid,willReleaseAt:0};await g.promises.writeFile(p,JSON.stringify(o),{flag:"wx"})}catch(o){h.error(o)}const r=await v(h,p);return!r||r.pid!==process.pid?t?(h.info(`Lock '${p}': Could not acquire lock, giving up.`),null):(h.info(`Lock '${p}': Could not acquire lock, checking if the file is stale.`),A(h,p)):(h.info(`Lock '${p}': Lock acquired.`),new m(h,p))}async function v(h,p){let t;try{t=await g.promises.readFile(p)}catch(r){return h.error(r),null}try{return JSON.parse(String(t))}catch(r){return h.error(r),null}}async function _(h,p){let t;try{t=await g.promises.stat(p)}catch(r){return h.error(r),0}return t.mtime.getTime()}function b(h){try{return process.kill(h,0),!0}catch(p){return!1}}async function A(h,p){const t=await v(h,p);if(!t)return h.info(`Lock '${p}': Could not read pid of lock holder.`),c(h,p);if(t.willReleaseAt){let f=t.willReleaseAt-Date.now();if(f<5e3){for(f>0?h.info(`Lock '${p}': The lockfile is scheduled to be released in ${f} ms.`):h.info(`Lock '${p}': The lockfile is scheduled to have been released.`);f>0;){if(await(0,S.timeout)(Math.min(100,f)),await _(h,p)===0)return c(h,p);f=t.willReleaseAt-Date.now()}return c(h,p)}}if(!b(t.pid))return h.info(`Lock '${p}': The pid ${t.pid} appears to be gone.`),c(h,p);const r=await _(h,p),o=Date.now()-r;if(o<=u)return h.info(`Lock '${p}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null;h.info(`Lock '${p}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const n=await _(h,p),a=Date.now()-n;return a<=u?(h.info(`Lock '${p}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null):(h.info(`Lock '${p}': The lock looks stale even after waiting for 2s.`),c(h,p))}async function c(h,p){h.info(`Lock '${p}': Deleting a stale lock.`);try{await g.promises.unlink(p)}catch(t){}return l(h,p,!0)}}),define(me[261],ge([0,1,32,13,33]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends k.BaseExtHostTerminalService{constructor(C){super(!0,C)}createTerminal(C,S,P){return this.createTerminalFromOptions({name:C,shellPath:S,shellArgs:P})}createTerminalFromOptions(C,S){const P=new k.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),C,C.name);return this._terminals.push(P),P.create(C,S),P.value}};y=Ve([$e(0,L.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(me[262],ge([0,1,5,13,6,27,2,39,23,28,7,11,52,3,193,75,12]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(d,w,E){this.remoteAddress=d,this.localAddress=w,this._dispose=E,this._onDispose=new m.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function A(f){const d=f.trim().split(`
`),w=[];return d.forEach(s=>{const D=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(s);D&&D.length>=3&&w.push({pid:parseInt(D[1],10),socket:parseInt(D[2],10)})}),w.reduce((s,D)=>(s[D.socket]=D,s),{})}e.getSockets=A;function c(...f){const d=[].concat(...f.map(p));return[...new Map(d.filter(w=>w.st==="0A").map(w=>{const E=w.local_address.split(":");return{socket:parseInt(w.inode,10),ip:h(E[0]),port:parseInt(E[1],16)}}).map(w=>[w.ip+":"+w.port,w])).values()]}e.loadListeningPorts=c;function h(f){let d="";if(f.length===8)for(let w=f.length-2;w>=0;w-=2)d+=parseInt(f.substr(w,2),16),w!==0&&(d+=".");else for(let w=f.length-4;w>=0;w-=4)d+=parseInt(f.substr(w,4),16).toString(16),w!==0&&(d+=":");return d}e.parseIpAddress=h;function p(f){const d=f.trim().split(`
`),w=d.shift().trim().split(/\s+/).filter(s=>s!=="rx_queue"&&s!=="tm->when");return d.map(s=>s.trim().split(/\s+/).reduce((D,R,U)=>(D[w[U]||U]=R,D),{}))}e.loadConnectionTable=p;function t(f){return!!f.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||f.indexOf("out/vs/server/main.js")!==-1||f.indexOf("_productName=VSCode")!==-1}function r(f){const d=f.trim().split(`
`),w=[];return d.forEach(E=>{const s=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);s&&s.length>=4&&w.push({pid:parseInt(s[1],10),ppid:parseInt(s[2]),cmd:s[3]})}),w}e.getRootProcesses=r;async function o(f,d,w){const E=w.reduce((D,R)=>(D[R.pid]=R,D),{}),s=[];return f.forEach(({socket:D,ip:R,port:U})=>{const V=d[D]?d[D].pid:void 0,ee=V?E[V]?.cmd:void 0;V&&ee&&!t(ee)&&s.push({host:R,port:U,detail:ee,pid:V})}),s}e.findPorts=o;function n(f,d,w){const E=new Map,s=r(d);for(const D of f){const R=w.get(D.port);if(R){E.set(D.port,R);continue}const U=s.find(V=>V.cmd.includes(`${D.port}`));if(U){let V=U,ee;do ee=s.find(K=>K.ppid===V.pid),ee&&(V=ee);while(ee);E.set(D.port,{host:D.ip,port:D.port,pid:V.pid,detail:V.cmd,ppid:V.ppid})}else E.set(D.port,{host:D.ip,port:D.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=n;let a=class extends k.Disposable{constructor(d,w,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new m.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=d.getProxy(g.MainContext.MainThreadTunnelService),I.isLinux&&w.remote.isRemote&&w.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(d,w){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${w.remoteAddress.host}:${w.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(w,d.displayName);if(E){const s=new b(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(s),s}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(d){return Math.max(d*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(d,w){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:d,provider:w}),this._proxy.$registerPortsAttributesProvider(d,E),new i.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(d,w,E,s,D){const R=[];for(const V of d){const ee=this._portAttributesProviders.get(V);if(!ee)return[];R.push(...await Promise.all(w.map(async K=>ee.provider.providePortAttributes(K,E,s,D))))}const U=R.filter(V=>!!V);return U.length>0?U.map(V=>({autoForwardAction:V.autoForwardAction,port:V.port})):[]}async $registerCandidateFinder(d){if(d&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=d;let w=new v.MovingAverage,E;for(;this._candidateFindingEnabled;){const s=new Date().getTime(),D=(await this.findCandidatePorts()).filter(U=>(0,l.isLocalhost)(U.host)||(0,l.isAllInterfaces)(U.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${D.map(U=>U.port).join(", ")}`);const R=new Date().getTime()-s;w.update(R),(!E||JSON.stringify(E)!==JSON.stringify(D))&&(E=D,await this._proxy.$onFoundNewCandidates(E)),await new Promise(U=>setTimeout(()=>U(),this.calculateDelay(w.value)))}}async setTunnelExtensionFunctions(d){return d?(d.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this._showCandidatePort=d.showCandidatePort,this._proxy.$setCandidateFilter()),d.tunnelFactory&&(this._forwardPortProvider=d.tunnelFactory,this._proxy.$setTunnelProvider(d.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,k.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(d,w){if(this._extensionTunnels.has(d.host)){const E=this._extensionTunnels.get(d.host);E.has(d.port)&&(w&&E.get(d.port).disposeListener.dispose(),await E.get(d.port).tunnel.dispose(),E.delete(d.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(d,w){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(d,w);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const s=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(d.remoteAddress.host)||this._extensionTunnels.set(d.remoteAddress.host,new Map);const D=this._register(s.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(s.remoteAddress))));return this._extensionTunnels.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:s,disposeListener:D}),u.TunnelDto.fromApiTunnel(s)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(d){const w=await Promise.all(d.map(s=>this._showCandidatePort(s.host,s.port,s.detail??""))),E=d.filter((s,D)=>w[D]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(s=>s.port).join(", ")} to ${E.map(s=>s.port).join(", ")}`),E}async findCandidatePorts(){let d="",w="";try{d=await P.Promises.readFile("/proc/net/tcp","utf8"),w=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch(x){}const E=c(d,w),s=await new Promise(x=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,z,M)=>{x(z)})}),D=A(s),R=await P.Promises.readdir("/proc"),U=[];for(let x of R)try{const F=Number(x),z=S.joinPath(T.URI.file("/proc"),x);if((await P.Promises.stat(z.fsPath)).isDirectory()&&!isNaN(F)){const N=await P.Promises.readlink(S.joinPath(z,"cwd").fsPath),q=await P.Promises.readFile(S.joinPath(z,"cmdline").fsPath,"utf8");U.push({pid:F,cwd:N,cmd:q})}}catch(F){}const V=[],ee=E.filter(x=>{const F=D[x.socket];return F||V.push(x),F}),K=o(ee,D,U);let O;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${V.length}`),V.length>0){const x=await new Promise(F=>{(0,C.exec)("ps -F -A -l | grep root",(z,M,N)=>{F(M)})});this._foundRootPorts=n(V,x,this._foundRootPorts),O=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${O.join(", ")}`)}return K.then(x=>O?x.concat(O):x)}};a=Ve([$e(0,L.IExtHostRpcService),$e(1,y.IExtHostInitDataService),$e(2,_.ILogService)],a),e.ExtHostTunnelService=a}),define(me[263],ge([0,1,17,21,16,3,6,103,227,130,24]),function(J,e,g,L,k,y,T,C,S,P,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function u(n,a){try{return JSON.stringify(n,a)}catch(f){return"null"}}function m(n,a){return JSON.stringify(n,a)}function l(n){return n?(a,f)=>f&&f.$mid===1?n.transformOutgoing(f):f:null}var v;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const b=()=>{},A=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class h extends T.Disposable{constructor(a,f=null,d=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=f,this._uriTransformer=d,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let w=0,E=P.ProxyIdentifier.count;w<E;w++)this._locals[w]=null,this._proxies[w]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(w=>this._receiveOneMessage(w))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(k.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?(0,C.transformIncomingURIs)(a,this._uriTransformer):a}getProxy(a){const{nid:f,sid:d}=a;return this._proxies[f]||(this._proxies[f]=this._createProxy(f,d)),this._proxies[f]}_createProxy(a,f){let d={get:(w,E)=>(typeof E=="string"&&!w[E]&&E.charCodeAt(0)===36&&(w[E]=(...s)=>this._remoteCall(a,E,s)),E===c?f:w[E])};return new Proxy(Object.create(null),d)}set(a,f){return this._locals[a.nid]=f,f}assertRegistered(a){for(let f=0,d=a.length;f<d;f++){const w=a[f];if(!this._locals[w.nid])throw new Error(`Missing actor ${w.sid} (isMain: ${w.isMain})`)}}_receiveOneMessage(a){if(this._isDisposed)return;const f=a.byteLength,d=p.read(a,0),w=d.readUInt8(),E=d.readUInt32();switch(w){case 1:case 2:{let{rpcId:s,method:D,args:R}=t.deserializeRequestJSONArgs(d);this._uriTransformer&&(R=(0,C.transformIncomingURIs)(R,this._uriTransformer)),this._receiveRequest(f,E,s,D,R,w===2);break}case 3:case 4:{let{rpcId:s,method:D,args:R}=t.deserializeRequestMixedArgs(d);this._uriTransformer&&(R=(0,C.transformIncomingURIs)(R,this._uriTransformer)),this._receiveRequest(f,E,s,D,R,w===4);break}case 5:{this._logger&&this._logger.logIncoming(f,E,0,"ack"),this._onDidReceiveAcknowledge(E);break}case 6:{this._receiveCancel(f,E);break}case 7:{this._receiveReply(f,E,void 0);break}case 9:{let s=t.deserializeReplyOKJSON(d);this._uriTransformer&&(s=(0,C.transformIncomingURIs)(s,this._uriTransformer)),this._receiveReply(f,E,s);break}case 8:{let s=t.deserializeReplyOKVSBuffer(d);this._receiveReply(f,E,s);break}case 10:{let s=t.deserializeReplyErrError(d);this._uriTransformer&&(s=(0,C.transformIncomingURIs)(s,this._uriTransformer)),this._receiveReplyErr(f,E,s);break}case 11:{this._receiveReplyErr(f,E,void 0);break}default:console.error("received unexpected message"),console.error(a)}}_receiveRequest(a,f,d,w,E,s){this._logger&&this._logger.logIncoming(a,f,1,`receiveRequest ${(0,P.getStringIdentifierForProxy)(d)}.${w}(`,E);const D=String(f);let R,U;if(s){const ee=new L.CancellationTokenSource;E.push(ee.token),R=this._invokeHandler(d,w,E),U=()=>ee.cancel()}else R=this._invokeHandler(d,w,E),U=b;this._cancelInvokedHandlers[D]=U;const V=t.serializeAcknowledged(f);this._logger&&this._logger.logOutgoing(V.byteLength,f,1,"ack"),this._protocol.send(V),R.then(ee=>{delete this._cancelInvokedHandlers[D];const K=t.serializeReplyOK(f,ee,this._uriReplacer);this._logger&&this._logger.logOutgoing(K.byteLength,f,1,"reply:",ee),this._protocol.send(K)},ee=>{delete this._cancelInvokedHandlers[D];const K=t.serializeReplyErr(f,ee);this._logger&&this._logger.logOutgoing(K.byteLength,f,1,"replyErr:",ee),this._protocol.send(K)})}_receiveCancel(a,f){this._logger&&this._logger.logIncoming(a,f,1,"receiveCancel");const d=String(f);this._cancelInvokedHandlers[d]&&this._cancelInvokedHandlers[d]()}_receiveReply(a,f,d){this._logger&&this._logger.logIncoming(a,f,0,"receiveReply:",d);const w=String(f);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const E=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w],E.resolveOk(d)}_receiveReplyErr(a,f,d){this._logger&&this._logger.logIncoming(a,f,0,"receiveReplyErr:",d);const w=String(f);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const E=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w];let s;d&&(d.$isError?(s=new Error,s.name=d.name,s.message=d.message,s.stack=d.stack):s=d),E.resolveErr(s)}_invokeHandler(a,f,d){try{return Promise.resolve(this._doInvokeHandler(a,f,d))}catch(w){return Promise.reject(w)}}_doInvokeHandler(a,f,d){const w=this._locals[a];if(!w)throw new Error("Unknown actor "+(0,P.getStringIdentifierForProxy)(a));let E=w[f];if(typeof E!="function")throw new Error("Unknown method "+f+" on actor "+(0,P.getStringIdentifierForProxy)(a));return E.apply(w,d)}_remoteCall(a,f,d){if(this._isDisposed)return Promise.reject(k.canceled());let w=null;if(d.length>0&&L.CancellationToken.isCancellationToken(d[d.length-1])&&(w=d.pop()),w&&w.isCancellationRequested)return Promise.reject(k.canceled());const E=t.serializeRequestArguments(d,this._uriReplacer),s=++this._lastMessageId,D=String(s),R=new S.LazyPromise;w&&w.onCancellationRequested(()=>{const V=t.serializeCancel(s);this._logger&&this._logger.logOutgoing(V.byteLength,s,0,"cancel"),this._protocol.send(t.serializeCancel(s))}),this._pendingRPCReplies[D]=R,this._onWillSendRequest(s);const U=t.serializeRequest(s,a,f,E,!!w);return this._logger&&this._logger.logOutgoing(U.byteLength,s,0,`request: ${(0,P.getStringIdentifierForProxy)(a)}.${f}(`,d),this._protocol.send(U),R}}e.RPCProtocol=h,I=A,h.UNRESPONSIVE_TIME=3*1e3;class p{constructor(a,f){this._buff=a,this._offset=f}static alloc(a,f,d){let w=new p(i.VSBuffer.alloc(d+1+4),0);return w.writeUInt8(a),w.writeUInt32(f),w}static read(a,f){return new p(a,f)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const d=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,d}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const d=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,d}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,f}static sizeMixedArray(a,f){let d=0;d+=1;for(let w=0,E=a.length;w<E;w++){const s=a[w],D=f[w];switch(d+=1,D){case 1:d+=this.sizeLongString(s);break;case 2:d+=this.sizeVSBuffer(s);break;case 3:break}}return d}writeMixedArray(a,f){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let d=0,w=a.length;d<w;d++){const E=a[d];switch(f[d]){case 1:this.writeUInt8(1),this.writeLongString(E);break;case 2:this.writeUInt8(2),this.writeVSBuffer(E);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let f=new Array(a);for(let d=0;d<a;d++)switch(this.readUInt8()){case 1:f[d]=this.readLongString();break;case 2:f[d]=this.readVSBuffer();break;case 3:f[d]=void 0;break}return f}}class t{static _arrayContainsBufferOrUndefined(a){for(let f=0,d=a.length;f<d;f++)if(a[f]instanceof i.VSBuffer||typeof a[f]=="undefined")return!0;return!1}static serializeRequestArguments(a,f){if(this._arrayContainsBufferOrUndefined(a)){let d=[],w=[];for(let E=0,s=a.length;E<s;E++){const D=a[E];D instanceof i.VSBuffer?(d[E]=D,w[E]=2):typeof D=="undefined"?(d[E]=i.VSBuffer.alloc(0),w[E]=3):(d[E]=i.VSBuffer.fromString(m(D,f)),w[E]=1)}return{type:"mixed",args:d,argsType:w}}return{type:"simple",args:m(a,f)}}static serializeRequest(a,f,d,w,E){return w.type==="mixed"?this._requestMixedArgs(a,f,d,w.args,w.argsType,E):this._requestJSONArgs(a,f,d,w.args,E)}static _requestJSONArgs(a,f,d,w,E){const s=i.VSBuffer.fromString(d),D=i.VSBuffer.fromString(w);let R=0;R+=p.sizeUInt8(),R+=p.sizeShortString(s),R+=p.sizeLongString(D);let U=p.alloc(E?2:1,a,R);return U.writeUInt8(f),U.writeShortString(s),U.writeLongString(D),U.buffer}static deserializeRequestJSONArgs(a){const f=a.readUInt8(),d=a.readShortString(),w=a.readLongString();return{rpcId:f,method:d,args:JSON.parse(w)}}static _requestMixedArgs(a,f,d,w,E,s){const D=i.VSBuffer.fromString(d);let R=0;R+=p.sizeUInt8(),R+=p.sizeShortString(D),R+=p.sizeMixedArray(w,E);let U=p.alloc(s?4:3,a,R);return U.writeUInt8(f),U.writeShortString(D),U.writeMixedArray(w,E),U.buffer}static deserializeRequestMixedArgs(a){const f=a.readUInt8(),d=a.readShortString(),w=a.readMixedArray(),E=new Array(w.length);for(let s=0,D=w.length;s<D;s++){const R=w[s];typeof R=="string"?E[s]=JSON.parse(R):E[s]=R}return{rpcId:f,method:d,args:E}}static serializeAcknowledged(a){return p.alloc(5,a,0).buffer}static serializeCancel(a){return p.alloc(6,a,0).buffer}static serializeReplyOK(a,f,d){return typeof f=="undefined"?this._serializeReplyOKEmpty(a):f instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(a,f):this._serializeReplyOKJSON(a,u(f,d))}static _serializeReplyOKEmpty(a){return p.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,f){let d=0;d+=p.sizeVSBuffer(f);let w=p.alloc(8,a,d);return w.writeVSBuffer(f),w.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,f){const d=i.VSBuffer.fromString(f);let w=0;w+=p.sizeLongString(d);let E=p.alloc(9,a,w);return E.writeLongString(d),E.buffer}static deserializeReplyOKJSON(a){const f=a.readLongString();return JSON.parse(f)}static serializeReplyErr(a,f){return f?this._serializeReplyErrEror(a,f):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,f){const d=i.VSBuffer.fromString(u(k.transformErrorForSerialization(f),null));let w=0;w+=p.sizeLongString(d);let E=p.alloc(10,a,w);return E.writeLongString(d),E.buffer}static deserializeReplyErrError(a){const f=a.readLongString();return JSON.parse(f)}static _serializeReplyErrEmpty(a){return p.alloc(11,a,0).buffer}}var r;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyErrError=10]="ReplyErrError",n[n.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var o;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.Undefined=3]="Undefined"})(o||(o={}))}),define(me[264],ge([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(me[265],ge([0,1,10,9,11,2,4,84,43,222,264]),function(J,e,g,L,k,y,T,C,S,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,T.createDecorator)("pathService");let I=class $n{constructor(m,l,v,_){this.localUserHome=m,this.remoteAgentService=l,this.environmentService=v,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||k.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome||m})()}get defaultUriScheme(){return $n.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,l){if(m.remoteAuthority)return g.Schemas.vscodeRemote;const v=(0,C.getVirtualWorkspaceScheme)(l.getWorkspace());if(v)return v;const _=l.getWorkspace().folders[0];if(_)return _.uri.scheme;const b=l.getWorkspace().configuration;return b?b.scheme:g.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?L.win32:L.posix)}async fileURI(m){let l="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const _=m.indexOf("/",2);_===-1?(l=m.substring(2),m="/"):(l=m.substring(2,_),m=m.substring(_)||"/")}return y.URI.from({scheme:g.Schemas.file,authority:l,path:m,query:"",fragment:""})}};I=Ve([$e(1,i.IRemoteAgentService),$e(2,P.IWorkbenchEnvironmentService),$e(3,S.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(me[68],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(T,C){this.line=T,this.character=C}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,C){return new g(0,0)}with(T){return new g(0,0)}}e.Position=g;class L{constructor(T,C,S,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(T,C),this.end=new g(S,P)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new L(0,0,0,0)}with(T){return new L(0,0,0,0)}}e.Range=L;var k;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,20,30,25,29,8,4,9,16,68]),function(J,e,g,L,k,y,T,C,S,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",u=" characters skipped \u27EB",m=(I.length+u.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var l;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function _(F){return!!F.preview}e.resultIsMatch=_;function b(F){return!!F.resource}e.isFileMatch=b;function A(F){return!!F.message}e.isProgressMessage=A;var c;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=h;class p{constructor(z,M,N){this.ranges=M;const q=Array.isArray(M)?M:[M];if(N&&N.matchLines===1&&t(q)){z=(0,T.getNLines)(z,N.matchLines);let B="",G=0,re=0;const he=Math.floor(N.charsPerLine/5),ye=[];for(const Ie of q){const Le=Math.max(Ie.startColumn-he,0),qe=Ie.startColumn+N.charsPerLine;if(Le>re+he+m){const We=I+(Le-re)+u;B+=We+z.slice(Le,qe),G+=Le-(re+We.length)}else B+=z.slice(re,qe);ye.push(new o(0,Ie.startColumn-G,Ie.endColumn-G)),re=qe}this.preview={text:B,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const B=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:z,matches:(0,g.mapArrayOrNot)(M,G=>new r(G.startLineNumber-B,G.startColumn,G.endLineNumber-B,G.endColumn))}}}}e.TextSearchMatch=p;function t(F){const z=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==z||M.endLineNumber!==z)return!1;return!0}class r{constructor(z,M,N,q){this.startLineNumber=z,this.startColumn=M,this.endLineNumber=N,this.endColumn=q}}e.SearchRange=r;class o extends r{constructor(z,M,N){super(z,M,z,N)}}e.OneLineRange=o;var n;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function a(F,z=!0){const M=F&&F.files&&F.files.exclude,N=z&&F&&F.search&&F.search.exclude;if(!M&&!N)return;if(!M||!N)return M||N;let q=Object.create(null);return q=k.mixin(q,k.deepClone(M)),q=k.mixin(q,k.deepClone(N),!0),q}e.getExcludes=a;function f(F,z){return F.excludePattern&&L.match(F.excludePattern,z)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&L.match(F.includePattern,z)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const N=M.folder.fsPath;if(y.isEqualOrParent(z,N)){const q=S.relative(N,z);return!M.includePattern||!!L.match(M.includePattern,q)}else return!1}):!1:!0}e.pathIncludedInQuery=f;var d;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(z,M){super(z);this.code=M}}e.SearchError=w;function E(F){const z=F.message;if((0,P.isPromiseCanceledError)(F))return new w(z,d.canceled);try{const M=JSON.parse(z);return new w(M.message,M.code)}catch(M){return new w(z,d.other)}}e.deserializeSearchError=E;function s(F){const z={message:F.message,code:F.code};return new Error(JSON.stringify(z))}e.serializeSearchError=s;function D(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=D;function R(F){return F.type==="success"}e.isSerializedSearchSuccess=R;function U(F){return!!F.path}e.isSerializedFileMatch=U;function V(F,z){const M=F.searchPath?F.searchPath:F.relativePath;return(0,T.fuzzyContains)(M,z)}e.isFilePatternMatch=V;class ee{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ee;function K(F,z){const M={...F||{},...z||{}};return Object.keys(M).filter(N=>{const q=M[N];return typeof q=="boolean"&&q})}e.resolvePatternsForProvider=K;class O{constructor(z,M){this._parsedIncludeExpression=null,this._excludeExpression={...z.excludePattern||{},...M.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let N=z.includePattern;M.includePattern&&(N?N={...N,...M.includePattern}:N=M.includePattern),N&&(this._parsedIncludeExpression=L.parse(N))}includedInQuerySync(z,M,N){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,M,N)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,M,N))}includedInQuery(z,M,N){return Promise.resolve(this._parsedExcludeExpression(z,M,N)).then(B=>!!B).then(B=>B?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(z,M,N)).then(G=>!!G):Promise.resolve(!0)).then(B=>B)}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=O;function x(F){for(const z in F)if(typeof F[z]!="boolean")return!0;return!1}}),define(me[36],ge([0,1,20,17,21,3,22,10,75,23,8,14,2,169,4,12,189,43,62,27,13,7,31,5]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_,b,A,c,h,p,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(D,R,U){return new P.ExtUri(V=>d(V,U)).isEqual(D,R)}function n(D,R,U){return o(D.uri,R.uri,U)?0:(0,i.compare)(D.uri.toString(),R.uri.toString())}function a(D,R,U){return D.index!==R.index?D.index<R.index?-1:1:o(D.uri,R.uri,U)?(0,i.compare)(D.name,R.name):(0,i.compare)(D.uri.toString(),R.uri.toString())}function f(D,R,U,V){const ee=D.slice(0).sort((O,x)=>U(O,x,V)),K=R.slice(0).sort((O,x)=>U(O,x,V));return(0,g.delta)(ee,K,(O,x)=>U(O,x,V))}function d(D,R){const U=R.getCapabilities(D.scheme);return!(U&&U&1024)}class w extends b.Workspace{constructor(R,U,V,ee,K,O){super(R,V.map(x=>new b.WorkspaceFolder(x)),ee,O);this._name=U,this._isUntitled=K,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(O),V.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(R,U,V,ee){if(!R)return{workspace:null,added:[],removed:[]};const{id:K,name:O,folders:x,configuration:F,isUntitled:z}=R,M=[],N=U;U?x.forEach((re,he)=>{const ye=u.URI.revive(re.uri),Ie=w._findFolder(V||U,ye,ee);Ie?(Ie.name=re.name,Ie.index=re.index,M.push(Ie)):M.push({uri:ye,name:re.name,index:he})}):M.push(...x.map(({uri:re,name:he,index:ye})=>({uri:u.URI.revive(re),name:he,index:ye}))),M.sort((re,he)=>re.index<he.index?-1:1);const q=new w(K,O,M,F?u.URI.revive(F):null,!!z,re=>d(re,ee)),{added:B,removed:G}=f(N?N.workspaceFolders:[],q.workspaceFolders,n,ee);return{workspace:q,added:B,removed:G}}static _findFolder(R,U,V){for(let ee=0;ee<R.folders.length;ee++){const K=R.workspaceFolders[ee];if(o(K.uri,U,V))return K}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,U){return U&&this._structure.get(R)&&(R=(0,P.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let E=class{constructor(R,U,V,ee){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=ee,this._extHostFileSystemInfo=V,this._requestIdProvider=new S.Counter,this._barrier=new L.Barrier,this._proxy=R.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(r.MainContext.MainThreadMessageService);const K=U.workspace;this._confirmedWorkspace=K?new w(K.id,K.name,[],K.configuration?u.URI.revive(K.configuration):null,!!K.isUntitled,O=>d(O,V)):void 0}$initializeWorkspace(R,U){this._trusted=U,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:C.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,U,V,...ee){const K=[];if(Array.isArray(ee)&&ee.forEach(M=>{u.URI.isUri(M.uri)&&!K.some(N=>o(N.uri,M.uri,this._extHostFileSystemInfo))&&K.push({uri:M.uri,name:M.name||(0,P.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[U,V].some(M=>typeof M!="number"||M<0)||V===0&&K.length===0)return!1;const O=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+V>O.length)return!1;const x=O.slice(0);x.splice(U,V,...K.map(M=>({uri:M.uri,name:M.name||(0,P.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<x.length;M++){const N=x[M];if(x.some((q,B)=>B!==M&&o(N.uri,q.uri,this._extHostFileSystemInfo)))return!1}x.forEach((M,N)=>M.index=N);const{added:F,removed:z}=f(O,x,a,this._extHostFileSystemInfo);if(F.length===0&&z.length===0)return!1;if(this._proxy){const M=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(M,U,V,K).then(void 0,N=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,m.localize)(0,null,M,N.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(R,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,U)}async getWorkspaceFolder2(R,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,U)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,U){let V,ee="";if(typeof R=="string"?(V=u.URI.file(R),ee=R):typeof R!="undefined"&&(V=R,ee=R.fsPath),!V)return ee;const K=this.getWorkspaceFolder(V,!0);if(!K)return ee;typeof U=="undefined"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let O=(0,P.relativePath)(K.uri,V);return U&&K.name&&(O=`${K.name}/${O}`),O}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:U,added:V,removed:ee}=w.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:V,removed:ee}))}findFiles(R,U,V,ee,K=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${ee.value}, entryPoint: findFiles`);let O;if(U===null?O=!1:U&&(typeof U=="string"?O=U:O=U.pattern),K&&K.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:F}=s(R);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(x),(0,I.withUndefinedAsNull)(F),(0,I.withUndefinedAsNull)(O),(0,I.withUndefinedAsNull)(V),K).then(z=>Array.isArray(z)?z.map(M=>u.URI.revive(M)):[])}async findTextInFiles(R,U,V,ee,K=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${ee.value}, entryPoint: findTextInFiles`);const O=this._requestIdProvider.getNext(),x=typeof U.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:F,folder:z}=s(U.include),M=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,N={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:x,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:F,excludePattern:M},q=!1;if(this._activeSearchCallbacks[O]=B=>{if(q)return;const G=u.URI.revive(B.resource);B.results.forEach(re=>{(0,t.resultIsMatch)(re)?V({uri:G,preview:{text:re.preview.text,matches:(0,g.mapArrayOrNot)(re.preview.matches,he=>new p.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,g.mapArrayOrNot)(re.ranges,he=>new p.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):V({uri:G,text:re.text,lineNumber:re.lineNumber})})},K.isCancellationRequested)return{};try{const B=await this._proxy.$startTextSearch(R,(0,I.withUndefinedAsNull)(z),N,O,K);return delete this._activeSearchCallbacks[O],B||{}}catch(B){throw delete this._activeSearchCallbacks[O],B}}$handleTextSearchResult(R,U){this._activeSearchCallbacks[U]&&this._activeSearchCallbacks[U](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=Ve([$e(0,h.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,A.IExtHostFileSystemInfo),$e(3,v.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function s(D){let R,U;return D&&(typeof D=="string"?R=D:(R=D.pattern,U=D.baseFolder||u.URI.file(D.base))),{includePattern:R,folder:U}}}),define(me[37],ge([0,1,25,3,36,5,7,192,83,14,17,4,13,12,2]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(r,o){if(o){const n=o.split(".");let a=r;for(let f=0;a&&f<n.length;f++)a=a[n[f]];return a}}function _(r){return r instanceof l.URI}function b(r){return r&&r.uri instanceof l.URI&&r.languageId&&typeof r.languageId=="string"}function A(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function c(r){return r&&r.uri instanceof l.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function h(r){if(_(r))return{resource:r};if(b(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(A(r))return{overrideIdentifier:r.languageId};if(c(r))return{resource:r.uri};if(r===null)return{resource:null}}let p=class{constructor(o,n,a){this._proxy=o.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=a,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,n){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(o,n))}};p=Ve([$e(0,u.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,m.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(o,n,a,f){this._onDidChangeConfiguration=new L.Emitter,this._proxy=o,this._logService=f,this._extHostWorkspace=n,this._configuration=C.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,n){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,a))}getConfiguration(o,n,a){const f=h(n)||{},d=this._toReadonlyValue(o?v(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,f,a?.identifier);function w(s){if(s==null)return null;if(typeof s=="boolean")return s?1:4;switch(s){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const E={has(s){return typeof v(d,s)!="undefined"},get:(s,D)=>{this._validateConfigurationAccess(o?`${o}.${s}`:s,f,a?.identifier);let R=v(d,s);if(typeof R=="undefined")R=D;else{let U;const V=(ee,K)=>{let O;const x=()=>{U=U||(0,g.deepClone)(d),O=O||v(U,K)};return(0,P.isObject)(ee)?new Proxy(ee,{get:(F,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return x(),()=>O;if(U)return O=O||v(U,K),O[z];const M=F[z];return typeof z=="string"?V(M,`${K}.${z}`):M},set:(F,z,M)=>(x(),O&&(O[z]=M),!0),deleteProperty:(F,z)=>(x(),O&&delete O[z],!0),defineProperty:(F,z,M)=>(x(),O&&Object.defineProperty(O,z,M),!0)}):ee};R=V(R,s)}return R},update:(s,D,R,U)=>{s=o?`${o}.${s}`:s;const V=w(R);return D!==void 0?this._proxy.$updateConfigurationOption(V,s,D,f,U):this._proxy.$removeConfigurationOption(V,s,f,U)},inspect:s=>{s=o?`${o}.${s}`:s;const D=(0,g.deepClone)(this._configuration.inspect(s,f,this._extHostWorkspace.workspace));if(D)return{key:s,defaultValue:D.default?.value,globalValue:D.user?.value,workspaceValue:D.workspace?.value,workspaceFolderValue:D.workspaceFolder?.value,defaultLanguageValue:D.default?.override,globalLanguageValue:D.user?.override,workspaceLanguageValue:D.workspace?.override,workspaceFolderLanguageValue:D.workspaceFolder?.override,languageIds:D.overrideIdentifiers}}};return typeof d=="object"&&(0,g.mixin)(E,d,!1),Object.freeze(E)}_toReadonlyValue(o){const n=a=>(0,P.isObject)(a)?new Proxy(a,{get:(f,d)=>n(f[d]),set:(f,d,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(f,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(f,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return n(o)}_validateConfigurationAccess(o,n,a){const f=S.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),d=a?`[${a.value}] `:"";if(f===4){typeof n?.resource=="undefined"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){n?.resource&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,n){const a=new C.ConfigurationChangeEvent(o,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,d)=>a.affectsConfiguration(f,h(d))})}_toMap(o){return o.reduce((n,a)=>(n.set(a[0],a[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(me[69],ge([0,1,2,17,3,5,25,7,36,45,37,21,33,13,27,4,10,11,12,64,212,16]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_,b,A,c,h,p){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(O){function x(z){if(z!=null)return z}O.from=x;function F(z){if(z!=null)return z}O.to=F})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var o;(function(O){function x(z){if(z!=null)return z}O.from=x;function F(z){if(z!=null)return z}O.to=F})(o=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(O){function x(z){if(z!=null)return z}O.from=x;function F(z){if(z!=null)return z}O.to=F})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var a;(function(O){function x(M){if(M){const N=M;return N&&!!N.process}else return!1}O.is=x;function F(M){if(M==null)return;const N={process:M.process,args:M.args};return M.options&&(N.options=n.from(M.options)),N}O.from=F;function z(M){if(M!=null)return new C.ProcessExecution(M.process,M.args,M.options)}O.to=z})(a=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var f;(function(O){function x(z){if(z!=null)return z}O.from=x;function F(z){if(z!=null)return z}O.to=F})(f=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(O){function x(M){if(M){const N=M;return N&&(!!N.commandLine||!!N.command)}else return!1}O.is=x;function F(M){if(M==null)return;const N={};return M.commandLine!==void 0?N.commandLine=M.commandLine:(N.command=M.command,N.args=M.args),M.options&&(N.options=f.from(M.options)),N}O.from=F;function z(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new C.ShellExecution(M.commandLine,M.options):new C.ShellExecution(M.command,M.args?M.args:[],M.options)}O.to=z})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var w;(function(O){function x(M){if(M){let N=M;return N&&N.customExecution==="customExecution"}else return!1}O.is=x;function F(M){return{customExecution:"customExecution"}}O.from=F;function z(M,N){return N.get(M)}O.to=z})(w=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(O){function x(F,z){let M;return F.scope!==void 0&&typeof F.scope!="number"?M=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===C.TaskScope.Workspace&&z&&z.workspaceFile?M=z.workspaceFile:M=h.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:M}}O.from=x})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var s;(function(O){function x(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}O.from=x})(s=e.TaskGroupDTO||(e.TaskGroupDTO={}));var D;(function(O){function x(M,N){if(M==null)return[];const q=[];for(let B of M){const G=F(B,N);G&&q.push(G)}return q}O.fromMany=x;function F(M,N){if(M==null)return;let q;M.execution instanceof C.ProcessExecution?q=a.from(M.execution):M.execution instanceof C.ShellExecution?q=d.from(M.execution):M.execution&&M.execution instanceof C.CustomExecution&&(q=w.from(M.execution));const B=r.from(M.definition);let G;return M.scope?typeof M.scope=="number"?G=M.scope:G=M.scope.uri:G=C.TaskScope.Workspace,!B||!G?void 0:{_id:M._id,definition:B,name:M.name,source:{extensionId:N.identifier.value,label:M.source,scope:G},execution:q,isBackground:M.isBackground,group:s.from(M.group),presentationOptions:o.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}O.from=F;async function z(M,N,q){if(M==null)return;let B;a.is(M.execution)?B=a.to(M.execution):d.is(M.execution)?B=d.to(M.execution):w.is(M.execution)&&(B=w.to(M._id,q));const G=r.to(M.definition);let re;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?re=M.source.scope:re=await N.resolveWorkspaceFolder(g.URI.revive(M.source.scope)):re=C.TaskScope.Workspace),!G||!re)return;const he=new C.Task(G,re,M.name,M.source.label,B,M.problemMatchers);return M.isBackground!==void 0&&(he.isBackground=M.isBackground),M.group!==void 0&&(he.group=C.TaskGroup.from(M.group._id),he.group&&(he.group=T.deepClone(he.group),M.group.isDefault&&(he.group.isDefault=M.group.isDefault))),M.presentationOptions&&(he.presentationOptions=o.to(M.presentationOptions)),M._id&&(he._id=M._id),M.detail&&(he.detail=M.detail),he}O.to=z})(D=e.TaskDTO||(e.TaskDTO={}));var R;(function(O){function x(z){return z}O.from=x;function F(z){if(!!z)return Object.assign(Object.create(null),z)}O.to=F})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class U{constructor(x,F,z){this._id=F,this._task=z,t.set(this,void 0),it(this,t,x,"f")}get task(){return this._task}terminate(){He(this,t,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}t=new WeakMap;var V;(function(O){function x(F){return{id:F._id,task:void 0}}O.from=x})(V=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let ee=class{constructor(x,F,z,M,N,q,B,G){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=x.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=z,this._editorService=M,this._configurationService=N,this._terminalService=q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=B,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,F,z){if(!z)return new C.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:F,provider:z,extension:x}),this._proxy.$registerTaskProvider(M,F),new C.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(x,F){this._proxy.$registerTaskSystem(x,F)}fetchTasks(x){return this._proxy.$fetchTasks(R.from(x)).then(async F=>{const z=[];for(let M of F){const N=await D.to(M,this._workspaceProvider,this._providedCustomExecutions2);N&&z.push(N)}return z})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(F=>x.push(F)),x}terminateTask(x){if(!(x instanceof U))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,F,z){const M=this._providedCustomExecutions2.get(x.id);if(M){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,M),this._terminalService.attachPtyToTerminal(F,await M.callback(z))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const F=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:F})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const F=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:F,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const F=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:F,exitCode:x.exitCode})}$provideTasks(x,F){const z=this._handlers.get(x);if(!z)return Promise.reject(new Error("no handler found"));const M=[],N=(0,L.asPromise)(()=>z.provider.provideTasks(I.CancellationToken.None)).then(q=>this.provideTasksInternal(F,M,z,q));return new Promise(q=>{N.then(B=>{Promise.all(M).then(()=>{q(B)})})})}async $resolveTask(x,F){const z=this._handlers.get(x);if(!z)return Promise.reject(new Error("no handler found"));if(F.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${z.type}].`);const M=await D.to(F,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const N=await z.provider.resolveTask(M,I.CancellationToken.None);if(!N)return;this.checkDeprecation(N,z);const q=D.from(N,z.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(N.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(q.execution)&&await this.addCustomExecution(q,N,!0),await this.resolveTaskInternal(q)}nextHandle(){return this._handleCounter++}async addCustomExecution(x,F,z){const M=await this._proxy.$createTaskId(x);!z&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,F.execution)}async getTaskExecution(x,F){if(typeof x=="string"){const N=this._taskExecutionPromises.get(x);if(!N)throw new Error("Unexpected: The specified task is missing an execution");return N}let z=this._taskExecutionPromises.get(x.id);if(z)return z;const M=new Promise(async(N,q)=>{const B=F||await D.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);B?N(new U(this,x.id,B)):q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,M),M.then(N=>(this._taskExecutions.set(x.id,N),N),N=>Promise.reject(N))}checkDeprecation(x,F){x._deprecated&&this._deprecationService.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let z=this._notProvidedCustomExecutions.values(),M=z.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=z.next()}};ee=Ve([$e(0,m.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,S.IExtHostWorkspace),$e(3,P.IExtHostDocumentsAndEditors),$e(4,i.IExtHostConfiguration),$e(5,u.IExtHostTerminalService),$e(6,A.ILogService),$e(7,c.IExtHostApiDeprecationService)],ee),e.ExtHostTaskBase=ee;let K=class extends ee{constructor(x,F,z,M,N,q,B,G){super(x,F,z,M,N,q,B,G);this.registerTaskSystem(_.Schemas.vscodeRemote,{scheme:_.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(x,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const z=D.from(F,x);if(z===void 0)throw new Error("Task is not valid");if(w.is(z.execution))await this.addCustomExecution(z,F,!1);else throw new p.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(z),F);return this._proxy.$executeTask(z).catch(N=>{throw new Error(N)}),M}provideTasksInternal(x,F,z,M){const N=[];if(M)for(let q of M){this.checkDeprecation(q,z),(!q.definition||!x[q.definition.type])&&this._logService.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const B=D.from(q,z.extension);B&&w.is(B.execution)?(N.push(B),F.push(this.addCustomExecution(B,q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:N,extension:z.extension}}async resolveTaskInternal(x){if(w.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(x,F,z){}};K=Ve([$e(0,m.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,S.IExtHostWorkspace),$e(3,P.IExtHostDocumentsAndEditors),$e(4,i.IExtHostConfiguration),$e(5,u.IExtHostTerminalService),$e(6,A.ILogService),$e(7,c.IExtHostApiDeprecationService)],K),e.WorkerExtHostTask=K,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(me[266],ge([0,1,20,55,30,77,22,10,9,23,8,14,2,145,175,120,43,127,265,31]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_,b,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(w,E,s,D){this.configurationService=w,this.workspaceContextService=E,this.editorGroupsService=s,this.pathService=D}text(w,E,s={}){w=this.getContentPattern(w,s);const D=this.configurationService.getValue(),R=E&&E.some(V=>!this.configurationService.getValue({resource:V}).search.useRipgrep);return{...this.commonQuery(E?.map(_.toWorkspaceFolder),s),type:2,contentPattern:w,previewOptions:s.previewOptions,maxFileSize:s.maxFileSize,usePCRE2:D.search.usePCRE2||R||!1,beforeContext:s.beforeContext,afterContext:s.afterContext,userDisabledExcludesAndIgnoreFiles:s.disregardExcludeSettings&&s.disregardIgnoreFiles}}getContentPattern(w,E){const s=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const D={...w,wordSeparators:s.editor.wordSeparators};return this.isCaseSensitive(w,E)&&(D.isCaseSensitive=!0),this.isMultiline(w)&&(D.isMultiline=!0),D}file(w,E={}){return{...this.commonQuery(w,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}handleIncludeExclude(w,E){return w?(w=Array.isArray(w)?w.map(n):n(w),E?this.parseSearchPaths(w):{pattern:t(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],E={}){const s=this.handleIncludeExclude(E.includePattern,E.expandPatterns),D=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),R=w.length>1,U=(s.searchPaths&&s.searchPaths.length?s.searchPaths.map(K=>this.getFolderQueryForSearchPath(K,E,D)):w.map(K=>this.getFolderQueryForRoot(K,E,D,R))).filter(K=>!!K),V={_reason:E._reason,folderQueries:U,usingSearchPaths:!!(s.searchPaths&&s.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:D.pattern,includePattern:s.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const O=g.coalesce(g.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(z=>z.resource)))).filter(F=>(0,c.pathIncludedInQuery)(V,F.fsPath)),x=this.commonQueryFromFileList(O);return{...V,...x}}const ee=E.extraFileResources&&E.extraFileResources.filter(K=>(0,c.pathIncludedInQuery)(V,K.fsPath));return V.extraFileResources=ee&&ee.length?ee:void 0,V}commonQueryFromFileList(w){const E=[],s=new T.ResourceMap,D={};let R=!1;return w.forEach(U=>{if(U.scheme===C.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(U)){const ee=this.workspaceContextService.getWorkspaceFolder(U)?.uri??U.with({path:S.dirname(U.fsPath)});let K=s.get(ee);K||(R=!0,K={folder:ee,includePattern:{}},E.push(K),s.set(ee,K));const O=S.relative(ee.fsPath,U.fsPath);(0,I.assertIsDefined)(K.includePattern)[O.replace(/\\/g,"/")]=!0}else U.fsPath&&(R=!0,D[U.fsPath]=!0)}),{folderQueries:E,includePattern:D,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(w,E){if(E.isSmartCase){if(w.isRegExp){if(i.containsUppercaseCharacter(w.pattern,!0))return!0}else if(i.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,m.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const E=x=>S.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),D=(Array.isArray(w)?w:r(w)).map(x=>{const F=this.pathService.resolvedUserHome;return F?(0,y.untildify)(x,F.scheme===C.Schemas.file?F.fsPath:F.path):x}),R=L.groupBy(D,x=>E(x)?"searchPaths":"exprSegments"),U=(R.exprSegments||[]).map(x=>i.rtrim(x,"/")).map(x=>i.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),o(x))),V={},ee=this.expandSearchPathPatterns(R.searchPaths||[]);ee&&ee.length&&(V.searchPaths=ee);const K=g.flatten(U),O=t(...K);return O&&(V.pattern=O),V}getExcludesForFolder(w,E){return E.disregardExcludeSettings?void 0:(0,c.getExcludes)(w,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const E=g.flatten(w.map(D=>{let{pathPortion:R,globPortion:U}=p(D);U&&(U=a(U));const V=this.expandOneSearchPath(R);return g.flatten(V.map(ee=>this.resolveOneSearchPathPattern(ee,U)))})),s=new Map;return E.forEach(D=>{const R=D.searchPath.toString(),U=s.get(R);U?D.pattern&&(U.pattern=U.pattern||{},U.pattern[D.pattern]=!0):s.set(R,{searchPath:D.searchPath,pattern:D.pattern?t(D.pattern):void 0})}),Array.from(s.values())}expandOneSearchPath(w){if(S.isAbsolute(w)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==C.Schemas.file?[{searchPath:E[0].uri.with({path:w})}]:[{searchPath:u.URI.file(S.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=n(w),w.startsWith("../")||w===".."){const D=S.posix.resolve(E.path,w);return[{searchPath:E.with({path:D})}]}const s=a(w);return[{searchPath:E,pattern:s}]}else{if(w==="./"||w===".\\")return[];{const E=w.replace(/^\.[\/\\]/,""),D=this.workspaceContextService.getWorkspace().folders.map(R=>{const U=E.match(new RegExp(`^${i.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return U?{match:U,folder:R}:null}).filter(I.isDefined);if(D.length)return D.map(R=>{const U=R.match[1];return{searchPath:R.folder.uri,pattern:U&&a(U)}});{const R=w.match(/\.[\/\\](.+)[\/\\]?/),U=R?R[1]:w,V=l.localize(0,null,U);throw new Error(V)}}}}resolveOneSearchPathPattern(w,E){const s=w.pattern&&E?`${w.pattern}/${E}`:w.pattern||E,D=[{searchPath:w.searchPath,pattern:s}];return s&&!s.endsWith("**")&&D.push({searchPath:w.searchPath,pattern:s+"/**"}),D}getFolderQueryForSearchPath(w,E,s){const D=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(w.searchPath),E,s,!1);return D?{...D,includePattern:w.pattern}:null}getFolderQueryForRoot(w,E,s,D){let R;const U=u.URI.isUri(w)?w:w.uri;if(s.searchPaths){const x=s.searchPaths.filter(F=>(0,P.isEqual)(F.searchPath,U))[0];if(x&&!x.pattern)return null;x&&(R=x.pattern)}const V=this.configurationService.getValue({resource:U}),K={...this.getExcludesForFolder(V,E)||{},...R||{}},O=u.URI.isUri(w)?(0,P.basename)(w):w.name;return{folder:U,folderName:D?O:void 0,excludePattern:Object.keys(K).length>0?K:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!V.search.followSymlinks}}};h=Ve([$e(0,v.IConfigurationService),$e(1,_.IWorkspaceContextService),$e(2,b.IEditorGroupsService),$e(3,A.IPathService)],h),e.QueryBuilder=h;function p(d){const w=d.match(/[\*\{\}\(\)\[\]\?]/);if(w){const E=w.index,s=d.substr(0,E).match(/[/|\\][^/\\]*$/);if(s){let D=d.substr(0,s.index);return D.match(/[/\\]/)||(D+="/"),{pathPortion:D,globPortion:d.substr((s.index||0)+1)}}}return{pathPortion:d}}function t(...d){return d.length?d.reduce((w,E)=>(w[E]=!0,w),Object.create(null)):void 0}function r(d){return k.splitGlobAware(d,",").map(w=>w.trim()).filter(w=>!!w.length)}function o(d){return[`**/${d}/**`,`**/${d}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function n(d){return d.replace(/\\/g,"/")}function a(d){return n(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(d,w){d=g.distinct(d,D=>D.toString());const E=[],s=w.getWorkspace();return d&&d.forEach(D=>{let R;if(w.getWorkbenchState()===2)R=(0,P.relativePath)(s.folders[0].uri,D),R&&R!=="."&&(R="./"+R);else{const U=w.getWorkspaceFolder(D);if(U){const V=U.name;if(s.folders.filter(K=>K.name===V).length===1){const K=(0,P.relativePath)(U.uri,D);K===""?R=`./${U.name}`:R=`./${U.name}/${K}`}else R=D.fsPath}}R&&E.push(R)}),E}e.resolveResourcesForSearchIncludes=f}),define(me[267],ge([0,1,23,2,21,16,4,266,31,43]),function(J,e,g,L,k,y,T,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(v,_){const b=_.activationEvents;if(!b)return Promise.resolve(void 0);const A=[],c=[];for(const n of b)if(/^workspaceContains:/.test(n)){const a=n.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||v.forceUsingSearch?c.push(a):A.push(a)}if(A.length===0&&c.length===0)return Promise.resolve(void 0);let h;const p=new Promise((n,a)=>{h=n}),t=n=>h({activationEvent:n}),r=Promise.all(A.map(n=>u(v,n,t))).then(()=>{}),o=m(v,_.identifier,c,t);return Promise.all([r,o]).then(()=>{h(void 0)}),p}e.checkActivateWorkspaceContainsExtension=I;async function u(v,_,b){for(const A of v.folders)if(await v.exists(g.joinPath(L.URI.revive(A),_))){b(`workspaceContains:${_}`);return}}async function m(v,_,b,A){if(b.length===0)return Promise.resolve(void 0);const c=new k.CancellationTokenSource,h=v.checkExists(v.folders,b,c.token),p=setTimeout(async()=>{c.cancel(),A(`workspaceContainsTimeout:${b.join(",")}`)},i);let t=!1;try{t=await h}catch(r){y.isPromiseCanceledError(r)||y.onUnexpectedError(r)}c.dispose(),clearTimeout(p),t&&A(`workspaceContains:${b.join(",")}`)}function l(v,_,b,A){const c=v.get(T.IInstantiationService),h=v.get(S.ISearchService),t=c.createInstance(C.QueryBuilder).file(_.map(r=>(0,P.toWorkspaceFolder)(L.URI.revive(r))),{_reason:"checkExists",includePattern:b,exists:!0});return h.fileSearch(t,A).then(r=>!!r.limitHit,r=>y.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=l});var it=this&&this.__classPrivateFieldSet||function(J,e,g,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,g):k?k.value=g:e.set(J,g),g},He=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(me[40],ge([0,1,164,9,70,23,17,6,22,2,12,5,37,225,93,36,35,223,16,26,24,199,7,121,4,27,66,13,82,52,33,3,267,91,201]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_,b,A,c,h,p,t,r,o,n,a,f,d,w,E,s,D,R,U){"use strict";var V,ee,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let O=class Wn extends C.Disposable{constructor(M,N,q,B,G,re,he,ye,Ie,Le){super();this._onDidChangeRemoteConnectionData=this._register(new s.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=N,this._extHostContext=q,this._initData=he,this._extHostWorkspace=B,this._extHostConfiguration=G,this._logService=re,this._extHostTunnelService=Ie,this._extHostTerminalService=Le,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new b.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=ye,this._instaService=M.createChild(new d.ServiceCollection([l.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const qe=new Set;this._initData.hostExtensions.forEach(We=>qe.add(c.ExtensionIdentifier.toKey(We))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(We,je,W)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(We,A.transformErrorForSerialization(je),W)},actualActivateExtension:async(We,je)=>{if(qe.has(c.ExtensionIdentifier.toKey(We)))return await this._mainThreadExtensionsProxy.$activateExtension(We,je),new m.HostExtension;const W=this._registry.getExtensionDescription(We);return this._activateExtension(W,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){A.onUnexpectedError(M)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let M=[];try{M=this._registry.getAllExtensionDescriptions().map(G=>G.identifier).filter(G=>this.isActivated(G)).map(G=>this._deactivate(G))}catch(N){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,N){return this._activator.activateByEvent(M,N)}_activateById(M,N){return this._activator.activateById(M,N)}activateByIdWithErrors(M,N){return this._activateById(M,N).then(()=>{const q=this._activator.getActivatedExtension(M);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=S.TernarySearchTree.forPaths(),N=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(B=>M.set(P.URI.file(B).fsPath,q))});this._extensionPathIndex=Promise.all(N).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let N=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return N;const q=this._activator.getActivatedExtension(M);if(!q)return N;try{typeof q.module.deactivate=="function"&&(N=Promise.resolve(q.module.deactivate()).then(void 0,B=>(this._logService.error(B),Promise.resolve(void 0))))}catch(B){this._logService.error(B)}try{(0,C.dispose)(q.subscriptions)}catch(B){this._logService.error(B)}return N}async _activateExtension(M,N){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,N).then(q=>{const B=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,B.codeLoadingTime,B.activateCallTime,B.activateResolvedTime,N),this._logExtensionActivationTimes(M,N,"success",B),q},q=>{throw this._logExtensionActivationTimes(M,N,"failure"),q})}_logExtensionActivationTimes(M,N,q,B){const G=x(M,N);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...G,...B||{},outcome:q})}_doActivateExtension(M,N){const q=x(M,N);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const B=this._getEntryPoint(M);if(!B)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(N)}`),this._logService.flush();const G=new m.ExtensionActivationTimesBuilder(N.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,y.joinPath)(M.extensionLocation,B),G),this._loadExtensionContext(M)]).then(re=>(k.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Wn._callActivate(this._logService,M.identifier,re[0],re[1],G))).then(re=>(k.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),re))}_loadExtensionContext(M){const N=new p.ExtensionGlobalMemento(M,this._storage),q=new p.ExtensionMemento(M.identifier.value,!1,this._storage),B=new U.ExtensionSecrets(M,this._secretState),G=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,re=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([N.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const he=this;let ye;return Object.freeze({globalState:N,workspaceState:q,secrets:B,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Ie){return L.join(M.extensionLocation.fsPath,Ie)},get storagePath(){return he._storagePath.workspaceValue(M)?.fsPath},get globalStoragePath(){return he._storagePath.globalValue(M).fsPath},get logPath(){return L.join(he._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return P.URI.joinPath(he._initData.logsLocation,M.identifier.value)},get storageUri(){return he._storagePath.workspaceValue(M)},get globalStorageUri(){return he._storagePath.globalValue(M)},get extensionMode(){return G},get extension(){return ye===void 0&&(ye=new F(he,M.identifier,M,re)),ye},get extensionRuntime(){return(0,_.checkProposedApiEnabled)(M),he.extensionRuntime},get environmentVariableCollection(){return he._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,N,q,B,G){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,N,q,B,G).then(re=>new m.ActivatedExtension(!1,null,G.build(),q,re,B.subscriptions))}static _callActivateOptional(M,N,q,B,G){if(typeof q.activate=="function")try{G.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${N.value}`);const re=typeof global=="object"?global:self,he=q.activate.apply(re,[B]);return G.activateCallStop(),G.activateResolveStart(),Promise.resolve(he).then(ye=>(G.activateResolveStop(),ye))}catch(re){return Promise.reject(re)}else return Promise.resolve(q)}_activateOneStartupFinished(M,N){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:N}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const N of M.activationEvents)N==="onStartupFinished"&&this._activateOneStartupFinished(M,N)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,G=>{this._logService.error(G)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(G=>this._handleWorkspaceContainsEagerExtensions(G.added)));const N=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(N),B=Promise.all([M,q]).then(()=>{});return Promise.race([B,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),B}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(N=>this._handleWorkspaceContainsEagerExtension(M,N))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,N){if(this.isActivated(N.identifier))return;const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,B={folders:M.map(re=>re.uri),forceUsingSearch:q,exists:re=>this._hostUtils.exists(re.fsPath),checkExists:(re,he,ye)=>this._mainThreadWorkspaceProxy.$checkExists(re,he,ye)},G=await(0,D.checkActivateWorkspaceContainsExtension)(B,N);if(!!G)return this._activateById(N.identifier,{startup:!0,extensionId:N.identifier,activationEvent:G.activationEvent}).then(void 0,re=>this._logService.error(re))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:N}=this._initData.environment;if(!M||!N)throw new Error(g.localize(0,null));const q=await this._loadCommonJSModule(null,N,new m.ExtensionActivationTimesBuilder(!1));if(!q||typeof q.run!="function")throw new Error(g.localize(1,null,N.toString()));return new Promise((B,G)=>{const re=(Ie,Le)=>{Ie?G(Ie):B(typeof Le=="number"&&Le>0?1:0)},he=(0,y.originalFSPath)(N),ye=q.run(he,re);ye&&ye.then&&ye.then(()=>{B(0)}).catch(Ie=>{G(Ie.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,N){return this._resolvers[M]=N,(0,C.toDisposable)(()=>{delete this._resolvers[M]})}async _activateAndGetResolver(M){const N=M.indexOf("+");if(N===-1)throw new Error("Not an authority that can be resolved!");const q=M.substr(0,N);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this._resolvers[q]}}async $resolveAuthority(M,N){const{authorityPrefix:q,resolver:B}=await this._activateAndGetResolver(M);if(!B)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(B)),k.mark(`code/extHost/willResolveAuthority/${q}`);const G=await B.resolve(M,{resolveAttempt:N});k.mark(`code/extHost/didResolveAuthorityOK/${q}`);const re={authority:M,host:G.host,port:G.port,connectionToken:G.connectionToken},he={extensionHostEnv:G.extensionHostEnv,isTrusted:G.isTrusted};return{type:"ok",value:{authority:re,options:he,tunnelInformation:{environmentTunnels:G.environmentTunnels}}}}catch(G){if(k.mark(`code/extHost/didResolveAuthorityError/${q}`),G instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G}}async $getCanonicalURI(M,N){const{authorityPrefix:q,resolver:B}=await this._activateAndGetResolver(M);if(!B)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${q}`);const G=P.URI.revive(N);if(typeof B.getCanonicalURI=="undefined")return G;const re=await(0,T.asPromise)(()=>B.getCanonicalURI(G));return re||G}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,N){return N===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(M,!1))}async $activate(M,N){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,N),!0):!1}async $deltaExtensions(M,N){M.forEach(B=>B.extensionLocation=P.URI.revive(B.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(N.map(async B=>{const G=this._registry.getExtensionDescription(B);if(!G)return;const re=await this._hostUtils.realpath(G.extensionLocation.fsPath);q.delete(P.URI.file(re).fsPath)})),await Promise.all(M.map(async B=>{const G=await this._hostUtils.realpath(B.extensionLocation.fsPath);q.set(P.URI.file(G).fsPath,B)})),this._registry.deltaExtensions(M,N),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let N=h.VSBuffer.alloc(M),q=Math.random()%256;for(let B=0;B<M;B++)N.writeUInt8(q,B);return N}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};O=Ve([$e(0,o.IInstantiationService),$e(1,e.IHostUtils),$e(2,f.IExtHostRpcService),$e(3,v.IExtHostWorkspace),$e(4,u.IExtHostConfiguration),$e(5,i.ILogService),$e(6,n.IExtHostInitDataService),$e(7,a.IExtensionStoragePaths),$e(8,w.IExtHostTunnelService),$e(9,E.IExtHostTerminalService)],O),e.AbstractExtHostExtensionService=O;function x(z,M){return{id:z.identifier.value,name:z.name,extensionVersion:z.version,publisherDisplayName:z.publisher,activationEvents:z.activationEvents?z.activationEvents.join(","):null,isBuiltin:z.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class F{constructor(M,N,q,B){V.set(this,void 0),ee.set(this,void 0),K.set(this,void 0),it(this,V,M,"f"),it(this,ee,N,"f"),it(this,K,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=L.normalize((0,y.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=B}get isActive(){return He(this,V,"f").isActivated(He(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return He(this,V,"f").getExtensionExports(He(this,K,"f"))}activate(){return He(this,V,"f").activateByIdWithErrors(He(this,K,"f"),{startup:!1,extensionId:He(this,ee,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,V=new WeakMap,ee=new WeakMap,K=new WeakMap}),define(me[53],ge([0,1,9,2,3,17,5,7,124,36,40,45,214,37,209,13,4,14,38,51]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_,b,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let h=class{constructor(d,w,E,s,D,R){this._workspaceService=w,this._extensionService=E,this._editorsService=s,this._configurationService=D,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=d.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(U=>{U.onDidChange(V=>{this.registerAllDebugTypes(U)}),this.registerAllDebugTypes(U)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(d,w){const E=d;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let s=`debug:${encodeURIComponent(E.path||"")}`,D="?";return w&&(s+=`${D}session=${encodeURIComponent(w.id)}`,D="&"),s+=`${D}ref=${E.sourceReference}`,L.URI.parse(s)}else{if(E.path)return L.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const w=[];for(const E of d.getAllExtensionDescriptions())if(E.contributes){const s=E.contributes.debuggers;if(s&&s.length>0)for(const D of s)(0,l.isDebuggerMainContribution)(D)&&w.push(D.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const d=[];return this._breakpoints.forEach(w=>d.push(w)),d}addBreakpoints(d){this.startBreakpoints();const w=d.filter(D=>{const R=D.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,D),!0)});this.fireBreakpointChanges(w,[],[]);const E=[],s=new Map;for(const D of w)if(D instanceof C.SourceBreakpoint){let R=s.get(D.location.uri.toString());R||(R={type:"sourceMulti",uri:D.location.uri,lines:[]},s.set(D.location.uri.toString(),R),E.push(R)),R.lines.push({id:D.id,enabled:D.enabled,condition:D.condition,hitCondition:D.hitCondition,logMessage:D.logMessage,line:D.location.range.start.line,character:D.location.range.start.character})}else D instanceof C.FunctionBreakpoint&&E.push({type:"function",id:D.id,enabled:D.enabled,hitCondition:D.hitCondition,logMessage:D.logMessage,condition:D.condition,functionName:D.functionName});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(d){this.startBreakpoints();const w=d.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],w,[]);const E=w.filter(R=>R instanceof C.SourceBreakpoint).map(R=>R.id),s=w.filter(R=>R instanceof C.FunctionBreakpoint).map(R=>R.id),D=w.filter(R=>R instanceof C.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(E,s,D)}startDebugging(d,w,E){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,w,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,debugUI:E.debugUI})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,w,E){if(!w)return new C.Disposable(()=>{});const s=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:s,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,E,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,s),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(D=>D.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(s)})}registerDebugAdapterDescriptorFactory(d,w,E){if(!E)return new C.Disposable(()=>{});if(!this.definesDebugType(d,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const s=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:s,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,s),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(D=>D.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(s)})}registerDebugAdapterTrackerFactory(d,w){if(!w)return new C.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:E,factory:w}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(s=>s.factory!==w)})}async $runInTerminal(d,w){return Promise.resolve(void 0)}async $substituteVariables(d,w){if(!this._variableResolver){const[D,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(D||[],this._editorsService,R)}let E;const s=await this.getFolder(d);return s&&(E={uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(E,w)}createDebugAdapter(d,w){if(d.type==="implementation")return new n(d.implementation)}createSignService(){}async $startDASession(d,w){const E=this,s=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(s.type),s).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}' (extension might have failed to activate)`);const R=this.convertToDto(D),U=this.createDebugAdapter(R,s);if(!U)throw new Error(`Couldn't create a debug adapter for type '${s.type}'.`);const V=U;return this._debugAdapters.set(d,V),this.getDebugAdapterTrackers(s).then(ee=>(ee&&this._debugAdaptersTrackers.set(d,ee),V.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const O=K,x={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(O.arguments.value);x.body={signature:F},V.sendResponse(x)}else throw new Error("no signer")}catch(F){x.success=!1,x.message=F.message,V.sendResponse(x)}}else ee&&ee.onDidSendMessage&&ee.onDidSendMessage(K),K=(0,l.convertToVSCPaths)(K,!0),E._debugServiceProxy.$acceptDAMessage(d,K)}),V.onError(K=>{ee&&ee.onError&&ee.onError(K),this._debugServiceProxy.$acceptDAError(d,K.name,K.message,K.stack)}),V.onExit(K=>{ee&&ee.onExit&&ee.onExit((0,b.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(d,(0,b.withNullAsUndefined)(K),void 0)}),ee&&ee.onWillStartSession&&ee.onWillStartSession(),V.startSession()))})}$sendDAMessage(d,w){w=(0,l.convertToDAPaths)(w,!1);const E=this._debugAdaptersTrackers.get(d);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(w);const s=this._debugAdapters.get(d);s&&s.sendMessage(w)}$stopDASession(d){const w=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),w&&w.onWillStopSession&&w.onWillStopSession();const E=this._debugAdapters.get(d);return this._debugAdapters.delete(d),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const w=[],E=[],s=[];if(d.added)for(const D of d.added){const R=D.id;if(R&&!this._breakpoints.has(R)){let U;if(D.type==="function")U=new C.FunctionBreakpoint(D.functionName,D.enabled,D.condition,D.hitCondition,D.logMessage);else if(D.type==="data")U=new C.DataBreakpoint(D.label,D.dataId,D.canPersist,D.enabled,D.hitCondition,D.condition,D.logMessage);else{const V=L.URI.revive(D.uri);U=new C.SourceBreakpoint(new C.Location(V,new C.Position(D.line,D.character)),D.enabled,D.condition,D.hitCondition,D.logMessage)}U._id=R,this._breakpoints.set(R,U),w.push(U)}}if(d.removed)for(const D of d.removed){const R=this._breakpoints.get(D);R&&(this._breakpoints.delete(D),E.push(R))}if(d.changed){for(const D of d.changed)if(D.id){const R=this._breakpoints.get(D.id);if(R){if(R instanceof C.FunctionBreakpoint&&D.type==="function"){const U=R;U.enabled=D.enabled,U.condition=D.condition,U.hitCondition=D.hitCondition,U.logMessage=D.logMessage,U.functionName=D.functionName}else if(R instanceof C.SourceBreakpoint&&D.type==="source"){const U=R;U.enabled=D.enabled,U.condition=D.condition,U.hitCondition=D.hitCondition,U.logMessage=D.logMessage,U.location=new C.Location(L.URI.revive(D.uri),new C.Position(D.line,D.character))}s.push(R)}}}this.fireBreakpointChanges(w,E,s)}$provideDebugConfigurations(d,w,E){return(0,y.asPromise)(async()=>{const s=this.getConfigProviderByHandle(d);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const D=await this.getFolder(w);return s.provideDebugConfigurations(D,E)}).then(s=>{if(!s)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return s})}$resolveDebugConfiguration(d,w,E,s){return(0,y.asPromise)(async()=>{const D=this.getConfigProviderByHandle(d);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(w);return D.resolveDebugConfiguration(R,E,s)})}$resolveDebugConfigurationWithSubstitutedVariables(d,w,E,s){return(0,y.asPromise)(async()=>{const D=this.getConfigProviderByHandle(d);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(w);return D.resolveDebugConfigurationWithSubstitutedVariables(R,E,s)})}async $provideDebugAdapter(d,w){const E=this.getAdapterDescriptorFactoryByHandle(d);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const s=await this.getSession(w);return this.getAdapterDescriptor(E,s).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}'`);return this.convertToDto(D)})}async $acceptDebugSessionStarted(d){const w=await this.getSession(d);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(d){const w=await this.getSession(d);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(d,w){const E=await this.getSession(d);E&&E._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(d,w){const s={session:await this.getSession(d),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(s)}convertToDto(d){if(d instanceof C.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof C.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const w=this._adapterFactories.filter(E=>E.type===d);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(d){const w=this._adapterFactories.filter(E=>E.handle===d);if(w.length>0)return w[0].factory}getConfigProviderByHandle(d){const w=this._configProviders.filter(E=>E.handle===d);if(w.length>0)return w[0].provider}definesDebugType(d,w){if(d.contributes){const E=d.contributes.debuggers;if(E&&E.length>0){for(const s of E)if(s.label&&s.type&&s.type===w)return!0}}return!1}getDebugAdapterTrackers(d){const E=d.configuration.type,s=this._trackerFactories.filter(D=>D.type===E||D.type==="*").map(D=>(0,y.asPromise)(()=>D.factory.createDebugAdapterTracker(d)).then(R=>R,R=>null));return Promise.race([Promise.all(s).then(D=>{const R=D.filter(U=>!!U);if(R.length>0)return new o(R)}),new Promise((D,R)=>{const U=setTimeout(()=>{clearTimeout(U),R(new Error("timeout"))},1e3)})]).catch(D=>{})}async getAdapterDescriptor(d,w){const E=w.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new C.DebugAdapterServer(E));if(d){const D=await this._extensionService.getExtensionRegistry();return(0,y.asPromise)(()=>d.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,D))).then(R=>{if(R)return R})}const s=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,s))}daExecutableFromPackage(d,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(d,w,E){(d.length>0||w.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:w,changed:E}))}async getSession(d){if(d)if(typeof d=="string"){const w=this._debugSessions.get(d);if(w)return w}else{let w=this._debugSessions.get(d.id);if(!w){const E=await this.getFolder(d.folderUri),s=d.parent?this._debugSessions.get(d.parent):void 0;w=new p(this._debugServiceProxy,d.id,d.type,d.name,E,d.configuration,s),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(d){if(d){const w=L.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};h=Ve([$e(0,v.IExtHostRpcService),$e(1,P.IExtHostWorkspace),$e(2,i.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,m.IExtHostConfiguration),$e(5,c.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class p{constructor(d,w,E,s,D,R,U){this._debugServiceProxy=d,this._id=w,this._type=E,this._name=s,this._workspaceFolder=D,this._configuration=R,this._parentSession=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(d){this._name=d,this._debugServiceProxy.$setDebugSessionName(this._id,d)}get parentSession(){return this._parentSession}_acceptNameChanged(d){this._name=d}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(d,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,d,w)}getDebugProtocolBreakpoint(d){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,d.id)}}e.ExtHostDebugSession=p;class t{constructor(d){this.value=Object.freeze({append(w){d.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=t;class r extends u.AbstractVariableResolverService{constructor(d,w,E,s,D){function R(){if(w){const U=w.activeEditor();if(U)return U.document.uri;const V=s.tabs.filter(ee=>ee.isActive);if(V.length>0)return V[0].resource}}super({getFolderUri:U=>{const V=d.filter(ee=>ee.name===U);if(V&&V.length>0)return V[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(U,V)=>E.getConfiguration(void 0,U).get(V),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const U=R();if(U)return g.normalize(U.fsPath)},getWorkspaceFolderPathForFile:()=>{if(D){const U=R();if(U){const V=D.getWorkspaceFolder(U);if(V)return g.normalize(V.uri.fsPath)}}},getSelectedText:()=>{if(w){const U=w.activeEditor();if(U&&!U.selection.isEmpty)return U.document.getText(U.selection)}},getLineNumber:()=>{if(w){const U=w.activeEditor();if(U)return String(U.selection.end.line+1)}}},void 0,Promise.resolve(A.env))}}e.ExtHostVariableResolverService=r;class o{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(w=>w.onError?w.onError(d):void 0)}onExit(d,w){this.trackers.forEach(E=>E.onExit?E.onExit(d,w):void 0)}}class n extends S.AbstractDebugAdapter{constructor(d){super();this.implementation=d,d.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends h{constructor(d,w,E,s,D,R){super(d,w,E,s,D,R)}createVariableResolver(d,w,E){return new r(d,w,E,this._editorTabs)}};a=Ve([$e(0,v.IExtHostRpcService),$e(1,P.IExtHostWorkspace),$e(2,i.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,m.IExtHostConfiguration),$e(5,c.IExtHostEditorTabs)],a),e.WorkerExtHostDebugService=a}),define(me[268],ge([0,1,70,2,5,37,35,26,13,27,4,40,38,12]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(c,h,p,t,r,o,n){this._apiFactory=c,this._extensionRegistry=h,this._instaService=p,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=o,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new v(this._apiFactory,h,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,h,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let h of c.nodeModuleName)this._factories.set(h,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(h=>c.alternativeModuleName(h))}};l=Ve([$e(2,i.IInstantiationService),$e(3,y.IExtHostConfiguration),$e(4,I.IExtHostExtensionService),$e(5,P.IExtHostInitDataService),$e(6,m.ILogService)],l),e.RequireInterceptor=l;class v{constructor(c,h,p,t,r){this._apiFactory=c,this._extensionPaths=h,this._extensionRegistry=p,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,h){const p=this._extensionPaths.findSubstr(h.fsPath);if(p){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(p.identifier));return t||(t=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(p.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,o)=>t+=`	${o} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(c,h){this.nodeModuleName="keytar";const{environment:p}=h,t=c.getProxy(k.MainContext.MainThreadKeytar);if(p.appRoot){let r=p.appRoot.fsPath;u.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,o)=>t.$getPassword(r,o),setPassword:(r,o,n)=>t.$setPassword(r,o,n),deletePassword:(r,o)=>t.$deletePassword(r,o),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(c,h){return this._impl}alternativeModuleName(c){const h=c.length;if(h<=7||!this.alternativeNames)return;const p=h-7;if((c.charAt(p)==="/"||c.charAt(p)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}};_=Ve([$e(0,S.IExtHostRpcService),$e(1,P.IExtHostInitDataService)],_);let b=class{constructor(c,h,p){this._extensionPaths=c,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(k.MainContext.MainThreadTelemetry);const t=p.getProxy(k.MainContext.MainThreadWindow);this._impl=(r,o)=>{const n=L.URI.parse(r);return o?this.callOriginal(r,o):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,r,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,r,{}):this.callOriginal(r,o)}}load(c,h,p){const t=this._extensionPaths.findSubstr(h.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=p(c),this._impl}callOriginal(c,h){return this.sendNoForwardTelemetry(),this._original(c,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=Ve([$e(2,S.IExtHostRpcService)],b)}),define(me[269],ge([0,1,170,11,7,210,36,40,45,37,33,13,53,194,17,211,51]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let b=class extends u.ExtHostDebugServiceBase{constructor(h,p,t,r,o,n,a){super(h,p,t,r,o,a);this._terminalService=n,this._integratedTerminalInstances=new A}createDebugAdapter(h,p){switch(h.type){case"server":return new y.SocketDebugAdapter(h);case"pipeServer":return new y.NamedPipeDebugAdapter(h);case"executable":return new y.ExecutableDebugAdapter(h,p.type)}return super.createDebugAdapter(h,p)}daExecutableFromPackage(h,p){const t=y.ExecutableDebugAdapter.platformAdapterExecutable(p.getAllExtensionDescriptions(),h.type);if(t)return new k.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new m.SignService}async $runInTerminal(h,p){if(h.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const t=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),o=this._terminalService.getDefaultShellArgs(!0),n=h.title||g.localize(0,null),a=JSON.stringify({shell:r,shellArgs:o});let f=await this._integratedTerminalInstances.checkout(a,n),d,w=!1;if(f)d=h.cwd;else{const R={shellPath:r,shellArgs:o,cwd:h.cwd,name:n,iconPath:new k.ThemeIcon("debug")};w=!0,f=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(f,a)}f.show(!0);const E=await f.processId;w?await new Promise(R=>setTimeout(R,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?f.sendText("cls"):r.indexOf("bash")>=0?f.sendText("clear"):L.isWindows?f.sendText("cls"):f.sendText("clear"));const s=(0,v.prepareCommand)(r,h.args,d,h.env);f.sendText(s);const D=this.onDidTerminateDebugSession(R=>{R.id===p&&(this._integratedTerminalInstances.free(f),D.dispose())});return E}else if(h.kind==="external")return(0,v.runInExternalTerminal)(h,await this._configurationService.getConfigProvider());return super.$runInTerminal(h,p)}createVariableResolver(h,p,t){return new u.ExtHostVariableResolverService(h,p,t,this._editorTabs,this._workspaceService)}};b=Ve([$e(0,I.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,C.IExtHostExtensionService),$e(3,S.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,i.IExtHostTerminalService),$e(6,_.IExtHostEditorTabs)],b),e.ExtHostDebugService=b;class A{constructor(){this._terminalInstances=new Map}async checkout(h,p){const r=[...this._terminalInstances.entries()].map(([o,n])=>(0,l.createCancelablePromise)(async a=>{if(o.name!==p||n.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await o.processId))return null;const f=Date.now();return n.lastUsedAt+A.minUseDelay>f||a.isCancellationRequested||n.config!==h?null:(n.lastUsedAt=f,o)}));return await(0,l.firstParallel)(r,o=>!!o)}insert(h,p){this._terminalInstances.set(h,{lastUsedAt:Date.now(),config:p})}free(h){const p=this._terminalInstances.get(h);p&&(p.lastUsedAt=-1)}onTerminalClosed(h){this._terminalInstances.delete(h)}}A.minUseDelay=1e3}),define(me[270],ge([0,1,9,2,113,36,53,45,37,43,33,13,27,69,10,12,64,51,23,78]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_,b,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let h=class extends m.ExtHostTaskBase{constructor(t,r,o,n,a,f,d,w,E){super(t,r,o,n,a,f,d,w);this.workspaceService=o,this.editorTabs=E,r.remote.isRemote&&r.remote.authority?this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:r.remote.authority,platform:process.platform}):this.registerTaskSystem(l.Schemas.file,{scheme:l.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,r){const o=r;if(!r.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const n=m.TaskHandleDTO.from(o,this.workspaceService),a=await this._proxy.$getTaskExecution(n);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const f=await this.getTaskExecution(a,r);return this._proxy.$executeTask(n).catch(()=>{}),f}else{const n=m.TaskDTO.from(r,t);if(n===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(n.execution)&&await this.addCustomExecution(n,r,!1);const a=await this.getTaskExecution(await this._proxy.$getTaskExecution(n),r);return this._proxy.$executeTask(n).catch(()=>{}),a}}provideTasksInternal(t,r,o,n){const a=[];if(n)for(let f of n){this.checkDeprecation(f,o),(!f.definition||!t[f.definition.type])&&this._logService.warn(`The task [${f.source}, ${f.name}] uses an undefined task type. The task will be ignored in the future.`);const d=m.TaskDTO.from(f,o.extension);d&&(a.push(d),m.CustomExecutionDTO.is(d.execution)&&r.push(this.addCustomExecution(d,f,!0)))}return{tasks:a,extension:o.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const r=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(t,this._editorService,r,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let r=t&&t.length>0?t[0]:void 0;if(!r){const o=L.URI.file((0,c.homedir)());r=new P.WorkspaceFolder({uri:o,name:A.basename(o),index:0})}return{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,r){const o=L.URI.revive(t),n={process:void 0,variables:Object.create(null)},a=await this._workspaceProvider.resolveWorkspaceFolder(o),f=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.getVariableResolver(f),w=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(f);for(let E of r.variables)n.variables[E]=await d.resolveAsync(w,E);if(r.process!==void 0){let E;if(r.process.path!==void 0){E=r.process.path.split(g.delimiter);for(let s=0;s<E.length;s++)E[s]=await d.resolveAsync(w,E[s])}n.process=await k.win32.findExecutable(await d.resolveAsync(w,r.process.name),r.process.cwd!==void 0?await d.resolveAsync(w,r.process.cwd):void 0,E)}return n}async $jsonTasksSupported(){return!0}async $findExecutable(t,r,o){return k.win32.findExecutable(t,r,o)}};h=Ve([$e(0,I.IExtHostRpcService),$e(1,u.IExtHostInitDataService),$e(2,y.IExtHostWorkspace),$e(3,C.IExtHostDocumentsAndEditors),$e(4,S.IExtHostConfiguration),$e(5,i.IExtHostTerminalService),$e(6,v.ILogService),$e(7,_.IExtHostApiDeprecationService),$e(8,b.IExtHostEditorTabs)],h),e.ExtHostTask=h}),define(me[271],ge([0,1,17,16,70,6,2,5,263,12,80,82,27,188,13,63,40,33]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class A{constructor(h,p,t,r){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new S.RPCProtocol(h,null,r),p=A._transform(p,this._rpcProtocol);const o=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());o.set(u.IExtHostInitDataService,{_serviceBrand:void 0,...p}),o.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),o.set(v.IURITransformerService,new v.URITransformerService(r)),o.set(_.IHostUtils,t);const n=new m.InstantiationService(o,!0),a=n.invokeFunction(E=>E.get(b.IExtHostTerminalService));this._disposables.add(a),this._logService=n.invokeFunction(E=>E.get(P.ILogService)),k.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",p),this._extensionService=n.invokeFunction(E=>E.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(E=>{Error.prepareStackTrace=(s,D)=>{let R="",U,V;for(const ee of D)R+=`
	at ${ee.toString()}`,V=ee.getFileName(),!U&&V&&(U=E.findSubstr(V));return f.set(s,U),`${s.name||"Error"}: ${s.message||""}${R}`}});const d=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),w=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(E=>{const s=L.transformErrorForSerialization(E),D=f.get(E);D?d.$onExtensionRuntimeError(D.identifier,s):w.$onUnexpectedError(s)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const p=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),p]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,p){h.extensions.forEach(r=>r.extensionLocation=T.URI.revive(p.transformIncomingURIs(r.extensionLocation))),h.environment.appRoot=T.URI.revive(p.transformIncomingURIs(h.environment.appRoot));const t=h.environment.extensionDevelopmentLocationURI;return t&&(h.environment.extensionDevelopmentLocationURI=t.map(r=>T.URI.revive(p.transformIncomingURIs(r)))),h.environment.extensionTestsLocationURI=T.URI.revive(p.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=T.URI.revive(p.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=T.URI.revive(p.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=T.URI.revive(p.transformIncomingURIs(h.logsLocation)),h.logFile=T.URI.revive(p.transformIncomingURIs(h.logFile)),h.workspace=p.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=A}),define(me[272],ge([0,1,9,21,60,30,23,46,31]),function(J,e,g,L,k,y,T,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(u,m,l){this.config=u,this.provider=m,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&y.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&y.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const m=this.config.folderQueries||[];return new Promise((l,v)=>{const _=b=>{this.resultCount++,u(b)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(b=>{const A=b.toString(),c=g.basename(A);this.globalExcludePattern&&this.globalExcludePattern(A,c)||this.matchFile(_,{base:b,basename:c})}),Promise.all(m.map(b=>this.searchInFolder(b,_))).then(b=>{l({limitHit:this.isLimitHit,stats:b[0]||void 0})},b=>{v(new Error((0,k.toErrorMessage)(b)))})})}async searchInFolder(u,m){const l=new L.CancellationTokenSource,v=this.getSearchOptionsForFolder(u),_=this.initDirectoryTree(),b=new S.QueryGlobTester(this.config,u),A=!b.hasSiblingExcludeClauses();let c;try{this.activeCancellationTokens.add(l),c=C.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,l.token),p=c.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(r=>{const o=g.posix.relative(u.folder.path,r.path);if(A){const n=g.basename(r.path);this.matchFile(m,{base:u.folder,relativePath:o,basename:n});return}this.addDirectoryEntries(_,u.folder,o,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,b,m),{providerTime:p,postProcessTime:t.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(u){const m=(0,S.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),l=(0,S.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:l,includes:m,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},m,l,v){if(l===this.filePattern){const b=g.basename(this.filePattern);this.matchFile(v,{base:m,relativePath:this.filePattern,basename:b})}function _(b){const A=g.basename(b),c=g.dirname(b);let h=u[c];h||(h=u[c]=[],_(c)),h.push({base:m,relativePath:b,basename:A})}_(l)}matchDirectoryTree({rootEntries:u,pathToEntries:m},l,v){const _=this,b=this.filePattern;function A(c){const h=y.hasSiblingFn(()=>c.map(p=>p.basename));for(let p=0,t=c.length;p<t;p++){const r=c[p],{relativePath:o,basename:n}=r;if(!l.includedInQuerySync(o,n,b!==n?h:void 0))continue;const a=m[o];if(a)A(a);else{if(o===b)continue;_.matchFile(v,r)}if(_.isLimitHit)break}}A(u)}matchFile(u,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(m))}}class i{constructor(){this.sessions=new Map}fileSearch(u,m,l,v){const _=this.getSessionTokenSource(u.cacheKey),b=new P(u,m,_&&_.token);let A=0;const c=h=>{A+=h.length,l(h.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(b,i.BATCH_SIZE,c,v).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:A,detailStats:h.stats}}))}clearCache(u){const m=this.getSessionTokenSource(u);m&&m.cancel()}getSessionTokenSource(u){if(!!u)return this.sessions.has(u)||this.sessions.set(u,new L.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:T.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,m,l,v){v.onCancellationRequested(()=>{u.cancel()});const _=A=>{A&&(b.push(A),m>0&&b.length>=m&&(l(b),b=[]))};let b=[];return u.search(_).then(A=>(b.length&&l(b),A),A=>(b.length&&l(b),Promise.reject(A)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(me[133],ge([0,1,9,20,21,60,23,30,2,31,10,14]),function(J,e,g,L,k,y,T,C,S,P,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class u{constructor(c,h,p){this.query=c,this.provider=h,this.fileUtils=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,h){const p=this.query.folderQueries||[],t=new k.CancellationTokenSource;return h.onCancellationRequested(()=>t.cancel()),new Promise((r,o)=>{this.collector=new l(c);let n=!1;const a=(f,d)=>{if(!n&&!this.isLimitHit){const w=this.resultSize(f);_(f)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const E=this.resultSize(f);this.resultCount+=E,(E>0||!_(f))&&this.collector.add(f,d)}};Promise.all(p.map((f,d)=>this.searchInFolder(f,w=>a(w,d),t.token))).then(f=>{t.dispose(),this.collector.flush();const d=f.some(w=>!!w&&!!w.limitHit);r({limitHit:this.isLimitHit||d,messages:(0,L.flatten)(f.map(w=>w?.message?(0,I.isArray)(w.message)?w.message:[w.message]:[])),stats:{type:"textSearchProvider"}})},f=>{t.dispose();const d=(0,y.toErrorMessage)(f);o(new Error(d))})})}resultSize(c){return _(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,h){const p=Array.isArray(c.ranges)?c.ranges:[c.ranges],t=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:p.slice(0,h),preview:{matches:t.slice(0,h),text:c.preview.text},uri:c.uri}}async searchInFolder(c,h,p){const t=new P.QueryGlobTester(this.query,c),r=[],o={report:f=>{if(!this.validateProviderResult(f))return;const d=c.folder.scheme===i.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(T.dirname(f.uri))):void 0,w=T.relativePath(c.folder,f.uri);w&&r.push(t.includedInQuery(w,g.basename(w),d).then(E=>{E&&h(f)}))}},n=this.getSearchOptionsForFolder(c),a=await this.provider.provideTextSearchResults(m(this.query.contentPattern),n,o,p);return await Promise.all(r),a}validateProviderResult(c){if(_(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const h=(0,P.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),p=(0,P.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),t={folder:S.URI.from(c.folder),excludes:p,includes:h,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=u;function m(A){return{isCaseSensitive:A.isCaseSensitive||!1,isRegExp:A.isRegExp||!1,isWordMatch:A.isWordMatch||!1,isMultiline:A.isMultiline||!1,pattern:A.pattern}}class l{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,h=>this.sendItems(h))}add(c,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!T.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(v(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=l;function v(A){return _(A)?{preview:{matches:(0,L.mapArrayOrNot)(A.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:A.preview.text},ranges:(0,L.mapArrayOrNot)(A.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:A.text,lineNumber:A.lineNumber}}function _(A){return!!A.preview}e.extensionResultIsMatch=_;class b{constructor(c,h){this.maxBatchSize=c,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,h){!c||this.addItemToBatch(c,h)}addItems(c,h){!c||this.addItemsToBatch(c,h)}addItemToBatch(c,h){this.batch.push(c),this.batchSize+=h,this.onUpdate()}addItemsToBatch(c,h){this.batch=this.batch.concat(c),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(me[71],ge([0,1,6,5,4,272,13,63,12,2,133]),function(J,e,g,L,k,y,T,C,S,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let I=class{constructor(v,_,b){this.extHostRpc=v,this._uriTransformer=_,this._logService=b,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,_){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const b=this._handlePool++;return this._textSearchProvider.set(b,_),this._proxy.$registerTextSearchProvider(b,this._transformScheme(v)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}registerFileSearchProvider(v,_){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const b=this._handlePool++;return this._fileSearchProvider.set(b,_),this._proxy.$registerFileSearchProvider(b,this._transformScheme(v)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}$provideFileSearchResults(v,_,b,A){const c=u(b),h=this._fileSearchProvider.get(v);if(h)return this._fileSearchManager.fileSearch(c,h,p=>{this._proxy.$handleFileMatch(v,_,p.map(t=>t.resource))},A);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,_,b,A){const c=this._textSearchProvider.get(v);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const h=u(b);return this.createTextSearchManager(h,c).search(t=>this._proxy.$handleTextMatch(v,_,t),A)}createTextSearchManager(v,_){return new i.TextSearchManager(v,_,{readdir:b=>Promise.resolve([]),toCanonicalName:b=>b})}};I=Ve([$e(0,T.IExtHostRpcService),$e(1,C.IURITransformerService),$e(2,S.ILogService)],I),e.ExtHostSearch=I;function u(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(m),extraFileResources:l.extraFileResources&&l.extraFileResources.map(v=>P.URI.revive(v))}}e.reviveQuery=u;function m(l){return{...l,folder:P.URI.revive(l.folder)}}}),define(me[273],ge([0,1,21,16,3,48,2,114,109,146,79,42,5,231,230,44,232,37,233,234,235,216,236,45,40,237,217,240,241,242,65,219,247,248,249,93,33,251,220,15,7,254,67,132,36,35,55,206,239,84,131,69,53,71,12,63,13,27,243,203,52,64,228,252,202,66,92,257,255,256,229,62,250,253,91,51,122,245,68,246,10,190,244,200,238]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_,b,A,c,h,p,t,r,o,n,a,f,d,w,E,s,D,R,U,V,ee,K,O,x,F,z,M,N,q,B,G,re,he,ye,Ie,Le,qe,We,je,W,Z,ne,le,Y,ae,ve,Me,ze,Ee,Je,X,se,fe,xe,Be,et,Ce,De,Te,ce,ue,pe,be,j,we,_e,Ae,Ue,Ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ze(Qe){const Xe=Qe.get(ne.IExtHostInitDataService),ct=Qe.get(et.IExtHostFileSystemInfo),mt=Qe.get(X.IExtHostConsumerFileSystem),bt=Qe.get(o.IExtHostExtensionService),ot=Qe.get(q.IExtHostWorkspace),at=Qe.get(ue.IExtHostTelemetry),Se=Qe.get(b.IExtHostConfiguration),Pe=Qe.get(W.IURITransformerService),te=Qe.get(Z.IExtHostRpcService),Q=Qe.get(V.IExtHostStorage),Oe=Qe.get(Je.IExtensionStoragePaths),Fe=Qe.get(je.ILogService),tt=Qe.get(ae.IExtHostTunnelService),Ke=Qe.get(ve.IExtHostApiDeprecationService),ut=Qe.get(N.IExtHostWindow),St=Qe.get(Te.IExtHostSecretState),kt=Qe.get(ce.IExtHostEditorTabs);te.set(u.ExtHostContext.ExtHostFileSystemInfo,ct),te.set(u.ExtHostContext.ExtHostLogService,Fe),te.set(u.ExtHostContext.ExtHostWorkspace,ot),te.set(u.ExtHostContext.ExtHostConfiguration,Se),te.set(u.ExtHostContext.ExtHostExtensionService,bt),te.set(u.ExtHostContext.ExtHostStorage,Q),te.set(u.ExtHostContext.ExtHostTunnelService,tt),te.set(u.ExtHostContext.ExtHostWindow,ut),te.set(u.ExtHostContext.ExtHostSecretState,St),te.set(u.ExtHostContext.ExtHostTelemetry,at),te.set(u.ExtHostContext.ExtHostEditorTabs,kt);const Dt=te.set(u.ExtHostContext.ExtHostDecorations,Qe.get(Ie.IExtHostDecorations)),ft=te.set(u.ExtHostContext.ExtHostDocumentsAndEditors,Qe.get(r.IExtHostDocumentsAndEditors)),dt=te.set(u.ExtHostContext.ExtHostCommands,Qe.get(v.IExtHostCommands)),vt=te.set(u.ExtHostContext.ExtHostTerminalService,Qe.get(ee.IExtHostTerminalService)),Et=te.set(u.ExtHostContext.ExtHostDebugService,Qe.get(qe.IExtHostDebugService)),Tt=te.set(u.ExtHostContext.ExtHostSearch,Qe.get(We.IExtHostSearch)),It=te.set(u.ExtHostContext.ExtHostTask,Qe.get(Le.IExtHostTask)),bn=te.set(u.ExtHostContext.ExtHostOutputService,Qe.get(E.IExtHostOutputService)),Vt=te.set(u.ExtHostContext.ExtHostUrls,new z.ExtHostUrls(te)),_t=te.set(u.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(te,ft)),Xt=te.set(u.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(te,ft,Fe)),Yt=te.set(u.ExtHostContext.ExtHostDocumentSaveParticipant,new p.ExtHostDocumentSaveParticipant(Fe,_t,te.getProxy(u.MainContext.MainThreadBulkEdits))),gt=te.set(u.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(te,dt,ft,_t,Oe)),jt=te.set(u.ExtHostContext.ExtHostNotebookDocuments,new Ue.ExtHostNotebookDocuments(Fe,gt)),Wt=te.set(u.ExtHostContext.ExtHostNotebookEditors,new Ae.ExtHostNotebookEditors(Fe,te,gt)),Jt=te.set(u.ExtHostContext.ExtHostNotebookKernels,new pe.ExtHostNotebookKernels(te,Xe,gt,Fe)),Zt=te.set(u.ExtHostContext.ExtHostNotebookRenderers,new j.ExtHostNotebookRenderers(te,gt)),Pt=te.set(u.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(te,ft)),dn=te.set(u.ExtHostContext.ExtHostTreeViews,new O.ExtHostTreeViews(te.getProxy(u.MainContext.MainThreadTreeViews),dt,Fe)),en=te.set(u.ExtHostContext.ExtHostEditorInsets,new re.ExtHostEditorInsets(te.getProxy(u.MainContext.MainThreadEditorInsets),Pt,Xe)),xt=te.set(u.ExtHostContext.ExtHostDiagnostics,new A.ExtHostDiagnostics(te,Fe)),ht=te.set(u.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(te,Pe,_t,dt,xt,Fe,Ke)),tn=te.set(u.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(te,ht)),Mt=te.set(u.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(te,Fe,ft)),Ot=te.set(u.ExtHostContext.ExtHostQuickOpen,(0,D.createExtHostQuickOpen)(te,ot,dt)),qt=te.set(u.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(te,dt,Fe)),En=te.set(u.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(te,dt,_t)),hn=te.set(u.ExtHostContext.ExtHostProgress,new s.ExtHostProgress(te.getProxy(u.MainContext.MainThreadProgress))),_n=te.set(u.ExtHostContext.ExtHosLabelService,new he.ExtHostLabelService(te)),fn=te.set(u.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(te)),nn=te.set(u.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(te)),rn=te.set(u.ExtHostContext.ExtHostTimeline,new ze.ExtHostTimeline(te,dt)),Ht=te.set(u.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews(te,{remote:Xe.remote},ot,Fe,Ke)),sn=te.set(u.ExtHostContext.ExtHostWebviewPanels,new xe.ExtHostWebviewPanels(te,Ht,ot)),Sn=te.set(u.ExtHostContext.ExtHostCustomEditors,new fe.ExtHostCustomEditors(te,_t,Oe,Ht,sn)),yn=te.set(u.ExtHostContext.ExtHostWebviewViews,new se.ExtHostWebviewViews(te,Ht)),zt=te.set(u.ExtHostContext.ExtHostTesting,new Ce.ExtHostTesting(te,dt)),Gt=te.set(u.ExtHostContext.ExtHostUriOpeners,new De.ExtHostUriOpeners(te));te.set(u.ExtHostContext.ExtHostInteractive,new Ge.ExtHostInteractive(te,gt,ft,dt));const Dn=(0,G.values)(u.ExtHostContext);te.assertRegistered(Dn);const Cn=new Be.ExtHostBulkEdits(te,ft),on=new l.ExtHostClipboard(te),an=new w.ExtHostMessageService(te,Fe),Bt=new c.ExtHostDialogs(te),Lt=new U.ExtHostStatusBar(te,dt.converter),Kt=new d.ExtHostLanguages(te,_t);return m.ExtHostApiCommands.register(dt),function(Ne,$t,mn){const pt=function(){let ie=!Ne.isUnderDevelopment;function de(Re){ie||(Fe.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Re(st){if(Array.isArray(st))st.forEach(Re);else if(typeof st=="string")de(st);else{const wt=st;typeof wt.scheme=="undefined"&&de(st),!Ne.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,B.throwProposedApiError)(Ne)}return st}}(),kn={getSession(ie,de,Re){return Re?.forceNewSession&&(0,B.checkProposedApiEnabled)(Ne),nn.getSession(Ne,ie,de,Re)},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(ie,de,Re,st){return nn.registerAuthenticationProvider(ie,de,Re,st)}},In={registerCommand(ie,de,Re){return dt.registerCommand(!0,ie,de,Re)},registerTextEditorCommand(ie,de,Re){return dt.registerCommand(!0,ie,(...st)=>{const wt=Pt.getActiveTextEditor();if(!wt){Fe.warn("Cannot execute "+ie+" because there is no active text editor.");return}return wt.edit(Ct=>{de.apply(Re,[wt,Ct,...st])}).then(Ct=>{Ct||Fe.warn("Edits from command "+ie+" were not applied.")},Ct=>{Fe.warn("An error occurred while running command "+ie,Ct)})})},registerDiffInformationCommand:(ie,de,Re)=>((0,B.checkProposedApiEnabled)(Ne),dt.registerCommand(!0,ie,async(...st)=>{const wt=ft.activeEditor(!0);if(!wt){Fe.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Ct=await Pt.getDiffInformation(wt.id);de.apply(Re,[Ct,...st])})),executeCommand(ie,...de){return dt.executeCommand(ie,...de)},getCommands(ie=!1){return dt.getCommands(ie)}},gn={get machineId(){return Xe.telemetryInfo.machineId},get sessionId(){return Xe.telemetryInfo.sessionId},get language(){return Xe.environment.appLanguage},get appName(){return Xe.environment.appName},get appRoot(){return Xe.environment.appRoot?.fsPath??""},get embedderIdentifier(){return Xe.environment.embedderIdentifier},get uriScheme(){return Xe.environment.appUriScheme},get clipboard(){return on.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return at.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return at.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(Xe.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,de){return ut.openUri(ie,{allowTunneling:!!Xe.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===Xe.environment.appUriScheme)return Vt.createAppUri(ie);try{return await ut.asExternalUri(ie,{allowTunneling:!!Xe.remote.authority})}catch(de){if((0,_e.matchesScheme)(ie,we.Schemas.http)||(0,_e.matchesScheme)(ie,we.Schemas.https))return ie;throw de}},get remoteName(){return(0,ye.getRemoteName)(Xe.remote.authority)},get uiKind(){return Xe.uiKind}};Xe.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Xe.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,Pn={createTestController(ie,de){return zt.createTestController(ie,de)},createTestObserver(){return(0,B.checkProposedApiEnabled)(Ne),zt.createTestObserver()},runTests(ie){return(0,B.checkProposedApiEnabled)(Ne),zt.runTests(ie)},get onDidChangeTestResults(){return(0,B.checkProposedApiEnabled)(Ne),zt.onResultsChanged},get testResults(){return(0,B.checkProposedApiEnabled)(Ne),zt.results}},ln={getExtension(ie){const de=$t.getExtensionDescription(ie);if(de)return new o.Extension(bt,Ne.identifier,de,pn)},get all(){return $t.getAllExtensionDescriptions().map(ie=>new o.Extension(bt,Ne.identifier,ie,pn))},get onDidChange(){return $t.onDidChange}},An={createDiagnosticCollection(ie){return xt.createDiagnosticCollection(Ne.identifier,ie)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:ie=>xt.getDiagnostics(ie),getLanguages(){return Kt.getLanguages()},setTextDocumentLanguage(ie,de){return Kt.changeLanguage(ie.uri,de)},match(ie,de){return(0,i.score)(x.LanguageSelector.from(ie),de.uri,de.languageId,!0)},registerCodeActionsProvider(ie,de,Re){return ht.registerCodeActionProvider(Ne,pt(ie),de,Re)},registerCodeLensProvider(ie,de){return ht.registerCodeLensProvider(Ne,pt(ie),de)},registerDefinitionProvider(ie,de){return ht.registerDefinitionProvider(Ne,pt(ie),de)},registerDeclarationProvider(ie,de){return ht.registerDeclarationProvider(Ne,pt(ie),de)},registerImplementationProvider(ie,de){return ht.registerImplementationProvider(Ne,pt(ie),de)},registerTypeDefinitionProvider(ie,de){return ht.registerTypeDefinitionProvider(Ne,pt(ie),de)},registerHoverProvider(ie,de){return ht.registerHoverProvider(Ne,pt(ie),de,Ne.identifier)},registerEvaluatableExpressionProvider(ie,de){return ht.registerEvaluatableExpressionProvider(Ne,pt(ie),de,Ne.identifier)},registerInlineValuesProvider(ie,de){return ht.registerInlineValuesProvider(Ne,pt(ie),de,Ne.identifier)},registerDocumentHighlightProvider(ie,de){return ht.registerDocumentHighlightProvider(Ne,pt(ie),de)},registerLinkedEditingRangeProvider(ie,de){return ht.registerLinkedEditingRangeProvider(Ne,pt(ie),de)},registerReferenceProvider(ie,de){return ht.registerReferenceProvider(Ne,pt(ie),de)},registerRenameProvider(ie,de){return ht.registerRenameProvider(Ne,pt(ie),de)},registerDocumentSymbolProvider(ie,de,Re){return ht.registerDocumentSymbolProvider(Ne,pt(ie),de,Re)},registerWorkspaceSymbolProvider(ie){return ht.registerWorkspaceSymbolProvider(Ne,ie)},registerDocumentFormattingEditProvider(ie,de){return ht.registerDocumentFormattingEditProvider(Ne,pt(ie),de)},registerDocumentRangeFormattingEditProvider(ie,de){return ht.registerDocumentRangeFormattingEditProvider(Ne,pt(ie),de)},registerOnTypeFormattingEditProvider(ie,de,Re,...st){return ht.registerOnTypeFormattingEditProvider(Ne,pt(ie),de,[Re].concat(st))},registerDocumentSemanticTokensProvider(ie,de,Re){return ht.registerDocumentSemanticTokensProvider(Ne,pt(ie),de,Re)},registerDocumentRangeSemanticTokensProvider(ie,de,Re){return ht.registerDocumentRangeSemanticTokensProvider(Ne,pt(ie),de,Re)},registerSignatureHelpProvider(ie,de,Re,...st){return typeof Re=="object"?ht.registerSignatureHelpProvider(Ne,pt(ie),de,Re):ht.registerSignatureHelpProvider(Ne,pt(ie),de,typeof Re=="undefined"?[]:[Re,...st])},registerCompletionItemProvider(ie,de,...Re){return ht.registerCompletionItemProvider(Ne,pt(ie),de,Re)},registerInlineCompletionItemProvider(ie,de){return(0,B.checkProposedApiEnabled)(Ne),ht.registerInlineCompletionsProvider(Ne,pt(ie),de)},registerDocumentLinkProvider(ie,de){return ht.registerDocumentLinkProvider(Ne,pt(ie),de)},registerColorProvider(ie,de){return ht.registerColorProvider(Ne,pt(ie),de)},registerFoldingRangeProvider(ie,de){return ht.registerFoldingRangeProvider(Ne,pt(ie),de)},registerSelectionRangeProvider(ie,de){return ht.registerSelectionRangeProvider(Ne,ie,de)},registerCallHierarchyProvider(ie,de){return ht.registerCallHierarchyProvider(Ne,ie,de)},setLanguageConfiguration:(ie,de)=>ht.setLanguageConfiguration(Ne,ie,de),getTokenInformationAtPosition(ie,de){return(0,B.checkProposedApiEnabled)(Ne),Kt.tokenAtPosition(ie,de)},registerInlayHintsProvider(ie,de){return(0,B.checkProposedApiEnabled)(Ne),ht.registerInlayHintsProvider(Ne,ie,de)},registerTypeHierarchyProvider(ie,de){return(0,B.checkProposedApiEnabled)(Ne),ht.registerTypeHierarchyProvider(Ne,ie,de)},createLanguageStatusItem(ie){return(0,B.checkProposedApiEnabled)(Ne),Kt.createLanguageStatusItem(ie)}},Tn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(ie,de,Re){const st=await(T.URI.isUri(ie)?Promise.resolve(vn.openTextDocument(ie)):Promise.resolve(ie));return Pt.showTextDocument(st,de,Re)},createTextEditorDecorationType(ie){return Pt.createTextEditorDecorationType(Ne,ie)},onDidChangeActiveTextEditor(ie,de,Re){return Pt.onDidChangeActiveTextEditor(ie,de,Re)},onDidChangeVisibleTextEditors(ie,de,Re){return Pt.onDidChangeVisibleTextEditors(ie,de,Re)},onDidChangeTextEditorSelection(ie,de,Re){return Pt.onDidChangeTextEditorSelection(ie,de,Re)},onDidChangeTextEditorOptions(ie,de,Re){return Pt.onDidChangeTextEditorOptions(ie,de,Re)},onDidChangeTextEditorVisibleRanges(ie,de,Re){return Pt.onDidChangeTextEditorVisibleRanges(ie,de,Re)},onDidChangeTextEditorViewColumn(ie,de,Re){return Pt.onDidChangeTextEditorViewColumn(ie,de,Re)},onDidCloseTerminal(ie,de,Re){return vt.onDidCloseTerminal(ie,de,Re)},onDidOpenTerminal(ie,de,Re){return vt.onDidOpenTerminal(ie,de,Re)},onDidChangeActiveTerminal(ie,de,Re){return vt.onDidChangeActiveTerminal(ie,de,Re)},onDidChangeTerminalDimensions(ie,de,Re){return(0,B.checkProposedApiEnabled)(Ne),vt.onDidChangeTerminalDimensions(ie,de,Re)},onDidWriteTerminalData(ie,de,Re){return(0,B.checkProposedApiEnabled)(Ne),vt.onDidWriteTerminalData(ie,de,Re)},get state(){return ut.state},onDidChangeWindowState(ie,de,Re){return ut.onDidChangeWindowState(ie,de,Re)},showInformationMessage(ie,...de){return an.showMessage(Ne,y.default.Info,ie,de[0],de.slice(1))},showWarningMessage(ie,...de){return an.showMessage(Ne,y.default.Warning,ie,de[0],de.slice(1))},showErrorMessage(ie,...de){return an.showMessage(Ne,y.default.Error,ie,de[0],de.slice(1))},showQuickPick(ie,de,Re){return Ot.showQuickPick(ie,!!Ne.enableProposedApi,de,Re)},showWorkspaceFolderPick(ie){return Ot.showWorkspaceFolderPick(ie)},showInputBox(ie,de){return Ot.showInput(ie,de)},showOpenDialog(ie){return Bt.showOpenDialog(ie)},showSaveDialog(ie){return Bt.showSaveDialog(ie)},createStatusBarItem(ie,de,Re){let st,wt,Ct;return typeof ie=="string"?(st=ie,wt=de,Ct=Re):(wt=ie,Ct=de),Lt.createStatusBarEntry(Ne,st,wt,Ct)},setStatusBarMessage(ie,de){return Lt.setStatusBarMessage(ie,de)},withScmProgress(ie){return Ke.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),hn.withProgress(Ne,{location:F.ProgressLocation.SourceControl},(de,Re)=>ie({report(st){}}))},withProgress(ie,de){return hn.withProgress(Ne,ie,de)},createOutputChannel(ie){return bn.createOutputChannel(ie,Ne)},createWebviewPanel(ie,de,Re,st){return sn.createWebviewPanel(Ne,ie,de,Re,st)},createWebviewTextEditorInset(ie,de,Re,st){return(0,B.checkProposedApiEnabled)(Ne),en.createWebviewEditorInset(ie,de,Re,st,Ne)},createTerminal(ie,de,Re){return typeof ie=="object"?(ie.color&&(0,B.checkProposedApiEnabled)(Ne),"pty"in ie?vt.createExtensionTerminal(ie):vt.createTerminalFromOptions(ie)):vt.createTerminal(ie,de,Re)},registerTerminalLinkProvider(ie){return vt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,de){return vt.registerProfileProvider(Ne,ie,de)},registerTreeDataProvider(ie,de){return dn.registerTreeDataProvider(ie,de,Ne)},createTreeView(ie,de){return dn.createTreeView(ie,de,Ne)},registerWebviewPanelSerializer:(ie,de)=>sn.registerWebviewPanelSerializer(Ne,ie,de),registerCustomEditorProvider:(ie,de,Re={})=>Sn.registerCustomEditorProvider(Ne,ie,de,Re),registerFileDecorationProvider(ie){return Dt.registerFileDecorationProvider(ie,Ne.identifier)},registerUriHandler(ie){return Vt.registerUriHandler(Ne.identifier,ie)},createQuickPick(){return Ot.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Ot.createInputBox(Ne.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(ie,de,Re){return fn.onDidChangeActiveColorTheme(ie,de,Re)},registerWebviewViewProvider(ie,de,Re){return yn.registerWebviewViewProvider(Ne,ie,de,Re?.webviewOptions)},get activeNotebookEditor(){return(0,B.checkProposedApiEnabled)(Ne),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,de,Re){return(0,B.checkProposedApiEnabled)(Ne),gt.onDidChangeActiveNotebookEditor(ie,de,Re)},get visibleNotebookEditors(){return(0,B.checkProposedApiEnabled)(Ne),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,B.checkProposedApiEnabled)(Ne),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,de,Re){return(0,B.checkProposedApiEnabled)(Ne),Wt.onDidChangeNotebookEditorSelection(ie,de,Re)},onDidChangeNotebookEditorVisibleRanges(ie,de,Re){return(0,B.checkProposedApiEnabled)(Ne),Wt.onDidChangeNotebookEditorVisibleRanges(ie,de,Re)},showNotebookDocument(ie,de){return(0,B.checkProposedApiEnabled)(Ne),gt.showNotebookDocument(ie,de)},registerExternalUriOpener(ie,de,Re){return(0,B.checkProposedApiEnabled)(Ne),Gt.registerExternalUriOpener(Ne.identifier,ie,de,Re)},get openEditors(){return(0,B.checkProposedApiEnabled)(Ne),kt.tabs},get onDidChangeOpenEditors(){return(0,B.checkProposedApiEnabled)(Ne),kt.onDidChangeTabs},getInlineCompletionItemController(ie){return(0,B.checkProposedApiEnabled)(Ne),f.InlineCompletionController.get(ie)}},vn={get rootPath(){return Ke.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(ie){throw L.readonly()},getWorkspaceFolder(ie){return ot.getWorkspaceFolder(ie)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(ie){throw L.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(ie){throw L.readonly()},updateWorkspaceFolders:(ie,de,...Re)=>ot.updateWorkspaceFolders(Ne,ie,de||0,...Re),onDidChangeWorkspaceFolders:function(ie,de,Re){return ot.onDidChangeWorkspace(ie,de,Re)},asRelativePath:(ie,de)=>ot.getRelativePath(ie,de),findFiles:(ie,de,Re,st)=>ot.findFiles(x.GlobPattern.from(ie),x.GlobPattern.from(de),Re,Ne.identifier,st),findTextInFiles:(ie,de,Re,st)=>{let wt,Ct;return typeof de=="object"?(wt=de,Ct=Re):(wt={},Ct=de,st=Re),ot.findTextInFiles(ie,wt||{},Ct,Ne.identifier,st)},saveAll:ie=>ot.saveAll(ie),applyEdit(ie){return Cn.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,de,Re,st)=>Mt.createFileSystemWatcher(x.GlobPattern.from(ie),de,Re,st),get textDocuments(){return _t.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw L.readonly()},openTextDocument(ie){let de;const Re=ie;if(typeof ie=="string")de=Promise.resolve(T.URI.file(ie));else if(T.URI.isUri(ie))de=Promise.resolve(ie);else if(!Re||typeof Re=="object")de=_t.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(st=>_t.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(ie,de,Re)=>_t.onDidAddDocument(ie,de,Re),onDidCloseTextDocument:(ie,de,Re)=>_t.onDidRemoveDocument(ie,de,Re),onDidChangeTextDocument:(ie,de,Re)=>_t.onDidChangeDocument(ie,de,Re),onDidSaveTextDocument:(ie,de,Re)=>_t.onDidSaveDocument(ie,de,Re),onWillSaveTextDocument:(ie,de,Re)=>Yt.getOnWillSaveTextDocumentEvent(Ne)(ie,de,Re),get notebookDocuments(){return gt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,de){let Re;if(T.URI.isUri(ie))Re=ie,await gt.openNotebookDocument(ie);else if(typeof ie=="string")Re=T.URI.revive(await gt.createNotebookDocument({viewType:ie,content:de}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Re).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,de,Re,st){return gt.registerNotebookSerializer(Ne,ie,de,Re,Ne.enableProposedApi?st:void 0)},registerNotebookContentProvider:(ie,de,Re,st)=>((0,B.checkProposedApiEnabled)(Ne),gt.registerNotebookContentProvider(Ne,ie,de,Re,Ne.enableProposedApi?st:void 0)),onDidChangeConfiguration:(ie,de,Re)=>mn.onDidChangeConfiguration(ie,de,Re),getConfiguration(ie,de){return de=arguments.length===1?void 0:de,mn.getConfiguration(ie,de,Ne)},registerTextDocumentContentProvider(ie,de){return Xt.registerTextDocumentContentProvider(ie,de)},registerTaskProvider:(ie,de)=>(Ke.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Ne,ie,de)),registerFileSystemProvider(ie,de,Re){return tn.registerFileSystemProvider(Ne.identifier,ie,de,Re,Ne.enableProposedApi)},get fs(){return mt.value},registerFileSearchProvider:(ie,de)=>((0,B.checkProposedApiEnabled)(Ne),Tt.registerFileSearchProvider(ie,de)),registerTextSearchProvider:(ie,de)=>((0,B.checkProposedApiEnabled)(Ne),Tt.registerTextSearchProvider(ie,de)),registerRemoteAuthorityResolver:(ie,de)=>((0,B.checkProposedApiEnabled)(Ne),bt.registerRemoteAuthorityResolver(ie,de)),registerResourceLabelFormatter:ie=>((0,B.checkProposedApiEnabled)(Ne),_n.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,de,Re)=>Mt.onDidCreateFile(ie,de,Re),onDidDeleteFiles:(ie,de,Re)=>Mt.onDidDeleteFile(ie,de,Re),onDidRenameFiles:(ie,de,Re)=>Mt.onDidRenameFile(ie,de,Re),onWillCreateFiles:(ie,de,Re)=>Mt.getOnWillCreateFileEvent(Ne)(ie,de,Re),onWillDeleteFiles:(ie,de,Re)=>Mt.getOnWillDeleteFileEvent(Ne)(ie,de,Re),onWillRenameFiles:(ie,de,Re)=>Mt.getOnWillRenameFileEvent(Ne)(ie,de,Re),openTunnel:ie=>((0,B.checkProposedApiEnabled)(Ne),tt.openTunnel(Ne,ie).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,B.checkProposedApiEnabled)(Ne),tt.getTunnels()},onDidChangeTunnels:(ie,de,Re)=>((0,B.checkProposedApiEnabled)(Ne),tt.onDidChangeTunnels(ie,de,Re)),registerPortAttributesProvider:(ie,de)=>((0,B.checkProposedApiEnabled)(Ne),tt.registerPortsAttributesProvider(ie,de)),registerTimelineProvider:(ie,de)=>((0,B.checkProposedApiEnabled)(Ne),rn.registerTimelineProvider(ie,de,Ne.identifier,dt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:ie=>((0,B.checkProposedApiEnabled)(Ne),ot.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,de,Re)=>ot.onDidGrantWorkspaceTrust(ie,de,Re)},Rn={get inputBox(){return Ke.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),qt.getLastInputBox(Ne)},createSourceControl(ie,de,Re){return qt.createSourceControl(Ne,ie,de,Re)}},Ln={createCommentController(ie,de){return En.createCommentController(Ne,ie,de)}},Fn={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},onDidStartDebugSession(ie,de,Re){return Et.onDidStartDebugSession(ie,de,Re)},onDidTerminateDebugSession(ie,de,Re){return Et.onDidTerminateDebugSession(ie,de,Re)},onDidChangeActiveDebugSession(ie,de,Re){return Et.onDidChangeActiveDebugSession(ie,de,Re)},onDidReceiveDebugSessionCustomEvent(ie,de,Re){return Et.onDidReceiveDebugSessionCustomEvent(ie,de,Re)},onDidChangeBreakpoints(ie,de,Re){return Et.onDidChangeBreakpoints(ie,de,Re)},registerDebugConfigurationProvider(ie,de,Re){return Et.registerDebugConfigurationProvider(ie,de,Re||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,de){return Et.registerDebugAdapterDescriptorFactory(Ne,ie,de)},registerDebugAdapterTrackerFactory(ie,de){return Et.registerDebugAdapterTrackerFactory(ie,de)},startDebugging(ie,de,Re){return!Re||typeof Re=="object"&&"configuration"in Re?Et.startDebugging(ie,de,{parentSession:Re}):Et.startDebugging(ie,de,Re||{})},stopDebugging(ie){return Et.stopDebugging(ie)},addBreakpoints(ie){return Et.addBreakpoints(ie)},removeBreakpoints(ie){return Et.removeBreakpoints(ie)},asDebugSourceUri(ie,de){return Et.asDebugSourceUri(ie,de)}},Mn={registerTaskProvider:(ie,de)=>It.registerTaskProvider(Ne,ie,de),fetchTasks:ie=>It.fetchTasks(ie),executeTask:ie=>It.executeTask(Ne,ie),get taskExecutions(){return It.taskExecutions},onDidStartTask:(ie,de,Re)=>It.onDidStartTask(ie,de,Re),onDidEndTask:(ie,de,Re)=>It.onDidEndTask(ie,de,Re),onDidStartTaskProcess:(ie,de,Re)=>It.onDidStartTaskProcess(ie,de,Re),onDidEndTaskProcess:(ie,de,Re)=>It.onDidEndTaskProcess(ie,de,Re)},On={createNotebookController(ie,de,Re,st,wt){return Jt.createNotebookController(Ne,ie,de,Re,st,Ne.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,de)=>gt.registerNotebookCellStatusBarItemProvider(Ne,ie,de),get onDidSaveNotebookDocument(){return(0,B.checkProposedApiEnabled)(Ne),jt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,B.checkProposedApiEnabled)(Ne),Wt.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return Zt.createRendererMessaging(Ne,ie)},onDidChangeNotebookDocumentMetadata(ie,de,Re){return(0,B.checkProposedApiEnabled)(Ne),jt.onDidChangeNotebookDocumentMetadata(ie,de,Re)},onDidChangeNotebookCells(ie,de,Re){return(0,B.checkProposedApiEnabled)(Ne),gt.onDidChangeNotebookCells(ie,de,Re)},onDidChangeNotebookCellExecutionState(ie,de,Re){return(0,B.checkProposedApiEnabled)(Ne),gt.onDidChangeNotebookCellExecutionState(ie,de,Re)},onDidChangeCellOutputs(ie,de,Re){return(0,B.checkProposedApiEnabled)(Ne),gt.onDidChangeCellOutputs(ie,de,Re)},onDidChangeCellMetadata(ie,de,Re){return(0,B.checkProposedApiEnabled)(Ne),gt.onDidChangeCellMetadata(ie,de,Re)},createConcatTextDocument(ie,de){return(0,B.checkProposedApiEnabled)(Ne),new Ee.ExtHostNotebookConcatDocument(gt,_t,ie,de)}};return{version:Xe.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:ln,languages:An,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:Tn,workspace:vn,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:u.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionList:F.InlineSuggestions,Hover:F.Hover,IndentAction:P.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,Task2:F.Task,TaskGroup:F.TaskGroup,TaskGroup2:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:u.UIKind,Uri:T.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlayHint:F.InlayHint,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:be.TextSearchCompleteMessageType,TestMessageSeverity:F.TestMessageSeverity,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ze}),define(me[274],ge([0,1,80,65,36,131,37,44,45,33,69,53,71,93,52,64,132,92,62,91,122,51]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_,b,A,c,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,g.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,g.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,g.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,g.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,g.registerSingleton)(y.IExtHostDecorations,y.ExtHostDecorations),(0,g.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(A.IExtHostFileSystemInfo,A.ExtHostFileSystemInfo),(0,g.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,g.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch),(0,g.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,g.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,g.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,g.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,g.registerSingleton)(_.IExtHostWindow,_.ExtHostWindow),(0,g.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace),(0,g.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,g.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,g.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs)}),define(me[94],ge([0,1,20,12,31,68]),function(J,e,g,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=T;function C(I,u,m,l){const v=(0,g.mapArrayOrNot)(m,S),_=new k.TextSearchMatch(u,v,l),b=_.preview.matches;return{ranges:(0,g.mapArrayOrNot)(v,P),uri:I,preview:{text:_.preview.text,matches:(0,g.mapArrayOrNot)(b,P)}}}e.createTextSearchResult=C;function S(I){return new k.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function P(I){return new y.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let i=class{constructor(u,m){this.prefix=u,this.logService=m}appendLine(u){this.logService.debug(`${this.prefix}#search`,u)}};i=Ve([$e(1,L.ILogService)],i),e.OutputChannel=i}),define(me[275],ge([0,1,96,24]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(r=>r===t)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const y=512,T=512,C=512*8,S=512*128;class P{constructor(r){this.iconvLiteDecoder=r}static async create(r){let o;if(r!==e.UTF8)o=(await new Promise((a,f)=>{J(["iconv-lite-umd"],a,f)})).getDecoder(m(r));else{const n=new TextDecoder;o={write(a){return n.decode(a,{stream:!0})},end(){return n.decode()}}}return new P(o)}write(r){return this.iconvLiteDecoder.write(r)}end(){return this.iconvLiteDecoder.end()}}function i(t,r){const o=r.minBytesRequiredForDetection??r.guessEncoding?C:T;return new Promise((n,a)=>{const f=(0,g.newWriteableStream)(D=>D.join("")),d=[];let w=0,E;const s=async()=>{try{const D=await p({buffer:L.VSBuffer.concat(d),bytesRead:w},r.guessEncoding);D.encoding=await r.overwriteEncoding(D.encoding),E=await P.create(D.encoding);const R=E.write(L.VSBuffer.concat(d).buffer);f.write(R),d.length=0,w=0,n({stream:f,detected:D})}catch(D){a(D)}};(0,g.listenStream)(t,{onData:async D=>{E?f.write(E.write(D.buffer)):(d.push(D),w+=D.byteLength,w>=o&&(t.pause(),await s(),setTimeout(()=>t.resume())))},onError:D=>f.error(D),onEnd:async()=>{E||await s(),f.end(E?.end())}})})}e.toDecodeStream=i;async function I(t,r,o){const a=(await new Promise((w,E)=>{J(["iconv-lite-umd"],w,E)})).getEncoder(m(r),o);let f=!1,d=!1;return{read(){if(d)return null;const w=t.read();if(typeof w!="string"){if(d=!0,!f&&o?.addBOM)switch(r){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const E=a.end();return E&&E.length>0?(f=!0,L.VSBuffer.wrap(E)):null}return f=!0,L.VSBuffer.wrap(a.write(w))}}}e.toEncodeReadable=I;async function u(t){return(await new Promise((o,n)=>{J(["iconv-lite-umd"],o,n)})).encodingExists(m(t))}e.encodingExists=u;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function l(t,r){if(!t||r<e.UTF16be_BOM.length)return null;const o=t.readUInt8(0),n=t.readUInt8(1);if(o===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(r<e.UTF8_BOM.length)return null;const a=t.readUInt8(2);return o===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=l;const v=["ascii","utf-16","utf-32"];async function _(t){const r=await new Promise((d,w)=>{J(["jschardet"],d,w)}),o=t.slice(0,S),n=c(o.buffer),a=r.detect(n);if(!a||!a.encoding)return null;const f=a.encoding.toLowerCase();return 0<=v.indexOf(f)?null:A(a.encoding)}const b={ibm866:"cp866",big5:"cp950"};function A(t){const r=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[r]||r}function c(t){let r="";for(let o=0;o<t.length;o++)r+=String.fromCharCode(t[o]);return r}function h(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const r=t.match(/windows(\d+)/);return r?"windows-"+r[1]:t}}e.toCanonicalName=h;function p({buffer:t,bytesRead:r},o){let n=l(t,r),a=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let f=!0,d=!0,w=!1;for(let E=0;E<r&&E<y;E++){const s=E%2==1,D=t.readUInt8(E)===0;if(D&&(w=!0),f&&(s&&!D||!s&&D)&&(f=!1),d&&(s&&D||!s&&!D)&&(d=!1),D&&!f&&!d)break}w&&(f?n=e.UTF16le:d?n=e.UTF16be:a=!0)}return o&&!a&&!n&&t?_(t.slice(0,r)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:a,encoding:n}}e.detectEncodingFromBuffer=p,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[134],ge([0,1,275,28,133]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class y extends k.TextSearchManager{constructor(C,S,P=L){super(C,S,{readdir:i=>P.Promises.readdir(i.fsPath),toCanonicalName:i=>(0,g.toCanonicalName)(i)})}}e.NativeTextSearchManager=y}),define(me[276],ge([0,1,277,292,293,2,294]),function(J,e,g,L,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function C(I,u,m,l,v,_){const b=_.environment.useHostProxy,A=typeof b=="boolean"?b:!_.remote.isRemote,c=(0,T.createProxyResolver)({resolveProxy:p=>I.resolveProxy(p),getHttpProxySetting:()=>u.getConfiguration("http").get("proxy"),log:(p,t,...r)=>{switch(p){case T.LogLevel.Trace:l.trace(t,...r);break;case T.LogLevel.Debug:l.debug(t,...r);break;case T.LogLevel.Info:l.info(t,...r);break;case T.LogLevel.Warning:l.warn(t,...r);break;case T.LogLevel.Error:l.error(t,...r);break;case T.LogLevel.Critical:l.critical(t,...r);break;case T.LogLevel.Off:break;default:o(p,t,r);break}function o(n,a,...f){l.error("Unknown log level",n),l.error(a,...f)}},getLogLevel:()=>l.getLevel(),proxyResolveTelemetry:p=>{v.$publicLog2("resolveProxy",p)},useHostProxy:A,env:process.env}),h=S(u,c);return i(m,h)}e.connectProxyResolver=C;function S(I,u){const m={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(v=>{m.config=I.getConfiguration("http").get("proxySupport")||"off"});const l={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(v=>{l.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,T.createHttpPatch)(g,u,{config:"off"},l,!0)),on:Object.assign({},g,(0,T.createHttpPatch)(g,u,{config:"on"},l,!0)),override:Object.assign({},g,(0,T.createHttpPatch)(g,u,{config:"override"},l,!0)),onRequest:Object.assign({},g,(0,T.createHttpPatch)(g,u,m,l,!0)),default:Object.assign(g,(0,T.createHttpPatch)(g,u,m,l,!1))},https:{off:Object.assign({},L,(0,T.createHttpPatch)(L,u,{config:"off"},l,!0)),on:Object.assign({},L,(0,T.createHttpPatch)(L,u,{config:"on"},l,!0)),override:Object.assign({},L,(0,T.createHttpPatch)(L,u,{config:"override"},l,!0)),onRequest:Object.assign({},L,(0,T.createHttpPatch)(L,u,m,l,!0)),default:Object.assign(L,(0,T.createHttpPatch)(L,u,m,l,!1))},tls:Object.assign(k,(0,T.createTlsPatch)(k))}}const P=new Map;function i(I,u){return I.getExtensionPathIndex().then(m=>{const l=J.__$__nodeRequire("module"),v=l._load;l._load=function(b,A,c){if(b==="tls")return u.tls;if(b!=="http"&&b!=="https")return v.apply(this,arguments);const h=u[b],p=m.findSubstr(y.URI.file(A.filename).fsPath);let t=P.get(p);if(t||P.set(p,t={}),!t[b]){let r=h.default;p&&p.enableProposedApi&&(r=h[p.proxySupport]||h.onRequest),t[b]={...r}}return t[b]}})}}),define(me[278],ge([0,1,39,9,76,29,11,8,94,279]),function(J,e,g,L,k,y,T,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(c,h,p,t){const r=u(c,h,p,t),o=h.folder.fsPath;return{cmd:g.spawn(i,r.args,{cwd:o}),rgDiskPath:i,siblingClauses:r.siblingClauses,rgArgs:r,cwd:o}}e.spawnRipgrepCmd=I;function u(c,h,p,t){const r=["--files","--hidden","--case-sensitive"];l([h],p,!1).forEach(n=>{const a=(0,S.anchorGlob)(n);if(r.push("-g",a),T.isMacintosh){const f=(0,k.normalizeNFD)(a);f!==a&&r.push("-g",f)}});const o=m([h],t,void 0,!1);return o.globArgs.forEach(n=>{const a=`!${(0,S.anchorGlob)(n)}`;if(r.push("-g",a),T.isMacintosh){const f=(0,k.normalizeNFD)(a);f!==a&&r.push("-g",f)}}),h.disregardIgnoreFiles!==!1?r.push("--no-ignore"):r.push("--no-ignore-parent"),h.ignoreSymlinks||r.push("--follow"),c.exists&&r.push("--quiet"),r.push("--no-config"),h.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:o.siblingClauses}}function m(c,h,p,t=!0){const r=[];let o={};return c.forEach(n=>{const a=Object.assign({},n.excludePattern||{},h||{}),f=v(a,t?n.folder.fsPath:void 0,p);r.push(...f.globArgs),f.siblingClauses&&(o=Object.assign(o,f.siblingClauses))}),{globArgs:r,siblingClauses:o}}e.foldersToRgExcludeGlobs=m;function l(c,h,p=!0){const t=[];return c.forEach(r=>{const o=Object.assign({},h||{},r.includePattern||{}),n=v(o,p?r.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=l;function v(c,h,p){const t=[],r={};return Object.keys(c).forEach(o=>{if(p&&p.has(o)||!o)return;const n=c[o];o=b(h?_(h,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof n=="boolean"&&n?(o.startsWith("\\\\")&&(o+="**"),t.push(A(o))):n&&n.when&&(r[o]=n)}),{globArgs:t,siblingClauses:r}}function _(c,h){return L.isAbsolute(h)?h:L.join(c,h)}e.getAbsoluteGlob=_;function b(c){return c=C.rtrim(c,"\\"),C.rtrim(c,"/")}function A(c){return y.getRoot(c).toLowerCase()==="c:/"?c.replace(/^c:[/\\]/i,"/"):c}e.fixDriveC=A}),define(me[280],ge([0,1,39,49,9,104,20,60,30,76,29,11,46,8,14,28,31,278,101]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_,b,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const c=new Set;process.on("exit",()=>{c.forEach(o=>o())});class h{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&S.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,A.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&S.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(a=>{const f=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),d=a.folder.fsPath;n.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==d).forEach(w=>{(0,i.isEqualOrParent)(w,d)&&(f[k.relative(d,w)]=!0)}),this.folderExcludePatterns.set(d,new t(f,d))})}cancel(){this.isCanceled=!0}walk(n,a,f,d,w){if(this.fileWalkSW=u.StopWatch.create(!1),this.isCanceled)return w(null,this.isLimitHit);a.forEach(E=>{const s=k.basename(E.fsPath);this.globalExcludePattern&&this.globalExcludePattern(E.fsPath,s)||this.matchFile(f,{relativePath:E.fsPath,searchPath:void 0})}),this.cmdSW=u.StopWatch.create(!1),this.parallel(n,(E,s)=>{this.call(this.cmdTraversal,this,E,f,d,D=>{if(D){const R=(0,C.toErrorMessage)(D);console.error(R),this.errors.push(R),s(D,void 0)}else s(null,void 0)})},(E,s)=>{this.fileWalkSW.stop();const D=E?T.coalesce(E)[0]:null;w(D,this.isLimitHit)})}parallel(n,a,f){const d=new Array(n.length),w=new Array(n.length);let E=!1,s=0;if(n.length===0)return f(null,[]);n.forEach((D,R)=>{a(D,(U,V)=>{if(U?(E=!0,d[R]=null,w[R]=U):(d[R]=V,w[R]=null),++s===n.length)return f(E?w:null,d)})})}call(n,a,...f){try{n.apply(a,f)}catch(d){f[f.length-1](d)}}cmdTraversal(n,a,f,d){const w=n.folder.fsPath,E=I.isMacintosh;let s;const D=()=>s&&s.kill();c.add(D);let R=F=>{c.delete(D),R=()=>{},d(F)},U="";const V=this.initDirectoryTree();let ee;const K=(0,b.spawnRipgrepCmd)(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);s=K.cmd,ee=!Object.keys(K.siblingClauses).length;const O=K.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let x=`${K.rgDiskPath} ${O}
 - cwd: ${K.cwd}`;K.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(K.rgArgs.siblingClauses)}`),f({message:x}),this.cmdResultCount=0,this.collectStdout(s,"utf8",f,(F,z,M)=>{if(F){R(F);return}if(this.isLimitHit){R();return}const q=(U+(E?P.normalizeNFC(z||""):z)).split(`
`);if(M){const B=q.length;q[B-1]=q[B-1].trim(),q[B-1]||q.pop()}else U=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,ee){for(const B of q)if(this.matchFile(a,{base:w,relativePath:B,searchPath:this.getSearchPath(n,B)}),this.isLimitHit){D();break}(M||this.isLimitHit)&&R();return}this.addDirectoryEntries(n,V,w,q,a),M&&(this.matchDirectoryTree(V,w,a),R())})}spawnFindCmd(n){const a=this.folderExcludePatterns.get(n.folder.fsPath),f=a.getBasenameTerms(),d=a.getPathTerms(),w=["-L","."];if(f.length||d.length){w.push("-not","(","(");for(const E of f)w.push("-name",E),w.push("-o");for(const E of d)w.push("-path",E),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),g.spawn("find",w,{cwd:n.folder.fsPath})}readStdout(n,a,f){let d="";this.collectStdout(n,a,()=>{},(w,E,s)=>{if(w){f(w);return}d+=E,s&&f(null,d)})}collectStdout(n,a,f,d){let w=(D,R,U)=>{(D||U)&&(w=()=>{},this.cmdSW&&this.cmdSW.stop()),d(D,R,U)},E=!1;n.stdout?(this.forwardData(n.stdout,a,w),n.stdout.once("data",()=>E=!0)):f({message:"stdout is null"});let s;n.stderr?s=this.collectData(n.stderr):f({message:"stderr is null"}),n.on("error",D=>{w(D)}),n.on("close",D=>{let R;!E&&(R=this.decodeData(s,a))&&r(R)?w(new Error(`command failed with error code ${D}: ${this.decodeData(s,a)}`)):(this.exists&&D===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(n,a,f){const d=new y.StringDecoder(a);return n.on("data",w=>{f(null,d.write(w))}),d}collectData(n){const a=[];return n.on("data",f=>{a.push(f)}),a}decodeData(n,a){const f=new y.StringDecoder(a);return n.map(d=>f.write(d)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:a},f,d,w){d.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:f,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const E=s=>{const D=k.basename(s),R=k.dirname(s);let U=a[R];U||(U=a[R]=[],E(R)),U.push({base:f,relativePath:s,basename:D,searchPath:this.getSearchPath(n,s)})};d.forEach(E)}matchDirectoryTree({rootEntries:n,pathToEntries:a},f,d){const w=this,E=this.folderExcludePatterns.get(f),s=this.filePattern;function D(R){w.directoriesWalked++;const U=S.hasSiblingFn(()=>R.map(V=>V.basename));for(let V=0,ee=R.length;V<ee;V++){const K=R[V],{relativePath:O,basename:x}=K;if(E.test(O,x,s!==x?U:void 0))continue;const F=a[O];if(F)D(F);else{if(w.filesWalked++,O===s)continue;w.matchFile(d,K)}if(w.isLimitHit)break}}D(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,a,f,d,w){const E=n.folder,s=S.hasSiblingFn(()=>f);this.parallel(f,(D,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const U=a?[a,D].join(k.sep):D;if(this.folderExcludePatterns.get(n.folder.fsPath).test(U,D,this.config.filePattern!==D?s:void 0))return R(null);const V=[E.fsPath,U].join(k.sep);L.lstat(V,(ee,K)=>{if(ee||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(V,K,(O,x)=>O||this.isCanceled||this.isLimitHit?R(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(V,K,(F,z)=>F||this.isCanceled||this.isLimitHit||(z=z||"",this.walkedPaths[z])?R(null):(this.walkedPaths[z]=!0,v.Promises.readdir(V).then(M=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(n,U,M,d,N=>R(N||null))},M=>{R(null)})))):(this.filesWalked++,U===this.filePattern||this.maxFilesize&&l.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(d,{base:E.fsPath,relativePath:U,searchPath:this.getSearchPath(n,U)}),R(null,void 0)))})},D=>{const R=D&&T.coalesce(D);return w(R&&R.length>0?R[0]:void 0)})}matchFile(n,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,k.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(a))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,_.isFilePatternMatch)(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,a,f){return a.isSymbolicLink()?L.stat(n,f):f(null,a)}realPathIfNeeded(n,a,f){return a.isSymbolicLink()?L.realpath(n,(d,w)=>d?f(d):f(null,w)):f(null,n)}getSearchPath(n,a){return n.folderName?k.join(n.folderName,a):a}}e.FileWalker=h;class p{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new h(n)}search(n,a,f){this.walker.walk(this.folderQueries,this.extraFiles,n,a,(d,w)=>{f(d,{limitHit:w,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class t{constructor(n,a){this.expression=n,this.root=a,this.init(n)}init(n){let a,f;Object.keys(n).filter(d=>n[d]).forEach(d=>{k.isAbsolute(d)?(a=a||S.getEmptyExpression(),a[d]=n[d]):(f=f||S.getEmptyExpression(),f[d]=n[d])}),this.absoluteParsedExpr=a&&S.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=f&&S.parse(f,{trimForExclusions:!0})}test(n,a,f){return this.relativeParsedExpr&&this.relativeParsedExpr(n,a,f)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,n),a,f)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...S.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...S.getPathTerms(this.relativeParsedExpr)),n}}function r(o){const n=o.trim().split(`
`),a=n[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return m.uppercaseFirstLetter(n[n.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=r}),define(me[135],ge([0,1,39,295,104,20,55,30,9,8,2,31,68,296,279,94]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class b{constructor(E){this.outputChannel=E}provideTextSearchResults(E,s,D,R){return this.outputChannel.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...s,folder:s.folder.toString()})}`),new Promise((U,V)=>{R.onCancellationRequested(()=>N());const ee=r(E,s),K=s.folder.fsPath,O=ee.map(he=>he.match(/^-/)?he:`'${he}'`).join(" ");this.outputChannel.appendLine(`${_} ${O}
 - cwd: ${K}`);let x=g.spawn(_,ee,{cwd:K});x.on("error",he=>{console.error(he),this.outputChannel.appendLine("Error: "+(he&&he.message)),V((0,I.serializeSearchError)(new I.SearchError(he&&he.message,I.SearchErrorCode.rgProcessError)))});let F=!1;const z=new h(s.maxResults,K,s.previewOptions);z.on("result",he=>{F=!0,B="",D.report(he)});let M=!1;const N=()=>{M=!0,x&&x.kill(),z&&z.cancel()};let q=!1;z.on("hitLimit",()=>{q=!0,N()});let B="";x.stdout.on("data",he=>{z.handleData(he),F||(B+=he)});let G=!1;x.stdout.once("data",()=>G=!0);let re="";x.stderr.on("data",he=>{const ye=he.toString();this.outputChannel.appendLine(ye),re+=ye}),x.on("close",()=>{if(this.outputChannel.appendLine(G?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(F?"Got result from parser":"No result from parser"),B&&this.outputChannel.appendLine(`Got data without result: ${B}`),this.outputChannel.appendLine(""),M)U({limitHit:q});else{z.flush(),x=null;let he;re&&!G&&(he=A(re))?V((0,I.serializeSearchError)(new I.SearchError(he.message,he.code))):U({limitHit:q})}})})}}e.RipgrepTextSearchEngine=b;function A(w){const E=w.split(`
`),s=E[0].trim();if(E.some(R=>R.startsWith("regex parse error")))return new I.SearchError(c(E),I.SearchErrorCode.regexParseError);const D=s.match(/grep config error: unknown encoding: (.*)/);if(D)return new I.SearchError(`Unknown encoding: ${D[1]}`,I.SearchErrorCode.unknownEncoding);if(s.startsWith("error parsing glob"))return new I.SearchError(s.charAt(0).toUpperCase()+s.substr(1),I.SearchErrorCode.globParseError);if(s.startsWith("the literal"))return new I.SearchError(s.charAt(0).toUpperCase()+s.substr(1),I.SearchErrorCode.invalidLiteral);if(s.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(s,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=A;function c(w){const E=["Regex parse error"],s=w.filter(D=>D.startsWith("PCRE2:"));if(s.length>=1){const D=s[0].replace("PCRE2:","");if(D.indexOf(":")!==-1&&D.split(":").length>=2){const R=D.split(":")[1];E.push(":"+R)}}return E.join("")}e.buildRegexParseError=c;class h extends L.EventEmitter{constructor(E,s,D){super();this.maxResults=E,this.rootFolder=s,this.previewOptions=D,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(E,s){return super.on(E,s),this}handleData(E){if(this.isDone)return;const s=typeof E=="string"?E:this.stringDecoder.write(E);this.handleDecodedData(s)}handleDecodedData(E){let s=E.indexOf(`
`);const D=this.remainder+E;if(s>=0)s+=this.remainder.length;else{this.remainder=D;return}let R=0;for(;s>=0;)this.handleLine(D.substring(R,s).trim()),R=s+1,s=D.indexOf(`
`,R);this.remainder=D.substring(R)}handleLine(E){if(this.isDone||!E)return;let s;try{s=JSON.parse(E)}catch(D){throw new Error(`malformed line from rg: ${E}`)}if(s.type==="match"){const D=p(s.data.path),R=i.URI.file(S.join(this.rootFolder,D)),U=this.createTextSearchMatch(s.data,R);this.onResult(U),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(s.type==="context"){const D=p(s.data.path),R=i.URI.file(S.join(this.rootFolder,D));this.createTextSearchContext(s.data,R).forEach(V=>this.onResult(V))}}createTextSearchMatch(E,s){const D=E.line_number-1,R=p(E.lines),U=Buffer.from(R);let V=0,ee=0,K=D;E.submatches.length===0&&E.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const O=(0,y.coalesce)(E.submatches.map((x,F)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const z=p(x.match),M=U.slice(V,x.start).toString().length,N=ee+M,q=t(z),B=K,G=q.numLines+B,re=q.numLines>0?q.lastLineLength:q.lastLineLength+N;return V=x.end,ee=re,K=G,new u.Range(B,N,G,re)}));return(0,v.createTextSearchResult)(s,R,O,this.previewOptions)}createTextSearchContext(E,s){const D=p(E.lines),R=E.line_number;return D.replace(/\r?\n$/,"").split(`
`).map((U,V)=>({text:U,uri:s,lineNumber:R+V}))}onResult(E){this.emit("result",E)}}e.RipgrepParser=h;function p(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const E=/\n/g;let s=0,D=-1,R;for(;R=E.exec(w);)s++,D=R.index;const U=D>=0?w.length-D-1:w.length;return{numLines:s,lastLineLength:U}}function r(w,E){const s=["--hidden"];s.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:D,otherIncludes:R}=(0,T.groupBy)(E.includes,V=>V.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const V=new Set;R.forEach(ee=>{V.add(ee)}),s.push("-g","!*"),V.forEach(ee=>{o(ee).map(v.anchorGlob).forEach(K=>{s.push("-g",K)})})}D&&D.length&&D.forEach(V=>{s.push("-g",V)}),E.excludes.map(v.anchorGlob).forEach(V=>s.push("-g",`!${V}`)),E.maxFileSize&&s.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?s.push("--no-ignore-parent"):s.push("--no-ignore"),E.followSymlinks&&s.push("--follow"),E.encoding&&E.encoding!=="utf8"&&s.push("--encoding",E.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,P.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),E.usePCRE2&&s.push("--pcre2"),s.push("--crlf"),w.isRegExp&&(w.pattern=n(w.pattern),s.push("--auto-hybrid-regex"));let U;if(w.isWordMatch){const ee=(0,P.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");s.push("--regexp",ee)}else if(w.isRegExp){let V=f(w.pattern);V=d(V),s.push("--regexp",V)}else U=w.pattern,s.push("--fixed-strings");return s.push("--no-config"),E.useGlobalIgnoreFiles||s.push("--no-ignore-global"),s.push("--json"),w.isMultiline&&s.push("--multiline"),E.beforeContext&&s.push("--before-context",E.beforeContext+""),E.afterContext&&s.push("--after-context",E.afterContext+""),s.push("--"),U&&s.push(U),s.push("."),s}function o(w){const E=(0,C.splitGlobAware)(w,"/");return E.map((s,D)=>E.slice(0,D+1).join("/"))}e.spreadGlobComponents=o;function n(w){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(E);)w=w.replace(E,"$1\\x{$2}");const s=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(s);)w=w.replace(s,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=n;const a=w=>w.type==="Assertion"&&w.kind==="lookbehind";function f(w){let E;try{E=new m.RegExpParser().parsePattern(w)}catch{return w}let s="",D=0;const R=(ee,K,O)=>{s+=w.slice(D,ee)+O,D=K},U=[];return new m.RegExpVisitor({onCharacterEnter(ee){if(ee.raw!=="\\n")return;const K=U[0];if(!K)R(ee.start,ee.end,"\\r?\\n");else if(!U.some(a))if(K.type==="CharacterClass")if(K.negate){const O=w.slice(K.start+2,ee.start)+w.slice(ee.end,K.end-1);R(K.start,K.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=w.slice(K.start+1,ee.start)+w.slice(ee.end,K.end-1);R(K.start,K.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else K.type==="Quantifier"&&R(ee.start,ee.end,"(?:\\r?\\n)")},onQuantifierEnter(ee){U.unshift(ee)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(ee){U.unshift(ee)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(ee){U.unshift(ee)},onCharacterClassLeave(){U.shift()},onAssertionEnter(ee){a(ee)&&U.push(ee)},onAssertionLeave(ee){U[0]===ee&&U.shift()}}).visit(E),s+=w.slice(D),s}e.fixRegexNewline=f;function d(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=d}),define(me[281],ge([0,1,21,135,118,10]),function(J,e,g,L,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,i,I,u){const m=new L.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===y.Schemas.userData){const l={...i,folder:i.folder.with({scheme:y.Schemas.file})},v=new k.Progress(_=>I.report({..._,uri:_.uri.with({scheme:i.folder.scheme})}));return this.withToken(u,_=>m.provideTextSearchResults(P,l,v,_))}else return this.withToken(u,l=>m.provideTextSearchResults(P,i,I,l))}async withToken(P,i){const I=C(P);this.inProgress.add(I);const u=await i(I.token);return this.inProgress.delete(I),u}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=T;function C(S){const P=new g.CancellationTokenSource;return S.onCancellationRequested(()=>P.cancel()),P}}),define(me[282],ge([0,1,28,135,134]),function(J,e,g,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class y{constructor(S){this.query=S}search(S,P,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(m){i({message:m})}},u=new k.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(I),g);return new Promise((m,l)=>u.search(v=>{P(v.map(T))},S).then(v=>m({limitHit:v.limitHit,type:"success"}),l))}}e.TextSearchEngineAdapter=y;function T(C){return{path:C.resource&&C.resource.fsPath,results:C.results,numMatches:(C.results||[]).reduce((S,P)=>{if(P.ranges){const i=P;return S+(Array.isArray(i.ranges)?i.ranges.length:1)}else return S+1},0)}}}),define(me[283],ge([0,1,49,297,20,17,16,3,101,9,46,2,42,31,280,282]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(g);class _{constructor(){this.caches=Object.create(null)}fileSearch(t){let r;const o=c(t),n=new C.Emitter({onFirstListenerDidAdd:()=>{r=(0,y.createCancelablePromise)(a=>this.doFileSearchWithEngine(l.Engine,o,f=>n.fire(f),a)),r.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return n.event}textSearch(t){let r;const o=c(t),n=new C.Emitter({onFirstListenerDidAdd:()=>{r=(0,y.createCancelablePromise)(a=>this.ripgrepTextSearch(o,f=>n.fire(f),a)),r.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return n.event}ripgrepTextSearch(t,r,o){return t.maxFileSize=(0,u.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new v.TextSearchEngineAdapter(t).search(o,r,r)}doFileSearch(t,r,o){return this.doFileSearchWithEngine(l.Engine,t,r,o)}doFileSearchWithEngine(t,r,o,n,a=_.BATCH_SIZE){let f=0;const d=E=>{Array.isArray(E)?(f+=E.length,o(E.map(s=>this.rawMatchToSearchItem(s)))):E.relativePath?(f++,o(this.rawMatchToSearchItem(E))):o(E)};if(r.sortByScore){let E=this.trySortedSearchFromCache(r,d,n);if(!E){const s=r.maxResults?Object.assign({},r,{maxResults:null}):r,D=new t(s);E=this.doSortedSearch(D,r,o,d,n)}return new Promise((s,D)=>{E.then(([R,U])=>{const V=U.map(ee=>this.rawMatchToSearchItem(ee));this.sendProgress(V,o,a),s(R)},D)})}const w=new t(r);return this.doSearch(w,d,a,n).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:"searchProcess",fromCache:!1,resultCount:f,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,P.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,r,o,n,a){const f=new C.Emitter;let d=(0,y.createCancelablePromise)(E=>{let s=[];const D=R=>{Array.isArray(R)?s=R:(n(R),f.fire(R))};return this.doSearch(t,D,-1,E).then(R=>[R,s])}),w;if(r.cacheKey){w=this.getOrCreateCache(r.cacheKey);const E={promise:d,event:f.event,resolved:!1};w.resultsToSearchCache[r.filePattern||""]=E,d.then(()=>{E.resolved=!0},s=>{delete w.resultsToSearchCache[r.filePattern||""]}),d=this.preventCancellation(d)}return d.then(([E,s])=>{const D=w?w.scorerCache:Object.create(null),R=(typeof r.maxResults!="number"||r.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(r,s,D,a).then(U=>{const V=R?R.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:V,fromCache:!1,type:"searchProcess",workspaceFolderCount:r.folderQueries.length,resultCount:U.length},messages:E.messages,limitHit:E.limitHit||typeof r.maxResults=="number"&&s.length>r.maxResults},U]})})}getOrCreateCache(t){const r=this.caches[t];return r||(this.caches[t]=new b)}trySortedSearchFromCache(t,r,o){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const a=this.getResultsFromCache(n,t.filePattern||"",r,o);if(a)return a.then(([f,d,w])=>{const E=i.StopWatch.create(!1);return this.sortResults(t,d,n.scorerCache,o).then(s=>{const D=E.elapsed(),R={fromCache:!0,detailStats:w,type:"searchProcess",resultCount:d.length,sortingTime:D};return[{type:"success",limitHit:f.limitHit||typeof t.maxResults=="number"&&d.length>t.maxResults,stats:R},s]})})}sortResults(t,r,o,n){const a=(0,S.prepareQuery)(t.filePattern||""),f=(w,E)=>(0,S.compareItemsByFuzzyScore)(w,E,a,!0,A,o),d=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return k.topAsync(r,f,d,1e4,n)}sendProgress(t,r,o){if(o&&o>0)for(let n=0;n<t.length;n+=o)r(t.slice(n,n+o));else r(t)}getResultsFromCache(t,r,o,n){const a=i.StopWatch.create(!1),f=r.indexOf(P.sep)>=0;let d;for(const D in t.resultsToSearchCache)if(r.startsWith(D)){if(f&&D.indexOf(P.sep)<0&&D!=="")continue;const R=t.resultsToSearchCache[D];d={promise:this.preventCancellation(R.promise),event:R.event,resolved:R.resolved};break}if(!d)return null;const w=a.elapsed(),E=i.StopWatch.create(!1),s=d.event(o);return n&&n.onCancellationRequested(()=>{s.dispose()}),d.promise.then(([D,R])=>{if(n&&n.isCancellationRequested)throw(0,T.canceled)();const U=[],V=(0,S.prepareQuery)(r).normalizedLowercase;for(const ee of R)!(0,m.isFilePatternMatch)(ee,V)||U.push(ee);return[D,U,{cacheWasResolved:d.resolved,cacheLookupTime:w,cacheFilterTime:E.elapsed(),cacheEntryCount:R.length}]})}doSearch(t,r,o,n){return new Promise((a,f)=>{let d=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(w=>{w&&(o?(d.push(w),o>0&&d.length>=o&&(r(d),d=[])):r(w))},w=>{r(w)},(w,E)=>{d.length&&r(d),w?f(w):a(E)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,o){return t.then(r,o)}catch(r){return this.then(void 0,r)}finally(r){return t.finally(r)}}}}e.SearchService=_,_.BATCH_SIZE=512;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const A=new class{getItemLabel(p){return(0,P.basename)(p.relativePath)}getItemDescription(p){return(0,P.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function c(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(h),extraFileResources:p.extraFileResources&&p.extraFileResources.map(t=>I.URI.revive(t))}}function h(p){return{...p,folder:I.URI.revive(p.folder)}}}),define(me[284],ge([0,1,6,2,28,12,31,283,281,94,13,63,27,71,10,134]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends m.ExtHostSearch{constructor(A,c,h,p){super(A,h,p);this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new P.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(l.Schemas.userData,new S.RipgrepSearchProvider(t)),c.remote.isRemote&&c.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const A=new P.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(l.Schemas.file,new S.RipgrepSearchProvider(A)),this.registerInternalFileSearchProvider(l.Schemas.file,new C.SearchService)}registerInternalFileSearchProvider(A,c){const h=this._handlePool++;return this._internalFileSearchProvider=c,this._internalFileSearchHandle=h,this._proxy.$registerFileSearchProvider(h,this._transformScheme(A)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(A,c,h,p){const t=(0,m.reviveQuery)(h);return A===this._internalFileSearchHandle?this.doInternalFileSearch(A,c,t,p):super.$provideFileSearchResults(A,c,h,p)}doInternalFileSearch(A,c,h,p){const t=r=>{if((0,T.isSerializedFileMatch)(r)&&(r=[r]),Array.isArray(r)){this._proxy.$handleFileMatch(A,c,r.map(o=>L.URI.file(o.path)));return}r.message&&this._logService.debug("ExtHostSearch",r.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(h,t,p)}$clearCache(A){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(A),super.$clearCache(A)}createTextSearchManager(A,c){return new v.NativeTextSearchManager(A,c)}};_=Ve([$e(0,i.IExtHostRpcService),$e(1,u.IExtHostInitDataService),$e(2,I.IURITransformerService),$e(3,y.ILogService)],_),e.NativeExtHostSearch=_}),define(me[136],ge([0,1,298,125,78,24,16,3,6,9,11,32,106,107,299]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(d){this.socket=d,this._errorListener=w=>{if(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const w=E=>d(y.VSBuffer.wrap(E));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(d){const w=E=>{d({type:0,hadError:E,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(d){return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(d){if(!this.socket.destroyed)try{this.socket.write(d.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}}end(){this.socket.end()}drain(){return new Promise((d,w)=>{if(this.socket.bufferSize===0){d();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),d()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=v;var _;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var b;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(b||(b={}));class A extends S.Disposable{constructor(d,w,E,s){super();this._onDidZlibFlush=this._register(new C.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=d,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=s,w?(this._zlibInflate=l.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",D=>{console.error(D),(0,T.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})}),this._zlibInflate.on("data",D=>{this._pendingInflateData.push(D)}),E&&(this._zlibInflate.write(E.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=l.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",D=>{console.error(D),(0,T.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})}),this._zlibDeflate.on("data",D=>{this._pendingDeflateData.push(D)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new m.ChunkStream,this._register(this.socket.onData(D=>this._acceptChunk(D))),this._register(this.socket.onClose(D=>this._onClose.fire(D)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?y.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):y.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._totalOutgoingDataBytes+=d.byteLength,this._zlibDeflate?(this._zlibDeflate.write(d.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(y.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(d,!1)}_write(d,w){let E=2;d.byteLength<126?E+=0:d.byteLength<2**16?E+=2:E+=8;const s=y.VSBuffer.alloc(E);if(w?s.writeUInt8(194,0):s.writeUInt8(130,0),d.byteLength<126)s.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){s.writeUInt8(126,1);let D=1;s.writeUInt8(d.byteLength>>>8&255,++D),s.writeUInt8(d.byteLength>>>0&255,++D)}else{s.writeUInt8(127,1);let D=1;s.writeUInt8(0,++D),s.writeUInt8(0,++D),s.writeUInt8(0,++D),s.writeUInt8(0,++D),s.writeUInt8(d.byteLength>>>24&255,++D),s.writeUInt8(d.byteLength>>>16&255,++D),s.writeUInt8(d.byteLength>>>8&255,++D),s.writeUInt8(d.byteLength>>>0&255,++D)}this._totalOutgoingWireBytes+=s.byteLength+d.byteLength,this.socket.write(y.VSBuffer.concat([s,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._totalIncomingWireBytes+=d.byteLength,this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),s=(w.readUInt8(0)&128)>>>7,D=w.readUInt8(1),R=(D&128)>>>7,U=D&127;this._state.state=2,this._state.readLen=2+(R?4:0)+(U===126?2:0)+(U===127?8:0),this._state.fin=s,this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),E=w.readUInt8(1),s=(E&128)>>>7;let D=E&127,R=1;D===126?D=w.readUInt8(++R)*2**8+w.readUInt8(++R):D===127&&(D=w.readUInt8(++R)*0+w.readUInt8(++R)*0+w.readUInt8(++R)*0+w.readUInt8(++R)*0+w.readUInt8(++R)*2**24+w.readUInt8(++R)*2**16+w.readUInt8(++R)*2**8+w.readUInt8(++R));let U=0;s&&(U=w.readUInt8(++R)*2**24+w.readUInt8(++R)*2**16+w.readUInt8(++R)*2**8+w.readUInt8(++R)),this._state.state=3,this._state.readLen=D,this._state.mask=U}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);c(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const E=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=E.length,this._onData.fire(y.VSBuffer.wrap(E))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await C.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=A;function c(f,d){if(d===0)return;let w=f.byteLength>>>2;for(let V=0;V<w;V++){const ee=f.readUInt32BE(V*4);f.writeUInt32BE(ee^d,V*4)}let E=w*4,s=f.byteLength-E;const D=d>>>24&255,R=d>>>16&255,U=d>>>8&255;s>=1&&f.writeUInt8(f.readUInt8(E)^D,E),s>=2&&f.writeUInt8(f.readUInt8(E+1)^R,E+1),s>=3&&f.writeUInt8(f.readUInt8(E+2)^U,E+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const h={[2]:107,[1]:103};function p(){const f=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let d;return e.XDG_RUNTIME_DIR?d=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):d=(0,P.join)((0,k.tmpdir)(),`vscode-ipc-${f}.sock`),r(d),d}e.createRandomIPCHandle=p;function t(f,d,w){const E=(0,g.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${w}-${d}-sock`;let s;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?s=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${E.substr(0,8)}-${w}-${d}.sock`):s=(0,P.join)(f,`${w}-${d}.sock`),r(s),s}e.createStaticIPCHandle=t;function r(f){const d=h[i.platform];typeof d=="number"&&f.length>=d&&console.warn(`WARNING: IPC handle "${f}" is longer than ${d} chars, try a shorter --user-data-dir`)}class o extends u.IPCServer{constructor(d){super(o.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const w=C.Event.fromNodeEventEmitter(d,"connection");return C.Event.map(w,E=>({protocol:new m.Protocol(new v(E)),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(E,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function n(f){return new Promise((d,w)=>{const E=(0,L.createServer)();E.on("error",w),E.listen(f,()=>{E.removeListener("error",w),d(new o(E))})})}e.serve=n;function a(f,d){return new Promise((w,E)=>{const s=(0,L.createConnection)(f,()=>{s.removeListener("error",E),w(m.Client.fromSocket(new v(s),d))});s.once("error",E)})}e.connect=a}),define(me[285],ge([0,1,136,277,49,44,2,198,12]),function(J,e,g,L,k,y,T,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(u,m,l){this._commands=u,this.logService=m,this._ipcHandlePath=l,this._server=L.createServer((v,_)=>this.onRequest(v,_)),this.setup().catch(v=>(m.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",u=>this.logService.error(u))}catch(u){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(u,m){const l=[];u.setEncoding("utf8"),u.on("data",v=>l.push(v)),u.on("end",()=>{const v=JSON.parse(l.join(""));switch(v.type){case"open":this.open(v,m);break;case"openExternal":this.openExternal(v,m);break;case"status":this.getStatus(v,m);break;case"extensionManagement":this.manageExtensions(v,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${v.type}`,_=>{_&&this.logService.error(_)}),m.end();break}})}open(u,m){let{fileURIs:l,folderURIs:v,forceNewWindow:_,diffMode:b,addMode:A,forceReuseWindow:c,gotoLineMode:h,waitMarkerFilePath:p}=u;const t=[];if(Array.isArray(v))for(const r of v)try{t.push({folderUri:T.URI.parse(r)})}catch(o){}if(Array.isArray(l))for(const r of l)try{(0,C.hasWorkspaceFileExtension)(r)?t.push({workspaceUri:T.URI.parse(r)}):t.push({fileUri:T.URI.parse(r)})}catch(o){}if(t.length){const r=p?T.URI.file(p):void 0,n={forceNewWindow:_,diffMode:b,addMode:A,gotoLineMode:h,forceReuseWindow:c,preferNewWindow:!c&&!r&&!A,waitMarkerFileURI:r};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}m.writeHead(200),m.end()}async openExternal(u,m){for(const l of u.uris){const v=T.URI.parse(l),_=v.scheme==="file"?v:l;await this._commands.executeCommand("_remoteCLI.openExternal",_)}m.writeHead(200),m.end()}async manageExtensions(u,m){try{const l=b=>b?.map(A=>/\.vsix$/i.test(A)?T.URI.parse(A):A),v={list:u.list,install:l(u.install),uninstall:l(u.uninstall),force:u.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);m.writeHead(200),m.write(_)}catch(l){m.writeHead(500),m.write(String(l),v=>{v&&this.logService.error(v)})}m.end()}async getStatus(u,m){try{const l=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(l),m.end()}catch(l){m.writeHead(500),m.write(String(l),v=>{v&&this.logService.error(v)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let i=class extends P{constructor(u,m){super(u,m,(0,g.createRandomIPCHandle)())}};i=Ve([$e(0,y.IExtHostCommands),$e(1,S.ILogService)],i),e.CLIServer=i}),define(me[286],ge([0,1,70,273,268,5,276,40,258,2,10,7,285,105]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class l extends k.RequireInterceptor{_installInterceptor(){const b=this,A=J.__$__nodeRequire("module"),c=A._load;A._load=function(p,t,r){for(let o of b._alternatives){let n=o(p);if(n){p=n;break}}return b._factories.has(p)?b._factories.get(p).load(p,P.URI.file((0,m.realpathSync)(t.filename)),o=>c.apply(this,[o,t,r])):c.apply(this,arguments)}}}class v extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const b=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(u.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(l,b,this._registry).install(),g.mark("code/extHost/didInitAPI");const c=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,c,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const h=process.send,p=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?h.apply(process,t):(p.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(b){return b.main}_loadCommonJSModule(b,A,c){if(A.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${A}', must be of file-scheme`);let h=null;c.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${A.toString(!0)}`),this._logService.flush();try{b&&g.mark(`code/extHost/willLoadExtensionCode/${b.value}`),h=J.__$__nodeRequire(A.fsPath)}catch(p){return Promise.reject(p)}finally{b&&g.mark(`code/extHost/didLoadExtensionCode/${b.value}`),c.codeLoadingStop()}return Promise.resolve(h)}async $setRemoteEnvironment(b){if(!!this._initData.remote.isRemote)for(const A in b){const c=b[A];c===null?delete process.env[A]:process.env[A]=c}}}e.ExtHostExtensionService=v}),define(me[287],ge([0,1,80,259,261,270,269,284,286,226,262,53,40,65,71,69,33,52,12,66,260]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_,b,A,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(u.IExtHostExtensionService,S.ExtHostExtensionService),(0,g.registerSingleton)(A.ILogService,P.ExtHostLogService),(0,g.registerSingleton)(c.IExtensionStoragePaths,h.ExtensionStoragePaths),(0,g.registerSingleton)(I.IExtHostDebugService,T.ExtHostDebugService),(0,g.registerSingleton)(m.IExtHostOutputService,L.ExtHostOutputService2),(0,g.registerSingleton)(l.IExtHostSearch,C.NativeExtHostSearch),(0,g.registerSingleton)(v.IExtHostTask,y.ExtHostTask),(0,g.registerSingleton)(_.IExtHostTerminalService,k.ExtHostTerminalService),(0,g.registerSingleton)(b.IExtHostTunnelService,i.ExtHostTunnelService)}),define(me[288],ge([0,1,125,300,70,16,107,136,191,224,271,24,103,28,105,17,114,274,287]),function(J,e,g,L,k,y,T,C,S,P,i,I,u,m,l,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let a=0;a<process.execArgv.length;a++)process.execArgv[a]==="--inspect-port=0"&&(process.execArgv.splice(a,1),a--)}();const b=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const n=J.__$__nodeRequire("module"),a=n._load;n._load=function(f){if(f==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return a.apply(this,arguments)}})();const A=process.exit.bind(process);function c(n){process.exit=function(a){if(n)A(a);else{const f=new Error("An extension called process.exit() and this was prevented.");console.warn(f.stack)}},process.crash=function(){const a=new Error("An extension called process.crash() and this was prevented.");console.warn(a.stack)}}let h=function(n){A()};function p(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((n,a)=>{let f=null,d=setTimeout(()=>{h("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const w=108e5,E=3e5,s=new v.RunOnceScheduler(()=>h("renderer disconnected for too long (1)"),w),D=new v.RunOnceScheduler(()=>h("renderer disconnected for too long (2)"),E);process.on("message",(U,V)=>{if(U&&U.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ee=I.VSBuffer.wrap(Buffer.from(U.initialDataChunk,"base64"));let K;if(U.skipWebSocketFrames)K=new C.NodeSocket(V);else{const O=I.VSBuffer.wrap(Buffer.from(U.inflateBytes,"base64"));K=new C.WebSocketNodeSocket(new C.NodeSocket(V),U.permessageDeflate,O,!1)}f?(s.cancel(),D.cancel(),f.beginAcceptReconnection(K,ee),f.endAcceptReconnection()):(clearTimeout(d),f=new T.PersistentProtocol(K,ee),f.onDidDispose(()=>h("renderer disconnected")),n(f),f.onSocketClose(()=>{s.schedule()}))}if(U&&U.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(D.isScheduled())return;s.isScheduled()&&D.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const n=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((a,f)=>{const d=g.createConnection(n,()=>{d.removeListener("error",f),a(new T.PersistentProtocol(new C.NodeSocket(d)))});d.once("error",f),d.on("close",()=>{h("renderer closed the socket")})})}}async function t(){const n=await p();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,n.onMessage(a=>{(0,P.isMessageOfType)(a,2)?(this._terminating=!0,h("received terminate message from renderer")):this._onMessage.fire(a)})}send(a){this._terminating||n.send(a)}drain(){return n.drain()}}}function r(n){return new Promise(a=>{const f=n.onMessage(d=>{f.dispose();const w=JSON.parse(d.toString()),E=w.commit,s=S.default.commit;E&&s&&E!==s&&A(55);const D=[];process.on("unhandledRejection",(V,ee)=>{D.push(ee),setTimeout(()=>{const K=D.indexOf(ee);K>=0&&ee.catch(O=>{D.splice(K,1),(0,y.isPromiseCanceledError)(O)||(console.warn(`rejected promise not handled within 1 second: ${O}`),O&&O.stack&&console.warn(`stack trace: ${O.stack}`),(0,y.onUnexpectedError)(V))})},1e3)}),process.on("rejectionHandled",V=>{const ee=D.indexOf(V);ee>=0&&D.splice(ee,1)}),process.on("uncaughtException",function(V){(0,y.onUnexpectedError)(V)});let R=0;setInterval(function(){try{process.kill(w.parentPid,0),R=0}catch(V){V&&V.code==="EPERM"?(R++,R>=3&&h(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):h(`parent process ${w.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let U;try{U=J.__$__nodeRequire("native-watchdog"),U.start(w.parentPid)}catch(V){(0,y.onUnexpectedError)(V)}n.send((0,P.createMessageOfType)(0)),a({protocol:n,initData:w})});n.send((0,P.createMessageOfType)(1))})}async function o(){k.mark("code/extHost/willConnectToRenderer");const n=await t();k.mark("code/extHost/didConnectToRenderer");const a=await r(n);k.mark("code/extHost/didWaitForInitData");const{initData:f}=a;c(!!f.environment.extensionTestsLocationURI),f.environment.useHostProxy=b.useHostProxy!==void 0?b.useHostProxy!=="false":void 0,f.environment.skipWorkspaceStorageLock=(0,_.boolean)(b.skipWorkspaceStorageLock,!1);const d=new class{exit(D){A(D)}exists(D){return m.Promises.exists(D)}realpath(D){return(0,l.realpath)(D)}};let w=null;if(f.remote.authority&&b.uriTransformerPath)try{const D=J.__$__nodeRequire(b.uriTransformerPath)(f.remote.authority);w=new u.URITransformer(D)}catch(s){console.error(s)}const E=new i.ExtensionHostMain(a.protocol,f,d,w);h=s=>E.terminate(s)}e.startExtensionHostProcess=o}),define(me[301],ge([0,1,288]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a4eb4d688477fb9f2176bb2ed932b0b1726caed3/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
